searchData={"content_type":"text/markdown","items":[{"doc":"Defines the behaviour for file system operations.\nThis is used for mocking in tests.","ref":"File.Behaviour.html","title":"File.Behaviour","type":"behaviour"},{"doc":"Checks if a file exists.","ref":"File.Behaviour.html#c:exists?/1","title":"File.Behaviour.exists?/1","type":"callback"},{"doc":"Creates a directory and its parent directories.","ref":"File.Behaviour.html#c:mkdir_p/1","title":"File.Behaviour.mkdir_p/1","type":"callback"},{"doc":"Reads file contents.","ref":"File.Behaviour.html#c:read/1","title":"File.Behaviour.read/1","type":"callback"},{"doc":"Removes a file.","ref":"File.Behaviour.html#c:rm/1","title":"File.Behaviour.rm/1","type":"callback"},{"doc":"Gets file statistics.","ref":"File.Behaviour.html#c:stat/1","title":"File.Behaviour.stat/1","type":"callback"},{"doc":"Writes content to a file.","ref":"File.Behaviour.html#c:write/2","title":"File.Behaviour.write/2","type":"callback"},{"doc":"Default implementation of File.Behaviour for testing.","ref":"FileMock.html","title":"FileMock","type":"module"},{"doc":"Defines the behaviour for file system watching functionality.\nThis is used for mocking in tests.","ref":"FileSystem.Behaviour.html","title":"FileSystem.Behaviour","type":"behaviour"},{"doc":"Starts a file system watcher for the given directories.","ref":"FileSystem.Behaviour.html#c:start_link/1","title":"FileSystem.Behaviour.start_link/1","type":"callback"},{"doc":"Subscribes to file system events from the watcher.","ref":"FileSystem.Behaviour.html#c:subscribe/1","title":"FileSystem.Behaviour.subscribe/1","type":"callback"},{"doc":"A simple mock Form component for testing button interactions.","ref":"Form.html","title":"Form","type":"module"},{"doc":"Handle events for the form component.","ref":"Form.html#handle_event/2","title":"Form.handle_event/2","type":"function"},{"doc":"Initialize the form component with default state.","ref":"Form.html#init/1","title":"Form.init/1","type":"function"},{"doc":"Render the form component.","ref":"Form.html#render/1","title":"Form.render/1","type":"function"},{"doc":"Implements a JSON String Parser for Bitstring values","ref":"JSON.Parser.String.html","title":"JSON.Parser.String","type":"module"},{"doc":"parses a valid JSON string, returns its elixir representation","ref":"JSON.Parser.String.html#parse/1","title":"JSON.Parser.String.parse/1","type":"function"},{"doc":"iex> JSON.Parser.String.parse \"\"\n    {:error, :unexpected_end_of_buffer}\n\n    iex> JSON.Parser.String.parse \"face0ff\"\n    {:error, {:unexpected_token, \"face0ff\"}}\n\n    iex> JSON.Parser.String.parse \"-hello\"\n    {:error, {:unexpected_token, \"-hello\"}}\n\n    iex> JSON.Parser.String.parse \"129245\"\n    {:error, {:unexpected_token, \"129245\"}}\n\n    iex> JSON.Parser.String.parse \"\"7.something\"\"\n    {:ok, \"7.something\", \"\"}\n\n    iex> JSON.Parser.String.parse \"\"-88.22suffix\" foo bar\"\n    {:ok, \"-88.22suffix\", \" foo bar\"}\n\n    iex> JSON.Parser.String.parse \"\"star -> \\u272d <- star\"\"\n    {:ok, \"star -> ✭ <- star\", \"\"}\n\n    iex> JSON.Parser.String.parse \"\"\\u00df ist wunderbar\"\"\n    {:ok, \"ß ist wunderbar\", \"\"}\n\n    iex> JSON.Parser.String.parse \"\"Rafaëlla\" foo bar\"\n    {:ok, \"Rafaëlla\", \" foo bar\"}\n\n    iex> JSON.Parser.String.parse \"\"Éloise woot\" Éloise\"\n    {:ok, \"Éloise woot\", \" Éloise\"}","ref":"JSON.Parser.String.html#parse/1-examples","title":"Examples - JSON.Parser.String.parse/1","type":"function"},{"doc":"Implements a JSON Unicode Parser for Bitstring values","ref":"JSON.Parser.Unicode.html","title":"JSON.Parser.Unicode","type":"module"},{"doc":"parses a valid chain of escaped unicode and returns the string representation,\nplus the remainder of the string","ref":"JSON.Parser.Unicode.html#parse/1","title":"JSON.Parser.Unicode.parse/1","type":"function"},{"doc":"iex> JSON.Parser.parse \"\"\n    {:error, :unexpected_end_of_buffer}\n\n    iex> JSON.Parser.parse \"face0ff\"\n    {:error, {:unexpected_token, \"face0ff\"}}\n\n    iex> JSON.Parser.parse \"-hello\"\n    {:error, {:unexpected_token, \"-hello\"}}","ref":"JSON.Parser.Unicode.html#parse/1-examples","title":"Examples - JSON.Parser.Unicode.parse/1","type":"function"},{"doc":"Runs visualization performance benchmarks.","ref":"Mix.Tasks.Benchmark.Visualization.html","title":"mix benchmark.visualization","type":"task"},{"doc":"$ mix benchmark.visualization [--small|--medium|--large|--production]","ref":"Mix.Tasks.Benchmark.Visualization.html#module-usage","title":"Usage - mix benchmark.visualization","type":"task"},{"doc":"* `--small` - Run a small benchmark with fewer data points (default)\n    * `--medium` - Run a medium-sized benchmark\n    * `--large` - Run a large benchmark with more data points\n    * `--production` - Run a comprehensive benchmark for production analysis","ref":"Mix.Tasks.Benchmark.Visualization.html#module-options","title":"Options - mix benchmark.visualization","type":"task"},{"doc":"Raxol is a feature-rich terminal UI framework for Elixir.\n\nIt provides a comprehensive set of components and tools for building\nbeautiful, accessible, and responsive terminal applications.","ref":"Raxol.html","title":"Raxol","type":"module"},{"doc":"* **Modern Component Library**: A rich set of pre-built UI components like buttons,\n  text inputs, tables, modals, and more.\n\n* **Accessibility Support**: Built-in features for screen readers, high contrast\n  mode, and keyboard navigation.\n\n* **Theming System**: Customize the look and feel of your application with\n  consistent theming.\n\n* **Responsive Layouts**: Create layouts that adapt to different terminal sizes.\n\n* **The Elm Architecture**: Follows TEA (The Elm Architecture) for predictable\n  state management.\n\n* **Event Handling**: Comprehensive event system for keyboard, mouse, and terminal events.","ref":"Raxol.html#module-features","title":"Features - Raxol","type":"module"},{"doc":"To create a new Raxol application, you need to define three core functions:\n\n* `init/1`: Initializes your application state\n* `update/2`: Updates the state based on events\n* `render/1`: Renders the UI based on the current state\n\nHere's a simple counter example:\n\n    ```text\n    defmodule Counter do\n      @behaviour Raxol.Core.Runtime.Application\n\n      require Raxol.Core.Renderer.View\n      alias Raxol.Core.Runtime.Events.Event\n\n      def init(_opts) do\n        {%{count: 0}, []}\n      end\n\n      def update(%{count: count} = model, %Event{type: :command, data: :increment}) do\n        {%{model | count: count + 1}, []}\n      end\n\n      def update(%{count: count} = model, %Event{type: :command, data: :decrement}) do\n        {%{model | count: count - 1}, []}\n      end\n\n      def update(model, _event_or_msg), do: {model, []}\n\n      def view(model) do\n        Raxol.Core.Renderer.View.column [padding: 1] do\n          [\n            Raxol.Core.Renderer.View.text(\"Count: #{model.count}\"),\n            Raxol.Core.Renderer.View.row [gap: 1] do\n              [\n                Raxol.Core.Renderer.View.button \"-\", on_click: {:command, :decrement},\n                Raxol.Core.Renderer.View.button \"+\", on_click: {:command, :increment}\n              ]\n            end\n          ]\n        end\n      end\n    end\n\n    # Start the application\n    Raxol.run(Counter)\n    ```","ref":"Raxol.html#module-getting-started","title":"Getting Started - Raxol","type":"module"},{"doc":"Raxol is built on the Elm Architecture:\n\n1. **Model**: Your application state\n2. **Update**: Logic to update the state based on messages\n3. **View**: Pure functions to render UI based on the current state\n\nMessages can be generated by user interactions (like button clicks) or\nsystem events (like terminal resize).","ref":"Raxol.html#module-architecture","title":"Architecture - Raxol","type":"module"},{"doc":"Raxol provides a rich set of built-in components in the Raxol.Components\nmodule. Common components include:\n\n* Buttons\n* Text inputs\n* Tables\n* Progress indicators\n* Modals\n* Dropdown menus\n* Tab bars\n\nEach component follows consistent patterns for styling and behavior.","ref":"Raxol.html#module-components","title":"Components - Raxol","type":"module"},{"doc":"Gets the current accessibility settings.","ref":"Raxol.html#accessibility_settings/0","title":"Raxol.accessibility_settings/0","type":"function"},{"doc":"A map of current accessibility settings.","ref":"Raxol.html#accessibility_settings/0-returns","title":"Returns - Raxol.accessibility_settings/0","type":"function"},{"doc":"```elixir\nsettings = Raxol.accessibility_settings()\nif settings.high_contrast do\n  # Do something for high contrast mode\nend\n```","ref":"Raxol.html#accessibility_settings/0-example","title":"Example - Raxol.accessibility_settings/0","type":"function"},{"doc":"Gets the current default theme.","ref":"Raxol.html#current_theme/0","title":"Raxol.current_theme/0","type":"function"},{"doc":"The current theme map.","ref":"Raxol.html#current_theme/0-returns","title":"Returns - Raxol.current_theme/0","type":"function"},{"doc":"```elixir\ntheme = Raxol.current_theme()\n```","ref":"Raxol.html#current_theme/0-example","title":"Example - Raxol.current_theme/0","type":"function"},{"doc":"Runs a Raxol application.\n\nThis function starts the Raxol runtime with the provided application module\nand options. The application module must implement the `Raxol.Core.Runtime.Application` behaviour.","ref":"Raxol.html#run/2","title":"Raxol.run/2","type":"function"},{"doc":"* `app` - Module implementing the `Raxol.Core.Runtime.Application` behaviour\n* `opts` - Additional options for the runtime","ref":"Raxol.html#run/2-parameters","title":"Parameters - Raxol.run/2","type":"function"},{"doc":"* `:quit_keys` - List of keys that will quit the application (default: `[{:ctrl, ?c}]`)\n* `:fps` - Target frames per second (default: `60`)\n* `:title` - Terminal window title (default: `\"Raxol Application\"`)\n* `:font` - Terminal font (if supported)\n* `:font_size` - Terminal font size (if supported)\n* `:accessibility` - Accessibility options\n  * `:screen_reader` - Enable screen reader support (default: `true`)\n  * `:high_contrast` - Enable high contrast mode (default: `false`)\n  * `:large_text` - Enable large text mode (default: `false`)","ref":"Raxol.html#run/2-options","title":"Options - Raxol.run/2","type":"function"},{"doc":"The return value of the application when it exits.","ref":"Raxol.html#run/2-returns","title":"Returns - Raxol.run/2","type":"function"},{"doc":"```elixir\nRaxol.run(MyApp, %{initial: \"state\"}, title: \"My Application\", fps: 30)\n```","ref":"Raxol.html#run/2-example","title":"Example - Raxol.run/2","type":"function"},{"doc":"Enables or disables accessibility features.","ref":"Raxol.html#set_accessibility/1","title":"Raxol.set_accessibility/1","type":"function"},{"doc":"* `opts` - Map of accessibility features to enable/disable","ref":"Raxol.html#set_accessibility/1-parameters","title":"Parameters - Raxol.set_accessibility/1","type":"function"},{"doc":"* `:screen_reader` - Enable screen reader support\n* `:high_contrast` - Enable high contrast mode\n* `:large_text` - Enable large text mode\n* `:reduced_motion` - Reduce or eliminate animations","ref":"Raxol.html#set_accessibility/1-options","title":"Options - Raxol.set_accessibility/1","type":"function"},{"doc":"```elixir\nRaxol.set_accessibility(screen_reader: true, high_contrast: true)\n```","ref":"Raxol.html#set_accessibility/1-example","title":"Example - Raxol.set_accessibility/1","type":"function"},{"doc":"Sets the default theme for Raxol applications.\n\nThis function sets the default theme that will be used by Raxol components.","ref":"Raxol.html#set_theme/1","title":"Raxol.set_theme/1","type":"function"},{"doc":"* `theme` - A theme created with `Raxol.UI.Theming.Theme.new/1` or one of the built-in themes","ref":"Raxol.html#set_theme/1-parameters","title":"Parameters - Raxol.set_theme/1","type":"function"},{"doc":"```elixir\n# Use a built-in theme\nRaxol.set_theme(Raxol.UI.Theming.Theme.dark())\n\n# Create and use a custom theme\ncustom_theme = Raxol.UI.Theming.Theme.new(name: \"Custom\", colors: %{primary: :green})\nRaxol.set_theme(custom_theme)\n```","ref":"Raxol.html#set_theme/1-example","title":"Example - Raxol.set_theme/1","type":"function"},{"doc":"Gracefully stops a running Raxol application.\n\nThis function can be called from within your application to exit gracefully.","ref":"Raxol.html#stop/1","title":"Raxol.stop/1","type":"function"},{"doc":"* `return_value` - Value to return from the `Raxol.run/3` function","ref":"Raxol.html#stop/1-parameters","title":"Parameters - Raxol.stop/1","type":"function"},{"doc":"```elixir\ndef update(model, :exit) do\n  Raxol.stop(:normal)\n  model\nend\n```","ref":"Raxol.html#stop/1-example","title":"Example - Raxol.stop/1","type":"function"},{"doc":"Returns information about the terminal environment.\n\nThis includes terminal size, color support, and other capabilities.","ref":"Raxol.html#terminal_info/0","title":"Raxol.terminal_info/0","type":"function"},{"doc":"A map with terminal information.","ref":"Raxol.html#terminal_info/0-returns","title":"Returns - Raxol.terminal_info/0","type":"function"},{"doc":"```elixir\nRaxol.terminal_info()\n# => %{\n#      name: \"iTerm2\",\n#      version: \"3.5.0\",\n#      features: [:true_color, :unicode, :mouse, :clipboard],\n#      ...\n#    }\n```","ref":"Raxol.html#terminal_info/0-example","title":"Example - Raxol.terminal_info/0","type":"function"},{"doc":"Returns the current version of Raxol.","ref":"Raxol.html#version/0","title":"Raxol.version/0","type":"function"},{"doc":"A string representing the current version.","ref":"Raxol.html#version/0-returns","title":"Returns - Raxol.version/0","type":"function"},{"doc":"```elixir\nRaxol.version()\n# => \"1.0.0\"\n```","ref":"Raxol.html#version/0-example","title":"Example - Raxol.version/0","type":"function"},{"doc":"Content generation capabilities for Raxol applications.\n\nThis module provides AI-powered content generation for various aspects of\nterminal UIs, including:\n\n* Text suggestions\n* Command completions\n* Help content generation\n* Documentation generation\n* Interactive tutorials\n* Contextual hints\n\nThe generation is configurable and can be adapted to different contexts\nwithin the application.","ref":"Raxol.AI.ContentGeneration.html","title":"Raxol.AI.ContentGeneration","type":"module"},{"doc":"Generates content based on the specified type and prompt.","ref":"Raxol.AI.ContentGeneration.html#generate/3","title":"Raxol.AI.ContentGeneration.generate/3","type":"function"},{"doc":"* `:max_length` - Maximum length of the generated content (default: 100)\n* `:style` - Style of the generated content (default: :neutral)\n* `:tone` - Tone of the generated content (default: :neutral)\n* `:context` - Additional context for generation (default: %{})\n* `:model` - AI model to use for generation (default: :default)","ref":"Raxol.AI.ContentGeneration.html#generate/3-options","title":"Options - Raxol.AI.ContentGeneration.generate/3","type":"function"},{"doc":"iex> generate(:text, \"Create a welcome message\", max_length: 50)\n    {:ok, \"Welcome to the terminal! How can I assist you today?'\"}","ref":"Raxol.AI.ContentGeneration.html#generate/3-examples","title":"Examples - Raxol.AI.ContentGeneration.generate/3","type":"function"},{"doc":"Generates a contextual help document based on application state.","ref":"Raxol.AI.ContentGeneration.html#generate_help/2","title":"Raxol.AI.ContentGeneration.generate_help/2","type":"function"},{"doc":"iex> generate_help(%{current_view: :editor, command_mode: true})\n    {:ok, %{title: \"Editor Mode Commands\", content: \"...\"}}","ref":"Raxol.AI.ContentGeneration.html#generate_help/2-examples","title":"Examples - Raxol.AI.ContentGeneration.generate_help/2","type":"function"},{"doc":"Generates an interactive tutorial for a specific feature.","ref":"Raxol.AI.ContentGeneration.html#generate_tutorial/2","title":"Raxol.AI.ContentGeneration.generate_tutorial/2","type":"function"},{"doc":"iex> generate_tutorial(:keyboard_shortcuts)\n    {:ok, %{steps: [...], interactive: true}}","ref":"Raxol.AI.ContentGeneration.html#generate_tutorial/2-examples","title":"Examples - Raxol.AI.ContentGeneration.generate_tutorial/2","type":"function"},{"doc":"","ref":"Raxol.AI.ContentGeneration.html#t:generation_options/0","title":"Raxol.AI.ContentGeneration.generation_options/0","type":"type"},{"doc":"","ref":"Raxol.AI.ContentGeneration.html#t:generation_type/0","title":"Raxol.AI.ContentGeneration.generation_type/0","type":"type"},{"doc":"Generates text suggestions based on current input context.","ref":"Raxol.AI.ContentGeneration.html#suggest_text/2","title":"Raxol.AI.ContentGeneration.suggest_text/2","type":"function"},{"doc":"iex> suggest_text(\"print(\", context: %{language: :python})\n    {:ok, [\"print(\"Hello, World!\")\", \"print(value)\", \"print(f\"Value: {value}\")\"]}","ref":"Raxol.AI.ContentGeneration.html#suggest_text/2-examples","title":"Examples - Raxol.AI.ContentGeneration.suggest_text/2","type":"function"},{"doc":"Runtime AI features for intelligent performance optimization.\n\nThis module provides AI-driven performance optimizations including:\n\n* Predictive rendering - Intelligently determine what needs to be rendered\n* Resource allocation - Dynamically allocate system resources based on usage patterns\n* Component caching - Smart caching of frequently used components\n* Prefetching - Predict and preload content likely to be needed soon\n* Adaptive throttling - Adjust refresh rates based on current activity\n* Runtime profiling - Continuously monitor and analyze performance patterns","ref":"Raxol.AI.PerformanceOptimization.html","title":"Raxol.AI.PerformanceOptimization","type":"module"},{"doc":"Analyzes performance and suggests optimizations.","ref":"Raxol.AI.PerformanceOptimization.html#analyze_performance/0","title":"Raxol.AI.PerformanceOptimization.analyze_performance/0","type":"function"},{"doc":"iex> analyze_performance()\n    [\n      %{type: :component, name: \"data_table\", issue: :slow_rendering, suggestion: \"Consider virtual scrolling\"},\n      %{type: :pattern, issue: :excessive_updates, suggestion: \"Implement throttling for search inputs\"}\n    ]","ref":"Raxol.AI.PerformanceOptimization.html#analyze_performance/0-examples","title":"Examples - Raxol.AI.PerformanceOptimization.analyze_performance/0","type":"function"},{"doc":"Recommends components for prefetching based on usage patterns.","ref":"Raxol.AI.PerformanceOptimization.html#get_prefetch_recommendations/1","title":"Raxol.AI.PerformanceOptimization.get_prefetch_recommendations/1","type":"function"},{"doc":"iex> get_prefetch_recommendations(\"user_profile\")\n    [\"user_settings\", \"user_activity\"]","ref":"Raxol.AI.PerformanceOptimization.html#get_prefetch_recommendations/1-examples","title":"Examples - Raxol.AI.PerformanceOptimization.get_prefetch_recommendations/1","type":"function"},{"doc":"Gets the recommended refresh rate for a component based on current activity.","ref":"Raxol.AI.PerformanceOptimization.html#get_refresh_rate/1","title":"Raxol.AI.PerformanceOptimization.get_refresh_rate/1","type":"function"},{"doc":"iex> get_refresh_rate(\"animated_progress\")\n    16  # milliseconds (approximately 60fps)","ref":"Raxol.AI.PerformanceOptimization.html#get_refresh_rate/1-examples","title":"Examples - Raxol.AI.PerformanceOptimization.get_refresh_rate/1","type":"function"},{"doc":"Initializes the performance optimization system.","ref":"Raxol.AI.PerformanceOptimization.html#init/1","title":"Raxol.AI.PerformanceOptimization.init/1","type":"function"},{"doc":"* `:optimization_level` - Level of optimization to apply (:minimal, :balanced, :aggressive)\n* `:features` - List of features to enable","ref":"Raxol.AI.PerformanceOptimization.html#init/1-options","title":"Options - Raxol.AI.PerformanceOptimization.init/1","type":"function"},{"doc":"iex> init(optimization_level: :balanced)\n    :ok","ref":"Raxol.AI.PerformanceOptimization.html#init/1-examples","title":"Examples - Raxol.AI.PerformanceOptimization.init/1","type":"function"},{"doc":"Records component usage for optimization analysis.","ref":"Raxol.AI.PerformanceOptimization.html#record_component_usage/1","title":"Raxol.AI.PerformanceOptimization.record_component_usage/1","type":"function"},{"doc":"iex> record_component_usage(\"dropdown_menu\")\n    :ok","ref":"Raxol.AI.PerformanceOptimization.html#record_component_usage/1-examples","title":"Examples - Raxol.AI.PerformanceOptimization.record_component_usage/1","type":"function"},{"doc":"Records component render time for optimization analysis.","ref":"Raxol.AI.PerformanceOptimization.html#record_render_time/2","title":"Raxol.AI.PerformanceOptimization.record_render_time/2","type":"function"},{"doc":"iex> record_render_time(\"user_profile\", 25)\n    :ok","ref":"Raxol.AI.PerformanceOptimization.html#record_render_time/2-examples","title":"Examples - Raxol.AI.PerformanceOptimization.record_render_time/2","type":"function"},{"doc":"Sets the optimization level for the system.","ref":"Raxol.AI.PerformanceOptimization.html#set_optimization_level/1","title":"Raxol.AI.PerformanceOptimization.set_optimization_level/1","type":"function"},{"doc":"iex> set_optimization_level(:aggressive)\n    :ok","ref":"Raxol.AI.PerformanceOptimization.html#set_optimization_level/1-examples","title":"Examples - Raxol.AI.PerformanceOptimization.set_optimization_level/1","type":"function"},{"doc":"Determines if a component should be rendered based on current conditions.\nUses predictive rendering to optimize performance.","ref":"Raxol.AI.PerformanceOptimization.html#should_render?/2","title":"Raxol.AI.PerformanceOptimization.should_render?/2","type":"function"},{"doc":"iex> should_render?(\"large_table\", %{visible: false, scroll_position: 500})\n    false","ref":"Raxol.AI.PerformanceOptimization.html#should_render?/2-examples","title":"Examples - Raxol.AI.PerformanceOptimization.should_render?/2","type":"function"},{"doc":"Enables or disables a specific optimization feature.","ref":"Raxol.AI.PerformanceOptimization.html#toggle_feature/2","title":"Raxol.AI.PerformanceOptimization.toggle_feature/2","type":"function"},{"doc":"iex> toggle_feature(:predictive_rendering, true)\n    :ok","ref":"Raxol.AI.PerformanceOptimization.html#toggle_feature/2-examples","title":"Examples - Raxol.AI.PerformanceOptimization.toggle_feature/2","type":"function"},{"doc":"Test helpers for accessibility-related assertions and simulation in Raxol.\nProvides assertion helpers for screen reader announcements, contrast, keyboard navigation, and focus management.","ref":"Raxol.AccessibilityTestHelpers.html","title":"Raxol.AccessibilityTestHelpers","type":"module"},{"doc":"- Test helpers for screen reader announcements\n- Color contrast testing tools\n- Keyboard navigation test helpers\n- Focus management testing\n- High contrast mode testing\n- Reduced motion testing","ref":"Raxol.AccessibilityTestHelpers.html#module-features","title":"Features - Raxol.AccessibilityTestHelpers","type":"module"},{"doc":"```elixir\nuse ExUnit.Case\nimport Raxol.AccessibilityTestHelpers\n\ntest \"button has proper contrast ratio\" do\n  assert_sufficient_contrast(\"#0077CC\", \"#FFFFFF\")\nend\n\ntest \"screen reader announcement is made\" do\n  with_screen_reader_spy fn ->\n    # Perform action that should trigger announcement\n    click_button(\"Save\")\n\n    # Assert announcement was made\n    assert_announced(\"File saved successfully\")\n  end\nend","ref":"Raxol.AccessibilityTestHelpers.html#module-usage","title":"Usage - Raxol.AccessibilityTestHelpers","type":"module"},{"doc":"Assert that a specific announcement was made to the screen reader.","ref":"Raxol.AccessibilityTestHelpers.html#assert_announced/2","title":"Raxol.AccessibilityTestHelpers.assert_announced/2","type":"function"},{"doc":"* `expected` - The expected announcement text or pattern\n* `opts` - Additional options","ref":"Raxol.AccessibilityTestHelpers.html#assert_announced/2-parameters","title":"Parameters - Raxol.AccessibilityTestHelpers.assert_announced/2","type":"function"},{"doc":"* `:exact` - Require exact match (default: `false`)\n* `:context` - Additional context for the error message","ref":"Raxol.AccessibilityTestHelpers.html#assert_announced/2-options","title":"Options - Raxol.AccessibilityTestHelpers.assert_announced/2","type":"function"},{"doc":"assert_announced(\"File saved\")\n\n    assert_announced(~r/File .* saved/, exact: false)","ref":"Raxol.AccessibilityTestHelpers.html#assert_announced/2-examples","title":"Examples - Raxol.AccessibilityTestHelpers.assert_announced/2","type":"function"},{"doc":"Assert that the focus is on a specific element.","ref":"Raxol.AccessibilityTestHelpers.html#assert_focus_on/2","title":"Raxol.AccessibilityTestHelpers.assert_focus_on/2","type":"function"},{"doc":"* `expected` - The expected focused element\n* `opts` - Additional options","ref":"Raxol.AccessibilityTestHelpers.html#assert_focus_on/2-parameters","title":"Parameters - Raxol.AccessibilityTestHelpers.assert_focus_on/2","type":"function"},{"doc":"* `:context` - Additional context for the error message","ref":"Raxol.AccessibilityTestHelpers.html#assert_focus_on/2-options","title":"Options - Raxol.AccessibilityTestHelpers.assert_focus_on/2","type":"function"},{"doc":"assert_focus_on(\"search_button\")","ref":"Raxol.AccessibilityTestHelpers.html#assert_focus_on/2-examples","title":"Examples - Raxol.AccessibilityTestHelpers.assert_focus_on/2","type":"function"},{"doc":"Assert that no announcements were made to the screen reader.","ref":"Raxol.AccessibilityTestHelpers.html#assert_no_announcements/1","title":"Raxol.AccessibilityTestHelpers.assert_no_announcements/1","type":"function"},{"doc":"* `opts` - Additional options","ref":"Raxol.AccessibilityTestHelpers.html#assert_no_announcements/1-parameters","title":"Parameters - Raxol.AccessibilityTestHelpers.assert_no_announcements/1","type":"function"},{"doc":"* `:context` - Additional context for the error message","ref":"Raxol.AccessibilityTestHelpers.html#assert_no_announcements/1-options","title":"Options - Raxol.AccessibilityTestHelpers.assert_no_announcements/1","type":"function"},{"doc":"assert_no_announcements()","ref":"Raxol.AccessibilityTestHelpers.html#assert_no_announcements/1-examples","title":"Examples - Raxol.AccessibilityTestHelpers.assert_no_announcements/1","type":"function"},{"doc":"Assert that a color combination has sufficient contrast for accessibility.","ref":"Raxol.AccessibilityTestHelpers.html#assert_sufficient_contrast/5","title":"Raxol.AccessibilityTestHelpers.assert_sufficient_contrast/5","type":"function"},{"doc":"* `foreground` - The foreground color (typically text)\n* `background` - The background color\n* `level` - The WCAG level to check against (`:aa` or `:aaa`) (default: `:aa`)\n* `size` - The text size (`:normal` or `:large`) (default: `:normal`)\n* `opts` - Additional options","ref":"Raxol.AccessibilityTestHelpers.html#assert_sufficient_contrast/5-parameters","title":"Parameters - Raxol.AccessibilityTestHelpers.assert_sufficient_contrast/5","type":"function"},{"doc":"* `:context` - Additional context for the error message","ref":"Raxol.AccessibilityTestHelpers.html#assert_sufficient_contrast/5-options","title":"Options - Raxol.AccessibilityTestHelpers.assert_sufficient_contrast/5","type":"function"},{"doc":"assert_sufficient_contrast(\"#000000\", \"#FFFFFF\")\n\n    assert_sufficient_contrast(\"#777777\", \"#FFFFFF\", :aaa, :large)","ref":"Raxol.AccessibilityTestHelpers.html#assert_sufficient_contrast/5-examples","title":"Examples - Raxol.AccessibilityTestHelpers.assert_sufficient_contrast/5","type":"function"},{"doc":"Spy handler for screen reader announcements.","ref":"Raxol.AccessibilityTestHelpers.html#handle_announcement_spy/1","title":"Raxol.AccessibilityTestHelpers.handle_announcement_spy/1","type":"function"},{"doc":"Spy handler for shortcut execution.","ref":"Raxol.AccessibilityTestHelpers.html#handle_shortcut_spy/1","title":"Raxol.AccessibilityTestHelpers.handle_shortcut_spy/1","type":"function"},{"doc":"Simulate a keyboard navigation sequence.\n\nThis function simulates pressing the tab key to navigate through focusable elements.","ref":"Raxol.AccessibilityTestHelpers.html#simulate_keyboard_navigation/2","title":"Raxol.AccessibilityTestHelpers.simulate_keyboard_navigation/2","type":"function"},{"doc":"* `count` - Number of tab key presses to simulate\n* `opts` - Additional options","ref":"Raxol.AccessibilityTestHelpers.html#simulate_keyboard_navigation/2-parameters","title":"Parameters - Raxol.AccessibilityTestHelpers.simulate_keyboard_navigation/2","type":"function"},{"doc":"* `:shift` - Whether to use Shift+Tab (backward navigation) (default: `false`)\n* `:starting_element` - Element to start navigation from (default: current focus)","ref":"Raxol.AccessibilityTestHelpers.html#simulate_keyboard_navigation/2-options","title":"Options - Raxol.AccessibilityTestHelpers.simulate_keyboard_navigation/2","type":"function"},{"doc":"simulate_keyboard_navigation(3)\n\n    simulate_keyboard_navigation(2, shift: true)\n\n    simulate_keyboard_navigation(1, starting_element: \"search_field\")","ref":"Raxol.AccessibilityTestHelpers.html#simulate_keyboard_navigation/2-examples","title":"Examples - Raxol.AccessibilityTestHelpers.simulate_keyboard_navigation/2","type":"function"},{"doc":"Test keyboard shortcut handling.\n\nThis function simulates pressing a keyboard shortcut and verifies that\nthe appropriate action is triggered.","ref":"Raxol.AccessibilityTestHelpers.html#test_keyboard_shortcut/2","title":"Raxol.AccessibilityTestHelpers.test_keyboard_shortcut/2","type":"function"},{"doc":"* `shortcut` - The shortcut to test (e.g., \"Ctrl+S\")\n* `opts` - Additional options","ref":"Raxol.AccessibilityTestHelpers.html#test_keyboard_shortcut/2-parameters","title":"Parameters - Raxol.AccessibilityTestHelpers.test_keyboard_shortcut/2","type":"function"},{"doc":"* `:context` - Additional context for the error message\n* `:in_context` - The context in which to test the shortcut","ref":"Raxol.AccessibilityTestHelpers.html#test_keyboard_shortcut/2-options","title":"Options - Raxol.AccessibilityTestHelpers.test_keyboard_shortcut/2","type":"function"},{"doc":"test_keyboard_shortcut(\"Ctrl+S\")\n\n    test_keyboard_shortcut(\"Ctrl+F\", in_context: :editor)","ref":"Raxol.AccessibilityTestHelpers.html#test_keyboard_shortcut/2-examples","title":"Examples - Raxol.AccessibilityTestHelpers.test_keyboard_shortcut/2","type":"function"},{"doc":"Test high contrast mode.\n\nThis function temporarily enables high contrast mode, runs the provided\nfunction, and then restores the previous setting.","ref":"Raxol.AccessibilityTestHelpers.html#with_high_contrast/1","title":"Raxol.AccessibilityTestHelpers.with_high_contrast/1","type":"function"},{"doc":"with_high_contrast fn ->\n      # Test how elements look in high contrast mode\n      assert color_of(\"button\") == \"#FFFFFF\"\n    end","ref":"Raxol.AccessibilityTestHelpers.html#with_high_contrast/1-examples","title":"Examples - Raxol.AccessibilityTestHelpers.with_high_contrast/1","type":"function"},{"doc":"Test reduced motion mode.\n\nThis function temporarily enables reduced motion mode, runs the provided\nfunction, and then restores the previous setting.","ref":"Raxol.AccessibilityTestHelpers.html#with_reduced_motion/2","title":"Raxol.AccessibilityTestHelpers.with_reduced_motion/2","type":"function"},{"doc":"with_reduced_motion fn ->\n      # Test animations with reduced motion\n      refute animation_running?(\"focus_ring\", :pulse)\n    end","ref":"Raxol.AccessibilityTestHelpers.html#with_reduced_motion/2-examples","title":"Examples - Raxol.AccessibilityTestHelpers.with_reduced_motion/2","type":"function"},{"doc":"Run a test with a spy on screen reader announcements.\n\nThis function sets up a spy to capture screen reader announcements\nduring the execution of the provided function, allowing you to\nassert that specific announcements were made.","ref":"Raxol.AccessibilityTestHelpers.html#with_screen_reader_spy/2","title":"Raxol.AccessibilityTestHelpers.with_screen_reader_spy/2","type":"function"},{"doc":"with_screen_reader_spy(user_preferences_pid, fn ->\n      # Perform action\n      click_button(\"Save\")\n\n      # Assert announcement\n      assert_announced(\"File saved successfully\")\n    end)","ref":"Raxol.AccessibilityTestHelpers.html#with_screen_reader_spy/2-examples","title":"Examples - Raxol.AccessibilityTestHelpers.with_screen_reader_spy/2","type":"function"},{"doc":"The Accounts context.\nManages user accounts and registration.\n(Currently uses an in-memory Agent for storage)","ref":"Raxol.Accounts.html","title":"Raxol.Accounts","type":"module"},{"doc":"Authenticates a user by email and password.\n\nCurrently checks against plaintext passwords stored in the agent.\nIn a real app, this should use password hashing.","ref":"Raxol.Accounts.html#authenticate_user/2","title":"Raxol.Accounts.authenticate_user/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Accounts.html#child_spec/1","title":"Raxol.Accounts.child_spec/1","type":"function"},{"doc":"Retrieves the full user map by user ID.\nNote: Inefficient O(N) scan of the agent state.","ref":"Raxol.Accounts.html#get_user/1","title":"Raxol.Accounts.get_user/1","type":"function"},{"doc":"Returns the list of registered users.","ref":"Raxol.Accounts.html#list_users/0","title":"Raxol.Accounts.list_users/0","type":"function"},{"doc":"Registers a new user.","ref":"Raxol.Accounts.html#register_user/1","title":"Raxol.Accounts.register_user/1","type":"function"},{"doc":"iex> register_user(%{email: \"user@example.com\", password: \"password\"})\n    {:ok, %{id: ..., email: \"user@example.com\"}}\n\n    iex> register_user(%{email: \"user@example.com\", password: \"password\"})\n    {:error, %{email: \"has already been taken\"}}","ref":"Raxol.Accounts.html#register_user/1-examples","title":"Examples - Raxol.Accounts.register_user/1","type":"function"},{"doc":"","ref":"Raxol.Accounts.html#start_link/1","title":"Raxol.Accounts.start_link/1","type":"function"},{"doc":"Updates a user's password after verifying the current password.\nUses user_id to find the user.","ref":"Raxol.Accounts.html#update_password/3","title":"Raxol.Accounts.update_password/3","type":"function"},{"doc":"","ref":"Raxol.Accounts.User.html","title":"Raxol.Accounts.User","type":"module"},{"doc":"Handles accessibility concerns for the Animation Framework,\nspecifically adapting animations for reduced motion preferences.","ref":"Raxol.Animation.Accessibility.html","title":"Raxol.Animation.Accessibility","type":"module"},{"doc":"Adapts an animation definition based on reduced motion and cognitive accessibility settings.\nIf reduced_motion is true, applies reduced motion adaptation.\nIf cognitive_accessibility is true, applies cognitive accessibility adaptation.\nOtherwise, returns the animation unchanged.","ref":"Raxol.Animation.Accessibility.html#adapt_animation/3","title":"Raxol.Animation.Accessibility.adapt_animation/3","type":"function"},{"doc":"Adapts an animation definition for cognitive accessibility by increasing its duration.\n\nThis makes animations slower and potentially easier to follow.","ref":"Raxol.Animation.Accessibility.html#adapt_for_cognitive_accessibility/1","title":"Raxol.Animation.Accessibility.adapt_for_cognitive_accessibility/1","type":"function"},{"doc":"Adapts an animation definition based on reduced motion settings.\n\nCurrently, it significantly shortens the duration to provide a near-instant transition.\nAlternative strategies include setting duration to 0 or changing animation type.","ref":"Raxol.Animation.Accessibility.html#adapt_for_reduced_motion/1","title":"Raxol.Animation.Accessibility.adapt_for_reduced_motion/1","type":"function"},{"doc":"Delegates animation API calls to Raxol.Animation.Framework for test and compatibility purposes.","ref":"Raxol.Animation.Animation.html","title":"Raxol.Animation.Animation","type":"module"},{"doc":"See  Raxol.Animation.Framework.apply_animations_to_state/1 .","ref":"Raxol.Animation.Animation.html#apply_animations_to_state/1","title":"Raxol.Animation.Animation.apply_animations_to_state/1","type":"function"},{"doc":"See  Raxol.Animation.Framework.create_animation/2 .","ref":"Raxol.Animation.Animation.html#create_animation/2","title":"Raxol.Animation.Animation.create_animation/2","type":"function"},{"doc":"See  Raxol.Animation.Framework.get_current_value/2 .","ref":"Raxol.Animation.Animation.html#get_current_value/2","title":"Raxol.Animation.Animation.get_current_value/2","type":"function"},{"doc":"","ref":"Raxol.Animation.Animation.html#init/2","title":"Raxol.Animation.Animation.init/2","type":"function"},{"doc":"","ref":"Raxol.Animation.Animation.html#should_reduce_motion?/1","title":"Raxol.Animation.Animation.should_reduce_motion?/1","type":"function"},{"doc":"See  Raxol.Animation.Framework.start_animation/2 .","ref":"Raxol.Animation.Animation.html#start_animation/2","title":"Raxol.Animation.Animation.start_animation/2","type":"function"},{"doc":"See  Raxol.Animation.Framework.start_animation/3 .","ref":"Raxol.Animation.Animation.html#start_animation/3","title":"Raxol.Animation.Animation.start_animation/3","type":"function"},{"doc":"See  Raxol.Animation.Framework.stop/0 .","ref":"Raxol.Animation.Animation.html#stop/0","title":"Raxol.Animation.Animation.stop/0","type":"function"},{"doc":"Provides standard easing functions for animations.","ref":"Raxol.Animation.Easing.html","title":"Raxol.Animation.Easing","type":"module"},{"doc":"Calculates the eased value for a given progress `t` (0.0 to 1.0).","ref":"Raxol.Animation.Easing.html#calculate_value/2","title":"Raxol.Animation.Easing.calculate_value/2","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_back/1","title":"Raxol.Animation.Easing.ease_in_back/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_bounce/1","title":"Raxol.Animation.Easing.ease_in_bounce/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_circ/1","title":"Raxol.Animation.Easing.ease_in_circ/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_cubic/1","title":"Raxol.Animation.Easing.ease_in_cubic/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_elastic/1","title":"Raxol.Animation.Easing.ease_in_elastic/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_expo/1","title":"Raxol.Animation.Easing.ease_in_expo/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_out_back/1","title":"Raxol.Animation.Easing.ease_in_out_back/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_out_bounce/1","title":"Raxol.Animation.Easing.ease_in_out_bounce/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_out_circ/1","title":"Raxol.Animation.Easing.ease_in_out_circ/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_out_cubic/1","title":"Raxol.Animation.Easing.ease_in_out_cubic/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_out_elastic/1","title":"Raxol.Animation.Easing.ease_in_out_elastic/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_out_expo/1","title":"Raxol.Animation.Easing.ease_in_out_expo/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_out_quad/1","title":"Raxol.Animation.Easing.ease_in_out_quad/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_out_quart/1","title":"Raxol.Animation.Easing.ease_in_out_quart/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_out_quint/1","title":"Raxol.Animation.Easing.ease_in_out_quint/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_out_sine/1","title":"Raxol.Animation.Easing.ease_in_out_sine/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_quad/1","title":"Raxol.Animation.Easing.ease_in_quad/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_quart/1","title":"Raxol.Animation.Easing.ease_in_quart/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_quint/1","title":"Raxol.Animation.Easing.ease_in_quint/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_in_sine/1","title":"Raxol.Animation.Easing.ease_in_sine/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_out_back/1","title":"Raxol.Animation.Easing.ease_out_back/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_out_bounce/1","title":"Raxol.Animation.Easing.ease_out_bounce/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_out_circ/1","title":"Raxol.Animation.Easing.ease_out_circ/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_out_cubic/1","title":"Raxol.Animation.Easing.ease_out_cubic/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_out_elastic/1","title":"Raxol.Animation.Easing.ease_out_elastic/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_out_expo/1","title":"Raxol.Animation.Easing.ease_out_expo/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_out_quad/1","title":"Raxol.Animation.Easing.ease_out_quad/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_out_quart/1","title":"Raxol.Animation.Easing.ease_out_quart/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_out_quint/1","title":"Raxol.Animation.Easing.ease_out_quint/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#ease_out_sine/1","title":"Raxol.Animation.Easing.ease_out_sine/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Easing.html#linear/1","title":"Raxol.Animation.Easing.linear/1","type":"function"},{"doc":"Coordinates the lifecycle of animations within Raxol.\n\nThis module acts as the main entry point for creating, starting, stopping,\nand applying animations to the application state. It relies on supporting\nmodules for specific concerns:\n\n- `Raxol.Animation.StateManager`: Handles the storage and retrieval of\n  animation definitions and active instances.\n- `Raxol.Animation.Accessibility`: Adapts animations based on user\n  accessibility preferences (e.g., reduced motion).\n- `Raxol.Animation.Interpolate`: Provides easing and value interpolation\n  functions.\n\nThe framework automatically handles:\n- Timing and progress calculation.\n- Applying interpolated values to the application state via configured paths.\n- Managing animation completion and callbacks.\n- Adapting to reduced motion settings.","ref":"Raxol.Animation.Framework.html","title":"Raxol.Animation.Framework","type":"module"},{"doc":"```elixir\n# Initialize the framework (typically done once on application start)\nRaxol.Animation.Framework.init()\n\n# Define an animation (target_path can be a property, e.g., [:opacity])\nRaxol.Animation.Framework.create_animation(:fade_in, %{\n  target_path: [:opacity], # Will be automatically scoped to the element's state\n  duration: 300,\n  easing: :ease_out_cubic,\n  from: 0.0,\n  to: 1.0\n})\n\n# Start the animation on an element\n# The framework will update [:elements, \"my_element_id\", :opacity] in the state\nRaxol.Animation.Framework.start_animation(:fade_in, \"my_element_id\")\n\n# In the application's update loop, apply animations to the state\nupdated_state = Raxol.Animation.Framework.apply_animations_to_state(current_state)\n```","ref":"Raxol.Animation.Framework.html#module-usage","title":"Usage - Raxol.Animation.Framework","type":"module"},{"doc":"When defining an animation, you can specify `target_path` as a single property (e.g., `[:opacity]`).\nWhen you start the animation for a specific element, the framework will automatically scope the path to that element:\n- If you pass `element_id = \"foo\"` and `target_path = [:opacity]`, the animation will update `[:elements, \"foo\", :opacity]` in your state.\n- If you provide a fully qualified path (e.g., `[:elements, \"foo\", :opacity]`), it will be used as-is.","ref":"Raxol.Animation.Framework.html#module-about-target_path","title":"About target_path - Raxol.Animation.Framework","type":"module"},{"doc":"Update animations and apply their current values to the state.","ref":"Raxol.Animation.Framework.html#apply_animations_to_state/2","title":"Raxol.Animation.Framework.apply_animations_to_state/2","type":"function"},{"doc":"* `state` - Current application state\n* `user_preferences_pid` - (Optional) The UserPreferences process pid or name for accessibility announcements","ref":"Raxol.Animation.Framework.html#apply_animations_to_state/2-parameters","title":"Parameters - Raxol.Animation.Framework.apply_animations_to_state/2","type":"function"},{"doc":"Updated state with animation values applied.","ref":"Raxol.Animation.Framework.html#apply_animations_to_state/2-returns","title":"Returns - Raxol.Animation.Framework.apply_animations_to_state/2","type":"function"},{"doc":"Create a new animation.","ref":"Raxol.Animation.Framework.html#create_animation/2","title":"Raxol.Animation.Framework.create_animation/2","type":"function"},{"doc":"* `name` - Unique identifier for the animation\n* `params` - Animation parameters","ref":"Raxol.Animation.Framework.html#create_animation/2-parameters","title":"Parameters - Raxol.Animation.Framework.create_animation/2","type":"function"},{"doc":"* `:type` - Animation type (:fade, :slide, :scale, :color, :generic)\n* `:duration` - Duration in milliseconds\n* `:easing` - Easing function name\n* `:from` - Starting value\n* `:to` - Ending value\n* `:direction` - Animation direction (:in, :out)\n* `:announce_to_screen_reader` - Whether to announce to screen readers\n* `:description` - Description for screen reader announcements\n* `:target_path` - Path within the state to animate. This can be a property (e.g., `[:opacity]`),\n  in which case the framework will scope it to the element's state when starting the animation.\n  If you provide a fully qualified path (e.g., `[:elements, \"my_element_id\", :opacity]`), it will be used as-is.","ref":"Raxol.Animation.Framework.html#create_animation/2-options","title":"Options - Raxol.Animation.Framework.create_animation/2","type":"function"},{"doc":"iex> AnimationFramework.create_animation(:fade_in, %{\n    ...>   type: :fade,\n    ...>   duration: 300,\n    ...>   easing: :ease_out_cubic,\n    ...>   from: 0.0,\n    ...>   to: 1.0,\n    ...>   direction: :in,\n    ...>   target_path: [:opacity] # Will be scoped to the element when started\n    ...> })\n    %{\n      name: :fade_in,\n      type: :fade,\n      duration: 300,\n      easing: :ease_out_cubic,\n      from: 0.0,\n      to: 1.0,\n      direction: :in,\n      target_path: [:opacity]\n    }","ref":"Raxol.Animation.Framework.html#create_animation/2-examples","title":"Examples - Raxol.Animation.Framework.create_animation/2","type":"function"},{"doc":"Gets the current value and completion status of an animation instance.","ref":"Raxol.Animation.Framework.html#get_current_value/2","title":"Raxol.Animation.Framework.get_current_value/2","type":"function"},{"doc":"* `animation_name` - The name of the animation\n* `element_id` - Identifier for the element being animated","ref":"Raxol.Animation.Framework.html#get_current_value/2-parameters","title":"Parameters - Raxol.Animation.Framework.get_current_value/2","type":"function"},{"doc":"* `{value, done?}` - A tuple with the current animation value and a boolean indicating if it's finished.\n* `:not_found` - If the animation instance is not active.","ref":"Raxol.Animation.Framework.html#get_current_value/2-returns","title":"Returns - Raxol.Animation.Framework.get_current_value/2","type":"function"},{"doc":"iex> AnimationFramework.get_current_value(:fade_in, \"search_button\")\n    {0.5, false}","ref":"Raxol.Animation.Framework.html#get_current_value/2-examples","title":"Examples - Raxol.Animation.Framework.get_current_value/2","type":"function"},{"doc":"Initialize the animation framework.\n\nThis sets up the necessary state for tracking animations and\nintegrates with accessibility settings.","ref":"Raxol.Animation.Framework.html#init/2","title":"Raxol.Animation.Framework.init/2","type":"function"},{"doc":"* `:reduced_motion` - Start with reduced motion (default: from accessibility settings)\n* `:cognitive_accessibility` - Start with cognitive accessibility (default: from accessibility settings)\n* `:default_duration` - Default animation duration in milliseconds (default: 300)\n* `:frame_ms` - Frame duration in milliseconds (default: 33)","ref":"Raxol.Animation.Framework.html#init/2-options","title":"Options - Raxol.Animation.Framework.init/2","type":"function"},{"doc":"iex> AnimationFramework.init()\n    :ok\n\n    iex> AnimationFramework.init(reduced_motion: true)\n    :ok","ref":"Raxol.Animation.Framework.html#init/2-examples","title":"Examples - Raxol.Animation.Framework.init/2","type":"function"},{"doc":"","ref":"Raxol.Animation.Framework.html#should_apply_cognitive_accessibility?/0","title":"Raxol.Animation.Framework.should_apply_cognitive_accessibility?/0","type":"function"},{"doc":"","ref":"Raxol.Animation.Framework.html#should_reduce_motion?/1","title":"Raxol.Animation.Framework.should_reduce_motion?/1","type":"function"},{"doc":"Start an animation for a specific element.","ref":"Raxol.Animation.Framework.html#start_animation/4","title":"Raxol.Animation.Framework.start_animation/4","type":"function"},{"doc":"* `animation_name` - The name of the animation to start\n* `element_id` - Identifier for the element being animated\n* `opts` - Additional options\n* `user_preferences_pid` - (Optional) The UserPreferences process pid or name for accessibility announcements","ref":"Raxol.Animation.Framework.html#start_animation/4-parameters","title":"Parameters - Raxol.Animation.Framework.start_animation/4","type":"function"},{"doc":"* `:on_complete` - Function to call when animation completes\n* `:context` - Additional context for the animation","ref":"Raxol.Animation.Framework.html#start_animation/4-options","title":"Options - Raxol.Animation.Framework.start_animation/4","type":"function"},{"doc":"If the animation's `target_path` is a property (e.g., `[:opacity]`), the framework will automatically scope it to the element's state (e.g., `[:elements, element_id, :opacity]`).\nIf you provide a fully qualified path, it will be used as-is.","ref":"Raxol.Animation.Framework.html#start_animation/4-path-scoping","title":"Path Scoping - Raxol.Animation.Framework.start_animation/4","type":"function"},{"doc":"iex> AnimationFramework.start_animation(:fade_in, \"search_button\", %{}, user_preferences_pid)\n    :ok\n\n    iex> AnimationFramework.start_animation(:slide_in, \"panel\", %{on_complete: &handle_complete/1}, user_preferences_pid)\n    :ok","ref":"Raxol.Animation.Framework.html#start_animation/4-examples","title":"Examples - Raxol.Animation.Framework.start_animation/4","type":"function"},{"doc":"Stops all animations and clears animation state. Used for test cleanup.","ref":"Raxol.Animation.Framework.html#stop/0","title":"Raxol.Animation.Framework.stop/0","type":"function"},{"doc":"Stops a specific animation for an element.","ref":"Raxol.Animation.Framework.html#stop_animation/2","title":"Raxol.Animation.Framework.stop_animation/2","type":"function"},{"doc":"* `animation_name` - The name of the animation to stop\n* `element_id` - Identifier for the element being animated","ref":"Raxol.Animation.Framework.html#stop_animation/2-parameters","title":"Parameters - Raxol.Animation.Framework.stop_animation/2","type":"function"},{"doc":"iex> AnimationFramework.stop_animation(:fade_in, \"search_button\")\n    :ok","ref":"Raxol.Animation.Framework.html#stop_animation/2-examples","title":"Examples - Raxol.Animation.Framework.stop_animation/2","type":"function"},{"doc":"Gesture-driven interactions for Raxol animations.\n\nThis module provides a system for detecting and handling gestures in terminal UI,\nwhich can be used to trigger physics-based animations.\n\nSupported gestures include:\n* Swipe (rapid movement in a direction)\n* Tap (quick press and release)\n* Long press (press and hold)\n* Drag (press, move, release)\n* Pinch/zoom (simulated in terminal context)\n* Multi-tap (multiple quick taps)","ref":"Raxol.Animation.Gestures.html","title":"Raxol.Animation.Gestures","type":"module"},{"doc":"","ref":"Raxol.Animation.Gestures.html#t:direction/0","title":"Raxol.Animation.Gestures.direction/0","type":"type"},{"doc":"","ref":"Raxol.Animation.Gestures.html#t:gesture_type/0","title":"Raxol.Animation.Gestures.gesture_type/0","type":"type"},{"doc":"Gets the current state of all objects in active animations.\nThis is used for rendering.","ref":"Raxol.Animation.Gestures.html#get_animation_objects/0","title":"Raxol.Animation.Gestures.get_animation_objects/0","type":"function"},{"doc":"","ref":"Raxol.Animation.Gestures.html#t:handler/0","title":"Raxol.Animation.Gestures.handler/0","type":"type"},{"doc":"Initializes the gesture system.","ref":"Raxol.Animation.Gestures.html#init/0","title":"Raxol.Animation.Gestures.init/0","type":"function"},{"doc":"","ref":"Raxol.Animation.Gestures.html#t:position/0","title":"Raxol.Animation.Gestures.position/0","type":"type"},{"doc":"Registers a handler for a specific gesture type.","ref":"Raxol.Animation.Gestures.html#register_handler/2","title":"Raxol.Animation.Gestures.register_handler/2","type":"function"},{"doc":"iex> register_handler(:swipe, fn %{direction: :left} -> handle_left_swipe() end)\n    :ok","ref":"Raxol.Animation.Gestures.html#register_handler/2-examples","title":"Examples - Raxol.Animation.Gestures.register_handler/2","type":"function"},{"doc":"Handles a touch/mouse down event.","ref":"Raxol.Animation.Gestures.html#touch_down/2","title":"Raxol.Animation.Gestures.touch_down/2","type":"function"},{"doc":"Handles a touch/mouse move event.","ref":"Raxol.Animation.Gestures.html#touch_move/2","title":"Raxol.Animation.Gestures.touch_move/2","type":"function"},{"doc":"Handles a touch/mouse up event.","ref":"Raxol.Animation.Gestures.html#touch_up/2","title":"Raxol.Animation.Gestures.touch_up/2","type":"function"},{"doc":"Updates all active physics-based animations.\nShould be called on each frame.","ref":"Raxol.Animation.Gestures.html#update_animations/1","title":"Raxol.Animation.Gestures.update_animations/1","type":"function"},{"doc":"Provides interpolation functions for different data types.","ref":"Raxol.Animation.Interpolate.html","title":"Raxol.Animation.Interpolate","type":"module"},{"doc":"Interpolates between two values based on progress `t` (0.0 to 1.0).","ref":"Raxol.Animation.Interpolate.html#value/3","title":"Raxol.Animation.Interpolate.value/3","type":"function"},{"doc":"Force field implementation for physics simulations.\n\nForce fields apply forces to physics objects within their influence.\nTypes of force fields include:\n\n* Point (radial forces emanating from a point)\n* Directional (constant force in a direction, like wind)\n* Vortex (spinning forces)\n* Noise (random forces based on position)\n* Custom (user-defined force function)","ref":"Raxol.Animation.Physics.ForceField.html","title":"Raxol.Animation.Physics.ForceField","type":"module"},{"doc":"Calculates the force applied by a field on an object.","ref":"Raxol.Animation.Physics.ForceField.html#calculate_force/2","title":"Raxol.Animation.Physics.ForceField.calculate_force/2","type":"function"},{"doc":"Creates a new custom force field.\n\nA custom force field uses a user-provided function to calculate forces.","ref":"Raxol.Animation.Physics.ForceField.html#custom_field/2","title":"Raxol.Animation.Physics.ForceField.custom_field/2","type":"function"},{"doc":"* `:function` - Function to calculate force (fn object, field -> force_vector end)\n* `:properties` - Additional properties for the function (default: %{})","ref":"Raxol.Animation.Physics.ForceField.html#custom_field/2-options","title":"Options - Raxol.Animation.Physics.ForceField.custom_field/2","type":"function"},{"doc":"Creates a new directional force field.\n\nA directional force field applies a constant force in a specific direction,\nlike wind or gravity.","ref":"Raxol.Animation.Physics.ForceField.html#directional_field/1","title":"Raxol.Animation.Physics.ForceField.directional_field/1","type":"function"},{"doc":"* `:direction` - Direction of the force (default: up)\n* `:strength` - Strength of the field (default: 1.0)","ref":"Raxol.Animation.Physics.ForceField.html#directional_field/1-options","title":"Options - Raxol.Animation.Physics.ForceField.directional_field/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Physics.ForceField.html#t:field_type/0","title":"Raxol.Animation.Physics.ForceField.field_type/0","type":"type"},{"doc":"Creates a new noise force field.\n\nA noise force field applies pseudo-random forces based on position.","ref":"Raxol.Animation.Physics.ForceField.html#noise_field/1","title":"Raxol.Animation.Physics.ForceField.noise_field/1","type":"function"},{"doc":"* `:strength` - Strength of the field (default: 1.0)\n* `:scale` - Scale of the noise (default: 0.1)\n* `:seed` - Random seed (default: random)","ref":"Raxol.Animation.Physics.ForceField.html#noise_field/1-options","title":"Options - Raxol.Animation.Physics.ForceField.noise_field/1","type":"function"},{"doc":"Creates a new point force field.\n\nA point force field applies forces radiating from or towards a point.\nPositive strength = repulsive, Negative strength = attractive.","ref":"Raxol.Animation.Physics.ForceField.html#point_field/1","title":"Raxol.Animation.Physics.ForceField.point_field/1","type":"function"},{"doc":"* `:position` - Position of the field (default: origin)\n* `:strength` - Strength of the field (default: 1.0)\n* `:radius` - Radius of influence (default: 10.0)\n* `:falloff` - How force decreases with distance (:linear, :quadratic, :none) (default: :quadratic)","ref":"Raxol.Animation.Physics.ForceField.html#point_field/1-options","title":"Options - Raxol.Animation.Physics.ForceField.point_field/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Physics.ForceField.html#t:t/0","title":"Raxol.Animation.Physics.ForceField.t/0","type":"type"},{"doc":"Creates a new vortex force field.\n\nA vortex force field applies spinning forces around an axis.","ref":"Raxol.Animation.Physics.ForceField.html#vortex_field/1","title":"Raxol.Animation.Physics.ForceField.vortex_field/1","type":"function"},{"doc":"* `:position` - Center of the vortex (default: origin)\n* `:direction` - Axis of rotation (default: up)\n* `:strength` - Strength of the field (default: 1.0)\n* `:radius` - Radius of influence (default: 10.0)\n* `:falloff` - How force decreases with distance (:linear, :quadratic, :none) (default: :linear)","ref":"Raxol.Animation.Physics.ForceField.html#vortex_field/1-options","title":"Options - Raxol.Animation.Physics.ForceField.vortex_field/1","type":"function"},{"doc":"Physics engine for Raxol animations.\n\nProvides physics-based animation capabilities including:\n* Spring simulations\n* Gravity and bounce effects\n* Friction and damping\n* Collisions\n* Particle systems\n* Force fields\n\nThese can be used to create natural, organic animations that respond\nto user interactions in a physically plausible way.","ref":"Raxol.Animation.Physics.PhysicsEngine.html","title":"Raxol.Animation.Physics.PhysicsEngine","type":"module"},{"doc":"Adds a force field to the physics world.","ref":"Raxol.Animation.Physics.PhysicsEngine.html#add_force_field/2","title":"Raxol.Animation.Physics.PhysicsEngine.add_force_field/2","type":"function"},{"doc":"Adds an object to the physics world.","ref":"Raxol.Animation.Physics.PhysicsEngine.html#add_object/2","title":"Raxol.Animation.Physics.PhysicsEngine.add_object/2","type":"function"},{"doc":"Applies an impulse force to an object.","ref":"Raxol.Animation.Physics.PhysicsEngine.html#apply_impulse/3","title":"Raxol.Animation.Physics.PhysicsEngine.apply_impulse/3","type":"function"},{"doc":"Creates a particle system at the specified position.","ref":"Raxol.Animation.Physics.PhysicsEngine.html#create_particle_system/4","title":"Raxol.Animation.Physics.PhysicsEngine.create_particle_system/4","type":"function"},{"doc":"Creates a new physics object with the given properties.","ref":"Raxol.Animation.Physics.PhysicsEngine.html#new_object/2","title":"Raxol.Animation.Physics.PhysicsEngine.new_object/2","type":"function"},{"doc":"Creates a new physics world with default values.","ref":"Raxol.Animation.Physics.PhysicsEngine.html#new_world/0","title":"Raxol.Animation.Physics.PhysicsEngine.new_world/0","type":"function"},{"doc":"Creates a new physics world with custom settings.","ref":"Raxol.Animation.Physics.PhysicsEngine.html#new_world/1","title":"Raxol.Animation.Physics.PhysicsEngine.new_world/1","type":"function"},{"doc":"","ref":"Raxol.Animation.Physics.PhysicsEngine.html#t:physics_object/0","title":"Raxol.Animation.Physics.PhysicsEngine.physics_object/0","type":"type"},{"doc":"Removes an object from the physics world.","ref":"Raxol.Animation.Physics.PhysicsEngine.html#remove_object/2","title":"Raxol.Animation.Physics.PhysicsEngine.remove_object/2","type":"function"},{"doc":"Sets the boundaries of the physics world.","ref":"Raxol.Animation.Physics.PhysicsEngine.html#set_boundaries/2","title":"Raxol.Animation.Physics.PhysicsEngine.set_boundaries/2","type":"function"},{"doc":"Creates a spring force between two objects.","ref":"Raxol.Animation.Physics.PhysicsEngine.html#spring_force/5","title":"Raxol.Animation.Physics.PhysicsEngine.spring_force/5","type":"function"},{"doc":"Updates the physics world by one time step.","ref":"Raxol.Animation.Physics.PhysicsEngine.html#update/2","title":"Raxol.Animation.Physics.PhysicsEngine.update/2","type":"function"},{"doc":"","ref":"Raxol.Animation.Physics.PhysicsEngine.html#t:world_state/0","title":"Raxol.Animation.Physics.PhysicsEngine.world_state/0","type":"type"},{"doc":"3D vector implementation for physics simulations.\n\nProvides basic vector operations needed for physics calculations.","ref":"Raxol.Animation.Physics.Vector.html","title":"Raxol.Animation.Physics.Vector","type":"module"},{"doc":"Adds two vectors.","ref":"Raxol.Animation.Physics.Vector.html#add/2","title":"Raxol.Animation.Physics.Vector.add/2","type":"function"},{"doc":"Calculates the angle between two vectors in radians.","ref":"Raxol.Animation.Physics.Vector.html#angle/2","title":"Raxol.Animation.Physics.Vector.angle/2","type":"function"},{"doc":"Calculates the cross product of two vectors.","ref":"Raxol.Animation.Physics.Vector.html#cross/2","title":"Raxol.Animation.Physics.Vector.cross/2","type":"function"},{"doc":"Calculates the distance between two points represented as vectors.","ref":"Raxol.Animation.Physics.Vector.html#distance/2","title":"Raxol.Animation.Physics.Vector.distance/2","type":"function"},{"doc":"Calculates the dot product of two vectors.","ref":"Raxol.Animation.Physics.Vector.html#dot/2","title":"Raxol.Animation.Physics.Vector.dot/2","type":"function"},{"doc":"Creates a vector from spherical coordinates.","ref":"Raxol.Animation.Physics.Vector.html#from_spherical/3","title":"Raxol.Animation.Physics.Vector.from_spherical/3","type":"function"},{"doc":"Performs linear interpolation between two vectors.","ref":"Raxol.Animation.Physics.Vector.html#lerp/3","title":"Raxol.Animation.Physics.Vector.lerp/3","type":"function"},{"doc":"Calculates the magnitude (length) of a vector.","ref":"Raxol.Animation.Physics.Vector.html#magnitude/1","title":"Raxol.Animation.Physics.Vector.magnitude/1","type":"function"},{"doc":"Returns the negation of the vector.","ref":"Raxol.Animation.Physics.Vector.html#negate/1","title":"Raxol.Animation.Physics.Vector.negate/1","type":"function"},{"doc":"Creates a new vector with the specified components.","ref":"Raxol.Animation.Physics.Vector.html#new/3","title":"Raxol.Animation.Physics.Vector.new/3","type":"function"},{"doc":"Normalizes a vector (makes it unit length).","ref":"Raxol.Animation.Physics.Vector.html#normalize/1","title":"Raxol.Animation.Physics.Vector.normalize/1","type":"function"},{"doc":"Multiplies a vector by a scalar.","ref":"Raxol.Animation.Physics.Vector.html#scale/2","title":"Raxol.Animation.Physics.Vector.scale/2","type":"function"},{"doc":"Subtracts the second vector from the first.","ref":"Raxol.Animation.Physics.Vector.html#subtract/2","title":"Raxol.Animation.Physics.Vector.subtract/2","type":"function"},{"doc":"","ref":"Raxol.Animation.Physics.Vector.html#t:t/0","title":"Raxol.Animation.Physics.Vector.t/0","type":"type"},{"doc":"Converts the vector to a string representation.","ref":"Raxol.Animation.Physics.Vector.html#to_string/1","title":"Raxol.Animation.Physics.Vector.to_string/1","type":"function"},{"doc":"Manages the state for the Raxol Animation Framework.\n\nThis module encapsulates the storage and retrieval of animation settings,\ndefinitions, and active instances, currently using the process dictionary.","ref":"Raxol.Animation.StateManager.html","title":"Raxol.Animation.StateManager","type":"module"},{"doc":"Clears all animation state (used primarily for testing or reset).","ref":"Raxol.Animation.StateManager.html#clear_all/0","title":"Raxol.Animation.StateManager.clear_all/0","type":"function"},{"doc":"Retrieves all active animations. Returns a map of `{element_id, %{animation_name => instance}}`.","ref":"Raxol.Animation.StateManager.html#get_active_animations/0","title":"Raxol.Animation.StateManager.get_active_animations/0","type":"function"},{"doc":"Retrieves an animation definition by name.","ref":"Raxol.Animation.StateManager.html#get_animation/1","title":"Raxol.Animation.StateManager.get_animation/1","type":"function"},{"doc":"Retrieves the animation framework settings.","ref":"Raxol.Animation.StateManager.html#get_settings/0","title":"Raxol.Animation.StateManager.get_settings/0","type":"function"},{"doc":"Initializes the animation state storage.","ref":"Raxol.Animation.StateManager.html#init/1","title":"Raxol.Animation.StateManager.init/1","type":"function"},{"doc":"Stores an active animation instance for a given element.","ref":"Raxol.Animation.StateManager.html#put_active_animation/3","title":"Raxol.Animation.StateManager.put_active_animation/3","type":"function"},{"doc":"Stores an animation definition.","ref":"Raxol.Animation.StateManager.html#put_animation/1","title":"Raxol.Animation.StateManager.put_animation/1","type":"function"},{"doc":"Removes a completed or stopped animation instance for a specific element.","ref":"Raxol.Animation.StateManager.html#remove_active_animation/2","title":"Raxol.Animation.StateManager.remove_active_animation/2","type":"function"},{"doc":"","ref":"Raxol.Application.html","title":"Raxol.Application","type":"module"},{"doc":"Authentication module for handling user authentication and authorization.\n\nThis module provides functionality for:\n- User authentication\n- Token generation and validation\n- Role-based access control\n- Session management","ref":"Raxol.Auth.html","title":"Raxol.Auth","type":"module"},{"doc":"Cleans up a user session.","ref":"Raxol.Auth.html#cleanup_user_session/1","title":"Raxol.Auth.cleanup_user_session/1","type":"function"},{"doc":"Creates a new session for an authenticated user.\n(Session logic currently commented out, returns :ok)","ref":"Raxol.Auth.html#create_user_session/2","title":"Raxol.Auth.create_user_session/2","type":"function"},{"doc":"Retrieves user information by ID (Calls Accounts).","ref":"Raxol.Auth.html#get_user/1","title":"Raxol.Auth.get_user/1","type":"function"},{"doc":"Retrieves a user by their session ID.\nNOTE: This function is a stub. Returns the user or nil if not found or session is invalid.","ref":"Raxol.Auth.html#get_user_by_session/1","title":"Raxol.Auth.get_user_by_session/1","type":"function"},{"doc":"Checks if a user has permission for a specific action (Placeholder).","ref":"Raxol.Auth.html#has_permission?/3","title":"Raxol.Auth.has_permission?/3","type":"function"},{"doc":"Checks if a user has the required role.","ref":"Raxol.Auth.html#has_role?/2","title":"Raxol.Auth.has_role?/2","type":"function"},{"doc":"Validates a session token and returns the associated user ID.\nWARNING: This is a placeholder and insecure. Needs proper implementation.","ref":"Raxol.Auth.html#validate_token/2","title":"Raxol.Auth.validate_token/2","type":"function"},{"doc":"Permission schema for role-based access control.","ref":"Raxol.Auth.Permission.html","title":"Raxol.Auth.Permission","type":"module"},{"doc":"Creates a changeset for a permission.","ref":"Raxol.Auth.Permission.html#changeset/2","title":"Raxol.Auth.Permission.changeset/2","type":"function"},{"doc":"Creates a changeset for a system permission.","ref":"Raxol.Auth.Permission.html#system_changeset/2","title":"Raxol.Auth.Permission.system_changeset/2","type":"function"},{"doc":"Plug for handling authentication and authorization.","ref":"Raxol.Auth.Plug.html","title":"Raxol.Auth.Plug","type":"module"},{"doc":"Authenticates a user by email and password.","ref":"Raxol.Auth.Plug.html#authenticate_user/3","title":"Raxol.Auth.Plug.authenticate_user/3","type":"function"},{"doc":"","ref":"Raxol.Auth.Plug.html#call/2","title":"Raxol.Auth.Plug.call/2","type":"function"},{"doc":"","ref":"Raxol.Auth.Plug.html#init/1","title":"Raxol.Auth.Plug.init/1","type":"function"},{"doc":"","ref":"Raxol.Auth.Plug.html#is_admin?/1","title":"Raxol.Auth.Plug.is_admin?/1","type":"macro"},{"doc":"Logs out the current user.","ref":"Raxol.Auth.Plug.html#logout_user/1","title":"Raxol.Auth.Plug.logout_user/1","type":"function"},{"doc":"Checks if the current user is logged in.","ref":"Raxol.Auth.Plug.html#require_authenticated_user/2","title":"Raxol.Auth.Plug.require_authenticated_user/2","type":"function"},{"doc":"","ref":"Raxol.Auth.Plug.html#require_permission/3","title":"Raxol.Auth.Plug.require_permission/3","type":"function"},{"doc":"Role schema for role-based access control.","ref":"Raxol.Auth.Role.html","title":"Raxol.Auth.Role","type":"module"},{"doc":"Creates a changeset for a role.","ref":"Raxol.Auth.Role.html#changeset/2","title":"Raxol.Auth.Role.changeset/2","type":"function"},{"doc":"Creates a changeset for a system role.","ref":"Raxol.Auth.Role.html#system_changeset/2","title":"Raxol.Auth.Role.system_changeset/2","type":"function"},{"doc":"User schema for authentication and authorization.","ref":"Raxol.Auth.User.html","title":"Raxol.Auth.User","type":"module"},{"doc":"Creates a changeset for a user.","ref":"Raxol.Auth.User.html#changeset/2","title":"Raxol.Auth.User.changeset/2","type":"function"},{"doc":"Creates a changeset for password reset.","ref":"Raxol.Auth.User.html#password_reset_changeset/2","title":"Raxol.Auth.User.password_reset_changeset/2","type":"function"},{"doc":"Creates a changeset for registration.","ref":"Raxol.Auth.User.html#registration_changeset/2","title":"Raxol.Auth.User.registration_changeset/2","type":"function"},{"doc":"Benchmarking utilities for Raxol.","ref":"Raxol.Benchmark.html","title":"Raxol.Benchmark","type":"module"},{"doc":"Run a benchmark with the given configuration.","ref":"Raxol.Benchmark.html#run_benchmark/1","title":"Raxol.Benchmark.run_benchmark/1","type":"function"},{"doc":"Performance benchmarking and validation tools for Raxol.\n\nThis module provides utilities for measuring and validating performance metrics\nincluding rendering speed, memory usage, and event handling latency.","ref":"Raxol.Benchmarks.Performance.html","title":"Raxol.Benchmarks.Performance","type":"module"},{"doc":"Runs all performance benchmarks and returns the results.","ref":"Raxol.Benchmarks.Performance.html#run_all/1","title":"Raxol.Benchmarks.Performance.run_all/1","type":"function"},{"doc":"* `:save_results` - Save results to file (default: `true`)\n* `:compare_with_baseline` - Compare with baseline metrics (default: `true`)\n* `:detailed` - Include detailed metrics (default: `false`)","ref":"Raxol.Benchmarks.Performance.html#run_all/1-options","title":"Options - Raxol.Benchmarks.Performance.run_all/1","type":"function"},{"doc":"Map containing benchmark results with the following structure:\n\n```\n%{\n  render_performance: %{...},\n  event_latency: %{...},\n  memory_usage: %{...},\n  animation_fps: %{...},\n  metrics_validation: %{...}\n}\n```","ref":"Raxol.Benchmarks.Performance.html#run_all/1-returns","title":"Returns - Raxol.Benchmarks.Performance.run_all/1","type":"function"},{"doc":"Animation performance benchmark functions for Raxol.","ref":"Raxol.Benchmarks.Performance.Animation.html","title":"Raxol.Benchmarks.Performance.Animation","type":"module"},{"doc":"Benchmarks animation performance and frame rate stability.\n\nTests:\n- Maximum achievable FPS\n- Frame time consistency\n- Animation smoothness\n- CPU usage during animation","ref":"Raxol.Benchmarks.Performance.Animation.html#benchmark_animation_performance/0","title":"Raxol.Benchmarks.Performance.Animation.benchmark_animation_performance/0","type":"function"},{"doc":"Event handling performance benchmark functions for Raxol.","ref":"Raxol.Benchmarks.Performance.EventHandling.html","title":"Raxol.Benchmarks.Performance.EventHandling","type":"module"},{"doc":"Benchmarks event handling latency for different event types and volumes.\n\nTests event handling for:\n- Keyboard events\n- Mouse events\n- Window events\n- Custom events\n- High-volume event bursts","ref":"Raxol.Benchmarks.Performance.EventHandling.html#benchmark_event_handling/0","title":"Raxol.Benchmarks.Performance.EventHandling.benchmark_event_handling/0","type":"function"},{"doc":"Memory usage performance benchmark functions for Raxol.","ref":"Raxol.Benchmarks.Performance.MemoryUsage.html","title":"Raxol.Benchmarks.Performance.MemoryUsage","type":"module"},{"doc":"Benchmarks memory usage patterns for components and rendering cycles.\n\nMeasures:\n- Memory consumption per component\n- Memory growth during rendering\n- GC impact on performance\n- Memory leaks in long-running scenarios","ref":"Raxol.Benchmarks.Performance.MemoryUsage.html#benchmark_memory_usage/0","title":"Raxol.Benchmarks.Performance.MemoryUsage.benchmark_memory_usage/0","type":"function"},{"doc":"Rendering performance benchmark functions for Raxol.","ref":"Raxol.Benchmarks.Performance.Rendering.html","title":"Raxol.Benchmarks.Performance.Rendering","type":"module"},{"doc":"Benchmarks rendering performance for various component types and complexities.\n\nTests rendering performance for:\n- Simple components (text, buttons)\n- Medium complexity (tables, lists)\n- Complex components (dashboards, multi-panel layouts)","ref":"Raxol.Benchmarks.Performance.Rendering.html#benchmark_rendering/0","title":"Raxol.Benchmarks.Performance.Rendering.benchmark_rendering/0","type":"function"},{"doc":"","ref":"Raxol.Benchmarks.Performance.Rendering.html#calculate_components_per_frame/1","title":"Raxol.Benchmarks.Performance.Rendering.calculate_components_per_frame/1","type":"function"},{"doc":"","ref":"Raxol.Benchmarks.Performance.Rendering.html#calculate_renders_per_second/1","title":"Raxol.Benchmarks.Performance.Rendering.calculate_renders_per_second/1","type":"function"},{"doc":"","ref":"Raxol.Benchmarks.Performance.Rendering.html#generate_test_component/1","title":"Raxol.Benchmarks.Performance.Rendering.generate_test_component/1","type":"function"},{"doc":"","ref":"Raxol.Benchmarks.Performance.Rendering.html#measure_full_screen_render/1","title":"Raxol.Benchmarks.Performance.Rendering.measure_full_screen_render/1","type":"function"},{"doc":"","ref":"Raxol.Benchmarks.Performance.Rendering.html#measure_render_time/2","title":"Raxol.Benchmarks.Performance.Rendering.measure_render_time/2","type":"function"},{"doc":"","ref":"Raxol.Benchmarks.Performance.Rendering.html#render_component/1","title":"Raxol.Benchmarks.Performance.Rendering.render_component/1","type":"function"},{"doc":"Reporting functions (saving, printing) for Raxol performance benchmarks.","ref":"Raxol.Benchmarks.Performance.Reporting.html","title":"Raxol.Benchmarks.Performance.Reporting","type":"module"},{"doc":"","ref":"Raxol.Benchmarks.Performance.Reporting.html#print_summary/2","title":"Raxol.Benchmarks.Performance.Reporting.print_summary/2","type":"function"},{"doc":"Saves benchmark results to a file.","ref":"Raxol.Benchmarks.Performance.Reporting.html#save_benchmark_results/2","title":"Raxol.Benchmarks.Performance.Reporting.save_benchmark_results/2","type":"function"},{"doc":"* `results` - Benchmark results map\n* `file_path` - Path to save results (default: auto-generated)","ref":"Raxol.Benchmarks.Performance.Reporting.html#save_benchmark_results/2-parameters","title":"Parameters - Raxol.Benchmarks.Performance.Reporting.save_benchmark_results/2","type":"function"},{"doc":"Validation functions for Raxol performance benchmarks.","ref":"Raxol.Benchmarks.Performance.Validation.html","title":"Raxol.Benchmarks.Performance.Validation","type":"module"},{"doc":"Retrieves baseline performance metrics for the current platform.\n\nIf no platform-specific baseline exists, falls back to default baseline.","ref":"Raxol.Benchmarks.Performance.Validation.html#get_baseline_metrics/0","title":"Raxol.Benchmarks.Performance.Validation.get_baseline_metrics/0","type":"function"},{"doc":"Validates performance against baseline requirements.","ref":"Raxol.Benchmarks.Performance.Validation.html#validate_metrics/2","title":"Raxol.Benchmarks.Performance.Validation.validate_metrics/2","type":"function"},{"doc":"* `results` - Current benchmark results\n* `baseline` - Baseline metrics to compare against","ref":"Raxol.Benchmarks.Performance.Validation.html#validate_metrics/2-parameters","title":"Parameters - Raxol.Benchmarks.Performance.Validation.validate_metrics/2","type":"function"},{"doc":"Map containing validation results and pass/fail status for each metric","ref":"Raxol.Benchmarks.Performance.Validation.html#validate_metrics/2-returns","title":"Returns - Raxol.Benchmarks.Performance.Validation.validate_metrics/2","type":"function"},{"doc":"Performance benchmarking tool for visualization components.\nProvides tools to measure rendering time, memory usage, and optimization effectiveness\nfor different data sizes and visualization types.","ref":"Raxol.Benchmarks.VisualizationBenchmark.html","title":"Raxol.Benchmarks.VisualizationBenchmark","type":"module"},{"doc":"Benchmark chart rendering performance.","ref":"Raxol.Benchmarks.VisualizationBenchmark.html#benchmark_charts/4","title":"Raxol.Benchmarks.VisualizationBenchmark.benchmark_charts/4","type":"function"},{"doc":"Benchmark treemap rendering performance.","ref":"Raxol.Benchmarks.VisualizationBenchmark.html#benchmark_treemaps/4","title":"Raxol.Benchmarks.VisualizationBenchmark.benchmark_treemaps/4","type":"function"},{"doc":"Run a comprehensive benchmark suite for visualization components.\n\nThis test will:\n1. Generate test datasets of varying sizes\n2. Benchmark chart rendering performance\n3. Benchmark treemap rendering performance\n4. Test cache hit performance\n5. Measure memory usage\n6. Generate a summary report","ref":"Raxol.Benchmarks.VisualizationBenchmark.html#run_benchmark/1","title":"Raxol.Benchmarks.VisualizationBenchmark.run_benchmark/1","type":"function"},{"doc":"* `:output_path` - Path to write the benchmark results (default: \"benchmark_results\")\n* `:datasets` - List of dataset sizes to test (default: [10, 100, 1000, 10000])\n* `:iterations` - Number of times to run each test (default: 5)\n* `:cache_test` - Whether to test cache performance (default: true)\n* `:memory_test` - Whether to track memory usage (default: true)","ref":"Raxol.Benchmarks.VisualizationBenchmark.html#run_benchmark/1-options","title":"Options - Raxol.Benchmarks.VisualizationBenchmark.run_benchmark/1","type":"function"},{"doc":"A realistic benchmark tool for visualization components with progressive data sizes.\nTests the performance impact of our optimizations on various dataset sizes.","ref":"Raxol.Benchmarks.VisualizationBenchmarkRealistic.html","title":"Raxol.Benchmarks.VisualizationBenchmarkRealistic","type":"module"},{"doc":"Run a benchmark test with realistic dataset sizes.\n\nThis function tests the caching system and data sampling optimizations\nwith progressively larger data sizes.\n\nReturns a map with the benchmark results.","ref":"Raxol.Benchmarks.VisualizationBenchmarkRealistic.html#run_benchmark/0","title":"Raxol.Benchmarks.VisualizationBenchmarkRealistic.run_benchmark/0","type":"function"},{"doc":"A simplified benchmark tool for visualization components, without external dependencies.\nThis is designed for direct testing during development without requiring the full application.","ref":"Raxol.Benchmarks.VisualizationBenchmarkSimple.html","title":"Raxol.Benchmarks.VisualizationBenchmarkSimple","type":"module"},{"doc":"Run a simple benchmark test of the visualization caching system.\n\nThis function directly tests the VisualizationPlugin's caching system\nwith small data samples and doesn't require the full application to be running.\n\nReturns a map with the benchmark results.","ref":"Raxol.Benchmarks.VisualizationBenchmarkSimple.html#run_simple_benchmark/0","title":"Raxol.Benchmarks.VisualizationBenchmarkSimple.run_simple_benchmark/0","type":"function"},{"doc":"CLI command for managing Raxol updates.\n\nThis module handles:\n- Checking for updates\n- Performing self-updates\n- Managing update settings","ref":"Raxol.CLI.Commands.UpdateCmd.html","title":"Raxol.CLI.Commands.UpdateCmd","type":"module"},{"doc":"Executes the update command with the provided options and arguments.","ref":"Raxol.CLI.Commands.UpdateCmd.html#execute/1","title":"Raxol.CLI.Commands.UpdateCmd.execute/1","type":"function"},{"doc":"- `--check` or `-c`: Check for updates without installing\n- `--force` or `-f`: Force update check, bypassing the check interval\n- `--auto` or `-a`: Enable or disable automatic update checks (value: on/off)\n- `--version` or `-v`: Update to a specific version\n- `--no-delta` or `-n`: Disable delta updates and use full updates only\n- `--delta-info` or `-d`: Show information about delta update availability","ref":"Raxol.CLI.Commands.UpdateCmd.html#execute/1-options","title":"Options - Raxol.CLI.Commands.UpdateCmd.execute/1","type":"function"},{"doc":"Check for updates:\n```\nraxol update --check\n```\n\nPerform an update:\n```\nraxol update\n```\n\nUpdate to a specific version:\n```\nraxol update --version 0.2.0\n```\n\nUpdate without using delta updates:\n```\nraxol update --no-delta\n```\n\nDisable automatic update checks:\n```\nraxol update --auto off\n```","ref":"Raxol.CLI.Commands.UpdateCmd.html#execute/1-examples","title":"Examples - Raxol.CLI.Commands.UpdateCmd.execute/1","type":"function"},{"doc":"Handles clipboard operations across different platforms.\nProvides a unified interface for copy/paste functionality.","ref":"Raxol.Clipboard.html","title":"Raxol.Clipboard","type":"module"},{"doc":"Gets text from the system clipboard.\nReturns {:ok, text} on success, {:error, reason} on failure.","ref":"Raxol.Clipboard.html#get_text/0","title":"Raxol.Clipboard.get_text/0","type":"function"},{"doc":"Sets text to the system clipboard.\nReturns :ok on success, {:error, reason} on failure.","ref":"Raxol.Clipboard.html#set_text/1","title":"Raxol.Clipboard.set_text/1","type":"function"},{"doc":"Cloud integration system for Raxol applications.","ref":"Raxol.Cloud.html","title":"Raxol.Cloud","type":"module"},{"doc":"","ref":"Raxol.Cloud.html#config/3","title":"Raxol.Cloud.config/3","type":"function"},{"doc":"","ref":"Raxol.Cloud.html#connect/1","title":"Raxol.Cloud.connect/1","type":"function"},{"doc":"","ref":"Raxol.Cloud.html#deploy/1","title":"Raxol.Cloud.deploy/1","type":"function"},{"doc":"","ref":"Raxol.Cloud.html#discover/1","title":"Raxol.Cloud.discover/1","type":"function"},{"doc":"","ref":"Raxol.Cloud.html#execute/2","title":"Raxol.Cloud.execute/2","type":"function"},{"doc":"","ref":"Raxol.Cloud.html#init/1","title":"Raxol.Cloud.init/1","type":"function"},{"doc":"","ref":"Raxol.Cloud.html#monitor/3","title":"Raxol.Cloud.monitor/3","type":"function"},{"doc":"","ref":"Raxol.Cloud.html#register/1","title":"Raxol.Cloud.register/1","type":"function"},{"doc":"","ref":"Raxol.Cloud.html#scale/1","title":"Raxol.Cloud.scale/1","type":"function"},{"doc":"","ref":"Raxol.Cloud.html#start/0","title":"Raxol.Cloud.start/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.html#status/0","title":"Raxol.Cloud.status/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.html#stop/0","title":"Raxol.Cloud.stop/0","type":"function"},{"doc":"Configuration management for Raxol cloud integrations.\n\nProvides centralized configuration management with validation,\ndynamic updates, and multiple source support.","ref":"Raxol.Cloud.Config.html","title":"Raxol.Cloud.Config","type":"module"},{"doc":"","ref":"Raxol.Cloud.Config.html#cancel_backup/0","title":"Raxol.Cloud.Config.cancel_backup/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#cancel_sync/0","title":"Raxol.Cloud.Config.cancel_sync/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#clear_backup_error/0","title":"Raxol.Cloud.Config.clear_backup_error/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#clear_backup_log/0","title":"Raxol.Cloud.Config.clear_backup_log/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#clear_backup_stats/0","title":"Raxol.Cloud.Config.clear_backup_stats/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#clear_sync_error/0","title":"Raxol.Cloud.Config.clear_sync_error/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#clear_sync_log/0","title":"Raxol.Cloud.Config.clear_sync_log/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#clear_sync_stats/0","title":"Raxol.Cloud.Config.clear_sync_stats/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#default_config/0","title":"Raxol.Cloud.Config.default_config/0","type":"function"},{"doc":"Gets the current configuration.","ref":"Raxol.Cloud.Config.html#get/1","title":"Raxol.Cloud.Config.get/1","type":"function"},{"doc":"* `:section` - Specific configuration section to get\n* `:flatten` - Whether to flatten nested maps","ref":"Raxol.Cloud.Config.html#get/1-options","title":"Options - Raxol.Cloud.Config.get/1","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#get_backup_error/0","title":"Raxol.Cloud.Config.get_backup_error/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#get_backup_log/0","title":"Raxol.Cloud.Config.get_backup_log/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#get_backup_progress/0","title":"Raxol.Cloud.Config.get_backup_progress/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#get_backup_stats/0","title":"Raxol.Cloud.Config.get_backup_stats/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#get_backup_status/0","title":"Raxol.Cloud.Config.get_backup_status/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#get_config/0","title":"Raxol.Cloud.Config.get_config/0","type":"function"},{"doc":"Gets the default configuration value for a key.","ref":"Raxol.Cloud.Config.html#get_default/1","title":"Raxol.Cloud.Config.get_default/1","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#get_sync_error/0","title":"Raxol.Cloud.Config.get_sync_error/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#get_sync_log/0","title":"Raxol.Cloud.Config.get_sync_log/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#get_sync_progress/0","title":"Raxol.Cloud.Config.get_sync_progress/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#get_sync_stats/0","title":"Raxol.Cloud.Config.get_sync_stats/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#get_sync_status/0","title":"Raxol.Cloud.Config.get_sync_status/0","type":"function"},{"doc":"Initializes the configuration system.","ref":"Raxol.Cloud.Config.html#init/1","title":"Raxol.Cloud.Config.init/1","type":"function"},{"doc":"* `:sources` - List of configuration sources [:env, :file]\n* `:environment` - Environment to use (:development, :test, :production)\n* `:config_file` - Path to configuration file\n* `:auto_apply` - Whether to automatically apply configuration","ref":"Raxol.Cloud.Config.html#init/1-options","title":"Options - Raxol.Cloud.Config.init/1","type":"function"},{"doc":"Reloads configuration from all sources.","ref":"Raxol.Cloud.Config.html#reload/1","title":"Raxol.Cloud.Config.reload/1","type":"function"},{"doc":"* `:sources` - List of sources to reload from\n* `:apply` - Whether to apply the reloaded configuration","ref":"Raxol.Cloud.Config.html#reload/1-options","title":"Options - Raxol.Cloud.Config.reload/1","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#reset_config/0","title":"Raxol.Cloud.Config.reset_config/0","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#set_config/1","title":"Raxol.Cloud.Config.set_config/1","type":"function"},{"doc":"Gets the current status of the configuration system.","ref":"Raxol.Cloud.Config.html#status/0","title":"Raxol.Cloud.Config.status/0","type":"function"},{"doc":"Updates the configuration with new values.","ref":"Raxol.Cloud.Config.html#update/2","title":"Raxol.Cloud.Config.update/2","type":"function"},{"doc":"* `:section` - Section to update\n* `:validate` - Whether to validate the configuration\n* `:persist` - Whether to persist changes\n* `:apply` - Whether to apply changes","ref":"Raxol.Cloud.Config.html#update/2-options","title":"Options - Raxol.Cloud.Config.update/2","type":"function"},{"doc":"","ref":"Raxol.Cloud.Config.html#update_config/1","title":"Raxol.Cloud.Config.update_config/1","type":"function"},{"doc":"Core functionality for Raxol cloud integrations.\n\nThis module combines edge computing and monitoring capabilities,\nproviding a unified interface for cloud operations.","ref":"Raxol.Cloud.Core.html","title":"Raxol.Cloud.Core","type":"module"},{"doc":"Deploys an application component.","ref":"Raxol.Cloud.Core.html#deploy/1","title":"Raxol.Cloud.Core.deploy/1","type":"function"},{"doc":"Discovers services available in the current environment.","ref":"Raxol.Cloud.Core.html#discover_services/1","title":"Raxol.Cloud.Core.discover_services/1","type":"function"},{"doc":"Executes a function in the optimal location (edge or cloud).","ref":"Raxol.Cloud.Core.html#execute/2","title":"Raxol.Cloud.Core.execute/2","type":"function"},{"doc":"* `:priority` - Priority for execution (:speed, :reliability, :cost)\n* `:location` - Preferred location (:auto, :edge, :cloud)\n* `:timeout` - Timeout in milliseconds","ref":"Raxol.Cloud.Core.html#execute/2-options","title":"Options - Raxol.Cloud.Core.execute/2","type":"function"},{"doc":"Gets a connection to a cloud service.","ref":"Raxol.Cloud.Core.html#get_service_connection/1","title":"Raxol.Cloud.Core.get_service_connection/1","type":"function"},{"doc":"Initializes the cloud core components.","ref":"Raxol.Cloud.Core.html#init/1","title":"Raxol.Cloud.Core.init/1","type":"function"},{"doc":"* `:edge` - Edge computing options\n* `:monitoring` - Monitoring options\n* `:providers` - List of cloud providers to enable","ref":"Raxol.Cloud.Core.html#init/1-options","title":"Options - Raxol.Cloud.Core.init/1","type":"function"},{"doc":"Records an error or exception.","ref":"Raxol.Cloud.Core.html#record_error/2","title":"Raxol.Cloud.Core.record_error/2","type":"function"},{"doc":"Records a metric with the given name and value.","ref":"Raxol.Cloud.Core.html#record_metric/3","title":"Raxol.Cloud.Core.record_metric/3","type":"function"},{"doc":"Registers the current application as a service.","ref":"Raxol.Cloud.Core.html#register_service/1","title":"Raxol.Cloud.Core.register_service/1","type":"function"},{"doc":"Runs a health check on the system.","ref":"Raxol.Cloud.Core.html#run_health_check/1","title":"Raxol.Cloud.Core.run_health_check/1","type":"function"},{"doc":"Scales a service based on current metrics and conditions.","ref":"Raxol.Cloud.Core.html#scale/1","title":"Raxol.Cloud.Core.scale/1","type":"function"},{"doc":"Starts all cloud services.","ref":"Raxol.Cloud.Core.html#start/0","title":"Raxol.Cloud.Core.start/0","type":"function"},{"doc":"Returns the current status of all cloud services.","ref":"Raxol.Cloud.Core.html#status/0","title":"Raxol.Cloud.Core.status/0","type":"function"},{"doc":"Stops all cloud services.","ref":"Raxol.Cloud.Core.html#stop/0","title":"Raxol.Cloud.Core.stop/0","type":"function"},{"doc":"Triggers an alert with the given type and data.","ref":"Raxol.Cloud.Core.html#trigger_alert/3","title":"Raxol.Cloud.Core.trigger_alert/3","type":"function"},{"doc":"Edge computing support for Raxol applications.\n\nThis module provides functionality for optimizing Raxol applications\nat the edge, allowing for improved performance, reduced latency,\nand offline capabilities.\n\nFeatures:\n* Edge processing configuration\n* Offline mode and data synchronization\n* Resource optimization for edge devices\n* Automatic failover between edge and cloud\n* Edge-specific monitoring and diagnostics\n* Edge-to-cloud data streaming","ref":"Raxol.Cloud.EdgeComputing.html","title":"Raxol.Cloud.EdgeComputing","type":"module"},{"doc":"Manually checks the cloud connection status and updates the system state.","ref":"Raxol.Cloud.EdgeComputing.html#check_connection/0","title":"Raxol.Cloud.EdgeComputing.check_connection/0","type":"function"},{"doc":"Clears the edge cache.","ref":"Raxol.Cloud.EdgeComputing.html#clear_cache/0","title":"Raxol.Cloud.EdgeComputing.clear_cache/0","type":"function"},{"doc":"Executes a function at the edge or in the cloud based on current mode and conditions.","ref":"Raxol.Cloud.EdgeComputing.html#execute/2","title":"Raxol.Cloud.EdgeComputing.execute/2","type":"function"},{"doc":"* `:force_edge` - Force execution at the edge even in hybrid mode (default: false)\n* `:force_cloud` - Force execution in the cloud even in hybrid mode (default: false)\n* `:fallback_fn` - Function to execute if primary execution fails (default: nil)\n* `:timeout` - Timeout in milliseconds for the operation (default: 5000)\n* `:retry` - Number of retry attempts (default: from config)","ref":"Raxol.Cloud.EdgeComputing.html#execute/2-options","title":"Options - Raxol.Cloud.EdgeComputing.execute/2","type":"function"},{"doc":"iex> execute(fn -> process_data(data) end)\n    {:ok, result}","ref":"Raxol.Cloud.EdgeComputing.html#execute/2-examples","title":"Examples - Raxol.Cloud.EdgeComputing.execute/2","type":"function"},{"doc":"Forces the system into a specific mode.","ref":"Raxol.Cloud.EdgeComputing.html#force_mode/1","title":"Raxol.Cloud.EdgeComputing.force_mode/1","type":"function"},{"doc":"Gets metrics for the edge computing system.","ref":"Raxol.Cloud.EdgeComputing.html#get_metrics/0","title":"Raxol.Cloud.EdgeComputing.get_metrics/0","type":"function"},{"doc":"Initializes the edge computing system.","ref":"Raxol.Cloud.EdgeComputing.html#init/1","title":"Raxol.Cloud.EdgeComputing.init/1","type":"function"},{"doc":"* `:mode` - Operation mode (:edge_only, :cloud_only, :hybrid) (default: :hybrid)\n* `:connection_check_interval` - Time in ms between connection checks (default: 5000)\n* `:sync_interval` - Time in ms between cloud syncs (default: 30000)\n* `:retry_limit` - Number of retry attempts for operations (default: 5)\n* `:compression_enabled` - Whether to compress data for transfer (default: true)\n* `:offline_cache_size` - Maximum size in bytes for offline cache (default: 100MB)\n* `:priority_functions` - List of functions that should prioritize edge execution","ref":"Raxol.Cloud.EdgeComputing.html#init/1-options","title":"Options - Raxol.Cloud.EdgeComputing.init/1","type":"function"},{"doc":"iex> init(mode: :hybrid)\n    :ok","ref":"Raxol.Cloud.EdgeComputing.html#init/1-examples","title":"Examples - Raxol.Cloud.EdgeComputing.init/1","type":"function"},{"doc":"Checks if the system is currently operating in offline mode.","ref":"Raxol.Cloud.EdgeComputing.html#offline?/0","title":"Raxol.Cloud.EdgeComputing.offline?/0","type":"function"},{"doc":"Gets the current status of the edge computing system.","ref":"Raxol.Cloud.EdgeComputing.html#status/0","title":"Raxol.Cloud.EdgeComputing.status/0","type":"function"},{"doc":"Synchronizes data between edge and cloud.","ref":"Raxol.Cloud.EdgeComputing.html#sync/1","title":"Raxol.Cloud.EdgeComputing.sync/1","type":"function"},{"doc":"* `:force` - Force immediate synchronization (default: false)\n* `:selective` - List of data types to synchronize (default: all)\n* `:direction` - Sync direction (:both, :to_cloud, :from_cloud) (default: :both)\n* `:conflict_resolution` - Strategy for resolving conflicts (default: :latest_wins)","ref":"Raxol.Cloud.EdgeComputing.html#sync/1-options","title":"Options - Raxol.Cloud.EdgeComputing.sync/1","type":"function"},{"doc":"iex> sync(force: true)\n    {:ok, %{status: :completed, synced_items: 5}}","ref":"Raxol.Cloud.EdgeComputing.html#sync/1-examples","title":"Examples - Raxol.Cloud.EdgeComputing.sync/1","type":"function"},{"doc":"Updates the edge computing configuration.","ref":"Raxol.Cloud.EdgeComputing.html#update_config/2","title":"Raxol.Cloud.EdgeComputing.update_config/2","type":"function"},{"doc":"Cloud integration utilities for Raxol applications.\n\nThis module provides integration utilities for connecting various cloud services\nwith Raxol applications, focusing on edge computing, monitoring, and service discovery.\nIt serves as a central coordination point for cloud-related features.\n\nFeatures:\n* Edge-to-cloud integration helpers\n* Centralized configuration management\n* Service discovery and registration\n* Multi-cloud provider support\n* Deployment and scaling utilities","ref":"Raxol.Cloud.Integrations.html","title":"Raxol.Cloud.Integrations","type":"module"},{"doc":"Deploys an application component to the appropriate environment based on configuration.","ref":"Raxol.Cloud.Integrations.html#deploy/1","title":"Raxol.Cloud.Integrations.deploy/1","type":"function"},{"doc":"* `:component` - Name of the component to deploy\n* `:version` - Version to deploy\n* `:environment` - Target environment (:production, :staging, :development)\n* `:strategy` - Deployment strategy (:blue_green, :canary, :rolling)","ref":"Raxol.Cloud.Integrations.html#deploy/1-options","title":"Options - Raxol.Cloud.Integrations.deploy/1","type":"function"},{"doc":"iex> deploy(\n    ...>   component: :api_service,\n    ...>   version: \"1.2.3\",\n    ...>   environment: :production,\n    ...>   strategy: :blue_green\n    ...> )\n    {:ok, %{deployment_id: \"dep-12345\", status: :in_progress}}","ref":"Raxol.Cloud.Integrations.html#deploy/1-examples","title":"Examples - Raxol.Cloud.Integrations.deploy/1","type":"function"},{"doc":"Discovers services available in the current environment.","ref":"Raxol.Cloud.Integrations.html#discover_services/1","title":"Raxol.Cloud.Integrations.discover_services/1","type":"function"},{"doc":"* `:type` - Type of service to discover (:all, or a specific service type)\n* `:provider` - Cloud provider to query (:all, or a specific provider)\n* `:region` - Region to search in","ref":"Raxol.Cloud.Integrations.html#discover_services/1-options","title":"Options - Raxol.Cloud.Integrations.discover_services/1","type":"function"},{"doc":"iex> discover_services(type: :database)\n    {:ok, [\n      %{name: \"main-db\", type: :database, endpoint: \"main-db.example.com:5432\"},\n      %{name: \"analytics-db\", type: :database, endpoint: \"analytics-db.example.com:5432\"}\n    ]}","ref":"Raxol.Cloud.Integrations.html#discover_services/1-examples","title":"Examples - Raxol.Cloud.Integrations.discover_services/1","type":"function"},{"doc":"Executes a function in the optimal location (edge or cloud) based on current conditions.\n\nThis is a wrapper around EdgeComputing.execute/2 that adds monitoring.","ref":"Raxol.Cloud.Integrations.html#execute/2","title":"Raxol.Cloud.Integrations.execute/2","type":"function"},{"doc":"iex> execute(fn -> perform_calculation(data) end, priority: :speed)\n    {:ok, result}","ref":"Raxol.Cloud.Integrations.html#execute/2-examples","title":"Examples - Raxol.Cloud.Integrations.execute/2","type":"function"},{"doc":"Gets a connection to a cloud service with the specified parameters.","ref":"Raxol.Cloud.Integrations.html#get_service_connection/1","title":"Raxol.Cloud.Integrations.get_service_connection/1","type":"function"},{"doc":"* `:service` - Service name or type to connect to (required)\n* `:provider` - Cloud provider to use (:aws, :azure, :gcp, or :custom)\n* `:region` - Region to connect to\n* `:config` - Additional configuration for the connection","ref":"Raxol.Cloud.Integrations.html#get_service_connection/1-options","title":"Options - Raxol.Cloud.Integrations.get_service_connection/1","type":"function"},{"doc":"iex> get_service_connection(\n    ...>   service: :storage,\n    ...>   provider: :aws,\n    ...>   region: \"us-west-2\"\n    ...> )\n    {:ok, %{\n    ...>   client: client,\n    ...>   endpoint: \"s3.us-west-2.amazonaws.com\",\n    ...>   service: :storage,\n    ...>   provider: :aws\n    ...> }}","ref":"Raxol.Cloud.Integrations.html#get_service_connection/1-examples","title":"Examples - Raxol.Cloud.Integrations.get_service_connection/1","type":"function"},{"doc":"Initializes all cloud integrations with the provided configuration.","ref":"Raxol.Cloud.Integrations.html#init/1","title":"Raxol.Cloud.Integrations.init/1","type":"function"},{"doc":"* `:edge` - Options for edge computing (passed to EdgeComputing.init/1)\n* `:monitoring` - Options for monitoring system (passed to Monitoring.init/1)\n* `:providers` - List of cloud providers to enable [:aws, :azure, :gcp, :custom]\n* `:service_discovery` - Service discovery configuration\n* `:deployment` - Deployment and scaling configuration","ref":"Raxol.Cloud.Integrations.html#init/1-options","title":"Options - Raxol.Cloud.Integrations.init/1","type":"function"},{"doc":"iex> init(\n    ...>   edge: [mode: :auto, sync_interval: 30000],\n    ...>   monitoring: [backends: [:prometheus], active: true],\n    ...>   providers: [:aws]\n    ...> )\n    :ok","ref":"Raxol.Cloud.Integrations.html#init/1-examples","title":"Examples - Raxol.Cloud.Integrations.init/1","type":"function"},{"doc":"Registers the current application as a service in the service discovery system.","ref":"Raxol.Cloud.Integrations.html#register_service/1","title":"Raxol.Cloud.Integrations.register_service/1","type":"function"},{"doc":"* `:name` - Service name (required)\n* `:type` - Service type (required)\n* `:endpoint` - Service endpoint (required)\n* `:metadata` - Additional metadata about the service\n* `:health_check_path` - Path for health checks","ref":"Raxol.Cloud.Integrations.html#register_service/1-options","title":"Options - Raxol.Cloud.Integrations.register_service/1","type":"function"},{"doc":"iex> register_service(\n    ...>   name: \"user-api\",\n    ...>   type: :api,\n    ...>   endpoint: \"user-api.example.com:8080\",\n    ...>   health_check_path: \"/health\"\n    ...> )\n    {:ok, %{registration_id: \"reg-12345\", status: :registered}}","ref":"Raxol.Cloud.Integrations.html#register_service/1-examples","title":"Examples - Raxol.Cloud.Integrations.register_service/1","type":"function"},{"doc":"Scales a service based on current metrics and conditions.","ref":"Raxol.Cloud.Integrations.html#scale/1","title":"Raxol.Cloud.Integrations.scale/1","type":"function"},{"doc":"* `:service` - Service name to scale (required)\n* `:min` - Minimum number of instances\n* `:max` - Maximum number of instances\n* `:desired` - Desired number of instances (if specified, overrides automatic scaling)\n* `:metrics` - Metrics to use for scaling decisions","ref":"Raxol.Cloud.Integrations.html#scale/1-options","title":"Options - Raxol.Cloud.Integrations.scale/1","type":"function"},{"doc":"iex> scale(\n    ...>   service: \"api-server\",\n    ...>   min: 2,\n    ...>   max: 10,\n    ...>   metrics: [\n    ...>     %{name: \"cpu\", target: 70},\n    ...>     %{name: \"requests\", target: 1000}\n    ...>   ]\n    ...> )\n    {:ok, %{service: \"api-server\", current: 2, target: 4, status: :scaling}}","ref":"Raxol.Cloud.Integrations.html#scale/1-examples","title":"Examples - Raxol.Cloud.Integrations.scale/1","type":"function"},{"doc":"Returns the current status of all cloud integrations.","ref":"Raxol.Cloud.Integrations.html#status/0","title":"Raxol.Cloud.Integrations.status/0","type":"function"},{"doc":"iex> status()\n    %{\n      edge: %{mode: :auto, connected: true, ...},\n      monitoring: %{active: true, ...},\n      providers: %{aws: :connected, ...}\n    }","ref":"Raxol.Cloud.Integrations.html#status/0-examples","title":"Examples - Raxol.Cloud.Integrations.status/0","type":"function"},{"doc":"Cloud monitoring system for Raxol applications.\n\nThis module provides comprehensive monitoring capabilities for Raxol\napplications, including performance metrics, error tracking, usage statistics,\nand health checks.\n\nFeatures:\n* Performance monitoring and metrics collection\n* Error and exception tracking\n* Resource usage tracking\n* Health checks and status monitoring\n* Alerting and notification system\n* Integration with popular monitoring services","ref":"Raxol.Cloud.Monitoring.html","title":"Raxol.Cloud.Monitoring","type":"module"},{"doc":"Gets recent alerts.","ref":"Raxol.Cloud.Monitoring.html#get_alerts/1","title":"Raxol.Cloud.Monitoring.get_alerts/1","type":"function"},{"doc":"* `:limit` - Maximum number of alerts to return (default: 100)\n* `:since` - Only return alerts since this timestamp (default: 1 day ago)\n* `:until` - Only return alerts until this timestamp (default: now)\n* `:type` - Filter alerts by type\n* `:severity` - Filter alerts by severity","ref":"Raxol.Cloud.Monitoring.html#get_alerts/1-options","title":"Options - Raxol.Cloud.Monitoring.get_alerts/1","type":"function"},{"doc":"iex> get_alerts(limit: 10, severity: :critical)\n    [%{type: :high_cpu_usage, severity: :critical, ...}]","ref":"Raxol.Cloud.Monitoring.html#get_alerts/1-examples","title":"Examples - Raxol.Cloud.Monitoring.get_alerts/1","type":"function"},{"doc":"Gets recent errors.","ref":"Raxol.Cloud.Monitoring.html#get_errors/1","title":"Raxol.Cloud.Monitoring.get_errors/1","type":"function"},{"doc":"* `:limit` - Maximum number of errors to return (default: 100)\n* `:since` - Only return errors since this timestamp (default: 1 day ago)\n* `:until` - Only return errors until this timestamp (default: now)\n* `:severity` - Filter errors by severity\n* `:tags` - Filter errors by tags","ref":"Raxol.Cloud.Monitoring.html#get_errors/1-options","title":"Options - Raxol.Cloud.Monitoring.get_errors/1","type":"function"},{"doc":"iex> get_errors(limit: 10, severity: :critical)\n    [%{error: %RuntimeError{...}, severity: :critical, ...}]","ref":"Raxol.Cloud.Monitoring.html#get_errors/1-examples","title":"Examples - Raxol.Cloud.Monitoring.get_errors/1","type":"function"},{"doc":"Gets recent metrics for the specified metric name.","ref":"Raxol.Cloud.Monitoring.html#get_metrics/2","title":"Raxol.Cloud.Monitoring.get_metrics/2","type":"function"},{"doc":"* `:limit` - Maximum number of metrics to return (default: 100)\n* `:since` - Only return metrics since this timestamp (default: 1 hour ago)\n* `:until` - Only return metrics until this timestamp (default: now)\n* `:tags` - Filter metrics by tags","ref":"Raxol.Cloud.Monitoring.html#get_metrics/2-options","title":"Options - Raxol.Cloud.Monitoring.get_metrics/2","type":"function"},{"doc":"iex> get_metrics(\"response_time\", limit: 10, tags: [\"api\"])\n    [%{name: \"response_time\", value: 123, timestamp: ~U[2023-01-01 12:00:00Z], tags: [\"api\"]}]","ref":"Raxol.Cloud.Monitoring.html#get_metrics/2-examples","title":"Examples - Raxol.Cloud.Monitoring.get_metrics/2","type":"function"},{"doc":"Initializes the monitoring system.","ref":"Raxol.Cloud.Monitoring.html#init/1","title":"Raxol.Cloud.Monitoring.init/1","type":"function"},{"doc":"* `:active` - Whether monitoring should be active on start (default: true)\n* `:metrics_interval` - Interval in ms between metrics collection (default: 10000)\n* `:health_check_interval` - Interval in ms between health checks (default: 60000)\n* `:error_sample_rate` - Fraction of errors to track (0.0-1.0) (default: 1.0)\n* `:metrics_batch_size` - Number of metrics to batch before sending (default: 100)\n* `:backends` - List of monitoring service backends to use (default: [])\n* `:alert_thresholds` - Map of alert thresholds (default: see State.new)","ref":"Raxol.Cloud.Monitoring.html#init/1-options","title":"Options - Raxol.Cloud.Monitoring.init/1","type":"function"},{"doc":"iex> init(metrics_interval: 5000, backends: [:datadog, :prometheus])\n    :ok","ref":"Raxol.Cloud.Monitoring.html#init/1-examples","title":"Examples - Raxol.Cloud.Monitoring.init/1","type":"function"},{"doc":"Records an error or exception.","ref":"Raxol.Cloud.Monitoring.html#record_error/2","title":"Raxol.Cloud.Monitoring.record_error/2","type":"function"},{"doc":"* `:context` - Additional context information about the error\n* `:severity` - Severity level (:debug, :info, :warning, :error, :critical)\n* `:tags` - List of tags to associate with the error\n* `:timestamp` - Custom timestamp for the error (default: current time)","ref":"Raxol.Cloud.Monitoring.html#record_error/2-options","title":"Options - Raxol.Cloud.Monitoring.record_error/2","type":"function"},{"doc":"iex> record_error(%RuntimeError{message: \"Connection failed\"},\n    ...>   context: %{user_id: 123}, severity: :error)\n    :ok","ref":"Raxol.Cloud.Monitoring.html#record_error/2-examples","title":"Examples - Raxol.Cloud.Monitoring.record_error/2","type":"function"},{"doc":"Records a metric with the given name and value.","ref":"Raxol.Cloud.Monitoring.html#record_metric/3","title":"Raxol.Cloud.Monitoring.record_metric/3","type":"function"},{"doc":"* `:tags` - List of tags to associate with the metric\n* `:timestamp` - Custom timestamp for the metric (default: current time)\n* `:source` - Source of the metric (default: :application)","ref":"Raxol.Cloud.Monitoring.html#record_metric/3-options","title":"Options - Raxol.Cloud.Monitoring.record_metric/3","type":"function"},{"doc":"iex> record_metric(\"response_time\", 123, tags: [\"api\", \"users\"], source: :api)\n    :ok","ref":"Raxol.Cloud.Monitoring.html#record_metric/3-examples","title":"Examples - Raxol.Cloud.Monitoring.record_metric/3","type":"function"},{"doc":"Records a batch of metrics.","ref":"Raxol.Cloud.Monitoring.html#record_metrics/1","title":"Raxol.Cloud.Monitoring.record_metrics/1","type":"function"},{"doc":"iex> record_metrics([\n    ...>   {\"cpu_usage\", 0.75, [source: :system]},\n    ...>   {\"memory_usage\", 0.5, [source: :system]}\n    ...> ])\n    :ok","ref":"Raxol.Cloud.Monitoring.html#record_metrics/1-examples","title":"Examples - Raxol.Cloud.Monitoring.record_metrics/1","type":"function"},{"doc":"Runs a health check on the system.","ref":"Raxol.Cloud.Monitoring.html#run_health_check/1","title":"Raxol.Cloud.Monitoring.run_health_check/1","type":"function"},{"doc":"* `:components` - List of components to check (default: all)\n* `:timeout` - Timeout for health checks in milliseconds (default: 5000)","ref":"Raxol.Cloud.Monitoring.html#run_health_check/1-options","title":"Options - Raxol.Cloud.Monitoring.run_health_check/1","type":"function"},{"doc":"iex> run_health_check(components: [:database, :api])\n    {:ok, %{status: :healthy, components: %{database: :healthy, api: :healthy}}}","ref":"Raxol.Cloud.Monitoring.html#run_health_check/1-examples","title":"Examples - Raxol.Cloud.Monitoring.run_health_check/1","type":"function"},{"doc":"Starts the monitoring system if it's not already active.","ref":"Raxol.Cloud.Monitoring.html#start/0","title":"Raxol.Cloud.Monitoring.start/0","type":"function"},{"doc":"Gets the current monitoring status.","ref":"Raxol.Cloud.Monitoring.html#status/0","title":"Raxol.Cloud.Monitoring.status/0","type":"function"},{"doc":"Stops the monitoring system.","ref":"Raxol.Cloud.Monitoring.html#stop/0","title":"Raxol.Cloud.Monitoring.stop/0","type":"function"},{"doc":"Triggers an alert with the given type and data.","ref":"Raxol.Cloud.Monitoring.html#trigger_alert/3","title":"Raxol.Cloud.Monitoring.trigger_alert/3","type":"function"},{"doc":"* `:severity` - Severity level of the alert (default: :warning)\n* `:notify` - Whether to send notifications (default: true)","ref":"Raxol.Cloud.Monitoring.html#trigger_alert/3-options","title":"Options - Raxol.Cloud.Monitoring.trigger_alert/3","type":"function"},{"doc":"iex> trigger_alert(:high_cpu_usage, %{value: 0.95}, severity: :critical)\n    :ok","ref":"Raxol.Cloud.Monitoring.html#trigger_alert/3-examples","title":"Examples - Raxol.Cloud.Monitoring.trigger_alert/3","type":"function"},{"doc":"Updates the monitoring configuration.","ref":"Raxol.Cloud.Monitoring.html#update_config/2","title":"Raxol.Cloud.Monitoring.update_config/2","type":"function"},{"doc":"Centralized state management for Raxol cloud components.\n\nThis module provides a centralized way to store and retrieve state\nfor all cloud components, eliminating the need for Process.put/2\nand Process.get/1 in multiple modules.","ref":"Raxol.Cloud.StateManager.html","title":"Raxol.Cloud.StateManager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Cloud.StateManager.html#child_spec/1","title":"Raxol.Cloud.StateManager.child_spec/1","type":"function"},{"doc":"Clears the state.","ref":"Raxol.Cloud.StateManager.html#clear/1","title":"Raxol.Cloud.StateManager.clear/1","type":"function"},{"doc":"Gets a value from the state.","ref":"Raxol.Cloud.StateManager.html#get/2","title":"Raxol.Cloud.StateManager.get/2","type":"function"},{"doc":"Gets the entire state.","ref":"Raxol.Cloud.StateManager.html#get_all/1","title":"Raxol.Cloud.StateManager.get_all/1","type":"function"},{"doc":"Puts a value in the state.","ref":"Raxol.Cloud.StateManager.html#put/3","title":"Raxol.Cloud.StateManager.put/3","type":"function"},{"doc":"Starts the state manager.","ref":"Raxol.Cloud.StateManager.html#start_link/1","title":"Raxol.Cloud.StateManager.start_link/1","type":"function"},{"doc":"Updates a value in the state.","ref":"Raxol.Cloud.StateManager.html#update/3","title":"Raxol.Cloud.StateManager.update/3","type":"function"},{"doc":"Accessibility module for Raxol terminal UI applications.\n\nThis module provides accessibility features including:\n- Screen reader announcements\n- Keyboard navigation enhancements\n- High contrast mode\n- Reduced motion support\n- Focus management\n- Large text support","ref":"Raxol.Core.Accessibility.html","title":"Raxol.Core.Accessibility","type":"module"},{"doc":"```elixir\n# Enable accessibility features\nAccessibility.enable()\n\n# Make an announcement for screen readers\nAccessibility.announce(\"You have selected the search button\")\n\n# Enable high contrast mode\nAccessibility.set_high_contrast(true)\n\n# Enable reduced motion mode\nAccessibility.set_reduced_motion(true)\n\n# Enable large text mode\nAccessibility.set_large_text(true)\n```","ref":"Raxol.Core.Accessibility.html#module-usage","title":"Usage - Raxol.Core.Accessibility","type":"module"},{"doc":"Make an announcement for screen readers.","ref":"Raxol.Core.Accessibility.html#announce/1","title":"Raxol.Core.Accessibility.announce/1","type":"function"},{"doc":"* `message` - The message to announce","ref":"Raxol.Core.Accessibility.html#announce/1-parameters","title":"Parameters - Raxol.Core.Accessibility.announce/1","type":"function"},{"doc":"iex> Accessibility.announce(\"You have selected the search button\")\n    :ok","ref":"Raxol.Core.Accessibility.html#announce/1-examples","title":"Examples - Raxol.Core.Accessibility.announce/1","type":"function"},{"doc":"Make an announcement for screen readers with a specific priority.","ref":"Raxol.Core.Accessibility.html#announce/2","title":"Raxol.Core.Accessibility.announce/2","type":"function"},{"doc":"* `message` - The message to announce\n* `priority` - The priority of the announcement (:polite or :assertive)","ref":"Raxol.Core.Accessibility.html#announce/2-parameters","title":"Parameters - Raxol.Core.Accessibility.announce/2","type":"function"},{"doc":"iex> Accessibility.announce(\"You have selected the search button\", :assertive)\n    :ok","ref":"Raxol.Core.Accessibility.html#announce/2-examples","title":"Examples - Raxol.Core.Accessibility.announce/2","type":"function"},{"doc":"Make an announcement for screen readers with a specific priority and user preferences.","ref":"Raxol.Core.Accessibility.html#announce/3","title":"Raxol.Core.Accessibility.announce/3","type":"function"},{"doc":"* `message` - The message to announce\n* `priority` - The priority of the announcement (:polite or :assertive)\n* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (optional)","ref":"Raxol.Core.Accessibility.html#announce/3-parameters","title":"Parameters - Raxol.Core.Accessibility.announce/3","type":"function"},{"doc":"iex> Accessibility.announce(\"You have selected the search button\", :assertive, :user_preferences)\n    :ok","ref":"Raxol.Core.Accessibility.html#announce/3-examples","title":"Examples - Raxol.Core.Accessibility.announce/3","type":"function"},{"doc":"Clear all pending announcements.","ref":"Raxol.Core.Accessibility.html#clear_announcements/0","title":"Raxol.Core.Accessibility.clear_announcements/0","type":"function"},{"doc":"iex> Accessibility.clear_announcements()\n    :ok","ref":"Raxol.Core.Accessibility.html#clear_announcements/0-examples","title":"Examples - Raxol.Core.Accessibility.clear_announcements/0","type":"function"},{"doc":"Disable accessibility features.","ref":"Raxol.Core.Accessibility.html#disable/1","title":"Raxol.Core.Accessibility.disable/1","type":"function"},{"doc":"iex> Accessibility.disable()\n    :ok","ref":"Raxol.Core.Accessibility.html#disable/1-examples","title":"Examples - Raxol.Core.Accessibility.disable/1","type":"function"},{"doc":"Enable accessibility features with the given options.","ref":"Raxol.Core.Accessibility.html#enable/2","title":"Raxol.Core.Accessibility.enable/2","type":"function"},{"doc":"* `options` - Options to override the default accessibility settings\n* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (optional).","ref":"Raxol.Core.Accessibility.html#enable/2-parameters","title":"Parameters - Raxol.Core.Accessibility.enable/2","type":"function"},{"doc":"* `:high_contrast` - Enable high contrast mode (default: `false`)\n* `:reduced_motion` - Enable reduced motion (default: `false`)\n* `:large_text` - Enable large text (default: `false`)\n* `:screen_reader` - Enable screen reader support (default: `true`)\n* `:keyboard_focus` - Enable keyboard focus indicators (default: `true`)\n* `:silence_announcements` - Silence screen reader announcements (default: `false`)","ref":"Raxol.Core.Accessibility.html#enable/2-options","title":"Options - Raxol.Core.Accessibility.enable/2","type":"function"},{"doc":"iex> Accessibility.enable(high_contrast: true)\n    :ok\n\n    iex> Accessibility.enable(reduced_motion: true, screen_reader: false)\n    :ok","ref":"Raxol.Core.Accessibility.html#enable/2-examples","title":"Examples - Raxol.Core.Accessibility.enable/2","type":"function"},{"doc":"Get the current color scheme based on accessibility settings.","ref":"Raxol.Core.Accessibility.html#get_color_scheme/0","title":"Raxol.Core.Accessibility.get_color_scheme/0","type":"function"},{"doc":"iex> Accessibility.get_color_scheme()\n    %{background: ...}  # Returns the current color scheme","ref":"Raxol.Core.Accessibility.html#get_color_scheme/0-examples","title":"Examples - Raxol.Core.Accessibility.get_color_scheme/0","type":"function"},{"doc":"Get style settings for a component type.","ref":"Raxol.Core.Accessibility.html#get_component_style/1","title":"Raxol.Core.Accessibility.get_component_style/1","type":"function"},{"doc":"* `component_type` - Atom representing the component type","ref":"Raxol.Core.Accessibility.html#get_component_style/1-parameters","title":"Parameters - Raxol.Core.Accessibility.get_component_style/1","type":"function"},{"doc":"* The style map for the component type, or empty map if not found","ref":"Raxol.Core.Accessibility.html#get_component_style/1-returns","title":"Returns - Raxol.Core.Accessibility.get_component_style/1","type":"function"},{"doc":"iex> Accessibility.get_component_style(:button)\n    %{background: :blue}","ref":"Raxol.Core.Accessibility.html#get_component_style/1-examples","title":"Examples - Raxol.Core.Accessibility.get_component_style/1","type":"function"},{"doc":"Get metadata for an element.","ref":"Raxol.Core.Accessibility.html#get_element_metadata/1","title":"Raxol.Core.Accessibility.get_element_metadata/1","type":"function"},{"doc":"* `element_id` - Unique identifier for the element","ref":"Raxol.Core.Accessibility.html#get_element_metadata/1-parameters","title":"Parameters - Raxol.Core.Accessibility.get_element_metadata/1","type":"function"},{"doc":"* The metadata map for the element, or `nil` if not found","ref":"Raxol.Core.Accessibility.html#get_element_metadata/1-returns","title":"Returns - Raxol.Core.Accessibility.get_element_metadata/1","type":"function"},{"doc":"iex> Accessibility.get_element_metadata(\"search_button\")\n    %{label: \"Search\"}","ref":"Raxol.Core.Accessibility.html#get_element_metadata/1-examples","title":"Examples - Raxol.Core.Accessibility.get_element_metadata/1","type":"function"},{"doc":"Get the next announcement to be read by screen readers.\n\nThis function is typically called by the screen reader integration.","ref":"Raxol.Core.Accessibility.html#get_next_announcement/1","title":"Raxol.Core.Accessibility.get_next_announcement/1","type":"function"},{"doc":"iex> Accessibility.get_next_announcement()\n    \"Button clicked\"","ref":"Raxol.Core.Accessibility.html#get_next_announcement/1-examples","title":"Examples - Raxol.Core.Accessibility.get_next_announcement/1","type":"function"},{"doc":"Gets an accessibility option value.","ref":"Raxol.Core.Accessibility.html#get_option/3","title":"Raxol.Core.Accessibility.get_option/3","type":"function"},{"doc":"Get the current text scale factor based on the large text setting.","ref":"Raxol.Core.Accessibility.html#get_text_scale/1","title":"Raxol.Core.Accessibility.get_text_scale/1","type":"function"},{"doc":"* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (optional).","ref":"Raxol.Core.Accessibility.html#get_text_scale/1-parameters","title":"Parameters - Raxol.Core.Accessibility.get_text_scale/1","type":"function"},{"doc":"iex> Accessibility.get_text_scale()\n    1.0 # or 1.5 if large_text is enabled","ref":"Raxol.Core.Accessibility.html#get_text_scale/1-examples","title":"Examples - Raxol.Core.Accessibility.get_text_scale/1","type":"function"},{"doc":"Delegates theme changed events to the EventHandlers module.","ref":"Raxol.Core.Accessibility.html#handle_theme_changed/2","title":"Raxol.Core.Accessibility.handle_theme_changed/2","type":"function"},{"doc":"Register style settings for a component type.","ref":"Raxol.Core.Accessibility.html#register_component_style/2","title":"Raxol.Core.Accessibility.register_component_style/2","type":"function"},{"doc":"* `component_type` - Atom representing the component type\n* `style` - Style map to associate with the component type","ref":"Raxol.Core.Accessibility.html#register_component_style/2-parameters","title":"Parameters - Raxol.Core.Accessibility.register_component_style/2","type":"function"},{"doc":"iex> Accessibility.register_component_style(:button, %{background: :blue})\n    :ok","ref":"Raxol.Core.Accessibility.html#register_component_style/2-examples","title":"Examples - Raxol.Core.Accessibility.register_component_style/2","type":"function"},{"doc":"Register metadata for an element to be used for accessibility features.","ref":"Raxol.Core.Accessibility.html#register_element_metadata/2","title":"Raxol.Core.Accessibility.register_element_metadata/2","type":"function"},{"doc":"* `element_id` - Unique identifier for the element\n* `metadata` - Metadata to associate with the element","ref":"Raxol.Core.Accessibility.html#register_element_metadata/2-parameters","title":"Parameters - Raxol.Core.Accessibility.register_element_metadata/2","type":"function"},{"doc":"iex> Accessibility.register_element_metadata(\"search_button\", %{label: \"Search\"})\n    :ok","ref":"Raxol.Core.Accessibility.html#register_element_metadata/2-examples","title":"Examples - Raxol.Core.Accessibility.register_element_metadata/2","type":"function"},{"doc":"Enable or disable high contrast mode.","ref":"Raxol.Core.Accessibility.html#set_high_contrast/2","title":"Raxol.Core.Accessibility.set_high_contrast/2","type":"function"},{"doc":"* `enabled` - `true` to enable high contrast, `false` to disable.\n* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (optional).","ref":"Raxol.Core.Accessibility.html#set_high_contrast/2-parameters","title":"Parameters - Raxol.Core.Accessibility.set_high_contrast/2","type":"function"},{"doc":"iex> Accessibility.set_high_contrast(true)\n    :ok","ref":"Raxol.Core.Accessibility.html#set_high_contrast/2-examples","title":"Examples - Raxol.Core.Accessibility.set_high_contrast/2","type":"function"},{"doc":"Enable or disable large text mode.","ref":"Raxol.Core.Accessibility.html#set_large_text/2","title":"Raxol.Core.Accessibility.set_large_text/2","type":"function"},{"doc":"* `enabled` - `true` to enable large text, `false` to disable.\n* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (optional).","ref":"Raxol.Core.Accessibility.html#set_large_text/2-parameters","title":"Parameters - Raxol.Core.Accessibility.set_large_text/2","type":"function"},{"doc":"iex> Accessibility.set_large_text(true)\n    :ok","ref":"Raxol.Core.Accessibility.html#set_large_text/2-examples","title":"Examples - Raxol.Core.Accessibility.set_large_text/2","type":"function"},{"doc":"Sets an accessibility option value.","ref":"Raxol.Core.Accessibility.html#set_option/3","title":"Raxol.Core.Accessibility.set_option/3","type":"function"},{"doc":"Enable or disable reduced motion.","ref":"Raxol.Core.Accessibility.html#set_reduced_motion/2","title":"Raxol.Core.Accessibility.set_reduced_motion/2","type":"function"},{"doc":"* `enabled` - `true` to enable reduced motion, `false` to disable.\n* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (optional).","ref":"Raxol.Core.Accessibility.html#set_reduced_motion/2-parameters","title":"Parameters - Raxol.Core.Accessibility.set_reduced_motion/2","type":"function"},{"doc":"iex> Accessibility.set_reduced_motion(true)\n    :ok","ref":"Raxol.Core.Accessibility.html#set_reduced_motion/2-examples","title":"Examples - Raxol.Core.Accessibility.set_reduced_motion/2","type":"function"},{"doc":"Handles screen reader announcements and announcement queue management.","ref":"Raxol.Core.Accessibility.Announcements.html","title":"Raxol.Core.Accessibility.Announcements","type":"module"},{"doc":"Make an announcement for screen readers.","ref":"Raxol.Core.Accessibility.Announcements.html#announce/3","title":"Raxol.Core.Accessibility.Announcements.announce/3","type":"function"},{"doc":"* `message` - The message to announce\n* `opts` - Options for the announcement\n* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (optional).","ref":"Raxol.Core.Accessibility.Announcements.html#announce/3-parameters","title":"Parameters - Raxol.Core.Accessibility.Announcements.announce/3","type":"function"},{"doc":"* `:priority` - Priority level (`:low`, `:medium`, `:high`) (default: `:medium`)\n* `:interrupt` - Whether to interrupt current announcements (default: `false`)","ref":"Raxol.Core.Accessibility.Announcements.html#announce/3-options","title":"Options - Raxol.Core.Accessibility.Announcements.announce/3","type":"function"},{"doc":"iex> Announcements.announce(\"Button clicked\")\n    :ok\n\n    iex> Announcements.announce(\"Error occurred\", priority: :high, interrupt: true)\n    :ok","ref":"Raxol.Core.Accessibility.Announcements.html#announce/3-examples","title":"Examples - Raxol.Core.Accessibility.Announcements.announce/3","type":"function"},{"doc":"Clear all pending announcements.","ref":"Raxol.Core.Accessibility.Announcements.html#clear_announcements/0","title":"Raxol.Core.Accessibility.Announcements.clear_announcements/0","type":"function"},{"doc":"iex> Announcements.clear_announcements()\n    :ok","ref":"Raxol.Core.Accessibility.Announcements.html#clear_announcements/0-examples","title":"Examples - Raxol.Core.Accessibility.Announcements.clear_announcements/0","type":"function"},{"doc":"Get the next announcement to be read by screen readers for a specific user/context.","ref":"Raxol.Core.Accessibility.Announcements.html#get_next_announcement/1","title":"Raxol.Core.Accessibility.Announcements.get_next_announcement/1","type":"function"},{"doc":"* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (optional).","ref":"Raxol.Core.Accessibility.Announcements.html#get_next_announcement/1-parameters","title":"Parameters - Raxol.Core.Accessibility.Announcements.get_next_announcement/1","type":"function"},{"doc":"iex> Announcements.get_next_announcement(:user1)\n    \"Button clicked\"","ref":"Raxol.Core.Accessibility.Announcements.html#get_next_announcement/1-examples","title":"Examples - Raxol.Core.Accessibility.Announcements.get_next_announcement/1","type":"function"},{"doc":"","ref":"Raxol.Core.Accessibility.Behaviour.html","title":"Raxol.Core.Accessibility.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Core.Accessibility.Behaviour.html#c:get_focus_history/0","title":"Raxol.Core.Accessibility.Behaviour.get_focus_history/0","type":"callback"},{"doc":"","ref":"Raxol.Core.Accessibility.Behaviour.html#c:set_large_text/2","title":"Raxol.Core.Accessibility.Behaviour.set_large_text/2","type":"callback"},{"doc":"Handles accessibility-related events and notifications.","ref":"Raxol.Core.Accessibility.EventHandlers.html","title":"Raxol.Core.Accessibility.EventHandlers","type":"module"},{"doc":"","ref":"Raxol.Core.Accessibility.EventHandlers.html#handle_focus_change/1","title":"Raxol.Core.Accessibility.EventHandlers.handle_focus_change/1","type":"function"},{"doc":"Handle focus change events for accessibility announcements.","ref":"Raxol.Core.Accessibility.EventHandlers.html#handle_focus_change/2","title":"Raxol.Core.Accessibility.EventHandlers.handle_focus_change/2","type":"function"},{"doc":"iex> EventHandlers.handle_focus_change({:focus_change, nil, \"search_button\"})\n    :ok","ref":"Raxol.Core.Accessibility.EventHandlers.html#handle_focus_change/2-examples","title":"Examples - Raxol.Core.Accessibility.EventHandlers.handle_focus_change/2","type":"function"},{"doc":"Handle locale changes.","ref":"Raxol.Core.Accessibility.EventHandlers.html#handle_locale_changed/1","title":"Raxol.Core.Accessibility.EventHandlers.handle_locale_changed/1","type":"function"},{"doc":"iex> EventHandlers.handle_locale_changed({:locale_changed, %{locale: \"en\"}})\n    :ok","ref":"Raxol.Core.Accessibility.EventHandlers.html#handle_locale_changed/1-examples","title":"Examples - Raxol.Core.Accessibility.EventHandlers.handle_locale_changed/1","type":"function"},{"doc":"Handle preference changes triggered internally or via EventManager.","ref":"Raxol.Core.Accessibility.EventHandlers.html#handle_preference_changed/2","title":"Raxol.Core.Accessibility.EventHandlers.handle_preference_changed/2","type":"function"},{"doc":"iex> EventHandlers.handle_preference_changed({:preference_changed, [:accessibility, :high_contrast], true})\n    :ok","ref":"Raxol.Core.Accessibility.EventHandlers.html#handle_preference_changed/2-examples","title":"Examples - Raxol.Core.Accessibility.EventHandlers.handle_preference_changed/2","type":"function"},{"doc":"Handle theme changes.","ref":"Raxol.Core.Accessibility.EventHandlers.html#handle_theme_changed/2","title":"Raxol.Core.Accessibility.EventHandlers.handle_theme_changed/2","type":"function"},{"doc":"iex> EventHandlers.handle_theme_changed({:theme_changed, %{theme: \"dark\"}})\n    :ok","ref":"Raxol.Core.Accessibility.EventHandlers.html#handle_theme_changed/2-examples","title":"Examples - Raxol.Core.Accessibility.EventHandlers.handle_theme_changed/2","type":"function"},{"doc":"Legacy functions for backwards compatibility.\nThese functions are deprecated and will be removed in a future version.","ref":"Raxol.Core.Accessibility.Legacy.html","title":"Raxol.Core.Accessibility.Legacy","type":"module"},{"doc":"Check if high contrast mode is enabled.","ref":"Raxol.Core.Accessibility.Legacy.html#high_contrast_enabled?/1","title":"Raxol.Core.Accessibility.Legacy.high_contrast_enabled?/1","type":"function"},{"doc":"* `true` if high contrast mode is enabled, `false` otherwise.","ref":"Raxol.Core.Accessibility.Legacy.html#high_contrast_enabled?/1-returns","title":"Returns - Raxol.Core.Accessibility.Legacy.high_contrast_enabled?/1","type":"function"},{"doc":"iex> Legacy.high_contrast_enabled?()\n    false","ref":"Raxol.Core.Accessibility.Legacy.html#high_contrast_enabled?/1-examples","title":"Examples - Raxol.Core.Accessibility.Legacy.high_contrast_enabled?/1","type":"function"},{"doc":"Check if large text mode is enabled.","ref":"Raxol.Core.Accessibility.Legacy.html#large_text_enabled?/1","title":"Raxol.Core.Accessibility.Legacy.large_text_enabled?/1","type":"function"},{"doc":"* `true` if large text mode is enabled, `false` otherwise.","ref":"Raxol.Core.Accessibility.Legacy.html#large_text_enabled?/1-returns","title":"Returns - Raxol.Core.Accessibility.Legacy.large_text_enabled?/1","type":"function"},{"doc":"iex> Legacy.large_text_enabled?()\n    false","ref":"Raxol.Core.Accessibility.Legacy.html#large_text_enabled?/1-examples","title":"Examples - Raxol.Core.Accessibility.Legacy.large_text_enabled?/1","type":"function"},{"doc":"Check if reduced motion mode is enabled.","ref":"Raxol.Core.Accessibility.Legacy.html#reduced_motion_enabled?/1","title":"Raxol.Core.Accessibility.Legacy.reduced_motion_enabled?/1","type":"function"},{"doc":"* `true` if reduced motion mode is enabled, `false` otherwise.","ref":"Raxol.Core.Accessibility.Legacy.html#reduced_motion_enabled?/1-returns","title":"Returns - Raxol.Core.Accessibility.Legacy.reduced_motion_enabled?/1","type":"function"},{"doc":"iex> Legacy.reduced_motion_enabled?()\n    false","ref":"Raxol.Core.Accessibility.Legacy.html#reduced_motion_enabled?/1-examples","title":"Examples - Raxol.Core.Accessibility.Legacy.reduced_motion_enabled?/1","type":"function"},{"doc":"Handles accessibility metadata for UI elements and component styles.","ref":"Raxol.Core.Accessibility.Metadata.html","title":"Raxol.Core.Accessibility.Metadata","type":"module"},{"doc":"Get the accessible name for an element.","ref":"Raxol.Core.Accessibility.Metadata.html#get_accessible_name/1","title":"Raxol.Core.Accessibility.Metadata.get_accessible_name/1","type":"function"},{"doc":"* `element` - The element to get the accessible name for","ref":"Raxol.Core.Accessibility.Metadata.html#get_accessible_name/1-parameters","title":"Parameters - Raxol.Core.Accessibility.Metadata.get_accessible_name/1","type":"function"},{"doc":"* The accessible name as a string, or nil if not found","ref":"Raxol.Core.Accessibility.Metadata.html#get_accessible_name/1-returns","title":"Returns - Raxol.Core.Accessibility.Metadata.get_accessible_name/1","type":"function"},{"doc":"iex> Metadata.get_accessible_name(\"search_button\")\n    \"Search\"","ref":"Raxol.Core.Accessibility.Metadata.html#get_accessible_name/1-examples","title":"Examples - Raxol.Core.Accessibility.Metadata.get_accessible_name/1","type":"function"},{"doc":"Get style settings for a component type.","ref":"Raxol.Core.Accessibility.Metadata.html#get_component_style/1","title":"Raxol.Core.Accessibility.Metadata.get_component_style/1","type":"function"},{"doc":"* `component_type` - Atom representing the component type","ref":"Raxol.Core.Accessibility.Metadata.html#get_component_style/1-parameters","title":"Parameters - Raxol.Core.Accessibility.Metadata.get_component_style/1","type":"function"},{"doc":"* The style map for the component type, or empty map if not found","ref":"Raxol.Core.Accessibility.Metadata.html#get_component_style/1-returns","title":"Returns - Raxol.Core.Accessibility.Metadata.get_component_style/1","type":"function"},{"doc":"iex> Metadata.get_component_style(:button)\n    %{background: :blue}","ref":"Raxol.Core.Accessibility.Metadata.html#get_component_style/1-examples","title":"Examples - Raxol.Core.Accessibility.Metadata.get_component_style/1","type":"function"},{"doc":"Get metadata for an element.","ref":"Raxol.Core.Accessibility.Metadata.html#get_element_metadata/1","title":"Raxol.Core.Accessibility.Metadata.get_element_metadata/1","type":"function"},{"doc":"* `element_id` - Unique identifier for the element","ref":"Raxol.Core.Accessibility.Metadata.html#get_element_metadata/1-parameters","title":"Parameters - Raxol.Core.Accessibility.Metadata.get_element_metadata/1","type":"function"},{"doc":"* The metadata map for the element, or `nil` if not found","ref":"Raxol.Core.Accessibility.Metadata.html#get_element_metadata/1-returns","title":"Returns - Raxol.Core.Accessibility.Metadata.get_element_metadata/1","type":"function"},{"doc":"iex> Metadata.get_element_metadata(\"search_button\")\n    %{label: \"Search\"}","ref":"Raxol.Core.Accessibility.Metadata.html#get_element_metadata/1-examples","title":"Examples - Raxol.Core.Accessibility.Metadata.get_element_metadata/1","type":"function"},{"doc":"Register style settings for a component type.","ref":"Raxol.Core.Accessibility.Metadata.html#register_component_style/2","title":"Raxol.Core.Accessibility.Metadata.register_component_style/2","type":"function"},{"doc":"* `component_type` - Atom representing the component type\n* `style` - Style map to associate with the component type","ref":"Raxol.Core.Accessibility.Metadata.html#register_component_style/2-parameters","title":"Parameters - Raxol.Core.Accessibility.Metadata.register_component_style/2","type":"function"},{"doc":"iex> Metadata.register_component_style(:button, %{background: :blue})\n    :ok","ref":"Raxol.Core.Accessibility.Metadata.html#register_component_style/2-examples","title":"Examples - Raxol.Core.Accessibility.Metadata.register_component_style/2","type":"function"},{"doc":"Register metadata for an element to be used for accessibility features.","ref":"Raxol.Core.Accessibility.Metadata.html#register_element_metadata/2","title":"Raxol.Core.Accessibility.Metadata.register_element_metadata/2","type":"function"},{"doc":"* `element_id` - Unique identifier for the element\n* `metadata` - Metadata to associate with the element","ref":"Raxol.Core.Accessibility.Metadata.html#register_element_metadata/2-parameters","title":"Parameters - Raxol.Core.Accessibility.Metadata.register_element_metadata/2","type":"function"},{"doc":"iex> Metadata.register_element_metadata(\"search_button\", %{label: \"Search\"})\n    :ok","ref":"Raxol.Core.Accessibility.Metadata.html#register_element_metadata/2-examples","title":"Examples - Raxol.Core.Accessibility.Metadata.register_element_metadata/2","type":"function"},{"doc":"Mock implementation of the accessibility module for testing.","ref":"Raxol.Core.Accessibility.Mock.html","title":"Raxol.Core.Accessibility.Mock","type":"module"},{"doc":"","ref":"Raxol.Core.Accessibility.Mock.html#announce/3","title":"Raxol.Core.Accessibility.Mock.announce/3","type":"function"},{"doc":"Manages accessibility preferences and settings.","ref":"Raxol.Core.Accessibility.Preferences.html","title":"Raxol.Core.Accessibility.Preferences","type":"module"},{"doc":"Get the default preferences name.","ref":"Raxol.Core.Accessibility.Preferences.html#default_prefs_name/0","title":"Raxol.Core.Accessibility.Preferences.default_prefs_name/0","type":"function"},{"doc":"iex> Preferences.default_prefs_name()\n    Raxol.Core.UserPreferences","ref":"Raxol.Core.Accessibility.Preferences.html#default_prefs_name/0-examples","title":"Examples - Raxol.Core.Accessibility.Preferences.default_prefs_name/0","type":"function"},{"doc":"Get an accessibility option value.","ref":"Raxol.Core.Accessibility.Preferences.html#get_option/3","title":"Raxol.Core.Accessibility.Preferences.get_option/3","type":"function"},{"doc":"* `option_name` - The atom representing the accessibility option (e.g., `:high_contrast`).\n* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (optional).\n* `default` - The default value to return if the option is not set (optional).","ref":"Raxol.Core.Accessibility.Preferences.html#get_option/3-parameters","title":"Parameters - Raxol.Core.Accessibility.Preferences.get_option/3","type":"function"},{"doc":"iex> Preferences.get_option(:high_contrast)\n    false","ref":"Raxol.Core.Accessibility.Preferences.html#get_option/3-examples","title":"Examples - Raxol.Core.Accessibility.Preferences.get_option/3","type":"function"},{"doc":"Get the current text scale factor based on the large text setting.","ref":"Raxol.Core.Accessibility.Preferences.html#get_text_scale/1","title":"Raxol.Core.Accessibility.Preferences.get_text_scale/1","type":"function"},{"doc":"* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (optional).","ref":"Raxol.Core.Accessibility.Preferences.html#get_text_scale/1-parameters","title":"Parameters - Raxol.Core.Accessibility.Preferences.get_text_scale/1","type":"function"},{"doc":"iex> Preferences.get_text_scale()\n    1.0 # or 1.5 if large_text is enabled","ref":"Raxol.Core.Accessibility.Preferences.html#get_text_scale/1-examples","title":"Examples - Raxol.Core.Accessibility.Preferences.get_text_scale/1","type":"function"},{"doc":"","ref":"Raxol.Core.Accessibility.Preferences.html#handle_preference_changed/2","title":"Raxol.Core.Accessibility.Preferences.handle_preference_changed/2","type":"function"},{"doc":"Enable or disable high contrast mode.","ref":"Raxol.Core.Accessibility.Preferences.html#set_high_contrast/2","title":"Raxol.Core.Accessibility.Preferences.set_high_contrast/2","type":"function"},{"doc":"* `enabled` - `true` to enable high contrast, `false` to disable.\n* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (optional).","ref":"Raxol.Core.Accessibility.Preferences.html#set_high_contrast/2-parameters","title":"Parameters - Raxol.Core.Accessibility.Preferences.set_high_contrast/2","type":"function"},{"doc":"iex> Preferences.set_high_contrast(true)\n    :ok","ref":"Raxol.Core.Accessibility.Preferences.html#set_high_contrast/2-examples","title":"Examples - Raxol.Core.Accessibility.Preferences.set_high_contrast/2","type":"function"},{"doc":"Enable or disable large text mode.","ref":"Raxol.Core.Accessibility.Preferences.html#set_large_text/2","title":"Raxol.Core.Accessibility.Preferences.set_large_text/2","type":"function"},{"doc":"* `enabled` - `true` to enable large text, `false` to disable.\n* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (optional).","ref":"Raxol.Core.Accessibility.Preferences.html#set_large_text/2-parameters","title":"Parameters - Raxol.Core.Accessibility.Preferences.set_large_text/2","type":"function"},{"doc":"iex> Preferences.set_large_text(true)\n    :ok","ref":"Raxol.Core.Accessibility.Preferences.html#set_large_text/2-examples","title":"Examples - Raxol.Core.Accessibility.Preferences.set_large_text/2","type":"function"},{"doc":"Set an accessibility option value.","ref":"Raxol.Core.Accessibility.Preferences.html#set_option/3","title":"Raxol.Core.Accessibility.Preferences.set_option/3","type":"function"},{"doc":"* `key` - The option key to set\n* `value` - The value to set\n* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (optional).","ref":"Raxol.Core.Accessibility.Preferences.html#set_option/3-parameters","title":"Parameters - Raxol.Core.Accessibility.Preferences.set_option/3","type":"function"},{"doc":"iex> Preferences.set_option(:high_contrast, true)\n    :ok","ref":"Raxol.Core.Accessibility.Preferences.html#set_option/3-examples","title":"Examples - Raxol.Core.Accessibility.Preferences.set_option/3","type":"function"},{"doc":"Enable or disable reduced motion.","ref":"Raxol.Core.Accessibility.Preferences.html#set_reduced_motion/2","title":"Raxol.Core.Accessibility.Preferences.set_reduced_motion/2","type":"function"},{"doc":"* `enabled` - `true` to enable reduced motion, `false` to disable.\n* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (optional).","ref":"Raxol.Core.Accessibility.Preferences.html#set_reduced_motion/2-parameters","title":"Parameters - Raxol.Core.Accessibility.Preferences.set_reduced_motion/2","type":"function"},{"doc":"iex> Preferences.set_reduced_motion(true)\n    :ok","ref":"Raxol.Core.Accessibility.Preferences.html#set_reduced_motion/2-examples","title":"Examples - Raxol.Core.Accessibility.Preferences.set_reduced_motion/2","type":"function"},{"doc":"Manages the integration between accessibility settings and the active theme.\n\nListens for accessibility changes (e.g., high contrast toggle) and\nupdates the active theme accordingly.","ref":"Raxol.Core.Accessibility.ThemeIntegration.html","title":"Raxol.Core.Accessibility.ThemeIntegration","type":"module"},{"doc":"Apply the current accessibility settings to components.\nThis function is typically called during initialization to ensure components\nreflect the persisted preferences.\nAccepts a keyword list of options (e.g., `[high_contrast: true, ...]`).","ref":"Raxol.Core.Accessibility.ThemeIntegration.html#apply_settings/1","title":"Raxol.Core.Accessibility.ThemeIntegration.apply_settings/1","type":"function"},{"doc":"Clean up the theme integration.\n\nUnregisters event handlers.","ref":"Raxol.Core.Accessibility.ThemeIntegration.html#cleanup/0","title":"Raxol.Core.Accessibility.ThemeIntegration.cleanup/0","type":"function"},{"doc":"iex> ThemeIntegration.cleanup()\n    :ok","ref":"Raxol.Core.Accessibility.ThemeIntegration.html#cleanup/0-examples","title":"Examples - Raxol.Core.Accessibility.ThemeIntegration.cleanup/0","type":"function"},{"doc":"Returns the current accessibility mode based on settings.\nDefaults to `:normal` if high contrast is off.","ref":"Raxol.Core.Accessibility.ThemeIntegration.html#get_accessibility_mode/0","title":"Raxol.Core.Accessibility.ThemeIntegration.get_accessibility_mode/0","type":"function"},{"doc":"Returns the current active theme variant for accessibility-aware theming.\nUsed by the renderer and theming system to select the correct theme variant.","ref":"Raxol.Core.Accessibility.ThemeIntegration.html#get_active_variant/0","title":"Raxol.Core.Accessibility.ThemeIntegration.get_active_variant/0","type":"function"},{"doc":"iex> ThemeIntegration.get_active_variant()\n    :normal | :high_contrast","ref":"Raxol.Core.Accessibility.ThemeIntegration.html#get_active_variant/0-examples","title":"Examples - Raxol.Core.Accessibility.ThemeIntegration.get_active_variant/0","type":"function"},{"doc":"Get the current theme based on accessibility settings.","ref":"Raxol.Core.Accessibility.ThemeIntegration.html#get_theme/0","title":"Raxol.Core.Accessibility.ThemeIntegration.get_theme/0","type":"function"},{"doc":"iex> ThemeIntegration.get_theme()\n    %Theme{}  # Returns the current theme with accessibility adjustments","ref":"Raxol.Core.Accessibility.ThemeIntegration.html#get_theme/0-examples","title":"Examples - Raxol.Core.Accessibility.ThemeIntegration.get_theme/0","type":"function"},{"doc":"Handle high contrast mode changes.\nUpdates the theme based on high contrast setting.","ref":"Raxol.Core.Accessibility.ThemeIntegration.html#handle_high_contrast/1","title":"Raxol.Core.Accessibility.ThemeIntegration.handle_high_contrast/1","type":"function"},{"doc":"Handle large text setting changes.","ref":"Raxol.Core.Accessibility.ThemeIntegration.html#handle_large_text/1","title":"Raxol.Core.Accessibility.ThemeIntegration.handle_large_text/1","type":"function"},{"doc":"iex> ThemeIntegration.handle_large_text({:accessibility_large_text, true})\n    :ok","ref":"Raxol.Core.Accessibility.ThemeIntegration.html#handle_large_text/1-examples","title":"Examples - Raxol.Core.Accessibility.ThemeIntegration.handle_large_text/1","type":"function"},{"doc":"Handle reduced motion setting changes.","ref":"Raxol.Core.Accessibility.ThemeIntegration.html#handle_reduced_motion/1","title":"Raxol.Core.Accessibility.ThemeIntegration.handle_reduced_motion/1","type":"function"},{"doc":"iex> ThemeIntegration.handle_reduced_motion({:accessibility_reduced_motion, true})\n    :ok","ref":"Raxol.Core.Accessibility.ThemeIntegration.html#handle_reduced_motion/1-examples","title":"Examples - Raxol.Core.Accessibility.ThemeIntegration.handle_reduced_motion/1","type":"function"},{"doc":"Initialize the theme integration.\n\nRegisters event handlers for accessibility setting changes.","ref":"Raxol.Core.Accessibility.ThemeIntegration.html#init/0","title":"Raxol.Core.Accessibility.ThemeIntegration.init/0","type":"function"},{"doc":"iex> ThemeIntegration.init()\n    :ok","ref":"Raxol.Core.Accessibility.ThemeIntegration.html#init/0-examples","title":"Examples - Raxol.Core.Accessibility.ThemeIntegration.init/0","type":"function"},{"doc":"Behaviour for clipboard operations.","ref":"Raxol.Core.Clipboard.Behaviour.html","title":"Raxol.Core.Clipboard.Behaviour","type":"behaviour"},{"doc":"Copies text to the clipboard.","ref":"Raxol.Core.Clipboard.Behaviour.html#c:copy/1","title":"Raxol.Core.Clipboard.Behaviour.copy/1","type":"callback"},{"doc":"Pastes text from the clipboard.","ref":"Raxol.Core.Clipboard.Behaviour.html#c:paste/0","title":"Raxol.Core.Clipboard.Behaviour.paste/0","type":"callback"},{"doc":"Core color system for Raxol.\n\nThis module provides a unified interface for managing colors and themes\nthroughout the application. It integrates with the Style.Colors modules\nto provide a consistent color experience.","ref":"Raxol.Core.ColorSystem.html","title":"Raxol.Core.ColorSystem","type":"module"},{"doc":"- Theme management with semantic color naming\n- Color format conversion and validation\n- Accessibility checks and adjustments","ref":"Raxol.Core.ColorSystem.html#module-features","title":"Features - Raxol.Core.ColorSystem","type":"module"},{"doc":"Adjusts a color to meet contrast requirements with another color.","ref":"Raxol.Core.ColorSystem.html#adjust_for_contrast/5","title":"Raxol.Core.ColorSystem.adjust_for_contrast/5","type":"function"},{"doc":"iex> theme = create_theme(\"dark\", %{\n    ...>   text: \"#808080\",\n    ...>   background: \"#000000\"\n    ...> })\n    iex> adjusted = adjust_for_contrast(theme, :text, :background, :AA, :normal)\n    iex> meets_contrast_requirements?(adjusted, :text, :background, :AA, :normal)\n    true","ref":"Raxol.Core.ColorSystem.html#adjust_for_contrast/5-examples","title":"Examples - Raxol.Core.ColorSystem.adjust_for_contrast/5","type":"function"},{"doc":"Creates a new theme with the given name and colors.","ref":"Raxol.Core.ColorSystem.html#create_theme/2","title":"Raxol.Core.ColorSystem.create_theme/2","type":"function"},{"doc":"iex> theme = create_theme(\"dark\", %{\n    ...>   primary: \"#FF0000\",\n    ...>   background: \"#000000\",\n    ...>   text: \"#FFFFFF\"\n    ...> })\n    iex> theme.name\n    \"dark\"","ref":"Raxol.Core.ColorSystem.html#create_theme/2-examples","title":"Examples - Raxol.Core.ColorSystem.create_theme/2","type":"function"},{"doc":"Gets the effective color value for a given semantic color name.\n\nIt retrieves the color from the specified theme (by ID), automatically considering\nwhether a high contrast variant is active based on accessibility settings.\n\nArgs:\n  - `theme_id`: The atom ID of the theme to use (e.g., :default, :dark).\n  - `color_name`: The semantic name of the color (e.g., :primary, :background).\n\nReturns the color value (e.g., :red, {:rgb, r, g, b}) or nil if not found.","ref":"Raxol.Core.ColorSystem.html#get/2","title":"Raxol.Core.ColorSystem.get/2","type":"function"},{"doc":"Gets a color value and ensures it's returned in a specific format (e.g., RGB tuple).\nUseful when a specific color representation is required for rendering.\n\nArgs:\n  - `theme_id`: The atom ID of the theme to use.\n  - `color_name`: The semantic name of the color.\n  - `format`: The desired output format (:rgb_tuple, :hex_string, :term).\n\nSupported formats: :rgb_tuple, :hex_string, :term","ref":"Raxol.Core.ColorSystem.html#get_as/3","title":"Raxol.Core.ColorSystem.get_as/3","type":"function"},{"doc":"Gets a color from the theme by its semantic name.","ref":"Raxol.Core.ColorSystem.html#get_color/2","title":"Raxol.Core.ColorSystem.get_color/2","type":"function"},{"doc":"iex> theme = create_theme(\"dark\", %{primary: \"#FF0000\"})\n    iex> get_color(theme, :primary)\n    %Color{r: 255, g: 0, b: 0, hex: \"#FF0000\"}","ref":"Raxol.Core.ColorSystem.html#get_color/2-examples","title":"Examples - Raxol.Core.ColorSystem.get_color/2","type":"function"},{"doc":"Checks if two colors meet WCAG contrast requirements.","ref":"Raxol.Core.ColorSystem.html#meets_contrast_requirements?/5","title":"Raxol.Core.ColorSystem.meets_contrast_requirements?/5","type":"function"},{"doc":"iex> theme = create_theme(\"dark\", %{\n    ...>   text: \"#FFFFFF\",\n    ...>   background: \"#000000\"\n    ...> })\n    iex> meets_contrast_requirements?(theme, :text, :background, :AA, :normal)\n    true","ref":"Raxol.Core.ColorSystem.html#meets_contrast_requirements?/5-examples","title":"Examples - Raxol.Core.ColorSystem.meets_contrast_requirements?/5","type":"function"},{"doc":"Converts a color to its ANSI representation.","ref":"Raxol.Core.ColorSystem.html#to_ansi/3","title":"Raxol.Core.ColorSystem.to_ansi/3","type":"function"},{"doc":"iex> theme = create_theme(\"dark\", %{primary: \"#FF0000\"})\n    iex> to_ansi(theme, :primary, :foreground)\n    196","ref":"Raxol.Core.ColorSystem.html#to_ansi/3-examples","title":"Examples - Raxol.Core.ColorSystem.to_ansi/3","type":"function"},{"doc":"Utility functions for component-related logic shared across Raxol modules.","ref":"Raxol.Core.ComponentUtils.html","title":"Raxol.Core.ComponentUtils","type":"module"},{"doc":"Determines if a component is considered important (e.g., header, navigation, menu).\nThis is used for performance optimizations and gesture prioritization.","ref":"Raxol.Core.ComponentUtils.html#is_important_component?/2","title":"Raxol.Core.ComponentUtils.is_important_component?/2","type":"function"},{"doc":"Configuration manager for the Raxol Terminal Emulator.\nProvides a unified interface for managing all configuration options,\nincluding loading, validation, and runtime updates.","ref":"Raxol.Core.Config.Manager.html","title":"Raxol.Core.Config.Manager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Config.Manager.html#child_spec/1","title":"Raxol.Core.Config.Manager.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Core.Config.Manager.html#t:config_key/0","title":"Raxol.Core.Config.Manager.config_key/0","type":"type"},{"doc":"","ref":"Raxol.Core.Config.Manager.html#t:config_opts/0","title":"Raxol.Core.Config.Manager.config_opts/0","type":"type"},{"doc":"","ref":"Raxol.Core.Config.Manager.html#t:config_value/0","title":"Raxol.Core.Config.Manager.config_value/0","type":"type"},{"doc":"Deletes a configuration value.","ref":"Raxol.Core.Config.Manager.html#delete/2","title":"Raxol.Core.Config.Manager.delete/2","type":"function"},{"doc":"* `key` - The configuration key\n  * `opts` - Additional options\n    * `:persist` - Whether to persist the deletion (default: true)","ref":"Raxol.Core.Config.Manager.html#delete/2-parameters","title":"Parameters - Raxol.Core.Config.Manager.delete/2","type":"function"},{"doc":"* `:ok` - If the value was deleted successfully\n  * `{:error, reason}` - If the value could not be deleted","ref":"Raxol.Core.Config.Manager.html#delete/2-returns","title":"Returns - Raxol.Core.Config.Manager.delete/2","type":"function"},{"doc":"Gets a configuration value.","ref":"Raxol.Core.Config.Manager.html#get/2","title":"Raxol.Core.Config.Manager.get/2","type":"function"},{"doc":"* `key` - The configuration key\n  * `default` - Default value if key is not found (optional)","ref":"Raxol.Core.Config.Manager.html#get/2-parameters","title":"Parameters - Raxol.Core.Config.Manager.get/2","type":"function"},{"doc":"* The configuration value or default","ref":"Raxol.Core.Config.Manager.html#get/2-returns","title":"Returns - Raxol.Core.Config.Manager.get/2","type":"function"},{"doc":"Gets all configuration values.","ref":"Raxol.Core.Config.Manager.html#get_all/0","title":"Raxol.Core.Config.Manager.get_all/0","type":"function"},{"doc":"* Map of all configuration values","ref":"Raxol.Core.Config.Manager.html#get_all/0-returns","title":"Returns - Raxol.Core.Config.Manager.get_all/0","type":"function"},{"doc":"Reloads configuration from the file.","ref":"Raxol.Core.Config.Manager.html#reload/0","title":"Raxol.Core.Config.Manager.reload/0","type":"function"},{"doc":"* `:ok` - If the configuration was reloaded successfully\n  * `{:error, reason}` - If the configuration could not be reloaded","ref":"Raxol.Core.Config.Manager.html#reload/0-returns","title":"Returns - Raxol.Core.Config.Manager.reload/0","type":"function"},{"doc":"Sets a configuration value.","ref":"Raxol.Core.Config.Manager.html#set/3","title":"Raxol.Core.Config.Manager.set/3","type":"function"},{"doc":"* `key` - The configuration key\n  * `value` - The configuration value\n  * `opts` - Additional options\n    * `:validate` - Whether to validate the value (default: true)\n    * `:persist` - Whether to persist the value (default: true)","ref":"Raxol.Core.Config.Manager.html#set/3-parameters","title":"Parameters - Raxol.Core.Config.Manager.set/3","type":"function"},{"doc":"* `:ok` - If the value was set successfully\n  * `{:error, reason}` - If the value could not be set","ref":"Raxol.Core.Config.Manager.html#set/3-returns","title":"Returns - Raxol.Core.Config.Manager.set/3","type":"function"},{"doc":"Starts the configuration manager.","ref":"Raxol.Core.Config.Manager.html#start_link/1","title":"Raxol.Core.Config.Manager.start_link/1","type":"function"},{"doc":"* `:config_file` - Path to the configuration file (default: \"config/raxol.exs\")\n  * `:env` - Environment to load (default: Mix.env())\n  * `:validate` - Whether to validate configuration (default: true)","ref":"Raxol.Core.Config.Manager.html#start_link/1-options","title":"Options - Raxol.Core.Config.Manager.start_link/1","type":"function"},{"doc":"* `{:ok, pid}` - If the manager starts successfully\n  * `{:error, reason}` - If the manager fails to start","ref":"Raxol.Core.Config.Manager.html#start_link/1-returns","title":"Returns - Raxol.Core.Config.Manager.start_link/1","type":"function"},{"doc":"Updates a configuration value using a function.","ref":"Raxol.Core.Config.Manager.html#update/3","title":"Raxol.Core.Config.Manager.update/3","type":"function"},{"doc":"* `key` - The configuration key\n  * `fun` - Function to update the value\n  * `opts` - Additional options\n    * `:validate` - Whether to validate the value (default: true)\n    * `:persist` - Whether to persist the value (default: true)","ref":"Raxol.Core.Config.Manager.html#update/3-parameters","title":"Parameters - Raxol.Core.Config.Manager.update/3","type":"function"},{"doc":"* `:ok` - If the value was updated successfully\n  * `{:error, reason}` - If the value could not be updated","ref":"Raxol.Core.Config.Manager.html#update/3-returns","title":"Returns - Raxol.Core.Config.Manager.update/3","type":"function"},{"doc":"","ref":"Raxol.Core.Config.Manager.html#t:validation_result/0","title":"Raxol.Core.Config.Manager.validation_result/0","type":"type"},{"doc":"Defines the structure for events in the Raxol system, providing a standardized format\nfor key presses, mouse actions, and other UI events that components need to process.\n\nEvents are structs with a :type and :data field, where :type indicates the event category\n(e.g., :key, :mouse, :resize) and :data contains the event-specific details.","ref":"Raxol.Core.Events.Event.html","title":"Raxol.Core.Events.Event","type":"module"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:cursor_event/0","title":"Raxol.Core.Events.Event.cursor_event/0","type":"type"},{"doc":"Creates a cursor event.","ref":"Raxol.Core.Events.Event.html#cursor_event/4","title":"Raxol.Core.Events.Event.cursor_event/4","type":"function"},{"doc":"* `visible` - Whether cursor is visible\n  * `style` - Cursor style\n  * `blink` - Whether cursor should blink\n  * `position` - Cursor position","ref":"Raxol.Core.Events.Event.html#cursor_event/4-parameters","title":"Parameters - Raxol.Core.Events.Event.cursor_event/4","type":"function"},{"doc":"Creates a simple custom event.","ref":"Raxol.Core.Events.Event.html#custom/1","title":"Raxol.Core.Events.Event.custom/1","type":"function"},{"doc":"Creates a custom event.","ref":"Raxol.Core.Events.Event.html#custom_event/1","title":"Raxol.Core.Events.Event.custom_event/1","type":"function"},{"doc":"* `data` - Custom event data","ref":"Raxol.Core.Events.Event.html#custom_event/1-parameters","title":"Parameters - Raxol.Core.Events.Event.custom_event/1","type":"function"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:event_data/0","title":"Raxol.Core.Events.Event.event_data/0","type":"type"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:event_type/0","title":"Raxol.Core.Events.Event.event_type/0","type":"type"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:focus_event/0","title":"Raxol.Core.Events.Event.focus_event/0","type":"type"},{"doc":"Creates a focus event.","ref":"Raxol.Core.Events.Event.html#focus_event/2","title":"Raxol.Core.Events.Event.focus_event/2","type":"function"},{"doc":"* `target` - What received/lost focus\n  * `focused` - Whether focus was gained (true) or lost (false)","ref":"Raxol.Core.Events.Event.html#focus_event/2-parameters","title":"Parameters - Raxol.Core.Events.Event.focus_event/2","type":"function"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:focus_target/0","title":"Raxol.Core.Events.Event.focus_target/0","type":"type"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:key/0","title":"Raxol.Core.Events.Event.key/0","type":"type"},{"doc":"Creates a simple key event with pressed state and no modifiers.","ref":"Raxol.Core.Events.Event.html#key/1","title":"Raxol.Core.Events.Event.key/1","type":"function"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:key_event/0","title":"Raxol.Core.Events.Event.key_event/0","type":"type"},{"doc":"Creates a keyboard event.","ref":"Raxol.Core.Events.Event.html#key_event/3","title":"Raxol.Core.Events.Event.key_event/3","type":"function"},{"doc":"* `key` - The key that was pressed/released (e.g. :enter, :backspace, \"a\")\n  * `state` - The state of the key (:pressed, :released, :repeat)\n  * `modifiers` - List of active modifiers (e.g. [:shift, :ctrl])","ref":"Raxol.Core.Events.Event.html#key_event/3-parameters","title":"Parameters - Raxol.Core.Events.Event.key_event/3","type":"function"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:key_state/0","title":"Raxol.Core.Events.Event.key_state/0","type":"type"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:modifiers/0","title":"Raxol.Core.Events.Event.modifiers/0","type":"type"},{"doc":"Creates a simple mouse event with pressed state and no modifiers.","ref":"Raxol.Core.Events.Event.html#mouse/2","title":"Raxol.Core.Events.Event.mouse/2","type":"function"},{"doc":"Creates a mouse event with drag state.","ref":"Raxol.Core.Events.Event.html#mouse/3","title":"Raxol.Core.Events.Event.mouse/3","type":"function"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:mouse_button/0","title":"Raxol.Core.Events.Event.mouse_button/0","type":"type"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:mouse_event/0","title":"Raxol.Core.Events.Event.mouse_event/0","type":"type"},{"doc":"Creates a mouse event.","ref":"Raxol.Core.Events.Event.html#mouse_event/4","title":"Raxol.Core.Events.Event.mouse_event/4","type":"function"},{"doc":"* `button` - The mouse button (:left, :right, :middle)\n  * `position` - The mouse position as {x, y}\n  * `state` - The button state (:pressed, :released, :double_click)\n  * `modifiers` - List of active modifiers (e.g. [:shift, :ctrl])","ref":"Raxol.Core.Events.Event.html#mouse_event/4-parameters","title":"Parameters - Raxol.Core.Events.Event.mouse_event/4","type":"function"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:mouse_position/0","title":"Raxol.Core.Events.Event.mouse_position/0","type":"type"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:mouse_state/0","title":"Raxol.Core.Events.Event.mouse_state/0","type":"type"},{"doc":"Creates a new event with the given type and data. Optionally accepts a timestamp (defaults to now).","ref":"Raxol.Core.Events.Event.html#new/3","title":"Raxol.Core.Events.Event.new/3","type":"function"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:paste_event/0","title":"Raxol.Core.Events.Event.paste_event/0","type":"type"},{"doc":"Creates a paste event.","ref":"Raxol.Core.Events.Event.html#paste_event/2","title":"Raxol.Core.Events.Event.paste_event/2","type":"function"},{"doc":"* `text` - Pasted text\n  * `position` - Paste position","ref":"Raxol.Core.Events.Event.html#paste_event/2-parameters","title":"Parameters - Raxol.Core.Events.Event.paste_event/2","type":"function"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:scroll_direction/0","title":"Raxol.Core.Events.Event.scroll_direction/0","type":"type"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:scroll_event/0","title":"Raxol.Core.Events.Event.scroll_event/0","type":"type"},{"doc":"Creates a scroll event.","ref":"Raxol.Core.Events.Event.html#scroll_event/3","title":"Raxol.Core.Events.Event.scroll_event/3","type":"function"},{"doc":"* `direction` - Scroll direction\n  * `delta` - Amount scrolled (positive or negative)\n  * `position` - Current scroll position","ref":"Raxol.Core.Events.Event.html#scroll_event/3-parameters","title":"Parameters - Raxol.Core.Events.Event.scroll_event/3","type":"function"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:selection_event/0","title":"Raxol.Core.Events.Event.selection_event/0","type":"type"},{"doc":"Creates a selection event.","ref":"Raxol.Core.Events.Event.html#selection_event/3","title":"Raxol.Core.Events.Event.selection_event/3","type":"function"},{"doc":"* `start_pos` - Selection start position\n  * `end_pos` - Selection end position\n  * `text` - Selected text","ref":"Raxol.Core.Events.Event.html#selection_event/3-parameters","title":"Parameters - Raxol.Core.Events.Event.selection_event/3","type":"function"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:t/0","title":"Raxol.Core.Events.Event.t/0","type":"type"},{"doc":"Creates a simple timer event.","ref":"Raxol.Core.Events.Event.html#timer/1","title":"Raxol.Core.Events.Event.timer/1","type":"function"},{"doc":"Creates a timer event.","ref":"Raxol.Core.Events.Event.html#timer_event/1","title":"Raxol.Core.Events.Event.timer_event/1","type":"function"},{"doc":"* `data` - Timer-specific data","ref":"Raxol.Core.Events.Event.html#timer_event/1-parameters","title":"Parameters - Raxol.Core.Events.Event.timer_event/1","type":"function"},{"doc":"Creates a simple window event.","ref":"Raxol.Core.Events.Event.html#window/3","title":"Raxol.Core.Events.Event.window/3","type":"function"},{"doc":"","ref":"Raxol.Core.Events.Event.html#t:window_event/0","title":"Raxol.Core.Events.Event.window_event/0","type":"type"},{"doc":"Creates a window event.","ref":"Raxol.Core.Events.Event.html#window_event/3","title":"Raxol.Core.Events.Event.window_event/3","type":"function"},{"doc":"* `width` - The window width\n  * `height` - The window height\n  * `action` - The window action (:resize, :focus, :blur)","ref":"Raxol.Core.Events.Event.html#window_event/3-parameters","title":"Parameters - Raxol.Core.Events.Event.window_event/3","type":"function"},{"doc":"Event manager for handling and dispatching events in Raxol applications.\n\nThis module provides a simple event system that allows:\n- Registering event handlers\n- Dispatching events\n- Handling events\n- Managing subscriptions","ref":"Raxol.Core.Events.Manager.html","title":"Raxol.Core.Events.Manager","type":"module"},{"doc":"```elixir\n# Initialize the event manager\nEventManager.init()\n\n# Register an event handler\nEventManager.register_handler(:click, MyModule, :handle_click)\n\n# Subscribe to events\n{:ok, ref} = EventManager.subscribe([:click, :key_press])\n\n# Dispatch an event\nEventManager.dispatch({:click, %{x: 10, y: 20}})\n\n# Unsubscribe\nEventManager.unsubscribe(ref)\n```","ref":"Raxol.Core.Events.Manager.html#module-usage","title":"Usage - Raxol.Core.Events.Manager","type":"module"},{"doc":"Broadcast an event to all subscribers.","ref":"Raxol.Core.Events.Manager.html#broadcast/1","title":"Raxol.Core.Events.Manager.broadcast/1","type":"function"},{"doc":"iex> EventManager.broadcast({:system_event, :shutdown})\n    :ok","ref":"Raxol.Core.Events.Manager.html#broadcast/1-examples","title":"Examples - Raxol.Core.Events.Manager.broadcast/1","type":"function"},{"doc":"Cleans up the event manager state.","ref":"Raxol.Core.Events.Manager.html#cleanup/0","title":"Raxol.Core.Events.Manager.cleanup/0","type":"function"},{"doc":"Clear all event handlers.","ref":"Raxol.Core.Events.Manager.html#clear_handlers/0","title":"Raxol.Core.Events.Manager.clear_handlers/0","type":"function"},{"doc":"iex> EventManager.clear_handlers()\n    :ok","ref":"Raxol.Core.Events.Manager.html#clear_handlers/0-examples","title":"Examples - Raxol.Core.Events.Manager.clear_handlers/0","type":"function"},{"doc":"Dispatch an event to all registered handlers and subscribers.","ref":"Raxol.Core.Events.Manager.html#dispatch/1","title":"Raxol.Core.Events.Manager.dispatch/1","type":"function"},{"doc":"* `event` - The event to dispatch","ref":"Raxol.Core.Events.Manager.html#dispatch/1-parameters","title":"Parameters - Raxol.Core.Events.Manager.dispatch/1","type":"function"},{"doc":"iex> EventManager.dispatch({:click, %{x: 10, y: 20}})\n    :ok\n\n    iex> EventManager.dispatch(:accessibility_high_contrast)\n    :ok","ref":"Raxol.Core.Events.Manager.html#dispatch/1-examples","title":"Examples - Raxol.Core.Events.Manager.dispatch/1","type":"function"},{"doc":"Get all registered event handlers.","ref":"Raxol.Core.Events.Manager.html#get_handlers/0","title":"Raxol.Core.Events.Manager.get_handlers/0","type":"function"},{"doc":"iex> EventManager.get_handlers()\n    %{click: [{MyModule, :handle_click}]}","ref":"Raxol.Core.Events.Manager.html#get_handlers/0-examples","title":"Examples - Raxol.Core.Events.Manager.get_handlers/0","type":"function"},{"doc":"Initialize the event manager.","ref":"Raxol.Core.Events.Manager.html#init/0","title":"Raxol.Core.Events.Manager.init/0","type":"function"},{"doc":"iex> EventManager.init()\n    :ok","ref":"Raxol.Core.Events.Manager.html#init/0-examples","title":"Examples - Raxol.Core.Events.Manager.init/0","type":"function"},{"doc":"Register an event handler.","ref":"Raxol.Core.Events.Manager.html#register_handler/3","title":"Raxol.Core.Events.Manager.register_handler/3","type":"function"},{"doc":"* `event_type` - The type of event to handle\n* `module` - The module containing the handler function\n* `function` - The function to call when the event occurs","ref":"Raxol.Core.Events.Manager.html#register_handler/3-parameters","title":"Parameters - Raxol.Core.Events.Manager.register_handler/3","type":"function"},{"doc":"iex> EventManager.register_handler(:click, MyModule, :handle_click)\n    :ok","ref":"Raxol.Core.Events.Manager.html#register_handler/3-examples","title":"Examples - Raxol.Core.Events.Manager.register_handler/3","type":"function"},{"doc":"Subscribe to events with optional filters.","ref":"Raxol.Core.Events.Manager.html#subscribe/2","title":"Raxol.Core.Events.Manager.subscribe/2","type":"function"},{"doc":"* `event_types` - List of event types to subscribe to\n* `opts` - Optional filters and options","ref":"Raxol.Core.Events.Manager.html#subscribe/2-parameters","title":"Parameters - Raxol.Core.Events.Manager.subscribe/2","type":"function"},{"doc":"iex> EventManager.subscribe([:click, :key_press])\n    {:ok, ref}\n\n    iex> EventManager.subscribe([:mouse], button: :left)\n    {:ok, ref}","ref":"Raxol.Core.Events.Manager.html#subscribe/2-examples","title":"Examples - Raxol.Core.Events.Manager.subscribe/2","type":"function"},{"doc":"Triggers an event with a type and payload (alias for dispatch/1).\nThis is provided for API compatibility; use dispatch/1 for generic events.","ref":"Raxol.Core.Events.Manager.html#trigger/2","title":"Raxol.Core.Events.Manager.trigger/2","type":"function"},{"doc":"Unregister an event handler.","ref":"Raxol.Core.Events.Manager.html#unregister_handler/3","title":"Raxol.Core.Events.Manager.unregister_handler/3","type":"function"},{"doc":"* `event_type` - The type of event\n* `module` - The module containing the handler function\n* `function` - The function that was registered","ref":"Raxol.Core.Events.Manager.html#unregister_handler/3-parameters","title":"Parameters - Raxol.Core.Events.Manager.unregister_handler/3","type":"function"},{"doc":"iex> EventManager.unregister_handler(:click, MyModule, :handle_click)\n    :ok","ref":"Raxol.Core.Events.Manager.html#unregister_handler/3-examples","title":"Examples - Raxol.Core.Events.Manager.unregister_handler/3","type":"function"},{"doc":"Unsubscribe from events using the subscription reference.","ref":"Raxol.Core.Events.Manager.html#unsubscribe/1","title":"Raxol.Core.Events.Manager.unsubscribe/1","type":"function"},{"doc":"iex> EventManager.unsubscribe(ref)\n    :ok","ref":"Raxol.Core.Events.Manager.html#unsubscribe/1-examples","title":"Examples - Raxol.Core.Events.Manager.unsubscribe/1","type":"function"},{"doc":"","ref":"Raxol.Core.Events.Manager.Behaviour.html","title":"Raxol.Core.Events.Manager.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Core.Events.Manager.Behaviour.html#c:dispatch/1","title":"Raxol.Core.Events.Manager.Behaviour.dispatch/1","type":"callback"},{"doc":"Provides helpers for managing event subscriptions.\n\nThis module makes it easy to:\n* Subscribe to specific event types\n* Filter events based on criteria\n* Handle event cleanup\n* Manage multiple subscriptions","ref":"Raxol.Core.Events.Subscription.html","title":"Raxol.Core.Events.Subscription","type":"module"},{"doc":"Subscribes to a list of event types.","ref":"Raxol.Core.Events.Subscription.html#events/1","title":"Raxol.Core.Events.Subscription.events/1","type":"function"},{"doc":"- `event_types` - A list of event type atoms (e.g., `[:key, :mouse, :window]`).\n                   Can also include tuples like `{:key, opts}` or `{:mouse, opts}`\n                   to pass specific options to the individual subscription functions.","ref":"Raxol.Core.Events.Subscription.html#events/1-parameters","title":"Parameters - Raxol.Core.Events.Subscription.events/1","type":"function"},{"doc":"- `{:ok, list(subscription_ref())}` on success, containing a list of references for each subscription.\n- `{:error, reason}` if any subscription fails. Successfully created subscriptions before the failure will be automatically unsubscribed.","ref":"Raxol.Core.Events.Subscription.html#events/1-returns","title":"Returns - Raxol.Core.Events.Subscription.events/1","type":"function"},{"doc":"Subscribes to custom events with data matching.","ref":"Raxol.Core.Events.Subscription.html#subscribe_custom/1","title":"Raxol.Core.Events.Subscription.subscribe_custom/1","type":"function"},{"doc":"* `:match` - Pattern to match against custom event data","ref":"Raxol.Core.Events.Subscription.html#subscribe_custom/1-options","title":"Options - Raxol.Core.Events.Subscription.subscribe_custom/1","type":"function"},{"doc":"subscribe_custom(match: {:user_action, _})","ref":"Raxol.Core.Events.Subscription.html#subscribe_custom/1-example","title":"Example - Raxol.Core.Events.Subscription.subscribe_custom/1","type":"function"},{"doc":"Subscribes to keyboard events with optional key filters.","ref":"Raxol.Core.Events.Subscription.html#subscribe_keyboard/1","title":"Raxol.Core.Events.Subscription.subscribe_keyboard/1","type":"function"},{"doc":"* `:keys` - List of specific keys to match\n* `:exclude_keys` - List of keys to ignore","ref":"Raxol.Core.Events.Subscription.html#subscribe_keyboard/1-options","title":"Options - Raxol.Core.Events.Subscription.subscribe_keyboard/1","type":"function"},{"doc":"subscribe_keyboard(keys: [:enter, :esc])\n    subscribe_keyboard(exclude_keys: [:tab])","ref":"Raxol.Core.Events.Subscription.html#subscribe_keyboard/1-example","title":"Example - Raxol.Core.Events.Subscription.subscribe_keyboard/1","type":"function"},{"doc":"Subscribes to mouse events with optional button and position filters.","ref":"Raxol.Core.Events.Subscription.html#subscribe_mouse/1","title":"Raxol.Core.Events.Subscription.subscribe_mouse/1","type":"function"},{"doc":"* `:buttons` - List of mouse buttons to match\n* `:drag_only` - Only match drag events\n* `:click_only` - Only match click events\n* `:area` - Tuple of {x, y, width, height} to match position","ref":"Raxol.Core.Events.Subscription.html#subscribe_mouse/1-options","title":"Options - Raxol.Core.Events.Subscription.subscribe_mouse/1","type":"function"},{"doc":"subscribe_mouse(buttons: [:left, :right])\n    subscribe_mouse(area: {0, 0, 10, 10})","ref":"Raxol.Core.Events.Subscription.html#subscribe_mouse/1-example","title":"Example - Raxol.Core.Events.Subscription.subscribe_mouse/1","type":"function"},{"doc":"Subscribes to timer events with optional data matching.","ref":"Raxol.Core.Events.Subscription.html#subscribe_timer/1","title":"Raxol.Core.Events.Subscription.subscribe_timer/1","type":"function"},{"doc":"* `:match` - Pattern to match against timer data","ref":"Raxol.Core.Events.Subscription.html#subscribe_timer/1-options","title":"Options - Raxol.Core.Events.Subscription.subscribe_timer/1","type":"function"},{"doc":"subscribe_timer(match: :tick)","ref":"Raxol.Core.Events.Subscription.html#subscribe_timer/1-example","title":"Example - Raxol.Core.Events.Subscription.subscribe_timer/1","type":"function"},{"doc":"Subscribes to window events with optional action filters.","ref":"Raxol.Core.Events.Subscription.html#subscribe_window/1","title":"Raxol.Core.Events.Subscription.subscribe_window/1","type":"function"},{"doc":"* `:actions` - List of window actions to match (:resize, :focus, :blur)","ref":"Raxol.Core.Events.Subscription.html#subscribe_window/1-options","title":"Options - Raxol.Core.Events.Subscription.subscribe_window/1","type":"function"},{"doc":"subscribe_window(actions: [:resize])","ref":"Raxol.Core.Events.Subscription.html#subscribe_window/1-example","title":"Example - Raxol.Core.Events.Subscription.subscribe_window/1","type":"function"},{"doc":"","ref":"Raxol.Core.Events.Subscription.html#t:subscription_opts/0","title":"Raxol.Core.Events.Subscription.subscription_opts/0","type":"type"},{"doc":"","ref":"Raxol.Core.Events.Subscription.html#t:subscription_ref/0","title":"Raxol.Core.Events.Subscription.subscription_ref/0","type":"type"},{"doc":"Unsubscribes from events using the subscription reference.","ref":"Raxol.Core.Events.Subscription.html#unsubscribe/1","title":"Raxol.Core.Events.Subscription.unsubscribe/1","type":"function"},{"doc":"Unsubscribes from multiple subscriptions.","ref":"Raxol.Core.Events.Subscription.html#unsubscribe_all/1","title":"Raxol.Core.Events.Subscription.unsubscribe_all/1","type":"function"},{"doc":"Converts rrex_termbox v2.0.1 NIF events to Raxol.Core.Events.Event structs.\n\nThis module handles the translation from the low-level rrex_termbox event format\nto the Raxol event system format.","ref":"Raxol.Core.Events.TermboxConverter.html","title":"Raxol.Core.Events.TermboxConverter","type":"module"},{"doc":"Converts a rrex_termbox v2.0.1 event map to a Raxol Event struct.","ref":"Raxol.Core.Events.TermboxConverter.html#convert/1","title":"Raxol.Core.Events.TermboxConverter.convert/1","type":"function"},{"doc":"- event_map: The event map from rrex_termbox","ref":"Raxol.Core.Events.TermboxConverter.html#convert/1-parameters","title":"Parameters - Raxol.Core.Events.TermboxConverter.convert/1","type":"function"},{"doc":"- `{:ok, %Event{}}` if the conversion was successful\n- `:ignore` if the event should be ignored\n- `{:error, reason}` if the conversion failed","ref":"Raxol.Core.Events.TermboxConverter.html#convert/1-returns","title":"Returns - Raxol.Core.Events.TermboxConverter.convert/1","type":"function"},{"doc":"Focus management system for Raxol terminal UI applications.\n\nThis module provides utilities for managing focus between interactive components:\n- Tab-based keyboard navigation\n- Focus history tracking\n- Focus ring rendering\n- Screen reader announcements","ref":"Raxol.Core.FocusManager.html","title":"Raxol.Core.FocusManager","type":"module"},{"doc":"```elixir\n# Register focusable components in your view\nFocusManager.register_focusable(\"search_input\", 1)\nFocusManager.register_focusable(\"submit_button\", 2)\n\n# Initialize the focus manager with the first focusable element\nFocusManager.set_initial_focus(\"search_input\")\n```","ref":"Raxol.Core.FocusManager.html#module-usage","title":"Usage - Raxol.Core.FocusManager","type":"module"},{"doc":"Disable a focusable component, preventing it from receiving focus.","ref":"Raxol.Core.FocusManager.html#disable_component/1","title":"Raxol.Core.FocusManager.disable_component/1","type":"function"},{"doc":"iex> FocusManager.disable_component(\"submit_button\")\n    :ok","ref":"Raxol.Core.FocusManager.html#disable_component/1-examples","title":"Examples - Raxol.Core.FocusManager.disable_component/1","type":"function"},{"doc":"Enable a previously disabled focusable component.","ref":"Raxol.Core.FocusManager.html#enable_component/1","title":"Raxol.Core.FocusManager.enable_component/1","type":"function"},{"doc":"iex> FocusManager.enable_component(\"submit_button\")\n    :ok","ref":"Raxol.Core.FocusManager.html#enable_component/1-examples","title":"Examples - Raxol.Core.FocusManager.enable_component/1","type":"function"},{"doc":"Move focus to the next focusable element.","ref":"Raxol.Core.FocusManager.html#focus_next/1","title":"Raxol.Core.FocusManager.focus_next/1","type":"function"},{"doc":"* `:group` - Only navigate within this group (default: `nil` - use current group)\n* `:wrap` - Wrap around to first element when at the end (default: `true`)","ref":"Raxol.Core.FocusManager.html#focus_next/1-options","title":"Options - Raxol.Core.FocusManager.focus_next/1","type":"function"},{"doc":"iex> FocusManager.focus_next()\n    :ok\n\n    iex> FocusManager.focus_next(group: :form_actions)\n    :ok","ref":"Raxol.Core.FocusManager.html#focus_next/1-examples","title":"Examples - Raxol.Core.FocusManager.focus_next/1","type":"function"},{"doc":"Move focus to the previous focusable element.","ref":"Raxol.Core.FocusManager.html#focus_previous/1","title":"Raxol.Core.FocusManager.focus_previous/1","type":"function"},{"doc":"* `:group` - Only navigate within this group (default: `nil` - use current group)\n* `:wrap` - Wrap around to last element when at the beginning (default: `true`)","ref":"Raxol.Core.FocusManager.html#focus_previous/1-options","title":"Options - Raxol.Core.FocusManager.focus_previous/1","type":"function"},{"doc":"iex> FocusManager.focus_previous()\n    :ok","ref":"Raxol.Core.FocusManager.html#focus_previous/1-examples","title":"Examples - Raxol.Core.FocusManager.focus_previous/1","type":"function"},{"doc":"Alias for get_focused_element/0.","ref":"Raxol.Core.FocusManager.html#get_current_focus/0","title":"Raxol.Core.FocusManager.get_current_focus/0","type":"function"},{"doc":"Gets the focus history.","ref":"Raxol.Core.FocusManager.html#get_focus_history/0","title":"Raxol.Core.FocusManager.get_focus_history/0","type":"function"},{"doc":"Get the ID of the currently focused element.","ref":"Raxol.Core.FocusManager.html#get_focused_element/0","title":"Raxol.Core.FocusManager.get_focused_element/0","type":"function"},{"doc":"iex> FocusManager.set_initial_focus(\"my_button\")\n    iex> FocusManager.get_focused_element()\n    \"my_button\"","ref":"Raxol.Core.FocusManager.html#get_focused_element/0-examples","title":"Examples - Raxol.Core.FocusManager.get_focused_element/0","type":"function"},{"doc":"Get the next focusable element after the given one.\n(Placeholder implementation - mirrors focus_next logic)","ref":"Raxol.Core.FocusManager.html#get_next_focusable/1","title":"Raxol.Core.FocusManager.get_next_focusable/1","type":"function"},{"doc":"Get the previous focusable element before the given one.\nMirrors the logic of `get_next_focusable/1` but searches backwards.","ref":"Raxol.Core.FocusManager.html#get_previous_focusable/1","title":"Raxol.Core.FocusManager.get_previous_focusable/1","type":"function"},{"doc":"Check if a component has focus.","ref":"Raxol.Core.FocusManager.html#has_focus?/1","title":"Raxol.Core.FocusManager.has_focus?/1","type":"function"},{"doc":"iex> FocusManager.has_focus?(\"search_input\")\n    true","ref":"Raxol.Core.FocusManager.html#has_focus?/1-examples","title":"Examples - Raxol.Core.FocusManager.has_focus?/1","type":"function"},{"doc":"Register a handler function to be called when focus changes.\n\nThe handler function should accept two arguments: `old_focus` and `new_focus`.\n(Placeholder implementation)","ref":"Raxol.Core.FocusManager.html#register_focus_change_handler/1","title":"Raxol.Core.FocusManager.register_focus_change_handler/1","type":"function"},{"doc":"Register a focusable component with the focus manager.","ref":"Raxol.Core.FocusManager.html#register_focusable/3","title":"Raxol.Core.FocusManager.register_focusable/3","type":"function"},{"doc":"* `component_id` - Unique identifier for the component\n* `tab_index` - Tab order index (lower numbers are focused first)\n* `opts` - Additional options","ref":"Raxol.Core.FocusManager.html#register_focusable/3-parameters","title":"Parameters - Raxol.Core.FocusManager.register_focusable/3","type":"function"},{"doc":"* `:group` - Focus group name for grouped navigation (default: `:default`)\n* `:disabled` - Whether the component is initially disabled (default: `false`)\n* `:announce` - Announcement text for screen readers when focused (default: `nil`)","ref":"Raxol.Core.FocusManager.html#register_focusable/3-options","title":"Options - Raxol.Core.FocusManager.register_focusable/3","type":"function"},{"doc":"iex> FocusManager.register_focusable(\"search_input\", 1)\n    :ok\n\n    iex> FocusManager.register_focusable(\"submit_button\", 2, group: :form_actions)\n    :ok","ref":"Raxol.Core.FocusManager.html#register_focusable/3-examples","title":"Examples - Raxol.Core.FocusManager.register_focusable/3","type":"function"},{"doc":"Return to the previously focused element.","ref":"Raxol.Core.FocusManager.html#return_to_previous/0","title":"Raxol.Core.FocusManager.return_to_previous/0","type":"function"},{"doc":"iex> FocusManager.return_to_previous()\n    :ok","ref":"Raxol.Core.FocusManager.html#return_to_previous/0-examples","title":"Examples - Raxol.Core.FocusManager.return_to_previous/0","type":"function"},{"doc":"Set focus to a specific component.","ref":"Raxol.Core.FocusManager.html#set_focus/1","title":"Raxol.Core.FocusManager.set_focus/1","type":"function"},{"doc":"iex> FocusManager.set_focus(\"submit_button\")\n    :ok","ref":"Raxol.Core.FocusManager.html#set_focus/1-examples","title":"Examples - Raxol.Core.FocusManager.set_focus/1","type":"function"},{"doc":"Set the initial focus to a specific component.","ref":"Raxol.Core.FocusManager.html#set_initial_focus/1","title":"Raxol.Core.FocusManager.set_initial_focus/1","type":"function"},{"doc":"iex> FocusManager.set_initial_focus(\"search_input\")\n    :ok","ref":"Raxol.Core.FocusManager.html#set_initial_focus/1-examples","title":"Examples - Raxol.Core.FocusManager.set_initial_focus/1","type":"function"},{"doc":"Unregister a focus change handler function.\n(Placeholder implementation)","ref":"Raxol.Core.FocusManager.html#unregister_focus_change_handler/1","title":"Raxol.Core.FocusManager.unregister_focus_change_handler/1","type":"function"},{"doc":"Unregister a focusable component.","ref":"Raxol.Core.FocusManager.html#unregister_focusable/1","title":"Raxol.Core.FocusManager.unregister_focusable/1","type":"function"},{"doc":"iex> FocusManager.unregister_focusable(\"search_input\")\n    :ok","ref":"Raxol.Core.FocusManager.html#unregister_focusable/1-examples","title":"Examples - Raxol.Core.FocusManager.unregister_focusable/1","type":"function"},{"doc":"Defines the behaviour for focus management services.","ref":"Raxol.Core.FocusManager.Behaviour.html","title":"Raxol.Core.FocusManager.Behaviour","type":"behaviour"},{"doc":"Disables a focusable component.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:disable_component/1","title":"Raxol.Core.FocusManager.Behaviour.disable_component/1","type":"callback"},{"doc":"Enables a previously disabled focusable component.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:enable_component/1","title":"Raxol.Core.FocusManager.Behaviour.enable_component/1","type":"callback"},{"doc":"Moves focus to the next focusable element.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:focus_next/1","title":"Raxol.Core.FocusManager.Behaviour.focus_next/1","type":"callback"},{"doc":"Moves focus to the previous focusable element.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:focus_previous/1","title":"Raxol.Core.FocusManager.Behaviour.focus_previous/1","type":"callback"},{"doc":"Alias for get_focused_element/0.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:get_current_focus/0","title":"Raxol.Core.FocusManager.Behaviour.get_current_focus/0","type":"callback"},{"doc":"Gets the focus history.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:get_focus_history/0","title":"Raxol.Core.FocusManager.Behaviour.get_focus_history/0","type":"callback"},{"doc":"Gets the ID of the currently focused element.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:get_focused_element/0","title":"Raxol.Core.FocusManager.Behaviour.get_focused_element/0","type":"callback"},{"doc":"Gets the next focusable element after the given one.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:get_next_focusable/1","title":"Raxol.Core.FocusManager.Behaviour.get_next_focusable/1","type":"callback"},{"doc":"Gets the previous focusable element before the given one.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:get_previous_focusable/1","title":"Raxol.Core.FocusManager.Behaviour.get_previous_focusable/1","type":"callback"},{"doc":"Checks if a component has focus.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:has_focus?/1","title":"Raxol.Core.FocusManager.Behaviour.has_focus?/1","type":"callback"},{"doc":"Registers a handler function to be called when focus changes.\nThe handler function should accept two arguments: `old_focus` and `new_focus`.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:register_focus_change_handler/1","title":"Raxol.Core.FocusManager.Behaviour.register_focus_change_handler/1","type":"callback"},{"doc":"Registers a focusable component.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:register_focusable/3","title":"Raxol.Core.FocusManager.Behaviour.register_focusable/3","type":"callback"},{"doc":"Returns to the previously focused element.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:return_to_previous/0","title":"Raxol.Core.FocusManager.Behaviour.return_to_previous/0","type":"callback"},{"doc":"Sets focus to a specific component.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:set_focus/1","title":"Raxol.Core.FocusManager.Behaviour.set_focus/1","type":"callback"},{"doc":"Sets the initial focus to a specific component.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:set_initial_focus/1","title":"Raxol.Core.FocusManager.Behaviour.set_initial_focus/1","type":"callback"},{"doc":"Unregisters a focus change handler function.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:unregister_focus_change_handler/1","title":"Raxol.Core.FocusManager.Behaviour.unregister_focus_change_handler/1","type":"callback"},{"doc":"Unregisters a focusable component.","ref":"Raxol.Core.FocusManager.Behaviour.html#c:unregister_focusable/1","title":"Raxol.Core.FocusManager.Behaviour.unregister_focusable/1","type":"callback"},{"doc":"Internationalization framework for Raxol terminal UI applications.\n\nThis module provides comprehensive internationalization (i18n) support:\n- Translation of UI text to multiple languages\n- Right-to-left (RTL) language support\n- Integration with accessibility features\n- Language detection and selection\n- Translation fallbacks\n- Dynamic language switching\n\nThe framework works seamlessly with the accessibility module to provide\nscreen reader announcements in the user's preferred language.","ref":"Raxol.Core.I18n.html","title":"Raxol.Core.I18n","type":"module"},{"doc":"```elixir\n# Initialize with default locale\nI18n.init(default_locale: \"en\")\n\n# Get a translated string\nmessage = I18n.t(\"welcome_message\")\n\n# Get a translated string with variables\ngreeting = I18n.t(\"hello_name\", %{name: \"John\"})\n\n# Switch to a different locale\nI18n.set_locale(\"fr\")\n\n# Check if the current locale is RTL\nis_rtl = I18n.rtl?()\n```","ref":"Raxol.Core.I18n.html#module-usage","title":"Usage - Raxol.Core.I18n","type":"module"},{"doc":"Format a screen reader announcement in the current locale.\n\nThis integrates with the accessibility module to provide\nscreen reader announcements in the user's preferred language.","ref":"Raxol.Core.I18n.html#announce/3","title":"Raxol.Core.I18n.announce/3","type":"function"},{"doc":"* `key` - The translation key for the announcement\n* `bindings` - Map of variable bindings (default: %{})\n* `opts` - Additional options","ref":"Raxol.Core.I18n.html#announce/3-parameters","title":"Parameters - Raxol.Core.I18n.announce/3","type":"function"},{"doc":"iex> I18n.announce(\"file_saved\")\n    :ok\n\n    iex> I18n.announce(\"item_selected\", %{item: \"Document\"})\n    :ok","ref":"Raxol.Core.I18n.html#announce/3-examples","title":"Examples - Raxol.Core.I18n.announce/3","type":"function"},{"doc":"Get a list of available locales.","ref":"Raxol.Core.I18n.html#available_locales/0","title":"Raxol.Core.I18n.available_locales/0","type":"function"},{"doc":"iex> I18n.available_locales()\n    [\"en\", \"fr\", \"es\"]","ref":"Raxol.Core.I18n.html#available_locales/0-examples","title":"Examples - Raxol.Core.I18n.available_locales/0","type":"function"},{"doc":"Get the current locale.","ref":"Raxol.Core.I18n.html#get_locale/0","title":"Raxol.Core.I18n.get_locale/0","type":"function"},{"doc":"iex> I18n.get_locale()\n    \"en\"","ref":"Raxol.Core.I18n.html#get_locale/0-examples","title":"Examples - Raxol.Core.I18n.get_locale/0","type":"function"},{"doc":"Handle locale changed events.","ref":"Raxol.Core.I18n.html#handle_locale_changed/1","title":"Raxol.Core.I18n.handle_locale_changed/1","type":"function"},{"doc":"Initialize the internationalization system.","ref":"Raxol.Core.I18n.html#init/1","title":"Raxol.Core.I18n.init/1","type":"function"},{"doc":"* `:default_locale` - The default locale to use (default: \"en\")\n* `:available_locales` - List of available locales (default: [\"en\"])\n* `:fallback_locale` - Fallback locale when translation is missing (default: \"en\")\n* `:translations_dir` - Directory containing translation files (default: \"./priv/locales\")","ref":"Raxol.Core.I18n.html#init/1-options","title":"Options - Raxol.Core.I18n.init/1","type":"function"},{"doc":"iex> I18n.init()\n    :ok\n\n    iex> I18n.init(default_locale: \"fr\", available_locales: [\"en\", \"fr\", \"es\"])\n    :ok","ref":"Raxol.Core.I18n.html#init/1-examples","title":"Examples - Raxol.Core.I18n.init/1","type":"function"},{"doc":"Register translations for a specific locale.","ref":"Raxol.Core.I18n.html#register_translations/2","title":"Raxol.Core.I18n.register_translations/2","type":"function"},{"doc":"* `locale` - The locale for these translations\n* `translations` - Map of translation keys to translated strings","ref":"Raxol.Core.I18n.html#register_translations/2-parameters","title":"Parameters - Raxol.Core.I18n.register_translations/2","type":"function"},{"doc":"iex> I18n.register_translations(\"fr\", %{\n    ...>   \"welcome_message\" => \"Bienvenue dans l'application\",\n    ...>   \"hello_name\" => \"Bonjour, {{name}}!\"\n    ...> })\n    :ok","ref":"Raxol.Core.I18n.html#register_translations/2-examples","title":"Examples - Raxol.Core.I18n.register_translations/2","type":"function"},{"doc":"Check if the current locale is right-to-left (RTL).","ref":"Raxol.Core.I18n.html#rtl?/1","title":"Raxol.Core.I18n.rtl?/1","type":"function"},{"doc":"* `:locale` - Check a specific locale instead of the current one","ref":"Raxol.Core.I18n.html#rtl?/1-options","title":"Options - Raxol.Core.I18n.rtl?/1","type":"function"},{"doc":"iex> I18n.rtl?()\n    false\n\n    iex> I18n.rtl?(locale: \"ar\")\n    true","ref":"Raxol.Core.I18n.html#rtl?/1-examples","title":"Examples - Raxol.Core.I18n.rtl?/1","type":"function"},{"doc":"Set the current locale.","ref":"Raxol.Core.I18n.html#set_locale/1","title":"Raxol.Core.I18n.set_locale/1","type":"function"},{"doc":"* `locale` - The locale to set as current","ref":"Raxol.Core.I18n.html#set_locale/1-parameters","title":"Parameters - Raxol.Core.I18n.set_locale/1","type":"function"},{"doc":"iex> I18n.set_locale(\"fr\")\n    :ok\n\n    iex> I18n.set_locale(\"invalid\")\n    {:error, :invalid_locale}","ref":"Raxol.Core.I18n.html#set_locale/1-examples","title":"Examples - Raxol.Core.I18n.set_locale/1","type":"function"},{"doc":"Get a translated string for the current locale.","ref":"Raxol.Core.I18n.html#t/3","title":"Raxol.Core.I18n.t/3","type":"function"},{"doc":"* `key` - The translation key\n* `bindings` - Map of variable bindings (default: %{})\n* `opts` - Additional options","ref":"Raxol.Core.I18n.html#t/3-parameters","title":"Parameters - Raxol.Core.I18n.t/3","type":"function"},{"doc":"* `:locale` - Override the current locale\n* `:default` - Default text if translation is missing","ref":"Raxol.Core.I18n.html#t/3-options","title":"Options - Raxol.Core.I18n.t/3","type":"function"},{"doc":"iex> I18n.t(\"welcome_message\")\n    \"Welcome to the application\"\n\n    iex> I18n.t(\"hello_name\", %{name: \"John\"})\n    \"Hello, John!\"\n\n    iex> I18n.t(\"missing_key\", %{}, default: \"Missing translation\")\n    \"Missing translation\"","ref":"Raxol.Core.I18n.html#t/3-examples","title":"Examples - Raxol.Core.I18n.t/3","type":"function"},{"doc":"Provides functions for generating unique identifiers.","ref":"Raxol.Core.ID.html","title":"Raxol.Core.ID","type":"module"},{"doc":"Generates a unique string identifier.\n\nUses `System.unique_integer([:positive])` and converts it to a string.\nWhile unique within the runtime, these are not guaranteed universally unique like UUIDs.","ref":"Raxol.Core.ID.html#generate/0","title":"Raxol.Core.ID.generate/0","type":"function"},{"doc":"Keyboard navigation handler for Raxol terminal UI applications.\n\nThis module integrates with the FocusManager to provide keyboard navigation between\ninteractive components using standard key bindings:\n\n- Tab: Move to next focusable element\n- Shift+Tab: Move to previous focusable element\n- Arrow keys: Navigate between elements in a component group\n- Escape: Return to previous focus or dismiss dialogs\n- Enter/Space: Activate currently focused element","ref":"Raxol.Core.KeyboardNavigator.html","title":"Raxol.Core.KeyboardNavigator","type":"module"},{"doc":"```elixir\n# Initialize keyboard navigation in your application\nKeyboardNavigator.init()\n\n# Customize keybindings\nKeyboardNavigator.configure(next_key: :right, previous_key: :left)\n```","ref":"Raxol.Core.KeyboardNavigator.html#module-usage","title":"Usage - Raxol.Core.KeyboardNavigator","type":"module"},{"doc":"Configure keyboard navigation behavior.","ref":"Raxol.Core.KeyboardNavigator.html#configure/1","title":"Raxol.Core.KeyboardNavigator.configure/1","type":"function"},{"doc":"* `:next_key` - Key to move to next element (default: `:tab`)\n* `:previous_key` - Key to move to previous element (default: `:tab` with shift)\n* `:activate_keys` - Keys to activate elements (default: `[:enter, :space]`)\n* `:dismiss_key` - Key to dismiss or go back (default: `:escape`)\n* `:arrow_navigation` - Enable arrow key navigation (default: `true`)\n* `:vim_keys` - Enable vim-style navigation with h,j,k,l (default: `false`)\n* `:group_navigation` - Enable group-based navigation (default: `true`)\n* `:spatial_navigation` - Enable spatial navigation for grid layouts (default: `false`)\n* `:tab_navigation` - Enable tab-based navigation (default: `true`)","ref":"Raxol.Core.KeyboardNavigator.html#configure/1-options","title":"Options - Raxol.Core.KeyboardNavigator.configure/1","type":"function"},{"doc":"iex> KeyboardNavigator.configure(vim_keys: true)\n    :ok","ref":"Raxol.Core.KeyboardNavigator.html#configure/1-examples","title":"Examples - Raxol.Core.KeyboardNavigator.configure/1","type":"function"},{"doc":"Define explicit navigation paths between components.\n\nThis allows customizing navigation beyond spatial or tab order.","ref":"Raxol.Core.KeyboardNavigator.html#define_navigation_path/3","title":"Raxol.Core.KeyboardNavigator.define_navigation_path/3","type":"function"},{"doc":"* `from_id` - Component ID to navigate from\n* `direction` - Navigation direction (`:up`, `:down`, `:left`, `:right`)\n* `to_id` - Component ID to navigate to","ref":"Raxol.Core.KeyboardNavigator.html#define_navigation_path/3-parameters","title":"Parameters - Raxol.Core.KeyboardNavigator.define_navigation_path/3","type":"function"},{"doc":"iex> KeyboardNavigator.define_navigation_path(\"search_input\", :down, \"submit_button\")\n    :ok","ref":"Raxol.Core.KeyboardNavigator.html#define_navigation_path/3-examples","title":"Examples - Raxol.Core.KeyboardNavigator.define_navigation_path/3","type":"function"},{"doc":"Handle keyboard events for navigation.\n\nThis function is called by the EventManager when keyboard events occur.","ref":"Raxol.Core.KeyboardNavigator.html#handle_keyboard_event/1","title":"Raxol.Core.KeyboardNavigator.handle_keyboard_event/1","type":"function"},{"doc":"* `event` - The keyboard event to handle","ref":"Raxol.Core.KeyboardNavigator.html#handle_keyboard_event/1-parameters","title":"Parameters - Raxol.Core.KeyboardNavigator.handle_keyboard_event/1","type":"function"},{"doc":"* `:handled` - If the event was handled by the navigator\n* `:unhandled` - If the event was not handled","ref":"Raxol.Core.KeyboardNavigator.html#handle_keyboard_event/1-returns","title":"Returns - Raxol.Core.KeyboardNavigator.handle_keyboard_event/1","type":"function"},{"doc":"Initialize the keyboard navigator.\n\nThis registers event handlers for keyboard navigation.","ref":"Raxol.Core.KeyboardNavigator.html#init/0","title":"Raxol.Core.KeyboardNavigator.init/0","type":"function"},{"doc":"iex> KeyboardNavigator.init()\n    :ok","ref":"Raxol.Core.KeyboardNavigator.html#init/0-examples","title":"Examples - Raxol.Core.KeyboardNavigator.init/0","type":"function"},{"doc":"Register component positions for spatial navigation.\n\nThis allows arrow keys to navigate components based on their physical layout.","ref":"Raxol.Core.KeyboardNavigator.html#register_component_position/5","title":"Raxol.Core.KeyboardNavigator.register_component_position/5","type":"function"},{"doc":"* `component_id` - Unique identifier for the component\n* `x` - X coordinate\n* `y` - Y coordinate\n* `width` - Width of the component\n* `height` - Height of the component","ref":"Raxol.Core.KeyboardNavigator.html#register_component_position/5-parameters","title":"Parameters - Raxol.Core.KeyboardNavigator.register_component_position/5","type":"function"},{"doc":"iex> KeyboardNavigator.register_component_position(\"search_input\", 10, 5, 30, 3)\n    :ok","ref":"Raxol.Core.KeyboardNavigator.html#register_component_position/5-examples","title":"Examples - Raxol.Core.KeyboardNavigator.register_component_position/5","type":"function"},{"doc":"Register a custom shortcut handler.","ref":"Raxol.Core.KeyboardNavigator.html#register_shortcut/3","title":"Raxol.Core.KeyboardNavigator.register_shortcut/3","type":"function"},{"doc":"* `key` - The key to handle\n* `modifiers` - List of modifier keys (e.g., [:ctrl, :shift])\n* `handler` - Function to call when shortcut is pressed","ref":"Raxol.Core.KeyboardNavigator.html#register_shortcut/3-parameters","title":"Parameters - Raxol.Core.KeyboardNavigator.register_shortcut/3","type":"function"},{"doc":"iex> KeyboardNavigator.register_shortcut(:f1, [], &show_help/0)\n    :ok","ref":"Raxol.Core.KeyboardNavigator.html#register_shortcut/3-examples","title":"Examples - Raxol.Core.KeyboardNavigator.register_shortcut/3","type":"function"},{"doc":"Keyboard shortcuts manager for Raxol applications.\n\nThis module provides functionality to register, manage, and handle keyboard shortcuts\nthroughout the application. It integrates with the accessibility features to provide\nbetter keyboard navigation and interaction.","ref":"Raxol.Core.KeyboardShortcuts.html","title":"Raxol.Core.KeyboardShortcuts","type":"module"},{"doc":"* Register global and context-specific shortcuts\n* Handle keyboard shortcuts with custom callbacks\n* Display available shortcuts based on current context\n* Integration with accessibility features\n* Support for shortcut combinations (Ctrl, Alt, Shift modifiers)","ref":"Raxol.Core.KeyboardShortcuts.html#module-features","title":"Features - Raxol.Core.KeyboardShortcuts","type":"module"},{"doc":"# Initialize the keyboard shortcuts manager\n    KeyboardShortcuts.init()\n\n    # Register a global shortcut\n    KeyboardShortcuts.register_shortcut(\"Ctrl+F\", :search, fn ->\n      # Search functionality\n      search_content()\n    end)\n\n    # Register a context-specific shortcut\n    KeyboardShortcuts.register_shortcut(\"Alt+S\", :save, fn ->\n      # Save functionality\n      save_document()\n    end, context: :editor)\n\n    # Get all available shortcuts for current context\n    shortcuts = KeyboardShortcuts.get_shortcuts_for_context(:editor)\n\n    # Display help for available shortcuts\n    KeyboardShortcuts.show_shortcuts_help()","ref":"Raxol.Core.KeyboardShortcuts.html#module-examples","title":"Examples - Raxol.Core.KeyboardShortcuts","type":"module"},{"doc":"Clean up the keyboard shortcuts manager.\n\nThis function cleans up any resources used by the keyboard shortcuts manager\nand unregisters event handlers.","ref":"Raxol.Core.KeyboardShortcuts.html#cleanup/0","title":"Raxol.Core.KeyboardShortcuts.cleanup/0","type":"function"},{"doc":"iex> KeyboardShortcuts.cleanup()\n    :ok","ref":"Raxol.Core.KeyboardShortcuts.html#cleanup/0-examples","title":"Examples - Raxol.Core.KeyboardShortcuts.cleanup/0","type":"function"},{"doc":"Get the current active context for shortcuts.","ref":"Raxol.Core.KeyboardShortcuts.html#get_current_context/0","title":"Raxol.Core.KeyboardShortcuts.get_current_context/0","type":"function"},{"doc":"iex> KeyboardShortcuts.get_current_context()\n    :editor","ref":"Raxol.Core.KeyboardShortcuts.html#get_current_context/0-examples","title":"Examples - Raxol.Core.KeyboardShortcuts.get_current_context/0","type":"function"},{"doc":"Get all shortcuts for a specific context.","ref":"Raxol.Core.KeyboardShortcuts.html#get_shortcuts_for_context/1","title":"Raxol.Core.KeyboardShortcuts.get_shortcuts_for_context/1","type":"function"},{"doc":"* `context` - The context to get shortcuts for (default: current context)","ref":"Raxol.Core.KeyboardShortcuts.html#get_shortcuts_for_context/1-parameters","title":"Parameters - Raxol.Core.KeyboardShortcuts.get_shortcuts_for_context/1","type":"function"},{"doc":"iex> KeyboardShortcuts.get_shortcuts_for_context(:editor)\n    [\n      %{name: :save, key_combo: \"Ctrl+S\", description: \"Save document\"},\n      %{name: :find, key_combo: \"Ctrl+F\", description: \"Find in document\"}\n    ]","ref":"Raxol.Core.KeyboardShortcuts.html#get_shortcuts_for_context/1-examples","title":"Examples - Raxol.Core.KeyboardShortcuts.get_shortcuts_for_context/1","type":"function"},{"doc":"Initialize the keyboard shortcuts manager.\n\nThis function sets up the necessary state for managing keyboard shortcuts\nand registers event handlers for keyboard events.","ref":"Raxol.Core.KeyboardShortcuts.html#init/0","title":"Raxol.Core.KeyboardShortcuts.init/0","type":"function"},{"doc":"iex> KeyboardShortcuts.init()\n    :ok","ref":"Raxol.Core.KeyboardShortcuts.html#init/0-examples","title":"Examples - Raxol.Core.KeyboardShortcuts.init/0","type":"function"},{"doc":"Register a keyboard shortcut with a callback function.","ref":"Raxol.Core.KeyboardShortcuts.html#register_shortcut/4","title":"Raxol.Core.KeyboardShortcuts.register_shortcut/4","type":"function"},{"doc":"* `shortcut` - The keyboard shortcut string (e.g., \"Ctrl+S\", \"Alt+F4\")\n* `name` - A unique identifier for the shortcut (atom or string)\n* `callback` - A function to be called when the shortcut is triggered\n* `opts` - Options for the shortcut","ref":"Raxol.Core.KeyboardShortcuts.html#register_shortcut/4-parameters","title":"Parameters - Raxol.Core.KeyboardShortcuts.register_shortcut/4","type":"function"},{"doc":"* `:context` - The context in which this shortcut is active (default: `:global`)\n* `:description` - A description of what the shortcut does\n* `:priority` - Priority level (`:high`, `:medium`, `:low`), affects precedence","ref":"Raxol.Core.KeyboardShortcuts.html#register_shortcut/4-options","title":"Options - Raxol.Core.KeyboardShortcuts.register_shortcut/4","type":"function"},{"doc":"iex> KeyboardShortcuts.register_shortcut(\"Ctrl+S\", :save, fn -> save_document() end)\n    :ok\n\n    iex> KeyboardShortcuts.register_shortcut(\"Alt+F\", :file_menu, fn -> open_file_menu() end,\n    ...>   context: :main_menu, description: \"Open File menu\")\n    :ok","ref":"Raxol.Core.KeyboardShortcuts.html#register_shortcut/4-examples","title":"Examples - Raxol.Core.KeyboardShortcuts.register_shortcut/4","type":"function"},{"doc":"Set the current context for shortcuts.\n\nThis affects which shortcuts are active and will be triggered by keyboard events.","ref":"Raxol.Core.KeyboardShortcuts.html#set_context/1","title":"Raxol.Core.KeyboardShortcuts.set_context/1","type":"function"},{"doc":"* `context` - The context to set as active","ref":"Raxol.Core.KeyboardShortcuts.html#set_context/1-parameters","title":"Parameters - Raxol.Core.KeyboardShortcuts.set_context/1","type":"function"},{"doc":"iex> KeyboardShortcuts.set_context(:editor)\n    :ok\n\n    iex> KeyboardShortcuts.set_context(:file_browser)\n    :ok","ref":"Raxol.Core.KeyboardShortcuts.html#set_context/1-examples","title":"Examples - Raxol.Core.KeyboardShortcuts.set_context/1","type":"function"},{"doc":"Show help for available keyboard shortcuts for the current context.\n\nReturns a formatted string of available shortcuts. This version matches the behaviour and can be called without arguments.","ref":"Raxol.Core.KeyboardShortcuts.html#show_shortcuts_help/0","title":"Raxol.Core.KeyboardShortcuts.show_shortcuts_help/0","type":"function"},{"doc":"iex> KeyboardShortcuts.show_shortcuts_help()\n    {:ok, help_string}","ref":"Raxol.Core.KeyboardShortcuts.html#show_shortcuts_help/0-examples","title":"Examples - Raxol.Core.KeyboardShortcuts.show_shortcuts_help/0","type":"function"},{"doc":"Display help for available shortcuts.\n\nThis function generates a help message for all shortcuts available in the current context\nand announces it through the accessibility system if enabled.","ref":"Raxol.Core.KeyboardShortcuts.html#show_shortcuts_help/1","title":"Raxol.Core.KeyboardShortcuts.show_shortcuts_help/1","type":"function"},{"doc":"* `user_preferences_pid_or_name` - The PID or name of the user preferences process","ref":"Raxol.Core.KeyboardShortcuts.html#show_shortcuts_help/1-parameters","title":"Parameters - Raxol.Core.KeyboardShortcuts.show_shortcuts_help/1","type":"function"},{"doc":"iex> KeyboardShortcuts.show_shortcuts_help(self())\n    :ok","ref":"Raxol.Core.KeyboardShortcuts.html#show_shortcuts_help/1-examples","title":"Examples - Raxol.Core.KeyboardShortcuts.show_shortcuts_help/1","type":"function"},{"doc":"Trigger a shortcut programmatically.","ref":"Raxol.Core.KeyboardShortcuts.html#trigger_shortcut/2","title":"Raxol.Core.KeyboardShortcuts.trigger_shortcut/2","type":"function"},{"doc":"* `name` - The unique identifier for the shortcut\n* `context` - The context in which the shortcut was registered (default: current context)","ref":"Raxol.Core.KeyboardShortcuts.html#trigger_shortcut/2-parameters","title":"Parameters - Raxol.Core.KeyboardShortcuts.trigger_shortcut/2","type":"function"},{"doc":"iex> KeyboardShortcuts.trigger_shortcut(:save)\n    :ok\n\n    iex> KeyboardShortcuts.trigger_shortcut(:file_menu, :main_menu)\n    :ok","ref":"Raxol.Core.KeyboardShortcuts.html#trigger_shortcut/2-examples","title":"Examples - Raxol.Core.KeyboardShortcuts.trigger_shortcut/2","type":"function"},{"doc":"Unregister a keyboard shortcut.","ref":"Raxol.Core.KeyboardShortcuts.html#unregister_shortcut/2","title":"Raxol.Core.KeyboardShortcuts.unregister_shortcut/2","type":"function"},{"doc":"* `name` - The unique identifier for the shortcut\n* `context` - The context in which the shortcut was registered (default: `:global`)","ref":"Raxol.Core.KeyboardShortcuts.html#unregister_shortcut/2-parameters","title":"Parameters - Raxol.Core.KeyboardShortcuts.unregister_shortcut/2","type":"function"},{"doc":"iex> KeyboardShortcuts.unregister_shortcut(:save)\n    :ok\n\n    iex> KeyboardShortcuts.unregister_shortcut(:file_menu, :main_menu)\n    :ok","ref":"Raxol.Core.KeyboardShortcuts.html#unregister_shortcut/2-examples","title":"Examples - Raxol.Core.KeyboardShortcuts.unregister_shortcut/2","type":"function"},{"doc":"Behaviour for the KeyboardShortcuts module.\nThis allows for mocking the KeyboardShortcuts module in tests.","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html","title":"Raxol.Core.KeyboardShortcutsBehaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html#c:cleanup/0","title":"Raxol.Core.KeyboardShortcutsBehaviour.cleanup/0","type":"callback"},{"doc":"","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html#c:get_current_context/0","title":"Raxol.Core.KeyboardShortcutsBehaviour.get_current_context/0","type":"callback"},{"doc":"","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html#c:get_shortcuts_for_context/1","title":"Raxol.Core.KeyboardShortcutsBehaviour.get_shortcuts_for_context/1","type":"callback"},{"doc":"","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html#c:handle_keyboard_event/1","title":"Raxol.Core.KeyboardShortcutsBehaviour.handle_keyboard_event/1","type":"callback"},{"doc":"","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html#c:init/0","title":"Raxol.Core.KeyboardShortcutsBehaviour.init/0","type":"callback"},{"doc":"","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html#c:register_shortcut/4","title":"Raxol.Core.KeyboardShortcutsBehaviour.register_shortcut/4","type":"callback"},{"doc":"","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html#c:set_context/1","title":"Raxol.Core.KeyboardShortcutsBehaviour.set_context/1","type":"callback"},{"doc":"","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html#t:shortcut/0","title":"Raxol.Core.KeyboardShortcutsBehaviour.shortcut/0","type":"type"},{"doc":"","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html#t:shortcut_callback/0","title":"Raxol.Core.KeyboardShortcutsBehaviour.shortcut_callback/0","type":"type"},{"doc":"","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html#t:shortcut_context/0","title":"Raxol.Core.KeyboardShortcutsBehaviour.shortcut_context/0","type":"type"},{"doc":"","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html#t:shortcut_name/0","title":"Raxol.Core.KeyboardShortcutsBehaviour.shortcut_name/0","type":"type"},{"doc":"","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html#t:shortcut_opts/0","title":"Raxol.Core.KeyboardShortcutsBehaviour.shortcut_opts/0","type":"type"},{"doc":"","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html#c:show_shortcuts_help/1","title":"Raxol.Core.KeyboardShortcutsBehaviour.show_shortcuts_help/1","type":"callback"},{"doc":"","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html#c:trigger_shortcut/2","title":"Raxol.Core.KeyboardShortcutsBehaviour.trigger_shortcut/2","type":"callback"},{"doc":"","ref":"Raxol.Core.KeyboardShortcutsBehaviour.html#c:unregister_shortcut/2","title":"Raxol.Core.KeyboardShortcutsBehaviour.unregister_shortcut/2","type":"callback"},{"doc":"Metric aggregation system for the Raxol metrics.\n\nThis module handles:\n- Metric aggregation by time windows\n- Statistical calculations (mean, median, percentiles)\n- Metric grouping and categorization\n- Aggregation rules and policies\n- Real-time aggregation updates","ref":"Raxol.Core.Metrics.Aggregator.html","title":"Raxol.Core.Metrics.Aggregator","type":"module"},{"doc":"Adds a new aggregation rule.","ref":"Raxol.Core.Metrics.Aggregator.html#add_rule/1","title":"Raxol.Core.Metrics.Aggregator.add_rule/1","type":"function"},{"doc":"","ref":"Raxol.Core.Metrics.Aggregator.html#t:aggregation_rule/0","title":"Raxol.Core.Metrics.Aggregator.aggregation_rule/0","type":"type"},{"doc":"","ref":"Raxol.Core.Metrics.Aggregator.html#t:aggregation_type/0","title":"Raxol.Core.Metrics.Aggregator.aggregation_type/0","type":"type"},{"doc":"Calculates an aggregation of values using the specified method.","ref":"Raxol.Core.Metrics.Aggregator.html#calculate_aggregation/2","title":"Raxol.Core.Metrics.Aggregator.calculate_aggregation/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Metrics.Aggregator.html#child_spec/1","title":"Raxol.Core.Metrics.Aggregator.child_spec/1","type":"function"},{"doc":"Gets aggregated metrics for a specific rule.","ref":"Raxol.Core.Metrics.Aggregator.html#get_aggregated_metrics/1","title":"Raxol.Core.Metrics.Aggregator.get_aggregated_metrics/1","type":"function"},{"doc":"Gets all aggregation rules.","ref":"Raxol.Core.Metrics.Aggregator.html#get_rules/0","title":"Raxol.Core.Metrics.Aggregator.get_rules/0","type":"function"},{"doc":"Starts the metric aggregator.","ref":"Raxol.Core.Metrics.Aggregator.html#start_link/1","title":"Raxol.Core.Metrics.Aggregator.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Core.Metrics.Aggregator.html#t:time_window/0","title":"Raxol.Core.Metrics.Aggregator.time_window/0","type":"type"},{"doc":"Updates aggregation for a specific rule.","ref":"Raxol.Core.Metrics.Aggregator.html#update_aggregation/1","title":"Raxol.Core.Metrics.Aggregator.update_aggregation/1","type":"function"},{"doc":"Alert management system for the Raxol metrics.\n\nThis module handles:\n- Alert rule definition and management\n- Metric threshold monitoring\n- Alert state tracking\n- Alert notifications\n- Alert history","ref":"Raxol.Core.Metrics.AlertManager.html","title":"Raxol.Core.Metrics.AlertManager","type":"module"},{"doc":"Acknowledges an alert.","ref":"Raxol.Core.Metrics.AlertManager.html#acknowledge_alert/1","title":"Raxol.Core.Metrics.AlertManager.acknowledge_alert/1","type":"function"},{"doc":"Adds a new alert rule.","ref":"Raxol.Core.Metrics.AlertManager.html#add_rule/1","title":"Raxol.Core.Metrics.AlertManager.add_rule/1","type":"function"},{"doc":"","ref":"Raxol.Core.Metrics.AlertManager.html#t:alert_condition/0","title":"Raxol.Core.Metrics.AlertManager.alert_condition/0","type":"type"},{"doc":"","ref":"Raxol.Core.Metrics.AlertManager.html#t:alert_rule/0","title":"Raxol.Core.Metrics.AlertManager.alert_rule/0","type":"type"},{"doc":"","ref":"Raxol.Core.Metrics.AlertManager.html#t:alert_severity/0","title":"Raxol.Core.Metrics.AlertManager.alert_severity/0","type":"type"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Metrics.AlertManager.html#child_spec/1","title":"Raxol.Core.Metrics.AlertManager.child_spec/1","type":"function"},{"doc":"Gets the alert history.","ref":"Raxol.Core.Metrics.AlertManager.html#get_alert_history/1","title":"Raxol.Core.Metrics.AlertManager.get_alert_history/1","type":"function"},{"doc":"Gets the current alert state for a rule.","ref":"Raxol.Core.Metrics.AlertManager.html#get_alert_state/1","title":"Raxol.Core.Metrics.AlertManager.get_alert_state/1","type":"function"},{"doc":"Gets all alert rules.","ref":"Raxol.Core.Metrics.AlertManager.html#get_rules/0","title":"Raxol.Core.Metrics.AlertManager.get_rules/0","type":"function"},{"doc":"Starts the alert manager.","ref":"Raxol.Core.Metrics.AlertManager.html#start_link/1","title":"Raxol.Core.Metrics.AlertManager.start_link/1","type":"function"},{"doc":"Cloud integration for the Raxol metrics system.\n\nThis module handles:\n- Sending metrics to cloud services\n- Metric aggregation for cloud transmission\n- Cloud service configuration\n- Metric batching and compression","ref":"Raxol.Core.Metrics.Cloud.html","title":"Raxol.Core.Metrics.Cloud","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Metrics.Cloud.html#child_spec/1","title":"Raxol.Core.Metrics.Cloud.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Core.Metrics.Cloud.html#t:cloud_config/0","title":"Raxol.Core.Metrics.Cloud.cloud_config/0","type":"type"},{"doc":"","ref":"Raxol.Core.Metrics.Cloud.html#t:cloud_service/0","title":"Raxol.Core.Metrics.Cloud.cloud_service/0","type":"type"},{"doc":"Configures the cloud metrics service.","ref":"Raxol.Core.Metrics.Cloud.html#configure/1","title":"Raxol.Core.Metrics.Cloud.configure/1","type":"function"},{"doc":"Manually triggers a metrics flush to the cloud service.","ref":"Raxol.Core.Metrics.Cloud.html#flush_metrics/0","title":"Raxol.Core.Metrics.Cloud.flush_metrics/0","type":"function"},{"doc":"Gets the current cloud configuration.","ref":"Raxol.Core.Metrics.Cloud.html#get_config/0","title":"Raxol.Core.Metrics.Cloud.get_config/0","type":"function"},{"doc":"","ref":"Raxol.Core.Metrics.Cloud.html#send_to_cloudwatch/2","title":"Raxol.Core.Metrics.Cloud.send_to_cloudwatch/2","type":"function"},{"doc":"","ref":"Raxol.Core.Metrics.Cloud.html#send_to_datadog/2","title":"Raxol.Core.Metrics.Cloud.send_to_datadog/2","type":"function"},{"doc":"","ref":"Raxol.Core.Metrics.Cloud.html#send_to_prometheus/2","title":"Raxol.Core.Metrics.Cloud.send_to_prometheus/2","type":"function"},{"doc":"Starts the cloud metrics service.","ref":"Raxol.Core.Metrics.Cloud.html#start_link/1","title":"Raxol.Core.Metrics.Cloud.start_link/1","type":"function"},{"doc":"Configuration management for the Raxol metrics system.\n\nThis module handles:\n- Environment-based configuration\n- Runtime configuration updates\n- Configuration validation\n- Default settings","ref":"Raxol.Core.Metrics.Config.html","title":"Raxol.Core.Metrics.Config","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Metrics.Config.html#child_spec/1","title":"Raxol.Core.Metrics.Config.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Core.Metrics.Config.html#t:config_key/0","title":"Raxol.Core.Metrics.Config.config_key/0","type":"type"},{"doc":"Returns the default configuration.","ref":"Raxol.Core.Metrics.Config.html#default_config/0","title":"Raxol.Core.Metrics.Config.default_config/0","type":"function"},{"doc":"Gets the current environment.","ref":"Raxol.Core.Metrics.Config.html#environment/0","title":"Raxol.Core.Metrics.Config.environment/0","type":"function"},{"doc":"Gets the current configuration value for the given key.","ref":"Raxol.Core.Metrics.Config.html#get/2","title":"Raxol.Core.Metrics.Config.get/2","type":"function"},{"doc":"","ref":"Raxol.Core.Metrics.Config.html#t:metric_type/0","title":"Raxol.Core.Metrics.Config.metric_type/0","type":"type"},{"doc":"Resets the configuration to default values.","ref":"Raxol.Core.Metrics.Config.html#reset/0","title":"Raxol.Core.Metrics.Config.reset/0","type":"function"},{"doc":"Sets the current environment.","ref":"Raxol.Core.Metrics.Config.html#set_environment/1","title":"Raxol.Core.Metrics.Config.set_environment/1","type":"function"},{"doc":"Starts the configuration server.","ref":"Raxol.Core.Metrics.Config.html#start_link/1","title":"Raxol.Core.Metrics.Config.start_link/1","type":"function"},{"doc":"Updates the configuration with the given key-value pairs.","ref":"Raxol.Core.Metrics.Config.html#update/1","title":"Raxol.Core.Metrics.Config.update/1","type":"function"},{"doc":"Validates the given configuration.\nReturns :ok if valid, {:error, reason} if invalid.","ref":"Raxol.Core.Metrics.Config.html#validate_config/1","title":"Raxol.Core.Metrics.Config.validate_config/1","type":"function"},{"doc":"Manages unified metrics collection across the application.","ref":"Raxol.Core.Metrics.UnifiedCollector.html","title":"Raxol.Core.Metrics.UnifiedCollector","type":"module"},{"doc":"Adds a collector.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#add_collector/3","title":"Raxol.Core.Metrics.UnifiedCollector.add_collector/3","type":"function"},{"doc":"Calculates the average of a metric.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#calculate_average/2","title":"Raxol.Core.Metrics.UnifiedCollector.calculate_average/2","type":"function"},{"doc":"Calculates the maximum value of a metric.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#calculate_max/2","title":"Raxol.Core.Metrics.UnifiedCollector.calculate_max/2","type":"function"},{"doc":"Calculates the minimum value of a metric.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#calculate_min/2","title":"Raxol.Core.Metrics.UnifiedCollector.calculate_min/2","type":"function"},{"doc":"Calculates the sum of a metric.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#calculate_sum/2","title":"Raxol.Core.Metrics.UnifiedCollector.calculate_sum/2","type":"function"},{"doc":"Clears all metrics.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#clear_metrics/1","title":"Raxol.Core.Metrics.UnifiedCollector.clear_metrics/1","type":"function"},{"doc":"Collects metrics from all registered collectors.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#collect_metrics/1","title":"Raxol.Core.Metrics.UnifiedCollector.collect_metrics/1","type":"function"},{"doc":"Gets all metrics.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#get_all_metrics/1","title":"Raxol.Core.Metrics.UnifiedCollector.get_all_metrics/1","type":"function"},{"doc":"Gets a collector.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#get_collector/2","title":"Raxol.Core.Metrics.UnifiedCollector.get_collector/2","type":"function"},{"doc":"Gets all collectors.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#get_collectors/1","title":"Raxol.Core.Metrics.UnifiedCollector.get_collectors/1","type":"function"},{"doc":"Gets a metric value.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#get_metric/2","title":"Raxol.Core.Metrics.UnifiedCollector.get_metric/2","type":"function"},{"doc":"Gets metrics for a specific metric name and tags.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#get_metrics/2","title":"Raxol.Core.Metrics.UnifiedCollector.get_metrics/2","type":"function"},{"doc":"Gets the time since the last update.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#get_time_since_last_update/1","title":"Raxol.Core.Metrics.UnifiedCollector.get_time_since_last_update/1","type":"function"},{"doc":"Gets the total runtime of the collector.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#get_total_runtime/1","title":"Raxol.Core.Metrics.UnifiedCollector.get_total_runtime/1","type":"function"},{"doc":"Creates a new unified collector.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#new/1","title":"Raxol.Core.Metrics.UnifiedCollector.new/1","type":"function"},{"doc":"Records a metric value.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#record_metric/3","title":"Raxol.Core.Metrics.UnifiedCollector.record_metric/3","type":"function"},{"doc":"Removes a collector.","ref":"Raxol.Core.Metrics.UnifiedCollector.html#remove_collector/2","title":"Raxol.Core.Metrics.UnifiedCollector.remove_collector/2","type":"function"},{"doc":"","ref":"Raxol.Core.Metrics.UnifiedCollector.html#t:t/0","title":"Raxol.Core.Metrics.UnifiedCollector.t/0","type":"type"},{"doc":"Visualization system for the Raxol metrics.\n\nThis module handles:\n- Real-time metric visualization\n- Metric data formatting\n- Chart generation\n- Dashboard rendering\n- Export capabilities","ref":"Raxol.Core.Metrics.Visualizer.html","title":"Raxol.Core.Metrics.Visualizer","type":"module"},{"doc":"","ref":"Raxol.Core.Metrics.Visualizer.html#t:chart_options/0","title":"Raxol.Core.Metrics.Visualizer.chart_options/0","type":"type"},{"doc":"","ref":"Raxol.Core.Metrics.Visualizer.html#t:chart_type/0","title":"Raxol.Core.Metrics.Visualizer.chart_type/0","type":"type"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Metrics.Visualizer.html#child_spec/1","title":"Raxol.Core.Metrics.Visualizer.child_spec/1","type":"function"},{"doc":"Creates a new chart with the given metrics and options.","ref":"Raxol.Core.Metrics.Visualizer.html#create_chart/2","title":"Raxol.Core.Metrics.Visualizer.create_chart/2","type":"function"},{"doc":"Exports chart data in the specified format.","ref":"Raxol.Core.Metrics.Visualizer.html#export_chart/2","title":"Raxol.Core.Metrics.Visualizer.export_chart/2","type":"function"},{"doc":"Gets the current chart data.","ref":"Raxol.Core.Metrics.Visualizer.html#get_chart/1","title":"Raxol.Core.Metrics.Visualizer.get_chart/1","type":"function"},{"doc":"Starts the metrics visualizer.","ref":"Raxol.Core.Metrics.Visualizer.html#start_link/1","title":"Raxol.Core.Metrics.Visualizer.start_link/1","type":"function"},{"doc":"Updates an existing chart with new metrics.","ref":"Raxol.Core.Metrics.Visualizer.html#update_chart/2","title":"Raxol.Core.Metrics.Visualizer.update_chart/2","type":"function"},{"doc":"Handles AI-based analysis of performance metrics and generates optimization recommendations.\nThis module integrates with an AI agent to provide deep insights and actionable suggestions.","ref":"Raxol.Core.Performance.AIAnalyzer.html","title":"Raxol.Core.Performance.AIAnalyzer","type":"module"},{"doc":"Analyzes performance metrics using AI and returns detailed insights and recommendations.","ref":"Raxol.Core.Performance.AIAnalyzer.html#analyze/2","title":"Raxol.Core.Performance.AIAnalyzer.analyze/2","type":"function"},{"doc":"- metrics: Map containing performance metrics from the monitor\n  - options: Map of analysis options\n    - :depth (atom) - Analysis depth (:basic, :detailed, :comprehensive)\n    - :focus (list) - Areas to focus on ([:fps, :memory, :jank, :gc])\n    - :historical_data (list) - Optional historical metrics for trend analysis","ref":"Raxol.Core.Performance.AIAnalyzer.html#analyze/2-parameters","title":"Parameters - Raxol.Core.Performance.AIAnalyzer.analyze/2","type":"function"},{"doc":"- Map containing:\n    - :insights - Detailed performance insights\n    - :recommendations - Prioritized optimization suggestions\n    - :risk_assessment - Performance risk analysis\n    - :optimization_impact - Expected impact of suggested optimizations\n    - :ai_confidence - AI's confidence in the analysis","ref":"Raxol.Core.Performance.AIAnalyzer.html#analyze/2-returns","title":"Returns - Raxol.Core.Performance.AIAnalyzer.analyze/2","type":"function"},{"doc":"Generates a performance report with AI insights and recommendations.","ref":"Raxol.Core.Performance.AIAnalyzer.html#generate_report/2","title":"Raxol.Core.Performance.AIAnalyzer.generate_report/2","type":"function"},{"doc":"- metrics: Map containing performance metrics\n  - options: Map of report options\n    - :format (atom) - Report format (:text, :json, :html)\n    - :include_graphs (boolean) - Whether to include performance graphs\n    - :include_code_samples (boolean) - Whether to include code optimization examples","ref":"Raxol.Core.Performance.AIAnalyzer.html#generate_report/2-parameters","title":"Parameters - Raxol.Core.Performance.AIAnalyzer.generate_report/2","type":"function"},{"doc":"- Map containing the formatted report and additional data","ref":"Raxol.Core.Performance.AIAnalyzer.html#generate_report/2-returns","title":"Returns - Raxol.Core.Performance.AIAnalyzer.generate_report/2","type":"function"},{"doc":"Analyzes performance metrics and generates insights for AI analysis.\n\nThis module:\n- Processes performance metrics\n- Identifies performance patterns\n- Generates optimization suggestions\n- Formats data for AI analysis","ref":"Raxol.Core.Performance.Analyzer.html","title":"Raxol.Core.Performance.Analyzer","type":"module"},{"doc":"```elixir\n# Get metrics from monitor\nmetrics = Monitor.get_metrics(monitor)\n\n# Analyze metrics\nanalysis = Analyzer.analyze(metrics)\n\n# Get AI-ready data\nai_data = Analyzer.prepare_ai_data(analysis)\n```","ref":"Raxol.Core.Performance.Analyzer.html#module-usage","title":"Usage - Raxol.Core.Performance.Analyzer","type":"module"},{"doc":"Analyzes performance metrics and generates insights.","ref":"Raxol.Core.Performance.Analyzer.html#analyze/1","title":"Raxol.Core.Performance.Analyzer.analyze/1","type":"function"},{"doc":"* `metrics` - Map of performance metrics from Monitor","ref":"Raxol.Core.Performance.Analyzer.html#analyze/1-parameters","title":"Parameters - Raxol.Core.Performance.Analyzer.analyze/1","type":"function"},{"doc":"Map containing analysis results:\n* `:performance_score` - Overall performance score (0-100)\n* `:issues` - List of identified performance issues\n* `:suggestions` - List of optimization suggestions\n* `:patterns` - Identified performance patterns\n* `:trends` - Performance trends over time","ref":"Raxol.Core.Performance.Analyzer.html#analyze/1-returns","title":"Returns - Raxol.Core.Performance.Analyzer.analyze/1","type":"function"},{"doc":"iex> metrics = %{\n      fps: 60,\n      avg_frame_time: 16.5,\n      jank_count: 2,\n      memory_usage: 1234567,\n      gc_stats: %{...}\n    }\n    iex> Analyzer.analyze(metrics)\n    %{\n      performance_score: 85,\n      issues: [\"High memory usage\", \"Occasional jank\"],\n      suggestions: [\"Optimize memory allocation\", \"Profile render loop\"],\n      patterns: %{...},\n      trends: %{...}\n    }","ref":"Raxol.Core.Performance.Analyzer.html#analyze/1-examples","title":"Examples - Raxol.Core.Performance.Analyzer.analyze/1","type":"function"},{"doc":"Prepares performance data for AI analysis.","ref":"Raxol.Core.Performance.Analyzer.html#prepare_ai_data/1","title":"Raxol.Core.Performance.Analyzer.prepare_ai_data/1","type":"function"},{"doc":"* `analysis` - Analysis results from analyze/1","ref":"Raxol.Core.Performance.Analyzer.html#prepare_ai_data/1-parameters","title":"Parameters - Raxol.Core.Performance.Analyzer.prepare_ai_data/1","type":"function"},{"doc":"Map containing AI-ready data:\n* `:metrics` - Raw performance metrics\n* `:analysis` - Analysis results\n* `:context` - Additional context for AI\n* `:format` - Data format specification","ref":"Raxol.Core.Performance.Analyzer.html#prepare_ai_data/1-returns","title":"Returns - Raxol.Core.Performance.Analyzer.prepare_ai_data/1","type":"function"},{"doc":"iex> metrics = %{fps: 60, ...}\n    iex> analysis = Analyzer.analyze(metrics)\n    iex> ai_data = Analyzer.prepare_ai_data(analysis)\n    iex> Map.has_key?(ai_data, :metrics)\n    true","ref":"Raxol.Core.Performance.Analyzer.html#prepare_ai_data/1-examples","title":"Examples - Raxol.Core.Performance.Analyzer.prepare_ai_data/1","type":"function"},{"doc":"Detects UI jank by analyzing frame timing.\n\nA frame is considered janky if it takes longer than the jank threshold\nto render. The detector maintains a rolling window of frame times to\nidentify patterns of jank.","ref":"Raxol.Core.Performance.JankDetector.html","title":"Raxol.Core.Performance.JankDetector","type":"module"},{"doc":"```elixir\n# Create a new detector\ndetector = JankDetector.new(16, 60)  # 16ms threshold, 60 frame window\n\n# Record a frame\ndetector = JankDetector.record_frame(detector, 20)\n\n# Check for jank\nif JankDetector.detect_jank?(detector) do\n  Raxol.Core.Runtime.Log.warning_with_context(\"Jank detected\", %{})\nend\n```","ref":"Raxol.Core.Performance.JankDetector.html#module-usage","title":"Usage - Raxol.Core.Performance.JankDetector","type":"module"},{"doc":"Checks if jank was detected in the last frame.","ref":"Raxol.Core.Performance.JankDetector.html#detect_jank?/1","title":"Raxol.Core.Performance.JankDetector.detect_jank?/1","type":"function"},{"doc":"* `detector` - The jank detector","ref":"Raxol.Core.Performance.JankDetector.html#detect_jank?/1-parameters","title":"Parameters - Raxol.Core.Performance.JankDetector.detect_jank?/1","type":"function"},{"doc":"* `true` if the last frame was janky\n* `false` otherwise","ref":"Raxol.Core.Performance.JankDetector.html#detect_jank?/1-returns","title":"Returns - Raxol.Core.Performance.JankDetector.detect_jank?/1","type":"function"},{"doc":"iex> detector = JankDetector.new(16, 60)\n    iex> detector = JankDetector.record_frame(detector, 20)\n    iex> JankDetector.detect_jank?(detector)\n    true","ref":"Raxol.Core.Performance.JankDetector.html#detect_jank?/1-examples","title":"Examples - Raxol.Core.Performance.JankDetector.detect_jank?/1","type":"function"},{"doc":"Gets the average frame time in the current window.","ref":"Raxol.Core.Performance.JankDetector.html#get_avg_frame_time/1","title":"Raxol.Core.Performance.JankDetector.get_avg_frame_time/1","type":"function"},{"doc":"* `detector` - The jank detector","ref":"Raxol.Core.Performance.JankDetector.html#get_avg_frame_time/1-parameters","title":"Parameters - Raxol.Core.Performance.JankDetector.get_avg_frame_time/1","type":"function"},{"doc":"Average frame time in milliseconds.","ref":"Raxol.Core.Performance.JankDetector.html#get_avg_frame_time/1-returns","title":"Returns - Raxol.Core.Performance.JankDetector.get_avg_frame_time/1","type":"function"},{"doc":"iex> detector = JankDetector.new(16, 60)\n    iex> detector = JankDetector.record_frame(detector, 20)\n    iex> JankDetector.get_avg_frame_time(detector)\n    20.0","ref":"Raxol.Core.Performance.JankDetector.html#get_avg_frame_time/1-examples","title":"Examples - Raxol.Core.Performance.JankDetector.get_avg_frame_time/1","type":"function"},{"doc":"Gets the number of janky frames in the current window.","ref":"Raxol.Core.Performance.JankDetector.html#get_jank_count/1","title":"Raxol.Core.Performance.JankDetector.get_jank_count/1","type":"function"},{"doc":"* `detector` - The jank detector","ref":"Raxol.Core.Performance.JankDetector.html#get_jank_count/1-parameters","title":"Parameters - Raxol.Core.Performance.JankDetector.get_jank_count/1","type":"function"},{"doc":"Number of janky frames.","ref":"Raxol.Core.Performance.JankDetector.html#get_jank_count/1-returns","title":"Returns - Raxol.Core.Performance.JankDetector.get_jank_count/1","type":"function"},{"doc":"iex> detector = JankDetector.new(16, 60)\n    iex> detector = JankDetector.record_frame(detector, 20)\n    iex> JankDetector.get_jank_count(detector)\n    1","ref":"Raxol.Core.Performance.JankDetector.html#get_jank_count/1-examples","title":"Examples - Raxol.Core.Performance.JankDetector.get_jank_count/1","type":"function"},{"doc":"Gets the maximum frame time in the current window.","ref":"Raxol.Core.Performance.JankDetector.html#get_max_frame_time/1","title":"Raxol.Core.Performance.JankDetector.get_max_frame_time/1","type":"function"},{"doc":"* `detector` - The jank detector","ref":"Raxol.Core.Performance.JankDetector.html#get_max_frame_time/1-parameters","title":"Parameters - Raxol.Core.Performance.JankDetector.get_max_frame_time/1","type":"function"},{"doc":"Maximum frame time in milliseconds.","ref":"Raxol.Core.Performance.JankDetector.html#get_max_frame_time/1-returns","title":"Returns - Raxol.Core.Performance.JankDetector.get_max_frame_time/1","type":"function"},{"doc":"iex> detector = JankDetector.new(16, 60)\n    iex> detector = JankDetector.record_frame(detector, 20)\n    iex> JankDetector.get_max_frame_time(detector)\n    20","ref":"Raxol.Core.Performance.JankDetector.html#get_max_frame_time/1-examples","title":"Examples - Raxol.Core.Performance.JankDetector.get_max_frame_time/1","type":"function"},{"doc":"Creates a new jank detector.","ref":"Raxol.Core.Performance.JankDetector.html#new/2","title":"Raxol.Core.Performance.JankDetector.new/2","type":"function"},{"doc":"* `threshold` - Time in milliseconds above which a frame is considered janky\n* `window_size` - Number of frames to keep in the rolling window","ref":"Raxol.Core.Performance.JankDetector.html#new/2-parameters","title":"Parameters - Raxol.Core.Performance.JankDetector.new/2","type":"function"},{"doc":"A new jank detector struct.","ref":"Raxol.Core.Performance.JankDetector.html#new/2-returns","title":"Returns - Raxol.Core.Performance.JankDetector.new/2","type":"function"},{"doc":"iex> JankDetector.new(16, 60)\n    %JankDetector{\n      threshold: 16,\n      window_size: 60,\n      frame_times: [],\n      jank_count: 0\n    }","ref":"Raxol.Core.Performance.JankDetector.html#new/2-examples","title":"Examples - Raxol.Core.Performance.JankDetector.new/2","type":"function"},{"doc":"Records a frame's timing.","ref":"Raxol.Core.Performance.JankDetector.html#record_frame/2","title":"Raxol.Core.Performance.JankDetector.record_frame/2","type":"function"},{"doc":"* `detector` - The jank detector\n* `frame_time` - Time taken to render the frame in milliseconds","ref":"Raxol.Core.Performance.JankDetector.html#record_frame/2-parameters","title":"Parameters - Raxol.Core.Performance.JankDetector.record_frame/2","type":"function"},{"doc":"Updated jank detector.","ref":"Raxol.Core.Performance.JankDetector.html#record_frame/2-returns","title":"Returns - Raxol.Core.Performance.JankDetector.record_frame/2","type":"function"},{"doc":"iex> detector = JankDetector.new(16, 60)\n    iex> detector = JankDetector.record_frame(detector, 20)\n    iex> detector.jank_count\n    1","ref":"Raxol.Core.Performance.JankDetector.html#record_frame/2-examples","title":"Examples - Raxol.Core.Performance.JankDetector.record_frame/2","type":"function"},{"doc":"Collects and calculates performance metrics.\n\nThis module tracks:\n- Frame rate (FPS)\n- Frame timing statistics\n- Memory usage\n- Garbage collection statistics","ref":"Raxol.Core.Performance.MetricsCollector.html","title":"Raxol.Core.Performance.MetricsCollector","type":"module"},{"doc":"```elixir\n# Create a new collector\ncollector = MetricsCollector.new()\n\n# Record a frame\ncollector = MetricsCollector.record_frame(collector, 16)\n\n# Get current FPS\nfps = MetricsCollector.get_fps(collector)\n\n# Update memory metrics\ncollector = MetricsCollector.update_memory_usage(collector)\n```","ref":"Raxol.Core.Performance.MetricsCollector.html#module-usage","title":"Usage - Raxol.Core.Performance.MetricsCollector","type":"module"},{"doc":"Gets the average frame time.","ref":"Raxol.Core.Performance.MetricsCollector.html#get_avg_frame_time/1","title":"Raxol.Core.Performance.MetricsCollector.get_avg_frame_time/1","type":"function"},{"doc":"* `collector` - The metrics collector","ref":"Raxol.Core.Performance.MetricsCollector.html#get_avg_frame_time/1-parameters","title":"Parameters - Raxol.Core.Performance.MetricsCollector.get_avg_frame_time/1","type":"function"},{"doc":"Average frame time in milliseconds.","ref":"Raxol.Core.Performance.MetricsCollector.html#get_avg_frame_time/1-returns","title":"Returns - Raxol.Core.Performance.MetricsCollector.get_avg_frame_time/1","type":"function"},{"doc":"iex> collector = MetricsCollector.new()\n    iex> collector = MetricsCollector.record_frame(collector, 16)\n    iex> MetricsCollector.get_avg_frame_time(collector)\n    16.0","ref":"Raxol.Core.Performance.MetricsCollector.html#get_avg_frame_time/1-examples","title":"Examples - Raxol.Core.Performance.MetricsCollector.get_avg_frame_time/1","type":"function"},{"doc":"Gets the current frames per second.","ref":"Raxol.Core.Performance.MetricsCollector.html#get_fps/1","title":"Raxol.Core.Performance.MetricsCollector.get_fps/1","type":"function"},{"doc":"* `collector` - The metrics collector","ref":"Raxol.Core.Performance.MetricsCollector.html#get_fps/1-parameters","title":"Parameters - Raxol.Core.Performance.MetricsCollector.get_fps/1","type":"function"},{"doc":"Current FPS as a float.","ref":"Raxol.Core.Performance.MetricsCollector.html#get_fps/1-returns","title":"Returns - Raxol.Core.Performance.MetricsCollector.get_fps/1","type":"function"},{"doc":"iex> collector = MetricsCollector.new()\n    iex> collector = MetricsCollector.record_frame(collector, 16)\n    iex> MetricsCollector.get_fps(collector)\n    62.5","ref":"Raxol.Core.Performance.MetricsCollector.html#get_fps/1-examples","title":"Examples - Raxol.Core.Performance.MetricsCollector.get_fps/1","type":"function"},{"doc":"Gets garbage collection statistics.","ref":"Raxol.Core.Performance.MetricsCollector.html#get_gc_stats/1","title":"Raxol.Core.Performance.MetricsCollector.get_gc_stats/1","type":"function"},{"doc":"* `collector` - The metrics collector","ref":"Raxol.Core.Performance.MetricsCollector.html#get_gc_stats/1-parameters","title":"Parameters - Raxol.Core.Performance.MetricsCollector.get_gc_stats/1","type":"function"},{"doc":"Map containing GC statistics:\n* `:number_of_gcs` - Total number of garbage collections\n* `:words_reclaimed` - Total words reclaimed\n* `:heap_size` - Current heap size\n* `:heap_limit` - Maximum heap size","ref":"Raxol.Core.Performance.MetricsCollector.html#get_gc_stats/1-returns","title":"Returns - Raxol.Core.Performance.MetricsCollector.get_gc_stats/1","type":"function"},{"doc":"iex> collector = MetricsCollector.new()\n    iex> collector = MetricsCollector.update_memory_usage(collector)\n    iex> gc_stats = MetricsCollector.get_gc_stats(collector)\n    iex> Map.has_key?(gc_stats, :number_of_gcs)\n    true","ref":"Raxol.Core.Performance.MetricsCollector.html#get_gc_stats/1-examples","title":"Examples - Raxol.Core.Performance.MetricsCollector.get_gc_stats/1","type":"function"},{"doc":"Gets the memory usage trend.","ref":"Raxol.Core.Performance.MetricsCollector.html#get_memory_trend/1","title":"Raxol.Core.Performance.MetricsCollector.get_memory_trend/1","type":"function"},{"doc":"* `collector` - The metrics collector","ref":"Raxol.Core.Performance.MetricsCollector.html#get_memory_trend/1-parameters","title":"Parameters - Raxol.Core.Performance.MetricsCollector.get_memory_trend/1","type":"function"},{"doc":"Memory usage trend as a percentage change.","ref":"Raxol.Core.Performance.MetricsCollector.html#get_memory_trend/1-returns","title":"Returns - Raxol.Core.Performance.MetricsCollector.get_memory_trend/1","type":"function"},{"doc":"iex> collector = MetricsCollector.new()\n    iex> collector = MetricsCollector.update_memory_usage(collector)\n    iex> collector = MetricsCollector.update_memory_usage(collector)\n    iex> MetricsCollector.get_memory_trend(collector)\n    0.0","ref":"Raxol.Core.Performance.MetricsCollector.html#get_memory_trend/1-examples","title":"Examples - Raxol.Core.Performance.MetricsCollector.get_memory_trend/1","type":"function"},{"doc":"Creates a new metrics collector.","ref":"Raxol.Core.Performance.MetricsCollector.html#new/0","title":"Raxol.Core.Performance.MetricsCollector.new/0","type":"function"},{"doc":"A new metrics collector struct.","ref":"Raxol.Core.Performance.MetricsCollector.html#new/0-returns","title":"Returns - Raxol.Core.Performance.MetricsCollector.new/0","type":"function"},{"doc":"iex> MetricsCollector.new()\n    %MetricsCollector{\n      frame_times: [],\n      memory_usage: 0,\n      gc_stats: %{},\n      last_gc_time: 0\n    }","ref":"Raxol.Core.Performance.MetricsCollector.html#new/0-examples","title":"Examples - Raxol.Core.Performance.MetricsCollector.new/0","type":"function"},{"doc":"Records a frame's timing.","ref":"Raxol.Core.Performance.MetricsCollector.html#record_frame/2","title":"Raxol.Core.Performance.MetricsCollector.record_frame/2","type":"function"},{"doc":"* `collector` - The metrics collector\n* `frame_time` - Time taken to render the frame in milliseconds","ref":"Raxol.Core.Performance.MetricsCollector.html#record_frame/2-parameters","title":"Parameters - Raxol.Core.Performance.MetricsCollector.record_frame/2","type":"function"},{"doc":"Updated metrics collector.","ref":"Raxol.Core.Performance.MetricsCollector.html#record_frame/2-returns","title":"Returns - Raxol.Core.Performance.MetricsCollector.record_frame/2","type":"function"},{"doc":"iex> collector = MetricsCollector.new()\n    iex> collector = MetricsCollector.record_frame(collector, 16)\n    iex> length(collector.frame_times)\n    1","ref":"Raxol.Core.Performance.MetricsCollector.html#record_frame/2-examples","title":"Examples - Raxol.Core.Performance.MetricsCollector.record_frame/2","type":"function"},{"doc":"Updates memory usage metrics.","ref":"Raxol.Core.Performance.MetricsCollector.html#update_memory_usage/1","title":"Raxol.Core.Performance.MetricsCollector.update_memory_usage/1","type":"function"},{"doc":"* `collector` - The metrics collector","ref":"Raxol.Core.Performance.MetricsCollector.html#update_memory_usage/1-parameters","title":"Parameters - Raxol.Core.Performance.MetricsCollector.update_memory_usage/1","type":"function"},{"doc":"Updated metrics collector with current memory usage and GC stats.","ref":"Raxol.Core.Performance.MetricsCollector.html#update_memory_usage/1-returns","title":"Returns - Raxol.Core.Performance.MetricsCollector.update_memory_usage/1","type":"function"},{"doc":"iex> collector = MetricsCollector.new()\n    iex> collector = MetricsCollector.update_memory_usage(collector)\n    iex> collector.memory_usage > 0\n    true","ref":"Raxol.Core.Performance.MetricsCollector.html#update_memory_usage/1-examples","title":"Examples - Raxol.Core.Performance.MetricsCollector.update_memory_usage/1","type":"function"},{"doc":"Performance monitoring system for Raxol applications.\n\nThis module provides tools for:\n- Frame rate monitoring\n- Memory usage tracking\n- UI jank detection\n- Performance metrics collection\n- Performance visualization","ref":"Raxol.Core.Performance.Monitor.html","title":"Raxol.Core.Performance.Monitor","type":"module"},{"doc":"```elixir\n# Start monitoring\n{:ok, monitor} = Monitor.start_link()\n\n# Record frame timing\nMonitor.record_frame(monitor, 16)  # 16ms frame time\n\n# Check for jank\nif Monitor.detect_jank?(monitor) do\n  Raxol.Core.Runtime.Log.warning_with_context(\"UI jank detected\", %{})\nend\n\n# Get performance metrics\nmetrics = Monitor.get_metrics(monitor)\n```","ref":"Raxol.Core.Performance.Monitor.html#module-usage","title":"Usage - Raxol.Core.Performance.Monitor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Performance.Monitor.html#child_spec/1","title":"Raxol.Core.Performance.Monitor.child_spec/1","type":"function"},{"doc":"Checks if jank was detected in the last frame.","ref":"Raxol.Core.Performance.Monitor.html#detect_jank?/1","title":"Raxol.Core.Performance.Monitor.detect_jank?/1","type":"function"},{"doc":"* `monitor` - The monitor process","ref":"Raxol.Core.Performance.Monitor.html#detect_jank?/1-parameters","title":"Parameters - Raxol.Core.Performance.Monitor.detect_jank?/1","type":"function"},{"doc":"* `true` if jank was detected\n* `false` otherwise","ref":"Raxol.Core.Performance.Monitor.html#detect_jank?/1-returns","title":"Returns - Raxol.Core.Performance.Monitor.detect_jank?/1","type":"function"},{"doc":"iex> Monitor.detect_jank?(monitor)\n    false","ref":"Raxol.Core.Performance.Monitor.html#detect_jank?/1-examples","title":"Examples - Raxol.Core.Performance.Monitor.detect_jank?/1","type":"function"},{"doc":"Gets current performance metrics.","ref":"Raxol.Core.Performance.Monitor.html#get_metrics/1","title":"Raxol.Core.Performance.Monitor.get_metrics/1","type":"function"},{"doc":"* `monitor` - The monitor process","ref":"Raxol.Core.Performance.Monitor.html#get_metrics/1-parameters","title":"Parameters - Raxol.Core.Performance.Monitor.get_metrics/1","type":"function"},{"doc":"Map containing performance metrics:\n* `:fps` - Current frames per second\n* `:avg_frame_time` - Average frame time in milliseconds\n* `:jank_count` - Number of janky frames in the sample window\n* `:memory_usage` - Current memory usage in bytes\n* `:gc_stats` - Garbage collection statistics","ref":"Raxol.Core.Performance.Monitor.html#get_metrics/1-returns","title":"Returns - Raxol.Core.Performance.Monitor.get_metrics/1","type":"function"},{"doc":"iex> Monitor.get_metrics(monitor)\n    %{\n      fps: 60,\n      avg_frame_time: 16.5,\n      jank_count: 2,\n      memory_usage: 1234567,\n      gc_stats: %{...}\n    }","ref":"Raxol.Core.Performance.Monitor.html#get_metrics/1-examples","title":"Examples - Raxol.Core.Performance.Monitor.get_metrics/1","type":"function"},{"doc":"Records a frame's timing.","ref":"Raxol.Core.Performance.Monitor.html#record_frame/2","title":"Raxol.Core.Performance.Monitor.record_frame/2","type":"function"},{"doc":"* `monitor` - The monitor process\n* `frame_time` - Time taken to render the frame in milliseconds","ref":"Raxol.Core.Performance.Monitor.html#record_frame/2-parameters","title":"Parameters - Raxol.Core.Performance.Monitor.record_frame/2","type":"function"},{"doc":"iex> Monitor.record_frame(monitor, 16)\n    :ok","ref":"Raxol.Core.Performance.Monitor.html#record_frame/2-examples","title":"Examples - Raxol.Core.Performance.Monitor.record_frame/2","type":"function"},{"doc":"","ref":"Raxol.Core.Performance.Monitor.html#reset_metrics/1","title":"Raxol.Core.Performance.Monitor.reset_metrics/1","type":"function"},{"doc":"Starts a new performance monitor.","ref":"Raxol.Core.Performance.Monitor.html#start_link/1","title":"Raxol.Core.Performance.Monitor.start_link/1","type":"function"},{"doc":"* `:jank_threshold` - Time in milliseconds above which a frame is considered janky (default: 16)\n* `:sample_size` - Number of frames to keep in the rolling window (default: 60)\n* `:memory_check_interval` - How often to check memory usage in milliseconds (default: 5000)","ref":"Raxol.Core.Performance.Monitor.html#start_link/1-options","title":"Options - Raxol.Core.Performance.Monitor.start_link/1","type":"function"},{"doc":"iex> {:ok, monitor} = Monitor.start_link()\n    {:ok, #PID<0.123.0>}\n\n    iex> {:ok, monitor} = Monitor.start_link(jank_threshold: 20)\n    {:ok, #PID<0.124.0>}","ref":"Raxol.Core.Performance.Monitor.html#start_link/1-examples","title":"Examples - Raxol.Core.Performance.Monitor.start_link/1","type":"function"},{"doc":"Provides clipboard read/write commands and delegates to a configured system clipboard implementation.","ref":"Raxol.Core.Plugins.Core.ClipboardPlugin.html","title":"Raxol.Core.Plugins.Core.ClipboardPlugin","type":"module"},{"doc":"Defines the behaviour for clipboard plugin operations.","ref":"Raxol.Core.Plugins.Core.ClipboardPluginBehaviour.html","title":"Raxol.Core.Plugins.Core.ClipboardPluginBehaviour","type":"behaviour"},{"doc":"Returns the list of commands supported by the clipboard plugin.","ref":"Raxol.Core.Plugins.Core.ClipboardPluginBehaviour.html#c:get_commands/0","title":"Raxol.Core.Plugins.Core.ClipboardPluginBehaviour.get_commands/0","type":"callback"},{"doc":"Handles a clipboard command with the given arguments and state.","ref":"Raxol.Core.Plugins.Core.ClipboardPluginBehaviour.html#c:handle_command/3","title":"Raxol.Core.Plugins.Core.ClipboardPluginBehaviour.handle_command/3","type":"callback"},{"doc":"Initializes the clipboard plugin with the given options.","ref":"Raxol.Core.Plugins.Core.ClipboardPluginBehaviour.html#c:init/1","title":"Raxol.Core.Plugins.Core.ClipboardPluginBehaviour.init/1","type":"callback"},{"doc":"Core plugin responsible for handling notifications (:notify).\nRelies on an implementation of Raxol.System.Interaction for OS interactions.","ref":"Raxol.Core.Plugins.Core.NotificationPlugin.html","title":"Raxol.Core.Plugins.Core.NotificationPlugin","type":"module"},{"doc":"Wrapper for handle_command/2 for backward compatibility. Delegates to handle_command/3 if possible.","ref":"Raxol.Core.Plugins.Core.NotificationPlugin.html#handle_command/2","title":"Raxol.Core.Plugins.Core.NotificationPlugin.handle_command/2","type":"function"},{"doc":"Manages user preferences including accessibility settings like reduced motion.","ref":"Raxol.Core.Preferences.html","title":"Raxol.Core.Preferences","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Preferences.html#child_spec/1","title":"Raxol.Core.Preferences.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Core.Preferences.html#get_preference/2","title":"Raxol.Core.Preferences.get_preference/2","type":"function"},{"doc":"","ref":"Raxol.Core.Preferences.html#set_preference/2","title":"Raxol.Core.Preferences.set_preference/2","type":"function"},{"doc":"","ref":"Raxol.Core.Preferences.html#start_link/1","title":"Raxol.Core.Preferences.start_link/1","type":"function"},{"doc":"Handles persistence (loading/saving) of user preferences to a file.","ref":"Raxol.Core.Preferences.Persistence.html","title":"Raxol.Core.Preferences.Persistence","type":"module"},{"doc":"Loads user preferences from the designated file.\n\nReturns:\n  - `{:ok, preferences_map}` if successful.\n  - `{:error, :file_not_found}` if the file doesn't exist.\n  - `{:error, reason}` for other file or decoding errors.","ref":"Raxol.Core.Preferences.Persistence.html#load/0","title":"Raxol.Core.Preferences.Persistence.load/0","type":"function"},{"doc":"Returns the full path to the user preferences file.\nUses an application-specific directory.","ref":"Raxol.Core.Preferences.Persistence.html#preferences_path/0","title":"Raxol.Core.Preferences.Persistence.preferences_path/0","type":"function"},{"doc":"Saves the given preferences map to the designated file.\n\nSerializes the map using `:erlang.term_to_binary`.\n\nReturns:\n  - `:ok` on success.\n  - `{:error, reason}` on failure.","ref":"Raxol.Core.Preferences.Persistence.html#save/1","title":"Raxol.Core.Preferences.Persistence.save/1","type":"function"},{"doc":"Handles storage and retrieval of user preferences.","ref":"Raxol.Core.Preferences.Store.html","title":"Raxol.Core.Preferences.Store","type":"module"},{"doc":"Retrieves all user preferences as a map.","ref":"Raxol.Core.Preferences.Store.html#get_all_preferences/0","title":"Raxol.Core.Preferences.Store.get_all_preferences/0","type":"function"},{"doc":"Retrieves a user preference by key or key path.\nExample: get_preference(:theme) or get_preference([:accessibility, :high_contrast])","ref":"Raxol.Core.Preferences.Store.html#get_preference/1","title":"Raxol.Core.Preferences.Store.get_preference/1","type":"function"},{"doc":"Resets all preferences to defaults (by clearing and saving defaults).","ref":"Raxol.Core.Preferences.Store.html#reset_preferences/0","title":"Raxol.Core.Preferences.Store.reset_preferences/0","type":"function"},{"doc":"","ref":"Raxol.Core.Preferences.Store.html#save_to_preferences/1","title":"Raxol.Core.Preferences.Store.save_to_preferences/1","type":"function"},{"doc":"Sets a user preference by key or key path.\nExample: set_preference(:theme, \"dark\") or set_preference([:accessibility, :high_contrast], true)","ref":"Raxol.Core.Preferences.Store.html#set_preference/2","title":"Raxol.Core.Preferences.Store.set_preference/2","type":"function"},{"doc":"Manages terminal buffer rendering with double buffering and damage tracking.\n\nThis module provides efficient terminal rendering by:\n* Using double buffering to prevent screen flicker\n* Tracking damaged regions to minimize updates\n* Supporting partial screen updates\n* Managing frame timing","ref":"Raxol.Core.Renderer.Buffer.html","title":"Raxol.Core.Renderer.Buffer","type":"module"},{"doc":"","ref":"Raxol.Core.Renderer.Buffer.html#t:buffer/0","title":"Raxol.Core.Renderer.Buffer.buffer/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.Buffer.html#t:cell/0","title":"Raxol.Core.Renderer.Buffer.cell/0","type":"type"},{"doc":"Clears the entire buffer and marks all cells as damaged.","ref":"Raxol.Core.Renderer.Buffer.html#clear/1","title":"Raxol.Core.Renderer.Buffer.clear/1","type":"function"},{"doc":"Gets the damaged regions that need to be redrawn.\nReturns a list of {position, cell} tuples.","ref":"Raxol.Core.Renderer.Buffer.html#get_damage/1","title":"Raxol.Core.Renderer.Buffer.get_damage/1","type":"function"},{"doc":"Creates a new buffer manager with the given size and FPS.","ref":"Raxol.Core.Renderer.Buffer.html#new/3","title":"Raxol.Core.Renderer.Buffer.new/3","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Buffer.html#t:position/0","title":"Raxol.Core.Renderer.Buffer.position/0","type":"type"},{"doc":"Updates a cell in the back buffer and marks it as damaged.","ref":"Raxol.Core.Renderer.Buffer.html#put_cell/4","title":"Raxol.Core.Renderer.Buffer.put_cell/4","type":"function"},{"doc":"Resizes the buffer to the new dimensions.\nPreserves content where possible and marks all changed cells as damaged.","ref":"Raxol.Core.Renderer.Buffer.html#resize/3","title":"Raxol.Core.Renderer.Buffer.resize/3","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Buffer.html#t:size/0","title":"Raxol.Core.Renderer.Buffer.size/0","type":"type"},{"doc":"Swaps the front and back buffers if enough time has passed since the last frame.\nReturns {buffer, should_render}, where should_render indicates if a new frame should be drawn.","ref":"Raxol.Core.Renderer.Buffer.html#swap_buffers/1","title":"Raxol.Core.Renderer.Buffer.swap_buffers/1","type":"function"},{"doc":"Provides comprehensive color support for terminal rendering.\n\nSupports:\n* ANSI 16 colors (4-bit)\n* ANSI 256 colors (8-bit)\n* True Color (24-bit)\n* Color themes\n* Terminal background detection","ref":"Raxol.Core.Renderer.Color.html","title":"Raxol.Core.Renderer.Color","type":"module"},{"doc":"","ref":"Raxol.Core.Renderer.Color.html#t:ansi_16/0","title":"Raxol.Core.Renderer.Color.ansi_16/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.Color.html#t:ansi_256/0","title":"Raxol.Core.Renderer.Color.ansi_256/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.Color.html#t:color/0","title":"Raxol.Core.Renderer.Color.color/0","type":"type"},{"doc":"Creates a color theme map.","ref":"Raxol.Core.Renderer.Color.html#create_theme/1","title":"Raxol.Core.Renderer.Color.create_theme/1","type":"function"},{"doc":"Returns the default color theme.","ref":"Raxol.Core.Renderer.Color.html#default_theme/0","title":"Raxol.Core.Renderer.Color.default_theme/0","type":"function"},{"doc":"Detects the terminal's background color.\nReturns :light or :dark.","ref":"Raxol.Core.Renderer.Color.html#detect_background/0","title":"Raxol.Core.Renderer.Color.detect_background/0","type":"function"},{"doc":"Converts a hex color string to RGB.","ref":"Raxol.Core.Renderer.Color.html#hex_to_rgb/1","title":"Raxol.Core.Renderer.Color.hex_to_rgb/1","type":"function"},{"doc":"Converts RGB values to the nearest ANSI 256 color code.","ref":"Raxol.Core.Renderer.Color.html#rgb_to_ansi256/1","title":"Raxol.Core.Renderer.Color.rgb_to_ansi256/1","type":"function"},{"doc":"Converts a color representation to its ANSI foreground escape code.","ref":"Raxol.Core.Renderer.Color.html#to_ansi/1","title":"Raxol.Core.Renderer.Color.to_ansi/1","type":"function"},{"doc":"Converts a color representation to its ANSI background escape code.","ref":"Raxol.Core.Renderer.Color.html#to_bg_ansi/1","title":"Raxol.Core.Renderer.Color.to_bg_ansi/1","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Color.html#t:true_color/0","title":"Raxol.Core.Renderer.Color.true_color/0","type":"type"},{"doc":"Defines the core element structure for the rendering system.\n\nElements are the building blocks of Raxol's UI system. Each element\nrepresents a renderable component with:\n* A tag identifying its type\n* Attributes controlling its appearance and behavior\n* Optional children forming a tree structure","ref":"Raxol.Core.Renderer.Element.html","title":"Raxol.Core.Renderer.Element","type":"module"},{"doc":"Adds children to an existing element.","ref":"Raxol.Core.Renderer.Element.html#add_children/2","title":"Raxol.Core.Renderer.Element.add_children/2","type":"function"},{"doc":"Creates a new element with the given tag and attributes.","ref":"Raxol.Core.Renderer.Element.html#new/3","title":"Raxol.Core.Renderer.Element.new/3","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Element.html#t:t/0","title":"Raxol.Core.Renderer.Element.t/0","type":"type"},{"doc":"Updates an element's attributes while preserving its structure.","ref":"Raxol.Core.Renderer.Element.html#update_attrs/2","title":"Raxol.Core.Renderer.Element.update_attrs/2","type":"function"},{"doc":"Validates that an element tree follows the component rules.","ref":"Raxol.Core.Renderer.Element.html#validate/1","title":"Raxol.Core.Renderer.Element.validate/1","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Layout.html","title":"Raxol.Core.Renderer.Layout","type":"module"},{"doc":"Manages the rendering system for Raxol applications.\n\nThis module coordinates:\n* Frame-based rendering\n* Terminal buffer management\n* Component rendering\n* Screen updates","ref":"Raxol.Core.Renderer.Manager.html","title":"Raxol.Core.Renderer.Manager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Renderer.Manager.html#child_spec/1","title":"Raxol.Core.Renderer.Manager.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Manager.html#cleanup/0","title":"Raxol.Core.Renderer.Manager.cleanup/0","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Manager.html#initialize/1","title":"Raxol.Core.Renderer.Manager.initialize/1","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Manager.html#render/1","title":"Raxol.Core.Renderer.Manager.render/1","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Manager.html#start_link/1","title":"Raxol.Core.Renderer.Manager.start_link/1","type":"function"},{"doc":"Provides view-related functionality for rendering UI components.","ref":"Raxol.Core.Renderer.View.html","title":"Raxol.Core.Renderer.View","type":"module"},{"doc":"Wraps a view with a border using a block style.","ref":"Raxol.Core.Renderer.View.html#block_border/2","title":"Raxol.Core.Renderer.View.block_border/2","type":"function"},{"doc":"* `view` - The view to wrap with a border\n  * `opts` - Options for the border\n    * `:title` - Optional title to display in the border\n    * `:align` - Title alignment (`:left`, `:center`, `:right`)","ref":"Raxol.Core.Renderer.View.html#block_border/2-parameters","title":"Parameters - Raxol.Core.Renderer.View.block_border/2","type":"function"},{"doc":"View.block_border(view)\n    View.block_border(view, title: \"Title\")","ref":"Raxol.Core.Renderer.View.html#block_border/2-examples","title":"Examples - Raxol.Core.Renderer.View.block_border/2","type":"function"},{"doc":"Wraps a view with a border using a bold style.","ref":"Raxol.Core.Renderer.View.html#bold_border/2","title":"Raxol.Core.Renderer.View.bold_border/2","type":"function"},{"doc":"* `view` - The view to wrap with a border\n  * `opts` - Options for the border\n    * `:title` - Optional title to display in the border\n    * `:align` - Title alignment (`:left`, `:center`, `:right`)","ref":"Raxol.Core.Renderer.View.html#bold_border/2-parameters","title":"Parameters - Raxol.Core.Renderer.View.bold_border/2","type":"function"},{"doc":"View.bold_border(view)\n    View.bold_border(view, title: \"Title\")","ref":"Raxol.Core.Renderer.View.html#bold_border/2-examples","title":"Examples - Raxol.Core.Renderer.View.bold_border/2","type":"function"},{"doc":"Creates a new border around a view.","ref":"Raxol.Core.Renderer.View.html#border/2","title":"Raxol.Core.Renderer.View.border/2","type":"function"},{"doc":"* `:style` - Border style\n  * `:title` - Title for the border\n  * `:fg` - Foreground color\n  * `:bg` - Background color","ref":"Raxol.Core.Renderer.View.html#border/2-options","title":"Options - Raxol.Core.Renderer.View.border/2","type":"function"},{"doc":"View.border(view, style: :single)\n    View.border(view, title: \"Title\", style: :double)","ref":"Raxol.Core.Renderer.View.html#border/2-examples","title":"Examples - Raxol.Core.Renderer.View.border/2","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.View.html#border/3","title":"Raxol.Core.Renderer.View.border/3","type":"macro"},{"doc":"Macro for creating a border around a view with a do-block for children.","ref":"Raxol.Core.Renderer.View.html#border_wrap/2","title":"Raxol.Core.Renderer.View.border_wrap/2","type":"macro"},{"doc":"View.border_wrap style: [:bold] do\n      [View.text(\"A\"), View.text(\"B\")]\n    end\n\n    View.border_wrap :single, style: [:bold] do\n      [View.text(\"A\"), View.text(\"B\")]\n    end","ref":"Raxol.Core.Renderer.View.html#border_wrap/2-examples","title":"Examples - Raxol.Core.Renderer.View.border_wrap/2","type":"macro"},{"doc":"Creates a new box view with padding and optional border.","ref":"Raxol.Core.Renderer.View.html#box/1","title":"Raxol.Core.Renderer.View.box/1","type":"function"},{"doc":"* `opts` - Options for the box\n    * `:padding` - Padding around the content (default: 0)\n    * `:border` - Border style (`:none`, `:single`, `:double`, `:rounded`, `:bold`, `:block`, `:simple`)\n    * `:children` - Child views to place inside the box\n    * `:size` - Size of the box {width, height}\n    * `:style` - Style options for the box","ref":"Raxol.Core.Renderer.View.html#box/1-parameters","title":"Parameters - Raxol.Core.Renderer.View.box/1","type":"function"},{"doc":"View.box(padding: 2)\n    View.box(padding: 2, border: :single)\n    View.box(style: [border: :double, padding: 1], children: [text(\"Hello\")])","ref":"Raxol.Core.Renderer.View.html#box/1-examples","title":"Examples - Raxol.Core.Renderer.View.box/1","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.View.html#box/2","title":"Raxol.Core.Renderer.View.box/2","type":"macro"},{"doc":"Creates a simple box element with the given options.","ref":"Raxol.Core.Renderer.View.html#box_element/1","title":"Raxol.Core.Renderer.View.box_element/1","type":"function"},{"doc":"Creates a button element.","ref":"Raxol.Core.Renderer.View.html#button/2","title":"Raxol.Core.Renderer.View.button/2","type":"function"},{"doc":"* `:on_click` - Event handler for click events\n  * `:aria_label` - Accessibility label\n  * `:aria_description` - Accessibility description\n  * `:style` - Style options for the button","ref":"Raxol.Core.Renderer.View.html#button/2-options","title":"Options - Raxol.Core.Renderer.View.button/2","type":"function"},{"doc":"View.button(\"Click Me\", on_click: {:button_clicked})\n    View.button(\"Submit\", aria_label: \"Submit form\")","ref":"Raxol.Core.Renderer.View.html#button/2-examples","title":"Examples - Raxol.Core.Renderer.View.button/2","type":"function"},{"doc":"Creates a checkbox element.","ref":"Raxol.Core.Renderer.View.html#checkbox/2","title":"Raxol.Core.Renderer.View.checkbox/2","type":"function"},{"doc":"* `:checked` - Whether the checkbox is checked (default: false)\n  * `:on_toggle` - Event handler for toggle events\n  * `:aria_label` - Accessibility label\n  * `:aria_description` - Accessibility description\n  * `:style` - Style options for the checkbox","ref":"Raxol.Core.Renderer.View.html#checkbox/2-options","title":"Options - Raxol.Core.Renderer.View.checkbox/2","type":"function"},{"doc":"View.checkbox(\"Enable Feature\", checked: true)\n    View.checkbox(\"Accept Terms\", on_toggle: {:terms_toggled})","ref":"Raxol.Core.Renderer.View.html#checkbox/2-examples","title":"Examples - Raxol.Core.Renderer.View.checkbox/2","type":"function"},{"doc":"Creates a new column layout.","ref":"Raxol.Core.Renderer.View.html#column/1","title":"Raxol.Core.Renderer.View.column/1","type":"function"},{"doc":"* `:children` - Child views\n  * `:align` - Alignment of children\n  * `:justify` - Justification of children\n  * `:gap` - Gap between children","ref":"Raxol.Core.Renderer.View.html#column/1-options","title":"Options - Raxol.Core.Renderer.View.column/1","type":"function"},{"doc":"View.column do\n      [text(\"Hello\"), text(\"World\")]\n    end\n    View.column align: :center, gap: 2 do\n      [text(\"A\"), text(\"B\")]\n    end","ref":"Raxol.Core.Renderer.View.html#column/1-examples","title":"Examples - Raxol.Core.Renderer.View.column/1","type":"function"},{"doc":"Wraps a view with a border using a double line style.","ref":"Raxol.Core.Renderer.View.html#double_border/2","title":"Raxol.Core.Renderer.View.double_border/2","type":"function"},{"doc":"* `view` - The view to wrap with a border\n  * `opts` - Options for the border\n    * `:title` - Optional title to display in the border\n    * `:align` - Title alignment (`:left`, `:center`, `:right`)","ref":"Raxol.Core.Renderer.View.html#double_border/2-parameters","title":"Parameters - Raxol.Core.Renderer.View.double_border/2","type":"function"},{"doc":"View.double_border(view)\n    View.double_border(view, title: \"Title\")","ref":"Raxol.Core.Renderer.View.html#double_border/2-examples","title":"Examples - Raxol.Core.Renderer.View.double_border/2","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.View.html#ensure_keyword/1","title":"Raxol.Core.Renderer.View.ensure_keyword/1","type":"macro"},{"doc":"Calculates flex layout dimensions based on the given constraints.\nReturns a map with calculated width and height.","ref":"Raxol.Core.Renderer.View.html#flex/1","title":"Raxol.Core.Renderer.View.flex/1","type":"function"},{"doc":"Creates a new flex container.","ref":"Raxol.Core.Renderer.View.html#flex/2","title":"Raxol.Core.Renderer.View.flex/2","type":"macro"},{"doc":"* `:direction` - Flex direction (:row or :column)\n  * `:children` - Child views\n  * `:align` - Alignment of children\n  * `:justify` - Justification of children\n  * `:gap` - Gap between children\n  * `:wrap` - Whether to wrap children","ref":"Raxol.Core.Renderer.View.html#flex/2-options","title":"Options - Raxol.Core.Renderer.View.flex/2","type":"macro"},{"doc":"View.flex(direction: :column, children: [text(\"Hello\"), text(\"World\")])\n    View.flex(align: :center, gap: 2, wrap: true)","ref":"Raxol.Core.Renderer.View.html#flex/2-examples","title":"Examples - Raxol.Core.Renderer.View.flex/2","type":"macro"},{"doc":"","ref":"Raxol.Core.Renderer.View.html#grid/1","title":"Raxol.Core.Renderer.View.grid/1","type":"macro"},{"doc":"Creates a grid layout with the given options and block.","ref":"Raxol.Core.Renderer.View.html#grid/2","title":"Raxol.Core.Renderer.View.grid/2","type":"macro"},{"doc":"* `:columns` - Number of columns in the grid\n  * `:rows` - Number of rows in the grid\n  * `:gap` - Gap between grid items\n  * `:align` - Alignment of grid items\n  * `:justify` - Justification of grid items","ref":"Raxol.Core.Renderer.View.html#grid/2-options","title":"Options - Raxol.Core.Renderer.View.grid/2","type":"macro"},{"doc":"View.grid(columns: 2, gap: 2) do\n      [text(\"A\"), text(\"B\"), text(\"C\"), text(\"D\")]\n    end","ref":"Raxol.Core.Renderer.View.html#grid/2-examples","title":"Examples - Raxol.Core.Renderer.View.grid/2","type":"macro"},{"doc":"Applies layout to a view, calculating absolute positions for all elements.\nDelegates to Raxol.Renderer.Layout.apply_layout/2.","ref":"Raxol.Core.Renderer.View.html#layout/2","title":"Raxol.Core.Renderer.View.layout/2","type":"function"},{"doc":"Creates a new view with the specified type and options.","ref":"Raxol.Core.Renderer.View.html#new/2","title":"Raxol.Core.Renderer.View.new/2","type":"function"},{"doc":"* `:type` - The type of view to create\n  * `:position` - Position of the view {x, y}\n  * `:z_index` - Z-index for layering\n  * `:size` - Size of the view {width, height}\n  * `:style` - Style options for the view\n  * `:fg` - Foreground color\n  * `:bg` - Background color\n  * `:border` - Border style\n  * `:padding` - Padding around the view\n  * `:margin` - Margin around the view\n  * `:children` - Child views\n  * `:content` - Content for the view","ref":"Raxol.Core.Renderer.View.html#new/2-options","title":"Options - Raxol.Core.Renderer.View.new/2","type":"function"},{"doc":"View.new(:box, size: {80, 24})\n    View.new(:text, content: \"Hello\", fg: :red)","ref":"Raxol.Core.Renderer.View.html#new/2-examples","title":"Examples - Raxol.Core.Renderer.View.new/2","type":"function"},{"doc":"Creates a new panel view (box with border and children).","ref":"Raxol.Core.Renderer.View.html#panel/1","title":"Raxol.Core.Renderer.View.panel/1","type":"function"},{"doc":"* `:children` - Child views\n  * `:border` - Border style (default: :single)\n  * `:padding` - Padding inside the panel (default: 1)\n  * `:style` - Additional style options\n  * `:title` - Optional title for the panel\n  * `:fg` - Foreground color\n  * `:bg` - Background color","ref":"Raxol.Core.Renderer.View.html#panel/1-options","title":"Options - Raxol.Core.Renderer.View.panel/1","type":"function"},{"doc":"View.panel(children: [View.text(\"Hello\")])\n    View.panel(border: :double, title: \"Panel\")\n\nNOTE: Only panel/1 (with a keyword list) is supported. Update any panel/2 usages to panel/1.","ref":"Raxol.Core.Renderer.View.html#panel/1-examples","title":"Examples - Raxol.Core.Renderer.View.panel/1","type":"function"},{"doc":"Wraps a view with a border using a rounded style.","ref":"Raxol.Core.Renderer.View.html#rounded_border/2","title":"Raxol.Core.Renderer.View.rounded_border/2","type":"function"},{"doc":"* `view` - The view to wrap with a border\n  * `opts` - Options for the border\n    * `:title` - Optional title to display in the border\n    * `:align` - Title alignment (`:left`, `:center`, `:right`)","ref":"Raxol.Core.Renderer.View.html#rounded_border/2-parameters","title":"Parameters - Raxol.Core.Renderer.View.rounded_border/2","type":"function"},{"doc":"View.rounded_border(view)\n    View.rounded_border(view, title: \"Title\")","ref":"Raxol.Core.Renderer.View.html#rounded_border/2-examples","title":"Examples - Raxol.Core.Renderer.View.rounded_border/2","type":"function"},{"doc":"Creates a new row layout.","ref":"Raxol.Core.Renderer.View.html#row/1","title":"Raxol.Core.Renderer.View.row/1","type":"function"},{"doc":"* `:children` - Child views\n  * `:align` - Alignment of children\n  * `:justify` - Justification of children\n  * `:gap` - Gap between children","ref":"Raxol.Core.Renderer.View.html#row/1-options","title":"Options - Raxol.Core.Renderer.View.row/1","type":"function"},{"doc":"View.row do\n      [text(\"Hello\"), text(\"World\")]\n    end\n    View.row align: :center, gap: 2 do\n      [text(\"A\"), text(\"B\")]\n    end","ref":"Raxol.Core.Renderer.View.html#row/1-examples","title":"Examples - Raxol.Core.Renderer.View.row/1","type":"function"},{"doc":"Macro for creating a row layout with a do-block for children.","ref":"Raxol.Core.Renderer.View.html#row/2","title":"Raxol.Core.Renderer.View.row/2","type":"macro"},{"doc":"View.row style: [:bold] do\n      [View.text(\"A\"), View.text(\"B\")]\n    end","ref":"Raxol.Core.Renderer.View.html#row/2-examples","title":"Examples - Raxol.Core.Renderer.View.row/2","type":"macro"},{"doc":"Creates a new scrollable view.","ref":"Raxol.Core.Renderer.View.html#scroll/2","title":"Raxol.Core.Renderer.View.scroll/2","type":"function"},{"doc":"* `:viewport` - Viewport size {width, height}\n  * `:offset` - Initial scroll offset {x, y}\n  * `:scrollbars` - Whether to show scrollbars\n  * `:fg` - Foreground color\n  * `:bg` - Background color","ref":"Raxol.Core.Renderer.View.html#scroll/2-options","title":"Options - Raxol.Core.Renderer.View.scroll/2","type":"function"},{"doc":"View.scroll(view, viewport: {80, 24})\n    View.scroll(view, offset: {0, 10}, scrollbars: true)","ref":"Raxol.Core.Renderer.View.html#scroll/2-examples","title":"Examples - Raxol.Core.Renderer.View.scroll/2","type":"function"},{"doc":"Macro for creating a scrollable view with a do-block for children.","ref":"Raxol.Core.Renderer.View.html#scroll_wrap/2","title":"Raxol.Core.Renderer.View.scroll_wrap/2","type":"macro"},{"doc":"View.scroll_wrap viewport: {80, 24} do\n      [View.text(\"A\"), View.text(\"B\")]\n    end","ref":"Raxol.Core.Renderer.View.html#scroll_wrap/2-examples","title":"Examples - Raxol.Core.Renderer.View.scroll_wrap/2","type":"macro"},{"doc":"Wraps a view with a border using a simple style.","ref":"Raxol.Core.Renderer.View.html#simple_border/2","title":"Raxol.Core.Renderer.View.simple_border/2","type":"function"},{"doc":"* `view` - The view to wrap with a border\n  * `opts` - Options for the border\n    * `:title` - Optional title to display in the border\n    * `:align` - Title alignment (`:left`, `:center`, `:right`)","ref":"Raxol.Core.Renderer.View.html#simple_border/2-parameters","title":"Parameters - Raxol.Core.Renderer.View.simple_border/2","type":"function"},{"doc":"View.simple_border(view)\n    View.simple_border(view, title: \"Title\")","ref":"Raxol.Core.Renderer.View.html#simple_border/2-examples","title":"Examples - Raxol.Core.Renderer.View.simple_border/2","type":"function"},{"doc":"Style options for a view. Typically a list of atoms, e.g., [:bold, :underline].\nSee `Raxol.Core.Renderer.View.Types.style/0` for details.","ref":"Raxol.Core.Renderer.View.html#t:style/0","title":"Raxol.Core.Renderer.View.style/0","type":"type"},{"doc":"Creates a new text view.","ref":"Raxol.Core.Renderer.View.html#text/2","title":"Raxol.Core.Renderer.View.text/2","type":"function"},{"doc":"* `:content` - The text content\n  * `:fg` - Foreground color\n  * `:bg` - Background color\n  * `:style` - Text style options\n  * `:align` - Text alignment\n  * `:wrap` - Text wrapping mode","ref":"Raxol.Core.Renderer.View.html#text/2-options","title":"Options - Raxol.Core.Renderer.View.text/2","type":"function"},{"doc":"View.text(\"Hello\", fg: :red)\n    View.text(\"World\", style: [bold: true, underline: true])","ref":"Raxol.Core.Renderer.View.html#text/2-examples","title":"Examples - Raxol.Core.Renderer.View.text/2","type":"function"},{"doc":"Creates a text input element.","ref":"Raxol.Core.Renderer.View.html#text_input/1","title":"Raxol.Core.Renderer.View.text_input/1","type":"function"},{"doc":"* `:value` - Current value of the input (default: \"\")\n  * `:placeholder` - Placeholder text\n  * `:on_change` - Event handler for change events\n  * `:aria_label` - Accessibility label\n  * `:aria_description` - Accessibility description\n  * `:style` - Style options for the input","ref":"Raxol.Core.Renderer.View.html#text_input/1-options","title":"Options - Raxol.Core.Renderer.View.text_input/1","type":"function"},{"doc":"View.text_input(placeholder: \"Enter your name...\")\n    View.text_input(value: \"John\", on_change: {:name_changed})","ref":"Raxol.Core.Renderer.View.html#text_input/1-examples","title":"Examples - Raxol.Core.Renderer.View.text_input/1","type":"function"},{"doc":"Renders a view with the given options.","ref":"Raxol.Core.Renderer.View.html#view/2","title":"Raxol.Core.Renderer.View.view/2","type":"macro"},{"doc":"- _options: A keyword list of rendering options\n  - _block: A block containing the view content","ref":"Raxol.Core.Renderer.View.html#view/2-parameters","title":"Parameters - Raxol.Core.Renderer.View.view/2","type":"macro"},{"doc":"- A rendered view","ref":"Raxol.Core.Renderer.View.html#view/2-returns","title":"Returns - Raxol.Core.Renderer.View.view/2","type":"macro"},{"doc":"Wraps a view with a border, optionally with a title and style.","ref":"Raxol.Core.Renderer.View.html#wrap_with_border/2","title":"Raxol.Core.Renderer.View.wrap_with_border/2","type":"function"},{"doc":"* `view` - The view to wrap with a border\n  * `opts` - Options for the border\n    * `:title` - Optional title to display in the border\n    * `:style` - Border style (`:single`, `:double`, `:rounded`, `:bold`, `:block`, `:simple`)\n    * `:align` - Title alignment (`:left`, `:center`, `:right`)","ref":"Raxol.Core.Renderer.View.html#wrap_with_border/2-parameters","title":"Parameters - Raxol.Core.Renderer.View.wrap_with_border/2","type":"function"},{"doc":"View.border_wrap(view, style: :single)\n    View.border_wrap(view, title: \"Title\", style: :double)","ref":"Raxol.Core.Renderer.View.html#wrap_with_border/2-examples","title":"Examples - Raxol.Core.Renderer.View.wrap_with_border/2","type":"function"},{"doc":"Handles box layout functionality for the Raxol view system.\nProvides box model layout with content, padding, border, and margin.","ref":"Raxol.Core.Renderer.View.Components.Box.html","title":"Raxol.Core.Renderer.View.Components.Box","type":"module"},{"doc":"Calculates the layout of a box and its children.","ref":"Raxol.Core.Renderer.View.Components.Box.html#calculate_layout/2","title":"Raxol.Core.Renderer.View.Components.Box.calculate_layout/2","type":"function"},{"doc":"Creates a new box view.","ref":"Raxol.Core.Renderer.View.Components.Box.html#new/1","title":"Raxol.Core.Renderer.View.Components.Box.new/1","type":"function"},{"doc":"* `:children` - List of child views\n  * `:padding` - Padding around content (integer or {top, right, bottom, left})\n  * `:margin` - Margin around box (integer or {top, right, bottom, left})\n  * `:border` - Border style (:none, :single, :double, :rounded, :bold, :dashed)\n  * `:fg` - Foreground color\n  * `:bg` - Background color\n  * `:size` - Box size {width, height}","ref":"Raxol.Core.Renderer.View.Components.Box.html#new/1-options","title":"Options - Raxol.Core.Renderer.View.Components.Box.new/1","type":"function"},{"doc":"Box.new(children: [view1, view2], padding: 1)\n    Box.new(padding: {1, 2, 1, 2}, border: :single)","ref":"Raxol.Core.Renderer.View.Components.Box.html#new/1-examples","title":"Examples - Raxol.Core.Renderer.View.Components.Box.new/1","type":"function"},{"doc":"Handles scrollable views for the Raxol view system.\nProvides viewport management, scrollbar rendering, and content scrolling.","ref":"Raxol.Core.Renderer.View.Components.Scroll.html","title":"Raxol.Core.Renderer.View.Components.Scroll","type":"module"},{"doc":"Calculates the layout of a scrollable view.","ref":"Raxol.Core.Renderer.View.Components.Scroll.html#calculate_layout/2","title":"Raxol.Core.Renderer.View.Components.Scroll.calculate_layout/2","type":"function"},{"doc":"Creates a new scrollable view.","ref":"Raxol.Core.Renderer.View.Components.Scroll.html#new/2","title":"Raxol.Core.Renderer.View.Components.Scroll.new/2","type":"function"},{"doc":"* `:viewport` - Viewport size {width, height}\n  * `:offset` - Initial scroll offset {x, y}\n  * `:scrollbars` - Whether to show scrollbars (boolean)\n  * `:fg` - Foreground color\n  * `:bg` - Background color","ref":"Raxol.Core.Renderer.View.Components.Scroll.html#new/2-options","title":"Options - Raxol.Core.Renderer.View.Components.Scroll.new/2","type":"function"},{"doc":"Scroll.new(content, viewport: {80, 24})\n    Scroll.new(content, offset: {0, 10}, scrollbars: true)","ref":"Raxol.Core.Renderer.View.Components.Scroll.html#new/2-examples","title":"Examples - Raxol.Core.Renderer.View.Components.Scroll.new/2","type":"function"},{"doc":"Updates the scroll offset of a view.","ref":"Raxol.Core.Renderer.View.Components.Scroll.html#update_offset/2","title":"Raxol.Core.Renderer.View.Components.Scroll.update_offset/2","type":"function"},{"doc":"Handles text rendering for the Raxol view system.\nProvides text styling, wrapping, and alignment functionality.","ref":"Raxol.Core.Renderer.View.Components.Text.html","title":"Raxol.Core.Renderer.View.Components.Text","type":"module"},{"doc":"Creates a new text view.","ref":"Raxol.Core.Renderer.View.Components.Text.html#new/2","title":"Raxol.Core.Renderer.View.Components.Text.new/2","type":"function"},{"doc":"* `:fg` - Foreground color\n  * `:bg` - Background color\n  * `:style` - List of style atoms (e.g., [:bold, :underline])\n  * `:align` - Text alignment (:left, :center, :right)\n  * `:wrap` - Text wrapping mode (:none, :char, :word)","ref":"Raxol.Core.Renderer.View.Components.Text.html#new/2-options","title":"Options - Raxol.Core.Renderer.View.Components.Text.new/2","type":"function"},{"doc":"Text.new(\"Hello, World!\", fg: :red, style: [:bold])\n    Text.new(\"Centered text\", align: :center)","ref":"Raxol.Core.Renderer.View.Components.Text.html#new/2-examples","title":"Examples - Raxol.Core.Renderer.View.Components.Text.new/2","type":"function"},{"doc":"Renders text with the given options and width.","ref":"Raxol.Core.Renderer.View.Components.Text.html#render/2","title":"Raxol.Core.Renderer.View.Components.Text.render/2","type":"function"},{"doc":"Handles flex layout functionality for the Raxol view system.\nProvides row and column layouts with various alignment and justification options.","ref":"Raxol.Core.Renderer.View.Layout.Flex.html","title":"Raxol.Core.Renderer.View.Layout.Flex","type":"module"},{"doc":"Calculates the layout of flex children based on container size and options.","ref":"Raxol.Core.Renderer.View.Layout.Flex.html#calculate_layout/2","title":"Raxol.Core.Renderer.View.Layout.Flex.calculate_layout/2","type":"function"},{"doc":"Creates a column layout container that arranges its children vertically.","ref":"Raxol.Core.Renderer.View.Layout.Flex.html#column/1","title":"Raxol.Core.Renderer.View.Layout.Flex.column/1","type":"function"},{"doc":"* `:children` - List of child views to arrange vertically\n  * `:align` - Alignment of children (:start, :center, :end)\n  * `:justify` - Justification of children (:start, :center, :end, :space_between)\n  * `:gap` - Space between children (integer)","ref":"Raxol.Core.Renderer.View.Layout.Flex.html#column/1-options","title":"Options - Raxol.Core.Renderer.View.Layout.Flex.column/1","type":"function"},{"doc":"Flex.column(children: [view1, view2])\n    Flex.column(align: :center, justify: :space_between, children: [view1, view2])","ref":"Raxol.Core.Renderer.View.Layout.Flex.html#column/1-examples","title":"Examples - Raxol.Core.Renderer.View.Layout.Flex.column/1","type":"function"},{"doc":"Creates a flex container that arranges its children in the specified direction.","ref":"Raxol.Core.Renderer.View.Layout.Flex.html#container/1","title":"Raxol.Core.Renderer.View.Layout.Flex.container/1","type":"function"},{"doc":"* `:direction` - Direction of flex layout (:row or :column)\n  * `:children` - List of child views\n  * `:align` - Alignment of children (:start, :center, :end)\n  * `:justify` - Justification of children (:start, :center, :end, :space_between)\n  * `:gap` - Space between children (integer)\n  * `:wrap` - Whether to wrap children (boolean)","ref":"Raxol.Core.Renderer.View.Layout.Flex.html#container/1-options","title":"Options - Raxol.Core.Renderer.View.Layout.Flex.container/1","type":"function"},{"doc":"Flex.container(direction: :row, children: [view1, view2])\n    Flex.container(direction: :column, align: :center, children: [view1, view2])","ref":"Raxol.Core.Renderer.View.Layout.Flex.html#container/1-examples","title":"Examples - Raxol.Core.Renderer.View.Layout.Flex.container/1","type":"function"},{"doc":"Creates a row layout container that arranges its children horizontally.","ref":"Raxol.Core.Renderer.View.Layout.Flex.html#row/1","title":"Raxol.Core.Renderer.View.Layout.Flex.row/1","type":"function"},{"doc":"* `:children` - List of child views to arrange horizontally\n  * `:align` - Alignment of children (:start, :center, :end)\n  * `:justify` - Justification of children (:start, :center, :end, :space_between)\n  * `:gap` - Space between children (integer)","ref":"Raxol.Core.Renderer.View.Layout.Flex.html#row/1-options","title":"Options - Raxol.Core.Renderer.View.Layout.Flex.row/1","type":"function"},{"doc":"Flex.row(children: [view1, view2])\n    Flex.row(align: :center, justify: :space_between, children: [view1, view2])","ref":"Raxol.Core.Renderer.View.Layout.Flex.html#row/1-examples","title":"Examples - Raxol.Core.Renderer.View.Layout.Flex.row/1","type":"function"},{"doc":"Handles grid-based layouts for the Raxol view system.\nProvides functionality for creating and managing grid layouts with customizable columns and rows.","ref":"Raxol.Core.Renderer.View.Layout.Grid.html","title":"Raxol.Core.Renderer.View.Layout.Grid","type":"module"},{"doc":"Adds a child to the grid at the specified position.","ref":"Raxol.Core.Renderer.View.Layout.Grid.html#add_child/3","title":"Raxol.Core.Renderer.View.Layout.Grid.add_child/3","type":"function"},{"doc":"Calculates the layout of a grid.","ref":"Raxol.Core.Renderer.View.Layout.Grid.html#calculate_layout/2","title":"Raxol.Core.Renderer.View.Layout.Grid.calculate_layout/2","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.View.Layout.Grid.html#container/1","title":"Raxol.Core.Renderer.View.Layout.Grid.container/1","type":"function"},{"doc":"Creates a new grid layout.","ref":"Raxol.Core.Renderer.View.Layout.Grid.html#new/1","title":"Raxol.Core.Renderer.View.Layout.Grid.new/1","type":"function"},{"doc":"* `:columns` - Number of columns or list of column sizes\n  * `:rows` - Number of rows or list of row sizes\n  * `:gap` - Gap between grid items {x, y}\n  * `:align` - Alignment of items within grid cells\n  * `:justify` - Justification of items within grid cells\n  * `:children` - List of child views to place in the grid","ref":"Raxol.Core.Renderer.View.Layout.Grid.html#new/1-options","title":"Options - Raxol.Core.Renderer.View.Layout.Grid.new/1","type":"function"},{"doc":"Grid.new(columns: 3, rows: 2)\n    Grid.new(columns: [1, 2, 1], rows: [\"auto\", \"1fr\"])","ref":"Raxol.Core.Renderer.View.Layout.Grid.html#new/1-examples","title":"Examples - Raxol.Core.Renderer.View.Layout.Grid.new/1","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.View.Layout.Grid.html#validate_children/1","title":"Raxol.Core.Renderer.View.Layout.Grid.validate_children/1","type":"function"},{"doc":"Handles border rendering for the Raxol view system.\nProvides various border styles and rendering functionality.","ref":"Raxol.Core.Renderer.View.Style.Border.html","title":"Raxol.Core.Renderer.View.Style.Border","type":"module"},{"doc":"Renders a border around a view with the given style and dimensions.","ref":"Raxol.Core.Renderer.View.Style.Border.html#render_border/3","title":"Raxol.Core.Renderer.View.Style.Border.render_border/3","type":"function"},{"doc":"Creates a border around a view.","ref":"Raxol.Core.Renderer.View.Style.Border.html#wrap/2","title":"Raxol.Core.Renderer.View.Style.Border.wrap/2","type":"function"},{"doc":"* `:style` - Border style (:single, :double, :rounded, :bold, :dashed)\n  * `:title` - Optional title to display in the border\n  * `:fg` - Foreground color\n  * `:bg` - Background color","ref":"Raxol.Core.Renderer.View.Style.Border.html#wrap/2-options","title":"Options - Raxol.Core.Renderer.View.Style.Border.wrap/2","type":"function"},{"doc":"Border.wrap(view, style: :single)\n    Border.wrap(view, style: :double, title: \"Title\")","ref":"Raxol.Core.Renderer.View.Style.Border.html#wrap/2-examples","title":"Examples - Raxol.Core.Renderer.View.Style.Border.wrap/2","type":"function"},{"doc":"Type definitions for the Raxol view system.","ref":"Raxol.Core.Renderer.View.Types.html","title":"Raxol.Core.Renderer.View.Types","type":"module"},{"doc":"Returns the border characters for different border styles.","ref":"Raxol.Core.Renderer.View.Types.html#border_chars/0","title":"Raxol.Core.Renderer.View.Types.border_chars/0","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.View.Types.html#t:border_style/0","title":"Raxol.Core.Renderer.View.Types.border_style/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.View.Types.html#t:color/0","title":"Raxol.Core.Renderer.View.Types.color/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.View.Types.html#t:layout_type/0","title":"Raxol.Core.Renderer.View.Types.layout_type/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.View.Types.html#t:margin/0","title":"Raxol.Core.Renderer.View.Types.margin/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.View.Types.html#t:padding/0","title":"Raxol.Core.Renderer.View.Types.padding/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.View.Types.html#t:position/0","title":"Raxol.Core.Renderer.View.Types.position/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.View.Types.html#t:position_type/0","title":"Raxol.Core.Renderer.View.Types.position_type/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.View.Types.html#t:size/0","title":"Raxol.Core.Renderer.View.Types.size/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.View.Types.html#t:style/0","title":"Raxol.Core.Renderer.View.Types.style/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.View.Types.html#t:view/0","title":"Raxol.Core.Renderer.View.Types.view/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.View.Types.html#t:z_index/0","title":"Raxol.Core.Renderer.View.Types.z_index/0","type":"type"},{"doc":"Provides utility functions for common view operations in the Raxol view system.","ref":"Raxol.Core.Renderer.View.Utils.ViewUtils.html","title":"Raxol.Core.Renderer.View.Utils.ViewUtils","type":"module"},{"doc":"Applies foreground and background colors to text.","ref":"Raxol.Core.Renderer.View.Utils.ViewUtils.html#apply_colors/2","title":"Raxol.Core.Renderer.View.Utils.ViewUtils.apply_colors/2","type":"function"},{"doc":"apply_colors(\"Hello\", fg: :red, bg: :blue)\n    apply_colors(\"World\", fg: {255, 0, 0}, bg: {0, 0, 255})","ref":"Raxol.Core.Renderer.View.Utils.ViewUtils.html#apply_colors/2-examples","title":"Examples - Raxol.Core.Renderer.View.Utils.ViewUtils.apply_colors/2","type":"function"},{"doc":"Applies styles to a string of text.","ref":"Raxol.Core.Renderer.View.Utils.ViewUtils.html#apply_styles/2","title":"Raxol.Core.Renderer.View.Utils.ViewUtils.apply_styles/2","type":"function"},{"doc":"* `:bold` - Makes text bold\n  * `:underline` - Underlines text\n  * `:italic` - Makes text italic\n  * `:strikethrough` - Adds strikethrough to text","ref":"Raxol.Core.Renderer.View.Utils.ViewUtils.html#apply_styles/2-options","title":"Options - Raxol.Core.Renderer.View.Utils.ViewUtils.apply_styles/2","type":"function"},{"doc":"Calculates the dimensions of a view based on its content and constraints.","ref":"Raxol.Core.Renderer.View.Utils.ViewUtils.html#calculate_dimensions/2","title":"Raxol.Core.Renderer.View.Utils.ViewUtils.calculate_dimensions/2","type":"function"},{"doc":"Converts a color name to its ANSI color code.","ref":"Raxol.Core.Renderer.View.Utils.ViewUtils.html#color_to_code/1","title":"Raxol.Core.Renderer.View.Utils.ViewUtils.color_to_code/1","type":"function"},{"doc":"Merges two views, with the second view's properties taking precedence.","ref":"Raxol.Core.Renderer.View.Utils.ViewUtils.html#merge_views/2","title":"Raxol.Core.Renderer.View.Utils.ViewUtils.merge_views/2","type":"function"},{"doc":"Normalizes spacing values for padding and margin.\nAccepts various input formats and converts them to a standardized format.","ref":"Raxol.Core.Renderer.View.Utils.ViewUtils.html#normalize_spacing/1","title":"Raxol.Core.Renderer.View.Utils.ViewUtils.normalize_spacing/1","type":"function"},{"doc":"normalize_spacing(5)           # {5, 5, 5, 5}\n    normalize_spacing({10, 20})    # {10, 20, 10, 20}\n    normalize_spacing({1, 2, 3, 4}) # {1, 2, 3, 4}","ref":"Raxol.Core.Renderer.View.Utils.ViewUtils.html#normalize_spacing/1-examples","title":"Examples - Raxol.Core.Renderer.View.Utils.ViewUtils.normalize_spacing/1","type":"function"},{"doc":"Chart view component for data visualization.\n\nSupports:\n* Bar charts (vertical and horizontal)\n* Line charts\n* Sparklines\n* Axes and labels\n* Multiple series\n* Custom styling","ref":"Raxol.Core.Renderer.Views.Chart.html","title":"Raxol.Core.Renderer.Views.Chart","type":"module"},{"doc":"","ref":"Raxol.Core.Renderer.Views.Chart.html#t:chart_type/0","title":"Raxol.Core.Renderer.Views.Chart.chart_type/0","type":"type"},{"doc":"Creates a new chart view.","ref":"Raxol.Core.Renderer.Views.Chart.html#new/1","title":"Raxol.Core.Renderer.Views.Chart.new/1","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Views.Chart.html#t:options/0","title":"Raxol.Core.Renderer.Views.Chart.options/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.Views.Chart.html#t:orientation/0","title":"Raxol.Core.Renderer.Views.Chart.orientation/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.Views.Chart.html#t:series/0","title":"Raxol.Core.Renderer.Views.Chart.series/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.Views.PerformanceTest.TestHostComponent.html","title":"Raxol.Core.Renderer.Views.PerformanceTest.TestHostComponent","type":"module"},{"doc":"","ref":"Raxol.Core.Renderer.Views.PerformanceTest.TestHostComponent.html#init/1","title":"Raxol.Core.Renderer.Views.PerformanceTest.TestHostComponent.init/1","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Views.PerformanceTest.TestHostComponent.html#mount/1","title":"Raxol.Core.Renderer.Views.PerformanceTest.TestHostComponent.mount/1","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Views.PerformanceTest.TestHostComponent.html#render/1","title":"Raxol.Core.Renderer.Views.PerformanceTest.TestHostComponent.render/1","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Views.PerformanceTest.TestHostComponent.html#update/2","title":"Raxol.Core.Renderer.Views.PerformanceTest.TestHostComponent.update/2","type":"function"},{"doc":"Table view component for displaying tabular data.\n\nFeatures:\n* Column headers\n* Row striping\n* Column alignment\n* Border styles\n* Column resizing\n* Row selection","ref":"Raxol.Core.Renderer.Views.Table.html","title":"Raxol.Core.Renderer.Views.Table","type":"module"},{"doc":"","ref":"Raxol.Core.Renderer.Views.Table.html#t:column/0","title":"Raxol.Core.Renderer.Views.Table.column/0","type":"type"},{"doc":"","ref":"Raxol.Core.Renderer.Views.Table.html#fetch/2","title":"Raxol.Core.Renderer.Views.Table.fetch/2","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Views.Table.html#get_and_update/3","title":"Raxol.Core.Renderer.Views.Table.get_and_update/3","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Views.Table.html#handle_call/3","title":"Raxol.Core.Renderer.Views.Table.handle_call/3","type":"function"},{"doc":"Handles dispatched events.","ref":"Raxol.Core.Renderer.Views.Table.html#handle_event/3","title":"Raxol.Core.Renderer.Views.Table.handle_event/3","type":"function"},{"doc":"Initializes the Table component with props.\nProps are expected to be a map.","ref":"Raxol.Core.Renderer.Views.Table.html#init/1","title":"Raxol.Core.Renderer.Views.Table.init/1","type":"function"},{"doc":"Called when the component is mounted.","ref":"Raxol.Core.Renderer.Views.Table.html#mount/1","title":"Raxol.Core.Renderer.Views.Table.mount/1","type":"function"},{"doc":"Constructs a Table struct for view usage (not stateful component usage).\nAccepts a map of props and returns the struct directly (not a tuple).","ref":"Raxol.Core.Renderer.Views.Table.html#new/1","title":"Raxol.Core.Renderer.Views.Table.new/1","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Views.Table.html#pop/2","title":"Raxol.Core.Renderer.Views.Table.pop/2","type":"function"},{"doc":"","ref":"Raxol.Core.Renderer.Views.Table.html#t:props/0","title":"Raxol.Core.Renderer.Views.Table.props/0","type":"type"},{"doc":"Renders the Table component based on its current state.","ref":"Raxol.Core.Renderer.Views.Table.html#render/2","title":"Raxol.Core.Renderer.Views.Table.render/2","type":"function"},{"doc":"Renders the table content, potentially with a border.","ref":"Raxol.Core.Renderer.Views.Table.html#render_content/1","title":"Raxol.Core.Renderer.Views.Table.render_content/1","type":"function"},{"doc":"Called when the component is about to be unmounted.","ref":"Raxol.Core.Renderer.Views.Table.html#unmount/1","title":"Raxol.Core.Renderer.Views.Table.unmount/1","type":"function"},{"doc":"Handles updates to the component state.","ref":"Raxol.Core.Renderer.Views.Table.html#update/2","title":"Raxol.Core.Renderer.Views.Table.update/2","type":"function"},{"doc":"Defines the behaviour for Raxol applications following The Elm Architecture (TEA).\n\nThis module provides the core structure for building terminal applications using\na pure functional approach with unidirectional data flow. The architecture is\ncomposed of three main parts:\n\n1. **Model** - The complete state of your application\n2. **Update** - A way to update your state\n3. **View** - A way to view your state as UI elements","ref":"Raxol.Core.Runtime.Application.html","title":"Raxol.Core.Runtime.Application","type":"behaviour"},{"doc":"defmodule MyApp do\n      use Raxol.Core.Runtime.Application\n\n      def init(_context) do\n        %{count: 0}\n      end\n\n      def update(msg, model) do\n        case msg do\n          :increment ->\n            {%{model | count: model.count + 1}, []}\n          :decrement ->\n            {%{model | count: model.count - 1}, []}\n          _ ->\n            {model, []}\n        end\n      end\n\n      def view(model) do\n        view do\n          panel title: \"Counter\" do\n            row do\n              button(label: \"-\", on_click: :decrement)\n              text(content: \"Count: #{model.count}\")\n              button(label: \"+\", on_click: :increment)\n            end\n          end\n        end\n      end\n\n      def subscribe(_model) do\n        # Optional subscriptions to time-based or external events\n        []\n      end\n    end","ref":"Raxol.Core.Runtime.Application.html#module-example","title":"Example - Raxol.Core.Runtime.Application","type":"behaviour"},{"doc":"1. The application starts with `init/1`, which sets up the initial state\n2. Events or messages trigger `update/2`, which computes the new state\n3. State changes cause `view/1` to re-render the UI\n4. `subscribe/1` can set up recurring updates or external event subscriptions","ref":"Raxol.Core.Runtime.Application.html#module-lifecycle","title":"Lifecycle - Raxol.Core.Runtime.Application","type":"behaviour"},{"doc":"The update function returns a tuple of `{new_state, commands}`, where commands\nare used to handle side effects like:\n- API calls\n- File operations\n- Timer operations\n- Inter-process communication\n\nCommands are executed by the runtime system, keeping the update function pure.","ref":"Raxol.Core.Runtime.Application.html#module-commands-and-effects","title":"Commands and Effects - Raxol.Core.Runtime.Application","type":"behaviour"},{"doc":"Subscriptions allow your application to receive messages over time, such as:\n- Timer-based updates\n- System events\n- External data streams\n\nDefine subscriptions in the `subscribe/1` callback, which is called after\ninitialization and after each state update.","ref":"Raxol.Core.Runtime.Application.html#module-subscriptions","title":"Subscriptions - Raxol.Core.Runtime.Application","type":"behaviour"},{"doc":"","ref":"Raxol.Core.Runtime.Application.html#t:command/0","title":"Raxol.Core.Runtime.Application.command/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Application.html#t:context/0","title":"Raxol.Core.Runtime.Application.context/0","type":"type"},{"doc":"Delegates initialization to the provided application module.\n\nAttempts to call the `init/1` callback on the given module, handles the result,\nand returns a standardized tuple of `{model, commands}` or an error.","ref":"Raxol.Core.Runtime.Application.html#delegate_init/2","title":"Raxol.Core.Runtime.Application.delegate_init/2","type":"function"},{"doc":"- app_module: The module that implements the Application behavior\n  - context: The initialization context containing runtime information","ref":"Raxol.Core.Runtime.Application.html#delegate_init/2-parameters","title":"Parameters - Raxol.Core.Runtime.Application.delegate_init/2","type":"function"},{"doc":"- `{model, commands}` tuple when successful\n  - `{:error, reason}` tuple when initialization fails","ref":"Raxol.Core.Runtime.Application.html#delegate_init/2-returns","title":"Returns - Raxol.Core.Runtime.Application.delegate_init/2","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Application.html#delegate_update/3","title":"Raxol.Core.Runtime.Application.delegate_update/3","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Application.html#t:element/0","title":"Raxol.Core.Runtime.Application.element/0","type":"type"},{"doc":"Gets environment configuration for the application.","ref":"Raxol.Core.Runtime.Application.html#get_env/3","title":"Raxol.Core.Runtime.Application.get_env/3","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Application.html#c:handle_event/1","title":"Raxol.Core.Runtime.Application.handle_event/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Application.html#c:handle_message/2","title":"Raxol.Core.Runtime.Application.handle_message/2","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Application.html#c:handle_tick/1","title":"Raxol.Core.Runtime.Application.handle_tick/1","type":"callback"},{"doc":"Initializes the application state.\n\nCalled once when the application starts. The context map contains runtime\ninformation such as terminal dimensions, environment variables, and startup\narguments.\n\nReturns either:\n- Initial state: `state()`\n- State and commands: `{state(), [command()]}`","ref":"Raxol.Core.Runtime.Application.html#c:init/1","title":"Raxol.Core.Runtime.Application.init/1","type":"callback"},{"doc":"Initializes the application state.\n\nCalled once when the application starts. The context map contains runtime\ninformation such as terminal dimensions, environment variables, and startup\narguments.\n\nA simpler version of delegate_init that provides fallbacks for different return types\nfrom application modules.","ref":"Raxol.Core.Runtime.Application.html#init/2","title":"Raxol.Core.Runtime.Application.init/2","type":"function"},{"doc":"- `{model, commands}` tuple when successful\n  - `{:error, reason}` tuple when initialization fails","ref":"Raxol.Core.Runtime.Application.html#init/2-returns","title":"Returns - Raxol.Core.Runtime.Application.init/2","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Application.html#t:message/0","title":"Raxol.Core.Runtime.Application.message/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Application.html#t:model/0","title":"Raxol.Core.Runtime.Application.model/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Application.html#t:state/0","title":"Raxol.Core.Runtime.Application.state/0","type":"type"},{"doc":"Sets up subscriptions based on the current state.\n\nCalled after initialization and after each state update. Use this to\nset up recurring updates or subscribe to external events.\n\nReturns a list of subscription specifications.","ref":"Raxol.Core.Runtime.Application.html#c:subscribe/1","title":"Raxol.Core.Runtime.Application.subscribe/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Application.html#t:subscription/0","title":"Raxol.Core.Runtime.Application.subscription/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Application.html#c:subscriptions/1","title":"Raxol.Core.Runtime.Application.subscriptions/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Application.html#c:terminate/2","title":"Raxol.Core.Runtime.Application.terminate/2","type":"callback"},{"doc":"Updates the application state in response to messages.\n\nCalled whenever a message is received, either from events, commands, or\nsubscriptions. Should be a pure function that computes the new state\nbased on the current state and message.\n\nReturns a tuple of the new state and any commands to be executed:\n`{state(), [command()]}`","ref":"Raxol.Core.Runtime.Application.html#c:update/2","title":"Raxol.Core.Runtime.Application.update/2","type":"callback"},{"doc":"Handles incoming events or messages and updates the application state.\n\nReturns the updated model and optional commands to execute.","ref":"Raxol.Core.Runtime.Application.html#update/3","title":"Raxol.Core.Runtime.Application.update/3","type":"function"},{"doc":"Renders the current state as UI elements.\n\nCalled after every state update to generate the new view. Should be a\npure function that converts the state into UI elements.\n\nReturns an element tree that will be rendered to the terminal.","ref":"Raxol.Core.Runtime.Application.html#c:view/1","title":"Raxol.Core.Runtime.Application.view/1","type":"callback"},{"doc":"Provides a way to handle side effects in a pure functional way.\n\nCommands are used to describe side effects that should be performed by the\nruntime system. This keeps the application's update function pure while still\nallowing necessary side effects to occur.","ref":"Raxol.Core.Runtime.Command.html","title":"Raxol.Core.Runtime.Command","type":"module"},{"doc":"* `:none` - No side effect\n* `:task` - Asynchronous task that will send a message when complete\n* `:batch` - Multiple commands to be executed in sequence\n* `:delay` - Delayed message delivery\n* `:broadcast` - Send a message to all components\n* `:system` - System-level operations (file, network, etc.)\n* `:quit` - Signals the runtime to quit\n* `:clipboard_write` - Write text to the system clipboard\n* `:clipboard_read` - Request text from the system clipboard (will result in a message)\n* `:notify` - Send a system notification","ref":"Raxol.Core.Runtime.Command.html#module-types-of-commands","title":"Types of Commands - Raxol.Core.Runtime.Command","type":"module"},{"doc":"# No side effect\n    Command.none()\n\n    # Run an async task\n    Command.task(fn ->\n      # Do something expensive\n      result = expensive_operation()\n      {:operation_complete, result}\n    end)\n\n    # Multiple commands\n    Command.batch([\n      Command.task(fn -> {:fetch_data, api_call()} end),\n      Command.delay(:refresh, 1000)\n    ])\n\n    # Delayed message\n    Command.delay(:timeout, 5000)\n\n    # Broadcast to all components\n    Command.broadcast(:data_updated)\n\n    # System operation\n    Command.system(:file_write, path: \"data.txt\", content: \"Hello\")\n\n    # Signal the runtime to quit\n    Command.quit()\n\n    # Write to clipboard\n    Command.clipboard_write(\"Copied text\")\n\n    # Read from clipboard (expects a {:clipboard_content, text} message later)\n    Command.clipboard_read()\n\n    # Send notification\n    Command.notify(\"Task Complete\", \"Your background job finished.\")","ref":"Raxol.Core.Runtime.Command.html#module-examples","title":"Examples - Raxol.Core.Runtime.Command","type":"module"},{"doc":"Creates a command that will execute multiple commands in sequence.","ref":"Raxol.Core.Runtime.Command.html#batch/1","title":"Raxol.Core.Runtime.Command.batch/1","type":"function"},{"doc":"Creates a command that will broadcast a message to all components.","ref":"Raxol.Core.Runtime.Command.html#broadcast/1","title":"Raxol.Core.Runtime.Command.broadcast/1","type":"function"},{"doc":"Creates a command to read text from the system clipboard.\nThis will eventually result in a `{:command_result, {:clipboard_content, content}}`\nmessage being sent back to the application's update function.","ref":"Raxol.Core.Runtime.Command.html#clipboard_read/0","title":"Raxol.Core.Runtime.Command.clipboard_read/0","type":"function"},{"doc":"Creates a command to write text to the system clipboard.","ref":"Raxol.Core.Runtime.Command.html#clipboard_write/1","title":"Raxol.Core.Runtime.Command.clipboard_write/1","type":"function"},{"doc":"Creates a command that will send a message after the specified delay\nin milliseconds.","ref":"Raxol.Core.Runtime.Command.html#delay/2","title":"Raxol.Core.Runtime.Command.delay/2","type":"function"},{"doc":"Executes a command within the given context. This is used by the runtime\nsystem and should not be called directly by applications.","ref":"Raxol.Core.Runtime.Command.html#execute/2","title":"Raxol.Core.Runtime.Command.execute/2","type":"function"},{"doc":"Maps a function over a command's result message. This is useful for\nnamespacing messages or transforming them before they reach the update\nfunction.","ref":"Raxol.Core.Runtime.Command.html#map/2","title":"Raxol.Core.Runtime.Command.map/2","type":"function"},{"doc":"# Transform the task's result message\n    Command.task(fn -> {:data, fetch_data()} end)\n    |> Command.map(fn {:data, result} -> {:processed_data, process(result)} end)","ref":"Raxol.Core.Runtime.Command.html#map/2-example","title":"Example - Raxol.Core.Runtime.Command.map/2","type":"function"},{"doc":"Creates a new command. This is the low-level constructor, prefer using\nthe specific command constructors unless you need custom behavior.","ref":"Raxol.Core.Runtime.Command.html#new/2","title":"Raxol.Core.Runtime.Command.new/2","type":"function"},{"doc":"Returns a command that does nothing.","ref":"Raxol.Core.Runtime.Command.html#none/0","title":"Raxol.Core.Runtime.Command.none/0","type":"function"},{"doc":"Creates a command to send a system notification.","ref":"Raxol.Core.Runtime.Command.html#notify/2","title":"Raxol.Core.Runtime.Command.notify/2","type":"function"},{"doc":"Returns a command that signals the runtime to quit.","ref":"Raxol.Core.Runtime.Command.html#quit/0","title":"Raxol.Core.Runtime.Command.quit/0","type":"function"},{"doc":"Creates a command for system-level operations like file I/O or network\nrequests. The operation type and options specify what should be done.","ref":"Raxol.Core.Runtime.Command.html#system/2","title":"Raxol.Core.Runtime.Command.system/2","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Command.html#t:t/0","title":"Raxol.Core.Runtime.Command.t/0","type":"type"},{"doc":"Creates a command that will execute the given function asynchronously.\nThe function should return a message that will be sent back to the update\nfunction when the task completes.","ref":"Raxol.Core.Runtime.Command.html#task/1","title":"Raxol.Core.Runtime.Command.task/1","type":"function"},{"doc":"Manages component lifecycle and state in the Raxol runtime system.\n\nThis module is responsible for:\n* Mounting and unmounting components\n* Managing component state\n* Handling event dispatch to components\n* Managing component subscriptions\n* Coordinating updates and renders","ref":"Raxol.Core.Runtime.ComponentManager.html","title":"Raxol.Core.Runtime.ComponentManager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Runtime.ComponentManager.html#child_spec/1","title":"Raxol.Core.Runtime.ComponentManager.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.ComponentManager.html#dispatch_event/1","title":"Raxol.Core.Runtime.ComponentManager.dispatch_event/1","type":"function"},{"doc":"Retrieves a specific component's data by its ID.","ref":"Raxol.Core.Runtime.ComponentManager.html#get_component/1","title":"Raxol.Core.Runtime.ComponentManager.get_component/1","type":"function"},{"doc":"Retrieves the current render queue and clears it.","ref":"Raxol.Core.Runtime.ComponentManager.html#get_render_queue/0","title":"Raxol.Core.Runtime.ComponentManager.get_render_queue/0","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.ComponentManager.html#mount/2","title":"Raxol.Core.Runtime.ComponentManager.mount/2","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.ComponentManager.html#set_runtime_pid/1","title":"Raxol.Core.Runtime.ComponentManager.set_runtime_pid/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.ComponentManager.html#start_link/1","title":"Raxol.Core.Runtime.ComponentManager.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.ComponentManager.html#unmount/1","title":"Raxol.Core.Runtime.ComponentManager.unmount/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.ComponentManager.html#update/2","title":"Raxol.Core.Runtime.ComponentManager.update/2","type":"function"},{"doc":"Debug logging functionality for the Raxol runtime.","ref":"Raxol.Core.Runtime.Debug.html","title":"Raxol.Core.Runtime.Debug","type":"behaviour"},{"doc":"","ref":"Raxol.Core.Runtime.Debug.html#c:debug/1","title":"Raxol.Core.Runtime.Debug.debug/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Debug.html#c:error/1","title":"Raxol.Core.Runtime.Debug.error/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Debug.html#c:info/1","title":"Raxol.Core.Runtime.Debug.info/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Debug.html#c:warn/1","title":"Raxol.Core.Runtime.Debug.warn/1","type":"callback"},{"doc":"Behaviour for implementing custom event sources for subscriptions.\n\nEvent sources are processes that can generate events over time and send them\nto subscribers. This behaviour defines the contract that custom event sources\nmust implement.","ref":"Raxol.Core.Runtime.EventSource.html","title":"Raxol.Core.Runtime.EventSource","type":"behaviour"},{"doc":"defmodule MyEventSource do\n      use Raxol.Core.Runtime.EventSource\n\n      @impl true\n      def init(args, context) do\n        # Set up initial state\n        {:ok, %{args: args, context: context}}\n      end\n\n      @impl true\n      def handle_info(:tick, state) do\n        # Send an event to the subscriber\n        send_event(state.context, {:my_event, :data})\n        {:noreply, state}\n      end\n    end","ref":"Raxol.Core.Runtime.EventSource.html#module-example","title":"Example - Raxol.Core.Runtime.EventSource","type":"behaviour"},{"doc":"Called when the event source receives a message. Should handle the message\nand optionally send events to the subscriber.","ref":"Raxol.Core.Runtime.EventSource.html#c:handle_info/2","title":"Raxol.Core.Runtime.EventSource.handle_info/2","type":"callback"},{"doc":"* `msg` - The received message\n  * `state` - The current state","ref":"Raxol.Core.Runtime.EventSource.html#c:handle_info/2-parameters","title":"Parameters - Raxol.Core.Runtime.EventSource.handle_info/2","type":"callback"},{"doc":"* `{:noreply, new_state}` - Continue with new state\n  * `{:stop, reason, new_state}` - Stop the event source","ref":"Raxol.Core.Runtime.EventSource.html#c:handle_info/2-returns","title":"Returns - Raxol.Core.Runtime.EventSource.handle_info/2","type":"callback"},{"doc":"Called when the event source is started. Should return the initial state.","ref":"Raxol.Core.Runtime.EventSource.html#c:init/2","title":"Raxol.Core.Runtime.EventSource.init/2","type":"callback"},{"doc":"* `args` - The arguments passed to `Subscription.custom/2`\n  * `context` - The runtime context containing the subscriber pid","ref":"Raxol.Core.Runtime.EventSource.html#c:init/2-parameters","title":"Parameters - Raxol.Core.Runtime.EventSource.init/2","type":"callback"},{"doc":"* `{:ok, state}` - Successfully initialized with state\n  * `{:error, reason}` - Failed to initialize","ref":"Raxol.Core.Runtime.EventSource.html#c:init/2-returns","title":"Returns - Raxol.Core.Runtime.EventSource.init/2","type":"callback"},{"doc":"Called when the event source is stopping. Can be used to clean up resources.","ref":"Raxol.Core.Runtime.EventSource.html#c:terminate/2","title":"Raxol.Core.Runtime.EventSource.terminate/2","type":"callback"},{"doc":"* `reason` - The reason for stopping\n  * `state` - The current state","ref":"Raxol.Core.Runtime.EventSource.html#c:terminate/2-parameters","title":"Parameters - Raxol.Core.Runtime.EventSource.terminate/2","type":"callback"},{"doc":"* `:ok`","ref":"Raxol.Core.Runtime.EventSource.html#c:terminate/2-returns","title":"Returns - Raxol.Core.Runtime.EventSource.terminate/2","type":"callback"},{"doc":"A test implementation of an event source for testing purposes.","ref":"Raxol.Core.Runtime.EventSourceTest.TestEventSource.html","title":"Raxol.Core.Runtime.EventSourceTest.TestEventSource","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Runtime.EventSourceTest.TestEventSource.html#child_spec/1","title":"Raxol.Core.Runtime.EventSourceTest.TestEventSource.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.EventSourceTest.TestEventSource.html#emit/1","title":"Raxol.Core.Runtime.EventSourceTest.TestEventSource.emit/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.EventSourceTest.TestEventSource.html#get_events/0","title":"Raxol.Core.Runtime.EventSourceTest.TestEventSource.get_events/0","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.EventSourceTest.TestEventSource.html#get_state/0","title":"Raxol.Core.Runtime.EventSourceTest.TestEventSource.get_state/0","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.EventSourceTest.TestEventSource.html#start_link/2","title":"Raxol.Core.Runtime.EventSourceTest.TestEventSource.start_link/2","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.EventSourceTest.TestEventSource.html#subscribe/1","title":"Raxol.Core.Runtime.EventSourceTest.TestEventSource.subscribe/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.EventSourceTest.TestEventSource.html#unsubscribe/1","title":"Raxol.Core.Runtime.EventSourceTest.TestEventSource.unsubscribe/1","type":"function"},{"doc":"Handles conversion between different event formats in the Raxol system.\n\nThis module is responsible for:\n* Converting Termbox events to the Raxol event format\n* Converting VS Code events to the Raxol event format\n* Normalizing events into a consistent format","ref":"Raxol.Core.Runtime.Events.Converter.html","title":"Raxol.Core.Runtime.Events.Converter","type":"module"},{"doc":"Converts a Termbox event to the standardized Raxol event format.","ref":"Raxol.Core.Runtime.Events.Converter.html#convert_termbox_event/6","title":"Raxol.Core.Runtime.Events.Converter.convert_termbox_event/6","type":"function"},{"doc":"- `type`: The Termbox event type (e.g., :key, :resize)\n- `mod`: Key modifiers (if applicable)\n- `key`: The key code (for key events)\n- `ch`: The character (for character events)\n- `w`, `h`: Width and height (for resize events)","ref":"Raxol.Core.Runtime.Events.Converter.html#convert_termbox_event/6-parameters","title":"Parameters - Raxol.Core.Runtime.Events.Converter.convert_termbox_event/6","type":"function"},{"doc":"A structured `%Event{}` struct.","ref":"Raxol.Core.Runtime.Events.Converter.html#convert_termbox_event/6-returns","title":"Returns - Raxol.Core.Runtime.Events.Converter.convert_termbox_event/6","type":"function"},{"doc":"Converts a VS Code extension event to the standardized Raxol event format.","ref":"Raxol.Core.Runtime.Events.Converter.html#convert_vscode_event/1","title":"Raxol.Core.Runtime.Events.Converter.convert_vscode_event/1","type":"function"},{"doc":"- `event`: The VS Code event map","ref":"Raxol.Core.Runtime.Events.Converter.html#convert_vscode_event/1-parameters","title":"Parameters - Raxol.Core.Runtime.Events.Converter.convert_vscode_event/1","type":"function"},{"doc":"A structured `%Event{}` struct.","ref":"Raxol.Core.Runtime.Events.Converter.html#convert_vscode_event/1-returns","title":"Returns - Raxol.Core.Runtime.Events.Converter.convert_vscode_event/1","type":"function"},{"doc":"Normalizes events from various sources into a consistent format.\n\nThis is useful when handling events from multiple backends to ensure\nthey all follow the same structure before processing.","ref":"Raxol.Core.Runtime.Events.Converter.html#normalize_event/1","title":"Raxol.Core.Runtime.Events.Converter.normalize_event/1","type":"function"},{"doc":"- `event`: The event to normalize","ref":"Raxol.Core.Runtime.Events.Converter.html#normalize_event/1-parameters","title":"Parameters - Raxol.Core.Runtime.Events.Converter.normalize_event/1","type":"function"},{"doc":"A normalized `%Event{}` struct.","ref":"Raxol.Core.Runtime.Events.Converter.html#normalize_event/1-returns","title":"Returns - Raxol.Core.Runtime.Events.Converter.normalize_event/1","type":"function"},{"doc":"Manages the application state (model) and dispatches events to the application's\n`update/2` function. It also handles commands returned by `update/2`.","ref":"Raxol.Core.Runtime.Events.Dispatcher.html","title":"Raxol.Core.Runtime.Events.Dispatcher","type":"module"},{"doc":"Broadcasts an event payload to all subscribers of a topic.","ref":"Raxol.Core.Runtime.Events.Dispatcher.html#broadcast/2","title":"Raxol.Core.Runtime.Events.Dispatcher.broadcast/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Runtime.Events.Dispatcher.html#child_spec/1","title":"Raxol.Core.Runtime.Events.Dispatcher.child_spec/1","type":"function"},{"doc":"Dispatches an event to the appropriate handler based on event type and target.","ref":"Raxol.Core.Runtime.Events.Dispatcher.html#dispatch_event/2","title":"Raxol.Core.Runtime.Events.Dispatcher.dispatch_event/2","type":"function"},{"doc":"Handles an application-level event and updates the application state.","ref":"Raxol.Core.Runtime.Events.Dispatcher.html#handle_event/2","title":"Raxol.Core.Runtime.Events.Dispatcher.handle_event/2","type":"function"},{"doc":"Processes a system-level event that affects the runtime itself rather than the application logic.","ref":"Raxol.Core.Runtime.Events.Dispatcher.html#process_system_event/2","title":"Raxol.Core.Runtime.Events.Dispatcher.process_system_event/2","type":"function"},{"doc":"Subscribes the calling process to a specific event topic.","ref":"Raxol.Core.Runtime.Events.Dispatcher.html#subscribe/1","title":"Raxol.Core.Runtime.Events.Dispatcher.subscribe/1","type":"function"},{"doc":"Unsubscribes the calling process from a specific event topic.","ref":"Raxol.Core.Runtime.Events.Dispatcher.html#unsubscribe/1","title":"Raxol.Core.Runtime.Events.Dispatcher.unsubscribe/1","type":"function"},{"doc":"Defines the behaviour for the Event Dispatcher GenServer.\n\nPrimarily used for mocking with Mox.","ref":"Raxol.Core.Runtime.Events.Dispatcher.Behaviour.html","title":"Raxol.Core.Runtime.Events.Dispatcher.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Core.Runtime.Events.Dispatcher.Behaviour.html#c:dispatch/1","title":"Raxol.Core.Runtime.Events.Dispatcher.Behaviour.dispatch/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Events.Dispatcher.Behaviour.html#c:start_link/2","title":"Raxol.Core.Runtime.Events.Dispatcher.Behaviour.start_link/2","type":"callback"},{"doc":"Manages event handlers registration and execution in the Raxol system.\n\nThis module is responsible for:\n* Registering event handlers for specific event types\n* Executing handlers when events occur\n* Managing the priority and order of handlers","ref":"Raxol.Core.Runtime.Events.Handlers.html","title":"Raxol.Core.Runtime.Events.Handlers","type":"module"},{"doc":"Executes all registered handlers for the given event.\nHandlers are executed in priority order (lowest to highest).\nEach handler can transform the event for the next handler.","ref":"Raxol.Core.Runtime.Events.Handlers.html#execute_handlers/2","title":"Raxol.Core.Runtime.Events.Handlers.execute_handlers/2","type":"function"},{"doc":"Registers a new event handler for the specified event types.","ref":"Raxol.Core.Runtime.Events.Handlers.html#register_handler/4","title":"Raxol.Core.Runtime.Events.Handlers.register_handler/4","type":"function"},{"doc":"Unregisters an event handler.","ref":"Raxol.Core.Runtime.Events.Handlers.html#unregister_handler/1","title":"Raxol.Core.Runtime.Events.Handlers.unregister_handler/1","type":"function"},{"doc":"- `handler_id`: ID of the handler to remove","ref":"Raxol.Core.Runtime.Events.Handlers.html#unregister_handler/1-parameters","title":"Parameters - Raxol.Core.Runtime.Events.Handlers.unregister_handler/1","type":"function"},{"doc":"Handles keyboard event processing in the Raxol system.\n\nThis module is responsible for:\n* Processing keyboard events\n* Handling special key combinations\n* Converting keyboard events to application messages","ref":"Raxol.Core.Runtime.Events.Keyboard.html","title":"Raxol.Core.Runtime.Events.Keyboard","type":"module"},{"doc":"Checks if a key combination matches any of the application's registered shortcuts.","ref":"Raxol.Core.Runtime.Events.Keyboard.html#check_shortcuts/2","title":"Raxol.Core.Runtime.Events.Keyboard.check_shortcuts/2","type":"function"},{"doc":"- `event`: The keyboard event to check\n- `shortcuts`: Map of registered shortcuts","ref":"Raxol.Core.Runtime.Events.Keyboard.html#check_shortcuts/2-parameters","title":"Parameters - Raxol.Core.Runtime.Events.Keyboard.check_shortcuts/2","type":"function"},{"doc":"`{:ok, action}` if a match is found, `:none` otherwise.","ref":"Raxol.Core.Runtime.Events.Keyboard.html#check_shortcuts/2-returns","title":"Returns - Raxol.Core.Runtime.Events.Keyboard.check_shortcuts/2","type":"function"},{"doc":"Converts a keyboard event to an application message.","ref":"Raxol.Core.Runtime.Events.Keyboard.html#convert_to_message/1","title":"Raxol.Core.Runtime.Events.Keyboard.convert_to_message/1","type":"function"},{"doc":"- `event`: The keyboard event to convert","ref":"Raxol.Core.Runtime.Events.Keyboard.html#convert_to_message/1-parameters","title":"Parameters - Raxol.Core.Runtime.Events.Keyboard.convert_to_message/1","type":"function"},{"doc":"A message that can be understood by the application's update function.","ref":"Raxol.Core.Runtime.Events.Keyboard.html#convert_to_message/1-returns","title":"Returns - Raxol.Core.Runtime.Events.Keyboard.convert_to_message/1","type":"function"},{"doc":"Processes a keyboard event and determines if it should be handled by the application\nor if it's a system-level command.","ref":"Raxol.Core.Runtime.Events.Keyboard.html#process_keyboard_event/2","title":"Raxol.Core.Runtime.Events.Keyboard.process_keyboard_event/2","type":"function"},{"doc":"- `event`: The keyboard event to process\n- `state`: The current application state","ref":"Raxol.Core.Runtime.Events.Keyboard.html#process_keyboard_event/2-parameters","title":"Parameters - Raxol.Core.Runtime.Events.Keyboard.process_keyboard_event/2","type":"function"},{"doc":"`{:system, command, state}` if it's a system command,\n`{:application, event, state}` if it should be handled by the application,\n`{:ignore, state}` if the event should be ignored.","ref":"Raxol.Core.Runtime.Events.Keyboard.html#process_keyboard_event/2-returns","title":"Returns - Raxol.Core.Runtime.Events.Keyboard.process_keyboard_event/2","type":"function"},{"doc":"Manages the application lifecycle, including startup, shutdown, and terminal interaction.","ref":"Raxol.Core.Runtime.Lifecycle.html","title":"Raxol.Core.Runtime.Lifecycle","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Runtime.Lifecycle.html#child_spec/1","title":"Raxol.Core.Runtime.Lifecycle.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Lifecycle.html#handle_cleanup/1","title":"Raxol.Core.Runtime.Lifecycle.handle_cleanup/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Lifecycle.html#handle_error/2","title":"Raxol.Core.Runtime.Lifecycle.handle_error/2","type":"function"},{"doc":"Initializes the runtime environment. (Stub for test compatibility)","ref":"Raxol.Core.Runtime.Lifecycle.html#initialize_environment/1","title":"Raxol.Core.Runtime.Lifecycle.initialize_environment/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Lifecycle.html#lookup_app/1","title":"Raxol.Core.Runtime.Lifecycle.lookup_app/1","type":"function"},{"doc":"Starts a Raxol application (compatibility wrapper).","ref":"Raxol.Core.Runtime.Lifecycle.html#start_application/2","title":"Raxol.Core.Runtime.Lifecycle.start_application/2","type":"function"},{"doc":"Starts and links a new Raxol application lifecycle manager.","ref":"Raxol.Core.Runtime.Lifecycle.html#start_link/2","title":"Raxol.Core.Runtime.Lifecycle.start_link/2","type":"function"},{"doc":"* `:name` - Optional name for registering the GenServer. If not provided, a name\n              will be derived from `app_module`.\n  * `:width` - Terminal width (default: 80).\n  * `:height` - Terminal height (default: 24).\n  * `:debug` - Enable debug mode (default: false).\n  * `:initial_commands` - A list of `Raxol.Core.Runtime.Command` structs to execute on startup.\n  * `:plugin_manager_opts` - Options to pass to the PluginManager's start_link function.\n  * Other options are passed to the application module's `init/1` function.","ref":"Raxol.Core.Runtime.Lifecycle.html#start_link/2-options","title":"Options - Raxol.Core.Runtime.Lifecycle.start_link/2","type":"function"},{"doc":"Stops the Raxol application lifecycle manager.\n`pid_or_name` can be the PID or the registered name of the Lifecycle GenServer.","ref":"Raxol.Core.Runtime.Lifecycle.html#stop/1","title":"Raxol.Core.Runtime.Lifecycle.stop/1","type":"function"},{"doc":"Stops a Raxol application (compatibility wrapper).","ref":"Raxol.Core.Runtime.Lifecycle.html#stop_application/1","title":"Raxol.Core.Runtime.Lifecycle.stop_application/1","type":"function"},{"doc":"Standardized logging helpers for error and warning messages with context and stacktraces.","ref":"Raxol.Core.Runtime.Log.html","title":"Raxol.Core.Runtime.Log","type":"module"},{"doc":"","ref":"Raxol.Core.Runtime.Log.html#debug/1","title":"Raxol.Core.Runtime.Log.debug/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Log.html#debug/2","title":"Raxol.Core.Runtime.Log.debug/2","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Log.html#debug_with_context/2","title":"Raxol.Core.Runtime.Log.debug_with_context/2","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Log.html#error/1","title":"Raxol.Core.Runtime.Log.error/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Log.html#error/2","title":"Raxol.Core.Runtime.Log.error/2","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Log.html#error_with_context/2","title":"Raxol.Core.Runtime.Log.error_with_context/2","type":"function"},{"doc":"Logs an error with stacktrace and context.","ref":"Raxol.Core.Runtime.Log.html#error_with_stacktrace/4","title":"Raxol.Core.Runtime.Log.error_with_stacktrace/4","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Log.html#info/1","title":"Raxol.Core.Runtime.Log.info/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Log.html#info/2","title":"Raxol.Core.Runtime.Log.info/2","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Log.html#info_with_context/1","title":"Raxol.Core.Runtime.Log.info_with_context/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Log.html#info_with_context/2","title":"Raxol.Core.Runtime.Log.info_with_context/2","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Log.html#warning/1","title":"Raxol.Core.Runtime.Log.warning/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Log.html#warning/2","title":"Raxol.Core.Runtime.Log.warning/2","type":"function"},{"doc":"Logs a warning with context.","ref":"Raxol.Core.Runtime.Log.html#warning_with_context/2","title":"Raxol.Core.Runtime.Log.warning_with_context/2","type":"function"},{"doc":"Public API for Raxol plugins to interact with the core system.\n\nThis module provides standardized interfaces for plugins to:\n- Register event handlers\n- Access runtime services\n- Register commands\n- Access rendering capabilities\n- Modify application state in approved ways\n\nPlugin developers should only use these API functions for interacting with\nthe Raxol system to ensure forward compatibility when the internal system changes.","ref":"Raxol.Core.Runtime.Plugins.API.html","title":"Raxol.Core.Runtime.Plugins.API","type":"module"},{"doc":"Broadcast an event to all subscribers.","ref":"Raxol.Core.Runtime.Plugins.API.html#broadcast/2","title":"Raxol.Core.Runtime.Plugins.API.broadcast/2","type":"function"},{"doc":"- `event_type` - The type of event to broadcast\n- `payload` - Data to include with the event","ref":"Raxol.Core.Runtime.Plugins.API.html#broadcast/2-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.API.broadcast/2","type":"function"},{"doc":"- `:ok` if broadcast was successful","ref":"Raxol.Core.Runtime.Plugins.API.html#broadcast/2-returns","title":"Returns - Raxol.Core.Runtime.Plugins.API.broadcast/2","type":"function"},{"doc":"Creates a new screen buffer with the specified dimensions.","ref":"Raxol.Core.Runtime.Plugins.API.html#create_buffer/3","title":"Raxol.Core.Runtime.Plugins.API.create_buffer/3","type":"function"},{"doc":"* `width` - The width of the buffer\n  * `height` - The height of the buffer\n  * `options` - Additional options for buffer creation","ref":"Raxol.Core.Runtime.Plugins.API.html#create_buffer/3-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.API.create_buffer/3","type":"function"},{"doc":"A new screen buffer instance","ref":"Raxol.Core.Runtime.Plugins.API.html#create_buffer/3-returns","title":"Returns - Raxol.Core.Runtime.Plugins.API.create_buffer/3","type":"function"},{"doc":"Get the current application configuration.","ref":"Raxol.Core.Runtime.Plugins.API.html#get_config/2","title":"Raxol.Core.Runtime.Plugins.API.get_config/2","type":"function"},{"doc":"- `key` - The configuration key to retrieve\n- `default` - Default value if the key is not found","ref":"Raxol.Core.Runtime.Plugins.API.html#get_config/2-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.API.get_config/2","type":"function"},{"doc":"The configuration value or default","ref":"Raxol.Core.Runtime.Plugins.API.html#get_config/2-returns","title":"Returns - Raxol.Core.Runtime.Plugins.API.get_config/2","type":"function"},{"doc":"Log a message from a plugin.","ref":"Raxol.Core.Runtime.Plugins.API.html#log/3","title":"Raxol.Core.Runtime.Plugins.API.log/3","type":"function"},{"doc":"- `plugin_id` - The ID of the plugin\n- `level` - Log level (:debug, :info, :warn, :error)\n- `message` - The message to log","ref":"Raxol.Core.Runtime.Plugins.API.html#log/3-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.API.log/3","type":"function"},{"doc":"`:ok`","ref":"Raxol.Core.Runtime.Plugins.API.html#log/3-returns","title":"Returns - Raxol.Core.Runtime.Plugins.API.log/3","type":"function"},{"doc":"Get the path to the plugin data directory.","ref":"Raxol.Core.Runtime.Plugins.API.html#plugin_data_dir/1","title":"Raxol.Core.Runtime.Plugins.API.plugin_data_dir/1","type":"function"},{"doc":"- `plugin_id` - The ID of the plugin","ref":"Raxol.Core.Runtime.Plugins.API.html#plugin_data_dir/1-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.API.plugin_data_dir/1","type":"function"},{"doc":"String path to the plugin's data directory","ref":"Raxol.Core.Runtime.Plugins.API.html#plugin_data_dir/1-returns","title":"Returns - Raxol.Core.Runtime.Plugins.API.plugin_data_dir/1","type":"function"},{"doc":"Subscribe to runtime events.","ref":"Raxol.Core.Runtime.Plugins.API.html#subscribe/3","title":"Raxol.Core.Runtime.Plugins.API.subscribe/3","type":"function"},{"doc":"- `event_type` - The type of event to subscribe to\n- `handler` - Module that will handle the event\n- `function` - Function in the handler module that will be called (default: :handle_event)","ref":"Raxol.Core.Runtime.Plugins.API.html#subscribe/3-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.API.subscribe/3","type":"function"},{"doc":"- `:ok` if successful\n- `{:error, reason}` if subscription failed","ref":"Raxol.Core.Runtime.Plugins.API.html#subscribe/3-returns","title":"Returns - Raxol.Core.Runtime.Plugins.API.subscribe/3","type":"function"},{"doc":"```elixir\nAPI.subscribe(:key_press, MyPluginHandlers)\n```","ref":"Raxol.Core.Runtime.Plugins.API.html#subscribe/3-example","title":"Example - Raxol.Core.Runtime.Plugins.API.subscribe/3","type":"function"},{"doc":"Unsubscribe from runtime events.","ref":"Raxol.Core.Runtime.Plugins.API.html#unsubscribe/2","title":"Raxol.Core.Runtime.Plugins.API.unsubscribe/2","type":"function"},{"doc":"- `event_type` - The type of event to unsubscribe from\n- `handler` - Module to unsubscribe","ref":"Raxol.Core.Runtime.Plugins.API.html#unsubscribe/2-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.API.unsubscribe/2","type":"function"},{"doc":"- `:ok` if successful\n- `{:error, reason}` if unsubscription failed","ref":"Raxol.Core.Runtime.Plugins.API.html#unsubscribe/2-returns","title":"Returns - Raxol.Core.Runtime.Plugins.API.unsubscribe/2","type":"function"},{"doc":"This module is responsible for processing cells in the Raxol runtime.","ref":"Raxol.Core.Runtime.Plugins.CellProcessor.html","title":"Raxol.Core.Runtime.Plugins.CellProcessor","type":"module"},{"doc":"Process a cell with the given data.","ref":"Raxol.Core.Runtime.Plugins.CellProcessor.html#process_cell/1","title":"Raxol.Core.Runtime.Plugins.CellProcessor.process_cell/1","type":"function"},{"doc":"Handles command execution and management for plugins.\nThis module is responsible for:\n- Processing command requests\n- Executing commands through plugins\n- Managing command results and error handling\n- Handling clipboard-related commands","ref":"Raxol.Core.Runtime.Plugins.CommandHandler.html","title":"Raxol.Core.Runtime.Plugins.CommandHandler","type":"module"},{"doc":"Handles clipboard result messages.","ref":"Raxol.Core.Runtime.Plugins.CommandHandler.html#handle_clipboard_result/2","title":"Raxol.Core.Runtime.Plugins.CommandHandler.handle_clipboard_result/2","type":"function"},{"doc":"Handles a command request by delegating to the appropriate plugin.\nReturns an updated state and any necessary side effects.","ref":"Raxol.Core.Runtime.Plugins.CommandHandler.html#handle_command/5","title":"Raxol.Core.Runtime.Plugins.CommandHandler.handle_command/5","type":"function"},{"doc":"Processes a command by delegating to the appropriate handler.\nReturns an updated state and any necessary side effects.","ref":"Raxol.Core.Runtime.Plugins.CommandHandler.html#process_command/2","title":"Raxol.Core.Runtime.Plugins.CommandHandler.process_command/2","type":"function"},{"doc":"Handles plugin command registration and dispatch for the Plugin Manager.","ref":"Raxol.Core.Runtime.Plugins.CommandHelper.html","title":"Raxol.Core.Runtime.Plugins.CommandHelper","type":"module"},{"doc":"Finds the plugin ID for a given module.","ref":"Raxol.Core.Runtime.Plugins.CommandHelper.html#find_plugin_id_by_module/2","title":"Raxol.Core.Runtime.Plugins.CommandHelper.find_plugin_id_by_module/2","type":"function"},{"doc":"Validates command arguments.","ref":"Raxol.Core.Runtime.Plugins.CommandHelper.html#validate_command_args/1","title":"Raxol.Core.Runtime.Plugins.CommandHelper.validate_command_args/1","type":"function"},{"doc":"Defines the behaviour for plugin command management.\n\nThis behaviour is responsible for:\n- Registering plugin commands\n- Managing command handlers\n- Validating command specifications\n- Handling command execution","ref":"Raxol.Core.Runtime.Plugins.CommandHelper.Behaviour.html","title":"Raxol.Core.Runtime.Plugins.CommandHelper.Behaviour","type":"behaviour"},{"doc":"Executes a command for a plugin.","ref":"Raxol.Core.Runtime.Plugins.CommandHelper.Behaviour.html#c:execute_command/4","title":"Raxol.Core.Runtime.Plugins.CommandHelper.Behaviour.execute_command/4","type":"callback"},{"doc":"Gets all registered commands for a plugin.","ref":"Raxol.Core.Runtime.Plugins.CommandHelper.Behaviour.html#c:get_plugin_commands/2","title":"Raxol.Core.Runtime.Plugins.CommandHelper.Behaviour.get_plugin_commands/2","type":"callback"},{"doc":"Registers commands for a plugin.","ref":"Raxol.Core.Runtime.Plugins.CommandHelper.Behaviour.html#c:register_plugin_commands/3","title":"Raxol.Core.Runtime.Plugins.CommandHelper.Behaviour.register_plugin_commands/3","type":"callback"},{"doc":"Unregisters commands for a plugin.","ref":"Raxol.Core.Runtime.Plugins.CommandHelper.Behaviour.html#c:unregister_plugin_commands/2","title":"Raxol.Core.Runtime.Plugins.CommandHelper.Behaviour.unregister_plugin_commands/2","type":"callback"},{"doc":"Validates a plugin's command specifications.","ref":"Raxol.Core.Runtime.Plugins.CommandHelper.Behaviour.html#c:validate_commands/1","title":"Raxol.Core.Runtime.Plugins.CommandHelper.Behaviour.validate_commands/1","type":"callback"},{"doc":"Manages command registration and execution for plugins.","ref":"Raxol.Core.Runtime.Plugins.CommandRegistry.html","title":"Raxol.Core.Runtime.Plugins.CommandRegistry","type":"module"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.CommandRegistry.html#t:command/0","title":"Raxol.Core.Runtime.Plugins.CommandRegistry.command/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.CommandRegistry.html#t:command_handler/0","title":"Raxol.Core.Runtime.Plugins.CommandRegistry.command_handler/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.CommandRegistry.html#t:command_metadata/0","title":"Raxol.Core.Runtime.Plugins.CommandRegistry.command_metadata/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.CommandRegistry.html#t:command_name/0","title":"Raxol.Core.Runtime.Plugins.CommandRegistry.command_name/0","type":"type"},{"doc":"Executes a command with proper error handling and timeout.","ref":"Raxol.Core.Runtime.Plugins.CommandRegistry.html#execute_command/3","title":"Raxol.Core.Runtime.Plugins.CommandRegistry.execute_command/3","type":"function"},{"doc":"Looks up the handler for a command name and namespace (plugin module).\nReturns {:ok, {module, function, arity}} or {:error, :not_found}.","ref":"Raxol.Core.Runtime.Plugins.CommandRegistry.html#find_command/2","title":"Raxol.Core.Runtime.Plugins.CommandRegistry.find_command/2","type":"function"},{"doc":"Registers commands for a plugin.","ref":"Raxol.Core.Runtime.Plugins.CommandRegistry.html#register_plugin_commands/3","title":"Raxol.Core.Runtime.Plugins.CommandRegistry.register_plugin_commands/3","type":"function"},{"doc":"Unregisters all commands for a plugin.","ref":"Raxol.Core.Runtime.Plugins.CommandRegistry.html#unregister_plugin_commands/2","title":"Raxol.Core.Runtime.Plugins.CommandRegistry.unregister_plugin_commands/2","type":"function"},{"doc":"Manages plugin dependencies, ensuring that plugins are loaded in the correct\norder and that their dependencies are met.\n\nThis module is the primary interface for dependency management, and it is\ncomposed of several smaller modules, each with a specific responsibility:\n\n- `DependencyManager.Core`: Core dependency checking and load order resolution\n- `DependencyManager.Version`: Version parsing and constraint checking\n- `DependencyManager.Graph`: Dependency graph building and analysis\n- `DependencyManager.Resolver`: Load order resolution using Tarjan's algorithm\n\nFor more detailed documentation about the module's architecture and internals,\nsee `docs/dependency_manager.md`.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.html","title":"Raxol.Core.Runtime.Plugins.DependencyManager","type":"module"},{"doc":"Checks if a plugin's dependencies are met by the currently loaded plugins.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.html#check_dependencies/4","title":"Raxol.Core.Runtime.Plugins.DependencyManager.check_dependencies/4","type":"function"},{"doc":"* `plugin_id` - The ID of the plugin to check\n* `plugin_metadata` - The plugin's metadata containing its dependencies\n* `loaded_plugins` - Map of currently loaded plugins\n* `dependency_chain` - List of plugin IDs in the current dependency chain (for error reporting)","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.html#check_dependencies/4-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.DependencyManager.check_dependencies/4","type":"function"},{"doc":"* `:ok` - If all dependencies are satisfied\n* `{:error, :missing_dependencies, missing, chain}` - If any dependencies are missing\n* `{:error, :version_mismatch, mismatches, chain}` - If any dependencies have incompatible versions\n* `{:error, :circular_dependency, cycle, chain}` - If a circular dependency is detected","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.html#check_dependencies/4-returns","title":"Returns - Raxol.Core.Runtime.Plugins.DependencyManager.check_dependencies/4","type":"function"},{"doc":"iex> DependencyManager.check_dependencies(\"my_plugin\", %{dependencies: [{\"other_plugin\", \">= 1.0.0\"}]}, %{\"other_plugin\" => %{version: \"1.1.0\"}}, [])\n    :ok\n\n    iex> DependencyManager.check_dependencies(\"my_plugin\", %{dependencies: [{\"missing_plugin\", \">= 1.0.0\"}]}, %{}, [])\n    {:error, :missing_dependencies, [\"missing_plugin\"], [\"my_plugin\"]}\n\n    iex> DependencyManager.check_dependencies(\"my_plugin\", %{dependencies: [{\"other_plugin\", \">= 2.0.0\"}]}, %{\"other_plugin\" => %{version: \"1.0.0\"}}, [])\n    {:error, :version_mismatch, [{\"other_plugin\", \"1.0.0\", \">= 2.0.0\"}], [\"my_plugin\"]}","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.html#check_dependencies/4-examples","title":"Examples - Raxol.Core.Runtime.Plugins.DependencyManager.check_dependencies/4","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.html#t:dependency/0","title":"Raxol.Core.Runtime.Plugins.DependencyManager.dependency/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.html#t:dependency_chain/0","title":"Raxol.Core.Runtime.Plugins.DependencyManager.dependency_chain/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.html#t:dependency_error/0","title":"Raxol.Core.Runtime.Plugins.DependencyManager.dependency_error/0","type":"type"},{"doc":"Resolves the load order for a list of plugins.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.html#resolve_load_order/1","title":"Raxol.Core.Runtime.Plugins.DependencyManager.resolve_load_order/1","type":"function"},{"doc":"Checks if a version meets a version requirement.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.html#satisfies_version?/2","title":"Raxol.Core.Runtime.Plugins.DependencyManager.satisfies_version?/2","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.html#t:version_constraint/0","title":"Raxol.Core.Runtime.Plugins.DependencyManager.version_constraint/0","type":"type"},{"doc":"Defines the behaviour for plugin dependency management.\n\nThis behaviour is responsible for:\n- Checking plugin dependencies\n- Resolving dependency conflicts\n- Managing dependency versions\n- Handling circular dependencies","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Behaviour.html","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Behaviour","type":"behaviour"},{"doc":"Checks for circular dependencies in the plugin graph.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Behaviour.html#c:check_circular_dependencies/3","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Behaviour.check_circular_dependencies/3","type":"callback"},{"doc":"Checks if a plugin's dependencies are satisfied.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Behaviour.html#c:check_dependencies/3","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Behaviour.check_dependencies/3","type":"callback"},{"doc":"Resolves dependencies between plugins.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Behaviour.html#c:resolve_dependencies/2","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Behaviour.resolve_dependencies/2","type":"callback"},{"doc":"Validates a plugin's dependency specifications.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Behaviour.html#c:validate_dependencies/1","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Behaviour.validate_dependencies/1","type":"callback"},{"doc":"Core module for managing plugin dependencies and dependency resolution.\nProvides the main public API for dependency checking and load order resolution.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Core","type":"module"},{"doc":"Checks for circular dependencies in the plugin graph.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#check_circular_dependencies/3","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.check_circular_dependencies/3","type":"function"},{"doc":"* `plugin_id` - The ID of the plugin to check\n* `dependencies` - List of dependencies to check\n* `loaded_plugins` - Map of currently loaded plugins","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#check_circular_dependencies/3-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.DependencyManager.Core.check_circular_dependencies/3","type":"function"},{"doc":"* `:ok` - If no circular dependencies are found\n* `{:error, :circular_dependency, cycle, chain}` - If a circular dependency is detected","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#check_circular_dependencies/3-returns","title":"Returns - Raxol.Core.Runtime.Plugins.DependencyManager.Core.check_circular_dependencies/3","type":"function"},{"doc":"Checks if a plugin's dependencies are satisfied.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#check_dependencies/4","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.check_dependencies/4","type":"function"},{"doc":"* `plugin_id` - The ID of the plugin to check\n* `plugin_metadata` - The plugin's metadata containing its dependencies\n* `loaded_plugins` - Map of currently loaded plugins\n* `dependency_chain` - List of plugin IDs in the current dependency chain (for error reporting)","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#check_dependencies/4-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.DependencyManager.Core.check_dependencies/4","type":"function"},{"doc":"* `:ok` - If all dependencies are satisfied\n* `{:error, :missing_dependencies, missing, chain}` - If any dependencies are missing\n* `{:error, :version_mismatch, mismatches, chain}` - If any dependencies have incompatible versions\n* `{:error, :circular_dependency, cycle, chain}` - If a circular dependency is detected","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#check_dependencies/4-returns","title":"Returns - Raxol.Core.Runtime.Plugins.DependencyManager.Core.check_dependencies/4","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#t:dependency/0","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.dependency/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#t:dependency_chain/0","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.dependency_chain/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#t:dependency_error/0","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.dependency_error/0","type":"type"},{"doc":"Resolves dependencies between plugins.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#resolve_dependencies/2","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.resolve_dependencies/2","type":"function"},{"doc":"* `plugin_metadata` - The plugin's metadata containing its dependencies\n* `loaded_plugins` - Map of currently loaded plugins","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#resolve_dependencies/2-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.DependencyManager.Core.resolve_dependencies/2","type":"function"},{"doc":"* `{:ok, resolved_deps}` - List of resolved dependencies\n* `{:error, reason}` - If dependency resolution fails","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#resolve_dependencies/2-returns","title":"Returns - Raxol.Core.Runtime.Plugins.DependencyManager.Core.resolve_dependencies/2","type":"function"},{"doc":"Resolves the load order for a set of plugins based on their dependencies.\nUses Tarjan's algorithm for efficient cycle detection and component identification.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#resolve_load_order/1","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.resolve_load_order/1","type":"function"},{"doc":"* `plugins` - Map of plugin metadata, keyed by plugin ID","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#resolve_load_order/1-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.DependencyManager.Core.resolve_load_order/1","type":"function"},{"doc":"* `{:ok, load_order}` - List of plugin IDs in the correct load order\n* `{:error, :circular_dependency, cycle, chain}` - If a circular dependency is detected","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#resolve_load_order/1-returns","title":"Returns - Raxol.Core.Runtime.Plugins.DependencyManager.Core.resolve_load_order/1","type":"function"},{"doc":"Validates a list of dependencies.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#validate_dependencies/1","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.validate_dependencies/1","type":"function"},{"doc":"* `dependencies` - List of dependencies to validate","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#validate_dependencies/1-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.DependencyManager.Core.validate_dependencies/1","type":"function"},{"doc":"* `:ok` - If all dependencies are valid\n* `{:error, reason}` - If any dependencies are invalid","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#validate_dependencies/1-returns","title":"Returns - Raxol.Core.Runtime.Plugins.DependencyManager.Core.validate_dependencies/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.html#t:version_constraint/0","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Core.version_constraint/0","type":"type"},{"doc":"Handles dependency graph building and cycle detection for plugin dependencies.\nProvides functionality for building dependency graphs and analyzing dependency chains.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph.html","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph","type":"module"},{"doc":"Builds a dependency chain for error reporting.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph.html#build_dependency_chain/2","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph.build_dependency_chain/2","type":"function"},{"doc":"* `cycle` - List of plugin IDs forming a cycle\n* `graph` - The dependency graph","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph.html#build_dependency_chain/2-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.DependencyManager.Graph.build_dependency_chain/2","type":"function"},{"doc":"* A list of plugin IDs representing the dependency chain","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph.html#build_dependency_chain/2-returns","title":"Returns - Raxol.Core.Runtime.Plugins.DependencyManager.Graph.build_dependency_chain/2","type":"function"},{"doc":"iex> Graph.build_dependency_chain([\"plugin_a\", \"plugin_b\"], %{\n      \"plugin_a\" => [{\"plugin_b\", \">= 1.0.0\", %{optional: false}}],\n      \"plugin_b\" => [{\"plugin_a\", \">= 1.0.0\", %{optional: false}}]\n    })\n    [\"plugin_a\", \"plugin_b\", \"plugin_a\"]","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph.html#build_dependency_chain/2-example","title":"Example - Raxol.Core.Runtime.Plugins.DependencyManager.Graph.build_dependency_chain/2","type":"function"},{"doc":"Builds a dependency graph from plugin metadata.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph.html#build_dependency_graph/1","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph.build_dependency_graph/1","type":"function"},{"doc":"* `plugins` - Map of plugin metadata, keyed by plugin ID","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph.html#build_dependency_graph/1-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.DependencyManager.Graph.build_dependency_graph/1","type":"function"},{"doc":"* A map representing the dependency graph, where each key is a plugin ID and the value\n  is a list of tuples containing dependency information: `{dep_id, version_req, opts}`","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph.html#build_dependency_graph/1-returns","title":"Returns - Raxol.Core.Runtime.Plugins.DependencyManager.Graph.build_dependency_graph/1","type":"function"},{"doc":"iex> Graph.build_dependency_graph(%{\n      \"plugin_a\" => %{dependencies: [{\"plugin_b\", \">= 1.0.0\"}]},\n      \"plugin_b\" => %{dependencies: []}\n    })\n    %{\n      \"plugin_a\" => [{\"plugin_b\", \">= 1.0.0\", %{optional: false}}],\n      \"plugin_b\" => []\n    }","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph.html#build_dependency_graph/1-example","title":"Example - Raxol.Core.Runtime.Plugins.DependencyManager.Graph.build_dependency_graph/1","type":"function"},{"doc":"Gets all dependencies for a plugin, including transitive dependencies.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph.html#get_all_dependencies/3","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph.get_all_dependencies/3","type":"function"},{"doc":"* `plugin_id` - The ID of the plugin\n* `graph` - The dependency graph\n* `visited` - Set of already visited plugin IDs (for cycle detection)","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph.html#get_all_dependencies/3-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.DependencyManager.Graph.get_all_dependencies/3","type":"function"},{"doc":"* `{:ok, deps}` - List of all dependencies\n* `{:error, :circular_dependency, cycle}` - If a circular dependency is detected","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Graph.html#get_all_dependencies/3-returns","title":"Returns - Raxol.Core.Runtime.Plugins.DependencyManager.Graph.get_all_dependencies/3","type":"function"},{"doc":"Handles load order resolution for plugin dependencies using Tarjan's algorithm.\nProvides efficient cycle detection and topological sorting of dependencies.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Resolver.html","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Resolver","type":"module"},{"doc":"Performs a topological sort of the dependency graph using Tarjan's algorithm.\nThis algorithm efficiently detects cycles and produces a valid load order.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Resolver.html#tarjan_sort/1","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Resolver.tarjan_sort/1","type":"function"},{"doc":"* `graph` - The dependency graph","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Resolver.html#tarjan_sort/1-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.DependencyManager.Resolver.tarjan_sort/1","type":"function"},{"doc":"* `{:ok, order}` - List of plugin IDs in the correct load order\n* `{:error, cycle}` - If a circular dependency is detected","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Resolver.html#tarjan_sort/1-returns","title":"Returns - Raxol.Core.Runtime.Plugins.DependencyManager.Resolver.tarjan_sort/1","type":"function"},{"doc":"iex> Resolver.tarjan_sort(%{\n      \"plugin_a\" => [{\"plugin_b\", \">= 1.0.0\", %{optional: false}}],\n      \"plugin_b\" => []\n    })\n    {:ok, [\"plugin_b\", \"plugin_a\"]}","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Resolver.html#tarjan_sort/1-example","title":"Example - Raxol.Core.Runtime.Plugins.DependencyManager.Resolver.tarjan_sort/1","type":"function"},{"doc":"Handles version parsing and constraint checking for plugin dependencies.\nProvides sophisticated version constraint handling with support for complex requirements.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Version.html","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Version","type":"module"},{"doc":"Checks if a version satisfies a version requirement.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Version.html#check_version/2","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Version.check_version/2","type":"function"},{"doc":"* `version` - The version string to check\n* `requirement` - The version requirement string","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Version.html#check_version/2-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.DependencyManager.Version.check_version/2","type":"function"},{"doc":"* `:ok` - If the version satisfies the requirement\n* `{:error, reason}` - If there's an error or the version doesn't satisfy the requirement","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Version.html#check_version/2-returns","title":"Returns - Raxol.Core.Runtime.Plugins.DependencyManager.Version.check_version/2","type":"function"},{"doc":"Parses a single version requirement.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Version.html#parse_single_requirement/1","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Version.parse_single_requirement/1","type":"function"},{"doc":"* `req` - The version requirement string","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Version.html#parse_single_requirement/1-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.DependencyManager.Version.parse_single_requirement/1","type":"function"},{"doc":"* `{:ok, parsed}` - The parsed requirement\n* `{:error, :invalid_requirement_format}` - If the requirement is invalid","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Version.html#parse_single_requirement/1-returns","title":"Returns - Raxol.Core.Runtime.Plugins.DependencyManager.Version.parse_single_requirement/1","type":"function"},{"doc":"Parses a version requirement string into a format suitable for version matching.","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Version.html#parse_version_requirement/1","title":"Raxol.Core.Runtime.Plugins.DependencyManager.Version.parse_version_requirement/1","type":"function"},{"doc":"* `requirement` - The version requirement string","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Version.html#parse_version_requirement/1-parameters","title":"Parameters - Raxol.Core.Runtime.Plugins.DependencyManager.Version.parse_version_requirement/1","type":"function"},{"doc":"* `{:ok, parsed_requirement}` - The parsed requirement\n* `{:error, :invalid_requirement_format}` - If the requirement is invalid","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Version.html#parse_version_requirement/1-returns","title":"Returns - Raxol.Core.Runtime.Plugins.DependencyManager.Version.parse_version_requirement/1","type":"function"},{"doc":"iex> Version.parse_version_requirement(\">= 1.0.0\")\n    {:ok, \">= 1.0.0\"}\n\n    iex> Version.parse_version_requirement(\">= 1.0.0 || >= 2.0.0\")\n    {:ok, {:or, [\">= 1.0.0\", \">= 2.0.0\"]}}","ref":"Raxol.Core.Runtime.Plugins.DependencyManager.Version.html#parse_version_requirement/1-examples","title":"Examples - Raxol.Core.Runtime.Plugins.DependencyManager.Version.parse_version_requirement/1","type":"function"},{"doc":"Test helper functions for DependencyManager tests.","ref":"Raxol.Core.Runtime.Plugins.DependencyManagerTestHelper.html","title":"Raxol.Core.Runtime.Plugins.DependencyManagerTestHelper","type":"module"},{"doc":"Creates a complex version requirements structure for testing.","ref":"Raxol.Core.Runtime.Plugins.DependencyManagerTestHelper.html#create_complex_version_requirements/1","title":"Raxol.Core.Runtime.Plugins.DependencyManagerTestHelper.create_complex_version_requirements/1","type":"function"},{"doc":"Creates a dependency chain for testing.","ref":"Raxol.Core.Runtime.Plugins.DependencyManagerTestHelper.html#create_dependency_chain/1","title":"Raxol.Core.Runtime.Plugins.DependencyManagerTestHelper.create_dependency_chain/1","type":"function"},{"doc":"Creates a plugin set for dependency tests.","ref":"Raxol.Core.Runtime.Plugins.DependencyManagerTestHelper.html#create_plugin_set/1","title":"Raxol.Core.Runtime.Plugins.DependencyManagerTestHelper.create_plugin_set/1","type":"function"},{"doc":"Measures the memory usage of a function or operation.","ref":"Raxol.Core.Runtime.Plugins.DependencyManagerTestHelper.html#measure_memory_usage/1","title":"Raxol.Core.Runtime.Plugins.DependencyManagerTestHelper.measure_memory_usage/1","type":"function"},{"doc":"Measures the execution time of a function or operation.","ref":"Raxol.Core.Runtime.Plugins.DependencyManagerTestHelper.html#measure_time/1","title":"Raxol.Core.Runtime.Plugins.DependencyManagerTestHelper.measure_time/1","type":"function"},{"doc":"Handles plugin discovery and initialization.\nThis module is responsible for:\n- Discovering available plugins in configured directories\n- Initializing the plugin system\n- Managing plugin metadata and paths\n- Handling plugin dependencies","ref":"Raxol.Core.Runtime.Plugins.Discovery.html","title":"Raxol.Core.Runtime.Plugins.Discovery","type":"module"},{"doc":"Discovers plugins in the given state (all plugin_dirs and plugins_dir).","ref":"Raxol.Core.Runtime.Plugins.Discovery.html#discover_plugins/1","title":"Raxol.Core.Runtime.Plugins.Discovery.discover_plugins/1","type":"function"},{"doc":"Discovers plugins in a specific directory.","ref":"Raxol.Core.Runtime.Plugins.Discovery.html#discover_plugins_in_dir/2","title":"Raxol.Core.Runtime.Plugins.Discovery.discover_plugins_in_dir/2","type":"function"},{"doc":"Gets a specific plugin by ID.","ref":"Raxol.Core.Runtime.Plugins.Discovery.html#get_plugin/2","title":"Raxol.Core.Runtime.Plugins.Discovery.get_plugin/2","type":"function"},{"doc":"Initializes the plugin discovery system.","ref":"Raxol.Core.Runtime.Plugins.Discovery.html#initialize/1","title":"Raxol.Core.Runtime.Plugins.Discovery.initialize/1","type":"function"},{"doc":"Lists all discovered plugins in load order as {id, metadata}.","ref":"Raxol.Core.Runtime.Plugins.Discovery.html#list_plugins/1","title":"Raxol.Core.Runtime.Plugins.Discovery.list_plugins/1","type":"function"},{"doc":"Handles event filtering for plugins.\nThis module is responsible for:\n- Filtering events through registered plugin filters\n- Managing event modifications\n- Handling event halting","ref":"Raxol.Core.Runtime.Plugins.EventFilter.html","title":"Raxol.Core.Runtime.Plugins.EventFilter","type":"module"},{"doc":"Filters an event through registered plugin filters.\nReturns the filtered event or :halt if the event should be stopped.","ref":"Raxol.Core.Runtime.Plugins.EventFilter.html#filter_event/2","title":"Raxol.Core.Runtime.Plugins.EventFilter.filter_event/2","type":"function"},{"doc":"Manages file watching operations for plugins.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.html","title":"Raxol.Core.Runtime.Plugins.FileWatcher","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.html#child_spec/1","title":"Raxol.Core.Runtime.Plugins.FileWatcher.child_spec/1","type":"function"},{"doc":"Gets the list of watched files.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.html#get_watched_files/1","title":"Raxol.Core.Runtime.Plugins.FileWatcher.get_watched_files/1","type":"function"},{"doc":"Sets up file watching for a directory.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.html#setup_file_watching/1","title":"Raxol.Core.Runtime.Plugins.FileWatcher.setup_file_watching/1","type":"function"},{"doc":"Starts the file watcher.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.html#start_link/1","title":"Raxol.Core.Runtime.Plugins.FileWatcher.start_link/1","type":"function"},{"doc":"Stops the file watcher.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.html#stop/1","title":"Raxol.Core.Runtime.Plugins.FileWatcher.stop/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.html#t:t/0","title":"Raxol.Core.Runtime.Plugins.FileWatcher.t/0","type":"type"},{"doc":"Removes a file from watching.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.html#unwatch_file/2","title":"Raxol.Core.Runtime.Plugins.FileWatcher.unwatch_file/2","type":"function"},{"doc":"Adds a file to watch.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.html#watch_file/3","title":"Raxol.Core.Runtime.Plugins.FileWatcher.watch_file/3","type":"function"},{"doc":"Defines the behaviour for file watching functionality in the plugin system.\n\nThis behaviour is responsible for:\n- Setting up file system watchers\n- Handling file change events\n- Managing file paths and reverse mappings\n- Debouncing file events\n- Triggering plugin reloads","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Behaviour.html","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Behaviour","type":"behaviour"},{"doc":"Cleans up file watching resources.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Behaviour.html#c:cleanup_file_watching/1","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Behaviour.cleanup_file_watching/1","type":"callback"},{"doc":"Handles debounced file events.\nReturns updated state after processing events.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Behaviour.html#c:handle_debounced_events/1","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Behaviour.handle_debounced_events/1","type":"callback"},{"doc":"Handles file system events.\nReturns updated state with debounced reload timer if needed.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Behaviour.html#c:handle_file_event/2","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Behaviour.handle_file_event/2","type":"callback"},{"doc":"Sets up file watching for plugin source files.\nReturns the updated state with the file watcher PID.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Behaviour.html#c:setup_file_watching/1","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Behaviour.setup_file_watching/1","type":"callback"},{"doc":"Updates the reverse path mapping for file watching.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Behaviour.html#c:update_file_watcher/1","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Behaviour.update_file_watcher/1","type":"callback"},{"doc":"Handles cleanup of file watching resources.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Cleanup.html","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Cleanup","type":"module"},{"doc":"Cleans up file watching resources.\nReturns the updated state.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Cleanup.html#cleanup_file_watching/1","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Cleanup.cleanup_file_watching/1","type":"function"},{"doc":"Core functionality for file watching in plugins.\nHandles basic setup and state management.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Core.html","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Core","type":"module"},{"doc":"Sets up file watching for plugin source files.\nReturns the updated state with the file watcher PID.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Core.html#setup_file_watching/1","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Core.setup_file_watching/1","type":"function"},{"doc":"Updates the reverse path mapping for file watching.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Core.html#update_file_watcher/1","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Core.update_file_watcher/1","type":"function"},{"doc":"Handles file system events and debouncing for plugin reloading.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Events.html","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Events","type":"module"},{"doc":"Handles debounced file events.\nReturns updated state after processing events.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Events.html#handle_debounced_events/3","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Events.handle_debounced_events/3","type":"function"},{"doc":"Handles file system events.\nReturns updated state with debounced reload timer if needed.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Events.html#handle_file_event/3","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Events.handle_file_event/3","type":"function"},{"doc":"Handles plugin reloading functionality.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Reload.html","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Reload","type":"module"},{"doc":"Reloads a plugin after file changes.\nReturns :ok on success or {:error, reason} on failure.","ref":"Raxol.Core.Runtime.Plugins.FileWatcher.Reload.html#reload_plugin/2","title":"Raxol.Core.Runtime.Plugins.FileWatcher.Reload.reload_plugin/2","type":"function"},{"doc":"Behaviour defining the interface for file watching operations.","ref":"Raxol.Core.Runtime.Plugins.FileWatcherBehaviour.html","title":"Raxol.Core.Runtime.Plugins.FileWatcherBehaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.FileWatcherBehaviour.html#c:get_watched_files/1","title":"Raxol.Core.Runtime.Plugins.FileWatcherBehaviour.get_watched_files/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.FileWatcherBehaviour.html#c:setup_file_watching/1","title":"Raxol.Core.Runtime.Plugins.FileWatcherBehaviour.setup_file_watching/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.FileWatcherBehaviour.html#c:start_link/1","title":"Raxol.Core.Runtime.Plugins.FileWatcherBehaviour.start_link/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.FileWatcherBehaviour.html#c:stop/1","title":"Raxol.Core.Runtime.Plugins.FileWatcherBehaviour.stop/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.FileWatcherBehaviour.html#c:unwatch_file/2","title":"Raxol.Core.Runtime.Plugins.FileWatcherBehaviour.unwatch_file/2","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.FileWatcherBehaviour.html#c:watch_file/3","title":"Raxol.Core.Runtime.Plugins.FileWatcherBehaviour.watch_file/3","type":"callback"},{"doc":"Helper functions for plugin lifecycle management.","ref":"Raxol.Core.Runtime.Plugins.LifecycleHelper.html","title":"Raxol.Core.Runtime.Plugins.LifecycleHelper","type":"module"},{"doc":"Catch-all for load_plugin/3. Raises a clear error if called with the wrong arity.","ref":"Raxol.Core.Runtime.Plugins.LifecycleHelper.html#load_plugin/3","title":"Raxol.Core.Runtime.Plugins.LifecycleHelper.load_plugin/3","type":"function"},{"doc":"Defines the behaviour for plugin lifecycle management.\n\nThis behaviour is responsible for:\n- Loading and unloading plugins\n- Managing plugin dependencies\n- Handling plugin state transitions\n- Coordinating plugin lifecycle events","ref":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.html","title":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour","type":"behaviour"},{"doc":"Cleans up a plugin with the given plugin_id and state.","ref":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.html#c:cleanup_plugin/2","title":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.cleanup_plugin/2","type":"callback"},{"doc":"Handles a state transition for a plugin.","ref":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.html#c:handle_state_transition/3","title":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.handle_state_transition/3","type":"callback"},{"doc":"Initializes a plugin with the given module and options.","ref":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.html#c:init_plugin/2","title":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.init_plugin/2","type":"callback"},{"doc":"Initializes plugins based on discovery and dependencies.","ref":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.html#c:initialize_plugins/7","title":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.initialize_plugins/7","type":"callback"},{"doc":"Loads a plugin by its ID or module.","ref":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.html#c:load_plugin/8","title":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.load_plugin/8","type":"callback"},{"doc":"Loads a plugin by its module name when the module is already known.","ref":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.html#c:load_plugin_by_module/8","title":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.load_plugin_by_module/8","type":"callback"},{"doc":"Reloads a plugin by its ID.","ref":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.html#c:reload_plugin/7","title":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.reload_plugin/7","type":"callback"},{"doc":"Reloads a specific plugin from disk.","ref":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.html#c:reload_plugin_from_disk/8","title":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.reload_plugin_from_disk/8","type":"callback"},{"doc":"Terminates a plugin with the given plugin_id, state, and reason.","ref":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.html#c:terminate_plugin/3","title":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.terminate_plugin/3","type":"callback"},{"doc":"Unloads a plugin by its ID.","ref":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.html#c:unload_plugin/6","title":"Raxol.Core.Runtime.Plugins.LifecycleHelper.Behaviour.unload_plugin/6","type":"callback"},{"doc":"Handles plugin lifecycle operations including enabling, disabling, and reloading plugins.\nThis module is responsible for:\n- Enabling plugins\n- Disabling plugins\n- Reloading plugins\n- Managing plugin states during lifecycle changes","ref":"Raxol.Core.Runtime.Plugins.LifecycleManager.html","title":"Raxol.Core.Runtime.Plugins.LifecycleManager","type":"module"},{"doc":"Disables a plugin temporarily without unloading it.","ref":"Raxol.Core.Runtime.Plugins.LifecycleManager.html#disable_plugin/2","title":"Raxol.Core.Runtime.Plugins.LifecycleManager.disable_plugin/2","type":"function"},{"doc":"Enables a previously disabled plugin.","ref":"Raxol.Core.Runtime.Plugins.LifecycleManager.html#enable_plugin/2","title":"Raxol.Core.Runtime.Plugins.LifecycleManager.enable_plugin/2","type":"function"},{"doc":"Loads a plugin with the given configuration.","ref":"Raxol.Core.Runtime.Plugins.LifecycleManager.html#load_plugin/3","title":"Raxol.Core.Runtime.Plugins.LifecycleManager.load_plugin/3","type":"function"},{"doc":"Reloads a plugin by unloading and then loading it again.","ref":"Raxol.Core.Runtime.Plugins.LifecycleManager.html#reload_plugin/2","title":"Raxol.Core.Runtime.Plugins.LifecycleManager.reload_plugin/2","type":"function"},{"doc":"Manages plugin loading operations.","ref":"Raxol.Core.Runtime.Plugins.Loader.html","title":"Raxol.Core.Runtime.Plugins.Loader","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Runtime.Plugins.Loader.html#child_spec/1","title":"Raxol.Core.Runtime.Plugins.Loader.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.Loader.html#extract_metadata/1","title":"Raxol.Core.Runtime.Plugins.Loader.extract_metadata/1","type":"function"},{"doc":"Gets the list of loaded plugins.","ref":"Raxol.Core.Runtime.Plugins.Loader.html#get_loaded_plugins/0","title":"Raxol.Core.Runtime.Plugins.Loader.get_loaded_plugins/0","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.Loader.html#initialize_plugin/2","title":"Raxol.Core.Runtime.Plugins.Loader.initialize_plugin/2","type":"function"},{"doc":"Checks if a plugin is loaded.","ref":"Raxol.Core.Runtime.Plugins.Loader.html#is_plugin_loaded?/1","title":"Raxol.Core.Runtime.Plugins.Loader.is_plugin_loaded?/1","type":"function"},{"doc":"Loads a plugin from the given path.","ref":"Raxol.Core.Runtime.Plugins.Loader.html#load_plugin/1","title":"Raxol.Core.Runtime.Plugins.Loader.load_plugin/1","type":"function"},{"doc":"Reloads a plugin.","ref":"Raxol.Core.Runtime.Plugins.Loader.html#reload_plugin/1","title":"Raxol.Core.Runtime.Plugins.Loader.reload_plugin/1","type":"function"},{"doc":"Starts the plugin loader.","ref":"Raxol.Core.Runtime.Plugins.Loader.html#start_link/1","title":"Raxol.Core.Runtime.Plugins.Loader.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.Loader.html#t:t/0","title":"Raxol.Core.Runtime.Plugins.Loader.t/0","type":"type"},{"doc":"Unloads a plugin.","ref":"Raxol.Core.Runtime.Plugins.Loader.html#unload_plugin/1","title":"Raxol.Core.Runtime.Plugins.Loader.unload_plugin/1","type":"function"},{"doc":"Behaviour defining the interface for plugin loading operations.","ref":"Raxol.Core.Runtime.Plugins.LoaderBehaviour.html","title":"Raxol.Core.Runtime.Plugins.LoaderBehaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.LoaderBehaviour.html#c:get_loaded_plugins/0","title":"Raxol.Core.Runtime.Plugins.LoaderBehaviour.get_loaded_plugins/0","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.LoaderBehaviour.html#c:is_plugin_loaded?/1","title":"Raxol.Core.Runtime.Plugins.LoaderBehaviour.is_plugin_loaded?/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.LoaderBehaviour.html#c:load_plugin/1","title":"Raxol.Core.Runtime.Plugins.LoaderBehaviour.load_plugin/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.LoaderBehaviour.html#c:reload_plugin/1","title":"Raxol.Core.Runtime.Plugins.LoaderBehaviour.reload_plugin/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.LoaderBehaviour.html#c:unload_plugin/1","title":"Raxol.Core.Runtime.Plugins.LoaderBehaviour.unload_plugin/1","type":"callback"},{"doc":"Manages the loading, initialization, and lifecycle of plugins in the Raxol runtime.\n\nThis module is responsible for:\n- Discovering available plugins\n- Loading and initializing plugins\n- Managing plugin lifecycle events\n- Providing access to loaded plugins\n- Handling plugin dependencies and conflicts\n- Optionally watching plugin source files for changes and reloading them (dev only).","ref":"Raxol.Core.Runtime.Plugins.Manager.html","title":"Raxol.Core.Runtime.Plugins.Manager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Runtime.Plugins.Manager.html#child_spec/1","title":"Raxol.Core.Runtime.Plugins.Manager.child_spec/1","type":"function"},{"doc":"Disable a plugin temporarily without unloading it.","ref":"Raxol.Core.Runtime.Plugins.Manager.html#disable_plugin/1","title":"Raxol.Core.Runtime.Plugins.Manager.disable_plugin/1","type":"function"},{"doc":"Enable a plugin that was previously disabled.","ref":"Raxol.Core.Runtime.Plugins.Manager.html#enable_plugin/1","title":"Raxol.Core.Runtime.Plugins.Manager.enable_plugin/1","type":"function"},{"doc":"Get a specific plugin by its ID.","ref":"Raxol.Core.Runtime.Plugins.Manager.html#get_plugin/1","title":"Raxol.Core.Runtime.Plugins.Manager.get_plugin/1","type":"function"},{"doc":"Gets a plugin's current state.","ref":"Raxol.Core.Runtime.Plugins.Manager.html#get_plugin_state/1","title":"Raxol.Core.Runtime.Plugins.Manager.get_plugin_state/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.Manager.html#handle_cleanup/1","title":"Raxol.Core.Runtime.Plugins.Manager.handle_cleanup/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.Manager.html#handle_error/2","title":"Raxol.Core.Runtime.Plugins.Manager.handle_error/2","type":"function"},{"doc":"Initialize the plugin system and load all available plugins.","ref":"Raxol.Core.Runtime.Plugins.Manager.html#initialize/0","title":"Raxol.Core.Runtime.Plugins.Manager.initialize/0","type":"function"},{"doc":"Get a list of all loaded plugins with their metadata.","ref":"Raxol.Core.Runtime.Plugins.Manager.html#list_plugins/0","title":"Raxol.Core.Runtime.Plugins.Manager.list_plugins/0","type":"function"},{"doc":"Loads a plugin by sending a call to the GenServer.","ref":"Raxol.Core.Runtime.Plugins.Manager.html#load_plugin/1","title":"Raxol.Core.Runtime.Plugins.Manager.load_plugin/1","type":"function"},{"doc":"Loads a plugin with the given name and configuration.","ref":"Raxol.Core.Runtime.Plugins.Manager.html#load_plugin/2","title":"Raxol.Core.Runtime.Plugins.Manager.load_plugin/2","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.Manager.html#t:plugin_id/0","title":"Raxol.Core.Runtime.Plugins.Manager.plugin_id/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.Manager.html#t:plugin_metadata/0","title":"Raxol.Core.Runtime.Plugins.Manager.plugin_metadata/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.Manager.html#t:plugin_state/0","title":"Raxol.Core.Runtime.Plugins.Manager.plugin_state/0","type":"type"},{"doc":"Reload a plugin by unloading and then loading it again.","ref":"Raxol.Core.Runtime.Plugins.Manager.html#reload_plugin/1","title":"Raxol.Core.Runtime.Plugins.Manager.reload_plugin/1","type":"function"},{"doc":"Sets a plugin's state directly.","ref":"Raxol.Core.Runtime.Plugins.Manager.html#set_plugin_state/2","title":"Raxol.Core.Runtime.Plugins.Manager.set_plugin_state/2","type":"function"},{"doc":"Unloads a plugin by sending a call to the GenServer.","ref":"Raxol.Core.Runtime.Plugins.Manager.html#unload_plugin/1","title":"Raxol.Core.Runtime.Plugins.Manager.unload_plugin/1","type":"function"},{"doc":"Updates a plugin's state using a function.","ref":"Raxol.Core.Runtime.Plugins.Manager.html#update_plugin/2","title":"Raxol.Core.Runtime.Plugins.Manager.update_plugin/2","type":"function"},{"doc":"Defines the behaviour for plugin management functionality.\nThis is used for mocking in tests.","ref":"Raxol.Core.Runtime.Plugins.Manager.Behaviour.html","title":"Raxol.Core.Runtime.Plugins.Manager.Behaviour","type":"behaviour"},{"doc":"Gets a plugin by its ID.","ref":"Raxol.Core.Runtime.Plugins.Manager.Behaviour.html#c:get_plugin/1","title":"Raxol.Core.Runtime.Plugins.Manager.Behaviour.get_plugin/1","type":"callback"},{"doc":"Loads a plugin from a file path.","ref":"Raxol.Core.Runtime.Plugins.Manager.Behaviour.html#c:load_plugin/1","title":"Raxol.Core.Runtime.Plugins.Manager.Behaviour.load_plugin/1","type":"callback"},{"doc":"Starts the plugin manager with the given options.","ref":"Raxol.Core.Runtime.Plugins.Manager.Behaviour.html#c:start_link/1","title":"Raxol.Core.Runtime.Plugins.Manager.Behaviour.start_link/1","type":"callback"},{"doc":"Unloads a plugin by its ID.","ref":"Raxol.Core.Runtime.Plugins.Manager.Behaviour.html#c:unload_plugin/1","title":"Raxol.Core.Runtime.Plugins.Manager.Behaviour.unload_plugin/1","type":"callback"},{"doc":"Defines the behaviour for Raxol plugins.\n\nPlugins must implement this behaviour to be loaded and managed by the plugin manager.","ref":"Raxol.Core.Runtime.Plugins.Plugin.html","title":"Raxol.Core.Runtime.Plugins.Plugin","type":"behaviour"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.Plugin.html#t:command/0","title":"Raxol.Core.Runtime.Plugins.Plugin.command/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.Plugin.html#t:config/0","title":"Raxol.Core.Runtime.Plugins.Plugin.config/0","type":"type"},{"doc":"Called when the plugin is disabled.\n\nShould return `{:ok, new_state}` or `{:error, reason}`.","ref":"Raxol.Core.Runtime.Plugins.Plugin.html#c:disable/1","title":"Raxol.Core.Runtime.Plugins.Plugin.disable/1","type":"callback"},{"doc":"Called when the plugin is enabled after being disabled.\n\nShould return `{:ok, new_state}` or `{:error, reason}`.","ref":"Raxol.Core.Runtime.Plugins.Plugin.html#c:enable/1","title":"Raxol.Core.Runtime.Plugins.Plugin.enable/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.Plugin.html#t:event/0","title":"Raxol.Core.Runtime.Plugins.Plugin.event/0","type":"type"},{"doc":"Optional callback to filter or react to system events before they reach the application.\n\nReturn `{:ok, event}` to pass the event through (potentially modified).\nReturn `:halt` to stop the event from propagating further.\nReturn any other value to indicate an error.","ref":"Raxol.Core.Runtime.Plugins.Plugin.html#c:filter_event/2","title":"Raxol.Core.Runtime.Plugins.Plugin.filter_event/2","type":"callback"},{"doc":"Optional callback to declare commands provided by the plugin.\n\nThis callback allows plugins to register their commands with the command registry.\nEach command is specified as a tuple containing:\n- The command name as an atom\n- The function to handle the command\n- The arity of the handler function","ref":"Raxol.Core.Runtime.Plugins.Plugin.html#c:get_commands/0","title":"Raxol.Core.Runtime.Plugins.Plugin.get_commands/0","type":"callback"},{"doc":"* List of command specifications in the format `[{name_atom, function_atom, arity_integer}]`","ref":"Raxol.Core.Runtime.Plugins.Plugin.html#c:get_commands/0-returns","title":"Returns - Raxol.Core.Runtime.Plugins.Plugin.get_commands/0","type":"callback"},{"doc":"def get_commands do\n      [\n        {:do_something, :handle_do_something_command, 2},\n        {:process_data, :handle_process_data_command, 1}\n      ]\n    end","ref":"Raxol.Core.Runtime.Plugins.Plugin.html#c:get_commands/0-examples","title":"Examples - Raxol.Core.Runtime.Plugins.Plugin.get_commands/0","type":"callback"},{"doc":"* The command name will be converted to a string when registered\n  * The plugin module itself will be used as the namespace\n  * Commands will be registered in the CommandRegistry via CommandHelper","ref":"Raxol.Core.Runtime.Plugins.Plugin.html#c:get_commands/0-notes","title":"Notes - Raxol.Core.Runtime.Plugins.Plugin.get_commands/0","type":"callback"},{"doc":"Optional callback to handle commands delegated by the plugin manager.\n\nShould return `{:ok, new_state, result}` or `{:error, reason, new_state}`.\nThe `result` can be sent back to the original command requester if needed.","ref":"Raxol.Core.Runtime.Plugins.Plugin.html#c:handle_command/3","title":"Raxol.Core.Runtime.Plugins.Plugin.handle_command/3","type":"callback"},{"doc":"Called when the plugin is first initialized.\n\nShould return `{:ok, initial_state}` or `{:error, reason}`.\nThe `initial_state` will be managed by the plugin manager.","ref":"Raxol.Core.Runtime.Plugins.Plugin.html#c:init/1","title":"Raxol.Core.Runtime.Plugins.Plugin.init/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.Plugin.html#t:state/0","title":"Raxol.Core.Runtime.Plugins.Plugin.state/0","type":"type"},{"doc":"Called when the plugin is terminated (e.g., during shutdown or unload).\n\nAllows the plugin to perform cleanup. The return value is ignored.","ref":"Raxol.Core.Runtime.Plugins.Plugin.html#c:terminate/2","title":"Raxol.Core.Runtime.Plugins.Plugin.terminate/2","type":"callback"},{"doc":"Defines the behaviour for plugin command dispatching.\n\nThis behaviour is responsible for:\n- Dispatching commands to appropriate plugins\n- Managing command execution flow\n- Handling command results and errors\n- Coordinating command responses","ref":"Raxol.Core.Runtime.Plugins.PluginCommandDispatcher.Behaviour.html","title":"Raxol.Core.Runtime.Plugins.PluginCommandDispatcher.Behaviour","type":"behaviour"},{"doc":"Dispatches a command to the appropriate plugin.\nReturns an updated state and any necessary side effects.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandDispatcher.Behaviour.html#c:dispatch_command/5","title":"Raxol.Core.Runtime.Plugins.PluginCommandDispatcher.Behaviour.dispatch_command/5","type":"callback"},{"doc":"Handles command errors from plugins.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandDispatcher.Behaviour.html#c:handle_command_error/4","title":"Raxol.Core.Runtime.Plugins.PluginCommandDispatcher.Behaviour.handle_command_error/4","type":"callback"},{"doc":"Handles command results from plugins.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandDispatcher.Behaviour.html#c:handle_command_result/4","title":"Raxol.Core.Runtime.Plugins.PluginCommandDispatcher.Behaviour.handle_command_result/4","type":"callback"},{"doc":"Handles command timeouts.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandDispatcher.Behaviour.html#c:handle_command_timeout/3","title":"Raxol.Core.Runtime.Plugins.PluginCommandDispatcher.Behaviour.handle_command_timeout/3","type":"callback"},{"doc":"Updates the command dispatcher state.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandDispatcher.Behaviour.html#c:update_dispatcher_state/2","title":"Raxol.Core.Runtime.Plugins.PluginCommandDispatcher.Behaviour.update_dispatcher_state/2","type":"callback"},{"doc":"Defines the behaviour for plugin command handling.\n\nThis behaviour is responsible for:\n- Processing command requests\n- Executing commands through plugins\n- Managing command results and error handling\n- Handling command timeouts and errors","ref":"Raxol.Core.Runtime.Plugins.PluginCommandHandler.Behaviour.html","title":"Raxol.Core.Runtime.Plugins.PluginCommandHandler.Behaviour","type":"behaviour"},{"doc":"Handles a command request by delegating to the appropriate plugin.\nReturns an updated state and any necessary side effects.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandHandler.Behaviour.html#c:handle_command/5","title":"Raxol.Core.Runtime.Plugins.PluginCommandHandler.Behaviour.handle_command/5","type":"callback"},{"doc":"Handles command errors.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandHandler.Behaviour.html#c:handle_command_error/4","title":"Raxol.Core.Runtime.Plugins.PluginCommandHandler.Behaviour.handle_command_error/4","type":"callback"},{"doc":"Handles command results.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandHandler.Behaviour.html#c:handle_command_result/4","title":"Raxol.Core.Runtime.Plugins.PluginCommandHandler.Behaviour.handle_command_result/4","type":"callback"},{"doc":"Handles command timeouts.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandHandler.Behaviour.html#c:handle_command_timeout/3","title":"Raxol.Core.Runtime.Plugins.PluginCommandHandler.Behaviour.handle_command_timeout/3","type":"callback"},{"doc":"Updates the command handler state.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandHandler.Behaviour.html#c:update_command_state/2","title":"Raxol.Core.Runtime.Plugins.PluginCommandHandler.Behaviour.update_command_state/2","type":"callback"},{"doc":"Defines the behaviour for plugin command registration and dispatch.\n\nThis behaviour is responsible for:\n- Finding plugins for command handling\n- Registering plugin commands\n- Handling command dispatch\n- Managing command unregistration","ref":"Raxol.Core.Runtime.Plugins.PluginCommandHelper.Behaviour.html","title":"Raxol.Core.Runtime.Plugins.PluginCommandHelper.Behaviour","type":"behaviour"},{"doc":"Finds the plugin responsible for handling a command.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandHelper.Behaviour.html#c:find_plugin_for_command/4","title":"Raxol.Core.Runtime.Plugins.PluginCommandHelper.Behaviour.find_plugin_for_command/4","type":"callback"},{"doc":"Handles the dispatching of a command to the appropriate plugin.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandHelper.Behaviour.html#c:handle_command/5","title":"Raxol.Core.Runtime.Plugins.PluginCommandHelper.Behaviour.handle_command/5","type":"callback"},{"doc":"Registers the commands exposed by a plugin.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandHelper.Behaviour.html#c:register_plugin_commands/3","title":"Raxol.Core.Runtime.Plugins.PluginCommandHelper.Behaviour.register_plugin_commands/3","type":"callback"},{"doc":"Unregisters all commands associated with a specific plugin module.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandHelper.Behaviour.html#c:unregister_plugin_commands/2","title":"Raxol.Core.Runtime.Plugins.PluginCommandHelper.Behaviour.unregister_plugin_commands/2","type":"callback"},{"doc":"Defines the behaviour for plugin command registration.\n\nThis behaviour is responsible for:\n- Registering plugin commands\n- Managing command lookups\n- Handling command unregistration\n- Maintaining command metadata","ref":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.html","title":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.html#t:command_entry/0","title":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.command_entry/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.html#t:command_key/0","title":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.command_key/0","type":"type"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.html#t:command_name/0","title":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.command_name/0","type":"type"},{"doc":"Looks up the handler for a command name and namespace.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.html#c:lookup_command/3","title":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.lookup_command/3","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.html#t:namespace/0","title":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.namespace/0","type":"type"},{"doc":"Creates a new command registry table.\nReturns the name of the created table.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.html#c:new/0","title":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.new/0","type":"callback"},{"doc":"Registers a command provided by a plugin.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.html#c:register_command/6","title":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.register_command/6","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.html#t:table_name/0","title":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.table_name/0","type":"type"},{"doc":"Unregisters a command.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.html#c:unregister_command/3","title":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.unregister_command/3","type":"callback"},{"doc":"Unregisters all commands associated with a specific module.","ref":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.html#c:unregister_commands_by_module/2","title":"Raxol.Core.Runtime.Plugins.PluginCommandRegistry.Behaviour.unregister_commands_by_module/2","type":"callback"},{"doc":"Defines the behaviour for plugin event filtering.\n\nThis behaviour is responsible for:\n- Filtering events through registered plugin filters\n- Managing event modifications\n- Handling event halting\n- Coordinating event propagation","ref":"Raxol.Core.Runtime.Plugins.PluginEventFilter.Behaviour.html","title":"Raxol.Core.Runtime.Plugins.PluginEventFilter.Behaviour","type":"behaviour"},{"doc":"Applies a single plugin's filter to the event.","ref":"Raxol.Core.Runtime.Plugins.PluginEventFilter.Behaviour.html#c:apply_plugin_filter/3","title":"Raxol.Core.Runtime.Plugins.PluginEventFilter.Behaviour.apply_plugin_filter/3","type":"callback"},{"doc":"Filters an event through registered plugin filters.\nReturns the filtered event or :halt if the event should be stopped.","ref":"Raxol.Core.Runtime.Plugins.PluginEventFilter.Behaviour.html#c:filter_event/2","title":"Raxol.Core.Runtime.Plugins.PluginEventFilter.Behaviour.filter_event/2","type":"callback"},{"doc":"Gets a list of enabled plugins in load order.","ref":"Raxol.Core.Runtime.Plugins.PluginEventFilter.Behaviour.html#c:get_enabled_plugins/1","title":"Raxol.Core.Runtime.Plugins.PluginEventFilter.Behaviour.get_enabled_plugins/1","type":"callback"},{"doc":"Handles event filtering errors.","ref":"Raxol.Core.Runtime.Plugins.PluginEventFilter.Behaviour.html#c:handle_filter_error/3","title":"Raxol.Core.Runtime.Plugins.PluginEventFilter.Behaviour.handle_filter_error/3","type":"callback"},{"doc":"Updates the event filter state.","ref":"Raxol.Core.Runtime.Plugins.PluginEventFilter.Behaviour.html#c:update_filter_state/2","title":"Raxol.Core.Runtime.Plugins.PluginEventFilter.Behaviour.update_filter_state/2","type":"callback"},{"doc":"Defines the behaviour for plugins that provide metadata like ID, version, and dependencies.\n\nPlugins can optionally implement this behaviour to declare their metadata,\nwhich the plugin manager uses for dependency resolution and management.","ref":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.html","title":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider","type":"behaviour"},{"doc":"Callback invoked by the plugin manager to retrieve the plugin's metadata.","ref":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.html#c:get_metadata/0","title":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.get_metadata/0","type":"callback"},{"doc":"Represents the metadata for a plugin.\n- `id`: A unique atom identifying the plugin (e.g., `:my_plugin`).\n- `version`: A string representing the plugin version (e.g., \"0.1.0\").\n- `dependencies`: A list of tuples {plugin_id, version_requirement} that this plugin depends on.","ref":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.html#t:metadata/0","title":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.metadata/0","type":"type"},{"doc":"Defines the behaviour for plugin metadata providers.\n\nThis behaviour is responsible for:\n- Providing plugin metadata (ID, version, dependencies)\n- Validating plugin metadata\n- Managing plugin metadata lifecycle","ref":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.html","title":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.html#t:dependency/0","title":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.dependency/0","type":"type"},{"doc":"Gets the metadata for a plugin.","ref":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.html#c:get_metadata/1","title":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.get_metadata/1","type":"callback"},{"doc":"Gets the plugin behaviours from metadata.","ref":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.html#c:get_plugin_behaviours/1","title":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.get_plugin_behaviours/1","type":"callback"},{"doc":"Gets the plugin config schema from metadata.","ref":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.html#c:get_plugin_config_schema/1","title":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.get_plugin_config_schema/1","type":"callback"},{"doc":"Gets the plugin dependencies from metadata.\nReturns a list of dependencies, each being either:\n- A tuple {plugin_id, version_constraint} for versioned dependencies\n- A simple plugin_id string for unversioned dependencies","ref":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.html#c:get_plugin_dependencies/1","title":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.get_plugin_dependencies/1","type":"callback"},{"doc":"Gets the plugin ID from metadata.","ref":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.html#c:get_plugin_id/1","title":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.get_plugin_id/1","type":"callback"},{"doc":"Gets the plugin optional dependencies from metadata.\nReturns a list of dependencies, each being either:\n- A tuple {plugin_id, version_constraint} for versioned dependencies\n- A simple plugin_id string for unversioned dependencies","ref":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.html#c:get_plugin_optional_dependencies/1","title":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.get_plugin_optional_dependencies/1","type":"callback"},{"doc":"Gets the plugin version from metadata.","ref":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.html#c:get_plugin_version/1","title":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.get_plugin_version/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.html#t:metadata/0","title":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.metadata/0","type":"type"},{"doc":"Validates plugin metadata.","ref":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.html#c:validate_metadata/1","title":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.validate_metadata/1","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.html#t:version_constraint/0","title":"Raxol.Core.Runtime.Plugins.PluginMetadataProvider.Behaviour.version_constraint/0","type":"type"},{"doc":"Handles plugin reloading operations.\nThis module is responsible for:\n- Reloading plugins from disk\n- Managing plugin state during reloads\n- Handling reload failures and recovery","ref":"Raxol.Core.Runtime.Plugins.PluginReloader.html","title":"Raxol.Core.Runtime.Plugins.PluginReloader","type":"module"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.PluginReloader.html#reload_plugin/2","title":"Raxol.Core.Runtime.Plugins.PluginReloader.reload_plugin/2","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.PluginReloader.html#reload_plugin_by_id/2","title":"Raxol.Core.Runtime.Plugins.PluginReloader.reload_plugin_by_id/2","type":"function"},{"doc":"Defines the behaviour for plugin reloading functionality.\n\nThis behaviour is responsible for:\n- Reloading plugins from disk\n- Managing plugin reload state\n- Handling plugin reload errors\n- Coordinating plugin reload lifecycle","ref":"Raxol.Core.Runtime.Plugins.PluginReloader.Behaviour.html","title":"Raxol.Core.Runtime.Plugins.PluginReloader.Behaviour","type":"behaviour"},{"doc":"Checks if a plugin can be reloaded.","ref":"Raxol.Core.Runtime.Plugins.PluginReloader.Behaviour.html#c:can_reload?/3","title":"Raxol.Core.Runtime.Plugins.PluginReloader.Behaviour.can_reload?/3","type":"callback"},{"doc":"Coordinates the plugin reload lifecycle.","ref":"Raxol.Core.Runtime.Plugins.PluginReloader.Behaviour.html#c:coordinate_reload/6","title":"Raxol.Core.Runtime.Plugins.PluginReloader.Behaviour.coordinate_reload/6","type":"callback"},{"doc":"Gets the reload state of a plugin.","ref":"Raxol.Core.Runtime.Plugins.PluginReloader.Behaviour.html#c:get_reload_state/3","title":"Raxol.Core.Runtime.Plugins.PluginReloader.Behaviour.get_reload_state/3","type":"callback"},{"doc":"Handles plugin reload errors.","ref":"Raxol.Core.Runtime.Plugins.PluginReloader.Behaviour.html#c:handle_reload_error/5","title":"Raxol.Core.Runtime.Plugins.PluginReloader.Behaviour.handle_reload_error/5","type":"callback"},{"doc":"Reloads a plugin from disk.","ref":"Raxol.Core.Runtime.Plugins.PluginReloader.Behaviour.html#c:reload_plugin_from_disk/8","title":"Raxol.Core.Runtime.Plugins.PluginReloader.Behaviour.reload_plugin_from_disk/8","type":"callback"},{"doc":"Plugin registry using GenServer for state management.\nManages information about loaded plugins and their metadata.","ref":"Raxol.Core.Runtime.Plugins.Registry.html","title":"Raxol.Core.Runtime.Plugins.Registry","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Runtime.Plugins.Registry.html#child_spec/1","title":"Raxol.Core.Runtime.Plugins.Registry.child_spec/1","type":"function"},{"doc":"Lists all registered plugins as {plugin_id, metadata} tuples.","ref":"Raxol.Core.Runtime.Plugins.Registry.html#list_plugins/0","title":"Raxol.Core.Runtime.Plugins.Registry.list_plugins/0","type":"function"},{"doc":"Registers a plugin with its metadata.","ref":"Raxol.Core.Runtime.Plugins.Registry.html#register_plugin/2","title":"Raxol.Core.Runtime.Plugins.Registry.register_plugin/2","type":"function"},{"doc":"Starts the plugin registry GenServer.","ref":"Raxol.Core.Runtime.Plugins.Registry.html#start_link/1","title":"Raxol.Core.Runtime.Plugins.Registry.start_link/1","type":"function"},{"doc":"Unregisters a plugin by its ID.","ref":"Raxol.Core.Runtime.Plugins.Registry.html#unregister_plugin/1","title":"Raxol.Core.Runtime.Plugins.Registry.unregister_plugin/1","type":"function"},{"doc":"Defines the state struct for the plugin manager.","ref":"Raxol.Core.Runtime.Plugins.State.html","title":"Raxol.Core.Runtime.Plugins.State","type":"module"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.State.html#t:t/0","title":"Raxol.Core.Runtime.Plugins.State.t/0","type":"type"},{"doc":"Manages plugin state and state transitions.","ref":"Raxol.Core.Runtime.Plugins.StateManager.html","title":"Raxol.Core.Runtime.Plugins.StateManager","type":"module"},{"doc":"Initializes the plugin state. Returns {:ok, state}.","ref":"Raxol.Core.Runtime.Plugins.StateManager.html#initialize/1","title":"Raxol.Core.Runtime.Plugins.StateManager.initialize/1","type":"function"},{"doc":"Returns a new default plugin manager state struct.","ref":"Raxol.Core.Runtime.Plugins.StateManager.html#new/0","title":"Raxol.Core.Runtime.Plugins.StateManager.new/0","type":"function"},{"doc":"Sets the state for a given plugin.\nAlias for update_plugin_state/3.","ref":"Raxol.Core.Runtime.Plugins.StateManager.html#set_plugin_state/3","title":"Raxol.Core.Runtime.Plugins.StateManager.set_plugin_state/3","type":"function"},{"doc":"Defines the behaviour for plugin state management.\n\nThis behaviour is responsible for:\n- Managing plugin state transitions\n- Updating plugin state maps\n- Retrieving plugin state information\n- Handling plugin state lifecycle","ref":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour.html","title":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour","type":"behaviour"},{"doc":"Gets a plugin's configuration.","ref":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour.html#c:get_plugin_config/2","title":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour.get_plugin_config/2","type":"callback"},{"doc":"Gets a plugin's metadata.","ref":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour.html#c:get_plugin_metadata/2","title":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour.get_plugin_metadata/2","type":"callback"},{"doc":"Gets a plugin's module.","ref":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour.html#c:get_plugin_module/2","title":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour.get_plugin_module/2","type":"callback"},{"doc":"Gets a plugin's state.","ref":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour.html#c:get_plugin_state/2","title":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour.get_plugin_state/2","type":"callback"},{"doc":"Removes a plugin from the state maps.","ref":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour.html#c:remove_plugin/2","title":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour.remove_plugin/2","type":"callback"},{"doc":"Updates a plugin's state.","ref":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour.html#c:update_plugin_state/3","title":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour.update_plugin_state/3","type":"callback"},{"doc":"Updates the plugin state maps with a new plugin.","ref":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour.html#c:update_state_maps/6","title":"Raxol.Core.Runtime.Plugins.StateManager.Behaviour.update_state_maps/6","type":"callback"},{"doc":"Manages timers and scheduling for plugin operations.","ref":"Raxol.Core.Runtime.Plugins.TimerManager.html","title":"Raxol.Core.Runtime.Plugins.TimerManager","type":"module"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.TimerManager.html#cancel_existing_timer/1","title":"Raxol.Core.Runtime.Plugins.TimerManager.cancel_existing_timer/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.TimerManager.html#cancel_periodic_tick/1","title":"Raxol.Core.Runtime.Plugins.TimerManager.cancel_periodic_tick/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.TimerManager.html#schedule_periodic_tick/2","title":"Raxol.Core.Runtime.Plugins.TimerManager.schedule_periodic_tick/2","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Plugins.TimerManager.html#schedule_reload/3","title":"Raxol.Core.Runtime.Plugins.TimerManager.schedule_reload/3","type":"function"},{"doc":"Defines the behaviour for plugin timer management.\n\nThis behaviour is responsible for:\n- Managing plugin timers\n- Handling timer scheduling and cancellation\n- Coordinating timer events\n- Managing timer state","ref":"Raxol.Core.Runtime.Plugins.TimerManager.Behaviour.html","title":"Raxol.Core.Runtime.Plugins.TimerManager.Behaviour","type":"behaviour"},{"doc":"Cancels an existing timer and returns updated state.","ref":"Raxol.Core.Runtime.Plugins.TimerManager.Behaviour.html#c:cancel_existing_timer/1","title":"Raxol.Core.Runtime.Plugins.TimerManager.Behaviour.cancel_existing_timer/1","type":"callback"},{"doc":"Gets the current timer state.","ref":"Raxol.Core.Runtime.Plugins.TimerManager.Behaviour.html#c:get_timer_state/1","title":"Raxol.Core.Runtime.Plugins.TimerManager.Behaviour.get_timer_state/1","type":"callback"},{"doc":"Handles timer message delivery.","ref":"Raxol.Core.Runtime.Plugins.TimerManager.Behaviour.html#c:handle_timer_message/2","title":"Raxol.Core.Runtime.Plugins.TimerManager.Behaviour.handle_timer_message/2","type":"callback"},{"doc":"Schedules a new timer and returns updated state.","ref":"Raxol.Core.Runtime.Plugins.TimerManager.Behaviour.html#c:schedule_timer/3","title":"Raxol.Core.Runtime.Plugins.TimerManager.Behaviour.schedule_timer/3","type":"callback"},{"doc":"Updates the timer state.","ref":"Raxol.Core.Runtime.Plugins.TimerManager.Behaviour.html#c:update_timer_state/2","title":"Raxol.Core.Runtime.Plugins.TimerManager.Behaviour.update_timer_state/2","type":"callback"},{"doc":"Provides a screen buffer implementation for efficient rendering in Raxol applications.\n\nThis module is responsible for:\n* Maintaining the screen buffer state\n* Calculating diffs between buffer states\n* Optimizing rendering by only updating changed cells","ref":"Raxol.Core.Runtime.Rendering.Buffer.html","title":"Raxol.Core.Runtime.Rendering.Buffer","type":"module"},{"doc":"A cell represents a single character position on the screen.\n\nIt is represented as a tuple with the following elements:\n- `x`: X coordinate (column)\n- `y`: Y coordinate (row)\n- `ch`: Character to display\n- `fg`: Foreground color\n- `bg`: Background color\n- `attrs`: List of attributes (e.g., :bold, :underline)","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#t:cell/0","title":"Raxol.Core.Runtime.Rendering.Buffer.cell/0","type":"type"},{"doc":"Clears the buffer by removing all cells.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#clear/1","title":"Raxol.Core.Runtime.Rendering.Buffer.clear/1","type":"function"},{"doc":"- `buffer`: The buffer to clear","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#clear/1-parameters","title":"Parameters - Raxol.Core.Runtime.Rendering.Buffer.clear/1","type":"function"},{"doc":"Cleared buffer.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#clear/1-returns","title":"Returns - Raxol.Core.Runtime.Rendering.Buffer.clear/1","type":"function"},{"doc":"Computes the diff between two buffers.\n\nThe diff contains only the cells that need to be updated.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#diff/2","title":"Raxol.Core.Runtime.Rendering.Buffer.diff/2","type":"function"},{"doc":"- `old_buffer`: Previous buffer state\n- `new_buffer`: Current buffer state","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#diff/2-parameters","title":"Parameters - Raxol.Core.Runtime.Rendering.Buffer.diff/2","type":"function"},{"doc":"List of changed cells.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#diff/2-returns","title":"Returns - Raxol.Core.Runtime.Rendering.Buffer.diff/2","type":"function"},{"doc":"Builds a buffer from a list of cells.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#from_cells/3","title":"Raxol.Core.Runtime.Rendering.Buffer.from_cells/3","type":"function"},{"doc":"- `cells`: List of cells\n- `width`: Width of the buffer in columns\n- `height`: Height of the buffer in rows","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#from_cells/3-parameters","title":"Parameters - Raxol.Core.Runtime.Rendering.Buffer.from_cells/3","type":"function"},{"doc":"A new buffer containing the cells.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#from_cells/3-returns","title":"Returns - Raxol.Core.Runtime.Rendering.Buffer.from_cells/3","type":"function"},{"doc":"Gets the cell at the specified position.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#get_cell/3","title":"Raxol.Core.Runtime.Rendering.Buffer.get_cell/3","type":"function"},{"doc":"- `buffer`: The buffer to query\n- `x`: X coordinate\n- `y`: Y coordinate","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#get_cell/3-parameters","title":"Parameters - Raxol.Core.Runtime.Rendering.Buffer.get_cell/3","type":"function"},{"doc":"The cell tuple if found, nil otherwise.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#get_cell/3-returns","title":"Returns - Raxol.Core.Runtime.Rendering.Buffer.get_cell/3","type":"function"},{"doc":"Merges another buffer's cells into this buffer.\n\nCells from the other buffer overwrite cells in this buffer.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#merge/4","title":"Raxol.Core.Runtime.Rendering.Buffer.merge/4","type":"function"},{"doc":"- `buffer`: The destination buffer\n- `other`: The source buffer\n- `offset_x`: X offset to apply when merging\n- `offset_y`: Y offset to apply when merging","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#merge/4-parameters","title":"Parameters - Raxol.Core.Runtime.Rendering.Buffer.merge/4","type":"function"},{"doc":"Updated buffer.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#merge/4-returns","title":"Returns - Raxol.Core.Runtime.Rendering.Buffer.merge/4","type":"function"},{"doc":"Creates a new empty buffer with the given dimensions.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#new/2","title":"Raxol.Core.Runtime.Rendering.Buffer.new/2","type":"function"},{"doc":"- `width`: Width of the buffer in columns\n- `height`: Height of the buffer in rows","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#new/2-parameters","title":"Parameters - Raxol.Core.Runtime.Rendering.Buffer.new/2","type":"function"},{"doc":"A new buffer struct.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#new/2-returns","title":"Returns - Raxol.Core.Runtime.Rendering.Buffer.new/2","type":"function"},{"doc":"Resizes the buffer to new dimensions.\n\nCells outside the new dimensions are discarded.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#resize/3","title":"Raxol.Core.Runtime.Rendering.Buffer.resize/3","type":"function"},{"doc":"- `buffer`: The buffer to resize\n- `width`: New width\n- `height`: New height","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#resize/3-parameters","title":"Parameters - Raxol.Core.Runtime.Rendering.Buffer.resize/3","type":"function"},{"doc":"Resized buffer.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#resize/3-returns","title":"Returns - Raxol.Core.Runtime.Rendering.Buffer.resize/3","type":"function"},{"doc":"Sets a cell in the buffer.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#set_cell/7","title":"Raxol.Core.Runtime.Rendering.Buffer.set_cell/7","type":"function"},{"doc":"- `buffer`: The buffer to modify\n- `x`: X coordinate\n- `y`: Y coordinate\n- `ch`: Character\n- `fg`: Foreground color\n- `bg`: Background color\n- `attrs`: Attributes list","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#set_cell/7-parameters","title":"Parameters - Raxol.Core.Runtime.Rendering.Buffer.set_cell/7","type":"function"},{"doc":"Updated buffer.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#set_cell/7-returns","title":"Returns - Raxol.Core.Runtime.Rendering.Buffer.set_cell/7","type":"function"},{"doc":"A buffer is a map containing cells indexed by their position.\n\nThe buffer also contains metadata about its dimensions.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#t:t/0","title":"Raxol.Core.Runtime.Rendering.Buffer.t/0","type":"type"},{"doc":"Converts the buffer to a flat list of cells.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#to_cells/1","title":"Raxol.Core.Runtime.Rendering.Buffer.to_cells/1","type":"function"},{"doc":"- `buffer`: The buffer to convert","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#to_cells/1-parameters","title":"Parameters - Raxol.Core.Runtime.Rendering.Buffer.to_cells/1","type":"function"},{"doc":"List of cells.","ref":"Raxol.Core.Runtime.Rendering.Buffer.html#to_cells/1-returns","title":"Returns - Raxol.Core.Runtime.Rendering.Buffer.to_cells/1","type":"function"},{"doc":"Provides the core rendering functionality for Raxol applications.\n\nThis module is responsible for:\n* Rendering application views into screen buffers\n* Managing the rendering lifecycle\n* Coordinating with the output backends","ref":"Raxol.Core.Runtime.Rendering.Engine.html","title":"Raxol.Core.Runtime.Rendering.Engine","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Runtime.Rendering.Engine.html#child_spec/1","title":"Raxol.Core.Runtime.Rendering.Engine.child_spec/1","type":"function"},{"doc":"Starts the Rendering Engine process.","ref":"Raxol.Core.Runtime.Rendering.Engine.html#start_link/1","title":"Raxol.Core.Runtime.Rendering.Engine.start_link/1","type":"function"},{"doc":"Behaviour for Rendering.Engine, used for mocking.","ref":"Raxol.Core.Runtime.Rendering.Engine.Behaviour.html","title":"Raxol.Core.Runtime.Rendering.Engine.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Core.Runtime.Rendering.Engine.Behaviour.html#c:handle_cast/2","title":"Raxol.Core.Runtime.Rendering.Engine.Behaviour.handle_cast/2","type":"callback"},{"doc":"","ref":"Raxol.Core.Runtime.Rendering.Engine.Behaviour.html#c:start_link/1","title":"Raxol.Core.Runtime.Rendering.Engine.Behaviour.start_link/1","type":"callback"},{"doc":"Manages the rendering schedule based on frame rate.","ref":"Raxol.Core.Runtime.Rendering.Scheduler.html","title":"Raxol.Core.Runtime.Rendering.Scheduler","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Runtime.Rendering.Scheduler.html#child_spec/1","title":"Raxol.Core.Runtime.Rendering.Scheduler.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Rendering.Scheduler.html#disable/0","title":"Raxol.Core.Runtime.Rendering.Scheduler.disable/0","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Rendering.Scheduler.html#enable/0","title":"Raxol.Core.Runtime.Rendering.Scheduler.enable/0","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Rendering.Scheduler.html#set_interval/1","title":"Raxol.Core.Runtime.Rendering.Scheduler.set_interval/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Rendering.Scheduler.html#start_link/1","title":"Raxol.Core.Runtime.Rendering.Scheduler.start_link/1","type":"function"},{"doc":"Provides a way to subscribe to recurring updates and external events.\n\nSubscriptions allow applications to receive messages over time without\nexplicitly requesting them. This is useful for:\n* Timer-based updates (animation, polling)\n* System events (window resize, focus change)\n* External data streams (file changes, network events)","ref":"Raxol.Core.Runtime.Subscription.html","title":"Raxol.Core.Runtime.Subscription","type":"module"},{"doc":"* `:interval` - Regular time-based updates\n* `:events` - System or component events\n* `:file_watch` - File system changes\n* `:custom` - Custom event sources","ref":"Raxol.Core.Runtime.Subscription.html#module-types-of-subscriptions","title":"Types of Subscriptions - Raxol.Core.Runtime.Subscription","type":"module"},{"doc":"# Update every second\n    Subscription.interval(1000, :tick)\n\n    # Listen for specific events\n    Subscription.events([:key_press, :mouse_click])\n\n    # Watch a file for changes\n    Subscription.file_watch(\"config.json\", [:modify, :delete])\n\n    # Custom subscription\n    Subscription.custom(MyEventSource, :start_listening)","ref":"Raxol.Core.Runtime.Subscription.html#module-examples","title":"Examples - Raxol.Core.Runtime.Subscription","type":"module"},{"doc":"Creates a custom subscription using a provided event source.\nThe event source should implement the `Raxol.Core.Runtime.EventSource`\nbehaviour.","ref":"Raxol.Core.Runtime.Subscription.html#custom/2","title":"Raxol.Core.Runtime.Subscription.custom/2","type":"function"},{"doc":"Creates a subscription for system or component events.","ref":"Raxol.Core.Runtime.Subscription.html#events/1","title":"Raxol.Core.Runtime.Subscription.events/1","type":"function"},{"doc":"* `:key_press` - Keyboard events\n  * `:mouse_click` - Mouse click events\n  * `:mouse_move` - Mouse movement events\n  * `:window_resize` - Terminal window resize\n  * `:focus_change` - Terminal focus change\n  * `:component` - Component-specific events","ref":"Raxol.Core.Runtime.Subscription.html#events/1-event-types","title":"Event Types - Raxol.Core.Runtime.Subscription.events/1","type":"function"},{"doc":"Creates a subscription that watches for file system changes.","ref":"Raxol.Core.Runtime.Subscription.html#file_watch/2","title":"Raxol.Core.Runtime.Subscription.file_watch/2","type":"function"},{"doc":"* `:modify` - File content changes\n  * `:delete` - File deletion\n  * `:create` - File creation\n  * `:rename` - File rename\n  * `:attrib` - Attribute changes\n\nReturns `{:error, :invalid_file_watch_args}` if event_types is not a list.","ref":"Raxol.Core.Runtime.Subscription.html#file_watch/2-event-types","title":"Event Types - Raxol.Core.Runtime.Subscription.file_watch/2","type":"function"},{"doc":"Creates a subscription that will send a message at regular intervals.","ref":"Raxol.Core.Runtime.Subscription.html#interval/3","title":"Raxol.Core.Runtime.Subscription.interval/3","type":"function"},{"doc":"* `:start_immediately` - Send first message immediately (default: false)\n  * `:jitter` - Add random jitter to interval (default: 0)","ref":"Raxol.Core.Runtime.Subscription.html#interval/3-options","title":"Options - Raxol.Core.Runtime.Subscription.interval/3","type":"function"},{"doc":"Creates a new subscription. This is the low-level constructor, prefer using\nthe specific subscription constructors unless you need custom behavior.","ref":"Raxol.Core.Runtime.Subscription.html#new/2","title":"Raxol.Core.Runtime.Subscription.new/2","type":"function"},{"doc":"Starts a subscription within the given context. This is used by the runtime\nsystem and should not be called directly by applications.\n\nReturns `{:ok, subscription_id}` or `{:error, reason}`.","ref":"Raxol.Core.Runtime.Subscription.html#start/2","title":"Raxol.Core.Runtime.Subscription.start/2","type":"function"},{"doc":"Stops a subscription. This is used by the runtime system and should not\nbe called directly by applications.","ref":"Raxol.Core.Runtime.Subscription.html#stop/1","title":"Raxol.Core.Runtime.Subscription.stop/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Subscription.html#t:t/0","title":"Raxol.Core.Runtime.Subscription.t/0","type":"type"},{"doc":"Supervises the core runtime processes of a Raxol application.\n\nThis supervisor manages:\n* Application runtime\n* Event handlers\n* Render processes\n* State management\n* Plugin system","ref":"Raxol.Core.Runtime.Supervisor.html","title":"Raxol.Core.Runtime.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.Runtime.Supervisor.html#child_spec/1","title":"Raxol.Core.Runtime.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for  Supervisor.init/1 .","ref":"Raxol.Core.Runtime.Supervisor.html#init/1","title":"Raxol.Core.Runtime.Supervisor.init/1","type":"function"},{"doc":"","ref":"Raxol.Core.Runtime.Supervisor.html#start_link/1","title":"Raxol.Core.Runtime.Supervisor.start_link/1","type":"function"},{"doc":"Defines a behaviour for interacting with the operating system, allowing for mocking.","ref":"Raxol.Core.SystemInteraction.html","title":"Raxol.Core.SystemInteraction","type":"behaviour"},{"doc":"Finds an executable like System.find_executable/1","ref":"Raxol.Core.SystemInteraction.html#c:find_executable/1","title":"Raxol.Core.SystemInteraction.find_executable/1","type":"callback"},{"doc":"Returns the OS type like :os.type()","ref":"Raxol.Core.SystemInteraction.html#c:get_os_type/0","title":"Raxol.Core.SystemInteraction.get_os_type/0","type":"callback"},{"doc":"Executes a system command like System.cmd/3","ref":"Raxol.Core.SystemInteraction.html#c:system_cmd/3","title":"Raxol.Core.SystemInteraction.system_cmd/3","type":"callback"},{"doc":"Handles OSC 4 (Color Palette Set/Query) commands.\n\nThis handler manages the terminal's color palette, allowing dynamic\nmodification of colors during runtime.","ref":"Raxol.Core.Terminal.OSC.Handlers.ColorPalette.html","title":"Raxol.Core.Terminal.OSC.Handlers.ColorPalette","type":"module"},{"doc":"- rgb:RRRR/GGGG/BBBB (hex, 1-4 digits per component)\n- #RRGGBB (hex, 2 digits per component)\n- #RGB (hex, 1 digit per component)\n- rgb(r,g,b) (decimal, 0-255)\n- rgb(r%,g%,b%) (percentage, 0-100%)","ref":"Raxol.Core.Terminal.OSC.Handlers.ColorPalette.html#module-color-formats-supported","title":"Color Formats Supported - Raxol.Core.Terminal.OSC.Handlers.ColorPalette","type":"module"},{"doc":"Handles OSC 4 commands for color palette management.","ref":"Raxol.Core.Terminal.OSC.Handlers.ColorPalette.html#handle/2","title":"Raxol.Core.Terminal.OSC.Handlers.ColorPalette.handle/2","type":"function"},{"doc":"- `4;c;spec` - Set color c to spec\n- `4;c;?` - Query color c\n\nWhere:\n- c is the color index (0-255)\n- spec is the color specification","ref":"Raxol.Core.Terminal.OSC.Handlers.ColorPalette.html#handle/2-commands","title":"Commands - Raxol.Core.Terminal.OSC.Handlers.ColorPalette.handle/2","type":"function"},{"doc":"Represents the core state of a terminal instance.\n\nThis module defines the minimal state structure required for terminal operations,\nparticularly for handling color palette OSC (Operating System Command) operations.\nThe state maintains a mapping of color indices to their RGB values.","ref":"Raxol.Core.Terminal.State.html","title":"Raxol.Core.Terminal.State","type":"module"},{"doc":"The color palette is stored as a map where:\n* Keys are color indices (integers)\n* Values are RGB color tuples `{r, g, b}` where each component is 0-255","ref":"Raxol.Core.Terminal.State.html#module-color-palette","title":"Color Palette - Raxol.Core.Terminal.State","type":"module"},{"doc":"```elixir\n# Create a new state with default palette\nstate = %Raxol.Core.Terminal.State{}\n\n# Create state with custom palette\nstate = %Raxol.Core.Terminal.State{\n  palette: %{\n    0 => {0, 0, 0},       # Black\n    1 => {255, 0, 0},     # Red\n    2 => {0, 255, 0},     # Green\n    3 => {255, 255, 0}    # Yellow\n  }\n}\n```","ref":"Raxol.Core.Terminal.State.html#module-usage","title":"Usage - Raxol.Core.Terminal.State","type":"module"},{"doc":"Defines the terminal state structure.","ref":"Raxol.Core.Terminal.State.html#__struct__/0","title":"Raxol.Core.Terminal.State.__struct__/0","type":"function"},{"doc":"* `:palette` - Map of color indices to RGB values","ref":"Raxol.Core.Terminal.State.html#__struct__/0-fields","title":"Fields - Raxol.Core.Terminal.State.__struct__/0","type":"function"},{"doc":"Handles text processing and formatting for UI elements.","ref":"Raxol.Core.TextProcessor.html","title":"Raxol.Core.TextProcessor","type":"module"},{"doc":"Processes a text element map and returns a processed version with proper formatting.","ref":"Raxol.Core.TextProcessor.html#process_text_element/2","title":"Raxol.Core.TextProcessor.process_text_element/2","type":"function"},{"doc":"User experience refinement module for the Raxol terminal UI.\n\nThis module provides comprehensive UX features to enhance the terminal UI experience:\n\n* Focus Management - Track and manage focus across UI components\n* Keyboard Navigation - Enable intuitive keyboard navigation\n* Contextual Hints - Display helpful hints based on current context\n* Focus Indicators - Visual indicators for focused elements\n* Multi-level Hints - Basic, detailed, and examples for different help levels\n* Keyboard Shortcuts - Global and context-specific keyboard shortcuts\n* Accessibility Features - Screen reader support, high contrast, reduced motion, etc.\n\nAll features can be enabled or disabled individually to customize the UX to your needs.","ref":"Raxol.Core.UXRefinement.html","title":"Raxol.Core.UXRefinement","type":"module"},{"doc":"Make an announcement for screen readers.","ref":"Raxol.Core.UXRefinement.html#announce/3","title":"Raxol.Core.UXRefinement.announce/3","type":"function"},{"doc":"* `message` - The message to announce\n* `opts` - Options for the announcement\n* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (required)","ref":"Raxol.Core.UXRefinement.html#announce/3-parameters","title":"Parameters - Raxol.Core.UXRefinement.announce/3","type":"function"},{"doc":"Disable a previously enabled UX refinement feature.","ref":"Raxol.Core.UXRefinement.html#disable_feature/1","title":"Raxol.Core.UXRefinement.disable_feature/1","type":"function"},{"doc":"* `feature` - The feature to disable","ref":"Raxol.Core.UXRefinement.html#disable_feature/1-parameters","title":"Parameters - Raxol.Core.UXRefinement.disable_feature/1","type":"function"},{"doc":"iex> UXRefinement.disable_feature(:hints)\n    :ok","ref":"Raxol.Core.UXRefinement.html#disable_feature/1-examples","title":"Examples - Raxol.Core.UXRefinement.disable_feature/1","type":"function"},{"doc":"","ref":"Raxol.Core.UXRefinement.html#enable_feature/1","title":"Raxol.Core.UXRefinement.enable_feature/1","type":"function"},{"doc":"Enable a UX refinement feature.\n\nAvailable features:\n\n* `:focus_management` - Enable focus tracking and management\n* `:keyboard_navigation` - Enable keyboard navigation\n* `:hints` - Enable contextual hints\n* `:focus_ring` - Enable visual focus indicators\n* `:accessibility` - Enable accessibility features\n* `:keyboard_shortcuts` - Enable keyboard shortcuts\n* `:events` - Enable event management system","ref":"Raxol.Core.UXRefinement.html#enable_feature/3","title":"Raxol.Core.UXRefinement.enable_feature/3","type":"function"},{"doc":"* `feature` - The feature to enable\n* `opts` - Options for the feature\n* `user_preferences_pid_or_name` - The PID or registered name of the UserPreferences process to use (required)","ref":"Raxol.Core.UXRefinement.html#enable_feature/3-parameters","title":"Parameters - Raxol.Core.UXRefinement.enable_feature/3","type":"function"},{"doc":"iex> UXRefinement.enable_feature(:focus_management)\n    :ok\n\n    iex> UXRefinement.enable_feature(:accessibility, high_contrast: true)\n    :ok","ref":"Raxol.Core.UXRefinement.html#enable_feature/3-examples","title":"Examples - Raxol.Core.UXRefinement.enable_feature/3","type":"function"},{"doc":"Check if a UX refinement feature is enabled.","ref":"Raxol.Core.UXRefinement.html#feature_enabled?/1","title":"Raxol.Core.UXRefinement.feature_enabled?/1","type":"function"},{"doc":"* `feature` - The feature to check","ref":"Raxol.Core.UXRefinement.html#feature_enabled?/1-parameters","title":"Parameters - Raxol.Core.UXRefinement.feature_enabled?/1","type":"function"},{"doc":"iex> UXRefinement.feature_enabled?(:focus_management)\n    true","ref":"Raxol.Core.UXRefinement.html#feature_enabled?/1-examples","title":"Examples - Raxol.Core.UXRefinement.feature_enabled?/1","type":"function"},{"doc":"Get accessibility metadata for a component.","ref":"Raxol.Core.UXRefinement.html#get_accessibility_metadata/1","title":"Raxol.Core.UXRefinement.get_accessibility_metadata/1","type":"function"},{"doc":"Get all available shortcuts for a given context.\nIf no context is provided, returns shortcuts for the current active context.","ref":"Raxol.Core.UXRefinement.html#get_available_shortcuts/1","title":"Raxol.Core.UXRefinement.get_available_shortcuts/1","type":"function"},{"doc":"Get a specific hint level for a component.","ref":"Raxol.Core.UXRefinement.html#get_component_hint/2","title":"Raxol.Core.UXRefinement.get_component_hint/2","type":"function"},{"doc":"* `component_id` - The ID of the component\n* `level` - The hint level to retrieve (`:basic`, `:detailed`, `:examples`)","ref":"Raxol.Core.UXRefinement.html#get_component_hint/2-parameters","title":"Parameters - Raxol.Core.UXRefinement.get_component_hint/2","type":"function"},{"doc":"iex> UXRefinement.get_component_hint(\"search_button\", :detailed)\n    \"Search for content in the application using keywords\"","ref":"Raxol.Core.UXRefinement.html#get_component_hint/2-examples","title":"Examples - Raxol.Core.UXRefinement.get_component_hint/2","type":"function"},{"doc":"Get shortcuts for a component.","ref":"Raxol.Core.UXRefinement.html#get_component_shortcuts/1","title":"Raxol.Core.UXRefinement.get_component_shortcuts/1","type":"function"},{"doc":"* `component_id` - The ID of the component","ref":"Raxol.Core.UXRefinement.html#get_component_shortcuts/1-parameters","title":"Parameters - Raxol.Core.UXRefinement.get_component_shortcuts/1","type":"function"},{"doc":"iex> UXRefinement.get_component_shortcuts(\"search_button\")\n    [{\"Enter\", \"Execute search\"}, {\"Alt+S\", \"Focus search\"}]","ref":"Raxol.Core.UXRefinement.html#get_component_shortcuts/1-examples","title":"Examples - Raxol.Core.UXRefinement.get_component_shortcuts/1","type":"function"},{"doc":"Get the hint for a component.\n\nThis returns the basic hint by default. Use `get_component_hint/2` for\nmore detailed hints.","ref":"Raxol.Core.UXRefinement.html#get_hint/1","title":"Raxol.Core.UXRefinement.get_hint/1","type":"function"},{"doc":"* `component_id` - The ID of the component","ref":"Raxol.Core.UXRefinement.html#get_hint/1-parameters","title":"Parameters - Raxol.Core.UXRefinement.get_hint/1","type":"function"},{"doc":"iex> UXRefinement.get_hint(\"search_button\")\n    \"Search for content\"","ref":"Raxol.Core.UXRefinement.html#get_hint/1-examples","title":"Examples - Raxol.Core.UXRefinement.get_hint/1","type":"function"},{"doc":"Initialize the UX refinement system.\n\nThis function sets up the basic infrastructure for UX refinement features.\nIt should be called before enabling any specific features.","ref":"Raxol.Core.UXRefinement.html#init/0","title":"Raxol.Core.UXRefinement.init/0","type":"function"},{"doc":"iex> UXRefinement.init()\n    :ok","ref":"Raxol.Core.UXRefinement.html#init/0-examples","title":"Examples - Raxol.Core.UXRefinement.init/0","type":"function"},{"doc":"Register accessibility metadata for a component.","ref":"Raxol.Core.UXRefinement.html#register_accessibility_metadata/2","title":"Raxol.Core.UXRefinement.register_accessibility_metadata/2","type":"function"},{"doc":"* `component_id` - The ID of the component\n* `metadata` - The metadata to register","ref":"Raxol.Core.UXRefinement.html#register_accessibility_metadata/2-parameters","title":"Parameters - Raxol.Core.UXRefinement.register_accessibility_metadata/2","type":"function"},{"doc":"iex> UXRefinement.register_accessibility_metadata(\"search_button\", %{label: \"Search\"})\n    :ok","ref":"Raxol.Core.UXRefinement.html#register_accessibility_metadata/2-examples","title":"Examples - Raxol.Core.UXRefinement.register_accessibility_metadata/2","type":"function"},{"doc":"Register comprehensive hints for a component with multiple detail levels.","ref":"Raxol.Core.UXRefinement.html#register_component_hint/2","title":"Raxol.Core.UXRefinement.register_component_hint/2","type":"function"},{"doc":"* `component_id` - The ID of the component\n* `hint_info` - Map containing different levels of hints and shortcuts","ref":"Raxol.Core.UXRefinement.html#register_component_hint/2-parameters","title":"Parameters - Raxol.Core.UXRefinement.register_component_hint/2","type":"function"},{"doc":"* `:basic` - Basic hint (shown by default)\n* `:detailed` - More detailed explanation\n* `:examples` - Examples of usage\n* `:shortcuts` - List of keyboard shortcuts for the component: `[{\"Ctrl+S\", \"Save\"}, ...]`","ref":"Raxol.Core.UXRefinement.html#register_component_hint/2-hint-info-structure","title":"Hint Info Structure - Raxol.Core.UXRefinement.register_component_hint/2","type":"function"},{"doc":"iex> UXRefinement.register_component_hint(\"search_button\", %{\n    ...>   basic: \"Search for content\",\n    ...>   detailed: \"Search for content in the application using keywords\",\n    ...>   examples: \"Type keywords like \"settings\" or \"help\"\",\n    ...>   shortcuts: [\n    ...>     {\"Enter\", \"Execute search\"},\n    ...>     {\"Alt+S\", \"Focus search\"}\n    ...>   ]\n    ...> })\n    :ok\n\n    iex> UXRefinement.register_component_hint(\"simple_button\", \"Click me\")\n    :ok","ref":"Raxol.Core.UXRefinement.html#register_component_hint/2-examples","title":"Examples - Raxol.Core.UXRefinement.register_component_hint/2","type":"function"},{"doc":"Register a hint for a component.","ref":"Raxol.Core.UXRefinement.html#register_hint/2","title":"Raxol.Core.UXRefinement.register_hint/2","type":"function"},{"doc":"* `component_id` - The ID of the component\n* `hint` - The hint text","ref":"Raxol.Core.UXRefinement.html#register_hint/2-parameters","title":"Parameters - Raxol.Core.UXRefinement.register_hint/2","type":"function"},{"doc":"iex> UXRefinement.register_hint(\"search_button\", \"Search for content\")\n    :ok","ref":"Raxol.Core.UXRefinement.html#register_hint/2-examples","title":"Examples - Raxol.Core.UXRefinement.register_hint/2","type":"function"},{"doc":"Set the active context for keyboard shortcuts.","ref":"Raxol.Core.UXRefinement.html#set_shortcuts_context/1","title":"Raxol.Core.UXRefinement.set_shortcuts_context/1","type":"function"},{"doc":"Display help for available keyboard shortcuts (no user preferences context).","ref":"Raxol.Core.UXRefinement.html#show_shortcuts_help/0","title":"Raxol.Core.UXRefinement.show_shortcuts_help/0","type":"function"},{"doc":"Display help for available keyboard shortcuts.","ref":"Raxol.Core.UXRefinement.html#show_shortcuts_help/1","title":"Raxol.Core.UXRefinement.show_shortcuts_help/1","type":"function"},{"doc":"Manages user preferences for the terminal emulator.\n\nActs as a GenServer holding the preferences state and handles persistence.","ref":"Raxol.Core.UserPreferences.html","title":"Raxol.Core.UserPreferences","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Core.UserPreferences.html#child_spec/1","title":"Raxol.Core.UserPreferences.child_spec/1","type":"function"},{"doc":"Returns the default preferences map.\nThis includes default values for theme, terminal configuration, accessibility settings,\nand keybindings.","ref":"Raxol.Core.UserPreferences.html#default_preferences/0","title":"Raxol.Core.UserPreferences.default_preferences/0","type":"function"},{"doc":"","ref":"Raxol.Core.UserPreferences.html#get/2","title":"Raxol.Core.UserPreferences.get/2","type":"function"},{"doc":"","ref":"Raxol.Core.UserPreferences.html#get_all/1","title":"Raxol.Core.UserPreferences.get_all/1","type":"function"},{"doc":"Returns the current theme id as an atom, defaulting to :default if not set or invalid.","ref":"Raxol.Core.UserPreferences.html#get_theme_id/1","title":"Raxol.Core.UserPreferences.get_theme_id/1","type":"function"},{"doc":"","ref":"Raxol.Core.UserPreferences.html#reset_to_defaults_for_test!/1","title":"Raxol.Core.UserPreferences.reset_to_defaults_for_test!/1","type":"function"},{"doc":"","ref":"Raxol.Core.UserPreferences.html#save!/1","title":"Raxol.Core.UserPreferences.save!/1","type":"function"},{"doc":"","ref":"Raxol.Core.UserPreferences.html#set/3","title":"Raxol.Core.UserPreferences.set/3","type":"function"},{"doc":"","ref":"Raxol.Core.UserPreferences.html#start_link/1","title":"Raxol.Core.UserPreferences.start_link/1","type":"function"},{"doc":"Defines the behaviour for UserPreferences services.","ref":"Raxol.Core.UserPreferences.Behaviour.html","title":"Raxol.Core.UserPreferences.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Core.UserPreferences.Behaviour.html#c:get/1","title":"Raxol.Core.UserPreferences.Behaviour.get/1","type":"callback"},{"doc":"Gets a user preference value by key path.","ref":"Raxol.Core.UserPreferences.Behaviour.html#c:get/2","title":"Raxol.Core.UserPreferences.Behaviour.get/2","type":"callback"},{"doc":"","ref":"Raxol.Core.UserPreferences.Behaviour.html#c:get_all/0","title":"Raxol.Core.UserPreferences.Behaviour.get_all/0","type":"callback"},{"doc":"Retrieves the entire preferences map.","ref":"Raxol.Core.UserPreferences.Behaviour.html#c:get_all/1","title":"Raxol.Core.UserPreferences.Behaviour.get_all/1","type":"callback"},{"doc":"","ref":"Raxol.Core.UserPreferences.Behaviour.html#c:save!/0","title":"Raxol.Core.UserPreferences.Behaviour.save!/0","type":"callback"},{"doc":"Forces an immediate save of the current preferences.","ref":"Raxol.Core.UserPreferences.Behaviour.html#c:save!/1","title":"Raxol.Core.UserPreferences.Behaviour.save!/1","type":"callback"},{"doc":"","ref":"Raxol.Core.UserPreferences.Behaviour.html#c:set/2","title":"Raxol.Core.UserPreferences.Behaviour.set/2","type":"callback"},{"doc":"Sets a user preference value by key path.","ref":"Raxol.Core.UserPreferences.Behaviour.html#c:set/3","title":"Raxol.Core.UserPreferences.Behaviour.set/3","type":"callback"},{"doc":"Internal state for the UserPreferences GenServer.","ref":"Raxol.Core.UserPreferences.State.html","title":"Raxol.Core.UserPreferences.State","type":"module"},{"doc":"Provides a safe interface for database operations.\n\nThis module:\n- Wraps all database operations with retry logic\n- Provides convenience functions for common database operations\n- Handles database errors gracefully","ref":"Raxol.Database.html","title":"Raxol.Database","type":"module"},{"doc":"Gets all records of a schema with retry logic.","ref":"Raxol.Database.html#all/2","title":"Raxol.Database.all/2","type":"function"},{"doc":"- `schema` - The schema module\n- `clauses` - Optional where clauses","ref":"Raxol.Database.html#all/2-parameters","title":"Parameters - Raxol.Database.all/2","type":"function"},{"doc":"- `{:ok, records}` - Records found\n- `{:error, reason}` - Query failed","ref":"Raxol.Database.html#all/2-returns","title":"Returns - Raxol.Database.all/2","type":"function"},{"doc":"Creates a record with retry logic.","ref":"Raxol.Database.html#create/2","title":"Raxol.Database.create/2","type":"function"},{"doc":"- `schema` - The schema module\n- `attrs` - The attributes for the new record","ref":"Raxol.Database.html#create/2-parameters","title":"Parameters - Raxol.Database.create/2","type":"function"},{"doc":"- `{:ok, record}` - Record created\n- `{:error, changeset}` - Validation failed\n- `{:error, reason}` - Query failed","ref":"Raxol.Database.html#create/2-returns","title":"Returns - Raxol.Database.create/2","type":"function"},{"doc":"Deletes a record with retry logic.","ref":"Raxol.Database.html#delete/1","title":"Raxol.Database.delete/1","type":"function"},{"doc":"- `record` - The record to delete","ref":"Raxol.Database.html#delete/1-parameters","title":"Parameters - Raxol.Database.delete/1","type":"function"},{"doc":"- `{:ok, record}` - Record deleted\n- `{:error, changeset}` - Deletion validation failed\n- `{:error, reason}` - Query failed","ref":"Raxol.Database.html#delete/1-returns","title":"Returns - Raxol.Database.delete/1","type":"function"},{"doc":"Gets a record by ID with retry logic.","ref":"Raxol.Database.html#get/2","title":"Raxol.Database.get/2","type":"function"},{"doc":"- `schema` - The schema module\n- `id` - The record ID","ref":"Raxol.Database.html#get/2-parameters","title":"Parameters - Raxol.Database.get/2","type":"function"},{"doc":"- `{:ok, record}` - Record found\n- `{:error, :not_found}` - Record not found\n- `{:error, reason}` - Query failed","ref":"Raxol.Database.html#get/2-returns","title":"Returns - Raxol.Database.get/2","type":"function"},{"doc":"Checks if the database connection is healthy.","ref":"Raxol.Database.html#healthy?/0","title":"Raxol.Database.healthy?/0","type":"function"},{"doc":"- `true` - Connection is healthy\n- `false` - Connection is unhealthy","ref":"Raxol.Database.html#healthy?/0-returns","title":"Returns - Raxol.Database.healthy?/0","type":"function"},{"doc":"Restarts the database connection if it becomes unhealthy.","ref":"Raxol.Database.html#restart_connection/0","title":"Raxol.Database.restart_connection/0","type":"function"},{"doc":"- `:ok` - Connection restart attempted","ref":"Raxol.Database.html#restart_connection/0-returns","title":"Returns - Raxol.Database.restart_connection/0","type":"function"},{"doc":"Safely executes a database query with retry logic.","ref":"Raxol.Database.html#safe_query/1","title":"Raxol.Database.safe_query/1","type":"function"},{"doc":"- `fun` - Function containing database operations","ref":"Raxol.Database.html#safe_query/1-parameters","title":"Parameters - Raxol.Database.safe_query/1","type":"function"},{"doc":"- `{:ok, result}` - Operation succeeded\n- `{:error, reason}` - Operation failed after retries","ref":"Raxol.Database.html#safe_query/1-returns","title":"Returns - Raxol.Database.safe_query/1","type":"function"},{"doc":"Executes a transaction with retry logic.","ref":"Raxol.Database.html#transaction/1","title":"Raxol.Database.transaction/1","type":"function"},{"doc":"- `fun` - Function containing transaction operations","ref":"Raxol.Database.html#transaction/1-parameters","title":"Parameters - Raxol.Database.transaction/1","type":"function"},{"doc":"- `{:ok, result}` - Transaction succeeded\n- `{:error, reason}` - Transaction failed","ref":"Raxol.Database.html#transaction/1-returns","title":"Returns - Raxol.Database.transaction/1","type":"function"},{"doc":"Updates a record with retry logic.","ref":"Raxol.Database.html#update/3","title":"Raxol.Database.update/3","type":"function"},{"doc":"- `schema` - The schema module\n- `record` - The record to update\n- `attrs` - The new attributes","ref":"Raxol.Database.html#update/3-parameters","title":"Parameters - Raxol.Database.update/3","type":"function"},{"doc":"- `{:ok, record}` - Record updated\n- `{:error, changeset}` - Validation failed\n- `{:error, reason}` - Query failed","ref":"Raxol.Database.html#update/3-returns","title":"Returns - Raxol.Database.update/3","type":"function"},{"doc":"Manages database connections and provides retry logic for Postgres errors.\n\nThis module:\n- Handles graceful connection retries\n- Monitors database connection health\n- Provides tools for debugging connection issues","ref":"Raxol.Database.ConnectionManager.html","title":"Raxol.Database.ConnectionManager","type":"module"},{"doc":"Ensures the database connection is reset after application crash.\n\nThis function should be called during application startup.","ref":"Raxol.Database.ConnectionManager.html#ensure_connection/0","title":"Raxol.Database.ConnectionManager.ensure_connection/0","type":"function"},{"doc":"Checks if the database connection is healthy.","ref":"Raxol.Database.ConnectionManager.html#healthy?/0","title":"Raxol.Database.ConnectionManager.healthy?/0","type":"function"},{"doc":"- `true` - Connection is healthy\n- `false` - Connection is unhealthy","ref":"Raxol.Database.ConnectionManager.html#healthy?/0-returns","title":"Returns - Raxol.Database.ConnectionManager.healthy?/0","type":"function"},{"doc":"Forcibly restarts the database connection.","ref":"Raxol.Database.ConnectionManager.html#restart_connection/0","title":"Raxol.Database.ConnectionManager.restart_connection/0","type":"function"},{"doc":"Attempts a database operation with retry logic.","ref":"Raxol.Database.ConnectionManager.html#with_retries/3","title":"Raxol.Database.ConnectionManager.with_retries/3","type":"function"},{"doc":"- `operation` - A function that performs a database operation\n- `max_retries` - Maximum number of retry attempts (default: 5)\n- `retry_delay_ms` - Delay between retries in milliseconds (default: 1000)","ref":"Raxol.Database.ConnectionManager.html#with_retries/3-parameters","title":"Parameters - Raxol.Database.ConnectionManager.with_retries/3","type":"function"},{"doc":"- `{:ok, result}` - Operation succeeded\n- `{:error, error}` - Operation failed after retries","ref":"Raxol.Database.ConnectionManager.html#with_retries/3-returns","title":"Returns - Raxol.Database.ConnectionManager.with_retries/3","type":"function"},{"doc":"Visual component catalog for Raxol documentation.\n\nThis module provides a comprehensive catalog of all UI components\navailable in Raxol, with visual examples, code snippets, and interactive\ncustomization capabilities.\n\nFeatures:\n* Categorized components listing\n* Live examples with code snippets\n* Interactive property customization\n* Accessibility information\n* Related components suggestions\n* Search functionality","ref":"Raxol.Docs.ComponentCatalog.html","title":"Raxol.Docs.ComponentCatalog","type":"module"},{"doc":"Generates code snippets for a component with the given properties.","ref":"Raxol.Docs.ComponentCatalog.html#generate_code_snippet/2","title":"Raxol.Docs.ComponentCatalog.generate_code_snippet/2","type":"function"},{"doc":"Gets accessibility information for a component.","ref":"Raxol.Docs.ComponentCatalog.html#get_accessibility_info/1","title":"Raxol.Docs.ComponentCatalog.get_accessibility_info/1","type":"function"},{"doc":"Gets a specific category by ID.","ref":"Raxol.Docs.ComponentCatalog.html#get_category/1","title":"Raxol.Docs.ComponentCatalog.get_category/1","type":"function"},{"doc":"Gets a specific component by ID.","ref":"Raxol.Docs.ComponentCatalog.html#get_component/1","title":"Raxol.Docs.ComponentCatalog.get_component/1","type":"function"},{"doc":"Gets usage statistics for components.","ref":"Raxol.Docs.ComponentCatalog.html#get_usage_stats/0","title":"Raxol.Docs.ComponentCatalog.get_usage_stats/0","type":"function"},{"doc":"Initializes the component catalog.","ref":"Raxol.Docs.ComponentCatalog.html#init/0","title":"Raxol.Docs.ComponentCatalog.init/0","type":"function"},{"doc":"Lists all component categories.","ref":"Raxol.Docs.ComponentCatalog.html#list_categories/0","title":"Raxol.Docs.ComponentCatalog.list_categories/0","type":"function"},{"doc":"Lists all components in a specific category.","ref":"Raxol.Docs.ComponentCatalog.html#list_components/1","title":"Raxol.Docs.ComponentCatalog.list_components/1","type":"function"},{"doc":"Renders a component example.","ref":"Raxol.Docs.ComponentCatalog.html#render_example/3","title":"Raxol.Docs.ComponentCatalog.render_example/3","type":"function"},{"doc":"Searches for components based on a query.","ref":"Raxol.Docs.ComponentCatalog.html#search/1","title":"Raxol.Docs.ComponentCatalog.search/1","type":"function"},{"doc":"Suggests related components.","ref":"Raxol.Docs.ComponentCatalog.html#suggest_related_components/1","title":"Raxol.Docs.ComponentCatalog.suggest_related_components/1","type":"function"},{"doc":"Interactive tutorial system for Raxol documentation.\n\nThis module provides a framework for creating and displaying interactive\ntutorials that guide users through Raxol features with hands-on examples\nand step-by-step instructions.\n\nFeatures:\n* Step-by-step guides with interactive examples\n* Progress tracking and bookmarking\n* Exercise validation\n* Contextual hints and help\n* Integration with documentation","ref":"Raxol.Docs.InteractiveTutorial.html","title":"Raxol.Docs.InteractiveTutorial","type":"module"},{"doc":"Gets the current position in the tutorial.","ref":"Raxol.Docs.InteractiveTutorial.html#get_current_position/0","title":"Raxol.Docs.InteractiveTutorial.get_current_position/0","type":"function"},{"doc":"Gets a hint for the current step.","ref":"Raxol.Docs.InteractiveTutorial.html#get_hint/0","title":"Raxol.Docs.InteractiveTutorial.get_hint/0","type":"function"},{"doc":"Gets the progress for a tutorial.","ref":"Raxol.Docs.InteractiveTutorial.html#get_progress/1","title":"Raxol.Docs.InteractiveTutorial.get_progress/1","type":"function"},{"doc":"Initializes the tutorial system.","ref":"Raxol.Docs.InteractiveTutorial.html#init/0","title":"Raxol.Docs.InteractiveTutorial.init/0","type":"function"},{"doc":"Jumps to a specific step in the current tutorial.","ref":"Raxol.Docs.InteractiveTutorial.html#jump_to_step/1","title":"Raxol.Docs.InteractiveTutorial.jump_to_step/1","type":"function"},{"doc":"Returns a list of all available tutorials.","ref":"Raxol.Docs.InteractiveTutorial.html#list_tutorials/0","title":"Raxol.Docs.InteractiveTutorial.list_tutorials/0","type":"function"},{"doc":"Goes to the next step in the current tutorial.","ref":"Raxol.Docs.InteractiveTutorial.html#next_step/0","title":"Raxol.Docs.InteractiveTutorial.next_step/0","type":"function"},{"doc":"Goes to the previous step in the current tutorial.","ref":"Raxol.Docs.InteractiveTutorial.html#previous_step/0","title":"Raxol.Docs.InteractiveTutorial.previous_step/0","type":"function"},{"doc":"Registers a new tutorial.","ref":"Raxol.Docs.InteractiveTutorial.html#register_tutorial/2","title":"Raxol.Docs.InteractiveTutorial.register_tutorial/2","type":"function"},{"doc":"Renders the current step's content.","ref":"Raxol.Docs.InteractiveTutorial.html#render_current_step/0","title":"Raxol.Docs.InteractiveTutorial.render_current_step/0","type":"function"},{"doc":"Renders interactive elements for the current step.","ref":"Raxol.Docs.InteractiveTutorial.html#render_interactive_elements/0","title":"Raxol.Docs.InteractiveTutorial.render_interactive_elements/0","type":"function"},{"doc":"Starts a tutorial by ID.","ref":"Raxol.Docs.InteractiveTutorial.html#start_tutorial/1","title":"Raxol.Docs.InteractiveTutorial.start_tutorial/1","type":"function"},{"doc":"Validates a solution for the current step.","ref":"Raxol.Docs.InteractiveTutorial.html#validate_exercise/1","title":"Raxol.Docs.InteractiveTutorial.validate_exercise/1","type":"function"},{"doc":"Handles loading and parsing of tutorials from markdown files.","ref":"Raxol.Docs.InteractiveTutorial.Loader.html","title":"Raxol.Docs.InteractiveTutorial.Loader","type":"module"},{"doc":"Extracts YAML front matter from markdown content.","ref":"Raxol.Docs.InteractiveTutorial.Loader.html#extract_front_matter/1","title":"Raxol.Docs.InteractiveTutorial.Loader.extract_front_matter/1","type":"function"},{"doc":"Loads a single tutorial from a markdown file.","ref":"Raxol.Docs.InteractiveTutorial.Loader.html#load_tutorial/1","title":"Raxol.Docs.InteractiveTutorial.Loader.load_tutorial/1","type":"function"},{"doc":"Loads all tutorials from the specified directory.","ref":"Raxol.Docs.InteractiveTutorial.Loader.html#load_tutorials_from_markdown/1","title":"Raxol.Docs.InteractiveTutorial.Loader.load_tutorials_from_markdown/1","type":"function"},{"doc":"Parses YAML front matter into a Tutorial struct.","ref":"Raxol.Docs.InteractiveTutorial.Loader.html#parse_front_matter/1","title":"Raxol.Docs.InteractiveTutorial.Loader.parse_front_matter/1","type":"function"},{"doc":"Parses a single step from markdown content.","ref":"Raxol.Docs.InteractiveTutorial.Loader.html#parse_step/1","title":"Raxol.Docs.InteractiveTutorial.Loader.parse_step/1","type":"function"},{"doc":"Parses markdown content into a list of Step structs.","ref":"Raxol.Docs.InteractiveTutorial.Loader.html#parse_steps/1","title":"Raxol.Docs.InteractiveTutorial.Loader.parse_steps/1","type":"function"},{"doc":"Defines the core data structures for the interactive tutorial system.","ref":"Raxol.Docs.InteractiveTutorial.Models.html","title":"Raxol.Docs.InteractiveTutorial.Models","type":"module"},{"doc":"","ref":"Raxol.Docs.InteractiveTutorial.Models.html#t:step_id/0","title":"Raxol.Docs.InteractiveTutorial.Models.step_id/0","type":"type"},{"doc":"","ref":"Raxol.Docs.InteractiveTutorial.Models.html#t:tutorial_id/0","title":"Raxol.Docs.InteractiveTutorial.Models.tutorial_id/0","type":"type"},{"doc":"Represents a single step in a tutorial.","ref":"Raxol.Docs.InteractiveTutorial.Models.Step.html","title":"Raxol.Docs.InteractiveTutorial.Models.Step","type":"module"},{"doc":"","ref":"Raxol.Docs.InteractiveTutorial.Models.Step.html#t:t/0","title":"Raxol.Docs.InteractiveTutorial.Models.Step.t/0","type":"type"},{"doc":"Represents a complete tutorial with multiple steps.","ref":"Raxol.Docs.InteractiveTutorial.Models.Tutorial.html","title":"Raxol.Docs.InteractiveTutorial.Models.Tutorial","type":"module"},{"doc":"","ref":"Raxol.Docs.InteractiveTutorial.Models.Tutorial.html#t:t/0","title":"Raxol.Docs.InteractiveTutorial.Models.Tutorial.t/0","type":"type"},{"doc":"Handles navigation and progress tracking for tutorials.","ref":"Raxol.Docs.InteractiveTutorial.Navigation.html","title":"Raxol.Docs.InteractiveTutorial.Navigation","type":"module"},{"doc":"Gets the progress for a tutorial.","ref":"Raxol.Docs.InteractiveTutorial.Navigation.html#get_progress/2","title":"Raxol.Docs.InteractiveTutorial.Navigation.get_progress/2","type":"function"},{"doc":"Jumps to a specific step in the current tutorial.","ref":"Raxol.Docs.InteractiveTutorial.Navigation.html#jump_to_step/2","title":"Raxol.Docs.InteractiveTutorial.Navigation.jump_to_step/2","type":"function"},{"doc":"Goes to the next step in the current tutorial.","ref":"Raxol.Docs.InteractiveTutorial.Navigation.html#next_step/1","title":"Raxol.Docs.InteractiveTutorial.Navigation.next_step/1","type":"function"},{"doc":"Goes to the previous step in the current tutorial.","ref":"Raxol.Docs.InteractiveTutorial.Navigation.html#previous_step/1","title":"Raxol.Docs.InteractiveTutorial.Navigation.previous_step/1","type":"function"},{"doc":"Starts a tutorial by ID.","ref":"Raxol.Docs.InteractiveTutorial.Navigation.html#start_tutorial/2","title":"Raxol.Docs.InteractiveTutorial.Navigation.start_tutorial/2","type":"function"},{"doc":"Handles rendering of interactive tutorial content.","ref":"Raxol.Docs.InteractiveTutorial.Renderer.html","title":"Raxol.Docs.InteractiveTutorial.Renderer","type":"module"},{"doc":"Renders interactive elements for a step.","ref":"Raxol.Docs.InteractiveTutorial.Renderer.html#render_interactive_elements/1","title":"Raxol.Docs.InteractiveTutorial.Renderer.render_interactive_elements/1","type":"function"},{"doc":"Renders a single step's content.","ref":"Raxol.Docs.InteractiveTutorial.Renderer.html#render_step/1","title":"Raxol.Docs.InteractiveTutorial.Renderer.render_step/1","type":"function"},{"doc":"Renders a tutorial's content.","ref":"Raxol.Docs.InteractiveTutorial.Renderer.html#render_tutorial/1","title":"Raxol.Docs.InteractiveTutorial.Renderer.render_tutorial/1","type":"function"},{"doc":"Manages the state of the interactive tutorial system.","ref":"Raxol.Docs.InteractiveTutorial.State.html","title":"Raxol.Docs.InteractiveTutorial.State","type":"module"},{"doc":"Gets the current step from the state.","ref":"Raxol.Docs.InteractiveTutorial.State.html#get_current_step/1","title":"Raxol.Docs.InteractiveTutorial.State.get_current_step/1","type":"function"},{"doc":"Marks a tutorial as completed.","ref":"Raxol.Docs.InteractiveTutorial.State.html#mark_completed/2","title":"Raxol.Docs.InteractiveTutorial.State.mark_completed/2","type":"function"},{"doc":"Creates a new empty state.","ref":"Raxol.Docs.InteractiveTutorial.State.html#new/0","title":"Raxol.Docs.InteractiveTutorial.State.new/0","type":"function"},{"doc":"","ref":"Raxol.Docs.InteractiveTutorial.State.html#t:progress/0","title":"Raxol.Docs.InteractiveTutorial.State.progress/0","type":"type"},{"doc":"","ref":"Raxol.Docs.InteractiveTutorial.State.html#t:step_id/0","title":"Raxol.Docs.InteractiveTutorial.State.step_id/0","type":"type"},{"doc":"","ref":"Raxol.Docs.InteractiveTutorial.State.html#t:t/0","title":"Raxol.Docs.InteractiveTutorial.State.t/0","type":"type"},{"doc":"","ref":"Raxol.Docs.InteractiveTutorial.State.html#t:tutorial_id/0","title":"Raxol.Docs.InteractiveTutorial.State.tutorial_id/0","type":"type"},{"doc":"Updates the progress for a tutorial.","ref":"Raxol.Docs.InteractiveTutorial.State.html#update_progress/3","title":"Raxol.Docs.InteractiveTutorial.State.update_progress/3","type":"function"},{"doc":"Handles validation of tutorial exercises and user input.","ref":"Raxol.Docs.InteractiveTutorial.Validation.html","title":"Raxol.Docs.InteractiveTutorial.Validation","type":"module"},{"doc":"Validates code execution.","ref":"Raxol.Docs.InteractiveTutorial.Validation.html#validate_execution/1","title":"Raxol.Docs.InteractiveTutorial.Validation.validate_execution/1","type":"function"},{"doc":"Checks if a solution matches the expected output.","ref":"Raxol.Docs.InteractiveTutorial.Validation.html#validate_output/2","title":"Raxol.Docs.InteractiveTutorial.Validation.validate_output/2","type":"function"},{"doc":"Validates a user's solution for an exercise.","ref":"Raxol.Docs.InteractiveTutorial.Validation.html#validate_solution/2","title":"Raxol.Docs.InteractiveTutorial.Validation.validate_solution/2","type":"function"},{"doc":"Validates a user's solution for an exercise with custom validation function.","ref":"Raxol.Docs.InteractiveTutorial.Validation.html#validate_solution/3","title":"Raxol.Docs.InteractiveTutorial.Validation.validate_solution/3","type":"function"},{"doc":"Validates code syntax.","ref":"Raxol.Docs.InteractiveTutorial.Validation.html#validate_syntax/1","title":"Raxol.Docs.InteractiveTutorial.Validation.validate_syntax/1","type":"function"},{"doc":"","ref":"Raxol.Docs.InteractiveTutorial.Validation.html#t:validation_result/0","title":"Raxol.Docs.InteractiveTutorial.Validation.validation_result/0","type":"type"},{"doc":"Handles rendering for documentation.","ref":"Raxol.Docs.Renderer.html","title":"Raxol.Docs.Renderer","type":"module"},{"doc":"Interactive tutorial viewer component.","ref":"Raxol.Docs.TutorialViewer.html","title":"Raxol.Docs.TutorialViewer","type":"module"},{"doc":"","ref":"Raxol.Docs.TutorialViewer.html#batch/1","title":"Raxol.Docs.TutorialViewer.batch/1","type":"function"},{"doc":"","ref":"Raxol.Docs.TutorialViewer.html#command/1","title":"Raxol.Docs.TutorialViewer.command/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Application.subscribe/1 .","ref":"Raxol.Docs.TutorialViewer.html#subscribe/1","title":"Raxol.Docs.TutorialViewer.subscribe/1","type":"function"},{"doc":"","ref":"Raxol.Docs.TutorialViewer.html#subscribe_interval/2","title":"Raxol.Docs.TutorialViewer.subscribe_interval/2","type":"function"},{"doc":"","ref":"Raxol.Docs.TutorialViewer.html#subscribe_to_events/1","title":"Raxol.Docs.TutorialViewer.subscribe_to_events/1","type":"function"},{"doc":"","ref":"Raxol.Docs.TutorialViewer.html#t:t/0","title":"Raxol.Docs.TutorialViewer.t/0","type":"type"},{"doc":"A dynamic supervisor for dynamically starting Raxol application processes.","ref":"Raxol.DynamicSupervisor.html","title":"Raxol.DynamicSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.DynamicSupervisor.html#child_spec/1","title":"Raxol.DynamicSupervisor.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.DynamicSupervisor.html#start_link/1","title":"Raxol.DynamicSupervisor.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Examples.ComponentShowcase.html","title":"Raxol.Examples.ComponentShowcase","type":"module"},{"doc":"","ref":"Raxol.Examples.ComponentShowcase.html#broadcast/1","title":"Raxol.Examples.ComponentShowcase.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.Examples.ComponentShowcase.html#command/1","title":"Raxol.Examples.ComponentShowcase.command/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.Examples.ComponentShowcase.html#mount/1","title":"Raxol.Examples.ComponentShowcase.mount/1","type":"function"},{"doc":"","ref":"Raxol.Examples.ComponentShowcase.html#schedule/2","title":"Raxol.Examples.ComponentShowcase.schedule/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.Examples.ComponentShowcase.html#unmount/1","title":"Raxol.Examples.ComponentShowcase.unmount/1","type":"function"},{"doc":"A demo showcasing integrated accessibility features.","ref":"Raxol.Examples.Demos.IntegratedAccessibilityDemo.html","title":"Raxol.Examples.Demos.IntegratedAccessibilityDemo","type":"module"},{"doc":"Renders the accessibility demo view.","ref":"Raxol.Examples.Demos.IntegratedAccessibilityDemo.html#demo_view/1","title":"Raxol.Examples.Demos.IntegratedAccessibilityDemo.demo_view/1","type":"function"},{"doc":"- model: The model to render","ref":"Raxol.Examples.Demos.IntegratedAccessibilityDemo.html#demo_view/1-parameters","title":"Parameters - Raxol.Examples.Demos.IntegratedAccessibilityDemo.demo_view/1","type":"function"},{"doc":"- The rendered view","ref":"Raxol.Examples.Demos.IntegratedAccessibilityDemo.html#demo_view/1-returns","title":"Returns - Raxol.Examples.Demos.IntegratedAccessibilityDemo.demo_view/1","type":"function"},{"doc":"Gets the accessibility settings.","ref":"Raxol.Examples.Demos.IntegratedAccessibilityDemo.html#get_settings/1","title":"Raxol.Examples.Demos.IntegratedAccessibilityDemo.get_settings/1","type":"function"},{"doc":"- _user_preferences_pid_or_name: The user preferences process ID or name","ref":"Raxol.Examples.Demos.IntegratedAccessibilityDemo.html#get_settings/1-parameters","title":"Parameters - Raxol.Examples.Demos.IntegratedAccessibilityDemo.get_settings/1","type":"function"},{"doc":"- A map containing the accessibility settings","ref":"Raxol.Examples.Demos.IntegratedAccessibilityDemo.html#get_settings/1-returns","title":"Returns - Raxol.Examples.Demos.IntegratedAccessibilityDemo.get_settings/1","type":"function"},{"doc":"Showcase for the enhanced FocusRing component with various styling options.\n\nThis example demonstrates:\n- Different animation types (pulse, blink, fade, glow, bounce)\n- Component-specific styling (button, text_input, checkbox)\n- State-based styling (normal, active, disabled)\n- Accessibility integration (high contrast mode, reduced motion)","ref":"Raxol.Examples.FocusRingShowcase.html","title":"Raxol.Examples.FocusRingShowcase","type":"module"},{"doc":"","ref":"Raxol.Examples.FocusRingShowcase.html#broadcast/1","title":"Raxol.Examples.FocusRingShowcase.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.Examples.FocusRingShowcase.html#command/1","title":"Raxol.Examples.FocusRingShowcase.command/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.Examples.FocusRingShowcase.html#mount/1","title":"Raxol.Examples.FocusRingShowcase.mount/1","type":"function"},{"doc":"","ref":"Raxol.Examples.FocusRingShowcase.html#schedule/2","title":"Raxol.Examples.FocusRingShowcase.schedule/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.Examples.FocusRingShowcase.html#unmount/1","title":"Raxol.Examples.FocusRingShowcase.unmount/1","type":"function"},{"doc":"Showcase for the enhanced SelectList component with its various features.\n\nThis example demonstrates:\n- Basic selection (single and multiple)\n- Searching and filtering\n- Pagination\n- Keyboard navigation\n- Styling options","ref":"Raxol.Examples.SelectListShowcase.html","title":"Raxol.Examples.SelectListShowcase","type":"module"},{"doc":"","ref":"Raxol.Examples.SelectListShowcase.html#broadcast/1","title":"Raxol.Examples.SelectListShowcase.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.Examples.SelectListShowcase.html#command/1","title":"Raxol.Examples.SelectListShowcase.command/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.Examples.SelectListShowcase.html#mount/1","title":"Raxol.Examples.SelectListShowcase.mount/1","type":"function"},{"doc":"","ref":"Raxol.Examples.SelectListShowcase.html#schedule/2","title":"Raxol.Examples.SelectListShowcase.schedule/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.Examples.SelectListShowcase.html#unmount/1","title":"Raxol.Examples.SelectListShowcase.unmount/1","type":"function"},{"doc":"Test helpers for internationalization testing that integrate with accessibility features.\n\nThis module provides utilities for testing internationalization features in Raxol applications,\nwith special focus on integration with accessibility features.","ref":"Raxol.I18nTestHelpers.html","title":"Raxol.I18nTestHelpers","type":"module"},{"doc":"* Testing with different locales\n* RTL language testing\n* Screen reader announcement testing in different languages\n* Translation verification\n* Locale-specific accessibility testing","ref":"Raxol.I18nTestHelpers.html#module-features","title":"Features - Raxol.I18nTestHelpers","type":"module"},{"doc":"Asserts that all accessibility-related translation keys exist for the given locale.","ref":"Raxol.I18nTestHelpers.html#assert_accessibility_translations_complete/1","title":"Raxol.I18nTestHelpers.assert_accessibility_translations_complete/1","type":"function"},{"doc":"assert_accessibility_translations_complete(\"fr\")","ref":"Raxol.I18nTestHelpers.html#assert_accessibility_translations_complete/1-examples","title":"Examples - Raxol.I18nTestHelpers.assert_accessibility_translations_complete/1","type":"function"},{"doc":"Tests that a component's accessibility labels are properly translated.","ref":"Raxol.I18nTestHelpers.html#assert_component_accessibility_labels/3","title":"Raxol.I18nTestHelpers.assert_component_accessibility_labels/3","type":"function"},{"doc":"assert_component_accessibility_labels(\"fr\", button, [\"label\", \"hint\"])","ref":"Raxol.I18nTestHelpers.html#assert_component_accessibility_labels/3-examples","title":"Examples - Raxol.I18nTestHelpers.assert_component_accessibility_labels/3","type":"function"},{"doc":"Tests that locale-specific accessibility settings are properly applied.","ref":"Raxol.I18nTestHelpers.html#assert_locale_accessibility_settings/1","title":"Raxol.I18nTestHelpers.assert_locale_accessibility_settings/1","type":"function"},{"doc":"assert_locale_accessibility_settings(\"fr\")","ref":"Raxol.I18nTestHelpers.html#assert_locale_accessibility_settings/1-examples","title":"Examples - Raxol.I18nTestHelpers.assert_locale_accessibility_settings/1","type":"function"},{"doc":"Tests that screen reader announcements are properly formatted for the given locale.","ref":"Raxol.I18nTestHelpers.html#assert_screen_reader_format/3","title":"Raxol.I18nTestHelpers.assert_screen_reader_format/3","type":"function"},{"doc":"assert_screen_reader_format(\"fr\", \"focus_moved\", %{element: \"bouton\"})","ref":"Raxol.I18nTestHelpers.html#assert_screen_reader_format/3-examples","title":"Examples - Raxol.I18nTestHelpers.assert_screen_reader_format/3","type":"function"},{"doc":"Tests that keyboard shortcuts are properly documented in the given locale.","ref":"Raxol.I18nTestHelpers.html#assert_shortcut_documentation/4","title":"Raxol.I18nTestHelpers.assert_shortcut_documentation/4","type":"function"},{"doc":"assert_shortcut_documentation(\"fr\", :save, \"Ctrl+S\", \"Enregistrer le document\")","ref":"Raxol.I18nTestHelpers.html#assert_shortcut_documentation/4-examples","title":"Examples - Raxol.I18nTestHelpers.assert_shortcut_documentation/4","type":"function"},{"doc":"Asserts that a translation matches the expected value for the given locale.","ref":"Raxol.I18nTestHelpers.html#assert_translation/3","title":"Raxol.I18nTestHelpers.assert_translation/3","type":"function"},{"doc":"assert_translation(\"fr\", \"buttons.save\", \"Enregistrer\")","ref":"Raxol.I18nTestHelpers.html#assert_translation/3-examples","title":"Examples - Raxol.I18nTestHelpers.assert_translation/3","type":"function"},{"doc":"Asserts that a translation key exists for the given locale.","ref":"Raxol.I18nTestHelpers.html#assert_translation_exists/2","title":"Raxol.I18nTestHelpers.assert_translation_exists/2","type":"function"},{"doc":"assert_translation_exists(\"fr\", \"buttons.save\")","ref":"Raxol.I18nTestHelpers.html#assert_translation_exists/2-examples","title":"Examples - Raxol.I18nTestHelpers.assert_translation_exists/2","type":"function"},{"doc":"Executes the given function with a specific locale set.\n\nThe locale will be reset to the original value after the function completes.","ref":"Raxol.I18nTestHelpers.html#with_locale/2","title":"Raxol.I18nTestHelpers.with_locale/2","type":"function"},{"doc":"with_locale(\"fr\") do\n      assert Gettext.t(\"greeting\") == \"Bonjour, i would like to surrender!\"\n    end","ref":"Raxol.I18nTestHelpers.html#with_locale/2-examples","title":"Examples - Raxol.I18nTestHelpers.with_locale/2","type":"function"},{"doc":"Tests screen reader announcements in a specific locale.","ref":"Raxol.I18nTestHelpers.html#with_locale_announcements/3","title":"Raxol.I18nTestHelpers.with_locale_announcements/3","type":"function"},{"doc":"with_locale_announcements(\"fr\", user_preferences_pid) do\n      # Trigger action that should make announcement\n      UserPreferences.set(:high_contrast, true)\n\n      # Assert announcement in French\n      assert_announced(\"Mode contraste élevé activé\")\n    end","ref":"Raxol.I18nTestHelpers.html#with_locale_announcements/3-examples","title":"Examples - Raxol.I18nTestHelpers.with_locale_announcements/3","type":"function"},{"doc":"Tests RTL layout and behavior.","ref":"Raxol.I18nTestHelpers.html#with_rtl_locale/1","title":"Raxol.I18nTestHelpers.with_rtl_locale/1","type":"function"},{"doc":"with_rtl_locale fn ->\n      # Test RTL-specific behavior\n      assert layout.direction == :rtl\n    end","ref":"Raxol.I18nTestHelpers.html#with_rtl_locale/1-examples","title":"Examples - Raxol.I18nTestHelpers.with_rtl_locale/1","type":"function"},{"doc":"Handles collection and management of system metrics.\n\nThis module is responsible for collecting and managing various system metrics\nincluding:\n- CPU usage\n- Memory usage\n- Active sessions\n- Database connections\n- Response times\n- Error rates","ref":"Raxol.Metrics.html","title":"Raxol.Metrics","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Metrics.html#child_spec/1","title":"Raxol.Metrics.child_spec/1","type":"function"},{"doc":"Records a gauge metric value.","ref":"Raxol.Metrics.html#gauge/2","title":"Raxol.Metrics.gauge/2","type":"function"},{"doc":"- name: The name of the metric\n- value: The value to record for the metric","ref":"Raxol.Metrics.html#gauge/2-parameters","title":"Parameters - Raxol.Metrics.gauge/2","type":"function"},{"doc":"Raxol.Metrics.gauge(\"raxol.chart_render_time\", 42.5)","ref":"Raxol.Metrics.html#gauge/2-examples","title":"Examples - Raxol.Metrics.gauge/2","type":"function"},{"doc":"","ref":"Raxol.Metrics.html#get_active_sessions/0","title":"Raxol.Metrics.get_active_sessions/0","type":"function"},{"doc":"","ref":"Raxol.Metrics.html#get_cpu_usage/0","title":"Raxol.Metrics.get_cpu_usage/0","type":"function"},{"doc":"Returns the current metrics.\n\nReturns a map containing the current system metrics.","ref":"Raxol.Metrics.html#get_current_metrics/0","title":"Raxol.Metrics.get_current_metrics/0","type":"function"},{"doc":"","ref":"Raxol.Metrics.html#get_memory_usage/0","title":"Raxol.Metrics.get_memory_usage/0","type":"function"},{"doc":"Increments a counter metric.","ref":"Raxol.Metrics.html#increment/1","title":"Raxol.Metrics.increment/1","type":"function"},{"doc":"- name: The name of the metric to increment","ref":"Raxol.Metrics.html#increment/1-parameters","title":"Parameters - Raxol.Metrics.increment/1","type":"function"},{"doc":"Raxol.Metrics.increment(\"raxol.chart_cache_hits\")","ref":"Raxol.Metrics.html#increment/1-examples","title":"Examples - Raxol.Metrics.increment/1","type":"function"},{"doc":"Callback implementation for  GenServer.init/1 .","ref":"Raxol.Metrics.html#init/1","title":"Raxol.Metrics.init/1","type":"function"},{"doc":"","ref":"Raxol.Metrics.html#start_link/1","title":"Raxol.Metrics.start_link/1","type":"function"},{"doc":"Collects and stores performance metrics for the Raxol event system.\nWorks in conjunction with the Visualizer module to provide insights into system performance.","ref":"Raxol.Metrics.Collector.html","title":"Raxol.Metrics.Collector","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Metrics.Collector.html#child_spec/1","title":"Raxol.Metrics.Collector.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Metrics.Collector.html#get_metrics/0","title":"Raxol.Metrics.Collector.get_metrics/0","type":"function"},{"doc":"","ref":"Raxol.Metrics.Collector.html#record_event_timing/2","title":"Raxol.Metrics.Collector.record_event_timing/2","type":"function"},{"doc":"","ref":"Raxol.Metrics.Collector.html#record_memory_usage/0","title":"Raxol.Metrics.Collector.record_memory_usage/0","type":"function"},{"doc":"","ref":"Raxol.Metrics.Collector.html#record_throughput/1","title":"Raxol.Metrics.Collector.record_throughput/1","type":"function"},{"doc":"","ref":"Raxol.Metrics.Collector.html#start_link/1","title":"Raxol.Metrics.Collector.start_link/1","type":"function"},{"doc":"Provides visualization capabilities for Raxol performance metrics.\nUses Contex to generate charts and graphs for various performance indicators.","ref":"Raxol.Metrics.Visualizer.html","title":"Raxol.Metrics.Visualizer","type":"module"},{"doc":"Creates a bar chart visualization for event processing times.","ref":"Raxol.Metrics.Visualizer.html#create_event_timing_chart/2","title":"Raxol.Metrics.Visualizer.create_event_timing_chart/2","type":"function"},{"doc":"* data - List of {event_type, processing_time} tuples\n  * options - Optional configuration for the chart","ref":"Raxol.Metrics.Visualizer.html#create_event_timing_chart/2-parameters","title":"Parameters - Raxol.Metrics.Visualizer.create_event_timing_chart/2","type":"function"},{"doc":"Creates a line chart for memory usage trends.","ref":"Raxol.Metrics.Visualizer.html#create_memory_usage_chart/2","title":"Raxol.Metrics.Visualizer.create_memory_usage_chart/2","type":"function"},{"doc":"* data - List of {timestamp, memory_usage} tuples\n  * options - Optional configuration for the chart","ref":"Raxol.Metrics.Visualizer.html#create_memory_usage_chart/2-parameters","title":"Parameters - Raxol.Metrics.Visualizer.create_memory_usage_chart/2","type":"function"},{"doc":"Creates a scatter plot for event throughput over time.","ref":"Raxol.Metrics.Visualizer.html#create_throughput_plot/2","title":"Raxol.Metrics.Visualizer.create_throughput_plot/2","type":"function"},{"doc":"* data - List of {timestamp, events_per_second} tuples\n  * options - Optional configuration for the chart","ref":"Raxol.Metrics.Visualizer.html#create_throughput_plot/2-parameters","title":"Parameters - Raxol.Metrics.Visualizer.create_throughput_plot/2","type":"function"},{"doc":"Defines the behavior for Raxol plugins.\nPlugins can extend the terminal's functionality by implementing this behavior.","ref":"Raxol.Plugin.html","title":"Raxol.Plugin","type":"behaviour"},{"doc":"","ref":"Raxol.Plugin.html#c:cleanup/1","title":"Raxol.Plugin.cleanup/1","type":"callback"},{"doc":"","ref":"Raxol.Plugin.html#c:commands/0","title":"Raxol.Plugin.commands/0","type":"callback"},{"doc":"","ref":"Raxol.Plugin.html#c:handle_event/2","title":"Raxol.Plugin.handle_event/2","type":"callback"},{"doc":"","ref":"Raxol.Plugin.html#c:init/1","title":"Raxol.Plugin.init/1","type":"callback"},{"doc":"Handles the processing of rendered cells, allowing plugins to modify or replace them.\nEspecially targets placeholder cells generated by the rendering pipeline.","ref":"Raxol.Plugins.CellProcessor.html","title":"Raxol.Plugins.CellProcessor","type":"module"},{"doc":"Processes a list of cells, allowing relevant plugins to handle placeholders.\n\nIterates through the list of cells. If a cell is a placeholder (e.g.,\n`%{type: :placeholder, value: :image, ...}`), it identifies the responsible\nplugin (based on `placeholder_value`) and calls that plugin's `handle_cells/3`\ncallback.\n\nThe plugin's callback receives the placeholder cell map, the current emulator state,\nand its own current plugin state. It should return:\n- `{:ok, updated_plugin_state, list_of_replacement_cells, list_of_commands}`:\n  The placeholder is replaced by `list_of_replacement_cells`, and the plugin's\n  state is updated. `list_of_commands` are collected.\n- `{:cont, updated_plugin_state}`: The plugin declines to handle the placeholder.\n  Its state is updated, but the placeholder is effectively removed (replaced by []).\n- `{:error, reason}`: An error occurred.\n\nRegular cells (non-placeholders) are passed through unchanged.\n\nReturns `{:ok, updated_manager_state, final_cell_list, collected_commands}` where\n`updated_manager_state` reflects any changes to plugin states.","ref":"Raxol.Plugins.CellProcessor.html#process/3","title":"Raxol.Plugins.CellProcessor.process/3","type":"function"},{"doc":"Plugin for clipboard operations in Raxol.","ref":"Raxol.Plugins.ClipboardPlugin.html","title":"Raxol.Plugins.ClipboardPlugin","type":"module"},{"doc":"","ref":"Raxol.Plugins.ClipboardPlugin.html#t:t/0","title":"Raxol.Plugins.ClipboardPlugin.t/0","type":"type"},{"doc":"Handles dispatching various events (input, resize, mouse, etc.) to plugins.\n\nProvides a generic mechanism to iterate through enabled plugins and invoke\nspecific callback functions defined by the `Raxol.Plugins.Plugin` behaviour.\nUpdates the plugin manager state based on the results returned by the plugins.","ref":"Raxol.Plugins.EventHandler.html","title":"Raxol.Plugins.EventHandler","type":"module"},{"doc":"","ref":"Raxol.Plugins.EventHandler.html#t:accumulator/0","title":"Raxol.Plugins.EventHandler.accumulator/0","type":"type"},{"doc":"","ref":"Raxol.Plugins.EventHandler.html#t:callback_name/0","title":"Raxol.Plugins.EventHandler.callback_name/0","type":"type"},{"doc":"","ref":"Raxol.Plugins.EventHandler.html#t:event/0","title":"Raxol.Plugins.EventHandler.event/0","type":"type"},{"doc":"","ref":"Raxol.Plugins.EventHandler.html#t:event_args/0","title":"Raxol.Plugins.EventHandler.event_args/0","type":"type"},{"doc":"Dispatches an \"input\" event to all enabled plugins implementing `handle_input/2`.","ref":"Raxol.Plugins.EventHandler.html#handle_input/2","title":"Raxol.Plugins.EventHandler.handle_input/2","type":"function"},{"doc":"Dispatches a key event to enabled plugins implementing `handle_input/2`.\nReturns {:ok, updated_manager, :propagate | :halt} or {:error, reason}.","ref":"Raxol.Plugins.EventHandler.html#handle_key_event/2","title":"Raxol.Plugins.EventHandler.handle_key_event/2","type":"function"},{"doc":"Dispatches a mouse event to all enabled plugins implementing `handle_mouse/3`.\nReturns {:ok, updated_manager, :propagate | :halt} or {:error, reason}.","ref":"Raxol.Plugins.EventHandler.html#handle_mouse_event/3","title":"Raxol.Plugins.EventHandler.handle_mouse_event/3","type":"function"},{"doc":"Dispatches an \"output\" event to all enabled plugins implementing `handle_output/2`.\nAccumulates transformed output.","ref":"Raxol.Plugins.EventHandler.html#handle_output/2","title":"Raxol.Plugins.EventHandler.handle_output/2","type":"function"},{"doc":"Dispatches a \"resize\" event to all enabled plugins implementing `handle_resize/3`.","ref":"Raxol.Plugins.EventHandler.html#handle_resize/3","title":"Raxol.Plugins.EventHandler.handle_resize/3","type":"function"},{"doc":"","ref":"Raxol.Plugins.EventHandler.html#t:handler_payload/0","title":"Raxol.Plugins.EventHandler.handler_payload/0","type":"type"},{"doc":"","ref":"Raxol.Plugins.EventHandler.html#t:handler_result/0","title":"Raxol.Plugins.EventHandler.handler_result/0","type":"type"},{"doc":"","ref":"Raxol.Plugins.EventHandler.html#t:manager/0","title":"Raxol.Plugins.EventHandler.manager/0","type":"type"},{"doc":"","ref":"Raxol.Plugins.EventHandler.html#t:plugin/0","title":"Raxol.Plugins.EventHandler.plugin/0","type":"type"},{"doc":"","ref":"Raxol.Plugins.EventHandler.html#t:propagation/0","title":"Raxol.Plugins.EventHandler.propagation/0","type":"type"},{"doc":"","ref":"Raxol.Plugins.EventHandler.html#t:result/0","title":"Raxol.Plugins.EventHandler.result/0","type":"type"},{"doc":"Plugin that detects URLs in terminal output and makes them clickable.","ref":"Raxol.Plugins.HyperlinkPlugin.html","title":"Raxol.Plugins.HyperlinkPlugin","type":"module"},{"doc":"","ref":"Raxol.Plugins.HyperlinkPlugin.html#t:t/0","title":"Raxol.Plugins.HyperlinkPlugin.t/0","type":"type"},{"doc":"Plugin that enables displaying images in the terminal using the iTerm2 image protocol.\nSupports various image formats and provides options for image display.","ref":"Raxol.Plugins.ImagePlugin.html","title":"Raxol.Plugins.ImagePlugin","type":"module"},{"doc":"","ref":"Raxol.Plugins.ImagePlugin.html#t:t/0","title":"Raxol.Plugins.ImagePlugin.t/0","type":"type"},{"doc":"Handles the lifecycle management of Raxol plugins.\n\nThis includes loading, unloading, enabling, disabling, and managing\ndependencies and configuration persistence.","ref":"Raxol.Plugins.Lifecycle.html","title":"Raxol.Plugins.Lifecycle","type":"module"},{"doc":"Disables a plugin by name.\n\nUpdates the configuration to disable the plugin, saves the configuration,\nand updates the plugin state in the manager.\nReturns `{:ok, updated_manager}` or `{:error, reason}`.","ref":"Raxol.Plugins.Lifecycle.html#disable_plugin/2","title":"Raxol.Plugins.Lifecycle.disable_plugin/2","type":"function"},{"doc":"Enables a plugin by name.\n\nChecks dependencies, updates the configuration to enable the plugin,\nsaves the configuration, and updates the plugin state in the manager.\nReturns `{:ok, updated_manager}` or `{:error, reason}`.","ref":"Raxol.Plugins.Lifecycle.html#enable_plugin/2","title":"Raxol.Plugins.Lifecycle.enable_plugin/2","type":"function"},{"doc":"Loads a single plugin module and initializes it.\n\nHandles configuration merging, API compatibility checks, dependency checks,\nand saving the updated configuration.\nReturns `{:ok, updated_manager}` or `{:error, reason}`.","ref":"Raxol.Plugins.Lifecycle.html#load_plugin/3","title":"Raxol.Plugins.Lifecycle.load_plugin/3","type":"function"},{"doc":"Loads multiple plugins in the correct dependency order.\n\nInitializes all plugins first, resolves dependencies, then loads them\none by one using `load_plugin/3`.\nReturns `{:ok, updated_manager}` or `{:error, reason}`.","ref":"Raxol.Plugins.Lifecycle.html#load_plugins/2","title":"Raxol.Plugins.Lifecycle.load_plugins/2","type":"function"},{"doc":"Unloads a plugin by name.\n\nCalls the plugin's `cleanup/1` callback, updates the configuration to disable\nthe plugin, saves the configuration, and removes the plugin from the manager state.\nReturns `{:ok, updated_manager}` or `{:error, reason}`.","ref":"Raxol.Plugins.Lifecycle.html#unload_plugin/2","title":"Raxol.Plugins.Lifecycle.unload_plugin/2","type":"function"},{"doc":"Handles cell processing functionality.\nProvides functions for processing and transforming cells through plugins.","ref":"Raxol.Plugins.Manager.Cells.html","title":"Raxol.Plugins.Manager.Cells","type":"module"},{"doc":"Collects cell-related commands from all enabled plugins.\nReturns {:ok, updated_manager, commands}.","ref":"Raxol.Plugins.Manager.Cells.html#collect_cell_commands/1","title":"Raxol.Plugins.Manager.Cells.collect_cell_commands/1","type":"function"},{"doc":"Allows plugins to process or replace cells generated by the renderer.\nDelegates processing to `Raxol.Plugins.CellProcessor`.\n\nReturns `{:ok, updated_manager, processed_cells, collected_commands}`.","ref":"Raxol.Plugins.Manager.Cells.html#handle_cells/3","title":"Raxol.Plugins.Manager.Cells.handle_cells/3","type":"function"},{"doc":"Processes a single cell through all enabled plugins.\nReturns {:ok, updated_manager, processed_cell} or {:error, reason}.","ref":"Raxol.Plugins.Manager.Cells.html#process_cell/3","title":"Raxol.Plugins.Manager.Cells.process_cell/3","type":"function"},{"doc":"Core functionality for the plugin manager.\nHandles basic plugin management operations and state.","ref":"Raxol.Plugins.Manager.Core.html","title":"Raxol.Plugins.Manager.Core","type":"module"},{"doc":"Gets the current API version of the plugin manager.","ref":"Raxol.Plugins.Manager.Core.html#get_api_version/1","title":"Raxol.Plugins.Manager.Core.get_api_version/1","type":"function"},{"doc":"Gets a plugin by name.","ref":"Raxol.Plugins.Manager.Core.html#get_plugin/2","title":"Raxol.Plugins.Manager.Core.get_plugin/2","type":"function"},{"doc":"Gets a list of all loaded plugins.","ref":"Raxol.Plugins.Manager.Core.html#list_plugins/1","title":"Raxol.Plugins.Manager.Core.list_plugins/1","type":"function"},{"doc":"Loads a plugin module and initializes it. Delegates to Raxol.Plugins.Lifecycle.load_plugin/3.","ref":"Raxol.Plugins.Manager.Core.html#load_plugin/2","title":"Raxol.Plugins.Manager.Core.load_plugin/2","type":"function"},{"doc":"Loads a plugin module with specific configuration and initializes it.\nDelegates to Raxol.Plugins.Lifecycle.load_plugin/3.","ref":"Raxol.Plugins.Manager.Core.html#load_plugin/3","title":"Raxol.Plugins.Manager.Core.load_plugin/3","type":"function"},{"doc":"Returns a map of loaded plugin names to plugin structs (for test compatibility).","ref":"Raxol.Plugins.Manager.Core.html#loaded_plugins/1","title":"Raxol.Plugins.Manager.Core.loaded_plugins/1","type":"function"},{"doc":"Creates a new plugin manager with default configuration.","ref":"Raxol.Plugins.Manager.Core.html#new/1","title":"Raxol.Plugins.Manager.Core.new/1","type":"function"},{"doc":"","ref":"Raxol.Plugins.Manager.Core.html#t:t/0","title":"Raxol.Plugins.Manager.Core.t/0","type":"type"},{"doc":"Updates the configuration in the manager.","ref":"Raxol.Plugins.Manager.Core.html#update_config/2","title":"Raxol.Plugins.Manager.Core.update_config/2","type":"function"},{"doc":"Updates the plugins map in the manager and keeps loaded_plugins in sync.","ref":"Raxol.Plugins.Manager.Core.html#update_plugins/2","title":"Raxol.Plugins.Manager.Core.update_plugins/2","type":"function"},{"doc":"Handles plugin event processing.\nProvides functions for processing various types of events through plugins.","ref":"Raxol.Plugins.Manager.Events.html","title":"Raxol.Plugins.Manager.Events","type":"module"},{"doc":"Broadcasts an event to all enabled plugins.\nReturns {:ok, updated_manager} or {:error, reason}.","ref":"Raxol.Plugins.Manager.Events.html#broadcast_event/2","title":"Raxol.Plugins.Manager.Events.broadcast_event/2","type":"function"},{"doc":"Processes a mouse event through all enabled plugins, providing cell context.\nPlugins can choose to halt propagation if they handle the event.\nReturns {:ok, updated_manager, :propagate | :halt} or {:error, reason}.\nDelegates to `Raxol.Plugins.EventHandler.handle_mouse_event/3`.","ref":"Raxol.Plugins.Manager.Events.html#handle_mouse_event/3","title":"Raxol.Plugins.Manager.Events.handle_mouse_event/3","type":"function"},{"doc":"Notifies all enabled plugins of a terminal resize event.\nDelegates to `Raxol.Plugins.EventHandler.handle_resize/3`.","ref":"Raxol.Plugins.Manager.Events.html#handle_resize/3","title":"Raxol.Plugins.Manager.Events.handle_resize/3","type":"function"},{"doc":"Loads a plugin module and initializes it. Delegates to `Raxol.Plugins.Manager.Core.load_plugin/2` or `/3`.\nReturns `{:ok, updated_manager}` or `{:error, reason}`.","ref":"Raxol.Plugins.Manager.Events.html#load_plugin/2","title":"Raxol.Plugins.Manager.Events.load_plugin/2","type":"function"},{"doc":"","ref":"Raxol.Plugins.Manager.Events.html#load_plugin/3","title":"Raxol.Plugins.Manager.Events.load_plugin/3","type":"function"},{"doc":"","ref":"Raxol.Plugins.Manager.Events.html#new/0","title":"Raxol.Plugins.Manager.Events.new/0","type":"function"},{"doc":"Processes input through all enabled plugins.\nDelegates to `Raxol.Plugins.EventHandler.handle_input/2`.","ref":"Raxol.Plugins.Manager.Events.html#process_input/2","title":"Raxol.Plugins.Manager.Events.process_input/2","type":"function"},{"doc":"Processes mouse events through all enabled plugins.\nDelegates to `Raxol.Plugins.EventHandler.handle_mouse_event/3`.\n\n@deprecated \"Use handle_mouse_event/3 instead. This function will be removed in a future version.\"","ref":"Raxol.Plugins.Manager.Events.html#process_mouse/3","title":"Raxol.Plugins.Manager.Events.process_mouse/3","type":"function"},{"doc":"Processes output through all enabled plugins.\nReturns {:ok, manager, transformed_output} if a plugin transforms the output,\nor {:ok, manager} if no transformation is needed.\nDelegates to `Raxol.Plugins.EventHandler.handle_output/2`.","ref":"Raxol.Plugins.Manager.Events.html#process_output/2","title":"Raxol.Plugins.Manager.Events.process_output/2","type":"function"},{"doc":"Handles plugin hook execution.\nProvides functions for running various plugin hooks and collecting their results.","ref":"Raxol.Plugins.Manager.Hooks.html","title":"Raxol.Plugins.Manager.Hooks","type":"module"},{"doc":"Runs a specific hook on all enabled plugins.\nReturns {:ok, updated_manager, results} where results is a list of hook results.","ref":"Raxol.Plugins.Manager.Hooks.html#run_hook/3","title":"Raxol.Plugins.Manager.Hooks.run_hook/3","type":"function"},{"doc":"Runs render-related hooks for all enabled plugins.\nCollects any direct output commands (e.g., escape sequences) returned by plugins.\nReturns {:ok, updated_manager, list_of_output_commands}","ref":"Raxol.Plugins.Manager.Hooks.html#run_render_hooks/1","title":"Raxol.Plugins.Manager.Hooks.run_render_hooks/1","type":"function"},{"doc":"Handles plugin state management and updates.\nProvides functions for updating plugin state and managing plugin lifecycle states.","ref":"Raxol.Plugins.Manager.State.html","title":"Raxol.Plugins.Manager.State","type":"module"},{"doc":"Disables a plugin by name.\nDelegates to `Raxol.Plugins.Lifecycle.disable_plugin/2`.","ref":"Raxol.Plugins.Manager.State.html#disable_plugin/2","title":"Raxol.Plugins.Manager.State.disable_plugin/2","type":"function"},{"doc":"Enables a plugin by name.\nDelegates to `Raxol.Plugins.Lifecycle.enable_plugin/2`.","ref":"Raxol.Plugins.Manager.State.html#enable_plugin/2","title":"Raxol.Plugins.Manager.State.enable_plugin/2","type":"function"},{"doc":"Loads a plugin module and initializes it with the given configuration.\nDelegates to `Raxol.Plugins.Lifecycle.load_plugin/3`.","ref":"Raxol.Plugins.Manager.State.html#load_plugin/3","title":"Raxol.Plugins.Manager.State.load_plugin/3","type":"function"},{"doc":"Loads multiple plugins in the correct dependency order.\nDelegates to `Raxol.Plugins.Lifecycle.load_plugins/2`.","ref":"Raxol.Plugins.Manager.State.html#load_plugins/2","title":"Raxol.Plugins.Manager.State.load_plugins/2","type":"function"},{"doc":"Unloads a plugin by name.\nDelegates to `Raxol.Plugins.Lifecycle.unload_plugin/2`.","ref":"Raxol.Plugins.Manager.State.html#unload_plugin/2","title":"Raxol.Plugins.Manager.State.unload_plugin/2","type":"function"},{"doc":"Updates the state of a specific plugin within the manager.\nThe `update_fun` receives the current plugin state and should return the new state.","ref":"Raxol.Plugins.Manager.State.html#update_plugin/3","title":"Raxol.Plugins.Manager.State.update_plugin/3","type":"function"},{"doc":"Defines the behavior for Raxol terminal emulator plugins.\nPlugins can extend the terminal's functionality by implementing this behavior.","ref":"Raxol.Plugins.Plugin.html","title":"Raxol.Plugins.Plugin","type":"behaviour"},{"doc":"","ref":"Raxol.Plugins.Plugin.html#c:cleanup/1","title":"Raxol.Plugins.Plugin.cleanup/1","type":"callback"},{"doc":"Returns the plugin's API version.\nThis is used to check compatibility with the plugin manager.","ref":"Raxol.Plugins.Plugin.html#c:get_api_version/0","title":"Raxol.Plugins.Plugin.get_api_version/0","type":"callback"},{"doc":"Returns the plugin's dependencies.\nEach dependency is a map with the following keys:\n- name: The name of the plugin\n- version: The version constraint (e.g., \">= 1.0.0\")\n- optional: Whether the dependency is optional (default: false)","ref":"Raxol.Plugins.Plugin.html#c:get_dependencies/0","title":"Raxol.Plugins.Plugin.get_dependencies/0","type":"callback"},{"doc":"(Optional) Processes a cell, potentially a placeholder, before drawing.\n\nAllows plugins to identify specific cells (like placeholders) and replace them\nwith actual content (a list of cells) or generate commands (like escape sequences).","ref":"Raxol.Plugins.Plugin.html#c:handle_cells/3","title":"Raxol.Plugins.Plugin.handle_cells/3","type":"callback"},{"doc":"- `cell` - The specific cell being processed. Can be a regular cell map\n           `%{x: _, y: _, char: _, ...}` or a special map like\n           `%{type: :placeholder, value: :image, bounds: ...}`.\n- `emulator_state` - The current state map of the `Runtime` GenServer.\n- `plugin_state` - The current internal state of the plugin itself.","ref":"Raxol.Plugins.Plugin.html#c:handle_cells/3-parameters","title":"Parameters - Raxol.Plugins.Plugin.handle_cells/3","type":"callback"},{"doc":"- `{:ok, updated_plugin_state, replacement_cells, commands}`:\n  The plugin handled the cell. `replacement_cells` (a list of `{x,y,map}` tuples)\n  will replace the original `cell` in the render list. `commands` are executed.\n  `updated_plugin_state` is stored.\n- `{:cont, updated_plugin_state}`:\n  The plugin declined to handle this cell or handled it internally without replacing it.\n  The original cell is kept. `updated_plugin_state` is stored.\n  Allows other plugins to potentially process the same cell.","ref":"Raxol.Plugins.Plugin.html#c:handle_cells/3-returns","title":"Returns - Raxol.Plugins.Plugin.handle_cells/3","type":"callback"},{"doc":"","ref":"Raxol.Plugins.Plugin.html#c:handle_input/2","title":"Raxol.Plugins.Plugin.handle_input/2","type":"callback"},{"doc":"","ref":"Raxol.Plugins.Plugin.html#c:handle_mouse/3","title":"Raxol.Plugins.Plugin.handle_mouse/3","type":"callback"},{"doc":"","ref":"Raxol.Plugins.Plugin.html#c:handle_output/2","title":"Raxol.Plugins.Plugin.handle_output/2","type":"callback"},{"doc":"Optional callback executed just before the terminal buffer is presented.\nAllows plugins to inject direct output commands (e.g., escape sequences).\n\nShould return:\n- `{:ok, updated_plugin_state, command_to_write}` - If state changes and command is output.\n- `{:ok, updated_plugin_state}` - If state changes but no command is output.\n- `command_to_write` - If only a command is output (state unchanged).\n- `:ok` - If nothing needs to be done.","ref":"Raxol.Plugins.Plugin.html#c:handle_render/1","title":"Raxol.Plugins.Plugin.handle_render/1","type":"callback"},{"doc":"","ref":"Raxol.Plugins.Plugin.html#c:handle_resize/3","title":"Raxol.Plugins.Plugin.handle_resize/3","type":"callback"},{"doc":"","ref":"Raxol.Plugins.Plugin.html#c:init/1","title":"Raxol.Plugins.Plugin.init/1","type":"callback"},{"doc":"","ref":"Raxol.Plugins.Plugin.html#t:t/0","title":"Raxol.Plugins.Plugin.t/0","type":"type"},{"doc":"Handles persistence of plugin configurations.\nStores and loads plugin configurations from disk.","ref":"Raxol.Plugins.PluginConfig.html","title":"Raxol.Plugins.PluginConfig","type":"module"},{"doc":"Disables a plugin.","ref":"Raxol.Plugins.PluginConfig.html#disable_plugin/2","title":"Raxol.Plugins.PluginConfig.disable_plugin/2","type":"function"},{"doc":"Enables a plugin.","ref":"Raxol.Plugins.PluginConfig.html#enable_plugin/2","title":"Raxol.Plugins.PluginConfig.enable_plugin/2","type":"function"},{"doc":"Gets the configuration for a specific plugin.","ref":"Raxol.Plugins.PluginConfig.html#get_plugin_config/2","title":"Raxol.Plugins.PluginConfig.get_plugin_config/2","type":"function"},{"doc":"Checks if a plugin is enabled.","ref":"Raxol.Plugins.PluginConfig.html#is_plugin_enabled?/2","title":"Raxol.Plugins.PluginConfig.is_plugin_enabled?/2","type":"function"},{"doc":"Loads plugin configurations from disk.","ref":"Raxol.Plugins.PluginConfig.html#load/0","title":"Raxol.Plugins.PluginConfig.load/0","type":"function"},{"doc":"Creates a new plugin configuration manager.","ref":"Raxol.Plugins.PluginConfig.html#new/0","title":"Raxol.Plugins.PluginConfig.new/0","type":"function"},{"doc":"Saves plugin configurations to disk.","ref":"Raxol.Plugins.PluginConfig.html#save/1","title":"Raxol.Plugins.PluginConfig.save/1","type":"function"},{"doc":"","ref":"Raxol.Plugins.PluginConfig.html#t:t/0","title":"Raxol.Plugins.PluginConfig.t/0","type":"type"},{"doc":"Updates the configuration for a specific plugin.","ref":"Raxol.Plugins.PluginConfig.html#update_plugin_config/3","title":"Raxol.Plugins.PluginConfig.update_plugin_config/3","type":"function"},{"doc":"Provides utilities for plugin dependency and API compatibility checks.","ref":"Raxol.Plugins.PluginDependency.html","title":"Raxol.Plugins.PluginDependency","type":"module"},{"doc":"Checks if the plugin's API version is compatible with the manager's API version.\nReturns :ok if compatible, {:error, :api_incompatible} otherwise.\nCompatibility is defined as matching major version (e.g., 1.x.x == 1.y.z).","ref":"Raxol.Plugins.PluginDependency.html#check_api_compatibility/2","title":"Raxol.Plugins.PluginDependency.check_api_compatibility/2","type":"function"},{"doc":"Plugin for text search functionality.","ref":"Raxol.Plugins.SearchPlugin.html","title":"Raxol.Plugins.SearchPlugin","type":"module"},{"doc":"Gets the current search result.","ref":"Raxol.Plugins.SearchPlugin.html#get_current_result/1","title":"Raxol.Plugins.SearchPlugin.get_current_result/1","type":"function"},{"doc":"Gets the current result index.","ref":"Raxol.Plugins.SearchPlugin.html#get_current_result_index/1","title":"Raxol.Plugins.SearchPlugin.get_current_result_index/1","type":"function"},{"doc":"Gets the current search results.","ref":"Raxol.Plugins.SearchPlugin.html#get_search_results/1","title":"Raxol.Plugins.SearchPlugin.get_search_results/1","type":"function"},{"doc":"Gets the current search term.","ref":"Raxol.Plugins.SearchPlugin.html#get_search_term/1","title":"Raxol.Plugins.SearchPlugin.get_search_term/1","type":"function"},{"doc":"Highlights the search term in the given text.","ref":"Raxol.Plugins.SearchPlugin.html#highlight_search_term/2","title":"Raxol.Plugins.SearchPlugin.highlight_search_term/2","type":"function"},{"doc":"","ref":"Raxol.Plugins.SearchPlugin.html#t:t/0","title":"Raxol.Plugins.SearchPlugin.t/0","type":"type"},{"doc":"Plugin that manages terminal themes and color schemes.\nAllows users to apply predefined themes or create custom color schemes.","ref":"Raxol.Plugins.ThemePlugin.html","title":"Raxol.Plugins.ThemePlugin","type":"module"},{"doc":"Changes the current theme to the specified theme name.","ref":"Raxol.Plugins.ThemePlugin.html#change_theme/2","title":"Raxol.Plugins.ThemePlugin.change_theme/2","type":"function"},{"doc":"","ref":"Raxol.Plugins.ThemePlugin.html#disable/1","title":"Raxol.Plugins.ThemePlugin.disable/1","type":"function"},{"doc":"","ref":"Raxol.Plugins.ThemePlugin.html#enable/1","title":"Raxol.Plugins.ThemePlugin.enable/1","type":"function"},{"doc":"","ref":"Raxol.Plugins.ThemePlugin.html#enabled?/1","title":"Raxol.Plugins.ThemePlugin.enabled?/1","type":"function"},{"doc":"","ref":"Raxol.Plugins.ThemePlugin.html#get_name/1","title":"Raxol.Plugins.ThemePlugin.get_name/1","type":"function"},{"doc":"Gets the current theme.","ref":"Raxol.Plugins.ThemePlugin.html#get_theme/1","title":"Raxol.Plugins.ThemePlugin.get_theme/1","type":"function"},{"doc":"Gets a list of available themes.","ref":"Raxol.Plugins.ThemePlugin.html#list_themes/0","title":"Raxol.Plugins.ThemePlugin.list_themes/0","type":"function"},{"doc":"Registers a new theme.\nCan accept either a map of theme attributes or an existing Theme struct.","ref":"Raxol.Plugins.ThemePlugin.html#register_theme/1","title":"Raxol.Plugins.ThemePlugin.register_theme/1","type":"function"},{"doc":"Handles rendering logic for chart visualizations within the VisualizationPlugin.","ref":"Raxol.Plugins.Visualization.ChartRenderer.html","title":"Raxol.Plugins.Visualization.ChartRenderer","type":"module"},{"doc":"Public entry point for rendering chart content.\nHandles bounds checking, error handling, and calls the internal drawing logic.\nExpects bounds to be a map like %{width: w, height: h}.","ref":"Raxol.Plugins.Visualization.ChartRenderer.html#render_chart_content/4","title":"Raxol.Plugins.Visualization.ChartRenderer.render_chart_content/4","type":"function"},{"doc":"Utility functions for drawing basic shapes and text onto a cell grid.\nUsed by visualization renderers.","ref":"Raxol.Plugins.Visualization.DrawingUtils.html","title":"Raxol.Plugins.Visualization.DrawingUtils","type":"module"},{"doc":"Draws box borders onto an existing grid.","ref":"Raxol.Plugins.Visualization.DrawingUtils.html#draw_box_borders/6","title":"Raxol.Plugins.Visualization.DrawingUtils.draw_box_borders/6","type":"function"},{"doc":"Draws a simple box with optional text centered inside.\nReturns a grid of cells.\nExpects bounds map: %{width: w, height: h}.","ref":"Raxol.Plugins.Visualization.DrawingUtils.html#draw_box_with_text/2","title":"Raxol.Plugins.Visualization.DrawingUtils.draw_box_with_text/2","type":"function"},{"doc":"Draws text onto a grid at a specific coordinate.\nTruncates if text exceeds grid width.\nUses optional style.","ref":"Raxol.Plugins.Visualization.DrawingUtils.html#draw_text/5","title":"Raxol.Plugins.Visualization.DrawingUtils.draw_text/5","type":"function"},{"doc":"Draws text centered horizontally on a specific row in the grid.\nTruncates text if it exceeds grid width.","ref":"Raxol.Plugins.Visualization.DrawingUtils.html#draw_text_centered/3","title":"Raxol.Plugins.Visualization.DrawingUtils.draw_text_centered/3","type":"function"},{"doc":"Safely gets a cell from the grid.\nReturns nil if coordinates are out of bounds.","ref":"Raxol.Plugins.Visualization.DrawingUtils.html#get_cell/3","title":"Raxol.Plugins.Visualization.DrawingUtils.get_cell/3","type":"function"},{"doc":"Safely puts a cell into the grid (list of lists).\nHandles out-of-bounds coordinates gracefully (no-op).","ref":"Raxol.Plugins.Visualization.DrawingUtils.html#put_cell/4","title":"Raxol.Plugins.Visualization.DrawingUtils.put_cell/4","type":"function"},{"doc":"Handles rendering logic for image visualization within the VisualizationPlugin.\nSupports both sixel and kitty protocols for terminal image rendering.","ref":"Raxol.Plugins.Visualization.ImageRenderer.html","title":"Raxol.Plugins.Visualization.ImageRenderer","type":"module"},{"doc":"Public entry point for rendering image content.\nHandles bounds checking and calls the internal drawing logic.\nExpects bounds map: %{width: w, height: h}.","ref":"Raxol.Plugins.Visualization.ImageRenderer.html#render_image_content/4","title":"Raxol.Plugins.Visualization.ImageRenderer.render_image_content/4","type":"function"},{"doc":"Handles rendering logic for treemap visualizations within the VisualizationPlugin.\nUses a squarified layout algorithm.","ref":"Raxol.Plugins.Visualization.TreemapRenderer.html","title":"Raxol.Plugins.Visualization.TreemapRenderer","type":"module"},{"doc":"Public entry point for rendering treemap content.\nHandles bounds checking, error handling, and calls the internal layout/drawing logic.\nExpects bounds map: %{width: w, height: h}.","ref":"Raxol.Plugins.Visualization.TreemapRenderer.html#render_treemap_content/4","title":"Raxol.Plugins.Visualization.TreemapRenderer.render_treemap_content/4","type":"function"},{"doc":"Plugin responsible for rendering visualization components like charts and treemaps.\nIt receives data structures from the view rendering pipeline and outputs\nactual terminal cells.","ref":"Raxol.Plugins.VisualizationPlugin.html","title":"Raxol.Plugins.VisualizationPlugin","type":"module"},{"doc":"","ref":"Raxol.Plugins.VisualizationPlugin.html#get_commands/0","title":"Raxol.Plugins.VisualizationPlugin.get_commands/0","type":"function"},{"doc":"","ref":"Raxol.Plugins.VisualizationPlugin.html#handle_command/4","title":"Raxol.Plugins.VisualizationPlugin.handle_command/4","type":"function"},{"doc":"","ref":"Raxol.Plugins.VisualizationPlugin.html#handle_event/3","title":"Raxol.Plugins.VisualizationPlugin.handle_event/3","type":"function"},{"doc":"","ref":"Raxol.Plugins.VisualizationPlugin.html#handle_placeholder/3","title":"Raxol.Plugins.VisualizationPlugin.handle_placeholder/3","type":"function"},{"doc":"","ref":"Raxol.Plugins.VisualizationPlugin.html#terminate/3","title":"Raxol.Plugins.VisualizationPlugin.terminate/3","type":"function"},{"doc":"Protocols module for managing protocols.","ref":"Raxol.Protocols.html","title":"Raxol.Protocols","type":"module"},{"doc":"","ref":"Raxol.Protocols.html#create_protocol/1","title":"Raxol.Protocols.create_protocol/1","type":"function"},{"doc":"","ref":"Raxol.Protocols.html#delete_protocol/1","title":"Raxol.Protocols.delete_protocol/1","type":"function"},{"doc":"","ref":"Raxol.Protocols.html#get_protocol/1","title":"Raxol.Protocols.get_protocol/1","type":"function"},{"doc":"","ref":"Raxol.Protocols.html#list_protocols/0","title":"Raxol.Protocols.list_protocols/0","type":"function"},{"doc":"","ref":"Raxol.Protocols.html#update_protocol/2","title":"Raxol.Protocols.update_protocol/2","type":"function"},{"doc":"Protocol module for handling protocol-related functionality.","ref":"Raxol.Protocols.Protocol.html","title":"Raxol.Protocols.Protocol","type":"module"},{"doc":"","ref":"Raxol.Protocols.Protocol.html#new/1","title":"Raxol.Protocols.Protocol.new/1","type":"function"},{"doc":"","ref":"Raxol.Protocols.Protocol.html#t:t/0","title":"Raxol.Protocols.Protocol.t/0","type":"type"},{"doc":"Handles layout calculations for UI elements.\n\nThis module translates the logical layout (panels, rows, columns)\ninto absolute positions for rendering.","ref":"Raxol.Renderer.Layout.html","title":"Raxol.Renderer.Layout","type":"module"},{"doc":"Applies layout to a view, calculating absolute positions for all elements.","ref":"Raxol.Renderer.Layout.html#apply_layout/2","title":"Raxol.Renderer.Layout.apply_layout/2","type":"function"},{"doc":"* `view` - The view to calculate layout for\n* `dimensions` - Terminal dimensions `%{width: w, height: h}`","ref":"Raxol.Renderer.Layout.html#apply_layout/2-parameters","title":"Parameters - Raxol.Renderer.Layout.apply_layout/2","type":"function"},{"doc":"A list of positioned elements with absolute coordinates.","ref":"Raxol.Renderer.Layout.html#apply_layout/2-returns","title":"Returns - Raxol.Renderer.Layout.apply_layout/2","type":"function"},{"doc":"Default renderer module for the Raxol pipeline.\nDelegates to the main UI rendering process.","ref":"Raxol.Renderer.Main.html","title":"Raxol.Renderer.Main","type":"module"},{"doc":"Handles the final painted output from the rendering pipeline.\nDelegates to Raxol.UI.Rendering.Renderer.","ref":"Raxol.Renderer.Main.html#render/1","title":"Raxol.Renderer.Main.render/1","type":"function"},{"doc":"","ref":"Raxol.Repo.html","title":"Raxol.Repo","type":"module"},{"doc":"Callback implementation for  Ecto.Repo.aggregate/3 .","ref":"Raxol.Repo.html#aggregate/3","title":"Raxol.Repo.aggregate/3","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.aggregate/4 .","ref":"Raxol.Repo.html#aggregate/4","title":"Raxol.Repo.aggregate/4","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.all/2 .","ref":"Raxol.Repo.html#all/2","title":"Raxol.Repo.all/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.checked_out?/0 .","ref":"Raxol.Repo.html#checked_out?/0","title":"Raxol.Repo.checked_out?/0","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.checkout/2 .","ref":"Raxol.Repo.html#checkout/2","title":"Raxol.Repo.checkout/2","type":"function"},{"doc":"","ref":"Raxol.Repo.html#child_spec/1","title":"Raxol.Repo.child_spec/1","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.config/0 .","ref":"Raxol.Repo.html#config/0","title":"Raxol.Repo.config/0","type":"function"},{"doc":"Executes raw SQL query with logging.\n\nThis adds better error handling and logging around raw SQL queries.","ref":"Raxol.Repo.html#custom_query/3","title":"Raxol.Repo.custom_query/3","type":"function"},{"doc":"* `{:ok, result}` - on success\n* `{:error, exception}` - on failure","ref":"Raxol.Repo.html#custom_query/3-returns","title":"Returns - Raxol.Repo.custom_query/3","type":"function"},{"doc":"Executes raw SQL query with logging, raising on errors.\n\nThis adds better error handling and logging around raw SQL queries.","ref":"Raxol.Repo.html#custom_query!/3","title":"Raxol.Repo.custom_query!/3","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.default_options/1 .","ref":"Raxol.Repo.html#default_options/1","title":"Raxol.Repo.default_options/1","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.delete/2 .","ref":"Raxol.Repo.html#delete/2","title":"Raxol.Repo.delete/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.delete!/2 .","ref":"Raxol.Repo.html#delete!/2","title":"Raxol.Repo.delete!/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.delete_all/2 .","ref":"Raxol.Repo.html#delete_all/2","title":"Raxol.Repo.delete_all/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that forces all connections in the\npool to disconnect within the given interval.\n\nSee `Ecto.Adapters.SQL.disconnect_all/3` for more information.","ref":"Raxol.Repo.html#disconnect_all/2","title":"Raxol.Repo.disconnect_all/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.exists?/2 .","ref":"Raxol.Repo.html#exists?/2","title":"Raxol.Repo.exists?/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes an EXPLAIN statement or similar\ndepending on the adapter to obtain statistics for the given query.\n\nSee `Ecto.Adapters.SQL.explain/4` for more information.","ref":"Raxol.Repo.html#explain/3","title":"Raxol.Repo.explain/3","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.get/3 .","ref":"Raxol.Repo.html#get/3","title":"Raxol.Repo.get/3","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.get!/3 .","ref":"Raxol.Repo.html#get!/3","title":"Raxol.Repo.get!/3","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.get_by/3 .","ref":"Raxol.Repo.html#get_by/3","title":"Raxol.Repo.get_by/3","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.get_by!/3 .","ref":"Raxol.Repo.html#get_by!/3","title":"Raxol.Repo.get_by!/3","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.get_dynamic_repo/0 .","ref":"Raxol.Repo.html#get_dynamic_repo/0","title":"Raxol.Repo.get_dynamic_repo/0","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.in_transaction?/0 .","ref":"Raxol.Repo.html#in_transaction?/0","title":"Raxol.Repo.in_transaction?/0","type":"function"},{"doc":"Initializes the repository.","ref":"Raxol.Repo.html#init/2","title":"Raxol.Repo.init/2","type":"function"},{"doc":"This function is called when the repo is started. It adds improved logging\naround database connection events.","ref":"Raxol.Repo.html#init/2-overrides","title":"Overrides - Raxol.Repo.init/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.insert/2 .","ref":"Raxol.Repo.html#insert/2","title":"Raxol.Repo.insert/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.insert!/2 .","ref":"Raxol.Repo.html#insert!/2","title":"Raxol.Repo.insert!/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.insert_all/3 .","ref":"Raxol.Repo.html#insert_all/3","title":"Raxol.Repo.insert_all/3","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.insert_or_update/2 .","ref":"Raxol.Repo.html#insert_or_update/2","title":"Raxol.Repo.insert_or_update/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.insert_or_update!/2 .","ref":"Raxol.Repo.html#insert_or_update!/2","title":"Raxol.Repo.insert_or_update!/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.load/2 .","ref":"Raxol.Repo.html#load/2","title":"Raxol.Repo.load/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.one/2 .","ref":"Raxol.Repo.html#one/2","title":"Raxol.Repo.one/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.one!/2 .","ref":"Raxol.Repo.html#one!/2","title":"Raxol.Repo.one!/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.preload/3 .","ref":"Raxol.Repo.html#preload/3","title":"Raxol.Repo.preload/3","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.prepare_query/3 .","ref":"Raxol.Repo.html#prepare_query/3","title":"Raxol.Repo.prepare_query/3","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.put_dynamic_repo/1 .","ref":"Raxol.Repo.html#put_dynamic_repo/1","title":"Raxol.Repo.put_dynamic_repo/1","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query.\n\nSee `Ecto.Adapters.SQL.query/4` for more information.","ref":"Raxol.Repo.html#query/3","title":"Raxol.Repo.query/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query.\n\nSee `Ecto.Adapters.SQL.query!/4` for more information.","ref":"Raxol.Repo.html#query!/3","title":"Raxol.Repo.query!/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given multi-result query.\n\nSee `Ecto.Adapters.SQL.query_many/4` for more information.","ref":"Raxol.Repo.html#query_many/3","title":"Raxol.Repo.query_many/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given multi-result query.\n\nSee `Ecto.Adapters.SQL.query_many!/4` for more information.","ref":"Raxol.Repo.html#query_many!/3","title":"Raxol.Repo.query_many!/3","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.reload/2 .","ref":"Raxol.Repo.html#reload/2","title":"Raxol.Repo.reload/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.reload!/2 .","ref":"Raxol.Repo.html#reload!/2","title":"Raxol.Repo.reload!/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.rollback/1 .","ref":"Raxol.Repo.html#rollback/1","title":"Raxol.Repo.rollback/1","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.start_link/1 .","ref":"Raxol.Repo.html#start_link/1","title":"Raxol.Repo.start_link/1","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.stop/1 .","ref":"Raxol.Repo.html#stop/1","title":"Raxol.Repo.stop/1","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.stream/2 .","ref":"Raxol.Repo.html#stream/2","title":"Raxol.Repo.stream/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that translates the given query to SQL.\n\nSee `Ecto.Adapters.SQL.to_sql/3` for more information.","ref":"Raxol.Repo.html#to_sql/2","title":"Raxol.Repo.to_sql/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.transaction/2 .","ref":"Raxol.Repo.html#transaction/2","title":"Raxol.Repo.transaction/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.update/2 .","ref":"Raxol.Repo.html#update/2","title":"Raxol.Repo.update/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.update!/2 .","ref":"Raxol.Repo.html#update!/2","title":"Raxol.Repo.update!/2","type":"function"},{"doc":"Callback implementation for  Ecto.Repo.update_all/3 .","ref":"Raxol.Repo.html#update_all/3","title":"Raxol.Repo.update_all/3","type":"function"},{"doc":"The main supervisor for the Raxol application runtime.\nManages core processes like Dispatcher, Plugin system, etc.","ref":"Raxol.Runtime.Supervisor.html","title":"Raxol.Runtime.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Runtime.Supervisor.html#child_spec/1","title":"Raxol.Runtime.Supervisor.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Runtime.Supervisor.html#start_link/1","title":"Raxol.Runtime.Supervisor.start_link/1","type":"function"},{"doc":"Defines the structure for a sequence of terminal commands.","ref":"Raxol.Sequence.html","title":"Raxol.Sequence","type":"module"},{"doc":"","ref":"Raxol.Sequence.html#t:t/0","title":"Raxol.Sequence.t/0","type":"type"},{"doc":"Handles the execution of sequences of terminal commands.","ref":"Raxol.SequenceExecutor.html","title":"Raxol.SequenceExecutor","type":"module"},{"doc":"Executes a sequence of terminal commands.","ref":"Raxol.SequenceExecutor.html#execute_sequence/2","title":"Raxol.SequenceExecutor.execute_sequence/2","type":"function"},{"doc":"Defines style properties for terminal UI elements.","ref":"Raxol.Style.html","title":"Raxol.Style","type":"module"},{"doc":"Apply component-specific styling.","ref":"Raxol.Style.html#apply_component_specific/2","title":"Raxol.Style.apply_component_specific/2","type":"function"},{"doc":"Apply responsive styling based on terminal dimensions.","ref":"Raxol.Style.html#apply_responsive/3","title":"Raxol.Style.apply_responsive/3","type":"function"},{"doc":"Merges two styles, with the second overriding the first.","ref":"Raxol.Style.html#merge/2","title":"Raxol.Style.merge/2","type":"function"},{"doc":"Creates a new style with default values.","ref":"Raxol.Style.html#new/0","title":"Raxol.Style.new/0","type":"function"},{"doc":"Creates a new style from a keyword list or map of attributes.","ref":"Raxol.Style.html#new/1","title":"Raxol.Style.new/1","type":"function"},{"doc":"Resolves a style definition against the current theme.","ref":"Raxol.Style.html#resolve/2","title":"Raxol.Style.resolve/2","type":"function"},{"doc":"","ref":"Raxol.Style.html#t:t/0","title":"Raxol.Style.t/0","type":"type"},{"doc":"Converts style properties to ANSI escape sequences (currently just numeric codes).","ref":"Raxol.Style.html#to_ansi/1","title":"Raxol.Style.to_ansi/1","type":"function"},{"doc":"Defines border properties for terminal UI elements.","ref":"Raxol.Style.Borders.html","title":"Raxol.Style.Borders","type":"module"},{"doc":"Merges two border structs, with the second overriding the first.","ref":"Raxol.Style.Borders.html#merge/2","title":"Raxol.Style.Borders.merge/2","type":"function"},{"doc":"Creates a new border with default values.","ref":"Raxol.Style.Borders.html#new/0","title":"Raxol.Style.Borders.new/0","type":"function"},{"doc":"Creates a new border with the specified values.","ref":"Raxol.Style.Borders.html#new/1","title":"Raxol.Style.Borders.new/1","type":"function"},{"doc":"","ref":"Raxol.Style.Borders.html#t:t/0","title":"Raxol.Style.Borders.t/0","type":"type"},{"doc":"Provides utilities for color accessibility, focusing on WCAG contrast.","ref":"Raxol.Style.Colors.Accessibility.html","title":"Raxol.Style.Colors.Accessibility","type":"module"},{"doc":"Finds an accessible color pair (foreground/background) based on a base color and WCAG level.\n\nTries to find a contrasting color (black or white first) that meets the desired level.\n\nParameters:\n  - `base_color`: The Color struct or hex string to find a contrasting pair for.\n  - `level`: The minimum WCAG contrast ratio level (:aa or :aaa, defaults to :aa).\n\nReturns:\n  A tuple `{foreground_color, background_color}` where one is the `base_color`\n  and the other is a contrasting color (typically black or white) that meets the\n  specified `level`. Returns `nil` if no suitable pair is found immediately\n  (further logic might be needed for complex cases).","ref":"Raxol.Style.Colors.Accessibility.html#accessible_color_pair/2","title":"Raxol.Style.Colors.Accessibility.accessible_color_pair/2","type":"function"},{"doc":"Adjusts a color palette to ensure all colors are accessible against a background.","ref":"Raxol.Style.Colors.Accessibility.html#adjust_palette/2","title":"Raxol.Style.Colors.Accessibility.adjust_palette/2","type":"function"},{"doc":"- `colors` - Map of colors to adjust\n- `background` - Background color to check against","ref":"Raxol.Style.Colors.Accessibility.html#adjust_palette/2-parameters","title":"Parameters - Raxol.Style.Colors.Accessibility.adjust_palette/2","type":"function"},{"doc":"- Map of adjusted colors","ref":"Raxol.Style.Colors.Accessibility.html#adjust_palette/2-returns","title":"Returns - Raxol.Style.Colors.Accessibility.adjust_palette/2","type":"function"},{"doc":"Checks if two colors have sufficient contrast according to WCAG guidelines.","ref":"Raxol.Style.Colors.Accessibility.html#check_contrast/4","title":"Raxol.Style.Colors.Accessibility.check_contrast/4","type":"function"},{"doc":"- `color1` - First color\n- `color2` - Second color\n- `level` - WCAG level (:aa or :aaa)\n- `size` - Text size (:normal or :large)","ref":"Raxol.Style.Colors.Accessibility.html#check_contrast/4-parameters","title":"Parameters - Raxol.Style.Colors.Accessibility.check_contrast/4","type":"function"},{"doc":"- `{:ok, ratio}` if contrast is sufficient\n- `{:error, {:contrast_too_low, ratio, min_ratio}}` if contrast is insufficient","ref":"Raxol.Style.Colors.Accessibility.html#check_contrast/4-returns","title":"Returns - Raxol.Style.Colors.Accessibility.check_contrast/4","type":"function"},{"doc":"Calculates the contrast ratio between two colors according to WCAG guidelines.","ref":"Raxol.Style.Colors.Accessibility.html#contrast_ratio/2","title":"Raxol.Style.Colors.Accessibility.contrast_ratio/2","type":"function"},{"doc":"- `color1` - The first color (hex string or Color struct)\n- `color2` - The second color (hex string or Color struct)","ref":"Raxol.Style.Colors.Accessibility.html#contrast_ratio/2-parameters","title":"Parameters - Raxol.Style.Colors.Accessibility.contrast_ratio/2","type":"function"},{"doc":"- A float representing the contrast ratio (1:1 to 21:1)","ref":"Raxol.Style.Colors.Accessibility.html#contrast_ratio/2-returns","title":"Returns - Raxol.Style.Colors.Accessibility.contrast_ratio/2","type":"function"},{"doc":"iex> Raxol.Style.Colors.Accessibility.contrast_ratio(\"#000000\", \"#FFFFFF\")\n    21.0\n\n    iex> Raxol.Style.Colors.Accessibility.contrast_ratio(\"#777777\", \"#999999\")\n    1.3","ref":"Raxol.Style.Colors.Accessibility.html#contrast_ratio/2-examples","title":"Examples - Raxol.Style.Colors.Accessibility.contrast_ratio/2","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.Accessibility.html#darken_until_contrast/3","title":"Raxol.Style.Colors.Accessibility.darken_until_contrast/3","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.Accessibility.html#generate_accessible_palette/2","title":"Raxol.Style.Colors.Accessibility.generate_accessible_palette/2","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.Accessibility.html#get_optimal_text_color/1","title":"Raxol.Style.Colors.Accessibility.get_optimal_text_color/1","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.Accessibility.html#lighten_until_contrast/3","title":"Raxol.Style.Colors.Accessibility.lighten_until_contrast/3","type":"function"},{"doc":"Checks if a foreground color is readable on a background color.","ref":"Raxol.Style.Colors.Accessibility.html#readable?/3","title":"Raxol.Style.Colors.Accessibility.readable?/3","type":"function"},{"doc":"- `background` - Background color\n- `foreground` - Text color\n- `level` - Accessibility level (`:aa`, `:aaa`, `:aa_large`, `:aaa_large`)","ref":"Raxol.Style.Colors.Accessibility.html#readable?/3-parameters","title":"Parameters - Raxol.Style.Colors.Accessibility.readable?/3","type":"function"},{"doc":"iex> bg = Raxol.Style.Colors.Color.from_hex(\"#333333\")\n    iex> fg = Raxol.Style.Colors.Color.from_hex(\"#FFFFFF\")\n    iex> Raxol.Style.Colors.Accessibility.readable?(bg, fg)\n    true\n\n    iex> bg = Raxol.Style.Colors.Color.from_hex(\"#CCCCCC\")\n    iex> fg = Raxol.Style.Colors.Color.from_hex(\"#999999\")\n    iex> Raxol.Style.Colors.Accessibility.readable?(bg, fg, :aaa)\n    false","ref":"Raxol.Style.Colors.Accessibility.html#readable?/3-examples","title":"Examples - Raxol.Style.Colors.Accessibility.readable?/3","type":"function"},{"doc":"Calculates the relative luminance of a color according to WCAG guidelines.","ref":"Raxol.Style.Colors.Accessibility.html#relative_luminance/1","title":"Raxol.Style.Colors.Accessibility.relative_luminance/1","type":"function"},{"doc":"- `color` - The color to calculate luminance for (hex string or Color struct)","ref":"Raxol.Style.Colors.Accessibility.html#relative_luminance/1-parameters","title":"Parameters - Raxol.Style.Colors.Accessibility.relative_luminance/1","type":"function"},{"doc":"- A float between 0 and 1 representing the relative luminance","ref":"Raxol.Style.Colors.Accessibility.html#relative_luminance/1-returns","title":"Returns - Raxol.Style.Colors.Accessibility.relative_luminance/1","type":"function"},{"doc":"iex> Raxol.Style.Colors.Accessibility.relative_luminance(\"#000000\")\n    0.0\n\n    iex> Raxol.Style.Colors.Accessibility.relative_luminance(\"#FFFFFF\")\n    1.0","ref":"Raxol.Style.Colors.Accessibility.html#relative_luminance/1-examples","title":"Examples - Raxol.Style.Colors.Accessibility.relative_luminance/1","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.Accessibility.html#suggest_accessible_color/2","title":"Raxol.Style.Colors.Accessibility.suggest_accessible_color/2","type":"function"},{"doc":"Suggests a color with good contrast (at least AA) to the base color.\n\nPrioritizes complementary color, then black/white.","ref":"Raxol.Style.Colors.Accessibility.html#suggest_contrast_color/1","title":"Raxol.Style.Colors.Accessibility.suggest_contrast_color/1","type":"function"},{"doc":"- `color` - The base color (hex string or Color struct)","ref":"Raxol.Style.Colors.Accessibility.html#suggest_contrast_color/1-parameters","title":"Parameters - Raxol.Style.Colors.Accessibility.suggest_contrast_color/1","type":"function"},{"doc":"iex> color = Raxol.Style.Colors.Color.from_hex(\"#3366CC\")\n    iex> contrast_color = Raxol.Style.Colors.Accessibility.suggest_contrast_color(color)\n    iex> Raxol.Style.Colors.Accessibility.readable?(color, contrast_color)\n    true","ref":"Raxol.Style.Colors.Accessibility.html#suggest_contrast_color/1-examples","title":"Examples - Raxol.Style.Colors.Accessibility.suggest_contrast_color/1","type":"function"},{"doc":"Suggests an appropriate text color (black or white) for a given background.\n\nEnsures minimum AA contrast.","ref":"Raxol.Style.Colors.Accessibility.html#suggest_text_color/1","title":"Raxol.Style.Colors.Accessibility.suggest_text_color/1","type":"function"},{"doc":"- `background` - The background color (hex string or Color struct)","ref":"Raxol.Style.Colors.Accessibility.html#suggest_text_color/1-parameters","title":"Parameters - Raxol.Style.Colors.Accessibility.suggest_text_color/1","type":"function"},{"doc":"iex> Raxol.Style.Colors.Accessibility.suggest_text_color(\"#333333\").hex\n    \"#FFFFFF\"\n\n    iex> Raxol.Style.Colors.Accessibility.suggest_text_color(\"#EEEEEE\").hex\n    \"#000000\"","ref":"Raxol.Style.Colors.Accessibility.html#suggest_text_color/1-examples","title":"Examples - Raxol.Style.Colors.Accessibility.suggest_text_color/1","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.Accessibility.html#suitable_for_text?/2","title":"Raxol.Style.Colors.Accessibility.suitable_for_text?/2","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.Accessibility.html#validate_colors/2","title":"Raxol.Style.Colors.Accessibility.validate_colors/2","type":"function"},{"doc":"Detects terminal capabilities and adapts color schemes accordingly.\n\nThis module provides functionality to detect what color capabilities are\nsupported by the current terminal and adapt colors and themes to work\noptimally with the detected capabilities.","ref":"Raxol.Style.Colors.Adaptive.html","title":"Raxol.Style.Colors.Adaptive","type":"module"},{"doc":"```elixir\n# Check if the terminal supports true color\nif Raxol.Style.Colors.Adaptive.supports_true_color?() do\n  # Use true color features\nelse\n  # Fall back to 256 colors or 16 colors\nend\n\n# Adapt a color to the current terminal capabilities\ncolor = Raxol.Style.Colors.Color.from_hex(\"#FF5500\")\nadapted_color = Raxol.Style.Colors.Adaptive.adapt_color(color)\n\n# Check if we're in a dark terminal\nif Raxol.Style.Colors.Adaptive.dark_terminal?() do\n  # Use light text on dark background\nelse\n  # Use dark text on light background\nend\n```","ref":"Raxol.Style.Colors.Adaptive.html#module-examples","title":"Examples - Raxol.Style.Colors.Adaptive","type":"module"},{"doc":"Adapts a color to the current terminal capabilities.\n\nIf the terminal does not support the full color range, this will\nconvert the color to the best available representation.","ref":"Raxol.Style.Colors.Adaptive.html#adapt_color/1","title":"Raxol.Style.Colors.Adaptive.adapt_color/1","type":"function"},{"doc":"- `color` - The color to adapt","ref":"Raxol.Style.Colors.Adaptive.html#adapt_color/1-parameters","title":"Parameters - Raxol.Style.Colors.Adaptive.adapt_color/1","type":"function"},{"doc":"iex> color = Raxol.Style.Colors.Color.from_hex(\"#FF5500\")\n    iex> adapted = Raxol.Style.Colors.Adaptive.adapt_color(color)\n    iex> adapted.hex\n    \"#FF5500\"  # If terminal supports true color, otherwise closest supported color","ref":"Raxol.Style.Colors.Adaptive.html#adapt_color/1-examples","title":"Examples - Raxol.Style.Colors.Adaptive.adapt_color/1","type":"function"},{"doc":"Adapts a theme (canonical structure) to the current terminal capabilities and background.","ref":"Raxol.Style.Colors.Adaptive.html#adapt_theme/1","title":"Raxol.Style.Colors.Adaptive.adapt_theme/1","type":"function"},{"doc":"- `theme` - The canonical theme map to adapt","ref":"Raxol.Style.Colors.Adaptive.html#adapt_theme/1-parameters","title":"Parameters - Raxol.Style.Colors.Adaptive.adapt_theme/1","type":"function"},{"doc":"iex> theme = Raxol.UI.Theming.Theme.default_theme()\n    iex> adapted = Raxol.Style.Colors.Adaptive.adapt_theme(theme)\n    iex> adapted.name\n    \"default (Adapted)\"  # Adapted to terminal capabilities","ref":"Raxol.Style.Colors.Adaptive.html#adapt_theme/1-examples","title":"Examples - Raxol.Style.Colors.Adaptive.adapt_theme/1","type":"function"},{"doc":"Checks if the terminal has a dark background.","ref":"Raxol.Style.Colors.Adaptive.html#dark_terminal?/0","title":"Raxol.Style.Colors.Adaptive.dark_terminal?/0","type":"function"},{"doc":"iex> Raxol.Style.Colors.Adaptive.dark_terminal?()\n    true  # Depends on your terminal","ref":"Raxol.Style.Colors.Adaptive.html#dark_terminal?/0-examples","title":"Examples - Raxol.Style.Colors.Adaptive.dark_terminal?/0","type":"function"},{"doc":"Detects the color support level of the current terminal.\n\nReturns one of:\n- `:true_color` - 24-bit color (16 million colors)\n- `:ansi_256` - 256 colors\n- `:ansi_16` - 16 colors\n- `:no_color` - No color support","ref":"Raxol.Style.Colors.Adaptive.html#detect_color_support/0","title":"Raxol.Style.Colors.Adaptive.detect_color_support/0","type":"function"},{"doc":"iex> Raxol.Style.Colors.Adaptive.detect_color_support()\n    :true_color  # Depends on your terminal","ref":"Raxol.Style.Colors.Adaptive.html#detect_color_support/0-examples","title":"Examples - Raxol.Style.Colors.Adaptive.detect_color_support/0","type":"function"},{"doc":"Gets the optimal color format for the current terminal.\n\nReturns one of:\n- `:true_color` - 24-bit color (16 million colors)\n- `:ansi_256` - 256 colors\n- `:ansi_16`","ref":"Raxol.Style.Colors.Adaptive.html#get_optimal_format/0","title":"Raxol.Style.Colors.Adaptive.get_optimal_format/0","type":"function"},{"doc":"iex> Raxol.Style.Colors.Adaptive.get_optimal_format()\n    :true_color  # Depends on your terminal","ref":"Raxol.Style.Colors.Adaptive.html#get_optimal_format/0-examples","title":"Examples - Raxol.Style.Colors.Adaptive.get_optimal_format/0","type":"function"},{"doc":"Initializes the terminal capabilities cache.\n\nThis should be called once, usually during application startup.\nIt creates the ETS table used for caching detected capabilities.","ref":"Raxol.Style.Colors.Adaptive.html#init/0","title":"Raxol.Style.Colors.Adaptive.init/0","type":"function"},{"doc":"Gets the optimal color format for the current terminal.\n\nReturns one of:\n- `:true_color` - 24-bit color (16 million colors)\n- `:ansi_256` - 256 colors\n- `:ansi_16` - 16 colors\n- `:no_color` - No color support","ref":"Raxol.Style.Colors.Adaptive.html#optimal_format/0","title":"Raxol.Style.Colors.Adaptive.optimal_format/0","type":"function"},{"doc":"iex> Raxol.Style.Colors.Adaptive.optimal_format()\n    :true_color  # Depends on your terminal","ref":"Raxol.Style.Colors.Adaptive.html#optimal_format/0-examples","title":"Examples - Raxol.Style.Colors.Adaptive.optimal_format/0","type":"function"},{"doc":"Resets the cached terminal capabilities.\n\nThis forces the next call to detection functions to re-evaluate\nthe terminal environment.","ref":"Raxol.Style.Colors.Adaptive.html#reset_detection/0","title":"Raxol.Style.Colors.Adaptive.reset_detection/0","type":"function"},{"doc":"Checks if the terminal supports 256 colors.","ref":"Raxol.Style.Colors.Adaptive.html#supports_256_colors?/0","title":"Raxol.Style.Colors.Adaptive.supports_256_colors?/0","type":"function"},{"doc":"iex> Raxol.Style.Colors.Adaptive.supports_256_colors?()\n    true  # Depends on your terminal","ref":"Raxol.Style.Colors.Adaptive.html#supports_256_colors?/0-examples","title":"Examples - Raxol.Style.Colors.Adaptive.supports_256_colors?/0","type":"function"},{"doc":"Checks if the terminal supports true color (24-bit color).","ref":"Raxol.Style.Colors.Adaptive.html#supports_true_color?/0","title":"Raxol.Style.Colors.Adaptive.supports_true_color?/0","type":"function"},{"doc":"iex> Raxol.Style.Colors.Adaptive.supports_true_color?()\n    true  # Depends on your terminal","ref":"Raxol.Style.Colors.Adaptive.html#supports_true_color?/0-examples","title":"Examples - Raxol.Style.Colors.Adaptive.supports_true_color?/0","type":"function"},{"doc":"Detects the terminal background color (light or dark).\n\nReturns one of:\n- `:dark` - Dark background\n- `:light` - Light background\n- `:unknown` - Unable to determine","ref":"Raxol.Style.Colors.Adaptive.html#terminal_background/0","title":"Raxol.Style.Colors.Adaptive.terminal_background/0","type":"function"},{"doc":"iex> Raxol.Style.Colors.Adaptive.terminal_background()\n    :dark  # Depends on your terminal","ref":"Raxol.Style.Colors.Adaptive.html#terminal_background/0-examples","title":"Examples - Raxol.Style.Colors.Adaptive.terminal_background/0","type":"function"},{"doc":"Provides advanced color handling capabilities for the terminal.\n\nFeatures:\n- Color blending and mixing\n- Custom color palettes\n- Enhanced color adaptation\n- Color space conversions\n- Color harmony generation","ref":"Raxol.Style.Colors.Advanced.html","title":"Raxol.Style.Colors.Advanced","type":"module"},{"doc":"Adapts a color to the current terminal capabilities with advanced options.","ref":"Raxol.Style.Colors.Advanced.html#adapt_color_advanced/2","title":"Raxol.Style.Colors.Advanced.adapt_color_advanced/2","type":"function"},{"doc":"- `color` - The color to adapt\n- `options` - Adaptation options\n  - `:preserve_brightness` - Try to maintain perceived brightness\n  - `:enhance_contrast` - Increase contrast when possible\n  - `:color_blind_safe` - Ensure color blind friendly colors","ref":"Raxol.Style.Colors.Advanced.html#adapt_color_advanced/2-parameters","title":"Parameters - Raxol.Style.Colors.Advanced.adapt_color_advanced/2","type":"function"},{"doc":"iex> color = Color.from_hex(\"#FF0000\")\n    iex> adapted = Advanced.adapt_color_advanced(color, preserve_brightness: true)\n    iex> adapted.hex\n    \"#FF0000\"  # If terminal supports true color","ref":"Raxol.Style.Colors.Advanced.html#adapt_color_advanced/2-examples","title":"Examples - Raxol.Style.Colors.Advanced.adapt_color_advanced/2","type":"function"},{"doc":"Blends two colors together with the given ratio.","ref":"Raxol.Style.Colors.Advanced.html#blend_colors/3","title":"Raxol.Style.Colors.Advanced.blend_colors/3","type":"function"},{"doc":"- `color1` - First color\n- `color2` - Second color\n- `ratio` - Blend ratio (0.0 to 1.0, where 0.0 is color1 and 1.0 is color2)","ref":"Raxol.Style.Colors.Advanced.html#blend_colors/3-parameters","title":"Parameters - Raxol.Style.Colors.Advanced.blend_colors/3","type":"function"},{"doc":"iex> color1 = Color.from_hex(\"#FF0000\")\n    iex> color2 = Color.from_hex(\"#0000FF\")\n    iex> blended = Advanced.blend_colors(color1, color2, 0.5)\n    iex> blended.hex\n    \"#800080\"  # Purple","ref":"Raxol.Style.Colors.Advanced.html#blend_colors/3-examples","title":"Examples - Raxol.Style.Colors.Advanced.blend_colors/3","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.Advanced.html#t:color/0","title":"Raxol.Style.Colors.Advanced.color/0","type":"type"},{"doc":"Converts a color to a different color space.","ref":"Raxol.Style.Colors.Advanced.html#convert_color_space/2","title":"Raxol.Style.Colors.Advanced.convert_color_space/2","type":"function"},{"doc":"- `color` - The color to convert\n- `target_space` - The target color space (:rgb, :hsl, :lab, or :xyz)","ref":"Raxol.Style.Colors.Advanced.html#convert_color_space/2-parameters","title":"Parameters - Raxol.Style.Colors.Advanced.convert_color_space/2","type":"function"},{"doc":"iex> color = Color.from_hex(\"#FF0000\")\n    iex> hsl = Advanced.convert_color_space(color, :hsl)\n    iex> hsl\n    %{h: 0, s: 100, l: 50}","ref":"Raxol.Style.Colors.Advanced.html#convert_color_space/2-examples","title":"Examples - Raxol.Style.Colors.Advanced.convert_color_space/2","type":"function"},{"doc":"Creates a gradient between two colors with the specified number of steps.","ref":"Raxol.Style.Colors.Advanced.html#create_gradient/3","title":"Raxol.Style.Colors.Advanced.create_gradient/3","type":"function"},{"doc":"- `color1` - Start color\n- `color2` - End color\n- `steps` - Number of steps in the gradient","ref":"Raxol.Style.Colors.Advanced.html#create_gradient/3-parameters","title":"Parameters - Raxol.Style.Colors.Advanced.create_gradient/3","type":"function"},{"doc":"iex> color1 = Color.from_hex(\"#FF0000\")\n    iex> color2 = Color.from_hex(\"#0000FF\")\n    iex> gradient = Advanced.create_gradient(color1, color2, 3)\n    iex> Enum.map(gradient, & &1.hex)\n    [\"#FF0000\", \"#800080\", \"#0000FF\"]","ref":"Raxol.Style.Colors.Advanced.html#create_gradient/3-examples","title":"Examples - Raxol.Style.Colors.Advanced.create_gradient/3","type":"function"},{"doc":"Creates a color harmony based on the input color.","ref":"Raxol.Style.Colors.Advanced.html#create_harmony/3","title":"Raxol.Style.Colors.Advanced.create_harmony/3","type":"function"},{"doc":"- `color` - The base color\n- `harmony_type` - Type of harmony (:complementary, :analogous, :triadic, :tetradic)","ref":"Raxol.Style.Colors.Advanced.html#create_harmony/3-parameters","title":"Parameters - Raxol.Style.Colors.Advanced.create_harmony/3","type":"function"},{"doc":"iex> color = Color.from_hex(\"#FF0000\")\n    iex> harmony = Advanced.create_harmony(color, :complementary)\n    iex> Enum.map(harmony, & &1.hex)\n    [\"#FF0000\", \"#00FFFF\"]","ref":"Raxol.Style.Colors.Advanced.html#create_harmony/3-examples","title":"Examples - Raxol.Style.Colors.Advanced.create_harmony/3","type":"function"},{"doc":"Core color representation and manipulation module.\n\nThis module provides a unified interface for working with colors in Raxol,\nsupporting various color formats and operations.","ref":"Raxol.Style.Colors.Color.html","title":"Raxol.Style.Colors.Color","type":"module"},{"doc":"- RGB: `{r, g, b}` where each component is 0-255\n- RGBA: `{r, g, b, a}` where alpha is 0-255\n- Hex: `\"#RRGGBB\"` or `\"#RRGGBBAA\"`\n- ANSI: 0-255 for 256-color mode, 0-15 for basic colors\n- Named: `:red`, `:blue`, etc.","ref":"Raxol.Style.Colors.Color.html#module-color-formats","title":"Color Formats - Raxol.Style.Colors.Color","type":"module"},{"doc":"iex> Color.from_hex(\"#FF0000\")\n    %Color{r: 255, g: 0, b: 0, hex: \"#FF0000\"}\n\n    iex> Color.from_rgb(255, 0, 0)\n    %Color{r: 255, g: 0, b: 0, hex: \"#FF0000\"}\n\n    iex> Color.from_ansi(1)\n    %Color{r: 205, g: 0, b: 0, hex: \"#CD0000\", ansi_code: 1}","ref":"Raxol.Style.Colors.Color.html#module-examples","title":"Examples - Raxol.Style.Colors.Color","type":"module"},{"doc":"Blends two colors with the specified alpha value.","ref":"Raxol.Style.Colors.Color.html#blend/3","title":"Raxol.Style.Colors.Color.blend/3","type":"function"},{"doc":"iex> Color.blend(Color.from_hex(\"#FF0000\"), Color.from_hex(\"#0000FF\"), 0.5)\n    %Color{r: 128, g: 0, b: 128, hex: \"#800080\"}","ref":"Raxol.Style.Colors.Color.html#blend/3-examples","title":"Examples - Raxol.Style.Colors.Color.blend/3","type":"function"},{"doc":"Returns the complementary color.","ref":"Raxol.Style.Colors.Color.html#complement/1","title":"Raxol.Style.Colors.Color.complement/1","type":"function"},{"doc":"iex> Color.from_hex(\"#FF0000\") |> Color.complement()\n    %Color{r: 0, g: 255, b: 255, hex: \"#00FFFF\"}","ref":"Raxol.Style.Colors.Color.html#complement/1-examples","title":"Examples - Raxol.Style.Colors.Color.complement/1","type":"function"},{"doc":"Darkens a color by the specified amount.","ref":"Raxol.Style.Colors.Color.html#darken/2","title":"Raxol.Style.Colors.Color.darken/2","type":"function"},{"doc":"iex> Color.from_hex(\"#FFFFFF\") |> Color.darken(0.5)\n    %Color{r: 128, g: 128, b: 128, hex: \"#808080\"}","ref":"Raxol.Style.Colors.Color.html#darken/2-examples","title":"Examples - Raxol.Style.Colors.Color.darken/2","type":"function"},{"doc":"Creates a color from an ANSI color code.","ref":"Raxol.Style.Colors.Color.html#from_ansi/1","title":"Raxol.Style.Colors.Color.from_ansi/1","type":"function"},{"doc":"iex> Color.from_ansi(1)\n    %Color{r: 205, g: 0, b: 0, hex: \"#CD0000\", ansi_code: 1}","ref":"Raxol.Style.Colors.Color.html#from_ansi/1-examples","title":"Examples - Raxol.Style.Colors.Color.from_ansi/1","type":"function"},{"doc":"Creates a color from a hex string.","ref":"Raxol.Style.Colors.Color.html#from_hex/1","title":"Raxol.Style.Colors.Color.from_hex/1","type":"function"},{"doc":"iex> Color.from_hex(\"#FF0000\")\n    %Color{r: 255, g: 0, b: 0, hex: \"#FF0000\"}\n\n    iex> Color.from_hex(\"#FF000080\")\n    %Color{r: 255, g: 0, b: 0, a: 128, hex: \"#FF000080\"}","ref":"Raxol.Style.Colors.Color.html#from_hex/1-examples","title":"Examples - Raxol.Style.Colors.Color.from_hex/1","type":"function"},{"doc":"Creates a color from RGB values.","ref":"Raxol.Style.Colors.Color.html#from_rgb/3","title":"Raxol.Style.Colors.Color.from_rgb/3","type":"function"},{"doc":"iex> Color.from_rgb(255, 0, 0)\n    %Color{r: 255, g: 0, b: 0, hex: \"#FF0000\"}","ref":"Raxol.Style.Colors.Color.html#from_rgb/3-examples","title":"Examples - Raxol.Style.Colors.Color.from_rgb/3","type":"function"},{"doc":"Creates a color from RGBA values.","ref":"Raxol.Style.Colors.Color.html#from_rgba/4","title":"Raxol.Style.Colors.Color.from_rgba/4","type":"function"},{"doc":"iex> Color.from_rgba(255, 0, 0, 128)\n    %Color{r: 255, g: 0, b: 0, a: 128, hex: \"#FF000080\"}","ref":"Raxol.Style.Colors.Color.html#from_rgba/4-examples","title":"Examples - Raxol.Style.Colors.Color.from_rgba/4","type":"function"},{"doc":"Lightens a color by the specified amount.","ref":"Raxol.Style.Colors.Color.html#lighten/2","title":"Raxol.Style.Colors.Color.lighten/2","type":"function"},{"doc":"iex> Color.from_hex(\"#000000\") |> Color.lighten(0.5)\n    %Color{r: 128, g: 128, b: 128, hex: \"#808080\"}","ref":"Raxol.Style.Colors.Color.html#lighten/2-examples","title":"Examples - Raxol.Style.Colors.Color.lighten/2","type":"function"},{"doc":"Mixes two colors with the specified weight (0.0 to 1.0).","ref":"Raxol.Style.Colors.Color.html#mix/3","title":"Raxol.Style.Colors.Color.mix/3","type":"function"},{"doc":"iex> color1 = Color.from_rgb(255, 0, 0)\n    iex> color2 = Color.from_rgb(0, 0, 255)\n    iex> mixed = Color.mix(color1, color2, 0.5)\n    iex> {mixed.r, mixed.g, mixed.b}\n    {127, 0, 127}","ref":"Raxol.Style.Colors.Color.html#mix/3-examples","title":"Examples - Raxol.Style.Colors.Color.mix/3","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.Color.html#t:t/0","title":"Raxol.Style.Colors.Color.t/0","type":"type"},{"doc":"Converts a color to an ANSI code (currently defaults to 256-color code).\nThe `type` parameter (:foreground or :background) is currently ignored.\n\nNOTE: This is a placeholder. Implement proper ANSI sequence generation based on type and terminal capabilities in the future.","ref":"Raxol.Style.Colors.Color.html#to_ansi/2","title":"Raxol.Style.Colors.Color.to_ansi/2","type":"function"},{"doc":"Converts a color to the closest ANSI 16-color code.","ref":"Raxol.Style.Colors.Color.html#to_ansi_16/1","title":"Raxol.Style.Colors.Color.to_ansi_16/1","type":"function"},{"doc":"iex> color = Color.from_rgb(255, 0, 0)\n    iex> Color.to_ansi_16(color)\n    9","ref":"Raxol.Style.Colors.Color.html#to_ansi_16/1-examples","title":"Examples - Raxol.Style.Colors.Color.to_ansi_16/1","type":"function"},{"doc":"Converts a color to the closest ANSI 256-color code.","ref":"Raxol.Style.Colors.Color.html#to_ansi_256/1","title":"Raxol.Style.Colors.Color.to_ansi_256/1","type":"function"},{"doc":"iex> color = Color.from_rgb(255, 0, 0)\n    iex> Color.to_ansi_256(color)\n    196","ref":"Raxol.Style.Colors.Color.html#to_ansi_256/1-examples","title":"Examples - Raxol.Style.Colors.Color.to_ansi_256/1","type":"function"},{"doc":"Converts a color to its hex representation.","ref":"Raxol.Style.Colors.Color.html#to_hex/1","title":"Raxol.Style.Colors.Color.to_hex/1","type":"function"},{"doc":"iex> color = Color.from_rgb(255, 0, 0)\n    iex> Color.to_hex(color)\n    \"#FF0000\"","ref":"Raxol.Style.Colors.Color.html#to_hex/1-examples","title":"Examples - Raxol.Style.Colors.Color.to_hex/1","type":"function"},{"doc":"Color format conversion utilities.\n\nThis module provides functions for converting between different color formats:\n- RGB/RGBA tuples\n- Hex strings\n- ANSI color codes\n- Named colors","ref":"Raxol.Style.Colors.Formats.html","title":"Raxol.Style.Colors.Formats","type":"module"},{"doc":"Converts an ANSI color code to RGB values.","ref":"Raxol.Style.Colors.Formats.html#ansi_to_rgb/1","title":"Raxol.Style.Colors.Formats.ansi_to_rgb/1","type":"function"},{"doc":"iex> Formats.ansi_to_rgb(1)\n    {205, 0, 0}","ref":"Raxol.Style.Colors.Formats.html#ansi_to_rgb/1-examples","title":"Examples - Raxol.Style.Colors.Formats.ansi_to_rgb/1","type":"function"},{"doc":"Parses a hex string into RGB/RGBA values.","ref":"Raxol.Style.Colors.Formats.html#from_hex/1","title":"Raxol.Style.Colors.Formats.from_hex/1","type":"function"},{"doc":"iex> Formats.from_hex(\"#FF0000\")\n    {255, 0, 0}\n\n    iex> Formats.from_hex(\"#FF000080\")\n    {255, 0, 0, 128}","ref":"Raxol.Style.Colors.Formats.html#from_hex/1-examples","title":"Examples - Raxol.Style.Colors.Formats.from_hex/1","type":"function"},{"doc":"Converts RGB values to an ANSI color code.","ref":"Raxol.Style.Colors.Formats.html#rgb_to_ansi/1","title":"Raxol.Style.Colors.Formats.rgb_to_ansi/1","type":"function"},{"doc":"iex> Formats.rgb_to_ansi({255, 0, 0})\n    196","ref":"Raxol.Style.Colors.Formats.html#rgb_to_ansi/1-examples","title":"Examples - Raxol.Style.Colors.Formats.rgb_to_ansi/1","type":"function"},{"doc":"Converts a color to its hex representation.","ref":"Raxol.Style.Colors.Formats.html#to_hex/1","title":"Raxol.Style.Colors.Formats.to_hex/1","type":"function"},{"doc":"iex> Formats.to_hex({255, 0, 0})\n    \"#FF0000\"\n\n    iex> Formats.to_hex({255, 0, 0, 128})\n    \"#FF000080\"","ref":"Raxol.Style.Colors.Formats.html#to_hex/1-examples","title":"Examples - Raxol.Style.Colors.Formats.to_hex/1","type":"function"},{"doc":"Creates and manages color gradients for terminal applications.\n\nThis module provides functionality for creating gradients between colors and\napplying them to text, creating visually striking terminal effects.","ref":"Raxol.Style.Colors.Gradient.html","title":"Raxol.Style.Colors.Gradient","type":"module"},{"doc":"```elixir\n# Create a simple linear gradient between red and blue\nalias Raxol.Style.Colors.{Color, Gradient}\n\nred = Color.from_hex(\"#FF0000\")\nblue = Color.from_hex(\"#0000FF\")\ngradient = Gradient.linear(red, blue, 10)\n\n# Apply the gradient to text\ncolored_text = Gradient.apply_to_text(gradient, \"Hello, World!\")\n\n# Create a rainbow gradient\nrainbow = Gradient.rainbow(20)\nrainbow_text = Gradient.apply_to_text(rainbow, \"Rainbow Text\")\n\n# Create a multi-stop gradient\ncolors = [\n  Color.from_hex(\"#FF0000\"),  # Red\n  Color.from_hex(\"#FFFF00\"),  # Yellow\n  Color.from_hex(\"#00FF00\")   # Green\n]\nmulti = Gradient.multi_stop(colors, 15)\n```","ref":"Raxol.Style.Colors.Gradient.html#module-examples","title":"Examples - Raxol.Style.Colors.Gradient","type":"module"},{"doc":"Applies a gradient to text, returning an ANSI-formatted string.","ref":"Raxol.Style.Colors.Gradient.html#apply_to_text/2","title":"Raxol.Style.Colors.Gradient.apply_to_text/2","type":"function"},{"doc":"- `gradient` - The gradient to apply\n- `text` - The text to colorize","ref":"Raxol.Style.Colors.Gradient.html#apply_to_text/2-parameters","title":"Parameters - Raxol.Style.Colors.Gradient.apply_to_text/2","type":"function"},{"doc":"iex> red = Raxol.Style.Colors.Color.from_hex(\"#FF0000\")\n    iex> blue = Raxol.Style.Colors.Color.from_hex(\"#0000FF\")\n    iex> gradient = Raxol.Style.Colors.Gradient.linear(red, blue, 5)\n    iex> Raxol.Style.Colors.Gradient.apply_to_text(gradient, \"Hello\")\n    \"\u001B[38;2;255;0;0mH\u001B[0m\u001B[38;2;191;0;64me\u001B[0m\u001B[38;2;128;0;128ml\u001B[0m\u001B[38;2;64;0;191ml\u001B[0m\u001B[38;2;0;0;255mo\u001B[0m\"","ref":"Raxol.Style.Colors.Gradient.html#apply_to_text/2-examples","title":"Examples - Raxol.Style.Colors.Gradient.apply_to_text/2","type":"function"},{"doc":"Gets the color at a specific position in the gradient.","ref":"Raxol.Style.Colors.Gradient.html#at_position/2","title":"Raxol.Style.Colors.Gradient.at_position/2","type":"function"},{"doc":"- `gradient` - The gradient to sample from\n- `position` - A value between 0.0 and 1.0 representing the position in the gradient","ref":"Raxol.Style.Colors.Gradient.html#at_position/2-parameters","title":"Parameters - Raxol.Style.Colors.Gradient.at_position/2","type":"function"},{"doc":"iex> red = Raxol.Style.Colors.Color.from_hex(\"#FF0000\")\n    iex> blue = Raxol.Style.Colors.Color.from_hex(\"#0000FF\")\n    iex> gradient = Raxol.Style.Colors.Gradient.linear(red, blue, 5)\n    iex> color = Raxol.Style.Colors.Gradient.at_position(gradient, 0.5)\n    iex> color.hex\n    \"#800080\"  # Purple (mix of red and blue)","ref":"Raxol.Style.Colors.Gradient.html#at_position/2-examples","title":"Examples - Raxol.Style.Colors.Gradient.at_position/2","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.Gradient.html#t:gradient_type/0","title":"Raxol.Style.Colors.Gradient.gradient_type/0","type":"type"},{"doc":"Creates a heat map gradient from cool to hot colors.","ref":"Raxol.Style.Colors.Gradient.html#heat_map/1","title":"Raxol.Style.Colors.Gradient.heat_map/1","type":"function"},{"doc":"- `steps` - The number of color steps in the heat map","ref":"Raxol.Style.Colors.Gradient.html#heat_map/1-parameters","title":"Parameters - Raxol.Style.Colors.Gradient.heat_map/1","type":"function"},{"doc":"iex> gradient = Raxol.Style.Colors.Gradient.heat_map(5)\n    iex> length(gradient.colors)\n    5","ref":"Raxol.Style.Colors.Gradient.html#heat_map/1-examples","title":"Examples - Raxol.Style.Colors.Gradient.heat_map/1","type":"function"},{"doc":"Creates a linear gradient between two colors.","ref":"Raxol.Style.Colors.Gradient.html#linear/3","title":"Raxol.Style.Colors.Gradient.linear/3","type":"function"},{"doc":"- `start_color` - The starting color\n- `end_color` - The ending color\n- `steps` - The number of color steps in the gradient (including start and end)","ref":"Raxol.Style.Colors.Gradient.html#linear/3-parameters","title":"Parameters - Raxol.Style.Colors.Gradient.linear/3","type":"function"},{"doc":"iex> red = Raxol.Style.Colors.Color.from_hex(\"#FF0000\")\n    iex> blue = Raxol.Style.Colors.Color.from_hex(\"#0000FF\")\n    iex> gradient = Raxol.Style.Colors.Gradient.linear(red, blue, 5)\n    iex> length(gradient.colors)\n    5","ref":"Raxol.Style.Colors.Gradient.html#linear/3-examples","title":"Examples - Raxol.Style.Colors.Gradient.linear/3","type":"function"},{"doc":"Creates a multi-stop gradient with multiple color stops.","ref":"Raxol.Style.Colors.Gradient.html#multi_stop/2","title":"Raxol.Style.Colors.Gradient.multi_stop/2","type":"function"},{"doc":"- `color_stops` - A list of colors to transition between\n- `steps` - The total number of color steps in the gradient","ref":"Raxol.Style.Colors.Gradient.html#multi_stop/2-parameters","title":"Parameters - Raxol.Style.Colors.Gradient.multi_stop/2","type":"function"},{"doc":"iex> colors = [\n    ...>   Raxol.Style.Colors.Color.from_hex(\"#FF0000\"),\n    ...>   Raxol.Style.Colors.Color.from_hex(\"#00FF00\"),\n    ...>   Raxol.Style.Colors.Color.from_hex(\"#0000FF\")\n    ...> ]\n    iex> gradient = Raxol.Style.Colors.Gradient.multi_stop(colors, 10)\n    iex> length(gradient.colors)\n    10","ref":"Raxol.Style.Colors.Gradient.html#multi_stop/2-examples","title":"Examples - Raxol.Style.Colors.Gradient.multi_stop/2","type":"function"},{"doc":"Creates a rainbow gradient with the given number of steps.","ref":"Raxol.Style.Colors.Gradient.html#rainbow/1","title":"Raxol.Style.Colors.Gradient.rainbow/1","type":"function"},{"doc":"- `steps` - The number of color steps in the rainbow","ref":"Raxol.Style.Colors.Gradient.html#rainbow/1-parameters","title":"Parameters - Raxol.Style.Colors.Gradient.rainbow/1","type":"function"},{"doc":"iex> gradient = Raxol.Style.Colors.Gradient.rainbow(6)\n    iex> length(gradient.colors)\n    6","ref":"Raxol.Style.Colors.Gradient.html#rainbow/1-examples","title":"Examples - Raxol.Style.Colors.Gradient.rainbow/1","type":"function"},{"doc":"Reverses the direction of a gradient.","ref":"Raxol.Style.Colors.Gradient.html#reverse/1","title":"Raxol.Style.Colors.Gradient.reverse/1","type":"function"},{"doc":"- `gradient` - The gradient to reverse","ref":"Raxol.Style.Colors.Gradient.html#reverse/1-parameters","title":"Parameters - Raxol.Style.Colors.Gradient.reverse/1","type":"function"},{"doc":"iex> red = Raxol.Style.Colors.Color.from_hex(\"#FF0000\")\n    iex> blue = Raxol.Style.Colors.Color.from_hex(\"#0000FF\")\n    iex> gradient = Raxol.Style.Colors.Gradient.linear(red, blue, 3)\n    iex> reversed = Raxol.Style.Colors.Gradient.reverse(gradient)\n    iex> hd(reversed.colors).hex\n    \"#0000FF\"","ref":"Raxol.Style.Colors.Gradient.html#reverse/1-examples","title":"Examples - Raxol.Style.Colors.Gradient.reverse/1","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.Gradient.html#t:t/0","title":"Raxol.Style.Colors.Gradient.t/0","type":"type"},{"doc":"Alias for apply_to_text/2.","ref":"Raxol.Style.Colors.Gradient.html#to_ansi_sequence/2","title":"Raxol.Style.Colors.Gradient.to_ansi_sequence/2","type":"function"},{"doc":"Provides functions for HSL color space conversions and adjustments.","ref":"Raxol.Style.Colors.HSL.html","title":"Raxol.Style.Colors.HSL","type":"module"},{"doc":"Darkens a color by a specified amount (adjusting Lightness).","ref":"Raxol.Style.Colors.HSL.html#darken/2","title":"Raxol.Style.Colors.HSL.darken/2","type":"function"},{"doc":"- `color` - The color to darken (Color struct)\n- `amount` - The amount to darken by (0.0 to 1.0)","ref":"Raxol.Style.Colors.HSL.html#darken/2-parameters","title":"Parameters - Raxol.Style.Colors.HSL.darken/2","type":"function"},{"doc":"- A Color struct representing the darkened color","ref":"Raxol.Style.Colors.HSL.html#darken/2-returns","title":"Returns - Raxol.Style.Colors.HSL.darken/2","type":"function"},{"doc":"Desaturates a color by a specified amount (adjusting Saturation).","ref":"Raxol.Style.Colors.HSL.html#desaturate/2","title":"Raxol.Style.Colors.HSL.desaturate/2","type":"function"},{"doc":"- `color` - The color to desaturate (Color struct)\n- `amount` - The amount to desaturate by (0.0 to 1.0)","ref":"Raxol.Style.Colors.HSL.html#desaturate/2-parameters","title":"Parameters - Raxol.Style.Colors.HSL.desaturate/2","type":"function"},{"doc":"- A Color struct representing the desaturated color","ref":"Raxol.Style.Colors.HSL.html#desaturate/2-returns","title":"Returns - Raxol.Style.Colors.HSL.desaturate/2","type":"function"},{"doc":"Converts HSL values to RGB.","ref":"Raxol.Style.Colors.HSL.html#hsl_to_rgb/3","title":"Raxol.Style.Colors.HSL.hsl_to_rgb/3","type":"function"},{"doc":"- `h`, `s`, `l` - Hue (0-360), Saturation (0.0-1.0), Lightness (0.0-1.0)","ref":"Raxol.Style.Colors.HSL.html#hsl_to_rgb/3-parameters","title":"Parameters - Raxol.Style.Colors.HSL.hsl_to_rgb/3","type":"function"},{"doc":"- `{r, g, b}` tuple: Red, Green, Blue values (0-255)","ref":"Raxol.Style.Colors.HSL.html#hsl_to_rgb/3-returns","title":"Returns - Raxol.Style.Colors.HSL.hsl_to_rgb/3","type":"function"},{"doc":"Lightens a color by a specified amount (adjusting Lightness).","ref":"Raxol.Style.Colors.HSL.html#lighten/2","title":"Raxol.Style.Colors.HSL.lighten/2","type":"function"},{"doc":"- `color` - The color to lighten (Color struct)\n- `amount` - The amount to lighten by (0.0 to 1.0)","ref":"Raxol.Style.Colors.HSL.html#lighten/2-parameters","title":"Parameters - Raxol.Style.Colors.HSL.lighten/2","type":"function"},{"doc":"- A Color struct representing the lightened color","ref":"Raxol.Style.Colors.HSL.html#lighten/2-returns","title":"Returns - Raxol.Style.Colors.HSL.lighten/2","type":"function"},{"doc":"Converts RGB values to HSL.","ref":"Raxol.Style.Colors.HSL.html#rgb_to_hsl/3","title":"Raxol.Style.Colors.HSL.rgb_to_hsl/3","type":"function"},{"doc":"- `r`, `g`, `b` - Red, Green, Blue values (0-255)","ref":"Raxol.Style.Colors.HSL.html#rgb_to_hsl/3-parameters","title":"Parameters - Raxol.Style.Colors.HSL.rgb_to_hsl/3","type":"function"},{"doc":"- `{h, s, l}` tuple: Hue (0-360), Saturation (0.0-1.0), Lightness (0.0-1.0)","ref":"Raxol.Style.Colors.HSL.html#rgb_to_hsl/3-returns","title":"Returns - Raxol.Style.Colors.HSL.rgb_to_hsl/3","type":"function"},{"doc":"Rotates the hue of a color by a specified number of degrees.","ref":"Raxol.Style.Colors.HSL.html#rotate_hue/2","title":"Raxol.Style.Colors.HSL.rotate_hue/2","type":"function"},{"doc":"- `color` - The color to rotate (Color struct)\n- `degrees` - The number of degrees to rotate (positive or negative)","ref":"Raxol.Style.Colors.HSL.html#rotate_hue/2-parameters","title":"Parameters - Raxol.Style.Colors.HSL.rotate_hue/2","type":"function"},{"doc":"- A Color struct representing the rotated color","ref":"Raxol.Style.Colors.HSL.html#rotate_hue/2-returns","title":"Returns - Raxol.Style.Colors.HSL.rotate_hue/2","type":"function"},{"doc":"Saturates a color by a specified amount (adjusting Saturation).","ref":"Raxol.Style.Colors.HSL.html#saturate/2","title":"Raxol.Style.Colors.HSL.saturate/2","type":"function"},{"doc":"- `color` - The color to saturate (Color struct)\n- `amount` - The amount to saturate by (0.0 to 1.0)","ref":"Raxol.Style.Colors.HSL.html#saturate/2-parameters","title":"Parameters - Raxol.Style.Colors.HSL.saturate/2","type":"function"},{"doc":"- A Color struct representing the saturated color","ref":"Raxol.Style.Colors.HSL.html#saturate/2-returns","title":"Returns - Raxol.Style.Colors.HSL.saturate/2","type":"function"},{"doc":"Provides functions for generating color harmonies based on a base color.","ref":"Raxol.Style.Colors.Harmony.html","title":"Raxol.Style.Colors.Harmony","type":"module"},{"doc":"Generates analogous colors based on the HSL color wheel.\nAnalogous colors are groups of colors that are adjacent to each other on the color wheel.","ref":"Raxol.Style.Colors.Harmony.html#analogous_colors/3","title":"Raxol.Style.Colors.Harmony.analogous_colors/3","type":"function"},{"doc":"- `color`: The base `Color{}` struct.\n- `count`: The number of analogous colors to generate (defaults to 3).\n- `angle`: The angle separation between analogous colors (defaults to 30 degrees).","ref":"Raxol.Style.Colors.Harmony.html#analogous_colors/3-parameters","title":"Parameters - Raxol.Style.Colors.Harmony.analogous_colors/3","type":"function"},{"doc":"A list of `Color{}` structs representing the analogous colors.","ref":"Raxol.Style.Colors.Harmony.html#analogous_colors/3-returns","title":"Returns - Raxol.Style.Colors.Harmony.analogous_colors/3","type":"function"},{"doc":"Generates complementary colors (opposite on the color wheel).\n\nReturns a list containing the base color and its complement.","ref":"Raxol.Style.Colors.Harmony.html#complementary_colors/1","title":"Raxol.Style.Colors.Harmony.complementary_colors/1","type":"function"},{"doc":"- `color` - The base color (Color struct or hex string)","ref":"Raxol.Style.Colors.Harmony.html#complementary_colors/1-parameters","title":"Parameters - Raxol.Style.Colors.Harmony.complementary_colors/1","type":"function"},{"doc":"- A list of two Color structs: `[base_color, complement]`","ref":"Raxol.Style.Colors.Harmony.html#complementary_colors/1-returns","title":"Returns - Raxol.Style.Colors.Harmony.complementary_colors/1","type":"function"},{"doc":"iex> red = Raxol.Style.Colors.Color.from_hex(\"#FF0000\")\n    iex> [red_struct, cyan_struct] = Raxol.Style.Colors.Harmony.complementary_colors(red)\n    iex> cyan_struct.hex\n    \"#00FFFF\"","ref":"Raxol.Style.Colors.Harmony.html#complementary_colors/1-examples","title":"Examples - Raxol.Style.Colors.Harmony.complementary_colors/1","type":"function"},{"doc":"Generates triadic colors (three colors evenly spaced on the color wheel).","ref":"Raxol.Style.Colors.Harmony.html#triadic_colors/1","title":"Raxol.Style.Colors.Harmony.triadic_colors/1","type":"function"},{"doc":"- `color` - The base color (Color struct or hex string)","ref":"Raxol.Style.Colors.Harmony.html#triadic_colors/1-parameters","title":"Parameters - Raxol.Style.Colors.Harmony.triadic_colors/1","type":"function"},{"doc":"- A list of three Color structs","ref":"Raxol.Style.Colors.Harmony.html#triadic_colors/1-returns","title":"Returns - Raxol.Style.Colors.Harmony.triadic_colors/1","type":"function"},{"doc":"iex> red = Raxol.Style.Colors.Color.from_hex(\"#FF0000\")\n    iex> colors = Raxol.Style.Colors.Harmony.triadic_colors(red)\n    iex> length(colors)\n    3\n    # Colors will be red, green, blue (approximately)","ref":"Raxol.Style.Colors.Harmony.html#triadic_colors/1-examples","title":"Examples - Raxol.Style.Colors.Harmony.triadic_colors/1","type":"function"},{"doc":"Provides hot-reloading capabilities for color themes.\n\nThis module watches for changes to theme files and automatically\nreloads them when they change. It also provides a way to subscribe\nto theme change events.","ref":"Raxol.Style.Colors.HotReload.html","title":"Raxol.Style.Colors.HotReload","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Style.Colors.HotReload.html#child_spec/1","title":"Raxol.Style.Colors.HotReload.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.HotReload.html#start_link/1","title":"Raxol.Style.Colors.HotReload.start_link/1","type":"function"},{"doc":"Subscribe to theme change events.","ref":"Raxol.Style.Colors.HotReload.html#subscribe/0","title":"Raxol.Style.Colors.HotReload.subscribe/0","type":"function"},{"doc":"iex> HotReload.subscribe()\n    :ok","ref":"Raxol.Style.Colors.HotReload.html#subscribe/0-examples","title":"Examples - Raxol.Style.Colors.HotReload.subscribe/0","type":"function"},{"doc":"Unsubscribe from theme change events.","ref":"Raxol.Style.Colors.HotReload.html#unsubscribe/0","title":"Raxol.Style.Colors.HotReload.unsubscribe/0","type":"function"},{"doc":"iex> HotReload.unsubscribe()\n    :ok","ref":"Raxol.Style.Colors.HotReload.html#unsubscribe/0-examples","title":"Examples - Raxol.Style.Colors.HotReload.unsubscribe/0","type":"function"},{"doc":"Add a path to watch for theme changes.","ref":"Raxol.Style.Colors.HotReload.html#watch_path/1","title":"Raxol.Style.Colors.HotReload.watch_path/1","type":"function"},{"doc":"- `path` - The path to watch","ref":"Raxol.Style.Colors.HotReload.html#watch_path/1-parameters","title":"Parameters - Raxol.Style.Colors.HotReload.watch_path/1","type":"function"},{"doc":"iex> HotReload.watch_path(\"/path/to/themes\")\n    :ok","ref":"Raxol.Style.Colors.HotReload.html#watch_path/1-examples","title":"Examples - Raxol.Style.Colors.HotReload.watch_path/1","type":"function"},{"doc":"Handles persistence of color themes and user preferences.\n\nThis module provides functionality for:\n- Saving and loading themes\n- Managing user preferences\n- Handling theme file storage","ref":"Raxol.Style.Colors.Persistence.html","title":"Raxol.Style.Colors.Persistence","type":"module"},{"doc":"Deletes a theme.","ref":"Raxol.Style.Colors.Persistence.html#delete_theme/1","title":"Raxol.Style.Colors.Persistence.delete_theme/1","type":"function"},{"doc":"- `theme_name` - The name of the theme to delete","ref":"Raxol.Style.Colors.Persistence.html#delete_theme/1-parameters","title":"Parameters - Raxol.Style.Colors.Persistence.delete_theme/1","type":"function"},{"doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"Raxol.Style.Colors.Persistence.html#delete_theme/1-returns","title":"Returns - Raxol.Style.Colors.Persistence.delete_theme/1","type":"function"},{"doc":"Lists all available themes.","ref":"Raxol.Style.Colors.Persistence.html#list_themes/0","title":"Raxol.Style.Colors.Persistence.list_themes/0","type":"function"},{"doc":"- A list of theme names","ref":"Raxol.Style.Colors.Persistence.html#list_themes/0-returns","title":"Returns - Raxol.Style.Colors.Persistence.list_themes/0","type":"function"},{"doc":"Loads the current theme from user preferences.","ref":"Raxol.Style.Colors.Persistence.html#load_current_theme/0","title":"Raxol.Style.Colors.Persistence.load_current_theme/0","type":"function"},{"doc":"- `{:ok, theme}` on success\n- `{:error, reason}` on failure","ref":"Raxol.Style.Colors.Persistence.html#load_current_theme/0-returns","title":"Returns - Raxol.Style.Colors.Persistence.load_current_theme/0","type":"function"},{"doc":"Loads a theme from a file.","ref":"Raxol.Style.Colors.Persistence.html#load_theme/1","title":"Raxol.Style.Colors.Persistence.load_theme/1","type":"function"},{"doc":"- `theme_name` - The name of the theme to load","ref":"Raxol.Style.Colors.Persistence.html#load_theme/1-parameters","title":"Parameters - Raxol.Style.Colors.Persistence.load_theme/1","type":"function"},{"doc":"- `{:ok, theme}` on success\n- `{:error, reason}` on failure","ref":"Raxol.Style.Colors.Persistence.html#load_theme/1-returns","title":"Returns - Raxol.Style.Colors.Persistence.load_theme/1","type":"function"},{"doc":"Loads user preferences from file.","ref":"Raxol.Style.Colors.Persistence.html#load_user_preferences/0","title":"Raxol.Style.Colors.Persistence.load_user_preferences/0","type":"function"},{"doc":"- `{:ok, preferences}` on success\n- `{:error, reason}` on failure","ref":"Raxol.Style.Colors.Persistence.html#load_user_preferences/0-returns","title":"Returns - Raxol.Style.Colors.Persistence.load_user_preferences/0","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.Persistence.html#map_to_theme_struct/1","title":"Raxol.Style.Colors.Persistence.map_to_theme_struct/1","type":"function"},{"doc":"Saves a theme to a file.","ref":"Raxol.Style.Colors.Persistence.html#save_theme/1","title":"Raxol.Style.Colors.Persistence.save_theme/1","type":"function"},{"doc":"- `theme` - The theme to save","ref":"Raxol.Style.Colors.Persistence.html#save_theme/1-parameters","title":"Parameters - Raxol.Style.Colors.Persistence.save_theme/1","type":"function"},{"doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"Raxol.Style.Colors.Persistence.html#save_theme/1-returns","title":"Returns - Raxol.Style.Colors.Persistence.save_theme/1","type":"function"},{"doc":"Saves user preferences to file.","ref":"Raxol.Style.Colors.Persistence.html#save_user_preferences/1","title":"Raxol.Style.Colors.Persistence.save_user_preferences/1","type":"function"},{"doc":"- `preferences` - The preferences to save","ref":"Raxol.Style.Colors.Persistence.html#save_user_preferences/1-parameters","title":"Parameters - Raxol.Style.Colors.Persistence.save_user_preferences/1","type":"function"},{"doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"Raxol.Style.Colors.Persistence.html#save_user_preferences/1-returns","title":"Returns - Raxol.Style.Colors.Persistence.save_user_preferences/1","type":"function"},{"doc":"Core color system for the Raxol terminal emulator.\n\nThis module provides a robust color system that:\n- Manages color palettes with semantic naming\n- Provides accessible color alternatives for high contrast mode\n- Supports theme customization\n- Calculates contrast ratios for text/background combinations\n- Automatically adjusts colors for optimal readability\n- Integrates with the accessibility module","ref":"Raxol.Style.Colors.System.html","title":"Raxol.Style.Colors.System","type":"module"},{"doc":"```elixir\n# Initialize the color system\nColorSystem.init()\n\n# Get a semantic color (will respect accessibility settings)\ncolor = ColorSystem.get_color(:primary)\n\n# Get a specific color variation\nhover_color = ColorSystem.get_color(:primary, :hover)\n\n# Register a custom theme\nColorSystem.register_theme(%{\n  primary: \"#0077CC\",\n  secondary: \"#00AAFF\",\n  background: \"#001133\",\n  foreground: \"#FFFFFF\",\n  accent: \"#FF9900\"\n})\n\n# Apply a theme\nColorSystem.apply_theme(:ocean)\n```","ref":"Raxol.Style.Colors.System.html#module-usage","title":"Usage - Raxol.Style.Colors.System","type":"module"},{"doc":"","ref":"Raxol.Style.Colors.System.html#adjust_for_contrast/4","title":"Raxol.Style.Colors.System.adjust_for_contrast/4","type":"function"},{"doc":"Applies a theme to the color system.","ref":"Raxol.Style.Colors.System.html#apply_theme/2","title":"Raxol.Style.Colors.System.apply_theme/2","type":"function"},{"doc":"- `theme_name` - The name of the theme to apply\n- `opts` - Additional options\n  - `:high_contrast` - Whether to apply high contrast mode (default: current setting)","ref":"Raxol.Style.Colors.System.html#apply_theme/2-parameters","title":"Parameters - Raxol.Style.Colors.System.apply_theme/2","type":"function"},{"doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"Raxol.Style.Colors.System.html#apply_theme/2-returns","title":"Returns - Raxol.Style.Colors.System.apply_theme/2","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.System.html#create_dark_theme/0","title":"Raxol.Style.Colors.System.create_dark_theme/0","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.System.html#create_high_contrast_theme/0","title":"Raxol.Style.Colors.System.create_high_contrast_theme/0","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.System.html#darken_color/2","title":"Raxol.Style.Colors.System.darken_color/2","type":"function"},{"doc":"Get all UI colors for the current theme as a map of role => color.","ref":"Raxol.Style.Colors.System.html#get_all_ui_colors/0","title":"Raxol.Style.Colors.System.get_all_ui_colors/0","type":"function"},{"doc":"Get all UI colors for a specific theme as a map of role => color.","ref":"Raxol.Style.Colors.System.html#get_all_ui_colors/1","title":"Raxol.Style.Colors.System.get_all_ui_colors/1","type":"function"},{"doc":"Get a color from the current theme.\n\nThis function respects the current accessibility settings, automatically\nreturning high-contrast alternatives when needed.","ref":"Raxol.Style.Colors.System.html#get_color/2","title":"Raxol.Style.Colors.System.get_color/2","type":"function"},{"doc":"* `color_name` - The semantic name of the color (e.g., `:primary`, `:error`)\n* `variant` - The variant of the color (e.g., `:base`, `:hover`, `:active`) (default: `:base`)","ref":"Raxol.Style.Colors.System.html#get_color/2-parameters","title":"Parameters - Raxol.Style.Colors.System.get_color/2","type":"function"},{"doc":"iex> ColorSystem.get_color(:primary)\n    \"#0077CC\"\n\n    iex> ColorSystem.get_color(:primary, :hover)\n    \"#0088DD\"","ref":"Raxol.Style.Colors.System.html#get_color/2-examples","title":"Examples - Raxol.Style.Colors.System.get_color/2","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.System.html#get_current_theme_name/0","title":"Raxol.Style.Colors.System.get_current_theme_name/0","type":"function"},{"doc":"Get a UI color by role (e.g., :primary_button) from the current theme.\nResolves the role using the theme's ui_mappings, then fetches the color.\nReturns nil if the role or color is not found.","ref":"Raxol.Style.Colors.System.html#get_ui_color/1","title":"Raxol.Style.Colors.System.get_ui_color/1","type":"function"},{"doc":"Handle high contrast mode changes from the accessibility module.","ref":"Raxol.Style.Colors.System.html#handle_high_contrast/1","title":"Raxol.Style.Colors.System.handle_high_contrast/1","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.System.html#increase_contrast/1","title":"Raxol.Style.Colors.System.increase_contrast/1","type":"function"},{"doc":"Initialize the color system.\n\nThis sets up the default themes, registers event handlers for accessibility changes,\nand establishes the default color palette.","ref":"Raxol.Style.Colors.System.html#init/1","title":"Raxol.Style.Colors.System.init/1","type":"function"},{"doc":"* `:theme` - The initial theme to use (default: `:default`)\n* `:high_contrast` - Whether to start in high contrast mode (default: from accessibility settings)","ref":"Raxol.Style.Colors.System.html#init/1-options","title":"Options - Raxol.Style.Colors.System.init/1","type":"function"},{"doc":"iex> ColorSystem.init()\n    :ok\n\n    iex> ColorSystem.init(theme: :dark)\n    :ok","ref":"Raxol.Style.Colors.System.html#init/1-examples","title":"Examples - Raxol.Style.Colors.System.init/1","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.System.html#lighten_color/2","title":"Raxol.Style.Colors.System.lighten_color/2","type":"function"},{"doc":"","ref":"Raxol.Style.Colors.System.html#meets_contrast_requirements?/4","title":"Raxol.Style.Colors.System.meets_contrast_requirements?/4","type":"function"},{"doc":"Register a custom theme.","ref":"Raxol.Style.Colors.System.html#register_theme/1","title":"Raxol.Style.Colors.System.register_theme/1","type":"function"},{"doc":"* `theme_attrs` - Map of theme attributes","ref":"Raxol.Style.Colors.System.html#register_theme/1-parameters","title":"Parameters - Raxol.Style.Colors.System.register_theme/1","type":"function"},{"doc":"iex> ColorSystem.register_theme(%{\n    ...>   primary: \"#0077CC\",\n    ...>   secondary: \"#00AAFF\",\n    ...>   background: \"#001133\",\n    ...>   foreground: \"#FFFFFF\",\n    ...>   accent: \"#FF9900\"\n    ...> })\n    :ok","ref":"Raxol.Style.Colors.System.html#register_theme/1-examples","title":"Examples - Raxol.Style.Colors.System.register_theme/1","type":"function"},{"doc":"Shared color utilities for the Raxol color system.\n\nThis module provides common color manipulation and analysis functions,\nincluding contrast calculations, accessibility checks, and color format\nconversions.","ref":"Raxol.Style.Colors.Utilities.html","title":"Raxol.Style.Colors.Utilities","type":"module"},{"doc":"Adjusts a color to meet contrast requirements with another color.","ref":"Raxol.Style.Colors.Utilities.html#adjust_for_contrast/4","title":"Raxol.Style.Colors.Utilities.adjust_for_contrast/4","type":"function"},{"doc":"* `color` - The color to adjust (Color struct or RGB tuple)\n* `background` - The background color (Color struct or RGB tuple)\n* `level` - WCAG level (:A, :AA, or :AAA)\n* `size` - Text size (:normal or :large)","ref":"Raxol.Style.Colors.Utilities.html#adjust_for_contrast/4-parameters","title":"Parameters - Raxol.Style.Colors.Utilities.adjust_for_contrast/4","type":"function"},{"doc":"An adjusted Color struct that meets contrast requirements","ref":"Raxol.Style.Colors.Utilities.html#adjust_for_contrast/4-returns","title":"Returns - Raxol.Style.Colors.Utilities.adjust_for_contrast/4","type":"function"},{"doc":"Returns black or white, whichever has better contrast with the background.","ref":"Raxol.Style.Colors.Utilities.html#best_bw_contrast/2","title":"Raxol.Style.Colors.Utilities.best_bw_contrast/2","type":"function"},{"doc":"Checks if two colors have sufficient contrast according to WCAG guidelines.","ref":"Raxol.Style.Colors.Utilities.html#check_contrast/4","title":"Raxol.Style.Colors.Utilities.check_contrast/4","type":"function"},{"doc":"Calculates the contrast ratio between two colors according to WCAG 2.0.","ref":"Raxol.Style.Colors.Utilities.html#contrast_ratio/2","title":"Raxol.Style.Colors.Utilities.contrast_ratio/2","type":"function"},{"doc":"* `color1` - First color (Color struct or RGB tuple)\n* `color2` - Second color (Color struct or RGB tuple)","ref":"Raxol.Style.Colors.Utilities.html#contrast_ratio/2-parameters","title":"Parameters - Raxol.Style.Colors.Utilities.contrast_ratio/2","type":"function"},{"doc":"A float representing the contrast ratio (1:1 to 21:1)","ref":"Raxol.Style.Colors.Utilities.html#contrast_ratio/2-returns","title":"Returns - Raxol.Style.Colors.Utilities.contrast_ratio/2","type":"function"},{"doc":"Converts HSL values to RGB.","ref":"Raxol.Style.Colors.Utilities.html#hsl_to_rgb/3","title":"Raxol.Style.Colors.Utilities.hsl_to_rgb/3","type":"function"},{"doc":"* `h` - Hue (0-360)\n* `s` - Saturation (0-1)\n* `l` - Lightness (0-1)","ref":"Raxol.Style.Colors.Utilities.html#hsl_to_rgb/3-parameters","title":"Parameters - Raxol.Style.Colors.Utilities.hsl_to_rgb/3","type":"function"},{"doc":"A tuple {r, g, b} where each component is in the range 0-255","ref":"Raxol.Style.Colors.Utilities.html#hsl_to_rgb/3-returns","title":"Returns - Raxol.Style.Colors.Utilities.hsl_to_rgb/3","type":"function"},{"doc":"Increases the contrast of a color by making it more extreme.","ref":"Raxol.Style.Colors.Utilities.html#increase_contrast/1","title":"Raxol.Style.Colors.Utilities.increase_contrast/1","type":"function"},{"doc":"* `color` - The color to increase contrast for (Color struct or RGB tuple)","ref":"Raxol.Style.Colors.Utilities.html#increase_contrast/1-parameters","title":"Parameters - Raxol.Style.Colors.Utilities.increase_contrast/1","type":"function"},{"doc":"A new Color struct with increased contrast","ref":"Raxol.Style.Colors.Utilities.html#increase_contrast/1-returns","title":"Returns - Raxol.Style.Colors.Utilities.increase_contrast/1","type":"function"},{"doc":"Checks if two colors meet WCAG contrast requirements.","ref":"Raxol.Style.Colors.Utilities.html#meets_contrast_requirements?/4","title":"Raxol.Style.Colors.Utilities.meets_contrast_requirements?/4","type":"function"},{"doc":"* `color1` - First color (Color struct or RGB tuple)\n* `color2` - Second color (Color struct or RGB tuple)\n* `level` - WCAG level (:A, :AA, or :AAA)\n* `size` - Text size (:normal or :large)","ref":"Raxol.Style.Colors.Utilities.html#meets_contrast_requirements?/4-parameters","title":"Parameters - Raxol.Style.Colors.Utilities.meets_contrast_requirements?/4","type":"function"},{"doc":"`true` if the contrast meets requirements, `false` otherwise","ref":"Raxol.Style.Colors.Utilities.html#meets_contrast_requirements?/4-returns","title":"Returns - Raxol.Style.Colors.Utilities.meets_contrast_requirements?/4","type":"function"},{"doc":"Calculates the relative luminance of a color according to WCAG 2.0.","ref":"Raxol.Style.Colors.Utilities.html#relative_luminance/1","title":"Raxol.Style.Colors.Utilities.relative_luminance/1","type":"function"},{"doc":"* `color` - A Color struct or RGB tuple","ref":"Raxol.Style.Colors.Utilities.html#relative_luminance/1-parameters","title":"Parameters - Raxol.Style.Colors.Utilities.relative_luminance/1","type":"function"},{"doc":"A float between 0 and 1 representing the relative luminance","ref":"Raxol.Style.Colors.Utilities.html#relative_luminance/1-returns","title":"Returns - Raxol.Style.Colors.Utilities.relative_luminance/1","type":"function"},{"doc":"Converts RGB values to HSL.","ref":"Raxol.Style.Colors.Utilities.html#rgb_to_hsl/3","title":"Raxol.Style.Colors.Utilities.rgb_to_hsl/3","type":"function"},{"doc":"* `r` - Red component (0-255)\n* `g` - Green component (0-255)\n* `b` - Blue component (0-255)","ref":"Raxol.Style.Colors.Utilities.html#rgb_to_hsl/3-parameters","title":"Parameters - Raxol.Style.Colors.Utilities.rgb_to_hsl/3","type":"function"},{"doc":"A tuple {h, s, l} where:\n* h is hue (0-360)\n* s is saturation (0-1)\n* l is lightness (0-1)","ref":"Raxol.Style.Colors.Utilities.html#rgb_to_hsl/3-returns","title":"Returns - Raxol.Style.Colors.Utilities.rgb_to_hsl/3","type":"function"},{"doc":"Handles layout styling for Raxol components.","ref":"Raxol.Style.Layout.html","title":"Raxol.Style.Layout","type":"module"},{"doc":"Gets the alignment from a layout style.","ref":"Raxol.Style.Layout.html#get_alignment/1","title":"Raxol.Style.Layout.get_alignment/1","type":"function"},{"doc":"Gets the border from a layout style.","ref":"Raxol.Style.Layout.html#get_border/1","title":"Raxol.Style.Layout.get_border/1","type":"function"},{"doc":"Gets the display property from a layout style.","ref":"Raxol.Style.Layout.html#get_display/1","title":"Raxol.Style.Layout.get_display/1","type":"function"},{"doc":"Gets the flex properties from a layout style.","ref":"Raxol.Style.Layout.html#get_flex/1","title":"Raxol.Style.Layout.get_flex/1","type":"function"},{"doc":"Gets the grid properties from a layout style.","ref":"Raxol.Style.Layout.html#get_grid/1","title":"Raxol.Style.Layout.get_grid/1","type":"function"},{"doc":"Gets the margin from a layout style.","ref":"Raxol.Style.Layout.html#get_margin/1","title":"Raxol.Style.Layout.get_margin/1","type":"function"},{"doc":"Gets the overflow behavior from a layout style.","ref":"Raxol.Style.Layout.html#get_overflow/1","title":"Raxol.Style.Layout.get_overflow/1","type":"function"},{"doc":"Gets the padding from a layout style.","ref":"Raxol.Style.Layout.html#get_padding/1","title":"Raxol.Style.Layout.get_padding/1","type":"function"},{"doc":"Gets the position from a layout style.","ref":"Raxol.Style.Layout.html#get_position/1","title":"Raxol.Style.Layout.get_position/1","type":"function"},{"doc":"Gets the z-index from a layout style.","ref":"Raxol.Style.Layout.html#get_z_index/1","title":"Raxol.Style.Layout.get_z_index/1","type":"function"},{"doc":"Creates a new layout style with default values.","ref":"Raxol.Style.Layout.html#new/0","title":"Raxol.Style.Layout.new/0","type":"function"},{"doc":"Creates a new layout style with the specified margin.","ref":"Raxol.Style.Layout.html#new/1","title":"Raxol.Style.Layout.new/1","type":"function"},{"doc":"Sets the alignment for a layout style.","ref":"Raxol.Style.Layout.html#set_alignment/2","title":"Raxol.Style.Layout.set_alignment/2","type":"function"},{"doc":"Sets the border for a layout style.","ref":"Raxol.Style.Layout.html#set_border/3","title":"Raxol.Style.Layout.set_border/3","type":"function"},{"doc":"Sets the display property for a layout style.","ref":"Raxol.Style.Layout.html#set_display/2","title":"Raxol.Style.Layout.set_display/2","type":"function"},{"doc":"Sets the flex properties for a layout style.","ref":"Raxol.Style.Layout.html#set_flex/2","title":"Raxol.Style.Layout.set_flex/2","type":"function"},{"doc":"Sets the grid properties for a layout style.","ref":"Raxol.Style.Layout.html#set_grid/2","title":"Raxol.Style.Layout.set_grid/2","type":"function"},{"doc":"Sets the margin for a layout style.","ref":"Raxol.Style.Layout.html#set_margin/2","title":"Raxol.Style.Layout.set_margin/2","type":"function"},{"doc":"Sets the overflow behavior for a layout style.","ref":"Raxol.Style.Layout.html#set_overflow/2","title":"Raxol.Style.Layout.set_overflow/2","type":"function"},{"doc":"Sets the padding for a layout style.","ref":"Raxol.Style.Layout.html#set_padding/2","title":"Raxol.Style.Layout.set_padding/2","type":"function"},{"doc":"Sets the position for a layout style.","ref":"Raxol.Style.Layout.html#set_position/2","title":"Raxol.Style.Layout.set_position/2","type":"function"},{"doc":"Sets the z-index for a layout style.","ref":"Raxol.Style.Layout.html#set_z_index/2","title":"Raxol.Style.Layout.set_z_index/2","type":"function"},{"doc":"","ref":"Raxol.Style.Layout.html#t:t/0","title":"Raxol.Style.Layout.t/0","type":"type"},{"doc":"Provides consolidated access to the system clipboard across different operating systems.\n\nHandles interactions with platform-specific clipboard utilities like `pbcopy`/`pbpaste` (macOS),\n`xclip` (Linux/X11), and `clip`/`powershell Get-Clipboard` (Windows).\n\nRequires `xclip` to be installed on Linux systems using X11.\nWayland clipboard access might require different utilities not currently handled.","ref":"Raxol.System.Clipboard.html","title":"Raxol.System.Clipboard","type":"module"},{"doc":"Copies the given text to the system clipboard.","ref":"Raxol.System.Clipboard.html#copy/1","title":"Raxol.System.Clipboard.copy/1","type":"function"},{"doc":"Retrieves text from the system clipboard.\n\nReturns `{:ok, text}` on success, or `{:error, reason}` on failure.\nAn empty clipboard is considered success and returns `{:ok, \"\"}`.","ref":"Raxol.System.Clipboard.html#paste/0","title":"Raxol.System.Clipboard.paste/0","type":"function"},{"doc":"Handles delta updates for the Raxol terminal emulator.","ref":"Raxol.System.DeltaUpdater.html","title":"Raxol.System.DeltaUpdater","type":"module"},{"doc":"","ref":"Raxol.System.DeltaUpdater.html#apply_delta_update/2","title":"Raxol.System.DeltaUpdater.apply_delta_update/2","type":"function"},{"doc":"","ref":"Raxol.System.DeltaUpdater.html#check_delta_availability/1","title":"Raxol.System.DeltaUpdater.check_delta_availability/1","type":"function"},{"doc":"Behaviour for a system adapter used by DeltaUpdater.\n\nThis module defines the contract for functions that interact with the system,\nallowing for different implementations (e.g., a real one and a mock for tests).","ref":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.html","title":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour","type":"behaviour"},{"doc":"Gets the current version string.","ref":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.html#c:current_version/0","title":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.current_version/0","type":"callback"},{"doc":"Changes the mode of a file.\nMirrors `File.chmod!/2` or `File.chmod/2`.","ref":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.html#c:file_chmod/2","title":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.file_chmod/2","type":"callback"},{"doc":"Creates a directory, including any necessary parent directories.\nMirrors `File.mkdir_p!/1` or `File.mkdir_p/1`.","ref":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.html#c:file_mkdir_p/1","title":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.file_mkdir_p/1","type":"callback"},{"doc":"Removes a file or directory recursively.\nMirrors `File.rm_rf!/1` or `File.rm_rf/1`.","ref":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.html#c:file_rm_rf/1","title":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.file_rm_rf/1","type":"callback"},{"doc":"Performs a simple HTTP GET request and returns the body as a string.","ref":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.html#c:http_get/1","title":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.http_get/1","type":"callback"},{"doc":"Performs an HTTP request.\nMirrors `:httpc.request/4` or similar functionality.\n`method` is an atom e.g. `:get`, `:post`.\n`url_with_headers` is typically `{charlist_url, list_of_headers}`.\n`http_options` and `stream_options` are keyword lists or lists of tuples.","ref":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.html#c:httpc_request/4","title":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.httpc_request/4","type":"callback"},{"doc":"Gets the operating system type.\nMirrors `:os.type/0`.","ref":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.html#c:os_type/0","title":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.os_type/0","type":"callback"},{"doc":"Gets the command-line arguments passed to the program.\nMirrors `System.argv/0`.","ref":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.html#c:system_argv/0","title":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.system_argv/0","type":"callback"},{"doc":"Executes a system command.\nMirrors `System.cmd/3`.\nOptions can include e.g. `:stderr_to_stdout`.","ref":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.html#c:system_cmd/3","title":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.system_cmd/3","type":"callback"},{"doc":"Gets the value of an environment variable.\nMirrors `System.get_env/1`.","ref":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.html#c:system_get_env/1","title":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.system_get_env/1","type":"callback"},{"doc":"Gets the path to the system's temporary directory.\nMirrors `System.tmp_dir!/0` or `System.tmp_dir/0`.","ref":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.html#c:system_tmp_dir/0","title":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.system_tmp_dir/0","type":"callback"},{"doc":"Replaces the current executable with a new one.\nThis abstracts the call to `Raxol.System.Updater.do_replace_executable/3`.","ref":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.html#c:updater_do_replace_executable/3","title":"Raxol.System.DeltaUpdaterSystemAdapterBehaviour.updater_do_replace_executable/3","type":"callback"},{"doc":"","ref":"Raxol.System.DeltaUpdaterSystemAdapterImpl.html","title":"Raxol.System.DeltaUpdaterSystemAdapterImpl","type":"module"},{"doc":"A behaviour for abstracting system environment interactions.","ref":"Raxol.System.EnvironmentAdapterBehaviour.html","title":"Raxol.System.EnvironmentAdapterBehaviour","type":"behaviour"},{"doc":"","ref":"Raxol.System.EnvironmentAdapterBehaviour.html#c:cmd/3","title":"Raxol.System.EnvironmentAdapterBehaviour.cmd/3","type":"callback"},{"doc":"","ref":"Raxol.System.EnvironmentAdapterBehaviour.html#c:get_env/1","title":"Raxol.System.EnvironmentAdapterBehaviour.get_env/1","type":"callback"},{"doc":"Concrete implementation of EnvironmentAdapterBehaviour using Elixir's System module.","ref":"Raxol.System.EnvironmentAdapterImpl.html","title":"Raxol.System.EnvironmentAdapterImpl","type":"module"},{"doc":"Behaviour for abstracting system interactions like running commands,\nfinding executables, and getting OS type. Allows for easier testing.","ref":"Raxol.System.Interaction.html","title":"Raxol.System.Interaction","type":"behaviour"},{"doc":"Finds the full path to an executable. Returns `nil` if not found.","ref":"Raxol.System.Interaction.html#c:find_executable/1","title":"Raxol.System.Interaction.find_executable/1","type":"callback"},{"doc":"Returns the OS type.","ref":"Raxol.System.Interaction.html#c:get_os_type/0","title":"Raxol.System.Interaction.get_os_type/0","type":"callback"},{"doc":"","ref":"Raxol.System.Interaction.html#t:os_type/0","title":"Raxol.System.Interaction.os_type/0","type":"type"},{"doc":"Executes a system command.\nReturns `{output, exit_status}` on success.\nCan raise exceptions on errors depending on the implementation.\nOptions can be passed to control execution (e.g., `stderr_to_stdout`).","ref":"Raxol.System.Interaction.html#c:system_cmd/3","title":"Raxol.System.Interaction.system_cmd/3","type":"callback"},{"doc":"Concrete implementation of the System.Interaction behaviour using standard Elixir/Erlang functions.","ref":"Raxol.System.InteractionImpl.html","title":"Raxol.System.InteractionImpl","type":"module"},{"doc":"Platform-specific functionality and detection for Raxol.\n\nThis module handles detection of the current platform, providing platform-specific\ninformation, and managing platform-dependent operations.","ref":"Raxol.System.Platform.html","title":"Raxol.System.Platform","type":"module"},{"doc":"Returns the current platform as an atom.","ref":"Raxol.System.Platform.html#get_current_platform/0","title":"Raxol.System.Platform.get_current_platform/0","type":"function"},{"doc":"* `:macos` - macOS (Darwin)\n* `:linux` - Linux variants\n* `:windows` - Windows","ref":"Raxol.System.Platform.html#get_current_platform/0-returns","title":"Returns - Raxol.System.Platform.get_current_platform/0","type":"function"},{"doc":"iex> Platform.get_current_platform()\n    :macos","ref":"Raxol.System.Platform.html#get_current_platform/0-examples","title":"Examples - Raxol.System.Platform.get_current_platform/0","type":"function"},{"doc":"Returns the executable name for the current platform.","ref":"Raxol.System.Platform.html#get_executable_name/0","title":"Raxol.System.Platform.get_executable_name/0","type":"function"},{"doc":"* `\"raxol.exe\"` - Windows platforms\n* `\"raxol\"` - Unix platforms (macOS, Linux)","ref":"Raxol.System.Platform.html#get_executable_name/0-returns","title":"Returns - Raxol.System.Platform.get_executable_name/0","type":"function"},{"doc":"iex> Platform.get_executable_name()\n    \"raxol\"","ref":"Raxol.System.Platform.html#get_executable_name/0-examples","title":"Examples - Raxol.System.Platform.get_executable_name/0","type":"function"},{"doc":"Returns the file extension for the current platform.","ref":"Raxol.System.Platform.html#get_platform_extension/0","title":"Raxol.System.Platform.get_platform_extension/0","type":"function"},{"doc":"* `\"zip\"` - Windows platforms\n* `\"tar.gz\"` - Unix platforms (macOS, Linux)","ref":"Raxol.System.Platform.html#get_platform_extension/0-returns","title":"Returns - Raxol.System.Platform.get_platform_extension/0","type":"function"},{"doc":"iex> Platform.get_platform_extension()\n    \"tar.gz\"","ref":"Raxol.System.Platform.html#get_platform_extension/0-examples","title":"Examples - Raxol.System.Platform.get_platform_extension/0","type":"function"},{"doc":"Gathers detailed information about the current platform.","ref":"Raxol.System.Platform.html#get_platform_info/0","title":"Raxol.System.Platform.get_platform_info/0","type":"function"},{"doc":"A map containing platform details including:\n\n* `:name` - Platform name (e.g., \"macOS\", \"Linux\", \"Windows\")\n* `:version` - OS version if available\n* `:architecture` - CPU architecture (e.g., \"x86_64\", \"arm64\")\n* `:terminal` - Current terminal information if available","ref":"Raxol.System.Platform.html#get_platform_info/0-returns","title":"Returns - Raxol.System.Platform.get_platform_info/0","type":"function"},{"doc":"iex> Platform.get_platform_info()\n    %{\n      name: \"macOS\",\n      version: \"12.6\",\n      architecture: \"arm64\",\n      terminal: \"iTerm.app\"\n    }","ref":"Raxol.System.Platform.html#get_platform_info/0-examples","title":"Examples - Raxol.System.Platform.get_platform_info/0","type":"function"},{"doc":"Returns the platform name as a string.","ref":"Raxol.System.Platform.html#get_platform_name/0","title":"Raxol.System.Platform.get_platform_name/0","type":"function"},{"doc":"* `\"macos\"` - macOS (Darwin)\n* `\"linux\"` - Linux variants\n* `\"windows\"` - Windows","ref":"Raxol.System.Platform.html#get_platform_name/0-returns","title":"Returns - Raxol.System.Platform.get_platform_name/0","type":"function"},{"doc":"iex> Platform.get_platform_name()\n    \"macos\"","ref":"Raxol.System.Platform.html#get_platform_name/0-examples","title":"Examples - Raxol.System.Platform.get_platform_name/0","type":"function"},{"doc":"Detects if the feature is supported on the current platform.","ref":"Raxol.System.Platform.html#supports_feature?/1","title":"Raxol.System.Platform.supports_feature?/1","type":"function"},{"doc":"* `feature` - Feature name as an atom (e.g., `:true_color`, `:unicode`, `:mouse`)","ref":"Raxol.System.Platform.html#supports_feature?/1-parameters","title":"Parameters - Raxol.System.Platform.supports_feature?/1","type":"function"},{"doc":"* `true` - Feature is supported on the current platform\n* `false` - Feature is not supported or support is uncertain","ref":"Raxol.System.Platform.html#supports_feature?/1-returns","title":"Returns - Raxol.System.Platform.supports_feature?/1","type":"function"},{"doc":"iex> Platform.supports_feature?(:true_color)\n    true","ref":"Raxol.System.Platform.html#supports_feature?/1-examples","title":"Examples - Raxol.System.Platform.supports_feature?/1","type":"function"},{"doc":"Terminal-specific platform features and compatibility checks.\n\nThis module provides detailed information about terminal capabilities,\nfeature support, and compatibility across different platforms and terminal emulators.","ref":"Raxol.System.TerminalPlatform.html","title":"Raxol.System.TerminalPlatform","type":"module"},{"doc":"Returns the list of all supported terminal features.","ref":"Raxol.System.TerminalPlatform.html#get_supported_features/0","title":"Raxol.System.TerminalPlatform.get_supported_features/0","type":"function"},{"doc":"List of supported feature atoms.","ref":"Raxol.System.TerminalPlatform.html#get_supported_features/0-returns","title":"Returns - Raxol.System.TerminalPlatform.get_supported_features/0","type":"function"},{"doc":"iex> TerminalPlatform.get_supported_features()\n    [:true_color, :unicode, :mouse, :clipboard]","ref":"Raxol.System.TerminalPlatform.html#get_supported_features/0-examples","title":"Examples - Raxol.System.TerminalPlatform.get_supported_features/0","type":"function"},{"doc":"Returns detailed information about the current terminal's capabilities.","ref":"Raxol.System.TerminalPlatform.html#get_terminal_capabilities/0","title":"Raxol.System.TerminalPlatform.get_terminal_capabilities/0","type":"function"},{"doc":"A map containing terminal capabilities including:\n\n* `:name` - Terminal name/type\n* `:version` - Terminal version if available\n* `:features` - List of supported features\n* `:colors` - Color support information\n* `:unicode` - Unicode support details\n* `:input` - Input capabilities\n* `:output` - Output capabilities","ref":"Raxol.System.TerminalPlatform.html#get_terminal_capabilities/0-returns","title":"Returns - Raxol.System.TerminalPlatform.get_terminal_capabilities/0","type":"function"},{"doc":"iex> TerminalPlatform.get_terminal_capabilities()\n    %{\n      name: \"iTerm2\",\n      version: \"3.5.0\",\n      features: [:true_color, :unicode, :mouse, :clipboard],\n      colors: %{\n        basic: true,\n        true_color: true,\n        palette: \"default\"\n      },\n      unicode: %{\n        support: true,\n        width: :ambiguous,\n        emoji: true\n      },\n      input: %{\n        mouse: true,\n        bracketed_paste: true,\n        focus: true\n      },\n      output: %{\n        title: true,\n        bell: true,\n        alternate_screen: true\n      }\n    }","ref":"Raxol.System.TerminalPlatform.html#get_terminal_capabilities/0-examples","title":"Examples - Raxol.System.TerminalPlatform.get_terminal_capabilities/0","type":"function"},{"doc":"Checks if a specific terminal feature is supported.","ref":"Raxol.System.TerminalPlatform.html#supports_feature?/1","title":"Raxol.System.TerminalPlatform.supports_feature?/1","type":"function"},{"doc":"* `feature` - Feature to check for support","ref":"Raxol.System.TerminalPlatform.html#supports_feature?/1-parameters","title":"Parameters - Raxol.System.TerminalPlatform.supports_feature?/1","type":"function"},{"doc":"* `true` - Feature is supported\n* `false` - Feature is not supported","ref":"Raxol.System.TerminalPlatform.html#supports_feature?/1-returns","title":"Returns - Raxol.System.TerminalPlatform.supports_feature?/1","type":"function"},{"doc":"iex> TerminalPlatform.supports_feature?(:true_color)\n    true","ref":"Raxol.System.TerminalPlatform.html#supports_feature?/1-examples","title":"Examples - Raxol.System.TerminalPlatform.supports_feature?/1","type":"function"},{"doc":"","ref":"Raxol.System.TerminalPlatform.html#t:terminal_feature/0","title":"Raxol.System.TerminalPlatform.terminal_feature/0","type":"type"},{"doc":"Provides version management and self-update functionality for Raxol.\n\nThis module handles:\n- Checking for updates from GitHub releases\n- Comparing versions to determine if updates are available\n- Self-updating the application when running as a compiled binary\n- Managing update settings and configurations","ref":"Raxol.System.Updater.html","title":"Raxol.System.Updater","type":"module"},{"doc":"","ref":"Raxol.System.Updater.html#cancel_update/0","title":"Raxol.System.Updater.cancel_update/0","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#check_for_updates/0","title":"Raxol.System.Updater.check_for_updates/0","type":"function"},{"doc":"Checks if a newer version of Raxol is available.\n\nReturns a tuple with the check result and the latest version if available:\n- `{:no_update, current_version}` - No update available\n- `{:update_available, latest_version}` - Update available\n- `{:error, reason}` - Error occurred during check","ref":"Raxol.System.Updater.html#check_for_updates/1","title":"Raxol.System.Updater.check_for_updates/1","type":"function"},{"doc":"- `force`: When set to `true`, bypasses the update check interval. Defaults to `false`.","ref":"Raxol.System.Updater.html#check_for_updates/1-parameters","title":"Parameters - Raxol.System.Updater.check_for_updates/1","type":"function"},{"doc":"iex> Raxol.System.Updater.check_for_updates()\n    {:no_update, \"0.1.0\"}\n\n    iex> Raxol.System.Updater.check_for_updates(force: true)\n    {:update_available, \"0.2.0\"}","ref":"Raxol.System.Updater.html#check_for_updates/1-examples","title":"Examples - Raxol.System.Updater.check_for_updates/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.System.Updater.html#child_spec/1","title":"Raxol.System.Updater.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#clear_update_error/0","title":"Raxol.System.Updater.clear_update_error/0","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#clear_update_history/0","title":"Raxol.System.Updater.clear_update_history/0","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#clear_update_log/0","title":"Raxol.System.Updater.clear_update_log/0","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#clear_update_stats/0","title":"Raxol.System.Updater.clear_update_stats/0","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#do_replace_executable/3","title":"Raxol.System.Updater.do_replace_executable/3","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#download_update/1","title":"Raxol.System.Updater.download_update/1","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#get_available_versions/0","title":"Raxol.System.Updater.get_available_versions/0","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#get_current_version/0","title":"Raxol.System.Updater.get_current_version/0","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#get_update_error/0","title":"Raxol.System.Updater.get_update_error/0","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#get_update_history/0","title":"Raxol.System.Updater.get_update_history/0","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#get_update_log/0","title":"Raxol.System.Updater.get_update_log/0","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#get_update_progress/0","title":"Raxol.System.Updater.get_update_progress/0","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#get_update_settings/0","title":"Raxol.System.Updater.get_update_settings/0","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#get_update_stats/0","title":"Raxol.System.Updater.get_update_stats/0","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#install_update/2","title":"Raxol.System.Updater.install_update/2","type":"function"},{"doc":"Displays update information to the user, if an update is available.\n\nThis function checks for updates (respecting the check interval) and\noutputs a message to the user if an update is available.","ref":"Raxol.System.Updater.html#notify_if_update_available/0","title":"Raxol.System.Updater.notify_if_update_available/0","type":"function"},{"doc":"iex> Raxol.System.Updater.notify_if_update_available()\n    :ok","ref":"Raxol.System.Updater.html#notify_if_update_available/0-examples","title":"Examples - Raxol.System.Updater.notify_if_update_available/0","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#rollback_update/0","title":"Raxol.System.Updater.rollback_update/0","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#self_update/2","title":"Raxol.System.Updater.self_update/2","type":"function"},{"doc":"Enables or disables automatic update checks.","ref":"Raxol.System.Updater.html#set_auto_check/1","title":"Raxol.System.Updater.set_auto_check/1","type":"function"},{"doc":"- `enabled`: Whether to enable or disable automatic update checks","ref":"Raxol.System.Updater.html#set_auto_check/1-parameters","title":"Parameters - Raxol.System.Updater.set_auto_check/1","type":"function"},{"doc":"iex> Raxol.System.Updater.set_auto_check(true)\n    :ok\n\n    iex> Raxol.System.Updater.set_auto_check(false)\n    :ok","ref":"Raxol.System.Updater.html#set_auto_check/1-examples","title":"Examples - Raxol.System.Updater.set_auto_check/1","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#set_update_settings/1","title":"Raxol.System.Updater.set_update_settings/1","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#start_link/1","title":"Raxol.System.Updater.start_link/1","type":"function"},{"doc":"","ref":"Raxol.System.Updater.html#update/1","title":"Raxol.System.Updater.update/1","type":"function"},{"doc":"This module serves as a documentation reference for the ANSI terminal functionality.\n\nThe functionality has been organized into smaller, more focused modules:\n\n- Raxol.Terminal.ANSI.Parser - For parsing ANSI sequences\n- Raxol.Terminal.ANSI.Emitter - For generating ANSI sequences\n- Raxol.Terminal.ANSI.Processor - For processing ANSI sequences\n- Raxol.Terminal.ANSI.Sequences.{Cursor, Colors, Modes} - For specific sequence types\n- Raxol.Terminal.ANSI.TextFormatting - For text formatting and styling\n- Raxol.Terminal.ANSI.CharacterSets - For character set handling\n- Raxol.Terminal.ANSI.TerminalState - For terminal state management\n\nThis module itself does not contain any functionality - it exists solely as a documentation\nreference to help developers find the appropriate specialized modules for their needs.","ref":"Raxol.Terminal.ANSI.html","title":"Raxol.Terminal.ANSI","type":"module"},{"doc":"Provides benchmarking capabilities for the ANSI handling system.\nMeasures performance of parsing and processing ANSI sequences.","ref":"Raxol.Terminal.ANSI.Benchmark.html","title":"Raxol.Terminal.ANSI.Benchmark","type":"module"},{"doc":"Benchmarks the parsing performance with various ANSI sequences.","ref":"Raxol.Terminal.ANSI.Benchmark.html#benchmark_parsing/0","title":"Raxol.Terminal.ANSI.Benchmark.benchmark_parsing/0","type":"function"},{"doc":"Benchmarks the processing performance with various ANSI sequences.","ref":"Raxol.Terminal.ANSI.Benchmark.html#benchmark_processing/0","title":"Raxol.Terminal.ANSI.Benchmark.benchmark_processing/0","type":"function"},{"doc":"Benchmarks the state machine performance with various inputs.","ref":"Raxol.Terminal.ANSI.Benchmark.html#benchmark_state_machine/0","title":"Raxol.Terminal.ANSI.Benchmark.benchmark_state_machine/0","type":"function"},{"doc":"Runs a benchmark suite on the ANSI handling system.\nReturns a map of benchmark results.","ref":"Raxol.Terminal.ANSI.Benchmark.html#run_benchmark/0","title":"Raxol.Terminal.ANSI.Benchmark.run_benchmark/0","type":"function"},{"doc":"Manages character set switching and translation for the terminal emulator.\nSupports G0, G1, G2, G3 character sets and their switching operations.","ref":"Raxol.Terminal.ANSI.CharacterSets.html","title":"Raxol.Terminal.ANSI.CharacterSets","type":"module"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.html#t:charset/0","title":"Raxol.Terminal.ANSI.CharacterSets.charset/0","type":"type"},{"doc":"Map character code byte to charset atom (Based on escape_sequence.ex).\nPublic for use in tests and other modules.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#charset_code_to_atom/1","title":"Raxol.Terminal.ANSI.CharacterSets.charset_code_to_atom/1","type":"function"},{"doc":"Map character code byte to charset module.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#charset_code_to_module/1","title":"Raxol.Terminal.ANSI.CharacterSets.charset_code_to_module/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.html#t:charset_state/0","title":"Raxol.Terminal.ANSI.CharacterSets.charset_state/0","type":"type"},{"doc":"Clears any active single shift. This should be called after processing\na character that was interpreted using a single-shifted charset.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#clear_single_shift/1","title":"Raxol.Terminal.ANSI.CharacterSets.clear_single_shift/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.html#t:codepoint/0","title":"Raxol.Terminal.ANSI.CharacterSets.codepoint/0","type":"type"},{"doc":"Delegates to Handler.designate_charset/3 for designating a character set for a specific G-set.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#designate_charset/3","title":"Raxol.Terminal.ANSI.CharacterSets.designate_charset/3","type":"function"},{"doc":"Gets the active character set based on the current state.\nNote: This function does not consume an active single shift.\nThe caller is responsible for calling clear_single_shift after processing\nthe character if a single shift was active.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#get_active_charset/1","title":"Raxol.Terminal.ANSI.CharacterSets.get_active_charset/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.html#t:gl_gr_target/0","title":"Raxol.Terminal.ANSI.CharacterSets.gl_gr_target/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.html#t:gset_name/0","title":"Raxol.Terminal.ANSI.CharacterSets.gset_name/0","type":"type"},{"doc":"Map G-set index (0-3) to map key (:g0-:g3).\nPublic for use in tests and other modules.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#index_to_gset/1","title":"Raxol.Terminal.ANSI.CharacterSets.index_to_gset/1","type":"function"},{"doc":"Invokes a character set designator into GL or GR.\nBy default, invokes into GL (left). If the second argument is :gr, invokes into GR (right).","ref":"Raxol.Terminal.ANSI.CharacterSets.html#invoke_designator/3","title":"Raxol.Terminal.ANSI.CharacterSets.invoke_designator/3","type":"function"},{"doc":"Creates a new character set state with default values.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#new/0","title":"Raxol.Terminal.ANSI.CharacterSets.new/0","type":"function"},{"doc":"Sets the active character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#set_active/2","title":"Raxol.Terminal.ANSI.CharacterSets.set_active/2","type":"function"},{"doc":"Sets the character set designator.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#set_designator/3","title":"Raxol.Terminal.ANSI.CharacterSets.set_designator/3","type":"function"},{"doc":"Sets the GL (left) character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#set_gl/2","title":"Raxol.Terminal.ANSI.CharacterSets.set_gl/2","type":"function"},{"doc":"Sets the GR (right) character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#set_gr/2","title":"Raxol.Terminal.ANSI.CharacterSets.set_gr/2","type":"function"},{"doc":"Sets the locking shift character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#set_locking_shift/2","title":"Raxol.Terminal.ANSI.CharacterSets.set_locking_shift/2","type":"function"},{"doc":"Activates a single shift for the next character.\nSS2 invokes the G2 character set.\nSS3 invokes the G3 character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#set_single_shift/2","title":"Raxol.Terminal.ANSI.CharacterSets.set_single_shift/2","type":"function"},{"doc":"Switches the specified character set to the given charset.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#switch_charset/3","title":"Raxol.Terminal.ANSI.CharacterSets.switch_charset/3","type":"function"},{"doc":"Character set state struct for terminal emulation (G0-G3, GL/GR, single/locked shift).","ref":"Raxol.Terminal.ANSI.CharacterSets.html#t:t/0","title":"Raxol.Terminal.ANSI.CharacterSets.t/0","type":"type"},{"doc":"Translates a character using the active character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#translate_char/2","title":"Raxol.Terminal.ANSI.CharacterSets.translate_char/2","type":"function"},{"doc":"Translates a string using the active character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.html#translate_string/2","title":"Raxol.Terminal.ANSI.CharacterSets.translate_string/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.ASCII.html","title":"Raxol.Terminal.ANSI.CharacterSets.ASCII","type":"module"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.ASCII.html#translate_char/1","title":"Raxol.Terminal.ANSI.CharacterSets.ASCII.translate_char/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.ASCII.html#translate_string/1","title":"Raxol.Terminal.ANSI.CharacterSets.ASCII.translate_string/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.DEC.html","title":"Raxol.Terminal.ANSI.CharacterSets.DEC","type":"module"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.DEC.html#translate_char/1","title":"Raxol.Terminal.ANSI.CharacterSets.DEC.translate_char/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.DEC.html#translate_string/1","title":"Raxol.Terminal.ANSI.CharacterSets.DEC.translate_string/1","type":"function"},{"doc":"Handles character set control sequences and state changes.","ref":"Raxol.Terminal.ANSI.CharacterSets.Handler.html","title":"Raxol.Terminal.ANSI.CharacterSets.Handler","type":"module"},{"doc":"Designates a character set for a specific G-set.","ref":"Raxol.Terminal.ANSI.CharacterSets.Handler.html#designate_charset/3","title":"Raxol.Terminal.ANSI.CharacterSets.Handler.designate_charset/3","type":"function"},{"doc":"Handles a character set control sequence.","ref":"Raxol.Terminal.ANSI.CharacterSets.Handler.html#handle_sequence/2","title":"Raxol.Terminal.ANSI.CharacterSets.Handler.handle_sequence/2","type":"function"},{"doc":"Invokes a character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.Handler.html#invoke_charset/2","title":"Raxol.Terminal.ANSI.CharacterSets.Handler.invoke_charset/2","type":"function"},{"doc":"Sets a locking shift character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.Handler.html#set_locking_shift/2","title":"Raxol.Terminal.ANSI.CharacterSets.Handler.set_locking_shift/2","type":"function"},{"doc":"Sets a single shift character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.Handler.html#set_single_shift/2","title":"Raxol.Terminal.ANSI.CharacterSets.Handler.set_single_shift/2","type":"function"},{"doc":"Manages character set state and operations.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager","type":"module"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#t:charset/0","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.charset/0","type":"type"},{"doc":"Converts a character set code to an atom.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#charset_code_to_atom/1","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.charset_code_to_atom/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#t:charset_state/0","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.charset_state/0","type":"type"},{"doc":"Clears the single shift character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#clear_single_shift/1","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.clear_single_shift/1","type":"function"},{"doc":"Gets the active character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#get_active/1","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.get_active/1","type":"function"},{"doc":"Gets the active GR character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#get_active_gr/1","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.get_active_gr/1","type":"function"},{"doc":"Gets the active G-set character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#get_active_gset/1","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.get_active_gset/1","type":"function"},{"doc":"Gets the charset state from the emulator state.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#get_charset_state/1","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.get_charset_state/1","type":"function"},{"doc":"Gets the GL (left) character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#get_gl/1","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.get_gl/1","type":"function"},{"doc":"Gets the GR (right) character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#get_gr/1","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.get_gr/1","type":"function"},{"doc":"Gets a G-set character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#get_gset/2","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.get_gset/2","type":"function"},{"doc":"Gets the mode manager from the emulator state.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#get_mode_manager/1","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.get_mode_manager/1","type":"function"},{"doc":"Gets the single shift character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#get_single_shift/1","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.get_single_shift/1","type":"function"},{"doc":"Converts a G-set index to an atom.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#index_to_gset/1","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.index_to_gset/1","type":"function"},{"doc":"Creates a new character set state with default values.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#new/0","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.new/0","type":"function"},{"doc":"Sets the active character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#set_active/2","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.set_active/2","type":"function"},{"doc":"Sets the GL (left) character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#set_gl/2","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.set_gl/2","type":"function"},{"doc":"Sets the GR (right) character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#set_gr/2","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.set_gr/2","type":"function"},{"doc":"Sets a G-set character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#set_gset/3","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.set_gset/3","type":"function"},{"doc":"Sets the single shift character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#set_single_shift/2","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.set_single_shift/2","type":"function"},{"doc":"Updates the charset state in the emulator state.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#update_charset_state/2","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.update_charset_state/2","type":"function"},{"doc":"Updates the mode manager in the emulator state.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#update_mode_manager/2","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.update_mode_manager/2","type":"function"},{"doc":"Validates a character set state.\nReturns :ok if valid, or {:error, reason} if invalid.","ref":"Raxol.Terminal.ANSI.CharacterSets.StateManager.html#validate_state/1","title":"Raxol.Terminal.ANSI.CharacterSets.StateManager.validate_state/1","type":"function"},{"doc":"Handles character set translations and mappings.","ref":"Raxol.Terminal.ANSI.CharacterSets.Translator.html","title":"Raxol.Terminal.ANSI.CharacterSets.Translator","type":"module"},{"doc":"Translates a character using the active character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.Translator.html#translate_char/3","title":"Raxol.Terminal.ANSI.CharacterSets.Translator.translate_char/3","type":"function"},{"doc":"Translates a string using the active character set.","ref":"Raxol.Terminal.ANSI.CharacterSets.Translator.html#translate_string/3","title":"Raxol.Terminal.ANSI.CharacterSets.Translator.translate_string/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.UK.html","title":"Raxol.Terminal.ANSI.CharacterSets.UK","type":"module"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.UK.html#translate_char/1","title":"Raxol.Terminal.ANSI.CharacterSets.UK.translate_char/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.CharacterSets.UK.html#translate_string/1","title":"Raxol.Terminal.ANSI.CharacterSets.UK.translate_string/1","type":"function"},{"doc":"Provides character translation tables for different character sets.\nMaps characters between different character sets according to ANSI standards.","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html","title":"Raxol.Terminal.ANSI.CharacterTranslations","type":"module"},{"doc":"Returns the DEC Special Graphics character set translation table.","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#dec_special/0","title":"Raxol.Terminal.ANSI.CharacterTranslations.dec_special/0","type":"function"},{"doc":"* Map containing DEC Special Graphics character translations","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#dec_special/0-returns","title":"Returns - Raxol.Terminal.ANSI.CharacterTranslations.dec_special/0","type":"function"},{"doc":"iex> Raxol.Terminal.ANSI.CharacterTranslations.dec_special()\n    %{...}","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#dec_special/0-examples","title":"Examples - Raxol.Terminal.ANSI.CharacterTranslations.dec_special/0","type":"function"},{"doc":"Returns the DEC Supplementary character set translation table.","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#dec_supplementary/0","title":"Raxol.Terminal.ANSI.CharacterTranslations.dec_supplementary/0","type":"function"},{"doc":"* Map containing DEC Supplementary character translations","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#dec_supplementary/0-returns","title":"Returns - Raxol.Terminal.ANSI.CharacterTranslations.dec_supplementary/0","type":"function"},{"doc":"iex> Raxol.Terminal.ANSI.CharacterTranslations.dec_supplementary()\n    %{...}","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#dec_supplementary/0-examples","title":"Examples - Raxol.Terminal.ANSI.CharacterTranslations.dec_supplementary/0","type":"function"},{"doc":"Returns the DEC Supplementary Graphics character set translation table.","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#dec_supplementary_graphics/0","title":"Raxol.Terminal.ANSI.CharacterTranslations.dec_supplementary_graphics/0","type":"function"},{"doc":"* Map containing DEC Supplementary Graphics character translations","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#dec_supplementary_graphics/0-returns","title":"Returns - Raxol.Terminal.ANSI.CharacterTranslations.dec_supplementary_graphics/0","type":"function"},{"doc":"iex> Raxol.Terminal.ANSI.CharacterTranslations.dec_supplementary_graphics()\n    %{...}","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#dec_supplementary_graphics/0-examples","title":"Examples - Raxol.Terminal.ANSI.CharacterTranslations.dec_supplementary_graphics/0","type":"function"},{"doc":"Returns the DEC Technical character set translation table.","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#dec_technical/0","title":"Raxol.Terminal.ANSI.CharacterTranslations.dec_technical/0","type":"function"},{"doc":"* Map containing DEC Technical character translations","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#dec_technical/0-returns","title":"Returns - Raxol.Terminal.ANSI.CharacterTranslations.dec_technical/0","type":"function"},{"doc":"iex> Raxol.Terminal.ANSI.CharacterTranslations.dec_technical()\n    %{...}","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#dec_technical/0-examples","title":"Examples - Raxol.Terminal.ANSI.CharacterTranslations.dec_technical/0","type":"function"},{"doc":"Returns the French character set translation table.","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#french/0","title":"Raxol.Terminal.ANSI.CharacterTranslations.french/0","type":"function"},{"doc":"* Map containing French character translations","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#french/0-returns","title":"Returns - Raxol.Terminal.ANSI.CharacterTranslations.french/0","type":"function"},{"doc":"iex> Raxol.Terminal.ANSI.CharacterTranslations.french()\n    %{...}","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#french/0-examples","title":"Examples - Raxol.Terminal.ANSI.CharacterTranslations.french/0","type":"function"},{"doc":"Returns the German character set translation table.","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#german/0","title":"Raxol.Terminal.ANSI.CharacterTranslations.german/0","type":"function"},{"doc":"* Map containing German character translations","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#german/0-returns","title":"Returns - Raxol.Terminal.ANSI.CharacterTranslations.german/0","type":"function"},{"doc":"iex> Raxol.Terminal.ANSI.CharacterTranslations.german()\n    %{...}","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#german/0-examples","title":"Examples - Raxol.Terminal.ANSI.CharacterTranslations.german/0","type":"function"},{"doc":"Returns the Latin-1 character set translation table.","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#latin1/0","title":"Raxol.Terminal.ANSI.CharacterTranslations.latin1/0","type":"function"},{"doc":"* Map containing Latin-1 character translations","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#latin1/0-returns","title":"Returns - Raxol.Terminal.ANSI.CharacterTranslations.latin1/0","type":"function"},{"doc":"iex> Raxol.Terminal.ANSI.CharacterTranslations.latin1()\n    %{...}","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#latin1/0-examples","title":"Examples - Raxol.Terminal.ANSI.CharacterTranslations.latin1/0","type":"function"},{"doc":"Translates a character from the source character set to the target character set.","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#translate_char/2","title":"Raxol.Terminal.ANSI.CharacterTranslations.translate_char/2","type":"function"},{"doc":"* `char_codepoint` - The Unicode codepoint of the character to translate\n  * `charset` - The target character set to translate to (e.g., `:us_ascii`, `:uk`, `:french`)","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#translate_char/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.CharacterTranslations.translate_char/2","type":"function"},{"doc":"* Binary containing the translated character in UTF-8 encoding\n  * The original character if no translation exists","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#translate_char/2-returns","title":"Returns - Raxol.Terminal.ANSI.CharacterTranslations.translate_char/2","type":"function"},{"doc":"iex> Raxol.Terminal.ANSI.CharacterTranslations.translate_char(?é, :us_ascii)\n    \"e\"\n\n    iex> Raxol.Terminal.ANSI.CharacterTranslations.translate_char(?a, :us_ascii)\n    \"a\"","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#translate_char/2-examples","title":"Examples - Raxol.Terminal.ANSI.CharacterTranslations.translate_char/2","type":"function"},{"doc":"Translates a string from the source character set to the target character set.\nHandles invalid bytes gracefully by passing them through as-is.","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#translate_string/2","title":"Raxol.Terminal.ANSI.CharacterTranslations.translate_string/2","type":"function"},{"doc":"Returns the UK character set translation table.","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#uk/0","title":"Raxol.Terminal.ANSI.CharacterTranslations.uk/0","type":"function"},{"doc":"* Map containing UK character translations","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#uk/0-returns","title":"Returns - Raxol.Terminal.ANSI.CharacterTranslations.uk/0","type":"function"},{"doc":"iex> Raxol.Terminal.ANSI.CharacterTranslations.uk()\n    %{...}","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#uk/0-examples","title":"Examples - Raxol.Terminal.ANSI.CharacterTranslations.uk/0","type":"function"},{"doc":"Map of Unicode codepoints to their ANSI terminal equivalents.","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#unicode_to_ansi/0","title":"Raxol.Terminal.ANSI.CharacterTranslations.unicode_to_ansi/0","type":"function"},{"doc":"Returns the US ASCII character set translation table.","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#us_ascii/0","title":"Raxol.Terminal.ANSI.CharacterTranslations.us_ascii/0","type":"function"},{"doc":"* Map containing US ASCII character translations","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#us_ascii/0-returns","title":"Returns - Raxol.Terminal.ANSI.CharacterTranslations.us_ascii/0","type":"function"},{"doc":"iex> Raxol.Terminal.ANSI.CharacterTranslations.us_ascii()\n    %{...}","ref":"Raxol.Terminal.ANSI.CharacterTranslations.html#us_ascii/0-examples","title":"Examples - Raxol.Terminal.ANSI.CharacterTranslations.us_ascii/0","type":"function"},{"doc":"Provides ANSI color functionality for terminal output.\nHandles color parsing, setting, and management for terminal text.","ref":"Raxol.Terminal.ANSI.Colors.html","title":"Raxol.Terminal.ANSI.Colors","type":"module"},{"doc":"","ref":"Raxol.Terminal.ANSI.Colors.html#t:color/0","title":"Raxol.Terminal.ANSI.Colors.color/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.Colors.html#t:color_mode/0","title":"Raxol.Terminal.ANSI.Colors.color_mode/0","type":"type"},{"doc":"Parses a color specification into a standardized format.\nAccepts named colors, RGB values, and ANSI color codes.","ref":"Raxol.Terminal.ANSI.Colors.html#parse_color/1","title":"Raxol.Terminal.ANSI.Colors.parse_color/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Colors.html#t:rgb/0","title":"Raxol.Terminal.ANSI.Colors.rgb/0","type":"type"},{"doc":"Sets the background color.","ref":"Raxol.Terminal.ANSI.Colors.html#set_background/2","title":"Raxol.Terminal.ANSI.Colors.set_background/2","type":"function"},{"doc":"Sets a color for the given type (foreground/background) and mode.","ref":"Raxol.Terminal.ANSI.Colors.html#set_color/3","title":"Raxol.Terminal.ANSI.Colors.set_color/3","type":"function"},{"doc":"Sets the cursor color.","ref":"Raxol.Terminal.ANSI.Colors.html#set_cursor_color/2","title":"Raxol.Terminal.ANSI.Colors.set_cursor_color/2","type":"function"},{"doc":"Sets the foreground color.","ref":"Raxol.Terminal.ANSI.Colors.html#set_foreground/2","title":"Raxol.Terminal.ANSI.Colors.set_foreground/2","type":"function"},{"doc":"Sets the highlight background color.","ref":"Raxol.Terminal.ANSI.Colors.html#set_highlight_background/2","title":"Raxol.Terminal.ANSI.Colors.set_highlight_background/2","type":"function"},{"doc":"Sets the highlight cursor color.","ref":"Raxol.Terminal.ANSI.Colors.html#set_highlight_cursor/2","title":"Raxol.Terminal.ANSI.Colors.set_highlight_cursor/2","type":"function"},{"doc":"Sets the highlight foreground color.","ref":"Raxol.Terminal.ANSI.Colors.html#set_highlight_foreground/2","title":"Raxol.Terminal.ANSI.Colors.set_highlight_foreground/2","type":"function"},{"doc":"Sets the highlight mouse background color.","ref":"Raxol.Terminal.ANSI.Colors.html#set_highlight_mouse_background/2","title":"Raxol.Terminal.ANSI.Colors.set_highlight_mouse_background/2","type":"function"},{"doc":"Sets the highlight mouse foreground color.","ref":"Raxol.Terminal.ANSI.Colors.html#set_highlight_mouse_foreground/2","title":"Raxol.Terminal.ANSI.Colors.set_highlight_mouse_foreground/2","type":"function"},{"doc":"Sets the mouse background color.","ref":"Raxol.Terminal.ANSI.Colors.html#set_mouse_background/2","title":"Raxol.Terminal.ANSI.Colors.set_mouse_background/2","type":"function"},{"doc":"Sets the mouse foreground color.","ref":"Raxol.Terminal.ANSI.Colors.html#set_mouse_foreground/2","title":"Raxol.Terminal.ANSI.Colors.set_mouse_foreground/2","type":"function"},{"doc":"Handles terminal state queries and device status reports.\nThis includes cursor position reports, device status reports,\nand terminal identification queries.","ref":"Raxol.Terminal.ANSI.DeviceStatus.html","title":"Raxol.Terminal.ANSI.DeviceStatus","type":"module"},{"doc":"Generates a cursor position report.","ref":"Raxol.Terminal.ANSI.DeviceStatus.html#cursor_position_report/1","title":"Raxol.Terminal.ANSI.DeviceStatus.cursor_position_report/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.DeviceStatus.html#t:device_status/0","title":"Raxol.Terminal.ANSI.DeviceStatus.device_status/0","type":"type"},{"doc":"Generates a device status report.","ref":"Raxol.Terminal.ANSI.DeviceStatus.html#device_status_report/2","title":"Raxol.Terminal.ANSI.DeviceStatus.device_status_report/2","type":"function"},{"doc":"Generates a fourth device attributes report.","ref":"Raxol.Terminal.ANSI.DeviceStatus.html#fourth_device_attributes/1","title":"Raxol.Terminal.ANSI.DeviceStatus.fourth_device_attributes/1","type":"function"},{"doc":"Creates a new device status map with default values.","ref":"Raxol.Terminal.ANSI.DeviceStatus.html#new/0","title":"Raxol.Terminal.ANSI.DeviceStatus.new/0","type":"function"},{"doc":"Generates a primary device attributes report.","ref":"Raxol.Terminal.ANSI.DeviceStatus.html#primary_device_attributes/1","title":"Raxol.Terminal.ANSI.DeviceStatus.primary_device_attributes/1","type":"function"},{"doc":"Generates a secondary device attributes report.","ref":"Raxol.Terminal.ANSI.DeviceStatus.html#secondary_device_attributes/1","title":"Raxol.Terminal.ANSI.DeviceStatus.secondary_device_attributes/1","type":"function"},{"doc":"Generates a tertiary device attributes report.","ref":"Raxol.Terminal.ANSI.DeviceStatus.html#tertiary_device_attributes/1","title":"Raxol.Terminal.ANSI.DeviceStatus.tertiary_device_attributes/1","type":"function"},{"doc":"Updates the cursor position in the device status.","ref":"Raxol.Terminal.ANSI.DeviceStatus.html#update_cursor_position/2","title":"Raxol.Terminal.ANSI.DeviceStatus.update_cursor_position/2","type":"function"},{"doc":"ANSI escape sequence generation module.\n\nProvides functions for generating ANSI escape sequences for terminal control:\n- Cursor movements\n- Colors and text attributes\n- Screen manipulation\n- Various terminal modes","ref":"Raxol.Terminal.ANSI.Emitter.html","title":"Raxol.Terminal.ANSI.Emitter","type":"module"},{"doc":"* Cursor control (movement, visibility)\n* Screen manipulation (clearing, scrolling)\n* Text attributes (bold, underline, etc.)\n* Color control (foreground, background)\n* Terminal mode control","ref":"Raxol.Terminal.ANSI.Emitter.html#module-features","title":"Features - Raxol.Terminal.ANSI.Emitter","type":"module"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#alternate_buffer_off/0","title":"Raxol.Terminal.ANSI.Emitter.alternate_buffer_off/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#alternate_buffer_on/0","title":"Raxol.Terminal.ANSI.Emitter.alternate_buffer_on/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#auto_wrap_off/0","title":"Raxol.Terminal.ANSI.Emitter.auto_wrap_off/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#auto_wrap_on/0","title":"Raxol.Terminal.ANSI.Emitter.auto_wrap_on/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#background/1","title":"Raxol.Terminal.ANSI.Emitter.background/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#background_256/1","title":"Raxol.Terminal.ANSI.Emitter.background_256/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#background_rgb/3","title":"Raxol.Terminal.ANSI.Emitter.background_rgb/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#blink/0","title":"Raxol.Terminal.ANSI.Emitter.blink/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#bold/0","title":"Raxol.Terminal.ANSI.Emitter.bold/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#bracketed_paste_off/0","title":"Raxol.Terminal.ANSI.Emitter.bracketed_paste_off/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#bracketed_paste_on/0","title":"Raxol.Terminal.ANSI.Emitter.bracketed_paste_on/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#clear_line/0","title":"Raxol.Terminal.ANSI.Emitter.clear_line/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#clear_line_from_cursor/0","title":"Raxol.Terminal.ANSI.Emitter.clear_line_from_cursor/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#clear_line_to_cursor/0","title":"Raxol.Terminal.ANSI.Emitter.clear_line_to_cursor/0","type":"function"},{"doc":"Generates ANSI sequences for screen manipulation.","ref":"Raxol.Terminal.ANSI.Emitter.html#clear_screen/0","title":"Raxol.Terminal.ANSI.Emitter.clear_screen/0","type":"function"},{"doc":"* `n` - Number of lines to scroll (default: 1)","ref":"Raxol.Terminal.ANSI.Emitter.html#clear_screen/0-parameters","title":"Parameters - Raxol.Terminal.ANSI.Emitter.clear_screen/0","type":"function"},{"doc":"The ANSI escape sequence for the requested screen operation.","ref":"Raxol.Terminal.ANSI.Emitter.html#clear_screen/0-returns","title":"Returns - Raxol.Terminal.ANSI.Emitter.clear_screen/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#clear_screen_from_cursor/0","title":"Raxol.Terminal.ANSI.Emitter.clear_screen_from_cursor/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#clear_screen_to_cursor/0","title":"Raxol.Terminal.ANSI.Emitter.clear_screen_to_cursor/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#conceal/0","title":"Raxol.Terminal.ANSI.Emitter.conceal/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#cursor_backward/1","title":"Raxol.Terminal.ANSI.Emitter.cursor_backward/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#cursor_down/1","title":"Raxol.Terminal.ANSI.Emitter.cursor_down/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#cursor_forward/1","title":"Raxol.Terminal.ANSI.Emitter.cursor_forward/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#cursor_hide/0","title":"Raxol.Terminal.ANSI.Emitter.cursor_hide/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#cursor_position/2","title":"Raxol.Terminal.ANSI.Emitter.cursor_position/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#cursor_restore_position/0","title":"Raxol.Terminal.ANSI.Emitter.cursor_restore_position/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#cursor_save_position/0","title":"Raxol.Terminal.ANSI.Emitter.cursor_save_position/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#cursor_show/0","title":"Raxol.Terminal.ANSI.Emitter.cursor_show/0","type":"function"},{"doc":"Generates ANSI sequences for cursor movement.","ref":"Raxol.Terminal.ANSI.Emitter.html#cursor_up/1","title":"Raxol.Terminal.ANSI.Emitter.cursor_up/1","type":"function"},{"doc":"* `n` - Number of positions to move (default: 1)","ref":"Raxol.Terminal.ANSI.Emitter.html#cursor_up/1-parameters","title":"Parameters - Raxol.Terminal.ANSI.Emitter.cursor_up/1","type":"function"},{"doc":"The ANSI escape sequence for the requested cursor movement.","ref":"Raxol.Terminal.ANSI.Emitter.html#cursor_up/1-returns","title":"Returns - Raxol.Terminal.ANSI.Emitter.cursor_up/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#faint/0","title":"Raxol.Terminal.ANSI.Emitter.faint/0","type":"function"},{"doc":"Generates ANSI sequences for colors.","ref":"Raxol.Terminal.ANSI.Emitter.html#foreground/1","title":"Raxol.Terminal.ANSI.Emitter.foreground/1","type":"function"},{"doc":"* `color_code` - The color code (0-15 for basic colors)","ref":"Raxol.Terminal.ANSI.Emitter.html#foreground/1-parameters","title":"Parameters - Raxol.Terminal.ANSI.Emitter.foreground/1","type":"function"},{"doc":"The ANSI escape sequence for the requested color.","ref":"Raxol.Terminal.ANSI.Emitter.html#foreground/1-returns","title":"Returns - Raxol.Terminal.ANSI.Emitter.foreground/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#foreground_256/1","title":"Raxol.Terminal.ANSI.Emitter.foreground_256/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#foreground_rgb/3","title":"Raxol.Terminal.ANSI.Emitter.foreground_rgb/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#inverse/0","title":"Raxol.Terminal.ANSI.Emitter.inverse/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#italic/0","title":"Raxol.Terminal.ANSI.Emitter.italic/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#no_blink/0","title":"Raxol.Terminal.ANSI.Emitter.no_blink/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#no_conceal/0","title":"Raxol.Terminal.ANSI.Emitter.no_conceal/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#no_inverse/0","title":"Raxol.Terminal.ANSI.Emitter.no_inverse/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#no_italic/0","title":"Raxol.Terminal.ANSI.Emitter.no_italic/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#no_strikethrough/0","title":"Raxol.Terminal.ANSI.Emitter.no_strikethrough/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#no_underline/0","title":"Raxol.Terminal.ANSI.Emitter.no_underline/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#normal_intensity/0","title":"Raxol.Terminal.ANSI.Emitter.normal_intensity/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#rapid_blink/0","title":"Raxol.Terminal.ANSI.Emitter.rapid_blink/0","type":"function"},{"doc":"Generates ANSI sequences for text attributes.","ref":"Raxol.Terminal.ANSI.Emitter.html#reset_attributes/0","title":"Raxol.Terminal.ANSI.Emitter.reset_attributes/0","type":"function"},{"doc":"The ANSI escape sequence for the requested text attribute.","ref":"Raxol.Terminal.ANSI.Emitter.html#reset_attributes/0-returns","title":"Returns - Raxol.Terminal.ANSI.Emitter.reset_attributes/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#reset_mode/1","title":"Raxol.Terminal.ANSI.Emitter.reset_mode/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#scroll_down_ansi/1","title":"Raxol.Terminal.ANSI.Emitter.scroll_down_ansi/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#scroll_up_ansi/1","title":"Raxol.Terminal.ANSI.Emitter.scroll_up_ansi/1","type":"function"},{"doc":"Generates ANSI sequences for terminal modes.","ref":"Raxol.Terminal.ANSI.Emitter.html#set_mode/1","title":"Raxol.Terminal.ANSI.Emitter.set_mode/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#strikethrough/0","title":"Raxol.Terminal.ANSI.Emitter.strikethrough/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Emitter.html#underline/0","title":"Raxol.Terminal.ANSI.Emitter.underline/0","type":"function"},{"doc":"Handles extended ANSI sequences and provides improved integration with the screen buffer.\nThis module adds support for:\n- Extended SGR attributes (90-97, 100-107)\n- True color support (24-bit RGB)\n- Unicode handling\n- Terminal state management\n- Improved cursor control","ref":"Raxol.Terminal.ANSI.ExtendedSequences.html","title":"Raxol.Terminal.ANSI.ExtendedSequences","type":"module"},{"doc":"","ref":"Raxol.Terminal.ANSI.ExtendedSequences.html#t:attribute/0","title":"Raxol.Terminal.ANSI.ExtendedSequences.attribute/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.ExtendedSequences.html#t:color/0","title":"Raxol.Terminal.ANSI.ExtendedSequences.color/0","type":"type"},{"doc":"Processes extended SGR (Select Graphic Rendition) parameters.\nSupports:\n- Extended colors (90-97, 100-107)\n- True color (24-bit RGB)\n- Additional attributes","ref":"Raxol.Terminal.ANSI.ExtendedSequences.html#process_extended_sgr/2","title":"Raxol.Terminal.ANSI.ExtendedSequences.process_extended_sgr/2","type":"function"},{"doc":"Processes terminal state changes.","ref":"Raxol.Terminal.ANSI.ExtendedSequences.html#process_terminal_state/2","title":"Raxol.Terminal.ANSI.ExtendedSequences.process_terminal_state/2","type":"function"},{"doc":"Processes true color sequences (24-bit RGB).","ref":"Raxol.Terminal.ANSI.ExtendedSequences.html#process_true_color/3","title":"Raxol.Terminal.ANSI.ExtendedSequences.process_true_color/3","type":"function"},{"doc":"Handles Unicode character sequences.","ref":"Raxol.Terminal.ANSI.ExtendedSequences.html#process_unicode/2","title":"Raxol.Terminal.ANSI.ExtendedSequences.process_unicode/2","type":"function"},{"doc":"Provides monitoring capabilities for the ANSI handling system.\nTracks performance metrics, errors, and sequence statistics.","ref":"Raxol.Terminal.ANSI.Monitor.html","title":"Raxol.Terminal.ANSI.Monitor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.ANSI.Monitor.html#child_spec/1","title":"Raxol.Terminal.ANSI.Monitor.child_spec/1","type":"function"},{"doc":"Gets the current metrics.","ref":"Raxol.Terminal.ANSI.Monitor.html#get_metrics/0","title":"Raxol.Terminal.ANSI.Monitor.get_metrics/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Monitor.html#t:metrics/0","title":"Raxol.Terminal.ANSI.Monitor.metrics/0","type":"type"},{"doc":"Records an error in ANSI sequence processing.","ref":"Raxol.Terminal.ANSI.Monitor.html#record_error/3","title":"Raxol.Terminal.ANSI.Monitor.record_error/3","type":"function"},{"doc":"Records the processing of an ANSI sequence.","ref":"Raxol.Terminal.ANSI.Monitor.html#record_sequence/1","title":"Raxol.Terminal.ANSI.Monitor.record_sequence/1","type":"function"},{"doc":"Resets the metrics.","ref":"Raxol.Terminal.ANSI.Monitor.html#reset_metrics/0","title":"Raxol.Terminal.ANSI.Monitor.reset_metrics/0","type":"function"},{"doc":"Starts the ANSI monitor process.","ref":"Raxol.Terminal.ANSI.Monitor.html#start_link/1","title":"Raxol.Terminal.ANSI.Monitor.start_link/1","type":"function"},{"doc":"Handles mouse event reporting for the terminal emulator.\nSupports various mouse reporting modes including:\n- Basic mouse tracking (mode 1000)\n- Highlight mouse tracking (mode 1001)\n- Cell mouse tracking (mode 1002)\n- All mouse tracking (mode 1003)\n- Focus events (mode 1004)\n- UTF-8 mouse reporting (mode 1005)\n- SGR mouse reporting (mode 1006)\n- URXVT mouse reporting (mode 1015)\n- SGR pixels mouse reporting (mode 1016)","ref":"Raxol.Terminal.ANSI.MouseEvents.html","title":"Raxol.Terminal.ANSI.MouseEvents","type":"module"},{"doc":"Calculates the drag state based on the current and previous mouse states.","ref":"Raxol.Terminal.ANSI.MouseEvents.html#calculate_drag_state/2","title":"Raxol.Terminal.ANSI.MouseEvents.calculate_drag_state/2","type":"function"},{"doc":"Decodes button state and modifiers from a mouse event byte.","ref":"Raxol.Terminal.ANSI.MouseEvents.html#decode_button/1","title":"Raxol.Terminal.ANSI.MouseEvents.decode_button/1","type":"function"},{"doc":"Decodes modifier keys from a mouse event byte.","ref":"Raxol.Terminal.ANSI.MouseEvents.html#decode_modifiers/1","title":"Raxol.Terminal.ANSI.MouseEvents.decode_modifiers/1","type":"function"},{"doc":"Decodes URXVT button state from a mouse event byte.","ref":"Raxol.Terminal.ANSI.MouseEvents.html#decode_urxvt_button/1","title":"Raxol.Terminal.ANSI.MouseEvents.decode_urxvt_button/1","type":"function"},{"doc":"Disables mouse tracking.","ref":"Raxol.Terminal.ANSI.MouseEvents.html#disable/1","title":"Raxol.Terminal.ANSI.MouseEvents.disable/1","type":"function"},{"doc":"Enables mouse tracking with the specified mode.","ref":"Raxol.Terminal.ANSI.MouseEvents.html#enable/2","title":"Raxol.Terminal.ANSI.MouseEvents.enable/2","type":"function"},{"doc":"Generates a mouse event report based on the current state.","ref":"Raxol.Terminal.ANSI.MouseEvents.html#generate_report/1","title":"Raxol.Terminal.ANSI.MouseEvents.generate_report/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.MouseEvents.html#t:modifier/0","title":"Raxol.Terminal.ANSI.MouseEvents.modifier/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.MouseEvents.html#t:mouse_mode/0","title":"Raxol.Terminal.ANSI.MouseEvents.mouse_mode/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.MouseEvents.html#t:mouse_state/0","title":"Raxol.Terminal.ANSI.MouseEvents.mouse_state/0","type":"type"},{"doc":"Creates a new mouse state with default values.","ref":"Raxol.Terminal.ANSI.MouseEvents.html#new/0","title":"Raxol.Terminal.ANSI.MouseEvents.new/0","type":"function"},{"doc":"Parses coordinates from a mouse event string.","ref":"Raxol.Terminal.ANSI.MouseEvents.html#parse_coordinates/1","title":"Raxol.Terminal.ANSI.MouseEvents.parse_coordinates/1","type":"function"},{"doc":"Parses a mouse event in the format:  ; ; M","ref":"Raxol.Terminal.ANSI.MouseEvents.html#parse_mouse_event/1","title":"Raxol.Terminal.ANSI.MouseEvents.parse_mouse_event/1","type":"function"},{"doc":"Parses an SGR pixels mouse event in the format:  ; ; M","ref":"Raxol.Terminal.ANSI.MouseEvents.html#parse_sgr_pixels_event/1","title":"Raxol.Terminal.ANSI.MouseEvents.parse_sgr_pixels_event/1","type":"function"},{"doc":"Parses a URXVT mouse event in the format:  ; ; M","ref":"Raxol.Terminal.ANSI.MouseEvents.html#parse_urxvt_event/1","title":"Raxol.Terminal.ANSI.MouseEvents.parse_urxvt_event/1","type":"function"},{"doc":"Processes a mouse event and returns the updated state and event data.\nSupports extended mouse reporting modes including SGR pixels and URXVT.","ref":"Raxol.Terminal.ANSI.MouseEvents.html#process_event/2","title":"Raxol.Terminal.ANSI.MouseEvents.process_event/2","type":"function"},{"doc":"Updates the button state.","ref":"Raxol.Terminal.ANSI.MouseEvents.html#update_button_state/2","title":"Raxol.Terminal.ANSI.MouseEvents.update_button_state/2","type":"function"},{"doc":"Updates the drag state.","ref":"Raxol.Terminal.ANSI.MouseEvents.html#update_drag_state/2","title":"Raxol.Terminal.ANSI.MouseEvents.update_drag_state/2","type":"function"},{"doc":"Updates the modifiers state.","ref":"Raxol.Terminal.ANSI.MouseEvents.html#update_modifiers/2","title":"Raxol.Terminal.ANSI.MouseEvents.update_modifiers/2","type":"function"},{"doc":"Updates the mouse position.","ref":"Raxol.Terminal.ANSI.MouseEvents.html#update_position/2","title":"Raxol.Terminal.ANSI.MouseEvents.update_position/2","type":"function"},{"doc":"Updates the mouse state with new event data.","ref":"Raxol.Terminal.ANSI.MouseEvents.html#update_state/2","title":"Raxol.Terminal.ANSI.MouseEvents.update_state/2","type":"function"},{"doc":"Handles mouse tracking and focus tracking for the terminal.\nSupports various mouse tracking modes and focus tracking events.","ref":"Raxol.Terminal.ANSI.MouseTracking.html","title":"Raxol.Terminal.ANSI.MouseTracking","type":"module"},{"doc":"Disables mouse tracking with the specified mode.","ref":"Raxol.Terminal.ANSI.MouseTracking.html#disable_mouse_tracking/1","title":"Raxol.Terminal.ANSI.MouseTracking.disable_mouse_tracking/1","type":"function"},{"doc":"Enables mouse tracking with the specified mode.","ref":"Raxol.Terminal.ANSI.MouseTracking.html#enable_mouse_tracking/1","title":"Raxol.Terminal.ANSI.MouseTracking.enable_mouse_tracking/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.MouseTracking.html#t:focus_event/0","title":"Raxol.Terminal.ANSI.MouseTracking.focus_event/0","type":"type"},{"doc":"Formats a focus event into a tracking sequence.","ref":"Raxol.Terminal.ANSI.MouseTracking.html#format_focus_event/1","title":"Raxol.Terminal.ANSI.MouseTracking.format_focus_event/1","type":"function"},{"doc":"Formats a mouse event into a tracking sequence.","ref":"Raxol.Terminal.ANSI.MouseTracking.html#format_mouse_event/1","title":"Raxol.Terminal.ANSI.MouseTracking.format_mouse_event/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.MouseTracking.html#t:mouse_action/0","title":"Raxol.Terminal.ANSI.MouseTracking.mouse_action/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.MouseTracking.html#t:mouse_button/0","title":"Raxol.Terminal.ANSI.MouseTracking.mouse_button/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.MouseTracking.html#t:mouse_event/0","title":"Raxol.Terminal.ANSI.MouseTracking.mouse_event/0","type":"type"},{"doc":"Parses a focus tracking sequence into a focus event.","ref":"Raxol.Terminal.ANSI.MouseTracking.html#parse_focus_sequence/1","title":"Raxol.Terminal.ANSI.MouseTracking.parse_focus_sequence/1","type":"function"},{"doc":"Parses a mouse tracking sequence into a mouse event.","ref":"Raxol.Terminal.ANSI.MouseTracking.html#parse_mouse_sequence/1","title":"Raxol.Terminal.ANSI.MouseTracking.parse_mouse_sequence/1","type":"function"},{"doc":"Provides comprehensive parsing for ANSI escape sequences.\nDetermines the type of sequence and extracts its parameters.","ref":"Raxol.Terminal.ANSI.Parser.html","title":"Raxol.Terminal.ANSI.Parser","type":"module"},{"doc":"Determines if a string contains ANSI escape sequences.","ref":"Raxol.Terminal.ANSI.Parser.html#contains_ansi?/1","title":"Raxol.Terminal.ANSI.Parser.contains_ansi?/1","type":"function"},{"doc":"Parses a string containing ANSI escape sequences.\nReturns a list of parsed sequences.","ref":"Raxol.Terminal.ANSI.Parser.html#parse/1","title":"Raxol.Terminal.ANSI.Parser.parse/1","type":"function"},{"doc":"Parses a single ANSI escape sequence.\nReturns a map containing the sequence type and parameters.","ref":"Raxol.Terminal.ANSI.Parser.html#parse_sequence/1","title":"Raxol.Terminal.ANSI.Parser.parse_sequence/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.Parser.html#t:sequence/0","title":"Raxol.Terminal.ANSI.Parser.sequence/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.Parser.html#t:sequence_type/0","title":"Raxol.Terminal.ANSI.Parser.sequence_type/0","type":"type"},{"doc":"Strips all ANSI escape sequences from a string.","ref":"Raxol.Terminal.ANSI.Parser.html#strip_ansi/1","title":"Raxol.Terminal.ANSI.Parser.strip_ansi/1","type":"function"},{"doc":"Processes ANSI escape sequences for terminal control.","ref":"Raxol.Terminal.ANSI.Processor.html","title":"Raxol.Terminal.ANSI.Processor","type":"module"},{"doc":"Processes an ANSI escape sequence and updates the terminal state accordingly.","ref":"Raxol.Terminal.ANSI.Processor.html#process_sequence/2","title":"Raxol.Terminal.ANSI.Processor.process_sequence/2","type":"function"},{"doc":"Handles parsing of SGR (Select Graphic Rendition) ANSI escape sequences.\nTranslates SGR codes into updates on a TextFormatting style map.","ref":"Raxol.Terminal.ANSI.SGRHandler.html","title":"Raxol.Terminal.ANSI.SGRHandler","type":"module"},{"doc":"Applies a list of SGR parameters to the current style.\nHandles multi-parameter sequences like 38/48.","ref":"Raxol.Terminal.ANSI.SGRHandler.html#apply_sgr_params/2","title":"Raxol.Terminal.ANSI.SGRHandler.apply_sgr_params/2","type":"function"},{"doc":"Helper module for parsing ANSI escape sequences.\n\nThis module provides common utilities for parsing and handling ANSI sequences,\nextracted from duplicate implementations in other ANSI-related modules.","ref":"Raxol.Terminal.ANSI.SequenceParser.html","title":"Raxol.Terminal.ANSI.SequenceParser","type":"module"},{"doc":"Parses parameters from an ANSI sequence.\n\nSplits the parameter string by semicolons and converts them to integers.","ref":"Raxol.Terminal.ANSI.SequenceParser.html#parse_params/1","title":"Raxol.Terminal.ANSI.SequenceParser.parse_params/1","type":"function"},{"doc":"* `{:ok, params}` - Successfully parsed parameters\n* `:error` - Failed to parse parameters","ref":"Raxol.Terminal.ANSI.SequenceParser.html#parse_params/1-returns","title":"Returns - Raxol.Terminal.ANSI.SequenceParser.parse_params/1","type":"function"},{"doc":"Generic parser for ANSI sequences that follow the pattern: params + operation code.","ref":"Raxol.Terminal.ANSI.SequenceParser.html#parse_sequence/2","title":"Raxol.Terminal.ANSI.SequenceParser.parse_sequence/2","type":"function"},{"doc":"* `sequence` - The binary sequence to parse\n* `operation_decoder` - Function to decode operation from character code","ref":"Raxol.Terminal.ANSI.SequenceParser.html#parse_sequence/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.SequenceParser.parse_sequence/2","type":"function"},{"doc":"* `{:ok, operation, params}` - Successfully parsed sequence\n* `:error` - Failed to parse sequence","ref":"Raxol.Terminal.ANSI.SequenceParser.html#parse_sequence/2-returns","title":"Returns - Raxol.Terminal.ANSI.SequenceParser.parse_sequence/2","type":"function"},{"doc":"ANSI Color Sequence Handler.\n\nHandles parsing and application of ANSI color control sequences,\nincluding 16-color mode, 256-color mode, and true color (24-bit) mode.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html","title":"Raxol.Terminal.ANSI.Sequences.Colors","type":"module"},{"doc":"Generate ANSI color code for a given color.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#color_code/2","title":"Raxol.Terminal.ANSI.Sequences.Colors.color_code/2","type":"function"},{"doc":"* `color` - The color struct\n* `type` - Either :foreground or :background","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#color_code/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.color_code/2","type":"function"},{"doc":"ANSI escape sequence as string","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#color_code/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.color_code/2","type":"function"},{"doc":"Returns a map of ANSI color codes.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#color_codes/0","title":"Raxol.Terminal.ANSI.Sequences.Colors.color_codes/0","type":"function"},{"doc":"A map of color names to ANSI codes.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#color_codes/0-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.color_codes/0","type":"function"},{"doc":"iex> Raxol.Terminal.ANSI.Sequences.Colors.color_codes()\n    %{\n      black: \"\u001B[30m\",\n      red: \"\u001B[31m\",\n      # ... other colors ...\n      reset: \"\u001B[0m\"\n    }","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#color_codes/0-examples","title":"Examples - Raxol.Terminal.ANSI.Sequences.Colors.color_codes/0","type":"function"},{"doc":"Parse a color string into a Color struct.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#parse_color/1","title":"Raxol.Terminal.ANSI.Sequences.Colors.parse_color/1","type":"function"},{"doc":"* `color_str` - Color string in format \"rgb:RRRR/GGGG/BBBB\" or \"#RRGGBB\"","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#parse_color/1-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.parse_color/1","type":"function"},{"doc":"Color struct or nil if invalid format","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#parse_color/1-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.parse_color/1","type":"function"},{"doc":"Set the background color.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_background/2","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_background/2","type":"function"},{"doc":"* `colors` - The color palette\n* `color` - Color struct","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_background/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_background/2","type":"function"},{"doc":"Updated color palette","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_background/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_background/2","type":"function"},{"doc":"Set background color using 256-color mode.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_background_256/2","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_background_256/2","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `index` - Color index (0-255)","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_background_256/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_background_256/2","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_background_256/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_background_256/2","type":"function"},{"doc":"Set background color using basic 16-color mode.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_background_basic/2","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_background_basic/2","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `color_code` - Color code (0-15)","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_background_basic/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_background_basic/2","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_background_basic/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_background_basic/2","type":"function"},{"doc":"Set background color using true (24-bit) RGB color.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_background_true/4","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_background_true/4","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `r` - Red component (0-255)\n* `g` - Green component (0-255)\n* `b` - Blue component (0-255)","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_background_true/4-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_background_true/4","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_background_true/4-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_background_true/4","type":"function"},{"doc":"Set a color at a specific index in the color palette.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_color/3","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_color/3","type":"function"},{"doc":"* `colors` - The color palette\n* `index` - Color index (0-255)\n* `color` - Color struct","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_color/3-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_color/3","type":"function"},{"doc":"Updated color palette","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_color/3-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_color/3","type":"function"},{"doc":"Set the cursor color.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_cursor_color/2","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_cursor_color/2","type":"function"},{"doc":"* `colors` - The color palette\n* `color` - Color struct","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_cursor_color/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_cursor_color/2","type":"function"},{"doc":"Updated color palette","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_cursor_color/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_cursor_color/2","type":"function"},{"doc":"Set the foreground color.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_foreground/2","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_foreground/2","type":"function"},{"doc":"* `colors` - The color palette\n* `color` - Color struct","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_foreground/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_foreground/2","type":"function"},{"doc":"Updated color palette","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_foreground/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_foreground/2","type":"function"},{"doc":"Set foreground color using 256-color mode.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_foreground_256/2","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_foreground_256/2","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `index` - Color index (0-255)","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_foreground_256/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_foreground_256/2","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_foreground_256/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_foreground_256/2","type":"function"},{"doc":"Set foreground color using basic 16-color mode.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_foreground_basic/2","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_foreground_basic/2","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `color_code` - Color code (0-15)","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_foreground_basic/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_foreground_basic/2","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_foreground_basic/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_foreground_basic/2","type":"function"},{"doc":"Set foreground color using true (24-bit) RGB color.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_foreground_true/4","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_foreground_true/4","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `r` - Red component (0-255)\n* `g` - Green component (0-255)\n* `b` - Blue component (0-255)","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_foreground_true/4-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_foreground_true/4","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_foreground_true/4-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_foreground_true/4","type":"function"},{"doc":"Set the highlight background color.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_highlight_background/2","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_highlight_background/2","type":"function"},{"doc":"* `colors` - The color palette\n* `color` - Color struct","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_highlight_background/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_highlight_background/2","type":"function"},{"doc":"Updated color palette","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_highlight_background/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_highlight_background/2","type":"function"},{"doc":"Set the highlight cursor color.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_highlight_cursor/2","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_highlight_cursor/2","type":"function"},{"doc":"* `colors` - The color palette\n* `color` - Color struct","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_highlight_cursor/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_highlight_cursor/2","type":"function"},{"doc":"Updated color palette","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_highlight_cursor/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_highlight_cursor/2","type":"function"},{"doc":"Set the highlight foreground color.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_highlight_foreground/2","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_highlight_foreground/2","type":"function"},{"doc":"* `colors` - The color palette\n* `color` - Color struct","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_highlight_foreground/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_highlight_foreground/2","type":"function"},{"doc":"Updated color palette","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_highlight_foreground/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_highlight_foreground/2","type":"function"},{"doc":"Set the highlight mouse background color.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_highlight_mouse_background/2","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_highlight_mouse_background/2","type":"function"},{"doc":"* `colors` - The color palette\n* `color` - Color struct","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_highlight_mouse_background/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_highlight_mouse_background/2","type":"function"},{"doc":"Updated color palette","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_highlight_mouse_background/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_highlight_mouse_background/2","type":"function"},{"doc":"Set the highlight mouse foreground color.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_highlight_mouse_foreground/2","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_highlight_mouse_foreground/2","type":"function"},{"doc":"* `colors` - The color palette\n* `color` - Color struct","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_highlight_mouse_foreground/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_highlight_mouse_foreground/2","type":"function"},{"doc":"Updated color palette","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_highlight_mouse_foreground/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_highlight_mouse_foreground/2","type":"function"},{"doc":"Set the mouse background color.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_mouse_background/2","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_mouse_background/2","type":"function"},{"doc":"* `colors` - The color palette\n* `color` - Color struct","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_mouse_background/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_mouse_background/2","type":"function"},{"doc":"Updated color palette","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_mouse_background/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_mouse_background/2","type":"function"},{"doc":"Set the mouse foreground color.","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_mouse_foreground/2","title":"Raxol.Terminal.ANSI.Sequences.Colors.set_mouse_foreground/2","type":"function"},{"doc":"* `colors` - The color palette\n* `color` - Color struct","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_mouse_foreground/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Colors.set_mouse_foreground/2","type":"function"},{"doc":"Updated color palette","ref":"Raxol.Terminal.ANSI.Sequences.Colors.html#set_mouse_foreground/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Colors.set_mouse_foreground/2","type":"function"},{"doc":"ANSI Cursor Sequence Handler.\n\nHandles parsing and application of ANSI cursor control sequences,\nincluding movement, position saving/restoring, and visibility.","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html","title":"Raxol.Terminal.ANSI.Sequences.Cursor","type":"module"},{"doc":"Move cursor to absolute position.","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#move_cursor/3","title":"Raxol.Terminal.ANSI.Sequences.Cursor.move_cursor/3","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `row` - Row to move to (1-indexed)\n* `col` - Column to move to (1-indexed)","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#move_cursor/3-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Cursor.move_cursor/3","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#move_cursor/3-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Cursor.move_cursor/3","type":"function"},{"doc":"Move cursor backward by specified number of columns.","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#move_cursor_backward/2","title":"Raxol.Terminal.ANSI.Sequences.Cursor.move_cursor_backward/2","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `n` - Number of columns to move backward","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#move_cursor_backward/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Cursor.move_cursor_backward/2","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#move_cursor_backward/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Cursor.move_cursor_backward/2","type":"function"},{"doc":"Move cursor down by specified number of rows.","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#move_cursor_down/2","title":"Raxol.Terminal.ANSI.Sequences.Cursor.move_cursor_down/2","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `n` - Number of rows to move down","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#move_cursor_down/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Cursor.move_cursor_down/2","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#move_cursor_down/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Cursor.move_cursor_down/2","type":"function"},{"doc":"Move cursor forward by specified number of columns.","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#move_cursor_forward/2","title":"Raxol.Terminal.ANSI.Sequences.Cursor.move_cursor_forward/2","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `n` - Number of columns to move forward","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#move_cursor_forward/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Cursor.move_cursor_forward/2","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#move_cursor_forward/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Cursor.move_cursor_forward/2","type":"function"},{"doc":"Move cursor up by specified number of rows.","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#move_cursor_up/2","title":"Raxol.Terminal.ANSI.Sequences.Cursor.move_cursor_up/2","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `n` - Number of rows to move up","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#move_cursor_up/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Cursor.move_cursor_up/2","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#move_cursor_up/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Cursor.move_cursor_up/2","type":"function"},{"doc":"Restore previously saved cursor position.","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#restore_cursor_position/1","title":"Raxol.Terminal.ANSI.Sequences.Cursor.restore_cursor_position/1","type":"function"},{"doc":"* `emulator` - The terminal emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#restore_cursor_position/1-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Cursor.restore_cursor_position/1","type":"function"},{"doc":"Updated emulator state with restored cursor position","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#restore_cursor_position/1-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Cursor.restore_cursor_position/1","type":"function"},{"doc":"Save current cursor position.","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#save_cursor_position/1","title":"Raxol.Terminal.ANSI.Sequences.Cursor.save_cursor_position/1","type":"function"},{"doc":"* `emulator` - The terminal emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#save_cursor_position/1-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Cursor.save_cursor_position/1","type":"function"},{"doc":"Updated emulator state with saved cursor position","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#save_cursor_position/1-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Cursor.save_cursor_position/1","type":"function"},{"doc":"Set cursor visibility.","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#set_cursor_visibility/2","title":"Raxol.Terminal.ANSI.Sequences.Cursor.set_cursor_visibility/2","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `visible` - Boolean indicating visibility","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#set_cursor_visibility/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Cursor.set_cursor_visibility/2","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Cursor.html#set_cursor_visibility/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Cursor.set_cursor_visibility/2","type":"function"},{"doc":"ANSI Terminal Modes Sequence Handler.\n\nHandles parsing and application of ANSI terminal mode sequences,\nincluding screen modes, input modes, and rendering modes.","ref":"Raxol.Terminal.ANSI.Sequences.Modes.html","title":"Raxol.Terminal.ANSI.Sequences.Modes","type":"module"},{"doc":"Sets or resets ANSI modes.","ref":"Raxol.Terminal.ANSI.Sequences.Modes.html#handle_mode_sequence/3","title":"Raxol.Terminal.ANSI.Sequences.Modes.handle_mode_sequence/3","type":"function"},{"doc":"Switch to alternate buffer mode.","ref":"Raxol.Terminal.ANSI.Sequences.Modes.html#set_alternate_buffer/2","title":"Raxol.Terminal.ANSI.Sequences.Modes.set_alternate_buffer/2","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `use_alternate` - Boolean indicating if alternate buffer should be used","ref":"Raxol.Terminal.ANSI.Sequences.Modes.html#set_alternate_buffer/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Modes.set_alternate_buffer/2","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Modes.html#set_alternate_buffer/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Modes.set_alternate_buffer/2","type":"function"},{"doc":"Enable or disable bracketed paste mode.","ref":"Raxol.Terminal.ANSI.Sequences.Modes.html#set_bracketed_paste_mode/2","title":"Raxol.Terminal.ANSI.Sequences.Modes.set_bracketed_paste_mode/2","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `enabled` - Boolean indicating if mode should be enabled or disabled","ref":"Raxol.Terminal.ANSI.Sequences.Modes.html#set_bracketed_paste_mode/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Modes.set_bracketed_paste_mode/2","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Modes.html#set_bracketed_paste_mode/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Modes.set_bracketed_paste_mode/2","type":"function"},{"doc":"Enable or disable focus reporting.","ref":"Raxol.Terminal.ANSI.Sequences.Modes.html#set_focus_reporting/2","title":"Raxol.Terminal.ANSI.Sequences.Modes.set_focus_reporting/2","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `enabled` - Boolean indicating if mode should be enabled or disabled","ref":"Raxol.Terminal.ANSI.Sequences.Modes.html#set_focus_reporting/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Modes.set_focus_reporting/2","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Modes.html#set_focus_reporting/2-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Modes.set_focus_reporting/2","type":"function"},{"doc":"Set or reset a screen mode.","ref":"Raxol.Terminal.ANSI.Sequences.Modes.html#set_screen_mode/3","title":"Raxol.Terminal.ANSI.Sequences.Modes.set_screen_mode/3","type":"function"},{"doc":"* `emulator` - The terminal emulator state\n* `mode` - Mode identifier\n* `enabled` - Boolean indicating if mode should be enabled or disabled","ref":"Raxol.Terminal.ANSI.Sequences.Modes.html#set_screen_mode/3-parameters","title":"Parameters - Raxol.Terminal.ANSI.Sequences.Modes.set_screen_mode/3","type":"function"},{"doc":"Updated emulator state","ref":"Raxol.Terminal.ANSI.Sequences.Modes.html#set_screen_mode/3-returns","title":"Returns - Raxol.Terminal.ANSI.Sequences.Modes.set_screen_mode/3","type":"function"},{"doc":"Sixel graphics support for terminal rendering.\n\nThis module handles:\n* Sixel image encoding and decoding\n* Color palette management\n* Image scaling and positioning\n* Terminal compatibility checks","ref":"Raxol.Terminal.ANSI.SixelGraphics.html","title":"Raxol.Terminal.ANSI.SixelGraphics","type":"module"},{"doc":"Decodes an ANSI escape sequence into a Sixel image.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#decode/1","title":"Raxol.Terminal.ANSI.SixelGraphics.decode/1","type":"function"},{"doc":"* `data` - The ANSI escape sequence to decode","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#decode/1-parameters","title":"Parameters - Raxol.Terminal.ANSI.SixelGraphics.decode/1","type":"function"},{"doc":"A new `t:Raxol.Terminal.ANSI.SixelGraphics.t/0` struct with the decoded image data.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#decode/1-returns","title":"Returns - Raxol.Terminal.ANSI.SixelGraphics.decode/1","type":"function"},{"doc":"Encodes a Sixel image to ANSI escape sequence.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#encode/1","title":"Raxol.Terminal.ANSI.SixelGraphics.encode/1","type":"function"},{"doc":"* `image` - The image to encode","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#encode/1-parameters","title":"Parameters - Raxol.Terminal.ANSI.SixelGraphics.encode/1","type":"function"},{"doc":"A binary containing the ANSI escape sequence for the Sixel image.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#encode/1-returns","title":"Returns - Raxol.Terminal.ANSI.SixelGraphics.encode/1","type":"function"},{"doc":"Gets the current image data.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#get_data/1","title":"Raxol.Terminal.ANSI.SixelGraphics.get_data/1","type":"function"},{"doc":"* `image` - The current image","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#get_data/1-parameters","title":"Parameters - Raxol.Terminal.ANSI.SixelGraphics.get_data/1","type":"function"},{"doc":"The binary image data.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#get_data/1-returns","title":"Returns - Raxol.Terminal.ANSI.SixelGraphics.get_data/1","type":"function"},{"doc":"Gets the current color palette.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#get_palette/1","title":"Raxol.Terminal.ANSI.SixelGraphics.get_palette/1","type":"function"},{"doc":"* `image` - The current image","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#get_palette/1-parameters","title":"Parameters - Raxol.Terminal.ANSI.SixelGraphics.get_palette/1","type":"function"},{"doc":"A map containing the current color palette.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#get_palette/1-returns","title":"Returns - Raxol.Terminal.ANSI.SixelGraphics.get_palette/1","type":"function"},{"doc":"Gets the current position.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#get_position/1","title":"Raxol.Terminal.ANSI.SixelGraphics.get_position/1","type":"function"},{"doc":"* `image` - The current image","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#get_position/1-parameters","title":"Parameters - Raxol.Terminal.ANSI.SixelGraphics.get_position/1","type":"function"},{"doc":"A tuple `{x, y}` with the current position.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#get_position/1-returns","title":"Returns - Raxol.Terminal.ANSI.SixelGraphics.get_position/1","type":"function"},{"doc":"Gets the current scale factors.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#get_scale/1","title":"Raxol.Terminal.ANSI.SixelGraphics.get_scale/1","type":"function"},{"doc":"* `image` - The current image","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#get_scale/1-parameters","title":"Parameters - Raxol.Terminal.ANSI.SixelGraphics.get_scale/1","type":"function"},{"doc":"A tuple `{x_scale, y_scale}` with the current scale factors.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#get_scale/1-returns","title":"Returns - Raxol.Terminal.ANSI.SixelGraphics.get_scale/1","type":"function"},{"doc":"Creates a new Sixel image with default values.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#new/0","title":"Raxol.Terminal.ANSI.SixelGraphics.new/0","type":"function"},{"doc":"A new `t:Raxol.Terminal.ANSI.SixelGraphics.t/0` struct with default values.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#new/0-returns","title":"Returns - Raxol.Terminal.ANSI.SixelGraphics.new/0","type":"function"},{"doc":"Creates a new Sixel image with specified dimensions.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#new/2","title":"Raxol.Terminal.ANSI.SixelGraphics.new/2","type":"function"},{"doc":"* `width` - The image width in pixels\n* `height` - The image height in pixels","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#new/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.SixelGraphics.new/2","type":"function"},{"doc":"A new `t:Raxol.Terminal.ANSI.SixelGraphics.t/0` struct with the specified dimensions.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#new/2-returns","title":"Returns - Raxol.Terminal.ANSI.SixelGraphics.new/2","type":"function"},{"doc":"Processes a sequence of Sixel data.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#process_sequence/2","title":"Raxol.Terminal.ANSI.SixelGraphics.process_sequence/2","type":"function"},{"doc":"* `state` - The current Sixel state\n* `data` - The Sixel data to process","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#process_sequence/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.SixelGraphics.process_sequence/2","type":"function"},{"doc":"A tuple containing the updated state and a response.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#process_sequence/2-returns","title":"Returns - Raxol.Terminal.ANSI.SixelGraphics.process_sequence/2","type":"function"},{"doc":"Sets the image data for a Sixel image.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#set_data/2","title":"Raxol.Terminal.ANSI.SixelGraphics.set_data/2","type":"function"},{"doc":"* `image` - The current image\n* `data` - The binary image data","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#set_data/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.SixelGraphics.set_data/2","type":"function"},{"doc":"The updated image with new data.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#set_data/2-returns","title":"Returns - Raxol.Terminal.ANSI.SixelGraphics.set_data/2","type":"function"},{"doc":"Sets the color palette for a Sixel image.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#set_palette/2","title":"Raxol.Terminal.ANSI.SixelGraphics.set_palette/2","type":"function"},{"doc":"* `image` - The current image\n* `palette` - A map of color indices to RGB values","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#set_palette/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.SixelGraphics.set_palette/2","type":"function"},{"doc":"The updated image with new palette.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#set_palette/2-returns","title":"Returns - Raxol.Terminal.ANSI.SixelGraphics.set_palette/2","type":"function"},{"doc":"Sets the position for a Sixel image.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#set_position/3","title":"Raxol.Terminal.ANSI.SixelGraphics.set_position/3","type":"function"},{"doc":"* `image` - The current image\n* `x` - The horizontal position\n* `y` - The vertical position","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#set_position/3-parameters","title":"Parameters - Raxol.Terminal.ANSI.SixelGraphics.set_position/3","type":"function"},{"doc":"The updated image with new position.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#set_position/3-returns","title":"Returns - Raxol.Terminal.ANSI.SixelGraphics.set_position/3","type":"function"},{"doc":"Sets the scale factor for a Sixel image.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#set_scale/3","title":"Raxol.Terminal.ANSI.SixelGraphics.set_scale/3","type":"function"},{"doc":"* `image` - The current image\n* `x_scale` - The horizontal scale factor\n* `y_scale` - The vertical scale factor","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#set_scale/3-parameters","title":"Parameters - Raxol.Terminal.ANSI.SixelGraphics.set_scale/3","type":"function"},{"doc":"The updated image with new scale factors.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#set_scale/3-returns","title":"Returns - Raxol.Terminal.ANSI.SixelGraphics.set_scale/3","type":"function"},{"doc":"Checks if the terminal supports Sixel graphics.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#supported?/0","title":"Raxol.Terminal.ANSI.SixelGraphics.supported?/0","type":"function"},{"doc":"`true` if Sixel graphics are supported, `false` otherwise.","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#supported?/0-returns","title":"Returns - Raxol.Terminal.ANSI.SixelGraphics.supported?/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.html#t:t/0","title":"Raxol.Terminal.ANSI.SixelGraphics.t/0","type":"type"},{"doc":"Behaviour for Sixel graphics support.","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html#c:decode/1","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.decode/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html#c:encode/1","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.encode/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html#c:get_data/1","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.get_data/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html#c:get_palette/1","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.get_palette/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html#c:get_position/1","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.get_position/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html#c:get_scale/1","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.get_scale/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html#c:new/0","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.new/0","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html#c:new/2","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.new/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html#c:process_sequence/2","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.process_sequence/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html#c:set_data/2","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.set_data/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html#c:set_palette/2","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.set_palette/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html#c:set_position/3","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.set_position/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html#c:set_scale/3","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.set_scale/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html#c:supported?/0","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.supported?/0","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.html#t:t/0","title":"Raxol.Terminal.ANSI.SixelGraphics.Behaviour.t/0","type":"type"},{"doc":"Handles Sixel color palette management.\n\nProvides functions to initialize the default palette and potentially\nmanage custom color definitions in the future.","ref":"Raxol.Terminal.ANSI.SixelPalette.html","title":"Raxol.Terminal.ANSI.SixelPalette","type":"module"},{"doc":"Converts color parameters based on the specified color space.\n\nHandles clamping values and delegation to specific conversion functions.\nSupports HLS (1) and RGB (2).","ref":"Raxol.Terminal.ANSI.SixelPalette.html#convert_color/4","title":"Raxol.Terminal.ANSI.SixelPalette.convert_color/4","type":"function"},{"doc":"Defines a custom color in the palette using the Sixel \"#\" command format.","ref":"Raxol.Terminal.ANSI.SixelPalette.html#define_color/6","title":"Raxol.Terminal.ANSI.SixelPalette.define_color/6","type":"function"},{"doc":"* `palette` - The current color palette map\n  * `index` - The color index to define (0-255)\n  * `format` - The color space format (1 for HLS, 2 for RGB)\n  * `p1` - First parameter (H or R)\n  * `p2` - Second parameter (L or G)\n  * `p3` - Third parameter (S or B)","ref":"Raxol.Terminal.ANSI.SixelPalette.html#define_color/6-parameters","title":"Parameters - Raxol.Terminal.ANSI.SixelPalette.define_color/6","type":"function"},{"doc":"* `{:ok, updated_palette}` - The updated palette with the new color\n  * `{:error, reason}` - If the color definition fails","ref":"Raxol.Terminal.ANSI.SixelPalette.html#define_color/6-returns","title":"Returns - Raxol.Terminal.ANSI.SixelPalette.define_color/6","type":"function"},{"doc":"Simplified HLS to RGB conversion (based on standard formulas).\n\nInput: H (0-360), L (0-1), S (0-1)\nOutput: {:ok, {R, G, B}} (0-255)","ref":"Raxol.Terminal.ANSI.SixelPalette.html#hls_to_rgb/3","title":"Raxol.Terminal.ANSI.SixelPalette.hls_to_rgb/3","type":"function"},{"doc":"Initializes the default Sixel color palette (256 colors).","ref":"Raxol.Terminal.ANSI.SixelPalette.html#initialize_palette/0","title":"Raxol.Terminal.ANSI.SixelPalette.initialize_palette/0","type":"function"},{"doc":"Returns the maximum valid color index (typically 255 for a 256-color palette).","ref":"Raxol.Terminal.ANSI.SixelPalette.html#max_colors/0","title":"Raxol.Terminal.ANSI.SixelPalette.max_colors/0","type":"function"},{"doc":"Handles the parsing logic for Sixel graphics data streams within a DCS sequence.","ref":"Raxol.Terminal.ANSI.SixelParser.html","title":"Raxol.Terminal.ANSI.SixelParser","type":"module"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelParser.html#consume_integer_params/1","title":"Raxol.Terminal.ANSI.SixelParser.consume_integer_params/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelParser.html#parse/2","title":"Raxol.Terminal.ANSI.SixelParser.parse/2","type":"function"},{"doc":"Represents the state during the parsing of a Sixel graphics data stream.\nTracks position, color, palette, and pixel buffer information.","ref":"Raxol.Terminal.ANSI.SixelParser.ParserState.html","title":"Raxol.Terminal.ANSI.SixelParser.ParserState","type":"module"},{"doc":"","ref":"Raxol.Terminal.ANSI.SixelParser.ParserState.html#t:t/0","title":"Raxol.Terminal.ANSI.SixelParser.ParserState.t/0","type":"type"},{"doc":"Provides a mapping from Sixel characters to their 6-bit pixel patterns.","ref":"Raxol.Terminal.ANSI.SixelPatternMap.html","title":"Raxol.Terminal.ANSI.SixelPatternMap","type":"module"},{"doc":"Gets the 6-bit integer pattern for a given Sixel character code.","ref":"Raxol.Terminal.ANSI.SixelPatternMap.html#get_pattern/1","title":"Raxol.Terminal.ANSI.SixelPatternMap.get_pattern/1","type":"function"},{"doc":"Converts a 6-bit integer pattern into a list of 6 pixel values (0 or 1).","ref":"Raxol.Terminal.ANSI.SixelPatternMap.html#pattern_to_pixels/1","title":"Raxol.Terminal.ANSI.SixelPatternMap.pattern_to_pixels/1","type":"function"},{"doc":"Handles rendering Sixel graphics data from a pixel buffer.","ref":"Raxol.Terminal.ANSI.SixelRenderer.html","title":"Raxol.Terminal.ANSI.SixelRenderer","type":"module"},{"doc":"Renders the image stored in the pixel_buffer as a Sixel data stream.","ref":"Raxol.Terminal.ANSI.SixelRenderer.html#render_image/1","title":"Raxol.Terminal.ANSI.SixelRenderer.render_image/1","type":"function"},{"doc":"A state machine for parsing ANSI escape sequences.\nThis module provides a more efficient alternative to regex-based parsing.","ref":"Raxol.Terminal.ANSI.StateMachine.html","title":"Raxol.Terminal.ANSI.StateMachine","type":"module"},{"doc":"Creates a new parser state with default values.","ref":"Raxol.Terminal.ANSI.StateMachine.html#new/0","title":"Raxol.Terminal.ANSI.StateMachine.new/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.StateMachine.html#t:parser_state/0","title":"Raxol.Terminal.ANSI.StateMachine.parser_state/0","type":"type"},{"doc":"Processes input bytes through the state machine.\nReturns the updated state and any parsed sequences.","ref":"Raxol.Terminal.ANSI.StateMachine.html#process/2","title":"Raxol.Terminal.ANSI.StateMachine.process/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.StateMachine.html#t:sequence/0","title":"Raxol.Terminal.ANSI.StateMachine.sequence/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.StateMachine.html#t:sequence_type/0","title":"Raxol.Terminal.ANSI.StateMachine.sequence_type/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.StateMachine.html#t:state/0","title":"Raxol.Terminal.ANSI.StateMachine.state/0","type":"type"},{"doc":"Manages terminal state operations for ANSI escape sequences.","ref":"Raxol.Terminal.ANSI.TerminalState.html","title":"Raxol.Terminal.ANSI.TerminalState","type":"module"},{"doc":"Clears all saved states.","ref":"Raxol.Terminal.ANSI.TerminalState.html#clear/1","title":"Raxol.Terminal.ANSI.TerminalState.clear/1","type":"function"},{"doc":"Gets the current state from the state stack.","ref":"Raxol.Terminal.ANSI.TerminalState.html#current/1","title":"Raxol.Terminal.ANSI.TerminalState.current/1","type":"function"},{"doc":"Gets the current state.","ref":"Raxol.Terminal.ANSI.TerminalState.html#get_current_state/1","title":"Raxol.Terminal.ANSI.TerminalState.get_current_state/1","type":"function"},{"doc":"Gets the number of saved states.","ref":"Raxol.Terminal.ANSI.TerminalState.html#get_saved_states_count/1","title":"Raxol.Terminal.ANSI.TerminalState.get_saved_states_count/1","type":"function"},{"doc":"Gets the current state stack.","ref":"Raxol.Terminal.ANSI.TerminalState.html#get_state_stack/1","title":"Raxol.Terminal.ANSI.TerminalState.get_state_stack/1","type":"function"},{"doc":"Checks if there are any saved states.","ref":"Raxol.Terminal.ANSI.TerminalState.html#has_saved_states?/1","title":"Raxol.Terminal.ANSI.TerminalState.has_saved_states?/1","type":"function"},{"doc":"Creates a new terminal state with default settings.","ref":"Raxol.Terminal.ANSI.TerminalState.html#new/1","title":"Raxol.Terminal.ANSI.TerminalState.new/1","type":"function"},{"doc":"Pops a state from the state stack.","ref":"Raxol.Terminal.ANSI.TerminalState.html#pop/1","title":"Raxol.Terminal.ANSI.TerminalState.pop/1","type":"function"},{"doc":"Pushes the current state onto the state stack.","ref":"Raxol.Terminal.ANSI.TerminalState.html#push/1","title":"Raxol.Terminal.ANSI.TerminalState.push/1","type":"function"},{"doc":"Restores the most recently saved state.","ref":"Raxol.Terminal.ANSI.TerminalState.html#restore/1","title":"Raxol.Terminal.ANSI.TerminalState.restore/1","type":"function"},{"doc":"Restores the most recently saved terminal state from the state stack.\nReturns the restored state and the updated stack.","ref":"Raxol.Terminal.ANSI.TerminalState.html#restore_state/1","title":"Raxol.Terminal.ANSI.TerminalState.restore_state/1","type":"function"},{"doc":"Saves the current state.","ref":"Raxol.Terminal.ANSI.TerminalState.html#save/1","title":"Raxol.Terminal.ANSI.TerminalState.save/1","type":"function"},{"doc":"Saves the current terminal state to the state stack.","ref":"Raxol.Terminal.ANSI.TerminalState.html#save_state/2","title":"Raxol.Terminal.ANSI.TerminalState.save_state/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.TerminalState.html#t:t/0","title":"Raxol.Terminal.ANSI.TerminalState.t/0","type":"type"},{"doc":"Updates the current state.","ref":"Raxol.Terminal.ANSI.TerminalState.html#update_current_state/2","title":"Raxol.Terminal.ANSI.TerminalState.update_current_state/2","type":"function"},{"doc":"Updates the state stack.","ref":"Raxol.Terminal.ANSI.TerminalState.html#update_state_stack/2","title":"Raxol.Terminal.ANSI.TerminalState.update_state_stack/2","type":"function"},{"doc":"Behaviour for managing terminal state saving and restoring.","ref":"Raxol.Terminal.ANSI.TerminalStateBehaviour.html","title":"Raxol.Terminal.ANSI.TerminalStateBehaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.ANSI.TerminalStateBehaviour.html#c:apply_restored_data/3","title":"Raxol.Terminal.ANSI.TerminalStateBehaviour.apply_restored_data/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TerminalStateBehaviour.html#c:restore_state/1","title":"Raxol.Terminal.ANSI.TerminalStateBehaviour.restore_state/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TerminalStateBehaviour.html#c:save_state/2","title":"Raxol.Terminal.ANSI.TerminalStateBehaviour.save_state/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TerminalStateBehaviour.html#t:state_data_map/0","title":"Raxol.Terminal.ANSI.TerminalStateBehaviour.state_data_map/0","type":"type"},{"doc":"Handles advanced text formatting features for the terminal emulator.\nThis includes double-width and double-height characters, as well as\nother advanced text attributes and colors.","ref":"Raxol.Terminal.ANSI.TextFormatting.html","title":"Raxol.Terminal.ANSI.TextFormatting","type":"module"},{"doc":"Converts an ANSI code to a color name.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#ansi_code_to_color_name/1","title":"Raxol.Terminal.ANSI.TextFormatting.ansi_code_to_color_name/1","type":"function"},{"doc":"Applies a text attribute to the style map.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#apply_attribute/2","title":"Raxol.Terminal.ANSI.TextFormatting.apply_attribute/2","type":"function"},{"doc":"* `style` - The current text style\n* `attribute` - The attribute to apply (e.g., :bold, :underline, etc.)","ref":"Raxol.Terminal.ANSI.TextFormatting.html#apply_attribute/2-parameters","title":"Parameters - Raxol.Terminal.ANSI.TextFormatting.apply_attribute/2","type":"function"},{"doc":"The updated text style with the new attribute applied.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#apply_attribute/2-returns","title":"Returns - Raxol.Terminal.ANSI.TextFormatting.apply_attribute/2","type":"function"},{"doc":"Applies the given color to the text.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#apply_color/3","title":"Raxol.Terminal.ANSI.TextFormatting.apply_color/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormatting.html#t:color/0","title":"Raxol.Terminal.ANSI.TextFormatting.color/0","type":"type"},{"doc":"Calculates the effective width of the text.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#effective_width/2","title":"Raxol.Terminal.ANSI.TextFormatting.effective_width/2","type":"function"},{"doc":"Formats a style into SGR (Select Graphic Rendition) parameters.\nReturns a list of ANSI SGR codes.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#format_sgr_params/1","title":"Raxol.Terminal.ANSI.TextFormatting.format_sgr_params/1","type":"function"},{"doc":"Gets the background color.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#get_background/1","title":"Raxol.Terminal.ANSI.TextFormatting.get_background/1","type":"function"},{"doc":"Gets the foreground color.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#get_foreground/1","title":"Raxol.Terminal.ANSI.TextFormatting.get_foreground/1","type":"function"},{"doc":"Gets the hyperlink from a style.\nReturns the hyperlink URL or nil if no hyperlink is set.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#get_hyperlink/1","title":"Raxol.Terminal.ANSI.TextFormatting.get_hyperlink/1","type":"function"},{"doc":"Returns the paired line type for the given line.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#get_paired_line_type/1","title":"Raxol.Terminal.ANSI.TextFormatting.get_paired_line_type/1","type":"function"},{"doc":"Checks if the line needs a paired line.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#needs_paired_line?/1","title":"Raxol.Terminal.ANSI.TextFormatting.needs_paired_line?/1","type":"function"},{"doc":"Creates a new text formatting struct with default values.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#new/0","title":"Raxol.Terminal.ANSI.TextFormatting.new/0","type":"function"},{"doc":"Resets all text attributes to their default values.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#reset_attributes/1","title":"Raxol.Terminal.ANSI.TextFormatting.reset_attributes/1","type":"function"},{"doc":"Resets blink text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#reset_blink/1","title":"Raxol.Terminal.ANSI.TextFormatting.reset_blink/1","type":"function"},{"doc":"Resets bold text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#reset_bold/1","title":"Raxol.Terminal.ANSI.TextFormatting.reset_bold/1","type":"function"},{"doc":"Resets italic text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#reset_italic/1","title":"Raxol.Terminal.ANSI.TextFormatting.reset_italic/1","type":"function"},{"doc":"Resets reverse video mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#reset_reverse/1","title":"Raxol.Terminal.ANSI.TextFormatting.reset_reverse/1","type":"function"},{"doc":"Resets to single-width, single-height mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#reset_size/1","title":"Raxol.Terminal.ANSI.TextFormatting.reset_size/1","type":"function"},{"doc":"Resets underline text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#reset_underline/1","title":"Raxol.Terminal.ANSI.TextFormatting.reset_underline/1","type":"function"},{"doc":"Sets a single attribute on the emulator.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_attribute/2","title":"Raxol.Terminal.ANSI.TextFormatting.set_attribute/2","type":"function"},{"doc":"Sets multiple text attributes at once.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_attributes/2","title":"Raxol.Terminal.ANSI.TextFormatting.set_attributes/2","type":"function"},{"doc":"Sets the background color.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_background/2","title":"Raxol.Terminal.ANSI.TextFormatting.set_background/2","type":"function"},{"doc":"Sets blink text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_blink/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_blink/1","type":"function"},{"doc":"Sets bold text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_bold/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_bold/1","type":"function"},{"doc":"Sets concealed text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_conceal/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_conceal/1","type":"function"},{"doc":"Sets a custom attribute in the style map.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_custom/3","title":"Raxol.Terminal.ANSI.TextFormatting.set_custom/3","type":"function"},{"doc":"Sets double-height bottom half mode for the current line.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_double_height_bottom/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_double_height_bottom/1","type":"function"},{"doc":"Sets double-height top half mode for the current line.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_double_height_top/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_double_height_top/1","type":"function"},{"doc":"Sets double underline text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_double_underline/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_double_underline/1","type":"function"},{"doc":"Sets double-width mode for the current line.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_double_width/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_double_width/1","type":"function"},{"doc":"Sets encircled text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_encircled/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_encircled/1","type":"function"},{"doc":"Sets faint text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_faint/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_faint/1","type":"function"},{"doc":"Sets the foreground color.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_foreground/2","title":"Raxol.Terminal.ANSI.TextFormatting.set_foreground/2","type":"function"},{"doc":"Sets fraktur text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_fraktur/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_fraktur/1","type":"function"},{"doc":"Sets framed text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_framed/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_framed/1","type":"function"},{"doc":"Sets a hyperlink for the text.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_hyperlink/2","title":"Raxol.Terminal.ANSI.TextFormatting.set_hyperlink/2","type":"function"},{"doc":"Sets italic text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_italic/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_italic/1","type":"function"},{"doc":"Sets overlined text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_overlined/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_overlined/1","type":"function"},{"doc":"Sets reverse video mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_reverse/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_reverse/1","type":"function"},{"doc":"Sets strikethrough text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_strikethrough/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_strikethrough/1","type":"function"},{"doc":"Sets underline text mode.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#set_underline/1","title":"Raxol.Terminal.ANSI.TextFormatting.set_underline/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormatting.html#t:t/0","title":"Raxol.Terminal.ANSI.TextFormatting.t/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormatting.html#t:text_style/0","title":"Raxol.Terminal.ANSI.TextFormatting.text_style/0","type":"type"},{"doc":"Updates multiple attributes from a map.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#update_attrs/2","title":"Raxol.Terminal.ANSI.TextFormatting.update_attrs/2","type":"function"},{"doc":"Validates a text style map.","ref":"Raxol.Terminal.ANSI.TextFormatting.html#validate/1","title":"Raxol.Terminal.ANSI.TextFormatting.validate/1","type":"function"},{"doc":"Defines the behaviour for text formatting in the terminal.\nThis includes handling text attributes, colors, and special text modes.","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:apply_attribute/2","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.apply_attribute/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#t:color/0","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.color/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:get_background/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.get_background/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:get_foreground/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.get_foreground/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:new/0","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.new/0","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:reset_attributes/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.reset_attributes/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:reset_blink/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.reset_blink/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:reset_bold/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.reset_bold/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:reset_italic/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.reset_italic/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:reset_reverse/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.reset_reverse/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:reset_size/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.reset_size/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:reset_underline/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.reset_underline/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_attributes/2","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_attributes/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_background/2","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_background/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_blink/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_blink/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_bold/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_bold/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_conceal/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_conceal/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_custom/3","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_custom/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_double_height_bottom/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_double_height_bottom/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_double_height_top/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_double_height_top/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_double_underline/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_double_underline/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_double_width/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_double_width/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_encircled/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_encircled/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_faint/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_faint/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_foreground/2","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_foreground/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_fraktur/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_fraktur/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_framed/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_framed/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_hyperlink/2","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_hyperlink/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_italic/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_italic/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_overlined/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_overlined/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_reverse/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_reverse/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_strikethrough/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_strikethrough/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:set_underline/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.set_underline/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#t:text_style/0","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.text_style/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:update_attrs/2","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.update_attrs/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ANSI.TextFormattingBehaviour.html#c:validate/1","title":"Raxol.Terminal.ANSI.TextFormattingBehaviour.validate/1","type":"callback"},{"doc":"Handles window events for terminal control.\nSupports window close, minimize, maximize, restore, and other window events.","ref":"Raxol.Terminal.ANSI.WindowEvents.html","title":"Raxol.Terminal.ANSI.WindowEvents","type":"module"},{"doc":"* Window close events\n* Window minimize/maximize events\n* Window focus events\n* Window move events\n* Window resize events\n* Window state change events\n* Window visibility events\n* Window activation events\n* Window drag events\n* Window drop events","ref":"Raxol.Terminal.ANSI.WindowEvents.html#module-features","title":"Features - Raxol.Terminal.ANSI.WindowEvents","type":"module"},{"doc":"Disables window event reporting.","ref":"Raxol.Terminal.ANSI.WindowEvents.html#disable_window_events/0","title":"Raxol.Terminal.ANSI.WindowEvents.disable_window_events/0","type":"function"},{"doc":"Enables window event reporting.","ref":"Raxol.Terminal.ANSI.WindowEvents.html#enable_window_events/0","title":"Raxol.Terminal.ANSI.WindowEvents.enable_window_events/0","type":"function"},{"doc":"Formats a window event into an ANSI escape sequence.","ref":"Raxol.Terminal.ANSI.WindowEvents.html#format_event/1","title":"Raxol.Terminal.ANSI.WindowEvents.format_event/1","type":"function"},{"doc":"Processes a window event sequence and returns the corresponding event.","ref":"Raxol.Terminal.ANSI.WindowEvents.html#process_sequence/2","title":"Raxol.Terminal.ANSI.WindowEvents.process_sequence/2","type":"function"},{"doc":"Processes window-related ANSI escape sequences.\nReturns updated emulator state and any commands that need to be executed.","ref":"Raxol.Terminal.ANSI.WindowEvents.html#process_window_event/2","title":"Raxol.Terminal.ANSI.WindowEvents.process_window_event/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowEvents.html#t:window_event/0","title":"Raxol.Terminal.ANSI.WindowEvents.window_event/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowEvents.html#t:window_event_type/0","title":"Raxol.Terminal.ANSI.WindowEvents.window_event_type/0","type":"type"},{"doc":"Handles window manipulation sequences for terminal control.\nSupports window resizing, positioning, and state management.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html","title":"Raxol.Terminal.ANSI.WindowManipulation","type":"module"},{"doc":"* Window resizing\n* Window positioning\n* Window state (minimize, maximize, restore)\n* Window title management\n* Window icon management\n* Window stacking order\n* Window transparency\n* Window focus management\n* Window borders and decorations\n* Window events\n* Window state persistence\n* Window layout management\n* Window group management\n* Window animations","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#module-features","title":"Features - Raxol.Terminal.ANSI.WindowManipulation","type":"module"},{"doc":"Clears the entire screen.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#clear_screen/0","title":"Raxol.Terminal.ANSI.WindowManipulation.clear_screen/0","type":"function"},{"doc":"Disables window manipulation mode.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#disable_window_manipulation/0","title":"Raxol.Terminal.ANSI.WindowManipulation.disable_window_manipulation/0","type":"function"},{"doc":"Enables window manipulation mode.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#enable_window_manipulation/0","title":"Raxol.Terminal.ANSI.WindowManipulation.enable_window_manipulation/0","type":"function"},{"doc":"Formats a focus gain event into an ANSI sequence.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#focus_gain/0","title":"Raxol.Terminal.ANSI.WindowManipulation.focus_gain/0","type":"function"},{"doc":"Formats a focus loss event into an ANSI sequence.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#focus_loss/0","title":"Raxol.Terminal.ANSI.WindowManipulation.focus_loss/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_border_color/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_border_color/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_border_radius/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_border_radius/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_border_style/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_border_style/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_border_width/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_border_width/1","type":"function"},{"doc":"Formats a window event into an ANSI sequence.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_event/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_event/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_focus/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_focus/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_icon/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_icon/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_move/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_move/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_resize/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_resize/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_shadow/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_shadow/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_shadow_blur/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_shadow_blur/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_shadow_color/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_shadow_color/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_shadow_offset/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_shadow_offset/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_stack/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_stack/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_state/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_state/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_title/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_title/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#format_transparency/1","title":"Raxol.Terminal.ANSI.WindowManipulation.format_transparency/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_border_color/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_border_color/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_border_radius/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_border_radius/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_border_style/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_border_style/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_border_width/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_border_width/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_focus/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_focus/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_icon/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_icon/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_move/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_move/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_resize/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_resize/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_shadow/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_shadow/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_shadow_blur/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_shadow_blur/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_shadow_color/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_shadow_color/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_shadow_offset/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_shadow_offset/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_stack/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_stack/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_state/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_state/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_title/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_title/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#handle_transparency/1","title":"Raxol.Terminal.ANSI.WindowManipulation.handle_transparency/1","type":"function"},{"doc":"Formats a key press event into an ANSI sequence.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#key_press/1","title":"Raxol.Terminal.ANSI.WindowManipulation.key_press/1","type":"function"},{"doc":"Formats a key release event into an ANSI sequence.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#key_release/1","title":"Raxol.Terminal.ANSI.WindowManipulation.key_release/1","type":"function"},{"doc":"Formats a mouse click event into an ANSI sequence.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#mouse_click/3","title":"Raxol.Terminal.ANSI.WindowManipulation.mouse_click/3","type":"function"},{"doc":"Formats a mouse drag event into an ANSI sequence.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#mouse_drag/3","title":"Raxol.Terminal.ANSI.WindowManipulation.mouse_drag/3","type":"function"},{"doc":"Formats a mouse release event into an ANSI sequence.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#mouse_release/3","title":"Raxol.Terminal.ANSI.WindowManipulation.mouse_release/3","type":"function"},{"doc":"Moves the cursor to the specified position.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#move_cursor/2","title":"Raxol.Terminal.ANSI.WindowManipulation.move_cursor/2","type":"function"},{"doc":"Processes a window manipulation sequence and returns the corresponding event.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#process_sequence/2","title":"Raxol.Terminal.ANSI.WindowManipulation.process_sequence/2","type":"function"},{"doc":"Sets the window icon name.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#set_icon_name/1","title":"Raxol.Terminal.ANSI.WindowManipulation.set_icon_name/1","type":"function"},{"doc":"Sets the window mode.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#set_mode/1","title":"Raxol.Terminal.ANSI.WindowManipulation.set_mode/1","type":"function"},{"doc":"Sets the window title.","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#set_title/1","title":"Raxol.Terminal.ANSI.WindowManipulation.set_title/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#t:window_border_style/0","title":"Raxol.Terminal.ANSI.WindowManipulation.window_border_style/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#t:window_event/0","title":"Raxol.Terminal.ANSI.WindowManipulation.window_event/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#t:window_position/0","title":"Raxol.Terminal.ANSI.WindowManipulation.window_position/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#t:window_size/0","title":"Raxol.Terminal.ANSI.WindowManipulation.window_size/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ANSI.WindowManipulation.html#t:window_state/0","title":"Raxol.Terminal.ANSI.WindowManipulation.window_state/0","type":"type"},{"doc":"Manages the terminal buffer state and operations.","ref":"Raxol.Terminal.Buffer.html","title":"Raxol.Terminal.Buffer","type":"module"},{"doc":"Adds content to the buffer at the current cursor position.","ref":"Raxol.Terminal.Buffer.html#add/2","title":"Raxol.Terminal.Buffer.add/2","type":"function"},{"doc":"iex> buffer = Buffer.new({80, 24})\n    iex> buffer = Buffer.add(buffer, \"Hello, World!\")\n    iex> {content, _} = Buffer.read(buffer)\n    iex> content\n    \"Hello, World!\"","ref":"Raxol.Terminal.Buffer.html#add/2-examples","title":"Examples - Raxol.Terminal.Buffer.add/2","type":"function"},{"doc":"Clears the buffer.","ref":"Raxol.Terminal.Buffer.html#clear/2","title":"Raxol.Terminal.Buffer.clear/2","type":"function"},{"doc":"Gets the current cursor position.","ref":"Raxol.Terminal.Buffer.html#get_cursor_position/1","title":"Raxol.Terminal.Buffer.get_cursor_position/1","type":"function"},{"doc":"Gets all damaged regions in the buffer.","ref":"Raxol.Terminal.Buffer.html#get_damage_regions/1","title":"Raxol.Terminal.Buffer.get_damage_regions/1","type":"function"},{"doc":"Marks a region of the buffer as damaged.","ref":"Raxol.Terminal.Buffer.html#mark_damaged/5","title":"Raxol.Terminal.Buffer.mark_damaged/5","type":"function"},{"doc":"Creates a new buffer with the specified dimensions.\nRaises ArgumentError if dimensions are invalid.","ref":"Raxol.Terminal.Buffer.html#new/1","title":"Raxol.Terminal.Buffer.new/1","type":"function"},{"doc":"Reads data from the buffer.","ref":"Raxol.Terminal.Buffer.html#read/2","title":"Raxol.Terminal.Buffer.read/2","type":"function"},{"doc":"Scrolls the buffer by the specified number of lines.","ref":"Raxol.Terminal.Buffer.html#scroll/2","title":"Raxol.Terminal.Buffer.scroll/2","type":"function"},{"doc":"Sets a cell in the buffer at the specified coordinates.\nRaises ArgumentError if coordinates or cell data are invalid.","ref":"Raxol.Terminal.Buffer.html#set_cell/4","title":"Raxol.Terminal.Buffer.set_cell/4","type":"function"},{"doc":"Sets the cursor position.","ref":"Raxol.Terminal.Buffer.html#set_cursor_position/3","title":"Raxol.Terminal.Buffer.set_cursor_position/3","type":"function"},{"doc":"Sets the scroll region.","ref":"Raxol.Terminal.Buffer.html#set_scroll_region/3","title":"Raxol.Terminal.Buffer.set_scroll_region/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.html#t:t/0","title":"Raxol.Terminal.Buffer.t/0","type":"type"},{"doc":"Writes data to the buffer at the current cursor position.","ref":"Raxol.Terminal.Buffer.html#write/3","title":"Raxol.Terminal.Buffer.write/3","type":"function"},{"doc":"Manages caching for the terminal buffer system.\nProvides efficient caching mechanisms for frequently accessed buffer regions.","ref":"Raxol.Terminal.Buffer.CacheManager.html","title":"Raxol.Terminal.Buffer.CacheManager","type":"module"},{"doc":"","ref":"Raxol.Terminal.Buffer.CacheManager.html#t:cache_entry/0","title":"Raxol.Terminal.Buffer.CacheManager.cache_entry/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Buffer.CacheManager.html#t:cache_key/0","title":"Raxol.Terminal.Buffer.CacheManager.cache_key/0","type":"type"},{"doc":"Gets a value from the cache.","ref":"Raxol.Terminal.Buffer.CacheManager.html#get/2","title":"Raxol.Terminal.Buffer.CacheManager.get/2","type":"function"},{"doc":"* `cache` - The cache manager instance\n  * `key` - The cache key","ref":"Raxol.Terminal.Buffer.CacheManager.html#get/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.CacheManager.get/2","type":"function"},{"doc":"* `{:ok, value}` - The cached value if found\n  * `:miss` - If the value is not in cache","ref":"Raxol.Terminal.Buffer.CacheManager.html#get/2-returns","title":"Returns - Raxol.Terminal.Buffer.CacheManager.get/2","type":"function"},{"doc":"Invalidates a cache entry.","ref":"Raxol.Terminal.Buffer.CacheManager.html#invalidate/2","title":"Raxol.Terminal.Buffer.CacheManager.invalidate/2","type":"function"},{"doc":"* `cache` - The cache manager instance\n  * `key` - The cache key to invalidate","ref":"Raxol.Terminal.Buffer.CacheManager.html#invalidate/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.CacheManager.invalidate/2","type":"function"},{"doc":"* Updated cache manager instance","ref":"Raxol.Terminal.Buffer.CacheManager.html#invalidate/2-returns","title":"Returns - Raxol.Terminal.Buffer.CacheManager.invalidate/2","type":"function"},{"doc":"Creates a new cache manager with the specified maximum size.","ref":"Raxol.Terminal.Buffer.CacheManager.html#new/1","title":"Raxol.Terminal.Buffer.CacheManager.new/1","type":"function"},{"doc":"* `max_size` - Maximum number of cache entries (default: 1000)","ref":"Raxol.Terminal.Buffer.CacheManager.html#new/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.CacheManager.new/1","type":"function"},{"doc":"* A new cache manager instance","ref":"Raxol.Terminal.Buffer.CacheManager.html#new/1-returns","title":"Returns - Raxol.Terminal.Buffer.CacheManager.new/1","type":"function"},{"doc":"Puts a value in the cache.","ref":"Raxol.Terminal.Buffer.CacheManager.html#put/3","title":"Raxol.Terminal.Buffer.CacheManager.put/3","type":"function"},{"doc":"* `cache` - The cache manager instance\n  * `key` - The cache key\n  * `value` - The value to cache","ref":"Raxol.Terminal.Buffer.CacheManager.html#put/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.CacheManager.put/3","type":"function"},{"doc":"* Updated cache manager instance","ref":"Raxol.Terminal.Buffer.CacheManager.html#put/3-returns","title":"Returns - Raxol.Terminal.Buffer.CacheManager.put/3","type":"function"},{"doc":"Gets cache statistics.","ref":"Raxol.Terminal.Buffer.CacheManager.html#stats/1","title":"Raxol.Terminal.Buffer.CacheManager.stats/1","type":"function"},{"doc":"* `cache` - The cache manager instance","ref":"Raxol.Terminal.Buffer.CacheManager.html#stats/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.CacheManager.stats/1","type":"function"},{"doc":"* Map containing cache statistics","ref":"Raxol.Terminal.Buffer.CacheManager.html#stats/1-returns","title":"Returns - Raxol.Terminal.Buffer.CacheManager.stats/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.CacheManager.html#t:t/0","title":"Raxol.Terminal.Buffer.CacheManager.t/0","type":"type"},{"doc":"Manages terminal cell operations and attributes.","ref":"Raxol.Terminal.Buffer.Cell.html","title":"Raxol.Terminal.Buffer.Cell","type":"module"},{"doc":"Copies attributes from one cell to another.","ref":"Raxol.Terminal.Buffer.Cell.html#copy_attributes/2","title":"Raxol.Terminal.Buffer.Cell.copy_attributes/2","type":"function"},{"doc":"Checks if the cell is empty.","ref":"Raxol.Terminal.Buffer.Cell.html#empty?/1","title":"Raxol.Terminal.Buffer.Cell.empty?/1","type":"function"},{"doc":"Gets the cell's attributes.","ref":"Raxol.Terminal.Buffer.Cell.html#get_attributes/1","title":"Raxol.Terminal.Buffer.Cell.get_attributes/1","type":"function"},{"doc":"Gets the cell's background color.","ref":"Raxol.Terminal.Buffer.Cell.html#get_background/1","title":"Raxol.Terminal.Buffer.Cell.get_background/1","type":"function"},{"doc":"Gets the cell's character.","ref":"Raxol.Terminal.Buffer.Cell.html#get_char/1","title":"Raxol.Terminal.Buffer.Cell.get_char/1","type":"function"},{"doc":"Gets the cell's foreground color.","ref":"Raxol.Terminal.Buffer.Cell.html#get_foreground/1","title":"Raxol.Terminal.Buffer.Cell.get_foreground/1","type":"function"},{"doc":"Gets the cell's hyperlink.","ref":"Raxol.Terminal.Buffer.Cell.html#get_hyperlink/1","title":"Raxol.Terminal.Buffer.Cell.get_hyperlink/1","type":"function"},{"doc":"Gets the cell's width.","ref":"Raxol.Terminal.Buffer.Cell.html#get_width/1","title":"Raxol.Terminal.Buffer.Cell.get_width/1","type":"function"},{"doc":"Creates a new cell with default settings.","ref":"Raxol.Terminal.Buffer.Cell.html#new/1","title":"Raxol.Terminal.Buffer.Cell.new/1","type":"function"},{"doc":"Creates a new cell with the specified character and style.","ref":"Raxol.Terminal.Buffer.Cell.html#new/2","title":"Raxol.Terminal.Buffer.Cell.new/2","type":"function"},{"doc":"Resets a cell to its default state.","ref":"Raxol.Terminal.Buffer.Cell.html#reset/1","title":"Raxol.Terminal.Buffer.Cell.reset/1","type":"function"},{"doc":"Sets the cell's attributes.","ref":"Raxol.Terminal.Buffer.Cell.html#set_attributes/2","title":"Raxol.Terminal.Buffer.Cell.set_attributes/2","type":"function"},{"doc":"Sets the cell's background color.","ref":"Raxol.Terminal.Buffer.Cell.html#set_background/2","title":"Raxol.Terminal.Buffer.Cell.set_background/2","type":"function"},{"doc":"Sets the cell's character.","ref":"Raxol.Terminal.Buffer.Cell.html#set_char/2","title":"Raxol.Terminal.Buffer.Cell.set_char/2","type":"function"},{"doc":"Sets the cell's foreground color.","ref":"Raxol.Terminal.Buffer.Cell.html#set_foreground/2","title":"Raxol.Terminal.Buffer.Cell.set_foreground/2","type":"function"},{"doc":"Sets the cell's hyperlink.","ref":"Raxol.Terminal.Buffer.Cell.html#set_hyperlink/2","title":"Raxol.Terminal.Buffer.Cell.set_hyperlink/2","type":"function"},{"doc":"Sets the cell's width.","ref":"Raxol.Terminal.Buffer.Cell.html#set_width/2","title":"Raxol.Terminal.Buffer.Cell.set_width/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Cell.html#t:t/0","title":"Raxol.Terminal.Buffer.Cell.t/0","type":"type"},{"doc":"Validates a cell's data.\nReturns true if the cell is valid, false otherwise.","ref":"Raxol.Terminal.Buffer.Cell.html#valid?/1","title":"Raxol.Terminal.Buffer.Cell.valid?/1","type":"function"},{"doc":"Manages terminal character editing operations.","ref":"Raxol.Terminal.Buffer.CharEditor.html","title":"Raxol.Terminal.Buffer.CharEditor","type":"module"},{"doc":"Gets the width of a character.","ref":"Raxol.Terminal.Buffer.CharEditor.html#char_width/1","title":"Raxol.Terminal.Buffer.CharEditor.char_width/1","type":"function"},{"doc":"Checks if a character is a control character.","ref":"Raxol.Terminal.Buffer.CharEditor.html#control_char?/1","title":"Raxol.Terminal.Buffer.CharEditor.control_char?/1","type":"function"},{"doc":"Deletes a character at the current position.","ref":"Raxol.Terminal.Buffer.CharEditor.html#delete_char/1","title":"Raxol.Terminal.Buffer.CharEditor.delete_char/1","type":"function"},{"doc":"Deletes a specified number of characters starting from the given position.\nCharacters to the right of the deleted characters are shifted left.\nBlank characters are added at the end of the line using the provided default style.","ref":"Raxol.Terminal.Buffer.CharEditor.html#delete_characters/5","title":"Raxol.Terminal.Buffer.CharEditor.delete_characters/5","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `row` - The row to delete characters from\n* `col` - The column to start deleting from\n* `count` - The number of characters to delete\n* `default_style` - The style to apply to new characters","ref":"Raxol.Terminal.Buffer.CharEditor.html#delete_characters/5-parameters","title":"Parameters - Raxol.Terminal.Buffer.CharEditor.delete_characters/5","type":"function"},{"doc":"The updated screen buffer.","ref":"Raxol.Terminal.Buffer.CharEditor.html#delete_characters/5-returns","title":"Returns - Raxol.Terminal.Buffer.CharEditor.delete_characters/5","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> style = %{fg: :red, bg: :blue}\n    iex> buffer = CharEditor.delete_characters(buffer, 0, 0, 5, style)\n    iex> CharEditor.get_char(buffer, 0, 0)\n    \" \"","ref":"Raxol.Terminal.Buffer.CharEditor.html#delete_characters/5-examples","title":"Examples - Raxol.Terminal.Buffer.CharEditor.delete_characters/5","type":"function"},{"doc":"Deletes a string of characters.","ref":"Raxol.Terminal.Buffer.CharEditor.html#delete_string/2","title":"Raxol.Terminal.Buffer.CharEditor.delete_string/2","type":"function"},{"doc":"Inserts a character at the current position.","ref":"Raxol.Terminal.Buffer.CharEditor.html#insert_char/2","title":"Raxol.Terminal.Buffer.CharEditor.insert_char/2","type":"function"},{"doc":"Inserts a specified number of blank characters at the given position.\nCharacters to the right of the insertion point are shifted right.\nCharacters shifted off the end of the line are discarded.\nUses the provided default style for new characters.","ref":"Raxol.Terminal.Buffer.CharEditor.html#insert_characters/5","title":"Raxol.Terminal.Buffer.CharEditor.insert_characters/5","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `row` - The row to insert characters in\n* `col` - The column to start inserting at\n* `count` - The number of characters to insert\n* `default_style` - The style to apply to new characters","ref":"Raxol.Terminal.Buffer.CharEditor.html#insert_characters/5-parameters","title":"Parameters - Raxol.Terminal.Buffer.CharEditor.insert_characters/5","type":"function"},{"doc":"The updated screen buffer.","ref":"Raxol.Terminal.Buffer.CharEditor.html#insert_characters/5-returns","title":"Returns - Raxol.Terminal.Buffer.CharEditor.insert_characters/5","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> style = %{fg: :red, bg: :blue}\n    iex> buffer = CharEditor.insert_characters(buffer, 0, 0, 5, style)\n    iex> CharEditor.get_char(buffer, 0, 0)\n    \" \"","ref":"Raxol.Terminal.Buffer.CharEditor.html#insert_characters/5-examples","title":"Examples - Raxol.Terminal.Buffer.CharEditor.insert_characters/5","type":"function"},{"doc":"Inserts characters into a line at the specified position.","ref":"Raxol.Terminal.Buffer.CharEditor.html#insert_into_line/4","title":"Raxol.Terminal.Buffer.CharEditor.insert_into_line/4","type":"function"},{"doc":"* `line` - The line to modify\n* `col` - The column to start inserting at\n* `count` - The number of characters to insert\n* `default_style` - The style to apply to new characters","ref":"Raxol.Terminal.Buffer.CharEditor.html#insert_into_line/4-parameters","title":"Parameters - Raxol.Terminal.Buffer.CharEditor.insert_into_line/4","type":"function"},{"doc":"The updated line with inserted characters.","ref":"Raxol.Terminal.Buffer.CharEditor.html#insert_into_line/4-returns","title":"Returns - Raxol.Terminal.Buffer.CharEditor.insert_into_line/4","type":"function"},{"doc":"iex> line = List.duplicate(%Cell{}, 10)\n    iex> style = %{fg: :red, bg: :blue}\n    iex> new_line = CharEditor.insert_into_line(line, 5, 3, style)\n    iex> length(new_line)\n    10","ref":"Raxol.Terminal.Buffer.CharEditor.html#insert_into_line/4-examples","title":"Examples - Raxol.Terminal.Buffer.CharEditor.insert_into_line/4","type":"function"},{"doc":"Inserts a string of characters.","ref":"Raxol.Terminal.Buffer.CharEditor.html#insert_string/2","title":"Raxol.Terminal.Buffer.CharEditor.insert_string/2","type":"function"},{"doc":"Checks if a character is a printable character.","ref":"Raxol.Terminal.Buffer.CharEditor.html#printable_char?/1","title":"Raxol.Terminal.Buffer.CharEditor.printable_char?/1","type":"function"},{"doc":"Replaces a character at the current position.","ref":"Raxol.Terminal.Buffer.CharEditor.html#replace_char/2","title":"Raxol.Terminal.Buffer.CharEditor.replace_char/2","type":"function"},{"doc":"Replaces a string of characters.","ref":"Raxol.Terminal.Buffer.CharEditor.html#replace_string/2","title":"Raxol.Terminal.Buffer.CharEditor.replace_string/2","type":"function"},{"doc":"Gets the width of a string.","ref":"Raxol.Terminal.Buffer.CharEditor.html#string_width/1","title":"Raxol.Terminal.Buffer.CharEditor.string_width/1","type":"function"},{"doc":"Checks if a character is a whitespace character.","ref":"Raxol.Terminal.Buffer.CharEditor.html#whitespace_char?/1","title":"Raxol.Terminal.Buffer.CharEditor.whitespace_char?/1","type":"function"},{"doc":"Handles character-based operations in the terminal buffer.","ref":"Raxol.Terminal.Buffer.CharOperations.html","title":"Raxol.Terminal.Buffer.CharOperations","type":"module"},{"doc":"Deletes a specified number of characters starting from the current cursor position.\nCharacters to the right of the deleted characters are shifted left, and blank characters are added at the end.","ref":"Raxol.Terminal.Buffer.CharOperations.html#delete_chars/2","title":"Raxol.Terminal.Buffer.CharOperations.delete_chars/2","type":"function"},{"doc":"Helper function that handles the line manipulation logic for deleting characters.\nSplits the line at the cursor position, removes characters, and adds blanks at the end.","ref":"Raxol.Terminal.Buffer.CharOperations.html#delete_chars_from_line/3","title":"Raxol.Terminal.Buffer.CharOperations.delete_chars_from_line/3","type":"function"},{"doc":"* `line` - The line to modify\n* `x` - The column to start deleting from\n* `count` - The number of characters to delete","ref":"Raxol.Terminal.Buffer.CharOperations.html#delete_chars_from_line/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.CharOperations.delete_chars_from_line/3","type":"function"},{"doc":"The updated line with characters deleted and blanks added at the end.","ref":"Raxol.Terminal.Buffer.CharOperations.html#delete_chars_from_line/3-returns","title":"Returns - Raxol.Terminal.Buffer.CharOperations.delete_chars_from_line/3","type":"function"},{"doc":"iex> line = List.duplicate(%Cell{char: \"A\"}, 10)\n    iex> new_line = CharOperations.delete_chars_from_line(line, 5, 3)\n    iex> length(new_line)\n    10\n    iex> Enum.at(new_line, 5).char\n    \" \"","ref":"Raxol.Terminal.Buffer.CharOperations.html#delete_chars_from_line/3-examples","title":"Examples - Raxol.Terminal.Buffer.CharOperations.delete_chars_from_line/3","type":"function"},{"doc":"Inserts a specified number of blank characters at the given position.\nCharacters to the right of the insertion point are shifted right.\nCharacters shifted off the end of the line are discarded.","ref":"Raxol.Terminal.Buffer.CharOperations.html#insert_characters/5","title":"Raxol.Terminal.Buffer.CharOperations.insert_characters/5","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `row` - The row to insert characters in\n* `col` - The column to start inserting at\n* `count` - The number of characters to insert\n* `default_style` - The style to apply to new characters","ref":"Raxol.Terminal.Buffer.CharOperations.html#insert_characters/5-parameters","title":"Parameters - Raxol.Terminal.Buffer.CharOperations.insert_characters/5","type":"function"},{"doc":"The updated screen buffer.","ref":"Raxol.Terminal.Buffer.CharOperations.html#insert_characters/5-returns","title":"Returns - Raxol.Terminal.Buffer.CharOperations.insert_characters/5","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> style = %{fg: :red, bg: :blue}\n    iex> buffer = CharOperations.insert_characters(buffer, 0, 0, 5, style)\n    iex> CharOperations.get_char(buffer, 0, 0)\n    \" \"","ref":"Raxol.Terminal.Buffer.CharOperations.html#insert_characters/5-examples","title":"Examples - Raxol.Terminal.Buffer.CharOperations.insert_characters/5","type":"function"},{"doc":"Inserts a specified number of blank characters at the current cursor position.\nCharacters to the right of the cursor are shifted right, and characters shifted off the end are discarded.","ref":"Raxol.Terminal.Buffer.CharOperations.html#insert_chars/2","title":"Raxol.Terminal.Buffer.CharOperations.insert_chars/2","type":"function"},{"doc":"Inserts characters into a line at the specified position.","ref":"Raxol.Terminal.Buffer.CharOperations.html#insert_into_line/4","title":"Raxol.Terminal.Buffer.CharOperations.insert_into_line/4","type":"function"},{"doc":"* `line` - The line to modify\n* `col` - The column to start inserting at\n* `count` - The number of characters to insert\n* `default_style` - The style to apply to new characters","ref":"Raxol.Terminal.Buffer.CharOperations.html#insert_into_line/4-parameters","title":"Parameters - Raxol.Terminal.Buffer.CharOperations.insert_into_line/4","type":"function"},{"doc":"The updated line with inserted characters.","ref":"Raxol.Terminal.Buffer.CharOperations.html#insert_into_line/4-returns","title":"Returns - Raxol.Terminal.Buffer.CharOperations.insert_into_line/4","type":"function"},{"doc":"iex> line = List.duplicate(%Cell{}, 10)\n    iex> style = %{fg: :red, bg: :blue}\n    iex> new_line = CharOperations.insert_into_line(line, 5, 3, style)\n    iex> length(new_line)\n    10","ref":"Raxol.Terminal.Buffer.CharOperations.html#insert_into_line/4-examples","title":"Examples - Raxol.Terminal.Buffer.CharOperations.insert_into_line/4","type":"function"},{"doc":"Manages character set state and operations for the screen buffer.\nThis module handles character set designations, G-sets, and single shifts.","ref":"Raxol.Terminal.Buffer.Charset.html","title":"Raxol.Terminal.Buffer.Charset","type":"module"},{"doc":"Applies a single shift to a specific G-set.","ref":"Raxol.Terminal.Buffer.Charset.html#apply_single_shift/2","title":"Raxol.Terminal.Buffer.Charset.apply_single_shift/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `slot` - The G-set to shift to (:g0, :g1, :g2, or :g3)","ref":"Raxol.Terminal.Buffer.Charset.html#apply_single_shift/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Charset.apply_single_shift/2","type":"function"},{"doc":"The updated screen buffer with new single shift.","ref":"Raxol.Terminal.Buffer.Charset.html#apply_single_shift/2-returns","title":"Returns - Raxol.Terminal.Buffer.Charset.apply_single_shift/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Charset.apply_single_shift(buffer, :g1)\n    iex> Charset.get_single_shift(buffer)\n    :g1","ref":"Raxol.Terminal.Buffer.Charset.html#apply_single_shift/2-examples","title":"Examples - Raxol.Terminal.Buffer.Charset.apply_single_shift/2","type":"function"},{"doc":"Designates a character set to a specific slot.","ref":"Raxol.Terminal.Buffer.Charset.html#designate/3","title":"Raxol.Terminal.Buffer.Charset.designate/3","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `slot` - The slot to designate (:g0, :g1, :g2, or :g3)\n* `charset` - The character set to designate","ref":"Raxol.Terminal.Buffer.Charset.html#designate/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.Charset.designate/3","type":"function"},{"doc":"The updated screen buffer with new charset designation.","ref":"Raxol.Terminal.Buffer.Charset.html#designate/3-returns","title":"Returns - Raxol.Terminal.Buffer.Charset.designate/3","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Charset.designate(buffer, :g0, :us_ascii)\n    iex> Charset.get_designated(buffer, :g0)\n    :us_ascii","ref":"Raxol.Terminal.Buffer.Charset.html#designate/3-examples","title":"Examples - Raxol.Terminal.Buffer.Charset.designate/3","type":"function"},{"doc":"Gets the current G-set.","ref":"Raxol.Terminal.Buffer.Charset.html#get_current_g_set/1","title":"Raxol.Terminal.Buffer.Charset.get_current_g_set/1","type":"function"},{"doc":"* `buffer` - The screen buffer to query","ref":"Raxol.Terminal.Buffer.Charset.html#get_current_g_set/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Charset.get_current_g_set/1","type":"function"},{"doc":"The current G-set.","ref":"Raxol.Terminal.Buffer.Charset.html#get_current_g_set/1-returns","title":"Returns - Raxol.Terminal.Buffer.Charset.get_current_g_set/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Charset.get_current_g_set(buffer)\n    :g0","ref":"Raxol.Terminal.Buffer.Charset.html#get_current_g_set/1-examples","title":"Examples - Raxol.Terminal.Buffer.Charset.get_current_g_set/1","type":"function"},{"doc":"Gets the designated character set for a specific slot.","ref":"Raxol.Terminal.Buffer.Charset.html#get_designated/2","title":"Raxol.Terminal.Buffer.Charset.get_designated/2","type":"function"},{"doc":"* `buffer` - The screen buffer to query\n* `slot` - The slot to query (:g0, :g1, :g2, or :g3)","ref":"Raxol.Terminal.Buffer.Charset.html#get_designated/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Charset.get_designated/2","type":"function"},{"doc":"The designated character set for the slot.","ref":"Raxol.Terminal.Buffer.Charset.html#get_designated/2-returns","title":"Returns - Raxol.Terminal.Buffer.Charset.get_designated/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Charset.get_designated(buffer, :g0)\n    :us_ascii","ref":"Raxol.Terminal.Buffer.Charset.html#get_designated/2-examples","title":"Examples - Raxol.Terminal.Buffer.Charset.get_designated/2","type":"function"},{"doc":"Gets the current single shift.","ref":"Raxol.Terminal.Buffer.Charset.html#get_single_shift/1","title":"Raxol.Terminal.Buffer.Charset.get_single_shift/1","type":"function"},{"doc":"* `buffer` - The screen buffer to query","ref":"Raxol.Terminal.Buffer.Charset.html#get_single_shift/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Charset.get_single_shift/1","type":"function"},{"doc":"The current single shift or nil if none is active.","ref":"Raxol.Terminal.Buffer.Charset.html#get_single_shift/1-returns","title":"Returns - Raxol.Terminal.Buffer.Charset.get_single_shift/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Charset.get_single_shift(buffer)\n    nil","ref":"Raxol.Terminal.Buffer.Charset.html#get_single_shift/1-examples","title":"Examples - Raxol.Terminal.Buffer.Charset.get_single_shift/1","type":"function"},{"doc":"Initializes a new charset state with default values.","ref":"Raxol.Terminal.Buffer.Charset.html#init/0","title":"Raxol.Terminal.Buffer.Charset.init/0","type":"function"},{"doc":"Invokes a G-set for the left or right side.","ref":"Raxol.Terminal.Buffer.Charset.html#invoke_g_set/2","title":"Raxol.Terminal.Buffer.Charset.invoke_g_set/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `slot` - The G-set to invoke (:g0, :g1, :g2, or :g3)","ref":"Raxol.Terminal.Buffer.Charset.html#invoke_g_set/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Charset.invoke_g_set/2","type":"function"},{"doc":"The updated screen buffer with new G-set invocation.","ref":"Raxol.Terminal.Buffer.Charset.html#invoke_g_set/2-returns","title":"Returns - Raxol.Terminal.Buffer.Charset.invoke_g_set/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Charset.invoke_g_set(buffer, :g1)\n    iex> Charset.get_current_g_set(buffer)\n    :g1","ref":"Raxol.Terminal.Buffer.Charset.html#invoke_g_set/2-examples","title":"Examples - Raxol.Terminal.Buffer.Charset.invoke_g_set/2","type":"function"},{"doc":"Resets the charset state to default values.","ref":"Raxol.Terminal.Buffer.Charset.html#reset/1","title":"Raxol.Terminal.Buffer.Charset.reset/1","type":"function"},{"doc":"* `buffer` - The screen buffer to modify","ref":"Raxol.Terminal.Buffer.Charset.html#reset/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Charset.reset/1","type":"function"},{"doc":"The updated screen buffer with reset charset state.","ref":"Raxol.Terminal.Buffer.Charset.html#reset/1-returns","title":"Returns - Raxol.Terminal.Buffer.Charset.reset/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Charset.reset(buffer)\n    iex> Charset.get_current_g_set(buffer)\n    :g0","ref":"Raxol.Terminal.Buffer.Charset.html#reset/1-examples","title":"Examples - Raxol.Terminal.Buffer.Charset.reset/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Charset.html#t:t/0","title":"Raxol.Terminal.Buffer.Charset.t/0","type":"type"},{"doc":"Translates a character according to the current charset state.","ref":"Raxol.Terminal.Buffer.Charset.html#translate_char/2","title":"Raxol.Terminal.Buffer.Charset.translate_char/2","type":"function"},{"doc":"* `buffer` - The screen buffer to use for translation\n* `char` - The character to translate","ref":"Raxol.Terminal.Buffer.Charset.html#translate_char/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Charset.translate_char/2","type":"function"},{"doc":"The translated character.","ref":"Raxol.Terminal.Buffer.Charset.html#translate_char/2-returns","title":"Returns - Raxol.Terminal.Buffer.Charset.translate_char/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Charset.translate_char(buffer, \"A\")\n    \"A\"","ref":"Raxol.Terminal.Buffer.Charset.html#translate_char/2-examples","title":"Examples - Raxol.Terminal.Buffer.Charset.translate_char/2","type":"function"},{"doc":"Handles buffer commands for the unified buffer manager.","ref":"Raxol.Terminal.Buffer.CommandHandler.html","title":"Raxol.Terminal.Buffer.CommandHandler","type":"module"},{"doc":"","ref":"Raxol.Terminal.Buffer.CommandHandler.html#handle_command/2","title":"Raxol.Terminal.Buffer.CommandHandler.handle_command/2","type":"function"},{"doc":"Common buffer operations shared between different buffer-related modules.\nThis module provides utility functions for buffer manipulation that are used\nby multiple modules to avoid code duplication.","ref":"Raxol.Terminal.Buffer.Common.html","title":"Raxol.Terminal.Buffer.Common","type":"module"},{"doc":"Appends new lines to existing lines.","ref":"Raxol.Terminal.Buffer.Common.html#append_lines/2","title":"Raxol.Terminal.Buffer.Common.append_lines/2","type":"function"},{"doc":"* `lines` - Current buffer lines\n  * `new_lines` - Lines to append","ref":"Raxol.Terminal.Buffer.Common.html#append_lines/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Common.append_lines/2","type":"function"},{"doc":"* `{:ok, combined_lines}` on success","ref":"Raxol.Terminal.Buffer.Common.html#append_lines/2-returns","title":"Returns - Raxol.Terminal.Buffer.Common.append_lines/2","type":"function"},{"doc":"Creates a single empty line with optional styling.","ref":"Raxol.Terminal.Buffer.Common.html#create_empty_line/1","title":"Raxol.Terminal.Buffer.Common.create_empty_line/1","type":"function"},{"doc":"* `blank_style` - Optional style to apply to blank line","ref":"Raxol.Terminal.Buffer.Common.html#create_empty_line/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Common.create_empty_line/1","type":"function"},{"doc":"Empty line with optional styling","ref":"Raxol.Terminal.Buffer.Common.html#create_empty_line/1-returns","title":"Returns - Raxol.Terminal.Buffer.Common.create_empty_line/1","type":"function"},{"doc":"Creates empty lines with optional styling.","ref":"Raxol.Terminal.Buffer.Common.html#create_empty_lines/2","title":"Raxol.Terminal.Buffer.Common.create_empty_lines/2","type":"function"},{"doc":"* `count` - Number of lines to create\n  * `blank_style` - Optional style to apply to blank lines","ref":"Raxol.Terminal.Buffer.Common.html#create_empty_lines/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Common.create_empty_lines/2","type":"function"},{"doc":"* `{:ok, new_lines}` on success","ref":"Raxol.Terminal.Buffer.Common.html#create_empty_lines/2-returns","title":"Returns - Raxol.Terminal.Buffer.Common.create_empty_lines/2","type":"function"},{"doc":"Gets the lines within a specific region of the buffer.","ref":"Raxol.Terminal.Buffer.Common.html#get_region_lines/3","title":"Raxol.Terminal.Buffer.Common.get_region_lines/3","type":"function"},{"doc":"* `lines` - Current buffer lines\n  * `top` - Top boundary of region\n  * `bottom` - Bottom boundary of region","ref":"Raxol.Terminal.Buffer.Common.html#get_region_lines/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.Common.get_region_lines/3","type":"function"},{"doc":"* `{:ok, region_lines}` on success\n  * `{:error, :invalid_region}` on failure","ref":"Raxol.Terminal.Buffer.Common.html#get_region_lines/3-returns","title":"Returns - Raxol.Terminal.Buffer.Common.get_region_lines/3","type":"function"},{"doc":"Gets the bottom boundary of the scroll region.","ref":"Raxol.Terminal.Buffer.Common.html#get_scroll_bottom/2","title":"Raxol.Terminal.Buffer.Common.get_scroll_bottom/2","type":"function"},{"doc":"* `buffer` - The screen buffer\n  * `scroll_region` - Optional scroll region override","ref":"Raxol.Terminal.Buffer.Common.html#get_scroll_bottom/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Common.get_scroll_bottom/2","type":"function"},{"doc":"* `{:ok, bottom}` on success\n  * `{:error, reason}` on failure","ref":"Raxol.Terminal.Buffer.Common.html#get_scroll_bottom/2-returns","title":"Returns - Raxol.Terminal.Buffer.Common.get_scroll_bottom/2","type":"function"},{"doc":"Gets the top boundary of the scroll region.","ref":"Raxol.Terminal.Buffer.Common.html#get_scroll_top/2","title":"Raxol.Terminal.Buffer.Common.get_scroll_top/2","type":"function"},{"doc":"* `buffer` - The screen buffer\n  * `scroll_region` - Optional scroll region override","ref":"Raxol.Terminal.Buffer.Common.html#get_scroll_top/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Common.get_scroll_top/2","type":"function"},{"doc":"* `{:ok, top}` on success\n  * `{:error, reason}` on failure","ref":"Raxol.Terminal.Buffer.Common.html#get_scroll_top/2-returns","title":"Returns - Raxol.Terminal.Buffer.Common.get_scroll_top/2","type":"function"},{"doc":"Replaces content in a specific region of the buffer.","ref":"Raxol.Terminal.Buffer.Common.html#replace_region/4","title":"Raxol.Terminal.Buffer.Common.replace_region/4","type":"function"},{"doc":"* `lines` - Current buffer lines\n  * `new_region` - New content for the region\n  * `top` - Top boundary of region\n  * `bottom` - Bottom boundary of region","ref":"Raxol.Terminal.Buffer.Common.html#replace_region/4-parameters","title":"Parameters - Raxol.Terminal.Buffer.Common.replace_region/4","type":"function"},{"doc":"Updated buffer lines with the region replaced","ref":"Raxol.Terminal.Buffer.Common.html#replace_region/4-returns","title":"Returns - Raxol.Terminal.Buffer.Common.replace_region/4","type":"function"},{"doc":"Handles content operations for the screen buffer.\nThis module provides functions for writing and reading content from the buffer,\nincluding character and string operations.","ref":"Raxol.Terminal.Buffer.Content.html","title":"Raxol.Terminal.Buffer.Content","type":"module"},{"doc":"Calculates the difference between the current buffer state and a list of changes.","ref":"Raxol.Terminal.Buffer.Content.html#diff/2","title":"Raxol.Terminal.Buffer.Content.diff/2","type":"function"},{"doc":"Gets a cell at the specified position.","ref":"Raxol.Terminal.Buffer.Content.html#get_cell/3","title":"Raxol.Terminal.Buffer.Content.get_cell/3","type":"function"},{"doc":"Gets a character at the specified position.","ref":"Raxol.Terminal.Buffer.Content.html#get_char/3","title":"Raxol.Terminal.Buffer.Content.get_char/3","type":"function"},{"doc":"Gets the entire buffer content as a string.","ref":"Raxol.Terminal.Buffer.Content.html#get_content/1","title":"Raxol.Terminal.Buffer.Content.get_content/1","type":"function"},{"doc":"Gets a line of cells from the buffer.","ref":"Raxol.Terminal.Buffer.Content.html#get_line/2","title":"Raxol.Terminal.Buffer.Content.get_line/2","type":"function"},{"doc":"Updates a line in the buffer with new cells.","ref":"Raxol.Terminal.Buffer.Content.html#put_line/3","title":"Raxol.Terminal.Buffer.Content.put_line/3","type":"function"},{"doc":"Updates the buffer with a list of changes.","ref":"Raxol.Terminal.Buffer.Content.html#update/2","title":"Raxol.Terminal.Buffer.Content.update/2","type":"function"},{"doc":"Writes a character at the specified position with optional styling.","ref":"Raxol.Terminal.Buffer.Content.html#write_char/5","title":"Raxol.Terminal.Buffer.Content.write_char/5","type":"function"},{"doc":"Writes a string starting at the specified position.","ref":"Raxol.Terminal.Buffer.Content.html#write_string/5","title":"Raxol.Terminal.Buffer.Content.write_string/5","type":"function"},{"doc":"Manages cursor state and operations for the screen buffer.\nThis module handles cursor position, visibility, style, and blink state.","ref":"Raxol.Terminal.Buffer.Cursor.html","title":"Raxol.Terminal.Buffer.Cursor","type":"module"},{"doc":"Checks if the cursor is blinking.","ref":"Raxol.Terminal.Buffer.Cursor.html#blinking?/1","title":"Raxol.Terminal.Buffer.Cursor.blinking?/1","type":"function"},{"doc":"* `cursor` - The cursor to query","ref":"Raxol.Terminal.Buffer.Cursor.html#blinking?/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Cursor.blinking?/1","type":"function"},{"doc":"A boolean indicating if the cursor is blinking.","ref":"Raxol.Terminal.Buffer.Cursor.html#blinking?/1-returns","title":"Returns - Raxol.Terminal.Buffer.Cursor.blinking?/1","type":"function"},{"doc":"iex> cursor = Cursor.init()\n    iex> Cursor.blinking?(cursor)\n    true","ref":"Raxol.Terminal.Buffer.Cursor.html#blinking?/1-examples","title":"Examples - Raxol.Terminal.Buffer.Cursor.blinking?/1","type":"function"},{"doc":"Gets the cursor position as a tuple of {row, col}.","ref":"Raxol.Terminal.Buffer.Cursor.html#get_cursor_position/1","title":"Raxol.Terminal.Buffer.Cursor.get_cursor_position/1","type":"function"},{"doc":"* `cursor` - The cursor to query","ref":"Raxol.Terminal.Buffer.Cursor.html#get_cursor_position/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Cursor.get_cursor_position/1","type":"function"},{"doc":"A tuple {row, col} representing the cursor position.","ref":"Raxol.Terminal.Buffer.Cursor.html#get_cursor_position/1-returns","title":"Returns - Raxol.Terminal.Buffer.Cursor.get_cursor_position/1","type":"function"},{"doc":"iex> cursor = Cursor.init()\n    iex> Cursor.get_cursor_position(cursor)\n    {0, 0}","ref":"Raxol.Terminal.Buffer.Cursor.html#get_cursor_position/1-examples","title":"Examples - Raxol.Terminal.Buffer.Cursor.get_cursor_position/1","type":"function"},{"doc":"Gets the current cursor position.","ref":"Raxol.Terminal.Buffer.Cursor.html#get_position/1","title":"Raxol.Terminal.Buffer.Cursor.get_position/1","type":"function"},{"doc":"* `buffer` - The screen buffer to query","ref":"Raxol.Terminal.Buffer.Cursor.html#get_position/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Cursor.get_position/1","type":"function"},{"doc":"A tuple {x, y} representing the cursor position.","ref":"Raxol.Terminal.Buffer.Cursor.html#get_position/1-returns","title":"Returns - Raxol.Terminal.Buffer.Cursor.get_position/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Cursor.get_position(buffer)\n    {0, 0}","ref":"Raxol.Terminal.Buffer.Cursor.html#get_position/1-examples","title":"Examples - Raxol.Terminal.Buffer.Cursor.get_position/1","type":"function"},{"doc":"Gets the current cursor style.","ref":"Raxol.Terminal.Buffer.Cursor.html#get_style/1","title":"Raxol.Terminal.Buffer.Cursor.get_style/1","type":"function"},{"doc":"* `buffer` - The screen buffer to query","ref":"Raxol.Terminal.Buffer.Cursor.html#get_style/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Cursor.get_style/1","type":"function"},{"doc":"The current cursor style.","ref":"Raxol.Terminal.Buffer.Cursor.html#get_style/1-returns","title":"Returns - Raxol.Terminal.Buffer.Cursor.get_style/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Cursor.get_style(buffer)\n    :block","ref":"Raxol.Terminal.Buffer.Cursor.html#get_style/1-examples","title":"Examples - Raxol.Terminal.Buffer.Cursor.get_style/1","type":"function"},{"doc":"Initializes a new cursor state with default values.","ref":"Raxol.Terminal.Buffer.Cursor.html#init/0","title":"Raxol.Terminal.Buffer.Cursor.init/0","type":"function"},{"doc":"Moves the cursor backward by the specified number of columns.","ref":"Raxol.Terminal.Buffer.Cursor.html#move_backward/2","title":"Raxol.Terminal.Buffer.Cursor.move_backward/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `columns` - Number of columns to move backward","ref":"Raxol.Terminal.Buffer.Cursor.html#move_backward/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Cursor.move_backward/2","type":"function"},{"doc":"The updated screen buffer with new cursor position.","ref":"Raxol.Terminal.Buffer.Cursor.html#move_backward/2-returns","title":"Returns - Raxol.Terminal.Buffer.Cursor.move_backward/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Cursor.move_backward(buffer, 2)\n    iex> Cursor.get_position(buffer)\n    {0, 0}  # Cursor stays at left edge","ref":"Raxol.Terminal.Buffer.Cursor.html#move_backward/2-examples","title":"Examples - Raxol.Terminal.Buffer.Cursor.move_backward/2","type":"function"},{"doc":"Moves the cursor down by the specified number of lines.","ref":"Raxol.Terminal.Buffer.Cursor.html#move_down/2","title":"Raxol.Terminal.Buffer.Cursor.move_down/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `lines` - Number of lines to move down","ref":"Raxol.Terminal.Buffer.Cursor.html#move_down/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Cursor.move_down/2","type":"function"},{"doc":"The updated screen buffer with new cursor position.","ref":"Raxol.Terminal.Buffer.Cursor.html#move_down/2-returns","title":"Returns - Raxol.Terminal.Buffer.Cursor.move_down/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Cursor.move_down(buffer, 2)\n    iex> Cursor.get_position(buffer)\n    {0, 2}","ref":"Raxol.Terminal.Buffer.Cursor.html#move_down/2-examples","title":"Examples - Raxol.Terminal.Buffer.Cursor.move_down/2","type":"function"},{"doc":"Moves the cursor forward by the specified number of columns.","ref":"Raxol.Terminal.Buffer.Cursor.html#move_forward/2","title":"Raxol.Terminal.Buffer.Cursor.move_forward/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `columns` - Number of columns to move forward","ref":"Raxol.Terminal.Buffer.Cursor.html#move_forward/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Cursor.move_forward/2","type":"function"},{"doc":"The updated screen buffer with new cursor position.","ref":"Raxol.Terminal.Buffer.Cursor.html#move_forward/2-returns","title":"Returns - Raxol.Terminal.Buffer.Cursor.move_forward/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Cursor.move_forward(buffer, 2)\n    iex> Cursor.get_position(buffer)\n    {2, 0}","ref":"Raxol.Terminal.Buffer.Cursor.html#move_forward/2-examples","title":"Examples - Raxol.Terminal.Buffer.Cursor.move_forward/2","type":"function"},{"doc":"Moves the cursor to the specified position.","ref":"Raxol.Terminal.Buffer.Cursor.html#move_to/2","title":"Raxol.Terminal.Buffer.Cursor.move_to/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `position` - The target position as {x, y}","ref":"Raxol.Terminal.Buffer.Cursor.html#move_to/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Cursor.move_to/2","type":"function"},{"doc":"The updated screen buffer with new cursor position.","ref":"Raxol.Terminal.Buffer.Cursor.html#move_to/2-returns","title":"Returns - Raxol.Terminal.Buffer.Cursor.move_to/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Cursor.move_to(buffer, {10, 5})\n    iex> Cursor.get_position(buffer)\n    {10, 5}","ref":"Raxol.Terminal.Buffer.Cursor.html#move_to/2-examples","title":"Examples - Raxol.Terminal.Buffer.Cursor.move_to/2","type":"function"},{"doc":"Moves the cursor up by the specified number of lines.","ref":"Raxol.Terminal.Buffer.Cursor.html#move_up/2","title":"Raxol.Terminal.Buffer.Cursor.move_up/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `lines` - Number of lines to move up","ref":"Raxol.Terminal.Buffer.Cursor.html#move_up/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Cursor.move_up/2","type":"function"},{"doc":"The updated screen buffer with new cursor position.","ref":"Raxol.Terminal.Buffer.Cursor.html#move_up/2-returns","title":"Returns - Raxol.Terminal.Buffer.Cursor.move_up/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Cursor.move_up(buffer, 2)\n    iex> Cursor.get_position(buffer)\n    {0, 0}  # Cursor stays at top","ref":"Raxol.Terminal.Buffer.Cursor.html#move_up/2-examples","title":"Examples - Raxol.Terminal.Buffer.Cursor.move_up/2","type":"function"},{"doc":"Sets the cursor blink state.","ref":"Raxol.Terminal.Buffer.Cursor.html#set_blink/2","title":"Raxol.Terminal.Buffer.Cursor.set_blink/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `blink` - Whether the cursor should blink","ref":"Raxol.Terminal.Buffer.Cursor.html#set_blink/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Cursor.set_blink/2","type":"function"},{"doc":"The updated screen buffer with new cursor blink state.","ref":"Raxol.Terminal.Buffer.Cursor.html#set_blink/2-returns","title":"Returns - Raxol.Terminal.Buffer.Cursor.set_blink/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Cursor.set_blink(buffer, false)\n    iex> Cursor.blinking?(buffer)\n    false","ref":"Raxol.Terminal.Buffer.Cursor.html#set_blink/2-examples","title":"Examples - Raxol.Terminal.Buffer.Cursor.set_blink/2","type":"function"},{"doc":"Sets the cursor position.","ref":"Raxol.Terminal.Buffer.Cursor.html#set_cursor_position/3","title":"Raxol.Terminal.Buffer.Cursor.set_cursor_position/3","type":"function"},{"doc":"* `cursor` - The cursor to modify\n* `row` - The row position\n* `col` - The column position","ref":"Raxol.Terminal.Buffer.Cursor.html#set_cursor_position/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.Cursor.set_cursor_position/3","type":"function"},{"doc":"The updated cursor with new position.","ref":"Raxol.Terminal.Buffer.Cursor.html#set_cursor_position/3-returns","title":"Returns - Raxol.Terminal.Buffer.Cursor.set_cursor_position/3","type":"function"},{"doc":"iex> cursor = Cursor.init()\n    iex> cursor = Cursor.set_cursor_position(cursor, 5, 10)\n    iex> Cursor.get_cursor_position(cursor)\n    {5, 10}","ref":"Raxol.Terminal.Buffer.Cursor.html#set_cursor_position/3-examples","title":"Examples - Raxol.Terminal.Buffer.Cursor.set_cursor_position/3","type":"function"},{"doc":"Sets the cursor position.","ref":"Raxol.Terminal.Buffer.Cursor.html#set_position/3","title":"Raxol.Terminal.Buffer.Cursor.set_position/3","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `x` - The x-coordinate (column)\n* `y` - The y-coordinate (row)","ref":"Raxol.Terminal.Buffer.Cursor.html#set_position/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.Cursor.set_position/3","type":"function"},{"doc":"The updated screen buffer with new cursor position.","ref":"Raxol.Terminal.Buffer.Cursor.html#set_position/3-returns","title":"Returns - Raxol.Terminal.Buffer.Cursor.set_position/3","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Cursor.set_position(buffer, 10, 5)\n    iex> Cursor.get_position(buffer)\n    {10, 5}","ref":"Raxol.Terminal.Buffer.Cursor.html#set_position/3-examples","title":"Examples - Raxol.Terminal.Buffer.Cursor.set_position/3","type":"function"},{"doc":"Sets the cursor style.","ref":"Raxol.Terminal.Buffer.Cursor.html#set_style/2","title":"Raxol.Terminal.Buffer.Cursor.set_style/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `style` - The cursor style (:block, :underline, :bar)","ref":"Raxol.Terminal.Buffer.Cursor.html#set_style/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Cursor.set_style/2","type":"function"},{"doc":"The updated screen buffer with new cursor style.","ref":"Raxol.Terminal.Buffer.Cursor.html#set_style/2-returns","title":"Returns - Raxol.Terminal.Buffer.Cursor.set_style/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Cursor.set_style(buffer, :underline)\n    iex> Cursor.get_style(buffer)\n    :underline","ref":"Raxol.Terminal.Buffer.Cursor.html#set_style/2-examples","title":"Examples - Raxol.Terminal.Buffer.Cursor.set_style/2","type":"function"},{"doc":"Sets the cursor visibility.","ref":"Raxol.Terminal.Buffer.Cursor.html#set_visibility/2","title":"Raxol.Terminal.Buffer.Cursor.set_visibility/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `visible` - Whether the cursor should be visible","ref":"Raxol.Terminal.Buffer.Cursor.html#set_visibility/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Cursor.set_visibility/2","type":"function"},{"doc":"The updated screen buffer with new cursor visibility.","ref":"Raxol.Terminal.Buffer.Cursor.html#set_visibility/2-returns","title":"Returns - Raxol.Terminal.Buffer.Cursor.set_visibility/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Cursor.set_visibility(buffer, false)\n    iex> Cursor.visible?(buffer)\n    false","ref":"Raxol.Terminal.Buffer.Cursor.html#set_visibility/2-examples","title":"Examples - Raxol.Terminal.Buffer.Cursor.set_visibility/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Cursor.html#t:t/0","title":"Raxol.Terminal.Buffer.Cursor.t/0","type":"type"},{"doc":"Checks if the cursor is visible.","ref":"Raxol.Terminal.Buffer.Cursor.html#visible?/1","title":"Raxol.Terminal.Buffer.Cursor.visible?/1","type":"function"},{"doc":"* `cursor` - The cursor to query","ref":"Raxol.Terminal.Buffer.Cursor.html#visible?/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Cursor.visible?/1","type":"function"},{"doc":"A boolean indicating cursor visibility.","ref":"Raxol.Terminal.Buffer.Cursor.html#visible?/1-returns","title":"Returns - Raxol.Terminal.Buffer.Cursor.visible?/1","type":"function"},{"doc":"iex> cursor = Cursor.init()\n    iex> Cursor.visible?(cursor)\n    true","ref":"Raxol.Terminal.Buffer.Cursor.html#visible?/1-examples","title":"Examples - Raxol.Terminal.Buffer.Cursor.visible?/1","type":"function"},{"doc":"Manages damage tracking for terminal buffers.\n\nHandles marking regions as damaged and merging overlapping regions\nfor efficient redrawing.","ref":"Raxol.Terminal.Buffer.DamageTracker.html","title":"Raxol.Terminal.Buffer.DamageTracker","type":"module"},{"doc":"Clears all tracked damage regions.","ref":"Raxol.Terminal.Buffer.DamageTracker.html#clear_regions/1","title":"Raxol.Terminal.Buffer.DamageTracker.clear_regions/1","type":"function"},{"doc":"Gets the list of distinct damaged regions.","ref":"Raxol.Terminal.Buffer.DamageTracker.html#get_regions/1","title":"Raxol.Terminal.Buffer.DamageTracker.get_regions/1","type":"function"},{"doc":"Marks a rectangular region as damaged.\n\nMerges the new region with any existing overlapping regions.","ref":"Raxol.Terminal.Buffer.DamageTracker.html#mark_damaged/5","title":"Raxol.Terminal.Buffer.DamageTracker.mark_damaged/5","type":"function"},{"doc":"Creates a new, empty damage tracker.","ref":"Raxol.Terminal.Buffer.DamageTracker.html#new/0","title":"Raxol.Terminal.Buffer.DamageTracker.new/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.DamageTracker.html#t:region/0","title":"Raxol.Terminal.Buffer.DamageTracker.region/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Buffer.DamageTracker.html#t:t/0","title":"Raxol.Terminal.Buffer.DamageTracker.t/0","type":"type"},{"doc":"Enhanced buffer manager with advanced features for improved performance.\n\nThis module provides:\n- Asynchronous buffer updates\n- Buffer compression\n- Buffer pooling\n- Performance optimization","ref":"Raxol.Terminal.Buffer.EnhancedManager.html","title":"Raxol.Terminal.Buffer.EnhancedManager","type":"module"},{"doc":"- Async updates for non-blocking operations\n- Compression to reduce memory usage\n- Buffer pooling for efficient memory management\n- Performance monitoring and optimization","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#module-features","title":"Features - Raxol.Terminal.Buffer.EnhancedManager","type":"module"},{"doc":"Compresses the buffer to reduce memory usage.","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#compress_buffer/2","title":"Raxol.Terminal.Buffer.EnhancedManager.compress_buffer/2","type":"function"},{"doc":"* `manager` - The buffer manager instance\n* `opts` - Compression options","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#compress_buffer/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.EnhancedManager.compress_buffer/2","type":"function"},{"doc":"Updated buffer manager instance","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#compress_buffer/2-returns","title":"Returns - Raxol.Terminal.Buffer.EnhancedManager.compress_buffer/2","type":"function"},{"doc":"Gets a buffer from the pool or creates a new one.","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#get_buffer/3","title":"Raxol.Terminal.Buffer.EnhancedManager.get_buffer/3","type":"function"},{"doc":"* `manager` - The buffer manager instance\n* `width` - The width of the buffer\n* `height` - The height of the buffer","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#get_buffer/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.EnhancedManager.get_buffer/3","type":"function"},{"doc":"`{buffer, updated_manager}`","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#get_buffer/3-returns","title":"Returns - Raxol.Terminal.Buffer.EnhancedManager.get_buffer/3","type":"function"},{"doc":"Gets the current performance metrics.","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#get_performance_metrics/1","title":"Raxol.Terminal.Buffer.EnhancedManager.get_performance_metrics/1","type":"function"},{"doc":"* `manager` - The buffer manager instance","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#get_performance_metrics/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.EnhancedManager.get_performance_metrics/1","type":"function"},{"doc":"Map containing performance metrics","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#get_performance_metrics/1-returns","title":"Returns - Raxol.Terminal.Buffer.EnhancedManager.get_performance_metrics/1","type":"function"},{"doc":"Creates a new enhanced buffer manager.","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#new/3","title":"Raxol.Terminal.Buffer.EnhancedManager.new/3","type":"function"},{"doc":"* `width` - The width of the buffer\n* `height` - The height of the buffer\n* `opts` - Additional options","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#new/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.EnhancedManager.new/3","type":"function"},{"doc":"A new enhanced buffer manager instance","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#new/3-returns","title":"Returns - Raxol.Terminal.Buffer.EnhancedManager.new/3","type":"function"},{"doc":"Optimizes the buffer manager based on current performance metrics.","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#optimize/1","title":"Raxol.Terminal.Buffer.EnhancedManager.optimize/1","type":"function"},{"doc":"* `manager` - The buffer manager instance","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#optimize/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.EnhancedManager.optimize/1","type":"function"},{"doc":"Updated buffer manager instance","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#optimize/1-returns","title":"Returns - Raxol.Terminal.Buffer.EnhancedManager.optimize/1","type":"function"},{"doc":"Processes all queued updates.","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#process_updates/1","title":"Raxol.Terminal.Buffer.EnhancedManager.process_updates/1","type":"function"},{"doc":"* `manager` - The buffer manager instance","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#process_updates/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.EnhancedManager.process_updates/1","type":"function"},{"doc":"Updated buffer manager instance","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#process_updates/1-returns","title":"Returns - Raxol.Terminal.Buffer.EnhancedManager.process_updates/1","type":"function"},{"doc":"Queues an asynchronous buffer update.","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#queue_update/2","title":"Raxol.Terminal.Buffer.EnhancedManager.queue_update/2","type":"function"},{"doc":"* `manager` - The buffer manager instance\n* `update_fn` - The function to execute for the update","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#queue_update/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.EnhancedManager.queue_update/2","type":"function"},{"doc":"Updated buffer manager instance","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#queue_update/2-returns","title":"Returns - Raxol.Terminal.Buffer.EnhancedManager.queue_update/2","type":"function"},{"doc":"Returns a buffer to the pool.","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#return_buffer/2","title":"Raxol.Terminal.Buffer.EnhancedManager.return_buffer/2","type":"function"},{"doc":"* `manager` - The buffer manager instance\n* `buffer` - The buffer to return","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#return_buffer/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.EnhancedManager.return_buffer/2","type":"function"},{"doc":"Updated buffer manager instance","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#return_buffer/2-returns","title":"Returns - Raxol.Terminal.Buffer.EnhancedManager.return_buffer/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.EnhancedManager.html#t:t/0","title":"Raxol.Terminal.Buffer.EnhancedManager.t/0","type":"type"},{"doc":"Provides screen clearing operations for the screen buffer.\nThis module handles operations like clearing the screen, lines, and regions.","ref":"Raxol.Terminal.Buffer.Eraser.html","title":"Raxol.Terminal.Buffer.Eraser","type":"module"},{"doc":"Clears the entire screen with the specified style.","ref":"Raxol.Terminal.Buffer.Eraser.html#clear/2","title":"Raxol.Terminal.Buffer.Eraser.clear/2","type":"function"},{"doc":"Clears a specific line with the specified style.","ref":"Raxol.Terminal.Buffer.Eraser.html#clear_line/3","title":"Raxol.Terminal.Buffer.Eraser.clear_line/3","type":"function"},{"doc":"Clears from the given position to the end of the line using the provided style.\nReturns the updated buffer state.","ref":"Raxol.Terminal.Buffer.Eraser.html#clear_line_from/4","title":"Raxol.Terminal.Buffer.Eraser.clear_line_from/4","type":"function"},{"doc":"Clears from the beginning of the line to the given position using the provided style.\nReturns the updated buffer state.","ref":"Raxol.Terminal.Buffer.Eraser.html#clear_line_to/4","title":"Raxol.Terminal.Buffer.Eraser.clear_line_to/4","type":"function"},{"doc":"Clears a region of the screen with the specified style.","ref":"Raxol.Terminal.Buffer.Eraser.html#clear_region/6","title":"Raxol.Terminal.Buffer.Eraser.clear_region/6","type":"function"},{"doc":"Clears the entire screen (main buffer grid) using the provided style.\nReturns the updated buffer state.","ref":"Raxol.Terminal.Buffer.Eraser.html#clear_screen/2","title":"Raxol.Terminal.Buffer.Eraser.clear_screen/2","type":"function"},{"doc":"Clears the screen from cursor position to end.","ref":"Raxol.Terminal.Buffer.Eraser.html#clear_screen_from/4","title":"Raxol.Terminal.Buffer.Eraser.clear_screen_from/4","type":"function"},{"doc":"Clears the screen from start to cursor position.","ref":"Raxol.Terminal.Buffer.Eraser.html#clear_screen_to/4","title":"Raxol.Terminal.Buffer.Eraser.clear_screen_to/4","type":"function"},{"doc":"Erases the entire screen.","ref":"Raxol.Terminal.Buffer.Eraser.html#erase_all/1","title":"Raxol.Terminal.Buffer.Eraser.erase_all/1","type":"function"},{"doc":"Erases from cursor to end of display.","ref":"Raxol.Terminal.Buffer.Eraser.html#erase_display_segment/4","title":"Raxol.Terminal.Buffer.Eraser.erase_display_segment/4","type":"function"},{"doc":"Erases from cursor to end of screen.","ref":"Raxol.Terminal.Buffer.Eraser.html#erase_from_cursor_to_end/1","title":"Raxol.Terminal.Buffer.Eraser.erase_from_cursor_to_end/1","type":"function"},{"doc":"Erases from start of screen to cursor.","ref":"Raxol.Terminal.Buffer.Eraser.html#erase_from_start_to_cursor/1","title":"Raxol.Terminal.Buffer.Eraser.erase_from_start_to_cursor/1","type":"function"},{"doc":"Erases parts of the display based on cursor position and type.\nType can be :to_end, :to_beginning, or :all.\nRequires cursor state {col, row}.\nDelegates to specific clear_screen_* functions.\nDoes not handle type 3 (scrollback) - that should be handled by the Emulator.","ref":"Raxol.Terminal.Buffer.Eraser.html#erase_in_display/4","title":"Raxol.Terminal.Buffer.Eraser.erase_in_display/4","type":"function"},{"doc":"Erases parts of the current line based on cursor position and type.\nType can be :to_end, :to_beginning, or :all.\nRequires cursor state {col, row}.\nDelegates to specific clear_line_* functions.","ref":"Raxol.Terminal.Buffer.Eraser.html#erase_in_line/4","title":"Raxol.Terminal.Buffer.Eraser.erase_in_line/4","type":"function"},{"doc":"Erases from cursor to end of line.","ref":"Raxol.Terminal.Buffer.Eraser.html#erase_line_segment/4","title":"Raxol.Terminal.Buffer.Eraser.erase_line_segment/4","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Eraser.html#get_cursor_position/1","title":"Raxol.Terminal.Buffer.Eraser.get_cursor_position/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Eraser.html#get_damage_regions/1","title":"Raxol.Terminal.Buffer.Eraser.get_damage_regions/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Eraser.html#mark_damaged/5","title":"Raxol.Terminal.Buffer.Eraser.mark_damaged/5","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Eraser.html#set_cursor_position/3","title":"Raxol.Terminal.Buffer.Eraser.set_cursor_position/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Eraser.html#set_scroll_region/3","title":"Raxol.Terminal.Buffer.Eraser.set_scroll_region/3","type":"function"},{"doc":"Manages text formatting state and operations for the screen buffer.\nThis module handles text attributes, colors, and style management.","ref":"Raxol.Terminal.Buffer.Formatting.html","title":"Raxol.Terminal.Buffer.Formatting","type":"module"},{"doc":"Checks if a specific attribute is set.","ref":"Raxol.Terminal.Buffer.Formatting.html#attribute_set?/2","title":"Raxol.Terminal.Buffer.Formatting.attribute_set?/2","type":"function"},{"doc":"* `buffer` - The screen buffer to query\n* `attribute` - The attribute to check","ref":"Raxol.Terminal.Buffer.Formatting.html#attribute_set?/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Formatting.attribute_set?/2","type":"function"},{"doc":"A boolean indicating if the attribute is set.","ref":"Raxol.Terminal.Buffer.Formatting.html#attribute_set?/2-returns","title":"Returns - Raxol.Terminal.Buffer.Formatting.attribute_set?/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Formatting.attribute_set?(buffer, :bold)\n    false","ref":"Raxol.Terminal.Buffer.Formatting.html#attribute_set?/2-examples","title":"Examples - Raxol.Terminal.Buffer.Formatting.attribute_set?/2","type":"function"},{"doc":"Gets the current background color.","ref":"Raxol.Terminal.Buffer.Formatting.html#get_background/1","title":"Raxol.Terminal.Buffer.Formatting.get_background/1","type":"function"},{"doc":"* `buffer` - The screen buffer to query","ref":"Raxol.Terminal.Buffer.Formatting.html#get_background/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Formatting.get_background/1","type":"function"},{"doc":"The current background color or nil if not set.","ref":"Raxol.Terminal.Buffer.Formatting.html#get_background/1-returns","title":"Returns - Raxol.Terminal.Buffer.Formatting.get_background/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Formatting.get_background(buffer)\n    nil","ref":"Raxol.Terminal.Buffer.Formatting.html#get_background/1-examples","title":"Examples - Raxol.Terminal.Buffer.Formatting.get_background/1","type":"function"},{"doc":"Gets the current foreground color.","ref":"Raxol.Terminal.Buffer.Formatting.html#get_foreground/1","title":"Raxol.Terminal.Buffer.Formatting.get_foreground/1","type":"function"},{"doc":"* `buffer` - The screen buffer to query","ref":"Raxol.Terminal.Buffer.Formatting.html#get_foreground/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Formatting.get_foreground/1","type":"function"},{"doc":"The current foreground color or nil if not set.","ref":"Raxol.Terminal.Buffer.Formatting.html#get_foreground/1-returns","title":"Returns - Raxol.Terminal.Buffer.Formatting.get_foreground/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Formatting.get_foreground(buffer)\n    nil","ref":"Raxol.Terminal.Buffer.Formatting.html#get_foreground/1-examples","title":"Examples - Raxol.Terminal.Buffer.Formatting.get_foreground/1","type":"function"},{"doc":"Gets all currently set attributes.","ref":"Raxol.Terminal.Buffer.Formatting.html#get_set_attributes/1","title":"Raxol.Terminal.Buffer.Formatting.get_set_attributes/1","type":"function"},{"doc":"* `buffer` - The screen buffer to query","ref":"Raxol.Terminal.Buffer.Formatting.html#get_set_attributes/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Formatting.get_set_attributes/1","type":"function"},{"doc":"A list of set attributes.","ref":"Raxol.Terminal.Buffer.Formatting.html#get_set_attributes/1-returns","title":"Returns - Raxol.Terminal.Buffer.Formatting.get_set_attributes/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Formatting.set_attribute(buffer, :bold)\n    iex> Formatting.get_set_attributes(buffer)\n    [:bold]","ref":"Raxol.Terminal.Buffer.Formatting.html#get_set_attributes/1-examples","title":"Examples - Raxol.Terminal.Buffer.Formatting.get_set_attributes/1","type":"function"},{"doc":"Gets the current style.","ref":"Raxol.Terminal.Buffer.Formatting.html#get_style/1","title":"Raxol.Terminal.Buffer.Formatting.get_style/1","type":"function"},{"doc":"* `buffer` - The screen buffer to query","ref":"Raxol.Terminal.Buffer.Formatting.html#get_style/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Formatting.get_style/1","type":"function"},{"doc":"The current style map.","ref":"Raxol.Terminal.Buffer.Formatting.html#get_style/1-returns","title":"Returns - Raxol.Terminal.Buffer.Formatting.get_style/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Formatting.get_style(buffer)\n    %{bold: false, dim: false, italic: false, underline: false, blink: false, reverse: false, hidden: false, strikethrough: false, foreground: nil, background: nil}","ref":"Raxol.Terminal.Buffer.Formatting.html#get_style/1-examples","title":"Examples - Raxol.Terminal.Buffer.Formatting.get_style/1","type":"function"},{"doc":"Initializes a new formatting state with default values.","ref":"Raxol.Terminal.Buffer.Formatting.html#init/0","title":"Raxol.Terminal.Buffer.Formatting.init/0","type":"function"},{"doc":"Resets all attributes to their default values.","ref":"Raxol.Terminal.Buffer.Formatting.html#reset_all/1","title":"Raxol.Terminal.Buffer.Formatting.reset_all/1","type":"function"},{"doc":"* `buffer` - The screen buffer to modify","ref":"Raxol.Terminal.Buffer.Formatting.html#reset_all/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Formatting.reset_all/1","type":"function"},{"doc":"The updated screen buffer with all attributes reset.","ref":"Raxol.Terminal.Buffer.Formatting.html#reset_all/1-returns","title":"Returns - Raxol.Terminal.Buffer.Formatting.reset_all/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Formatting.reset_all(buffer)\n    iex> Formatting.get_style(buffer)\n    %{bold: false, dim: false, italic: false, underline: false, blink: false, reverse: false, hidden: false, strikethrough: false, foreground: nil, background: nil}","ref":"Raxol.Terminal.Buffer.Formatting.html#reset_all/1-examples","title":"Examples - Raxol.Terminal.Buffer.Formatting.reset_all/1","type":"function"},{"doc":"Resets a specific attribute.","ref":"Raxol.Terminal.Buffer.Formatting.html#reset_attribute/2","title":"Raxol.Terminal.Buffer.Formatting.reset_attribute/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `attribute` - The attribute to reset (:bold, :dim, :italic, etc.)","ref":"Raxol.Terminal.Buffer.Formatting.html#reset_attribute/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Formatting.reset_attribute/2","type":"function"},{"doc":"The updated screen buffer with the attribute reset.","ref":"Raxol.Terminal.Buffer.Formatting.html#reset_attribute/2-returns","title":"Returns - Raxol.Terminal.Buffer.Formatting.reset_attribute/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Formatting.reset_attribute(buffer, :bold)\n    iex> Formatting.attribute_set?(buffer, :bold)\n    false","ref":"Raxol.Terminal.Buffer.Formatting.html#reset_attribute/2-examples","title":"Examples - Raxol.Terminal.Buffer.Formatting.reset_attribute/2","type":"function"},{"doc":"Sets a specific attribute.","ref":"Raxol.Terminal.Buffer.Formatting.html#set_attribute/2","title":"Raxol.Terminal.Buffer.Formatting.set_attribute/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `attribute` - The attribute to set (:bold, :dim, :italic, etc.)","ref":"Raxol.Terminal.Buffer.Formatting.html#set_attribute/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Formatting.set_attribute/2","type":"function"},{"doc":"The updated screen buffer with the attribute set.","ref":"Raxol.Terminal.Buffer.Formatting.html#set_attribute/2-returns","title":"Returns - Raxol.Terminal.Buffer.Formatting.set_attribute/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Formatting.set_attribute(buffer, :bold)\n    iex> Formatting.attribute_set?(buffer, :bold)\n    true","ref":"Raxol.Terminal.Buffer.Formatting.html#set_attribute/2-examples","title":"Examples - Raxol.Terminal.Buffer.Formatting.set_attribute/2","type":"function"},{"doc":"Sets the background color.","ref":"Raxol.Terminal.Buffer.Formatting.html#set_background/2","title":"Raxol.Terminal.Buffer.Formatting.set_background/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `color` - The RGB color tuple {r, g, b}","ref":"Raxol.Terminal.Buffer.Formatting.html#set_background/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Formatting.set_background/2","type":"function"},{"doc":"The updated screen buffer with new background color.","ref":"Raxol.Terminal.Buffer.Formatting.html#set_background/2-returns","title":"Returns - Raxol.Terminal.Buffer.Formatting.set_background/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Formatting.set_background(buffer, {0, 0, 255})\n    iex> Formatting.get_background(buffer)\n    {0, 0, 255}","ref":"Raxol.Terminal.Buffer.Formatting.html#set_background/2-examples","title":"Examples - Raxol.Terminal.Buffer.Formatting.set_background/2","type":"function"},{"doc":"Sets the foreground color.","ref":"Raxol.Terminal.Buffer.Formatting.html#set_foreground/2","title":"Raxol.Terminal.Buffer.Formatting.set_foreground/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `color` - The RGB color tuple {r, g, b}","ref":"Raxol.Terminal.Buffer.Formatting.html#set_foreground/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Formatting.set_foreground/2","type":"function"},{"doc":"The updated screen buffer with new foreground color.","ref":"Raxol.Terminal.Buffer.Formatting.html#set_foreground/2-returns","title":"Returns - Raxol.Terminal.Buffer.Formatting.set_foreground/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Formatting.set_foreground(buffer, {255, 0, 0})\n    iex> Formatting.get_foreground(buffer)\n    {255, 0, 0}","ref":"Raxol.Terminal.Buffer.Formatting.html#set_foreground/2-examples","title":"Examples - Raxol.Terminal.Buffer.Formatting.set_foreground/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Formatting.html#t:t/0","title":"Raxol.Terminal.Buffer.Formatting.t/0","type":"type"},{"doc":"Updates the style with new attributes.","ref":"Raxol.Terminal.Buffer.Formatting.html#update_style/2","title":"Raxol.Terminal.Buffer.Formatting.update_style/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `style` - The new style map","ref":"Raxol.Terminal.Buffer.Formatting.html#update_style/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Formatting.update_style/2","type":"function"},{"doc":"The updated screen buffer with new style.","ref":"Raxol.Terminal.Buffer.Formatting.html#update_style/2-returns","title":"Returns - Raxol.Terminal.Buffer.Formatting.update_style/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Formatting.update_style(buffer, %{bold: true})\n    iex> Formatting.get_style(buffer)\n    %{bold: true, ...}","ref":"Raxol.Terminal.Buffer.Formatting.html#update_style/2-examples","title":"Examples - Raxol.Terminal.Buffer.Formatting.update_style/2","type":"function"},{"doc":"Handles initialization and validation of screen buffers.\nThis module provides functions for creating new screen buffers and validating\ntheir dimensions and properties.","ref":"Raxol.Terminal.Buffer.Initializer.html","title":"Raxol.Terminal.Buffer.Initializer","type":"module"},{"doc":"Creates a new screen buffer with the specified dimensions.\nValidates and normalizes the input dimensions to ensure they are valid.","ref":"Raxol.Terminal.Buffer.Initializer.html#new/3","title":"Raxol.Terminal.Buffer.Initializer.new/3","type":"function"},{"doc":"Validates a dimension value, returning a default if invalid.","ref":"Raxol.Terminal.Buffer.Initializer.html#validate_dimension/2","title":"Raxol.Terminal.Buffer.Initializer.validate_dimension/2","type":"function"},{"doc":"Provides functionality for line editing operations in the terminal buffer.","ref":"Raxol.Terminal.Buffer.LineEditor.html","title":"Raxol.Terminal.Buffer.LineEditor","type":"module"},{"doc":"Deletes a specified number of lines starting from the given row index.\nLines below the deleted lines are shifted up.\nBlank lines are added at the bottom of the buffer to fill the space using the provided default_style.\nUses the buffer's default style for new lines.","ref":"Raxol.Terminal.Buffer.LineEditor.html#delete_lines/4","title":"Raxol.Terminal.Buffer.LineEditor.delete_lines/4","type":"function"},{"doc":"Inserts a specified number of blank lines at the given row index using the provided default_style.\nExisting lines from the insertion point downwards are shifted down.\nLines shifted off the bottom of the buffer are discarded.\nUses the buffer's default style for new lines.","ref":"Raxol.Terminal.Buffer.LineEditor.html#insert_lines/4","title":"Raxol.Terminal.Buffer.LineEditor.insert_lines/4","type":"function"},{"doc":"Provides line-level operations for the screen buffer.\nThis module handles operations like inserting, deleting, and manipulating lines.","ref":"Raxol.Terminal.Buffer.LineOperations.html","title":"Raxol.Terminal.Buffer.LineOperations","type":"module"},{"doc":"Clears a line in the buffer with optional styling.","ref":"Raxol.Terminal.Buffer.LineOperations.html#clear_line/3","title":"Raxol.Terminal.Buffer.LineOperations.clear_line/3","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `line_index` - The index of the line to clear\n* `style` - Optional text style for the cleared line","ref":"Raxol.Terminal.Buffer.LineOperations.html#clear_line/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.LineOperations.clear_line/3","type":"function"},{"doc":"The updated screen buffer.","ref":"Raxol.Terminal.Buffer.LineOperations.html#clear_line/3-returns","title":"Returns - Raxol.Terminal.Buffer.LineOperations.clear_line/3","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> style = %{fg: :red, bg: :blue}\n    iex> buffer = LineOperations.clear_line(buffer, 0, style)\n    iex> LineOperations.get_line(buffer, 0) |> hd() |> Map.get(:style)\n    %{fg: :red, bg: :blue}","ref":"Raxol.Terminal.Buffer.LineOperations.html#clear_line/3-examples","title":"Examples - Raxol.Terminal.Buffer.LineOperations.clear_line/3","type":"function"},{"doc":"Creates a single empty line with the given width and optional style.","ref":"Raxol.Terminal.Buffer.LineOperations.html#create_empty_line/2","title":"Raxol.Terminal.Buffer.LineOperations.create_empty_line/2","type":"function"},{"doc":"* `width` - The width of the line\n* `style` - Optional text style for the cells","ref":"Raxol.Terminal.Buffer.LineOperations.html#create_empty_line/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.LineOperations.create_empty_line/2","type":"function"},{"doc":"A list of empty cells representing an empty line.","ref":"Raxol.Terminal.Buffer.LineOperations.html#create_empty_line/2-returns","title":"Returns - Raxol.Terminal.Buffer.LineOperations.create_empty_line/2","type":"function"},{"doc":"iex> line = LineOperations.create_empty_line(80)\n    iex> length(line)\n    80\n    iex> line = LineOperations.create_empty_line(80, %{fg: :red})\n    iex> hd(line).style.fg\n    :red","ref":"Raxol.Terminal.Buffer.LineOperations.html#create_empty_line/2-examples","title":"Examples - Raxol.Terminal.Buffer.LineOperations.create_empty_line/2","type":"function"},{"doc":"Creates a specified number of empty lines with the given width.","ref":"Raxol.Terminal.Buffer.LineOperations.html#create_empty_lines/2","title":"Raxol.Terminal.Buffer.LineOperations.create_empty_lines/2","type":"function"},{"doc":"* `width` - The width of each line\n* `count` - The number of lines to create","ref":"Raxol.Terminal.Buffer.LineOperations.html#create_empty_lines/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.LineOperations.create_empty_lines/2","type":"function"},{"doc":"A list of empty lines, where each line is a list of empty cells.","ref":"Raxol.Terminal.Buffer.LineOperations.html#create_empty_lines/2-returns","title":"Returns - Raxol.Terminal.Buffer.LineOperations.create_empty_lines/2","type":"function"},{"doc":"iex> lines = LineOperations.create_empty_lines(80, 2)\n    iex> length(lines)\n    2\n    iex> length(hd(lines))\n    80","ref":"Raxol.Terminal.Buffer.LineOperations.html#create_empty_lines/2-examples","title":"Examples - Raxol.Terminal.Buffer.LineOperations.create_empty_lines/2","type":"function"},{"doc":"Deletes a specified number of lines starting from the current cursor position.\nLines below the deleted lines are shifted up, and blank lines are added at the bottom.","ref":"Raxol.Terminal.Buffer.LineOperations.html#delete_lines/2","title":"Raxol.Terminal.Buffer.LineOperations.delete_lines/2","type":"function"},{"doc":"Helper function to handle the line insertion logic.","ref":"Raxol.Terminal.Buffer.LineOperations.html#do_insert_lines/4","title":"Raxol.Terminal.Buffer.LineOperations.do_insert_lines/4","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `cursor_y` - The y-coordinate of the cursor\n* `count` - The number of lines to insert\n* `bottom` - The bottom boundary of the scroll region","ref":"Raxol.Terminal.Buffer.LineOperations.html#do_insert_lines/4-parameters","title":"Parameters - Raxol.Terminal.Buffer.LineOperations.do_insert_lines/4","type":"function"},{"doc":"The updated screen buffer.","ref":"Raxol.Terminal.Buffer.LineOperations.html#do_insert_lines/4-returns","title":"Returns - Raxol.Terminal.Buffer.LineOperations.do_insert_lines/4","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = LineOperations.do_insert_lines(buffer, 0, 5, 23)\n    iex> length(buffer.cells)\n    24","ref":"Raxol.Terminal.Buffer.LineOperations.html#do_insert_lines/4-examples","title":"Examples - Raxol.Terminal.Buffer.LineOperations.do_insert_lines/4","type":"function"},{"doc":"Erases a specified number of characters in a line.","ref":"Raxol.Terminal.Buffer.LineOperations.html#erase_chars/4","title":"Raxol.Terminal.Buffer.LineOperations.erase_chars/4","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `row` - The row to modify\n* `col` - The starting column\n* `count` - The number of characters to erase","ref":"Raxol.Terminal.Buffer.LineOperations.html#erase_chars/4-parameters","title":"Parameters - Raxol.Terminal.Buffer.LineOperations.erase_chars/4","type":"function"},{"doc":"The updated screen buffer.","ref":"Raxol.Terminal.Buffer.LineOperations.html#erase_chars/4-returns","title":"Returns - Raxol.Terminal.Buffer.LineOperations.erase_chars/4","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = LineOperations.erase_chars(buffer, 0, 0, 10)\n    iex> LineOperations.get_line(buffer, 0) |> Enum.take(10) |> Enum.all?(fn cell -> cell.char == \"\" end)\n    true","ref":"Raxol.Terminal.Buffer.LineOperations.html#erase_chars/4-examples","title":"Examples - Raxol.Terminal.Buffer.LineOperations.erase_chars/4","type":"function"},{"doc":"Gets a line from the buffer.","ref":"Raxol.Terminal.Buffer.LineOperations.html#get_line/2","title":"Raxol.Terminal.Buffer.LineOperations.get_line/2","type":"function"},{"doc":"Inserts a specified number of blank lines at the current cursor position.\nLines below the cursor are shifted down, and lines shifted off the bottom are discarded.","ref":"Raxol.Terminal.Buffer.LineOperations.html#insert_lines/2","title":"Raxol.Terminal.Buffer.LineOperations.insert_lines/2","type":"function"},{"doc":"Removes lines from the top of the buffer.","ref":"Raxol.Terminal.Buffer.LineOperations.html#pop_top_lines/2","title":"Raxol.Terminal.Buffer.LineOperations.pop_top_lines/2","type":"function"},{"doc":"Prepends lines to the top of the screen buffer, shifting existing content down.\nLines shifted off the bottom are moved to the scrollback buffer.","ref":"Raxol.Terminal.Buffer.LineOperations.html#prepend_lines/2","title":"Raxol.Terminal.Buffer.LineOperations.prepend_lines/2","type":"function"},{"doc":"Updates a line in the buffer with new cells.","ref":"Raxol.Terminal.Buffer.LineOperations.html#update_line/3","title":"Raxol.Terminal.Buffer.LineOperations.update_line/3","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `line_index` - The index of the line to update\n* `new_line` - The new line content","ref":"Raxol.Terminal.Buffer.LineOperations.html#update_line/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.LineOperations.update_line/3","type":"function"},{"doc":"The updated screen buffer.","ref":"Raxol.Terminal.Buffer.LineOperations.html#update_line/3-returns","title":"Returns - Raxol.Terminal.Buffer.LineOperations.update_line/3","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> new_line = List.duplicate(%Cell{char: \"A\"}, 80)\n    iex> buffer = LineOperations.update_line(buffer, 0, new_line)\n    iex> LineOperations.get_line(buffer, 0) |> hd() |> Map.get(:char)\n    \"A\"","ref":"Raxol.Terminal.Buffer.LineOperations.html#update_line/3-examples","title":"Examples - Raxol.Terminal.Buffer.LineOperations.update_line/3","type":"function"},{"doc":"Behaviour for terminal buffer line operations.\nThis module defines the callbacks required for manipulating lines in the screen buffer.","ref":"Raxol.Terminal.Buffer.LineOperations.Behaviour.html","title":"Raxol.Terminal.Buffer.LineOperations.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.Buffer.LineOperations.Behaviour.html#c:delete_lines/3","title":"Raxol.Terminal.Buffer.LineOperations.Behaviour.delete_lines/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.LineOperations.Behaviour.html#c:delete_lines/5","title":"Raxol.Terminal.Buffer.LineOperations.Behaviour.delete_lines/5","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.LineOperations.Behaviour.html#c:get_line/2","title":"Raxol.Terminal.Buffer.LineOperations.Behaviour.get_line/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.LineOperations.Behaviour.html#c:insert_lines/3","title":"Raxol.Terminal.Buffer.LineOperations.Behaviour.insert_lines/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.LineOperations.Behaviour.html#c:pop_top_lines/2","title":"Raxol.Terminal.Buffer.LineOperations.Behaviour.pop_top_lines/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.LineOperations.Behaviour.html#c:prepend_lines/2","title":"Raxol.Terminal.Buffer.LineOperations.Behaviour.prepend_lines/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.LineOperations.Behaviour.html#c:set_line/3","title":"Raxol.Terminal.Buffer.LineOperations.Behaviour.set_line/3","type":"callback"},{"doc":"Manages terminal buffer operations and state.","ref":"Raxol.Terminal.Buffer.Manager.html","title":"Raxol.Terminal.Buffer.Manager","type":"module"},{"doc":"Performs an atomic operation on the buffer.\nThis ensures thread safety for concurrent operations.","ref":"Raxol.Terminal.Buffer.Manager.html#atomic_operation/2","title":"Raxol.Terminal.Buffer.Manager.atomic_operation/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Buffer.Manager.html#child_spec/1","title":"Raxol.Terminal.Buffer.Manager.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#clear/0","title":"Raxol.Terminal.Buffer.Manager.clear/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#default_tab_stops/1","title":"Raxol.Terminal.Buffer.Manager.default_tab_stops/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#get_active_buffer/1","title":"Raxol.Terminal.Buffer.Manager.get_active_buffer/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#get_attributes/0","title":"Raxol.Terminal.Buffer.Manager.get_attributes/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#get_cursor/0","title":"Raxol.Terminal.Buffer.Manager.get_cursor/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#get_icon_name/0","title":"Raxol.Terminal.Buffer.Manager.get_icon_name/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#get_icon_title/0","title":"Raxol.Terminal.Buffer.Manager.get_icon_title/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#get_line/1","title":"Raxol.Terminal.Buffer.Manager.get_line/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#get_mode/0","title":"Raxol.Terminal.Buffer.Manager.get_mode/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#get_size/0","title":"Raxol.Terminal.Buffer.Manager.get_size/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#get_title/0","title":"Raxol.Terminal.Buffer.Manager.get_title/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#set_attributes/1","title":"Raxol.Terminal.Buffer.Manager.set_attributes/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#set_cursor/1","title":"Raxol.Terminal.Buffer.Manager.set_cursor/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#set_cursor/2","title":"Raxol.Terminal.Buffer.Manager.set_cursor/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#set_icon_name/1","title":"Raxol.Terminal.Buffer.Manager.set_icon_name/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#set_line/2","title":"Raxol.Terminal.Buffer.Manager.set_line/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#set_mode/1","title":"Raxol.Terminal.Buffer.Manager.set_mode/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#set_title/1","title":"Raxol.Terminal.Buffer.Manager.set_title/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#start_link/1","title":"Raxol.Terminal.Buffer.Manager.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.html#t:t/0","title":"Raxol.Terminal.Buffer.Manager.t/0","type":"type"},{"doc":"Behaviour for terminal buffer management.","ref":"Raxol.Terminal.Buffer.Manager.Behaviour.html","title":"Raxol.Terminal.Buffer.Manager.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.Behaviour.html#c:clear_damage/0","title":"Raxol.Terminal.Buffer.Manager.Behaviour.clear_damage/0","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.Behaviour.html#c:get_cell/2","title":"Raxol.Terminal.Buffer.Manager.Behaviour.get_cell/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.Behaviour.html#c:get_memory_usage/0","title":"Raxol.Terminal.Buffer.Manager.Behaviour.get_memory_usage/0","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.Behaviour.html#c:get_metrics/0","title":"Raxol.Terminal.Buffer.Manager.Behaviour.get_metrics/0","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.Behaviour.html#c:get_scrollback_count/0","title":"Raxol.Terminal.Buffer.Manager.Behaviour.get_scrollback_count/0","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.Behaviour.html#c:initialize_buffers/3","title":"Raxol.Terminal.Buffer.Manager.Behaviour.initialize_buffers/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.Behaviour.html#c:read/1","title":"Raxol.Terminal.Buffer.Manager.Behaviour.read/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.Behaviour.html#c:resize/2","title":"Raxol.Terminal.Buffer.Manager.Behaviour.resize/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.Behaviour.html#c:scroll/1","title":"Raxol.Terminal.Buffer.Manager.Behaviour.scroll/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.Behaviour.html#c:set_cell/3","title":"Raxol.Terminal.Buffer.Manager.Behaviour.set_cell/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.Behaviour.html#c:write/2","title":"Raxol.Terminal.Buffer.Manager.Behaviour.write/2","type":"callback"},{"doc":"Handles buffer operations and synchronization for the terminal.\nProvides functionality for buffer manipulation, double buffering, and synchronization.","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html","title":"Raxol.Terminal.Buffer.Manager.Buffer","type":"module"},{"doc":"Adds content to the active buffer.","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#add/2","title":"Raxol.Terminal.Buffer.Manager.Buffer.add/2","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Buffer.add(state, \"Hello, World!\")\n    iex> Buffer.get_content(state)\n    \"Hello, World!\"","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#add/2-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Buffer.add/2","type":"function"},{"doc":"Clears the active buffer.","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#clear/1","title":"Raxol.Terminal.Buffer.Manager.Buffer.clear/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Buffer.clear(state)\n    iex> Buffer.get_cell(state, 0, 0)\n    %Cell{char: \" \", fg: :default, bg: :default}","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#clear/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Buffer.clear/1","type":"function"},{"doc":"Copies a region from one position to another in the active buffer.","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#copy_region/7","title":"Raxol.Terminal.Buffer.Manager.Buffer.copy_region/7","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> cell = %Cell{char: \"A\", fg: :red, bg: :blue}\n    iex> state = Buffer.set_cell(state, 0, 0, cell)\n    iex> state = Buffer.copy_region(state, 0, 0, 10, 0, 5, 5)\n    iex> Buffer.get_cell(state, 10, 0)\n    %Cell{char: \"A\", fg: :red, bg: :blue}","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#copy_region/7-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Buffer.copy_region/7","type":"function"},{"doc":"Fills a region in the active buffer with a cell.","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#fill_region/6","title":"Raxol.Terminal.Buffer.Manager.Buffer.fill_region/6","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> cell = %Cell{char: \"X\", fg: :red, bg: :blue}\n    iex> state = Buffer.fill_region(state, 0, 0, 10, 5, cell)\n    iex> Buffer.get_cell(state, 5, 2)\n    %Cell{char: \"X\", fg: :red, bg: :blue}","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#fill_region/6-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Buffer.fill_region/6","type":"function"},{"doc":"Gets a cell from the active buffer.","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#get_cell/3","title":"Raxol.Terminal.Buffer.Manager.Buffer.get_cell/3","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> Buffer.get_cell(state, 0, 0)\n    %Cell{char: \" \", fg: :default, bg: :default}","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#get_cell/3-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Buffer.get_cell/3","type":"function"},{"doc":"Gets the differences between the active and back buffers.","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#get_differences/1","title":"Raxol.Terminal.Buffer.Manager.Buffer.get_differences/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> cell = %Cell{char: \"A\", fg: :red, bg: :blue}\n    iex> state = Buffer.set_cell(state, 0, 0, cell)\n    iex> Buffer.get_differences(state)\n    [{0, 0, %Cell{char: \"A\", fg: :red, bg: :blue}}]","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#get_differences/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Buffer.get_differences/1","type":"function"},{"doc":"Creates a new buffer with the specified dimensions.","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#new/2","title":"Raxol.Terminal.Buffer.Manager.Buffer.new/2","type":"function"},{"doc":"iex> Buffer.new(80, 24)\n    %Buffer{width: 80, height: 24, cells: %{}}","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#new/2-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Buffer.new/2","type":"function"},{"doc":"Resizes the active buffer.","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#resize/3","title":"Raxol.Terminal.Buffer.Manager.Buffer.resize/3","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Buffer.resize(state, 100, 30)\n    iex> state.active_buffer.width\n    100\n    iex> state.active_buffer.height\n    30","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#resize/3-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Buffer.resize/3","type":"function"},{"doc":"Scrolls a region in the active buffer.","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#scroll_region/6","title":"Raxol.Terminal.Buffer.Manager.Buffer.scroll_region/6","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Buffer.scroll_region(state, 0, 0, 10, 5, 2)\n    iex> Buffer.get_cell(state, 0, 2)\n    %Cell{char: \" \", fg: :default, bg: :default}","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#scroll_region/6-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Buffer.scroll_region/6","type":"function"},{"doc":"Sets a cell in the active buffer.","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#set_cell/4","title":"Raxol.Terminal.Buffer.Manager.Buffer.set_cell/4","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> cell = %Cell{char: \"A\", fg: :red, bg: :blue}\n    iex> state = Buffer.set_cell(state, 0, 0, cell)\n    iex> Buffer.get_cell(state, 0, 0)\n    %Cell{char: \"A\", fg: :red, bg: :blue}","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#set_cell/4-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Buffer.set_cell/4","type":"function"},{"doc":"Synchronizes the back buffer with the active buffer.","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#sync_buffers/1","title":"Raxol.Terminal.Buffer.Manager.Buffer.sync_buffers/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Buffer.sync_buffers(state)\n    iex> state.active_buffer == state.back_buffer\n    true","ref":"Raxol.Terminal.Buffer.Manager.Buffer.html#sync_buffers/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Buffer.sync_buffers/1","type":"function"},{"doc":"Implementation of buffer operations for the terminal.\nThis module contains the actual implementation of buffer operations\nthat are used by the public Buffer interface.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html","title":"Raxol.Terminal.Buffer.Manager.BufferImpl","type":"module"},{"doc":"Adds content to the buffer at the current cursor position.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#add/2","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.add/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#clear/1","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.clear/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#copy/1","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.copy/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#copy_region/7","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.copy_region/7","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#fill_region/6","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.fill_region/6","type":"function"},{"doc":"Gets the current attributes.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#get_attributes/1","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.get_attributes/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#get_cell/3","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.get_cell/3","type":"function"},{"doc":"Gets the cursor position.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#get_cursor/1","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.get_cursor/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#get_differences/2","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.get_differences/2","type":"function"},{"doc":"Gets the icon name.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#get_icon_name/1","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.get_icon_name/1","type":"function"},{"doc":"Gets the icon title.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#get_icon_title/1","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.get_icon_title/1","type":"function"},{"doc":"Gets a line from the buffer.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#get_line/2","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.get_line/2","type":"function"},{"doc":"Gets the current mode.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#get_mode/1","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.get_mode/1","type":"function"},{"doc":"Gets the buffer size.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#get_size/1","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.get_size/1","type":"function"},{"doc":"Gets the window title.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#get_title/1","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.get_title/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#new/2","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.new/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#resize/3","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.resize/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#scroll_region/6","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.scroll_region/6","type":"function"},{"doc":"Sets the current attributes.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#set_attributes/2","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.set_attributes/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#set_cell/4","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.set_cell/4","type":"function"},{"doc":"Sets the cursor position.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#set_cursor/2","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.set_cursor/2","type":"function"},{"doc":"Sets the icon name.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#set_icon_name/2","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.set_icon_name/2","type":"function"},{"doc":"Sets the icon title.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#set_icon_title/2","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.set_icon_title/2","type":"function"},{"doc":"Sets a line in the buffer.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#set_line/3","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.set_line/3","type":"function"},{"doc":"Sets the current mode.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#set_mode/2","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.set_mode/2","type":"function"},{"doc":"Sets the window title.","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#set_title/2","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.set_title/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.BufferImpl.html#t:t/0","title":"Raxol.Terminal.Buffer.Manager.BufferImpl.t/0","type":"type"},{"doc":"Handles cursor management for the terminal buffer.\nProvides functionality for cursor position tracking and movement.","ref":"Raxol.Terminal.Buffer.Manager.Cursor.html","title":"Raxol.Terminal.Buffer.Manager.Cursor","type":"module"},{"doc":"Gets the current cursor position.","ref":"Raxol.Terminal.Buffer.Manager.Cursor.html#get_position/1","title":"Raxol.Terminal.Buffer.Manager.Cursor.get_position/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> Cursor.get_position(state)\n    {0, 0}","ref":"Raxol.Terminal.Buffer.Manager.Cursor.html#get_position/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Cursor.get_position/1","type":"function"},{"doc":"Moves the cursor relative to its current position.","ref":"Raxol.Terminal.Buffer.Manager.Cursor.html#move/3","title":"Raxol.Terminal.Buffer.Manager.Cursor.move/3","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Cursor.move(state, 5, 3)\n    iex> Cursor.get_position(state)\n    {5, 3}","ref":"Raxol.Terminal.Buffer.Manager.Cursor.html#move/3-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Cursor.move/3","type":"function"},{"doc":"Moves the cursor to the specified coordinates.","ref":"Raxol.Terminal.Buffer.Manager.Cursor.html#move_to/3","title":"Raxol.Terminal.Buffer.Manager.Cursor.move_to/3","type":"function"},{"doc":"Moves the cursor to the bottom of the screen.","ref":"Raxol.Terminal.Buffer.Manager.Cursor.html#move_to_bottom/1","title":"Raxol.Terminal.Buffer.Manager.Cursor.move_to_bottom/1","type":"function"},{"doc":"Moves the cursor to the end of the current line.","ref":"Raxol.Terminal.Buffer.Manager.Cursor.html#move_to_line_end/1","title":"Raxol.Terminal.Buffer.Manager.Cursor.move_to_line_end/1","type":"function"},{"doc":"Moves the cursor to the start of the current line.","ref":"Raxol.Terminal.Buffer.Manager.Cursor.html#move_to_line_start/1","title":"Raxol.Terminal.Buffer.Manager.Cursor.move_to_line_start/1","type":"function"},{"doc":"Moves the cursor to the top of the screen.","ref":"Raxol.Terminal.Buffer.Manager.Cursor.html#move_to_top/1","title":"Raxol.Terminal.Buffer.Manager.Cursor.move_to_top/1","type":"function"},{"doc":"Sets the cursor position to the specified coordinates.","ref":"Raxol.Terminal.Buffer.Manager.Cursor.html#set_position/3","title":"Raxol.Terminal.Buffer.Manager.Cursor.set_position/3","type":"function"},{"doc":"Handles damage tracking for the terminal buffer.\nProvides functionality for tracking and managing damaged regions.","ref":"Raxol.Terminal.Buffer.Manager.Damage.html","title":"Raxol.Terminal.Buffer.Manager.Damage","type":"module"},{"doc":"Clears all damage regions.","ref":"Raxol.Terminal.Buffer.Manager.Damage.html#clear_regions/1","title":"Raxol.Terminal.Buffer.Manager.Damage.clear_regions/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Damage.mark_region(state, 0, 0, 10, 5)\n    iex> state = Damage.clear_regions(state)\n    iex> length(Damage.get_regions(state))\n    0","ref":"Raxol.Terminal.Buffer.Manager.Damage.html#clear_regions/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Damage.clear_regions/1","type":"function"},{"doc":"Gets all damaged regions.","ref":"Raxol.Terminal.Buffer.Manager.Damage.html#get_regions/1","title":"Raxol.Terminal.Buffer.Manager.Damage.get_regions/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Damage.mark_region(state, 0, 0, 10, 5)\n    iex> regions = Damage.get_regions(state)\n    iex> length(regions)\n    1","ref":"Raxol.Terminal.Buffer.Manager.Damage.html#get_regions/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Damage.get_regions/1","type":"function"},{"doc":"Marks the entire visible region as damaged.","ref":"Raxol.Terminal.Buffer.Manager.Damage.html#mark_all/1","title":"Raxol.Terminal.Buffer.Manager.Damage.mark_all/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Damage.mark_all(state)\n    iex> length(Damage.get_regions(state))\n    1","ref":"Raxol.Terminal.Buffer.Manager.Damage.html#mark_all/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Damage.mark_all/1","type":"function"},{"doc":"Marks a column as damaged.","ref":"Raxol.Terminal.Buffer.Manager.Damage.html#mark_column/2","title":"Raxol.Terminal.Buffer.Manager.Damage.mark_column/2","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Damage.mark_column(state, 10)\n    iex> length(Damage.get_regions(state))\n    1","ref":"Raxol.Terminal.Buffer.Manager.Damage.html#mark_column/2-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Damage.mark_column/2","type":"function"},{"doc":"Marks a line as damaged.","ref":"Raxol.Terminal.Buffer.Manager.Damage.html#mark_line/2","title":"Raxol.Terminal.Buffer.Manager.Damage.mark_line/2","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Damage.mark_line(state, 5)\n    iex> length(Damage.get_regions(state))\n    1","ref":"Raxol.Terminal.Buffer.Manager.Damage.html#mark_line/2-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Damage.mark_line/2","type":"function"},{"doc":"Marks a region of the buffer as damaged.","ref":"Raxol.Terminal.Buffer.Manager.Damage.html#mark_region/5","title":"Raxol.Terminal.Buffer.Manager.Damage.mark_region/5","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Damage.mark_region(state, 0, 0, 10, 5)\n    iex> length(Damage.get_regions(state))\n    1","ref":"Raxol.Terminal.Buffer.Manager.Damage.html#mark_region/5-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Damage.mark_region/5","type":"function"},{"doc":"Handles memory management for the terminal buffer.\nProvides functionality for tracking memory usage and enforcing limits.","ref":"Raxol.Terminal.Buffer.Manager.Memory.html","title":"Raxol.Terminal.Buffer.Manager.Memory","type":"module"},{"doc":"Calculates memory usage for a specific buffer.","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#calculate_buffer_usage/1","title":"Raxol.Terminal.Buffer.Manager.Memory.calculate_buffer_usage/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> Memory.calculate_buffer_usage(state.active_buffer) > 0\n    true","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#calculate_buffer_usage/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Memory.calculate_buffer_usage/1","type":"function"},{"doc":"Estimates memory usage for a given buffer size.","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#estimate_usage/3","title":"Raxol.Terminal.Buffer.Manager.Memory.estimate_usage/3","type":"function"},{"doc":"iex> Memory.estimate_usage(80, 24, 1000) > 0\n    true","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#estimate_usage/3-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Memory.estimate_usage/3","type":"function"},{"doc":"Gets the memory limit.","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#get_limit/1","title":"Raxol.Terminal.Buffer.Manager.Memory.get_limit/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> Memory.get_limit(state)\n    10_000_000","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#get_limit/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Memory.get_limit/1","type":"function"},{"doc":"Gets the current memory usage.","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#get_usage/1","title":"Raxol.Terminal.Buffer.Manager.Memory.get_usage/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Memory.update_usage(state)\n    iex> Memory.get_usage(state) > 0\n    true","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#get_usage/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Memory.get_usage/1","type":"function"},{"doc":"Sets a new memory limit.","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#set_limit/2","title":"Raxol.Terminal.Buffer.Manager.Memory.set_limit/2","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Memory.set_limit(state, 5_000_000)\n    iex> Memory.get_limit(state)\n    5_000_000","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#set_limit/2-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Memory.set_limit/2","type":"function"},{"doc":"Updates memory usage tracking.","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#update_usage/1","title":"Raxol.Terminal.Buffer.Manager.Memory.update_usage/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Memory.update_usage(state)\n    iex> state.memory_usage > 0\n    true","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#update_usage/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Memory.update_usage/1","type":"function"},{"doc":"Checks if memory usage is within limits.","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#within_limits?/1","title":"Raxol.Terminal.Buffer.Manager.Memory.within_limits?/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> Memory.within_limits?(state)\n    true","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#within_limits?/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Memory.within_limits?/1","type":"function"},{"doc":"Checks if a given buffer size would exceed memory limits.","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#would_exceed_limit?/4","title":"Raxol.Terminal.Buffer.Manager.Memory.would_exceed_limit?/4","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> Memory.would_exceed_limit?(state, 100, 50, 2000)\n    false","ref":"Raxol.Terminal.Buffer.Manager.Memory.html#would_exceed_limit?/4-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Memory.would_exceed_limit?/4","type":"function"},{"doc":"Handles scrollback buffer management for the terminal.\nProvides functionality for managing scrollback history and operations.","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html","title":"Raxol.Terminal.Buffer.Manager.Scrollback","type":"module"},{"doc":"Adds a line to the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#add_line/2","title":"Raxol.Terminal.Buffer.Manager.Scrollback.add_line/2","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Scrollback.add_line(state, \"Hello, World!\")\n    iex> Scrollback.get_line(state, 0)\n    \"Hello, World!\"","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#add_line/2-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Scrollback.add_line/2","type":"function"},{"doc":"Clears the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#clear/1","title":"Raxol.Terminal.Buffer.Manager.Scrollback.clear/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Scrollback.add_line(state, \"Hello, World!\")\n    iex> state = Scrollback.clear(state)\n    iex> Scrollback.get_line_count(state)\n    0","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#clear/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Scrollback.clear/1","type":"function"},{"doc":"Checks if the scrollback buffer is full.","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#full?/1","title":"Raxol.Terminal.Buffer.Manager.Scrollback.full?/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> Scrollback.full?(state)\n    false","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#full?/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Scrollback.full?/1","type":"function"},{"doc":"Gets the scrollback height limit.","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#get_height/1","title":"Raxol.Terminal.Buffer.Manager.Scrollback.get_height/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> Scrollback.get_height(state)\n    1000","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#get_height/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Scrollback.get_height/1","type":"function"},{"doc":"Gets a line from the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#get_line/2","title":"Raxol.Terminal.Buffer.Manager.Scrollback.get_line/2","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Scrollback.add_line(state, \"Hello, World!\")\n    iex> Scrollback.get_line(state, 0)\n    \"Hello, World!\"","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#get_line/2-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Scrollback.get_line/2","type":"function"},{"doc":"Gets the number of lines in the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#get_line_count/1","title":"Raxol.Terminal.Buffer.Manager.Scrollback.get_line_count/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Scrollback.add_line(state, \"Hello, World!\")\n    iex> Scrollback.get_line_count(state)\n    1","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#get_line_count/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Scrollback.get_line_count/1","type":"function"},{"doc":"Gets a range of lines from the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#get_lines/3","title":"Raxol.Terminal.Buffer.Manager.Scrollback.get_lines/3","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Scrollback.add_line(state, \"Line 1\")\n    iex> state = Scrollback.add_line(state, \"Line 2\")\n    iex> Scrollback.get_lines(state, 0, 2)\n    [\"Line 1\", \"Line 2\"]","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#get_lines/3-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Scrollback.get_lines/3","type":"function"},{"doc":"Gets the newest line in the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#get_newest_line/1","title":"Raxol.Terminal.Buffer.Manager.Scrollback.get_newest_line/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Scrollback.add_line(state, \"Newest line\")\n    iex> Scrollback.get_newest_line(state)\n    \"Newest line\"","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#get_newest_line/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Scrollback.get_newest_line/1","type":"function"},{"doc":"Gets the oldest line in the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#get_oldest_line/1","title":"Raxol.Terminal.Buffer.Manager.Scrollback.get_oldest_line/1","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Scrollback.add_line(state, \"Oldest line\")\n    iex> Scrollback.get_oldest_line(state)\n    \"Oldest line\"","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#get_oldest_line/1-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Scrollback.get_oldest_line/1","type":"function"},{"doc":"Sets a new scrollback height limit.","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#set_height/2","title":"Raxol.Terminal.Buffer.Manager.Scrollback.set_height/2","type":"function"},{"doc":"iex> state = State.new(80, 24)\n    iex> state = Scrollback.set_height(state, 2000)\n    iex> Scrollback.get_height(state)\n    2000","ref":"Raxol.Terminal.Buffer.Manager.Scrollback.html#set_height/2-examples","title":"Examples - Raxol.Terminal.Buffer.Manager.Scrollback.set_height/2","type":"function"},{"doc":"Defines the state structure and operations for the buffer manager.\nThis module handles the core state management for the terminal buffer,\nincluding active buffer, back buffer, scrollback, damage tracking, and memory management.","ref":"Raxol.Terminal.Buffer.Manager.State.html","title":"Raxol.Terminal.Buffer.Manager.State","type":"module"},{"doc":"Gets a cell from the active buffer.","ref":"Raxol.Terminal.Buffer.Manager.State.html#get_cell/3","title":"Raxol.Terminal.Buffer.Manager.State.get_cell/3","type":"function"},{"doc":"Gets a cell from the active buffer at the specified coordinates.","ref":"Raxol.Terminal.Buffer.Manager.State.html#get_cell_at/3","title":"Raxol.Terminal.Buffer.Manager.State.get_cell_at/3","type":"function"},{"doc":"Gets the content of the active buffer.","ref":"Raxol.Terminal.Buffer.Manager.State.html#get_content/1","title":"Raxol.Terminal.Buffer.Manager.State.get_content/1","type":"function"},{"doc":"Gets the dimensions of the active buffer.","ref":"Raxol.Terminal.Buffer.Manager.State.html#get_dimensions/1","title":"Raxol.Terminal.Buffer.Manager.State.get_dimensions/1","type":"function"},{"doc":"Gets the height of the active buffer.","ref":"Raxol.Terminal.Buffer.Manager.State.html#get_height/1","title":"Raxol.Terminal.Buffer.Manager.State.get_height/1","type":"function"},{"doc":"Gets a line from the active buffer.","ref":"Raxol.Terminal.Buffer.Manager.State.html#get_line/2","title":"Raxol.Terminal.Buffer.Manager.State.get_line/2","type":"function"},{"doc":"Gets the width of the active buffer.","ref":"Raxol.Terminal.Buffer.Manager.State.html#get_width/1","title":"Raxol.Terminal.Buffer.Manager.State.get_width/1","type":"function"},{"doc":"Creates a new state with the specified dimensions.","ref":"Raxol.Terminal.Buffer.Manager.State.html#new/2","title":"Raxol.Terminal.Buffer.Manager.State.new/2","type":"function"},{"doc":"Updates a line in the active buffer.","ref":"Raxol.Terminal.Buffer.Manager.State.html#put_line/3","title":"Raxol.Terminal.Buffer.Manager.State.put_line/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Manager.State.html#t:t/0","title":"Raxol.Terminal.Buffer.Manager.State.t/0","type":"type"},{"doc":"Handles calculation and checking of terminal buffer memory usage.","ref":"Raxol.Terminal.Buffer.MemoryManager.html","title":"Raxol.Terminal.Buffer.MemoryManager","type":"module"},{"doc":"Calculates the approximate memory usage of a single screen buffer.\n\nThis is a rough estimation based on buffer dimensions and an estimated cell size.","ref":"Raxol.Terminal.Buffer.MemoryManager.html#calculate_buffer_usage/1","title":"Raxol.Terminal.Buffer.MemoryManager.calculate_buffer_usage/1","type":"function"},{"doc":"Estimates the approximate memory usage for a given set of dimensions.","ref":"Raxol.Terminal.Buffer.MemoryManager.html#estimate_usage/3","title":"Raxol.Terminal.Buffer.MemoryManager.estimate_usage/3","type":"function"},{"doc":"Calculates the total approximate memory usage for two buffers (active and back).","ref":"Raxol.Terminal.Buffer.MemoryManager.html#get_total_usage/2","title":"Raxol.Terminal.Buffer.MemoryManager.get_total_usage/2","type":"function"},{"doc":"Checks if the given memory usage is within the specified limit.","ref":"Raxol.Terminal.Buffer.MemoryManager.html#is_within_limit?/2","title":"Raxol.Terminal.Buffer.MemoryManager.is_within_limit?/2","type":"function"},{"doc":"Trims the scrollback buffer to the specified limit.","ref":"Raxol.Terminal.Buffer.MemoryManager.html#trim_scrollback/1","title":"Raxol.Terminal.Buffer.MemoryManager.trim_scrollback/1","type":"function"},{"doc":"Handles buffer operations for the terminal, including resizing, scrolling,\nand cursor movement.","ref":"Raxol.Terminal.Buffer.Operations.html","title":"Raxol.Terminal.Buffer.Operations","type":"module"},{"doc":"Clears the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Operations.html#clear_scrollback/1","title":"Raxol.Terminal.Buffer.Operations.clear_scrollback/1","type":"function"},{"doc":"* `buffer` - The screen buffer to modify","ref":"Raxol.Terminal.Buffer.Operations.html#clear_scrollback/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Operations.clear_scrollback/1","type":"function"},{"doc":"The modified buffer with an empty scrollback.","ref":"Raxol.Terminal.Buffer.Operations.html#clear_scrollback/1-returns","title":"Returns - Raxol.Terminal.Buffer.Operations.clear_scrollback/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Operations.clear_scrollback(buffer)\n    %{buffer | scrollback: []}","ref":"Raxol.Terminal.Buffer.Operations.html#clear_scrollback/1-examples","title":"Examples - Raxol.Terminal.Buffer.Operations.clear_scrollback/1","type":"function"},{"doc":"Creates a new empty line with the specified number of columns.","ref":"Raxol.Terminal.Buffer.Operations.html#create_empty_line/1","title":"Raxol.Terminal.Buffer.Operations.create_empty_line/1","type":"function"},{"doc":"* `cols` - The number of columns in the line","ref":"Raxol.Terminal.Buffer.Operations.html#create_empty_line/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Operations.create_empty_line/1","type":"function"},{"doc":"A list of empty cells representing a line.","ref":"Raxol.Terminal.Buffer.Operations.html#create_empty_line/1-returns","title":"Returns - Raxol.Terminal.Buffer.Operations.create_empty_line/1","type":"function"},{"doc":"iex> Operations.create_empty_line(80)\n    [%Cell{char: \"\", style: %{}}, ...]","ref":"Raxol.Terminal.Buffer.Operations.html#create_empty_line/1-examples","title":"Examples - Raxol.Terminal.Buffer.Operations.create_empty_line/1","type":"function"},{"doc":"Deletes the specified number of characters at the cursor position.","ref":"Raxol.Terminal.Buffer.Operations.html#delete_chars/2","title":"Raxol.Terminal.Buffer.Operations.delete_chars/2","type":"function"},{"doc":"Deletes the specified number of lines at the cursor position.","ref":"Raxol.Terminal.Buffer.Operations.html#delete_lines/4","title":"Raxol.Terminal.Buffer.Operations.delete_lines/4","type":"function"},{"doc":"Deletes the specified number of lines at the cursor position with scroll region.","ref":"Raxol.Terminal.Buffer.Operations.html#delete_lines/6","title":"Raxol.Terminal.Buffer.Operations.delete_lines/6","type":"function"},{"doc":"Erases the entire line.","ref":"Raxol.Terminal.Buffer.Operations.html#erase_entire_line/2","title":"Raxol.Terminal.Buffer.Operations.erase_entire_line/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `row` - The row to erase","ref":"Raxol.Terminal.Buffer.Operations.html#erase_entire_line/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Operations.erase_entire_line/2","type":"function"},{"doc":"The modified buffer with the specified line erased.","ref":"Raxol.Terminal.Buffer.Operations.html#erase_entire_line/2-returns","title":"Returns - Raxol.Terminal.Buffer.Operations.erase_entire_line/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Operations.erase_entire_line(buffer, 0)\n    [%Cell{char: \"\", style: %{}}, ...]","ref":"Raxol.Terminal.Buffer.Operations.html#erase_entire_line/2-examples","title":"Examples - Raxol.Terminal.Buffer.Operations.erase_entire_line/2","type":"function"},{"doc":"Erases characters from the cursor position to the end of the line.","ref":"Raxol.Terminal.Buffer.Operations.html#erase_from_cursor_to_line_end/3","title":"Raxol.Terminal.Buffer.Operations.erase_from_cursor_to_line_end/3","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `row` - The row to erase from\n* `col` - The column to start erasing from","ref":"Raxol.Terminal.Buffer.Operations.html#erase_from_cursor_to_line_end/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.Operations.erase_from_cursor_to_line_end/3","type":"function"},{"doc":"The modified buffer with characters erased.","ref":"Raxol.Terminal.Buffer.Operations.html#erase_from_cursor_to_line_end/3-returns","title":"Returns - Raxol.Terminal.Buffer.Operations.erase_from_cursor_to_line_end/3","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Operations.erase_from_cursor_to_line_end(buffer, 0, 40)\n    [%Cell{char: \"\", style: %{}}, ...]","ref":"Raxol.Terminal.Buffer.Operations.html#erase_from_cursor_to_line_end/3-examples","title":"Examples - Raxol.Terminal.Buffer.Operations.erase_from_cursor_to_line_end/3","type":"function"},{"doc":"Erases characters from the start of the line to the cursor position.","ref":"Raxol.Terminal.Buffer.Operations.html#erase_from_line_start_to_cursor/3","title":"Raxol.Terminal.Buffer.Operations.erase_from_line_start_to_cursor/3","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `row` - The row to erase from\n* `col` - The column to erase up to","ref":"Raxol.Terminal.Buffer.Operations.html#erase_from_line_start_to_cursor/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.Operations.erase_from_line_start_to_cursor/3","type":"function"},{"doc":"The modified buffer with characters erased.","ref":"Raxol.Terminal.Buffer.Operations.html#erase_from_line_start_to_cursor/3-returns","title":"Returns - Raxol.Terminal.Buffer.Operations.erase_from_line_start_to_cursor/3","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Operations.erase_from_line_start_to_cursor(buffer, 0, 40)\n    [%Cell{char: \"\", style: %{}}, ...]","ref":"Raxol.Terminal.Buffer.Operations.html#erase_from_line_start_to_cursor/3-examples","title":"Examples - Raxol.Terminal.Buffer.Operations.erase_from_line_start_to_cursor/3","type":"function"},{"doc":"Erases characters in the display based on the mode.","ref":"Raxol.Terminal.Buffer.Operations.html#erase_in_display/3","title":"Raxol.Terminal.Buffer.Operations.erase_in_display/3","type":"function"},{"doc":"Erases characters in the current line based on the mode.","ref":"Raxol.Terminal.Buffer.Operations.html#erase_in_line/3","title":"Raxol.Terminal.Buffer.Operations.erase_in_line/3","type":"function"},{"doc":"Erases all lines after the specified row.","ref":"Raxol.Terminal.Buffer.Operations.html#erase_lines_after/2","title":"Raxol.Terminal.Buffer.Operations.erase_lines_after/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `start_row` - The row to start erasing from","ref":"Raxol.Terminal.Buffer.Operations.html#erase_lines_after/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Operations.erase_lines_after/2","type":"function"},{"doc":"The modified buffer with all lines after start_row erased.","ref":"Raxol.Terminal.Buffer.Operations.html#erase_lines_after/2-returns","title":"Returns - Raxol.Terminal.Buffer.Operations.erase_lines_after/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Operations.erase_lines_after(buffer, 12)\n    [%Cell{char: \"\", style: %{}}, ...]","ref":"Raxol.Terminal.Buffer.Operations.html#erase_lines_after/2-examples","title":"Examples - Raxol.Terminal.Buffer.Operations.erase_lines_after/2","type":"function"},{"doc":"Erases all lines before the specified row.","ref":"Raxol.Terminal.Buffer.Operations.html#erase_lines_before/2","title":"Raxol.Terminal.Buffer.Operations.erase_lines_before/2","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `end_row` - The row to erase up to","ref":"Raxol.Terminal.Buffer.Operations.html#erase_lines_before/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Operations.erase_lines_before/2","type":"function"},{"doc":"The modified buffer with all lines before end_row erased.","ref":"Raxol.Terminal.Buffer.Operations.html#erase_lines_before/2-returns","title":"Returns - Raxol.Terminal.Buffer.Operations.erase_lines_before/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Operations.erase_lines_before(buffer, 12)\n    [%Cell{char: \"\", style: %{}}, ...]","ref":"Raxol.Terminal.Buffer.Operations.html#erase_lines_before/2-examples","title":"Examples - Raxol.Terminal.Buffer.Operations.erase_lines_before/2","type":"function"},{"doc":"Gets the content of the buffer.","ref":"Raxol.Terminal.Buffer.Operations.html#get_content/1","title":"Raxol.Terminal.Buffer.Operations.get_content/1","type":"function"},{"doc":"Moves the cursor to the beginning of the next line.","ref":"Raxol.Terminal.Buffer.Operations.html#index/1","title":"Raxol.Terminal.Buffer.Operations.index/1","type":"function"},{"doc":"Inserts the specified number of blank characters at the cursor position.","ref":"Raxol.Terminal.Buffer.Operations.html#insert_chars/2","title":"Raxol.Terminal.Buffer.Operations.insert_chars/2","type":"function"},{"doc":"Inserts the specified number of blank lines at the cursor position.","ref":"Raxol.Terminal.Buffer.Operations.html#insert_lines/4","title":"Raxol.Terminal.Buffer.Operations.insert_lines/4","type":"function"},{"doc":"Inserts the specified number of blank lines at the cursor position with scroll region.","ref":"Raxol.Terminal.Buffer.Operations.html#insert_lines/6","title":"Raxol.Terminal.Buffer.Operations.insert_lines/6","type":"function"},{"doc":"Checks if scrolling is needed and performs it if necessary.","ref":"Raxol.Terminal.Buffer.Operations.html#maybe_scroll/1","title":"Raxol.Terminal.Buffer.Operations.maybe_scroll/1","type":"function"},{"doc":"Checks if scrolling is needed based on buffer state.","ref":"Raxol.Terminal.Buffer.Operations.html#needs_scroll?/1","title":"Raxol.Terminal.Buffer.Operations.needs_scroll?/1","type":"function"},{"doc":"* `buffer` - The screen buffer to check","ref":"Raxol.Terminal.Buffer.Operations.html#needs_scroll?/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Operations.needs_scroll?/1","type":"function"},{"doc":"A boolean indicating if scrolling is needed.","ref":"Raxol.Terminal.Buffer.Operations.html#needs_scroll?/1-returns","title":"Returns - Raxol.Terminal.Buffer.Operations.needs_scroll?/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Operations.needs_scroll?(buffer)\n    false","ref":"Raxol.Terminal.Buffer.Operations.html#needs_scroll?/1-examples","title":"Examples - Raxol.Terminal.Buffer.Operations.needs_scroll?/1","type":"function"},{"doc":"Creates a new buffer with the specified dimensions.","ref":"Raxol.Terminal.Buffer.Operations.html#new/1","title":"Raxol.Terminal.Buffer.Operations.new/1","type":"function"},{"doc":"Moves the cursor to the next line, scrolling if necessary.","ref":"Raxol.Terminal.Buffer.Operations.html#next_line/1","title":"Raxol.Terminal.Buffer.Operations.next_line/1","type":"function"},{"doc":"Reads data from the buffer.","ref":"Raxol.Terminal.Buffer.Operations.html#read/2","title":"Raxol.Terminal.Buffer.Operations.read/2","type":"function"},{"doc":"Resizes the buffer to the specified dimensions.","ref":"Raxol.Terminal.Buffer.Operations.html#resize/3","title":"Raxol.Terminal.Buffer.Operations.resize/3","type":"function"},{"doc":"Moves the cursor to the previous line.","ref":"Raxol.Terminal.Buffer.Operations.html#reverse_index/1","title":"Raxol.Terminal.Buffer.Operations.reverse_index/1","type":"function"},{"doc":"Scrolls the buffer by the specified number of lines.","ref":"Raxol.Terminal.Buffer.Operations.html#scroll/2","title":"Raxol.Terminal.Buffer.Operations.scroll/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Operations.html#scroll_down/2","title":"Raxol.Terminal.Buffer.Operations.scroll_down/2","type":"function"},{"doc":"Scrolls the buffer down by the specified number of lines.","ref":"Raxol.Terminal.Buffer.Operations.html#scroll_down/4","title":"Raxol.Terminal.Buffer.Operations.scroll_down/4","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Operations.html#scroll_up/2","title":"Raxol.Terminal.Buffer.Operations.scroll_up/2","type":"function"},{"doc":"Scrolls the buffer up by the specified number of lines.","ref":"Raxol.Terminal.Buffer.Operations.html#scroll_up/4","title":"Raxol.Terminal.Buffer.Operations.scroll_up/4","type":"function"},{"doc":"Writes data to the buffer.","ref":"Raxol.Terminal.Buffer.Operations.html#write/3","title":"Raxol.Terminal.Buffer.Operations.write/3","type":"function"},{"doc":"Writes a character to the buffer at the specified position.","ref":"Raxol.Terminal.Buffer.Operations.html#write_char/5","title":"Raxol.Terminal.Buffer.Operations.write_char/5","type":"function"},{"doc":"Writes a string to the buffer.","ref":"Raxol.Terminal.Buffer.Operations.html#write_string/4","title":"Raxol.Terminal.Buffer.Operations.write_string/4","type":"function"},{"doc":"Defines the behaviour for terminal buffer operations.","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html","title":"Raxol.Terminal.Buffer.OperationsBehaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#t:buffer/0","title":"Raxol.Terminal.Buffer.OperationsBehaviour.buffer/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#c:delete_lines/4","title":"Raxol.Terminal.Buffer.OperationsBehaviour.delete_lines/4","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#c:delete_lines/6","title":"Raxol.Terminal.Buffer.OperationsBehaviour.delete_lines/6","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#c:erase_in_display/4","title":"Raxol.Terminal.Buffer.OperationsBehaviour.erase_in_display/4","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#c:erase_in_line/4","title":"Raxol.Terminal.Buffer.OperationsBehaviour.erase_in_line/4","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#c:index/1","title":"Raxol.Terminal.Buffer.OperationsBehaviour.index/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#c:insert_lines/4","title":"Raxol.Terminal.Buffer.OperationsBehaviour.insert_lines/4","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#c:insert_lines/6","title":"Raxol.Terminal.Buffer.OperationsBehaviour.insert_lines/6","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#c:maybe_scroll/1","title":"Raxol.Terminal.Buffer.OperationsBehaviour.maybe_scroll/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#c:next_line/1","title":"Raxol.Terminal.Buffer.OperationsBehaviour.next_line/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#c:resize/3","title":"Raxol.Terminal.Buffer.OperationsBehaviour.resize/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#c:reverse_index/1","title":"Raxol.Terminal.Buffer.OperationsBehaviour.reverse_index/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#c:scroll_down/4","title":"Raxol.Terminal.Buffer.OperationsBehaviour.scroll_down/4","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#c:scroll_up/4","title":"Raxol.Terminal.Buffer.OperationsBehaviour.scroll_up/4","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#t:style/0","title":"Raxol.Terminal.Buffer.OperationsBehaviour.style/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Buffer.OperationsBehaviour.html#c:write_char/5","title":"Raxol.Terminal.Buffer.OperationsBehaviour.write_char/5","type":"callback"},{"doc":"Delegates buffer operations to Raxol.Terminal.Buffer.Operations.\nThis module exists to resolve undefined function errors for BufferOps.*","ref":"Raxol.Terminal.Buffer.Ops.html","title":"Raxol.Terminal.Buffer.Ops","type":"module"},{"doc":"See  Raxol.Terminal.Buffer.Operations.index/1 .","ref":"Raxol.Terminal.Buffer.Ops.html#index/1","title":"Raxol.Terminal.Buffer.Ops.index/1","type":"function"},{"doc":"See  Raxol.Terminal.Buffer.Operations.maybe_scroll/1 .","ref":"Raxol.Terminal.Buffer.Ops.html#maybe_scroll/1","title":"Raxol.Terminal.Buffer.Ops.maybe_scroll/1","type":"function"},{"doc":"See  Raxol.Terminal.Buffer.Operations.next_line/1 .","ref":"Raxol.Terminal.Buffer.Ops.html#next_line/1","title":"Raxol.Terminal.Buffer.Ops.next_line/1","type":"function"},{"doc":"See  Raxol.Terminal.Buffer.Operations.resize/3 .","ref":"Raxol.Terminal.Buffer.Ops.html#resize/3","title":"Raxol.Terminal.Buffer.Ops.resize/3","type":"function"},{"doc":"See  Raxol.Terminal.Buffer.Operations.reverse_index/1 .","ref":"Raxol.Terminal.Buffer.Ops.html#reverse_index/1","title":"Raxol.Terminal.Buffer.Ops.reverse_index/1","type":"function"},{"doc":"Handles buffer state querying operations.\nThis module provides functions for querying the state of the screen buffer,\nincluding dimensions, content, and selection state.","ref":"Raxol.Terminal.Buffer.Queries.html","title":"Raxol.Terminal.Buffer.Queries","type":"module"},{"doc":"Checks if the buffer is empty.","ref":"Raxol.Terminal.Buffer.Queries.html#empty?/1","title":"Raxol.Terminal.Buffer.Queries.empty?/1","type":"function"},{"doc":"* `buffer` - The screen buffer to check","ref":"Raxol.Terminal.Buffer.Queries.html#empty?/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Queries.empty?/1","type":"function"},{"doc":"A boolean indicating if the buffer is empty.","ref":"Raxol.Terminal.Buffer.Queries.html#empty?/1-returns","title":"Returns - Raxol.Terminal.Buffer.Queries.empty?/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Queries.empty?(buffer)\n    true","ref":"Raxol.Terminal.Buffer.Queries.html#empty?/1-examples","title":"Examples - Raxol.Terminal.Buffer.Queries.empty?/1","type":"function"},{"doc":"Gets a specific cell from the buffer.","ref":"Raxol.Terminal.Buffer.Queries.html#get_cell/3","title":"Raxol.Terminal.Buffer.Queries.get_cell/3","type":"function"},{"doc":"Gets the cell at the specified position in the buffer.","ref":"Raxol.Terminal.Buffer.Queries.html#get_cell_at/3","title":"Raxol.Terminal.Buffer.Queries.get_cell_at/3","type":"function"},{"doc":"* `buffer` - The screen buffer to query\n* `x` - The x-coordinate (column)\n* `y` - The y-coordinate (row)","ref":"Raxol.Terminal.Buffer.Queries.html#get_cell_at/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.Queries.get_cell_at/3","type":"function"},{"doc":"The cell at the specified position, or an empty cell if the position is out of bounds.","ref":"Raxol.Terminal.Buffer.Queries.html#get_cell_at/3-returns","title":"Returns - Raxol.Terminal.Buffer.Queries.get_cell_at/3","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> cell = Queries.get_cell_at(buffer, 0, 0)\n    iex> cell.char\n    \"\"","ref":"Raxol.Terminal.Buffer.Queries.html#get_cell_at/3-examples","title":"Examples - Raxol.Terminal.Buffer.Queries.get_cell_at/3","type":"function"},{"doc":"Gets the character at the given position in the buffer.","ref":"Raxol.Terminal.Buffer.Queries.html#get_char/3","title":"Raxol.Terminal.Buffer.Queries.get_char/3","type":"function"},{"doc":"Gets the character at the specified position in the buffer.","ref":"Raxol.Terminal.Buffer.Queries.html#get_char_at/3","title":"Raxol.Terminal.Buffer.Queries.get_char_at/3","type":"function"},{"doc":"* `buffer` - The screen buffer to query\n* `x` - The x-coordinate (column)\n* `y` - The y-coordinate (row)","ref":"Raxol.Terminal.Buffer.Queries.html#get_char_at/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.Queries.get_char_at/3","type":"function"},{"doc":"The character at the specified position, or a space if the position is out of bounds.","ref":"Raxol.Terminal.Buffer.Queries.html#get_char_at/3-returns","title":"Returns - Raxol.Terminal.Buffer.Queries.get_char_at/3","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Queries.get_char_at(buffer, 0, 0)\n    \" \"","ref":"Raxol.Terminal.Buffer.Queries.html#get_char_at/3-examples","title":"Examples - Raxol.Terminal.Buffer.Queries.get_char_at/3","type":"function"},{"doc":"Gets the content of the buffer as a list of lines.","ref":"Raxol.Terminal.Buffer.Queries.html#get_content/1","title":"Raxol.Terminal.Buffer.Queries.get_content/1","type":"function"},{"doc":"Gets the dimensions of the buffer.","ref":"Raxol.Terminal.Buffer.Queries.html#get_dimensions/1","title":"Raxol.Terminal.Buffer.Queries.get_dimensions/1","type":"function"},{"doc":"Gets the height of the buffer.","ref":"Raxol.Terminal.Buffer.Queries.html#get_height/1","title":"Raxol.Terminal.Buffer.Queries.get_height/1","type":"function"},{"doc":"Gets a specific line from the buffer.","ref":"Raxol.Terminal.Buffer.Queries.html#get_line/2","title":"Raxol.Terminal.Buffer.Queries.get_line/2","type":"function"},{"doc":"Gets the text content of a specific line.","ref":"Raxol.Terminal.Buffer.Queries.html#get_line_text/2","title":"Raxol.Terminal.Buffer.Queries.get_line_text/2","type":"function"},{"doc":"Gets the text content of the buffer.","ref":"Raxol.Terminal.Buffer.Queries.html#get_text/1","title":"Raxol.Terminal.Buffer.Queries.get_text/1","type":"function"},{"doc":"Gets the width of the buffer.","ref":"Raxol.Terminal.Buffer.Queries.html#get_width/1","title":"Raxol.Terminal.Buffer.Queries.get_width/1","type":"function"},{"doc":"Checks if a position is within the buffer bounds.","ref":"Raxol.Terminal.Buffer.Queries.html#in_bounds?/3","title":"Raxol.Terminal.Buffer.Queries.in_bounds?/3","type":"function"},{"doc":"Behaviour for terminal buffer querying operations.\nThis module defines the callbacks required for querying the state of the screen buffer,\nincluding dimensions, content, and selection state.","ref":"Raxol.Terminal.Buffer.Queries.Behaviour.html","title":"Raxol.Terminal.Buffer.Queries.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.Buffer.Queries.Behaviour.html#c:get_cell/3","title":"Raxol.Terminal.Buffer.Queries.Behaviour.get_cell/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Queries.Behaviour.html#c:get_char/3","title":"Raxol.Terminal.Buffer.Queries.Behaviour.get_char/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Queries.Behaviour.html#c:get_content/1","title":"Raxol.Terminal.Buffer.Queries.Behaviour.get_content/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Queries.Behaviour.html#c:get_dimensions/1","title":"Raxol.Terminal.Buffer.Queries.Behaviour.get_dimensions/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Queries.Behaviour.html#c:get_height/1","title":"Raxol.Terminal.Buffer.Queries.Behaviour.get_height/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Queries.Behaviour.html#c:get_line/2","title":"Raxol.Terminal.Buffer.Queries.Behaviour.get_line/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Queries.Behaviour.html#c:get_line_text/2","title":"Raxol.Terminal.Buffer.Queries.Behaviour.get_line_text/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Queries.Behaviour.html#c:get_text/1","title":"Raxol.Terminal.Buffer.Queries.Behaviour.get_text/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Queries.Behaviour.html#c:get_width/1","title":"Raxol.Terminal.Buffer.Queries.Behaviour.get_width/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Queries.Behaviour.html#c:in_bounds?/3","title":"Raxol.Terminal.Buffer.Queries.Behaviour.in_bounds?/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Queries.Behaviour.html#c:is_empty?/1","title":"Raxol.Terminal.Buffer.Queries.Behaviour.is_empty?/1","type":"callback"},{"doc":"Terminal scroll buffer module.\n\nThis module handles the management of terminal scrollback buffers, including:\n- Virtual scrolling implementation\n- Memory-efficient buffer management\n- Scroll position tracking\n- Buffer compression","ref":"Raxol.Terminal.Buffer.Scroll.html","title":"Raxol.Terminal.Buffer.Scroll","type":"module"},{"doc":"Adds a line to the scroll buffer.","ref":"Raxol.Terminal.Buffer.Scroll.html#add_line/2","title":"Raxol.Terminal.Buffer.Scroll.add_line/2","type":"function"},{"doc":"iex> scroll = Scroll.new(1000)\n    iex> line = [Cell.new(\"A\"), Cell.new(\"B\")]\n    iex> scroll = Scroll.add_line(scroll, line)\n    iex> scroll.height\n    1","ref":"Raxol.Terminal.Buffer.Scroll.html#add_line/2-examples","title":"Examples - Raxol.Terminal.Buffer.Scroll.add_line/2","type":"function"},{"doc":"Clears the scroll buffer.","ref":"Raxol.Terminal.Buffer.Scroll.html#clear/1","title":"Raxol.Terminal.Buffer.Scroll.clear/1","type":"function"},{"doc":"iex> scroll = Scroll.new(1000)\n    iex> line = [Cell.new(\"A\"), Cell.new(\"B\")]\n    iex> scroll = Scroll.add_line(scroll, line)\n    iex> scroll = Scroll.clear(scroll)\n    iex> scroll.height\n    0","ref":"Raxol.Terminal.Buffer.Scroll.html#clear/1-examples","title":"Examples - Raxol.Terminal.Buffer.Scroll.clear/1","type":"function"},{"doc":"Gets the total height of the scroll buffer.","ref":"Raxol.Terminal.Buffer.Scroll.html#get_height/1","title":"Raxol.Terminal.Buffer.Scroll.get_height/1","type":"function"},{"doc":"iex> scroll = Scroll.new(1000)\n    iex> line = [Cell.new(\"A\"), Cell.new(\"B\")]\n    iex> scroll = Scroll.add_line(scroll, line)\n    iex> Scroll.get_height(scroll)\n    1","ref":"Raxol.Terminal.Buffer.Scroll.html#get_height/1-examples","title":"Examples - Raxol.Terminal.Buffer.Scroll.get_height/1","type":"function"},{"doc":"Gets the current scroll position.","ref":"Raxol.Terminal.Buffer.Scroll.html#get_position/1","title":"Raxol.Terminal.Buffer.Scroll.get_position/1","type":"function"},{"doc":"iex> scroll = Scroll.new(1000)\n    iex> Scroll.get_position(scroll)\n    0","ref":"Raxol.Terminal.Buffer.Scroll.html#get_position/1-examples","title":"Examples - Raxol.Terminal.Buffer.Scroll.get_position/1","type":"function"},{"doc":"Gets a view of the scroll buffer at the current position.","ref":"Raxol.Terminal.Buffer.Scroll.html#get_view/2","title":"Raxol.Terminal.Buffer.Scroll.get_view/2","type":"function"},{"doc":"iex> scroll = Scroll.new(1000)\n    iex> line = [Cell.new(\"A\"), Cell.new(\"B\")]\n    iex> scroll = Scroll.add_line(scroll, line)\n    iex> view = Scroll.get_view(scroll, 10)\n    iex> length(view)\n    1","ref":"Raxol.Terminal.Buffer.Scroll.html#get_view/2-examples","title":"Examples - Raxol.Terminal.Buffer.Scroll.get_view/2","type":"function"},{"doc":"Gets the visible region of the scroll buffer.","ref":"Raxol.Terminal.Buffer.Scroll.html#get_visible_region/1","title":"Raxol.Terminal.Buffer.Scroll.get_visible_region/1","type":"function"},{"doc":"Creates a new scroll buffer with the given dimensions.","ref":"Raxol.Terminal.Buffer.Scroll.html#new/2","title":"Raxol.Terminal.Buffer.Scroll.new/2","type":"function"},{"doc":"iex> scroll = Scroll.new(1000)\n    iex> scroll.max_height\n    1000\n    iex> scroll.position\n    0","ref":"Raxol.Terminal.Buffer.Scroll.html#new/2-examples","title":"Examples - Raxol.Terminal.Buffer.Scroll.new/2","type":"function"},{"doc":"Resizes the scroll buffer to the new height.","ref":"Raxol.Terminal.Buffer.Scroll.html#resize/2","title":"Raxol.Terminal.Buffer.Scroll.resize/2","type":"function"},{"doc":"Scrolls the buffer by the given amount.","ref":"Raxol.Terminal.Buffer.Scroll.html#scroll/2","title":"Raxol.Terminal.Buffer.Scroll.scroll/2","type":"function"},{"doc":"iex> scroll = Scroll.new(1000)\n    iex> line = [Cell.new(\"A\"), Cell.new(\"B\")]\n    iex> scroll = Scroll.add_line(scroll, line)\n    iex> scroll = Scroll.scroll(scroll, 5)\n    iex> scroll.position\n    5","ref":"Raxol.Terminal.Buffer.Scroll.html#scroll/2-examples","title":"Examples - Raxol.Terminal.Buffer.Scroll.scroll/2","type":"function"},{"doc":"Scrolls the buffer in the specified direction by the given amount.","ref":"Raxol.Terminal.Buffer.Scroll.html#scroll/3","title":"Raxol.Terminal.Buffer.Scroll.scroll/3","type":"function"},{"doc":"Updates the maximum height of the scroll buffer.\nTrims the buffer if the new max height is smaller than the current content.","ref":"Raxol.Terminal.Buffer.Scroll.html#set_max_height/2","title":"Raxol.Terminal.Buffer.Scroll.set_max_height/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Scroll.html#t:t/0","title":"Raxol.Terminal.Buffer.Scroll.t/0","type":"type"},{"doc":"Handles scroll region operations for the screen buffer.\nThis module manages the scroll region boundaries and provides functions\nfor scrolling content within the defined region.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html","title":"Raxol.Terminal.Buffer.ScrollRegion","type":"module"},{"doc":"A scroll region defines a subset of the screen buffer where scrolling operations\nare confined. The region is defined by its top and bottom boundaries, and all\nscrolling operations (up/down) will only affect the content within these boundaries.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#module-scroll-region","title":"Scroll Region - Raxol.Terminal.Buffer.ScrollRegion","type":"module"},{"doc":"* Setting and clearing scroll regions\n* Scrolling content up and down within the region\n* Getting region boundaries\n* Validating region boundaries\n* Managing content within the region","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#module-operations","title":"Operations - Raxol.Terminal.Buffer.ScrollRegion","type":"module"},{"doc":"Clears the scroll region, resetting to full screen.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#clear/1","title":"Raxol.Terminal.Buffer.ScrollRegion.clear/1","type":"function"},{"doc":"* `buffer` - The screen buffer to modify","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#clear/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.ScrollRegion.clear/1","type":"function"},{"doc":"The updated screen buffer with scroll region cleared.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#clear/1-returns","title":"Returns - Raxol.Terminal.Buffer.ScrollRegion.clear/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = ScrollRegion.set_region(buffer, 5, 15)\n    iex> buffer = ScrollRegion.clear(buffer)\n    iex> ScrollRegion.get_region(buffer)\n    nil","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#clear/1-examples","title":"Examples - Raxol.Terminal.Buffer.ScrollRegion.clear/1","type":"function"},{"doc":"Gets the current scroll region boundaries.\nReturns {0, height-1} if no region is set.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#get_boundaries/1","title":"Raxol.Terminal.Buffer.ScrollRegion.get_boundaries/1","type":"function"},{"doc":"* `buffer` - The screen buffer to query","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#get_boundaries/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.ScrollRegion.get_boundaries/1","type":"function"},{"doc":"A tuple {top, bottom} representing the effective scroll region boundaries.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#get_boundaries/1-returns","title":"Returns - Raxol.Terminal.Buffer.ScrollRegion.get_boundaries/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> ScrollRegion.get_boundaries(buffer)\n    {0, 23}\n\n    iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = ScrollRegion.set_region(buffer, 5, 15)\n    iex> ScrollRegion.get_boundaries(buffer)\n    {5, 15}","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#get_boundaries/1-examples","title":"Examples - Raxol.Terminal.Buffer.ScrollRegion.get_boundaries/1","type":"function"},{"doc":"Gets the current scroll region boundaries.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#get_region/1","title":"Raxol.Terminal.Buffer.ScrollRegion.get_region/1","type":"function"},{"doc":"* `buffer` - The screen buffer to query","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#get_region/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.ScrollRegion.get_region/1","type":"function"},{"doc":"A tuple {top, bottom} representing the scroll region boundaries,\nor nil if no region is set.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#get_region/1-returns","title":"Returns - Raxol.Terminal.Buffer.ScrollRegion.get_region/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> ScrollRegion.get_region(buffer)\n    nil\n\n    iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = ScrollRegion.set_region(buffer, 5, 15)\n    iex> ScrollRegion.get_region(buffer)\n    {5, 15}","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#get_region/1-examples","title":"Examples - Raxol.Terminal.Buffer.ScrollRegion.get_region/1","type":"function"},{"doc":"Replaces the content of a region in the buffer with new content.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#replace_region_content/4","title":"Raxol.Terminal.Buffer.ScrollRegion.replace_region_content/4","type":"function"},{"doc":"* `cells` - The current cells in the buffer\n* `start_line` - The starting line of the region to replace\n* `end_line` - The ending line of the region to replace\n* `new_content` - The new content to insert in the region","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#replace_region_content/4-parameters","title":"Parameters - Raxol.Terminal.Buffer.ScrollRegion.replace_region_content/4","type":"function"},{"doc":"The updated cells with the region replaced.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#replace_region_content/4-returns","title":"Returns - Raxol.Terminal.Buffer.ScrollRegion.replace_region_content/4","type":"function"},{"doc":"iex> cells = [[%Cell{char: \"A\"}, %Cell{char: \"B\"}], [%Cell{char: \"C\"}, %Cell{char: \"D\"}]]\n    iex> new_content = [[%Cell{char: \"X\"}, %Cell{char: \"Y\"}], [%Cell{char: \"Z\"}, %Cell{char: \"W\"}]]\n    iex> ScrollRegion.replace_region_content(cells, 0, 1, new_content)\n    [[%Cell{char: \"X\"}, %Cell{char: \"Y\"}], [%Cell{char: \"Z\"}, %Cell{char: \"W\"}]]","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#replace_region_content/4-examples","title":"Examples - Raxol.Terminal.Buffer.ScrollRegion.replace_region_content/4","type":"function"},{"doc":"Scrolls the content down within the scroll region.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#scroll_down/3","title":"Raxol.Terminal.Buffer.ScrollRegion.scroll_down/3","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `lines` - The number of lines to scroll down\n* `scroll_region_arg` - Optional scroll region override","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#scroll_down/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.ScrollRegion.scroll_down/3","type":"function"},{"doc":"The updated screen buffer with content scrolled down.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#scroll_down/3-returns","title":"Returns - Raxol.Terminal.Buffer.ScrollRegion.scroll_down/3","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = ScrollRegion.set_region(buffer, 5, 15)\n    iex> buffer = ScrollRegion.scroll_down(buffer, 1)\n    iex> # Content is scrolled down within region 5-15","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#scroll_down/3-examples","title":"Examples - Raxol.Terminal.Buffer.ScrollRegion.scroll_down/3","type":"function"},{"doc":"Scrolls the content up within the scroll region.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#scroll_up/3","title":"Raxol.Terminal.Buffer.ScrollRegion.scroll_up/3","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `lines` - The number of lines to scroll up\n* `scroll_region_arg` - Optional scroll region override","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#scroll_up/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.ScrollRegion.scroll_up/3","type":"function"},{"doc":"The updated screen buffer with content scrolled up.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#scroll_up/3-returns","title":"Returns - Raxol.Terminal.Buffer.ScrollRegion.scroll_up/3","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = ScrollRegion.set_region(buffer, 5, 15)\n    iex> buffer = ScrollRegion.scroll_up(buffer, 1)\n    iex> # Content is scrolled up within region 5-15","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#scroll_up/3-examples","title":"Examples - Raxol.Terminal.Buffer.ScrollRegion.scroll_up/3","type":"function"},{"doc":"Sets the scroll region boundaries.\nThe region must be valid (top < bottom) and within screen bounds.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#set_region/3","title":"Raxol.Terminal.Buffer.ScrollRegion.set_region/3","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n* `top` - The top boundary of the scroll region\n* `bottom` - The bottom boundary of the scroll region","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#set_region/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.ScrollRegion.set_region/3","type":"function"},{"doc":"The updated screen buffer with new scroll region boundaries.\nIf the region is invalid, the scroll region is cleared.","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#set_region/3-returns","title":"Returns - Raxol.Terminal.Buffer.ScrollRegion.set_region/3","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = ScrollRegion.set_region(buffer, 5, 15)\n    iex> ScrollRegion.get_region(buffer)\n    {5, 15}\n\n    iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = ScrollRegion.set_region(buffer, 15, 5)  # Invalid region\n    iex> ScrollRegion.get_region(buffer)\n    nil","ref":"Raxol.Terminal.Buffer.ScrollRegion.html#set_region/3-examples","title":"Examples - Raxol.Terminal.Buffer.ScrollRegion.set_region/3","type":"function"},{"doc":"Behaviour for terminal scroll region buffer.","ref":"Raxol.Terminal.Buffer.ScrollRegion.Behaviour.html","title":"Raxol.Terminal.Buffer.ScrollRegion.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.Buffer.ScrollRegion.Behaviour.html#c:get_region/1","title":"Raxol.Terminal.Buffer.ScrollRegion.Behaviour.get_region/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.ScrollRegion.Behaviour.html#c:new/0","title":"Raxol.Terminal.Buffer.ScrollRegion.Behaviour.new/0","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.ScrollRegion.Behaviour.html#c:set_region/2","title":"Raxol.Terminal.Buffer.ScrollRegion.Behaviour.set_region/2","type":"callback"},{"doc":"Handles scrollback buffer operations for the screen buffer.\nThis module manages the history of lines that have scrolled off the screen,\nincluding adding, retrieving, and clearing scrollback content.","ref":"Raxol.Terminal.Buffer.Scrollback.html","title":"Raxol.Terminal.Buffer.Scrollback","type":"module"},{"doc":"Adds a line to the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Scrollback.html#add_line/2","title":"Raxol.Terminal.Buffer.Scrollback.add_line/2","type":"function"},{"doc":"Adds multiple lines to the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Scrollback.html#add_lines/2","title":"Raxol.Terminal.Buffer.Scrollback.add_lines/2","type":"function"},{"doc":"Clears the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Scrollback.html#clear/1","title":"Raxol.Terminal.Buffer.Scrollback.clear/1","type":"function"},{"doc":"Checks if the scrollback buffer is full.","ref":"Raxol.Terminal.Buffer.Scrollback.html#full?/1","title":"Raxol.Terminal.Buffer.Scrollback.full?/1","type":"function"},{"doc":"Gets the current scrollback limit.","ref":"Raxol.Terminal.Buffer.Scrollback.html#get_limit/1","title":"Raxol.Terminal.Buffer.Scrollback.get_limit/1","type":"function"},{"doc":"Gets a specific line from the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Scrollback.html#get_line/2","title":"Raxol.Terminal.Buffer.Scrollback.get_line/2","type":"function"},{"doc":"Gets lines from the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Scrollback.html#get_lines/3","title":"Raxol.Terminal.Buffer.Scrollback.get_lines/3","type":"function"},{"doc":"Gets the newest line in the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Scrollback.html#get_newest_line/1","title":"Raxol.Terminal.Buffer.Scrollback.get_newest_line/1","type":"function"},{"doc":"Gets the oldest line in the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Scrollback.html#get_oldest_line/1","title":"Raxol.Terminal.Buffer.Scrollback.get_oldest_line/1","type":"function"},{"doc":"Returns a new scrollback buffer with default settings.","ref":"Raxol.Terminal.Buffer.Scrollback.html#new/0","title":"Raxol.Terminal.Buffer.Scrollback.new/0","type":"function"},{"doc":"Sets the scrollback limit.","ref":"Raxol.Terminal.Buffer.Scrollback.html#set_limit/2","title":"Raxol.Terminal.Buffer.Scrollback.set_limit/2","type":"function"},{"doc":"Gets the total number of lines in the scrollback buffer.","ref":"Raxol.Terminal.Buffer.Scrollback.html#size/1","title":"Raxol.Terminal.Buffer.Scrollback.size/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.Scrollback.html#t:t/0","title":"Raxol.Terminal.Buffer.Scrollback.t/0","type":"type"},{"doc":"Behaviour for terminal scrollback buffer.","ref":"Raxol.Terminal.Buffer.Scrollback.Behaviour.html","title":"Raxol.Terminal.Buffer.Scrollback.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.Buffer.Scrollback.Behaviour.html#c:add_line/2","title":"Raxol.Terminal.Buffer.Scrollback.Behaviour.add_line/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Scrollback.Behaviour.html#c:get_lines/1","title":"Raxol.Terminal.Buffer.Scrollback.Behaviour.get_lines/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Scrollback.Behaviour.html#c:new/0","title":"Raxol.Terminal.Buffer.Scrollback.Behaviour.new/0","type":"callback"},{"doc":"Manages scrollback buffer for the terminal emulator.","ref":"Raxol.Terminal.Buffer.ScrollbackManager.html","title":"Raxol.Terminal.Buffer.ScrollbackManager","type":"module"},{"doc":"Adds a line to the scrollback buffer.","ref":"Raxol.Terminal.Buffer.ScrollbackManager.html#add_line/2","title":"Raxol.Terminal.Buffer.ScrollbackManager.add_line/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Buffer.ScrollbackManager.html#child_spec/1","title":"Raxol.Terminal.Buffer.ScrollbackManager.child_spec/1","type":"function"},{"doc":"Clears the scrollback buffer.","ref":"Raxol.Terminal.Buffer.ScrollbackManager.html#clear/1","title":"Raxol.Terminal.Buffer.ScrollbackManager.clear/1","type":"function"},{"doc":"Gets a range of lines from the scrollback buffer.","ref":"Raxol.Terminal.Buffer.ScrollbackManager.html#get_lines/3","title":"Raxol.Terminal.Buffer.ScrollbackManager.get_lines/3","type":"function"},{"doc":"Gets the current number of scrollback lines.","ref":"Raxol.Terminal.Buffer.ScrollbackManager.html#get_scrollback_count/1","title":"Raxol.Terminal.Buffer.ScrollbackManager.get_scrollback_count/1","type":"function"},{"doc":"Creates a new scrollback manager.","ref":"Raxol.Terminal.Buffer.ScrollbackManager.html#new/0","title":"Raxol.Terminal.Buffer.ScrollbackManager.new/0","type":"function"},{"doc":"Starts the scrollback manager process.","ref":"Raxol.Terminal.Buffer.ScrollbackManager.html#start_link/0","title":"Raxol.Terminal.Buffer.ScrollbackManager.start_link/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.ScrollbackManager.html#t:t/0","title":"Raxol.Terminal.Buffer.ScrollbackManager.t/0","type":"type"},{"doc":"Handles scrolling operations for the terminal buffer.","ref":"Raxol.Terminal.Buffer.Scroller.html","title":"Raxol.Terminal.Buffer.Scroller","type":"module"},{"doc":"Gets the scroll bottom position.","ref":"Raxol.Terminal.Buffer.Scroller.html#get_scroll_bottom/2","title":"Raxol.Terminal.Buffer.Scroller.get_scroll_bottom/2","type":"function"},{"doc":"Gets the scroll top position.","ref":"Raxol.Terminal.Buffer.Scroller.html#get_scroll_top/2","title":"Raxol.Terminal.Buffer.Scroller.get_scroll_top/2","type":"function"},{"doc":"Scrolls the buffer down by the specified number of lines.","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_down/2","title":"Raxol.Terminal.Buffer.Scroller.scroll_down/2","type":"function"},{"doc":"Scrolls the entire buffer down by the specified number of lines.","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_entire_buffer_down/2","title":"Raxol.Terminal.Buffer.Scroller.scroll_entire_buffer_down/2","type":"function"},{"doc":"* `buffer` - The screen buffer to scroll\n* `count` - The number of lines to scroll down","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_entire_buffer_down/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Scroller.scroll_entire_buffer_down/2","type":"function"},{"doc":"A tuple containing :ok and the updated buffer.","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_entire_buffer_down/2-returns","title":"Returns - Raxol.Terminal.Buffer.Scroller.scroll_entire_buffer_down/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> {:ok, new_buffer} = Scroller.scroll_entire_buffer_down(buffer, 1)\n    iex> length(new_buffer.content)\n    24","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_entire_buffer_down/2-examples","title":"Examples - Raxol.Terminal.Buffer.Scroller.scroll_entire_buffer_down/2","type":"function"},{"doc":"Scrolls the entire buffer up by the specified number of lines.","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_entire_buffer_up/2","title":"Raxol.Terminal.Buffer.Scroller.scroll_entire_buffer_up/2","type":"function"},{"doc":"* `buffer` - The screen buffer to scroll\n* `count` - The number of lines to scroll up","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_entire_buffer_up/2-parameters","title":"Parameters - Raxol.Terminal.Buffer.Scroller.scroll_entire_buffer_up/2","type":"function"},{"doc":"A tuple containing :ok and the updated buffer.","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_entire_buffer_up/2-returns","title":"Returns - Raxol.Terminal.Buffer.Scroller.scroll_entire_buffer_up/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> {:ok, new_buffer} = Scroller.scroll_entire_buffer_up(buffer, 1)\n    iex> length(new_buffer.content)\n    24","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_entire_buffer_up/2-examples","title":"Examples - Raxol.Terminal.Buffer.Scroller.scroll_entire_buffer_up/2","type":"function"},{"doc":"Scrolls a specific region of the buffer down by the specified number of lines.","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_region_down/4","title":"Raxol.Terminal.Buffer.Scroller.scroll_region_down/4","type":"function"},{"doc":"* `buffer` - The screen buffer to scroll\n* `count` - The number of lines to scroll down\n* `top` - The top boundary of the scroll region\n* `bottom` - The bottom boundary of the scroll region","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_region_down/4-parameters","title":"Parameters - Raxol.Terminal.Buffer.Scroller.scroll_region_down/4","type":"function"},{"doc":"A tuple containing :ok and the updated buffer.","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_region_down/4-returns","title":"Returns - Raxol.Terminal.Buffer.Scroller.scroll_region_down/4","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> {:ok, new_buffer} = Scroller.scroll_region_down(buffer, 1, 5, 15)\n    iex> length(new_buffer.content)\n    24","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_region_down/4-examples","title":"Examples - Raxol.Terminal.Buffer.Scroller.scroll_region_down/4","type":"function"},{"doc":"Scrolls a specific region of the buffer up by the specified number of lines.","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_region_up/4","title":"Raxol.Terminal.Buffer.Scroller.scroll_region_up/4","type":"function"},{"doc":"* `buffer` - The screen buffer to scroll\n* `count` - The number of lines to scroll up\n* `top` - The top boundary of the scroll region\n* `bottom` - The bottom boundary of the scroll region","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_region_up/4-parameters","title":"Parameters - Raxol.Terminal.Buffer.Scroller.scroll_region_up/4","type":"function"},{"doc":"A tuple containing :ok and the updated buffer.","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_region_up/4-returns","title":"Returns - Raxol.Terminal.Buffer.Scroller.scroll_region_up/4","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> {:ok, new_buffer} = Scroller.scroll_region_up(buffer, 1, 5, 15)\n    iex> length(new_buffer.content)\n    24","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_region_up/4-examples","title":"Examples - Raxol.Terminal.Buffer.Scroller.scroll_region_up/4","type":"function"},{"doc":"Scrolls the buffer up by the specified number of lines.","ref":"Raxol.Terminal.Buffer.Scroller.html#scroll_up/2","title":"Raxol.Terminal.Buffer.Scroller.scroll_up/2","type":"function"},{"doc":"Manages text selection operations for the terminal.\nThis module handles all selection-related operations including:\n- Starting and updating selections\n- Getting selected text\n- Checking if positions are within selections\n- Managing selection boundaries\n- Extracting text from regions","ref":"Raxol.Terminal.Buffer.Selection.html","title":"Raxol.Terminal.Buffer.Selection","type":"module"},{"doc":"Checks if there is an active selection.","ref":"Raxol.Terminal.Buffer.Selection.html#active?/1","title":"Raxol.Terminal.Buffer.Selection.active?/1","type":"function"},{"doc":"Clears the current selection.","ref":"Raxol.Terminal.Buffer.Selection.html#clear/1","title":"Raxol.Terminal.Buffer.Selection.clear/1","type":"function"},{"doc":"Checks if a position is within the current selection.","ref":"Raxol.Terminal.Buffer.Selection.html#contains?/3","title":"Raxol.Terminal.Buffer.Selection.contains?/3","type":"function"},{"doc":"Gets the current selection boundaries.","ref":"Raxol.Terminal.Buffer.Selection.html#get_boundaries/1","title":"Raxol.Terminal.Buffer.Selection.get_boundaries/1","type":"function"},{"doc":"Gets the selection end position.","ref":"Raxol.Terminal.Buffer.Selection.html#get_end_position/1","title":"Raxol.Terminal.Buffer.Selection.get_end_position/1","type":"function"},{"doc":"Gets the selection start position.","ref":"Raxol.Terminal.Buffer.Selection.html#get_start_position/1","title":"Raxol.Terminal.Buffer.Selection.get_start_position/1","type":"function"},{"doc":"Gets the currently selected text.","ref":"Raxol.Terminal.Buffer.Selection.html#get_text/1","title":"Raxol.Terminal.Buffer.Selection.get_text/1","type":"function"},{"doc":"Gets text from a specified region in the buffer.","ref":"Raxol.Terminal.Buffer.Selection.html#get_text_in_region/5","title":"Raxol.Terminal.Buffer.Selection.get_text_in_region/5","type":"function"},{"doc":"Starts a text selection at the specified position.","ref":"Raxol.Terminal.Buffer.Selection.html#start/3","title":"Raxol.Terminal.Buffer.Selection.start/3","type":"function"},{"doc":"Updates the current text selection to the specified position.","ref":"Raxol.Terminal.Buffer.Selection.html#update/3","title":"Raxol.Terminal.Buffer.Selection.update/3","type":"function"},{"doc":"Behaviour for terminal selection buffer.","ref":"Raxol.Terminal.Buffer.Selection.Behaviour.html","title":"Raxol.Terminal.Buffer.Selection.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.Buffer.Selection.Behaviour.html#c:get_selection/1","title":"Raxol.Terminal.Buffer.Selection.Behaviour.get_selection/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Selection.Behaviour.html#c:new/0","title":"Raxol.Terminal.Buffer.Selection.Behaviour.new/0","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Buffer.Selection.Behaviour.html#c:set_selection/3","title":"Raxol.Terminal.Buffer.Selection.Behaviour.set_selection/3","type":"callback"},{"doc":"Handles state management and accessors for the Raxol.Terminal.ScreenBuffer.\nIncludes resizing, getting dimensions, accessing cells/lines, managing scroll regions,\nand getting content.","ref":"Raxol.Terminal.Buffer.State.html","title":"Raxol.Terminal.Buffer.State","type":"module"},{"doc":"Clears the scroll region setting in the buffer.","ref":"Raxol.Terminal.Buffer.State.html#clear_scroll_region/1","title":"Raxol.Terminal.Buffer.State.clear_scroll_region/1","type":"function"},{"doc":"Gets a specific Cell from the buffer at {x, y}.\nReturns nil if coordinates are out of bounds.","ref":"Raxol.Terminal.Buffer.State.html#get_cell/3","title":"Raxol.Terminal.Buffer.State.get_cell/3","type":"function"},{"doc":"Gets the cell at the specified coordinates {x, y}.\nReturns nil if coordinates are out of bounds. Alias for get_cell/3.","ref":"Raxol.Terminal.Buffer.State.html#get_cell_at/3","title":"Raxol.Terminal.Buffer.State.get_cell_at/3","type":"function"},{"doc":"Converts the screen buffer content to a plain text string.","ref":"Raxol.Terminal.Buffer.State.html#get_content/1","title":"Raxol.Terminal.Buffer.State.get_content/1","type":"function"},{"doc":"Gets the dimensions {width, height} of the screen buffer.\nWARNING: This returns a tuple, NOT a buffer struct. Do not pass its result as a buffer!","ref":"Raxol.Terminal.Buffer.State.html#get_dimensions/1","title":"Raxol.Terminal.Buffer.State.get_dimensions/1","type":"function"},{"doc":"Gets the current height of the screen buffer.","ref":"Raxol.Terminal.Buffer.State.html#get_height/1","title":"Raxol.Terminal.Buffer.State.get_height/1","type":"function"},{"doc":"Gets a specific line (list of Cells) from the buffer by index.\nReturns nil if index is out of bounds.","ref":"Raxol.Terminal.Buffer.State.html#get_line/2","title":"Raxol.Terminal.Buffer.State.get_line/2","type":"function"},{"doc":"Gets the boundaries {top, bottom} of the current scroll region.\nReturns {0, height - 1} if no region is set.","ref":"Raxol.Terminal.Buffer.State.html#get_scroll_region_boundaries/1","title":"Raxol.Terminal.Buffer.State.get_scroll_region_boundaries/1","type":"function"},{"doc":"Gets the current width of the screen buffer.","ref":"Raxol.Terminal.Buffer.State.html#get_width/1","title":"Raxol.Terminal.Buffer.State.get_width/1","type":"function"},{"doc":"Replaces the line at the given index with the provided list of cells.\nReturns the updated buffer.","ref":"Raxol.Terminal.Buffer.State.html#put_line/3","title":"Raxol.Terminal.Buffer.State.put_line/3","type":"function"},{"doc":"Resizes the screen buffer to the new dimensions.\nPreserves content that fits within the new bounds. Clears selection and scroll region.","ref":"Raxol.Terminal.Buffer.State.html#resize/3","title":"Raxol.Terminal.Buffer.State.resize/3","type":"function"},{"doc":"Sets a scroll region in the buffer.","ref":"Raxol.Terminal.Buffer.State.html#set_scroll_region/3","title":"Raxol.Terminal.Buffer.State.set_scroll_region/3","type":"function"},{"doc":"Manages terminal text formatting operations.","ref":"Raxol.Terminal.Buffer.TextFormatting.html","title":"Raxol.Terminal.Buffer.TextFormatting","type":"module"},{"doc":"Applies blink formatting to a cell.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#apply_blink/1","title":"Raxol.Terminal.Buffer.TextFormatting.apply_blink/1","type":"function"},{"doc":"Applies bold formatting to a cell.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#apply_bold/1","title":"Raxol.Terminal.Buffer.TextFormatting.apply_bold/1","type":"function"},{"doc":"Applies invisible formatting to a cell.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#apply_invisible/1","title":"Raxol.Terminal.Buffer.TextFormatting.apply_invisible/1","type":"function"},{"doc":"Applies italic formatting to a cell.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#apply_italic/1","title":"Raxol.Terminal.Buffer.TextFormatting.apply_italic/1","type":"function"},{"doc":"Applies reverse video formatting to a cell.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#apply_reverse/1","title":"Raxol.Terminal.Buffer.TextFormatting.apply_reverse/1","type":"function"},{"doc":"Applies underline formatting to a cell.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#apply_underline/1","title":"Raxol.Terminal.Buffer.TextFormatting.apply_underline/1","type":"function"},{"doc":"Checks if a cell has blink formatting.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#blink?/1","title":"Raxol.Terminal.Buffer.TextFormatting.blink?/1","type":"function"},{"doc":"Checks if a cell has bold formatting.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#bold?/1","title":"Raxol.Terminal.Buffer.TextFormatting.bold?/1","type":"function"},{"doc":"Checks if a cell has invisible formatting.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#invisible?/1","title":"Raxol.Terminal.Buffer.TextFormatting.invisible?/1","type":"function"},{"doc":"Checks if a cell has italic formatting.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#italic?/1","title":"Raxol.Terminal.Buffer.TextFormatting.italic?/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.TextFormatting.html#new/0","title":"Raxol.Terminal.Buffer.TextFormatting.new/0","type":"function"},{"doc":"Removes blink formatting from a cell.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#remove_blink/1","title":"Raxol.Terminal.Buffer.TextFormatting.remove_blink/1","type":"function"},{"doc":"Removes bold formatting from a cell.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#remove_bold/1","title":"Raxol.Terminal.Buffer.TextFormatting.remove_bold/1","type":"function"},{"doc":"Removes invisible formatting from a cell.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#remove_invisible/1","title":"Raxol.Terminal.Buffer.TextFormatting.remove_invisible/1","type":"function"},{"doc":"Removes italic formatting from a cell.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#remove_italic/1","title":"Raxol.Terminal.Buffer.TextFormatting.remove_italic/1","type":"function"},{"doc":"Removes reverse video formatting from a cell.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#remove_reverse/1","title":"Raxol.Terminal.Buffer.TextFormatting.remove_reverse/1","type":"function"},{"doc":"Removes underline formatting from a cell.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#remove_underline/1","title":"Raxol.Terminal.Buffer.TextFormatting.remove_underline/1","type":"function"},{"doc":"Resets all formatting attributes on a cell.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#reset_formatting/1","title":"Raxol.Terminal.Buffer.TextFormatting.reset_formatting/1","type":"function"},{"doc":"Checks if a cell has reverse video formatting.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#reverse?/1","title":"Raxol.Terminal.Buffer.TextFormatting.reverse?/1","type":"function"},{"doc":"Checks if a cell has underline formatting.","ref":"Raxol.Terminal.Buffer.TextFormatting.html#underline?/1","title":"Raxol.Terminal.Buffer.TextFormatting.underline?/1","type":"function"},{"doc":"Unified buffer management system for the Raxol terminal emulator.\nThis module combines and enhances the functionality of the previous buffer managers,\nproviding improved memory management, caching, and performance metrics.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html","title":"Raxol.Terminal.Buffer.UnifiedManager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#child_spec/1","title":"Raxol.Terminal.Buffer.UnifiedManager.child_spec/1","type":"function"},{"doc":"Cleans up the buffer manager.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#cleanup/1","title":"Raxol.Terminal.Buffer.UnifiedManager.cleanup/1","type":"function"},{"doc":"Clears the active buffer.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#clear/1","title":"Raxol.Terminal.Buffer.UnifiedManager.clear/1","type":"function"},{"doc":"* `state` - The buffer manager state","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#clear/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.UnifiedManager.clear/1","type":"function"},{"doc":"* `{:ok, new_state}` - The updated buffer manager state","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#clear/1-returns","title":"Returns - Raxol.Terminal.Buffer.UnifiedManager.clear/1","type":"function"},{"doc":"Fills a region in the active buffer with a cell.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#fill_region/6","title":"Raxol.Terminal.Buffer.UnifiedManager.fill_region/6","type":"function"},{"doc":"* `state` - The buffer manager state\n  * `x` - The starting x coordinate\n  * `y` - The starting y coordinate\n  * `width` - The width of the region\n  * `height` - The height of the region\n  * `cell` - The cell to fill the region with","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#fill_region/6-parameters","title":"Parameters - Raxol.Terminal.Buffer.UnifiedManager.fill_region/6","type":"function"},{"doc":"* `{:ok, new_state}` - The updated buffer manager state","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#fill_region/6-returns","title":"Returns - Raxol.Terminal.Buffer.UnifiedManager.fill_region/6","type":"function"},{"doc":"Gets the active buffer.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#get_active_buffer/1","title":"Raxol.Terminal.Buffer.UnifiedManager.get_active_buffer/1","type":"function"},{"doc":"Gets the buffer manager state.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#get_buffer_manager/1","title":"Raxol.Terminal.Buffer.UnifiedManager.get_buffer_manager/1","type":"function"},{"doc":"Gets a cell from the active buffer at the specified position.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#get_cell/3","title":"Raxol.Terminal.Buffer.UnifiedManager.get_cell/3","type":"function"},{"doc":"* `state` - The buffer manager state\n  * `x` - The x coordinate\n  * `y` - The y coordinate","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#get_cell/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.UnifiedManager.get_cell/3","type":"function"},{"doc":"* `{:ok, cell}` - The cell at the specified position","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#get_cell/3-returns","title":"Returns - Raxol.Terminal.Buffer.UnifiedManager.get_cell/3","type":"function"},{"doc":"Gets the memory usage of the buffer.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#get_memory_usage/1","title":"Raxol.Terminal.Buffer.UnifiedManager.get_memory_usage/1","type":"function"},{"doc":"Gets the total number of lines in the buffer.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#get_total_lines/1","title":"Raxol.Terminal.Buffer.UnifiedManager.get_total_lines/1","type":"function"},{"doc":"Gets the visible content of the buffer.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#get_visible_content/1","title":"Raxol.Terminal.Buffer.UnifiedManager.get_visible_content/1","type":"function"},{"doc":"Gets the visible content for a specific buffer.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#get_visible_content/2","title":"Raxol.Terminal.Buffer.UnifiedManager.get_visible_content/2","type":"function"},{"doc":"Gets the number of visible lines in the buffer.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#get_visible_lines/1","title":"Raxol.Terminal.Buffer.UnifiedManager.get_visible_lines/1","type":"function"},{"doc":"Creates a new unified buffer manager with the specified dimensions.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#new/4","title":"Raxol.Terminal.Buffer.UnifiedManager.new/4","type":"function"},{"doc":"* `width` - The width of the buffer\n  * `height` - The height of the buffer\n  * `scrollback_limit` - Maximum number of scrollback lines (default: 1000)\n  * `memory_limit` - Maximum memory usage in bytes (default: 10_000_000)","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#new/4-parameters","title":"Parameters - Raxol.Terminal.Buffer.UnifiedManager.new/4","type":"function"},{"doc":"* `{:ok, state}` - The initialized buffer manager state","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#new/4-returns","title":"Returns - Raxol.Terminal.Buffer.UnifiedManager.new/4","type":"function"},{"doc":"Resizes the buffer to new dimensions.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#resize/3","title":"Raxol.Terminal.Buffer.UnifiedManager.resize/3","type":"function"},{"doc":"* `state` - The buffer manager state\n  * `width` - The new width\n  * `height` - The new height","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#resize/3-parameters","title":"Parameters - Raxol.Terminal.Buffer.UnifiedManager.resize/3","type":"function"},{"doc":"* `{:ok, new_state}` - The updated buffer manager state","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#resize/3-returns","title":"Returns - Raxol.Terminal.Buffer.UnifiedManager.resize/3","type":"function"},{"doc":"Scrolls a region in the active buffer.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#scroll_region/6","title":"Raxol.Terminal.Buffer.UnifiedManager.scroll_region/6","type":"function"},{"doc":"* `state` - The buffer manager state\n  * `x` - The starting x coordinate\n  * `y` - The starting y coordinate\n  * `width` - The width of the region\n  * `height` - The height of the region\n  * `amount` - The number of lines to scroll (positive for down, negative for up)","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#scroll_region/6-parameters","title":"Parameters - Raxol.Terminal.Buffer.UnifiedManager.scroll_region/6","type":"function"},{"doc":"* `{:ok, new_state}` - The updated buffer manager state","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#scroll_region/6-returns","title":"Returns - Raxol.Terminal.Buffer.UnifiedManager.scroll_region/6","type":"function"},{"doc":"Sets a cell in the active buffer at the specified position.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#set_cell/4","title":"Raxol.Terminal.Buffer.UnifiedManager.set_cell/4","type":"function"},{"doc":"* `state` - The buffer manager state\n  * `x` - The x coordinate\n  * `y` - The y coordinate\n  * `cell` - The cell to set","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#set_cell/4-parameters","title":"Parameters - Raxol.Terminal.Buffer.UnifiedManager.set_cell/4","type":"function"},{"doc":"* `{:ok, new_state}` - The updated buffer manager state","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#set_cell/4-returns","title":"Returns - Raxol.Terminal.Buffer.UnifiedManager.set_cell/4","type":"function"},{"doc":"Starts a new buffer manager process.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#start_link/1","title":"Raxol.Terminal.Buffer.UnifiedManager.start_link/1","type":"function"},{"doc":"* `:width` - The width of the buffer (default: 80)\n  * `:height` - The height of the buffer (default: 24)\n  * `:scrollback_limit` - Maximum number of scrollback lines (default: 1000)\n  * `:memory_limit` - Maximum memory usage in bytes (default: 10_000_000)","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#start_link/1-options","title":"Options - Raxol.Terminal.Buffer.UnifiedManager.start_link/1","type":"function"},{"doc":"* `{:ok, pid}` - The process ID of the started buffer manager","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#start_link/1-returns","title":"Returns - Raxol.Terminal.Buffer.UnifiedManager.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#t:t/0","title":"Raxol.Terminal.Buffer.UnifiedManager.t/0","type":"type"},{"doc":"Updates the buffer with new commands.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#update/2","title":"Raxol.Terminal.Buffer.UnifiedManager.update/2","type":"function"},{"doc":"Updates the buffer manager configuration.\nDelegates to update/2 for compatibility.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#update_config/2","title":"Raxol.Terminal.Buffer.UnifiedManager.update_config/2","type":"function"},{"doc":"Updates the visible region of the buffer.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#update_visible_region/2","title":"Raxol.Terminal.Buffer.UnifiedManager.update_visible_region/2","type":"function"},{"doc":"Writes data to the buffer.","ref":"Raxol.Terminal.Buffer.UnifiedManager.html#write/2","title":"Raxol.Terminal.Buffer.UnifiedManager.write/2","type":"function"},{"doc":"Handles calculating differences and applying updates to the Raxol.Terminal.ScreenBuffer.","ref":"Raxol.Terminal.Buffer.Updater.html","title":"Raxol.Terminal.Buffer.Updater","type":"module"},{"doc":"Calculates the difference between the current buffer state and a list of desired cell changes.\nReturns a list of {x, y, cell_map} tuples representing only the cells that need to be updated.\nInput `changes` must be a list of {x, y, map} tuples.","ref":"Raxol.Terminal.Buffer.Updater.html#diff/2","title":"Raxol.Terminal.Buffer.Updater.diff/2","type":"function"},{"doc":"Updates the buffer state by applying a list of cell changes.\nChanges must be in the format {x, y, Cell.t() | map()}.\nReturns the updated buffer.","ref":"Raxol.Terminal.Buffer.Updater.html#update/2","title":"Raxol.Terminal.Buffer.Updater.update/2","type":"function"},{"doc":"Handles writing characters and strings to the Raxol.Terminal.ScreenBuffer.\nResponsible for character width, bidirectional text segmentation, and cell creation.","ref":"Raxol.Terminal.Buffer.Writer.html","title":"Raxol.Terminal.Buffer.Writer","type":"module"},{"doc":"Creates a cell style by merging the provided style with default formatting.","ref":"Raxol.Terminal.Buffer.Writer.html#create_cell_style/1","title":"Raxol.Terminal.Buffer.Writer.create_cell_style/1","type":"function"},{"doc":"* `style` - The style to merge with default formatting, or nil for default style","ref":"Raxol.Terminal.Buffer.Writer.html#create_cell_style/1-parameters","title":"Parameters - Raxol.Terminal.Buffer.Writer.create_cell_style/1","type":"function"},{"doc":"A map containing the merged text formatting style.","ref":"Raxol.Terminal.Buffer.Writer.html#create_cell_style/1-returns","title":"Returns - Raxol.Terminal.Buffer.Writer.create_cell_style/1","type":"function"},{"doc":"iex> Writer.create_cell_style(%{fg: :red})\n    %{fg: :red, bg: :default, bold: false, ...}","ref":"Raxol.Terminal.Buffer.Writer.html#create_cell_style/1-examples","title":"Examples - Raxol.Terminal.Buffer.Writer.create_cell_style/1","type":"function"},{"doc":"Logs character write operations for debugging purposes.","ref":"Raxol.Terminal.Buffer.Writer.html#log_char_write/4","title":"Raxol.Terminal.Buffer.Writer.log_char_write/4","type":"function"},{"doc":"* `char` - The character being written\n* `x` - The x-coordinate where the character is being written\n* `y` - The y-coordinate where the character is being written\n* `cell_style` - The style being applied to the cell","ref":"Raxol.Terminal.Buffer.Writer.html#log_char_write/4-parameters","title":"Parameters - Raxol.Terminal.Buffer.Writer.log_char_write/4","type":"function"},{"doc":":ok","ref":"Raxol.Terminal.Buffer.Writer.html#log_char_write/4-returns","title":"Returns - Raxol.Terminal.Buffer.Writer.log_char_write/4","type":"function"},{"doc":"iex> Writer.log_char_write(\"A\", 0, 0, %{fg: :red})\n    :ok","ref":"Raxol.Terminal.Buffer.Writer.html#log_char_write/4-examples","title":"Examples - Raxol.Terminal.Buffer.Writer.log_char_write/4","type":"function"},{"doc":"Updates cells in the buffer at the specified position.","ref":"Raxol.Terminal.Buffer.Writer.html#update_cells/6","title":"Raxol.Terminal.Buffer.Writer.update_cells/6","type":"function"},{"doc":"* `buffer` - The screen buffer to update\n* `x` - The x-coordinate to update\n* `y` - The y-coordinate to update\n* `char` - The character to write\n* `cell_style` - The style to apply\n* `width` - The width of the character (1 or 2 for wide characters)","ref":"Raxol.Terminal.Buffer.Writer.html#update_cells/6-parameters","title":"Parameters - Raxol.Terminal.Buffer.Writer.update_cells/6","type":"function"},{"doc":"The updated list of cells.","ref":"Raxol.Terminal.Buffer.Writer.html#update_cells/6-returns","title":"Returns - Raxol.Terminal.Buffer.Writer.update_cells/6","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> Writer.update_cells(buffer, 0, 0, \"A\", %{fg: :red}, 1)\n    [%Cell{char: \"A\", style: %{fg: :red}}, ...]","ref":"Raxol.Terminal.Buffer.Writer.html#update_cells/6-examples","title":"Examples - Raxol.Terminal.Buffer.Writer.update_cells/6","type":"function"},{"doc":"Updates a row in the buffer at the specified position.","ref":"Raxol.Terminal.Buffer.Writer.html#update_row/6","title":"Raxol.Terminal.Buffer.Writer.update_row/6","type":"function"},{"doc":"* `row` - The row to update\n* `x` - The x-coordinate to update\n* `char` - The character to write\n* `cell_style` - The style to apply\n* `width` - The width of the character (1 or 2 for wide characters)\n* `buffer_width` - The total width of the buffer","ref":"Raxol.Terminal.Buffer.Writer.html#update_row/6-parameters","title":"Parameters - Raxol.Terminal.Buffer.Writer.update_row/6","type":"function"},{"doc":"The updated row of cells.","ref":"Raxol.Terminal.Buffer.Writer.html#update_row/6-returns","title":"Returns - Raxol.Terminal.Buffer.Writer.update_row/6","type":"function"},{"doc":"iex> row = List.duplicate(Cell.new(), 80)\n    iex> Writer.update_row(row, 0, \"A\", %{fg: :red}, 1, 80)\n    [%Cell{char: \"A\", style: %{fg: :red}}, ...]","ref":"Raxol.Terminal.Buffer.Writer.html#update_row/6-examples","title":"Examples - Raxol.Terminal.Buffer.Writer.update_row/6","type":"function"},{"doc":"Writes a character to the buffer at the specified position.\nHandles wide characters by taking up two cells when necessary.\nAccepts an optional style to apply to the cell.","ref":"Raxol.Terminal.Buffer.Writer.html#write_char/5","title":"Raxol.Terminal.Buffer.Writer.write_char/5","type":"function"},{"doc":"Writes a segment of text to the buffer.","ref":"Raxol.Terminal.Buffer.Writer.html#write_segment/4","title":"Raxol.Terminal.Buffer.Writer.write_segment/4","type":"function"},{"doc":"* `buffer` - The screen buffer to write to\n* `x` - The x-coordinate to start writing at\n* `y` - The y-coordinate to write at\n* `segment` - The text segment to write","ref":"Raxol.Terminal.Buffer.Writer.html#write_segment/4-parameters","title":"Parameters - Raxol.Terminal.Buffer.Writer.write_segment/4","type":"function"},{"doc":"A tuple containing the updated buffer and the new x-coordinate.","ref":"Raxol.Terminal.Buffer.Writer.html#write_segment/4-returns","title":"Returns - Raxol.Terminal.Buffer.Writer.write_segment/4","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> {new_buffer, new_x} = Writer.write_segment(buffer, 0, 0, \"Hello\")\n    iex> new_x\n    5","ref":"Raxol.Terminal.Buffer.Writer.html#write_segment/4-examples","title":"Examples - Raxol.Terminal.Buffer.Writer.write_segment/4","type":"function"},{"doc":"Writes a string to the buffer at the specified position.\nHandles wide characters and bidirectional text.","ref":"Raxol.Terminal.Buffer.Writer.html#write_string/4","title":"Raxol.Terminal.Buffer.Writer.write_string/4","type":"function"},{"doc":"Manages buffer operations and tab stops for the terminal.","ref":"Raxol.Terminal.BufferManager.html","title":"Raxol.Terminal.BufferManager","type":"module"},{"doc":"Gets the default tab stops.","ref":"Raxol.Terminal.BufferManager.html#default_tab_stops/1","title":"Raxol.Terminal.BufferManager.default_tab_stops/1","type":"function"},{"doc":"Creates a new BufferManager struct.","ref":"Raxol.Terminal.BufferManager.html#new/0","title":"Raxol.Terminal.BufferManager.new/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.BufferManager.html#t:t/0","title":"Raxol.Terminal.BufferManager.t/0","type":"type"},{"doc":"Helper functions for cache eviction strategies.\nProvides shared implementations for LRU, LFU, and FIFO eviction policies.","ref":"Raxol.Terminal.Cache.EvictionHelpers.html","title":"Raxol.Terminal.Cache.EvictionHelpers","type":"module"},{"doc":"Evicts entries using the First In First Out (FIFO) policy.","ref":"Raxol.Terminal.Cache.EvictionHelpers.html#evict_fifo/3","title":"Raxol.Terminal.Cache.EvictionHelpers.evict_fifo/3","type":"function"},{"doc":"Evicts entries using the Least Frequently Used (LFU) policy.","ref":"Raxol.Terminal.Cache.EvictionHelpers.html#evict_lfu/3","title":"Raxol.Terminal.Cache.EvictionHelpers.evict_lfu/3","type":"function"},{"doc":"Evicts entries using the Least Recently Used (LRU) policy.","ref":"Raxol.Terminal.Cache.EvictionHelpers.html#evict_lru/3","title":"Raxol.Terminal.Cache.EvictionHelpers.evict_lru/3","type":"function"},{"doc":"Unified caching system for the Raxol terminal emulator.\nThis module provides a centralized caching mechanism that consolidates all caching\noperations across the terminal system, including:\n- Buffer caching\n- Animation caching\n- Scroll caching\n- Clipboard caching\n- General purpose caching","ref":"Raxol.Terminal.Cache.System.html","title":"Raxol.Terminal.Cache.System","type":"module"},{"doc":"","ref":"Raxol.Terminal.Cache.System.html#t:cache_entry/0","title":"Raxol.Terminal.Cache.System.cache_entry/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Cache.System.html#t:cache_key/0","title":"Raxol.Terminal.Cache.System.cache_key/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Cache.System.html#t:cache_stats/0","title":"Raxol.Terminal.Cache.System.cache_stats/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Cache.System.html#t:cache_value/0","title":"Raxol.Terminal.Cache.System.cache_value/0","type":"type"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Cache.System.html#child_spec/1","title":"Raxol.Terminal.Cache.System.child_spec/1","type":"function"},{"doc":"Clears the cache.","ref":"Raxol.Terminal.Cache.System.html#clear/1","title":"Raxol.Terminal.Cache.System.clear/1","type":"function"},{"doc":"* `opts` - Clear options\n    * `:namespace` - Cache namespace (default: :general)","ref":"Raxol.Terminal.Cache.System.html#clear/1-parameters","title":"Parameters - Raxol.Terminal.Cache.System.clear/1","type":"function"},{"doc":"Gets a value from the cache.","ref":"Raxol.Terminal.Cache.System.html#get/2","title":"Raxol.Terminal.Cache.System.get/2","type":"function"},{"doc":"* `key` - The cache key\n  * `opts` - Get options\n    * `:namespace` - Cache namespace (default: :general)","ref":"Raxol.Terminal.Cache.System.html#get/2-parameters","title":"Parameters - Raxol.Terminal.Cache.System.get/2","type":"function"},{"doc":"Invalidates a cache entry.","ref":"Raxol.Terminal.Cache.System.html#invalidate/2","title":"Raxol.Terminal.Cache.System.invalidate/2","type":"function"},{"doc":"* `key` - The cache key\n  * `opts` - Invalidate options\n    * `:namespace` - Cache namespace (default: :general)","ref":"Raxol.Terminal.Cache.System.html#invalidate/2-parameters","title":"Parameters - Raxol.Terminal.Cache.System.invalidate/2","type":"function"},{"doc":"Returns the current monotonic time in milliseconds.\nThis is used for cache expiration and timing operations.","ref":"Raxol.Terminal.Cache.System.html#monotonic_time/0","title":"Raxol.Terminal.Cache.System.monotonic_time/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Cache.System.html#t:namespace/0","title":"Raxol.Terminal.Cache.System.namespace/0","type":"type"},{"doc":"Puts a value in the cache.","ref":"Raxol.Terminal.Cache.System.html#put/3","title":"Raxol.Terminal.Cache.System.put/3","type":"function"},{"doc":"* `key` - The cache key\n  * `value` - The value to cache\n  * `opts` - Put options\n    * `:namespace` - Cache namespace (default: :general)\n    * `:ttl` - Time-to-live in seconds\n    * `:metadata` - Additional metadata","ref":"Raxol.Terminal.Cache.System.html#put/3-parameters","title":"Parameters - Raxol.Terminal.Cache.System.put/3","type":"function"},{"doc":"Starts the unified cache system.","ref":"Raxol.Terminal.Cache.System.html#start_link/1","title":"Raxol.Terminal.Cache.System.start_link/1","type":"function"},{"doc":"* `:max_size` - Maximum cache size in bytes (default: 100MB)\n  * `:default_ttl` - Default time-to-live in seconds (default: 3600)\n  * `:eviction_policy` - Cache eviction policy (:lru, :lfu, :fifo) (default: :lru)\n  * `:compression_enabled` - Whether to enable compression (default: true)\n  * `:namespace_configs` - Configuration for specific namespaces","ref":"Raxol.Terminal.Cache.System.html#start_link/1-options","title":"Options - Raxol.Terminal.Cache.System.start_link/1","type":"function"},{"doc":"Gets cache statistics.","ref":"Raxol.Terminal.Cache.System.html#stats/1","title":"Raxol.Terminal.Cache.System.stats/1","type":"function"},{"doc":"* `opts` - Stats options\n    * `:namespace` - Cache namespace (default: :general)","ref":"Raxol.Terminal.Cache.System.html#stats/1-parameters","title":"Parameters - Raxol.Terminal.Cache.System.stats/1","type":"function"},{"doc":"Unified caching system for the Raxol terminal emulator.\nThis module provides a centralized caching mechanism for all terminal operations,\nincluding buffer operations, animations, scroll operations, and edge computing.","ref":"Raxol.Terminal.Cache.UnifiedCache.html","title":"Raxol.Terminal.Cache.UnifiedCache","type":"module"},{"doc":"","ref":"Raxol.Terminal.Cache.UnifiedCache.html#t:cache_entry/0","title":"Raxol.Terminal.Cache.UnifiedCache.cache_entry/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Cache.UnifiedCache.html#t:cache_key/0","title":"Raxol.Terminal.Cache.UnifiedCache.cache_key/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Cache.UnifiedCache.html#t:cache_stats/0","title":"Raxol.Terminal.Cache.UnifiedCache.cache_stats/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Cache.UnifiedCache.html#t:cache_value/0","title":"Raxol.Terminal.Cache.UnifiedCache.cache_value/0","type":"type"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Cache.UnifiedCache.html#child_spec/1","title":"Raxol.Terminal.Cache.UnifiedCache.child_spec/1","type":"function"},{"doc":"Clears the cache.","ref":"Raxol.Terminal.Cache.UnifiedCache.html#clear/1","title":"Raxol.Terminal.Cache.UnifiedCache.clear/1","type":"function"},{"doc":"* `opts` - Clear options\n    * `:namespace` - Cache namespace (default: :default)","ref":"Raxol.Terminal.Cache.UnifiedCache.html#clear/1-parameters","title":"Parameters - Raxol.Terminal.Cache.UnifiedCache.clear/1","type":"function"},{"doc":"Gets a value from the cache.","ref":"Raxol.Terminal.Cache.UnifiedCache.html#get/2","title":"Raxol.Terminal.Cache.UnifiedCache.get/2","type":"function"},{"doc":"* `key` - The cache key\n  * `opts` - Get options\n    * `:namespace` - Cache namespace (default: :default)","ref":"Raxol.Terminal.Cache.UnifiedCache.html#get/2-parameters","title":"Parameters - Raxol.Terminal.Cache.UnifiedCache.get/2","type":"function"},{"doc":"Invalidates a cache entry.","ref":"Raxol.Terminal.Cache.UnifiedCache.html#invalidate/2","title":"Raxol.Terminal.Cache.UnifiedCache.invalidate/2","type":"function"},{"doc":"* `key` - The cache key\n  * `opts` - Invalidate options\n    * `:namespace` - Cache namespace (default: :default)","ref":"Raxol.Terminal.Cache.UnifiedCache.html#invalidate/2-parameters","title":"Parameters - Raxol.Terminal.Cache.UnifiedCache.invalidate/2","type":"function"},{"doc":"Puts a value in the cache.","ref":"Raxol.Terminal.Cache.UnifiedCache.html#put/3","title":"Raxol.Terminal.Cache.UnifiedCache.put/3","type":"function"},{"doc":"* `key` - The cache key\n  * `value` - The value to cache\n  * `opts` - Put options\n    * `:namespace` - Cache namespace (default: :default)\n    * `:ttl` - Time-to-live in seconds\n    * `:metadata` - Additional metadata","ref":"Raxol.Terminal.Cache.UnifiedCache.html#put/3-parameters","title":"Parameters - Raxol.Terminal.Cache.UnifiedCache.put/3","type":"function"},{"doc":"Starts the unified cache manager.","ref":"Raxol.Terminal.Cache.UnifiedCache.html#start_link/1","title":"Raxol.Terminal.Cache.UnifiedCache.start_link/1","type":"function"},{"doc":"* `:max_size` - Maximum cache size in bytes (default: 100MB)\n  * `:default_ttl` - Default time-to-live in seconds (default: 3600)\n  * `:eviction_policy` - Cache eviction policy (:lru, :lfu, :fifo) (default: :lru)\n  * `:compression_enabled` - Whether to enable compression (default: true)","ref":"Raxol.Terminal.Cache.UnifiedCache.html#start_link/1-options","title":"Options - Raxol.Terminal.Cache.UnifiedCache.start_link/1","type":"function"},{"doc":"Gets cache statistics.","ref":"Raxol.Terminal.Cache.UnifiedCache.html#stats/1","title":"Raxol.Terminal.Cache.UnifiedCache.stats/1","type":"function"},{"doc":"* `opts` - Stats options\n    * `:namespace` - Cache namespace (default: :default)","ref":"Raxol.Terminal.Cache.UnifiedCache.html#stats/1-parameters","title":"Parameters - Raxol.Terminal.Cache.UnifiedCache.stats/1","type":"function"},{"doc":"Manages terminal capabilities including detection, negotiation, and caching.","ref":"Raxol.Terminal.Capabilities.Manager.html","title":"Raxol.Terminal.Capabilities.Manager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Capabilities.Manager.html#child_spec/1","title":"Raxol.Terminal.Capabilities.Manager.child_spec/1","type":"function"},{"doc":"Detects and registers a new capability.","ref":"Raxol.Terminal.Capabilities.Manager.html#detect_capability/2","title":"Raxol.Terminal.Capabilities.Manager.detect_capability/2","type":"function"},{"doc":"Enables a capability if supported.","ref":"Raxol.Terminal.Capabilities.Manager.html#enable_capability/1","title":"Raxol.Terminal.Capabilities.Manager.enable_capability/1","type":"function"},{"doc":"Queries if a capability is supported.","ref":"Raxol.Terminal.Capabilities.Manager.html#query_capability/1","title":"Raxol.Terminal.Capabilities.Manager.query_capability/1","type":"function"},{"doc":"Starts the capabilities manager.","ref":"Raxol.Terminal.Capabilities.Manager.html#start_link/1","title":"Raxol.Terminal.Capabilities.Manager.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Capabilities.Manager.html#t:state/0","title":"Raxol.Terminal.Capabilities.Manager.state/0","type":"type"},{"doc":"Defines types and structures for terminal capabilities management.","ref":"Raxol.Terminal.Capabilities.Types.html","title":"Raxol.Terminal.Capabilities.Types","type":"module"},{"doc":"","ref":"Raxol.Terminal.Capabilities.Types.html#t:capability/0","title":"Raxol.Terminal.Capabilities.Types.capability/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Capabilities.Types.html#t:capability_map/0","title":"Raxol.Terminal.Capabilities.Types.capability_map/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Capabilities.Types.html#t:capability_query/0","title":"Raxol.Terminal.Capabilities.Types.capability_query/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Capabilities.Types.html#t:capability_response/0","title":"Raxol.Terminal.Capabilities.Types.capability_response/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Capabilities.Types.html#t:capability_value/0","title":"Raxol.Terminal.Capabilities.Types.capability_value/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Capabilities.Types.html#t:t/0","title":"Raxol.Terminal.Capabilities.Types.t/0","type":"type"},{"doc":"Terminal character cell module.\n\nThis module handles the representation and manipulation of individual\ncharacter cells in the terminal screen buffer, including:\n- Character content\n- Text attributes (color, style)\n- Cell state","ref":"Raxol.Terminal.Cell.html","title":"Raxol.Terminal.Cell","type":"module"},{"doc":"Creates a deep copy of a cell.","ref":"Raxol.Terminal.Cell.html#copy/1","title":"Raxol.Terminal.Cell.copy/1","type":"function"},{"doc":"iex> cell = Cell.new(\"A\", %{foreground: :red})\n    iex> copy = Cell.copy(cell)\n    iex> Cell.get_char(copy)\n    \"A\"\n    iex> Cell.get_style(copy)\n    %{foreground: :red}","ref":"Raxol.Terminal.Cell.html#copy/1-examples","title":"Examples - Raxol.Terminal.Cell.copy/1","type":"function"},{"doc":"Checks if the cell is in double-height mode.","ref":"Raxol.Terminal.Cell.html#double_height?/1","title":"Raxol.Terminal.Cell.double_height?/1","type":"function"},{"doc":"iex> cell = Cell.new(\"A\", %{foreground: :red})\n    iex> Cell.double_height?(cell)\n    false","ref":"Raxol.Terminal.Cell.html#double_height?/1-examples","title":"Examples - Raxol.Terminal.Cell.double_height?/1","type":"function"},{"doc":"Checks if the cell is in double-width mode.","ref":"Raxol.Terminal.Cell.html#double_width?/1","title":"Raxol.Terminal.Cell.double_width?/1","type":"function"},{"doc":"iex> cell = Cell.new(\"A\", %{foreground: :red})\n    iex> Cell.double_width?(cell)\n    false","ref":"Raxol.Terminal.Cell.html#double_width?/1-examples","title":"Examples - Raxol.Terminal.Cell.double_width?/1","type":"function"},{"doc":"Creates an empty cell.","ref":"Raxol.Terminal.Cell.html#empty/0","title":"Raxol.Terminal.Cell.empty/0","type":"function"},{"doc":"Checks if a cell is empty.\n\nA cell is considered empty if it contains a space character *and*\nhas the default text formatting style.","ref":"Raxol.Terminal.Cell.html#empty?/1","title":"Raxol.Terminal.Cell.empty?/1","type":"function"},{"doc":"iex> cell = Cell.new()\n    iex> Cell.is_empty?(cell)\n    true\n\n    iex> cell = Cell.new(\"A\")\n    iex> Cell.is_empty?(cell)\n    false\n\n    iex> bold_style = TextFormatting.new() |> TextFormatting.apply_attribute(:bold)\n    iex> cell = Cell.new(\" \", bold_style) # Space char but non-default style\n    iex> Cell.is_empty?(cell)\n    false","ref":"Raxol.Terminal.Cell.html#empty?/1-examples","title":"Examples - Raxol.Terminal.Cell.empty?/1","type":"function"},{"doc":"Compares two cells for equality.\n\nCells are considered equal if they have the same character and the same style map.\nHandles comparison with `nil`.","ref":"Raxol.Terminal.Cell.html#equals?/2","title":"Raxol.Terminal.Cell.equals?/2","type":"function"},{"doc":"iex> style1 = TextFormatting.new() |> TextFormatting.apply_attribute(:bold)\n    iex> style2 = TextFormatting.new() |> TextFormatting.apply_attribute(:bold)\n    iex> style3 = TextFormatting.new() |> TextFormatting.apply_attribute(:underline)\n    iex> cell1 = Cell.new(\"A\", style1)\n    iex> cell2 = Cell.new(\"A\", style2) # Same char and style attributes\n    iex> cell3 = Cell.new(\"B\", style1) # Different char\n    iex> cell4 = Cell.new(\"A\", style3) # Different style\n    iex> Cell.equals?(cell1, cell2)\n    true\n    iex> Cell.equals?(cell1, cell3)\n    false\n    iex> Cell.equals?(cell1, cell4)\n    false\n    iex> Cell.equals?(cell1, nil)\n    false\n    iex> Cell.equals?(nil, cell1)\n    false\n    iex> Cell.equals?(nil, nil)\n    true","ref":"Raxol.Terminal.Cell.html#equals?/2-examples","title":"Examples - Raxol.Terminal.Cell.equals?/2","type":"function"},{"doc":"Creates a Cell struct from a map representation, typically from rendering.\nExpects a map like %{char: integer_codepoint, style: map, is_wide_placeholder: boolean | nil}.\nReturns nil if the map is invalid.","ref":"Raxol.Terminal.Cell.html#from_map/1","title":"Raxol.Terminal.Cell.from_map/1","type":"function"},{"doc":"Returns the character of the cell.","ref":"Raxol.Terminal.Cell.html#get_char/1","title":"Raxol.Terminal.Cell.get_char/1","type":"function"},{"doc":"Gets the text style of the cell.","ref":"Raxol.Terminal.Cell.html#get_style/1","title":"Raxol.Terminal.Cell.get_style/1","type":"function"},{"doc":"iex> cell = Cell.new(\"A\", %{foreground: :red})\n    iex> Cell.get_style(cell)\n    %{foreground: :red}","ref":"Raxol.Terminal.Cell.html#get_style/1-examples","title":"Examples - Raxol.Terminal.Cell.get_style/1","type":"function"},{"doc":"Checks if the cell has a specific attribute.","ref":"Raxol.Terminal.Cell.html#has_attribute?/2","title":"Raxol.Terminal.Cell.has_attribute?/2","type":"function"},{"doc":"iex> cell = Cell.new(\"A\", %{foreground: :red})\n    iex> Cell.has_attribute?(cell, :foreground)\n    true","ref":"Raxol.Terminal.Cell.html#has_attribute?/2-examples","title":"Examples - Raxol.Terminal.Cell.has_attribute?/2","type":"function"},{"doc":"Checks if the cell has a specific decoration.","ref":"Raxol.Terminal.Cell.html#has_decoration?/2","title":"Raxol.Terminal.Cell.has_decoration?/2","type":"function"},{"doc":"iex> cell = Cell.new(\"A\", %{foreground: :red})\n    iex> Cell.has_decoration?(cell, :bold)\n    false","ref":"Raxol.Terminal.Cell.html#has_decoration?/2-examples","title":"Examples - Raxol.Terminal.Cell.has_decoration?/2","type":"function"},{"doc":"Merges a given style map into the cell's style.\n\nOnly non-default attributes from the `style` map will overwrite existing attributes\nin the cell's style. This prevents merging default values (like `bold: false`)\nand unintentionally removing existing attributes.","ref":"Raxol.Terminal.Cell.html#merge_style/2","title":"Raxol.Terminal.Cell.merge_style/2","type":"function"},{"doc":"iex> initial_style = TextFormatting.new() |> TextFormatting.apply_attribute(:bold) # %{bold: true, ...}\n    iex> merge_style = TextFormatting.new() |> TextFormatting.apply_attribute(:underline) # %{underline: true, bold: false, ...}\n    iex> cell = Cell.new(\"A\", initial_style)\n    iex> merged_cell = Cell.merge_style(cell, merge_style)\n    iex> Cell.get_style(merged_cell)\n    %{bold: true, underline: true} # Note: :bold remains, :underline added","ref":"Raxol.Terminal.Cell.html#merge_style/2-examples","title":"Examples - Raxol.Terminal.Cell.merge_style/2","type":"function"},{"doc":"Creates a new cell with optional character and style.","ref":"Raxol.Terminal.Cell.html#new/2","title":"Raxol.Terminal.Cell.new/2","type":"function"},{"doc":"iex> cell = Cell.new()\n    iex> Cell.is_empty?(cell)\n    true\n\n    iex> cell = Cell.new(\"A\")\n    iex> Cell.get_char(cell)\n    \"A\"\n\n    iex> cell = Cell.new(\"A\", %{foreground: :red})\n    iex> Cell.get_char(cell)\n    \"A\"\n    iex> Cell.get_style(cell)\n    %{foreground: :red}","ref":"Raxol.Terminal.Cell.html#new/2-examples","title":"Examples - Raxol.Terminal.Cell.new/2","type":"function"},{"doc":"Creates a new cell representing the second half of a wide character.\nInherits the style from the primary cell.","ref":"Raxol.Terminal.Cell.html#new_wide_placeholder/1","title":"Raxol.Terminal.Cell.new_wide_placeholder/1","type":"function"},{"doc":"Sets the character content of a cell.","ref":"Raxol.Terminal.Cell.html#set_char/2","title":"Raxol.Terminal.Cell.set_char/2","type":"function"},{"doc":"iex> cell = Cell.new()\n    iex> cell = Cell.set_char(cell, \"A\")\n    iex> Cell.get_char(cell)\n    \"A\"","ref":"Raxol.Terminal.Cell.html#set_char/2-examples","title":"Examples - Raxol.Terminal.Cell.set_char/2","type":"function"},{"doc":"Sets the text style of the cell.","ref":"Raxol.Terminal.Cell.html#set_style/2","title":"Raxol.Terminal.Cell.set_style/2","type":"function"},{"doc":"iex> cell = Cell.new(\"A\")\n    iex> cell = Cell.set_style(cell, %{foreground: :red})\n    iex> Cell.get_style(cell)\n    %{foreground: :red}","ref":"Raxol.Terminal.Cell.html#set_style/2-examples","title":"Examples - Raxol.Terminal.Cell.set_style/2","type":"function"},{"doc":"Text style for a terminal cell. See `Raxol.Terminal.ANSI.TextFormatting.text_style/0` for details.","ref":"Raxol.Terminal.Cell.html#t:style/0","title":"Raxol.Terminal.Cell.style/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Cell.html#t:t/0","title":"Raxol.Terminal.Cell.t/0","type":"type"},{"doc":"Creates a copy of a cell with new attributes applied.\n\nAccepts a map of attributes or a list of attribute atoms.\nIf a list is provided, the attributes are applied sequentially, starting from the cell's *existing* style.","ref":"Raxol.Terminal.Cell.html#with_attributes/2","title":"Raxol.Terminal.Cell.with_attributes/2","type":"function"},{"doc":"iex> cell = Cell.new(\"A\", %{bold: true})\n    iex> new_cell = Cell.with_attributes(cell, %{underline: true}) # Using a map\n    iex> Cell.get_style(new_cell)\n    %{bold: true, underline: true} # Merged\n\n    iex> cell = Cell.new(\"B\", %{bold: true})\n    iex> new_cell = Cell.with_attributes(cell, [:underline, :reverse]) # Using a list\n    iex> Cell.get_style(new_cell)\n    %{bold: true, underline: true, reverse: true} # Original bold + list applied","ref":"Raxol.Terminal.Cell.html#with_attributes/2-examples","title":"Examples - Raxol.Terminal.Cell.with_attributes/2","type":"function"},{"doc":"Creates a copy of a cell with a new character.","ref":"Raxol.Terminal.Cell.html#with_char/2","title":"Raxol.Terminal.Cell.with_char/2","type":"function"},{"doc":"iex> cell = Cell.new(\"A\", %{foreground: :red})\n    iex> new_cell = Cell.with_char(cell, \"B\")\n    iex> Cell.get_char(new_cell)\n    \"B\"\n    iex> Cell.get_style(new_cell)\n    %{foreground: :red}","ref":"Raxol.Terminal.Cell.html#with_char/2-examples","title":"Examples - Raxol.Terminal.Cell.with_char/2","type":"function"},{"doc":"Handles wide character and bidirectional text support for the terminal emulator.\n\nThis module provides functions for:\n- Determining character width (single, double, or variable width)\n- Handling bidirectional text rendering\n- Managing character combining\n- Supporting Unicode character properties","ref":"Raxol.Terminal.CharacterHandling.html","title":"Raxol.Terminal.CharacterHandling","type":"module"},{"doc":"Determines if a character is a combining character.","ref":"Raxol.Terminal.CharacterHandling.html#combining_char?/1","title":"Raxol.Terminal.CharacterHandling.combining_char?/1","type":"function"},{"doc":"Determines the bidirectional character type.\nReturns :LTR, :RTL, :NEUTRAL, or :COMBINING.","ref":"Raxol.Terminal.CharacterHandling.html#get_bidi_type/1","title":"Raxol.Terminal.CharacterHandling.get_bidi_type/1","type":"function"},{"doc":"Determine the display width of a given character code point or string.","ref":"Raxol.Terminal.CharacterHandling.html#get_char_width/1","title":"Raxol.Terminal.CharacterHandling.get_char_width/1","type":"function"},{"doc":"Gets the effective width of a string, taking into account wide characters\nand ignoring combining characters.","ref":"Raxol.Terminal.CharacterHandling.html#get_string_width/1","title":"Raxol.Terminal.CharacterHandling.get_string_width/1","type":"function"},{"doc":"Processes a string for bidirectional text rendering.\nReturns a list of segments with their rendering order.","ref":"Raxol.Terminal.CharacterHandling.html#process_bidi_text/1","title":"Raxol.Terminal.CharacterHandling.process_bidi_text/1","type":"function"},{"doc":"Splits a string at a given width, respecting wide characters.","ref":"Raxol.Terminal.CharacterHandling.html#split_at_width/2","title":"Raxol.Terminal.CharacterHandling.split_at_width/2","type":"function"},{"doc":"Determines if a character is a wide character (takes up two cells).","ref":"Raxol.Terminal.CharacterHandling.html#wide_char?/1","title":"Raxol.Terminal.CharacterHandling.wide_char?/1","type":"function"},{"doc":"Manages character sets for the terminal emulator.","ref":"Raxol.Terminal.CharacterSets.html","title":"Raxol.Terminal.CharacterSets","type":"module"},{"doc":"Gets the current character set.","ref":"Raxol.Terminal.CharacterSets.html#get_current_set/1","title":"Raxol.Terminal.CharacterSets.get_current_set/1","type":"function"},{"doc":"Maps a character using the current character set.","ref":"Raxol.Terminal.CharacterSets.html#map_character/2","title":"Raxol.Terminal.CharacterSets.map_character/2","type":"function"},{"doc":"Creates a new character sets manager with default settings.","ref":"Raxol.Terminal.CharacterSets.html#new/0","title":"Raxol.Terminal.CharacterSets.new/0","type":"function"},{"doc":"Sets the current character set.","ref":"Raxol.Terminal.CharacterSets.html#set_current_set/2","title":"Raxol.Terminal.CharacterSets.set_current_set/2","type":"function"},{"doc":"Manages terminal character sets and encoding operations.","ref":"Raxol.Terminal.Charset.Manager.html","title":"Raxol.Terminal.Charset.Manager","type":"module"},{"doc":"See  Raxol.Terminal.Charset.Operations.apply_single_shift/2 .","ref":"Raxol.Terminal.Charset.Manager.html#apply_single_shift/2","title":"Raxol.Terminal.Charset.Manager.apply_single_shift/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Charset.Manager.html#t:char_map/0","title":"Raxol.Terminal.Charset.Manager.char_map/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Charset.Manager.html#t:charset/0","title":"Raxol.Terminal.Charset.Manager.charset/0","type":"type"},{"doc":"See  Raxol.Terminal.Charset.Operations.designate_charset/3 .","ref":"Raxol.Terminal.Charset.Manager.html#designate_charset/3","title":"Raxol.Terminal.Charset.Manager.designate_charset/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Charset.Manager.html#t:g_set/0","title":"Raxol.Terminal.Charset.Manager.g_set/0","type":"type"},{"doc":"Gets the current character set for the specified G-set.","ref":"Raxol.Terminal.Charset.Manager.html#get_charset/2","title":"Raxol.Terminal.Charset.Manager.get_charset/2","type":"function"},{"doc":"See  Raxol.Terminal.Charset.Operations.get_current_g_set/1 .","ref":"Raxol.Terminal.Charset.Manager.html#get_current_g_set/1","title":"Raxol.Terminal.Charset.Manager.get_current_g_set/1","type":"function"},{"doc":"See  Raxol.Terminal.Charset.Operations.get_designated_charset/2 .","ref":"Raxol.Terminal.Charset.Manager.html#get_designated_charset/2","title":"Raxol.Terminal.Charset.Manager.get_designated_charset/2","type":"function"},{"doc":"See  Raxol.Terminal.Charset.Operations.get_single_shift/1 .","ref":"Raxol.Terminal.Charset.Manager.html#get_single_shift/1","title":"Raxol.Terminal.Charset.Manager.get_single_shift/1","type":"function"},{"doc":"Gets the current state of the charset manager.","ref":"Raxol.Terminal.Charset.Manager.html#get_state/1","title":"Raxol.Terminal.Charset.Manager.get_state/1","type":"function"},{"doc":"See  Raxol.Terminal.Charset.Operations.handle_set_charset/3 .","ref":"Raxol.Terminal.Charset.Manager.html#handle_set_charset/3","title":"Raxol.Terminal.Charset.Manager.handle_set_charset/3","type":"function"},{"doc":"See  Raxol.Terminal.Charset.Operations.invoke_g_set/2 .","ref":"Raxol.Terminal.Charset.Manager.html#invoke_g_set/2","title":"Raxol.Terminal.Charset.Manager.invoke_g_set/2","type":"function"},{"doc":"Maps a character using the current character set.","ref":"Raxol.Terminal.Charset.Manager.html#map_character/2","title":"Raxol.Terminal.Charset.Manager.map_character/2","type":"function"},{"doc":"Creates a new charset manager instance.","ref":"Raxol.Terminal.Charset.Manager.html#new/0","title":"Raxol.Terminal.Charset.Manager.new/0","type":"function"},{"doc":"Resets the charset state to defaults.","ref":"Raxol.Terminal.Charset.Manager.html#reset_state/1","title":"Raxol.Terminal.Charset.Manager.reset_state/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Charset.Manager.html#t:t/0","title":"Raxol.Terminal.Charset.Manager.t/0","type":"type"},{"doc":"Updates the state of the charset manager.","ref":"Raxol.Terminal.Charset.Manager.html#update_state/2","title":"Raxol.Terminal.Charset.Manager.update_state/2","type":"function"},{"doc":"Provides character mapping functions for different character sets.","ref":"Raxol.Terminal.Charset.Maps.html","title":"Raxol.Terminal.Charset.Maps","type":"module"},{"doc":"Returns the DEC Special character map.","ref":"Raxol.Terminal.Charset.Maps.html#dec_special_map/0","title":"Raxol.Terminal.Charset.Maps.dec_special_map/0","type":"function"},{"doc":"Returns the DEC Supplementary character map.","ref":"Raxol.Terminal.Charset.Maps.html#dec_supplementary_map/0","title":"Raxol.Terminal.Charset.Maps.dec_supplementary_map/0","type":"function"},{"doc":"Returns the DEC Technical character map.","ref":"Raxol.Terminal.Charset.Maps.html#dec_technical_map/0","title":"Raxol.Terminal.Charset.Maps.dec_technical_map/0","type":"function"},{"doc":"Returns the US ASCII character map.","ref":"Raxol.Terminal.Charset.Maps.html#us_ascii_map/0","title":"Raxol.Terminal.Charset.Maps.us_ascii_map/0","type":"function"},{"doc":"Provides operations for managing character sets and their state.","ref":"Raxol.Terminal.Charset.Operations.html","title":"Raxol.Terminal.Charset.Operations","type":"module"},{"doc":"Applies a single shift to the current character.","ref":"Raxol.Terminal.Charset.Operations.html#apply_single_shift/2","title":"Raxol.Terminal.Charset.Operations.apply_single_shift/2","type":"function"},{"doc":"Designates a character set for a specific G-set.","ref":"Raxol.Terminal.Charset.Operations.html#designate_charset/3","title":"Raxol.Terminal.Charset.Operations.designate_charset/3","type":"function"},{"doc":"Gets the current G-set.","ref":"Raxol.Terminal.Charset.Operations.html#get_current_g_set/1","title":"Raxol.Terminal.Charset.Operations.get_current_g_set/1","type":"function"},{"doc":"Gets the designated charset for a G-set.","ref":"Raxol.Terminal.Charset.Operations.html#get_designated_charset/2","title":"Raxol.Terminal.Charset.Operations.get_designated_charset/2","type":"function"},{"doc":"Gets the current single shift.","ref":"Raxol.Terminal.Charset.Operations.html#get_single_shift/1","title":"Raxol.Terminal.Charset.Operations.get_single_shift/1","type":"function"},{"doc":"Handles setting the charset based on parameters and final byte.","ref":"Raxol.Terminal.Charset.Operations.html#handle_set_charset/3","title":"Raxol.Terminal.Charset.Operations.handle_set_charset/3","type":"function"},{"doc":"Invokes a G-set as the current character set.","ref":"Raxol.Terminal.Charset.Operations.html#invoke_g_set/2","title":"Raxol.Terminal.Charset.Operations.invoke_g_set/2","type":"function"},{"doc":"Defines types used across the charset modules.","ref":"Raxol.Terminal.Charset.Types.html","title":"Raxol.Terminal.Charset.Types","type":"module"},{"doc":"","ref":"Raxol.Terminal.Charset.Types.html#t:char_map/0","title":"Raxol.Terminal.Charset.Types.char_map/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Charset.Types.html#t:charset/0","title":"Raxol.Terminal.Charset.Types.charset/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Charset.Types.html#t:g_set/0","title":"Raxol.Terminal.Charset.Types.g_set/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Charset.Types.html#t:t/0","title":"Raxol.Terminal.Charset.Types.t/0","type":"type"},{"doc":"Manages the terminal character sets.","ref":"Raxol.Terminal.CharsetManager.html","title":"Raxol.Terminal.CharsetManager","type":"module"},{"doc":"Applies a single shift to the state.","ref":"Raxol.Terminal.CharsetManager.html#apply_single_shift/2","title":"Raxol.Terminal.CharsetManager.apply_single_shift/2","type":"function"},{"doc":"Designates a charset for the given g-set.","ref":"Raxol.Terminal.CharsetManager.html#designate_charset/3","title":"Raxol.Terminal.CharsetManager.designate_charset/3","type":"function"},{"doc":"Gets the current g-set.","ref":"Raxol.Terminal.CharsetManager.html#get_current_g_set/1","title":"Raxol.Terminal.CharsetManager.get_current_g_set/1","type":"function"},{"doc":"Gets the designated charset for the given g-set.","ref":"Raxol.Terminal.CharsetManager.html#get_designated_charset/2","title":"Raxol.Terminal.CharsetManager.get_designated_charset/2","type":"function"},{"doc":"Gets the current single shift.","ref":"Raxol.Terminal.CharsetManager.html#get_single_shift/1","title":"Raxol.Terminal.CharsetManager.get_single_shift/1","type":"function"},{"doc":"Gets the current state.","ref":"Raxol.Terminal.CharsetManager.html#get_state/1","title":"Raxol.Terminal.CharsetManager.get_state/1","type":"function"},{"doc":"Invokes the given g-set.","ref":"Raxol.Terminal.CharsetManager.html#invoke_g_set/2","title":"Raxol.Terminal.CharsetManager.invoke_g_set/2","type":"function"},{"doc":"Resets the state to its initial values.","ref":"Raxol.Terminal.CharsetManager.html#reset_state/1","title":"Raxol.Terminal.CharsetManager.reset_state/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.CharsetManager.html#t:t/0","title":"Raxol.Terminal.CharsetManager.t/0","type":"type"},{"doc":"Updates the state.","ref":"Raxol.Terminal.CharsetManager.html#update_state/2","title":"Raxol.Terminal.CharsetManager.update_state/2","type":"function"},{"doc":"Provides a high-level interface for clipboard operations.\n\nThis module offers a unified API for clipboard operations across different\nterminal environments. It supports:\n* Copying content to clipboard\n* Pasting content from clipboard\n* Clearing clipboard contents\n* Multiple clipboard formats","ref":"Raxol.Terminal.Clipboard.html","title":"Raxol.Terminal.Clipboard","type":"module"},{"doc":"The module supports different clipboard formats:\n* `\"text\"` - Plain text (default)\n* `\"html\"` - HTML content\n* `\"rtf\"` - Rich Text Format\n* Custom formats as needed","ref":"Raxol.Terminal.Clipboard.html#module-clipboard-formats","title":"Clipboard Formats - Raxol.Terminal.Clipboard","type":"module"},{"doc":"```elixir\n# Copy text to clipboard\nClipboard.copy(\"Hello, World!\")\n\n# Copy HTML content\nClipboard.copy(\" Hello \", \"html\")\n\n# Paste from clipboard\n{:ok, content} = Clipboard.paste()\n\n# Clear clipboard\nClipboard.clear()\n```","ref":"Raxol.Terminal.Clipboard.html#module-usage","title":"Usage - Raxol.Terminal.Clipboard","type":"module"},{"doc":"Clears the clipboard contents.","ref":"Raxol.Terminal.Clipboard.html#clear/0","title":"Raxol.Terminal.Clipboard.clear/0","type":"function"},{"doc":"* `:ok` - Clipboard cleared successfully","ref":"Raxol.Terminal.Clipboard.html#clear/0-returns","title":"Returns - Raxol.Terminal.Clipboard.clear/0","type":"function"},{"doc":"iex> Clipboard.copy(\"Hello, World!\")\n    iex> Clipboard.clear()\n    iex> Clipboard.paste()\n    {:error, :empty_clipboard}","ref":"Raxol.Terminal.Clipboard.html#clear/0-examples","title":"Examples - Raxol.Terminal.Clipboard.clear/0","type":"function"},{"doc":"Copies content to the clipboard.","ref":"Raxol.Terminal.Clipboard.html#copy/2","title":"Raxol.Terminal.Clipboard.copy/2","type":"function"},{"doc":"* `content` - The content to copy\n  * `format` - The clipboard format (default: \"text\")","ref":"Raxol.Terminal.Clipboard.html#copy/2-parameters","title":"Parameters - Raxol.Terminal.Clipboard.copy/2","type":"function"},{"doc":"* `:ok` - Content copied successfully","ref":"Raxol.Terminal.Clipboard.html#copy/2-returns","title":"Returns - Raxol.Terminal.Clipboard.copy/2","type":"function"},{"doc":"iex> Clipboard.copy(\"Hello, World!\")\n    :ok\n\n    iex> Clipboard.copy(\" Hello \", \"html\")\n    :ok","ref":"Raxol.Terminal.Clipboard.html#copy/2-examples","title":"Examples - Raxol.Terminal.Clipboard.copy/2","type":"function"},{"doc":"Pastes content from the clipboard.","ref":"Raxol.Terminal.Clipboard.html#paste/1","title":"Raxol.Terminal.Clipboard.paste/1","type":"function"},{"doc":"* `format` - The clipboard format to paste (default: \"text\")","ref":"Raxol.Terminal.Clipboard.html#paste/1-parameters","title":"Parameters - Raxol.Terminal.Clipboard.paste/1","type":"function"},{"doc":"* `{:ok, content}` - Content pasted successfully\n  * `{:error, :empty_clipboard}` - Clipboard is empty","ref":"Raxol.Terminal.Clipboard.html#paste/1-returns","title":"Returns - Raxol.Terminal.Clipboard.paste/1","type":"function"},{"doc":"iex> Clipboard.copy(\"Hello, World!\")\n    iex> Clipboard.paste()\n    {:ok, \"Hello, World!\"}\n\n    iex> Clipboard.clear()\n    iex> Clipboard.paste()\n    {:error, :empty_clipboard}","ref":"Raxol.Terminal.Clipboard.html#paste/1-examples","title":"Examples - Raxol.Terminal.Clipboard.paste/1","type":"function"},{"doc":"Handles clipboard content formatting and filtering.","ref":"Raxol.Terminal.Clipboard.Format.html","title":"Raxol.Terminal.Clipboard.Format","type":"module"},{"doc":"Applies a filter to clipboard content.","ref":"Raxol.Terminal.Clipboard.Format.html#apply_filter/3","title":"Raxol.Terminal.Clipboard.Format.apply_filter/3","type":"function"},{"doc":"Strips formatting from content.","ref":"Raxol.Terminal.Clipboard.Format.html#strip_formatting/1","title":"Raxol.Terminal.Clipboard.Format.strip_formatting/1","type":"function"},{"doc":"Converts content to HTML format.","ref":"Raxol.Terminal.Clipboard.Format.html#to_html/2","title":"Raxol.Terminal.Clipboard.Format.to_html/2","type":"function"},{"doc":"Converts content to RTF format.","ref":"Raxol.Terminal.Clipboard.Format.html#to_rtf/2","title":"Raxol.Terminal.Clipboard.Format.to_rtf/2","type":"function"},{"doc":"Manages clipboard history for the terminal.","ref":"Raxol.Terminal.Clipboard.History.html","title":"Raxol.Terminal.Clipboard.History","type":"module"},{"doc":"Adds content to the clipboard history.","ref":"Raxol.Terminal.Clipboard.History.html#add/3","title":"Raxol.Terminal.Clipboard.History.add/3","type":"function"},{"doc":"Clears the clipboard history.","ref":"Raxol.Terminal.Clipboard.History.html#clear/1","title":"Raxol.Terminal.Clipboard.History.clear/1","type":"function"},{"doc":"Gets content from the clipboard history by index.","ref":"Raxol.Terminal.Clipboard.History.html#get/3","title":"Raxol.Terminal.Clipboard.History.get/3","type":"function"},{"doc":"Gets all entries from the clipboard history with the specified format.","ref":"Raxol.Terminal.Clipboard.History.html#get_all/3","title":"Raxol.Terminal.Clipboard.History.get_all/3","type":"function"},{"doc":"Creates a new clipboard history with the specified size limit.","ref":"Raxol.Terminal.Clipboard.History.html#new/1","title":"Raxol.Terminal.Clipboard.History.new/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Clipboard.History.html#t:t/0","title":"Raxol.Terminal.Clipboard.History.t/0","type":"type"},{"doc":"Manages clipboard operations for the terminal, including copying and pasting text.","ref":"Raxol.Terminal.Clipboard.Manager.html","title":"Raxol.Terminal.Clipboard.Manager","type":"module"},{"doc":"Appends text to the current clipboard content.","ref":"Raxol.Terminal.Clipboard.Manager.html#append/2","title":"Raxol.Terminal.Clipboard.Manager.append/2","type":"function"},{"doc":"Clears the clipboard content.","ref":"Raxol.Terminal.Clipboard.Manager.html#clear/1","title":"Raxol.Terminal.Clipboard.Manager.clear/1","type":"function"},{"doc":"Checks if the clipboard is empty.","ref":"Raxol.Terminal.Clipboard.Manager.html#empty?/1","title":"Raxol.Terminal.Clipboard.Manager.empty?/1","type":"function"},{"doc":"Gets the current clipboard content.","ref":"Raxol.Terminal.Clipboard.Manager.html#get_content/1","title":"Raxol.Terminal.Clipboard.Manager.get_content/1","type":"function"},{"doc":"Gets the current clipboard mode.","ref":"Raxol.Terminal.Clipboard.Manager.html#get_mode/1","title":"Raxol.Terminal.Clipboard.Manager.get_mode/1","type":"function"},{"doc":"Gets the length of the clipboard content.","ref":"Raxol.Terminal.Clipboard.Manager.html#length/1","title":"Raxol.Terminal.Clipboard.Manager.length/1","type":"function"},{"doc":"Creates a new clipboard manager instance.","ref":"Raxol.Terminal.Clipboard.Manager.html#new/0","title":"Raxol.Terminal.Clipboard.Manager.new/0","type":"function"},{"doc":"Prepends text to the current clipboard content.","ref":"Raxol.Terminal.Clipboard.Manager.html#prepend/2","title":"Raxol.Terminal.Clipboard.Manager.prepend/2","type":"function"},{"doc":"Resets the clipboard manager to its initial state.","ref":"Raxol.Terminal.Clipboard.Manager.html#reset/1","title":"Raxol.Terminal.Clipboard.Manager.reset/1","type":"function"},{"doc":"Sets the clipboard content.","ref":"Raxol.Terminal.Clipboard.Manager.html#set_content/2","title":"Raxol.Terminal.Clipboard.Manager.set_content/2","type":"function"},{"doc":"Sets the clipboard mode.","ref":"Raxol.Terminal.Clipboard.Manager.html#set_mode/2","title":"Raxol.Terminal.Clipboard.Manager.set_mode/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Clipboard.Manager.html#t:t/0","title":"Raxol.Terminal.Clipboard.Manager.t/0","type":"type"},{"doc":"Manages clipboard content storage and retrieval.","ref":"Raxol.Terminal.Clipboard.Store.html","title":"Raxol.Terminal.Clipboard.Store","type":"module"},{"doc":"Checks if a store entry is expired.","ref":"Raxol.Terminal.Clipboard.Store.html#expired?/2","title":"Raxol.Terminal.Clipboard.Store.expired?/2","type":"function"},{"doc":"Gets the content from a store entry.","ref":"Raxol.Terminal.Clipboard.Store.html#get_content/1","title":"Raxol.Terminal.Clipboard.Store.get_content/1","type":"function"},{"doc":"Gets the format from a store entry.","ref":"Raxol.Terminal.Clipboard.Store.html#get_format/1","title":"Raxol.Terminal.Clipboard.Store.get_format/1","type":"function"},{"doc":"Gets the timestamp from a store entry.","ref":"Raxol.Terminal.Clipboard.Store.html#get_timestamp/1","title":"Raxol.Terminal.Clipboard.Store.get_timestamp/1","type":"function"},{"doc":"Creates a new clipboard store entry.","ref":"Raxol.Terminal.Clipboard.Store.html#new/2","title":"Raxol.Terminal.Clipboard.Store.new/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Clipboard.Store.html#t:t/0","title":"Raxol.Terminal.Clipboard.Store.t/0","type":"type"},{"doc":"Updates the content of a store entry.","ref":"Raxol.Terminal.Clipboard.Store.html#update_content/2","title":"Raxol.Terminal.Clipboard.Store.update_content/2","type":"function"},{"doc":"Updates the format of a store entry.","ref":"Raxol.Terminal.Clipboard.Store.html#update_format/2","title":"Raxol.Terminal.Clipboard.Store.update_format/2","type":"function"},{"doc":"Handles clipboard synchronization between different terminal instances.","ref":"Raxol.Terminal.Clipboard.Sync.html","title":"Raxol.Terminal.Clipboard.Sync","type":"module"},{"doc":"Adds a subscriber to receive clipboard updates.","ref":"Raxol.Terminal.Clipboard.Sync.html#add_subscriber/2","title":"Raxol.Terminal.Clipboard.Sync.add_subscriber/2","type":"function"},{"doc":"Broadcasts clipboard content to all subscribers.","ref":"Raxol.Terminal.Clipboard.Sync.html#broadcast/3","title":"Raxol.Terminal.Clipboard.Sync.broadcast/3","type":"function"},{"doc":"Creates a new clipboard sync instance.","ref":"Raxol.Terminal.Clipboard.Sync.html#new/0","title":"Raxol.Terminal.Clipboard.Sync.new/0","type":"function"},{"doc":"Removes a subscriber from receiving clipboard updates.","ref":"Raxol.Terminal.Clipboard.Sync.html#remove_subscriber/2","title":"Raxol.Terminal.Clipboard.Sync.remove_subscriber/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Clipboard.Sync.html#t:t/0","title":"Raxol.Terminal.Clipboard.Sync.t/0","type":"type"},{"doc":"Defines the behaviour for clipboard operations in the terminal.\n\nThis behaviour specifies the callbacks that must be implemented by any module\nthat wants to handle clipboard operations in the terminal emulator.","ref":"Raxol.Terminal.ClipboardBehaviour.html","title":"Raxol.Terminal.ClipboardBehaviour","type":"behaviour"},{"doc":"Clears the clipboard content.\n\nReturns `{:ok, updated_clipboard}` on success, or `{:error, reason}` on failure.","ref":"Raxol.Terminal.ClipboardBehaviour.html#c:clear/1","title":"Raxol.Terminal.ClipboardBehaviour.clear/1","type":"callback"},{"doc":"Gets the current content of the clipboard.\n\nReturns `{:ok, content}` on success, or `{:error, reason}` on failure.","ref":"Raxol.Terminal.ClipboardBehaviour.html#c:get_content/1","title":"Raxol.Terminal.ClipboardBehaviour.get_content/1","type":"callback"},{"doc":"Gets the current selection content.\n\nReturns `{:ok, content}` on success, or `{:error, reason}` on failure.","ref":"Raxol.Terminal.ClipboardBehaviour.html#c:get_selection/1","title":"Raxol.Terminal.ClipboardBehaviour.get_selection/1","type":"callback"},{"doc":"Sets the content of the clipboard.\n\nReturns `{:ok, updated_clipboard}` on success, or `{:error, reason}` on failure.","ref":"Raxol.Terminal.ClipboardBehaviour.html#c:set_content/2","title":"Raxol.Terminal.ClipboardBehaviour.set_content/2","type":"callback"},{"doc":"Sets the selection content.\n\nReturns `{:ok, updated_clipboard}` on success, or `{:error, reason}` on failure.","ref":"Raxol.Terminal.ClipboardBehaviour.html#c:set_selection/2","title":"Raxol.Terminal.ClipboardBehaviour.set_selection/2","type":"callback"},{"doc":"Manages terminal colors and color operations.","ref":"Raxol.Terminal.Color.Manager.html","title":"Raxol.Terminal.Color.Manager","type":"module"},{"doc":"","ref":"Raxol.Terminal.Color.Manager.html#t:color/0","title":"Raxol.Terminal.Color.Manager.color/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Color.Manager.html#t:color_map/0","title":"Raxol.Terminal.Color.Manager.color_map/0","type":"type"},{"doc":"Converts a color to RGB format.","ref":"Raxol.Terminal.Color.Manager.html#color_to_rgb/2","title":"Raxol.Terminal.Color.Manager.color_to_rgb/2","type":"function"},{"doc":"Gets a specific color by name.","ref":"Raxol.Terminal.Color.Manager.html#get_color/2","title":"Raxol.Terminal.Color.Manager.get_color/2","type":"function"},{"doc":"Gets all current colors.","ref":"Raxol.Terminal.Color.Manager.html#get_colors/1","title":"Raxol.Terminal.Color.Manager.get_colors/1","type":"function"},{"doc":"Gets the default color palette.","ref":"Raxol.Terminal.Color.Manager.html#get_default_palette/1","title":"Raxol.Terminal.Color.Manager.get_default_palette/1","type":"function"},{"doc":"Merges a new palette with the existing one.","ref":"Raxol.Terminal.Color.Manager.html#merge_palette/2","title":"Raxol.Terminal.Color.Manager.merge_palette/2","type":"function"},{"doc":"Creates a new color manager instance.","ref":"Raxol.Terminal.Color.Manager.html#new/1","title":"Raxol.Terminal.Color.Manager.new/1","type":"function"},{"doc":"Resets all colors to their default values.","ref":"Raxol.Terminal.Color.Manager.html#reset_colors/1","title":"Raxol.Terminal.Color.Manager.reset_colors/1","type":"function"},{"doc":"Sets a specific color by name.","ref":"Raxol.Terminal.Color.Manager.html#set_color/3","title":"Raxol.Terminal.Color.Manager.set_color/3","type":"function"},{"doc":"Sets multiple colors at once.","ref":"Raxol.Terminal.Color.Manager.html#set_colors/2","title":"Raxol.Terminal.Color.Manager.set_colors/2","type":"function"},{"doc":"Sets a custom color palette.","ref":"Raxol.Terminal.Color.Manager.html#set_palette/2","title":"Raxol.Terminal.Color.Manager.set_palette/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Color.Manager.html#t:t/0","title":"Raxol.Terminal.Color.Manager.t/0","type":"type"},{"doc":"Manages terminal colors and color-related operations.","ref":"Raxol.Terminal.Colors.html","title":"Raxol.Terminal.Colors","type":"module"},{"doc":"","ref":"Raxol.Terminal.Colors.html#t:color/0","title":"Raxol.Terminal.Colors.color/0","type":"type"},{"doc":"Gets the current background color.","ref":"Raxol.Terminal.Colors.html#get_background/1","title":"Raxol.Terminal.Colors.get_background/1","type":"function"},{"doc":"Gets the current cursor color.","ref":"Raxol.Terminal.Colors.html#get_cursor_color/1","title":"Raxol.Terminal.Colors.get_cursor_color/1","type":"function"},{"doc":"Gets the current foreground color.","ref":"Raxol.Terminal.Colors.html#get_foreground/1","title":"Raxol.Terminal.Colors.get_foreground/1","type":"function"},{"doc":"Gets the current selection background color.","ref":"Raxol.Terminal.Colors.html#get_selection_background/1","title":"Raxol.Terminal.Colors.get_selection_background/1","type":"function"},{"doc":"Gets the current selection foreground color.","ref":"Raxol.Terminal.Colors.html#get_selection_foreground/1","title":"Raxol.Terminal.Colors.get_selection_foreground/1","type":"function"},{"doc":"Resets the background color to default.","ref":"Raxol.Terminal.Colors.html#reset_background/1","title":"Raxol.Terminal.Colors.reset_background/1","type":"function"},{"doc":"Resets the cursor color to default.","ref":"Raxol.Terminal.Colors.html#reset_cursor_color/1","title":"Raxol.Terminal.Colors.reset_cursor_color/1","type":"function"},{"doc":"Resets the foreground color to default.","ref":"Raxol.Terminal.Colors.html#reset_foreground/1","title":"Raxol.Terminal.Colors.reset_foreground/1","type":"function"},{"doc":"Resets the selection background color to default.","ref":"Raxol.Terminal.Colors.html#reset_selection_background/1","title":"Raxol.Terminal.Colors.reset_selection_background/1","type":"function"},{"doc":"Resets the selection foreground color to default.","ref":"Raxol.Terminal.Colors.html#reset_selection_foreground/1","title":"Raxol.Terminal.Colors.reset_selection_foreground/1","type":"function"},{"doc":"Sets the background color.","ref":"Raxol.Terminal.Colors.html#set_background/2","title":"Raxol.Terminal.Colors.set_background/2","type":"function"},{"doc":"Sets the cursor color.","ref":"Raxol.Terminal.Colors.html#set_cursor_color/2","title":"Raxol.Terminal.Colors.set_cursor_color/2","type":"function"},{"doc":"Sets the foreground color.","ref":"Raxol.Terminal.Colors.html#set_foreground/2","title":"Raxol.Terminal.Colors.set_foreground/2","type":"function"},{"doc":"Sets the selection background color.","ref":"Raxol.Terminal.Colors.html#set_selection_background/2","title":"Raxol.Terminal.Colors.set_selection_background/2","type":"function"},{"doc":"Sets the selection foreground color.","ref":"Raxol.Terminal.Colors.html#set_selection_foreground/2","title":"Raxol.Terminal.Colors.set_selection_foreground/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Colors.html#t:t/0","title":"Raxol.Terminal.Colors.t/0","type":"type"},{"doc":"Manages terminal command state, history, and execution.","ref":"Raxol.Terminal.Command.Manager.html","title":"Raxol.Terminal.Command.Manager","type":"module"},{"doc":"Adds a command to the history.","ref":"Raxol.Terminal.Command.Manager.html#add_to_history/2","title":"Raxol.Terminal.Command.Manager.add_to_history/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Command.Manager.html#child_spec/1","title":"Raxol.Terminal.Command.Manager.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Command.Manager.html#clear_command_buffer/1","title":"Raxol.Terminal.Command.Manager.clear_command_buffer/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Command.Manager.html#clear_command_history/1","title":"Raxol.Terminal.Command.Manager.clear_command_history/1","type":"function"},{"doc":"Clears the command history.","ref":"Raxol.Terminal.Command.Manager.html#clear_history/1","title":"Raxol.Terminal.Command.Manager.clear_history/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Command.Manager.html#execute_command/2","title":"Raxol.Terminal.Command.Manager.execute_command/2","type":"function"},{"doc":"Gets the current command buffer.","ref":"Raxol.Terminal.Command.Manager.html#get_command_buffer/1","title":"Raxol.Terminal.Command.Manager.get_command_buffer/1","type":"function"},{"doc":"Gets the command history.","ref":"Raxol.Terminal.Command.Manager.html#get_command_history/1","title":"Raxol.Terminal.Command.Manager.get_command_history/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Command.Manager.html#get_command_state/1","title":"Raxol.Terminal.Command.Manager.get_command_state/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Command.Manager.html#get_current_command/1","title":"Raxol.Terminal.Command.Manager.get_current_command/1","type":"function"},{"doc":"Gets a command from history by index.","ref":"Raxol.Terminal.Command.Manager.html#get_history_command/2","title":"Raxol.Terminal.Command.Manager.get_history_command/2","type":"function"},{"doc":"Gets the last key event.","ref":"Raxol.Terminal.Command.Manager.html#get_last_key_event/1","title":"Raxol.Terminal.Command.Manager.get_last_key_event/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Command.Manager.html#new/1","title":"Raxol.Terminal.Command.Manager.new/1","type":"function"},{"doc":"Processes a key event and updates the command buffer accordingly.","ref":"Raxol.Terminal.Command.Manager.html#process_key_event/2","title":"Raxol.Terminal.Command.Manager.process_key_event/2","type":"function"},{"doc":"Searches command history for a matching command.","ref":"Raxol.Terminal.Command.Manager.html#search_history/2","title":"Raxol.Terminal.Command.Manager.search_history/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Command.Manager.html#set_command_state/2","title":"Raxol.Terminal.Command.Manager.set_command_state/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Command.Manager.html#set_current_command/2","title":"Raxol.Terminal.Command.Manager.set_current_command/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Command.Manager.html#start_link/1","title":"Raxol.Terminal.Command.Manager.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Command.Manager.html#t:t/0","title":"Raxol.Terminal.Command.Manager.t/0","type":"type"},{"doc":"Updates the command buffer.","ref":"Raxol.Terminal.Command.Manager.html#update_command_buffer/2","title":"Raxol.Terminal.Command.Manager.update_command_buffer/2","type":"function"},{"doc":"Updates the last key event.","ref":"Raxol.Terminal.Command.Manager.html#update_last_key_event/2","title":"Raxol.Terminal.Command.Manager.update_last_key_event/2","type":"function"},{"doc":"DEPRECATED: Handles the execution of parsed terminal commands.\n\nThis module is being replaced by `Raxol.Terminal.Commands.Executor` and\nvarious submodules within `Raxol.Terminal.Commands.*`.\n\nExisting functions are kept temporarily for backward compatibility or as\nplaceholders during refactoring, but they primarily log warnings and delegate\nto the new modules where possible.\n\nFor mode handling, use `Raxol.Terminal.Commands.ModeHandlers` instead.","ref":"Raxol.Terminal.CommandExecutor.html","title":"Raxol.Terminal.CommandExecutor","type":"module"},{"doc":"Executes a CSI (Control Sequence Introducer) command.\n\nDEPRECATED: Use Raxol.Terminal.Commands.Executor.execute_csi_command/4 instead.","ref":"Raxol.Terminal.CommandExecutor.html#execute_csi_command/4","title":"Raxol.Terminal.CommandExecutor.execute_csi_command/4","type":"function"},{"doc":"Executes a DCS (Device Control String) command.\n\nDEPRECATED: Use Raxol.Terminal.Commands.Executor.execute_dcs_command/5 instead.","ref":"Raxol.Terminal.CommandExecutor.html#execute_dcs_command/5","title":"Raxol.Terminal.CommandExecutor.execute_dcs_command/5","type":"function"},{"doc":"Executes an OSC (Operating System Command).\n\nDEPRECATED: Use Raxol.Terminal.Commands.Executor.execute_osc_command/2 instead.","ref":"Raxol.Terminal.CommandExecutor.html#execute_osc_command/2","title":"Raxol.Terminal.CommandExecutor.execute_osc_command/2","type":"function"},{"doc":"Gets a parameter at a specific index from the params list.\n\nDEPRECATED: Use Raxol.Terminal.Commands.Parser.get_param/3 instead.","ref":"Raxol.Terminal.CommandExecutor.html#get_param/3","title":"Raxol.Terminal.CommandExecutor.get_param/3","type":"function"},{"doc":"Parses a raw parameter string buffer into a list of integers or nil values.\n\nDEPRECATED: Use Raxol.Terminal.Commands.Parser.parse_params/1 instead.","ref":"Raxol.Terminal.CommandExecutor.html#parse_params/1","title":"Raxol.Terminal.CommandExecutor.parse_params/1","type":"function"},{"doc":"Handles buffer manipulation commands.","ref":"Raxol.Terminal.Commands.BufferHandlers.html","title":"Raxol.Terminal.Commands.BufferHandlers","type":"module"},{"doc":"Handles the \"l\" command (insert blank lines).","ref":"Raxol.Terminal.Commands.BufferHandlers.html#handle_l/2","title":"Raxol.Terminal.Commands.BufferHandlers.handle_l/2","type":"function"},{"doc":"Handles the \"m\" command (delete lines).","ref":"Raxol.Terminal.Commands.BufferHandlers.html#handle_m/2","title":"Raxol.Terminal.Commands.BufferHandlers.handle_m/2","type":"function"},{"doc":"Handles the \"x\" command (erase characters).","ref":"Raxol.Terminal.Commands.BufferHandlers.html#handle_x/2","title":"Raxol.Terminal.Commands.BufferHandlers.handle_x/2","type":"function"},{"doc":"Handlers for CSI (Control Sequence Introducer) commands.","ref":"Raxol.Terminal.Commands.CSIHandlers.html","title":"Raxol.Terminal.Commands.CSIHandlers","type":"module"},{"doc":"","ref":"Raxol.Terminal.Commands.CSIHandlers.html#handle_basic_command/3","title":"Raxol.Terminal.Commands.CSIHandlers.handle_basic_command/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Commands.CSIHandlers.html#handle_cursor_command/3","title":"Raxol.Terminal.Commands.CSIHandlers.handle_cursor_command/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Commands.CSIHandlers.html#handle_deccusr/2","title":"Raxol.Terminal.Commands.CSIHandlers.handle_deccusr/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Commands.CSIHandlers.html#handle_device_command/4","title":"Raxol.Terminal.Commands.CSIHandlers.handle_device_command/4","type":"function"},{"doc":"","ref":"Raxol.Terminal.Commands.CSIHandlers.html#handle_h_or_l/4","title":"Raxol.Terminal.Commands.CSIHandlers.handle_h_or_l/4","type":"function"},{"doc":"Handles DECCUSR (DEC Cursor Style Report) command.\nThis is an alias for handle_deccusr/2 for backward compatibility.","ref":"Raxol.Terminal.Commands.CSIHandlers.html#handle_q_deccusr/2","title":"Raxol.Terminal.Commands.CSIHandlers.handle_q_deccusr/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Commands.CSIHandlers.html#handle_screen_command/3","title":"Raxol.Terminal.Commands.CSIHandlers.handle_screen_command/3","type":"function"},{"doc":"Handles SCS (Select Character Set) command.\nThe final_byte parameter determines which character set to select.","ref":"Raxol.Terminal.Commands.CSIHandlers.html#handle_scs/3","title":"Raxol.Terminal.Commands.CSIHandlers.handle_scs/3","type":"function"},{"doc":"Handlers for basic CSI commands.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html","title":"Raxol.Terminal.Commands.CSIHandlers.Basic","type":"module"},{"doc":"Handles basic CSI commands.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html#handle_command/3","title":"Raxol.Terminal.Commands.CSIHandlers.Basic.handle_command/3","type":"function"},{"doc":"Cursor Position (CUP)\nMoves cursor to specified position.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html#handle_cup/2","title":"Raxol.Terminal.Commands.CSIHandlers.Basic.handle_cup/2","type":"function"},{"doc":"Device Attributes (DA)\nReports device attributes.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html#handle_da/2","title":"Raxol.Terminal.Commands.CSIHandlers.Basic.handle_da/2","type":"function"},{"doc":"Restore Cursor (DECRC)\nRestores previously saved cursor position and attributes.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html#handle_decrc/2","title":"Raxol.Terminal.Commands.CSIHandlers.Basic.handle_decrc/2","type":"function"},{"doc":"Save Cursor (DECSC)\nSaves current cursor position and attributes.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html#handle_decsc/2","title":"Raxol.Terminal.Commands.CSIHandlers.Basic.handle_decsc/2","type":"function"},{"doc":"Set Cursor Style (DECSCUSR)\nSets the cursor style.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html#handle_decscusr/2","title":"Raxol.Terminal.Commands.CSIHandlers.Basic.handle_decscusr/2","type":"function"},{"doc":"Set Left and Right Margins (DECSLRM)\nSets the horizontal margins.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html#handle_decslrm/2","title":"Raxol.Terminal.Commands.CSIHandlers.Basic.handle_decslrm/2","type":"function"},{"doc":"Set Top and Bottom Margins (DECSTBM)\nSets the scroll region.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html#handle_decstbm/2","title":"Raxol.Terminal.Commands.CSIHandlers.Basic.handle_decstbm/2","type":"function"},{"doc":"Soft Terminal Reset (DECSTR)\nResets terminal to initial state.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html#handle_decstr/2","title":"Raxol.Terminal.Commands.CSIHandlers.Basic.handle_decstr/2","type":"function"},{"doc":"Device Status Report (DSR)\nReports cursor position or device status.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html#handle_dsr/2","title":"Raxol.Terminal.Commands.CSIHandlers.Basic.handle_dsr/2","type":"function"},{"doc":"Erase in Display (ED)\nClears parts of the screen.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html#handle_ed/2","title":"Raxol.Terminal.Commands.CSIHandlers.Basic.handle_ed/2","type":"function"},{"doc":"Erase in Line (EL)\nClears parts of the current line.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html#handle_el/2","title":"Raxol.Terminal.Commands.CSIHandlers.Basic.handle_el/2","type":"function"},{"doc":"Reset Mode (RM)\nResets terminal modes.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html#handle_rm/2","title":"Raxol.Terminal.Commands.CSIHandlers.Basic.handle_rm/2","type":"function"},{"doc":"Select Graphic Rendition (SGR)\nSets text attributes and colors.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html#handle_sgr/2","title":"Raxol.Terminal.Commands.CSIHandlers.Basic.handle_sgr/2","type":"function"},{"doc":"Set Mode (SM)\nSets terminal modes.","ref":"Raxol.Terminal.Commands.CSIHandlers.Basic.html#handle_sm/2","title":"Raxol.Terminal.Commands.CSIHandlers.Basic.handle_sm/2","type":"function"},{"doc":"Handles CSI cursor control sequences.","ref":"Raxol.Terminal.Commands.CSIHandlers.Cursor.html","title":"Raxol.Terminal.Commands.CSIHandlers.Cursor","type":"module"},{"doc":"Handles Cursor Horizontal Absolute (CHA - 'G')","ref":"Raxol.Terminal.Commands.CSIHandlers.Cursor.html#handle_cha/2","title":"Raxol.Terminal.Commands.CSIHandlers.Cursor.handle_cha/2","type":"function"},{"doc":"Handles Cursor Next Line (CNL - 'E')","ref":"Raxol.Terminal.Commands.CSIHandlers.Cursor.html#handle_cnl/2","title":"Raxol.Terminal.Commands.CSIHandlers.Cursor.handle_cnl/2","type":"function"},{"doc":"Handles cursor movement commands.","ref":"Raxol.Terminal.Commands.CSIHandlers.Cursor.html#handle_command/3","title":"Raxol.Terminal.Commands.CSIHandlers.Cursor.handle_command/3","type":"function"},{"doc":"Handles Cursor Previous Line (CPL - 'F')","ref":"Raxol.Terminal.Commands.CSIHandlers.Cursor.html#handle_cpl/2","title":"Raxol.Terminal.Commands.CSIHandlers.Cursor.handle_cpl/2","type":"function"},{"doc":"Handles Cursor Backward (CUB - 'D')","ref":"Raxol.Terminal.Commands.CSIHandlers.Cursor.html#handle_cub/2","title":"Raxol.Terminal.Commands.CSIHandlers.Cursor.handle_cub/2","type":"function"},{"doc":"Handles Cursor Down (CUD - 'B')","ref":"Raxol.Terminal.Commands.CSIHandlers.Cursor.html#handle_cud/2","title":"Raxol.Terminal.Commands.CSIHandlers.Cursor.handle_cud/2","type":"function"},{"doc":"Handles Cursor Forward (CUF - 'C')","ref":"Raxol.Terminal.Commands.CSIHandlers.Cursor.html#handle_cuf/2","title":"Raxol.Terminal.Commands.CSIHandlers.Cursor.handle_cuf/2","type":"function"},{"doc":"Handles Cursor Position (CUP - 'H')","ref":"Raxol.Terminal.Commands.CSIHandlers.Cursor.html#handle_cup/2","title":"Raxol.Terminal.Commands.CSIHandlers.Cursor.handle_cup/2","type":"function"},{"doc":"Handles Cursor Up (CUU - 'A')","ref":"Raxol.Terminal.Commands.CSIHandlers.Cursor.html#handle_cuu/2","title":"Raxol.Terminal.Commands.CSIHandlers.Cursor.handle_cuu/2","type":"function"},{"doc":"Handles Horizontal Position Absolute (HPA - '`')","ref":"Raxol.Terminal.Commands.CSIHandlers.Cursor.html#handle_hpa/2","title":"Raxol.Terminal.Commands.CSIHandlers.Cursor.handle_hpa/2","type":"function"},{"doc":"Handles Horizontal Position Relative (HPR - 'a')","ref":"Raxol.Terminal.Commands.CSIHandlers.Cursor.html#handle_hpr/2","title":"Raxol.Terminal.Commands.CSIHandlers.Cursor.handle_hpr/2","type":"function"},{"doc":"Handles Vertical Position Absolute (VPA - 'd')","ref":"Raxol.Terminal.Commands.CSIHandlers.Cursor.html#handle_vpa/2","title":"Raxol.Terminal.Commands.CSIHandlers.Cursor.handle_vpa/2","type":"function"},{"doc":"Handlers for device-related CSI commands.","ref":"Raxol.Terminal.Commands.CSIHandlers.Device.html","title":"Raxol.Terminal.Commands.CSIHandlers.Device","type":"module"},{"doc":"","ref":"Raxol.Terminal.Commands.CSIHandlers.Device.html#handle_command/4","title":"Raxol.Terminal.Commands.CSIHandlers.Device.handle_command/4","type":"function"},{"doc":"Handle Device Attributes (DA) command.\nResponds with terminal capabilities.","ref":"Raxol.Terminal.Commands.CSIHandlers.Device.html#handle_da/3","title":"Raxol.Terminal.Commands.CSIHandlers.Device.handle_da/3","type":"function"},{"doc":"Handle Restore Cursor (DECRC) command.\nRestores cursor position and attributes.","ref":"Raxol.Terminal.Commands.CSIHandlers.Device.html#handle_decrc/2","title":"Raxol.Terminal.Commands.CSIHandlers.Device.handle_decrc/2","type":"function"},{"doc":"Handle Save Cursor (DECSC) command.\nSaves cursor position and attributes.","ref":"Raxol.Terminal.Commands.CSIHandlers.Device.html#handle_decsc/2","title":"Raxol.Terminal.Commands.CSIHandlers.Device.handle_decsc/2","type":"function"},{"doc":"Handle Device Status Report (DSR) command.\nResponds with cursor position or device status.","ref":"Raxol.Terminal.Commands.CSIHandlers.Device.html#handle_dsr/2","title":"Raxol.Terminal.Commands.CSIHandlers.Device.handle_dsr/2","type":"function"},{"doc":"Handle Window Manipulation (XTWINOPS) command.\nHandles window size and state changes.","ref":"Raxol.Terminal.Commands.CSIHandlers.Device.html#handle_xtwinops/2","title":"Raxol.Terminal.Commands.CSIHandlers.Device.handle_xtwinops/2","type":"function"},{"doc":"Main coordinator module for CSI (Control Sequence Introducer) commands.\nRoutes commands to the appropriate handler modules.","ref":"Raxol.Terminal.Commands.CSIHandlers.Main.html","title":"Raxol.Terminal.Commands.CSIHandlers.Main","type":"module"},{"doc":"Handles CSI commands by routing them to the appropriate handler module.","ref":"Raxol.Terminal.Commands.CSIHandlers.Main.html#handle_command/4","title":"Raxol.Terminal.Commands.CSIHandlers.Main.handle_command/4","type":"function"},{"doc":"Handles Select Graphic Rendition (SGR) commands.","ref":"Raxol.Terminal.Commands.CSIHandlers.SGRHandler.html","title":"Raxol.Terminal.Commands.CSIHandlers.SGRHandler","type":"module"},{"doc":"Handle Select Graphic Rendition (SGR) command.\nSets terminal modes based on the given parameters.","ref":"Raxol.Terminal.Commands.CSIHandlers.SGRHandler.html#handle/2","title":"Raxol.Terminal.Commands.CSIHandlers.SGRHandler.handle/2","type":"function"},{"doc":"Handles screen-related CSI commands.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html","title":"Raxol.Terminal.Commands.CSIHandlers.Screen","type":"module"},{"doc":"Handle Cursor Backward Tab (CBT) command.\nMoves cursor to the previous tab stop.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_cbt/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_cbt/2","type":"function"},{"doc":"Handle Cursor Horizontal Absolute (CHA) command.\nMoves cursor to specified horizontal position.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_cha/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_cha/2","type":"function"},{"doc":"Handle Cursor Horizontal Tab (CHT) command.\nMoves cursor to the next horizontal tab stop.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_cht/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_cht/2","type":"function"},{"doc":"Handle Cursor Next Line (CNL) command.\nMoves cursor to the beginning of the next line.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_cnl/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_cnl/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_command/3","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_command/3","type":"function"},{"doc":"Handle Cursor Previous Line (CPL) command.\nMoves cursor to the beginning of the previous line.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_cpl/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_cpl/2","type":"function"},{"doc":"Handle Cursor Backward (CUB) command.\nMoves cursor backward by specified number of columns.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_cub/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_cub/2","type":"function"},{"doc":"Handle Cursor Down (CUD) command.\nMoves cursor down by specified number of lines.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_cud/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_cud/2","type":"function"},{"doc":"Handle Cursor Forward (CUF) command.\nMoves cursor forward by specified number of columns.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_cuf/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_cuf/2","type":"function"},{"doc":"Handle Cursor Position (CUP) command.\nMoves cursor to specified position.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_cup/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_cup/2","type":"function"},{"doc":"Handle Cursor Up (CUU) command.\nMoves cursor up by specified number of lines.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_cuu/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_cuu/2","type":"function"},{"doc":"Handle Delete Character (DCH) command.\nDeletes characters at cursor position.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_dch/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_dch/2","type":"function"},{"doc":"Handle Delete Line (DL) command.\nDeletes lines at cursor position.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_dl/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_dl/2","type":"function"},{"doc":"Handle Erase Character (ECH) command.\nErases characters at cursor position.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_ech/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_ech/2","type":"function"},{"doc":"Handle Erase Display (ED) command.\nErases the screen from the cursor to the end of the screen.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_ed/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_ed/2","type":"function"},{"doc":"Handle Erase Line (EL) command.\nErases the line from the cursor to the end of the line.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_el/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_el/2","type":"function"},{"doc":"Handle Horizontal Position Absolute (HPA) command.\nMoves cursor to specified horizontal position.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_hpa/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_hpa/2","type":"function"},{"doc":"Handle Horizontal Position Relative (HPR) command.\nMoves cursor horizontally by specified number of columns.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_hpr/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_hpr/2","type":"function"},{"doc":"Handle Horizontal and Vertical Position (HVP) command.\nMoves cursor to specified position.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_hvp/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_hvp/2","type":"function"},{"doc":"Handle Insert Character (ICH) command.\nInserts blank characters at cursor position.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_ich/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_ich/2","type":"function"},{"doc":"Handle Insert Line (IL) command.\nInserts blank lines at cursor position.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_il/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_il/2","type":"function"},{"doc":"Handles the IND (Index) sequence - moves cursor down one line, scrolling if needed.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_ind/1","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_ind/1","type":"function"},{"doc":"Handles the NEL (Next Line) sequence - moves cursor to start of next line, scrolling if needed.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_nel/1","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_nel/1","type":"function"},{"doc":"Handles the RI (Reverse Index) sequence - moves cursor up one line, scrolling if needed.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_ri/1","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_ri/1","type":"function"},{"doc":"Handle Scroll Down (SD) command.\nScrolls screen down within scroll region.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_sd/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_sd/2","type":"function"},{"doc":"Handle Scroll Up (SU) command.\nScrolls screen up within scroll region.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_su/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_su/2","type":"function"},{"doc":"Handle Tab Clear (TBC) command.\nClears tab stops.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_tbc/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_tbc/2","type":"function"},{"doc":"Handle Vertical Position Absolute (VPA) command.\nMoves cursor to specified vertical position.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_vpa/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_vpa/2","type":"function"},{"doc":"Handle Vertical Position Relative (VPR) command.\nMoves cursor vertically by specified number of lines.","ref":"Raxol.Terminal.Commands.CSIHandlers.Screen.html#handle_vpr/2","title":"Raxol.Terminal.Commands.CSIHandlers.Screen.handle_vpr/2","type":"function"},{"doc":"Handles cursor movement related CSI commands.\n\nThis module contains handlers for cursor movement commands like CUP, CUU, CUD, etc.\nEach function takes the current emulator state and parsed parameters,\nreturning the updated emulator state.","ref":"Raxol.Terminal.Commands.CursorHandlers.html","title":"Raxol.Terminal.Commands.CursorHandlers","type":"module"},{"doc":"Handles Cursor Up (CUU - 'A\")","ref":"Raxol.Terminal.Commands.CursorHandlers.html#handle_a/2","title":"Raxol.Terminal.Commands.CursorHandlers.handle_a/2","type":"function"},{"doc":"Handles Cursor Down (CUD - 'B\")","ref":"Raxol.Terminal.Commands.CursorHandlers.html#handle_b/2","title":"Raxol.Terminal.Commands.CursorHandlers.handle_b/2","type":"function"},{"doc":"Handles Cursor Forward (CUF - 'C\")","ref":"Raxol.Terminal.Commands.CursorHandlers.html#handle_c/2","title":"Raxol.Terminal.Commands.CursorHandlers.handle_c/2","type":"function"},{"doc":"Handles Cursor Position (CUP - 'H\")","ref":"Raxol.Terminal.Commands.CursorHandlers.html#handle_cup/2","title":"Raxol.Terminal.Commands.CursorHandlers.handle_cup/2","type":"function"},{"doc":"Helper function to handle cursor movement operations.\nTakes the emulator, movement function, and movement parameters.","ref":"Raxol.Terminal.Commands.CursorHandlers.html#handle_cursor_movement/3","title":"Raxol.Terminal.Commands.CursorHandlers.handle_cursor_movement/3","type":"function"},{"doc":"Handles Cursor Backward (CUB - 'D\")","ref":"Raxol.Terminal.Commands.CursorHandlers.html#handle_d/2","title":"Raxol.Terminal.Commands.CursorHandlers.handle_d/2","type":"function"},{"doc":"Handles Cursor Vertical Absolute (VPA - 'd\")","ref":"Raxol.Terminal.Commands.CursorHandlers.html#handle_decvpa/2","title":"Raxol.Terminal.Commands.CursorHandlers.handle_decvpa/2","type":"function"},{"doc":"Handles Cursor Next Line (CNL - 'E\")","ref":"Raxol.Terminal.Commands.CursorHandlers.html#handle_e/2","title":"Raxol.Terminal.Commands.CursorHandlers.handle_e/2","type":"function"},{"doc":"Handles Cursor Previous Line (CPL - 'F\")","ref":"Raxol.Terminal.Commands.CursorHandlers.html#handle_f/2","title":"Raxol.Terminal.Commands.CursorHandlers.handle_f/2","type":"function"},{"doc":"Handles Cursor Horizontal Absolute (CHA - 'G\")","ref":"Raxol.Terminal.Commands.CursorHandlers.html#handle_g/2","title":"Raxol.Terminal.Commands.CursorHandlers.handle_g/2","type":"function"},{"doc":"Handles Device Control String (DCS) commands for the terminal emulator.","ref":"Raxol.Terminal.Commands.DCSHandlers.html","title":"Raxol.Terminal.Commands.DCSHandlers","type":"module"},{"doc":"Handles DCS commands.\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Commands.DCSHandlers.html#handle_dcs/3","title":"Raxol.Terminal.Commands.DCSHandlers.handle_dcs/3","type":"function"},{"doc":"Handles device status and attribute related CSI commands.\n\nThis module contains handlers for device status reports (DSR) and device\nattributes (DA). Each function takes the current emulator state and parsed\nparameters, returning the updated emulator state.","ref":"Raxol.Terminal.Commands.DeviceHandlers.html","title":"Raxol.Terminal.Commands.DeviceHandlers","type":"module"},{"doc":"Handles Device Attributes (DA - 'c')","ref":"Raxol.Terminal.Commands.DeviceHandlers.html#handle_c/3","title":"Raxol.Terminal.Commands.DeviceHandlers.handle_c/3","type":"function"},{"doc":"Handles Device Status Report (DSR - 'n')","ref":"Raxol.Terminal.Commands.DeviceHandlers.html#handle_n/2","title":"Raxol.Terminal.Commands.DeviceHandlers.handle_n/2","type":"function"},{"doc":"Handles editor-related terminal commands.","ref":"Raxol.Terminal.Commands.Editor.html","title":"Raxol.Terminal.Commands.Editor","type":"module"},{"doc":"Clears a line or part of a line based on the mode parameter.","ref":"Raxol.Terminal.Commands.Editor.html#clear_line/4","title":"Raxol.Terminal.Commands.Editor.clear_line/4","type":"function"},{"doc":"* `emulator` - The current emulator state\n* `mode` - The clear mode:\n  * 0 - Clear from cursor to end of line\n  * 1 - Clear from beginning of line to cursor\n  * 2 - Clear entire line","ref":"Raxol.Terminal.Commands.Editor.html#clear_line/4-parameters","title":"Parameters - Raxol.Terminal.Commands.Editor.clear_line/4","type":"function"},{"doc":"* Updated emulator state","ref":"Raxol.Terminal.Commands.Editor.html#clear_line/4-returns","title":"Returns - Raxol.Terminal.Commands.Editor.clear_line/4","type":"function"},{"doc":"Clears the screen based on the mode parameter.","ref":"Raxol.Terminal.Commands.Editor.html#clear_screen/4","title":"Raxol.Terminal.Commands.Editor.clear_screen/4","type":"function"},{"doc":"* `emulator` - The current emulator state\n* `mode` - The clear mode:\n  * 0 - Clear from cursor to end of screen\n  * 1 - Clear from beginning of screen to cursor\n  * 2 - Clear entire screen\n  * 3 - Clear entire screen and scrollback","ref":"Raxol.Terminal.Commands.Editor.html#clear_screen/4-parameters","title":"Parameters - Raxol.Terminal.Commands.Editor.clear_screen/4","type":"function"},{"doc":"* Updated emulator state","ref":"Raxol.Terminal.Commands.Editor.html#clear_screen/4-returns","title":"Returns - Raxol.Terminal.Commands.Editor.clear_screen/4","type":"function"},{"doc":"Deletes a specified number of characters starting from the current cursor position.\nCharacters to the right of the deleted characters are shifted left, and blank characters are added at the end.","ref":"Raxol.Terminal.Commands.Editor.html#delete_chars/5","title":"Raxol.Terminal.Commands.Editor.delete_chars/5","type":"function"},{"doc":"Deletes a specified number of lines starting from the current cursor position.\nLines below the deleted lines are shifted up, and blank lines are added at the bottom.","ref":"Raxol.Terminal.Commands.Editor.html#delete_lines/4","title":"Raxol.Terminal.Commands.Editor.delete_lines/4","type":"function"},{"doc":"Erases a specified number of characters starting from the current cursor position.\nCharacters are replaced with blank spaces using the default style.","ref":"Raxol.Terminal.Commands.Editor.html#erase_chars/5","title":"Raxol.Terminal.Commands.Editor.erase_chars/5","type":"function"},{"doc":"Inserts a specified number of blank characters at the current cursor position.\nCharacters to the right of the cursor are shifted right, and characters shifted off the end are discarded.","ref":"Raxol.Terminal.Commands.Editor.html#insert_chars/5","title":"Raxol.Terminal.Commands.Editor.insert_chars/5","type":"function"},{"doc":"Inserts a specified number of blank lines at the current cursor position.\nLines below the cursor are shifted down, and lines shifted off the bottom are discarded.","ref":"Raxol.Terminal.Commands.Editor.html#insert_lines/4","title":"Raxol.Terminal.Commands.Editor.insert_lines/4","type":"function"},{"doc":"Handles erase related CSI commands.\n\nThis module contains handlers for erase operations like ED (Erase in Display)\nand EL (Erase in Line). Each function takes the current emulator state and\nparsed parameters, returning the updated emulator state.","ref":"Raxol.Terminal.Commands.EraseHandlers.html","title":"Raxol.Terminal.Commands.EraseHandlers","type":"module"},{"doc":"Helper function to get active buffer, cursor position, and default style.\nReturns a tuple of {active_buffer, cursor_pos, default_style}.","ref":"Raxol.Terminal.Commands.EraseHandlers.html#get_buffer_state/1","title":"Raxol.Terminal.Commands.EraseHandlers.get_buffer_state/1","type":"function"},{"doc":"Helper function to handle erase operations.\nTakes the emulator, erase type, and erase parameters.","ref":"Raxol.Terminal.Commands.EraseHandlers.html#handle_erase/4","title":"Raxol.Terminal.Commands.EraseHandlers.handle_erase/4","type":"function"},{"doc":"Handles Erase in Display (ED - 'J')","ref":"Raxol.Terminal.Commands.EraseHandlers.html#handle_j/2","title":"Raxol.Terminal.Commands.EraseHandlers.handle_j/2","type":"function"},{"doc":"Handles Erase in Line (EL - 'K')","ref":"Raxol.Terminal.Commands.EraseHandlers.html#handle_k/2","title":"Raxol.Terminal.Commands.EraseHandlers.handle_k/2","type":"function"},{"doc":"Executes parsed terminal commands (CSI, OSC, DCS).\n\nThis module takes parsed command details and the current emulator state,\nand returns the updated emulator state after applying the command's effects.","ref":"Raxol.Terminal.Commands.Executor.html","title":"Raxol.Terminal.Commands.Executor","type":"module"},{"doc":"Executes a CSI (Control Sequence Introducer) command.\n\nThis function delegates to handler modules (e.g., CSIHandlers, CursorHandlers, etc.).\nTo add support for new CSI commands, implement them in the appropriate handler module.","ref":"Raxol.Terminal.Commands.Executor.html#execute_csi_command/4","title":"Raxol.Terminal.Commands.Executor.execute_csi_command/4","type":"function"},{"doc":"Executes a DCS (Device Control String) command.\n\nParams: `params_buffer`, `intermediates_buffer`, `data_string` (content between DCS and ST).","ref":"Raxol.Terminal.Commands.Executor.html#execute_dcs_command/4","title":"Raxol.Terminal.Commands.Executor.execute_dcs_command/4","type":"function"},{"doc":"Executes an OSC (Operating System Command).\n\nParams: `command_string` (the content between OSC and ST).","ref":"Raxol.Terminal.Commands.Executor.html#execute_osc_command/2","title":"Raxol.Terminal.Commands.Executor.execute_osc_command/2","type":"function"},{"doc":"Manages command history for the terminal emulator.\n\nThis module provides functionality for:\n- Storing and retrieving command history\n- Navigating through command history\n- Persisting command history\n- Managing history size limits","ref":"Raxol.Terminal.Commands.History.html","title":"Raxol.Terminal.Commands.History","type":"module"},{"doc":"Adds a command to the history.","ref":"Raxol.Terminal.Commands.History.html#add/2","title":"Raxol.Terminal.Commands.History.add/2","type":"function"},{"doc":"iex> history = History.new(1000)\n    iex> history = History.add(history, \"ls -la\")\n    iex> history.commands\n    [\"ls -la\"]","ref":"Raxol.Terminal.Commands.History.html#add/2-examples","title":"Examples - Raxol.Terminal.Commands.History.add/2","type":"function"},{"doc":"Clears the command history.","ref":"Raxol.Terminal.Commands.History.html#clear/1","title":"Raxol.Terminal.Commands.History.clear/1","type":"function"},{"doc":"iex> history = History.new(1000)\n    iex> history = History.add(history, \"ls -la\")\n    iex> history = History.clear(history)\n    iex> history.commands\n    []","ref":"Raxol.Terminal.Commands.History.html#clear/1-examples","title":"Examples - Raxol.Terminal.Commands.History.clear/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Commands.History.html#t:command_history/0","title":"Raxol.Terminal.Commands.History.command_history/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Commands.History.html#t:command_history_config/0","title":"Raxol.Terminal.Commands.History.command_history_config/0","type":"type"},{"doc":"Returns the current command history as a list.","ref":"Raxol.Terminal.Commands.History.html#list/1","title":"Raxol.Terminal.Commands.History.list/1","type":"function"},{"doc":"iex> history = History.new(1000)\n    iex> history = History.add(history, \"ls -la\")\n    iex> history = History.add(history, \"cd /tmp\")\n    iex> History.list(history)\n    [\"cd /tmp\", \"ls -la\"]","ref":"Raxol.Terminal.Commands.History.html#list/1-examples","title":"Examples - Raxol.Terminal.Commands.History.list/1","type":"function"},{"doc":"Adds to the emulator's command history if the input is a newline (10),\nor appends to the current command buffer if it's a printable character.\nReturns the updated emulator struct.","ref":"Raxol.Terminal.Commands.History.html#maybe_add_to_history/2","title":"Raxol.Terminal.Commands.History.maybe_add_to_history/2","type":"function"},{"doc":"Creates a new command history manager.","ref":"Raxol.Terminal.Commands.History.html#new/1","title":"Raxol.Terminal.Commands.History.new/1","type":"function"},{"doc":"iex> history = History.new(1000)\n    iex> history.max_size\n    1000","ref":"Raxol.Terminal.Commands.History.html#new/1-examples","title":"Examples - Raxol.Terminal.Commands.History.new/1","type":"function"},{"doc":"Retrieves the next command in history.","ref":"Raxol.Terminal.Commands.History.html#next/1","title":"Raxol.Terminal.Commands.History.next/1","type":"function"},{"doc":"iex> history = History.new(1000)\n    iex> history = History.add(history, \"ls -la\")\n    iex> history = History.add(history, \"cd /tmp\")\n    iex> {_, history} = History.previous(history)\n    iex> History.next(history)\n    {\"ls -la\", %History{...}}","ref":"Raxol.Terminal.Commands.History.html#next/1-examples","title":"Examples - Raxol.Terminal.Commands.History.next/1","type":"function"},{"doc":"Retrieves the previous command in history.","ref":"Raxol.Terminal.Commands.History.html#previous/1","title":"Raxol.Terminal.Commands.History.previous/1","type":"function"},{"doc":"iex> history = History.new(1000)\n    iex> history = History.add(history, \"ls -la\")\n    iex> history = History.add(history, \"cd /tmp\")\n    iex> History.previous(history)\n    {\"cd /tmp\", %History{...}}","ref":"Raxol.Terminal.Commands.History.html#previous/1-examples","title":"Examples - Raxol.Terminal.Commands.History.previous/1","type":"function"},{"doc":"Saves the current input state.","ref":"Raxol.Terminal.Commands.History.html#save_input/2","title":"Raxol.Terminal.Commands.History.save_input/2","type":"function"},{"doc":"iex> history = History.new(1000)\n    iex> history = History.save_input(history, \"ls -l\")\n    iex> history.current_input\n    \"ls -l\"","ref":"Raxol.Terminal.Commands.History.html#save_input/2-examples","title":"Examples - Raxol.Terminal.Commands.History.save_input/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Commands.History.html#t:t/0","title":"Raxol.Terminal.Commands.History.t/0","type":"type"},{"doc":"Updates the command history configuration.\nDelegates to update_size/2 for compatibility.","ref":"Raxol.Terminal.Commands.History.html#update_config/2","title":"Raxol.Terminal.Commands.History.update_config/2","type":"function"},{"doc":"Updates the maximum size of the command history. Truncates the history if needed.","ref":"Raxol.Terminal.Commands.History.html#update_size/2","title":"Raxol.Terminal.Commands.History.update_size/2","type":"function"},{"doc":"Handles mode setting and resetting related CSI commands.\n\nThis module contains handlers for setting and resetting terminal modes,\nboth standard ANSI modes and DEC private modes. Each function takes the\ncurrent emulator state and parsed parameters, returning the updated\nemulator state.","ref":"Raxol.Terminal.Commands.ModeHandlers.html","title":"Raxol.Terminal.Commands.ModeHandlers","type":"module"},{"doc":"Handles Set Mode (SM - CSI h).\nCalls handle_h_or_l/4 with final_byte ?h and no intermediates.","ref":"Raxol.Terminal.Commands.ModeHandlers.html#handle_h/2","title":"Raxol.Terminal.Commands.ModeHandlers.handle_h/2","type":"function"},{"doc":"Handles Set Mode (SM - `h`) or Reset Mode (RM - `l`).\n\nDispatches to `ModeManager` to handle both standard ANSI modes and\nDEC private modes (prefixed with `?`).","ref":"Raxol.Terminal.Commands.ModeHandlers.html#handle_h_or_l/4","title":"Raxol.Terminal.Commands.ModeHandlers.handle_h_or_l/4","type":"function"},{"doc":"Handles Reset Mode (RM - CSI l).\nCalls handle_h_or_l/4 with final_byte ?l and no intermediates.","ref":"Raxol.Terminal.Commands.ModeHandlers.html#handle_l/2","title":"Raxol.Terminal.Commands.ModeHandlers.handle_l/2","type":"function"},{"doc":"Handles Operating System Command (OSC) sequences.\n\nThis module dispatches OSC commands to their respective handlers based on the command number.\nEach handler is responsible for a specific set of related commands.","ref":"Raxol.Terminal.Commands.OSCHandlers.html","title":"Raxol.Terminal.Commands.OSCHandlers","type":"module"},{"doc":"- Window Operations (OSC 0, 1, 2, 7, 8, 1337)\n- Color Palette (OSC 4)\n- Clipboard Operations (OSC 9, 52)\n- Color Management (OSC 10, 11, 12, 17, 19)\n- Cursor and Font (OSC 12, 50, 112)\n- Selection (OSC 51)","ref":"Raxol.Terminal.Commands.OSCHandlers.html#module-supported-commands","title":"Supported Commands - Raxol.Terminal.Commands.OSCHandlers","type":"module"},{"doc":"Handles an OSC command by dispatching it to the appropriate handler.","ref":"Raxol.Terminal.Commands.OSCHandlers.html#handle/3","title":"Raxol.Terminal.Commands.OSCHandlers.handle/3","type":"function"},{"doc":"- `emulator` - The terminal emulator state\n- `command` - The OSC command number\n- `data` - The command data","ref":"Raxol.Terminal.Commands.OSCHandlers.html#handle/3-parameters","title":"Parameters - Raxol.Terminal.Commands.OSCHandlers.handle/3","type":"function"},{"doc":"- `{:ok, emulator}` - Command handled successfully\n- `{:error, reason, emulator}` - Command failed with reason","ref":"Raxol.Terminal.Commands.OSCHandlers.html#handle/3-returns","title":"Returns - Raxol.Terminal.Commands.OSCHandlers.handle/3","type":"function"},{"doc":"Handles clipboard-related OSC commands.\n\nThis handler manages clipboard operations, including:\n- Setting and querying clipboard content\n- Managing selection content\n- Handling different clipboard types (primary, clipboard)","ref":"Raxol.Terminal.Commands.OSCHandlers.Clipboard.html","title":"Raxol.Terminal.Commands.OSCHandlers.Clipboard","type":"module"},{"doc":"- OSC 9: Set/Query clipboard content\n- OSC 52: Set/Query clipboard or selection content","ref":"Raxol.Terminal.Commands.OSCHandlers.Clipboard.html#module-supported-commands","title":"Supported Commands - Raxol.Terminal.Commands.OSCHandlers.Clipboard","type":"module"},{"doc":"Handles OSC 9 command to set/query clipboard content.","ref":"Raxol.Terminal.Commands.OSCHandlers.Clipboard.html#handle_9/2","title":"Raxol.Terminal.Commands.OSCHandlers.Clipboard.handle_9/2","type":"function"},{"doc":"Handles OSC 52 command to set/query clipboard or selection content.","ref":"Raxol.Terminal.Commands.OSCHandlers.Clipboard.html#handle_52/2","title":"Raxol.Terminal.Commands.OSCHandlers.Clipboard.handle_52/2","type":"function"},{"doc":"- `52;c;?` - Query clipboard content\n- `52;c;content` - Set clipboard content\n- `52;s;?` - Query selection content\n- `52;s;content` - Set selection content\n\nWhere:\n- c: clipboard\n- s: selection","ref":"Raxol.Terminal.Commands.OSCHandlers.Clipboard.html#handle_52/2-command-format","title":"Command Format - Raxol.Terminal.Commands.OSCHandlers.Clipboard.handle_52/2","type":"function"},{"doc":"Handles color-related OSC commands.\n\nThis handler manages terminal colors, including:\n- Foreground color\n- Background color\n- Cursor color\n- Selection colors","ref":"Raxol.Terminal.Commands.OSCHandlers.Color.html","title":"Raxol.Terminal.Commands.OSCHandlers.Color","type":"module"},{"doc":"- OSC 10: Set/Query foreground color\n- OSC 11: Set/Query background color\n- OSC 12: Set/Query cursor color\n- OSC 17: Set/Query selection background color\n- OSC 19: Set/Query selection foreground color","ref":"Raxol.Terminal.Commands.OSCHandlers.Color.html#module-supported-commands","title":"Supported Commands - Raxol.Terminal.Commands.OSCHandlers.Color","type":"module"},{"doc":"Handles OSC 10 command to set/query foreground color.","ref":"Raxol.Terminal.Commands.OSCHandlers.Color.html#handle_10/2","title":"Raxol.Terminal.Commands.OSCHandlers.Color.handle_10/2","type":"function"},{"doc":"Handles OSC 11 command to set/query background color.","ref":"Raxol.Terminal.Commands.OSCHandlers.Color.html#handle_11/2","title":"Raxol.Terminal.Commands.OSCHandlers.Color.handle_11/2","type":"function"},{"doc":"Handles OSC 12 command to set/query cursor color.","ref":"Raxol.Terminal.Commands.OSCHandlers.Color.html#handle_12/2","title":"Raxol.Terminal.Commands.OSCHandlers.Color.handle_12/2","type":"function"},{"doc":"Handles OSC 17 command to set/query selection background color.","ref":"Raxol.Terminal.Commands.OSCHandlers.Color.html#handle_17/2","title":"Raxol.Terminal.Commands.OSCHandlers.Color.handle_17/2","type":"function"},{"doc":"Handles OSC 19 command to set/query selection foreground color.","ref":"Raxol.Terminal.Commands.OSCHandlers.Color.html#handle_19/2","title":"Raxol.Terminal.Commands.OSCHandlers.Color.handle_19/2","type":"function"},{"doc":"Handles OSC 110 command to reset foreground color.","ref":"Raxol.Terminal.Commands.OSCHandlers.Color.html#handle_110/2","title":"Raxol.Terminal.Commands.OSCHandlers.Color.handle_110/2","type":"function"},{"doc":"Handles OSC 111 command to reset background color.","ref":"Raxol.Terminal.Commands.OSCHandlers.Color.html#handle_111/2","title":"Raxol.Terminal.Commands.OSCHandlers.Color.handle_111/2","type":"function"},{"doc":"Handles OSC 112 command to reset cursor color.","ref":"Raxol.Terminal.Commands.OSCHandlers.Color.html#handle_112/2","title":"Raxol.Terminal.Commands.OSCHandlers.Color.handle_112/2","type":"function"},{"doc":"Handles OSC 117 command to reset selection background color.","ref":"Raxol.Terminal.Commands.OSCHandlers.Color.html#handle_117/2","title":"Raxol.Terminal.Commands.OSCHandlers.Color.handle_117/2","type":"function"},{"doc":"Handles OSC 119 command to reset selection foreground color.","ref":"Raxol.Terminal.Commands.OSCHandlers.Color.html#handle_119/2","title":"Raxol.Terminal.Commands.OSCHandlers.Color.handle_119/2","type":"function"},{"doc":"Handles OSC 4 (Color Palette Set/Query) commands.\n\nThis handler manages the terminal's color palette, allowing dynamic\nmodification of colors during runtime.","ref":"Raxol.Terminal.Commands.OSCHandlers.ColorPalette.html","title":"Raxol.Terminal.Commands.OSCHandlers.ColorPalette","type":"module"},{"doc":"- rgb:RRRR/GGGG/BBBB (hex, 1-4 digits per component)\n- #RRGGBB (hex, 2 digits per component)\n- #RGB (hex, 1 digit per component)\n- rgb(r,g,b) (decimal, 0-255)\n- rgb(r%,g%,b%) (percentage, 0-100%)","ref":"Raxol.Terminal.Commands.OSCHandlers.ColorPalette.html#module-color-formats-supported","title":"Color Formats Supported - Raxol.Terminal.Commands.OSCHandlers.ColorPalette","type":"module"},{"doc":"Handles OSC 4 commands for color palette management.","ref":"Raxol.Terminal.Commands.OSCHandlers.ColorPalette.html#handle_4/2","title":"Raxol.Terminal.Commands.OSCHandlers.ColorPalette.handle_4/2","type":"function"},{"doc":"- `4;c;spec` - Set color c to spec\n- `4;c;?` - Query color c\n\nWhere:\n- c is the color index (0-255)\n- spec is the color specification","ref":"Raxol.Terminal.Commands.OSCHandlers.ColorPalette.html#handle_4/2-commands","title":"Commands - Raxol.Terminal.Commands.OSCHandlers.ColorPalette.handle_4/2","type":"function"},{"doc":"Handles parsing of color specifications in various formats.","ref":"Raxol.Terminal.Commands.OSCHandlers.ColorParser.html","title":"Raxol.Terminal.Commands.OSCHandlers.ColorParser","type":"module"},{"doc":"Parses a color specification string into an RGB tuple.","ref":"Raxol.Terminal.Commands.OSCHandlers.ColorParser.html#parse/1","title":"Raxol.Terminal.Commands.OSCHandlers.ColorParser.parse/1","type":"function"},{"doc":"Handles cursor and font-related OSC commands.\n\nThis handler manages cursor properties and font settings, including:\n- Cursor color\n- Cursor style\n- Cursor blink state\n- Font family and size","ref":"Raxol.Terminal.Commands.OSCHandlers.Cursor.html","title":"Raxol.Terminal.Commands.OSCHandlers.Cursor","type":"module"},{"doc":"- OSC 12: Set/Query cursor color\n- OSC 50: Set/Query font\n- OSC 112: Reset cursor color","ref":"Raxol.Terminal.Commands.OSCHandlers.Cursor.html#module-supported-commands","title":"Supported Commands - Raxol.Terminal.Commands.OSCHandlers.Cursor","type":"module"},{"doc":"Handles OSC 12 command to set/query cursor color.","ref":"Raxol.Terminal.Commands.OSCHandlers.Cursor.html#handle_12/2","title":"Raxol.Terminal.Commands.OSCHandlers.Cursor.handle_12/2","type":"function"},{"doc":"Handles OSC 50 command to set/query font.","ref":"Raxol.Terminal.Commands.OSCHandlers.Cursor.html#handle_50/2","title":"Raxol.Terminal.Commands.OSCHandlers.Cursor.handle_50/2","type":"function"},{"doc":"- 50;? - Query current font\n- 50;family - Set font family\n- 50;family;size - Set font family and size\n- 50;family;size;style - Set font family, size, and style\n\nWhere:\n- family: Font family name\n- size: Font size in points\n- style: Font style (normal, bold, italic)","ref":"Raxol.Terminal.Commands.OSCHandlers.Cursor.html#handle_50/2-command-format","title":"Command Format - Raxol.Terminal.Commands.OSCHandlers.Cursor.handle_50/2","type":"function"},{"doc":"Handles OSC 112 command to reset cursor color.","ref":"Raxol.Terminal.Commands.OSCHandlers.Cursor.html#handle_112/2","title":"Raxol.Terminal.Commands.OSCHandlers.Cursor.handle_112/2","type":"function"},{"doc":"Handles parsing of font-related OSC commands.","ref":"Raxol.Terminal.Commands.OSCHandlers.FontParser.html","title":"Raxol.Terminal.Commands.OSCHandlers.FontParser","type":"module"},{"doc":"Parses a font command string into a tuple of {family, size, style}.","ref":"Raxol.Terminal.Commands.OSCHandlers.FontParser.html#parse/1","title":"Raxol.Terminal.Commands.OSCHandlers.FontParser.parse/1","type":"function"},{"doc":"Parser for hyperlink data in OSC commands.\n\nThis module handles parsing of hyperlink data in the format:\n- Query: \"?'\n- Set: 'id;url\"\n- Clear: \"id;\"","ref":"Raxol.Terminal.Commands.OSCHandlers.HyperlinkParser.html","title":"Raxol.Terminal.Commands.OSCHandlers.HyperlinkParser","type":"module"},{"doc":"Parses hyperlink data from an OSC command.\n\nReturns:\n- `{:query, id}` for query commands\n- `{:set, id, url}` for set commands\n- `{:clear, id}` for clear commands\n- `{:error, reason}` for invalid data","ref":"Raxol.Terminal.Commands.OSCHandlers.HyperlinkParser.html#parse/1","title":"Raxol.Terminal.Commands.OSCHandlers.HyperlinkParser.parse/1","type":"function"},{"doc":"Handles OSC 51 (Selection) commands.\n\nThis handler manages terminal selection operations, including:\n- Setting selection boundaries\n- Querying selection content\n- Managing selection attributes","ref":"Raxol.Terminal.Commands.OSCHandlers.Selection.html","title":"Raxol.Terminal.Commands.OSCHandlers.Selection","type":"module"},{"doc":"Handles OSC 51 commands for selection management.","ref":"Raxol.Terminal.Commands.OSCHandlers.Selection.html#handle_51/2","title":"Raxol.Terminal.Commands.OSCHandlers.Selection.handle_51/2","type":"function"},{"doc":"- `51;?` - Query current selection\n- `51;start;x;y` - Set selection start position\n- `51;end;x;y` - Set selection end position\n- `51;clear` - Clear selection\n- `51;text;content` - Set selection text directly\n\nWhere:\n- x, y are screen coordinates\n- content is the text to select","ref":"Raxol.Terminal.Commands.OSCHandlers.Selection.html#handle_51/2-commands","title":"Commands - Raxol.Terminal.Commands.OSCHandlers.Selection.handle_51/2","type":"function"},{"doc":"Handles parsing of selection-related OSC commands.","ref":"Raxol.Terminal.Commands.OSCHandlers.SelectionParser.html","title":"Raxol.Terminal.Commands.OSCHandlers.SelectionParser","type":"module"},{"doc":"Parses a selection command string into a command tuple.","ref":"Raxol.Terminal.Commands.OSCHandlers.SelectionParser.html#parse/1","title":"Raxol.Terminal.Commands.OSCHandlers.SelectionParser.parse/1","type":"function"},{"doc":"Handles OSC (Operating System Command) sequences for window operations.","ref":"Raxol.Terminal.Commands.OSCHandlers.Window.html","title":"Raxol.Terminal.Commands.OSCHandlers.Window","type":"module"},{"doc":"Handles window title setting (OSC 0)","ref":"Raxol.Terminal.Commands.OSCHandlers.Window.html#handle_0/2","title":"Raxol.Terminal.Commands.OSCHandlers.Window.handle_0/2","type":"function"},{"doc":"Handles window icon name setting (OSC 1)","ref":"Raxol.Terminal.Commands.OSCHandlers.Window.html#handle_1/2","title":"Raxol.Terminal.Commands.OSCHandlers.Window.handle_1/2","type":"function"},{"doc":"Handles window title and icon name setting (OSC 2)","ref":"Raxol.Terminal.Commands.OSCHandlers.Window.html#handle_2/2","title":"Raxol.Terminal.Commands.OSCHandlers.Window.handle_2/2","type":"function"},{"doc":"Handles working directory setting (OSC 7)","ref":"Raxol.Terminal.Commands.OSCHandlers.Window.html#handle_7/2","title":"Raxol.Terminal.Commands.OSCHandlers.Window.handle_7/2","type":"function"},{"doc":"Handles window size setting (OSC 8)","ref":"Raxol.Terminal.Commands.OSCHandlers.Window.html#handle_8/2","title":"Raxol.Terminal.Commands.OSCHandlers.Window.handle_8/2","type":"function"},{"doc":"Handles window size setting (OSC 1337)","ref":"Raxol.Terminal.Commands.OSCHandlers.Window.html#handle_1337/2","title":"Raxol.Terminal.Commands.OSCHandlers.Window.handle_1337/2","type":"function"},{"doc":"Provides parameter validation functions for CSI command handlers.\n\nThis module contains helper functions for validating and extracting\nparameters from CSI command sequences. Each function takes a list of\nparameters, an index, and a default value, returning either the\nvalidated parameter value or the default value if the parameter is\ninvalid.","ref":"Raxol.Terminal.Commands.ParameterValidation.html","title":"Raxol.Terminal.Commands.ParameterValidation","type":"module"},{"doc":"Gets a parameter value with validation for boolean values (0 or 1).\nReturns the parameter value if valid, or the default value if invalid.","ref":"Raxol.Terminal.Commands.ParameterValidation.html#get_valid_bool_param/3","title":"Raxol.Terminal.Commands.ParameterValidation.get_valid_bool_param/3","type":"function"},{"doc":"* `params` - List of parameter values\n  * `index` - Index of the parameter to get\n  * `default` - Default value to use if parameter is invalid (must be 0 or 1)","ref":"Raxol.Terminal.Commands.ParameterValidation.html#get_valid_bool_param/3-parameters","title":"Parameters - Raxol.Terminal.Commands.ParameterValidation.get_valid_bool_param/3","type":"function"},{"doc":"iex> ParameterValidation.get_valid_bool_param([1, 2, 3], 0, 0)\n    1\n\n    iex> ParameterValidation.get_valid_bool_param([nil, 2, 3], 0, 0)\n    0\n\n    iex> ParameterValidation.get_valid_bool_param([2, 2, 3], 0, 0)\n    0","ref":"Raxol.Terminal.Commands.ParameterValidation.html#get_valid_bool_param/3-examples","title":"Examples - Raxol.Terminal.Commands.ParameterValidation.get_valid_bool_param/3","type":"function"},{"doc":"Gets a parameter value with validation for non-negative integers.\nReturns the parameter value if valid, or the default value if invalid.","ref":"Raxol.Terminal.Commands.ParameterValidation.html#get_valid_non_neg_param/3","title":"Raxol.Terminal.Commands.ParameterValidation.get_valid_non_neg_param/3","type":"function"},{"doc":"* `params` - List of parameter values\n  * `index` - Index of the parameter to get\n  * `default` - Default value to use if parameter is invalid","ref":"Raxol.Terminal.Commands.ParameterValidation.html#get_valid_non_neg_param/3-parameters","title":"Parameters - Raxol.Terminal.Commands.ParameterValidation.get_valid_non_neg_param/3","type":"function"},{"doc":"iex> ParameterValidation.get_valid_non_neg_param([1, 2, 3], 0, 0)\n    1\n\n    iex> ParameterValidation.get_valid_non_neg_param([nil, 2, 3], 0, 0)\n    0\n\n    iex> ParameterValidation.get_valid_non_neg_param([-1, 2, 3], 0, 0)\n    0","ref":"Raxol.Terminal.Commands.ParameterValidation.html#get_valid_non_neg_param/3-examples","title":"Examples - Raxol.Terminal.Commands.ParameterValidation.get_valid_non_neg_param/3","type":"function"},{"doc":"Gets a parameter value with validation.\nReturns the parameter value if valid, or the default value if invalid.","ref":"Raxol.Terminal.Commands.ParameterValidation.html#get_valid_param/5","title":"Raxol.Terminal.Commands.ParameterValidation.get_valid_param/5","type":"function"},{"doc":"* `params` - List of parameter values\n  * `index` - Index of the parameter to get\n  * `default` - Default value to use if parameter is invalid\n  * `min` - Minimum allowed value\n  * `max` - Maximum allowed value","ref":"Raxol.Terminal.Commands.ParameterValidation.html#get_valid_param/5-parameters","title":"Parameters - Raxol.Terminal.Commands.ParameterValidation.get_valid_param/5","type":"function"},{"doc":"iex> ParameterValidation.get_valid_param([1, 2, 3], 0, 0, 0, 9999)\n    1\n\n    iex> ParameterValidation.get_valid_param([nil, 2, 3], 0, 0, 0, 9999)\n    0\n\n    iex> ParameterValidation.get_valid_param([-1, 2, 3], 0, 0, 0, 9999)\n    0","ref":"Raxol.Terminal.Commands.ParameterValidation.html#get_valid_param/5-examples","title":"Examples - Raxol.Terminal.Commands.ParameterValidation.get_valid_param/5","type":"function"},{"doc":"Gets a parameter value with validation for positive integers.\nReturns the parameter value if valid, or the default value if invalid.","ref":"Raxol.Terminal.Commands.ParameterValidation.html#get_valid_pos_param/3","title":"Raxol.Terminal.Commands.ParameterValidation.get_valid_pos_param/3","type":"function"},{"doc":"* `params` - List of parameter values\n  * `index` - Index of the parameter to get\n  * `default` - Default value to use if parameter is invalid","ref":"Raxol.Terminal.Commands.ParameterValidation.html#get_valid_pos_param/3-parameters","title":"Parameters - Raxol.Terminal.Commands.ParameterValidation.get_valid_pos_param/3","type":"function"},{"doc":"iex> ParameterValidation.get_valid_pos_param([1, 2, 3], 0, 1)\n    1\n\n    iex> ParameterValidation.get_valid_pos_param([nil, 2, 3], 0, 1)\n    1\n\n    iex> ParameterValidation.get_valid_pos_param([0, 2, 3], 0, 1)\n    1","ref":"Raxol.Terminal.Commands.ParameterValidation.html#get_valid_pos_param/3-examples","title":"Examples - Raxol.Terminal.Commands.ParameterValidation.get_valid_pos_param/3","type":"function"},{"doc":"Normalizes parameters to expected length, padding with nil or truncating as needed.","ref":"Raxol.Terminal.Commands.ParameterValidation.html#normalize_parameters/2","title":"Raxol.Terminal.Commands.ParameterValidation.normalize_parameters/2","type":"function"},{"doc":"Validates boolean, returns true for 1, false for 0. Defaults to true if invalid.","ref":"Raxol.Terminal.Commands.ParameterValidation.html#validate_boolean/1","title":"Raxol.Terminal.Commands.ParameterValidation.validate_boolean/1","type":"function"},{"doc":"Validates color, clamping between 0 and 255. Defaults to 0 if invalid.","ref":"Raxol.Terminal.Commands.ParameterValidation.html#validate_color/1","title":"Raxol.Terminal.Commands.ParameterValidation.validate_color/1","type":"function"},{"doc":"Validates coordinates, clamping to emulator bounds. Defaults to {0, 0} if invalid.","ref":"Raxol.Terminal.Commands.ParameterValidation.html#validate_coordinates/2","title":"Raxol.Terminal.Commands.ParameterValidation.validate_coordinates/2","type":"function"},{"doc":"Validates count, clamping between 1 and 10. Defaults to 1 if invalid.","ref":"Raxol.Terminal.Commands.ParameterValidation.html#validate_count/2","title":"Raxol.Terminal.Commands.ParameterValidation.validate_count/2","type":"function"},{"doc":"Validates mode, must be 0, 1, or 2. Defaults to 0 if invalid.","ref":"Raxol.Terminal.Commands.ParameterValidation.html#validate_mode/1","title":"Raxol.Terminal.Commands.ParameterValidation.validate_mode/1","type":"function"},{"doc":"Validates a value in params[0], clamping between min and max. Defaults to min if invalid.","ref":"Raxol.Terminal.Commands.ParameterValidation.html#validate_range/3","title":"Raxol.Terminal.Commands.ParameterValidation.validate_range/3","type":"function"},{"doc":"Handles parsing of command parameters in terminal sequences.\n\nThis module is part of the terminal command execution system. It provides\nutilities for parsing and extracting parameters from CSI, OSC, and DCS\nsequence parameter strings.","ref":"Raxol.Terminal.Commands.Parser.html","title":"Raxol.Terminal.Commands.Parser","type":"module"},{"doc":"Gets a parameter at a specific index from the params list.\n\nIf the parameter is not available, returns the provided default value.","ref":"Raxol.Terminal.Commands.Parser.html#get_param/3","title":"Raxol.Terminal.Commands.Parser.get_param/3","type":"function"},{"doc":"iex> Parser.get_param([5, 10, 15], 2)\n    10\n\n    iex> Parser.get_param([5, 10], 3)\n    1\n\n    iex> Parser.get_param([5, 10], 3, 0)\n    0","ref":"Raxol.Terminal.Commands.Parser.html#get_param/3-examples","title":"Examples - Raxol.Terminal.Commands.Parser.get_param/3","type":"function"},{"doc":"Safely parses a string into an integer.\n\nReturns the parsed integer, or nil on failure.","ref":"Raxol.Terminal.Commands.Parser.html#parse_int/1","title":"Raxol.Terminal.Commands.Parser.parse_int/1","type":"function"},{"doc":"iex> Parser.parse_int(\"123\")\n    123\n\n    iex> Parser.parse_int(\"abc\")\n    nil","ref":"Raxol.Terminal.Commands.Parser.html#parse_int/1-examples","title":"Examples - Raxol.Terminal.Commands.Parser.parse_int/1","type":"function"},{"doc":"Parses a raw parameter string buffer into a list of integers or nil values.\n\nHandles empty or malformed parameters by converting them to nil.\nHandles parameters with sub-parameters (separated by \":\")","ref":"Raxol.Terminal.Commands.Parser.html#parse_params/1","title":"Raxol.Terminal.Commands.Parser.parse_params/1","type":"function"},{"doc":"iex> Parser.parse_params(\"5;10;15\")\n    [5, 10, 15]\n\n    iex> Parser.parse_params(\"5;10;;15\")\n    [5, 10, nil, 15]\n\n    iex> Parser.parse_params(\"5:1;10:2;15:3\")\n    [[5, 1], [10, 2], [15, 3]]","ref":"Raxol.Terminal.Commands.Parser.html#parse_params/1-examples","title":"Examples - Raxol.Terminal.Commands.Parser.parse_params/1","type":"function"},{"doc":"Manages terminal commands with advanced features:\n- Command registration and lookup\n- Command validation and execution\n- Command history tracking\n- Command completion suggestions","ref":"Raxol.Terminal.Commands.Registry.html","title":"Raxol.Terminal.Commands.Registry","type":"module"},{"doc":"Clears the command history.","ref":"Raxol.Terminal.Commands.Registry.html#clear_history/1","title":"Raxol.Terminal.Commands.Registry.clear_history/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Commands.Registry.html#t:command/0","title":"Raxol.Terminal.Commands.Registry.command/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Commands.Registry.html#t:command_aliases/0","title":"Raxol.Terminal.Commands.Registry.command_aliases/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Commands.Registry.html#t:command_completion/0","title":"Raxol.Terminal.Commands.Registry.command_completion/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Commands.Registry.html#t:command_description/0","title":"Raxol.Terminal.Commands.Registry.command_description/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Commands.Registry.html#t:command_handler/0","title":"Raxol.Terminal.Commands.Registry.command_handler/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Commands.Registry.html#t:command_metrics/0","title":"Raxol.Terminal.Commands.Registry.command_metrics/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Commands.Registry.html#t:command_name/0","title":"Raxol.Terminal.Commands.Registry.command_name/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Commands.Registry.html#t:command_usage/0","title":"Raxol.Terminal.Commands.Registry.command_usage/0","type":"type"},{"doc":"Executes a command with the given arguments.","ref":"Raxol.Terminal.Commands.Registry.html#execute_command/3","title":"Raxol.Terminal.Commands.Registry.execute_command/3","type":"function"},{"doc":"Gets command completion suggestions for the given input.","ref":"Raxol.Terminal.Commands.Registry.html#get_completions/2","title":"Raxol.Terminal.Commands.Registry.get_completions/2","type":"function"},{"doc":"Gets the command history.","ref":"Raxol.Terminal.Commands.Registry.html#get_history/1","title":"Raxol.Terminal.Commands.Registry.get_history/1","type":"function"},{"doc":"Gets the current registry metrics.","ref":"Raxol.Terminal.Commands.Registry.html#get_metrics/1","title":"Raxol.Terminal.Commands.Registry.get_metrics/1","type":"function"},{"doc":"Creates a new command registry with the given options.","ref":"Raxol.Terminal.Commands.Registry.html#new/1","title":"Raxol.Terminal.Commands.Registry.new/1","type":"function"},{"doc":"Registers a new command in the registry.","ref":"Raxol.Terminal.Commands.Registry.html#register_command/2","title":"Raxol.Terminal.Commands.Registry.register_command/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Commands.Registry.html#t:t/0","title":"Raxol.Terminal.Commands.Registry.t/0","type":"type"},{"doc":"Handles screen manipulation commands in the terminal.\n\nThis module provides functions for clearing the screen or parts of it,\ninserting and deleting lines, and other screen manipulation operations.","ref":"Raxol.Terminal.Commands.Screen.html","title":"Raxol.Terminal.Commands.Screen","type":"module"},{"doc":"Clears a line or part of a line based on the mode parameter.","ref":"Raxol.Terminal.Commands.Screen.html#clear_line/2","title":"Raxol.Terminal.Commands.Screen.clear_line/2","type":"function"},{"doc":"* `emulator` - The current emulator state\n* `mode` - The clear mode:\n  * 0 - Clear from cursor to end of line\n  * 1 - Clear from beginning of line to cursor\n  * 2 - Clear entire line","ref":"Raxol.Terminal.Commands.Screen.html#clear_line/2-parameters","title":"Parameters - Raxol.Terminal.Commands.Screen.clear_line/2","type":"function"},{"doc":"* Updated emulator state","ref":"Raxol.Terminal.Commands.Screen.html#clear_line/2-returns","title":"Returns - Raxol.Terminal.Commands.Screen.clear_line/2","type":"function"},{"doc":"Clears the screen or a part of it based on the mode parameter.","ref":"Raxol.Terminal.Commands.Screen.html#clear_screen/2","title":"Raxol.Terminal.Commands.Screen.clear_screen/2","type":"function"},{"doc":"* `emulator` - The current emulator state\n* `mode` - The clear mode:\n  * 0 - Clear from cursor to end of screen\n  * 1 - Clear from beginning of screen to cursor\n  * 2 - Clear entire screen but don't move cursor\n  * 3 - Clear entire screen including scrollback","ref":"Raxol.Terminal.Commands.Screen.html#clear_screen/2-parameters","title":"Parameters - Raxol.Terminal.Commands.Screen.clear_screen/2","type":"function"},{"doc":"* Updated emulator state","ref":"Raxol.Terminal.Commands.Screen.html#clear_screen/2-returns","title":"Returns - Raxol.Terminal.Commands.Screen.clear_screen/2","type":"function"},{"doc":"Deletes lines at the current cursor position.","ref":"Raxol.Terminal.Commands.Screen.html#delete_lines/2","title":"Raxol.Terminal.Commands.Screen.delete_lines/2","type":"function"},{"doc":"* `emulator` - The current emulator state\n* `count` - The number of lines to delete","ref":"Raxol.Terminal.Commands.Screen.html#delete_lines/2-parameters","title":"Parameters - Raxol.Terminal.Commands.Screen.delete_lines/2","type":"function"},{"doc":"* Updated emulator state","ref":"Raxol.Terminal.Commands.Screen.html#delete_lines/2-returns","title":"Returns - Raxol.Terminal.Commands.Screen.delete_lines/2","type":"function"},{"doc":"Inserts blank lines at the current cursor position.","ref":"Raxol.Terminal.Commands.Screen.html#insert_lines/2","title":"Raxol.Terminal.Commands.Screen.insert_lines/2","type":"function"},{"doc":"* `emulator` - The current emulator state\n* `count` - The number of lines to insert","ref":"Raxol.Terminal.Commands.Screen.html#insert_lines/2-parameters","title":"Parameters - Raxol.Terminal.Commands.Screen.insert_lines/2","type":"function"},{"doc":"* Updated emulator state","ref":"Raxol.Terminal.Commands.Screen.html#insert_lines/2-returns","title":"Returns - Raxol.Terminal.Commands.Screen.insert_lines/2","type":"function"},{"doc":"Scrolls down by moving lines from the screen buffer into the scrollback buffer.","ref":"Raxol.Terminal.Commands.Screen.html#scroll_down/2","title":"Raxol.Terminal.Commands.Screen.scroll_down/2","type":"function"},{"doc":"Scrolls the screen up by the specified number of lines.","ref":"Raxol.Terminal.Commands.Screen.html#scroll_up/2","title":"Raxol.Terminal.Commands.Screen.scroll_up/2","type":"function"},{"doc":"Scrolls the screen up by moving lines from the scrollback buffer to the screen buffer.","ref":"Raxol.Terminal.Commands.Screen.html#scroll_up_screen_command/2","title":"Raxol.Terminal.Commands.Screen.scroll_up_screen_command/2","type":"function"},{"doc":"Handles scrolling operations for the terminal screen buffer.","ref":"Raxol.Terminal.Commands.Scrolling.html","title":"Raxol.Terminal.Commands.Scrolling","type":"module"},{"doc":"Scrolls the buffer down by the specified number of lines.","ref":"Raxol.Terminal.Commands.Scrolling.html#scroll_down/4","title":"Raxol.Terminal.Commands.Scrolling.scroll_down/4","type":"function"},{"doc":"* `buffer` - The screen buffer to modify\n  * `count` - The number of lines to scroll down\n  * `scroll_region` - Optional scroll region override {top, bottom}\n  * `blank_style` - Style to apply to blank lines","ref":"Raxol.Terminal.Commands.Scrolling.html#scroll_down/4-parameters","title":"Parameters - Raxol.Terminal.Commands.Scrolling.scroll_down/4","type":"function"},{"doc":"Updated screen buffer","ref":"Raxol.Terminal.Commands.Scrolling.html#scroll_down/4-returns","title":"Returns - Raxol.Terminal.Commands.Scrolling.scroll_down/4","type":"function"},{"doc":"","ref":"Raxol.Terminal.Commands.Scrolling.html#scroll_up/4","title":"Raxol.Terminal.Commands.Scrolling.scroll_up/4","type":"function"},{"doc":"Handles window-related commands and operations for the terminal.","ref":"Raxol.Terminal.Commands.WindowHandlers.html","title":"Raxol.Terminal.Commands.WindowHandlers","type":"module"},{"doc":"Calculates the window height in characters based on the pixel height.","ref":"Raxol.Terminal.Commands.WindowHandlers.html#calculate_height_chars/1","title":"Raxol.Terminal.Commands.WindowHandlers.calculate_height_chars/1","type":"function"},{"doc":"Calculates the window width in characters based on the pixel width.","ref":"Raxol.Terminal.Commands.WindowHandlers.html#calculate_width_chars/1","title":"Raxol.Terminal.Commands.WindowHandlers.calculate_width_chars/1","type":"function"},{"doc":"Returns the default character height in pixels.","ref":"Raxol.Terminal.Commands.WindowHandlers.html#default_char_height_px/0","title":"Raxol.Terminal.Commands.WindowHandlers.default_char_height_px/0","type":"function"},{"doc":"Returns the default character width in pixels.\nThis is used for calculating window dimensions and text layout.","ref":"Raxol.Terminal.Commands.WindowHandlers.html#default_char_width_px/0","title":"Raxol.Terminal.Commands.WindowHandlers.default_char_width_px/0","type":"function"},{"doc":"Handles terminal settings and behavior, including:\n- Terminal dimensions\n- Color settings\n- Input handling\n- Terminal state management\n- Configuration validation\n- Configuration persistence","ref":"Raxol.Terminal.Config.html","title":"Raxol.Terminal.Config","type":"module"},{"doc":"Gets the current color settings.","ref":"Raxol.Terminal.Config.html#get_colors/1","title":"Raxol.Terminal.Config.get_colors/1","type":"function"},{"doc":"* `config` - The current configuration","ref":"Raxol.Terminal.Config.html#get_colors/1-parameters","title":"Parameters - Raxol.Terminal.Config.get_colors/1","type":"function"},{"doc":"A map containing the current color settings.","ref":"Raxol.Terminal.Config.html#get_colors/1-returns","title":"Returns - Raxol.Terminal.Config.get_colors/1","type":"function"},{"doc":"Gets the current terminal dimensions.","ref":"Raxol.Terminal.Config.html#get_dimensions/1","title":"Raxol.Terminal.Config.get_dimensions/1","type":"function"},{"doc":"* `config` - The current configuration","ref":"Raxol.Terminal.Config.html#get_dimensions/1-parameters","title":"Parameters - Raxol.Terminal.Config.get_dimensions/1","type":"function"},{"doc":"A tuple `{width, height}` with the current dimensions.","ref":"Raxol.Terminal.Config.html#get_dimensions/1-returns","title":"Returns - Raxol.Terminal.Config.get_dimensions/1","type":"function"},{"doc":"Gets the current input handling settings.","ref":"Raxol.Terminal.Config.html#get_input/1","title":"Raxol.Terminal.Config.get_input/1","type":"function"},{"doc":"* `config` - The current configuration","ref":"Raxol.Terminal.Config.html#get_input/1-parameters","title":"Parameters - Raxol.Terminal.Config.get_input/1","type":"function"},{"doc":"A map containing the current input settings.","ref":"Raxol.Terminal.Config.html#get_input/1-returns","title":"Returns - Raxol.Terminal.Config.get_input/1","type":"function"},{"doc":"Gets the current terminal mode settings.","ref":"Raxol.Terminal.Config.html#get_mode/1","title":"Raxol.Terminal.Config.get_mode/1","type":"function"},{"doc":"* `config` - The current configuration","ref":"Raxol.Terminal.Config.html#get_mode/1-parameters","title":"Parameters - Raxol.Terminal.Config.get_mode/1","type":"function"},{"doc":"A map containing the current mode settings.","ref":"Raxol.Terminal.Config.html#get_mode/1-returns","title":"Returns - Raxol.Terminal.Config.get_mode/1","type":"function"},{"doc":"Gets the current performance settings.","ref":"Raxol.Terminal.Config.html#get_performance/1","title":"Raxol.Terminal.Config.get_performance/1","type":"function"},{"doc":"* `config` - The current configuration","ref":"Raxol.Terminal.Config.html#get_performance/1-parameters","title":"Parameters - Raxol.Terminal.Config.get_performance/1","type":"function"},{"doc":"A map containing the current performance settings.","ref":"Raxol.Terminal.Config.html#get_performance/1-returns","title":"Returns - Raxol.Terminal.Config.get_performance/1","type":"function"},{"doc":"Gets the current style settings.","ref":"Raxol.Terminal.Config.html#get_styles/1","title":"Raxol.Terminal.Config.get_styles/1","type":"function"},{"doc":"* `config` - The current configuration","ref":"Raxol.Terminal.Config.html#get_styles/1-parameters","title":"Parameters - Raxol.Terminal.Config.get_styles/1","type":"function"},{"doc":"A map containing the current style settings.","ref":"Raxol.Terminal.Config.html#get_styles/1-returns","title":"Returns - Raxol.Terminal.Config.get_styles/1","type":"function"},{"doc":"Lists all saved configurations.","ref":"Raxol.Terminal.Config.html#list_saved/0","title":"Raxol.Terminal.Config.list_saved/0","type":"function"},{"doc":"Loads a configuration from persistent storage.","ref":"Raxol.Terminal.Config.html#load/1","title":"Raxol.Terminal.Config.load/1","type":"function"},{"doc":"Merges a map of options with the current configuration.\nValidates the options before merging.","ref":"Raxol.Terminal.Config.html#merge_opts/2","title":"Raxol.Terminal.Config.merge_opts/2","type":"function"},{"doc":"* `config` - The current configuration\n* `opts` - A map of options to merge","ref":"Raxol.Terminal.Config.html#merge_opts/2-parameters","title":"Parameters - Raxol.Terminal.Config.merge_opts/2","type":"function"},{"doc":"The updated configuration with merged options.","ref":"Raxol.Terminal.Config.html#merge_opts/2-returns","title":"Returns - Raxol.Terminal.Config.merge_opts/2","type":"function"},{"doc":"Creates a new terminal configuration with default values.","ref":"Raxol.Terminal.Config.html#new/0","title":"Raxol.Terminal.Config.new/0","type":"function"},{"doc":"A new `t:Raxol.Terminal.Config.t/0` struct with default values.","ref":"Raxol.Terminal.Config.html#new/0-returns","title":"Returns - Raxol.Terminal.Config.new/0","type":"function"},{"doc":"Creates a new terminal configuration with custom dimensions.","ref":"Raxol.Terminal.Config.html#new/2","title":"Raxol.Terminal.Config.new/2","type":"function"},{"doc":"* `width` - The terminal width in characters\n* `height` - The terminal height in characters","ref":"Raxol.Terminal.Config.html#new/2-parameters","title":"Parameters - Raxol.Terminal.Config.new/2","type":"function"},{"doc":"A new `t:Raxol.Terminal.Config.t/0` struct with the specified dimensions.","ref":"Raxol.Terminal.Config.html#new/2-returns","title":"Returns - Raxol.Terminal.Config.new/2","type":"function"},{"doc":"Saves the configuration to persistent storage.","ref":"Raxol.Terminal.Config.html#save/2","title":"Raxol.Terminal.Config.save/2","type":"function"},{"doc":"Updates the color settings.","ref":"Raxol.Terminal.Config.html#set_colors/2","title":"Raxol.Terminal.Config.set_colors/2","type":"function"},{"doc":"* `config` - The current configuration\n* `colors` - A map of color settings to update","ref":"Raxol.Terminal.Config.html#set_colors/2-parameters","title":"Parameters - Raxol.Terminal.Config.set_colors/2","type":"function"},{"doc":"The updated configuration with new color settings.","ref":"Raxol.Terminal.Config.html#set_colors/2-returns","title":"Returns - Raxol.Terminal.Config.set_colors/2","type":"function"},{"doc":"Updates the terminal dimensions.","ref":"Raxol.Terminal.Config.html#set_dimensions/3","title":"Raxol.Terminal.Config.set_dimensions/3","type":"function"},{"doc":"* `config` - The current configuration\n* `width` - The new terminal width\n* `height` - The new terminal height","ref":"Raxol.Terminal.Config.html#set_dimensions/3-parameters","title":"Parameters - Raxol.Terminal.Config.set_dimensions/3","type":"function"},{"doc":"The updated configuration with new dimensions.","ref":"Raxol.Terminal.Config.html#set_dimensions/3-returns","title":"Returns - Raxol.Terminal.Config.set_dimensions/3","type":"function"},{"doc":"Updates the input handling settings.","ref":"Raxol.Terminal.Config.html#set_input/2","title":"Raxol.Terminal.Config.set_input/2","type":"function"},{"doc":"* `config` - The current configuration\n* `input` - A map of input settings to update","ref":"Raxol.Terminal.Config.html#set_input/2-parameters","title":"Parameters - Raxol.Terminal.Config.set_input/2","type":"function"},{"doc":"The updated configuration with new input settings.","ref":"Raxol.Terminal.Config.html#set_input/2-returns","title":"Returns - Raxol.Terminal.Config.set_input/2","type":"function"},{"doc":"Updates the terminal mode settings.","ref":"Raxol.Terminal.Config.html#set_mode/2","title":"Raxol.Terminal.Config.set_mode/2","type":"function"},{"doc":"* `config` - The current configuration\n* `mode` - A map of mode settings to update","ref":"Raxol.Terminal.Config.html#set_mode/2-parameters","title":"Parameters - Raxol.Terminal.Config.set_mode/2","type":"function"},{"doc":"The updated configuration with new mode settings.","ref":"Raxol.Terminal.Config.html#set_mode/2-returns","title":"Returns - Raxol.Terminal.Config.set_mode/2","type":"function"},{"doc":"Updates the performance settings.","ref":"Raxol.Terminal.Config.html#set_performance/2","title":"Raxol.Terminal.Config.set_performance/2","type":"function"},{"doc":"* `config` - The current configuration\n* `performance` - A map of performance settings to update","ref":"Raxol.Terminal.Config.html#set_performance/2-parameters","title":"Parameters - Raxol.Terminal.Config.set_performance/2","type":"function"},{"doc":"The updated configuration with new performance settings.","ref":"Raxol.Terminal.Config.html#set_performance/2-returns","title":"Returns - Raxol.Terminal.Config.set_performance/2","type":"function"},{"doc":"Updates the style settings.","ref":"Raxol.Terminal.Config.html#set_styles/2","title":"Raxol.Terminal.Config.set_styles/2","type":"function"},{"doc":"* `config` - The current configuration\n* `styles` - A map of style settings to update","ref":"Raxol.Terminal.Config.html#set_styles/2-parameters","title":"Parameters - Raxol.Terminal.Config.set_styles/2","type":"function"},{"doc":"The updated configuration with new style settings.","ref":"Raxol.Terminal.Config.html#set_styles/2-returns","title":"Returns - Raxol.Terminal.Config.set_styles/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Config.html#t:t/0","title":"Raxol.Terminal.Config.t/0","type":"type"},{"doc":"Updates the terminal configuration with validation.","ref":"Raxol.Terminal.Config.html#update/2","title":"Raxol.Terminal.Config.update/2","type":"function"},{"doc":"Validates a configuration map.\nChecks for required fields and valid values.","ref":"Raxol.Terminal.Config.html#validate_config/1","title":"Raxol.Terminal.Config.validate_config/1","type":"function"},{"doc":"* `config` - The configuration to validate","ref":"Raxol.Terminal.Config.html#validate_config/1-parameters","title":"Parameters - Raxol.Terminal.Config.validate_config/1","type":"function"},{"doc":"`:ok` if the configuration is valid, `{:error, reason}` otherwise.","ref":"Raxol.Terminal.Config.html#validate_config/1-returns","title":"Returns - Raxol.Terminal.Config.validate_config/1","type":"function"},{"doc":"Manages caching for terminal animations using the unified caching system.","ref":"Raxol.Terminal.Config.AnimationCache.html","title":"Raxol.Terminal.Config.AnimationCache","type":"module"},{"doc":"Caches an animation.","ref":"Raxol.Terminal.Config.AnimationCache.html#cache_animation/2","title":"Raxol.Terminal.Config.AnimationCache.cache_animation/2","type":"function"},{"doc":"* `animation_path` - Path to the animation file\n  * `animation_type` - Type of animation (:gif, :video, :shader, :particle)","ref":"Raxol.Terminal.Config.AnimationCache.html#cache_animation/2-parameters","title":"Parameters - Raxol.Terminal.Config.AnimationCache.cache_animation/2","type":"function"},{"doc":"Clears the animation cache.","ref":"Raxol.Terminal.Config.AnimationCache.html#clear_animation_cache/0","title":"Raxol.Terminal.Config.AnimationCache.clear_animation_cache/0","type":"function"},{"doc":"Decompresses an animation.","ref":"Raxol.Terminal.Config.AnimationCache.html#decompress_animation/1","title":"Raxol.Terminal.Config.AnimationCache.decompress_animation/1","type":"function"},{"doc":"* `compressed_data` - Compressed animation data","ref":"Raxol.Terminal.Config.AnimationCache.html#decompress_animation/1-parameters","title":"Parameters - Raxol.Terminal.Config.AnimationCache.decompress_animation/1","type":"function"},{"doc":"Gets animation cache statistics.","ref":"Raxol.Terminal.Config.AnimationCache.html#get_animation_cache_stats/0","title":"Raxol.Terminal.Config.AnimationCache.get_animation_cache_stats/0","type":"function"},{"doc":"Gets the current cache size.","ref":"Raxol.Terminal.Config.AnimationCache.html#get_cache_size/0","title":"Raxol.Terminal.Config.AnimationCache.get_cache_size/0","type":"function"},{"doc":"Gets a cached animation.","ref":"Raxol.Terminal.Config.AnimationCache.html#get_cached_animation/1","title":"Raxol.Terminal.Config.AnimationCache.get_cached_animation/1","type":"function"},{"doc":"* `animation_path` - Path to the animation file","ref":"Raxol.Terminal.Config.AnimationCache.html#get_cached_animation/1-parameters","title":"Parameters - Raxol.Terminal.Config.AnimationCache.get_cached_animation/1","type":"function"},{"doc":"Initializes the animation cache.","ref":"Raxol.Terminal.Config.AnimationCache.html#init_animation_cache/0","title":"Raxol.Terminal.Config.AnimationCache.init_animation_cache/0","type":"function"},{"doc":"Preloads a single animation.","ref":"Raxol.Terminal.Config.AnimationCache.html#preload_animation/1","title":"Raxol.Terminal.Config.AnimationCache.preload_animation/1","type":"function"},{"doc":"* `animation_path` - Path to the animation file","ref":"Raxol.Terminal.Config.AnimationCache.html#preload_animation/1-parameters","title":"Parameters - Raxol.Terminal.Config.AnimationCache.preload_animation/1","type":"function"},{"doc":"Preloads animations from the preload directory.","ref":"Raxol.Terminal.Config.AnimationCache.html#preload_animations/0","title":"Raxol.Terminal.Config.AnimationCache.preload_animations/0","type":"function"},{"doc":"Terminal configuration application.\n\nThis module handles applying configuration settings to the terminal,\nensuring all changes are properly propagated throughout the system.","ref":"Raxol.Terminal.Config.Application.html","title":"Raxol.Terminal.Config.Application","type":"module"},{"doc":"Applies a configuration to the terminal.\n\nThis function takes a configuration and applies it to the current terminal\ninstance, updating the terminal state and behavior.","ref":"Raxol.Terminal.Config.Application.html#apply_config/2","title":"Raxol.Terminal.Config.Application.apply_config/2","type":"function"},{"doc":"* `config` - The configuration to apply\n* `terminal_pid` - The PID of the terminal process (optional)","ref":"Raxol.Terminal.Config.Application.html#apply_config/2-parameters","title":"Parameters - Raxol.Terminal.Config.Application.apply_config/2","type":"function"},{"doc":"`{:ok, applied_config}` or `{:error, reason}`","ref":"Raxol.Terminal.Config.Application.html#apply_config/2-returns","title":"Returns - Raxol.Terminal.Config.Application.apply_config/2","type":"function"},{"doc":"Applies a partial configuration update to the terminal.\n\nThis allows updating only specific parts of the configuration without\nchanging other settings.","ref":"Raxol.Terminal.Config.Application.html#apply_partial_config/2","title":"Raxol.Terminal.Config.Application.apply_partial_config/2","type":"function"},{"doc":"* `partial_config` - The partial configuration to apply\n* `terminal_pid` - The PID of the terminal process (optional)","ref":"Raxol.Terminal.Config.Application.html#apply_partial_config/2-parameters","title":"Parameters - Raxol.Terminal.Config.Application.apply_partial_config/2","type":"function"},{"doc":"`{:ok, updated_config}` or `{:error, reason}`","ref":"Raxol.Terminal.Config.Application.html#apply_partial_config/2-returns","title":"Returns - Raxol.Terminal.Config.Application.apply_partial_config/2","type":"function"},{"doc":"Gets the current terminal configuration.","ref":"Raxol.Terminal.Config.Application.html#get_current_config/1","title":"Raxol.Terminal.Config.Application.get_current_config/1","type":"function"},{"doc":"* `terminal_pid` - The PID of the terminal process (optional)","ref":"Raxol.Terminal.Config.Application.html#get_current_config/1-parameters","title":"Parameters - Raxol.Terminal.Config.Application.get_current_config/1","type":"function"},{"doc":"The current terminal configuration.","ref":"Raxol.Terminal.Config.Application.html#get_current_config/1-returns","title":"Returns - Raxol.Terminal.Config.Application.get_current_config/1","type":"function"},{"doc":"Resets terminal configuration to default values.","ref":"Raxol.Terminal.Config.Application.html#reset_config/2","title":"Raxol.Terminal.Config.Application.reset_config/2","type":"function"},{"doc":"* `terminal_pid` - The PID of the terminal process (optional)\n* `optimize` - Whether to optimize for detected capabilities (default: true)","ref":"Raxol.Terminal.Config.Application.html#reset_config/2-parameters","title":"Parameters - Raxol.Terminal.Config.Application.reset_config/2","type":"function"},{"doc":"`{:ok, default_config}` or `{:error, reason}`","ref":"Raxol.Terminal.Config.Application.html#reset_config/2-returns","title":"Returns - Raxol.Terminal.Config.Application.reset_config/2","type":"function"},{"doc":"Terminal capability detection and management.\n\nProvides functionality to detect and determine terminal capabilities\nsuch as color support, unicode support, etc.","ref":"Raxol.Terminal.Config.Capabilities.html","title":"Raxol.Terminal.Config.Capabilities","type":"module"},{"doc":"Merges detected capabilities with configuration using a specific adapter.\n\nTakes a terminal configuration and enhances it with detected capabilities\nwhere those capabilities aren't already explicitly configured.","ref":"Raxol.Terminal.Config.Capabilities.html#apply_capabilities/2","title":"Raxol.Terminal.Config.Capabilities.apply_capabilities/2","type":"function"},{"doc":"* `config` - The existing configuration\n* `adapter_module` - The module implementing `EnvironmentAdapterBehaviour`.","ref":"Raxol.Terminal.Config.Capabilities.html#apply_capabilities/2-parameters","title":"Parameters - Raxol.Terminal.Config.Capabilities.apply_capabilities/2","type":"function"},{"doc":"The configuration enhanced with detected capabilities.","ref":"Raxol.Terminal.Config.Capabilities.html#apply_capabilities/2-returns","title":"Returns - Raxol.Terminal.Config.Capabilities.apply_capabilities/2","type":"function"},{"doc":"Detects terminal capabilities based on the environment using a specific adapter.\n\nThis examines environment variables, terminal responses, and other indicators\nto determine capabilities of the current terminal.","ref":"Raxol.Terminal.Config.Capabilities.html#detect_capabilities/1","title":"Raxol.Terminal.Config.Capabilities.detect_capabilities/1","type":"function"},{"doc":"* `adapter_module` - The module implementing `EnvironmentAdapterBehaviour`.","ref":"Raxol.Terminal.Config.Capabilities.html#detect_capabilities/1-parameters","title":"Parameters - Raxol.Terminal.Config.Capabilities.detect_capabilities/1","type":"function"},{"doc":"A map of detected capabilities.","ref":"Raxol.Terminal.Config.Capabilities.html#detect_capabilities/1-returns","title":"Returns - Raxol.Terminal.Config.Capabilities.detect_capabilities/1","type":"function"},{"doc":"Creates an optimized configuration based on detected capabilities using the default adapter.\n\nThis generates a configuration that's optimized for the current terminal\nenvironment, balancing features and performance.","ref":"Raxol.Terminal.Config.Capabilities.html#optimized_config/0","title":"Raxol.Terminal.Config.Capabilities.optimized_config/0","type":"function"},{"doc":"An optimized configuration for the current terminal.","ref":"Raxol.Terminal.Config.Capabilities.html#optimized_config/0-returns","title":"Returns - Raxol.Terminal.Config.Capabilities.optimized_config/0","type":"function"},{"doc":"Creates an optimized configuration based on detected capabilities using a specific adapter.","ref":"Raxol.Terminal.Config.Capabilities.html#optimized_config/1","title":"Raxol.Terminal.Config.Capabilities.optimized_config/1","type":"function"},{"doc":"* `adapter_module` - The module implementing `EnvironmentAdapterBehaviour`.","ref":"Raxol.Terminal.Config.Capabilities.html#optimized_config/1-parameters","title":"Parameters - Raxol.Terminal.Config.Capabilities.optimized_config/1","type":"function"},{"doc":"An optimized configuration for the current terminal.","ref":"Raxol.Terminal.Config.Capabilities.html#optimized_config/1-returns","title":"Returns - Raxol.Terminal.Config.Capabilities.optimized_config/1","type":"function"},{"doc":"Default terminal configuration values.\n\nProvides functions for generating default terminal configurations.","ref":"Raxol.Terminal.Config.Defaults.html","title":"Raxol.Terminal.Config.Defaults","type":"module"},{"doc":"Generates a default animation configuration.","ref":"Raxol.Terminal.Config.Defaults.html#default_animation_config/0","title":"Raxol.Terminal.Config.Defaults.default_animation_config/0","type":"function"},{"doc":"A map containing default animation configuration values.","ref":"Raxol.Terminal.Config.Defaults.html#default_animation_config/0-returns","title":"Returns - Raxol.Terminal.Config.Defaults.default_animation_config/0","type":"function"},{"doc":"Generates a default background configuration.","ref":"Raxol.Terminal.Config.Defaults.html#default_background_config/0","title":"Raxol.Terminal.Config.Defaults.default_background_config/0","type":"function"},{"doc":"A map containing default background configuration values.","ref":"Raxol.Terminal.Config.Defaults.html#default_background_config/0-returns","title":"Returns - Raxol.Terminal.Config.Defaults.default_background_config/0","type":"function"},{"doc":"Generates a default behavior configuration.","ref":"Raxol.Terminal.Config.Defaults.html#default_behavior_config/0","title":"Raxol.Terminal.Config.Defaults.default_behavior_config/0","type":"function"},{"doc":"A map containing default behavior configuration values.","ref":"Raxol.Terminal.Config.Defaults.html#default_behavior_config/0-returns","title":"Returns - Raxol.Terminal.Config.Defaults.default_behavior_config/0","type":"function"},{"doc":"Generates a default display configuration.","ref":"Raxol.Terminal.Config.Defaults.html#default_display_config/0","title":"Raxol.Terminal.Config.Defaults.default_display_config/0","type":"function"},{"doc":"A map containing default display configuration values.","ref":"Raxol.Terminal.Config.Defaults.html#default_display_config/0-returns","title":"Returns - Raxol.Terminal.Config.Defaults.default_display_config/0","type":"function"},{"doc":"Generates a default rendering configuration.","ref":"Raxol.Terminal.Config.Defaults.html#default_rendering_config/0","title":"Raxol.Terminal.Config.Defaults.default_rendering_config/0","type":"function"},{"doc":"A map containing default rendering configuration values.","ref":"Raxol.Terminal.Config.Defaults.html#default_rendering_config/0-returns","title":"Returns - Raxol.Terminal.Config.Defaults.default_rendering_config/0","type":"function"},{"doc":"Generates a default system/performance configuration.","ref":"Raxol.Terminal.Config.Defaults.html#default_system_config/0","title":"Raxol.Terminal.Config.Defaults.default_system_config/0","type":"function"},{"doc":"A map containing default system/performance configuration values.","ref":"Raxol.Terminal.Config.Defaults.html#default_system_config/0-returns","title":"Returns - Raxol.Terminal.Config.Defaults.default_system_config/0","type":"function"},{"doc":"Generates a default configuration map merging all specific defaults.\n\nThis map represents the base configuration before any detection or user overrides.","ref":"Raxol.Terminal.Config.Defaults.html#generate_default_config/0","title":"Raxol.Terminal.Config.Defaults.generate_default_config/0","type":"function"},{"doc":"A map containing default configuration values for all settings.","ref":"Raxol.Terminal.Config.Defaults.html#generate_default_config/0-returns","title":"Returns - Raxol.Terminal.Config.Defaults.generate_default_config/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Config.Defaults.html#minimal_config/0","title":"Raxol.Terminal.Config.Defaults.minimal_config/0","type":"function"},{"doc":"Defines the behaviour for terminal environment configuration.\n\nThis behaviour is responsible for:\n- Managing terminal environment variables\n- Handling terminal configuration\n- Providing environment-specific settings\n- Adapting to different terminal environments","ref":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour.html","title":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour","type":"behaviour"},{"doc":"Gets all environment variables.","ref":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour.html#c:get_all_env/0","title":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour.get_all_env/0","type":"callback"},{"doc":"Gets the value of an environment variable.","ref":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour.html#c:get_env/1","title":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour.get_env/1","type":"callback"},{"doc":"Gets terminal-specific configuration.","ref":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour.html#c:get_terminal_config/0","title":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour.get_terminal_config/0","type":"callback"},{"doc":"Gets the current terminal type.","ref":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour.html#c:get_terminal_type/0","title":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour.get_terminal_type/0","type":"callback"},{"doc":"Sets an environment variable.","ref":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour.html#c:set_env/2","title":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour.set_env/2","type":"callback"},{"doc":"Checks if a specific terminal feature is supported.","ref":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour.html#c:supports_feature?/1","title":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour.supports_feature?/1","type":"callback"},{"doc":"Updates terminal configuration.","ref":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour.html#c:update_terminal_config/1","title":"Raxol.Terminal.Config.EnvironmentAdapterBehaviour.update_terminal_config/1","type":"callback"},{"doc":"Handles persistence and migration of terminal configurations.","ref":"Raxol.Terminal.Config.Persistence.html","title":"Raxol.Terminal.Config.Persistence","type":"module"},{"doc":"Lists all saved configurations.","ref":"Raxol.Terminal.Config.Persistence.html#list_configs/0","title":"Raxol.Terminal.Config.Persistence.list_configs/0","type":"function"},{"doc":"Loads a configuration from persistent storage.","ref":"Raxol.Terminal.Config.Persistence.html#load_config/1","title":"Raxol.Terminal.Config.Persistence.load_config/1","type":"function"},{"doc":"Migrates a configuration to the latest version.","ref":"Raxol.Terminal.Config.Persistence.html#migrate_config/1","title":"Raxol.Terminal.Config.Persistence.migrate_config/1","type":"function"},{"doc":"Saves a configuration to persistent storage.","ref":"Raxol.Terminal.Config.Persistence.html#save_config/2","title":"Raxol.Terminal.Config.Persistence.save_config/2","type":"function"},{"doc":"Terminal configuration profile management.\n\nAllows users to define, save, load, and switch between different\nterminal configuration profiles.","ref":"Raxol.Terminal.Config.Profiles.html","title":"Raxol.Terminal.Config.Profiles","type":"module"},{"doc":"","ref":"Raxol.Terminal.Config.Profiles.html#t:animation_type/0","title":"Raxol.Terminal.Config.Profiles.animation_type/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Config.Profiles.html#t:background_type/0","title":"Raxol.Terminal.Config.Profiles.background_type/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Config.Profiles.html#t:color_mode/0","title":"Raxol.Terminal.Config.Profiles.color_mode/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Config.Profiles.html#t:config/0","title":"Raxol.Terminal.Config.Profiles.config/0","type":"type"},{"doc":"Creates a new profile with default settings.","ref":"Raxol.Terminal.Config.Profiles.html#create_default_profile/1","title":"Raxol.Terminal.Config.Profiles.create_default_profile/1","type":"function"},{"doc":"* `name` - The name of the new profile","ref":"Raxol.Terminal.Config.Profiles.html#create_default_profile/1-parameters","title":"Parameters - Raxol.Terminal.Config.Profiles.create_default_profile/1","type":"function"},{"doc":"`{:ok, config}` or `{:error, reason}`","ref":"Raxol.Terminal.Config.Profiles.html#create_default_profile/1-returns","title":"Returns - Raxol.Terminal.Config.Profiles.create_default_profile/1","type":"function"},{"doc":"Deletes a terminal configuration profile.","ref":"Raxol.Terminal.Config.Profiles.html#delete_profile/1","title":"Raxol.Terminal.Config.Profiles.delete_profile/1","type":"function"},{"doc":"* `name` - The name of the profile to delete","ref":"Raxol.Terminal.Config.Profiles.html#delete_profile/1-parameters","title":"Parameters - Raxol.Terminal.Config.Profiles.delete_profile/1","type":"function"},{"doc":"`:ok` or `{:error, reason}`","ref":"Raxol.Terminal.Config.Profiles.html#delete_profile/1-returns","title":"Returns - Raxol.Terminal.Config.Profiles.delete_profile/1","type":"function"},{"doc":"Duplicates an existing profile with a new name.","ref":"Raxol.Terminal.Config.Profiles.html#duplicate_profile/2","title":"Raxol.Terminal.Config.Profiles.duplicate_profile/2","type":"function"},{"doc":"* `source_name` - The name of the profile to duplicate\n* `target_name` - The name for the new profile","ref":"Raxol.Terminal.Config.Profiles.html#duplicate_profile/2-parameters","title":"Parameters - Raxol.Terminal.Config.Profiles.duplicate_profile/2","type":"function"},{"doc":"`{:ok, config}` or `{:error, reason}`","ref":"Raxol.Terminal.Config.Profiles.html#duplicate_profile/2-returns","title":"Returns - Raxol.Terminal.Config.Profiles.duplicate_profile/2","type":"function"},{"doc":"Lists all available terminal configuration profiles.","ref":"Raxol.Terminal.Config.Profiles.html#list_profiles/0","title":"Raxol.Terminal.Config.Profiles.list_profiles/0","type":"function"},{"doc":"A list of profile names.","ref":"Raxol.Terminal.Config.Profiles.html#list_profiles/0-returns","title":"Returns - Raxol.Terminal.Config.Profiles.list_profiles/0","type":"function"},{"doc":"Loads a specific terminal configuration profile.","ref":"Raxol.Terminal.Config.Profiles.html#load_profile/1","title":"Raxol.Terminal.Config.Profiles.load_profile/1","type":"function"},{"doc":"* `name` - The name of the profile to load","ref":"Raxol.Terminal.Config.Profiles.html#load_profile/1-parameters","title":"Parameters - Raxol.Terminal.Config.Profiles.load_profile/1","type":"function"},{"doc":"`{:ok, config}` or `{:error, reason}`","ref":"Raxol.Terminal.Config.Profiles.html#load_profile/1-returns","title":"Returns - Raxol.Terminal.Config.Profiles.load_profile/1","type":"function"},{"doc":"Saves the current configuration as a profile.","ref":"Raxol.Terminal.Config.Profiles.html#save_profile/2","title":"Raxol.Terminal.Config.Profiles.save_profile/2","type":"function"},{"doc":"* `name` - The name of the profile to save\n* `config` - The configuration to save","ref":"Raxol.Terminal.Config.Profiles.html#save_profile/2-parameters","title":"Parameters - Raxol.Terminal.Config.Profiles.save_profile/2","type":"function"},{"doc":"`:ok` or `{:error, reason}`","ref":"Raxol.Terminal.Config.Profiles.html#save_profile/2-returns","title":"Returns - Raxol.Terminal.Config.Profiles.save_profile/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Config.Profiles.html#t:terminal_type/0","title":"Raxol.Terminal.Config.Profiles.terminal_type/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Config.Profiles.html#t:theme_map/0","title":"Raxol.Terminal.Config.Profiles.theme_map/0","type":"type"},{"doc":"Updates an existing profile with new settings.","ref":"Raxol.Terminal.Config.Profiles.html#update_profile/2","title":"Raxol.Terminal.Config.Profiles.update_profile/2","type":"function"},{"doc":"* `name` - The name of the profile to update\n* `config` - The new configuration","ref":"Raxol.Terminal.Config.Profiles.html#update_profile/2-parameters","title":"Parameters - Raxol.Terminal.Config.Profiles.update_profile/2","type":"function"},{"doc":"`:ok` or `{:error, reason}`","ref":"Raxol.Terminal.Config.Profiles.html#update_profile/2-returns","title":"Returns - Raxol.Terminal.Config.Profiles.update_profile/2","type":"function"},{"doc":"Schema definitions for terminal configuration.\n\nDefines the structure and types for all terminal configuration options.","ref":"Raxol.Terminal.Config.Schema.html","title":"Raxol.Terminal.Config.Schema","type":"module"},{"doc":"Defines the schema for terminal configuration.\n\nThis includes all possible configuration fields with their types,\ndefault values, and descriptions.","ref":"Raxol.Terminal.Config.Schema.html#config_schema/0","title":"Raxol.Terminal.Config.Schema.config_schema/0","type":"function"},{"doc":"Returns the default configuration values.\nThis delegates to the Defaults module for actual values.","ref":"Raxol.Terminal.Config.Schema.html#default_config/0","title":"Raxol.Terminal.Config.Schema.default_config/0","type":"function"},{"doc":"Returns the type information for a specific configuration path.","ref":"Raxol.Terminal.Config.Schema.html#get_type/1","title":"Raxol.Terminal.Config.Schema.get_type/1","type":"function"},{"doc":"* `path` - A list of keys representing the path to the configuration value","ref":"Raxol.Terminal.Config.Schema.html#get_type/1-parameters","title":"Parameters - Raxol.Terminal.Config.Schema.get_type/1","type":"function"},{"doc":"A tuple with type information or nil if the path doesn't exist","ref":"Raxol.Terminal.Config.Schema.html#get_type/1-returns","title":"Returns - Raxol.Terminal.Config.Schema.get_type/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Config.Schema.html#schema/0","title":"Raxol.Terminal.Config.Schema.schema/0","type":"function"},{"doc":"Utility functions for handling terminal configuration maps.","ref":"Raxol.Terminal.Config.Utils.html","title":"Raxol.Terminal.Config.Utils","type":"module"},{"doc":"Deeply merges two maps.\n\nKeys in the right map take precedence. If both values for a key are maps,\nthey are merged recursively.","ref":"Raxol.Terminal.Config.Utils.html#deep_merge/2","title":"Raxol.Terminal.Config.Utils.deep_merge/2","type":"function"},{"doc":"Merges configuration options into an existing configuration map.\n\nThe `opts` are first converted into a nested map structure and then\ndeeply merged into the `current_config`.","ref":"Raxol.Terminal.Config.Utils.html#merge_opts/2","title":"Raxol.Terminal.Config.Utils.merge_opts/2","type":"function"},{"doc":"Converts a keyword list or map of potentially nested options into a nested map.\n\nHandles flat keys like `theme: \"light\"` and nested paths represented\nby lists like `[behavior: [scrollback: 100]]` within the keyword list.","ref":"Raxol.Terminal.Config.Utils.html#opts_to_nested_map/1","title":"Raxol.Terminal.Config.Utils.opts_to_nested_map/1","type":"function"},{"doc":"Validation logic for terminal configuration.\n\nEnsures that configuration values are valid according to their schema.","ref":"Raxol.Terminal.Config.Validation.html","title":"Raxol.Terminal.Config.Validation","type":"module"},{"doc":"Validates a complete terminal configuration.","ref":"Raxol.Terminal.Config.Validation.html#validate_config/1","title":"Raxol.Terminal.Config.Validation.validate_config/1","type":"function"},{"doc":"* `config` - The configuration to validate","ref":"Raxol.Terminal.Config.Validation.html#validate_config/1-parameters","title":"Parameters - Raxol.Terminal.Config.Validation.validate_config/1","type":"function"},{"doc":"`{:ok, validated_config}` or `{:error, reason}`","ref":"Raxol.Terminal.Config.Validation.html#validate_config/1-returns","title":"Returns - Raxol.Terminal.Config.Validation.validate_config/1","type":"function"},{"doc":"Validates a specific configuration value against its schema.","ref":"Raxol.Terminal.Config.Validation.html#validate_value/2","title":"Raxol.Terminal.Config.Validation.validate_value/2","type":"function"},{"doc":"* `path` - A list of keys representing the path to the configuration value\n* `value` - The value to validate","ref":"Raxol.Terminal.Config.Validation.html#validate_value/2-parameters","title":"Parameters - Raxol.Terminal.Config.Validation.validate_value/2","type":"function"},{"doc":"`{:ok, validated_value}` or `{:error, reason}`","ref":"Raxol.Terminal.Config.Validation.html#validate_value/2-returns","title":"Returns - Raxol.Terminal.Config.Validation.validate_value/2","type":"function"},{"doc":"Validates terminal configuration settings.","ref":"Raxol.Terminal.Config.Validator.html","title":"Raxol.Terminal.Config.Validator","type":"module"},{"doc":"Validates a complete configuration.","ref":"Raxol.Terminal.Config.Validator.html#validate_config/1","title":"Raxol.Terminal.Config.Validator.validate_config/1","type":"function"},{"doc":"Validates a configuration update.","ref":"Raxol.Terminal.Config.Validator.html#validate_update/2","title":"Raxol.Terminal.Config.Validator.validate_update/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Config.Validator.html#t:validation_result/0","title":"Raxol.Terminal.Config.Validator.validation_result/0","type":"type"},{"doc":"Configuration management for the terminal emulator.","ref":"Raxol.Terminal.Configuration.html","title":"Raxol.Terminal.Configuration","type":"module"},{"doc":"Applies restored data to the configuration.","ref":"Raxol.Terminal.Configuration.html#apply_restored_data/3","title":"Raxol.Terminal.Configuration.apply_restored_data/3","type":"function"},{"doc":"Creates a new configuration with default values.","ref":"Raxol.Terminal.Configuration.html#new/1","title":"Raxol.Terminal.Configuration.new/1","type":"function"},{"doc":"Restores the most recently saved terminal state.","ref":"Raxol.Terminal.Configuration.html#restore_state/1","title":"Raxol.Terminal.Configuration.restore_state/1","type":"function"},{"doc":"Saves the current terminal state.","ref":"Raxol.Terminal.Configuration.html#save_state/2","title":"Raxol.Terminal.Configuration.save_state/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Configuration.html#t:t/0","title":"Raxol.Terminal.Configuration.t/0","type":"type"},{"doc":"Handles C0 control codes and simple ESC sequences.\n\nExtracted from Terminal.Emulator for better organization.\nRelies on Emulator state and ScreenBuffer for actions.","ref":"Raxol.Terminal.ControlCodes.html","title":"Raxol.Terminal.ControlCodes","type":"module"},{"doc":"Handles bell control code.","ref":"Raxol.Terminal.ControlCodes.html#handle_bel/1","title":"Raxol.Terminal.ControlCodes.handle_bel/1","type":"function"},{"doc":"Handle Backspace (BS)","ref":"Raxol.Terminal.ControlCodes.html#handle_bs/1","title":"Raxol.Terminal.ControlCodes.handle_bs/1","type":"function"},{"doc":"Handles a C0 control code (0-31) or DEL (127).\nDelegates to specific handlers based on the codepoint.","ref":"Raxol.Terminal.ControlCodes.html#handle_c0/2","title":"Raxol.Terminal.ControlCodes.handle_c0/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ControlCodes.html#handle_can/1","title":"Raxol.Terminal.ControlCodes.handle_can/1","type":"function"},{"doc":"Handle Carriage Return (CR)","ref":"Raxol.Terminal.ControlCodes.html#handle_cr/1","title":"Raxol.Terminal.ControlCodes.handle_cr/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ControlCodes.html#handle_decrc/1","title":"Raxol.Terminal.ControlCodes.handle_decrc/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ControlCodes.html#handle_decsc/1","title":"Raxol.Terminal.ControlCodes.handle_decsc/1","type":"function"},{"doc":"Handles the Horizontal Tab (HT) action.","ref":"Raxol.Terminal.ControlCodes.html#handle_ht/1","title":"Raxol.Terminal.ControlCodes.handle_ht/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ControlCodes.html#handle_hts/1","title":"Raxol.Terminal.ControlCodes.handle_hts/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ControlCodes.html#handle_ind/1","title":"Raxol.Terminal.ControlCodes.handle_ind/1","type":"function"},{"doc":"Handle Line Feed (LF), New Line (NL), Vertical Tab (VT)","ref":"Raxol.Terminal.ControlCodes.html#handle_lf/1","title":"Raxol.Terminal.ControlCodes.handle_lf/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ControlCodes.html#handle_nel/1","title":"Raxol.Terminal.ControlCodes.handle_nel/1","type":"function"},{"doc":"Handle Reverse Index (RI) - ESC M","ref":"Raxol.Terminal.ControlCodes.html#handle_ri/1","title":"Raxol.Terminal.ControlCodes.handle_ri/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ControlCodes.html#handle_ris/1","title":"Raxol.Terminal.ControlCodes.handle_ris/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ControlCodes.html#handle_si/1","title":"Raxol.Terminal.ControlCodes.handle_si/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ControlCodes.html#handle_so/1","title":"Raxol.Terminal.ControlCodes.handle_so/1","type":"function"},{"doc":"Handles substitute character control code.","ref":"Raxol.Terminal.ControlCodes.html#handle_sub/1","title":"Raxol.Terminal.ControlCodes.handle_sub/1","type":"function"},{"doc":"Core state struct for the terminal emulator. This struct holds the main state fields used by the emulator state management functions.","ref":"Raxol.Terminal.Core.html","title":"Raxol.Terminal.Core","type":"module"},{"doc":"","ref":"Raxol.Terminal.Core.html#t:t/0","title":"Raxol.Terminal.Core.t/0","type":"type"},{"doc":"Provides cursor manipulation functions for the terminal emulator.\nThis module handles operations like moving the cursor, setting its visibility,\nand managing cursor state.","ref":"Raxol.Terminal.Cursor.html","title":"Raxol.Terminal.Cursor","type":"module"},{"doc":"Gets the current cursor position.","ref":"Raxol.Terminal.Cursor.html#get_position/1","title":"Raxol.Terminal.Cursor.get_position/1","type":"function"},{"doc":"Moves the cursor backward by the specified number of columns.","ref":"Raxol.Terminal.Cursor.html#move_backward/2","title":"Raxol.Terminal.Cursor.move_backward/2","type":"function"},{"doc":"Moves the cursor down by the specified number of lines.","ref":"Raxol.Terminal.Cursor.html#move_down/2","title":"Raxol.Terminal.Cursor.move_down/2","type":"function"},{"doc":"Moves the cursor down and to the beginning of the line.","ref":"Raxol.Terminal.Cursor.html#move_down_and_home/2","title":"Raxol.Terminal.Cursor.move_down_and_home/2","type":"function"},{"doc":"Moves the cursor forward by the specified number of columns.","ref":"Raxol.Terminal.Cursor.html#move_forward/2","title":"Raxol.Terminal.Cursor.move_forward/2","type":"function"},{"doc":"Moves the cursor left by the specified number of columns.","ref":"Raxol.Terminal.Cursor.html#move_left/2","title":"Raxol.Terminal.Cursor.move_left/2","type":"function"},{"doc":"Moves the cursor right by the specified number of columns.","ref":"Raxol.Terminal.Cursor.html#move_right/2","title":"Raxol.Terminal.Cursor.move_right/2","type":"function"},{"doc":"Moves the cursor to the specified position.","ref":"Raxol.Terminal.Cursor.html#move_to/2","title":"Raxol.Terminal.Cursor.move_to/2","type":"function"},{"doc":"Moves the cursor to the specified row and column.","ref":"Raxol.Terminal.Cursor.html#move_to/3","title":"Raxol.Terminal.Cursor.move_to/3","type":"function"},{"doc":"Moves the cursor to the specified position, taking into account the screen width and height.","ref":"Raxol.Terminal.Cursor.html#move_to/4","title":"Raxol.Terminal.Cursor.move_to/4","type":"function"},{"doc":"Moves the cursor to the specified column.","ref":"Raxol.Terminal.Cursor.html#move_to_column/2","title":"Raxol.Terminal.Cursor.move_to_column/2","type":"function"},{"doc":"Moves the cursor up by the specified number of lines.","ref":"Raxol.Terminal.Cursor.html#move_up/2","title":"Raxol.Terminal.Cursor.move_up/2","type":"function"},{"doc":"Moves the cursor up and to the beginning of the line.","ref":"Raxol.Terminal.Cursor.html#move_up_and_home/2","title":"Raxol.Terminal.Cursor.move_up_and_home/2","type":"function"},{"doc":"Sets the cursor shape.","ref":"Raxol.Terminal.Cursor.html#set_shape/2","title":"Raxol.Terminal.Cursor.set_shape/2","type":"function"},{"doc":"Sets the cursor visibility.","ref":"Raxol.Terminal.Cursor.html#set_visible/2","title":"Raxol.Terminal.Cursor.set_visible/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Cursor.html#t:t/0","title":"Raxol.Terminal.Cursor.t/0","type":"type"},{"doc":"Manages cursor state and operations in the terminal.\nHandles cursor position, visibility, style, and blinking state.","ref":"Raxol.Terminal.Cursor.Manager.html","title":"Raxol.Terminal.Cursor.Manager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Cursor.Manager.html#child_spec/1","title":"Raxol.Terminal.Cursor.Manager.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Cursor.Manager.html#t:color/0","title":"Raxol.Terminal.Cursor.Manager.color/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Cursor.Manager.html#t:cursor_style/0","title":"Raxol.Terminal.Cursor.Manager.cursor_style/0","type":"type"},{"doc":"Gets the cursor blinking state.","ref":"Raxol.Terminal.Cursor.Manager.html#get_blink/1","title":"Raxol.Terminal.Cursor.Manager.get_blink/1","type":"function"},{"doc":"Gets the cursor color.","ref":"Raxol.Terminal.Cursor.Manager.html#get_color/1","title":"Raxol.Terminal.Cursor.Manager.get_color/1","type":"function"},{"doc":"Gets the cursor margins.","ref":"Raxol.Terminal.Cursor.Manager.html#get_margins/1","title":"Raxol.Terminal.Cursor.Manager.get_margins/1","type":"function"},{"doc":"Gets the current cursor position.","ref":"Raxol.Terminal.Cursor.Manager.html#get_position/1","title":"Raxol.Terminal.Cursor.Manager.get_position/1","type":"function"},{"doc":"Gets the cursor style.","ref":"Raxol.Terminal.Cursor.Manager.html#get_style/1","title":"Raxol.Terminal.Cursor.Manager.get_style/1","type":"function"},{"doc":"Gets the cursor visibility state.","ref":"Raxol.Terminal.Cursor.Manager.html#get_visibility/1","title":"Raxol.Terminal.Cursor.Manager.get_visibility/1","type":"function"},{"doc":"Moves the cursor relative to its current position.","ref":"Raxol.Terminal.Cursor.Manager.html#move_cursor/3","title":"Raxol.Terminal.Cursor.Manager.move_cursor/3","type":"function"},{"doc":"Moves the cursor down by the specified number of lines.","ref":"Raxol.Terminal.Cursor.Manager.html#move_down/4","title":"Raxol.Terminal.Cursor.Manager.move_down/4","type":"function"},{"doc":"Moves the cursor to the home position (0, 0).","ref":"Raxol.Terminal.Cursor.Manager.html#move_home/3","title":"Raxol.Terminal.Cursor.Manager.move_home/3","type":"function"},{"doc":"Moves the cursor left by the specified number of columns.","ref":"Raxol.Terminal.Cursor.Manager.html#move_left/4","title":"Raxol.Terminal.Cursor.Manager.move_left/4","type":"function"},{"doc":"Moves the cursor right by the specified number of columns.","ref":"Raxol.Terminal.Cursor.Manager.html#move_right/4","title":"Raxol.Terminal.Cursor.Manager.move_right/4","type":"function"},{"doc":"Moves the cursor to a specific position.","ref":"Raxol.Terminal.Cursor.Manager.html#move_to/3","title":"Raxol.Terminal.Cursor.Manager.move_to/3","type":"function"},{"doc":"Moves the cursor to the specified column.","ref":"Raxol.Terminal.Cursor.Manager.html#move_to_column/2","title":"Raxol.Terminal.Cursor.Manager.move_to_column/2","type":"function"},{"doc":"Moves the cursor to the specified line.","ref":"Raxol.Terminal.Cursor.Manager.html#move_to_line/2","title":"Raxol.Terminal.Cursor.Manager.move_to_line/2","type":"function"},{"doc":"Moves the cursor to the end of the line.","ref":"Raxol.Terminal.Cursor.Manager.html#move_to_line_end/2","title":"Raxol.Terminal.Cursor.Manager.move_to_line_end/2","type":"function"},{"doc":"Moves the cursor to the beginning of the line.","ref":"Raxol.Terminal.Cursor.Manager.html#move_to_line_start/1","title":"Raxol.Terminal.Cursor.Manager.move_to_line_start/1","type":"function"},{"doc":"Moves the cursor to the next tab stop.","ref":"Raxol.Terminal.Cursor.Manager.html#move_to_next_tab/4","title":"Raxol.Terminal.Cursor.Manager.move_to_next_tab/4","type":"function"},{"doc":"Moves the cursor to the previous tab stop.","ref":"Raxol.Terminal.Cursor.Manager.html#move_to_prev_tab/4","title":"Raxol.Terminal.Cursor.Manager.move_to_prev_tab/4","type":"function"},{"doc":"Moves the cursor up by the specified number of lines.","ref":"Raxol.Terminal.Cursor.Manager.html#move_up/4","title":"Raxol.Terminal.Cursor.Manager.move_up/4","type":"function"},{"doc":"Creates a new cursor manager instance.","ref":"Raxol.Terminal.Cursor.Manager.html#new/0","title":"Raxol.Terminal.Cursor.Manager.new/0","type":"function"},{"doc":"Creates a new cursor struct with the given options.","ref":"Raxol.Terminal.Cursor.Manager.html#new/1","title":"Raxol.Terminal.Cursor.Manager.new/1","type":"function"},{"doc":"Resets the cursor state to default values.","ref":"Raxol.Terminal.Cursor.Manager.html#reset/1","title":"Raxol.Terminal.Cursor.Manager.reset/1","type":"function"},{"doc":"Resets the cursor color to default.","ref":"Raxol.Terminal.Cursor.Manager.html#reset_color/1","title":"Raxol.Terminal.Cursor.Manager.reset_color/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Cursor.Manager.html#reset_position/1","title":"Raxol.Terminal.Cursor.Manager.reset_position/1","type":"function"},{"doc":"Restores the saved cursor state.","ref":"Raxol.Terminal.Cursor.Manager.html#restore_state/1","title":"Raxol.Terminal.Cursor.Manager.restore_state/1","type":"function"},{"doc":"Saves the current cursor state.","ref":"Raxol.Terminal.Cursor.Manager.html#save_state/1","title":"Raxol.Terminal.Cursor.Manager.save_state/1","type":"function"},{"doc":"Sets the cursor blinking state.","ref":"Raxol.Terminal.Cursor.Manager.html#set_blink/2","title":"Raxol.Terminal.Cursor.Manager.set_blink/2","type":"function"},{"doc":"Sets the cursor color.","ref":"Raxol.Terminal.Cursor.Manager.html#set_color/2","title":"Raxol.Terminal.Cursor.Manager.set_color/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Cursor.Manager.html#set_custom_shape/3","title":"Raxol.Terminal.Cursor.Manager.set_custom_shape/3","type":"function"},{"doc":"Sets the cursor margins.","ref":"Raxol.Terminal.Cursor.Manager.html#set_margins/3","title":"Raxol.Terminal.Cursor.Manager.set_margins/3","type":"function"},{"doc":"Sets the cursor position.","ref":"Raxol.Terminal.Cursor.Manager.html#set_position/2","title":"Raxol.Terminal.Cursor.Manager.set_position/2","type":"function"},{"doc":"Sets the cursor state based on a state atom.\nSupported states: :visible, :hidden","ref":"Raxol.Terminal.Cursor.Manager.html#set_state/2","title":"Raxol.Terminal.Cursor.Manager.set_state/2","type":"function"},{"doc":"Sets the cursor style.","ref":"Raxol.Terminal.Cursor.Manager.html#set_style/2","title":"Raxol.Terminal.Cursor.Manager.set_style/2","type":"function"},{"doc":"Sets the cursor visibility state.","ref":"Raxol.Terminal.Cursor.Manager.html#set_visibility/2","title":"Raxol.Terminal.Cursor.Manager.set_visibility/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Cursor.Manager.html#start_link/1","title":"Raxol.Terminal.Cursor.Manager.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Cursor.Manager.html#t:t/0","title":"Raxol.Terminal.Cursor.Manager.t/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Cursor.Manager.html#update_blink/1","title":"Raxol.Terminal.Cursor.Manager.update_blink/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Cursor.Manager.html#update_position/2","title":"Raxol.Terminal.Cursor.Manager.update_position/2","type":"function"},{"doc":"Handles cursor movement and positioning for the terminal emulator.\n\nThis module provides functions for moving the cursor in various directions,\nhandling relative and absolute positioning, and managing cursor boundaries.","ref":"Raxol.Terminal.Cursor.Movement.html","title":"Raxol.Terminal.Cursor.Movement","type":"module"},{"doc":"Moves the cursor down by the specified number of lines, respecting margins.","ref":"Raxol.Terminal.Cursor.Movement.html#move_down/4","title":"Raxol.Terminal.Cursor.Movement.move_down/4","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Movement}\n    iex> cursor = Manager.new()\n    iex> cursor = Movement.move_down(cursor, 2)\n    iex> cursor.position\n    {0, 2}","ref":"Raxol.Terminal.Cursor.Movement.html#move_down/4-examples","title":"Examples - Raxol.Terminal.Cursor.Movement.move_down/4","type":"function"},{"doc":"Moves the cursor to the home position (0, 0).","ref":"Raxol.Terminal.Cursor.Movement.html#move_home/3","title":"Raxol.Terminal.Cursor.Movement.move_home/3","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Movement}\n    iex> cursor = Manager.new()\n    iex> cursor = Manager.move_to(cursor, 10, 5)\n    iex> cursor = Movement.move_home(cursor)\n    iex> cursor.position\n    {0, 0}","ref":"Raxol.Terminal.Cursor.Movement.html#move_home/3-examples","title":"Examples - Raxol.Terminal.Cursor.Movement.move_home/3","type":"function"},{"doc":"Moves the cursor left by the specified number of columns.","ref":"Raxol.Terminal.Cursor.Movement.html#move_left/2","title":"Raxol.Terminal.Cursor.Movement.move_left/2","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Movement}\n    iex> cursor = Manager.new()\n    iex> cursor = Manager.move_to(cursor, 5, 0)\n    iex> cursor = Movement.move_left(cursor, 2)\n    iex> cursor.position\n    {3, 0}","ref":"Raxol.Terminal.Cursor.Movement.html#move_left/2-examples","title":"Examples - Raxol.Terminal.Cursor.Movement.move_left/2","type":"function"},{"doc":"Moves the cursor right by the specified number of columns.","ref":"Raxol.Terminal.Cursor.Movement.html#move_right/2","title":"Raxol.Terminal.Cursor.Movement.move_right/2","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Movement}\n    iex> cursor = Manager.new()\n    iex> cursor = Movement.move_right(cursor, 2)\n    iex> cursor.position\n    {2, 0}","ref":"Raxol.Terminal.Cursor.Movement.html#move_right/2-examples","title":"Examples - Raxol.Terminal.Cursor.Movement.move_right/2","type":"function"},{"doc":"Moves the cursor to a specific position with row bounds.","ref":"Raxol.Terminal.Cursor.Movement.html#move_to/5","title":"Raxol.Terminal.Cursor.Movement.move_to/5","type":"function"},{"doc":"Moves the cursor to a specific position with both row and column bounds.","ref":"Raxol.Terminal.Cursor.Movement.html#move_to/7","title":"Raxol.Terminal.Cursor.Movement.move_to/7","type":"function"},{"doc":"Moves the cursor to the specified column.","ref":"Raxol.Terminal.Cursor.Movement.html#move_to_column/2","title":"Raxol.Terminal.Cursor.Movement.move_to_column/2","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Movement}\n    iex> cursor = Manager.new()\n    iex> cursor = Movement.move_to_column(cursor, 10)\n    iex> cursor.position\n    {10, 0}","ref":"Raxol.Terminal.Cursor.Movement.html#move_to_column/2-examples","title":"Examples - Raxol.Terminal.Cursor.Movement.move_to_column/2","type":"function"},{"doc":"Moves the cursor to the specified line.","ref":"Raxol.Terminal.Cursor.Movement.html#move_to_line/2","title":"Raxol.Terminal.Cursor.Movement.move_to_line/2","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Movement}\n    iex> cursor = Manager.new()\n    iex> cursor = Movement.move_to_line(cursor, 5)\n    iex> cursor.position\n    {0, 5}","ref":"Raxol.Terminal.Cursor.Movement.html#move_to_line/2-examples","title":"Examples - Raxol.Terminal.Cursor.Movement.move_to_line/2","type":"function"},{"doc":"Moves the cursor to the end of the line.","ref":"Raxol.Terminal.Cursor.Movement.html#move_to_line_end/2","title":"Raxol.Terminal.Cursor.Movement.move_to_line_end/2","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Movement}\n    iex> cursor = Manager.new()\n    iex> cursor = Movement.move_to_line_end(cursor, 80)\n    iex> cursor.position\n    {79, 0}","ref":"Raxol.Terminal.Cursor.Movement.html#move_to_line_end/2-examples","title":"Examples - Raxol.Terminal.Cursor.Movement.move_to_line_end/2","type":"function"},{"doc":"Moves the cursor to the beginning of the line.","ref":"Raxol.Terminal.Cursor.Movement.html#move_to_line_start/1","title":"Raxol.Terminal.Cursor.Movement.move_to_line_start/1","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Movement}\n    iex> cursor = Manager.new()\n    iex> cursor = Manager.move_to(cursor, 10, 0)\n    iex> cursor = Movement.move_to_line_start(cursor)\n    iex> cursor.position\n    {0, 0}","ref":"Raxol.Terminal.Cursor.Movement.html#move_to_line_start/1-examples","title":"Examples - Raxol.Terminal.Cursor.Movement.move_to_line_start/1","type":"function"},{"doc":"Moves the cursor to the next tab stop.","ref":"Raxol.Terminal.Cursor.Movement.html#move_to_next_tab/4","title":"Raxol.Terminal.Cursor.Movement.move_to_next_tab/4","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Movement}\n    iex> cursor = Manager.new()\n    iex> cursor = Movement.move_to_next_tab(cursor, 8)\n    iex> cursor.position\n    {8, 0}","ref":"Raxol.Terminal.Cursor.Movement.html#move_to_next_tab/4-examples","title":"Examples - Raxol.Terminal.Cursor.Movement.move_to_next_tab/4","type":"function"},{"doc":"Moves the cursor to a specific position in the terminal.","ref":"Raxol.Terminal.Cursor.Movement.html#move_to_position/3","title":"Raxol.Terminal.Cursor.Movement.move_to_position/3","type":"function"},{"doc":"Moves the cursor to the previous tab stop.","ref":"Raxol.Terminal.Cursor.Movement.html#move_to_prev_tab/4","title":"Raxol.Terminal.Cursor.Movement.move_to_prev_tab/4","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Movement}\n    iex> cursor = Manager.new()\n    iex> cursor = Manager.move_to(cursor, 10, 0)\n    iex> cursor = Movement.move_to_prev_tab(cursor, 8)\n    iex> cursor.position\n    {8, 0}","ref":"Raxol.Terminal.Cursor.Movement.html#move_to_prev_tab/4-examples","title":"Examples - Raxol.Terminal.Cursor.Movement.move_to_prev_tab/4","type":"function"},{"doc":"Moves the cursor up by the specified number of lines, respecting margins.","ref":"Raxol.Terminal.Cursor.Movement.html#move_up/4","title":"Raxol.Terminal.Cursor.Movement.move_up/4","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Movement}\n    iex> cursor = Manager.new()\n    iex> cursor = Movement.move_up(cursor, 2)\n    iex> cursor.position\n    {0, 0}  # Already at top, no change","ref":"Raxol.Terminal.Cursor.Movement.html#move_up/4-examples","title":"Examples - Raxol.Terminal.Cursor.Movement.move_up/4","type":"function"},{"doc":"Handles cursor style and visibility control for the terminal emulator.\n\nThis module provides functions for changing cursor appearance, controlling\nvisibility, and managing cursor blinking.","ref":"Raxol.Terminal.Cursor.Style.html","title":"Raxol.Terminal.Cursor.Style","type":"module"},{"doc":"Makes the cursor blink.","ref":"Raxol.Terminal.Cursor.Style.html#blink/1","title":"Raxol.Terminal.Cursor.Style.blink/1","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Style}\n    iex> cursor = Manager.new()\n    iex> cursor = Style.blink(cursor)\n    iex> cursor.state\n    :blinking","ref":"Raxol.Terminal.Cursor.Style.html#blink/1-examples","title":"Examples - Raxol.Terminal.Cursor.Style.blink/1","type":"function"},{"doc":"Gets the current cursor blink mode.","ref":"Raxol.Terminal.Cursor.Style.html#get_blink/1","title":"Raxol.Terminal.Cursor.Style.get_blink/1","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Style}\n    iex> cursor = Manager.new()\n    iex> Style.get_blink(cursor)\n    :none","ref":"Raxol.Terminal.Cursor.Style.html#get_blink/1-examples","title":"Examples - Raxol.Terminal.Cursor.Style.get_blink/1","type":"function"},{"doc":"Gets the current cursor state.","ref":"Raxol.Terminal.Cursor.Style.html#get_state/1","title":"Raxol.Terminal.Cursor.Style.get_state/1","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Style}\n    iex> cursor = Manager.new()\n    iex> Style.get_state(cursor)\n    :visible","ref":"Raxol.Terminal.Cursor.Style.html#get_state/1-examples","title":"Examples - Raxol.Terminal.Cursor.Style.get_state/1","type":"function"},{"doc":"Gets the current cursor style.","ref":"Raxol.Terminal.Cursor.Style.html#get_style/1","title":"Raxol.Terminal.Cursor.Style.get_style/1","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Style}\n    iex> cursor = Manager.new()\n    iex> Style.get_style(cursor)\n    :block","ref":"Raxol.Terminal.Cursor.Style.html#get_style/1-examples","title":"Examples - Raxol.Terminal.Cursor.Style.get_style/1","type":"function"},{"doc":"Hides the cursor.","ref":"Raxol.Terminal.Cursor.Style.html#hide/1","title":"Raxol.Terminal.Cursor.Style.hide/1","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Style}\n    iex> cursor = Manager.new()\n    iex> cursor = Style.hide(cursor)\n    iex> cursor.state\n    :hidden","ref":"Raxol.Terminal.Cursor.Style.html#hide/1-examples","title":"Examples - Raxol.Terminal.Cursor.Style.hide/1","type":"function"},{"doc":"Sets the cursor style to bar.","ref":"Raxol.Terminal.Cursor.Style.html#set_bar/1","title":"Raxol.Terminal.Cursor.Style.set_bar/1","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Style}\n    iex> cursor = Manager.new()\n    iex> cursor = Style.set_bar(cursor)\n    iex> cursor.style\n    :bar","ref":"Raxol.Terminal.Cursor.Style.html#set_bar/1-examples","title":"Examples - Raxol.Terminal.Cursor.Style.set_bar/1","type":"function"},{"doc":"Sets the cursor blink rate in milliseconds.","ref":"Raxol.Terminal.Cursor.Style.html#set_blink_rate/2","title":"Raxol.Terminal.Cursor.Style.set_blink_rate/2","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Style}\n    iex> cursor = Manager.new()\n    iex> cursor = Style.set_blink_rate(cursor, 1000)\n    iex> cursor.blink_rate\n    1000","ref":"Raxol.Terminal.Cursor.Style.html#set_blink_rate/2-examples","title":"Examples - Raxol.Terminal.Cursor.Style.set_blink_rate/2","type":"function"},{"doc":"Sets the cursor style to block.","ref":"Raxol.Terminal.Cursor.Style.html#set_block/1","title":"Raxol.Terminal.Cursor.Style.set_block/1","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Style}\n    iex> cursor = Manager.new()\n    iex> cursor = Style.set_block(cursor)\n    iex> cursor.style\n    :block","ref":"Raxol.Terminal.Cursor.Style.html#set_block/1-examples","title":"Examples - Raxol.Terminal.Cursor.Style.set_block/1","type":"function"},{"doc":"Sets a custom cursor shape.","ref":"Raxol.Terminal.Cursor.Style.html#set_custom/3","title":"Raxol.Terminal.Cursor.Style.set_custom/3","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Style}\n    iex> cursor = Manager.new()\n    iex> cursor = Style.set_custom(cursor, \"█\", {2, 1})\n    iex> cursor.style\n    :custom\n    iex> cursor.custom_shape\n    \"█\"","ref":"Raxol.Terminal.Cursor.Style.html#set_custom/3-examples","title":"Examples - Raxol.Terminal.Cursor.Style.set_custom/3","type":"function"},{"doc":"Sets the cursor style to underline.","ref":"Raxol.Terminal.Cursor.Style.html#set_underline/1","title":"Raxol.Terminal.Cursor.Style.set_underline/1","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Style}\n    iex> cursor = Manager.new()\n    iex> cursor = Style.set_underline(cursor)\n    iex> cursor.style\n    :underline","ref":"Raxol.Terminal.Cursor.Style.html#set_underline/1-examples","title":"Examples - Raxol.Terminal.Cursor.Style.set_underline/1","type":"function"},{"doc":"Makes the cursor visible.","ref":"Raxol.Terminal.Cursor.Style.html#show/1","title":"Raxol.Terminal.Cursor.Style.show/1","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Style}\n    iex> cursor = Manager.new()\n    iex> cursor = Manager.set_state(cursor, :hidden)\n    iex> cursor = Style.show(cursor)\n    iex> cursor.state\n    :visible","ref":"Raxol.Terminal.Cursor.Style.html#show/1-examples","title":"Examples - Raxol.Terminal.Cursor.Style.show/1","type":"function"},{"doc":"Toggles the cursor blinking state.","ref":"Raxol.Terminal.Cursor.Style.html#toggle_blink/1","title":"Raxol.Terminal.Cursor.Style.toggle_blink/1","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Style}\n    iex> cursor = Manager.new()\n    iex> cursor = Style.toggle_blink(cursor)\n    iex> cursor.state\n    :blinking\n    iex> cursor = Style.toggle_blink(cursor)\n    iex> cursor.state\n    :visible","ref":"Raxol.Terminal.Cursor.Style.html#toggle_blink/1-examples","title":"Examples - Raxol.Terminal.Cursor.Style.toggle_blink/1","type":"function"},{"doc":"Toggles the cursor visibility.","ref":"Raxol.Terminal.Cursor.Style.html#toggle_visibility/1","title":"Raxol.Terminal.Cursor.Style.toggle_visibility/1","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Style}\n    iex> cursor = Manager.new()\n    iex> cursor = Style.toggle_visibility(cursor)\n    iex> cursor.state\n    :hidden\n    iex> cursor = Style.toggle_visibility(cursor)\n    iex> cursor.state\n    :visible","ref":"Raxol.Terminal.Cursor.Style.html#toggle_visibility/1-examples","title":"Examples - Raxol.Terminal.Cursor.Style.toggle_visibility/1","type":"function"},{"doc":"Updates the cursor blink state and returns the updated cursor and visibility.","ref":"Raxol.Terminal.Cursor.Style.html#update_blink/1","title":"Raxol.Terminal.Cursor.Style.update_blink/1","type":"function"},{"doc":"iex> alias Raxol.Terminal.Cursor.{Manager, Style}\n    iex> cursor = Manager.new()\n    iex> cursor = Style.blink(cursor)\n    iex> {cursor, visible} = Style.update_blink(cursor)\n    iex> is_boolean(visible)\n    true","ref":"Raxol.Terminal.Cursor.Style.html#update_blink/1-examples","title":"Examples - Raxol.Terminal.Cursor.Style.update_blink/1","type":"function"},{"doc":"Handles device status reporting and attributes for the terminal emulator.","ref":"Raxol.Terminal.Device.Status.html","title":"Raxol.Terminal.Device.Status","type":"module"},{"doc":"Handles Device Attributes (DA) requests.","ref":"Raxol.Terminal.Device.Status.html#handle_device_attributes/3","title":"Raxol.Terminal.Device.Status.handle_device_attributes/3","type":"function"},{"doc":"Handles Device Status Report (DSR) requests.","ref":"Raxol.Terminal.Device.Status.html#handle_status_report/2","title":"Raxol.Terminal.Device.Status.handle_status_report/2","type":"function"},{"doc":"ASCII art rendering system for the Raxol terminal emulator.\n\nThis module provides functionality for:\n- Rendering ASCII art templates\n- Creating custom ASCII art\n- Animating ASCII art\n- Integrating with the terminal display system","ref":"Raxol.Terminal.Display.AsciiArt.html","title":"Raxol.Terminal.Display.AsciiArt","type":"module"},{"doc":"Returns an ASCII art box with the given text.","ref":"Raxol.Terminal.Display.AsciiArt.html#box/1","title":"Raxol.Terminal.Display.AsciiArt.box/1","type":"function"},{"doc":"Returns an ASCII art error indicator.","ref":"Raxol.Terminal.Display.AsciiArt.html#error/0","title":"Raxol.Terminal.Display.AsciiArt.error/0","type":"function"},{"doc":"Returns a stylized header with the given text.","ref":"Raxol.Terminal.Display.AsciiArt.html#header/1","title":"Raxol.Terminal.Display.AsciiArt.header/1","type":"function"},{"doc":"Returns an ASCII art help screen.","ref":"Raxol.Terminal.Display.AsciiArt.html#help/0","title":"Raxol.Terminal.Display.AsciiArt.help/0","type":"function"},{"doc":"Returns an ASCII art loading animation for the given text.","ref":"Raxol.Terminal.Display.AsciiArt.html#loading/2","title":"Raxol.Terminal.Display.AsciiArt.loading/2","type":"function"},{"doc":"Returns the ASCII art logo for the Raxol project.","ref":"Raxol.Terminal.Display.AsciiArt.html#logo/0","title":"Raxol.Terminal.Display.AsciiArt.logo/0","type":"function"},{"doc":"Returns an ASCII art progress bar with the given percentage.","ref":"Raxol.Terminal.Display.AsciiArt.html#progress_bar/1","title":"Raxol.Terminal.Display.AsciiArt.progress_bar/1","type":"function"},{"doc":"Returns an ASCII art spinner animation frame for the given step.","ref":"Raxol.Terminal.Display.AsciiArt.html#spinner/1","title":"Raxol.Terminal.Display.AsciiArt.spinner/1","type":"function"},{"doc":"Returns an ASCII art success indicator.","ref":"Raxol.Terminal.Display.AsciiArt.html#success/0","title":"Raxol.Terminal.Display.AsciiArt.success/0","type":"function"},{"doc":"Returns an ASCII art table with the given headers and rows.","ref":"Raxol.Terminal.Display.AsciiArt.html#table/2","title":"Raxol.Terminal.Display.AsciiArt.table/2","type":"function"},{"doc":"Returns an ASCII art theme preview.","ref":"Raxol.Terminal.Display.AsciiArt.html#theme_preview/0","title":"Raxol.Terminal.Display.AsciiArt.theme_preview/0","type":"function"},{"doc":"Returns an ASCII art warning indicator.","ref":"Raxol.Terminal.Display.AsciiArt.html#warning/0","title":"Raxol.Terminal.Display.AsciiArt.warning/0","type":"function"},{"doc":"Handles raw terminal input/output and event generation.\n\nResponsibilities:\n- Setting terminal mode (raw, echo)\n- Reading input events via rrex_termbox NIF v2.0.1\n- Parsing input events into `Raxol.Core.Events.Event` structs\n- Detecting terminal resize events\n- Sending parsed events to the `Dispatcher`\n- Restoring terminal state on exit","ref":"Raxol.Terminal.Driver.html","title":"Raxol.Terminal.Driver","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Driver.html#child_spec/1","title":"Raxol.Terminal.Driver.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Driver.html#t:dispatcher_pid/0","title":"Raxol.Terminal.Driver.dispatcher_pid/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Driver.html#t:original_stty/0","title":"Raxol.Terminal.Driver.original_stty/0","type":"type"},{"doc":"Processes a terminal position change event.","ref":"Raxol.Terminal.Driver.html#process_position_change/3","title":"Raxol.Terminal.Driver.process_position_change/3","type":"function"},{"doc":"Processes a terminal title change event.","ref":"Raxol.Terminal.Driver.html#process_title_change/2","title":"Raxol.Terminal.Driver.process_title_change/2","type":"function"},{"doc":"Starts the GenServer.","ref":"Raxol.Terminal.Driver.html#start_link/1","title":"Raxol.Terminal.Driver.start_link/1","type":"function"},{"doc":"Behaviour for Terminal.Driver, used for mocking.","ref":"Raxol.Terminal.Driver.Behaviour.html","title":"Raxol.Terminal.Driver.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.Driver.Behaviour.html#c:start_link/1","title":"Raxol.Terminal.Driver.Behaviour.start_link/1","type":"callback"},{"doc":"Manages the state of the terminal emulator, including screen buffer,\ncursor position, attributes, and modes.","ref":"Raxol.Terminal.Emulator.html","title":"Raxol.Terminal.Emulator","type":"module"},{"doc":"The scrollback buffer limit can be set via application config:\n\n    config :raxol, :terminal, scrollback_lines: 1000\n\nOr overridden per emulator instance by passing the `:scrollback` option to `new/3`:\n\n    Emulator.new(80, 24, scrollback: 2000)","ref":"Raxol.Terminal.Emulator.html#module-scrollback-limit-configuration","title":"Scrollback Limit Configuration - Raxol.Terminal.Emulator","type":"module"},{"doc":"See  Raxol.Terminal.Command.Manager.add_to_history/2 .","ref":"Raxol.Terminal.Emulator.html#add_to_history/2","title":"Raxol.Terminal.Emulator.add_to_history/2","type":"function"},{"doc":"See  Raxol.Terminal.ScrollbackManager.add_to_scrollback/2 .","ref":"Raxol.Terminal.Emulator.html#add_to_scrollback/2","title":"Raxol.Terminal.Emulator.add_to_scrollback/2","type":"function"},{"doc":"See  Raxol.Terminal.CharsetManager.apply_single_shift/2 .","ref":"Raxol.Terminal.Emulator.html#apply_single_shift/2","title":"Raxol.Terminal.Emulator.apply_single_shift/2","type":"function"},{"doc":"See  Raxol.Terminal.FormattingManager.attribute_set?/2 .","ref":"Raxol.Terminal.Emulator.html#attribute_set?/2","title":"Raxol.Terminal.Emulator.attribute_set?/2","type":"function"},{"doc":"See  Raxol.Core.Runtime.Plugins.Manager.call_hook/4 .","ref":"Raxol.Terminal.Emulator.html#call_plugin_hook/4","title":"Raxol.Terminal.Emulator.call_plugin_hook/4","type":"function"},{"doc":"See  Raxol.Terminal.Tab.Manager.clear_all_tab_stops/1 .","ref":"Raxol.Terminal.Emulator.html#clear_all_tab_stops/1","title":"Raxol.Terminal.Emulator.clear_all_tab_stops/1","type":"function"},{"doc":"See  Raxol.Terminal.Command.Manager.clear_history/1 .","ref":"Raxol.Terminal.Emulator.html#clear_history/1","title":"Raxol.Terminal.Emulator.clear_history/1","type":"function"},{"doc":"See  Raxol.Terminal.HyperlinkManager.clear_hyperlink_state/1 .","ref":"Raxol.Terminal.Emulator.html#clear_hyperlink_state/1","title":"Raxol.Terminal.Emulator.clear_hyperlink_state/1","type":"function"},{"doc":"See  Raxol.Terminal.OutputManager.clear_output_buffer/1 .","ref":"Raxol.Terminal.Emulator.html#clear_output_buffer/1","title":"Raxol.Terminal.Emulator.clear_output_buffer/1","type":"function"},{"doc":"See  Raxol.Terminal.State.Manager.clear_saved_states/1 .","ref":"Raxol.Terminal.Emulator.html#clear_saved_states/1","title":"Raxol.Terminal.Emulator.clear_saved_states/1","type":"function"},{"doc":"See  Raxol.Terminal.ScrollbackManager.clear_scrollback/1 .","ref":"Raxol.Terminal.Emulator.html#clear_scrollback/1","title":"Raxol.Terminal.Emulator.clear_scrollback/1","type":"function"},{"doc":"See  Raxol.Terminal.Tab.Manager.clear_tab_stop/1 .","ref":"Raxol.Terminal.Emulator.html#clear_tab_stop/1","title":"Raxol.Terminal.Emulator.clear_tab_stop/1","type":"function"},{"doc":"See  Raxol.Terminal.ColorManager.color_to_rgb/2 .","ref":"Raxol.Terminal.Emulator.html#color_to_rgb/2","title":"Raxol.Terminal.Emulator.color_to_rgb/2","type":"function"},{"doc":"See  Raxol.Terminal.HyperlinkManager.create_hyperlink/4 .","ref":"Raxol.Terminal.Emulator.html#create_hyperlink/4","title":"Raxol.Terminal.Emulator.create_hyperlink/4","type":"function"},{"doc":"","ref":"Raxol.Terminal.Emulator.html#t:cursor_style_type/0","title":"Raxol.Terminal.Emulator.cursor_style_type/0","type":"type"},{"doc":"See  Raxol.Terminal.CharsetManager.designate_charset/3 .","ref":"Raxol.Terminal.Emulator.html#designate_charset/3","title":"Raxol.Terminal.Emulator.designate_charset/3","type":"function"},{"doc":"See  Raxol.Terminal.OutputManager.enqueue_control_sequence/2 .","ref":"Raxol.Terminal.Emulator.html#enqueue_control_sequence/2","title":"Raxol.Terminal.Emulator.enqueue_control_sequence/2","type":"function"},{"doc":"See  Raxol.Terminal.OutputManager.enqueue_output/2 .","ref":"Raxol.Terminal.Emulator.html#enqueue_output/2","title":"Raxol.Terminal.Emulator.enqueue_output/2","type":"function"},{"doc":"See  Raxol.Terminal.OutputManager.flush_output/1 .","ref":"Raxol.Terminal.Emulator.html#flush_output/1","title":"Raxol.Terminal.Emulator.flush_output/1","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.EmulatorBehaviour.get_active_buffer/1 .","ref":"Raxol.Terminal.Emulator.html#get_active_buffer/1","title":"Raxol.Terminal.Emulator.get_active_buffer/1","type":"function"},{"doc":"See  Raxol.Terminal.FormattingManager.get_background/1 .","ref":"Raxol.Terminal.Emulator.html#get_background/1","title":"Raxol.Terminal.Emulator.get_background/1","type":"function"},{"doc":"See  Raxol.Terminal.ScreenManager.get_buffer_type/1 .","ref":"Raxol.Terminal.Emulator.html#get_buffer_type/1","title":"Raxol.Terminal.Emulator.get_buffer_type/1","type":"function"},{"doc":"See  Raxol.Terminal.CharsetManager.get_state/1 .","ref":"Raxol.Terminal.Emulator.html#get_charset_state/1","title":"Raxol.Terminal.Emulator.get_charset_state/1","type":"function"},{"doc":"See  Raxol.Terminal.ColorManager.get_color/2 .","ref":"Raxol.Terminal.Emulator.html#get_color/2","title":"Raxol.Terminal.Emulator.get_color/2","type":"function"},{"doc":"See  Raxol.Terminal.ColorManager.get_colors/1 .","ref":"Raxol.Terminal.Emulator.html#get_colors/1","title":"Raxol.Terminal.Emulator.get_colors/1","type":"function"},{"doc":"See  Raxol.Terminal.Command.Manager.get_command_buffer/1 .","ref":"Raxol.Terminal.Emulator.html#get_command_buffer/1","title":"Raxol.Terminal.Emulator.get_command_buffer/1","type":"function"},{"doc":"See  Raxol.Terminal.Command.Manager.get_command_history/1 .","ref":"Raxol.Terminal.Emulator.html#get_command_history/1","title":"Raxol.Terminal.Emulator.get_command_history/1","type":"function"},{"doc":"See  Raxol.Terminal.CharsetManager.get_current_g_set/1 .","ref":"Raxol.Terminal.Emulator.html#get_current_g_set/1","title":"Raxol.Terminal.Emulator.get_current_g_set/1","type":"function"},{"doc":"See  Raxol.Terminal.State.Manager.get_current_state/1 .","ref":"Raxol.Terminal.Emulator.html#get_current_state/1","title":"Raxol.Terminal.Emulator.get_current_state/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Emulator.html#get_cursor_blink/1","title":"Raxol.Terminal.Emulator.get_cursor_blink/1","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.EmulatorBehaviour.get_cursor_position/1 .","ref":"Raxol.Terminal.Emulator.html#get_cursor_position/1","title":"Raxol.Terminal.Emulator.get_cursor_position/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Emulator.html#get_cursor_style/1","title":"Raxol.Terminal.Emulator.get_cursor_style/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Emulator.html#get_cursor_visibility/1","title":"Raxol.Terminal.Emulator.get_cursor_visibility/1","type":"function"},{"doc":"See  Raxol.Terminal.CharsetManager.get_designated_charset/2 .","ref":"Raxol.Terminal.Emulator.html#get_designated_charset/2","title":"Raxol.Terminal.Emulator.get_designated_charset/2","type":"function"},{"doc":"See  Raxol.Terminal.FormattingManager.get_foreground/1 .","ref":"Raxol.Terminal.Emulator.html#get_foreground/1","title":"Raxol.Terminal.Emulator.get_foreground/1","type":"function"},{"doc":"See  Raxol.Terminal.Command.Manager.get_history_command/2 .","ref":"Raxol.Terminal.Emulator.html#get_history_command/2","title":"Raxol.Terminal.Emulator.get_history_command/2","type":"function"},{"doc":"See  Raxol.Terminal.HyperlinkManager.get_hyperlink_state/1 .","ref":"Raxol.Terminal.Emulator.html#get_hyperlink_state/1","title":"Raxol.Terminal.Emulator.get_hyperlink_state/1","type":"function"},{"doc":"See  Raxol.Terminal.HyperlinkManager.get_hyperlink_url/1 .","ref":"Raxol.Terminal.Emulator.html#get_hyperlink_url/1","title":"Raxol.Terminal.Emulator.get_hyperlink_url/1","type":"function"},{"doc":"See  Raxol.Terminal.State.Manager.get_last_col_exceeded/1 .","ref":"Raxol.Terminal.Emulator.html#get_last_col_exceeded/1","title":"Raxol.Terminal.Emulator.get_last_col_exceeded/1","type":"function"},{"doc":"See  Raxol.Terminal.Command.Manager.get_last_key_event/1 .","ref":"Raxol.Terminal.Emulator.html#get_last_key_event/1","title":"Raxol.Terminal.Emulator.get_last_key_event/1","type":"function"},{"doc":"See  Raxol.Core.Runtime.Plugins.Manager.get_loaded_plugins/1 .","ref":"Raxol.Terminal.Emulator.html#get_loaded_plugins/1","title":"Raxol.Terminal.Emulator.get_loaded_plugins/1","type":"function"},{"doc":"See  ModeManager.get_manager/1 .","ref":"Raxol.Terminal.Emulator.html#get_mode_manager/1","title":"Raxol.Terminal.Emulator.get_mode_manager/1","type":"function"},{"doc":"See  Raxol.Terminal.Tab.Manager.get_next_tab_stop/1 .","ref":"Raxol.Terminal.Emulator.html#get_next_tab_stop/1","title":"Raxol.Terminal.Emulator.get_next_tab_stop/1","type":"function"},{"doc":"See  Raxol.Terminal.OutputManager.get_output_buffer/1 .","ref":"Raxol.Terminal.Emulator.html#get_output_buffer/1","title":"Raxol.Terminal.Emulator.get_output_buffer/1","type":"function"},{"doc":"See  Raxol.Terminal.Parser.StateManager.get_state/1 .","ref":"Raxol.Terminal.Emulator.html#get_parser_state/1","title":"Raxol.Terminal.Emulator.get_parser_state/1","type":"function"},{"doc":"See  Raxol.Terminal.Parser.StateManager.get_state_name/1 .","ref":"Raxol.Terminal.Emulator.html#get_parser_state_name/1","title":"Raxol.Terminal.Emulator.get_parser_state_name/1","type":"function"},{"doc":"See  Raxol.Core.Runtime.Plugins.Manager.get_plugin_config/2 .","ref":"Raxol.Terminal.Emulator.html#get_plugin_config/2","title":"Raxol.Terminal.Emulator.get_plugin_config/2","type":"function"},{"doc":"See  Raxol.Core.Runtime.Plugins.Manager.get_manager/1 .","ref":"Raxol.Terminal.Emulator.html#get_plugin_manager/1","title":"Raxol.Terminal.Emulator.get_plugin_manager/1","type":"function"},{"doc":"See  Raxol.Terminal.State.Manager.get_saved_states_count/1 .","ref":"Raxol.Terminal.Emulator.html#get_saved_states_count/1","title":"Raxol.Terminal.Emulator.get_saved_states_count/1","type":"function"},{"doc":"See  Raxol.Terminal.State.Manager.get_scroll_region/1 .","ref":"Raxol.Terminal.Emulator.html#get_scroll_region/1","title":"Raxol.Terminal.Emulator.get_scroll_region/1","type":"function"},{"doc":"See  Raxol.Terminal.ScrollbackManager.get_scrollback_buffer/1 .","ref":"Raxol.Terminal.Emulator.html#get_scrollback_buffer/1","title":"Raxol.Terminal.Emulator.get_scrollback_buffer/1","type":"function"},{"doc":"See  Raxol.Terminal.ScrollbackManager.get_scrollback_limit/1 .","ref":"Raxol.Terminal.Emulator.html#get_scrollback_limit/1","title":"Raxol.Terminal.Emulator.get_scrollback_limit/1","type":"function"},{"doc":"See  Raxol.Terminal.ScrollbackManager.get_scrollback_range/3 .","ref":"Raxol.Terminal.Emulator.html#get_scrollback_range/3","title":"Raxol.Terminal.Emulator.get_scrollback_range/3","type":"function"},{"doc":"See  Raxol.Terminal.ScrollbackManager.get_scrollback_size/1 .","ref":"Raxol.Terminal.Emulator.html#get_scrollback_size/1","title":"Raxol.Terminal.Emulator.get_scrollback_size/1","type":"function"},{"doc":"See  Raxol.Terminal.FormattingManager.get_set_attributes/1 .","ref":"Raxol.Terminal.Emulator.html#get_set_attributes/1","title":"Raxol.Terminal.Emulator.get_set_attributes/1","type":"function"},{"doc":"See  ModeManager.get_set_modes/1 .","ref":"Raxol.Terminal.Emulator.html#get_set_modes/1","title":"Raxol.Terminal.Emulator.get_set_modes/1","type":"function"},{"doc":"See  Raxol.Terminal.CharsetManager.get_single_shift/1 .","ref":"Raxol.Terminal.Emulator.html#get_single_shift/1","title":"Raxol.Terminal.Emulator.get_single_shift/1","type":"function"},{"doc":"See  Raxol.Terminal.State.Manager.get_state_stack/1 .","ref":"Raxol.Terminal.Emulator.html#get_state_stack/1","title":"Raxol.Terminal.Emulator.get_state_stack/1","type":"function"},{"doc":"See  Raxol.Terminal.FormattingManager.get_style/1 .","ref":"Raxol.Terminal.Emulator.html#get_style/1","title":"Raxol.Terminal.Emulator.get_style/1","type":"function"},{"doc":"See  Raxol.Terminal.WindowManager.get_window_state/1 .","ref":"Raxol.Terminal.Emulator.html#get_window_state/1","title":"Raxol.Terminal.Emulator.get_window_state/1","type":"function"},{"doc":"See  Raxol.Terminal.State.Manager.has_saved_states?/1 .","ref":"Raxol.Terminal.Emulator.html#has_saved_states?/1","title":"Raxol.Terminal.Emulator.has_saved_states?/1","type":"function"},{"doc":"See  Raxol.Terminal.Parser.StateManager.in_control_sequence_state?/1 .","ref":"Raxol.Terminal.Emulator.html#in_control_sequence_state?/1","title":"Raxol.Terminal.Emulator.in_control_sequence_state?/1","type":"function"},{"doc":"See  Raxol.Terminal.Parser.StateManager.in_escape_state?/1 .","ref":"Raxol.Terminal.Emulator.html#in_escape_state?/1","title":"Raxol.Terminal.Emulator.in_escape_state?/1","type":"function"},{"doc":"See  Raxol.Terminal.Parser.StateManager.in_ground_state?/1 .","ref":"Raxol.Terminal.Emulator.html#in_ground_state?/1","title":"Raxol.Terminal.Emulator.in_ground_state?/1","type":"function"},{"doc":"See  Raxol.Terminal.Buffer.Operations.index/1 .","ref":"Raxol.Terminal.Emulator.html#index/1","title":"Raxol.Terminal.Emulator.index/1","type":"function"},{"doc":"See  Raxol.Terminal.ScreenManager.initialize_buffers/3 .","ref":"Raxol.Terminal.Emulator.html#initialize_buffers/3","title":"Raxol.Terminal.Emulator.initialize_buffers/3","type":"function"},{"doc":"See  Raxol.Core.Runtime.Plugins.Manager.initialize_plugin/3 .","ref":"Raxol.Terminal.Emulator.html#initialize_plugin/3","title":"Raxol.Terminal.Emulator.initialize_plugin/3","type":"function"},{"doc":"See  Raxol.Terminal.CharsetManager.invoke_g_set/2 .","ref":"Raxol.Terminal.Emulator.html#invoke_g_set/2","title":"Raxol.Terminal.Emulator.invoke_g_set/2","type":"function"},{"doc":"See  Raxol.Terminal.Buffer.Operations.maybe_scroll/1 .","ref":"Raxol.Terminal.Emulator.html#maybe_scroll/1","title":"Raxol.Terminal.Emulator.maybe_scroll/1","type":"function"},{"doc":"See  ModeManager.mode_set?/2 .","ref":"Raxol.Terminal.Emulator.html#mode_set?/2","title":"Raxol.Terminal.Emulator.mode_set?/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Emulator.html#move_cursor/3","title":"Raxol.Terminal.Emulator.move_cursor/3","type":"function"},{"doc":"See  Raxol.Terminal.Cursor.Manager.move_down/4 .","ref":"Raxol.Terminal.Emulator.html#move_cursor_down/4","title":"Raxol.Terminal.Emulator.move_cursor_down/4","type":"function"},{"doc":"See  Raxol.Terminal.Cursor.Manager.move_left/4 .","ref":"Raxol.Terminal.Emulator.html#move_cursor_left/4","title":"Raxol.Terminal.Emulator.move_cursor_left/4","type":"function"},{"doc":"See  Raxol.Terminal.Cursor.Manager.move_right/4 .","ref":"Raxol.Terminal.Emulator.html#move_cursor_right/4","title":"Raxol.Terminal.Emulator.move_cursor_right/4","type":"function"},{"doc":"See  Raxol.Terminal.Cursor.Manager.move_to/4 .","ref":"Raxol.Terminal.Emulator.html#move_cursor_to/4","title":"Raxol.Terminal.Emulator.move_cursor_to/4","type":"function"},{"doc":"See  Raxol.Terminal.Cursor.Manager.move_to/4 .","ref":"Raxol.Terminal.Emulator.html#move_cursor_to_column/4","title":"Raxol.Terminal.Emulator.move_cursor_to_column/4","type":"function"},{"doc":"See  Raxol.Terminal.Cursor.Manager.move_to_line_start/1 .","ref":"Raxol.Terminal.Emulator.html#move_cursor_to_line_start/1","title":"Raxol.Terminal.Emulator.move_cursor_to_line_start/1","type":"function"},{"doc":"See  Raxol.Terminal.Cursor.Manager.move_up/4 .","ref":"Raxol.Terminal.Emulator.html#move_cursor_up/4","title":"Raxol.Terminal.Emulator.move_cursor_up/4","type":"function"},{"doc":"Creates a new terminal emulator instance.\n\nCan be called with:\n- `new(opts_map)` where `opts_map` is a map containing `:width`, `:height`, and other options.\n- `new(width, height, opts_keyword_list)`\n- `new(width, height, session_id, client_options)` (delegates to the keyword list version)","ref":"Raxol.Terminal.Emulator.html#new/0","title":"Raxol.Terminal.Emulator.new/0","type":"function"},{"doc":"* `:width` - Terminal width (default: 80)\n  * `:height` - Terminal height (default: 24)\n  * `:scrollback` - Maximum number of scrollback lines (default: from config or 1000)\n  * `:memorylimit` - Memory limit (default: 1_000_000)\n  * `:max_command_history` - Max command history (default: 100)\n  * `:plugin_manager` - A pre-initialized `Raxol.Plugins.Manager.Core` struct.\n  * `:session_id` - A session identifier string.\n  * `:client_options` - A map of client-specific options.","ref":"Raxol.Terminal.Emulator.html#new/0-options-keyword-list-or-map","title":"Options (Keyword list or Map) - Raxol.Terminal.Emulator.new/0","type":"function"},{"doc":"See  Raxol.Terminal.Buffer.Operations.next_line/1 .","ref":"Raxol.Terminal.Emulator.html#next_line/1","title":"Raxol.Terminal.Emulator.next_line/1","type":"function"},{"doc":"See  Raxol.Core.Runtime.Plugins.Manager.plugin_loaded?/2 .","ref":"Raxol.Terminal.Emulator.html#plugin_loaded?/2","title":"Raxol.Terminal.Emulator.plugin_loaded?/2","type":"function"},{"doc":"Processes input from the user, handling both regular characters and escape sequences.\nDelegates to Raxol.Terminal.InputHandler.process_terminal_input/2.","ref":"Raxol.Terminal.Emulator.html#process_input/2","title":"Raxol.Terminal.Emulator.process_input/2","type":"function"},{"doc":"See  Raxol.Terminal.Command.Manager.process_key_event/2 .","ref":"Raxol.Terminal.Emulator.html#process_key_event/2","title":"Raxol.Terminal.Emulator.process_key_event/2","type":"function"},{"doc":"See  Raxol.Terminal.FormattingManager.reset_all_attributes/1 .","ref":"Raxol.Terminal.Emulator.html#reset_all_attributes/1","title":"Raxol.Terminal.Emulator.reset_all_attributes/1","type":"function"},{"doc":"See  ModeManager.reset_all_modes/1 .","ref":"Raxol.Terminal.Emulator.html#reset_all_modes/1","title":"Raxol.Terminal.Emulator.reset_all_modes/1","type":"function"},{"doc":"See  Raxol.Terminal.FormattingManager.reset_attribute/2 .","ref":"Raxol.Terminal.Emulator.html#reset_attribute/2","title":"Raxol.Terminal.Emulator.reset_attribute/2","type":"function"},{"doc":"See  Raxol.Terminal.CharsetManager.reset_state/1 .","ref":"Raxol.Terminal.Emulator.html#reset_charset_state/1","title":"Raxol.Terminal.Emulator.reset_charset_state/1","type":"function"},{"doc":"See  Raxol.Terminal.ColorManager.reset_colors/1 .","ref":"Raxol.Terminal.Emulator.html#reset_colors/1","title":"Raxol.Terminal.Emulator.reset_colors/1","type":"function"},{"doc":"See  ModeManager.reset_mode/2 .","ref":"Raxol.Terminal.Emulator.html#reset_mode/2","title":"Raxol.Terminal.Emulator.reset_mode/2","type":"function"},{"doc":"See  Raxol.Terminal.Parser.StateManager.reset_to_ground/1 .","ref":"Raxol.Terminal.Emulator.html#reset_parser_to_ground/1","title":"Raxol.Terminal.Emulator.reset_parser_to_ground/1","type":"function"},{"doc":"See  Raxol.Terminal.State.Manager.reset_to_initial_state/1 .","ref":"Raxol.Terminal.Emulator.html#reset_to_initial_state/1","title":"Raxol.Terminal.Emulator.reset_to_initial_state/1","type":"function"},{"doc":"Resizes the emulator's screen buffers.","ref":"Raxol.Terminal.Emulator.html#resize/3","title":"Raxol.Terminal.Emulator.resize/3","type":"function"},{"doc":"* `emulator` - The emulator to resize\n* `new_width` - New width in columns\n* `new_height` - New height in rows","ref":"Raxol.Terminal.Emulator.html#resize/3-parameters","title":"Parameters - Raxol.Terminal.Emulator.resize/3","type":"function"},{"doc":"Updated emulator with resized buffers","ref":"Raxol.Terminal.Emulator.html#resize/3-returns","title":"Returns - Raxol.Terminal.Emulator.resize/3","type":"function"},{"doc":"See  Raxol.Terminal.ScreenManager.resize_buffers/3 .","ref":"Raxol.Terminal.Emulator.html#resize_buffers/3","title":"Raxol.Terminal.Emulator.resize_buffers/3","type":"function"},{"doc":"See  ModeManager.restore_modes/1 .","ref":"Raxol.Terminal.Emulator.html#restore_modes/1","title":"Raxol.Terminal.Emulator.restore_modes/1","type":"function"},{"doc":"See  Raxol.Terminal.State.Manager.restore_state/1 .","ref":"Raxol.Terminal.Emulator.html#restore_state/1","title":"Raxol.Terminal.Emulator.restore_state/1","type":"function"},{"doc":"See  Raxol.Terminal.WindowManager.restore_window_size/1 .","ref":"Raxol.Terminal.Emulator.html#restore_window_size/1","title":"Raxol.Terminal.Emulator.restore_window_size/1","type":"function"},{"doc":"See  Raxol.Terminal.Buffer.Operations.reverse_index/1 .","ref":"Raxol.Terminal.Emulator.html#reverse_index/1","title":"Raxol.Terminal.Emulator.reverse_index/1","type":"function"},{"doc":"See  ModeManager.save_modes/1 .","ref":"Raxol.Terminal.Emulator.html#save_modes/1","title":"Raxol.Terminal.Emulator.save_modes/1","type":"function"},{"doc":"See  Raxol.Terminal.State.Manager.save_state/1 .","ref":"Raxol.Terminal.Emulator.html#save_state/1","title":"Raxol.Terminal.Emulator.save_state/1","type":"function"},{"doc":"See  Raxol.Terminal.WindowManager.save_window_size/1 .","ref":"Raxol.Terminal.Emulator.html#save_window_size/1","title":"Raxol.Terminal.Emulator.save_window_size/1","type":"function"},{"doc":"See  Raxol.Terminal.ScrollbackManager.scrollback_empty?/1 .","ref":"Raxol.Terminal.Emulator.html#scrollback_empty?/1","title":"Raxol.Terminal.Emulator.scrollback_empty?/1","type":"function"},{"doc":"See  Raxol.Terminal.Command.Manager.search_history/2 .","ref":"Raxol.Terminal.Emulator.html#search_history/2","title":"Raxol.Terminal.Emulator.search_history/2","type":"function"},{"doc":"See  Raxol.Terminal.FormattingManager.set_attribute/2 .","ref":"Raxol.Terminal.Emulator.html#set_attribute/2","title":"Raxol.Terminal.Emulator.set_attribute/2","type":"function"},{"doc":"See  Raxol.Terminal.FormattingManager.set_background/2 .","ref":"Raxol.Terminal.Emulator.html#set_background/2","title":"Raxol.Terminal.Emulator.set_background/2","type":"function"},{"doc":"See  Raxol.Terminal.ScreenManager.set_buffer_type/2 .","ref":"Raxol.Terminal.Emulator.html#set_buffer_type/2","title":"Raxol.Terminal.Emulator.set_buffer_type/2","type":"function"},{"doc":"Sets the character set for the specified G-set.\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.html#set_charset/2","title":"Raxol.Terminal.Emulator.set_charset/2","type":"function"},{"doc":"See  Raxol.Terminal.ColorManager.set_color/3 .","ref":"Raxol.Terminal.Emulator.html#set_color/3","title":"Raxol.Terminal.Emulator.set_color/3","type":"function"},{"doc":"See  Raxol.Terminal.ColorManager.set_colors/2 .","ref":"Raxol.Terminal.Emulator.html#set_colors/2","title":"Raxol.Terminal.Emulator.set_colors/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Emulator.html#set_cursor_blink/2","title":"Raxol.Terminal.Emulator.set_cursor_blink/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Emulator.html#set_cursor_position/2","title":"Raxol.Terminal.Emulator.set_cursor_position/2","type":"function"},{"doc":"See  Raxol.Terminal.Cursor.Manager.move_to/4 .","ref":"Raxol.Terminal.Emulator.html#set_cursor_position/4","title":"Raxol.Terminal.Emulator.set_cursor_position/4","type":"function"},{"doc":"","ref":"Raxol.Terminal.Emulator.html#set_cursor_style/2","title":"Raxol.Terminal.Emulator.set_cursor_style/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Emulator.html#set_cursor_visibility/2","title":"Raxol.Terminal.Emulator.set_cursor_visibility/2","type":"function"},{"doc":"See  Raxol.Terminal.FormattingManager.set_foreground/2 .","ref":"Raxol.Terminal.Emulator.html#set_foreground/2","title":"Raxol.Terminal.Emulator.set_foreground/2","type":"function"},{"doc":"See  Raxol.Terminal.Tab.Manager.set_horizontal_tab/1 .","ref":"Raxol.Terminal.Emulator.html#set_horizontal_tab/1","title":"Raxol.Terminal.Emulator.set_horizontal_tab/1","type":"function"},{"doc":"See  Raxol.Terminal.WindowManager.set_icon_name/2 .","ref":"Raxol.Terminal.Emulator.html#set_icon_name/2","title":"Raxol.Terminal.Emulator.set_icon_name/2","type":"function"},{"doc":"See  ModeManager.set_mode/2 .","ref":"Raxol.Terminal.Emulator.html#set_mode/2","title":"Raxol.Terminal.Emulator.set_mode/2","type":"function"},{"doc":"See  Raxol.Terminal.Parser.StateManager.set_state_name/2 .","ref":"Raxol.Terminal.Emulator.html#set_parser_state_name/2","title":"Raxol.Terminal.Emulator.set_parser_state_name/2","type":"function"},{"doc":"See  Raxol.Terminal.ScrollbackManager.set_scrollback_limit/2 .","ref":"Raxol.Terminal.Emulator.html#set_scrollback_limit/2","title":"Raxol.Terminal.Emulator.set_scrollback_limit/2","type":"function"},{"doc":"See  Raxol.Terminal.WindowManager.set_stacking_order/2 .","ref":"Raxol.Terminal.Emulator.html#set_stacking_order/2","title":"Raxol.Terminal.Emulator.set_stacking_order/2","type":"function"},{"doc":"See  Raxol.Terminal.WindowManager.set_window_position/3 .","ref":"Raxol.Terminal.Emulator.html#set_window_position/3","title":"Raxol.Terminal.Emulator.set_window_position/3","type":"function"},{"doc":"See  Raxol.Terminal.WindowManager.set_window_size/3 .","ref":"Raxol.Terminal.Emulator.html#set_window_size/3","title":"Raxol.Terminal.Emulator.set_window_size/3","type":"function"},{"doc":"See  Raxol.Terminal.WindowManager.set_window_title/2 .","ref":"Raxol.Terminal.Emulator.html#set_window_title/2","title":"Raxol.Terminal.Emulator.set_window_title/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Emulator.html#start_link/1","title":"Raxol.Terminal.Emulator.start_link/1","type":"function"},{"doc":"See  Raxol.Terminal.ScreenManager.switch_buffer/1 .","ref":"Raxol.Terminal.Emulator.html#switch_buffer/1","title":"Raxol.Terminal.Emulator.switch_buffer/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Emulator.html#t:t/0","title":"Raxol.Terminal.Emulator.t/0","type":"type"},{"doc":"See  Raxol.Core.Runtime.Plugins.Manager.unload_plugin/2 .","ref":"Raxol.Terminal.Emulator.html#unload_plugin/2","title":"Raxol.Terminal.Emulator.unload_plugin/2","type":"function"},{"doc":"Updates the currently active screen buffer.","ref":"Raxol.Terminal.Emulator.html#update_active_buffer/2","title":"Raxol.Terminal.Emulator.update_active_buffer/2","type":"function"},{"doc":"See  Raxol.Terminal.CharsetManager.update_state/2 .","ref":"Raxol.Terminal.Emulator.html#update_charset_state/2","title":"Raxol.Terminal.Emulator.update_charset_state/2","type":"function"},{"doc":"See  Raxol.Terminal.Command.Manager.update_command_buffer/2 .","ref":"Raxol.Terminal.Emulator.html#update_command_buffer/2","title":"Raxol.Terminal.Emulator.update_command_buffer/2","type":"function"},{"doc":"See  Raxol.Terminal.State.Manager.update_current_state/2 .","ref":"Raxol.Terminal.Emulator.html#update_current_state/2","title":"Raxol.Terminal.Emulator.update_current_state/2","type":"function"},{"doc":"See  Raxol.Terminal.HyperlinkManager.update_hyperlink_state/2 .","ref":"Raxol.Terminal.Emulator.html#update_hyperlink_state/2","title":"Raxol.Terminal.Emulator.update_hyperlink_state/2","type":"function"},{"doc":"See  Raxol.Terminal.HyperlinkManager.update_hyperlink_url/2 .","ref":"Raxol.Terminal.Emulator.html#update_hyperlink_url/2","title":"Raxol.Terminal.Emulator.update_hyperlink_url/2","type":"function"},{"doc":"See  Raxol.Terminal.State.Manager.update_last_col_exceeded/2 .","ref":"Raxol.Terminal.Emulator.html#update_last_col_exceeded/2","title":"Raxol.Terminal.Emulator.update_last_col_exceeded/2","type":"function"},{"doc":"See  Raxol.Terminal.Command.Manager.update_last_key_event/2 .","ref":"Raxol.Terminal.Emulator.html#update_last_key_event/2","title":"Raxol.Terminal.Emulator.update_last_key_event/2","type":"function"},{"doc":"See  ModeManager.update_manager/2 .","ref":"Raxol.Terminal.Emulator.html#update_mode_manager/2","title":"Raxol.Terminal.Emulator.update_mode_manager/2","type":"function"},{"doc":"See  Raxol.Terminal.Parser.StateManager.update_state/2 .","ref":"Raxol.Terminal.Emulator.html#update_parser_state/2","title":"Raxol.Terminal.Emulator.update_parser_state/2","type":"function"},{"doc":"See  Raxol.Core.Runtime.Plugins.Manager.update_plugin_config/3 .","ref":"Raxol.Terminal.Emulator.html#update_plugin_config/3","title":"Raxol.Terminal.Emulator.update_plugin_config/3","type":"function"},{"doc":"See  Raxol.Core.Runtime.Plugins.Manager.update_manager/2 .","ref":"Raxol.Terminal.Emulator.html#update_plugin_manager/2","title":"Raxol.Terminal.Emulator.update_plugin_manager/2","type":"function"},{"doc":"See  Raxol.Terminal.State.Manager.update_scroll_region/2 .","ref":"Raxol.Terminal.Emulator.html#update_scroll_region/2","title":"Raxol.Terminal.Emulator.update_scroll_region/2","type":"function"},{"doc":"See  Raxol.Terminal.State.Manager.update_state_stack/2 .","ref":"Raxol.Terminal.Emulator.html#update_state_stack/2","title":"Raxol.Terminal.Emulator.update_state_stack/2","type":"function"},{"doc":"See  Raxol.Terminal.FormattingManager.update_style/2 .","ref":"Raxol.Terminal.Emulator.html#update_style/2","title":"Raxol.Terminal.Emulator.update_style/2","type":"function"},{"doc":"Writes data to the terminal output.","ref":"Raxol.Terminal.Emulator.html#write/2","title":"Raxol.Terminal.Emulator.write/2","type":"function"},{"doc":"Writes output to the terminal.","ref":"Raxol.Terminal.Emulator.html#write_to_output/2","title":"Raxol.Terminal.Emulator.write_to_output/2","type":"function"},{"doc":"Provides buffer management functionality for the terminal emulator.","ref":"Raxol.Terminal.Emulator.Buffer.html","title":"Raxol.Terminal.Emulator.Buffer","type":"module"},{"doc":"Clears the entire buffer.","ref":"Raxol.Terminal.Emulator.Buffer.html#clear_buffer/1","title":"Raxol.Terminal.Emulator.Buffer.clear_buffer/1","type":"function"},{"doc":"Clears from cursor to end of screen.","ref":"Raxol.Terminal.Emulator.Buffer.html#clear_from_cursor_to_end/1","title":"Raxol.Terminal.Emulator.Buffer.clear_from_cursor_to_end/1","type":"function"},{"doc":"Clears from start of screen to cursor.","ref":"Raxol.Terminal.Emulator.Buffer.html#clear_from_cursor_to_start/1","title":"Raxol.Terminal.Emulator.Buffer.clear_from_cursor_to_start/1","type":"function"},{"doc":"Clears the current line.","ref":"Raxol.Terminal.Emulator.Buffer.html#clear_line/1","title":"Raxol.Terminal.Emulator.Buffer.clear_line/1","type":"function"},{"doc":"Clears the scroll region, allowing scrolling of the entire screen.\nReturns {:ok, updated_emulator}.","ref":"Raxol.Terminal.Emulator.Buffer.html#clear_scroll_region/1","title":"Raxol.Terminal.Emulator.Buffer.clear_scroll_region/1","type":"function"},{"doc":"Scrolls the buffer down by the specified number of lines.","ref":"Raxol.Terminal.Emulator.Buffer.html#scroll_down/2","title":"Raxol.Terminal.Emulator.Buffer.scroll_down/2","type":"function"},{"doc":"Scrolls the buffer up by the specified number of lines.","ref":"Raxol.Terminal.Emulator.Buffer.html#scroll_up_emulator/2","title":"Raxol.Terminal.Emulator.Buffer.scroll_up_emulator/2","type":"function"},{"doc":"Sets the scroll region for the active buffer.\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.Buffer.html#set_scroll_region/3","title":"Raxol.Terminal.Emulator.Buffer.set_scroll_region/3","type":"function"},{"doc":"Switches between main and alternate screen buffers.\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.Buffer.html#switch_buffer/2","title":"Raxol.Terminal.Emulator.Buffer.switch_buffer/2","type":"function"},{"doc":"Handles cursor operations for the terminal emulator.","ref":"Raxol.Terminal.Emulator.Cursor.html","title":"Raxol.Terminal.Emulator.Cursor","type":"module"},{"doc":"Hides the cursor.","ref":"Raxol.Terminal.Emulator.Cursor.html#hide/1","title":"Raxol.Terminal.Emulator.Cursor.hide/1","type":"function"},{"doc":"Moves the cursor down by the specified number of lines.","ref":"Raxol.Terminal.Emulator.Cursor.html#move_down/2","title":"Raxol.Terminal.Emulator.Cursor.move_down/2","type":"function"},{"doc":"Moves the cursor left by the specified number of columns.","ref":"Raxol.Terminal.Emulator.Cursor.html#move_left/2","title":"Raxol.Terminal.Emulator.Cursor.move_left/2","type":"function"},{"doc":"Moves the cursor right by the specified number of columns.","ref":"Raxol.Terminal.Emulator.Cursor.html#move_right/2","title":"Raxol.Terminal.Emulator.Cursor.move_right/2","type":"function"},{"doc":"Moves the cursor to a specific position.","ref":"Raxol.Terminal.Emulator.Cursor.html#move_to/3","title":"Raxol.Terminal.Emulator.Cursor.move_to/3","type":"function"},{"doc":"Moves the cursor up by the specified number of lines.","ref":"Raxol.Terminal.Emulator.Cursor.html#move_up/2","title":"Raxol.Terminal.Emulator.Cursor.move_up/2","type":"function"},{"doc":"Restores the previously saved cursor state.","ref":"Raxol.Terminal.Emulator.Cursor.html#restore_state/1","title":"Raxol.Terminal.Emulator.Cursor.restore_state/1","type":"function"},{"doc":"Saves the current cursor state.","ref":"Raxol.Terminal.Emulator.Cursor.html#save_state/1","title":"Raxol.Terminal.Emulator.Cursor.save_state/1","type":"function"},{"doc":"Sets the cursor style for the emulator.","ref":"Raxol.Terminal.Emulator.Cursor.html#set_style/2","title":"Raxol.Terminal.Emulator.Cursor.set_style/2","type":"function"},{"doc":"Shows the cursor.","ref":"Raxol.Terminal.Emulator.Cursor.html#show/1","title":"Raxol.Terminal.Emulator.Cursor.show/1","type":"function"},{"doc":"Handles input processing for the terminal emulator.\nProvides functions for key event handling, command history, and input parsing.","ref":"Raxol.Terminal.Emulator.Input.html","title":"Raxol.Terminal.Emulator.Input","type":"module"},{"doc":"Updates the command history with a new command.\nReturns {:ok, updated_emulator}.","ref":"Raxol.Terminal.Emulator.Input.html#add_to_history/2","title":"Raxol.Terminal.Emulator.Input.add_to_history/2","type":"function"},{"doc":"Clears the command buffer.\nReturns {:ok, updated_emulator}.","ref":"Raxol.Terminal.Emulator.Input.html#clear_command_buffer/1","title":"Raxol.Terminal.Emulator.Input.clear_command_buffer/1","type":"function"},{"doc":"Clears the command history.\nReturns {:ok, updated_emulator}.","ref":"Raxol.Terminal.Emulator.Input.html#clear_history/1","title":"Raxol.Terminal.Emulator.Input.clear_history/1","type":"function"},{"doc":"Gets the current command buffer.\nReturns the current command buffer.","ref":"Raxol.Terminal.Emulator.Input.html#get_command_buffer/1","title":"Raxol.Terminal.Emulator.Input.get_command_buffer/1","type":"function"},{"doc":"Gets the command history.\nReturns the list of commands in history.","ref":"Raxol.Terminal.Emulator.Input.html#get_history/1","title":"Raxol.Terminal.Emulator.Input.get_history/1","type":"function"},{"doc":"Creates a new input handler.","ref":"Raxol.Terminal.Emulator.Input.html#new/0","title":"Raxol.Terminal.Emulator.Input.new/0","type":"function"},{"doc":"Processes a key event through the emulator.\nReturns {:ok, updated_emulator, commands} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.Input.html#process_key_event/2","title":"Raxol.Terminal.Emulator.Input.process_key_event/2","type":"function"},{"doc":"Processes a key press event.\nReturns {:ok, updated_emulator, commands} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.Input.html#process_key_press/3","title":"Raxol.Terminal.Emulator.Input.process_key_press/3","type":"function"},{"doc":"Processes a key release event.\nReturns {:ok, updated_emulator, commands} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.Input.html#process_key_release/3","title":"Raxol.Terminal.Emulator.Input.process_key_release/3","type":"function"},{"doc":"Processes a mouse event.\nReturns {:ok, updated_emulator, commands} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.Input.html#process_mouse_event/2","title":"Raxol.Terminal.Emulator.Input.process_mouse_event/2","type":"function"},{"doc":"Sets the command buffer.\nReturns {:ok, updated_emulator}.","ref":"Raxol.Terminal.Emulator.Input.html#set_command_buffer/2","title":"Raxol.Terminal.Emulator.Input.set_command_buffer/2","type":"function"},{"doc":"Handles output processing for the terminal emulator.\nProvides functions for output buffering, processing, and formatting.","ref":"Raxol.Terminal.Emulator.Output.html","title":"Raxol.Terminal.Emulator.Output","type":"module"},{"doc":"Clears the output buffer.","ref":"Raxol.Terminal.Emulator.Output.html#clear_output_buffer/1","title":"Raxol.Terminal.Emulator.Output.clear_output_buffer/1","type":"function"},{"doc":"Gets the current output buffer content.","ref":"Raxol.Terminal.Emulator.Output.html#get_output_buffer/1","title":"Raxol.Terminal.Emulator.Output.get_output_buffer/1","type":"function"},{"doc":"Processes the output buffer and updates the emulator state.","ref":"Raxol.Terminal.Emulator.Output.html#process_buffer/1","title":"Raxol.Terminal.Emulator.Output.process_buffer/1","type":"function"},{"doc":"Processes output data and updates the emulator state.","ref":"Raxol.Terminal.Emulator.Output.html#process_output/2","title":"Raxol.Terminal.Emulator.Output.process_output/2","type":"function"},{"doc":"Writes data to the output buffer.","ref":"Raxol.Terminal.Emulator.Output.html#write/2","title":"Raxol.Terminal.Emulator.Output.write/2","type":"function"},{"doc":"Writes a control character to the output buffer.\nReturns {:ok, updated_emulator}.","ref":"Raxol.Terminal.Emulator.Output.html#write_control/2","title":"Raxol.Terminal.Emulator.Output.write_control/2","type":"function"},{"doc":"Writes an escape sequence to the output buffer.\nReturns {:ok, updated_emulator}.","ref":"Raxol.Terminal.Emulator.Output.html#write_escape/2","title":"Raxol.Terminal.Emulator.Output.write_escape/2","type":"function"},{"doc":"Writes a line to the output buffer.\nReturns {:ok, updated_emulator}.","ref":"Raxol.Terminal.Emulator.Output.html#write_line/2","title":"Raxol.Terminal.Emulator.Output.write_line/2","type":"function"},{"doc":"Handles state management for the terminal emulator.\nProvides functions for managing terminal state, modes, and character sets.","ref":"Raxol.Terminal.Emulator.State.html","title":"Raxol.Terminal.Emulator.State","type":"module"},{"doc":"Gets the current character set state.\nReturns the current charset state.","ref":"Raxol.Terminal.Emulator.State.html#get_charset_state/1","title":"Raxol.Terminal.Emulator.State.get_charset_state/1","type":"function"},{"doc":"Gets the current state from the state stack.\nReturns the current state or nil if stack is empty.","ref":"Raxol.Terminal.Emulator.State.html#get_current_state/1","title":"Raxol.Terminal.Emulator.State.get_current_state/1","type":"function"},{"doc":"Gets the current hyperlink URL.\nReturns the current hyperlink URL or nil.","ref":"Raxol.Terminal.Emulator.State.html#get_hyperlink_url/1","title":"Raxol.Terminal.Emulator.State.get_hyperlink_url/1","type":"function"},{"doc":"Gets the current memory limit.\nReturns the memory limit.","ref":"Raxol.Terminal.Emulator.State.html#get_memory_limit/1","title":"Raxol.Terminal.Emulator.State.get_memory_limit/1","type":"function"},{"doc":"Gets the value of a terminal mode.\nReturns the mode value or nil if not set.","ref":"Raxol.Terminal.Emulator.State.html#get_mode/2","title":"Raxol.Terminal.Emulator.State.get_mode/2","type":"function"},{"doc":"Gets the current tab stops.\nReturns the current tab stops.","ref":"Raxol.Terminal.Emulator.State.html#get_tab_stops/1","title":"Raxol.Terminal.Emulator.State.get_tab_stops/1","type":"function"},{"doc":"Pops a state from the state stack.\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.State.html#pop_state/1","title":"Raxol.Terminal.Emulator.State.pop_state/1","type":"function"},{"doc":"Pushes a new state onto the state stack.\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.State.html#push_state/1","title":"Raxol.Terminal.Emulator.State.push_state/1","type":"function"},{"doc":"Sets the character set state.\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.State.html#set_charset_state/2","title":"Raxol.Terminal.Emulator.State.set_charset_state/2","type":"function"},{"doc":"Sets the current hyperlink URL.\nReturns {:ok, updated_emulator}.","ref":"Raxol.Terminal.Emulator.State.html#set_hyperlink_url/2","title":"Raxol.Terminal.Emulator.State.set_hyperlink_url/2","type":"function"},{"doc":"Sets the memory limit for the terminal.\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.State.html#set_memory_limit/2","title":"Raxol.Terminal.Emulator.State.set_memory_limit/2","type":"function"},{"doc":"Sets a terminal mode.\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.State.html#set_mode/3","title":"Raxol.Terminal.Emulator.State.set_mode/3","type":"function"},{"doc":"Sets the tab stops for the terminal.\nReturns {:ok, updated_emulator}.","ref":"Raxol.Terminal.Emulator.State.html#set_tab_stops/2","title":"Raxol.Terminal.Emulator.State.set_tab_stops/2","type":"function"},{"doc":"Provides terminal emulator structure and related functionality.","ref":"Raxol.Terminal.Emulator.Struct.html","title":"Raxol.Terminal.Emulator.Struct","type":"module"},{"doc":"Gets the active buffer from the emulator.","ref":"Raxol.Terminal.Emulator.Struct.html#get_active_buffer/1","title":"Raxol.Terminal.Emulator.Struct.get_active_buffer/1","type":"function"},{"doc":"Gets the cursor position from the emulator.","ref":"Raxol.Terminal.Emulator.Struct.html#get_cursor_position/1","title":"Raxol.Terminal.Emulator.Struct.get_cursor_position/1","type":"function"},{"doc":"Checks if scrolling is needed and performs it if necessary.","ref":"Raxol.Terminal.Emulator.Struct.html#maybe_scroll/1","title":"Raxol.Terminal.Emulator.Struct.maybe_scroll/1","type":"function"},{"doc":"Creates a new terminal emulator with the given options.","ref":"Raxol.Terminal.Emulator.Struct.html#new/3","title":"Raxol.Terminal.Emulator.Struct.new/3","type":"function"},{"doc":"Processes input for the emulator.","ref":"Raxol.Terminal.Emulator.Struct.html#process_input/2","title":"Raxol.Terminal.Emulator.Struct.process_input/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Emulator.Struct.html#t:t/0","title":"Raxol.Terminal.Emulator.Struct.t/0","type":"type"},{"doc":"Updates the active buffer in the emulator.","ref":"Raxol.Terminal.Emulator.Struct.html#update_active_buffer/2","title":"Raxol.Terminal.Emulator.Struct.update_active_buffer/2","type":"function"},{"doc":"Handles text styling and formatting for the terminal emulator.\nProvides functions for managing character attributes, colors, and text formatting.","ref":"Raxol.Terminal.Emulator.Style.html","title":"Raxol.Terminal.Emulator.Style","type":"module"},{"doc":"","ref":"Raxol.Terminal.Emulator.Style.html#t:blink/0","title":"Raxol.Terminal.Emulator.Style.blink/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Emulator.Style.html#t:color/0","title":"Raxol.Terminal.Emulator.Style.color/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Emulator.Style.html#t:decoration/0","title":"Raxol.Terminal.Emulator.Style.decoration/0","type":"type"},{"doc":"Gets the current text style.\nReturns the current style.","ref":"Raxol.Terminal.Emulator.Style.html#get_style/1","title":"Raxol.Terminal.Emulator.Style.get_style/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Emulator.Style.html#t:intensity/0","title":"Raxol.Terminal.Emulator.Style.intensity/0","type":"type"},{"doc":"Resets all text attributes to default.\nReturns {:ok, updated_emulator}.","ref":"Raxol.Terminal.Emulator.Style.html#reset_attributes/1","title":"Raxol.Terminal.Emulator.Style.reset_attributes/1","type":"function"},{"doc":"Sets multiple style attributes at once.","ref":"Raxol.Terminal.Emulator.Style.html#set_attributes/2","title":"Raxol.Terminal.Emulator.Style.set_attributes/2","type":"function"},{"doc":"Sets the background color.\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.Style.html#set_background/2","title":"Raxol.Terminal.Emulator.Style.set_background/2","type":"function"},{"doc":"Sets the text blink mode.\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.Style.html#set_blink/2","title":"Raxol.Terminal.Emulator.Style.set_blink/2","type":"function"},{"doc":"Sets the text decoration (underline, strikethrough, etc.).\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.Style.html#set_decoration/2","title":"Raxol.Terminal.Emulator.Style.set_decoration/2","type":"function"},{"doc":"Sets the foreground color.\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.Style.html#set_foreground/2","title":"Raxol.Terminal.Emulator.Style.set_foreground/2","type":"function"},{"doc":"Sets the text intensity (bold, faint).\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.Style.html#set_intensity/2","title":"Raxol.Terminal.Emulator.Style.set_intensity/2","type":"function"},{"doc":"Sets the text inverse mode.\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.Style.html#set_inverse/2","title":"Raxol.Terminal.Emulator.Style.set_inverse/2","type":"function"},{"doc":"Sets the text visibility.\nReturns {:ok, updated_emulator} or {:error, reason}.","ref":"Raxol.Terminal.Emulator.Style.html#set_visibility/2","title":"Raxol.Terminal.Emulator.Style.set_visibility/2","type":"function"},{"doc":"Defines the behaviour for terminal emulator style management.\nThis includes handling text attributes, colors, and text formatting.","ref":"Raxol.Terminal.Emulator.Style.Behaviour.html","title":"Raxol.Terminal.Emulator.Style.Behaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.Emulator.Style.Behaviour.html#t:blink/0","title":"Raxol.Terminal.Emulator.Style.Behaviour.blink/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Emulator.Style.Behaviour.html#t:color/0","title":"Raxol.Terminal.Emulator.Style.Behaviour.color/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Emulator.Style.Behaviour.html#t:decoration/0","title":"Raxol.Terminal.Emulator.Style.Behaviour.decoration/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Emulator.Style.Behaviour.html#t:intensity/0","title":"Raxol.Terminal.Emulator.Style.Behaviour.intensity/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Emulator.Style.Behaviour.html#c:reset_attributes/1","title":"Raxol.Terminal.Emulator.Style.Behaviour.reset_attributes/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Emulator.Style.Behaviour.html#c:set_attributes/2","title":"Raxol.Terminal.Emulator.Style.Behaviour.set_attributes/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Emulator.Style.Behaviour.html#c:set_background/2","title":"Raxol.Terminal.Emulator.Style.Behaviour.set_background/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Emulator.Style.Behaviour.html#c:set_blink/2","title":"Raxol.Terminal.Emulator.Style.Behaviour.set_blink/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Emulator.Style.Behaviour.html#c:set_decoration/2","title":"Raxol.Terminal.Emulator.Style.Behaviour.set_decoration/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Emulator.Style.Behaviour.html#c:set_foreground/2","title":"Raxol.Terminal.Emulator.Style.Behaviour.set_foreground/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Emulator.Style.Behaviour.html#c:set_intensity/2","title":"Raxol.Terminal.Emulator.Style.Behaviour.set_intensity/2","type":"callback"},{"doc":"Defines the behaviour for the core Terminal Emulator.\n\nThis contract outlines the essential functions for managing terminal state,\nprocessing input, and handling resizing.","ref":"Raxol.Terminal.EmulatorBehaviour.html","title":"Raxol.Terminal.EmulatorBehaviour","type":"behaviour"},{"doc":"Returns the currently active screen buffer.","ref":"Raxol.Terminal.EmulatorBehaviour.html#c:get_active_buffer/1","title":"Raxol.Terminal.EmulatorBehaviour.get_active_buffer/1","type":"callback"},{"doc":"Gets the current cursor position (0-based).","ref":"Raxol.Terminal.EmulatorBehaviour.html#c:get_cursor_position/1","title":"Raxol.Terminal.EmulatorBehaviour.get_cursor_position/1","type":"callback"},{"doc":"Gets the current cursor visibility state.","ref":"Raxol.Terminal.EmulatorBehaviour.html#c:get_cursor_visible/1","title":"Raxol.Terminal.EmulatorBehaviour.get_cursor_visible/1","type":"callback"},{"doc":"Creates a new emulator with default dimensions and options.","ref":"Raxol.Terminal.EmulatorBehaviour.html#c:new/0","title":"Raxol.Terminal.EmulatorBehaviour.new/0","type":"callback"},{"doc":"Creates a new emulator with specified dimensions and default options.","ref":"Raxol.Terminal.EmulatorBehaviour.html#c:new/2","title":"Raxol.Terminal.EmulatorBehaviour.new/2","type":"callback"},{"doc":"Creates a new emulator with specified dimensions and options.","ref":"Raxol.Terminal.EmulatorBehaviour.html#c:new/3","title":"Raxol.Terminal.EmulatorBehaviour.new/3","type":"callback"},{"doc":"Creates a new emulator with specified dimensions, session ID, and client options.","ref":"Raxol.Terminal.EmulatorBehaviour.html#c:new/4","title":"Raxol.Terminal.EmulatorBehaviour.new/4","type":"callback"},{"doc":"Processes input data (e.g., user typing, escape sequences).","ref":"Raxol.Terminal.EmulatorBehaviour.html#c:process_input/2","title":"Raxol.Terminal.EmulatorBehaviour.process_input/2","type":"callback"},{"doc":"Resizes the emulator's screen buffers.","ref":"Raxol.Terminal.EmulatorBehaviour.html#c:resize/3","title":"Raxol.Terminal.EmulatorBehaviour.resize/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.EmulatorBehaviour.html#t:t/0","title":"Raxol.Terminal.EmulatorBehaviour.t/0","type":"type"},{"doc":"Updates the currently active screen buffer in the emulator state.","ref":"Raxol.Terminal.EmulatorBehaviour.html#c:update_active_buffer/2","title":"Raxol.Terminal.EmulatorBehaviour.update_active_buffer/2","type":"callback"},{"doc":"Common utilities for parsing escape sequences.\n\nThis module provides shared functionality for parsing escape sequences,\nincluding parameter parsing and validation.","ref":"Raxol.Terminal.Escape.Parsers.BaseParser.html","title":"Raxol.Terminal.Escape.Parsers.BaseParser","type":"module"},{"doc":"Logs an invalid sequence with context.","ref":"Raxol.Terminal.Escape.Parsers.BaseParser.html#log_invalid_sequence/2","title":"Raxol.Terminal.Escape.Parsers.BaseParser.log_invalid_sequence/2","type":"function"},{"doc":"Logs an unknown sequence with context.","ref":"Raxol.Terminal.Escape.Parsers.BaseParser.html#log_unknown_sequence/2","title":"Raxol.Terminal.Escape.Parsers.BaseParser.log_unknown_sequence/2","type":"function"},{"doc":"Gets a parameter value at the specified index, returning the default if not found.","ref":"Raxol.Terminal.Escape.Parsers.BaseParser.html#param_at/3","title":"Raxol.Terminal.Escape.Parsers.BaseParser.param_at/3","type":"function"},{"doc":"Parses numeric parameters from a string, handling empty values.\nReturns a list of integers or nil values.","ref":"Raxol.Terminal.Escape.Parsers.BaseParser.html#parse_params/1","title":"Raxol.Terminal.Escape.Parsers.BaseParser.parse_params/1","type":"function"},{"doc":"Validates if a string could be a valid escape sequence start.","ref":"Raxol.Terminal.Escape.Parsers.BaseParser.html#valid_sequence_start?/1","title":"Raxol.Terminal.Escape.Parsers.BaseParser.valid_sequence_start?/1","type":"function"},{"doc":"Parser for Control Sequence Introducer (CSI) escape sequences.\n\nHandles sequences in the format:\n- CSI P... I... F\nWhere:\n- P: Parameters (numeric, separated by ;)\n- I: Intermediate bytes (optional)\n- F: Final byte (determines command)\n\nAlso handles DEC Private sequences (CSI ? P... F)","ref":"Raxol.Terminal.Escape.Parsers.CSIParser.html","title":"Raxol.Terminal.Escape.Parsers.CSIParser","type":"module"},{"doc":"Parses a CSI sequence.\nReturns {:ok, command, remaining} or {:incomplete, remaining} or {:error, reason, remaining}","ref":"Raxol.Terminal.Escape.Parsers.CSIParser.html#parse/1","title":"Raxol.Terminal.Escape.Parsers.CSIParser.parse/1","type":"function"},{"doc":"Parses a DEC Private CSI sequence.","ref":"Raxol.Terminal.Escape.Parsers.CSIParser.html#parse_dec_private/3","title":"Raxol.Terminal.Escape.Parsers.CSIParser.parse_dec_private/3","type":"function"},{"doc":"Parses a standard CSI sequence.","ref":"Raxol.Terminal.Escape.Parsers.CSIParser.html#parse_standard_csi/1","title":"Raxol.Terminal.Escape.Parsers.CSIParser.parse_standard_csi/1","type":"function"},{"doc":"Parser for Select Character Set (SCS) escape sequences.\n\nHandles sequences like:\n- ESC ( C -> Designate G0 as Charset C\n- ESC ) C -> Designate G1 as Charset C\n- ESC * C -> Designate G2 as Charset C\n- ESC + C -> Designate G3 as Charset C","ref":"Raxol.Terminal.Escape.Parsers.SCSParser.html","title":"Raxol.Terminal.Escape.Parsers.SCSParser","type":"module"},{"doc":"Maps a character code byte to its corresponding charset atom.\nReference: https://vt100.net/docs/vt510-rm/SCS.html","ref":"Raxol.Terminal.Escape.Parsers.SCSParser.html#charset_code_to_atom/1","title":"Raxol.Terminal.Escape.Parsers.SCSParser.charset_code_to_atom/1","type":"function"},{"doc":"Maps a designator character to its corresponding G-set.","ref":"Raxol.Terminal.Escape.Parsers.SCSParser.html#designate_char_to_gset/1","title":"Raxol.Terminal.Escape.Parsers.SCSParser.designate_char_to_gset/1","type":"function"},{"doc":"Parses a Select Character Set sequence.\nReturns {:ok, command, remaining} or {:incomplete, remaining} or {:error, reason, remaining}","ref":"Raxol.Terminal.Escape.Parsers.SCSParser.html#parse/2","title":"Raxol.Terminal.Escape.Parsers.SCSParser.parse/2","type":"function"},{"doc":"Handles parsing of ANSI escape sequences and other control sequences.\n\nThis module provides functions for parsing ANSI escape sequences\ninto structured data representing terminal commands.","ref":"Raxol.Terminal.EscapeSequence.html","title":"Raxol.Terminal.EscapeSequence","type":"module"},{"doc":"Parses an input string, potentially containing an escape sequence.\n\nReturns:\n  * `{:ok, command_data, remaining_input}` if a complete sequence is parsed.\n  * `{:incomplete, remaining_input}` if the input is potentially part of a sequence but incomplete.\n  * `{:error, :invalid_sequence, remaining_input}` if the sequence is malformed.\n  * `{:error, :not_escape_sequence, input}` if the input doesn't start with ESC.\n\n`command_data` is a tuple representing the parsed command, e.g.:\n  * `{:cursor_position, {row, col}}`\n  * `{:cursor_move, :up, count}`\n  * `{:set_mode, :dec_private, mode_code, boolean_value}`\n  * `{:set_mode, :standard, mode_code, boolean_value}`\n  * `{:designate_charset, target_g_set, charset_atom}`\n  * `{:invoke_charset, target_g_set}`\n  * etc.","ref":"Raxol.Terminal.EscapeSequence.html#parse/1","title":"Raxol.Terminal.EscapeSequence.parse/1","type":"function"},{"doc":"Handles processing of terminal events and their effects on the terminal state.\n\nThis module is responsible for:\n- Processing different types of terminal events\n- Validating event data\n- Applying event effects to the terminal state\n- Coordinating with other terminal components","ref":"Raxol.Terminal.EventProcessor.html","title":"Raxol.Terminal.EventProcessor","type":"module"},{"doc":"Processes a terminal event and returns the updated terminal state.","ref":"Raxol.Terminal.EventProcessor.html#process_event/2","title":"Raxol.Terminal.EventProcessor.process_event/2","type":"function"},{"doc":"* `event` - The event to process\n  * `emulator` - The current terminal emulator state","ref":"Raxol.Terminal.EventProcessor.html#process_event/2-parameters","title":"Parameters - Raxol.Terminal.EventProcessor.process_event/2","type":"function"},{"doc":"* `{updated_emulator, output}` - The updated emulator state and any output","ref":"Raxol.Terminal.EventProcessor.html#process_event/2-returns","title":"Returns - Raxol.Terminal.EventProcessor.process_event/2","type":"function"},{"doc":"Handles terminal events and dispatches them to appropriate handlers.","ref":"Raxol.Terminal.Events.Handlers.html","title":"Raxol.Terminal.Events.Handlers","type":"module"},{"doc":"Generic event handler that dispatches to appropriate handlers.","ref":"Raxol.Terminal.Events.Handlers.html#handle_event/2","title":"Raxol.Terminal.Events.Handlers.handle_event/2","type":"function"},{"doc":"Handles focus events.","ref":"Raxol.Terminal.Events.Handlers.html#handle_focus_event/2","title":"Raxol.Terminal.Events.Handlers.handle_focus_event/2","type":"function"},{"doc":"Handles keyboard events.","ref":"Raxol.Terminal.Events.Handlers.html#handle_keyboard_event/2","title":"Raxol.Terminal.Events.Handlers.handle_keyboard_event/2","type":"function"},{"doc":"Handles mode change events.","ref":"Raxol.Terminal.Events.Handlers.html#handle_mode_event/2","title":"Raxol.Terminal.Events.Handlers.handle_mode_event/2","type":"function"},{"doc":"Handles mouse events.","ref":"Raxol.Terminal.Events.Handlers.html#handle_mouse_event/2","title":"Raxol.Terminal.Events.Handlers.handle_mouse_event/2","type":"function"},{"doc":"Handles window-related events.","ref":"Raxol.Terminal.Events.Handlers.html#handle_window_event/2","title":"Raxol.Terminal.Events.Handlers.handle_window_event/2","type":"function"},{"doc":"Example implementation of Raxol.Terminal.Manager.Callback.\nThis module logs each event it receives. Use as a template for your own callback modules.","ref":"Raxol.Terminal.ExampleCallback.html","title":"Raxol.Terminal.ExampleCallback","type":"module"},{"doc":"Manages terminal extensions with advanced features:\n- Extension loading and unloading\n- Extension lifecycle management\n- Extension API and event system\n- Extension configuration and state management","ref":"Raxol.Terminal.Extension.Manager.html","title":"Raxol.Terminal.Extension.Manager","type":"module"},{"doc":"","ref":"Raxol.Terminal.Extension.Manager.html#t:command/0","title":"Raxol.Terminal.Extension.Manager.command/0","type":"type"},{"doc":"Emits an event to all registered handlers.","ref":"Raxol.Terminal.Extension.Manager.html#emit_event/3","title":"Raxol.Terminal.Extension.Manager.emit_event/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Extension.Manager.html#t:event/0","title":"Raxol.Terminal.Extension.Manager.event/0","type":"type"},{"doc":"Executes an extension command.","ref":"Raxol.Terminal.Extension.Manager.html#execute_command/3","title":"Raxol.Terminal.Extension.Manager.execute_command/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Extension.Manager.html#t:extension/0","title":"Raxol.Terminal.Extension.Manager.extension/0","type":"type"},{"doc":"Gets the current extension metrics.","ref":"Raxol.Terminal.Extension.Manager.html#get_metrics/1","title":"Raxol.Terminal.Extension.Manager.get_metrics/1","type":"function"},{"doc":"Loads an extension into the manager.","ref":"Raxol.Terminal.Extension.Manager.html#load_extension/2","title":"Raxol.Terminal.Extension.Manager.load_extension/2","type":"function"},{"doc":"Creates a new extension manager with the given options.","ref":"Raxol.Terminal.Extension.Manager.html#new/1","title":"Raxol.Terminal.Extension.Manager.new/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Extension.Manager.html#t:t/0","title":"Raxol.Terminal.Extension.Manager.t/0","type":"type"},{"doc":"Unloads an extension from the manager.","ref":"Raxol.Terminal.Extension.Manager.html#unload_extension/2","title":"Raxol.Terminal.Extension.Manager.unload_extension/2","type":"function"},{"doc":"Updates the configuration for an extension.","ref":"Raxol.Terminal.Extension.Manager.html#update_extension_config/3","title":"Raxol.Terminal.Extension.Manager.update_extension_config/3","type":"function"},{"doc":"Unified extension system for the Raxol terminal emulator.\nHandles extension management, integration, and communication with the terminal.","ref":"Raxol.Terminal.Extension.UnifiedExtension.html","title":"Raxol.Terminal.Extension.UnifiedExtension","type":"module"},{"doc":"Activates an extension.","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#activate_extension/1","title":"Raxol.Terminal.Extension.UnifiedExtension.activate_extension/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#child_spec/1","title":"Raxol.Terminal.Extension.UnifiedExtension.child_spec/1","type":"function"},{"doc":"Deactivates an extension.","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#deactivate_extension/1","title":"Raxol.Terminal.Extension.UnifiedExtension.deactivate_extension/1","type":"function"},{"doc":"Executes an extension command.","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#execute_command/3","title":"Raxol.Terminal.Extension.UnifiedExtension.execute_command/3","type":"function"},{"doc":"Exports an extension to a file or directory.","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#export_extension/2","title":"Raxol.Terminal.Extension.UnifiedExtension.export_extension/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#t:extension_id/0","title":"Raxol.Terminal.Extension.UnifiedExtension.extension_id/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#t:extension_state/0","title":"Raxol.Terminal.Extension.UnifiedExtension.extension_state/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#t:extension_type/0","title":"Raxol.Terminal.Extension.UnifiedExtension.extension_type/0","type":"type"},{"doc":"Gets the state of an extension.","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#get_extension_state/1","title":"Raxol.Terminal.Extension.UnifiedExtension.get_extension_state/1","type":"function"},{"doc":"Gets all loaded extensions.","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#get_extensions/1","title":"Raxol.Terminal.Extension.UnifiedExtension.get_extensions/1","type":"function"},{"doc":"Imports an extension from a file or directory.","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#import_extension/2","title":"Raxol.Terminal.Extension.UnifiedExtension.import_extension/2","type":"function"},{"doc":"Loads an extension from a file or directory.","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#load_extension/3","title":"Raxol.Terminal.Extension.UnifiedExtension.load_extension/3","type":"function"},{"doc":"Registers a hook for an extension.","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#register_hook/3","title":"Raxol.Terminal.Extension.UnifiedExtension.register_hook/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#start_link/1","title":"Raxol.Terminal.Extension.UnifiedExtension.start_link/1","type":"function"},{"doc":"Triggers a hook for all registered extensions.","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#trigger_hook/2","title":"Raxol.Terminal.Extension.UnifiedExtension.trigger_hook/2","type":"function"},{"doc":"Unloads an extension by its ID.","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#unload_extension/1","title":"Raxol.Terminal.Extension.UnifiedExtension.unload_extension/1","type":"function"},{"doc":"Unregisters a hook for an extension.","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#unregister_hook/2","title":"Raxol.Terminal.Extension.UnifiedExtension.unregister_hook/2","type":"function"},{"doc":"Updates an extension's configuration.","ref":"Raxol.Terminal.Extension.UnifiedExtension.html#update_extension_config/2","title":"Raxol.Terminal.Extension.UnifiedExtension.update_extension_config/2","type":"function"},{"doc":"Manages font operations and settings for the terminal, including font family,\nsize, weight, and style.","ref":"Raxol.Terminal.Font.Manager.html","title":"Raxol.Terminal.Font.Manager","type":"module"},{"doc":"Adds a custom font.","ref":"Raxol.Terminal.Font.Manager.html#add_custom_font/3","title":"Raxol.Terminal.Font.Manager.add_custom_font/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Font.Manager.html#t:custom_fonts/0","title":"Raxol.Terminal.Font.Manager.custom_fonts/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Font.Manager.html#t:fallback_fonts/0","title":"Raxol.Terminal.Font.Manager.fallback_fonts/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Font.Manager.html#t:font_family/0","title":"Raxol.Terminal.Font.Manager.font_family/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Font.Manager.html#t:font_size/0","title":"Raxol.Terminal.Font.Manager.font_size/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Font.Manager.html#t:font_style/0","title":"Raxol.Terminal.Font.Manager.font_style/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Font.Manager.html#t:font_weight/0","title":"Raxol.Terminal.Font.Manager.font_weight/0","type":"type"},{"doc":"Gets the current custom fonts.","ref":"Raxol.Terminal.Font.Manager.html#get_custom_fonts/1","title":"Raxol.Terminal.Font.Manager.get_custom_fonts/1","type":"function"},{"doc":"Gets the current fallback fonts.","ref":"Raxol.Terminal.Font.Manager.html#get_fallback_fonts/1","title":"Raxol.Terminal.Font.Manager.get_fallback_fonts/1","type":"function"},{"doc":"Gets the current font family.","ref":"Raxol.Terminal.Font.Manager.html#get_family/1","title":"Raxol.Terminal.Font.Manager.get_family/1","type":"function"},{"doc":"Gets the complete font stack including fallbacks.","ref":"Raxol.Terminal.Font.Manager.html#get_font_stack/1","title":"Raxol.Terminal.Font.Manager.get_font_stack/1","type":"function"},{"doc":"Gets the current letter spacing.","ref":"Raxol.Terminal.Font.Manager.html#get_letter_spacing/1","title":"Raxol.Terminal.Font.Manager.get_letter_spacing/1","type":"function"},{"doc":"Gets the current line height.","ref":"Raxol.Terminal.Font.Manager.html#get_line_height/1","title":"Raxol.Terminal.Font.Manager.get_line_height/1","type":"function"},{"doc":"Gets the current font size.","ref":"Raxol.Terminal.Font.Manager.html#get_size/1","title":"Raxol.Terminal.Font.Manager.get_size/1","type":"function"},{"doc":"Gets the current font style.","ref":"Raxol.Terminal.Font.Manager.html#get_style/1","title":"Raxol.Terminal.Font.Manager.get_style/1","type":"function"},{"doc":"Gets the current font weight.","ref":"Raxol.Terminal.Font.Manager.html#get_weight/1","title":"Raxol.Terminal.Font.Manager.get_weight/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Font.Manager.html#t:letter_spacing/0","title":"Raxol.Terminal.Font.Manager.letter_spacing/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Font.Manager.html#t:line_height/0","title":"Raxol.Terminal.Font.Manager.line_height/0","type":"type"},{"doc":"Creates a new font manager instance with default settings.","ref":"Raxol.Terminal.Font.Manager.html#new/0","title":"Raxol.Terminal.Font.Manager.new/0","type":"function"},{"doc":"Removes a custom font.","ref":"Raxol.Terminal.Font.Manager.html#remove_custom_font/2","title":"Raxol.Terminal.Font.Manager.remove_custom_font/2","type":"function"},{"doc":"Resets the font manager to its initial state.","ref":"Raxol.Terminal.Font.Manager.html#reset/1","title":"Raxol.Terminal.Font.Manager.reset/1","type":"function"},{"doc":"Sets the fallback fonts.","ref":"Raxol.Terminal.Font.Manager.html#set_fallback_fonts/2","title":"Raxol.Terminal.Font.Manager.set_fallback_fonts/2","type":"function"},{"doc":"Sets the font family.","ref":"Raxol.Terminal.Font.Manager.html#set_family/2","title":"Raxol.Terminal.Font.Manager.set_family/2","type":"function"},{"doc":"Sets the letter spacing.","ref":"Raxol.Terminal.Font.Manager.html#set_letter_spacing/2","title":"Raxol.Terminal.Font.Manager.set_letter_spacing/2","type":"function"},{"doc":"Sets the line height.","ref":"Raxol.Terminal.Font.Manager.html#set_line_height/2","title":"Raxol.Terminal.Font.Manager.set_line_height/2","type":"function"},{"doc":"Sets the font size.","ref":"Raxol.Terminal.Font.Manager.html#set_size/2","title":"Raxol.Terminal.Font.Manager.set_size/2","type":"function"},{"doc":"Sets the font style.","ref":"Raxol.Terminal.Font.Manager.html#set_style/2","title":"Raxol.Terminal.Font.Manager.set_style/2","type":"function"},{"doc":"Sets the font weight.","ref":"Raxol.Terminal.Font.Manager.html#set_weight/2","title":"Raxol.Terminal.Font.Manager.set_weight/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Font.Manager.html#t:t/0","title":"Raxol.Terminal.Font.Manager.t/0","type":"type"},{"doc":"Manages terminal text formatting and styling operations.","ref":"Raxol.Terminal.Formatting.Manager.html","title":"Raxol.Terminal.Formatting.Manager","type":"module"},{"doc":"Applies a new format to the current state.","ref":"Raxol.Terminal.Formatting.Manager.html#apply_format/2","title":"Raxol.Terminal.Formatting.Manager.apply_format/2","type":"function"},{"doc":"Applies formatting to a string.","ref":"Raxol.Terminal.Formatting.Manager.html#apply_formatting/2","title":"Raxol.Terminal.Formatting.Manager.apply_formatting/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Formatting.Manager.html#t:format/0","title":"Raxol.Terminal.Formatting.Manager.format/0","type":"type"},{"doc":"Gets the current formatting state.","ref":"Raxol.Terminal.Formatting.Manager.html#get_format/1","title":"Raxol.Terminal.Formatting.Manager.get_format/1","type":"function"},{"doc":"Creates a new formatting manager instance.","ref":"Raxol.Terminal.Formatting.Manager.html#new/0","title":"Raxol.Terminal.Formatting.Manager.new/0","type":"function"},{"doc":"Resets the current format to default values.","ref":"Raxol.Terminal.Formatting.Manager.html#reset_format/1","title":"Raxol.Terminal.Formatting.Manager.reset_format/1","type":"function"},{"doc":"Restores the previously saved format state.","ref":"Raxol.Terminal.Formatting.Manager.html#restore_format/1","title":"Raxol.Terminal.Formatting.Manager.restore_format/1","type":"function"},{"doc":"Saves the current format state.","ref":"Raxol.Terminal.Formatting.Manager.html#save_format/1","title":"Raxol.Terminal.Formatting.Manager.save_format/1","type":"function"},{"doc":"Sets the background color.","ref":"Raxol.Terminal.Formatting.Manager.html#set_background/2","title":"Raxol.Terminal.Formatting.Manager.set_background/2","type":"function"},{"doc":"Sets the font number.","ref":"Raxol.Terminal.Formatting.Manager.html#set_font/2","title":"Raxol.Terminal.Formatting.Manager.set_font/2","type":"function"},{"doc":"Sets the foreground color.","ref":"Raxol.Terminal.Formatting.Manager.html#set_foreground/2","title":"Raxol.Terminal.Formatting.Manager.set_foreground/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Formatting.Manager.html#t:t/0","title":"Raxol.Terminal.Formatting.Manager.t/0","type":"type"},{"doc":"Toggles blink formatting.","ref":"Raxol.Terminal.Formatting.Manager.html#toggle_blink/1","title":"Raxol.Terminal.Formatting.Manager.toggle_blink/1","type":"function"},{"doc":"Toggles bold formatting.","ref":"Raxol.Terminal.Formatting.Manager.html#toggle_bold/1","title":"Raxol.Terminal.Formatting.Manager.toggle_bold/1","type":"function"},{"doc":"Toggles conceal formatting.","ref":"Raxol.Terminal.Formatting.Manager.html#toggle_conceal/1","title":"Raxol.Terminal.Formatting.Manager.toggle_conceal/1","type":"function"},{"doc":"Toggles faint formatting.","ref":"Raxol.Terminal.Formatting.Manager.html#toggle_faint/1","title":"Raxol.Terminal.Formatting.Manager.toggle_faint/1","type":"function"},{"doc":"Toggles italic formatting.","ref":"Raxol.Terminal.Formatting.Manager.html#toggle_italic/1","title":"Raxol.Terminal.Formatting.Manager.toggle_italic/1","type":"function"},{"doc":"Toggles reverse video formatting.","ref":"Raxol.Terminal.Formatting.Manager.html#toggle_reverse/1","title":"Raxol.Terminal.Formatting.Manager.toggle_reverse/1","type":"function"},{"doc":"Toggles strikethrough formatting.","ref":"Raxol.Terminal.Formatting.Manager.html#toggle_strikethrough/1","title":"Raxol.Terminal.Formatting.Manager.toggle_strikethrough/1","type":"function"},{"doc":"Toggles underline formatting.","ref":"Raxol.Terminal.Formatting.Manager.html#toggle_underline/1","title":"Raxol.Terminal.Formatting.Manager.toggle_underline/1","type":"function"},{"doc":"Manages the terminal text formatting.","ref":"Raxol.Terminal.FormattingManager.html","title":"Raxol.Terminal.FormattingManager","type":"module"},{"doc":"Checks if the given attribute is set in the style.","ref":"Raxol.Terminal.FormattingManager.html#attribute_set?/2","title":"Raxol.Terminal.FormattingManager.attribute_set?/2","type":"function"},{"doc":"Gets the background color from the style.","ref":"Raxol.Terminal.FormattingManager.html#get_background/1","title":"Raxol.Terminal.FormattingManager.get_background/1","type":"function"},{"doc":"Gets the foreground color from the style.","ref":"Raxol.Terminal.FormattingManager.html#get_foreground/1","title":"Raxol.Terminal.FormattingManager.get_foreground/1","type":"function"},{"doc":"Gets the set attributes from the style.","ref":"Raxol.Terminal.FormattingManager.html#get_set_attributes/1","title":"Raxol.Terminal.FormattingManager.get_set_attributes/1","type":"function"},{"doc":"Gets the current style.","ref":"Raxol.Terminal.FormattingManager.html#get_style/1","title":"Raxol.Terminal.FormattingManager.get_style/1","type":"function"},{"doc":"Resets all attributes in the style.","ref":"Raxol.Terminal.FormattingManager.html#reset_all_attributes/1","title":"Raxol.Terminal.FormattingManager.reset_all_attributes/1","type":"function"},{"doc":"Resets the given attribute in the style.","ref":"Raxol.Terminal.FormattingManager.html#reset_attribute/2","title":"Raxol.Terminal.FormattingManager.reset_attribute/2","type":"function"},{"doc":"Sets the given attribute in the style.","ref":"Raxol.Terminal.FormattingManager.html#set_attribute/2","title":"Raxol.Terminal.FormattingManager.set_attribute/2","type":"function"},{"doc":"Sets the background color in the style.","ref":"Raxol.Terminal.FormattingManager.html#set_background/2","title":"Raxol.Terminal.FormattingManager.set_background/2","type":"function"},{"doc":"Sets the foreground color in the style.","ref":"Raxol.Terminal.FormattingManager.html#set_foreground/2","title":"Raxol.Terminal.FormattingManager.set_foreground/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.FormattingManager.html#t:t/0","title":"Raxol.Terminal.FormattingManager.t/0","type":"type"},{"doc":"Updates the style.","ref":"Raxol.Terminal.FormattingManager.html#update_style/2","title":"Raxol.Terminal.FormattingManager.update_style/2","type":"function"},{"doc":"Manages terminal graphics operations including:\n- Image rendering to sixel format\n- Sixel data processing\n- Graphics pipeline optimization\n- Metrics tracking","ref":"Raxol.Terminal.Graphics.Manager.html","title":"Raxol.Terminal.Graphics.Manager","type":"module"},{"doc":"Gets the current metrics.","ref":"Raxol.Terminal.Graphics.Manager.html#get_metrics/1","title":"Raxol.Terminal.Graphics.Manager.get_metrics/1","type":"function"},{"doc":"Creates a new graphics manager with default state.","ref":"Raxol.Terminal.Graphics.Manager.html#new/0","title":"Raxol.Terminal.Graphics.Manager.new/0","type":"function"},{"doc":"Optimizes the graphics pipeline.","ref":"Raxol.Terminal.Graphics.Manager.html#optimize_pipeline/1","title":"Raxol.Terminal.Graphics.Manager.optimize_pipeline/1","type":"function"},{"doc":"Processes sixel data into an image.","ref":"Raxol.Terminal.Graphics.Manager.html#process_sixel/2","title":"Raxol.Terminal.Graphics.Manager.process_sixel/2","type":"function"},{"doc":"Renders an image to sixel format with the given options.","ref":"Raxol.Terminal.Graphics.Manager.html#render_image/3","title":"Raxol.Terminal.Graphics.Manager.render_image/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Graphics.Manager.html#t:t/0","title":"Raxol.Terminal.Graphics.Manager.t/0","type":"type"},{"doc":"Provides unified graphics capabilities for the terminal emulator.\nThis module handles graphics rendering, image display, and graphics state management.","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html","title":"Raxol.Terminal.Graphics.UnifiedGraphics","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#child_spec/1","title":"Raxol.Terminal.Graphics.UnifiedGraphics.child_spec/1","type":"function"},{"doc":"Cleans up resources.","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#cleanup/0","title":"Raxol.Terminal.Graphics.UnifiedGraphics.cleanup/0","type":"function"},{"doc":"Clears the graphics context.","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#clear_graphics/1","title":"Raxol.Terminal.Graphics.UnifiedGraphics.clear_graphics/1","type":"function"},{"doc":"Closes a graphics context.","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#close_graphics/1","title":"Raxol.Terminal.Graphics.UnifiedGraphics.close_graphics/1","type":"function"},{"doc":"Creates a new graphics context with the given configuration.","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#create_graphics/1","title":"Raxol.Terminal.Graphics.UnifiedGraphics.create_graphics/1","type":"function"},{"doc":"Gets the active graphics context ID.","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#get_active_graphics/0","title":"Raxol.Terminal.Graphics.UnifiedGraphics.get_active_graphics/0","type":"function"},{"doc":"Gets the list of all graphics contexts.","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#get_graphics/0","title":"Raxol.Terminal.Graphics.UnifiedGraphics.get_graphics/0","type":"function"},{"doc":"Gets the state of a specific graphics context.","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#get_graphics_state/1","title":"Raxol.Terminal.Graphics.UnifiedGraphics.get_graphics_state/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#t:graphics_config/0","title":"Raxol.Terminal.Graphics.UnifiedGraphics.graphics_config/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#t:graphics_id/0","title":"Raxol.Terminal.Graphics.UnifiedGraphics.graphics_id/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#t:graphics_state/0","title":"Raxol.Terminal.Graphics.UnifiedGraphics.graphics_state/0","type":"type"},{"doc":"Renders graphics data to the specified context.","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#render_graphics/2","title":"Raxol.Terminal.Graphics.UnifiedGraphics.render_graphics/2","type":"function"},{"doc":"Sets the active graphics context.","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#set_active_graphics/1","title":"Raxol.Terminal.Graphics.UnifiedGraphics.set_active_graphics/1","type":"function"},{"doc":"Starts the graphics manager with the given options.","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#start_link/1","title":"Raxol.Terminal.Graphics.UnifiedGraphics.start_link/1","type":"function"},{"doc":"Updates the graphics manager configuration.","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#update_config/1","title":"Raxol.Terminal.Graphics.UnifiedGraphics.update_config/1","type":"function"},{"doc":"Updates the configuration of a specific graphics context.","ref":"Raxol.Terminal.Graphics.UnifiedGraphics.html#update_graphics_config/2","title":"Raxol.Terminal.Graphics.UnifiedGraphics.update_graphics_config/2","type":"function"},{"doc":"Manages terminal hyperlinks and their states.","ref":"Raxol.Terminal.Hyperlink.Manager.html","title":"Raxol.Terminal.Hyperlink.Manager","type":"module"},{"doc":"Clears the hyperlink state.","ref":"Raxol.Terminal.Hyperlink.Manager.html#clear_hyperlink_state/1","title":"Raxol.Terminal.Hyperlink.Manager.clear_hyperlink_state/1","type":"function"},{"doc":"Creates a new hyperlink with the given parameters.","ref":"Raxol.Terminal.Hyperlink.Manager.html#create_hyperlink/4","title":"Raxol.Terminal.Hyperlink.Manager.create_hyperlink/4","type":"function"},{"doc":"Gets the hyperlink ID.","ref":"Raxol.Terminal.Hyperlink.Manager.html#get_hyperlink_id/1","title":"Raxol.Terminal.Hyperlink.Manager.get_hyperlink_id/1","type":"function"},{"doc":"Gets the hyperlink parameters.","ref":"Raxol.Terminal.Hyperlink.Manager.html#get_hyperlink_params/1","title":"Raxol.Terminal.Hyperlink.Manager.get_hyperlink_params/1","type":"function"},{"doc":"Gets the current hyperlink state.","ref":"Raxol.Terminal.Hyperlink.Manager.html#get_hyperlink_state/1","title":"Raxol.Terminal.Hyperlink.Manager.get_hyperlink_state/1","type":"function"},{"doc":"Gets the current hyperlink URL.","ref":"Raxol.Terminal.Hyperlink.Manager.html#get_hyperlink_url/1","title":"Raxol.Terminal.Hyperlink.Manager.get_hyperlink_url/1","type":"function"},{"doc":"Checks if a hyperlink exists.","ref":"Raxol.Terminal.Hyperlink.Manager.html#has_hyperlink?/1","title":"Raxol.Terminal.Hyperlink.Manager.has_hyperlink?/1","type":"function"},{"doc":"Checks if a hyperlink is active.","ref":"Raxol.Terminal.Hyperlink.Manager.html#hyperlink_active?/1","title":"Raxol.Terminal.Hyperlink.Manager.hyperlink_active?/1","type":"function"},{"doc":"Checks if a hyperlink is being hovered.","ref":"Raxol.Terminal.Hyperlink.Manager.html#hyperlink_hover?/1","title":"Raxol.Terminal.Hyperlink.Manager.hyperlink_hover?/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Hyperlink.Manager.html#t:hyperlink_params/0","title":"Raxol.Terminal.Hyperlink.Manager.hyperlink_params/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Hyperlink.Manager.html#t:hyperlink_state/0","title":"Raxol.Terminal.Hyperlink.Manager.hyperlink_state/0","type":"type"},{"doc":"Creates a new hyperlink manager instance.","ref":"Raxol.Terminal.Hyperlink.Manager.html#new/0","title":"Raxol.Terminal.Hyperlink.Manager.new/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Hyperlink.Manager.html#t:t/0","title":"Raxol.Terminal.Hyperlink.Manager.t/0","type":"type"},{"doc":"Updates the hyperlink parameters.","ref":"Raxol.Terminal.Hyperlink.Manager.html#update_hyperlink_params/2","title":"Raxol.Terminal.Hyperlink.Manager.update_hyperlink_params/2","type":"function"},{"doc":"Updates the hyperlink state.","ref":"Raxol.Terminal.Hyperlink.Manager.html#update_hyperlink_state/2","title":"Raxol.Terminal.Hyperlink.Manager.update_hyperlink_state/2","type":"function"},{"doc":"Updates the hyperlink URL.","ref":"Raxol.Terminal.Hyperlink.Manager.html#update_hyperlink_url/2","title":"Raxol.Terminal.Hyperlink.Manager.update_hyperlink_url/2","type":"function"},{"doc":"Unified input/output system for the terminal emulator.\n\nThis module provides a consolidated interface for handling all terminal I/O operations,\nincluding:\n- Input event processing (keyboard, mouse, special keys)\n- Output buffering and processing\n- Command history management\n- Input mode management\n- Event propagation control\n- Performance optimizations","ref":"Raxol.Terminal.IO.UnifiedIO.html","title":"Raxol.Terminal.IO.UnifiedIO","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.IO.UnifiedIO.html#child_spec/1","title":"Raxol.Terminal.IO.UnifiedIO.child_spec/1","type":"function"},{"doc":"Cleans up the I/O manager.","ref":"Raxol.Terminal.IO.UnifiedIO.html#cleanup/1","title":"Raxol.Terminal.IO.UnifiedIO.cleanup/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.IO.UnifiedIO.html#t:completion_callback/0","title":"Raxol.Terminal.IO.UnifiedIO.completion_callback/0","type":"type"},{"doc":"Initializes the terminal IO system.","ref":"Raxol.Terminal.IO.UnifiedIO.html#init_terminal/3","title":"Raxol.Terminal.IO.UnifiedIO.init_terminal/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.IO.UnifiedIO.html#t:input_mode/0","title":"Raxol.Terminal.IO.UnifiedIO.input_mode/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.IO.UnifiedIO.html#t:mouse_button/0","title":"Raxol.Terminal.IO.UnifiedIO.mouse_button/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.IO.UnifiedIO.html#t:mouse_event/0","title":"Raxol.Terminal.IO.UnifiedIO.mouse_event/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.IO.UnifiedIO.html#t:mouse_event_type/0","title":"Raxol.Terminal.IO.UnifiedIO.mouse_event_type/0","type":"type"},{"doc":"Processes an input event.","ref":"Raxol.Terminal.IO.UnifiedIO.html#process_input/1","title":"Raxol.Terminal.IO.UnifiedIO.process_input/1","type":"function"},{"doc":"Processes output data.","ref":"Raxol.Terminal.IO.UnifiedIO.html#process_output/1","title":"Raxol.Terminal.IO.UnifiedIO.process_output/1","type":"function"},{"doc":"Resets the configuration to defaults.","ref":"Raxol.Terminal.IO.UnifiedIO.html#reset_config/0","title":"Raxol.Terminal.IO.UnifiedIO.reset_config/0","type":"function"},{"doc":"Resizes the terminal.","ref":"Raxol.Terminal.IO.UnifiedIO.html#resize/2","title":"Raxol.Terminal.IO.UnifiedIO.resize/2","type":"function"},{"doc":"Sets a specific configuration value.","ref":"Raxol.Terminal.IO.UnifiedIO.html#set_config_value/2","title":"Raxol.Terminal.IO.UnifiedIO.set_config_value/2","type":"function"},{"doc":"Sets cursor visibility.","ref":"Raxol.Terminal.IO.UnifiedIO.html#set_cursor_visibility/1","title":"Raxol.Terminal.IO.UnifiedIO.set_cursor_visibility/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.IO.UnifiedIO.html#t:special_key/0","title":"Raxol.Terminal.IO.UnifiedIO.special_key/0","type":"type"},{"doc":"Starts the unified IO system.","ref":"Raxol.Terminal.IO.UnifiedIO.html#start_link/1","title":"Raxol.Terminal.IO.UnifiedIO.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.IO.UnifiedIO.html#t:t/0","title":"Raxol.Terminal.IO.UnifiedIO.t/0","type":"type"},{"doc":"Updates the IO configuration.","ref":"Raxol.Terminal.IO.UnifiedIO.html#update_config/1","title":"Raxol.Terminal.IO.UnifiedIO.update_config/1","type":"function"},{"doc":"Handles input processing for the terminal.","ref":"Raxol.Terminal.Input.html","title":"Raxol.Terminal.Input","type":"module"},{"doc":"Creates a new input handler.","ref":"Raxol.Terminal.Input.html#new/0","title":"Raxol.Terminal.Input.new/0","type":"function"},{"doc":"Manages input buffering for the terminal emulator.","ref":"Raxol.Terminal.Input.Buffer.html","title":"Raxol.Terminal.Input.Buffer","type":"module"},{"doc":"Adds an event to the input buffer.","ref":"Raxol.Terminal.Input.Buffer.html#add/2","title":"Raxol.Terminal.Input.Buffer.add/2","type":"function"},{"doc":"Clears the input buffer.","ref":"Raxol.Terminal.Input.Buffer.html#clear/1","title":"Raxol.Terminal.Input.Buffer.clear/1","type":"function"},{"doc":"Gets the current buffer contents.","ref":"Raxol.Terminal.Input.Buffer.html#get_contents/1","title":"Raxol.Terminal.Input.Buffer.get_contents/1","type":"function"},{"doc":"Creates a new input buffer with the given size.","ref":"Raxol.Terminal.Input.Buffer.html#new/1","title":"Raxol.Terminal.Input.Buffer.new/1","type":"function"},{"doc":"Handles character processing, translation, and writing to the terminal buffer.","ref":"Raxol.Terminal.Input.CharacterProcessor.html","title":"Raxol.Terminal.Input.CharacterProcessor","type":"module"},{"doc":"Processes a single character codepoint.\nDelegates to C0 handlers or printable character handlers.","ref":"Raxol.Terminal.Input.CharacterProcessor.html#process_character/2","title":"Raxol.Terminal.Input.CharacterProcessor.process_character/2","type":"function"},{"doc":"Processes a single printable character codepoint.\nHandles writing the character to the buffer, cursor advancement, and line wrapping.","ref":"Raxol.Terminal.Input.CharacterProcessor.html#process_printable_character/2","title":"Raxol.Terminal.Input.CharacterProcessor.process_printable_character/2","type":"function"},{"doc":"Handles clipboard operations for the terminal emulator.","ref":"Raxol.Terminal.Input.ClipboardHandler.html","title":"Raxol.Terminal.Input.ClipboardHandler","type":"module"},{"doc":"Handles clipboard copy operation.\n(Currently copies the entire buffer)","ref":"Raxol.Terminal.Input.ClipboardHandler.html#handle_copy/1","title":"Raxol.Terminal.Input.ClipboardHandler.handle_copy/1","type":"function"},{"doc":"Handles clipboard cut operation.\n(Currently cuts the entire buffer)","ref":"Raxol.Terminal.Input.ClipboardHandler.html#handle_cut/1","title":"Raxol.Terminal.Input.ClipboardHandler.handle_cut/1","type":"function"},{"doc":"Handles clipboard paste operation.","ref":"Raxol.Terminal.Input.ClipboardHandler.html#handle_paste/1","title":"Raxol.Terminal.Input.ClipboardHandler.handle_paste/1","type":"function"},{"doc":"Handles various control sequences for the terminal emulator.\nIncludes CSI, OSC, DCS, PM, and APC sequence handling.","ref":"Raxol.Terminal.Input.ControlSequenceHandler.html","title":"Raxol.Terminal.Input.ControlSequenceHandler","type":"module"},{"doc":"Handles an APC (Application Program Command) sequence.","ref":"Raxol.Terminal.Input.ControlSequenceHandler.html#handle_apc_sequence/3","title":"Raxol.Terminal.Input.ControlSequenceHandler.handle_apc_sequence/3","type":"function"},{"doc":"Handles a CSI (Control Sequence Introducer) sequence.","ref":"Raxol.Terminal.Input.ControlSequenceHandler.html#handle_csi_sequence/3","title":"Raxol.Terminal.Input.ControlSequenceHandler.handle_csi_sequence/3","type":"function"},{"doc":"Handles a DCS (Device Control String) sequence.","ref":"Raxol.Terminal.Input.ControlSequenceHandler.html#handle_dcs_sequence/3","title":"Raxol.Terminal.Input.ControlSequenceHandler.handle_dcs_sequence/3","type":"function"},{"doc":"Handles an OSC (Operating System Command) sequence.","ref":"Raxol.Terminal.Input.ControlSequenceHandler.html#handle_osc_sequence/3","title":"Raxol.Terminal.Input.ControlSequenceHandler.handle_osc_sequence/3","type":"function"},{"doc":"Handles a PM (Privacy Message) sequence.","ref":"Raxol.Terminal.Input.ControlSequenceHandler.html#handle_pm_sequence/3","title":"Raxol.Terminal.Input.ControlSequenceHandler.handle_pm_sequence/3","type":"function"},{"doc":"Core input handling functionality for the terminal emulator.\nManages the main input buffer and cursor state.","ref":"Raxol.Terminal.Input.CoreHandler.html","title":"Raxol.Terminal.Input.CoreHandler","type":"module"},{"doc":"Inserts text at the specified position in the buffer.","ref":"Raxol.Terminal.Input.CoreHandler.html#insert_text/3","title":"Raxol.Terminal.Input.CoreHandler.insert_text/3","type":"function"},{"doc":"Creates a new input handler with default values.","ref":"Raxol.Terminal.Input.CoreHandler.html#new/0","title":"Raxol.Terminal.Input.CoreHandler.new/0","type":"function"},{"doc":"Processes a raw input string for the terminal, parsing control sequences and printable characters.\nThis function drives the terminal command parser.","ref":"Raxol.Terminal.Input.CoreHandler.html#process_terminal_input/2","title":"Raxol.Terminal.Input.CoreHandler.process_terminal_input/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Input.CoreHandler.html#t:t/0","title":"Raxol.Terminal.Input.CoreHandler.t/0","type":"type"},{"doc":"Defines the base event struct and common types for input events.","ref":"Raxol.Terminal.Input.Event.html","title":"Raxol.Terminal.Input.Event","type":"module"},{"doc":"","ref":"Raxol.Terminal.Input.Event.html#t:modifier/0","title":"Raxol.Terminal.Input.Event.modifier/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Input.Event.html#t:t/0","title":"Raxol.Terminal.Input.Event.t/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Input.Event.html#t:timestamp/0","title":"Raxol.Terminal.Input.Event.timestamp/0","type":"type"},{"doc":"Represents a keyboard input event.","ref":"Raxol.Terminal.Input.Event.KeyEvent.html","title":"Raxol.Terminal.Input.Event.KeyEvent","type":"module"},{"doc":"","ref":"Raxol.Terminal.Input.Event.KeyEvent.html#t:t/0","title":"Raxol.Terminal.Input.Event.KeyEvent.t/0","type":"type"},{"doc":"Represents a mouse input event.","ref":"Raxol.Terminal.Input.Event.MouseEvent.html","title":"Raxol.Terminal.Input.Event.MouseEvent","type":"module"},{"doc":"","ref":"Raxol.Terminal.Input.Event.MouseEvent.html#t:action/0","title":"Raxol.Terminal.Input.Event.MouseEvent.action/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Input.Event.MouseEvent.html#t:button/0","title":"Raxol.Terminal.Input.Event.MouseEvent.button/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Input.Event.MouseEvent.html#t:t/0","title":"Raxol.Terminal.Input.Event.MouseEvent.t/0","type":"type"},{"doc":"Handles input buffering for the terminal emulator.\nProvides functionality for storing, retrieving, and manipulating input data.","ref":"Raxol.Terminal.Input.InputBuffer.html","title":"Raxol.Terminal.Input.InputBuffer","type":"module"},{"doc":"Appends data to the buffer, handling escape sequences appropriately.","ref":"Raxol.Terminal.Input.InputBuffer.html#append/2","title":"Raxol.Terminal.Input.InputBuffer.append/2","type":"function"},{"doc":"Removes the last character from the buffer.\nUses graphemes to handle multi-byte characters correctly.","ref":"Raxol.Terminal.Input.InputBuffer.html#backspace/1","title":"Raxol.Terminal.Input.InputBuffer.backspace/1","type":"function"},{"doc":"Clears the buffer.","ref":"Raxol.Terminal.Input.InputBuffer.html#clear/1","title":"Raxol.Terminal.Input.InputBuffer.clear/1","type":"function"},{"doc":"Removes the first character from the buffer.","ref":"Raxol.Terminal.Input.InputBuffer.html#delete_first/1","title":"Raxol.Terminal.Input.InputBuffer.delete_first/1","type":"function"},{"doc":"Checks if the buffer is empty.","ref":"Raxol.Terminal.Input.InputBuffer.html#empty?/1","title":"Raxol.Terminal.Input.InputBuffer.empty?/1","type":"function"},{"doc":"Gets the buffer contents.","ref":"Raxol.Terminal.Input.InputBuffer.html#get_contents/1","title":"Raxol.Terminal.Input.InputBuffer.get_contents/1","type":"function"},{"doc":"Handles escape sequence processing.","ref":"Raxol.Terminal.Input.InputBuffer.html#handle_escape_sequence/2","title":"Raxol.Terminal.Input.InputBuffer.handle_escape_sequence/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Input.InputBuffer.html#handle_resize/2","title":"Raxol.Terminal.Input.InputBuffer.handle_resize/2","type":"function"},{"doc":"Inserts a character at the specified position.\nRaises ArgumentError if position is out of bounds.","ref":"Raxol.Terminal.Input.InputBuffer.html#insert_at/3","title":"Raxol.Terminal.Input.InputBuffer.insert_at/3","type":"function"},{"doc":"Gets the maximum size of the buffer.","ref":"Raxol.Terminal.Input.InputBuffer.html#max_size/1","title":"Raxol.Terminal.Input.InputBuffer.max_size/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Input.InputBuffer.html#move_cursor_to_end_of_line/1","title":"Raxol.Terminal.Input.InputBuffer.move_cursor_to_end_of_line/1","type":"function"},{"doc":"Creates a new input buffer with default values.","ref":"Raxol.Terminal.Input.InputBuffer.html#new/2","title":"Raxol.Terminal.Input.InputBuffer.new/2","type":"function"},{"doc":"Gets the overflow mode of the buffer.","ref":"Raxol.Terminal.Input.InputBuffer.html#overflow_mode/1","title":"Raxol.Terminal.Input.InputBuffer.overflow_mode/1","type":"function"},{"doc":"Prepends data to the buffer.","ref":"Raxol.Terminal.Input.InputBuffer.html#prepend/2","title":"Raxol.Terminal.Input.InputBuffer.prepend/2","type":"function"},{"doc":"Replaces a character at the specified position.\nRaises ArgumentError if position is out of bounds.","ref":"Raxol.Terminal.Input.InputBuffer.html#replace_at/3","title":"Raxol.Terminal.Input.InputBuffer.replace_at/3","type":"function"},{"doc":"Sets the buffer contents.","ref":"Raxol.Terminal.Input.InputBuffer.html#set_contents/2","title":"Raxol.Terminal.Input.InputBuffer.set_contents/2","type":"function"},{"doc":"Sets the maximum size of the buffer.\nIf the current content exceeds the new max size, it will be handled\naccording to the current overflow mode.","ref":"Raxol.Terminal.Input.InputBuffer.html#set_max_size/2","title":"Raxol.Terminal.Input.InputBuffer.set_max_size/2","type":"function"},{"doc":"Sets the overflow mode of the buffer.","ref":"Raxol.Terminal.Input.InputBuffer.html#set_overflow_mode/2","title":"Raxol.Terminal.Input.InputBuffer.set_overflow_mode/2","type":"function"},{"doc":"Gets the current size of the buffer.","ref":"Raxol.Terminal.Input.InputBuffer.html#size/1","title":"Raxol.Terminal.Input.InputBuffer.size/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Input.InputBuffer.html#t:t/0","title":"Raxol.Terminal.Input.InputBuffer.t/0","type":"type"},{"doc":"Utility functions for Raxol.Terminal.Input.InputBuffer.","ref":"Raxol.Terminal.Input.InputBufferUtils.html","title":"Raxol.Terminal.Input.InputBufferUtils","type":"module"},{"doc":"","ref":"Raxol.Terminal.Input.InputBufferUtils.html#calculate_new_cursor_pos_v2/5","title":"Raxol.Terminal.Input.InputBufferUtils.calculate_new_cursor_pos_v2/5","type":"function"},{"doc":"","ref":"Raxol.Terminal.Input.InputBufferUtils.html#find_logical_position/2","title":"Raxol.Terminal.Input.InputBufferUtils.find_logical_position/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Input.InputBufferUtils.html#wrap_line/2","title":"Raxol.Terminal.Input.InputBufferUtils.wrap_line/2","type":"function"},{"doc":"Manages terminal input operations with advanced features:\n- Advanced key handling with modifier support\n- Input validation and sanitization\n- Input buffering with timeout handling\n- Input customization and mapping","ref":"Raxol.Terminal.Input.Manager.html","title":"Raxol.Terminal.Input.Manager","type":"module"},{"doc":"Flushes the input buffer.","ref":"Raxol.Terminal.Input.Manager.html#flush_buffer/1","title":"Raxol.Terminal.Input.Manager.flush_buffer/1","type":"function"},{"doc":"Gets the current input metrics.","ref":"Raxol.Terminal.Input.Manager.html#get_metrics/1","title":"Raxol.Terminal.Input.Manager.get_metrics/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Input.Manager.html#t:key_event/0","title":"Raxol.Terminal.Input.Manager.key_event/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Input.Manager.html#t:key_modifier/0","title":"Raxol.Terminal.Input.Manager.key_modifier/0","type":"type"},{"doc":"Creates a new input manager with the given options.","ref":"Raxol.Terminal.Input.Manager.html#new/1","title":"Raxol.Terminal.Input.Manager.new/1","type":"function"},{"doc":"Processes a key event with validation and mapping.","ref":"Raxol.Terminal.Input.Manager.html#process_key_event/2","title":"Raxol.Terminal.Input.Manager.process_key_event/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Input.Manager.html#t:t/0","title":"Raxol.Terminal.Input.Manager.t/0","type":"type"},{"doc":"Processes input events for the terminal emulator.","ref":"Raxol.Terminal.Input.Processor.html","title":"Raxol.Terminal.Input.Processor","type":"module"},{"doc":"Maps an input event to a terminal command.","ref":"Raxol.Terminal.Input.Processor.html#map_event/1","title":"Raxol.Terminal.Input.Processor.map_event/1","type":"function"},{"doc":"Creates a new input processor.","ref":"Raxol.Terminal.Input.Processor.html#new/0","title":"Raxol.Terminal.Input.Processor.new/0","type":"function"},{"doc":"Handles special key combinations and their escape sequences.\n\nThis module provides functionality for:\n- Detecting special key combinations (Ctrl, Alt, Shift, Meta)\n- Converting special keys to their corresponding escape sequences\n- Handling modifier key state\n- Supporting extended key combinations","ref":"Raxol.Terminal.Input.SpecialKeys.html","title":"Raxol.Terminal.Input.SpecialKeys","type":"module"},{"doc":"","ref":"Raxol.Terminal.Input.SpecialKeys.html#t:modifier/0","title":"Raxol.Terminal.Input.SpecialKeys.modifier/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Input.SpecialKeys.html#t:modifier_state/0","title":"Raxol.Terminal.Input.SpecialKeys.modifier_state/0","type":"type"},{"doc":"Creates a new modifier state.","ref":"Raxol.Terminal.Input.SpecialKeys.html#new_state/0","title":"Raxol.Terminal.Input.SpecialKeys.new_state/0","type":"function"},{"doc":"iex> state = SpecialKeys.new_state()\n    iex> state.ctrl\n    false","ref":"Raxol.Terminal.Input.SpecialKeys.html#new_state/0-examples","title":"Examples - Raxol.Terminal.Input.SpecialKeys.new_state/0","type":"function"},{"doc":"Converts a key combination to its corresponding escape sequence.","ref":"Raxol.Terminal.Input.SpecialKeys.html#to_escape_sequence/2","title":"Raxol.Terminal.Input.SpecialKeys.to_escape_sequence/2","type":"function"},{"doc":"iex> state = SpecialKeys.new_state() |> SpecialKeys.update_state(\"Control\", true)\n    iex> SpecialKeys.to_escape_sequence(state, \"c\")\n    \"\u001B[99\"","ref":"Raxol.Terminal.Input.SpecialKeys.html#to_escape_sequence/2-examples","title":"Examples - Raxol.Terminal.Input.SpecialKeys.to_escape_sequence/2","type":"function"},{"doc":"Updates the modifier state based on a key event.","ref":"Raxol.Terminal.Input.SpecialKeys.html#update_state/3","title":"Raxol.Terminal.Input.SpecialKeys.update_state/3","type":"function"},{"doc":"iex> state = SpecialKeys.new_state()\n    iex> state = SpecialKeys.update_state(state, \"Control\", true)\n    iex> state.ctrl\n    true","ref":"Raxol.Terminal.Input.SpecialKeys.html#update_state/3-examples","title":"Examples - Raxol.Terminal.Input.SpecialKeys.update_state/3","type":"function"},{"doc":"Defines shared types for the Raxol terminal input subsystem.","ref":"Raxol.Terminal.Input.Types.html","title":"Raxol.Terminal.Input.Types","type":"module"},{"doc":"Represents the state of the terminal input buffer.","ref":"Raxol.Terminal.Input.Types.html#t:input_buffer/0","title":"Raxol.Terminal.Input.Types.input_buffer/0","type":"type"},{"doc":"Main input handler module that coordinates between different input handling components.","ref":"Raxol.Terminal.InputHandler.html","title":"Raxol.Terminal.InputHandler","type":"module"},{"doc":"Handles an APC sequence.","ref":"Raxol.Terminal.InputHandler.html#handle_apc_sequence/3","title":"Raxol.Terminal.InputHandler.handle_apc_sequence/3","type":"function"},{"doc":"Handles clipboard copy operation.","ref":"Raxol.Terminal.InputHandler.html#handle_copy/1","title":"Raxol.Terminal.InputHandler.handle_copy/1","type":"function"},{"doc":"Handles a CSI sequence.","ref":"Raxol.Terminal.InputHandler.html#handle_csi_sequence/3","title":"Raxol.Terminal.InputHandler.handle_csi_sequence/3","type":"function"},{"doc":"Handles clipboard cut operation.","ref":"Raxol.Terminal.InputHandler.html#handle_cut/1","title":"Raxol.Terminal.InputHandler.handle_cut/1","type":"function"},{"doc":"Handles a DCS sequence.","ref":"Raxol.Terminal.InputHandler.html#handle_dcs_sequence/3","title":"Raxol.Terminal.InputHandler.handle_dcs_sequence/3","type":"function"},{"doc":"Handles an OSC sequence.","ref":"Raxol.Terminal.InputHandler.html#handle_osc_sequence/3","title":"Raxol.Terminal.InputHandler.handle_osc_sequence/3","type":"function"},{"doc":"Handles clipboard paste operation.","ref":"Raxol.Terminal.InputHandler.html#handle_paste/1","title":"Raxol.Terminal.InputHandler.handle_paste/1","type":"function"},{"doc":"Handles a PM sequence.","ref":"Raxol.Terminal.InputHandler.html#handle_pm_sequence/3","title":"Raxol.Terminal.InputHandler.handle_pm_sequence/3","type":"function"},{"doc":"Creates a new input handler with default values.","ref":"Raxol.Terminal.InputHandler.html#new/0","title":"Raxol.Terminal.InputHandler.new/0","type":"function"},{"doc":"Processes a single character codepoint.","ref":"Raxol.Terminal.InputHandler.html#process_character/2","title":"Raxol.Terminal.InputHandler.process_character/2","type":"function"},{"doc":"Processes a raw input string for the terminal.","ref":"Raxol.Terminal.InputHandler.html#process_terminal_input/2","title":"Raxol.Terminal.InputHandler.process_terminal_input/2","type":"function"},{"doc":"Coordinates terminal integration components and provides a unified interface\nfor terminal operations.\n\nThis module manages the interaction between various terminal components:\n- State management\n- Input/output processing (via UnifiedIO)\n- Buffer management\n- Rendering\n- Configuration","ref":"Raxol.Terminal.Integration.html","title":"Raxol.Terminal.Integration","type":"module"},{"doc":"Clears the terminal (delegates to buffer manager and renderer).","ref":"Raxol.Terminal.Integration.html#clear/1","title":"Raxol.Terminal.Integration.clear/1","type":"function"},{"doc":"Gets the current terminal configuration.","ref":"Raxol.Terminal.Integration.html#get_config/1","title":"Raxol.Terminal.Integration.get_config/1","type":"function"},{"doc":"Gets the current cursor position.","ref":"Raxol.Terminal.Integration.html#get_cursor_position/1","title":"Raxol.Terminal.Integration.get_cursor_position/1","type":"function"},{"doc":"Gets the current terminal dimensions.","ref":"Raxol.Terminal.Integration.html#get_dimensions/1","title":"Raxol.Terminal.Integration.get_dimensions/1","type":"function"},{"doc":"Gets the current scroll position.","ref":"Raxol.Terminal.Integration.html#get_scroll_position/1","title":"Raxol.Terminal.Integration.get_scroll_position/1","type":"function"},{"doc":"Gets the current terminal title.","ref":"Raxol.Terminal.Integration.html#get_title/1","title":"Raxol.Terminal.Integration.get_title/1","type":"function"},{"doc":"Gets the total number of lines in the buffer.","ref":"Raxol.Terminal.Integration.html#get_total_lines/1","title":"Raxol.Terminal.Integration.get_total_lines/1","type":"function"},{"doc":"Gets the current visible content.","ref":"Raxol.Terminal.Integration.html#get_visible_content/1","title":"Raxol.Terminal.Integration.get_visible_content/1","type":"function"},{"doc":"Gets the number of visible lines.","ref":"Raxol.Terminal.Integration.html#get_visible_lines/1","title":"Raxol.Terminal.Integration.get_visible_lines/1","type":"function"},{"doc":"Processes user input and updates the terminal state using UnifiedIO.","ref":"Raxol.Terminal.Integration.html#handle_input/2","title":"Raxol.Terminal.Integration.handle_input/2","type":"function"},{"doc":"Initializes a new terminal integration state.","ref":"Raxol.Terminal.Integration.html#init/1","title":"Raxol.Terminal.Integration.init/1","type":"function"},{"doc":"Moves the cursor to a specific position.","ref":"Raxol.Terminal.Integration.html#move_cursor/3","title":"Raxol.Terminal.Integration.move_cursor/3","type":"function"},{"doc":"Resets the terminal configuration to default values.","ref":"Raxol.Terminal.Integration.html#reset_config/1","title":"Raxol.Terminal.Integration.reset_config/1","type":"function"},{"doc":"Resizes the terminal.","ref":"Raxol.Terminal.Integration.html#resize/3","title":"Raxol.Terminal.Integration.resize/3","type":"function"},{"doc":"Scrolls the terminal.","ref":"Raxol.Terminal.Integration.html#scroll/3","title":"Raxol.Terminal.Integration.scroll/3","type":"function"},{"doc":"Sets a specific configuration value.","ref":"Raxol.Terminal.Integration.html#set_config_value/3","title":"Raxol.Terminal.Integration.set_config_value/3","type":"function"},{"doc":"Shows or hides the cursor.","ref":"Raxol.Terminal.Integration.html#set_cursor_visibility/2","title":"Raxol.Terminal.Integration.set_cursor_visibility/2","type":"function"},{"doc":"Sets the terminal title.","ref":"Raxol.Terminal.Integration.html#set_title/2","title":"Raxol.Terminal.Integration.set_title/2","type":"function"},{"doc":"Updates the configuration.","ref":"Raxol.Terminal.Integration.html#update_config/2","title":"Raxol.Terminal.Integration.update_config/2","type":"function"},{"doc":"Writes text to the terminal using UnifiedIO output processing.","ref":"Raxol.Terminal.Integration.html#write/2","title":"Raxol.Terminal.Integration.write/2","type":"function"},{"doc":"Handles buffer and cursor management for the terminal.","ref":"Raxol.Terminal.Integration.Buffer.html","title":"Raxol.Terminal.Integration.Buffer","type":"module"},{"doc":"Clears the terminal buffer.","ref":"Raxol.Terminal.Integration.Buffer.html#clear/1","title":"Raxol.Terminal.Integration.Buffer.clear/1","type":"function"},{"doc":"Gets the current cursor position.","ref":"Raxol.Terminal.Integration.Buffer.html#get_cursor_position/1","title":"Raxol.Terminal.Integration.Buffer.get_cursor_position/1","type":"function"},{"doc":"Gets the current scroll position.","ref":"Raxol.Terminal.Integration.Buffer.html#get_scroll_position/1","title":"Raxol.Terminal.Integration.Buffer.get_scroll_position/1","type":"function"},{"doc":"Gets the total number of lines in the buffer.","ref":"Raxol.Terminal.Integration.Buffer.html#get_total_lines/1","title":"Raxol.Terminal.Integration.Buffer.get_total_lines/1","type":"function"},{"doc":"Gets the current visible content.","ref":"Raxol.Terminal.Integration.Buffer.html#get_visible_content/1","title":"Raxol.Terminal.Integration.Buffer.get_visible_content/1","type":"function"},{"doc":"Gets the number of visible lines.","ref":"Raxol.Terminal.Integration.Buffer.html#get_visible_lines/1","title":"Raxol.Terminal.Integration.Buffer.get_visible_lines/1","type":"function"},{"doc":"Moves the cursor to a specific position.","ref":"Raxol.Terminal.Integration.Buffer.html#move_cursor/3","title":"Raxol.Terminal.Integration.Buffer.move_cursor/3","type":"function"},{"doc":"Resizes the terminal buffer.","ref":"Raxol.Terminal.Integration.Buffer.html#resize/3","title":"Raxol.Terminal.Integration.Buffer.resize/3","type":"function"},{"doc":"Scrolls the terminal buffer.","ref":"Raxol.Terminal.Integration.Buffer.html#scroll/3","title":"Raxol.Terminal.Integration.Buffer.scroll/3","type":"function"},{"doc":"Writes text to the terminal buffer.","ref":"Raxol.Terminal.Integration.Buffer.html#write/2","title":"Raxol.Terminal.Integration.Buffer.write/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Integration.CellRenderer.html","title":"Raxol.Terminal.Integration.CellRenderer","type":"module"},{"doc":"","ref":"Raxol.Terminal.Integration.CellRenderer.html#render/1","title":"Raxol.Terminal.Integration.CellRenderer.render/1","type":"function"},{"doc":"Manages configuration for the terminal integration.","ref":"Raxol.Terminal.Integration.Config.html","title":"Raxol.Terminal.Integration.Config","type":"module"},{"doc":"Applies configuration changes to the terminal state.","ref":"Raxol.Terminal.Integration.Config.html#apply_config_changes/2","title":"Raxol.Terminal.Integration.Config.apply_config_changes/2","type":"function"},{"doc":"Returns the default configuration.","ref":"Raxol.Terminal.Integration.Config.html#default_config/0","title":"Raxol.Terminal.Integration.Config.default_config/0","type":"function"},{"doc":"Gets a specific configuration value.","ref":"Raxol.Terminal.Integration.Config.html#get_config_value/2","title":"Raxol.Terminal.Integration.Config.get_config_value/2","type":"function"},{"doc":"Gets emulator configuration.","ref":"Raxol.Terminal.Integration.Config.html#get_emulator_config/1","title":"Raxol.Terminal.Integration.Config.get_emulator_config/1","type":"function"},{"doc":"Resets the configuration to default values.","ref":"Raxol.Terminal.Integration.Config.html#reset_config/1","title":"Raxol.Terminal.Integration.Config.reset_config/1","type":"function"},{"doc":"Sets a specific configuration value.","ref":"Raxol.Terminal.Integration.Config.html#set_config_value/3","title":"Raxol.Terminal.Integration.Config.set_config_value/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Integration.Config.html#t:t/0","title":"Raxol.Terminal.Integration.Config.t/0","type":"type"},{"doc":"Updates the buffer manager configuration.","ref":"Raxol.Terminal.Integration.Config.html#update_buffer_manager/2","title":"Raxol.Terminal.Integration.Config.update_buffer_manager/2","type":"function"},{"doc":"Updates the terminal configuration.\n\nMerges the provided `opts` into the current configuration and validates\nthe result before applying.","ref":"Raxol.Terminal.Integration.Config.html#update_config/2","title":"Raxol.Terminal.Integration.Config.update_config/2","type":"function"},{"doc":"Updates the renderer configuration.","ref":"Raxol.Terminal.Integration.Config.html#update_renderer_config/2","title":"Raxol.Terminal.Integration.Config.update_renderer_config/2","type":"function"},{"doc":"Updates the scroll buffer configuration.","ref":"Raxol.Terminal.Integration.Config.html#update_scroll_buffer/2","title":"Raxol.Terminal.Integration.Config.update_scroll_buffer/2","type":"function"},{"doc":"Validates the configuration.","ref":"Raxol.Terminal.Integration.Config.html#validate_config/1","title":"Raxol.Terminal.Integration.Config.validate_config/1","type":"function"},{"doc":"Handles terminal output rendering and display management using Termbox2.","ref":"Raxol.Terminal.Integration.Renderer.html","title":"Raxol.Terminal.Integration.Renderer","type":"module"},{"doc":"Clears the terminal screen (specifically, the back buffer).\nCall present/0 afterwards to make it visible.\nReturns :ok or {:error, reason}.","ref":"Raxol.Terminal.Integration.Renderer.html#clear_screen/1","title":"Raxol.Terminal.Integration.Renderer.clear_screen/1","type":"function"},{"doc":"Gets the current terminal dimensions.\nReturns {:ok, {width, height}} or {:error, :dimensions_unavailable}.\nNote: termbox2 width/height C functions return int, not status codes.\nA negative value might indicate an error (e.g., not initialized).","ref":"Raxol.Terminal.Integration.Renderer.html#get_dimensions/0","title":"Raxol.Terminal.Integration.Renderer.get_dimensions/0","type":"function"},{"doc":"Gets the terminal title.","ref":"Raxol.Terminal.Integration.Renderer.html#get_title/1","title":"Raxol.Terminal.Integration.Renderer.get_title/1","type":"function"},{"doc":"Initializes the underlying terminal system.\nMust be called before other rendering functions.\nReturns :ok or {:error, reason}.","ref":"Raxol.Terminal.Integration.Renderer.html#init_terminal/0","title":"Raxol.Terminal.Integration.Renderer.init_terminal/0","type":"function"},{"doc":"Moves the hardware cursor to a specific position on the screen.\nCall present/0 afterwards if you want to ensure it's shown with other changes.\nThe cursor position is typically updated with present/0.\nReturns :ok or {:error, reason}.","ref":"Raxol.Terminal.Integration.Renderer.html#move_cursor/3","title":"Raxol.Terminal.Integration.Renderer.move_cursor/3","type":"function"},{"doc":"Creates a new renderer with the given options.","ref":"Raxol.Terminal.Integration.Renderer.html#new/1","title":"Raxol.Terminal.Integration.Renderer.new/1","type":"function"},{"doc":"Renders the current terminal state to the screen.\nReturns :ok or {:error, reason}.","ref":"Raxol.Terminal.Integration.Renderer.html#render/1","title":"Raxol.Terminal.Integration.Renderer.render/1","type":"function"},{"doc":"Resets the renderer configuration to defaults.","ref":"Raxol.Terminal.Integration.Renderer.html#reset_config/1","title":"Raxol.Terminal.Integration.Renderer.reset_config/1","type":"function"},{"doc":"Resizes the renderer to the given dimensions.","ref":"Raxol.Terminal.Integration.Renderer.html#resize/3","title":"Raxol.Terminal.Integration.Renderer.resize/3","type":"function"},{"doc":"Sets a specific configuration value.","ref":"Raxol.Terminal.Integration.Renderer.html#set_config_value/3","title":"Raxol.Terminal.Integration.Renderer.set_config_value/3","type":"function"},{"doc":"Sets the cursor visibility.","ref":"Raxol.Terminal.Integration.Renderer.html#set_cursor_visibility/2","title":"Raxol.Terminal.Integration.Renderer.set_cursor_visibility/2","type":"function"},{"doc":"Sets the terminal title.","ref":"Raxol.Terminal.Integration.Renderer.html#set_title/2","title":"Raxol.Terminal.Integration.Renderer.set_title/2","type":"function"},{"doc":"Shuts down the underlying terminal system.\nMust be called to restore terminal state.\nReturns :ok or {:error, reason}.","ref":"Raxol.Terminal.Integration.Renderer.html#shutdown_terminal/0","title":"Raxol.Terminal.Integration.Renderer.shutdown_terminal/0","type":"function"},{"doc":"Updates the renderer configuration.","ref":"Raxol.Terminal.Integration.Renderer.html#update_config/2","title":"Raxol.Terminal.Integration.Renderer.update_config/2","type":"function"},{"doc":"Manages the state of the integrated terminal system.","ref":"Raxol.Terminal.Integration.State.html","title":"Raxol.Terminal.Integration.State","type":"module"},{"doc":"Cleans up resources.","ref":"Raxol.Terminal.Integration.State.html#cleanup/1","title":"Raxol.Terminal.Integration.State.cleanup/1","type":"function"},{"doc":"Gets the current memory usage.","ref":"Raxol.Terminal.Integration.State.html#get_memory_usage/1","title":"Raxol.Terminal.Integration.State.get_memory_usage/1","type":"function"},{"doc":"Gets the current scroll position.","ref":"Raxol.Terminal.Integration.State.html#get_scroll_position/1","title":"Raxol.Terminal.Integration.State.get_scroll_position/1","type":"function"},{"doc":"Gets the visible content from the current window.","ref":"Raxol.Terminal.Integration.State.html#get_visible_content/1","title":"Raxol.Terminal.Integration.State.get_visible_content/1","type":"function"},{"doc":"Creates a new integration state with the given options.","ref":"Raxol.Terminal.Integration.State.html#new/1","title":"Raxol.Terminal.Integration.State.new/1","type":"function"},{"doc":"Renders the current state.","ref":"Raxol.Terminal.Integration.State.html#render/1","title":"Raxol.Terminal.Integration.State.render/1","type":"function"},{"doc":"Resizes the terminal.","ref":"Raxol.Terminal.Integration.State.html#resize/3","title":"Raxol.Terminal.Integration.State.resize/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Integration.State.html#t:t/0","title":"Raxol.Terminal.Integration.State.t/0","type":"type"},{"doc":"Updates the integration state with new content.","ref":"Raxol.Terminal.Integration.State.html#update/2","title":"Raxol.Terminal.Integration.State.update/2","type":"function"},{"doc":"Updates the renderer configuration.","ref":"Raxol.Terminal.Integration.State.html#update_renderer_config/2","title":"Raxol.Terminal.Integration.State.update_renderer_config/2","type":"function"},{"doc":"Terminal manager module.\n\nThis module manages terminal sessions, including:\n- Session creation\n- Session destruction\n- Session listing\n- Session monitoring","ref":"Raxol.Terminal.Manager.html","title":"Raxol.Terminal.Manager","type":"module"},{"doc":"The manager processes terminal events using pattern matching on the canonical `Raxol.Core.Events.Event` struct. Each event type (e.g., `:window`, `:mode`, `:focus`, `:clipboard`, `:selection`, `:paste`, `:cursor`, `:scroll`) is handled with clear, semantic matches on the expected data fields.\n\nFor each event, the manager:\n- Updates the terminal state as needed\n- Notifies the runtime process (if present) via message passing\n- Logs the event using `Raxol.Core.Runtime.Log`\n- Emits a Telemetry event for observability\n- Calls a user-defined callback module (if provided)","ref":"Raxol.Terminal.Manager.html#module-event-handling-and-notification-system","title":"Event Handling and Notification System - Raxol.Terminal.Manager","type":"module"},{"doc":"To add a new event type:\n\n1. Add a new clause in the `handle_call({:process_event, %Raxol.Core.Events.Event{type: ..., data: ...}}, ...)` function.\n2. Add a corresponding notification helper (e.g., `notify_new_event/2`) if needed.\n3. Ensure the notification helper sends a message, logs, emits telemetry, and calls the callback module if present.","ref":"Raxol.Terminal.Manager.html#module-extending-event-handling","title":"Extending Event Handling - Raxol.Terminal.Manager","type":"module"},{"doc":"You can pass a `:callback_module` option to `start_link/1` to receive notifications for terminal events. The callback module must implement the `Raxol.Terminal.Manager.Callback` behaviour:\n\n    defmodule MyTerminalCallback do\n      @behaviour Raxol.Terminal.Manager.Callback\n\n      def focus_changed(focused, _state), do: IO.inspect({:focus, focused})\n      def resized(w, h, _state), do: IO.inspect({:resize, w, h})\n      # ...implement other callbacks as needed\n    end\n\n    {:ok, pid} = Raxol.Terminal.Manager.start_link(callback_module: MyTerminalCallback)","ref":"Raxol.Terminal.Manager.html#module-user-defined-callback-modules","title":"User-defined Callback Modules - Raxol.Terminal.Manager","type":"module"},{"doc":"Each notification emits a telemetry event under the `[:raxol, :terminal, ...]` prefix. You can attach handlers for metrics, tracing, or custom logic.","ref":"Raxol.Terminal.Manager.html#module-telemetry-events","title":"Telemetry Events - Raxol.Terminal.Manager","type":"module"},{"doc":"All notifications are logged at the info level for easy debugging and auditability.","ref":"Raxol.Terminal.Manager.html#module-logging","title":"Logging - Raxol.Terminal.Manager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Manager.html#child_spec/1","title":"Raxol.Terminal.Manager.child_spec/1","type":"function"},{"doc":"Gets the count of terminal sessions.","ref":"Raxol.Terminal.Manager.html#count_sessions/1","title":"Raxol.Terminal.Manager.count_sessions/1","type":"function"},{"doc":"iex> {:ok, pid} = Manager.start_link()\n    iex> {:ok, _} = Manager.create_session(pid)\n    iex> {:ok, _} = Manager.create_session(pid)\n    iex> Manager.count_sessions(pid)\n    2","ref":"Raxol.Terminal.Manager.html#count_sessions/1-examples","title":"Examples - Raxol.Terminal.Manager.count_sessions/1","type":"function"},{"doc":"Creates a new terminal session.","ref":"Raxol.Terminal.Manager.html#create_session/2","title":"Raxol.Terminal.Manager.create_session/2","type":"function"},{"doc":"iex> {:ok, pid} = Manager.start_link()\n    iex> {:ok, session_id} = Manager.create_session(pid, %{width: 80, height: 24})\n    iex> is_binary(session_id)\n    true","ref":"Raxol.Terminal.Manager.html#create_session/2-examples","title":"Examples - Raxol.Terminal.Manager.create_session/2","type":"function"},{"doc":"Destroys a terminal session.","ref":"Raxol.Terminal.Manager.html#destroy_session/2","title":"Raxol.Terminal.Manager.destroy_session/2","type":"function"},{"doc":"iex> {:ok, pid} = Manager.start_link()\n    iex> {:ok, session_id} = Manager.create_session(pid)\n    iex> :ok = Manager.destroy_session(pid, session_id)\n    iex> Manager.get_session(pid, session_id)\n    {:error, :not_found}","ref":"Raxol.Terminal.Manager.html#destroy_session/2-examples","title":"Examples - Raxol.Terminal.Manager.destroy_session/2","type":"function"},{"doc":"Gets a terminal session by ID.","ref":"Raxol.Terminal.Manager.html#get_session/2","title":"Raxol.Terminal.Manager.get_session/2","type":"function"},{"doc":"iex> {:ok, pid} = Manager.start_link()\n    iex> {:ok, session_id} = Manager.create_session(pid)\n    iex> {:ok, session} = Manager.get_session(pid, session_id)\n    iex> session.id\n    session_id","ref":"Raxol.Terminal.Manager.html#get_session/2-examples","title":"Examples - Raxol.Terminal.Manager.get_session/2","type":"function"},{"doc":"Lists all terminal sessions.","ref":"Raxol.Terminal.Manager.html#list_sessions/1","title":"Raxol.Terminal.Manager.list_sessions/1","type":"function"},{"doc":"iex> {:ok, pid} = Manager.start_link()\n    iex> {:ok, session_id1} = Manager.create_session(pid)\n    iex> {:ok, session_id2} = Manager.create_session(pid)\n    iex> sessions = Manager.list_sessions(pid)\n    iex> length(sessions)\n    2","ref":"Raxol.Terminal.Manager.html#list_sessions/1-examples","title":"Examples - Raxol.Terminal.Manager.list_sessions/1","type":"function"},{"doc":"Monitors a terminal session.","ref":"Raxol.Terminal.Manager.html#monitor_session/2","title":"Raxol.Terminal.Manager.monitor_session/2","type":"function"},{"doc":"iex> {:ok, pid} = Manager.start_link()\n    iex> {:ok, session_id} = Manager.create_session(pid)\n    iex> :ok = Manager.monitor_session(pid, session_id)\n    iex> Process.whereis({:via, Registry, {Registry, session_id}})\n    #PID<0.123.0>","ref":"Raxol.Terminal.Manager.html#monitor_session/2-examples","title":"Examples - Raxol.Terminal.Manager.monitor_session/2","type":"function"},{"doc":"Starts the terminal manager.","ref":"Raxol.Terminal.Manager.html#start_link/1","title":"Raxol.Terminal.Manager.start_link/1","type":"function"},{"doc":"* `:terminal` - The initial terminal emulator state (required for single-terminal mode)\n  * `:runtime_pid` - The runtime process PID (optional)\n  * `:callback_module` - The callback module for the manager (optional)","ref":"Raxol.Terminal.Manager.html#start_link/1-options","title":"Options - Raxol.Terminal.Manager.start_link/1","type":"function"},{"doc":"iex> {:ok, pid} = Manager.start_link(terminal: term, runtime_pid: self())\n    iex> Process.alive?(pid)\n    true","ref":"Raxol.Terminal.Manager.html#start_link/1-examples","title":"Examples - Raxol.Terminal.Manager.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Manager.html#t:t/0","title":"Raxol.Terminal.Manager.t/0","type":"type"},{"doc":"Unmonitors a terminal session.","ref":"Raxol.Terminal.Manager.html#unmonitor_session/2","title":"Raxol.Terminal.Manager.unmonitor_session/2","type":"function"},{"doc":"iex> {:ok, pid} = Manager.start_link()\n    iex> {:ok, session_id} = Manager.create_session(pid)\n    iex> :ok = Manager.monitor_session(pid, session_id)\n    iex> :ok = Manager.unmonitor_session(pid, session_id)\n    iex> Process.whereis({:via, Registry, {Registry, session_id}})\n    nil","ref":"Raxol.Terminal.Manager.html#unmonitor_session/2-examples","title":"Examples - Raxol.Terminal.Manager.unmonitor_session/2","type":"function"},{"doc":"Behaviour for terminal manager event callbacks. Implement this behaviour to receive notifications for terminal events.","ref":"Raxol.Terminal.Manager.Callback.html","title":"Raxol.Terminal.Manager.Callback","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.Manager.Callback.html#c:clipboard_event/3","title":"Raxol.Terminal.Manager.Callback.clipboard_event/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Manager.Callback.html#c:cursor_event/2","title":"Raxol.Terminal.Manager.Callback.cursor_event/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Manager.Callback.html#c:focus_changed/2","title":"Raxol.Terminal.Manager.Callback.focus_changed/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Manager.Callback.html#c:mode_changed/2","title":"Raxol.Terminal.Manager.Callback.mode_changed/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Manager.Callback.html#c:paste_event/3","title":"Raxol.Terminal.Manager.Callback.paste_event/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Manager.Callback.html#c:resized/3","title":"Raxol.Terminal.Manager.Callback.resized/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Manager.Callback.html#c:scroll_event/4","title":"Raxol.Terminal.Manager.Callback.scroll_event/4","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Manager.Callback.html#c:selection_changed/2","title":"Raxol.Terminal.Manager.Callback.selection_changed/2","type":"callback"},{"doc":"Handles terminal events and dispatches them to appropriate handlers.","ref":"Raxol.Terminal.Manager.EventHandler.html","title":"Raxol.Terminal.Manager.EventHandler","type":"module"},{"doc":"Handles a terminal event.","ref":"Raxol.Terminal.Manager.EventHandler.html#handle_event/2","title":"Raxol.Terminal.Manager.EventHandler.handle_event/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Manager.EventHandler.html#process_event/2","title":"Raxol.Terminal.Manager.EventHandler.process_event/2","type":"function"},{"doc":"Handles screen updates and batch operations.\n\nThis module is responsible for:\n- Processing screen updates\n- Handling batch screen updates\n- Managing screen state transitions\n- Coordinating with notification system","ref":"Raxol.Terminal.Manager.ScreenHandler.html","title":"Raxol.Terminal.Manager.ScreenHandler","type":"module"},{"doc":"Processes a batch of screen updates and returns updated state.","ref":"Raxol.Terminal.Manager.ScreenHandler.html#process_batch_updates/2","title":"Raxol.Terminal.Manager.ScreenHandler.process_batch_updates/2","type":"function"},{"doc":"Processes a single screen update and returns updated state.","ref":"Raxol.Terminal.Manager.ScreenHandler.html#process_update/2","title":"Raxol.Terminal.Manager.ScreenHandler.process_update/2","type":"function"},{"doc":"Handles terminal session management.\n\nThis module is responsible for:\n- Creating new sessions\n- Destroying sessions\n- Managing session state\n- Handling session monitoring","ref":"Raxol.Terminal.Manager.SessionHandler.html","title":"Raxol.Terminal.Manager.SessionHandler","type":"module"},{"doc":"Gets the count of terminal sessions.","ref":"Raxol.Terminal.Manager.SessionHandler.html#count_sessions/1","title":"Raxol.Terminal.Manager.SessionHandler.count_sessions/1","type":"function"},{"doc":"Creates a new terminal session.","ref":"Raxol.Terminal.Manager.SessionHandler.html#create_session/2","title":"Raxol.Terminal.Manager.SessionHandler.create_session/2","type":"function"},{"doc":"Destroys a terminal session.","ref":"Raxol.Terminal.Manager.SessionHandler.html#destroy_session/2","title":"Raxol.Terminal.Manager.SessionHandler.destroy_session/2","type":"function"},{"doc":"Gets a terminal session by ID.","ref":"Raxol.Terminal.Manager.SessionHandler.html#get_session/2","title":"Raxol.Terminal.Manager.SessionHandler.get_session/2","type":"function"},{"doc":"Handles a session process down event.","ref":"Raxol.Terminal.Manager.SessionHandler.html#handle_session_down/2","title":"Raxol.Terminal.Manager.SessionHandler.handle_session_down/2","type":"function"},{"doc":"Lists all terminal sessions.","ref":"Raxol.Terminal.Manager.SessionHandler.html#list_sessions/1","title":"Raxol.Terminal.Manager.SessionHandler.list_sessions/1","type":"function"},{"doc":"Monitors a terminal session.","ref":"Raxol.Terminal.Manager.SessionHandler.html#monitor_session/2","title":"Raxol.Terminal.Manager.SessionHandler.monitor_session/2","type":"function"},{"doc":"Unmonitors a terminal session.","ref":"Raxol.Terminal.Manager.SessionHandler.html#unmonitor_session/2","title":"Raxol.Terminal.Manager.SessionHandler.unmonitor_session/2","type":"function"},{"doc":"Manages memory usage and limits for the terminal emulator.","ref":"Raxol.Terminal.MemoryManager.html","title":"Raxol.Terminal.MemoryManager","type":"module"},{"doc":"Checks and cleans up memory if needed.","ref":"Raxol.Terminal.MemoryManager.html#check_and_cleanup/1","title":"Raxol.Terminal.MemoryManager.check_and_cleanup/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.MemoryManager.html#child_spec/1","title":"Raxol.Terminal.MemoryManager.child_spec/1","type":"function"},{"doc":"Gets the current memory usage.","ref":"Raxol.Terminal.MemoryManager.html#get_memory_usage/1","title":"Raxol.Terminal.MemoryManager.get_memory_usage/1","type":"function"},{"doc":"Checks if scrolling is needed based on memory usage.","ref":"Raxol.Terminal.MemoryManager.html#should_scroll?/2","title":"Raxol.Terminal.MemoryManager.should_scroll?/2","type":"function"},{"doc":"Starts the memory manager process.","ref":"Raxol.Terminal.MemoryManager.html#start_link/0","title":"Raxol.Terminal.MemoryManager.start_link/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.MemoryManager.html#t:t/0","title":"Raxol.Terminal.MemoryManager.t/0","type":"type"},{"doc":"Updates memory usage for the given state.","ref":"Raxol.Terminal.MemoryManager.html#update_usage/1","title":"Raxol.Terminal.MemoryManager.update_usage/1","type":"function"},{"doc":"Checks if the current memory usage is within limits.","ref":"Raxol.Terminal.MemoryManager.html#within_limits?/2","title":"Raxol.Terminal.MemoryManager.within_limits?/2","type":"function"},{"doc":"Manages terminal metrics and statistics collection, including performance\nmetrics, usage statistics, and error tracking.","ref":"Raxol.Terminal.Metrics.Manager.html","title":"Raxol.Terminal.Metrics.Manager","type":"module"},{"doc":"","ref":"Raxol.Terminal.Metrics.Manager.html#t:custom_metrics/0","title":"Raxol.Terminal.Metrics.Manager.custom_metrics/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Metrics.Manager.html#t:error_log/0","title":"Raxol.Terminal.Metrics.Manager.error_log/0","type":"type"},{"doc":"Gets the average characters processed per second.","ref":"Raxol.Terminal.Metrics.Manager.html#get_characters_per_second/1","title":"Raxol.Terminal.Metrics.Manager.get_characters_per_second/1","type":"function"},{"doc":"Gets the average commands processed per second.","ref":"Raxol.Terminal.Metrics.Manager.html#get_commands_per_second/1","title":"Raxol.Terminal.Metrics.Manager.get_commands_per_second/1","type":"function"},{"doc":"Gets a custom metric value.","ref":"Raxol.Terminal.Metrics.Manager.html#get_custom_metric/2","title":"Raxol.Terminal.Metrics.Manager.get_custom_metric/2","type":"function"},{"doc":"Gets the error log.","ref":"Raxol.Terminal.Metrics.Manager.html#get_error_log/1","title":"Raxol.Terminal.Metrics.Manager.get_error_log/1","type":"function"},{"doc":"Gets the error rate (errors per second).","ref":"Raxol.Terminal.Metrics.Manager.html#get_error_rate/1","title":"Raxol.Terminal.Metrics.Manager.get_error_rate/1","type":"function"},{"doc":"Gets the current performance metrics.","ref":"Raxol.Terminal.Metrics.Manager.html#get_performance_metrics/1","title":"Raxol.Terminal.Metrics.Manager.get_performance_metrics/1","type":"function"},{"doc":"Gets the uptime in milliseconds.","ref":"Raxol.Terminal.Metrics.Manager.html#get_uptime/1","title":"Raxol.Terminal.Metrics.Manager.get_uptime/1","type":"function"},{"doc":"Gets the current usage statistics.","ref":"Raxol.Terminal.Metrics.Manager.html#get_usage_stats/1","title":"Raxol.Terminal.Metrics.Manager.get_usage_stats/1","type":"function"},{"doc":"Creates a new metrics manager instance.","ref":"Raxol.Terminal.Metrics.Manager.html#new/0","title":"Raxol.Terminal.Metrics.Manager.new/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Metrics.Manager.html#t:performance_metrics/0","title":"Raxol.Terminal.Metrics.Manager.performance_metrics/0","type":"type"},{"doc":"Records the processing of characters.","ref":"Raxol.Terminal.Metrics.Manager.html#record_characters/2","title":"Raxol.Terminal.Metrics.Manager.record_characters/2","type":"function"},{"doc":"Records the processing of a command.","ref":"Raxol.Terminal.Metrics.Manager.html#record_command/2","title":"Raxol.Terminal.Metrics.Manager.record_command/2","type":"function"},{"doc":"Records an error occurrence.","ref":"Raxol.Terminal.Metrics.Manager.html#record_error/4","title":"Raxol.Terminal.Metrics.Manager.record_error/4","type":"function"},{"doc":"Records feature usage.","ref":"Raxol.Terminal.Metrics.Manager.html#record_feature_usage/2","title":"Raxol.Terminal.Metrics.Manager.record_feature_usage/2","type":"function"},{"doc":"Resets all metrics to their initial state.","ref":"Raxol.Terminal.Metrics.Manager.html#reset/1","title":"Raxol.Terminal.Metrics.Manager.reset/1","type":"function"},{"doc":"Adds or updates a custom metric.","ref":"Raxol.Terminal.Metrics.Manager.html#set_custom_metric/3","title":"Raxol.Terminal.Metrics.Manager.set_custom_metric/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Metrics.Manager.html#t:t/0","title":"Raxol.Terminal.Metrics.Manager.t/0","type":"type"},{"doc":"Updates performance metrics.","ref":"Raxol.Terminal.Metrics.Manager.html#update_performance_metrics/2","title":"Raxol.Terminal.Metrics.Manager.update_performance_metrics/2","type":"function"},{"doc":"Updates usage statistics.","ref":"Raxol.Terminal.Metrics.Manager.html#update_usage_stats/2","title":"Raxol.Terminal.Metrics.Manager.update_usage_stats/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Metrics.Manager.html#t:usage_stats/0","title":"Raxol.Terminal.Metrics.Manager.usage_stats/0","type":"type"},{"doc":"Unified metrics system for the Raxol terminal emulator.\nThis module provides centralized metrics collection for:\n- Performance metrics (response times, throughput)\n- Resource usage (memory, CPU)\n- Error tracking\n- Usage statistics","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html","title":"Raxol.Terminal.Metrics.UnifiedMetrics","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#child_spec/1","title":"Raxol.Terminal.Metrics.UnifiedMetrics.child_spec/1","type":"function"},{"doc":"Cleans up old metrics.","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#cleanup_metrics/1","title":"Raxol.Terminal.Metrics.UnifiedMetrics.cleanup_metrics/1","type":"function"},{"doc":"* `opts` - Cleanup options\n    * `:before` - Timestamp before which to clean up","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#cleanup_metrics/1-parameters","title":"Parameters - Raxol.Terminal.Metrics.UnifiedMetrics.cleanup_metrics/1","type":"function"},{"doc":"Exports metrics in the configured format.","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#export_metrics/1","title":"Raxol.Terminal.Metrics.UnifiedMetrics.export_metrics/1","type":"function"},{"doc":"* `opts` - Export options\n    * `:format` - Override the default export format\n    * `:time_range` - Time range to export","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#export_metrics/1-parameters","title":"Parameters - Raxol.Terminal.Metrics.UnifiedMetrics.export_metrics/1","type":"function"},{"doc":"Gets error statistics.","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#get_error_stats/1","title":"Raxol.Terminal.Metrics.UnifiedMetrics.get_error_stats/1","type":"function"},{"doc":"* `opts` - Get options\n    * `:time_range` - Time range to query\n    * `:severity` - Filter by severity","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#get_error_stats/1-parameters","title":"Parameters - Raxol.Terminal.Metrics.UnifiedMetrics.get_error_stats/1","type":"function"},{"doc":"Gets the current value of a metric.","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#get_metric/2","title":"Raxol.Terminal.Metrics.UnifiedMetrics.get_metric/2","type":"function"},{"doc":"* `name` - The metric name\n  * `opts` - Get options\n    * `:labels` - Filter by labels\n    * `:time_range` - Time range to query","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#get_metric/2-parameters","title":"Parameters - Raxol.Terminal.Metrics.UnifiedMetrics.get_metric/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#t:metric_config/0","title":"Raxol.Terminal.Metrics.UnifiedMetrics.metric_config/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#t:metric_id/0","title":"Raxol.Terminal.Metrics.UnifiedMetrics.metric_id/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#t:metric_state/0","title":"Raxol.Terminal.Metrics.UnifiedMetrics.metric_state/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#t:metric_type/0","title":"Raxol.Terminal.Metrics.UnifiedMetrics.metric_type/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#t:metric_value/0","title":"Raxol.Terminal.Metrics.UnifiedMetrics.metric_value/0","type":"type"},{"doc":"Records an error event.","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#record_error/2","title":"Raxol.Terminal.Metrics.UnifiedMetrics.record_error/2","type":"function"},{"doc":"* `error` - The error to record\n  * `opts` - Recording options\n    * `:severity` - Error severity\n    * `:context` - Error context\n    * `:metadata` - Additional metadata","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#record_error/2-parameters","title":"Parameters - Raxol.Terminal.Metrics.UnifiedMetrics.record_error/2","type":"function"},{"doc":"Records a metric value.","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#record_metric/3","title":"Raxol.Terminal.Metrics.UnifiedMetrics.record_metric/3","type":"function"},{"doc":"* `name` - The metric name\n  * `value` - The metric value\n  * `opts` - Recording options\n    * `:type` - Metric type (:counter, :gauge, :histogram, :summary)\n    * `:labels` - Metric labels\n    * `:metadata` - Additional metadata","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#record_metric/3-parameters","title":"Parameters - Raxol.Terminal.Metrics.UnifiedMetrics.record_metric/3","type":"function"},{"doc":"Starts the unified metrics manager.","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#start_link/1","title":"Raxol.Terminal.Metrics.UnifiedMetrics.start_link/1","type":"function"},{"doc":"* `:retention_period` - How long to keep metrics (in milliseconds)\n  * `:aggregation_interval` - How often to aggregate metrics (in milliseconds)\n  * `:alert_thresholds` - Thresholds for alerting\n  * `:export_format` - Format for exporting metrics","ref":"Raxol.Terminal.Metrics.UnifiedMetrics.html#start_link/1-options","title":"Options - Raxol.Terminal.Metrics.UnifiedMetrics.start_link/1","type":"function"},{"doc":"Manages terminal modes for the terminal emulator.","ref":"Raxol.Terminal.Mode.Manager.html","title":"Raxol.Terminal.Mode.Manager","type":"module"},{"doc":"Gets the mode manager from an emulator.","ref":"Raxol.Terminal.Mode.Manager.html#get_manager/1","title":"Raxol.Terminal.Mode.Manager.get_manager/1","type":"function"},{"doc":"Gets all set modes.","ref":"Raxol.Terminal.Mode.Manager.html#get_set_modes/1","title":"Raxol.Terminal.Mode.Manager.get_set_modes/1","type":"function"},{"doc":"Checks if a mode is set.","ref":"Raxol.Terminal.Mode.Manager.html#mode_set?/2","title":"Raxol.Terminal.Mode.Manager.mode_set?/2","type":"function"},{"doc":"Creates a new mode manager.","ref":"Raxol.Terminal.Mode.Manager.html#new/0","title":"Raxol.Terminal.Mode.Manager.new/0","type":"function"},{"doc":"Resets all modes.","ref":"Raxol.Terminal.Mode.Manager.html#reset_all_modes/1","title":"Raxol.Terminal.Mode.Manager.reset_all_modes/1","type":"function"},{"doc":"Resets a mode in the mode manager.","ref":"Raxol.Terminal.Mode.Manager.html#reset_mode/2","title":"Raxol.Terminal.Mode.Manager.reset_mode/2","type":"function"},{"doc":"Restores previously saved modes.","ref":"Raxol.Terminal.Mode.Manager.html#restore_modes/1","title":"Raxol.Terminal.Mode.Manager.restore_modes/1","type":"function"},{"doc":"Saves the current modes.","ref":"Raxol.Terminal.Mode.Manager.html#save_modes/1","title":"Raxol.Terminal.Mode.Manager.save_modes/1","type":"function"},{"doc":"Sets a mode in the mode manager.","ref":"Raxol.Terminal.Mode.Manager.html#set_mode/3","title":"Raxol.Terminal.Mode.Manager.set_mode/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Mode.Manager.html#t:t/0","title":"Raxol.Terminal.Mode.Manager.t/0","type":"type"},{"doc":"Updates the mode manager in an emulator.","ref":"Raxol.Terminal.Mode.Manager.html#update_manager/2","title":"Raxol.Terminal.Mode.Manager.update_manager/2","type":"function"},{"doc":"Manages terminal modes (DEC Private Modes, Standard Modes) and their effects.\n\nThis module centralizes the state and logic for various terminal modes,\nhandling both simple flag toggles and modes with side effects on the\nemulator state (like screen buffer switching or resizing).","ref":"Raxol.Terminal.ModeManager.html","title":"Raxol.Terminal.ModeManager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.ModeManager.html#child_spec/1","title":"Raxol.Terminal.ModeManager.child_spec/1","type":"function"},{"doc":"Gets the mode manager.","ref":"Raxol.Terminal.ModeManager.html#get_manager/1","title":"Raxol.Terminal.ModeManager.get_manager/1","type":"function"},{"doc":"Gets the set modes.","ref":"Raxol.Terminal.ModeManager.html#get_set_modes/1","title":"Raxol.Terminal.ModeManager.get_set_modes/1","type":"function"},{"doc":"Looks up a DEC private mode code and returns the corresponding mode atom.","ref":"Raxol.Terminal.ModeManager.html#lookup_private/1","title":"Raxol.Terminal.ModeManager.lookup_private/1","type":"function"},{"doc":"Looks up a standard mode code and returns the corresponding mode atom.","ref":"Raxol.Terminal.ModeManager.html#lookup_standard/1","title":"Raxol.Terminal.ModeManager.lookup_standard/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ModeManager.html#t:mode/0","title":"Raxol.Terminal.ModeManager.mode/0","type":"type"},{"doc":"Checks if a mode is enabled.","ref":"Raxol.Terminal.ModeManager.html#mode_enabled?/2","title":"Raxol.Terminal.ModeManager.mode_enabled?/2","type":"function"},{"doc":"Checks if the given mode is set.","ref":"Raxol.Terminal.ModeManager.html#mode_set?/2","title":"Raxol.Terminal.ModeManager.mode_set?/2","type":"function"},{"doc":"Creates a new instance of the ModeManager.","ref":"Raxol.Terminal.ModeManager.html#new/0","title":"Raxol.Terminal.ModeManager.new/0","type":"function"},{"doc":"Resets all modes.","ref":"Raxol.Terminal.ModeManager.html#reset_all_modes/1","title":"Raxol.Terminal.ModeManager.reset_all_modes/1","type":"function"},{"doc":"Resets one or more modes. Dispatches to specific handlers.\nReturns potentially updated Emulator state if side effects occurred.","ref":"Raxol.Terminal.ModeManager.html#reset_mode/2","title":"Raxol.Terminal.ModeManager.reset_mode/2","type":"function"},{"doc":"Restores the saved modes.","ref":"Raxol.Terminal.ModeManager.html#restore_modes/1","title":"Raxol.Terminal.ModeManager.restore_modes/1","type":"function"},{"doc":"Restores the previously saved terminal state.","ref":"Raxol.Terminal.ModeManager.html#restore_state/1","title":"Raxol.Terminal.ModeManager.restore_state/1","type":"function"},{"doc":"Saves the current modes.","ref":"Raxol.Terminal.ModeManager.html#save_modes/1","title":"Raxol.Terminal.ModeManager.save_modes/1","type":"function"},{"doc":"Saves the current terminal state.","ref":"Raxol.Terminal.ModeManager.html#save_state/1","title":"Raxol.Terminal.ModeManager.save_state/1","type":"function"},{"doc":"Sets one or more modes. Dispatches to specific handlers.\nReturns potentially updated Emulator state if side effects occurred.","ref":"Raxol.Terminal.ModeManager.html#set_mode/2","title":"Raxol.Terminal.ModeManager.set_mode/2","type":"function"},{"doc":"Sets a mode with a value and private flag.","ref":"Raxol.Terminal.ModeManager.html#set_mode/4","title":"Raxol.Terminal.ModeManager.set_mode/4","type":"function"},{"doc":"Sets a private mode with a value.","ref":"Raxol.Terminal.ModeManager.html#set_private_mode/3","title":"Raxol.Terminal.ModeManager.set_private_mode/3","type":"function"},{"doc":"Sets a standard mode with a value.","ref":"Raxol.Terminal.ModeManager.html#set_standard_mode/3","title":"Raxol.Terminal.ModeManager.set_standard_mode/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.ModeManager.html#t:t/0","title":"Raxol.Terminal.ModeManager.t/0","type":"type"},{"doc":"Updates the mode manager.","ref":"Raxol.Terminal.ModeManager.html#update_manager/2","title":"Raxol.Terminal.ModeManager.update_manager/2","type":"function"},{"doc":"Handles saved state operations for the mode manager.\nThis includes saving and restoring cursor positions, screen states, and other terminal modes.","ref":"Raxol.Terminal.ModeManager.SavedState.html","title":"Raxol.Terminal.ModeManager.SavedState","type":"module"},{"doc":"Restores the previously saved terminal state.","ref":"Raxol.Terminal.ModeManager.SavedState.html#restore_state/1","title":"Raxol.Terminal.ModeManager.SavedState.restore_state/1","type":"function"},{"doc":"Saves the current terminal state.\nThis includes:\n- Cursor position and attributes\n- Screen state (main/alternate)\n- Current modes","ref":"Raxol.Terminal.ModeManager.SavedState.html#save_state/1","title":"Raxol.Terminal.ModeManager.SavedState.save_state/1","type":"function"},{"doc":"Manages terminal mode state and transitions.\n\nThis module is responsible for:\n- Managing mode state\n- Handling mode transitions\n- Validating mode changes\n- Providing mode state queries","ref":"Raxol.Terminal.ModeState.html","title":"Raxol.Terminal.ModeState","type":"module"},{"doc":"Looks up a DEC private mode code and returns the corresponding mode atom.","ref":"Raxol.Terminal.ModeState.html#lookup_private/1","title":"Raxol.Terminal.ModeState.lookup_private/1","type":"function"},{"doc":"Looks up a standard mode code and returns the corresponding mode atom.","ref":"Raxol.Terminal.ModeState.html#lookup_standard/1","title":"Raxol.Terminal.ModeState.lookup_standard/1","type":"function"},{"doc":"Checks if a specific mode is enabled.","ref":"Raxol.Terminal.ModeState.html#mode_enabled?/2","title":"Raxol.Terminal.ModeState.mode_enabled?/2","type":"function"},{"doc":"* `state` - The current mode state\n  * `mode` - The mode to check","ref":"Raxol.Terminal.ModeState.html#mode_enabled?/2-parameters","title":"Parameters - Raxol.Terminal.ModeState.mode_enabled?/2","type":"function"},{"doc":"* `boolean()` - Whether the mode is enabled","ref":"Raxol.Terminal.ModeState.html#mode_enabled?/2-returns","title":"Returns - Raxol.Terminal.ModeState.mode_enabled?/2","type":"function"},{"doc":"Creates a new mode state with default values.","ref":"Raxol.Terminal.ModeState.html#new/0","title":"Raxol.Terminal.ModeState.new/0","type":"function"},{"doc":"Resets the alternate buffer mode.","ref":"Raxol.Terminal.ModeState.html#reset_alternate_buffer_mode/1","title":"Raxol.Terminal.ModeState.reset_alternate_buffer_mode/1","type":"function"},{"doc":"* `state` - The current mode state","ref":"Raxol.Terminal.ModeState.html#reset_alternate_buffer_mode/1-parameters","title":"Parameters - Raxol.Terminal.ModeState.reset_alternate_buffer_mode/1","type":"function"},{"doc":"* `t()` - The updated mode state","ref":"Raxol.Terminal.ModeState.html#reset_alternate_buffer_mode/1-returns","title":"Returns - Raxol.Terminal.ModeState.reset_alternate_buffer_mode/1","type":"function"},{"doc":"Resets a mode to disabled state.","ref":"Raxol.Terminal.ModeState.html#reset_mode/2","title":"Raxol.Terminal.ModeState.reset_mode/2","type":"function"},{"doc":"* `state` - The current mode state\n  * `mode` - The mode to disable","ref":"Raxol.Terminal.ModeState.html#reset_mode/2-parameters","title":"Parameters - Raxol.Terminal.ModeState.reset_mode/2","type":"function"},{"doc":"* `t()` - The updated mode state","ref":"Raxol.Terminal.ModeState.html#reset_mode/2-returns","title":"Returns - Raxol.Terminal.ModeState.reset_mode/2","type":"function"},{"doc":"Sets the alternate buffer mode.","ref":"Raxol.Terminal.ModeState.html#set_alternate_buffer_mode/2","title":"Raxol.Terminal.ModeState.set_alternate_buffer_mode/2","type":"function"},{"doc":"* `state` - The current mode state\n  * `type` - The alternate buffer mode type","ref":"Raxol.Terminal.ModeState.html#set_alternate_buffer_mode/2-parameters","title":"Parameters - Raxol.Terminal.ModeState.set_alternate_buffer_mode/2","type":"function"},{"doc":"* `t()` - The updated mode state","ref":"Raxol.Terminal.ModeState.html#set_alternate_buffer_mode/2-returns","title":"Returns - Raxol.Terminal.ModeState.set_alternate_buffer_mode/2","type":"function"},{"doc":"Sets a mode to enabled state.","ref":"Raxol.Terminal.ModeState.html#set_mode/2","title":"Raxol.Terminal.ModeState.set_mode/2","type":"function"},{"doc":"* `state` - The current mode state\n  * `mode` - The mode to enable","ref":"Raxol.Terminal.ModeState.html#set_mode/2-parameters","title":"Parameters - Raxol.Terminal.ModeState.set_mode/2","type":"function"},{"doc":"* `t()` - The updated mode state","ref":"Raxol.Terminal.ModeState.html#set_mode/2-returns","title":"Returns - Raxol.Terminal.ModeState.set_mode/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ModeState.html#t:t/0","title":"Raxol.Terminal.ModeState.t/0","type":"type"},{"doc":"Handles terminal modes and state transitions for the terminal emulator.\n\nThis module provides functions for managing terminal modes, processing\nescape sequences, and handling terminal state transitions.","ref":"Raxol.Terminal.Modes.html","title":"Raxol.Terminal.Modes","type":"module"},{"doc":"Checks if a terminal mode is active.","ref":"Raxol.Terminal.Modes.html#active?/2","title":"Raxol.Terminal.Modes.active?/2","type":"function"},{"doc":"iex> modes = Modes.new()\n    iex> Modes.active?(modes, :normal)\n    true\n    iex> Modes.active?(modes, :insert)\n    false","ref":"Raxol.Terminal.Modes.html#active?/2-examples","title":"Examples - Raxol.Terminal.Modes.active?/2","type":"function"},{"doc":"Returns a list of all active terminal modes.","ref":"Raxol.Terminal.Modes.html#active_modes/1","title":"Raxol.Terminal.Modes.active_modes/1","type":"function"},{"doc":"iex> modes = Modes.new()\n    iex> Modes.active_modes(modes)\n    [:normal, :replace]","ref":"Raxol.Terminal.Modes.html#active_modes/1-examples","title":"Examples - Raxol.Terminal.Modes.active_modes/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Modes.html#t:mode/0","title":"Raxol.Terminal.Modes.mode/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Modes.html#t:mode_state/0","title":"Raxol.Terminal.Modes.mode_state/0","type":"type"},{"doc":"Creates a new terminal mode state.","ref":"Raxol.Terminal.Modes.html#new/0","title":"Raxol.Terminal.Modes.new/0","type":"function"},{"doc":"iex> modes = Modes.new()\n    iex> modes.insert\n    false","ref":"Raxol.Terminal.Modes.html#new/0-examples","title":"Examples - Raxol.Terminal.Modes.new/0","type":"function"},{"doc":"Processes an escape sequence for terminal mode changes.","ref":"Raxol.Terminal.Modes.html#process_escape/2","title":"Raxol.Terminal.Modes.process_escape/2","type":"function"},{"doc":"iex> modes = Modes.new()\n    iex> {modes, _} = Modes.process_escape(modes, \"?1049h\")\n    iex> Modes.active?(modes, :alternate_screen)\n    true","ref":"Raxol.Terminal.Modes.html#process_escape/2-examples","title":"Examples - Raxol.Terminal.Modes.process_escape/2","type":"function"},{"doc":"Resets a specific terminal mode to its default value.","ref":"Raxol.Terminal.Modes.html#reset_mode/2","title":"Raxol.Terminal.Modes.reset_mode/2","type":"function"},{"doc":"iex> modes = Modes.new() |> Modes.set_mode(:insert)\n    iex> modes.insert\n    true\n    iex> modes = Modes.reset_mode(modes, :insert)\n    iex> modes.insert\n    false\n    iex> modes = Modes.reset_mode(modes, :replace) # replace defaults to true\n    iex> modes.replace\n    true","ref":"Raxol.Terminal.Modes.html#reset_mode/2-examples","title":"Examples - Raxol.Terminal.Modes.reset_mode/2","type":"function"},{"doc":"Restores a previously saved terminal mode state.","ref":"Raxol.Terminal.Modes.html#restore_state/2","title":"Raxol.Terminal.Modes.restore_state/2","type":"function"},{"doc":"iex> modes = Modes.new()\n    iex> {modes, saved_modes} = Modes.save_state(modes)\n    iex> modes = Modes.set_mode(modes, :insert)\n    iex> modes = Modes.restore_state(modes, saved_modes)\n    iex> Modes.active?(modes, :normal)\n    true","ref":"Raxol.Terminal.Modes.html#restore_state/2-examples","title":"Examples - Raxol.Terminal.Modes.restore_state/2","type":"function"},{"doc":"Saves the current terminal mode state.","ref":"Raxol.Terminal.Modes.html#save_state/1","title":"Raxol.Terminal.Modes.save_state/1","type":"function"},{"doc":"iex> modes = Modes.new()\n    iex> {modes, saved_modes} = Modes.save_state(modes)\n    iex> modes = Modes.set_mode(modes, :insert)\n    iex> modes = Modes.restore_state(modes, saved_modes)\n    iex> Modes.active?(modes, :normal)\n    true","ref":"Raxol.Terminal.Modes.html#save_state/1-examples","title":"Examples - Raxol.Terminal.Modes.save_state/1","type":"function"},{"doc":"Sets a terminal mode.","ref":"Raxol.Terminal.Modes.html#set_mode/2","title":"Raxol.Terminal.Modes.set_mode/2","type":"function"},{"doc":"iex> modes = Modes.new()\n    iex> modes = Modes.set_mode(modes, :insert)\n    iex> modes.insert\n    true\n    iex> modes.replace\n    false","ref":"Raxol.Terminal.Modes.html#set_mode/2-examples","title":"Examples - Raxol.Terminal.Modes.set_mode/2","type":"function"},{"doc":"Returns a string representation of the terminal mode state.","ref":"Raxol.Terminal.Modes.html#to_string/1","title":"Raxol.Terminal.Modes.to_string/1","type":"function"},{"doc":"iex> modes = Modes.new()\n    iex> Modes.to_string(modes)\n    \"Terminal Modes: normal, replace\"","ref":"Raxol.Terminal.Modes.html#to_string/1-examples","title":"Examples - Raxol.Terminal.Modes.to_string/1","type":"function"},{"doc":"Handles DEC Private mode operations and their side effects.\nManages the implementation of DEC private mode changes and their effects on the terminal.","ref":"Raxol.Terminal.Modes.Handlers.DECPrivateHandler.html","title":"Raxol.Terminal.Modes.Handlers.DECPrivateHandler","type":"module"},{"doc":"Handles a DEC private mode change and applies its effects to the emulator.","ref":"Raxol.Terminal.Modes.Handlers.DECPrivateHandler.html#handle_mode_change/3","title":"Raxol.Terminal.Modes.Handlers.DECPrivateHandler.handle_mode_change/3","type":"function"},{"doc":"Handles mouse mode operations and their side effects.\nManages different mouse reporting modes and their effects on the terminal.","ref":"Raxol.Terminal.Modes.Handlers.MouseHandler.html","title":"Raxol.Terminal.Modes.Handlers.MouseHandler","type":"module"},{"doc":"Handles a mouse mode change and applies its effects to the emulator.","ref":"Raxol.Terminal.Modes.Handlers.MouseHandler.html#handle_mode_change/3","title":"Raxol.Terminal.Modes.Handlers.MouseHandler.handle_mode_change/3","type":"function"},{"doc":"Handles screen buffer mode operations and their side effects.\nManages alternate screen buffer switching and related functionality.","ref":"Raxol.Terminal.Modes.Handlers.ScreenBufferHandler.html","title":"Raxol.Terminal.Modes.Handlers.ScreenBufferHandler","type":"module"},{"doc":"Handles a screen buffer mode change and applies its effects to the emulator.","ref":"Raxol.Terminal.Modes.Handlers.ScreenBufferHandler.html#handle_mode_change/3","title":"Raxol.Terminal.Modes.Handlers.ScreenBufferHandler.handle_mode_change/3","type":"function"},{"doc":"Handles standard mode operations and their side effects.\nManages standard terminal modes like insert mode and line feed mode.","ref":"Raxol.Terminal.Modes.Handlers.StandardHandler.html","title":"Raxol.Terminal.Modes.Handlers.StandardHandler","type":"module"},{"doc":"Handles a standard mode change and applies its effects to the emulator.","ref":"Raxol.Terminal.Modes.Handlers.StandardHandler.html#handle_mode_change/3","title":"Raxol.Terminal.Modes.Handlers.StandardHandler.handle_mode_change/3","type":"function"},{"doc":"Manages the state of terminal modes, including transitions and validation.\nHandles mode dependencies, conflicts, and state persistence.","ref":"Raxol.Terminal.Modes.ModeStateManager.html","title":"Raxol.Terminal.Modes.ModeStateManager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Modes.ModeStateManager.html#child_spec/1","title":"Raxol.Terminal.Modes.ModeStateManager.child_spec/1","type":"function"},{"doc":"Checks if a mode is enabled.","ref":"Raxol.Terminal.Modes.ModeStateManager.html#mode_enabled?/2","title":"Raxol.Terminal.Modes.ModeStateManager.mode_enabled?/2","type":"function"},{"doc":"Creates a new mode state with default values.","ref":"Raxol.Terminal.Modes.ModeStateManager.html#new/0","title":"Raxol.Terminal.Modes.ModeStateManager.new/0","type":"function"},{"doc":"Resets a mode to its default value.","ref":"Raxol.Terminal.Modes.ModeStateManager.html#reset_mode/2","title":"Raxol.Terminal.Modes.ModeStateManager.reset_mode/2","type":"function"},{"doc":"Sets a mode to a specific value.","ref":"Raxol.Terminal.Modes.ModeStateManager.html#set_mode/3","title":"Raxol.Terminal.Modes.ModeStateManager.set_mode/3","type":"function"},{"doc":"Starts the ModeStateManager process.","ref":"Raxol.Terminal.Modes.ModeStateManager.html#start_link/1","title":"Raxol.Terminal.Modes.ModeStateManager.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Modes.ModeStateManager.html#t:t/0","title":"Raxol.Terminal.Modes.ModeStateManager.t/0","type":"type"},{"doc":"Defines types and constants for terminal modes.\nProvides a centralized registry of all terminal modes and their properties.","ref":"Raxol.Terminal.Modes.Types.ModeTypes.html","title":"Raxol.Terminal.Modes.Types.ModeTypes","type":"module"},{"doc":"Returns all registered modes.","ref":"Raxol.Terminal.Modes.Types.ModeTypes.html#get_all_modes/0","title":"Raxol.Terminal.Modes.Types.ModeTypes.get_all_modes/0","type":"function"},{"doc":"Returns all modes of a specific category.","ref":"Raxol.Terminal.Modes.Types.ModeTypes.html#get_modes_by_category/1","title":"Raxol.Terminal.Modes.Types.ModeTypes.get_modes_by_category/1","type":"function"},{"doc":"Looks up a DEC private mode code and returns the corresponding mode definition.","ref":"Raxol.Terminal.Modes.Types.ModeTypes.html#lookup_private/1","title":"Raxol.Terminal.Modes.Types.ModeTypes.lookup_private/1","type":"function"},{"doc":"Looks up a standard mode code and returns the corresponding mode definition.","ref":"Raxol.Terminal.Modes.Types.ModeTypes.html#lookup_standard/1","title":"Raxol.Terminal.Modes.Types.ModeTypes.lookup_standard/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Modes.Types.ModeTypes.html#t:mode/0","title":"Raxol.Terminal.Modes.Types.ModeTypes.mode/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Modes.Types.ModeTypes.html#t:mode_category/0","title":"Raxol.Terminal.Modes.Types.ModeTypes.mode_category/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Modes.Types.ModeTypes.html#t:mode_state/0","title":"Raxol.Terminal.Modes.Types.ModeTypes.mode_state/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Modes.Types.ModeTypes.html#t:mode_value/0","title":"Raxol.Terminal.Modes.Types.ModeTypes.mode_value/0","type":"type"},{"doc":"Manages mouse events and tracking in the terminal, including button clicks,\nmovement, and wheel events.","ref":"Raxol.Terminal.Mouse.Manager.html","title":"Raxol.Terminal.Mouse.Manager","type":"module"},{"doc":"","ref":"Raxol.Terminal.Mouse.Manager.html#t:button_state/0","title":"Raxol.Terminal.Mouse.Manager.button_state/0","type":"type"},{"doc":"Disables mouse tracking.","ref":"Raxol.Terminal.Mouse.Manager.html#disable/1","title":"Raxol.Terminal.Mouse.Manager.disable/1","type":"function"},{"doc":"Disables cell motion tracking.","ref":"Raxol.Terminal.Mouse.Manager.html#disable_cell_motion_tracking/1","title":"Raxol.Terminal.Mouse.Manager.disable_cell_motion_tracking/1","type":"function"},{"doc":"Disables highlight tracking.","ref":"Raxol.Terminal.Mouse.Manager.html#disable_highlight_tracking/1","title":"Raxol.Terminal.Mouse.Manager.disable_highlight_tracking/1","type":"function"},{"doc":"Disables pixel position tracking.","ref":"Raxol.Terminal.Mouse.Manager.html#disable_pixel_position_tracking/1","title":"Raxol.Terminal.Mouse.Manager.disable_pixel_position_tracking/1","type":"function"},{"doc":"Disables SGR mode.","ref":"Raxol.Terminal.Mouse.Manager.html#disable_sgr_mode/1","title":"Raxol.Terminal.Mouse.Manager.disable_sgr_mode/1","type":"function"},{"doc":"Disables URXVT mode.","ref":"Raxol.Terminal.Mouse.Manager.html#disable_urxvt_mode/1","title":"Raxol.Terminal.Mouse.Manager.disable_urxvt_mode/1","type":"function"},{"doc":"Enables mouse tracking.","ref":"Raxol.Terminal.Mouse.Manager.html#enable/1","title":"Raxol.Terminal.Mouse.Manager.enable/1","type":"function"},{"doc":"Enables cell motion tracking.","ref":"Raxol.Terminal.Mouse.Manager.html#enable_cell_motion_tracking/1","title":"Raxol.Terminal.Mouse.Manager.enable_cell_motion_tracking/1","type":"function"},{"doc":"Enables highlight tracking.","ref":"Raxol.Terminal.Mouse.Manager.html#enable_highlight_tracking/1","title":"Raxol.Terminal.Mouse.Manager.enable_highlight_tracking/1","type":"function"},{"doc":"Enables pixel position tracking.","ref":"Raxol.Terminal.Mouse.Manager.html#enable_pixel_position_tracking/1","title":"Raxol.Terminal.Mouse.Manager.enable_pixel_position_tracking/1","type":"function"},{"doc":"Enables SGR mode.","ref":"Raxol.Terminal.Mouse.Manager.html#enable_sgr_mode/1","title":"Raxol.Terminal.Mouse.Manager.enable_sgr_mode/1","type":"function"},{"doc":"Enables URXVT mode.","ref":"Raxol.Terminal.Mouse.Manager.html#enable_urxvt_mode/1","title":"Raxol.Terminal.Mouse.Manager.enable_urxvt_mode/1","type":"function"},{"doc":"Checks if mouse tracking is enabled.","ref":"Raxol.Terminal.Mouse.Manager.html#enabled?/1","title":"Raxol.Terminal.Mouse.Manager.enabled?/1","type":"function"},{"doc":"Gets the current button state.","ref":"Raxol.Terminal.Mouse.Manager.html#get_button_state/1","title":"Raxol.Terminal.Mouse.Manager.get_button_state/1","type":"function"},{"doc":"Gets the current mouse tracking mode.","ref":"Raxol.Terminal.Mouse.Manager.html#get_mode/1","title":"Raxol.Terminal.Mouse.Manager.get_mode/1","type":"function"},{"doc":"Gets the last known mouse position.","ref":"Raxol.Terminal.Mouse.Manager.html#get_position/1","title":"Raxol.Terminal.Mouse.Manager.get_position/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Mouse.Manager.html#t:mouse_mode/0","title":"Raxol.Terminal.Mouse.Manager.mouse_mode/0","type":"type"},{"doc":"Creates a new mouse manager instance.","ref":"Raxol.Terminal.Mouse.Manager.html#new/0","title":"Raxol.Terminal.Mouse.Manager.new/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Mouse.Manager.html#t:position/0","title":"Raxol.Terminal.Mouse.Manager.position/0","type":"type"},{"doc":"Resets the mouse manager to its initial state.","ref":"Raxol.Terminal.Mouse.Manager.html#reset/1","title":"Raxol.Terminal.Mouse.Manager.reset/1","type":"function"},{"doc":"Updates the button state.","ref":"Raxol.Terminal.Mouse.Manager.html#set_button_state/2","title":"Raxol.Terminal.Mouse.Manager.set_button_state/2","type":"function"},{"doc":"Sets the mouse tracking mode.","ref":"Raxol.Terminal.Mouse.Manager.html#set_mode/2","title":"Raxol.Terminal.Mouse.Manager.set_mode/2","type":"function"},{"doc":"Updates the last known mouse position.","ref":"Raxol.Terminal.Mouse.Manager.html#set_position/2","title":"Raxol.Terminal.Mouse.Manager.set_position/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Mouse.Manager.html#t:t/0","title":"Raxol.Terminal.Mouse.Manager.t/0","type":"type"},{"doc":"Provides unified mouse handling functionality for the terminal emulator.\nThis module handles mouse events, tracking, and state management.","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html","title":"Raxol.Terminal.Mouse.UnifiedMouse","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#child_spec/1","title":"Raxol.Terminal.Mouse.UnifiedMouse.child_spec/1","type":"function"},{"doc":"Cleans up resources.","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#cleanup/0","title":"Raxol.Terminal.Mouse.UnifiedMouse.cleanup/0","type":"function"},{"doc":"Closes a mouse context.","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#close_mouse/1","title":"Raxol.Terminal.Mouse.UnifiedMouse.close_mouse/1","type":"function"},{"doc":"Creates a new mouse context with the given configuration.","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#create_mouse/1","title":"Raxol.Terminal.Mouse.UnifiedMouse.create_mouse/1","type":"function"},{"doc":"Gets the active mouse context ID.","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#get_active_mouse/0","title":"Raxol.Terminal.Mouse.UnifiedMouse.get_active_mouse/0","type":"function"},{"doc":"Gets the list of all mouse contexts.","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#get_mice/0","title":"Raxol.Terminal.Mouse.UnifiedMouse.get_mice/0","type":"function"},{"doc":"Gets the current mouse button state.","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#get_mouse_button_state/1","title":"Raxol.Terminal.Mouse.UnifiedMouse.get_mouse_button_state/1","type":"function"},{"doc":"Gets the current mouse position.","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#get_mouse_position/1","title":"Raxol.Terminal.Mouse.UnifiedMouse.get_mouse_position/1","type":"function"},{"doc":"Gets the state of a specific mouse context.","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#get_mouse_state/1","title":"Raxol.Terminal.Mouse.UnifiedMouse.get_mouse_state/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#t:mouse_button/0","title":"Raxol.Terminal.Mouse.UnifiedMouse.mouse_button/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#t:mouse_config/0","title":"Raxol.Terminal.Mouse.UnifiedMouse.mouse_config/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#t:mouse_event/0","title":"Raxol.Terminal.Mouse.UnifiedMouse.mouse_event/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#t:mouse_id/0","title":"Raxol.Terminal.Mouse.UnifiedMouse.mouse_id/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#t:mouse_modifier/0","title":"Raxol.Terminal.Mouse.UnifiedMouse.mouse_modifier/0","type":"type"},{"doc":"Processes a mouse event.","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#process_mouse_event/5","title":"Raxol.Terminal.Mouse.UnifiedMouse.process_mouse_event/5","type":"function"},{"doc":"Sets the active mouse context.","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#set_active_mouse/1","title":"Raxol.Terminal.Mouse.UnifiedMouse.set_active_mouse/1","type":"function"},{"doc":"Starts the mouse manager with the given options.","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#start_link/1","title":"Raxol.Terminal.Mouse.UnifiedMouse.start_link/1","type":"function"},{"doc":"Updates the mouse manager configuration.","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#update_config/1","title":"Raxol.Terminal.Mouse.UnifiedMouse.update_config/1","type":"function"},{"doc":"Updates the configuration of a specific mouse context.","ref":"Raxol.Terminal.Mouse.UnifiedMouse.html#update_mouse_config/2","title":"Raxol.Terminal.Mouse.UnifiedMouse.update_mouse_config/2","type":"function"},{"doc":"Manages terminal notifications, telemetry events, and callbacks.\n\nThis module is responsible for:\n- Sending notifications to runtime processes\n- Emitting telemetry events\n- Managing callback execution\n- Logging notification events","ref":"Raxol.Terminal.NotificationManager.html","title":"Raxol.Terminal.NotificationManager","type":"module"},{"doc":"Notifies about a clipboard event.","ref":"Raxol.Terminal.NotificationManager.html#notify_clipboard_event/4","title":"Raxol.Terminal.NotificationManager.notify_clipboard_event/4","type":"function"},{"doc":"* `runtime_pid` - The PID of the runtime process to notify\n  * `callback_module` - The callback module to execute\n  * `type` - The clipboard operation type\n  * `data` - The clipboard data","ref":"Raxol.Terminal.NotificationManager.html#notify_clipboard_event/4-parameters","title":"Parameters - Raxol.Terminal.NotificationManager.notify_clipboard_event/4","type":"function"},{"doc":"Notifies about a cursor event.","ref":"Raxol.Terminal.NotificationManager.html#notify_cursor_event/3","title":"Raxol.Terminal.NotificationManager.notify_cursor_event/3","type":"function"},{"doc":"* `runtime_pid` - The PID of the runtime process to notify\n  * `callback_module` - The callback module to execute\n  * `cursor` - The cursor data","ref":"Raxol.Terminal.NotificationManager.html#notify_cursor_event/3-parameters","title":"Parameters - Raxol.Terminal.NotificationManager.notify_cursor_event/3","type":"function"},{"doc":"Notifies about a focus change event.","ref":"Raxol.Terminal.NotificationManager.html#notify_focus_changed/3","title":"Raxol.Terminal.NotificationManager.notify_focus_changed/3","type":"function"},{"doc":"* `runtime_pid` - The PID of the runtime process to notify\n  * `callback_module` - The callback module to execute\n  * `focused?` - Whether the terminal is focused","ref":"Raxol.Terminal.NotificationManager.html#notify_focus_changed/3-parameters","title":"Parameters - Raxol.Terminal.NotificationManager.notify_focus_changed/3","type":"function"},{"doc":"Notifies about a mode change event.","ref":"Raxol.Terminal.NotificationManager.html#notify_mode_changed/3","title":"Raxol.Terminal.NotificationManager.notify_mode_changed/3","type":"function"},{"doc":"* `runtime_pid` - The PID of the runtime process to notify\n  * `callback_module` - The callback module to execute\n  * `new_mode` - The new mode","ref":"Raxol.Terminal.NotificationManager.html#notify_mode_changed/3-parameters","title":"Parameters - Raxol.Terminal.NotificationManager.notify_mode_changed/3","type":"function"},{"doc":"Notifies about a paste event.","ref":"Raxol.Terminal.NotificationManager.html#notify_paste_event/4","title":"Raxol.Terminal.NotificationManager.notify_paste_event/4","type":"function"},{"doc":"* `runtime_pid` - The PID of the runtime process to notify\n  * `callback_module` - The callback module to execute\n  * `text` - The pasted text\n  * `pos` - The paste position","ref":"Raxol.Terminal.NotificationManager.html#notify_paste_event/4-parameters","title":"Parameters - Raxol.Terminal.NotificationManager.notify_paste_event/4","type":"function"},{"doc":"Notifies about a terminal resize event.","ref":"Raxol.Terminal.NotificationManager.html#notify_resized/4","title":"Raxol.Terminal.NotificationManager.notify_resized/4","type":"function"},{"doc":"* `runtime_pid` - The PID of the runtime process to notify\n  * `callback_module` - The callback module to execute\n  * `width` - The new width\n  * `height` - The new height","ref":"Raxol.Terminal.NotificationManager.html#notify_resized/4-parameters","title":"Parameters - Raxol.Terminal.NotificationManager.notify_resized/4","type":"function"},{"doc":"Notifies about a scroll event.","ref":"Raxol.Terminal.NotificationManager.html#notify_scroll_event/5","title":"Raxol.Terminal.NotificationManager.notify_scroll_event/5","type":"function"},{"doc":"* `runtime_pid` - The PID of the runtime process to notify\n  * `callback_module` - The callback module to execute\n  * `dir` - The scroll direction\n  * `delta` - The scroll delta\n  * `pos` - The scroll position","ref":"Raxol.Terminal.NotificationManager.html#notify_scroll_event/5-parameters","title":"Parameters - Raxol.Terminal.NotificationManager.notify_scroll_event/5","type":"function"},{"doc":"Notifies about a selection change event.","ref":"Raxol.Terminal.NotificationManager.html#notify_selection_changed/3","title":"Raxol.Terminal.NotificationManager.notify_selection_changed/3","type":"function"},{"doc":"* `runtime_pid` - The PID of the runtime process to notify\n  * `callback_module` - The callback module to execute\n  * `selection` - The selection data","ref":"Raxol.Terminal.NotificationManager.html#notify_selection_changed/3-parameters","title":"Parameters - Raxol.Terminal.NotificationManager.notify_selection_changed/3","type":"function"},{"doc":"Manages terminal output buffering and control sequences.","ref":"Raxol.Terminal.Output.Manager.html","title":"Raxol.Terminal.Output.Manager","type":"module"},{"doc":"Clears all pending control sequences.","ref":"Raxol.Terminal.Output.Manager.html#clear_control_sequences/1","title":"Raxol.Terminal.Output.Manager.clear_control_sequences/1","type":"function"},{"doc":"Clears the output buffer.","ref":"Raxol.Terminal.Output.Manager.html#clear_output_buffer/1","title":"Raxol.Terminal.Output.Manager.clear_output_buffer/1","type":"function"},{"doc":"Enqueues a control sequence to be processed.","ref":"Raxol.Terminal.Output.Manager.html#enqueue_control_sequence/2","title":"Raxol.Terminal.Output.Manager.enqueue_control_sequence/2","type":"function"},{"doc":"Enqueues output to the buffer.","ref":"Raxol.Terminal.Output.Manager.html#enqueue_output/2","title":"Raxol.Terminal.Output.Manager.enqueue_output/2","type":"function"},{"doc":"Flushes the output buffer and returns the content.","ref":"Raxol.Terminal.Output.Manager.html#flush_output/1","title":"Raxol.Terminal.Output.Manager.flush_output/1","type":"function"},{"doc":"Gets the current buffer size.","ref":"Raxol.Terminal.Output.Manager.html#get_buffer_size/1","title":"Raxol.Terminal.Output.Manager.get_buffer_size/1","type":"function"},{"doc":"Gets the next control sequence from the queue.","ref":"Raxol.Terminal.Output.Manager.html#get_next_control_sequence/1","title":"Raxol.Terminal.Output.Manager.get_next_control_sequence/1","type":"function"},{"doc":"Gets the current output buffer content.","ref":"Raxol.Terminal.Output.Manager.html#get_output_buffer/1","title":"Raxol.Terminal.Output.Manager.get_output_buffer/1","type":"function"},{"doc":"Gets all pending control sequences.","ref":"Raxol.Terminal.Output.Manager.html#get_pending_control_sequences/1","title":"Raxol.Terminal.Output.Manager.get_pending_control_sequences/1","type":"function"},{"doc":"Creates a new output manager instance.","ref":"Raxol.Terminal.Output.Manager.html#new/1","title":"Raxol.Terminal.Output.Manager.new/1","type":"function"},{"doc":"Sets the maximum buffer size.","ref":"Raxol.Terminal.Output.Manager.html#set_max_buffer_size/2","title":"Raxol.Terminal.Output.Manager.set_max_buffer_size/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Output.Manager.html#t:t/0","title":"Raxol.Terminal.Output.Manager.t/0","type":"type"},{"doc":"Processes output events for the terminal emulator.","ref":"Raxol.Terminal.Output.Processor.html","title":"Raxol.Terminal.Output.Processor","type":"module"},{"doc":"Styles an output event with the current terminal attributes.","ref":"Raxol.Terminal.Output.Processor.html#style_event/1","title":"Raxol.Terminal.Output.Processor.style_event/1","type":"function"},{"doc":"Manages terminal output buffering, control sequences, and formatting.\nProvides functionality for:\n- Output buffering with size limits\n- Control sequence handling\n- Output formatting and styling\n- Performance metrics tracking\n- Batch processing","ref":"Raxol.Terminal.OutputManager.html","title":"Raxol.Terminal.OutputManager","type":"module"},{"doc":"Adds a custom formatting rule to the manager.","ref":"Raxol.Terminal.OutputManager.html#add_format_rule/2","title":"Raxol.Terminal.OutputManager.add_format_rule/2","type":"function"},{"doc":"Clears the control sequence buffer.","ref":"Raxol.Terminal.OutputManager.html#clear_control_sequence_buffer/1","title":"Raxol.Terminal.OutputManager.clear_control_sequence_buffer/1","type":"function"},{"doc":"Clears the output buffer.","ref":"Raxol.Terminal.OutputManager.html#clear_output_buffer/1","title":"Raxol.Terminal.OutputManager.clear_output_buffer/1","type":"function"},{"doc":"Enqueues a control sequence to the buffer.\nReturns {:ok, updated_manager} or {:error, :buffer_overflow}","ref":"Raxol.Terminal.OutputManager.html#enqueue_control_sequence/2","title":"Raxol.Terminal.OutputManager.enqueue_control_sequence/2","type":"function"},{"doc":"Enqueues output to the buffer.\nReturns {:ok, updated_manager} or {:error, :buffer_overflow}","ref":"Raxol.Terminal.OutputManager.html#enqueue_output/2","title":"Raxol.Terminal.OutputManager.enqueue_output/2","type":"function"},{"doc":"Flushes the control sequence buffer and returns its contents.\nReturns {sequences, updated_manager}","ref":"Raxol.Terminal.OutputManager.html#flush_control_sequence_buffer/1","title":"Raxol.Terminal.OutputManager.flush_control_sequence_buffer/1","type":"function"},{"doc":"Flushes the output buffer and returns its contents.\nReturns {output, updated_manager}","ref":"Raxol.Terminal.OutputManager.html#flush_output/1","title":"Raxol.Terminal.OutputManager.flush_output/1","type":"function"},{"doc":"Gets the current control sequence buffer contents.","ref":"Raxol.Terminal.OutputManager.html#get_control_sequence_buffer/1","title":"Raxol.Terminal.OutputManager.get_control_sequence_buffer/1","type":"function"},{"doc":"Gets the current metrics.","ref":"Raxol.Terminal.OutputManager.html#get_metrics/1","title":"Raxol.Terminal.OutputManager.get_metrics/1","type":"function"},{"doc":"Gets the current output buffer contents.","ref":"Raxol.Terminal.OutputManager.html#get_output_buffer/1","title":"Raxol.Terminal.OutputManager.get_output_buffer/1","type":"function"},{"doc":"Creates a new OutputManager with default settings.","ref":"Raxol.Terminal.OutputManager.html#new/1","title":"Raxol.Terminal.OutputManager.new/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.OutputManager.html#t:t/0","title":"Raxol.Terminal.OutputManager.t/0","type":"type"},{"doc":"Parses raw byte streams into terminal events and commands.\nHandles escape sequences (CSI, OSC, DCS, etc.) and plain text.","ref":"Raxol.Terminal.Parser.html","title":"Raxol.Terminal.Parser","type":"module"},{"doc":"","ref":"Raxol.Terminal.Parser.html#parse/2","title":"Raxol.Terminal.Parser.parse/2","type":"function"},{"doc":"Parses a chunk of input data, updating the parser state and emulator.\n\nTakes the current emulator state and input binary, returns the updated emulator state\nafter processing the input chunk.\n\nTakes the emulator state, the *current* parser state, and the input binary.\nReturns `{final_emulator_state, final_parser_state}`.","ref":"Raxol.Terminal.Parser.html#parse_chunk/3","title":"Raxol.Terminal.Parser.parse_chunk/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Parser.html#transition_to_escape/2","title":"Raxol.Terminal.Parser.transition_to_escape/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Parser.html#transition_to_ground/1","title":"Raxol.Terminal.Parser.transition_to_ground/1","type":"function"},{"doc":"Parser state for the terminal emulator.","ref":"Raxol.Terminal.Parser.State.html","title":"Raxol.Terminal.Parser.State","type":"module"},{"doc":"Manages the state of the terminal parser, including escape sequences,\ncontrol sequences, and parser modes.","ref":"Raxol.Terminal.Parser.State.Manager.html","title":"Raxol.Terminal.Parser.State.Manager","type":"module"},{"doc":"Clears all string buffers.","ref":"Raxol.Terminal.Parser.State.Manager.html#clear_string_buffers/1","title":"Raxol.Terminal.Parser.State.Manager.clear_string_buffers/1","type":"function"},{"doc":"Gets the APC buffer content.","ref":"Raxol.Terminal.Parser.State.Manager.html#get_apc_buffer/1","title":"Raxol.Terminal.Parser.State.Manager.get_apc_buffer/1","type":"function"},{"doc":"Gets the DCS buffer content.","ref":"Raxol.Terminal.Parser.State.Manager.html#get_dcs_buffer/1","title":"Raxol.Terminal.Parser.State.Manager.get_dcs_buffer/1","type":"function"},{"doc":"Gets the current intermediate characters.","ref":"Raxol.Terminal.Parser.State.Manager.html#get_intermediate/1","title":"Raxol.Terminal.Parser.State.Manager.get_intermediate/1","type":"function"},{"doc":"Gets the OSC buffer content.","ref":"Raxol.Terminal.Parser.State.Manager.html#get_osc_buffer/1","title":"Raxol.Terminal.Parser.State.Manager.get_osc_buffer/1","type":"function"},{"doc":"Gets the current parameters.","ref":"Raxol.Terminal.Parser.State.Manager.html#get_params/1","title":"Raxol.Terminal.Parser.State.Manager.get_params/1","type":"function"},{"doc":"Gets the PM buffer content.","ref":"Raxol.Terminal.Parser.State.Manager.html#get_pm_buffer/1","title":"Raxol.Terminal.Parser.State.Manager.get_pm_buffer/1","type":"function"},{"doc":"Gets the SOS buffer content.","ref":"Raxol.Terminal.Parser.State.Manager.html#get_sos_buffer/1","title":"Raxol.Terminal.Parser.State.Manager.get_sos_buffer/1","type":"function"},{"doc":"Gets the current parser state.","ref":"Raxol.Terminal.Parser.State.Manager.html#get_state/1","title":"Raxol.Terminal.Parser.State.Manager.get_state/1","type":"function"},{"doc":"Gets the string buffer content.","ref":"Raxol.Terminal.Parser.State.Manager.html#get_string_buffer/1","title":"Raxol.Terminal.Parser.State.Manager.get_string_buffer/1","type":"function"},{"doc":"Gets the string flags.","ref":"Raxol.Terminal.Parser.State.Manager.html#get_string_flags/1","title":"Raxol.Terminal.Parser.State.Manager.get_string_flags/1","type":"function"},{"doc":"Gets the string parser state.","ref":"Raxol.Terminal.Parser.State.Manager.html#get_string_parser_state/1","title":"Raxol.Terminal.Parser.State.Manager.get_string_parser_state/1","type":"function"},{"doc":"Gets the string terminator.","ref":"Raxol.Terminal.Parser.State.Manager.html#get_string_terminator/1","title":"Raxol.Terminal.Parser.State.Manager.get_string_terminator/1","type":"function"},{"doc":"Checks if the parser is in ignore mode.","ref":"Raxol.Terminal.Parser.State.Manager.html#ignore?/1","title":"Raxol.Terminal.Parser.State.Manager.ignore?/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Parser.State.Manager.html#t:intermediate/0","title":"Raxol.Terminal.Parser.State.Manager.intermediate/0","type":"type"},{"doc":"Creates a new parser state manager instance.","ref":"Raxol.Terminal.Parser.State.Manager.html#new/0","title":"Raxol.Terminal.Parser.State.Manager.new/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Parser.State.Manager.html#t:params/0","title":"Raxol.Terminal.Parser.State.Manager.params/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Parser.State.Manager.html#t:parser_state/0","title":"Raxol.Terminal.Parser.State.Manager.parser_state/0","type":"type"},{"doc":"Processes a single character and updates the parser state accordingly.","ref":"Raxol.Terminal.Parser.State.Manager.html#process_char/2","title":"Raxol.Terminal.Parser.State.Manager.process_char/2","type":"function"},{"doc":"Resets the parser state manager to its initial state.","ref":"Raxol.Terminal.Parser.State.Manager.html#reset/1","title":"Raxol.Terminal.Parser.State.Manager.reset/1","type":"function"},{"doc":"Sets the APC buffer content.","ref":"Raxol.Terminal.Parser.State.Manager.html#set_apc_buffer/2","title":"Raxol.Terminal.Parser.State.Manager.set_apc_buffer/2","type":"function"},{"doc":"Sets the DCS buffer content.","ref":"Raxol.Terminal.Parser.State.Manager.html#set_dcs_buffer/2","title":"Raxol.Terminal.Parser.State.Manager.set_dcs_buffer/2","type":"function"},{"doc":"Sets the ignore mode.","ref":"Raxol.Terminal.Parser.State.Manager.html#set_ignore/2","title":"Raxol.Terminal.Parser.State.Manager.set_ignore/2","type":"function"},{"doc":"Sets the intermediate characters.","ref":"Raxol.Terminal.Parser.State.Manager.html#set_intermediate/2","title":"Raxol.Terminal.Parser.State.Manager.set_intermediate/2","type":"function"},{"doc":"Sets the OSC buffer content.","ref":"Raxol.Terminal.Parser.State.Manager.html#set_osc_buffer/2","title":"Raxol.Terminal.Parser.State.Manager.set_osc_buffer/2","type":"function"},{"doc":"Sets the parameters.","ref":"Raxol.Terminal.Parser.State.Manager.html#set_params/2","title":"Raxol.Terminal.Parser.State.Manager.set_params/2","type":"function"},{"doc":"Sets the PM buffer content.","ref":"Raxol.Terminal.Parser.State.Manager.html#set_pm_buffer/2","title":"Raxol.Terminal.Parser.State.Manager.set_pm_buffer/2","type":"function"},{"doc":"Sets the SOS buffer content.","ref":"Raxol.Terminal.Parser.State.Manager.html#set_sos_buffer/2","title":"Raxol.Terminal.Parser.State.Manager.set_sos_buffer/2","type":"function"},{"doc":"Sets the parser state.","ref":"Raxol.Terminal.Parser.State.Manager.html#set_state/2","title":"Raxol.Terminal.Parser.State.Manager.set_state/2","type":"function"},{"doc":"Sets the string buffer content.","ref":"Raxol.Terminal.Parser.State.Manager.html#set_string_buffer/2","title":"Raxol.Terminal.Parser.State.Manager.set_string_buffer/2","type":"function"},{"doc":"Sets the string flags.","ref":"Raxol.Terminal.Parser.State.Manager.html#set_string_flags/2","title":"Raxol.Terminal.Parser.State.Manager.set_string_flags/2","type":"function"},{"doc":"Sets the string parser state.","ref":"Raxol.Terminal.Parser.State.Manager.html#set_string_parser_state/2","title":"Raxol.Terminal.Parser.State.Manager.set_string_parser_state/2","type":"function"},{"doc":"Sets the string terminator.","ref":"Raxol.Terminal.Parser.State.Manager.html#set_string_terminator/2","title":"Raxol.Terminal.Parser.State.Manager.set_string_terminator/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Parser.State.Manager.html#t:string_flags/0","title":"Raxol.Terminal.Parser.State.Manager.string_flags/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Parser.State.Manager.html#t:t/0","title":"Raxol.Terminal.Parser.State.Manager.t/0","type":"type"},{"doc":"Defines the behaviour for parser states.","ref":"Raxol.Terminal.Parser.StateBehaviour.html","title":"Raxol.Terminal.Parser.StateBehaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.Parser.StateBehaviour.html#t:emulator/0","title":"Raxol.Terminal.Parser.StateBehaviour.emulator/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Parser.StateBehaviour.html#c:handle/3","title":"Raxol.Terminal.Parser.StateBehaviour.handle/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateBehaviour.html#c:handle_apc_string/2","title":"Raxol.Terminal.Parser.StateBehaviour.handle_apc_string/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateBehaviour.html#c:handle_byte/3","title":"Raxol.Terminal.Parser.StateBehaviour.handle_byte/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateBehaviour.html#c:handle_control_sequence/2","title":"Raxol.Terminal.Parser.StateBehaviour.handle_control_sequence/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateBehaviour.html#c:handle_dcs_string/2","title":"Raxol.Terminal.Parser.StateBehaviour.handle_dcs_string/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateBehaviour.html#c:handle_escape/2","title":"Raxol.Terminal.Parser.StateBehaviour.handle_escape/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateBehaviour.html#c:handle_osc_string/2","title":"Raxol.Terminal.Parser.StateBehaviour.handle_osc_string/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateBehaviour.html#c:handle_pm_string/2","title":"Raxol.Terminal.Parser.StateBehaviour.handle_pm_string/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateBehaviour.html#c:handle_sos_string/2","title":"Raxol.Terminal.Parser.StateBehaviour.handle_sos_string/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateBehaviour.html#c:handle_unknown/2","title":"Raxol.Terminal.Parser.StateBehaviour.handle_unknown/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateBehaviour.html#t:state/0","title":"Raxol.Terminal.Parser.StateBehaviour.state/0","type":"type"},{"doc":"Behaviour for terminal parser state management.","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html","title":"Raxol.Terminal.Parser.StateManagerBehaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:get_charset_state/1","title":"Raxol.Terminal.Parser.StateManagerBehaviour.get_charset_state/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:get_last_col_exceeded/1","title":"Raxol.Terminal.Parser.StateManagerBehaviour.get_last_col_exceeded/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:get_mode_manager/1","title":"Raxol.Terminal.Parser.StateManagerBehaviour.get_mode_manager/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:get_scroll_region/1","title":"Raxol.Terminal.Parser.StateManagerBehaviour.get_scroll_region/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:get_state/1","title":"Raxol.Terminal.Parser.StateManagerBehaviour.get_state/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:get_state_name/1","title":"Raxol.Terminal.Parser.StateManagerBehaviour.get_state_name/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:get_state_stack/1","title":"Raxol.Terminal.Parser.StateManagerBehaviour.get_state_stack/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:in_control_sequence_state?/1","title":"Raxol.Terminal.Parser.StateManagerBehaviour.in_control_sequence_state?/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:in_escape_state?/1","title":"Raxol.Terminal.Parser.StateManagerBehaviour.in_escape_state?/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:in_ground_state?/1","title":"Raxol.Terminal.Parser.StateManagerBehaviour.in_ground_state?/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:new/0","title":"Raxol.Terminal.Parser.StateManagerBehaviour.new/0","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:reset_to_ground/1","title":"Raxol.Terminal.Parser.StateManagerBehaviour.reset_to_ground/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:reset_to_initial_state/1","title":"Raxol.Terminal.Parser.StateManagerBehaviour.reset_to_initial_state/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:set_state_name/2","title":"Raxol.Terminal.Parser.StateManagerBehaviour.set_state_name/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#t:t/0","title":"Raxol.Terminal.Parser.StateManagerBehaviour.t/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:update_charset_state/2","title":"Raxol.Terminal.Parser.StateManagerBehaviour.update_charset_state/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:update_last_col_exceeded/2","title":"Raxol.Terminal.Parser.StateManagerBehaviour.update_last_col_exceeded/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:update_mode_manager/2","title":"Raxol.Terminal.Parser.StateManagerBehaviour.update_mode_manager/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:update_scroll_region/2","title":"Raxol.Terminal.Parser.StateManagerBehaviour.update_scroll_region/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:update_state/2","title":"Raxol.Terminal.Parser.StateManagerBehaviour.update_state/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.Parser.StateManagerBehaviour.html#c:update_state_stack/2","title":"Raxol.Terminal.Parser.StateManagerBehaviour.update_state_stack/2","type":"callback"},{"doc":"Handles the CSI Entry state in the terminal parser.\nThis state is entered after receiving an ESC [ sequence.","ref":"Raxol.Terminal.Parser.States.CSIEntryState.html","title":"Raxol.Terminal.Parser.States.CSIEntryState","type":"module"},{"doc":"Handles input in CSI Entry state.\nReturns the next state and any accumulated data.","ref":"Raxol.Terminal.Parser.States.CSIEntryState.html#handle/2","title":"Raxol.Terminal.Parser.States.CSIEntryState.handle/2","type":"function"},{"doc":"Handles the :csi_intermediate state of the terminal parser.","ref":"Raxol.Terminal.Parser.States.CSIIntermediateState.html","title":"Raxol.Terminal.Parser.States.CSIIntermediateState","type":"module"},{"doc":"Processes input when the parser is in the :csi_intermediate state.\nCollects intermediate bytes (0x20-0x2F).","ref":"Raxol.Terminal.Parser.States.CSIIntermediateState.html#handle/3","title":"Raxol.Terminal.Parser.States.CSIIntermediateState.handle/3","type":"function"},{"doc":"Handles the :csi_param state of the terminal parser.","ref":"Raxol.Terminal.Parser.States.CSIParamState.html","title":"Raxol.Terminal.Parser.States.CSIParamState","type":"module"},{"doc":"Processes input when the parser is in the :csi_param state.\nCollects parameter digits (0-9) and semicolons (;).","ref":"Raxol.Terminal.Parser.States.CSIParamState.html#handle/3","title":"Raxol.Terminal.Parser.States.CSIParamState.handle/3","type":"function"},{"doc":"Handles the :dcs_entry state of the terminal parser.","ref":"Raxol.Terminal.Parser.States.DCSEntryState.html","title":"Raxol.Terminal.Parser.States.DCSEntryState","type":"module"},{"doc":"Processes input when the parser is in the :dcs_entry state.\nSimilar to CSI Entry - collects params/intermediates/final byte.","ref":"Raxol.Terminal.Parser.States.DCSEntryState.html#handle/3","title":"Raxol.Terminal.Parser.States.DCSEntryState.handle/3","type":"function"},{"doc":"Handles the :dcs_passthrough_maybe_st state of the terminal parser.","ref":"Raxol.Terminal.Parser.States.DCSPassthroughMaybeSTState.html","title":"Raxol.Terminal.Parser.States.DCSPassthroughMaybeSTState","type":"module"},{"doc":"Processes input when the parser is in the :dcs_passthrough_maybe_st state.","ref":"Raxol.Terminal.Parser.States.DCSPassthroughMaybeSTState.html#handle/3","title":"Raxol.Terminal.Parser.States.DCSPassthroughMaybeSTState.handle/3","type":"function"},{"doc":"Handles the :dcs_passthrough state of the terminal parser.","ref":"Raxol.Terminal.Parser.States.DCSPassthroughState.html","title":"Raxol.Terminal.Parser.States.DCSPassthroughState","type":"module"},{"doc":"Processes input when the parser is in the :dcs_passthrough state.\nCollects the DCS data string until ST (ESC ).","ref":"Raxol.Terminal.Parser.States.DCSPassthroughState.html#handle/3","title":"Raxol.Terminal.Parser.States.DCSPassthroughState.handle/3","type":"function"},{"doc":"Handles the :designate_charset state of the terminal parser.","ref":"Raxol.Terminal.Parser.States.DesignateCharsetState.html","title":"Raxol.Terminal.Parser.States.DesignateCharsetState","type":"module"},{"doc":"Processes input when the parser is in the :designate_charset state.\nExpects a single character designating the character set.","ref":"Raxol.Terminal.Parser.States.DesignateCharsetState.html#handle/3","title":"Raxol.Terminal.Parser.States.DesignateCharsetState.handle/3","type":"function"},{"doc":"Handles the :escape state of the terminal parser.","ref":"Raxol.Terminal.Parser.States.EscapeState.html","title":"Raxol.Terminal.Parser.States.EscapeState","type":"module"},{"doc":"Processes input when the parser is in the :escape state.","ref":"Raxol.Terminal.Parser.States.EscapeState.html#handle/3","title":"Raxol.Terminal.Parser.States.EscapeState.handle/3","type":"function"},{"doc":"Handles parsing in the ground state, the default state of the terminal.","ref":"Raxol.Terminal.Parser.States.GroundState.html","title":"Raxol.Terminal.Parser.States.GroundState","type":"module"},{"doc":"Handles the :osc_string_maybe_st state of the terminal parser.","ref":"Raxol.Terminal.Parser.States.OSCStringMaybeSTState.html","title":"Raxol.Terminal.Parser.States.OSCStringMaybeSTState","type":"module"},{"doc":"Processes input when the parser is in the :osc_string_maybe_st state.","ref":"Raxol.Terminal.Parser.States.OSCStringMaybeSTState.html#handle/3","title":"Raxol.Terminal.Parser.States.OSCStringMaybeSTState.handle/3","type":"function"},{"doc":"Handles the OSC String state in the terminal parser.\nThis state is entered when an OSC sequence is initiated.","ref":"Raxol.Terminal.Parser.States.OSCStringState.html","title":"Raxol.Terminal.Parser.States.OSCStringState","type":"module"},{"doc":"Processes input when the parser is in the :osc_string state.\nCollects the OSC string until ST (ESC ) or BEL.","ref":"Raxol.Terminal.Parser.States.OSCStringState.html#handle/3","title":"Raxol.Terminal.Parser.States.OSCStringState.handle/3","type":"function"},{"doc":"Manages terminal plugins with advanced features:\n- Plugin loading and unloading\n- Plugin lifecycle management\n- Plugin API and hooks\n- Plugin configuration and state management","ref":"Raxol.Terminal.Plugin.Manager.html","title":"Raxol.Terminal.Plugin.Manager","type":"module"},{"doc":"Calls a hook with the given arguments.","ref":"Raxol.Terminal.Plugin.Manager.html#call_hook/3","title":"Raxol.Terminal.Plugin.Manager.call_hook/3","type":"function"},{"doc":"Gets the current plugin metrics.","ref":"Raxol.Terminal.Plugin.Manager.html#get_metrics/1","title":"Raxol.Terminal.Plugin.Manager.get_metrics/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Plugin.Manager.html#t:hook/0","title":"Raxol.Terminal.Plugin.Manager.hook/0","type":"type"},{"doc":"Loads a plugin into the manager.","ref":"Raxol.Terminal.Plugin.Manager.html#load_plugin/2","title":"Raxol.Terminal.Plugin.Manager.load_plugin/2","type":"function"},{"doc":"Creates a new plugin manager with the given options.","ref":"Raxol.Terminal.Plugin.Manager.html#new/1","title":"Raxol.Terminal.Plugin.Manager.new/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Plugin.Manager.html#t:plugin/0","title":"Raxol.Terminal.Plugin.Manager.plugin/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Plugin.Manager.html#t:t/0","title":"Raxol.Terminal.Plugin.Manager.t/0","type":"type"},{"doc":"Unloads a plugin from the manager.","ref":"Raxol.Terminal.Plugin.Manager.html#unload_plugin/2","title":"Raxol.Terminal.Plugin.Manager.unload_plugin/2","type":"function"},{"doc":"Updates the configuration for a plugin.","ref":"Raxol.Terminal.Plugin.Manager.html#update_plugin_config/3","title":"Raxol.Terminal.Plugin.Manager.update_plugin_config/3","type":"function"},{"doc":"Unified plugin system for the Raxol terminal emulator.\nHandles themes, scripting, and extensions.","ref":"Raxol.Terminal.Plugin.UnifiedPlugin.html","title":"Raxol.Terminal.Plugin.UnifiedPlugin","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Plugin.UnifiedPlugin.html#child_spec/1","title":"Raxol.Terminal.Plugin.UnifiedPlugin.child_spec/1","type":"function"},{"doc":"Executes a plugin function.","ref":"Raxol.Terminal.Plugin.UnifiedPlugin.html#execute_plugin_function/3","title":"Raxol.Terminal.Plugin.UnifiedPlugin.execute_plugin_function/3","type":"function"},{"doc":"Gets the state of a plugin.","ref":"Raxol.Terminal.Plugin.UnifiedPlugin.html#get_plugin_state/1","title":"Raxol.Terminal.Plugin.UnifiedPlugin.get_plugin_state/1","type":"function"},{"doc":"Gets all loaded plugins.","ref":"Raxol.Terminal.Plugin.UnifiedPlugin.html#get_plugins/1","title":"Raxol.Terminal.Plugin.UnifiedPlugin.get_plugins/1","type":"function"},{"doc":"Loads a plugin from a file or directory.","ref":"Raxol.Terminal.Plugin.UnifiedPlugin.html#load_plugin/3","title":"Raxol.Terminal.Plugin.UnifiedPlugin.load_plugin/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Plugin.UnifiedPlugin.html#t:plugin_id/0","title":"Raxol.Terminal.Plugin.UnifiedPlugin.plugin_id/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Plugin.UnifiedPlugin.html#t:plugin_state/0","title":"Raxol.Terminal.Plugin.UnifiedPlugin.plugin_state/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Plugin.UnifiedPlugin.html#t:plugin_type/0","title":"Raxol.Terminal.Plugin.UnifiedPlugin.plugin_type/0","type":"type"},{"doc":"Reloads a plugin.","ref":"Raxol.Terminal.Plugin.UnifiedPlugin.html#reload_plugin/1","title":"Raxol.Terminal.Plugin.UnifiedPlugin.reload_plugin/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Plugin.UnifiedPlugin.html#start_link/1","title":"Raxol.Terminal.Plugin.UnifiedPlugin.start_link/1","type":"function"},{"doc":"Unloads a plugin by ID.","ref":"Raxol.Terminal.Plugin.UnifiedPlugin.html#unload_plugin/1","title":"Raxol.Terminal.Plugin.UnifiedPlugin.unload_plugin/1","type":"function"},{"doc":"Updates a plugin's configuration.","ref":"Raxol.Terminal.Plugin.UnifiedPlugin.html#update_plugin_config/2","title":"Raxol.Terminal.Plugin.UnifiedPlugin.update_plugin_config/2","type":"function"},{"doc":"Core functionality for managing terminal plugins.","ref":"Raxol.Terminal.Plugins.Manager.Core.html","title":"Raxol.Terminal.Plugins.Manager.Core","type":"module"},{"doc":"Creates a new plugin manager instance.","ref":"Raxol.Terminal.Plugins.Manager.Core.html#new/0","title":"Raxol.Terminal.Plugins.Manager.Core.new/0","type":"function"},{"doc":"Terminal registry module.\n\nThis module manages the registry of terminal sessions, including:\n- Session registration\n- Session lookup\n- Session cleanup","ref":"Raxol.Terminal.Registry.html","title":"Raxol.Terminal.Registry","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Registry.html#child_spec/1","title":"Raxol.Terminal.Registry.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Registry.html#count/0","title":"Raxol.Terminal.Registry.count/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Registry.html#exclude_by_id/1","title":"Raxol.Terminal.Registry.exclude_by_id/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Registry.html#filter_by_id/1","title":"Raxol.Terminal.Registry.filter_by_id/1","type":"function"},{"doc":"Callback implementation for  GenServer.init/1 .","ref":"Raxol.Terminal.Registry.html#init/1","title":"Raxol.Terminal.Registry.init/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Registry.html#list/0","title":"Raxol.Terminal.Registry.list/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Registry.html#lookup/1","title":"Raxol.Terminal.Registry.lookup/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Registry.html#match/1","title":"Raxol.Terminal.Registry.match/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Registry.html#match_except/1","title":"Raxol.Terminal.Registry.match_except/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Registry.html#register/2","title":"Raxol.Terminal.Registry.register/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Registry.html#start_link/1","title":"Raxol.Terminal.Registry.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Registry.html#unregister/1","title":"Raxol.Terminal.Registry.unregister/1","type":"function"},{"doc":"Provides a unified interface for terminal rendering operations.","ref":"Raxol.Terminal.Render.UnifiedRenderer.html","title":"Raxol.Terminal.Render.UnifiedRenderer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Render.UnifiedRenderer.html#child_spec/1","title":"Raxol.Terminal.Render.UnifiedRenderer.child_spec/1","type":"function"},{"doc":"Cleans up resources.","ref":"Raxol.Terminal.Render.UnifiedRenderer.html#cleanup/1","title":"Raxol.Terminal.Render.UnifiedRenderer.cleanup/1","type":"function"},{"doc":"Renders the current state.","ref":"Raxol.Terminal.Render.UnifiedRenderer.html#render/1","title":"Raxol.Terminal.Render.UnifiedRenderer.render/1","type":"function"},{"doc":"Renders the current state with a specific renderer ID.","ref":"Raxol.Terminal.Render.UnifiedRenderer.html#render/2","title":"Raxol.Terminal.Render.UnifiedRenderer.render/2","type":"function"},{"doc":"Resizes the renderer.","ref":"Raxol.Terminal.Render.UnifiedRenderer.html#resize/2","title":"Raxol.Terminal.Render.UnifiedRenderer.resize/2","type":"function"},{"doc":"Sets cursor visibility.","ref":"Raxol.Terminal.Render.UnifiedRenderer.html#set_cursor_visibility/1","title":"Raxol.Terminal.Render.UnifiedRenderer.set_cursor_visibility/1","type":"function"},{"doc":"Sets the window title.","ref":"Raxol.Terminal.Render.UnifiedRenderer.html#set_title/1","title":"Raxol.Terminal.Render.UnifiedRenderer.set_title/1","type":"function"},{"doc":"Starts the renderer.","ref":"Raxol.Terminal.Render.UnifiedRenderer.html#start_link/1","title":"Raxol.Terminal.Render.UnifiedRenderer.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Render.UnifiedRenderer.html#t:t/0","title":"Raxol.Terminal.Render.UnifiedRenderer.t/0","type":"type"},{"doc":"Updates the renderer configuration with a single argument.","ref":"Raxol.Terminal.Render.UnifiedRenderer.html#update_config/1","title":"Raxol.Terminal.Render.UnifiedRenderer.update_config/1","type":"function"},{"doc":"Updates the renderer configuration.","ref":"Raxol.Terminal.Render.UnifiedRenderer.html#update_config/2","title":"Raxol.Terminal.Render.UnifiedRenderer.update_config/2","type":"function"},{"doc":"Terminal renderer module.\n\nThis module handles rendering of terminal output, including:\n- Character cell rendering\n- Text styling\n- Cursor rendering\n- Performance optimizations","ref":"Raxol.Terminal.Renderer.html","title":"Raxol.Terminal.Renderer","type":"module"},{"doc":"The Renderer module works closely with several specialized modules:","ref":"Raxol.Terminal.Renderer.html#module-integration-with-other-modules","title":"Integration with Other Modules - Raxol.Terminal.Renderer","type":"module"},{"doc":"- Receives text and style updates from the Manipulation module\n- Renders text with proper styling and positioning\n- Handles text insertion, deletion, and modification","ref":"Raxol.Terminal.Renderer.html#module-manipulation-module","title":"Manipulation Module - Raxol.Terminal.Renderer","type":"module"},{"doc":"- Renders text selections with visual highlighting\n- Supports multiple selections\n- Handles selection state changes","ref":"Raxol.Terminal.Renderer.html#module-selection-module","title":"Selection Module - Raxol.Terminal.Renderer","type":"module"},{"doc":"- Renders validation errors and warnings\n- Applies visual indicators for invalid input\n- Shows validation state through styling","ref":"Raxol.Terminal.Renderer.html#module-validation-module","title":"Validation Module - Raxol.Terminal.Renderer","type":"module"},{"doc":"The renderer includes several optimizations:\n- Only renders changed cells\n- Batches style updates for consecutive cells\n- Minimizes DOM updates\n- Caches rendered output when possible","ref":"Raxol.Terminal.Renderer.html#module-performance-optimizations","title":"Performance Optimizations - Raxol.Terminal.Renderer","type":"module"},{"doc":"```elixir\n# Create a new renderer\nbuffer = ScreenBuffer.new(80, 24)\nrenderer = Renderer.new(buffer)\n\n# Render with selection\nselection = %{selection: {0, 0, 0, 5}}\noutput = Renderer.render(renderer, selection: selection)\n\n# Render with validation\nvalidation = Validation.validate_input(buffer, 0, 0, \"text\")\noutput = Renderer.render(renderer, validation: validation)\n```","ref":"Raxol.Terminal.Renderer.html#module-usage","title":"Usage - Raxol.Terminal.Renderer","type":"module"},{"doc":"Clears the cursor position.","ref":"Raxol.Terminal.Renderer.html#clear_cursor/1","title":"Raxol.Terminal.Renderer.clear_cursor/1","type":"function"},{"doc":"iex> screen_buffer = ScreenBuffer.new(80, 24)\n    iex> renderer = Renderer.new(screen_buffer)\n    iex> renderer = Renderer.set_cursor(renderer, {10, 5})\n    iex> renderer = Renderer.clear_cursor(renderer)\n    iex> renderer.cursor\n    nil","ref":"Raxol.Terminal.Renderer.html#clear_cursor/1-examples","title":"Examples - Raxol.Terminal.Renderer.clear_cursor/1","type":"function"},{"doc":"Gets the current content of the screen buffer.","ref":"Raxol.Terminal.Renderer.html#get_content/2","title":"Raxol.Terminal.Renderer.get_content/2","type":"function"},{"doc":"* `renderer` - The renderer to get content from\n  * `opts` - Options for content retrieval\n    * `:include_style` - Whether to include style information (default: false)\n    * `:include_cursor` - Whether to include cursor position (default: false)","ref":"Raxol.Terminal.Renderer.html#get_content/2-parameters","title":"Parameters - Raxol.Terminal.Renderer.get_content/2","type":"function"},{"doc":"* `{:ok, content}` - The current content\n  * `{:error, reason}` - If content retrieval fails","ref":"Raxol.Terminal.Renderer.html#get_content/2-returns","title":"Returns - Raxol.Terminal.Renderer.get_content/2","type":"function"},{"doc":"iex> get_content(renderer)\n    {:ok, \"Hello, World!\"}","ref":"Raxol.Terminal.Renderer.html#get_content/2-examples","title":"Examples - Raxol.Terminal.Renderer.get_content/2","type":"function"},{"doc":"Creates a new renderer with the given screen buffer.","ref":"Raxol.Terminal.Renderer.html#new/3","title":"Raxol.Terminal.Renderer.new/3","type":"function"},{"doc":"iex> screen_buffer = ScreenBuffer.new(80, 24)\n    iex> renderer = Renderer.new(screen_buffer)\n    iex> renderer.screen_buffer\n    %ScreenBuffer{}","ref":"Raxol.Terminal.Renderer.html#new/3-examples","title":"Examples - Raxol.Terminal.Renderer.new/3","type":"function"},{"doc":"Renders the terminal content without additional options.","ref":"Raxol.Terminal.Renderer.html#render/1","title":"Raxol.Terminal.Renderer.render/1","type":"function"},{"doc":"Renders the terminal content.","ref":"Raxol.Terminal.Renderer.html#render/2","title":"Raxol.Terminal.Renderer.render/2","type":"function"},{"doc":"Renders the terminal content with additional options.","ref":"Raxol.Terminal.Renderer.html#render/3","title":"Raxol.Terminal.Renderer.render/3","type":"function"},{"doc":"Sets the cursor position.","ref":"Raxol.Terminal.Renderer.html#set_cursor/2","title":"Raxol.Terminal.Renderer.set_cursor/2","type":"function"},{"doc":"iex> screen_buffer = ScreenBuffer.new(80, 24)\n    iex> renderer = Renderer.new(screen_buffer)\n    iex> renderer = Renderer.set_cursor(renderer, {10, 5})\n    iex> renderer.cursor\n    {10, 5}","ref":"Raxol.Terminal.Renderer.html#set_cursor/2-examples","title":"Examples - Raxol.Terminal.Renderer.set_cursor/2","type":"function"},{"doc":"Updates the font settings.","ref":"Raxol.Terminal.Renderer.html#set_font_settings/2","title":"Raxol.Terminal.Renderer.set_font_settings/2","type":"function"},{"doc":"iex> screen_buffer = ScreenBuffer.new(80, 24)\n    iex> renderer = Renderer.new(screen_buffer)\n    iex> settings = %{family: \"Fira Code\"}\n    iex> renderer = Renderer.set_font_settings(renderer, settings)\n    iex> renderer.font_settings\n    %{family: \"Fira Code\"}","ref":"Raxol.Terminal.Renderer.html#set_font_settings/2-examples","title":"Examples - Raxol.Terminal.Renderer.set_font_settings/2","type":"function"},{"doc":"Updates the theme settings.","ref":"Raxol.Terminal.Renderer.html#set_theme/2","title":"Raxol.Terminal.Renderer.set_theme/2","type":"function"},{"doc":"iex> screen_buffer = ScreenBuffer.new(80, 24)\n    iex> renderer = Renderer.new(screen_buffer)\n    iex> theme = %{foreground: %{default: \"#FFF\"}}\n    iex> renderer = Renderer.set_theme(renderer, theme)\n    iex> renderer.theme\n    %{foreground: %{default: \"#FFF\"}}","ref":"Raxol.Terminal.Renderer.html#set_theme/2-examples","title":"Examples - Raxol.Terminal.Renderer.set_theme/2","type":"function"},{"doc":"Starts a new renderer process.","ref":"Raxol.Terminal.Renderer.html#start_link/1","title":"Raxol.Terminal.Renderer.start_link/1","type":"function"},{"doc":"Stops the renderer process.","ref":"Raxol.Terminal.Renderer.html#stop/1","title":"Raxol.Terminal.Renderer.stop/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Renderer.html#t:t/0","title":"Raxol.Terminal.Renderer.t/0","type":"type"},{"doc":"GPU-accelerated terminal renderer.\n\nThis module provides hardware-accelerated rendering capabilities for the terminal,\nutilizing the GPU for improved performance. It includes:\n- Hardware-accelerated text rendering\n- GPU-based buffer management\n- Optimized render pipeline\n- Performance monitoring and optimization","ref":"Raxol.Terminal.Renderer.GPURenderer.html","title":"Raxol.Terminal.Renderer.GPURenderer","type":"module"},{"doc":"- GPU-accelerated text rendering\n- Hardware-accelerated buffer management\n- Efficient render pipeline\n- Performance optimization\n- Memory management\n- Resource pooling","ref":"Raxol.Terminal.Renderer.GPURenderer.html#module-features","title":"Features - Raxol.Terminal.Renderer.GPURenderer","type":"module"},{"doc":"Gets the current performance metrics.","ref":"Raxol.Terminal.Renderer.GPURenderer.html#get_performance_metrics/1","title":"Raxol.Terminal.Renderer.GPURenderer.get_performance_metrics/1","type":"function"},{"doc":"* `gpu_renderer` - The GPU renderer instance","ref":"Raxol.Terminal.Renderer.GPURenderer.html#get_performance_metrics/1-parameters","title":"Parameters - Raxol.Terminal.Renderer.GPURenderer.get_performance_metrics/1","type":"function"},{"doc":"Map containing performance metrics","ref":"Raxol.Terminal.Renderer.GPURenderer.html#get_performance_metrics/1-returns","title":"Returns - Raxol.Terminal.Renderer.GPURenderer.get_performance_metrics/1","type":"function"},{"doc":"Creates a new GPU renderer instance.","ref":"Raxol.Terminal.Renderer.GPURenderer.html#new/2","title":"Raxol.Terminal.Renderer.GPURenderer.new/2","type":"function"},{"doc":"* `renderer` - The base renderer instance\n* `opts` - Additional options for GPU rendering","ref":"Raxol.Terminal.Renderer.GPURenderer.html#new/2-parameters","title":"Parameters - Raxol.Terminal.Renderer.GPURenderer.new/2","type":"function"},{"doc":"A new GPU renderer instance","ref":"Raxol.Terminal.Renderer.GPURenderer.html#new/2-returns","title":"Returns - Raxol.Terminal.Renderer.GPURenderer.new/2","type":"function"},{"doc":"Optimizes the render pipeline based on current performance metrics.","ref":"Raxol.Terminal.Renderer.GPURenderer.html#optimize_pipeline/1","title":"Raxol.Terminal.Renderer.GPURenderer.optimize_pipeline/1","type":"function"},{"doc":"* `gpu_renderer` - The GPU renderer instance","ref":"Raxol.Terminal.Renderer.GPURenderer.html#optimize_pipeline/1-parameters","title":"Parameters - Raxol.Terminal.Renderer.GPURenderer.optimize_pipeline/1","type":"function"},{"doc":"Updated GPU renderer instance with optimized pipeline","ref":"Raxol.Terminal.Renderer.GPURenderer.html#optimize_pipeline/1-returns","title":"Returns - Raxol.Terminal.Renderer.GPURenderer.optimize_pipeline/1","type":"function"},{"doc":"Renders the screen buffer using GPU acceleration.","ref":"Raxol.Terminal.Renderer.GPURenderer.html#render/2","title":"Raxol.Terminal.Renderer.GPURenderer.render/2","type":"function"},{"doc":"* `gpu_renderer` - The GPU renderer instance\n* `opts` - Rendering options","ref":"Raxol.Terminal.Renderer.GPURenderer.html#render/2-parameters","title":"Parameters - Raxol.Terminal.Renderer.GPURenderer.render/2","type":"function"},{"doc":"The rendered output","ref":"Raxol.Terminal.Renderer.GPURenderer.html#render/2-returns","title":"Returns - Raxol.Terminal.Renderer.GPURenderer.render/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Renderer.GPURenderer.html#t:t/0","title":"Raxol.Terminal.Renderer.GPURenderer.t/0","type":"type"},{"doc":"Updates the render pipeline configuration.","ref":"Raxol.Terminal.Renderer.GPURenderer.html#update_pipeline/2","title":"Raxol.Terminal.Renderer.GPURenderer.update_pipeline/2","type":"function"},{"doc":"* `gpu_renderer` - The GPU renderer instance\n* `config` - The new pipeline configuration","ref":"Raxol.Terminal.Renderer.GPURenderer.html#update_pipeline/2-parameters","title":"Parameters - Raxol.Terminal.Renderer.GPURenderer.update_pipeline/2","type":"function"},{"doc":"Updated GPU renderer instance","ref":"Raxol.Terminal.Renderer.GPURenderer.html#update_pipeline/2-returns","title":"Returns - Raxol.Terminal.Renderer.GPURenderer.update_pipeline/2","type":"function"},{"doc":"Provides screen manipulation functions for the terminal emulator.\n\nThis module handles operations like resizing, marking damaged regions,\nand clearing the screen. It works in conjunction with `Raxol.Terminal.ScreenBuffer`\nto manage the terminal display state.","ref":"Raxol.Terminal.Screen.html","title":"Raxol.Terminal.Screen","type":"module"},{"doc":"* Screen resizing\n* Region damage tracking\n* Screen and line clearing\n* Line and character insertion/deletion\n* Cursor movement\n* Screen scrolling","ref":"Raxol.Terminal.Screen.html#module-features","title":"Features - Raxol.Terminal.Screen","type":"module"},{"doc":"```elixir\n# Create a new screen buffer\nbuffer = ScreenBuffer.new(80, 24)\n\n# Resize the screen\nbuffer = Screen.resize(buffer, 100, 30)\n\n# Clear the screen\nbuffer = Screen.clear_screen(buffer)\n```","ref":"Raxol.Terminal.Screen.html#module-usage","title":"Usage - Raxol.Terminal.Screen","type":"module"},{"doc":"Clears a specific line in the screen.","ref":"Raxol.Terminal.Screen.html#clear_line/2","title":"Raxol.Terminal.Screen.clear_line/2","type":"function"},{"doc":"* `buffer` - The current screen buffer\n  * `line` - Line number to clear (0-based)","ref":"Raxol.Terminal.Screen.html#clear_line/2-parameters","title":"Parameters - Raxol.Terminal.Screen.clear_line/2","type":"function"},{"doc":"* Updated screen buffer with cleared line","ref":"Raxol.Terminal.Screen.html#clear_line/2-returns","title":"Returns - Raxol.Terminal.Screen.clear_line/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Screen.clear_line(buffer, 0)\n    iex> get_in(buffer.content, [0])\n    %{}","ref":"Raxol.Terminal.Screen.html#clear_line/2-examples","title":"Examples - Raxol.Terminal.Screen.clear_line/2","type":"function"},{"doc":"Clears the entire screen and resets formatting.","ref":"Raxol.Terminal.Screen.html#clear_screen/1","title":"Raxol.Terminal.Screen.clear_screen/1","type":"function"},{"doc":"* `buffer` - The current screen buffer","ref":"Raxol.Terminal.Screen.html#clear_screen/1-parameters","title":"Parameters - Raxol.Terminal.Screen.clear_screen/1","type":"function"},{"doc":"* Updated screen buffer with cleared content","ref":"Raxol.Terminal.Screen.html#clear_screen/1-returns","title":"Returns - Raxol.Terminal.Screen.clear_screen/1","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Screen.clear_screen(buffer)\n    iex> buffer.content\n    %{}","ref":"Raxol.Terminal.Screen.html#clear_screen/1-examples","title":"Examples - Raxol.Terminal.Screen.clear_screen/1","type":"function"},{"doc":"Deletes characters at the current cursor position.","ref":"Raxol.Terminal.Screen.html#delete_chars/2","title":"Raxol.Terminal.Screen.delete_chars/2","type":"function"},{"doc":"Deletes lines at the current cursor position, pulling content up.","ref":"Raxol.Terminal.Screen.html#delete_lines/2","title":"Raxol.Terminal.Screen.delete_lines/2","type":"function"},{"doc":"* `buffer` - The current screen buffer\n  * `count` - Number of lines to delete","ref":"Raxol.Terminal.Screen.html#delete_lines/2-parameters","title":"Parameters - Raxol.Terminal.Screen.delete_lines/2","type":"function"},{"doc":"* Updated screen buffer with deleted lines","ref":"Raxol.Terminal.Screen.html#delete_lines/2-returns","title":"Returns - Raxol.Terminal.Screen.delete_lines/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Screen.delete_lines(buffer, 2)\n    iex> buffer.scroll_region\n    {0, 23}","ref":"Raxol.Terminal.Screen.html#delete_lines/2-examples","title":"Examples - Raxol.Terminal.Screen.delete_lines/2","type":"function"},{"doc":"Erases characters at the current cursor position.","ref":"Raxol.Terminal.Screen.html#erase_chars/2","title":"Raxol.Terminal.Screen.erase_chars/2","type":"function"},{"doc":"Erases the display based on the specified mode.\n\nMode values:\n* 0 - Erase from cursor to end of screen\n* 1 - Erase from start of screen to cursor\n* 2 - Erase entire screen\n* 3 - Erase entire screen and scrollback buffer","ref":"Raxol.Terminal.Screen.html#erase_display/2","title":"Raxol.Terminal.Screen.erase_display/2","type":"function"},{"doc":"Inserts characters at the current cursor position, pushing existing content right.","ref":"Raxol.Terminal.Screen.html#insert_chars/2","title":"Raxol.Terminal.Screen.insert_chars/2","type":"function"},{"doc":"* `buffer` - The current screen buffer\n  * `count` - Number of characters to insert","ref":"Raxol.Terminal.Screen.html#insert_chars/2-parameters","title":"Parameters - Raxol.Terminal.Screen.insert_chars/2","type":"function"},{"doc":"* Updated screen buffer with inserted characters","ref":"Raxol.Terminal.Screen.html#insert_chars/2-returns","title":"Returns - Raxol.Terminal.Screen.insert_chars/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Screen.insert_chars(buffer, 5)\n    iex> buffer.cursor\n    {5, 0}","ref":"Raxol.Terminal.Screen.html#insert_chars/2-examples","title":"Examples - Raxol.Terminal.Screen.insert_chars/2","type":"function"},{"doc":"Inserts lines at the current cursor position, pushing existing content down.","ref":"Raxol.Terminal.Screen.html#insert_lines/2","title":"Raxol.Terminal.Screen.insert_lines/2","type":"function"},{"doc":"* `buffer` - The current screen buffer\n  * `count` - Number of lines to insert","ref":"Raxol.Terminal.Screen.html#insert_lines/2-parameters","title":"Parameters - Raxol.Terminal.Screen.insert_lines/2","type":"function"},{"doc":"* Updated screen buffer with inserted lines","ref":"Raxol.Terminal.Screen.html#insert_lines/2-returns","title":"Returns - Raxol.Terminal.Screen.insert_lines/2","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Screen.insert_lines(buffer, 2)\n    iex> buffer.scroll_region\n    {0, 23}","ref":"Raxol.Terminal.Screen.html#insert_lines/2-examples","title":"Examples - Raxol.Terminal.Screen.insert_lines/2","type":"function"},{"doc":"Marks a region of the screen as damaged, indicating it needs to be redrawn.","ref":"Raxol.Terminal.Screen.html#mark_damaged/5","title":"Raxol.Terminal.Screen.mark_damaged/5","type":"function"},{"doc":"* `buffer` - The current screen buffer\n  * `x` - Starting x coordinate\n  * `y` - Starting y coordinate\n  * `width` - Width of damaged region\n  * `height` - Height of damaged region","ref":"Raxol.Terminal.Screen.html#mark_damaged/5-parameters","title":"Parameters - Raxol.Terminal.Screen.mark_damaged/5","type":"function"},{"doc":"* Updated screen buffer with marked damage region","ref":"Raxol.Terminal.Screen.html#mark_damaged/5-returns","title":"Returns - Raxol.Terminal.Screen.mark_damaged/5","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> buffer = Screen.mark_damaged(buffer, 0, 0, 10, 5)\n    iex> buffer.damage_regions\n    [{0, 0, 10, 5}]","ref":"Raxol.Terminal.Screen.html#mark_damaged/5-examples","title":"Examples - Raxol.Terminal.Screen.mark_damaged/5","type":"function"},{"doc":"Resizes the screen buffer to new dimensions.","ref":"Raxol.Terminal.Screen.html#resize/3","title":"Raxol.Terminal.Screen.resize/3","type":"function"},{"doc":"* `buffer` - The current screen buffer\n  * `width` - New width in characters\n  * `height` - New height in characters","ref":"Raxol.Terminal.Screen.html#resize/3-parameters","title":"Parameters - Raxol.Terminal.Screen.resize/3","type":"function"},{"doc":"* Updated screen buffer with new dimensions","ref":"Raxol.Terminal.Screen.html#resize/3-returns","title":"Returns - Raxol.Terminal.Screen.resize/3","type":"function"},{"doc":"iex> buffer = ScreenBuffer.new(80, 24)\n    iex> new_buffer = Screen.resize(buffer, 100, 30)\n    iex> {new_buffer.width, new_buffer.height}\n    {100, 30}","ref":"Raxol.Terminal.Screen.html#resize/3-examples","title":"Examples - Raxol.Terminal.Screen.resize/3","type":"function"},{"doc":"Scrolls the screen down by the specified number of lines.","ref":"Raxol.Terminal.Screen.html#scroll_down/2","title":"Raxol.Terminal.Screen.scroll_down/2","type":"function"},{"doc":"Scrolls the screen up by the specified number of lines.","ref":"Raxol.Terminal.Screen.html#scroll_up_screen/2","title":"Raxol.Terminal.Screen.scroll_up_screen/2","type":"function"},{"doc":"Manages the terminal's screen buffer state (grid, scrollback, selection).\nThis module serves as the main interface for terminal buffer operations,\ndelegating specific operations to specialized modules in Raxol.Terminal.Buffer.*.","ref":"Raxol.Terminal.ScreenBuffer.html","title":"Raxol.Terminal.ScreenBuffer","type":"module"},{"doc":"The buffer consists of:\n* A main grid of cells (the visible screen)\n* A scrollback buffer for history\n* Selection state\n* Scroll region settings\n* Dimensions (width and height)","ref":"Raxol.Terminal.ScreenBuffer.html#module-structure","title":"Structure - Raxol.Terminal.ScreenBuffer","type":"module"},{"doc":"The module delegates operations to specialized modules:\n* `Content` - Writing and content management\n* `ScrollRegion` - Scroll region and scrolling operations\n* `LineOperations` - Line manipulation\n* `CharEditor` - Character editing\n* `LineEditor` - Line editing\n* `Eraser` - Clearing operations\n* `Selection` - Text selection\n* `Scrollback` - History management\n* `Queries` - State querying\n* `Initializer` - Buffer creation and validation\n* `Cursor` - Cursor state management\n* `Charset` - Character set management\n* `Formatting` - Text formatting and styling","ref":"Raxol.Terminal.ScreenBuffer.html#module-operations","title":"Operations - Raxol.Terminal.ScreenBuffer","type":"module"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.html#clear/2","title":"Raxol.Terminal.ScreenBuffer.clear/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.html#clear_damaged_regions/1","title":"Raxol.Terminal.ScreenBuffer.clear_damaged_regions/1","type":"function"},{"doc":"See  Raxol.Terminal.ScreenBuffer.Core.clear_region/5 .","ref":"Raxol.Terminal.ScreenBuffer.html#clear_region/5","title":"Raxol.Terminal.ScreenBuffer.clear_region/5","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.html#delete_chars/4","title":"Raxol.Terminal.ScreenBuffer.delete_chars/4","type":"function"},{"doc":"Deletes lines at a specific position.","ref":"Raxol.Terminal.ScreenBuffer.html#delete_lines/5","title":"Raxol.Terminal.ScreenBuffer.delete_lines/5","type":"function"},{"doc":"- For command handlers: y, count, style, and region boundaries\n- For region operations: lines, y, top, and bottom positions","ref":"Raxol.Terminal.ScreenBuffer.html#delete_lines/5-parameters","title":"Parameters - Raxol.Terminal.ScreenBuffer.delete_lines/5","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.html#erase_display/5","title":"Raxol.Terminal.ScreenBuffer.erase_display/5","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.html#erase_line/5","title":"Raxol.Terminal.ScreenBuffer.erase_line/5","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.html#get_damaged_regions/1","title":"Raxol.Terminal.ScreenBuffer.get_damaged_regions/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.html#get_scrollback/1","title":"Raxol.Terminal.ScreenBuffer.get_scrollback/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.html#insert_chars/4","title":"Raxol.Terminal.ScreenBuffer.insert_chars/4","type":"function"},{"doc":"Inserts blank lines at a specific position with style.","ref":"Raxol.Terminal.ScreenBuffer.html#insert_lines/4","title":"Raxol.Terminal.ScreenBuffer.insert_lines/4","type":"function"},{"doc":"Inserts blank lines at a specific position within a region.","ref":"Raxol.Terminal.ScreenBuffer.html#insert_lines/5","title":"Raxol.Terminal.ScreenBuffer.insert_lines/5","type":"function"},{"doc":"See  Raxol.Terminal.ScreenBuffer.Core.mark_damaged/6 .","ref":"Raxol.Terminal.ScreenBuffer.html#mark_damaged/6","title":"Raxol.Terminal.ScreenBuffer.mark_damaged/6","type":"function"},{"doc":"See  Raxol.Terminal.ScreenBuffer.Core.pop_bottom_lines/2 .","ref":"Raxol.Terminal.ScreenBuffer.html#pop_bottom_lines/2","title":"Raxol.Terminal.ScreenBuffer.pop_bottom_lines/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.html#set_dimensions/3","title":"Raxol.Terminal.ScreenBuffer.set_dimensions/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.html#set_scrollback/2","title":"Raxol.Terminal.ScreenBuffer.set_scrollback/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.html#t:t/0","title":"Raxol.Terminal.ScreenBuffer.t/0","type":"type"},{"doc":"Handles CSI (Control Sequence Introducer) sequences for the screen buffer.","ref":"Raxol.Terminal.ScreenBuffer.CSI.html","title":"Raxol.Terminal.ScreenBuffer.CSI","type":"module"},{"doc":"Handles a CSI sequence.","ref":"Raxol.Terminal.ScreenBuffer.CSI.html#handle_sequence/3","title":"Raxol.Terminal.ScreenBuffer.CSI.handle_sequence/3","type":"function"},{"doc":"Initializes a new CSI state.","ref":"Raxol.Terminal.ScreenBuffer.CSI.html#init/0","title":"Raxol.Terminal.ScreenBuffer.CSI.init/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.CSI.html#t:t/0","title":"Raxol.Terminal.ScreenBuffer.CSI.t/0","type":"type"},{"doc":"Handles character set operations for the screen buffer.","ref":"Raxol.Terminal.ScreenBuffer.Charset.html","title":"Raxol.Terminal.ScreenBuffer.Charset","type":"module"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Charset.html#apply_single_shift/2","title":"Raxol.Terminal.ScreenBuffer.Charset.apply_single_shift/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Charset.html#designate/3","title":"Raxol.Terminal.ScreenBuffer.Charset.designate/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Charset.html#get_current_g_set/1","title":"Raxol.Terminal.ScreenBuffer.Charset.get_current_g_set/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Charset.html#get_designated/2","title":"Raxol.Terminal.ScreenBuffer.Charset.get_designated/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Charset.html#get_single_shift/1","title":"Raxol.Terminal.ScreenBuffer.Charset.get_single_shift/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Charset.html#init/0","title":"Raxol.Terminal.ScreenBuffer.Charset.init/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Charset.html#invoke_g_set/2","title":"Raxol.Terminal.ScreenBuffer.Charset.invoke_g_set/2","type":"function"},{"doc":"Resets the charset state to its initial values.","ref":"Raxol.Terminal.ScreenBuffer.Charset.html#reset/1","title":"Raxol.Terminal.ScreenBuffer.Charset.reset/1","type":"function"},{"doc":"Manages cloud-related settings for the screen buffer.","ref":"Raxol.Terminal.ScreenBuffer.Cloud.html","title":"Raxol.Terminal.ScreenBuffer.Cloud","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.ScreenBuffer.Cloud.html#child_spec/1","title":"Raxol.Terminal.ScreenBuffer.Cloud.child_spec/1","type":"function"},{"doc":"Gets the current cloud configuration.","ref":"Raxol.Terminal.ScreenBuffer.Cloud.html#get_config/0","title":"Raxol.Terminal.ScreenBuffer.Cloud.get_config/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Cloud.html#init/0","title":"Raxol.Terminal.ScreenBuffer.Cloud.init/0","type":"function"},{"doc":"Callback implementation for  GenServer.init/1 .","ref":"Raxol.Terminal.ScreenBuffer.Cloud.html#init/1","title":"Raxol.Terminal.ScreenBuffer.Cloud.init/1","type":"function"},{"doc":"Sets new cloud configuration.","ref":"Raxol.Terminal.ScreenBuffer.Cloud.html#set_config/1","title":"Raxol.Terminal.ScreenBuffer.Cloud.set_config/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Cloud.html#start_link/1","title":"Raxol.Terminal.ScreenBuffer.Cloud.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Cloud.html#t:t/0","title":"Raxol.Terminal.ScreenBuffer.Cloud.t/0","type":"type"},{"doc":"Core implementation of the screen buffer functionality.\nImplements the Raxol.Terminal.ScreenBufferBehaviour.","ref":"Raxol.Terminal.ScreenBuffer.Core.html","title":"Raxol.Terminal.ScreenBuffer.Core","type":"module"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#clear/2","title":"Raxol.Terminal.ScreenBuffer.Core.clear/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#clear_line/3","title":"Raxol.Terminal.ScreenBuffer.Core.clear_line/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#clear_region/5","title":"Raxol.Terminal.ScreenBuffer.Core.clear_region/5","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.ScreenBufferBehaviour.clear_scroll_region/1 .","ref":"Raxol.Terminal.ScreenBuffer.Core.html#clear_scroll_region/1","title":"Raxol.Terminal.ScreenBuffer.Core.clear_scroll_region/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#delete_chars/2","title":"Raxol.Terminal.ScreenBuffer.Core.delete_chars/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#delete_lines/2","title":"Raxol.Terminal.ScreenBuffer.Core.delete_lines/2","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.ScreenBufferBehaviour.erase_all/1 .","ref":"Raxol.Terminal.ScreenBuffer.Core.html#erase_all/1","title":"Raxol.Terminal.ScreenBuffer.Core.erase_all/1","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.ScreenBufferBehaviour.erase_all_with_scrollback/1 .","ref":"Raxol.Terminal.ScreenBuffer.Core.html#erase_all_with_scrollback/1","title":"Raxol.Terminal.ScreenBuffer.Core.erase_all_with_scrollback/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#erase_chars/2","title":"Raxol.Terminal.ScreenBuffer.Core.erase_chars/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#erase_display/2","title":"Raxol.Terminal.ScreenBuffer.Core.erase_display/2","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.ScreenBufferBehaviour.erase_from_cursor_to_end/1 .","ref":"Raxol.Terminal.ScreenBuffer.Core.html#erase_from_cursor_to_end/1","title":"Raxol.Terminal.ScreenBuffer.Core.erase_from_cursor_to_end/1","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.ScreenBufferBehaviour.erase_from_cursor_to_end_of_line/1 .","ref":"Raxol.Terminal.ScreenBuffer.Core.html#erase_from_cursor_to_end_of_line/1","title":"Raxol.Terminal.ScreenBuffer.Core.erase_from_cursor_to_end_of_line/1","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.ScreenBufferBehaviour.erase_from_start_of_line_to_cursor/1 .","ref":"Raxol.Terminal.ScreenBuffer.Core.html#erase_from_start_of_line_to_cursor/1","title":"Raxol.Terminal.ScreenBuffer.Core.erase_from_start_of_line_to_cursor/1","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.ScreenBufferBehaviour.erase_from_start_to_cursor/1 .","ref":"Raxol.Terminal.ScreenBuffer.Core.html#erase_from_start_to_cursor/1","title":"Raxol.Terminal.ScreenBuffer.Core.erase_from_start_to_cursor/1","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.ScreenBufferBehaviour.erase_line/1 .","ref":"Raxol.Terminal.ScreenBuffer.Core.html#erase_line/1","title":"Raxol.Terminal.ScreenBuffer.Core.erase_line/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#erase_region/5","title":"Raxol.Terminal.ScreenBuffer.Core.erase_region/5","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#get_cursor_position/1","title":"Raxol.Terminal.ScreenBuffer.Core.get_cursor_position/1","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.ScreenBufferBehaviour.get_scroll_position/1 .","ref":"Raxol.Terminal.ScreenBuffer.Core.html#get_scroll_position/1","title":"Raxol.Terminal.ScreenBuffer.Core.get_scroll_position/1","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.ScreenBufferBehaviour.get_scroll_region_boundaries/1 .","ref":"Raxol.Terminal.ScreenBuffer.Core.html#get_scroll_region_boundaries/1","title":"Raxol.Terminal.ScreenBuffer.Core.get_scroll_region_boundaries/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#insert_chars/2","title":"Raxol.Terminal.ScreenBuffer.Core.insert_chars/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#insert_lines/2","title":"Raxol.Terminal.ScreenBuffer.Core.insert_lines/2","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.ScreenBufferBehaviour.mark_damaged/5 .","ref":"Raxol.Terminal.ScreenBuffer.Core.html#mark_damaged/5","title":"Raxol.Terminal.ScreenBuffer.Core.mark_damaged/5","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#pop_bottom_lines/2","title":"Raxol.Terminal.ScreenBuffer.Core.pop_bottom_lines/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#push_top_lines/2","title":"Raxol.Terminal.ScreenBuffer.Core.push_top_lines/2","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.ScreenBufferBehaviour.scroll_down/2 .","ref":"Raxol.Terminal.ScreenBuffer.Core.html#scroll_down/2","title":"Raxol.Terminal.ScreenBuffer.Core.scroll_down/2","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.ScreenBufferBehaviour.scroll_up/2 .","ref":"Raxol.Terminal.ScreenBuffer.Core.html#scroll_up/2","title":"Raxol.Terminal.ScreenBuffer.Core.scroll_up/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#set_cursor_position/3","title":"Raxol.Terminal.ScreenBuffer.Core.set_cursor_position/3","type":"function"},{"doc":"Callback implementation for  Raxol.Terminal.ScreenBufferBehaviour.set_scroll_region/3 .","ref":"Raxol.Terminal.ScreenBuffer.Core.html#set_scroll_region/3","title":"Raxol.Terminal.ScreenBuffer.Core.set_scroll_region/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#t:t/0","title":"Raxol.Terminal.ScreenBuffer.Core.t/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Core.html#unimplemented/1","title":"Raxol.Terminal.ScreenBuffer.Core.unimplemented/1","type":"function"},{"doc":"Handles file system event monitoring for the terminal screen buffer.\nThis module provides functions for processing file system events and managing\ndebounced event handling.","ref":"Raxol.Terminal.ScreenBuffer.FileWatcher.html","title":"Raxol.Terminal.ScreenBuffer.FileWatcher","type":"module"},{"doc":"Cleans up the file watcher state.\nReturns a new file watcher state with all watched paths and pending events cleared.","ref":"Raxol.Terminal.ScreenBuffer.FileWatcher.html#cleanup/1","title":"Raxol.Terminal.ScreenBuffer.FileWatcher.cleanup/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.FileWatcher.html#t:debounce_timeout/0","title":"Raxol.Terminal.ScreenBuffer.FileWatcher.debounce_timeout/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.FileWatcher.html#t:event/0","title":"Raxol.Terminal.ScreenBuffer.FileWatcher.event/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.FileWatcher.html#t:events/0","title":"Raxol.Terminal.ScreenBuffer.FileWatcher.events/0","type":"type"},{"doc":"Handles debounced file system events.\nReturns a new file watcher state with the events processed after the timeout.","ref":"Raxol.Terminal.ScreenBuffer.FileWatcher.html#handle_debounced/3","title":"Raxol.Terminal.ScreenBuffer.FileWatcher.handle_debounced/3","type":"function"},{"doc":"Handles a file system event.\nReturns a new file watcher state with the event processed.","ref":"Raxol.Terminal.ScreenBuffer.FileWatcher.html#handle_event/2","title":"Raxol.Terminal.ScreenBuffer.FileWatcher.handle_event/2","type":"function"},{"doc":"Initializes a new file watcher struct with default values.","ref":"Raxol.Terminal.ScreenBuffer.FileWatcher.html#init/0","title":"Raxol.Terminal.ScreenBuffer.FileWatcher.init/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.FileWatcher.html#t:t/0","title":"Raxol.Terminal.ScreenBuffer.FileWatcher.t/0","type":"type"},{"doc":"Handles text formatting operations for the screen buffer.","ref":"Raxol.Terminal.ScreenBuffer.Formatting.html","title":"Raxol.Terminal.ScreenBuffer.Formatting","type":"module"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Formatting.html#attribute_set?/2","title":"Raxol.Terminal.ScreenBuffer.Formatting.attribute_set?/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Formatting.html#get_background/1","title":"Raxol.Terminal.ScreenBuffer.Formatting.get_background/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Formatting.html#get_foreground/1","title":"Raxol.Terminal.ScreenBuffer.Formatting.get_foreground/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Formatting.html#get_set_attributes/1","title":"Raxol.Terminal.ScreenBuffer.Formatting.get_set_attributes/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Formatting.html#get_style/1","title":"Raxol.Terminal.ScreenBuffer.Formatting.get_style/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Formatting.html#init/0","title":"Raxol.Terminal.ScreenBuffer.Formatting.init/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Formatting.html#reset_all/1","title":"Raxol.Terminal.ScreenBuffer.Formatting.reset_all/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Formatting.html#reset_attribute/2","title":"Raxol.Terminal.ScreenBuffer.Formatting.reset_attribute/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Formatting.html#set_attribute/2","title":"Raxol.Terminal.ScreenBuffer.Formatting.set_attribute/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Formatting.html#set_background/2","title":"Raxol.Terminal.ScreenBuffer.Formatting.set_background/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Formatting.html#set_foreground/2","title":"Raxol.Terminal.ScreenBuffer.Formatting.set_foreground/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Formatting.html#update_style/2","title":"Raxol.Terminal.ScreenBuffer.Formatting.update_style/2","type":"function"},{"doc":"Handles metrics collection and management for the terminal screen buffer.\nThis module provides functions for recording and retrieving various metrics\nrelated to screen buffer performance, operations, and resource usage.","ref":"Raxol.Terminal.ScreenBuffer.Metrics.html","title":"Raxol.Terminal.ScreenBuffer.Metrics","type":"module"},{"doc":"Collects metrics of a specific type.\nReturns a map of metric names to their values.","ref":"Raxol.Terminal.ScreenBuffer.Metrics.html#collect/2","title":"Raxol.Terminal.ScreenBuffer.Metrics.collect/2","type":"function"},{"doc":"Gets a metric value with optional tags.\nReturns the metric value if found, nil otherwise.","ref":"Raxol.Terminal.ScreenBuffer.Metrics.html#get/3","title":"Raxol.Terminal.ScreenBuffer.Metrics.get/3","type":"function"},{"doc":"Gets metrics by type.\nReturns a map of metric names to their values for the specified type.","ref":"Raxol.Terminal.ScreenBuffer.Metrics.html#get_by_type/2","title":"Raxol.Terminal.ScreenBuffer.Metrics.get_by_type/2","type":"function"},{"doc":"Gets the value of a specific metric.\nReturns the metric value and its associated tags.","ref":"Raxol.Terminal.ScreenBuffer.Metrics.html#get_value/2","title":"Raxol.Terminal.ScreenBuffer.Metrics.get_value/2","type":"function"},{"doc":"Initializes a new metrics struct with default values.","ref":"Raxol.Terminal.ScreenBuffer.Metrics.html#init/0","title":"Raxol.Terminal.ScreenBuffer.Metrics.init/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Metrics.html#t:metric_tags/0","title":"Raxol.Terminal.ScreenBuffer.Metrics.metric_tags/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Metrics.html#t:metric_type/0","title":"Raxol.Terminal.ScreenBuffer.Metrics.metric_type/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Metrics.html#t:metric_value/0","title":"Raxol.Terminal.ScreenBuffer.Metrics.metric_value/0","type":"type"},{"doc":"Records a metric with optional tags.\nReturns a new metrics state with the metric recorded.","ref":"Raxol.Terminal.ScreenBuffer.Metrics.html#record/4","title":"Raxol.Terminal.ScreenBuffer.Metrics.record/4","type":"function"},{"doc":"Records an operation metric.\nReturns a new metrics state with the operation metric updated.","ref":"Raxol.Terminal.ScreenBuffer.Metrics.html#record_operation/3","title":"Raxol.Terminal.ScreenBuffer.Metrics.record_operation/3","type":"function"},{"doc":"Records a performance metric.\nReturns a new metrics state with the performance metric updated.","ref":"Raxol.Terminal.ScreenBuffer.Metrics.html#record_performance/3","title":"Raxol.Terminal.ScreenBuffer.Metrics.record_performance/3","type":"function"},{"doc":"Records a resource metric.\nReturns a new metrics state with the resource metric updated.","ref":"Raxol.Terminal.ScreenBuffer.Metrics.html#record_resource/3","title":"Raxol.Terminal.ScreenBuffer.Metrics.record_resource/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Metrics.html#t:t/0","title":"Raxol.Terminal.ScreenBuffer.Metrics.t/0","type":"type"},{"doc":"Verifies if the given metrics exist in the state.\nReturns true if all metrics exist, false otherwise.","ref":"Raxol.Terminal.ScreenBuffer.Metrics.html#verify/2","title":"Raxol.Terminal.ScreenBuffer.Metrics.verify/2","type":"function"},{"doc":"Handles terminal mode state management.","ref":"Raxol.Terminal.ScreenBuffer.Mode.html","title":"Raxol.Terminal.ScreenBuffer.Mode","type":"module"},{"doc":"Handles mode changes.","ref":"Raxol.Terminal.ScreenBuffer.Mode.html#handle/3","title":"Raxol.Terminal.ScreenBuffer.Mode.handle/3","type":"function"},{"doc":"Initializes a new mode state.","ref":"Raxol.Terminal.ScreenBuffer.Mode.html#init/0","title":"Raxol.Terminal.ScreenBuffer.Mode.init/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Mode.html#t:t/0","title":"Raxol.Terminal.ScreenBuffer.Mode.t/0","type":"type"},{"doc":"Handles output buffer operations for the terminal screen buffer.\nThis module manages the output buffer state and provides functions for writing,\nflushing, and clearing the buffer.","ref":"Raxol.Terminal.ScreenBuffer.Output.html","title":"Raxol.Terminal.ScreenBuffer.Output","type":"module"},{"doc":"Clears the output buffer and control sequences.\nReturns a new output buffer state with empty buffer and control sequences.","ref":"Raxol.Terminal.ScreenBuffer.Output.html#clear/1","title":"Raxol.Terminal.ScreenBuffer.Output.clear/1","type":"function"},{"doc":"Enqueues a control sequence to be processed.\nReturns a new output buffer state with the sequence added to the queue.","ref":"Raxol.Terminal.ScreenBuffer.Output.html#enqueue_control_sequence/2","title":"Raxol.Terminal.ScreenBuffer.Output.enqueue_control_sequence/2","type":"function"},{"doc":"Flushes the output buffer.\nReturns a new output buffer state with an empty buffer.","ref":"Raxol.Terminal.ScreenBuffer.Output.html#flush/1","title":"Raxol.Terminal.ScreenBuffer.Output.flush/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Output.html#t:t/0","title":"Raxol.Terminal.ScreenBuffer.Output.t/0","type":"type"},{"doc":"Writes data to the output buffer.\nReturns a new output buffer state with the data appended.","ref":"Raxol.Terminal.ScreenBuffer.Output.html#write/2","title":"Raxol.Terminal.ScreenBuffer.Output.write/2","type":"function"},{"doc":"Manages screen buffer preferences and settings.","ref":"Raxol.Terminal.ScreenBuffer.Preferences.html","title":"Raxol.Terminal.ScreenBuffer.Preferences","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.ScreenBuffer.Preferences.html#child_spec/1","title":"Raxol.Terminal.ScreenBuffer.Preferences.child_spec/1","type":"function"},{"doc":"Gets the current preferences.","ref":"Raxol.Terminal.ScreenBuffer.Preferences.html#get/0","title":"Raxol.Terminal.ScreenBuffer.Preferences.get/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Preferences.html#init/0","title":"Raxol.Terminal.ScreenBuffer.Preferences.init/0","type":"function"},{"doc":"Callback implementation for  GenServer.init/1 .","ref":"Raxol.Terminal.ScreenBuffer.Preferences.html#init/1","title":"Raxol.Terminal.ScreenBuffer.Preferences.init/1","type":"function"},{"doc":"Sets new preferences.","ref":"Raxol.Terminal.ScreenBuffer.Preferences.html#set/1","title":"Raxol.Terminal.ScreenBuffer.Preferences.set/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Preferences.html#start_link/1","title":"Raxol.Terminal.ScreenBuffer.Preferences.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Preferences.html#t:t/0","title":"Raxol.Terminal.ScreenBuffer.Preferences.t/0","type":"type"},{"doc":"Handles screen buffer operations for the terminal emulator.\nThis module provides functions for managing the screen state, including\nclearing, erasing, and marking damaged regions.","ref":"Raxol.Terminal.ScreenBuffer.Screen.html","title":"Raxol.Terminal.ScreenBuffer.Screen","type":"module"},{"doc":"Clears the entire screen.","ref":"Raxol.Terminal.ScreenBuffer.Screen.html#clear/1","title":"Raxol.Terminal.ScreenBuffer.Screen.clear/1","type":"function"},{"doc":"Erases the entire screen.","ref":"Raxol.Terminal.ScreenBuffer.Screen.html#erase_all/1","title":"Raxol.Terminal.ScreenBuffer.Screen.erase_all/1","type":"function"},{"doc":"Erases the entire screen including scrollback.","ref":"Raxol.Terminal.ScreenBuffer.Screen.html#erase_all_with_scrollback/1","title":"Raxol.Terminal.ScreenBuffer.Screen.erase_all_with_scrollback/1","type":"function"},{"doc":"Erases from cursor to end of screen.","ref":"Raxol.Terminal.ScreenBuffer.Screen.html#erase_from_cursor_to_end/1","title":"Raxol.Terminal.ScreenBuffer.Screen.erase_from_cursor_to_end/1","type":"function"},{"doc":"Erases from cursor to end of line.","ref":"Raxol.Terminal.ScreenBuffer.Screen.html#erase_from_cursor_to_end_of_line/1","title":"Raxol.Terminal.ScreenBuffer.Screen.erase_from_cursor_to_end_of_line/1","type":"function"},{"doc":"Erases from start of line to cursor.","ref":"Raxol.Terminal.ScreenBuffer.Screen.html#erase_from_start_of_line_to_cursor/1","title":"Raxol.Terminal.ScreenBuffer.Screen.erase_from_start_of_line_to_cursor/1","type":"function"},{"doc":"Erases from start of screen to cursor.","ref":"Raxol.Terminal.ScreenBuffer.Screen.html#erase_from_start_to_cursor/1","title":"Raxol.Terminal.ScreenBuffer.Screen.erase_from_start_to_cursor/1","type":"function"},{"doc":"Erases the entire line.","ref":"Raxol.Terminal.ScreenBuffer.Screen.html#erase_line/1","title":"Raxol.Terminal.ScreenBuffer.Screen.erase_line/1","type":"function"},{"doc":"Initializes a new screen state.","ref":"Raxol.Terminal.ScreenBuffer.Screen.html#init/0","title":"Raxol.Terminal.ScreenBuffer.Screen.init/0","type":"function"},{"doc":"Marks a region of the screen as damaged.","ref":"Raxol.Terminal.ScreenBuffer.Screen.html#mark_damaged/5","title":"Raxol.Terminal.ScreenBuffer.Screen.mark_damaged/5","type":"function"},{"doc":"Handles scroll state management for the terminal screen buffer.","ref":"Raxol.Terminal.ScreenBuffer.Scroll.html","title":"Raxol.Terminal.ScreenBuffer.Scroll","type":"module"},{"doc":"Clears the scroll region, resetting to full screen.","ref":"Raxol.Terminal.ScreenBuffer.Scroll.html#clear_region/1","title":"Raxol.Terminal.ScreenBuffer.Scroll.clear_region/1","type":"function"},{"doc":"Moves the scroll position down by the specified number of lines.","ref":"Raxol.Terminal.ScreenBuffer.Scroll.html#down/2","title":"Raxol.Terminal.ScreenBuffer.Scroll.down/2","type":"function"},{"doc":"Gets the current scroll region boundaries.","ref":"Raxol.Terminal.ScreenBuffer.Scroll.html#get_boundaries/1","title":"Raxol.Terminal.ScreenBuffer.Scroll.get_boundaries/1","type":"function"},{"doc":"Gets the current scroll position.","ref":"Raxol.Terminal.ScreenBuffer.Scroll.html#get_position/1","title":"Raxol.Terminal.ScreenBuffer.Scroll.get_position/1","type":"function"},{"doc":"Gets the current scroll size.","ref":"Raxol.Terminal.ScreenBuffer.Scroll.html#get_size/1","title":"Raxol.Terminal.ScreenBuffer.Scroll.get_size/1","type":"function"},{"doc":"Initializes a new scroll state.","ref":"Raxol.Terminal.ScreenBuffer.Scroll.html#init/0","title":"Raxol.Terminal.ScreenBuffer.Scroll.init/0","type":"function"},{"doc":"Sets the scroll region boundaries.","ref":"Raxol.Terminal.ScreenBuffer.Scroll.html#set_region/3","title":"Raxol.Terminal.ScreenBuffer.Scroll.set_region/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Scroll.html#t:t/0","title":"Raxol.Terminal.ScreenBuffer.Scroll.t/0","type":"type"},{"doc":"Moves the scroll position up by the specified number of lines.","ref":"Raxol.Terminal.ScreenBuffer.Scroll.html#up/2","title":"Raxol.Terminal.ScreenBuffer.Scroll.up/2","type":"function"},{"doc":"Handles terminal state operations for the screen buffer.","ref":"Raxol.Terminal.ScreenBuffer.State.html","title":"Raxol.Terminal.ScreenBuffer.State","type":"module"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.State.html#clear_saved_states/1","title":"Raxol.Terminal.ScreenBuffer.State.clear_saved_states/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.State.html#get_current/1","title":"Raxol.Terminal.ScreenBuffer.State.get_current/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.State.html#get_saved_states_count/1","title":"Raxol.Terminal.ScreenBuffer.State.get_saved_states_count/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.State.html#get_stack/1","title":"Raxol.Terminal.ScreenBuffer.State.get_stack/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.State.html#has_saved_states?/1","title":"Raxol.Terminal.ScreenBuffer.State.has_saved_states?/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.State.html#init/0","title":"Raxol.Terminal.ScreenBuffer.State.init/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.State.html#restore/1","title":"Raxol.Terminal.ScreenBuffer.State.restore/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.State.html#save/1","title":"Raxol.Terminal.ScreenBuffer.State.save/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.State.html#update_current/2","title":"Raxol.Terminal.ScreenBuffer.State.update_current/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.State.html#update_stack/2","title":"Raxol.Terminal.ScreenBuffer.State.update_stack/2","type":"function"},{"doc":"Manages system-related settings for the screen buffer.","ref":"Raxol.Terminal.ScreenBuffer.System.html","title":"Raxol.Terminal.ScreenBuffer.System","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.ScreenBuffer.System.html#child_spec/1","title":"Raxol.Terminal.ScreenBuffer.System.child_spec/1","type":"function"},{"doc":"Gets the current update settings.","ref":"Raxol.Terminal.ScreenBuffer.System.html#get_update_settings/0","title":"Raxol.Terminal.ScreenBuffer.System.get_update_settings/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.System.html#init/0","title":"Raxol.Terminal.ScreenBuffer.System.init/0","type":"function"},{"doc":"Callback implementation for  GenServer.init/1 .","ref":"Raxol.Terminal.ScreenBuffer.System.html#init/1","title":"Raxol.Terminal.ScreenBuffer.System.init/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.System.html#start_link/1","title":"Raxol.Terminal.ScreenBuffer.System.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.System.html#t:t/0","title":"Raxol.Terminal.ScreenBuffer.System.t/0","type":"type"},{"doc":"Manages themes for the screen buffer.","ref":"Raxol.Terminal.ScreenBuffer.Theme.html","title":"Raxol.Terminal.ScreenBuffer.Theme","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.ScreenBuffer.Theme.html#child_spec/1","title":"Raxol.Terminal.ScreenBuffer.Theme.child_spec/1","type":"function"},{"doc":"Gets the current theme.","ref":"Raxol.Terminal.ScreenBuffer.Theme.html#current/0","title":"Raxol.Terminal.ScreenBuffer.Theme.current/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Theme.html#init/0","title":"Raxol.Terminal.ScreenBuffer.Theme.init/0","type":"function"},{"doc":"Callback implementation for  GenServer.init/1 .","ref":"Raxol.Terminal.ScreenBuffer.Theme.html#init/1","title":"Raxol.Terminal.ScreenBuffer.Theme.init/1","type":"function"},{"doc":"Sets the light theme.","ref":"Raxol.Terminal.ScreenBuffer.Theme.html#light/0","title":"Raxol.Terminal.ScreenBuffer.Theme.light/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Theme.html#start_link/1","title":"Raxol.Terminal.ScreenBuffer.Theme.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Theme.html#t:t/0","title":"Raxol.Terminal.ScreenBuffer.Theme.t/0","type":"type"},{"doc":"Handles screen visualization and chart creation.","ref":"Raxol.Terminal.ScreenBuffer.Visualizer.html","title":"Raxol.Terminal.ScreenBuffer.Visualizer","type":"module"},{"doc":"Creates a new chart with the given data and options.","ref":"Raxol.Terminal.ScreenBuffer.Visualizer.html#create_chart/3","title":"Raxol.Terminal.ScreenBuffer.Visualizer.create_chart/3","type":"function"},{"doc":"Initializes a new visualizer state.","ref":"Raxol.Terminal.ScreenBuffer.Visualizer.html#init/0","title":"Raxol.Terminal.ScreenBuffer.Visualizer.init/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.ScreenBuffer.Visualizer.html#t:t/0","title":"Raxol.Terminal.ScreenBuffer.Visualizer.t/0","type":"type"},{"doc":"Defines the behaviour for screen buffer operations in the terminal.\nThis module specifies the callbacks that must be implemented by any module\nthat wants to act as a screen buffer.","ref":"Raxol.Terminal.ScreenBufferBehaviour.html","title":"Raxol.Terminal.ScreenBufferBehaviour","type":"behaviour"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:apply_single_shift/2","title":"Raxol.Terminal.ScreenBufferBehaviour.apply_single_shift/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:attribute_set?/2","title":"Raxol.Terminal.ScreenBufferBehaviour.attribute_set?/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#t:charset/0","title":"Raxol.Terminal.ScreenBufferBehaviour.charset/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:cleanup_file_watching/1","title":"Raxol.Terminal.ScreenBufferBehaviour.cleanup_file_watching/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:clear_line/2","title":"Raxol.Terminal.ScreenBufferBehaviour.clear_line/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:clear_output_buffer/1","title":"Raxol.Terminal.ScreenBufferBehaviour.clear_output_buffer/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:clear_saved_states/1","title":"Raxol.Terminal.ScreenBufferBehaviour.clear_saved_states/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:clear_screen/1","title":"Raxol.Terminal.ScreenBufferBehaviour.clear_screen/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:clear_scroll_region/1","title":"Raxol.Terminal.ScreenBufferBehaviour.clear_scroll_region/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:collect_metrics/2","title":"Raxol.Terminal.ScreenBufferBehaviour.collect_metrics/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#t:color/0","title":"Raxol.Terminal.ScreenBufferBehaviour.color/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:create_chart/3","title":"Raxol.Terminal.ScreenBufferBehaviour.create_chart/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:current_theme/0","title":"Raxol.Terminal.ScreenBufferBehaviour.current_theme/0","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:designate_charset/3","title":"Raxol.Terminal.ScreenBufferBehaviour.designate_charset/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#t:dimensions/0","title":"Raxol.Terminal.ScreenBufferBehaviour.dimensions/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:enqueue_control_sequence/2","title":"Raxol.Terminal.ScreenBufferBehaviour.enqueue_control_sequence/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:erase_all/1","title":"Raxol.Terminal.ScreenBufferBehaviour.erase_all/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:erase_all_with_scrollback/1","title":"Raxol.Terminal.ScreenBufferBehaviour.erase_all_with_scrollback/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:erase_from_cursor_to_end/1","title":"Raxol.Terminal.ScreenBufferBehaviour.erase_from_cursor_to_end/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:erase_from_cursor_to_end_of_line/1","title":"Raxol.Terminal.ScreenBufferBehaviour.erase_from_cursor_to_end_of_line/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:erase_from_start_of_line_to_cursor/1","title":"Raxol.Terminal.ScreenBufferBehaviour.erase_from_start_of_line_to_cursor/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:erase_from_start_to_cursor/1","title":"Raxol.Terminal.ScreenBufferBehaviour.erase_from_start_to_cursor/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:erase_line/1","title":"Raxol.Terminal.ScreenBufferBehaviour.erase_line/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:flush_output/1","title":"Raxol.Terminal.ScreenBufferBehaviour.flush_output/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_background/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_background/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_cell/3","title":"Raxol.Terminal.ScreenBufferBehaviour.get_cell/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_char/3","title":"Raxol.Terminal.ScreenBufferBehaviour.get_char/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_config/0","title":"Raxol.Terminal.ScreenBufferBehaviour.get_config/0","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_current_g_set/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_current_g_set/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_current_state/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_current_state/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_designated_charset/2","title":"Raxol.Terminal.ScreenBufferBehaviour.get_designated_charset/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_dimensions/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_dimensions/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_foreground/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_foreground/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_height/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_height/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_metric/3","title":"Raxol.Terminal.ScreenBufferBehaviour.get_metric/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_metric_value/2","title":"Raxol.Terminal.ScreenBufferBehaviour.get_metric_value/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_metrics_by_type/2","title":"Raxol.Terminal.ScreenBufferBehaviour.get_metrics_by_type/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_output_buffer/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_output_buffer/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_preferences/0","title":"Raxol.Terminal.ScreenBufferBehaviour.get_preferences/0","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_saved_states_count/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_saved_states_count/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_scroll_position/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_scroll_position/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_scroll_region_boundaries/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_scroll_region_boundaries/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_set_attributes/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_set_attributes/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_single_shift/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_single_shift/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_size/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_size/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_state_stack/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_state_stack/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_style/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_style/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_update_settings/0","title":"Raxol.Terminal.ScreenBufferBehaviour.get_update_settings/0","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:get_width/1","title":"Raxol.Terminal.ScreenBufferBehaviour.get_width/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:handle_csi_sequence/3","title":"Raxol.Terminal.ScreenBufferBehaviour.handle_csi_sequence/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:handle_debounced_events/3","title":"Raxol.Terminal.ScreenBufferBehaviour.handle_debounced_events/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:handle_file_event/2","title":"Raxol.Terminal.ScreenBufferBehaviour.handle_file_event/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:handle_mode/3","title":"Raxol.Terminal.ScreenBufferBehaviour.handle_mode/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:has_saved_states?/1","title":"Raxol.Terminal.ScreenBufferBehaviour.has_saved_states?/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:invoke_g_set/2","title":"Raxol.Terminal.ScreenBufferBehaviour.invoke_g_set/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:is_empty?/1","title":"Raxol.Terminal.ScreenBufferBehaviour.is_empty?/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:light_theme/0","title":"Raxol.Terminal.ScreenBufferBehaviour.light_theme/0","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:mark_damaged/5","title":"Raxol.Terminal.ScreenBufferBehaviour.mark_damaged/5","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#t:metric/0","title":"Raxol.Terminal.ScreenBufferBehaviour.metric/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#t:metric_tags/0","title":"Raxol.Terminal.ScreenBufferBehaviour.metric_tags/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#t:metric_value/0","title":"Raxol.Terminal.ScreenBufferBehaviour.metric_value/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:new/2","title":"Raxol.Terminal.ScreenBufferBehaviour.new/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#t:position/0","title":"Raxol.Terminal.ScreenBufferBehaviour.position/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:record_metric/4","title":"Raxol.Terminal.ScreenBufferBehaviour.record_metric/4","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:record_operation/3","title":"Raxol.Terminal.ScreenBufferBehaviour.record_operation/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:record_performance/3","title":"Raxol.Terminal.ScreenBufferBehaviour.record_performance/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:record_resource/3","title":"Raxol.Terminal.ScreenBufferBehaviour.record_resource/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:reset_all_attributes/1","title":"Raxol.Terminal.ScreenBufferBehaviour.reset_all_attributes/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:reset_attribute/2","title":"Raxol.Terminal.ScreenBufferBehaviour.reset_attribute/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:reset_state/1","title":"Raxol.Terminal.ScreenBufferBehaviour.reset_state/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:restore_state/1","title":"Raxol.Terminal.ScreenBufferBehaviour.restore_state/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:save_state/1","title":"Raxol.Terminal.ScreenBufferBehaviour.save_state/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:scroll_down/2","title":"Raxol.Terminal.ScreenBufferBehaviour.scroll_down/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:scroll_up/2","title":"Raxol.Terminal.ScreenBufferBehaviour.scroll_up/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:set_attribute/2","title":"Raxol.Terminal.ScreenBufferBehaviour.set_attribute/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:set_background/2","title":"Raxol.Terminal.ScreenBufferBehaviour.set_background/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:set_config/1","title":"Raxol.Terminal.ScreenBufferBehaviour.set_config/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:set_foreground/2","title":"Raxol.Terminal.ScreenBufferBehaviour.set_foreground/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:set_preferences/1","title":"Raxol.Terminal.ScreenBufferBehaviour.set_preferences/1","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:set_scroll_region/3","title":"Raxol.Terminal.ScreenBufferBehaviour.set_scroll_region/3","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#t:style/0","title":"Raxol.Terminal.ScreenBufferBehaviour.style/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#t:t/0","title":"Raxol.Terminal.ScreenBufferBehaviour.t/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:update_current_state/2","title":"Raxol.Terminal.ScreenBufferBehaviour.update_current_state/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:update_state_stack/2","title":"Raxol.Terminal.ScreenBufferBehaviour.update_state_stack/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:update_style/2","title":"Raxol.Terminal.ScreenBufferBehaviour.update_style/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:verify_metrics/2","title":"Raxol.Terminal.ScreenBufferBehaviour.verify_metrics/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:write/2","title":"Raxol.Terminal.ScreenBufferBehaviour.write/2","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:write_char/5","title":"Raxol.Terminal.ScreenBufferBehaviour.write_char/5","type":"callback"},{"doc":"","ref":"Raxol.Terminal.ScreenBufferBehaviour.html#c:write_string/5","title":"Raxol.Terminal.ScreenBufferBehaviour.write_string/5","type":"callback"},{"doc":"Manages screen buffer operations for the terminal emulator.\nThis module handles operations related to the main and alternate screen buffers,\nincluding buffer switching, initialization, and state management.","ref":"Raxol.Terminal.ScreenManager.html","title":"Raxol.Terminal.ScreenManager","type":"module"},{"doc":"Gets the currently active screen buffer.","ref":"Raxol.Terminal.ScreenManager.html#get_active_buffer/1","title":"Raxol.Terminal.ScreenManager.get_active_buffer/1","type":"function"},{"doc":"Gets the current buffer type (main or alternate).","ref":"Raxol.Terminal.ScreenManager.html#get_buffer_type/1","title":"Raxol.Terminal.ScreenManager.get_buffer_type/1","type":"function"},{"doc":"Initializes both main and alternate screen buffers.","ref":"Raxol.Terminal.ScreenManager.html#initialize_buffers/3","title":"Raxol.Terminal.ScreenManager.initialize_buffers/3","type":"function"},{"doc":"Resizes both screen buffers.","ref":"Raxol.Terminal.ScreenManager.html#resize_buffers/3","title":"Raxol.Terminal.ScreenManager.resize_buffers/3","type":"function"},{"doc":"Sets the buffer type.","ref":"Raxol.Terminal.ScreenManager.html#set_buffer_type/2","title":"Raxol.Terminal.ScreenManager.set_buffer_type/2","type":"function"},{"doc":"Switches between main and alternate screen buffers.","ref":"Raxol.Terminal.ScreenManager.html#switch_buffer/1","title":"Raxol.Terminal.ScreenManager.switch_buffer/1","type":"function"},{"doc":"Updates the currently active screen buffer.","ref":"Raxol.Terminal.ScreenManager.html#update_active_buffer/2","title":"Raxol.Terminal.ScreenManager.update_active_buffer/2","type":"function"},{"doc":"Manages terminal screen state and updates.\n\nThis module is responsible for:\n- Managing screen buffer state\n- Handling screen updates\n- Coordinating screen state transitions\n- Managing screen dimensions","ref":"Raxol.Terminal.ScreenUpdater.html","title":"Raxol.Terminal.ScreenUpdater","type":"module"},{"doc":"Updates the screen with multiple updates.","ref":"Raxol.Terminal.ScreenUpdater.html#batch_update_screen/2","title":"Raxol.Terminal.ScreenUpdater.batch_update_screen/2","type":"function"},{"doc":"* `emulator` - The current terminal emulator state\n  * `updates` - The list of screen updates to apply","ref":"Raxol.Terminal.ScreenUpdater.html#batch_update_screen/2-parameters","title":"Parameters - Raxol.Terminal.ScreenUpdater.batch_update_screen/2","type":"function"},{"doc":"* `{updated_emulator, output}` - The updated emulator state and any output","ref":"Raxol.Terminal.ScreenUpdater.html#batch_update_screen/2-returns","title":"Returns - Raxol.Terminal.ScreenUpdater.batch_update_screen/2","type":"function"},{"doc":"Clears the screen.","ref":"Raxol.Terminal.ScreenUpdater.html#clear_screen/1","title":"Raxol.Terminal.ScreenUpdater.clear_screen/1","type":"function"},{"doc":"* `emulator` - The current terminal emulator state","ref":"Raxol.Terminal.ScreenUpdater.html#clear_screen/1-parameters","title":"Parameters - Raxol.Terminal.ScreenUpdater.clear_screen/1","type":"function"},{"doc":"* `updated_emulator` - The updated emulator state","ref":"Raxol.Terminal.ScreenUpdater.html#clear_screen/1-returns","title":"Returns - Raxol.Terminal.ScreenUpdater.clear_screen/1","type":"function"},{"doc":"Gets the current screen dimensions.","ref":"Raxol.Terminal.ScreenUpdater.html#get_dimensions/1","title":"Raxol.Terminal.ScreenUpdater.get_dimensions/1","type":"function"},{"doc":"* `emulator` - The current terminal emulator state","ref":"Raxol.Terminal.ScreenUpdater.html#get_dimensions/1-parameters","title":"Parameters - Raxol.Terminal.ScreenUpdater.get_dimensions/1","type":"function"},{"doc":"* `{width, height}` - The current screen dimensions","ref":"Raxol.Terminal.ScreenUpdater.html#get_dimensions/1-returns","title":"Returns - Raxol.Terminal.ScreenUpdater.get_dimensions/1","type":"function"},{"doc":"Handles screen resize.","ref":"Raxol.Terminal.ScreenUpdater.html#handle_resize/3","title":"Raxol.Terminal.ScreenUpdater.handle_resize/3","type":"function"},{"doc":"* `emulator` - The current terminal emulator state\n  * `width` - The new width\n  * `height` - The new height","ref":"Raxol.Terminal.ScreenUpdater.html#handle_resize/3-parameters","title":"Parameters - Raxol.Terminal.ScreenUpdater.handle_resize/3","type":"function"},{"doc":"* `updated_emulator` - The updated emulator state","ref":"Raxol.Terminal.ScreenUpdater.html#handle_resize/3-returns","title":"Returns - Raxol.Terminal.ScreenUpdater.handle_resize/3","type":"function"},{"doc":"Updates the screen with a single update.","ref":"Raxol.Terminal.ScreenUpdater.html#update_screen/2","title":"Raxol.Terminal.ScreenUpdater.update_screen/2","type":"function"},{"doc":"* `emulator` - The current terminal emulator state\n  * `update` - The screen update to apply","ref":"Raxol.Terminal.ScreenUpdater.html#update_screen/2-parameters","title":"Parameters - Raxol.Terminal.ScreenUpdater.update_screen/2","type":"function"},{"doc":"* `{updated_emulator, output}` - The updated emulator state and any output","ref":"Raxol.Terminal.ScreenUpdater.html#update_screen/2-returns","title":"Returns - Raxol.Terminal.ScreenUpdater.update_screen/2","type":"function"},{"doc":"Unified scripting system for the Raxol terminal emulator.\nHandles script execution, management, and integration with the terminal.","ref":"Raxol.Terminal.Script.UnifiedScript.html","title":"Raxol.Terminal.Script.UnifiedScript","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Script.UnifiedScript.html#child_spec/1","title":"Raxol.Terminal.Script.UnifiedScript.child_spec/1","type":"function"},{"doc":"Executes a script with optional arguments.","ref":"Raxol.Terminal.Script.UnifiedScript.html#execute_script/2","title":"Raxol.Terminal.Script.UnifiedScript.execute_script/2","type":"function"},{"doc":"Exports a script to a file.","ref":"Raxol.Terminal.Script.UnifiedScript.html#export_script/2","title":"Raxol.Terminal.Script.UnifiedScript.export_script/2","type":"function"},{"doc":"Gets the output of a script.","ref":"Raxol.Terminal.Script.UnifiedScript.html#get_script_output/1","title":"Raxol.Terminal.Script.UnifiedScript.get_script_output/1","type":"function"},{"doc":"Gets the state of a script.","ref":"Raxol.Terminal.Script.UnifiedScript.html#get_script_state/1","title":"Raxol.Terminal.Script.UnifiedScript.get_script_state/1","type":"function"},{"doc":"Gets all loaded scripts.","ref":"Raxol.Terminal.Script.UnifiedScript.html#get_scripts/1","title":"Raxol.Terminal.Script.UnifiedScript.get_scripts/1","type":"function"},{"doc":"Imports a script from a file.","ref":"Raxol.Terminal.Script.UnifiedScript.html#import_script/2","title":"Raxol.Terminal.Script.UnifiedScript.import_script/2","type":"function"},{"doc":"Loads a script from a file or string source.","ref":"Raxol.Terminal.Script.UnifiedScript.html#load_script/3","title":"Raxol.Terminal.Script.UnifiedScript.load_script/3","type":"function"},{"doc":"Pauses a running script.","ref":"Raxol.Terminal.Script.UnifiedScript.html#pause_script/1","title":"Raxol.Terminal.Script.UnifiedScript.pause_script/1","type":"function"},{"doc":"Resumes a paused script.","ref":"Raxol.Terminal.Script.UnifiedScript.html#resume_script/1","title":"Raxol.Terminal.Script.UnifiedScript.resume_script/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Script.UnifiedScript.html#t:script_id/0","title":"Raxol.Terminal.Script.UnifiedScript.script_id/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Script.UnifiedScript.html#t:script_state/0","title":"Raxol.Terminal.Script.UnifiedScript.script_state/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Script.UnifiedScript.html#t:script_type/0","title":"Raxol.Terminal.Script.UnifiedScript.script_type/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Script.UnifiedScript.html#start_link/1","title":"Raxol.Terminal.Script.UnifiedScript.start_link/1","type":"function"},{"doc":"Stops a running script.","ref":"Raxol.Terminal.Script.UnifiedScript.html#stop_script/1","title":"Raxol.Terminal.Script.UnifiedScript.stop_script/1","type":"function"},{"doc":"Unloads a script by its ID.","ref":"Raxol.Terminal.Script.UnifiedScript.html#unload_script/1","title":"Raxol.Terminal.Script.UnifiedScript.unload_script/1","type":"function"},{"doc":"Updates a script's configuration.","ref":"Raxol.Terminal.Script.UnifiedScript.html#update_script_config/2","title":"Raxol.Terminal.Script.UnifiedScript.update_script_config/2","type":"function"},{"doc":"Manages terminal scrolling operations with advanced features.\n\nFeatures:\n- Predictive scrolling for smooth performance\n- Scroll caching for efficient memory usage\n- Scroll optimization for better performance\n- Scroll synchronization across splits","ref":"Raxol.Terminal.Scroll.Manager.html","title":"Raxol.Terminal.Scroll.Manager","type":"module"},{"doc":"Gets the scroll history.","ref":"Raxol.Terminal.Scroll.Manager.html#get_history/2","title":"Raxol.Terminal.Scroll.Manager.get_history/2","type":"function"},{"doc":"* `manager` - The scroll manager\n  * `opts` - History options\n    * `:limit` - Maximum number of entries to return (default: all)","ref":"Raxol.Terminal.Scroll.Manager.html#get_history/2-parameters","title":"Parameters - Raxol.Terminal.Scroll.Manager.get_history/2","type":"function"},{"doc":"Gets the current scroll metrics.","ref":"Raxol.Terminal.Scroll.Manager.html#get_metrics/1","title":"Raxol.Terminal.Scroll.Manager.get_metrics/1","type":"function"},{"doc":"Creates a new scroll manager.","ref":"Raxol.Terminal.Scroll.Manager.html#new/1","title":"Raxol.Terminal.Scroll.Manager.new/1","type":"function"},{"doc":"* `:prediction_enabled` - Whether to enable predictive scrolling (default: true)\n  * `:optimization_enabled` - Whether to enable scroll optimization (default: true)\n  * `:sync_enabled` - Whether to enable scroll synchronization (default: true)","ref":"Raxol.Terminal.Scroll.Manager.html#new/1-options","title":"Options - Raxol.Terminal.Scroll.Manager.new/1","type":"function"},{"doc":"Optimizes the scroll manager based on current metrics.","ref":"Raxol.Terminal.Scroll.Manager.html#optimize/1","title":"Raxol.Terminal.Scroll.Manager.optimize/1","type":"function"},{"doc":"Scrolls the terminal content.","ref":"Raxol.Terminal.Scroll.Manager.html#scroll/4","title":"Raxol.Terminal.Scroll.Manager.scroll/4","type":"function"},{"doc":"* `manager` - The scroll manager\n  * `direction` - Scroll direction (:up or :down)\n  * `lines` - Number of lines to scroll\n  * `opts` - Scroll options\n    * `:predict` - Whether to use prediction (default: true)\n    * `:optimize` - Whether to optimize the scroll (default: true)\n    * `:sync` - Whether to sync across splits (default: true)","ref":"Raxol.Terminal.Scroll.Manager.html#scroll/4-parameters","title":"Parameters - Raxol.Terminal.Scroll.Manager.scroll/4","type":"function"},{"doc":"","ref":"Raxol.Terminal.Scroll.Manager.html#t:t/0","title":"Raxol.Terminal.Scroll.Manager.t/0","type":"type"},{"doc":"Handles scroll optimization for better performance.","ref":"Raxol.Terminal.Scroll.Optimizer.html","title":"Raxol.Terminal.Scroll.Optimizer","type":"module"},{"doc":"Creates a new optimizer instance.","ref":"Raxol.Terminal.Scroll.Optimizer.html#new/0","title":"Raxol.Terminal.Scroll.Optimizer.new/0","type":"function"},{"doc":"Optimizes scroll operations for better performance.","ref":"Raxol.Terminal.Scroll.Optimizer.html#optimize/3","title":"Raxol.Terminal.Scroll.Optimizer.optimize/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Scroll.Optimizer.html#t:t/0","title":"Raxol.Terminal.Scroll.Optimizer.t/0","type":"type"},{"doc":"Handles predictive scrolling operations for the terminal.","ref":"Raxol.Terminal.Scroll.Predictor.html","title":"Raxol.Terminal.Scroll.Predictor","type":"module"},{"doc":"Creates a new predictor instance.","ref":"Raxol.Terminal.Scroll.Predictor.html#new/0","title":"Raxol.Terminal.Scroll.Predictor.new/0","type":"function"},{"doc":"Predicts the next scroll operation based on history.","ref":"Raxol.Terminal.Scroll.Predictor.html#predict/3","title":"Raxol.Terminal.Scroll.Predictor.predict/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Scroll.Predictor.html#t:t/0","title":"Raxol.Terminal.Scroll.Predictor.t/0","type":"type"},{"doc":"Handles scroll synchronization across terminal splits.","ref":"Raxol.Terminal.Scroll.Sync.html","title":"Raxol.Terminal.Scroll.Sync","type":"module"},{"doc":"Creates a new sync instance.","ref":"Raxol.Terminal.Scroll.Sync.html#new/0","title":"Raxol.Terminal.Scroll.Sync.new/0","type":"function"},{"doc":"Synchronizes scroll operations across splits.","ref":"Raxol.Terminal.Scroll.Sync.html#sync/3","title":"Raxol.Terminal.Scroll.Sync.sync/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Scroll.Sync.html#t:t/0","title":"Raxol.Terminal.Scroll.Sync.t/0","type":"type"},{"doc":"Unified scroll management system for the terminal.\n\nThis module consolidates all scroll-related functionality including:\n- Scroll buffer management\n- Scroll operations (up/down)\n- Scroll region handling\n- Memory management\n- Performance optimization","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html","title":"Raxol.Terminal.Scroll.UnifiedScroll","type":"module"},{"doc":"Adds a line to the scroll buffer.","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#add_line/2","title":"Raxol.Terminal.Scroll.UnifiedScroll.add_line/2","type":"function"},{"doc":"Cleans up the scroll buffer.","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#cleanup/1","title":"Raxol.Terminal.Scroll.UnifiedScroll.cleanup/1","type":"function"},{"doc":"Clears the scroll buffer.","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#clear/1","title":"Raxol.Terminal.Scroll.UnifiedScroll.clear/1","type":"function"},{"doc":"Clears the scroll region.","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#clear_scroll_region/1","title":"Raxol.Terminal.Scroll.UnifiedScroll.clear_scroll_region/1","type":"function"},{"doc":"Gets the total height of the scroll buffer.","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#get_height/1","title":"Raxol.Terminal.Scroll.UnifiedScroll.get_height/1","type":"function"},{"doc":"Gets the current scroll position.","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#get_position/1","title":"Raxol.Terminal.Scroll.UnifiedScroll.get_position/1","type":"function"},{"doc":"Gets a view of the scroll buffer at the current position.","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#get_view/2","title":"Raxol.Terminal.Scroll.UnifiedScroll.get_view/2","type":"function"},{"doc":"Gets the visible region of the scroll buffer.","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#get_visible_region/1","title":"Raxol.Terminal.Scroll.UnifiedScroll.get_visible_region/1","type":"function"},{"doc":"Creates a new scroll buffer with the given dimensions and configuration.","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#new/2","title":"Raxol.Terminal.Scroll.UnifiedScroll.new/2","type":"function"},{"doc":"Resizes the scroll buffer to the new height.","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#resize/2","title":"Raxol.Terminal.Scroll.UnifiedScroll.resize/2","type":"function"},{"doc":"Scrolls the buffer by the given amount.","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#scroll/2","title":"Raxol.Terminal.Scroll.UnifiedScroll.scroll/2","type":"function"},{"doc":"Scrolls the buffer in the specified direction by the given amount.","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#scroll/3","title":"Raxol.Terminal.Scroll.UnifiedScroll.scroll/3","type":"function"},{"doc":"Updates the maximum height of the scroll buffer.","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#set_max_height/2","title":"Raxol.Terminal.Scroll.UnifiedScroll.set_max_height/2","type":"function"},{"doc":"Sets the scroll region.","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#set_scroll_region/3","title":"Raxol.Terminal.Scroll.UnifiedScroll.set_scroll_region/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#t:t/0","title":"Raxol.Terminal.Scroll.UnifiedScroll.t/0","type":"type"},{"doc":"Updates the scroll buffer with new commands.","ref":"Raxol.Terminal.Scroll.UnifiedScroll.html#update/2","title":"Raxol.Terminal.Scroll.UnifiedScroll.update/2","type":"function"},{"doc":"Manages terminal scrollback buffer operations.","ref":"Raxol.Terminal.Scrollback.Manager.html","title":"Raxol.Terminal.Scrollback.Manager","type":"module"},{"doc":"Adds a line to the scrollback buffer.","ref":"Raxol.Terminal.Scrollback.Manager.html#add_to_scrollback/2","title":"Raxol.Terminal.Scrollback.Manager.add_to_scrollback/2","type":"function"},{"doc":"Clears the scrollback buffer.","ref":"Raxol.Terminal.Scrollback.Manager.html#clear_scrollback/1","title":"Raxol.Terminal.Scrollback.Manager.clear_scrollback/1","type":"function"},{"doc":"Gets the current line from the scrollback buffer.","ref":"Raxol.Terminal.Scrollback.Manager.html#get_current_line/1","title":"Raxol.Terminal.Scrollback.Manager.get_current_line/1","type":"function"},{"doc":"Gets the current scrollback position.","ref":"Raxol.Terminal.Scrollback.Manager.html#get_current_position/1","title":"Raxol.Terminal.Scrollback.Manager.get_current_position/1","type":"function"},{"doc":"Gets the current scrollback buffer.","ref":"Raxol.Terminal.Scrollback.Manager.html#get_scrollback_buffer/1","title":"Raxol.Terminal.Scrollback.Manager.get_scrollback_buffer/1","type":"function"},{"doc":"Gets the scrollback limit.","ref":"Raxol.Terminal.Scrollback.Manager.html#get_scrollback_limit/1","title":"Raxol.Terminal.Scrollback.Manager.get_scrollback_limit/1","type":"function"},{"doc":"Gets a range of lines from the scrollback buffer.","ref":"Raxol.Terminal.Scrollback.Manager.html#get_scrollback_range/3","title":"Raxol.Terminal.Scrollback.Manager.get_scrollback_range/3","type":"function"},{"doc":"Gets the current size of the scrollback buffer.","ref":"Raxol.Terminal.Scrollback.Manager.html#get_scrollback_size/1","title":"Raxol.Terminal.Scrollback.Manager.get_scrollback_size/1","type":"function"},{"doc":"Creates a new scrollback manager instance.","ref":"Raxol.Terminal.Scrollback.Manager.html#new/1","title":"Raxol.Terminal.Scrollback.Manager.new/1","type":"function"},{"doc":"Scrolls down in the scrollback buffer.","ref":"Raxol.Terminal.Scrollback.Manager.html#scroll_down/2","title":"Raxol.Terminal.Scrollback.Manager.scroll_down/2","type":"function"},{"doc":"Scrolls up in the scrollback buffer.","ref":"Raxol.Terminal.Scrollback.Manager.html#scroll_up/2","title":"Raxol.Terminal.Scrollback.Manager.scroll_up/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Scrollback.Manager.html#t:scrollback_buffer/0","title":"Raxol.Terminal.Scrollback.Manager.scrollback_buffer/0","type":"type"},{"doc":"Checks if the scrollback buffer is empty.","ref":"Raxol.Terminal.Scrollback.Manager.html#scrollback_empty?/1","title":"Raxol.Terminal.Scrollback.Manager.scrollback_empty?/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Scrollback.Manager.html#t:scrollback_line/0","title":"Raxol.Terminal.Scrollback.Manager.scrollback_line/0","type":"type"},{"doc":"Sets the current scrollback position.","ref":"Raxol.Terminal.Scrollback.Manager.html#set_current_position/2","title":"Raxol.Terminal.Scrollback.Manager.set_current_position/2","type":"function"},{"doc":"Sets the scrollback limit.","ref":"Raxol.Terminal.Scrollback.Manager.html#set_scrollback_limit/2","title":"Raxol.Terminal.Scrollback.Manager.set_scrollback_limit/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Scrollback.Manager.html#t:t/0","title":"Raxol.Terminal.Scrollback.Manager.t/0","type":"type"},{"doc":"Manages text selection operations in the terminal.","ref":"Raxol.Terminal.Selection.Manager.html","title":"Raxol.Terminal.Selection.Manager","type":"module"},{"doc":"Ends the current selection.","ref":"Raxol.Terminal.Selection.Manager.html#end_selection/1","title":"Raxol.Terminal.Selection.Manager.end_selection/1","type":"function"},{"doc":"Gets the selected text from the terminal buffer.","ref":"Raxol.Terminal.Selection.Manager.html#get_selected_text/2","title":"Raxol.Terminal.Selection.Manager.get_selected_text/2","type":"function"},{"doc":"Gets the current selection range.","ref":"Raxol.Terminal.Selection.Manager.html#get_selection_range/1","title":"Raxol.Terminal.Selection.Manager.get_selection_range/1","type":"function"},{"doc":"Includes scrollback buffer in selection.","ref":"Raxol.Terminal.Selection.Manager.html#include_scrollback/2","title":"Raxol.Terminal.Selection.Manager.include_scrollback/2","type":"function"},{"doc":"Creates a new selection manager instance.","ref":"Raxol.Terminal.Selection.Manager.html#new/0","title":"Raxol.Terminal.Selection.Manager.new/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Selection.Manager.html#t:position/0","title":"Raxol.Terminal.Selection.Manager.position/0","type":"type"},{"doc":"Checks if a position is within the current selection.","ref":"Raxol.Terminal.Selection.Manager.html#position_in_selection?/2","title":"Raxol.Terminal.Selection.Manager.position_in_selection?/2","type":"function"},{"doc":"Checks if scrollback is included in selection.","ref":"Raxol.Terminal.Selection.Manager.html#scrollback_included?/1","title":"Raxol.Terminal.Selection.Manager.scrollback_included?/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Selection.Manager.html#t:selection_mode/0","title":"Raxol.Terminal.Selection.Manager.selection_mode/0","type":"type"},{"doc":"Starts a new selection at the given position.","ref":"Raxol.Terminal.Selection.Manager.html#start_selection/3","title":"Raxol.Terminal.Selection.Manager.start_selection/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Selection.Manager.html#t:t/0","title":"Raxol.Terminal.Selection.Manager.t/0","type":"type"},{"doc":"Updates the selection end position.","ref":"Raxol.Terminal.Selection.Manager.html#update_selection/2","title":"Raxol.Terminal.Selection.Manager.update_selection/2","type":"function"},{"doc":"Terminal session module.\n\nThis module manages terminal sessions, including:\n- Session lifecycle\n- Input/output handling\n- State management\n- Configuration\n- Session persistence and recovery","ref":"Raxol.Terminal.Session.html","title":"Raxol.Terminal.Session","type":"module"},{"doc":"","ref":"Raxol.Terminal.Session.html#count_active_sessions/0","title":"Raxol.Terminal.Session.count_active_sessions/0","type":"function"},{"doc":"Gets the current state of a terminal session.","ref":"Raxol.Terminal.Session.html#get_state/1","title":"Raxol.Terminal.Session.get_state/1","type":"function"},{"doc":"iex> {:ok, pid} = Session.start_link()\n    iex> state = Session.get_state(pid)\n    iex> state.width\n    80","ref":"Raxol.Terminal.Session.html#get_state/1-examples","title":"Examples - Raxol.Terminal.Session.get_state/1","type":"function"},{"doc":"Lists all saved sessions.","ref":"Raxol.Terminal.Session.html#list_saved_sessions/0","title":"Raxol.Terminal.Session.list_saved_sessions/0","type":"function"},{"doc":"Loads a session from persistent storage.","ref":"Raxol.Terminal.Session.html#load_session/1","title":"Raxol.Terminal.Session.load_session/1","type":"function"},{"doc":"Saves the current session state to persistent storage.","ref":"Raxol.Terminal.Session.html#save_session/1","title":"Raxol.Terminal.Session.save_session/1","type":"function"},{"doc":"Sends input to a terminal session.","ref":"Raxol.Terminal.Session.html#send_input/2","title":"Raxol.Terminal.Session.send_input/2","type":"function"},{"doc":"iex> {:ok, pid} = Session.start_link()\n    iex> :ok = Session.send_input(pid, \"test\")\n    iex> state = Session.get_state(pid)\n    iex> state.input.buffer\n    \"test\"","ref":"Raxol.Terminal.Session.html#send_input/2-examples","title":"Examples - Raxol.Terminal.Session.send_input/2","type":"function"},{"doc":"Sets whether the session should be automatically saved.","ref":"Raxol.Terminal.Session.html#set_auto_save/2","title":"Raxol.Terminal.Session.set_auto_save/2","type":"function"},{"doc":"Starts a new terminal session.","ref":"Raxol.Terminal.Session.html#start_link/1","title":"Raxol.Terminal.Session.start_link/1","type":"function"},{"doc":"iex> {:ok, pid} = Session.start_link(%{width: 80, height: 24})\n    iex> Process.alive?(pid)\n    true","ref":"Raxol.Terminal.Session.html#start_link/1-examples","title":"Examples - Raxol.Terminal.Session.start_link/1","type":"function"},{"doc":"Stops a terminal session.","ref":"Raxol.Terminal.Session.html#stop/1","title":"Raxol.Terminal.Session.stop/1","type":"function"},{"doc":"iex> {:ok, pid} = Session.start_link()\n    iex> :ok = Session.stop(pid)\n    iex> Process.alive?(pid)\n    false","ref":"Raxol.Terminal.Session.html#stop/1-examples","title":"Examples - Raxol.Terminal.Session.stop/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Session.html#t:t/0","title":"Raxol.Terminal.Session.t/0","type":"type"},{"doc":"Updates the configuration of a terminal session.","ref":"Raxol.Terminal.Session.html#update_config/2","title":"Raxol.Terminal.Session.update_config/2","type":"function"},{"doc":"iex> {:ok, pid} = Session.start_link()\n    iex> :ok = Session.update_config(pid, %{width: 100, height: 30})\n    iex> state = Session.get_state(pid)\n    iex> state.width\n    100","ref":"Raxol.Terminal.Session.html#update_config/2-examples","title":"Examples - Raxol.Terminal.Session.update_config/2","type":"function"},{"doc":"Handles serialization and deserialization of terminal session state.","ref":"Raxol.Terminal.Session.Serializer.html","title":"Raxol.Terminal.Session.Serializer","type":"module"},{"doc":"Deserializes a session state from a map.","ref":"Raxol.Terminal.Session.Serializer.html#deserialize/1","title":"Raxol.Terminal.Session.Serializer.deserialize/1","type":"function"},{"doc":"Serializes a session state to a map that can be stored and later restored.","ref":"Raxol.Terminal.Session.Serializer.html#serialize/1","title":"Raxol.Terminal.Session.Serializer.serialize/1","type":"function"},{"doc":"Handles persistence of terminal sessions.","ref":"Raxol.Terminal.Session.Storage.html","title":"Raxol.Terminal.Session.Storage","type":"module"},{"doc":"Deletes a saved session.","ref":"Raxol.Terminal.Session.Storage.html#delete_session/1","title":"Raxol.Terminal.Session.Storage.delete_session/1","type":"function"},{"doc":"Lists all saved sessions.","ref":"Raxol.Terminal.Session.Storage.html#list_sessions/0","title":"Raxol.Terminal.Session.Storage.list_sessions/0","type":"function"},{"doc":"Loads a session state from persistent storage.","ref":"Raxol.Terminal.Session.Storage.html#load_session/1","title":"Raxol.Terminal.Session.Storage.load_session/1","type":"function"},{"doc":"Saves a session state to persistent storage.","ref":"Raxol.Terminal.Session.Storage.html#save_session/1","title":"Raxol.Terminal.Session.Storage.save_session/1","type":"function"},{"doc":"Session management module for handling terminal sessions.\n\nThis module provides functionality for:\n- Session creation and management\n- Session authentication\n- Session state tracking\n- Session cleanup","ref":"Raxol.Terminal.SessionManager.html","title":"Raxol.Terminal.SessionManager","type":"module"},{"doc":"","ref":"Raxol.Terminal.SessionManager.html#authenticate_session/2","title":"Raxol.Terminal.SessionManager.authenticate_session/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.SessionManager.html#child_spec/1","title":"Raxol.Terminal.SessionManager.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.SessionManager.html#cleanup_session/1","title":"Raxol.Terminal.SessionManager.cleanup_session/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.SessionManager.html#count_sessions/1","title":"Raxol.Terminal.SessionManager.count_sessions/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.SessionManager.html#create_session/1","title":"Raxol.Terminal.SessionManager.create_session/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.SessionManager.html#create_session/2","title":"Raxol.Terminal.SessionManager.create_session/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.SessionManager.html#destroy_session/3","title":"Raxol.Terminal.SessionManager.destroy_session/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.SessionManager.html#get_session/1","title":"Raxol.Terminal.SessionManager.get_session/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.SessionManager.html#get_session/3","title":"Raxol.Terminal.SessionManager.get_session/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.SessionManager.html#handle_session_down/2","title":"Raxol.Terminal.SessionManager.handle_session_down/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.SessionManager.html#list_sessions/1","title":"Raxol.Terminal.SessionManager.list_sessions/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.SessionManager.html#monitor_session/2","title":"Raxol.Terminal.SessionManager.monitor_session/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.SessionManager.html#start_link/1","title":"Raxol.Terminal.SessionManager.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.SessionManager.html#unmonitor_session/2","title":"Raxol.Terminal.SessionManager.unmonitor_session/2","type":"function"},{"doc":"Manages terminal split windows, handling creation, resizing, navigation, and synchronization\nof split terminal windows.","ref":"Raxol.Terminal.Split.Manager.html","title":"Raxol.Terminal.Split.Manager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Split.Manager.html#child_spec/1","title":"Raxol.Terminal.Split.Manager.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Split.Manager.html#create_split/1","title":"Raxol.Terminal.Split.Manager.create_split/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Split.Manager.html#list_splits/0","title":"Raxol.Terminal.Split.Manager.list_splits/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.Split.Manager.html#navigate_to_split/1","title":"Raxol.Terminal.Split.Manager.navigate_to_split/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Split.Manager.html#resize_split/2","title":"Raxol.Terminal.Split.Manager.resize_split/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Split.Manager.html#start_link/1","title":"Raxol.Terminal.Split.Manager.start_link/1","type":"function"},{"doc":"Supervisor for the terminal split management system.","ref":"Raxol.Terminal.Split.Supervisor.html","title":"Raxol.Terminal.Split.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Split.Supervisor.html#child_spec/1","title":"Raxol.Terminal.Split.Supervisor.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Split.Supervisor.html#start_link/1","title":"Raxol.Terminal.Split.Supervisor.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Split.Supervisor.html#start_split_manager/1","title":"Raxol.Terminal.Split.Supervisor.start_split_manager/1","type":"function"},{"doc":"Handles synchronization between terminal splits, including event broadcasting,\nstate sharing, and communication protocols.","ref":"Raxol.Terminal.Split.Sync.html","title":"Raxol.Terminal.Split.Sync","type":"module"},{"doc":"","ref":"Raxol.Terminal.Split.Sync.html#broadcast_event/3","title":"Raxol.Terminal.Split.Sync.broadcast_event/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Split.Sync.html#child_spec/1","title":"Raxol.Terminal.Split.Sync.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Split.Sync.html#get_shared_state/1","title":"Raxol.Terminal.Split.Sync.get_shared_state/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Split.Sync.html#start_link/1","title":"Raxol.Terminal.Split.Sync.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Split.Sync.html#subscribe_to_events/2","title":"Raxol.Terminal.Split.Sync.subscribe_to_events/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Split.Sync.html#unsubscribe_from_events/1","title":"Raxol.Terminal.Split.Sync.unsubscribe_from_events/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Split.Sync.html#update_shared_state/2","title":"Raxol.Terminal.Split.Sync.update_shared_state/2","type":"function"},{"doc":"Provides state management for the terminal emulator.\nThis module handles operations like creating new states, saving and restoring states,\nand managing state transitions.","ref":"Raxol.Terminal.State.html","title":"Raxol.Terminal.State","type":"module"},{"doc":"Gets the current cursor position.","ref":"Raxol.Terminal.State.html#get_cursor_position/1","title":"Raxol.Terminal.State.get_cursor_position/1","type":"function"},{"doc":"Gets the current screen buffer.","ref":"Raxol.Terminal.State.html#get_screen_buffer/1","title":"Raxol.Terminal.State.get_screen_buffer/1","type":"function"},{"doc":"Creates a new terminal state with the specified dimensions and limits.","ref":"Raxol.Terminal.State.html#new/4","title":"Raxol.Terminal.State.new/4","type":"function"},{"doc":"Restores the most recently saved state.","ref":"Raxol.Terminal.State.html#restore_state/1","title":"Raxol.Terminal.State.restore_state/1","type":"function"},{"doc":"Saves the current state.","ref":"Raxol.Terminal.State.html#save_state/1","title":"Raxol.Terminal.State.save_state/1","type":"function"},{"doc":"Sets the cursor position.","ref":"Raxol.Terminal.State.html#set_cursor_position/3","title":"Raxol.Terminal.State.set_cursor_position/3","type":"function"},{"doc":"Sets the screen buffer.","ref":"Raxol.Terminal.State.html#set_screen_buffer/2","title":"Raxol.Terminal.State.set_screen_buffer/2","type":"function"},{"doc":"Manages the overall state of the terminal, including mode settings,\ncursor state, and terminal dimensions.","ref":"Raxol.Terminal.State.Manager.html","title":"Raxol.Terminal.State.Manager","type":"module"},{"doc":"","ref":"Raxol.Terminal.State.Manager.html#t:bell_style/0","title":"Raxol.Terminal.State.Manager.bell_style/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.State.Manager.html#t:bell_urgent_style/0","title":"Raxol.Terminal.State.Manager.bell_urgent_style/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.State.Manager.html#t:cursor_style/0","title":"Raxol.Terminal.State.Manager.cursor_style/0","type":"type"},{"doc":"Gets the current cursor position.","ref":"Raxol.Terminal.State.Manager.html#get_cursor_position/1","title":"Raxol.Terminal.State.Manager.get_cursor_position/1","type":"function"},{"doc":"Gets the cursor style.","ref":"Raxol.Terminal.State.Manager.html#get_cursor_style/1","title":"Raxol.Terminal.State.Manager.get_cursor_style/1","type":"function"},{"doc":"Gets the cursor visibility state.","ref":"Raxol.Terminal.State.Manager.html#get_cursor_visibility/1","title":"Raxol.Terminal.State.Manager.get_cursor_visibility/1","type":"function"},{"doc":"Gets the current terminal dimensions.","ref":"Raxol.Terminal.State.Manager.html#get_dimensions/1","title":"Raxol.Terminal.State.Manager.get_dimensions/1","type":"function"},{"doc":"Gets the terminal icon name.","ref":"Raxol.Terminal.State.Manager.html#get_icon_name/1","title":"Raxol.Terminal.State.Manager.get_icon_name/1","type":"function"},{"doc":"Gets the value of a terminal mode.","ref":"Raxol.Terminal.State.Manager.html#get_mode/2","title":"Raxol.Terminal.State.Manager.get_mode/2","type":"function"},{"doc":"Gets the terminal title.","ref":"Raxol.Terminal.State.Manager.html#get_title/1","title":"Raxol.Terminal.State.Manager.get_title/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.State.Manager.html#t:mode/0","title":"Raxol.Terminal.State.Manager.mode/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.State.Manager.html#t:mode_value/0","title":"Raxol.Terminal.State.Manager.mode_value/0","type":"type"},{"doc":"Creates a new terminal state manager instance.","ref":"Raxol.Terminal.State.Manager.html#new/1","title":"Raxol.Terminal.State.Manager.new/1","type":"function"},{"doc":"Resets the terminal state to default values.","ref":"Raxol.Terminal.State.Manager.html#reset/1","title":"Raxol.Terminal.State.Manager.reset/1","type":"function"},{"doc":"Restores the saved cursor state.","ref":"Raxol.Terminal.State.Manager.html#restore_cursor/1","title":"Raxol.Terminal.State.Manager.restore_cursor/1","type":"function"},{"doc":"Saves the current cursor state.","ref":"Raxol.Terminal.State.Manager.html#save_cursor/1","title":"Raxol.Terminal.State.Manager.save_cursor/1","type":"function"},{"doc":"Sets the cursor position.","ref":"Raxol.Terminal.State.Manager.html#set_cursor_position/3","title":"Raxol.Terminal.State.Manager.set_cursor_position/3","type":"function"},{"doc":"Sets the cursor style.","ref":"Raxol.Terminal.State.Manager.html#set_cursor_style/2","title":"Raxol.Terminal.State.Manager.set_cursor_style/2","type":"function"},{"doc":"Sets the cursor visibility.","ref":"Raxol.Terminal.State.Manager.html#set_cursor_visibility/2","title":"Raxol.Terminal.State.Manager.set_cursor_visibility/2","type":"function"},{"doc":"Sets the terminal dimensions.","ref":"Raxol.Terminal.State.Manager.html#set_dimensions/3","title":"Raxol.Terminal.State.Manager.set_dimensions/3","type":"function"},{"doc":"Sets the terminal icon name.","ref":"Raxol.Terminal.State.Manager.html#set_icon_name/2","title":"Raxol.Terminal.State.Manager.set_icon_name/2","type":"function"},{"doc":"Sets a terminal mode value.","ref":"Raxol.Terminal.State.Manager.html#set_mode/3","title":"Raxol.Terminal.State.Manager.set_mode/3","type":"function"},{"doc":"Sets the terminal title.","ref":"Raxol.Terminal.State.Manager.html#set_title/2","title":"Raxol.Terminal.State.Manager.set_title/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.State.Manager.html#t:t/0","title":"Raxol.Terminal.State.Manager.t/0","type":"type"},{"doc":"Triggers the terminal bell.","ref":"Raxol.Terminal.State.Manager.html#trigger_bell/1","title":"Raxol.Terminal.State.Manager.trigger_bell/1","type":"function"},{"doc":"Manages text styling and formatting for the terminal emulator.\nThis module provides a clean interface for managing text styles, colors, and attributes.","ref":"Raxol.Terminal.Style.Manager.html","title":"Raxol.Terminal.Style.Manager","type":"module"},{"doc":"Converts an ANSI color code to a color name.","ref":"Raxol.Terminal.Style.Manager.html#ansi_code_to_color_name/1","title":"Raxol.Terminal.Style.Manager.ansi_code_to_color_name/1","type":"function"},{"doc":"Applies a text attribute to the style.","ref":"Raxol.Terminal.Style.Manager.html#apply_style/2","title":"Raxol.Terminal.Style.Manager.apply_style/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Style.Manager.html#t:color/0","title":"Raxol.Terminal.Style.Manager.color/0","type":"type"},{"doc":"Calculates the effective width of a character based on the current style.","ref":"Raxol.Terminal.Style.Manager.html#effective_width/2","title":"Raxol.Terminal.Style.Manager.effective_width/2","type":"function"},{"doc":"Formats SGR parameters for DECRQSS responses.","ref":"Raxol.Terminal.Style.Manager.html#format_sgr_params/1","title":"Raxol.Terminal.Style.Manager.format_sgr_params/1","type":"function"},{"doc":"Gets the background color.","ref":"Raxol.Terminal.Style.Manager.html#get_background/1","title":"Raxol.Terminal.Style.Manager.get_background/1","type":"function"},{"doc":"Gets the current style.","ref":"Raxol.Terminal.Style.Manager.html#get_current_style/1","title":"Raxol.Terminal.Style.Manager.get_current_style/1","type":"function"},{"doc":"Gets the foreground color.","ref":"Raxol.Terminal.Style.Manager.html#get_foreground/1","title":"Raxol.Terminal.Style.Manager.get_foreground/1","type":"function"},{"doc":"Gets the hyperlink URI.","ref":"Raxol.Terminal.Style.Manager.html#get_hyperlink/1","title":"Raxol.Terminal.Style.Manager.get_hyperlink/1","type":"function"},{"doc":"Creates a new text style with default values.","ref":"Raxol.Terminal.Style.Manager.html#new/0","title":"Raxol.Terminal.Style.Manager.new/0","type":"function"},{"doc":"Resets to single-width, single-height mode.","ref":"Raxol.Terminal.Style.Manager.html#reset_size/1","title":"Raxol.Terminal.Style.Manager.reset_size/1","type":"function"},{"doc":"Resets all text formatting attributes to their default values.","ref":"Raxol.Terminal.Style.Manager.html#reset_style/1","title":"Raxol.Terminal.Style.Manager.reset_style/1","type":"function"},{"doc":"Sets the background color.","ref":"Raxol.Terminal.Style.Manager.html#set_background/2","title":"Raxol.Terminal.Style.Manager.set_background/2","type":"function"},{"doc":"Sets double-height bottom half mode for the current line.","ref":"Raxol.Terminal.Style.Manager.html#set_double_height_bottom/1","title":"Raxol.Terminal.Style.Manager.set_double_height_bottom/1","type":"function"},{"doc":"Sets double-height top half mode for the current line.","ref":"Raxol.Terminal.Style.Manager.html#set_double_height_top/1","title":"Raxol.Terminal.Style.Manager.set_double_height_top/1","type":"function"},{"doc":"Sets double-width mode for the current line.","ref":"Raxol.Terminal.Style.Manager.html#set_double_width/1","title":"Raxol.Terminal.Style.Manager.set_double_width/1","type":"function"},{"doc":"Sets the foreground color.","ref":"Raxol.Terminal.Style.Manager.html#set_foreground/2","title":"Raxol.Terminal.Style.Manager.set_foreground/2","type":"function"},{"doc":"Sets a hyperlink URI.","ref":"Raxol.Terminal.Style.Manager.html#set_hyperlink/2","title":"Raxol.Terminal.Style.Manager.set_hyperlink/2","type":"function"},{"doc":"Sets the style to a new value.","ref":"Raxol.Terminal.Style.Manager.html#set_style/2","title":"Raxol.Terminal.Style.Manager.set_style/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Style.Manager.html#t:text_style/0","title":"Raxol.Terminal.Style.Manager.text_style/0","type":"type"},{"doc":"Supervisor for terminal-related processes.","ref":"Raxol.Terminal.Supervisor.html","title":"Raxol.Terminal.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Supervisor.html#child_spec/1","title":"Raxol.Terminal.Supervisor.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Supervisor.html#start_link/1","title":"Raxol.Terminal.Supervisor.start_link/1","type":"function"},{"doc":"Defines the structure for synchronized components.","ref":"Raxol.Terminal.Sync.Component.html","title":"Raxol.Terminal.Sync.Component","type":"module"},{"doc":"","ref":"Raxol.Terminal.Sync.Component.html#t:t/0","title":"Raxol.Terminal.Sync.Component.t/0","type":"type"},{"doc":"Manages synchronization between different terminal components (splits, windows, tabs).\nProvides a high-level interface for component synchronization and state management.","ref":"Raxol.Terminal.Sync.Manager.html","title":"Raxol.Terminal.Sync.Manager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Sync.Manager.html#child_spec/1","title":"Raxol.Terminal.Sync.Manager.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.Manager.html#t:component_id/0","title":"Raxol.Terminal.Sync.Manager.component_id/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Sync.Manager.html#t:component_type/0","title":"Raxol.Terminal.Sync.Manager.component_type/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Sync.Manager.html#do_sync_state/5","title":"Raxol.Terminal.Sync.Manager.do_sync_state/5","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.Manager.html#generate_sync_id/1","title":"Raxol.Terminal.Sync.Manager.generate_sync_id/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.Manager.html#get_component_stats/1","title":"Raxol.Terminal.Sync.Manager.get_component_stats/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.Manager.html#get_state/1","title":"Raxol.Terminal.Sync.Manager.get_state/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.Manager.html#register_component/3","title":"Raxol.Terminal.Sync.Manager.register_component/3","type":"function"},{"doc":"Starts the sync manager.","ref":"Raxol.Terminal.Sync.Manager.html#start_link/1","title":"Raxol.Terminal.Sync.Manager.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.Manager.html#t:sync_state/0","title":"Raxol.Terminal.Sync.Manager.sync_state/0","type":"type"},{"doc":"Syncs a component's state.","ref":"Raxol.Terminal.Sync.Manager.html#sync_state/4","title":"Raxol.Terminal.Sync.Manager.sync_state/4","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.Manager.html#t:t/0","title":"Raxol.Terminal.Sync.Manager.t/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Sync.Manager.html#unregister_component/1","title":"Raxol.Terminal.Sync.Manager.unregister_component/1","type":"function"},{"doc":"Defines the synchronization protocol for terminal components.\nHandles message formats, versioning, and conflict resolution strategies.","ref":"Raxol.Terminal.Sync.Protocol.html","title":"Raxol.Terminal.Sync.Protocol","type":"module"},{"doc":"","ref":"Raxol.Terminal.Sync.Protocol.html#create_ack_message/3","title":"Raxol.Terminal.Sync.Protocol.create_ack_message/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.Protocol.html#create_conflict_message/4","title":"Raxol.Terminal.Sync.Protocol.create_conflict_message/4","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.Protocol.html#create_resolve_message/4","title":"Raxol.Terminal.Sync.Protocol.create_resolve_message/4","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.Protocol.html#create_sync_message/4","title":"Raxol.Terminal.Sync.Protocol.create_sync_message/4","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.Protocol.html#handle_ack_message/2","title":"Raxol.Terminal.Sync.Protocol.handle_ack_message/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.Protocol.html#handle_conflict_message/2","title":"Raxol.Terminal.Sync.Protocol.handle_conflict_message/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.Protocol.html#handle_resolve_message/2","title":"Raxol.Terminal.Sync.Protocol.handle_resolve_message/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.Protocol.html#handle_sync_message/2","title":"Raxol.Terminal.Sync.Protocol.handle_sync_message/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.Protocol.html#t:sync_message/0","title":"Raxol.Terminal.Sync.Protocol.sync_message/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Sync.Protocol.html#t:sync_result/0","title":"Raxol.Terminal.Sync.Protocol.sync_result/0","type":"type"},{"doc":"Unified synchronization system for the terminal emulator.\nHandles synchronization between splits, windows, and tabs with different consistency levels.","ref":"Raxol.Terminal.Sync.System.html","title":"Raxol.Terminal.Sync.System","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Sync.System.html#child_spec/1","title":"Raxol.Terminal.Sync.System.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.System.html#clear/1","title":"Raxol.Terminal.Sync.System.clear/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.System.html#delete/2","title":"Raxol.Terminal.Sync.System.delete/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.System.html#get/2","title":"Raxol.Terminal.Sync.System.get/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.System.html#get_all/1","title":"Raxol.Terminal.Sync.System.get_all/1","type":"function"},{"doc":"Gets the current monotonic time in the specified unit.","ref":"Raxol.Terminal.Sync.System.html#monotonic_time/1","title":"Raxol.Terminal.Sync.System.monotonic_time/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.System.html#start_link/1","title":"Raxol.Terminal.Sync.System.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.System.html#stats/1","title":"Raxol.Terminal.Sync.System.stats/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.System.html#sync/4","title":"Raxol.Terminal.Sync.System.sync/4","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.System.html#t:sync_entry/0","title":"Raxol.Terminal.Sync.System.sync_entry/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Sync.System.html#t:sync_id/0","title":"Raxol.Terminal.Sync.System.sync_id/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Sync.System.html#t:sync_key/0","title":"Raxol.Terminal.Sync.System.sync_key/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Sync.System.html#t:sync_metadata/0","title":"Raxol.Terminal.Sync.System.sync_metadata/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Sync.System.html#t:sync_stats/0","title":"Raxol.Terminal.Sync.System.sync_stats/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Sync.System.html#t:sync_value/0","title":"Raxol.Terminal.Sync.System.sync_value/0","type":"type"},{"doc":"Gets the current system time in the specified unit.","ref":"Raxol.Terminal.Sync.System.html#system_time/1","title":"Raxol.Terminal.Sync.System.system_time/1","type":"function"},{"doc":"Unified synchronization system for the Raxol terminal emulator.\nThis module provides centralized synchronization mechanisms for:\n- State synchronization between windows\n- Event synchronization\n- Resource synchronization","ref":"Raxol.Terminal.Sync.UnifiedSync.html","title":"Raxol.Terminal.Sync.UnifiedSync","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Sync.UnifiedSync.html#child_spec/1","title":"Raxol.Terminal.Sync.UnifiedSync.child_spec/1","type":"function"},{"doc":"Cleans up a synchronization context.","ref":"Raxol.Terminal.Sync.UnifiedSync.html#cleanup/1","title":"Raxol.Terminal.Sync.UnifiedSync.cleanup/1","type":"function"},{"doc":"* `sync_id` - The synchronization context ID","ref":"Raxol.Terminal.Sync.UnifiedSync.html#cleanup/1-parameters","title":"Parameters - Raxol.Terminal.Sync.UnifiedSync.cleanup/1","type":"function"},{"doc":"Creates a new synchronization context.","ref":"Raxol.Terminal.Sync.UnifiedSync.html#create_sync/2","title":"Raxol.Terminal.Sync.UnifiedSync.create_sync/2","type":"function"},{"doc":"* `type` - Type of synchronization (:state, :event, or :resource)\n  * `opts` - Creation options\n    * `:consistency` - Consistency level\n    * `:conflict_resolution` - Conflict resolution strategy\n    * `:timeout` - Synchronization timeout\n    * `:retry_count` - Number of retry attempts","ref":"Raxol.Terminal.Sync.UnifiedSync.html#create_sync/2-parameters","title":"Parameters - Raxol.Terminal.Sync.UnifiedSync.create_sync/2","type":"function"},{"doc":"Gets the current state of a synchronization context.","ref":"Raxol.Terminal.Sync.UnifiedSync.html#get_sync_state/1","title":"Raxol.Terminal.Sync.UnifiedSync.get_sync_state/1","type":"function"},{"doc":"* `sync_id` - The synchronization context ID","ref":"Raxol.Terminal.Sync.UnifiedSync.html#get_sync_state/1-parameters","title":"Parameters - Raxol.Terminal.Sync.UnifiedSync.get_sync_state/1","type":"function"},{"doc":"Resolves conflicts between synchronized data.","ref":"Raxol.Terminal.Sync.UnifiedSync.html#resolve_conflicts/3","title":"Raxol.Terminal.Sync.UnifiedSync.resolve_conflicts/3","type":"function"},{"doc":"* `sync_id` - The synchronization context ID\n  * `conflicts` - List of conflicting versions\n  * `opts` - Resolution options\n    * `:strategy` - Override the default conflict resolution strategy","ref":"Raxol.Terminal.Sync.UnifiedSync.html#resolve_conflicts/3-parameters","title":"Parameters - Raxol.Terminal.Sync.UnifiedSync.resolve_conflicts/3","type":"function"},{"doc":"Starts the unified synchronization manager.","ref":"Raxol.Terminal.Sync.UnifiedSync.html#start_link/1","title":"Raxol.Terminal.Sync.UnifiedSync.start_link/1","type":"function"},{"doc":"* `:consistency` - Default consistency level (:strong or :eventual)\n  * `:conflict_resolution` - Default conflict resolution strategy\n  * `:timeout` - Default synchronization timeout in milliseconds\n  * `:retry_count` - Default number of retry attempts","ref":"Raxol.Terminal.Sync.UnifiedSync.html#start_link/1-options","title":"Options - Raxol.Terminal.Sync.UnifiedSync.start_link/1","type":"function"},{"doc":"Synchronizes data between windows.","ref":"Raxol.Terminal.Sync.UnifiedSync.html#sync/3","title":"Raxol.Terminal.Sync.UnifiedSync.sync/3","type":"function"},{"doc":"* `sync_id` - The synchronization context ID\n  * `data` - The data to synchronize\n  * `opts` - Synchronization options\n    * `:version` - Current version of the data\n    * `:metadata` - Additional metadata","ref":"Raxol.Terminal.Sync.UnifiedSync.html#sync/3-parameters","title":"Parameters - Raxol.Terminal.Sync.UnifiedSync.sync/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Sync.UnifiedSync.html#t:sync_config/0","title":"Raxol.Terminal.Sync.UnifiedSync.sync_config/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Sync.UnifiedSync.html#t:sync_id/0","title":"Raxol.Terminal.Sync.UnifiedSync.sync_id/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Sync.UnifiedSync.html#t:sync_state/0","title":"Raxol.Terminal.Sync.UnifiedSync.sync_state/0","type":"type"},{"doc":"Manages terminal tabs and their associated sessions.\nThis module handles:\n- Creation, deletion, and switching of terminal tabs\n- Tab state and configuration management\n- Tab stop management for terminal operations","ref":"Raxol.Terminal.Tab.Manager.html","title":"Raxol.Terminal.Tab.Manager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Tab.Manager.html#child_spec/1","title":"Raxol.Terminal.Tab.Manager.child_spec/1","type":"function"},{"doc":"Clears all tab stops.","ref":"Raxol.Terminal.Tab.Manager.html#clear_all_tab_stops/1","title":"Raxol.Terminal.Tab.Manager.clear_all_tab_stops/1","type":"function"},{"doc":"Clears a tab stop at the specified position.","ref":"Raxol.Terminal.Tab.Manager.html#clear_tab_stop/2","title":"Raxol.Terminal.Tab.Manager.clear_tab_stop/2","type":"function"},{"doc":"Creates a new tab with the given configuration.","ref":"Raxol.Terminal.Tab.Manager.html#create_tab/2","title":"Raxol.Terminal.Tab.Manager.create_tab/2","type":"function"},{"doc":"* `manager` - The tab manager instance\n* `config` - The tab configuration (optional)","ref":"Raxol.Terminal.Tab.Manager.html#create_tab/2-parameters","title":"Parameters - Raxol.Terminal.Tab.Manager.create_tab/2","type":"function"},{"doc":"`{:ok, tab_id, updated_manager}` on success\n`{:error, reason}` on failure","ref":"Raxol.Terminal.Tab.Manager.html#create_tab/2-returns","title":"Returns - Raxol.Terminal.Tab.Manager.create_tab/2","type":"function"},{"doc":"Deletes a tab by its ID.","ref":"Raxol.Terminal.Tab.Manager.html#delete_tab/2","title":"Raxol.Terminal.Tab.Manager.delete_tab/2","type":"function"},{"doc":"* `manager` - The tab manager instance\n* `tab_id` - The ID of the tab to delete","ref":"Raxol.Terminal.Tab.Manager.html#delete_tab/2-parameters","title":"Parameters - Raxol.Terminal.Tab.Manager.delete_tab/2","type":"function"},{"doc":"`{:ok, updated_manager}` on success\n`{:error, :tab_not_found}` if the tab doesn't exist","ref":"Raxol.Terminal.Tab.Manager.html#delete_tab/2-returns","title":"Returns - Raxol.Terminal.Tab.Manager.delete_tab/2","type":"function"},{"doc":"Gets the active tab ID.","ref":"Raxol.Terminal.Tab.Manager.html#get_active_tab/1","title":"Raxol.Terminal.Tab.Manager.get_active_tab/1","type":"function"},{"doc":"* `manager` - The tab manager instance","ref":"Raxol.Terminal.Tab.Manager.html#get_active_tab/1-parameters","title":"Parameters - Raxol.Terminal.Tab.Manager.get_active_tab/1","type":"function"},{"doc":"The active tab ID or nil if no tab is active","ref":"Raxol.Terminal.Tab.Manager.html#get_active_tab/1-returns","title":"Returns - Raxol.Terminal.Tab.Manager.get_active_tab/1","type":"function"},{"doc":"Gets the next tab stop position from the current position.","ref":"Raxol.Terminal.Tab.Manager.html#get_next_tab_stop/1","title":"Raxol.Terminal.Tab.Manager.get_next_tab_stop/1","type":"function"},{"doc":"Gets the configuration for a specific tab.","ref":"Raxol.Terminal.Tab.Manager.html#get_tab_config/2","title":"Raxol.Terminal.Tab.Manager.get_tab_config/2","type":"function"},{"doc":"* `manager` - The tab manager instance\n* `tab_id` - The ID of the tab","ref":"Raxol.Terminal.Tab.Manager.html#get_tab_config/2-parameters","title":"Parameters - Raxol.Terminal.Tab.Manager.get_tab_config/2","type":"function"},{"doc":"`{:ok, config}` on success\n`{:error, :tab_not_found}` if the tab doesn't exist","ref":"Raxol.Terminal.Tab.Manager.html#get_tab_config/2-returns","title":"Returns - Raxol.Terminal.Tab.Manager.get_tab_config/2","type":"function"},{"doc":"Lists all tabs.","ref":"Raxol.Terminal.Tab.Manager.html#list_tabs/1","title":"Raxol.Terminal.Tab.Manager.list_tabs/1","type":"function"},{"doc":"* `manager` - The tab manager instance","ref":"Raxol.Terminal.Tab.Manager.html#list_tabs/1-parameters","title":"Parameters - Raxol.Terminal.Tab.Manager.list_tabs/1","type":"function"},{"doc":"A list of tab configurations","ref":"Raxol.Terminal.Tab.Manager.html#list_tabs/1-returns","title":"Returns - Raxol.Terminal.Tab.Manager.list_tabs/1","type":"function"},{"doc":"Creates a new tab manager instance.","ref":"Raxol.Terminal.Tab.Manager.html#new/0","title":"Raxol.Terminal.Tab.Manager.new/0","type":"function"},{"doc":"Sets a horizontal tab stop at the current cursor position.","ref":"Raxol.Terminal.Tab.Manager.html#set_horizontal_tab/1","title":"Raxol.Terminal.Tab.Manager.set_horizontal_tab/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Tab.Manager.html#start_link/1","title":"Raxol.Terminal.Tab.Manager.start_link/1","type":"function"},{"doc":"Switches to a different tab.","ref":"Raxol.Terminal.Tab.Manager.html#switch_tab/2","title":"Raxol.Terminal.Tab.Manager.switch_tab/2","type":"function"},{"doc":"* `manager` - The tab manager instance\n* `tab_id` - The ID of the tab to switch to","ref":"Raxol.Terminal.Tab.Manager.html#switch_tab/2-parameters","title":"Parameters - Raxol.Terminal.Tab.Manager.switch_tab/2","type":"function"},{"doc":"`{:ok, updated_manager}` on success\n`{:error, :tab_not_found}` if the tab doesn't exist","ref":"Raxol.Terminal.Tab.Manager.html#switch_tab/2-returns","title":"Returns - Raxol.Terminal.Tab.Manager.switch_tab/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Tab.Manager.html#t:t/0","title":"Raxol.Terminal.Tab.Manager.t/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Tab.Manager.html#t:tab_config/0","title":"Raxol.Terminal.Tab.Manager.tab_config/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Tab.Manager.html#t:tab_id/0","title":"Raxol.Terminal.Tab.Manager.tab_id/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Tab.Manager.html#t:tab_state/0","title":"Raxol.Terminal.Tab.Manager.tab_state/0","type":"type"},{"doc":"Updates the configuration for a specific tab.","ref":"Raxol.Terminal.Tab.Manager.html#update_tab_config/3","title":"Raxol.Terminal.Tab.Manager.update_tab_config/3","type":"function"},{"doc":"* `manager` - The tab manager instance\n* `tab_id` - The ID of the tab\n* `config` - The new configuration","ref":"Raxol.Terminal.Tab.Manager.html#update_tab_config/3-parameters","title":"Parameters - Raxol.Terminal.Tab.Manager.update_tab_config/3","type":"function"},{"doc":"`{:ok, updated_manager}` on success\n`{:error, :tab_not_found}` if the tab doesn't exist","ref":"Raxol.Terminal.Tab.Manager.html#update_tab_config/3-returns","title":"Returns - Raxol.Terminal.Tab.Manager.update_tab_config/3","type":"function"},{"doc":"Provides unified tab management functionality for the terminal emulator.\nThis module handles tab creation, switching, state management, and configuration.","ref":"Raxol.Terminal.Tab.UnifiedTab.html","title":"Raxol.Terminal.Tab.UnifiedTab","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Tab.UnifiedTab.html#child_spec/1","title":"Raxol.Terminal.Tab.UnifiedTab.child_spec/1","type":"function"},{"doc":"Cleans up resources.","ref":"Raxol.Terminal.Tab.UnifiedTab.html#cleanup/0","title":"Raxol.Terminal.Tab.UnifiedTab.cleanup/0","type":"function"},{"doc":"Closes a tab and its associated windows.","ref":"Raxol.Terminal.Tab.UnifiedTab.html#close_tab/1","title":"Raxol.Terminal.Tab.UnifiedTab.close_tab/1","type":"function"},{"doc":"Creates a new tab with the given configuration.","ref":"Raxol.Terminal.Tab.UnifiedTab.html#create_tab/1","title":"Raxol.Terminal.Tab.UnifiedTab.create_tab/1","type":"function"},{"doc":"Gets the active tab ID.","ref":"Raxol.Terminal.Tab.UnifiedTab.html#get_active_tab/0","title":"Raxol.Terminal.Tab.UnifiedTab.get_active_tab/0","type":"function"},{"doc":"Gets the state of a specific tab.","ref":"Raxol.Terminal.Tab.UnifiedTab.html#get_tab_state/1","title":"Raxol.Terminal.Tab.UnifiedTab.get_tab_state/1","type":"function"},{"doc":"Gets the list of all tabs.","ref":"Raxol.Terminal.Tab.UnifiedTab.html#get_tabs/0","title":"Raxol.Terminal.Tab.UnifiedTab.get_tabs/0","type":"function"},{"doc":"Moves a tab to a new position.","ref":"Raxol.Terminal.Tab.UnifiedTab.html#move_tab/2","title":"Raxol.Terminal.Tab.UnifiedTab.move_tab/2","type":"function"},{"doc":"Sets the active tab.","ref":"Raxol.Terminal.Tab.UnifiedTab.html#set_active_tab/1","title":"Raxol.Terminal.Tab.UnifiedTab.set_active_tab/1","type":"function"},{"doc":"Starts the tab manager with the given options.","ref":"Raxol.Terminal.Tab.UnifiedTab.html#start_link/1","title":"Raxol.Terminal.Tab.UnifiedTab.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Tab.UnifiedTab.html#t:tab_config/0","title":"Raxol.Terminal.Tab.UnifiedTab.tab_config/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Tab.UnifiedTab.html#t:tab_id/0","title":"Raxol.Terminal.Tab.UnifiedTab.tab_id/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Tab.UnifiedTab.html#t:tab_state/0","title":"Raxol.Terminal.Tab.UnifiedTab.tab_state/0","type":"type"},{"doc":"Updates the tab manager configuration.","ref":"Raxol.Terminal.Tab.UnifiedTab.html#update_config/1","title":"Raxol.Terminal.Tab.UnifiedTab.update_config/1","type":"function"},{"doc":"Updates the configuration of a specific tab.","ref":"Raxol.Terminal.Tab.UnifiedTab.html#update_tab_config/2","title":"Raxol.Terminal.Tab.UnifiedTab.update_tab_config/2","type":"function"},{"doc":"Logs all Raxol.Terminal telemetry events for observability and debugging.\n\nCall `Raxol.Terminal.TelemetryLogger.attach_all/0` in your application start to enable logging.","ref":"Raxol.Terminal.TelemetryLogger.html","title":"Raxol.Terminal.TelemetryLogger","type":"module"},{"doc":"Attaches the logger to all Raxol.Terminal telemetry events.","ref":"Raxol.Terminal.TelemetryLogger.html#attach_all/0","title":"Raxol.Terminal.TelemetryLogger.attach_all/0","type":"function"},{"doc":"Example integration of Telemetry.Metrics and TelemetryMetricsStatsd for Raxol terminal events.\n\nAdd this module to your supervision tree to automatically report terminal metrics to StatsD (or Datadog).","ref":"Raxol.Terminal.TelemetryMetrics.html","title":"Raxol.Terminal.TelemetryMetrics","type":"module"},{"doc":"def start(_type, _args) do\n      children = [\n        {TelemetryMetricsStatsd, metrics: Raxol.Terminal.TelemetryMetrics.metrics(), formatter: :datadog}\n      ]\n      Supervisor.start_link(children, strategy: :one_for_one)\n    end","ref":"Raxol.Terminal.TelemetryMetrics.html#module-usage","title":"Usage - Raxol.Terminal.TelemetryMetrics","type":"module"},{"doc":"- `summary/2` for scroll delta (average scroll amount)\n- `counter/2` for mode changes, tagged by mode","ref":"Raxol.Terminal.TelemetryMetrics.html#module-richer-metrics-example","title":"Richer Metrics Example - Raxol.Terminal.TelemetryMetrics","type":"module"},{"doc":"Returns a list of Telemetry metrics for Raxol terminal events.","ref":"Raxol.Terminal.TelemetryMetrics.html#metrics/0","title":"Raxol.Terminal.TelemetryMetrics.metrics/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.TelemetryMetrics.html#mode_tag/1","title":"Raxol.Terminal.TelemetryMetrics.mode_tag/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.TelemetryMetrics.html#scroll_tags/1","title":"Raxol.Terminal.TelemetryMetrics.scroll_tags/1","type":"function"},{"doc":"Example integration of Telemetry.Metrics and TelemetryMetricsPrometheus for Raxol terminal events.\n\nAdd this module to your supervision tree to automatically export terminal metrics for Prometheus scraping.","ref":"Raxol.Terminal.TelemetryPrometheus.html","title":"Raxol.Terminal.TelemetryPrometheus","type":"module"},{"doc":"def start(_type, _args) do\n      children = [\n        {TelemetryMetricsPrometheus, metrics: Raxol.Terminal.TelemetryPrometheus.metrics()}\n      ]\n      Supervisor.start_link(children, strategy: :one_for_one)\n    end","ref":"Raxol.Terminal.TelemetryPrometheus.html#module-usage","title":"Usage - Raxol.Terminal.TelemetryPrometheus","type":"module"},{"doc":"Returns a list of Telemetry metrics for Raxol terminal events, including advanced Prometheus metrics.","ref":"Raxol.Terminal.TelemetryPrometheus.html#metrics/0","title":"Raxol.Terminal.TelemetryPrometheus.metrics/0","type":"function"},{"doc":"","ref":"Raxol.Terminal.TelemetryPrometheus.html#mode_tag/1","title":"Raxol.Terminal.TelemetryPrometheus.mode_tag/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.TelemetryPrometheus.html#scroll_tags/1","title":"Raxol.Terminal.TelemetryPrometheus.scroll_tags/1","type":"function"},{"doc":"Manages terminal state operations for the terminal emulator.\nThis module handles the state stack, saved states, and state transitions.","ref":"Raxol.Terminal.TerminalState.Manager.html","title":"Raxol.Terminal.TerminalState.Manager","type":"module"},{"doc":"Clears all saved states.","ref":"Raxol.Terminal.TerminalState.Manager.html#clear_saved_states/1","title":"Raxol.Terminal.TerminalState.Manager.clear_saved_states/1","type":"function"},{"doc":"Gets the current state.","ref":"Raxol.Terminal.TerminalState.Manager.html#get_current_state/1","title":"Raxol.Terminal.TerminalState.Manager.get_current_state/1","type":"function"},{"doc":"Gets the number of saved states.","ref":"Raxol.Terminal.TerminalState.Manager.html#get_saved_states_count/1","title":"Raxol.Terminal.TerminalState.Manager.get_saved_states_count/1","type":"function"},{"doc":"Gets the current state stack.","ref":"Raxol.Terminal.TerminalState.Manager.html#get_state_stack/1","title":"Raxol.Terminal.TerminalState.Manager.get_state_stack/1","type":"function"},{"doc":"Checks if there are saved states.","ref":"Raxol.Terminal.TerminalState.Manager.html#has_saved_states?/1","title":"Raxol.Terminal.TerminalState.Manager.has_saved_states?/1","type":"function"},{"doc":"Creates a new terminal state.","ref":"Raxol.Terminal.TerminalState.Manager.html#new/0","title":"Raxol.Terminal.TerminalState.Manager.new/0","type":"function"},{"doc":"Restores the last saved state.","ref":"Raxol.Terminal.TerminalState.Manager.html#restore_state/1","title":"Raxol.Terminal.TerminalState.Manager.restore_state/1","type":"function"},{"doc":"Saves the current state.","ref":"Raxol.Terminal.TerminalState.Manager.html#save_state/1","title":"Raxol.Terminal.TerminalState.Manager.save_state/1","type":"function"},{"doc":"Updates the current state.","ref":"Raxol.Terminal.TerminalState.Manager.html#update_current_state/2","title":"Raxol.Terminal.TerminalState.Manager.update_current_state/2","type":"function"},{"doc":"Updates the state stack.","ref":"Raxol.Terminal.TerminalState.Manager.html#update_state_stack/2","title":"Raxol.Terminal.TerminalState.Manager.update_state_stack/2","type":"function"},{"doc":"Utility functions for terminal operations, providing cross-platform and\nconsistent handling of terminal capabilities and dimensions.","ref":"Raxol.Terminal.TerminalUtils.html","title":"Raxol.Terminal.TerminalUtils","type":"module"},{"doc":"Returns the current cursor position, if available.","ref":"Raxol.Terminal.TerminalUtils.html#cursor_position/0","title":"Raxol.Terminal.TerminalUtils.cursor_position/0","type":"function"},{"doc":"Detects terminal dimensions using a multi-layered approach:\n1. Uses `:io.columns` and `:io.rows` (preferred)\n2. Falls back to termbox2 NIF if `:io` methods fail\n3. Falls back to `stty size` system command if needed\n4. Finally uses hardcoded default dimensions if all else fails\n\nReturns a tuple of {width, height}.","ref":"Raxol.Terminal.TerminalUtils.html#detect_dimensions/0","title":"Raxol.Terminal.TerminalUtils.detect_dimensions/0","type":"function"},{"doc":"Detects terminal dimensions using :io.columns and :io.rows.\nReturns {:ok, width, height} or {:error, reason}.","ref":"Raxol.Terminal.TerminalUtils.html#detect_with_io/1","title":"Raxol.Terminal.TerminalUtils.detect_with_io/1","type":"function"},{"doc":"Detects terminal dimensions using the stty size command.\nReturns {:ok, width, height} or {:error, reason}.","ref":"Raxol.Terminal.TerminalUtils.html#detect_with_stty/0","title":"Raxol.Terminal.TerminalUtils.detect_with_stty/0","type":"function"},{"doc":"Detects terminal dimensions using the termbox2 NIF.\nReturns {:ok, width, height} or {:error, reason}.","ref":"Raxol.Terminal.TerminalUtils.html#detect_with_termbox/0","title":"Raxol.Terminal.TerminalUtils.detect_with_termbox/0","type":"function"},{"doc":"Creates a bounds map with dimensions, starting at origin (0,0)","ref":"Raxol.Terminal.TerminalUtils.html#get_bounds_map/0","title":"Raxol.Terminal.TerminalUtils.get_bounds_map/0","type":"function"},{"doc":"Gets terminal dimensions and returns them in a map format.","ref":"Raxol.Terminal.TerminalUtils.html#get_dimensions_map/0","title":"Raxol.Terminal.TerminalUtils.get_dimensions_map/0","type":"function"},{"doc":"Returns true if the current process is attached to a real TTY device.","ref":"Raxol.Terminal.TerminalUtils.html#real_tty?/0","title":"Raxol.Terminal.TerminalUtils.real_tty?/0","type":"function"},{"doc":"Alias module for Raxol.Terminal.ANSI.TextFormatting.\nThis module re-exports the functionality from ANSI.TextFormatting to maintain compatibility.","ref":"Raxol.Terminal.TextFormatting.html","title":"Raxol.Terminal.TextFormatting","type":"module"},{"doc":"See  Raxol.Terminal.ANSI.TextFormatting.ansi_code_to_color_name/1 .","ref":"Raxol.Terminal.TextFormatting.html#ansi_code_to_color_name/1","title":"Raxol.Terminal.TextFormatting.ansi_code_to_color_name/1","type":"function"},{"doc":"See  Raxol.Terminal.ANSI.TextFormatting.apply_attribute/2 .","ref":"Raxol.Terminal.TextFormatting.html#apply_attribute/2","title":"Raxol.Terminal.TextFormatting.apply_attribute/2","type":"function"},{"doc":"See  Raxol.Terminal.ANSI.TextFormatting.apply_color/3 .","ref":"Raxol.Terminal.TextFormatting.html#apply_color/3","title":"Raxol.Terminal.TextFormatting.apply_color/3","type":"function"},{"doc":"See  Raxol.Terminal.ANSI.TextFormatting.effective_width/2 .","ref":"Raxol.Terminal.TextFormatting.html#effective_width/2","title":"Raxol.Terminal.TextFormatting.effective_width/2","type":"function"},{"doc":"Formats a style into SGR parameters.","ref":"Raxol.Terminal.TextFormatting.html#format_sgr_params/1","title":"Raxol.Terminal.TextFormatting.format_sgr_params/1","type":"function"},{"doc":"See  Raxol.Terminal.ANSI.TextFormatting.get_background/1 .","ref":"Raxol.Terminal.TextFormatting.html#get_background/1","title":"Raxol.Terminal.TextFormatting.get_background/1","type":"function"},{"doc":"See  Raxol.Terminal.ANSI.TextFormatting.new/0 .","ref":"Raxol.Terminal.TextFormatting.html#get_default_style/0","title":"Raxol.Terminal.TextFormatting.get_default_style/0","type":"function"},{"doc":"See  Raxol.Terminal.ANSI.TextFormatting.get_foreground/1 .","ref":"Raxol.Terminal.TextFormatting.html#get_foreground/1","title":"Raxol.Terminal.TextFormatting.get_foreground/1","type":"function"},{"doc":"Gets the hyperlink from a style.","ref":"Raxol.Terminal.TextFormatting.html#get_hyperlink/1","title":"Raxol.Terminal.TextFormatting.get_hyperlink/1","type":"function"},{"doc":"Gets the paired line type for double-height mode.","ref":"Raxol.Terminal.TextFormatting.html#get_paired_line_type/1","title":"Raxol.Terminal.TextFormatting.get_paired_line_type/1","type":"function"},{"doc":"Checks if the current style needs a paired line for double-height mode.","ref":"Raxol.Terminal.TextFormatting.html#needs_paired_line?/1","title":"Raxol.Terminal.TextFormatting.needs_paired_line?/1","type":"function"},{"doc":"See  Raxol.Terminal.ANSI.TextFormatting.new/0 .","ref":"Raxol.Terminal.TextFormatting.html#new/0","title":"Raxol.Terminal.TextFormatting.new/0","type":"function"},{"doc":"Resets the blink attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#reset_blink/1","title":"Raxol.Terminal.TextFormatting.reset_blink/1","type":"function"},{"doc":"Resets the bold attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#reset_bold/1","title":"Raxol.Terminal.TextFormatting.reset_bold/1","type":"function"},{"doc":"Resets the italic attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#reset_italic/1","title":"Raxol.Terminal.TextFormatting.reset_italic/1","type":"function"},{"doc":"Resets the reverse attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#reset_reverse/1","title":"Raxol.Terminal.TextFormatting.reset_reverse/1","type":"function"},{"doc":"See  Raxol.Terminal.ANSI.TextFormatting.reset_size/1 .","ref":"Raxol.Terminal.TextFormatting.html#reset_size/1","title":"Raxol.Terminal.TextFormatting.reset_size/1","type":"function"},{"doc":"Resets the underline attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#reset_underline/1","title":"Raxol.Terminal.TextFormatting.reset_underline/1","type":"function"},{"doc":"See  Raxol.Terminal.ANSI.TextFormatting.set_background/2 .","ref":"Raxol.Terminal.TextFormatting.html#set_background/2","title":"Raxol.Terminal.TextFormatting.set_background/2","type":"function"},{"doc":"Sets the blink attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#set_blink/1","title":"Raxol.Terminal.TextFormatting.set_blink/1","type":"function"},{"doc":"Sets the bold attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#set_bold/1","title":"Raxol.Terminal.TextFormatting.set_bold/1","type":"function"},{"doc":"Sets the conceal attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#set_conceal/1","title":"Raxol.Terminal.TextFormatting.set_conceal/1","type":"function"},{"doc":"See  Raxol.Terminal.ANSI.TextFormatting.set_double_height_bottom/1 .","ref":"Raxol.Terminal.TextFormatting.html#set_double_height_bottom/1","title":"Raxol.Terminal.TextFormatting.set_double_height_bottom/1","type":"function"},{"doc":"See  Raxol.Terminal.ANSI.TextFormatting.set_double_height_top/1 .","ref":"Raxol.Terminal.TextFormatting.html#set_double_height_top/1","title":"Raxol.Terminal.TextFormatting.set_double_height_top/1","type":"function"},{"doc":"Sets the double underline attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#set_double_underline/1","title":"Raxol.Terminal.TextFormatting.set_double_underline/1","type":"function"},{"doc":"See  Raxol.Terminal.ANSI.TextFormatting.set_double_width/1 .","ref":"Raxol.Terminal.TextFormatting.html#set_double_width/1","title":"Raxol.Terminal.TextFormatting.set_double_width/1","type":"function"},{"doc":"Sets the encircled attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#set_encircled/1","title":"Raxol.Terminal.TextFormatting.set_encircled/1","type":"function"},{"doc":"Sets the faint attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#set_faint/1","title":"Raxol.Terminal.TextFormatting.set_faint/1","type":"function"},{"doc":"See  Raxol.Terminal.ANSI.TextFormatting.set_foreground/2 .","ref":"Raxol.Terminal.TextFormatting.html#set_foreground/2","title":"Raxol.Terminal.TextFormatting.set_foreground/2","type":"function"},{"doc":"Sets the fraktur attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#set_fraktur/1","title":"Raxol.Terminal.TextFormatting.set_fraktur/1","type":"function"},{"doc":"Sets the framed attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#set_framed/1","title":"Raxol.Terminal.TextFormatting.set_framed/1","type":"function"},{"doc":"Sets the italic attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#set_italic/1","title":"Raxol.Terminal.TextFormatting.set_italic/1","type":"function"},{"doc":"Sets the overlined attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#set_overlined/1","title":"Raxol.Terminal.TextFormatting.set_overlined/1","type":"function"},{"doc":"Sets the reverse attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#set_reverse/1","title":"Raxol.Terminal.TextFormatting.set_reverse/1","type":"function"},{"doc":"Sets the strikethrough attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#set_strikethrough/1","title":"Raxol.Terminal.TextFormatting.set_strikethrough/1","type":"function"},{"doc":"Sets the underline attribute for text formatting.","ref":"Raxol.Terminal.TextFormatting.html#set_underline/1","title":"Raxol.Terminal.TextFormatting.set_underline/1","type":"function"},{"doc":"Manages terminal themes with advanced features:\n- Theme loading from files and presets\n- Theme customization and modification\n- Dynamic theme switching\n- Theme persistence and state management","ref":"Raxol.Terminal.Theme.Manager.html","title":"Raxol.Terminal.Theme.Manager","type":"module"},{"doc":"Adds a custom style to the current theme.","ref":"Raxol.Terminal.Theme.Manager.html#add_custom_style/3","title":"Raxol.Terminal.Theme.Manager.add_custom_style/3","type":"function"},{"doc":"","ref":"Raxol.Terminal.Theme.Manager.html#t:color/0","title":"Raxol.Terminal.Theme.Manager.color/0","type":"type"},{"doc":"Gets the current theme metrics.","ref":"Raxol.Terminal.Theme.Manager.html#get_metrics/1","title":"Raxol.Terminal.Theme.Manager.get_metrics/1","type":"function"},{"doc":"Gets a style from the current theme or custom styles.","ref":"Raxol.Terminal.Theme.Manager.html#get_style/2","title":"Raxol.Terminal.Theme.Manager.get_style/2","type":"function"},{"doc":"Loads a theme from a file or preset.","ref":"Raxol.Terminal.Theme.Manager.html#load_theme/2","title":"Raxol.Terminal.Theme.Manager.load_theme/2","type":"function"},{"doc":"Creates a new theme manager with the given options.","ref":"Raxol.Terminal.Theme.Manager.html#new/1","title":"Raxol.Terminal.Theme.Manager.new/1","type":"function"},{"doc":"Restores a theme state from saved data.","ref":"Raxol.Terminal.Theme.Manager.html#restore_theme_state/2","title":"Raxol.Terminal.Theme.Manager.restore_theme_state/2","type":"function"},{"doc":"Saves the current theme state for persistence.","ref":"Raxol.Terminal.Theme.Manager.html#save_theme_state/1","title":"Raxol.Terminal.Theme.Manager.save_theme_state/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Theme.Manager.html#t:style/0","title":"Raxol.Terminal.Theme.Manager.style/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Theme.Manager.html#t:t/0","title":"Raxol.Terminal.Theme.Manager.t/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Theme.Manager.html#t:theme/0","title":"Raxol.Terminal.Theme.Manager.theme/0","type":"type"},{"doc":"Unified theme system for the Raxol terminal emulator.\nHandles theme management, preview, switching, and customization.","ref":"Raxol.Terminal.Theme.UnifiedTheme.html","title":"Raxol.Terminal.Theme.UnifiedTheme","type":"module"},{"doc":"Applies a theme to the terminal.","ref":"Raxol.Terminal.Theme.UnifiedTheme.html#apply_theme/1","title":"Raxol.Terminal.Theme.UnifiedTheme.apply_theme/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Theme.UnifiedTheme.html#child_spec/1","title":"Raxol.Terminal.Theme.UnifiedTheme.child_spec/1","type":"function"},{"doc":"Exports a theme to a file.","ref":"Raxol.Terminal.Theme.UnifiedTheme.html#export_theme/2","title":"Raxol.Terminal.Theme.UnifiedTheme.export_theme/2","type":"function"},{"doc":"Gets the state of a theme.","ref":"Raxol.Terminal.Theme.UnifiedTheme.html#get_theme_state/1","title":"Raxol.Terminal.Theme.UnifiedTheme.get_theme_state/1","type":"function"},{"doc":"Gets all loaded themes.","ref":"Raxol.Terminal.Theme.UnifiedTheme.html#get_themes/1","title":"Raxol.Terminal.Theme.UnifiedTheme.get_themes/1","type":"function"},{"doc":"Imports a theme from a file.","ref":"Raxol.Terminal.Theme.UnifiedTheme.html#import_theme/1","title":"Raxol.Terminal.Theme.UnifiedTheme.import_theme/1","type":"function"},{"doc":"Loads a theme from a file or directory.","ref":"Raxol.Terminal.Theme.UnifiedTheme.html#load_theme/2","title":"Raxol.Terminal.Theme.UnifiedTheme.load_theme/2","type":"function"},{"doc":"Previews a theme without applying it.","ref":"Raxol.Terminal.Theme.UnifiedTheme.html#preview_theme/1","title":"Raxol.Terminal.Theme.UnifiedTheme.preview_theme/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Theme.UnifiedTheme.html#start_link/1","title":"Raxol.Terminal.Theme.UnifiedTheme.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Theme.UnifiedTheme.html#t:theme_id/0","title":"Raxol.Terminal.Theme.UnifiedTheme.theme_id/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Theme.UnifiedTheme.html#t:theme_state/0","title":"Raxol.Terminal.Theme.UnifiedTheme.theme_state/0","type":"type"},{"doc":"Unloads a theme by ID.","ref":"Raxol.Terminal.Theme.UnifiedTheme.html#unload_theme/1","title":"Raxol.Terminal.Theme.UnifiedTheme.unload_theme/1","type":"function"},{"doc":"Updates a theme's configuration.","ref":"Raxol.Terminal.Theme.UnifiedTheme.html#update_theme_config/2","title":"Raxol.Terminal.Theme.UnifiedTheme.update_theme_config/2","type":"function"},{"doc":"Stub validation module for terminal input. Replace with real validation logic as needed.","ref":"Raxol.Terminal.Validation.html","title":"Raxol.Terminal.Validation","type":"module"},{"doc":"Validates input for the terminal. Currently a stub that always returns {:ok, value}.","ref":"Raxol.Terminal.Validation.html#validate_input/4","title":"Raxol.Terminal.Validation.validate_input/4","type":"function"},{"doc":"Represents a terminal window with its properties and state.\n\nThis module provides functionality for managing terminal windows, including:\n* Window creation and configuration\n* State management (active, inactive, minimized, maximized)\n* Size and position control\n* Parent-child window relationships\n* Terminal emulator integration","ref":"Raxol.Terminal.Window.html","title":"Raxol.Terminal.Window","type":"module"},{"doc":"* `:active` - Window is currently focused\n* `:inactive` - Window is not focused\n* `:minimized` - Window is minimized\n* `:maximized` - Window is maximized","ref":"Raxol.Terminal.Window.html#module-window-states","title":"Window States - Raxol.Terminal.Window","type":"module"},{"doc":"```elixir\n# Create a new window with default size\nwindow = Window.new(Config.new())\n\n# Create a window with custom dimensions\nwindow = Window.new(100, 50)\n\n# Update window title\n{:ok, window} = Window.set_title(window, \"My Terminal\")\n```","ref":"Raxol.Terminal.Window.html#module-usage","title":"Usage - Raxol.Terminal.Window","type":"module"},{"doc":"Adds a child window.","ref":"Raxol.Terminal.Window.html#add_child/2","title":"Raxol.Terminal.Window.add_child/2","type":"function"},{"doc":"Clears a hyperlink by ID.","ref":"Raxol.Terminal.Window.html#clear_hyperlink/2","title":"Raxol.Terminal.Window.clear_hyperlink/2","type":"function"},{"doc":"Gets the window's child windows.","ref":"Raxol.Terminal.Window.html#get_children/1","title":"Raxol.Terminal.Window.get_children/1","type":"function"},{"doc":"Gets the window's clipboard content.","ref":"Raxol.Terminal.Window.html#get_clipboard/1","title":"Raxol.Terminal.Window.get_clipboard/1","type":"function"},{"doc":"Gets the window's cursor shape.","ref":"Raxol.Terminal.Window.html#get_cursor_shape/1","title":"Raxol.Terminal.Window.get_cursor_shape/1","type":"function"},{"doc":"Gets the window's current dimensions.","ref":"Raxol.Terminal.Window.html#get_dimensions/1","title":"Raxol.Terminal.Window.get_dimensions/1","type":"function"},{"doc":"Gets the window's font.","ref":"Raxol.Terminal.Window.html#get_font/1","title":"Raxol.Terminal.Window.get_font/1","type":"function"},{"doc":"Gets a hyperlink by ID.","ref":"Raxol.Terminal.Window.html#get_hyperlink/2","title":"Raxol.Terminal.Window.get_hyperlink/2","type":"function"},{"doc":"Gets the window's icon name.","ref":"Raxol.Terminal.Window.html#get_icon_name/1","title":"Raxol.Terminal.Window.get_icon_name/1","type":"function"},{"doc":"Gets the window's parent window.","ref":"Raxol.Terminal.Window.html#get_parent/1","title":"Raxol.Terminal.Window.get_parent/1","type":"function"},{"doc":"Gets the window's current position.","ref":"Raxol.Terminal.Window.html#get_position/1","title":"Raxol.Terminal.Window.get_position/1","type":"function"},{"doc":"Gets the window's current size.","ref":"Raxol.Terminal.Window.html#get_size/1","title":"Raxol.Terminal.Window.get_size/1","type":"function"},{"doc":"Gets the window's current state.","ref":"Raxol.Terminal.Window.html#get_state/1","title":"Raxol.Terminal.Window.get_state/1","type":"function"},{"doc":"Gets the window's working directory.","ref":"Raxol.Terminal.Window.html#get_working_directory/1","title":"Raxol.Terminal.Window.get_working_directory/1","type":"function"},{"doc":"Creates a new window with the given configuration.","ref":"Raxol.Terminal.Window.html#new/1","title":"Raxol.Terminal.Window.new/1","type":"function"},{"doc":"* `config` - Terminal configuration (Config.t())","ref":"Raxol.Terminal.Window.html#new/1-parameters","title":"Parameters - Raxol.Terminal.Window.new/1","type":"function"},{"doc":"* A new window instance with the specified configuration","ref":"Raxol.Terminal.Window.html#new/1-returns","title":"Returns - Raxol.Terminal.Window.new/1","type":"function"},{"doc":"iex> config = Config.new()\n    iex> window = Window.new(config)\n    iex> window.size\n    {80, 24}","ref":"Raxol.Terminal.Window.html#new/1-examples","title":"Examples - Raxol.Terminal.Window.new/1","type":"function"},{"doc":"Creates a new window with custom dimensions.","ref":"Raxol.Terminal.Window.html#new/2","title":"Raxol.Terminal.Window.new/2","type":"function"},{"doc":"* `width` - Window width in characters (positive integer)\n  * `height` - Window height in characters (positive integer)","ref":"Raxol.Terminal.Window.html#new/2-parameters","title":"Parameters - Raxol.Terminal.Window.new/2","type":"function"},{"doc":"* A new window instance with the specified dimensions","ref":"Raxol.Terminal.Window.html#new/2-returns","title":"Returns - Raxol.Terminal.Window.new/2","type":"function"},{"doc":"iex> window = Window.new(100, 50)\n    iex> window.size\n    {100, 50}","ref":"Raxol.Terminal.Window.html#new/2-examples","title":"Examples - Raxol.Terminal.Window.new/2","type":"function"},{"doc":"Removes a child window.","ref":"Raxol.Terminal.Window.html#remove_child/2","title":"Raxol.Terminal.Window.remove_child/2","type":"function"},{"doc":"Restores the previous window size.","ref":"Raxol.Terminal.Window.html#restore_size/1","title":"Raxol.Terminal.Window.restore_size/1","type":"function"},{"doc":"Updates the window's clipboard content.","ref":"Raxol.Terminal.Window.html#set_clipboard/2","title":"Raxol.Terminal.Window.set_clipboard/2","type":"function"},{"doc":"Updates the window's cursor shape.","ref":"Raxol.Terminal.Window.html#set_cursor_shape/2","title":"Raxol.Terminal.Window.set_cursor_shape/2","type":"function"},{"doc":"Updates the window's font.","ref":"Raxol.Terminal.Window.html#set_font/2","title":"Raxol.Terminal.Window.set_font/2","type":"function"},{"doc":"Sets a hyperlink with the given ID and URL.","ref":"Raxol.Terminal.Window.html#set_hyperlink/3","title":"Raxol.Terminal.Window.set_hyperlink/3","type":"function"},{"doc":"Updates the window's icon name.","ref":"Raxol.Terminal.Window.html#set_icon_name/2","title":"Raxol.Terminal.Window.set_icon_name/2","type":"function"},{"doc":"Sets the parent window.","ref":"Raxol.Terminal.Window.html#set_parent/2","title":"Raxol.Terminal.Window.set_parent/2","type":"function"},{"doc":"Updates the window position.","ref":"Raxol.Terminal.Window.html#set_position/3","title":"Raxol.Terminal.Window.set_position/3","type":"function"},{"doc":"Updates the window size.","ref":"Raxol.Terminal.Window.html#set_size/3","title":"Raxol.Terminal.Window.set_size/3","type":"function"},{"doc":"Updates the window state.","ref":"Raxol.Terminal.Window.html#set_state/2","title":"Raxol.Terminal.Window.set_state/2","type":"function"},{"doc":"Updates the window title.","ref":"Raxol.Terminal.Window.html#set_title/2","title":"Raxol.Terminal.Window.set_title/2","type":"function"},{"doc":"* `window` - The window to update\n  * `title` - New window title","ref":"Raxol.Terminal.Window.html#set_title/2-parameters","title":"Parameters - Raxol.Terminal.Window.set_title/2","type":"function"},{"doc":"* `{:ok, updated_window}` - Title updated successfully\n  * `{:error, reason}` - Failed to update title","ref":"Raxol.Terminal.Window.html#set_title/2-returns","title":"Returns - Raxol.Terminal.Window.set_title/2","type":"function"},{"doc":"iex> window = Window.new(80, 24)\n    iex> {:ok, window} = Window.set_title(window, \"My Terminal\")\n    iex> window.title\n    \"My Terminal\"","ref":"Raxol.Terminal.Window.html#set_title/2-examples","title":"Examples - Raxol.Terminal.Window.set_title/2","type":"function"},{"doc":"Sets the window's working directory.","ref":"Raxol.Terminal.Window.html#set_working_directory/2","title":"Raxol.Terminal.Window.set_working_directory/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Window.html#t:t/0","title":"Raxol.Terminal.Window.t/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Window.html#t:window_position/0","title":"Raxol.Terminal.Window.window_position/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Window.html#t:window_size/0","title":"Raxol.Terminal.Window.window_size/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Window.html#t:window_state/0","title":"Raxol.Terminal.Window.window_state/0","type":"type"},{"doc":"Manages terminal window properties and operations.","ref":"Raxol.Terminal.Window.Manager.html","title":"Raxol.Terminal.Window.Manager","type":"module"},{"doc":"Gets the window height.","ref":"Raxol.Terminal.Window.Manager.html#get_height/1","title":"Raxol.Terminal.Window.Manager.get_height/1","type":"function"},{"doc":"Gets the window icon name.","ref":"Raxol.Terminal.Window.Manager.html#get_icon_name/1","title":"Raxol.Terminal.Window.Manager.get_icon_name/1","type":"function"},{"doc":"Gets the window position.","ref":"Raxol.Terminal.Window.Manager.html#get_position/1","title":"Raxol.Terminal.Window.Manager.get_position/1","type":"function"},{"doc":"Gets the window stacking order.","ref":"Raxol.Terminal.Window.Manager.html#get_stacking_order/1","title":"Raxol.Terminal.Window.Manager.get_stacking_order/1","type":"function"},{"doc":"Gets the window title.","ref":"Raxol.Terminal.Window.Manager.html#get_title/1","title":"Raxol.Terminal.Window.Manager.get_title/1","type":"function"},{"doc":"Gets the window width.","ref":"Raxol.Terminal.Window.Manager.html#get_width/1","title":"Raxol.Terminal.Window.Manager.get_width/1","type":"function"},{"doc":"Gets the current window state.","ref":"Raxol.Terminal.Window.Manager.html#get_window_state/1","title":"Raxol.Terminal.Window.Manager.get_window_state/1","type":"function"},{"doc":"Creates a new window manager instance.","ref":"Raxol.Terminal.Window.Manager.html#new/1","title":"Raxol.Terminal.Window.Manager.new/1","type":"function"},{"doc":"Restores the previously saved window size.","ref":"Raxol.Terminal.Window.Manager.html#restore_window_size/1","title":"Raxol.Terminal.Window.Manager.restore_window_size/1","type":"function"},{"doc":"Saves the current window size for later restoration.","ref":"Raxol.Terminal.Window.Manager.html#save_window_size/1","title":"Raxol.Terminal.Window.Manager.save_window_size/1","type":"function"},{"doc":"Sets the window icon name.","ref":"Raxol.Terminal.Window.Manager.html#set_icon_name/2","title":"Raxol.Terminal.Window.Manager.set_icon_name/2","type":"function"},{"doc":"Sets the window stacking order.","ref":"Raxol.Terminal.Window.Manager.html#set_stacking_order/2","title":"Raxol.Terminal.Window.Manager.set_stacking_order/2","type":"function"},{"doc":"Sets the window position.","ref":"Raxol.Terminal.Window.Manager.html#set_window_position/3","title":"Raxol.Terminal.Window.Manager.set_window_position/3","type":"function"},{"doc":"Sets the window size.","ref":"Raxol.Terminal.Window.Manager.html#set_window_size/3","title":"Raxol.Terminal.Window.Manager.set_window_size/3","type":"function"},{"doc":"Sets the window title.","ref":"Raxol.Terminal.Window.Manager.html#set_window_title/2","title":"Raxol.Terminal.Window.Manager.set_window_title/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Window.Manager.html#t:stacking_order/0","title":"Raxol.Terminal.Window.Manager.stacking_order/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Window.Manager.html#t:t/0","title":"Raxol.Terminal.Window.Manager.t/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Window.Manager.html#t:window_position/0","title":"Raxol.Terminal.Window.Manager.window_position/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Window.Manager.html#t:window_size/0","title":"Raxol.Terminal.Window.Manager.window_size/0","type":"type"},{"doc":"Registry for managing multiple terminal windows.","ref":"Raxol.Terminal.Window.Registry.html","title":"Raxol.Terminal.Window.Registry","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Window.Registry.html#child_spec/1","title":"Raxol.Terminal.Window.Registry.child_spec/1","type":"function"},{"doc":"Gets the active window.","ref":"Raxol.Terminal.Window.Registry.html#get_active_window/0","title":"Raxol.Terminal.Window.Registry.get_active_window/0","type":"function"},{"doc":"Gets a window by ID.","ref":"Raxol.Terminal.Window.Registry.html#get_window/1","title":"Raxol.Terminal.Window.Registry.get_window/1","type":"function"},{"doc":"Lists all registered windows.","ref":"Raxol.Terminal.Window.Registry.html#list_windows/0","title":"Raxol.Terminal.Window.Registry.list_windows/0","type":"function"},{"doc":"Registers a new window.","ref":"Raxol.Terminal.Window.Registry.html#register_window/1","title":"Raxol.Terminal.Window.Registry.register_window/1","type":"function"},{"doc":"Sets the active window.","ref":"Raxol.Terminal.Window.Registry.html#set_active_window/1","title":"Raxol.Terminal.Window.Registry.set_active_window/1","type":"function"},{"doc":"Starts the window registry.","ref":"Raxol.Terminal.Window.Registry.html#start_link/1","title":"Raxol.Terminal.Window.Registry.start_link/1","type":"function"},{"doc":"Unregisters a window.","ref":"Raxol.Terminal.Window.Registry.html#unregister_window/1","title":"Raxol.Terminal.Window.Registry.unregister_window/1","type":"function"},{"doc":"Updates a window's properties.","ref":"Raxol.Terminal.Window.Registry.html#update_window/2","title":"Raxol.Terminal.Window.Registry.update_window/2","type":"function"},{"doc":"Updates a window's state.","ref":"Raxol.Terminal.Window.Registry.html#update_window_state/2","title":"Raxol.Terminal.Window.Registry.update_window_state/2","type":"function"},{"doc":"","ref":"Raxol.Terminal.Window.Registry.html#t:window_id/0","title":"Raxol.Terminal.Window.Registry.window_id/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Window.Registry.html#t:window_state/0","title":"Raxol.Terminal.Window.Registry.window_state/0","type":"type"},{"doc":"Unified window management system for the Raxol Terminal Emulator.\nHandles window creation, manipulation, state management, and ANSI sequence processing.","ref":"Raxol.Terminal.Window.UnifiedWindow.html","title":"Raxol.Terminal.Window.UnifiedWindow","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#child_spec/1","title":"Raxol.Terminal.Window.UnifiedWindow.child_spec/1","type":"function"},{"doc":"Cleans up the window manager.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#cleanup/1","title":"Raxol.Terminal.Window.UnifiedWindow.cleanup/1","type":"function"},{"doc":"Closes a window and its children.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#close_window/1","title":"Raxol.Terminal.Window.UnifiedWindow.close_window/1","type":"function"},{"doc":"Creates a new window with the given options.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#create_window/1","title":"Raxol.Terminal.Window.UnifiedWindow.create_window/1","type":"function"},{"doc":"Gets the active window ID.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#get_active_window/0","title":"Raxol.Terminal.Window.UnifiedWindow.get_active_window/0","type":"function"},{"doc":"Gets the state of a window.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#get_window_state/1","title":"Raxol.Terminal.Window.UnifiedWindow.get_window_state/1","type":"function"},{"doc":"Moves a window to the specified position.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#move/3","title":"Raxol.Terminal.Window.UnifiedWindow.move/3","type":"function"},{"doc":"Resizes a window to the specified dimensions.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#resize/3","title":"Raxol.Terminal.Window.UnifiedWindow.resize/3","type":"function"},{"doc":"Sets the active window.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#set_active_window/1","title":"Raxol.Terminal.Window.UnifiedWindow.set_active_window/1","type":"function"},{"doc":"Sets the window icon name.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#set_icon_name/2","title":"Raxol.Terminal.Window.UnifiedWindow.set_icon_name/2","type":"function"},{"doc":"Maximizes or restores a window.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#set_maximized/2","title":"Raxol.Terminal.Window.UnifiedWindow.set_maximized/2","type":"function"},{"doc":"Sets the window's stacking order.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#set_stacking_order/2","title":"Raxol.Terminal.Window.UnifiedWindow.set_stacking_order/2","type":"function"},{"doc":"Sets the window title.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#set_title/2","title":"Raxol.Terminal.Window.UnifiedWindow.set_title/2","type":"function"},{"doc":"Splits an existing window in the specified direction.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#split_window/2","title":"Raxol.Terminal.Window.UnifiedWindow.split_window/2","type":"function"},{"doc":"Starts the window manager with optional configuration.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#start_link/1","title":"Raxol.Terminal.Window.UnifiedWindow.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Window.UnifiedWindow.html#t:t/0","title":"Raxol.Terminal.Window.UnifiedWindow.t/0","type":"type"},{"doc":"Updates the window manager configuration.","ref":"Raxol.Terminal.Window.UnifiedWindow.html#update_config/1","title":"Raxol.Terminal.Window.UnifiedWindow.update_config/1","type":"function"},{"doc":"","ref":"Raxol.Terminal.Window.UnifiedWindow.html#t:window_id/0","title":"Raxol.Terminal.Window.UnifiedWindow.window_id/0","type":"type"},{"doc":"","ref":"Raxol.Terminal.Window.UnifiedWindow.html#t:window_state/0","title":"Raxol.Terminal.Window.UnifiedWindow.window_state/0","type":"type"},{"doc":"Common assertion helpers for Raxol tests.\nProvides standardized assertions for components, events, and state.","ref":"Raxol.Test.AssertionHelpers.html","title":"Raxol.Test.AssertionHelpers","type":"module"},{"doc":"","ref":"Raxol.Test.AssertionHelpers.html#apply_theme/1","title":"Raxol.Test.AssertionHelpers.apply_theme/1","type":"function"},{"doc":"Asserts that a component properly handles errors.","ref":"Raxol.Test.AssertionHelpers.html#assert_error_handled/2","title":"Raxol.Test.AssertionHelpers.assert_error_handled/2","type":"function"},{"doc":"Asserts that a component received an event.","ref":"Raxol.Test.AssertionHelpers.html#assert_event_received/2","title":"Raxol.Test.AssertionHelpers.assert_event_received/2","type":"function"},{"doc":"Asserts that a component's render output matches a snapshot.","ref":"Raxol.Test.AssertionHelpers.html#assert_matches_snapshot/3","title":"Raxol.Test.AssertionHelpers.assert_matches_snapshot/3","type":"function"},{"doc":"Asserts that a component's render output matches expected text.","ref":"Raxol.Test.AssertionHelpers.html#assert_renders_with/2","title":"Raxol.Test.AssertionHelpers.assert_renders_with/2","type":"function"},{"doc":"Asserts that a component is responsive across different sizes.","ref":"Raxol.Test.AssertionHelpers.html#assert_responsive/2","title":"Raxol.Test.AssertionHelpers.assert_responsive/2","type":"function"},{"doc":"Asserts that a component's state matches expected values.","ref":"Raxol.Test.AssertionHelpers.html#assert_state_match/2","title":"Raxol.Test.AssertionHelpers.assert_state_match/2","type":"function"},{"doc":"Asserts that a component maintains consistent styling across themes.","ref":"Raxol.Test.AssertionHelpers.html#assert_theme_consistent/2","title":"Raxol.Test.AssertionHelpers.assert_theme_consistent/2","type":"function"},{"doc":"Asserts that a component did not receive an event.","ref":"Raxol.Test.AssertionHelpers.html#refute_event_received/2","title":"Raxol.Test.AssertionHelpers.refute_event_received/2","type":"function"},{"doc":"","ref":"Raxol.Test.ComponentManagerTestMocks.html","title":"Raxol.Test.ComponentManagerTestMocks","type":"module"},{"doc":"","ref":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent.html","title":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent","type":"module"},{"doc":"","ref":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent.html#handle_event/2","title":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent.handle_event/2","type":"function"},{"doc":"","ref":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent.html#handle_event_with_commands/2","title":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent.handle_event_with_commands/2","type":"function"},{"doc":"","ref":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent.html#init/1","title":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent.init/1","type":"function"},{"doc":"","ref":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent.html#mount/1","title":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent.mount/1","type":"function"},{"doc":"","ref":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent.html#mount_with_commands/1","title":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent.mount_with_commands/1","type":"function"},{"doc":"","ref":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent.html#unmount/1","title":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent.unmount/1","type":"function"},{"doc":"","ref":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent.html#update/2","title":"Raxol.Test.ComponentManagerTestMocks.Raxol.Core.Runtime.ComponentManagerTest.TestComponent.update/2","type":"function"},{"doc":"Helper functions for Emulator tests.","ref":"Raxol.Test.EmulatorHelpers.html","title":"Raxol.Test.EmulatorHelpers","type":"module"},{"doc":"Fills a region of the emulator buffer with identifiable line text.","ref":"Raxol.Test.EmulatorHelpers.html#fill_buffer/3","title":"Raxol.Test.EmulatorHelpers.fill_buffer/3","type":"function"},{"doc":"Retrieves the text content of a specific line from the emulator's active buffer.\nReplaces nil chars with spaces.","ref":"Raxol.Test.EmulatorHelpers.html#get_line_text/2","title":"Raxol.Test.EmulatorHelpers.get_line_text/2","type":"function"},{"doc":"Unwraps {:ok, value}, {:error, _, value}, or returns value if already a struct.\nUseful for safely extracting emulator or buffer structs from handler results.","ref":"Raxol.Test.EmulatorHelpers.html#unwrap_ok/1","title":"Raxol.Test.EmulatorHelpers.unwrap_ok/1","type":"function"},{"doc":"Event-based assertion helpers for ExUnit tests.\nProvides wrappers for assert_receive and refute_receive for event-driven code.","ref":"Raxol.Test.EventAssertions.html","title":"Raxol.Test.EventAssertions","type":"module"},{"doc":"Asserts that a message matching the given pattern is received within the timeout.","ref":"Raxol.Test.EventAssertions.html#assert_event_received/2","title":"Raxol.Test.EventAssertions.assert_event_received/2","type":"macro"},{"doc":"Refutes that a message matching the given pattern is received within the timeout.","ref":"Raxol.Test.EventAssertions.html#refute_event_received/2","title":"Raxol.Test.EventAssertions.refute_event_received/2","type":"macro"},{"doc":"Helpers for testing event handling in Raxol components.\nProvides utilities for simulating and verifying events.","ref":"Raxol.Test.EventHelpers.html","title":"Raxol.Test.EventHelpers","type":"module"},{"doc":"Asserts that a child component received an event from parent.","ref":"Raxol.Test.EventHelpers.html#assert_child_received/2","title":"Raxol.Test.EventHelpers.assert_child_received/2","type":"function"},{"doc":"Verifies that error handling works properly between components.","ref":"Raxol.Test.EventHelpers.html#assert_error_contained/3","title":"Raxol.Test.EventHelpers.assert_error_contained/3","type":"function"},{"doc":"Asserts that a parent component was updated after a child event.","ref":"Raxol.Test.EventHelpers.html#assert_parent_updated/2","title":"Raxol.Test.EventHelpers.assert_parent_updated/2","type":"function"},{"doc":"Verifies that state is synchronized between components.","ref":"Raxol.Test.EventHelpers.html#assert_state_synchronized/2","title":"Raxol.Test.EventHelpers.assert_state_synchronized/2","type":"function"},{"doc":"Verifies that a component properly handles system events.","ref":"Raxol.Test.EventHelpers.html#assert_system_events_handled/2","title":"Raxol.Test.EventHelpers.assert_system_events_handled/2","type":"function"},{"doc":"Simulates an event on a component.","ref":"Raxol.Test.EventHelpers.html#simulate_event/2","title":"Raxol.Test.EventHelpers.simulate_event/2","type":"function"},{"doc":"Simulates a user action on a component.","ref":"Raxol.Test.EventHelpers.html#simulate_user_action/2","title":"Raxol.Test.EventHelpers.simulate_user_action/2","type":"function"},{"doc":"Provides utilities for testing component interactions and system integration.\n\nThis module focuses on testing:\n- Multi-component interactions\n- Event propagation between components\n- State synchronization\n- Terminal I/O simulation\n- Component hierarchy behavior","ref":"Raxol.Test.Integration.html","title":"Raxol.Test.Integration","type":"module"},{"doc":"defmodule MyApp.IntegrationTest do\n      use ExUnit.Case\n      use Raxol.Test.Integration\n\n      test_scenario \"parent-child communication\", %{parent: Parent, child: Child} do\n        # Set up component hierarchy\n        {:ok, parent, child} = setup_component_hierarchy(Parent, Child)\n\n        # Simulate user interaction\n        simulate_user_action(parent, {:click, {10, 10}})\n\n        # Verify component interaction\n        assert_child_received(child, :parent_clicked)\n        assert_parent_updated(parent, :child_responded)\n      end\n    end","ref":"Raxol.Test.Integration.html#module-example","title":"Example - Raxol.Test.Integration","type":"module"},{"doc":"Verifies that a component properly handles a system event.","ref":"Raxol.Test.Integration.html#assert_handles_system_event/2","title":"Raxol.Test.Integration.assert_handles_system_event/2","type":"function"},{"doc":"Simulates component mounting in the application.","ref":"Raxol.Test.Integration.html#mount_component/2","title":"Raxol.Test.Integration.mount_component/2","type":"function"},{"doc":"Sets up a parent-child component hierarchy for testing.\n\nReturns the initialized parent and child components with proper event routing.","ref":"Raxol.Test.Integration.html#setup_component_hierarchy/3","title":"Raxol.Test.Integration.setup_component_hierarchy/3","type":"function"},{"doc":"Sets up a test scenario with multiple components.\n\nThis function:\n1. Initializes all components\n2. Sets up event routing\n3. Configures component relationships\n4. Establishes test monitoring","ref":"Raxol.Test.Integration.html#setup_test_scenario/1","title":"Raxol.Test.Integration.setup_test_scenario/1","type":"function"},{"doc":"Simulates a user action on a component.\n\nHandles various types of user interactions and ensures proper event propagation.","ref":"Raxol.Test.Integration.html#simulate_user_action/2","title":"Raxol.Test.Integration.simulate_user_action/2","type":"function"},{"doc":"","ref":"Raxol.Test.Integration.html#test_scenario/3","title":"Raxol.Test.Integration.test_scenario/3","type":"macro"},{"doc":"Simulates component unmounting from the application.","ref":"Raxol.Test.Integration.html#unmount_component/1","title":"Raxol.Test.Integration.unmount_component/1","type":"function"},{"doc":"Provides custom assertions for integration testing of Raxol components.\n\nThis module includes assertions for:\n- Component interaction verification\n- Event propagation validation\n- State synchronization checking\n- Command routing verification\n- Component lifecycle testing","ref":"Raxol.Test.Integration.Assertions.html","title":"Raxol.Test.Integration.Assertions","type":"module"},{"doc":"Asserts that a child component received an event from its parent.","ref":"Raxol.Test.Integration.Assertions.html#assert_child_received/2","title":"Raxol.Test.Integration.Assertions.assert_child_received/2","type":"function"},{"doc":"assert_child_received child, :parent_clicked","ref":"Raxol.Test.Integration.Assertions.html#assert_child_received/2-example","title":"Example - Raxol.Test.Integration.Assertions.assert_child_received/2","type":"function"},{"doc":"Asserts that commands are properly routed between components.","ref":"Raxol.Test.Integration.Assertions.html#assert_command_routing/3","title":"Raxol.Test.Integration.Assertions.assert_command_routing/3","type":"function"},{"doc":"assert_command_routing source, target, command","ref":"Raxol.Test.Integration.Assertions.html#assert_command_routing/3-example","title":"Example - Raxol.Test.Integration.Assertions.assert_command_routing/3","type":"function"},{"doc":"Asserts that error boundaries contain component failures.","ref":"Raxol.Test.Integration.Assertions.html#assert_error_contained/3","title":"Raxol.Test.Integration.Assertions.assert_error_contained/3","type":"function"},{"doc":"assert_error_contained parent, child, fn ->\n      simulate_user_action(child, :trigger_error)\n    end","ref":"Raxol.Test.Integration.Assertions.html#assert_error_contained/3-example","title":"Example - Raxol.Test.Integration.Assertions.assert_error_contained/3","type":"function"},{"doc":"Asserts that events are properly propagated through the component hierarchy.","ref":"Raxol.Test.Integration.Assertions.html#assert_event_propagation/3","title":"Raxol.Test.Integration.Assertions.assert_event_propagation/3","type":"function"},{"doc":"assert_event_propagation [parent, child1, child2], event, fn components ->\n      # Verify each component's response\n    end","ref":"Raxol.Test.Integration.Assertions.html#assert_event_propagation/3-example","title":"Example - Raxol.Test.Integration.Assertions.assert_event_propagation/3","type":"function"},{"doc":"Asserts that components are properly connected in a hierarchy.","ref":"Raxol.Test.Integration.Assertions.html#assert_hierarchy_valid/2","title":"Raxol.Test.Integration.Assertions.assert_hierarchy_valid/2","type":"function"},{"doc":"assert_hierarchy_valid parent, [child1, child2]","ref":"Raxol.Test.Integration.Assertions.html#assert_hierarchy_valid/2-example","title":"Example - Raxol.Test.Integration.Assertions.assert_hierarchy_valid/2","type":"function"},{"doc":"Asserts that a component properly handles mounting and unmounting.","ref":"Raxol.Test.Integration.Assertions.html#assert_lifecycle_handled/2","title":"Raxol.Test.Integration.Assertions.assert_lifecycle_handled/2","type":"function"},{"doc":"assert_lifecycle_handled component, fn comp ->\n      mount_component(comp)\n      # Test mounted state\n      unmount_component(comp)\n      # Test unmounted state\n    end","ref":"Raxol.Test.Integration.Assertions.html#assert_lifecycle_handled/2-example","title":"Example - Raxol.Test.Integration.Assertions.assert_lifecycle_handled/2","type":"function"},{"doc":"Asserts that a parent component was updated in response to a child event.","ref":"Raxol.Test.Integration.Assertions.html#assert_parent_updated/2","title":"Raxol.Test.Integration.Assertions.assert_parent_updated/2","type":"function"},{"doc":"assert_parent_updated parent, :child_responded","ref":"Raxol.Test.Integration.Assertions.html#assert_parent_updated/2-example","title":"Example - Raxol.Test.Integration.Assertions.assert_parent_updated/2","type":"function"},{"doc":"Asserts that component state is synchronized after interactions.","ref":"Raxol.Test.Integration.Assertions.html#assert_state_synchronized/2","title":"Raxol.Test.Integration.Assertions.assert_state_synchronized/2","type":"function"},{"doc":"assert_state_synchronized [comp1, comp2], fn states ->\n      Enum.all?(states, & &1.counter == 0)\n    end","ref":"Raxol.Test.Integration.Assertions.html#assert_state_synchronized/2-example","title":"Example - Raxol.Test.Integration.Assertions.assert_state_synchronized/2","type":"function"},{"doc":"Asserts that a component handles system events without corruption.","ref":"Raxol.Test.Integration.Assertions.html#assert_system_events_handled/2","title":"Raxol.Test.Integration.Assertions.assert_system_events_handled/2","type":"function"},{"doc":"assert_system_events_handled component, [:resize, :focus, :blur]","ref":"Raxol.Test.Integration.Assertions.html#assert_system_events_handled/2-example","title":"Example - Raxol.Test.Integration.Assertions.assert_system_events_handled/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockApplicationSupervisor.html","title":"Raxol.Test.MockApplicationSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Test.MockApplicationSupervisor.html#child_spec/1","title":"Raxol.Test.MockApplicationSupervisor.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Test.MockApplicationSupervisor.html#start_link/1","title":"Raxol.Test.MockApplicationSupervisor.start_link/1","type":"function"},{"doc":"A mock database adapter for testing purposes that implements all required Ecto adapter behaviors.","ref":"Raxol.Test.MockDB.html","title":"Raxol.Test.MockDB","type":"module"},{"doc":"Callback implementation for  Ecto.Adapter.Schema.autogenerate/1 .","ref":"Raxol.Test.MockDB.html#autogenerate/1","title":"Raxol.Test.MockDB.autogenerate/1","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.checked_out?/1 .","ref":"Raxol.Test.MockDB.html#checked_out?/1","title":"Raxol.Test.MockDB.checked_out?/1","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.checkout/3 .","ref":"Raxol.Test.MockDB.html#checkout/3","title":"Raxol.Test.MockDB.checkout/3","type":"function"},{"doc":"","ref":"Raxol.Test.MockDB.html#child_spec/1","title":"Raxol.Test.MockDB.child_spec/1","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.Schema.delete/5 .","ref":"Raxol.Test.MockDB.html#delete/5","title":"Raxol.Test.MockDB.delete/5","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.dumpers/2 .","ref":"Raxol.Test.MockDB.html#dumpers/2","title":"Raxol.Test.MockDB.dumpers/2","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.ensure_all_started/2 .","ref":"Raxol.Test.MockDB.html#ensure_all_started/2","title":"Raxol.Test.MockDB.ensure_all_started/2","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.Queryable.execute/5 .","ref":"Raxol.Test.MockDB.html#execute/5","title":"Raxol.Test.MockDB.execute/5","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.Migration.execute_ddl/3 .","ref":"Raxol.Test.MockDB.html#execute_ddl/3","title":"Raxol.Test.MockDB.execute_ddl/3","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.init/1 .","ref":"Raxol.Test.MockDB.html#init/1","title":"Raxol.Test.MockDB.init/1","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.Schema.insert/6 .","ref":"Raxol.Test.MockDB.html#insert/6","title":"Raxol.Test.MockDB.insert/6","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.Schema.insert_all/8 .","ref":"Raxol.Test.MockDB.html#insert_all/8","title":"Raxol.Test.MockDB.insert_all/8","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.loaders/2 .","ref":"Raxol.Test.MockDB.html#loaders/2","title":"Raxol.Test.MockDB.loaders/2","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.Migration.lock_for_migrations/3 .","ref":"Raxol.Test.MockDB.html#lock_for_migrations/3","title":"Raxol.Test.MockDB.lock_for_migrations/3","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.Queryable.prepare/2 .","ref":"Raxol.Test.MockDB.html#prepare/2","title":"Raxol.Test.MockDB.prepare/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockDB.html#rollback/2","title":"Raxol.Test.MockDB.rollback/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockDB.html#start_link/1","title":"Raxol.Test.MockDB.start_link/1","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.Storage.storage_down/1 .","ref":"Raxol.Test.MockDB.html#storage_down/1","title":"Raxol.Test.MockDB.storage_down/1","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.Storage.storage_status/1 .","ref":"Raxol.Test.MockDB.html#storage_status/1","title":"Raxol.Test.MockDB.storage_status/1","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.Storage.storage_up/1 .","ref":"Raxol.Test.MockDB.html#storage_up/1","title":"Raxol.Test.MockDB.storage_up/1","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.Queryable.stream/5 .","ref":"Raxol.Test.MockDB.html#stream/5","title":"Raxol.Test.MockDB.stream/5","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.Migration.supports_ddl_transaction?/0 .","ref":"Raxol.Test.MockDB.html#supports_ddl_transaction?/0","title":"Raxol.Test.MockDB.supports_ddl_transaction?/0","type":"function"},{"doc":"","ref":"Raxol.Test.MockDB.html#transaction/3","title":"Raxol.Test.MockDB.transaction/3","type":"function"},{"doc":"Callback implementation for  Ecto.Adapter.Schema.update/6 .","ref":"Raxol.Test.MockDB.html#update/6","title":"Raxol.Test.MockDB.update/6","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.html","title":"Raxol.Test.MockPlugins","type":"module"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockCommandPlugin.html","title":"Raxol.Test.MockPlugins.MockCommandPlugin","type":"module"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.MockPlugins.MockCommandPlugin.html#disable/1","title":"Raxol.Test.MockPlugins.MockCommandPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.MockPlugins.MockCommandPlugin.html#enable/1","title":"Raxol.Test.MockPlugins.MockCommandPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.MockPlugins.MockCommandPlugin.html#filter_event/2","title":"Raxol.Test.MockPlugins.MockCommandPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.MockPlugins.MockCommandPlugin.html#get_commands/0","title":"Raxol.Test.MockPlugins.MockCommandPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.MockPlugins.MockCommandPlugin.html#handle_command/3","title":"Raxol.Test.MockPlugins.MockCommandPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockCommandPlugin.html#handle_custom_event/3","title":"Raxol.Test.MockPlugins.MockCommandPlugin.handle_custom_event/3","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockCommandPlugin.html#handle_input/2","title":"Raxol.Test.MockPlugins.MockCommandPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockCommandPlugin.html#handle_mouse_event/2","title":"Raxol.Test.MockPlugins.MockCommandPlugin.handle_mouse_event/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockCommandPlugin.html#handle_output/2","title":"Raxol.Test.MockPlugins.MockCommandPlugin.handle_output/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockCommandPlugin.html#handle_terminal_event/3","title":"Raxol.Test.MockPlugins.MockCommandPlugin.handle_terminal_event/3","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.MockPlugins.MockCommandPlugin.html#init/1","title":"Raxol.Test.MockPlugins.MockCommandPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.MockPlugins.MockCommandPlugin.html#terminate/2","title":"Raxol.Test.MockPlugins.MockCommandPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockCrashyPlugin.html","title":"Raxol.Test.MockPlugins.MockCrashyPlugin","type":"module"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.MockPlugins.MockCrashyPlugin.html#disable/1","title":"Raxol.Test.MockPlugins.MockCrashyPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.MockPlugins.MockCrashyPlugin.html#enable/1","title":"Raxol.Test.MockPlugins.MockCrashyPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.MockPlugins.MockCrashyPlugin.html#filter_event/2","title":"Raxol.Test.MockPlugins.MockCrashyPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.MockPlugins.MockCrashyPlugin.html#get_commands/0","title":"Raxol.Test.MockPlugins.MockCrashyPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.MockPlugins.MockCrashyPlugin.html#handle_command/3","title":"Raxol.Test.MockPlugins.MockCrashyPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockCrashyPlugin.html#handle_custom_event/3","title":"Raxol.Test.MockPlugins.MockCrashyPlugin.handle_custom_event/3","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockCrashyPlugin.html#handle_input/2","title":"Raxol.Test.MockPlugins.MockCrashyPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockCrashyPlugin.html#handle_mouse_event/2","title":"Raxol.Test.MockPlugins.MockCrashyPlugin.handle_mouse_event/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockCrashyPlugin.html#handle_output/2","title":"Raxol.Test.MockPlugins.MockCrashyPlugin.handle_output/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockCrashyPlugin.html#handle_terminal_event/3","title":"Raxol.Test.MockPlugins.MockCrashyPlugin.handle_terminal_event/3","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.MockPlugins.MockCrashyPlugin.html#init/1","title":"Raxol.Test.MockPlugins.MockCrashyPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.MockPlugins.MockCrashyPlugin.html#terminate/2","title":"Raxol.Test.MockPlugins.MockCrashyPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockDependencyPlugin.html","title":"Raxol.Test.MockPlugins.MockDependencyPlugin","type":"module"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.MockPlugins.MockDependencyPlugin.html#disable/1","title":"Raxol.Test.MockPlugins.MockDependencyPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.MockPlugins.MockDependencyPlugin.html#enable/1","title":"Raxol.Test.MockPlugins.MockDependencyPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.MockPlugins.MockDependencyPlugin.html#filter_event/2","title":"Raxol.Test.MockPlugins.MockDependencyPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.MockPlugins.MockDependencyPlugin.html#get_commands/0","title":"Raxol.Test.MockPlugins.MockDependencyPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.MockPlugins.MockDependencyPlugin.html#handle_command/3","title":"Raxol.Test.MockPlugins.MockDependencyPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockDependencyPlugin.html#handle_input/2","title":"Raxol.Test.MockPlugins.MockDependencyPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockDependencyPlugin.html#handle_output/2","title":"Raxol.Test.MockPlugins.MockDependencyPlugin.handle_output/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.MockPlugins.MockDependencyPlugin.html#init/1","title":"Raxol.Test.MockPlugins.MockDependencyPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.MockPlugins.MockDependencyPlugin.html#terminate/2","title":"Raxol.Test.MockPlugins.MockDependencyPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockDependentPlugin.html","title":"Raxol.Test.MockPlugins.MockDependentPlugin","type":"module"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.MockPlugins.MockDependentPlugin.html#disable/1","title":"Raxol.Test.MockPlugins.MockDependentPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.MockPlugins.MockDependentPlugin.html#enable/1","title":"Raxol.Test.MockPlugins.MockDependentPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.MockPlugins.MockDependentPlugin.html#filter_event/2","title":"Raxol.Test.MockPlugins.MockDependentPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.MockPlugins.MockDependentPlugin.html#get_commands/0","title":"Raxol.Test.MockPlugins.MockDependentPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.MockPlugins.MockDependentPlugin.html#handle_command/3","title":"Raxol.Test.MockPlugins.MockDependentPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockDependentPlugin.html#handle_input/2","title":"Raxol.Test.MockPlugins.MockDependentPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockDependentPlugin.html#handle_output/2","title":"Raxol.Test.MockPlugins.MockDependentPlugin.handle_output/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.MockPlugins.MockDependentPlugin.html#init/1","title":"Raxol.Test.MockPlugins.MockDependentPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.MockPlugins.MockDependentPlugin.html#terminate/2","title":"Raxol.Test.MockPlugins.MockDependentPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.html","title":"Raxol.Test.MockPlugins.MockEventConsumingPlugin","type":"module"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.html#disable/1","title":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.html#enable/1","title":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.html#filter_event/2","title":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.html#get_commands/0","title":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.html#handle_command/3","title":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.html#handle_custom_event/3","title":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.handle_custom_event/3","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.html#handle_input/2","title":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.html#handle_mouse_event/2","title":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.handle_mouse_event/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.html#handle_output/2","title":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.handle_output/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.html#handle_terminal_event/3","title":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.handle_terminal_event/3","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.html#init/1","title":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.html#terminate/2","title":"Raxol.Test.MockPlugins.MockEventConsumingPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.html","title":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin","type":"module"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.html#disable/1","title":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.html#enable/1","title":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.html#filter_event/2","title":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.html#get_commands/0","title":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.html#handle_command/3","title":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.html#handle_input/2","title":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.html#handle_output/2","title":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.handle_output/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.html#init/1","title":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.html#terminate/2","title":"Raxol.Test.MockPlugins.MockIncompatibleVersionPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.html","title":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin","type":"module"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.html#disable/1","title":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.html#enable/1","title":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.html#filter_event/2","title":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.html#get_commands/0","title":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.html#handle_command/3","title":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.html#handle_custom_event/3","title":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.handle_custom_event/3","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.html#handle_input/2","title":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.html#handle_mouse_event/2","title":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.handle_mouse_event/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.html#handle_output/2","title":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.handle_output/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.html#handle_terminal_event/3","title":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.handle_terminal_event/3","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.html#init/1","title":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.html#terminate/2","title":"Raxol.Test.MockPlugins.MockOnInitCrashPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.html","title":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin","type":"module"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.html#disable/1","title":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.html#enable/1","title":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.html#filter_event/2","title":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.html#get_commands/0","title":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.html#handle_command/3","title":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.html#handle_custom_event/3","title":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.handle_custom_event/3","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.html#handle_input/2","title":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.html#handle_mouse_event/2","title":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.handle_mouse_event/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.html#handle_output/2","title":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.handle_output/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.html#handle_terminal_event/3","title":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.handle_terminal_event/3","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.html#init/1","title":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.html#terminate/2","title":"Raxol.Test.MockPlugins.MockOnTerminateCrashPlugin.terminate/2","type":"function"},{"doc":"Mock implementation of rrex_termbox v2.0.1 for testing environments.\n\nThis module provides stub implementations of all rrex_termbox NIF-based functions\nto allow tests to run in CI environments where a real TTY may not be available.","ref":"Raxol.Test.MockTermbox.html","title":"Raxol.Test.MockTermbox","type":"module"},{"doc":"","ref":"Raxol.Test.MockTermbox.html#change_cell/6","title":"Raxol.Test.MockTermbox.change_cell/6","type":"function"},{"doc":"","ref":"Raxol.Test.MockTermbox.html#clear/1","title":"Raxol.Test.MockTermbox.clear/1","type":"function"},{"doc":"","ref":"Raxol.Test.MockTermbox.html#height/1","title":"Raxol.Test.MockTermbox.height/1","type":"function"},{"doc":"","ref":"Raxol.Test.MockTermbox.html#init/1","title":"Raxol.Test.MockTermbox.init/1","type":"function"},{"doc":"","ref":"Raxol.Test.MockTermbox.html#present/1","title":"Raxol.Test.MockTermbox.present/1","type":"function"},{"doc":"","ref":"Raxol.Test.MockTermbox.html#select_input_mode/2","title":"Raxol.Test.MockTermbox.select_input_mode/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockTermbox.html#set_cell/5","title":"Raxol.Test.MockTermbox.set_cell/5","type":"function"},{"doc":"","ref":"Raxol.Test.MockTermbox.html#set_cursor/3","title":"Raxol.Test.MockTermbox.set_cursor/3","type":"function"},{"doc":"","ref":"Raxol.Test.MockTermbox.html#set_output_mode/2","title":"Raxol.Test.MockTermbox.set_output_mode/2","type":"function"},{"doc":"","ref":"Raxol.Test.MockTermbox.html#shutdown/1","title":"Raxol.Test.MockTermbox.shutdown/1","type":"function"},{"doc":"","ref":"Raxol.Test.MockTermbox.html#size/0","title":"Raxol.Test.MockTermbox.size/0","type":"function"},{"doc":"","ref":"Raxol.Test.MockTermbox.html#start_link/0","title":"Raxol.Test.MockTermbox.start_link/0","type":"function"},{"doc":"","ref":"Raxol.Test.MockTermbox.html#subscribe/0","title":"Raxol.Test.MockTermbox.subscribe/0","type":"function"},{"doc":"","ref":"Raxol.Test.MockTermbox.html#unsubscribe/0","title":"Raxol.Test.MockTermbox.unsubscribe/0","type":"function"},{"doc":"","ref":"Raxol.Test.MockTermbox.html#width/1","title":"Raxol.Test.MockTermbox.width/1","type":"function"},{"doc":"Provides utilities for performance testing of Raxol components.\n\nThis module includes:\n- Render time benchmarking\n- Memory usage profiling\n- Event handling latency testing\n- Resource utilization tracking","ref":"Raxol.Test.Performance.html","title":"Raxol.Test.Performance","type":"module"},{"doc":"Measures event handling latency.","ref":"Raxol.Test.Performance.html#measure_event_latency/2","title":"Raxol.Test.Performance.measure_event_latency/2","type":"function"},{"doc":"Measures memory usage during component operations.","ref":"Raxol.Test.Performance.html#measure_memory_usage/2","title":"Raxol.Test.Performance.measure_memory_usage/2","type":"function"},{"doc":"Measures the time taken to render a component multiple times.","ref":"Raxol.Test.Performance.html#measure_render_time/2","title":"Raxol.Test.Performance.measure_render_time/2","type":"function"},{"doc":"Runs a benchmark suite for a component.","ref":"Raxol.Test.Performance.html#run_benchmark_suite/1","title":"Raxol.Test.Performance.run_benchmark_suite/1","type":"function"},{"doc":"Sets up a component for performance testing with benchmark configuration.","ref":"Raxol.Test.Performance.html#setup_benchmark_component/2","title":"Raxol.Test.Performance.setup_benchmark_component/2","type":"function"},{"doc":"Tracks resource utilization over time.","ref":"Raxol.Test.Performance.html#track_resource_utilization/2","title":"Raxol.Test.Performance.track_resource_utilization/2","type":"function"},{"doc":"Provides assertions for performance testing of Raxol components.\n\nThis module includes assertions for:\n- Render time thresholds\n- Memory usage limits\n- Event latency requirements\n- Resource utilization bounds","ref":"Raxol.Test.Performance.Assertions.html","title":"Raxol.Test.Performance.Assertions","type":"module"},{"doc":"Asserts that event handling latency stays within acceptable bounds.","ref":"Raxol.Test.Performance.Assertions.html#assert_event_latency/3","title":"Raxol.Test.Performance.Assertions.assert_event_latency/3","type":"function"},{"doc":"assert_event_latency component, :click, under: 10 # milliseconds","ref":"Raxol.Test.Performance.Assertions.html#assert_event_latency/3-example","title":"Example - Raxol.Test.Performance.Assertions.assert_event_latency/3","type":"function"},{"doc":"Asserts that a component's memory usage stays within specified limits.","ref":"Raxol.Test.Performance.Assertions.html#assert_memory_usage/3","title":"Raxol.Test.Performance.Assertions.assert_memory_usage/3","type":"function"},{"doc":"assert_memory_usage component, fn ->\n      render_with_large_dataset(component)\n    end, under: 1024 * 1024 # 1MB","ref":"Raxol.Test.Performance.Assertions.html#assert_memory_usage/3-example","title":"Example - Raxol.Test.Performance.Assertions.assert_memory_usage/3","type":"function"},{"doc":"Asserts that a component's performance hasn't regressed from baseline.","ref":"Raxol.Test.Performance.Assertions.html#assert_no_performance_regression/2","title":"Raxol.Test.Performance.Assertions.assert_no_performance_regression/2","type":"function"},{"doc":"assert_no_performance_regression component, \"button_baseline\"","ref":"Raxol.Test.Performance.Assertions.html#assert_no_performance_regression/2-example","title":"Example - Raxol.Test.Performance.Assertions.assert_no_performance_regression/2","type":"function"},{"doc":"Asserts that a component's performance metrics meet all requirements.","ref":"Raxol.Test.Performance.Assertions.html#assert_performance_requirements/2","title":"Raxol.Test.Performance.Assertions.assert_performance_requirements/2","type":"function"},{"doc":"assert_performance_requirements component, %{\n      render_time: 100,\n      memory_usage: 1024 * 1024,\n      event_latency: 10\n    }","ref":"Raxol.Test.Performance.Assertions.html#assert_performance_requirements/2-example","title":"Example - Raxol.Test.Performance.Assertions.assert_performance_requirements/2","type":"function"},{"doc":"Asserts that a component renders within a specified time limit.","ref":"Raxol.Test.Performance.Assertions.html#assert_render_time/3","title":"Raxol.Test.Performance.Assertions.assert_render_time/3","type":"function"},{"doc":"assert_render_time component, fn ->\n      render_iterations(component, 1000)\n    end, under: 100 # milliseconds","ref":"Raxol.Test.Performance.Assertions.html#assert_render_time/3-example","title":"Example - Raxol.Test.Performance.Assertions.assert_render_time/3","type":"function"},{"doc":"Asserts that a component's resource utilization remains stable.","ref":"Raxol.Test.Performance.Assertions.html#assert_stable_resource_usage/2","title":"Raxol.Test.Performance.Assertions.assert_stable_resource_usage/2","type":"function"},{"doc":"assert_stable_resource_usage component, duration: 1000","ref":"Raxol.Test.Performance.Assertions.html#assert_stable_resource_usage/2-example","title":"Example - Raxol.Test.Performance.Assertions.assert_stable_resource_usage/2","type":"function"},{"doc":"Provides utilities for performance testing and benchmarking in Raxol.\n\nThis module includes:\n- Benchmarking utilities\n- Performance test setup and teardown\n- Common performance test scenarios\n- Metrics collection and reporting","ref":"Raxol.Test.PerformanceHelper.html","title":"Raxol.Test.PerformanceHelper","type":"module"},{"doc":"Asserts that a set of concurrent operations' average execution time is below a threshold.","ref":"Raxol.Test.PerformanceHelper.html#assert_concurrent_performance/4","title":"Raxol.Test.PerformanceHelper.assert_concurrent_performance/4","type":"function"},{"doc":"Asserts that an operation's memory usage is below a threshold.","ref":"Raxol.Test.PerformanceHelper.html#assert_memory_usage/3","title":"Raxol.Test.PerformanceHelper.assert_memory_usage/3","type":"function"},{"doc":"Asserts that an operation's average execution time is below a threshold.\nUse this for direct operation timing, not for benchmark result structs.","ref":"Raxol.Test.PerformanceHelper.html#assert_operation_performance/4","title":"Raxol.Test.PerformanceHelper.assert_operation_performance/4","type":"function"},{"doc":"Asserts that a benchmark meets performance requirements.","ref":"Raxol.Test.PerformanceHelper.html#assert_performance/2","title":"Raxol.Test.PerformanceHelper.assert_performance/2","type":"function"},{"doc":"* `:max_average_time` - Maximum allowed average time in microseconds\n  * `:max_p95_time` - Maximum allowed 95th percentile time in microseconds\n  * `:min_iterations` - Minimum number of iterations required","ref":"Raxol.Test.PerformanceHelper.html#assert_performance/2-options","title":"Options - Raxol.Test.PerformanceHelper.assert_performance/2","type":"function"},{"doc":"Measures and asserts both time and memory performance.","ref":"Raxol.Test.PerformanceHelper.html#assert_performance_metrics/4","title":"Raxol.Test.PerformanceHelper.assert_performance_metrics/4","type":"function"},{"doc":"Runs a benchmark with the given function and options.","ref":"Raxol.Test.PerformanceHelper.html#benchmark/2","title":"Raxol.Test.PerformanceHelper.benchmark/2","type":"function"},{"doc":"* `:iterations` - Number of iterations to run (default: 1000)\n  * `:warmup` - Number of warmup iterations (default: 100)\n  * `:timeout` - Maximum time to run in milliseconds (default: 5000)","ref":"Raxol.Test.PerformanceHelper.html#benchmark/2-options","title":"Options - Raxol.Test.PerformanceHelper.benchmark/2","type":"function"},{"doc":"Calculates the nth percentile from a list of times.","ref":"Raxol.Test.PerformanceHelper.html#calculate_percentile/2","title":"Raxol.Test.PerformanceHelper.calculate_percentile/2","type":"function"},{"doc":"Formats benchmark results for human-readable output.","ref":"Raxol.Test.PerformanceHelper.html#format_benchmark_results/1","title":"Raxol.Test.PerformanceHelper.format_benchmark_results/1","type":"function"},{"doc":"Measures the average execution time of an operation over multiple iterations.\nReturns the average time in milliseconds.","ref":"Raxol.Test.PerformanceHelper.html#measure_average_time/2","title":"Raxol.Test.PerformanceHelper.measure_average_time/2","type":"function"},{"doc":"Measures memory usage of an operation.\nReturns {memory_in_bytes, result}.","ref":"Raxol.Test.PerformanceHelper.html#measure_memory/1","title":"Raxol.Test.PerformanceHelper.measure_memory/1","type":"function"},{"doc":"Measures the execution time of an operation.\nReturns {time_in_ms, result}.","ref":"Raxol.Test.PerformanceHelper.html#measure_time/1","title":"Raxol.Test.PerformanceHelper.measure_time/1","type":"function"},{"doc":"Sets up a test environment optimized for performance testing.\n\nReturns a context map with initialized services and performance monitoring.","ref":"Raxol.Test.PerformanceHelper.html#setup_performance_test_env/0","title":"Raxol.Test.PerformanceHelper.setup_performance_test_env/0","type":"function"},{"doc":"Provides large sample data and data generation helpers for performance tests.","ref":"Raxol.Test.PerformanceTestData.html","title":"Raxol.Test.PerformanceTestData","type":"module"},{"doc":"","ref":"Raxol.Test.PerformanceTestData.html#generate_columns/1","title":"Raxol.Test.PerformanceTestData.generate_columns/1","type":"function"},{"doc":"","ref":"Raxol.Test.PerformanceTestData.html#generate_data/3","title":"Raxol.Test.PerformanceTestData.generate_data/3","type":"function"},{"doc":"","ref":"Raxol.Test.PerformanceTestData.html#large_data/0","title":"Raxol.Test.PerformanceTestData.large_data/0","type":"function"},{"doc":"Provides helper functions for generating complex view structures for performance tests.","ref":"Raxol.Test.PerformanceViewGenerators.html","title":"Raxol.Test.PerformanceViewGenerators","type":"module"},{"doc":"","ref":"Raxol.Test.PerformanceViewGenerators.html#count_nested_views/1","title":"Raxol.Test.PerformanceViewGenerators.count_nested_views/1","type":"function"},{"doc":"","ref":"Raxol.Test.PerformanceViewGenerators.html#create_chart_animation_frames/1","title":"Raxol.Test.PerformanceViewGenerators.create_chart_animation_frames/1","type":"function"},{"doc":"","ref":"Raxol.Test.PerformanceViewGenerators.html#create_configurable_test_layout/1","title":"Raxol.Test.PerformanceViewGenerators.create_configurable_test_layout/1","type":"function"},{"doc":"","ref":"Raxol.Test.PerformanceViewGenerators.html#create_nested_structure/2","title":"Raxol.Test.PerformanceViewGenerators.create_nested_structure/2","type":"function"},{"doc":"","ref":"Raxol.Test.PerformanceViewGenerators.html#create_progress_bar_frames/1","title":"Raxol.Test.PerformanceViewGenerators.create_progress_bar_frames/1","type":"function"},{"doc":"","ref":"Raxol.Test.PerformanceViewGenerators.html#create_simple_table/2","title":"Raxol.Test.PerformanceViewGenerators.create_simple_table/2","type":"function"},{"doc":"","ref":"Raxol.Test.PerformanceViewGenerators.html#create_spinner_frames/1","title":"Raxol.Test.PerformanceViewGenerators.create_spinner_frames/1","type":"function"},{"doc":"","ref":"Raxol.Test.PerformanceViewGenerators.html#update_some_data/2","title":"Raxol.Test.PerformanceViewGenerators.update_some_data/2","type":"function"},{"doc":"Test fixtures for plugin-related tests.\n\nEach plugin in this module is designed to be isolated and self-contained,\nwith clear state management and error handling. Plugins are designed to be\nused in parallel test runs without interference.","ref":"Raxol.Test.PluginTestFixtures.html","title":"Raxol.Test.PluginTestFixtures","type":"module"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.html#create_unique_state/0","title":"Raxol.Test.PluginTestFixtures.create_unique_state/0","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.html","title":"Raxol.Test.PluginTestFixtures.BadReturnPlugin","type":"module"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.html#disable/1","title":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.html#enable/1","title":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.html#filter_event/2","title":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.html#get_commands/0","title":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.PluginMetadataProvider.get_metadata/0 .","ref":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.html#get_metadata/0","title":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.get_metadata/0","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.html#handle_bad_return_cmd/2","title":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.handle_bad_return_cmd/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.html#handle_command/3","title":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.html#handle_input/2","title":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.html#handle_output/2","title":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.handle_output/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.html#handle_test_cmd/2","title":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.handle_test_cmd/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.html#init/1","title":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.html#terminate/2","title":"Raxol.Test.PluginTestFixtures.BadReturnPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.BrokenPlugin.html","title":"Raxol.Test.PluginTestFixtures.BrokenPlugin","type":"module"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.PluginTestFixtures.BrokenPlugin.html#disable/1","title":"Raxol.Test.PluginTestFixtures.BrokenPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.PluginTestFixtures.BrokenPlugin.html#enable/1","title":"Raxol.Test.PluginTestFixtures.BrokenPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.PluginTestFixtures.BrokenPlugin.html#filter_event/2","title":"Raxol.Test.PluginTestFixtures.BrokenPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.PluginTestFixtures.BrokenPlugin.html#get_commands/0","title":"Raxol.Test.PluginTestFixtures.BrokenPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.PluginMetadataProvider.get_metadata/0 .","ref":"Raxol.Test.PluginTestFixtures.BrokenPlugin.html#get_metadata/0","title":"Raxol.Test.PluginTestFixtures.BrokenPlugin.get_metadata/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.PluginTestFixtures.BrokenPlugin.html#handle_command/3","title":"Raxol.Test.PluginTestFixtures.BrokenPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.BrokenPlugin.html#handle_input/2","title":"Raxol.Test.PluginTestFixtures.BrokenPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.BrokenPlugin.html#handle_output/2","title":"Raxol.Test.PluginTestFixtures.BrokenPlugin.handle_output/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.PluginTestFixtures.BrokenPlugin.html#init/1","title":"Raxol.Test.PluginTestFixtures.BrokenPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.PluginTestFixtures.BrokenPlugin.html#terminate/2","title":"Raxol.Test.PluginTestFixtures.BrokenPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.html","title":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin","type":"module"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.html#dependencies/0","title":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.dependencies/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.html#disable/1","title":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.html#enable/1","title":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.html#filter_event/2","title":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.html#get_commands/0","title":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.PluginMetadataProvider.get_metadata/0 .","ref":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.html#get_metadata/0","title":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.get_metadata/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.html#handle_command/3","title":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.html#handle_input/2","title":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.html#handle_output/2","title":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.handle_output/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.html#id/0","title":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.id/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.html#init/1","title":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.html#terminate/2","title":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.html#version/0","title":"Raxol.Test.PluginTestFixtures.CircularDependencyPlugin.version/0","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.CrashPlugin.html","title":"Raxol.Test.PluginTestFixtures.CrashPlugin","type":"module"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.PluginTestFixtures.CrashPlugin.html#disable/1","title":"Raxol.Test.PluginTestFixtures.CrashPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.PluginTestFixtures.CrashPlugin.html#enable/1","title":"Raxol.Test.PluginTestFixtures.CrashPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.PluginTestFixtures.CrashPlugin.html#filter_event/2","title":"Raxol.Test.PluginTestFixtures.CrashPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.PluginTestFixtures.CrashPlugin.html#get_commands/0","title":"Raxol.Test.PluginTestFixtures.CrashPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.PluginMetadataProvider.get_metadata/0 .","ref":"Raxol.Test.PluginTestFixtures.CrashPlugin.html#get_metadata/0","title":"Raxol.Test.PluginTestFixtures.CrashPlugin.get_metadata/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.PluginTestFixtures.CrashPlugin.html#handle_command/3","title":"Raxol.Test.PluginTestFixtures.CrashPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.CrashPlugin.html#handle_input/2","title":"Raxol.Test.PluginTestFixtures.CrashPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.CrashPlugin.html#handle_input_crash/2","title":"Raxol.Test.PluginTestFixtures.CrashPlugin.handle_input_crash/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.CrashPlugin.html#handle_output/2","title":"Raxol.Test.PluginTestFixtures.CrashPlugin.handle_output/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.CrashPlugin.html#handle_output_crash/2","title":"Raxol.Test.PluginTestFixtures.CrashPlugin.handle_output_crash/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.PluginTestFixtures.CrashPlugin.html#init/1","title":"Raxol.Test.PluginTestFixtures.CrashPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.PluginTestFixtures.CrashPlugin.html#terminate/2","title":"Raxol.Test.PluginTestFixtures.CrashPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.DependentPlugin.html","title":"Raxol.Test.PluginTestFixtures.DependentPlugin","type":"module"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.DependentPlugin.html#dependencies/0","title":"Raxol.Test.PluginTestFixtures.DependentPlugin.dependencies/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.PluginTestFixtures.DependentPlugin.html#disable/1","title":"Raxol.Test.PluginTestFixtures.DependentPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.PluginTestFixtures.DependentPlugin.html#enable/1","title":"Raxol.Test.PluginTestFixtures.DependentPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.PluginTestFixtures.DependentPlugin.html#filter_event/2","title":"Raxol.Test.PluginTestFixtures.DependentPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.PluginTestFixtures.DependentPlugin.html#get_commands/0","title":"Raxol.Test.PluginTestFixtures.DependentPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.PluginMetadataProvider.get_metadata/0 .","ref":"Raxol.Test.PluginTestFixtures.DependentPlugin.html#get_metadata/0","title":"Raxol.Test.PluginTestFixtures.DependentPlugin.get_metadata/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.PluginTestFixtures.DependentPlugin.html#handle_command/3","title":"Raxol.Test.PluginTestFixtures.DependentPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.DependentPlugin.html#handle_input/2","title":"Raxol.Test.PluginTestFixtures.DependentPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.DependentPlugin.html#handle_output/2","title":"Raxol.Test.PluginTestFixtures.DependentPlugin.handle_output/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.DependentPlugin.html#id/0","title":"Raxol.Test.PluginTestFixtures.DependentPlugin.id/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.PluginTestFixtures.DependentPlugin.html#init/1","title":"Raxol.Test.PluginTestFixtures.DependentPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.PluginTestFixtures.DependentPlugin.html#terminate/2","title":"Raxol.Test.PluginTestFixtures.DependentPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.DependentPlugin.html#version/0","title":"Raxol.Test.PluginTestFixtures.DependentPlugin.version/0","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.html","title":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin","type":"module"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.html#dependencies/0","title":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.dependencies/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.html#disable/1","title":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.html#enable/1","title":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.html#filter_event/2","title":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.html#get_commands/0","title":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.PluginMetadataProvider.get_metadata/0 .","ref":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.html#get_metadata/0","title":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.get_metadata/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.html#handle_command/3","title":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.html#handle_input/2","title":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.html#handle_output/2","title":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.handle_output/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.html#id/0","title":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.id/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.html#init/1","title":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.html#terminate/2","title":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.html#version/0","title":"Raxol.Test.PluginTestFixtures.InvalidMetadataPlugin.version/0","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.TestPlugin.html","title":"Raxol.Test.PluginTestFixtures.TestPlugin","type":"module"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.PluginTestFixtures.TestPlugin.html#disable/1","title":"Raxol.Test.PluginTestFixtures.TestPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.PluginTestFixtures.TestPlugin.html#enable/1","title":"Raxol.Test.PluginTestFixtures.TestPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.PluginTestFixtures.TestPlugin.html#filter_event/2","title":"Raxol.Test.PluginTestFixtures.TestPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.PluginTestFixtures.TestPlugin.html#get_commands/0","title":"Raxol.Test.PluginTestFixtures.TestPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.PluginMetadataProvider.get_metadata/0 .","ref":"Raxol.Test.PluginTestFixtures.TestPlugin.html#get_metadata/0","title":"Raxol.Test.PluginTestFixtures.TestPlugin.get_metadata/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.PluginTestFixtures.TestPlugin.html#handle_command/3","title":"Raxol.Test.PluginTestFixtures.TestPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.TestPlugin.html#handle_input/2","title":"Raxol.Test.PluginTestFixtures.TestPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.TestPlugin.html#handle_output/2","title":"Raxol.Test.PluginTestFixtures.TestPlugin.handle_output/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.TestPlugin.html#handle_test_cmd/2","title":"Raxol.Test.PluginTestFixtures.TestPlugin.handle_test_cmd/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.PluginTestFixtures.TestPlugin.html#init/1","title":"Raxol.Test.PluginTestFixtures.TestPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.PluginTestFixtures.TestPlugin.html#terminate/2","title":"Raxol.Test.PluginTestFixtures.TestPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.html","title":"Raxol.Test.PluginTestFixtures.TimeoutPlugin","type":"module"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.html#disable/1","title":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.html#enable/1","title":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.html#filter_event/2","title":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.html#get_commands/0","title":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.PluginMetadataProvider.get_metadata/0 .","ref":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.html#get_metadata/0","title":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.get_metadata/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.html#handle_command/3","title":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.html#handle_input/2","title":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.html#handle_output/2","title":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.handle_output/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.html#init/1","title":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.html#terminate/2","title":"Raxol.Test.PluginTestFixtures.TimeoutPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.html","title":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin","type":"module"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.html#dependencies/0","title":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.dependencies/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.disable/1 .","ref":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.html#disable/1","title":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.disable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.enable/1 .","ref":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.html#enable/1","title":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.enable/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.filter_event/2 .","ref":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.html#filter_event/2","title":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.filter_event/2","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.get_commands/0 .","ref":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.html#get_commands/0","title":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.get_commands/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.PluginMetadataProvider.get_metadata/0 .","ref":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.html#get_metadata/0","title":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.get_metadata/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.handle_command/3 .","ref":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.html#handle_command/3","title":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.handle_command/3","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.html#handle_input/2","title":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.handle_input/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.html#handle_output/2","title":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.handle_output/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.html#id/0","title":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.id/0","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.init/1 .","ref":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.html#init/1","title":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.Core.Runtime.Plugins.Plugin.terminate/2 .","ref":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.html#terminate/2","title":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.terminate/2","type":"function"},{"doc":"","ref":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.html#version/0","title":"Raxol.Test.PluginTestFixtures.VersionMismatchPlugin.version/0","type":"function"},{"doc":"Provides common test utilities and setup functions for Raxol tests.\n\nThis module includes:\n- Test environment setup\n- Mock data generation\n- Common test scenarios\n- Cleanup utilities","ref":"Raxol.Test.TestHelper.html","title":"Raxol.Test.TestHelper","type":"module"},{"doc":"Captures all terminal output during a test.","ref":"Raxol.Test.TestHelper.html#capture_terminal_output/1","title":"Raxol.Test.TestHelper.capture_terminal_output/1","type":"function"},{"doc":"Cleans up an ETS table.","ref":"Raxol.Test.TestHelper.html#cleanup_ets_table/1","title":"Raxol.Test.TestHelper.cleanup_ets_table/1","type":"function"},{"doc":"Cleans up a process and waits for it to be down.","ref":"Raxol.Test.TestHelper.html#cleanup_process/2","title":"Raxol.Test.TestHelper.cleanup_process/2","type":"function"},{"doc":"Cleans up a registry.","ref":"Raxol.Test.TestHelper.html#cleanup_registry/1","title":"Raxol.Test.TestHelper.cleanup_registry/1","type":"function"},{"doc":"Cleans up a temporary directory.","ref":"Raxol.Test.TestHelper.html#cleanup_temp_dir/1","title":"Raxol.Test.TestHelper.cleanup_temp_dir/1","type":"function"},{"doc":"Cleans up test resources and resets the environment.","ref":"Raxol.Test.TestHelper.html#cleanup_test_env/0","title":"Raxol.Test.TestHelper.cleanup_test_env/0","type":"function"},{"doc":"Creates a temporary directory for test files.","ref":"Raxol.Test.TestHelper.html#create_temp_dir/0","title":"Raxol.Test.TestHelper.create_temp_dir/0","type":"function"},{"doc":"Creates a test component with the given module and initial state.","ref":"Raxol.Test.TestHelper.html#create_test_component/2","title":"Raxol.Test.TestHelper.create_test_component/2","type":"function"},{"doc":"Sets up a test environment with necessary services and configurations.","ref":"Raxol.Test.TestHelper.html#setup_test_env/0","title":"Raxol.Test.TestHelper.setup_test_env/0","type":"function"},{"doc":"Creates a mock terminal for testing.","ref":"Raxol.Test.TestHelper.html#setup_test_terminal/0","title":"Raxol.Test.TestHelper.setup_test_terminal/0","type":"function"},{"doc":"Simulates a sequence of events on a component.","ref":"Raxol.Test.TestHelper.html#simulate_event_sequence/2","title":"Raxol.Test.TestHelper.simulate_event_sequence/2","type":"function"},{"doc":"Starts a test event source.","ref":"Raxol.Test.TestHelper.html#start_test_event_source/2","title":"Raxol.Test.TestHelper.start_test_event_source/2","type":"function"},{"doc":"Generates test events for common scenarios.","ref":"Raxol.Test.TestHelper.html#test_events/0","title":"Raxol.Test.TestHelper.test_events/0","type":"function"},{"doc":"Generates test layouts for component positioning.","ref":"Raxol.Test.TestHelper.html#test_layouts/0","title":"Raxol.Test.TestHelper.test_layouts/0","type":"function"},{"doc":"Generates test styles for component rendering.","ref":"Raxol.Test.TestHelper.html#test_styles/0","title":"Raxol.Test.TestHelper.test_styles/0","type":"function"},{"doc":"Returns a complete theme struct for tests, merging any overrides provided.\nEnsures all required component_styles are present.","ref":"Raxol.Test.TestHelper.html#test_theme/1","title":"Raxol.Test.TestHelper.test_theme/1","type":"function"},{"doc":"Waits for a condition to be true, with a timeout.\nUses event-based synchronization instead of Process.sleep.","ref":"Raxol.Test.TestHelper.html#wait_for_state/2","title":"Raxol.Test.TestHelper.wait_for_state/2","type":"function"},{"doc":"Provides utilities for unit testing Raxol components and modules.\n\nThis module offers a comprehensive set of tools for:\n- Component isolation and testing\n- Event simulation and verification\n- State management testing\n- Render output validation","ref":"Raxol.Test.Unit.html","title":"Raxol.Test.Unit","type":"module"},{"doc":"defmodule MyComponent.Test do\n      use ExUnit.Case\n      use Raxol.Test.Unit\n\n      test_component \"handles keyboard input\", MyComponent do\n        event = keyboard_event(:enter)\n        result = simulate_event(component, event)\n\n        assert_state(component, %{text: \"\"})\n        assert_command_emitted(result, :submit)\n      end\n    end","ref":"Raxol.Test.Unit.html#module-example","title":"Example - Raxol.Test.Unit","type":"module"},{"doc":"Asserts that a command was emitted by the component.","ref":"Raxol.Test.Unit.html#assert_command_emitted/2","title":"Raxol.Test.Unit.assert_command_emitted/2","type":"function"},{"doc":"Asserts that a specific event was handled by the component.","ref":"Raxol.Test.Unit.html#assert_event_handled/3","title":"Raxol.Test.Unit.assert_event_handled/3","type":"function"},{"doc":"Asserts that a component's state matches the expected state.","ref":"Raxol.Test.Unit.html#assert_state/2","title":"Raxol.Test.Unit.assert_state/2","type":"function"},{"doc":"Creates a custom event for testing.","ref":"Raxol.Test.Unit.html#custom_event/1","title":"Raxol.Test.Unit.custom_event/1","type":"function"},{"doc":"Creates a keyboard event for testing.","ref":"Raxol.Test.Unit.html#keyboard_event/1","title":"Raxol.Test.Unit.keyboard_event/1","type":"function"},{"doc":"","ref":"Raxol.Test.Unit.html#setup_isolated_component/1","title":"Raxol.Test.Unit.setup_isolated_component/1","type":"function"},{"doc":"Sets up a component for isolated testing with initial properties.","ref":"Raxol.Test.Unit.html#setup_isolated_component/2","title":"Raxol.Test.Unit.setup_isolated_component/2","type":"function"},{"doc":"Simulates an event being sent to a component.\n\nReturns the updated state and any emitted commands.","ref":"Raxol.Test.Unit.html#simulate_event/2","title":"Raxol.Test.Unit.simulate_event/2","type":"function"},{"doc":"","ref":"Raxol.Test.Unit.html#test_component/3","title":"Raxol.Test.Unit.test_component/3","type":"macro"},{"doc":"Creates a window event for testing.","ref":"Raxol.Test.Unit.html#window_event/3","title":"Raxol.Test.Unit.window_event/3","type":"function"},{"doc":"Provides custom assertions for testing Raxol components.\n\nThis module includes assertions for:\n- Component state validation\n- Event handling verification\n- Command emission checking\n- Render output validation\n- Layout verification\n- Style application testing","ref":"Raxol.Test.Unit.Assertions.html","title":"Raxol.Test.Unit.Assertions","type":"module"},{"doc":"Asserts that a component emitted specific commands in sequence.","ref":"Raxol.Test.Unit.Assertions.html#assert_command_sequence/2","title":"Raxol.Test.Unit.Assertions.assert_command_sequence/2","type":"function"},{"doc":"assert_command_sequence component, [\n      {:update, :text},\n      {:notify, :changed},\n      {:submit}\n    ]","ref":"Raxol.Test.Unit.Assertions.html#assert_command_sequence/2-example","title":"Example - Raxol.Test.Unit.Assertions.assert_command_sequence/2","type":"function"},{"doc":"Asserts that a component properly handles an error condition.","ref":"Raxol.Test.Unit.Assertions.html#assert_handles_error/2","title":"Raxol.Test.Unit.Assertions.assert_handles_error/2","type":"function"},{"doc":"assert_handles_error component, fn ->\n      simulate_event(component, invalid_event())\n    end","ref":"Raxol.Test.Unit.Assertions.html#assert_handles_error/2-example","title":"Example - Raxol.Test.Unit.Assertions.assert_handles_error/2","type":"function"},{"doc":"Asserts that a component's layout matches the expected constraints.","ref":"Raxol.Test.Unit.Assertions.html#assert_layout/2","title":"Raxol.Test.Unit.Assertions.assert_layout/2","type":"function"},{"doc":"assert_layout component, %{\n      width: 10,\n      height: 5,\n      x: 0,\n      y: 0\n    }","ref":"Raxol.Test.Unit.Assertions.html#assert_layout/2-example","title":"Example - Raxol.Test.Unit.Assertions.assert_layout/2","type":"function"},{"doc":"Asserts that a component's rendered output matches the expected output.","ref":"Raxol.Test.Unit.Assertions.html#assert_rendered/2","title":"Raxol.Test.Unit.Assertions.assert_rendered/2","type":"macro"},{"doc":"assert_rendered component, fn output ->\n      assert output.type == :text\n      assert output.content == \"Hello, World!\"\n    end","ref":"Raxol.Test.Unit.Assertions.html#assert_rendered/2-example","title":"Example - Raxol.Test.Unit.Assertions.assert_rendered/2","type":"macro"},{"doc":"Asserts that a component's state history includes specific changes.","ref":"Raxol.Test.Unit.Assertions.html#assert_state_history/2","title":"Raxol.Test.Unit.Assertions.assert_state_history/2","type":"function"},{"doc":"assert_state_history component, [\n      %{text: \"\"},\n      %{text: \"Hello\"},\n      %{text: \"Hello, World!\"}\n    ]","ref":"Raxol.Test.Unit.Assertions.html#assert_state_history/2-example","title":"Example - Raxol.Test.Unit.Assertions.assert_state_history/2","type":"function"},{"doc":"","ref":"Raxol.Test.Unit.Assertions.html#assert_state_match/2","title":"Raxol.Test.Unit.Assertions.assert_state_match/2","type":"function"},{"doc":"Asserts that a style is properly applied to a component.","ref":"Raxol.Test.Unit.Assertions.html#assert_style/2","title":"Raxol.Test.Unit.Assertions.assert_style/2","type":"function"},{"doc":"assert_style component, %{\n      color: :blue,\n      background: :white,\n      bold: true\n    }","ref":"Raxol.Test.Unit.Assertions.html#assert_style/2-example","title":"Example - Raxol.Test.Unit.Assertions.assert_style/2","type":"function"},{"doc":"Asserts that a component has specific subscriptions active.","ref":"Raxol.Test.Unit.Assertions.html#assert_subscribed/2","title":"Raxol.Test.Unit.Assertions.assert_subscribed/2","type":"function"},{"doc":"assert_subscribed component, [:keyboard, :mouse]","ref":"Raxol.Test.Unit.Assertions.html#assert_subscribed/2-example","title":"Example - Raxol.Test.Unit.Assertions.assert_subscribed/2","type":"function"},{"doc":"Provides utilities for visual testing of Raxol components.\n\nThis module handles:\n- Component rendering verification\n- Layout testing\n- Style validation\n- Terminal output comparison\n- Cross-terminal compatibility testing","ref":"Raxol.Test.Visual.html","title":"Raxol.Test.Visual","type":"module"},{"doc":"defmodule MyComponent.VisualTest do\n      use ExUnit.Case\n      use Raxol.Test.Visual\n\n      test 'renders correctly' do\n        component = setup_visual_component(MyComponent)\n\n        assert_renders_as component, fn output ->\n          assert output =~ \"Expected Content\"\n          assert_layout_matches output, width: 10, height: 5\n        end\n      end\n    end","ref":"Raxol.Test.Visual.html#module-example","title":"Example - Raxol.Test.Visual","type":"module"},{"doc":"Verifies that a component renders as expected.\n\nTakes a function that can make assertions about the rendered output.","ref":"Raxol.Test.Visual.html#assert_renders_as/2","title":"Raxol.Test.Visual.assert_renders_as/2","type":"function"},{"doc":"Captures the rendered output of a component using a direct rendering pipeline.\nEnsures that the component is rendered in a controlled environment suitable for visual testing.\n\nThe `component_struct` argument is expected to be a Raxol component map, potentially\ncontaining a `:render_context` key with `:width`, `:height`, and `:theme` information.\nIf `:render_context` or its keys are missing, defaults will be applied.\n\nReturns the terminal output as a string for comparison.","ref":"Raxol.Test.Visual.html#capture_render/2","title":"Raxol.Test.Visual.capture_render/2","type":"function"},{"doc":"Compares a component's current render with its snapshot.\n\nReturns a detailed diff if there are differences.","ref":"Raxol.Test.Visual.html#compare_with_snapshot/3","title":"Raxol.Test.Visual.compare_with_snapshot/3","type":"function"},{"doc":"Renders a component state within a controlled test environment.\nAccepts an optional context map.","ref":"Raxol.Test.Visual.html#render_component/2","title":"Raxol.Test.Visual.render_component/2","type":"function"},{"doc":"Sets up a component for visual testing.\n\nThis function:\n1. Initializes the component\n2. Sets up the render context\n3. Configures the test terminal\n4. Prepares snapshot directories","ref":"Raxol.Test.Visual.html#setup_visual_component/2","title":"Raxol.Test.Visual.setup_visual_component/2","type":"function"},{"doc":"Creates or updates a snapshot of the component's rendered output.\n\nUsed for visual regression testing.","ref":"Raxol.Test.Visual.html#snapshot_component/3","title":"Raxol.Test.Visual.snapshot_component/3","type":"function"},{"doc":"Tests a component's rendering across different terminal sizes.\n\nVerifies responsive behavior and layout adaptability.","ref":"Raxol.Test.Visual.html#test_responsive_rendering/2","title":"Raxol.Test.Visual.test_responsive_rendering/2","type":"function"},{"doc":"Tests a component's rendering with different style themes.\n\nVerifies proper style application and theme switching.","ref":"Raxol.Test.Visual.html#test_themed_rendering/2","title":"Raxol.Test.Visual.test_themed_rendering/2","type":"function"},{"doc":"Provides custom assertions for visual testing of Raxol components.\n\nThis module includes assertions for:\n- Component rendering verification\n- Layout validation\n- Style checking\n- Visual regression testing\n- Terminal output comparison","ref":"Raxol.Test.Visual.Assertions.html","title":"Raxol.Test.Visual.Assertions","type":"module"},{"doc":"Asserts that a component's borders and edges align properly.","ref":"Raxol.Test.Visual.Assertions.html#assert_aligned/2","title":"Raxol.Test.Visual.Assertions.assert_aligned/2","type":"function"},{"doc":"assert_aligned component, :all\n    assert_aligned component, [:top, :left]","ref":"Raxol.Test.Visual.Assertions.html#assert_aligned/2-example","title":"Example - Raxol.Test.Visual.Assertions.assert_aligned/2","type":"function"},{"doc":"Asserts that a component's rendered output matches the expected snapshot.","ref":"Raxol.Test.Visual.Assertions.html#assert_matches_snapshot/3","title":"Raxol.Test.Visual.Assertions.assert_matches_snapshot/3","type":"function"},{"doc":"assert_matches_snapshot(component, \"button_primary\")","ref":"Raxol.Test.Visual.Assertions.html#assert_matches_snapshot/3-example","title":"Example - Raxol.Test.Visual.Assertions.assert_matches_snapshot/3","type":"function"},{"doc":"Asserts that a component renders with the expected content.","ref":"Raxol.Test.Visual.Assertions.html#assert_renders_with/2","title":"Raxol.Test.Visual.Assertions.assert_renders_with/2","type":"function"},{"doc":"assert_renders_with component, \"Expected Content\"","ref":"Raxol.Test.Visual.Assertions.html#assert_renders_with/2-example","title":"Example - Raxol.Test.Visual.Assertions.assert_renders_with/2","type":"function"},{"doc":"Asserts that a component renders correctly at different terminal sizes.","ref":"Raxol.Test.Visual.Assertions.html#assert_responsive/2","title":"Raxol.Test.Visual.Assertions.assert_responsive/2","type":"function"},{"doc":"assert_responsive component, [\n      {80, 24},\n      {40, 12},\n      {20, 6}\n    ]","ref":"Raxol.Test.Visual.Assertions.html#assert_responsive/2-example","title":"Example - Raxol.Test.Visual.Assertions.assert_responsive/2","type":"function"},{"doc":"Asserts that a component's style matches the expected theme.","ref":"Raxol.Test.Visual.Assertions.html#assert_styled_with/2","title":"Raxol.Test.Visual.Assertions.assert_styled_with/2","type":"function"},{"doc":"assert_styled_with component, %{color: :blue, bold: true}","ref":"Raxol.Test.Visual.Assertions.html#assert_styled_with/2-example","title":"Example - Raxol.Test.Visual.Assertions.assert_styled_with/2","type":"function"},{"doc":"Asserts that a component renders consistently across different themes.","ref":"Raxol.Test.Visual.Assertions.html#assert_theme_consistent/2","title":"Raxol.Test.Visual.Assertions.assert_theme_consistent/2","type":"function"},{"doc":"assert_theme_consistent component, %{\n      light: light_theme,\n      dark: dark_theme\n    }","ref":"Raxol.Test.Visual.Assertions.html#assert_theme_consistent/2-example","title":"Example - Raxol.Test.Visual.Assertions.assert_theme_consistent/2","type":"function"},{"doc":"Provides pattern matching helpers for visual testing of Raxol components.\n\nThis module includes matchers for:\n- ANSI color and style patterns\n- Terminal layout patterns\n- Border and edge patterns\n- Component structure patterns","ref":"Raxol.Test.Visual.Matchers.html","title":"Raxol.Test.Visual.Matchers","type":"module"},{"doc":"Matches specific text alignment patterns in the output.","ref":"Raxol.Test.Visual.Matchers.html#matches_alignment/3","title":"Raxol.Test.Visual.Matchers.matches_alignment/3","type":"function"},{"doc":"output\n    |> matches_alignment(:left)\n    |> matches_alignment(:right, width: 80)","ref":"Raxol.Test.Visual.Matchers.html#matches_alignment/3-example","title":"Example - Raxol.Test.Visual.Matchers.matches_alignment/3","type":"function"},{"doc":"Matches box drawing characters in the output.","ref":"Raxol.Test.Visual.Matchers.html#matches_box_edges/1","title":"Raxol.Test.Visual.Matchers.matches_box_edges/1","type":"function"},{"doc":"output\n    |> matches_box_edges()\n    |> matches_box_corners()","ref":"Raxol.Test.Visual.Matchers.html#matches_box_edges/1-example","title":"Example - Raxol.Test.Visual.Matchers.matches_box_edges/1","type":"function"},{"doc":"Matches ANSI color codes in the output.","ref":"Raxol.Test.Visual.Matchers.html#matches_color/3","title":"Raxol.Test.Visual.Matchers.matches_color/3","type":"function"},{"doc":"output\n    |> matches_color(:red, \"Error message\")\n    |> matches_color(:green, \"Success\")","ref":"Raxol.Test.Visual.Matchers.html#matches_color/3-example","title":"Example - Raxol.Test.Visual.Matchers.matches_color/3","type":"function"},{"doc":"Matches specific component patterns in the output.","ref":"Raxol.Test.Visual.Matchers.html#matches_component/3","title":"Raxol.Test.Visual.Matchers.matches_component/3","type":"function"},{"doc":"output\n    |> matches_component(:button, \"Click me\")\n    |> matches_component(:input, placeholder: \"Enter text\")","ref":"Raxol.Test.Visual.Matchers.html#matches_component/3-example","title":"Example - Raxol.Test.Visual.Matchers.matches_component/3","type":"function"},{"doc":"Matches specific layout patterns in the output.","ref":"Raxol.Test.Visual.Matchers.html#matches_layout/3","title":"Raxol.Test.Visual.Matchers.matches_layout/3","type":"function"},{"doc":"output\n    |> matches_layout(:centered)\n    |> matches_layout(:padded, padding: 2)","ref":"Raxol.Test.Visual.Matchers.html#matches_layout/3-example","title":"Example - Raxol.Test.Visual.Matchers.matches_layout/3","type":"function"},{"doc":"Matches ANSI style codes in the output.","ref":"Raxol.Test.Visual.Matchers.html#matches_style/3","title":"Raxol.Test.Visual.Matchers.matches_style/3","type":"function"},{"doc":"output\n    |> matches_style(:bold, \"Important\")\n    |> matches_style(:underline, \"Link\")","ref":"Raxol.Test.Visual.Matchers.html#matches_style/3-example","title":"Example - Raxol.Test.Visual.Matchers.matches_style/3","type":"function"},{"doc":"Helper functions for window-related tests.","ref":"Raxol.Test.WindowTestHelper.html","title":"Raxol.Test.WindowTestHelper","type":"module"},{"doc":"Returns a list of basic window operations for testing.","ref":"Raxol.Test.WindowTestHelper.html#basic_window_operations/0","title":"Raxol.Test.WindowTestHelper.basic_window_operations/0","type":"function"},{"doc":"Creates a test emulator with default window state.","ref":"Raxol.Test.WindowTestHelper.html#create_test_emulator/0","title":"Raxol.Test.WindowTestHelper.create_test_emulator/0","type":"function"},{"doc":"Returns a list of invalid parameters for testing.","ref":"Raxol.Test.WindowTestHelper.html#invalid_parameters/0","title":"Raxol.Test.WindowTestHelper.invalid_parameters/0","type":"function"},{"doc":"Returns a list of window reporting operations for testing.","ref":"Raxol.Test.WindowTestHelper.html#reporting_operations/0","title":"Raxol.Test.WindowTestHelper.reporting_operations/0","type":"function"},{"doc":"Returns a list of test window sizes for resize operations.","ref":"Raxol.Test.WindowTestHelper.html#test_window_sizes/0","title":"Raxol.Test.WindowTestHelper.test_window_sizes/0","type":"function"},{"doc":"Analyzes test results and categorizes failures and skipped tests.","ref":"Raxol.TestAnalyzer.html","title":"Raxol.TestAnalyzer","type":"module"},{"doc":"","ref":"Raxol.TestAnalyzer.html#analyze_test_output/1","title":"Raxol.TestAnalyzer.analyze_test_output/1","type":"function"},{"doc":"","ref":"Raxol.TestAnalyzer.html#categorize_failures/1","title":"Raxol.TestAnalyzer.categorize_failures/1","type":"function"},{"doc":"Custom ExUnit formatter for Raxol test output.","ref":"Raxol.TestFormatter.html","title":"Raxol.TestFormatter","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.TestFormatter.html#child_spec/1","title":"Raxol.TestFormatter.child_spec/1","type":"function"},{"doc":"Callback implementation for  GenServer.init/1 .","ref":"Raxol.TestFormatter.html#init/1","title":"Raxol.TestFormatter.init/1","type":"function"},{"doc":"Provides base functionality and utilities for Raxol components.\n\nThis module contains shared functionality used across different components,\nincluding common validation, styling, and event handling patterns.","ref":"Raxol.UI.Components.Base.html","title":"Raxol.UI.Components.Base","type":"module"},{"doc":"Creates a base style for components with common properties.","ref":"Raxol.UI.Components.Base.html#base_style/1","title":"Raxol.UI.Components.Base.base_style/1","type":"function"},{"doc":"Handles common events like focus, blur, and keyboard navigation.\n\nShould be called from a component's handle_event callback.","ref":"Raxol.UI.Components.Base.html#handle_common_events/2","title":"Raxol.UI.Components.Base.handle_common_events/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Base.html#t:state/0","title":"Raxol.UI.Components.Base.state/0","type":"type"},{"doc":"Validates component props against a schema.","ref":"Raxol.UI.Components.Base.html#validate_props/2","title":"Raxol.UI.Components.Base.validate_props/2","type":"function"},{"doc":"def validate_props(props) do\n      Base.validate_props(props, %{\n        required: [:label],\n        optional: [:style, :disabled],\n        types: %{\n          label: :string,\n          style: {:one_of, [:primary, :secondary, :danger]},\n          disabled: :boolean\n        }\n      })\n    end","ref":"Raxol.UI.Components.Base.html#validate_props/2-example","title":"Example - Raxol.UI.Components.Base.validate_props/2","type":"function"},{"doc":"Defines the behavior for UI components in the Raxol system.\n\nThis module provides the core structure for building reusable UI components\nwith lifecycle hooks, state management, and event handling. Components follow\na similar pattern to the main application architecture but at a smaller scale.","ref":"Raxol.UI.Components.Base.Component.html","title":"Raxol.UI.Components.Base.Component","type":"behaviour"},{"doc":"1. `init/1` - Initialize component state with props\n2. `mount/1` - Called when the component is first mounted\n3. `update/2` - Handle messages and update component state\n4. `render/1` - Generate the visual representation of the component\n5. `handle_event/2` - Handle UI events\n6. `unmount/1` - Clean up resources when component is removed","ref":"Raxol.UI.Components.Base.Component.html#module-component-lifecycle","title":"Component Lifecycle - Raxol.UI.Components.Base.Component","type":"behaviour"},{"doc":"defmodule MyComponent do\n      use Raxol.UI.Components.Base.Component\n\n      def init(props) do\n        Map.merge(%{count: 0}, props)\n      end\n\n      def mount(state) do\n        {state, []}\n      end\n\n      def update(:increment, state) do\n        %{state | count: state.count + 1}\n      end\n\n      def render(state) do\n        row do\n          button(label: \"-\", on_click: :decrement)\n          text(\"Count: #{state.count}\")\n          button(label: \"+\", on_click: :increment)\n        end\n      end\n\n      def handle_event({:click, :increment}, state) do\n        {update(:increment, state), []}\n      end\n\n      def handle_event({:click, :decrement}, state) do\n        {%{state | count: state.count - 1}, []}\n      end\n    end","ref":"Raxol.UI.Components.Base.Component.html#module-example","title":"Example - Raxol.UI.Components.Base.Component","type":"behaviour"},{"doc":"","ref":"Raxol.UI.Components.Base.Component.html#t:command/0","title":"Raxol.UI.Components.Base.Component.command/0","type":"type"},{"doc":"","ref":"Raxol.UI.Components.Base.Component.html#t:context/0","title":"Raxol.UI.Components.Base.Component.context/0","type":"type"},{"doc":"","ref":"Raxol.UI.Components.Base.Component.html#t:element/0","title":"Raxol.UI.Components.Base.Component.element/0","type":"type"},{"doc":"","ref":"Raxol.UI.Components.Base.Component.html#t:event/0","title":"Raxol.UI.Components.Base.Component.event/0","type":"type"},{"doc":"Handles UI events that occur on the component.\n\nThe context map provides additional event details or UI state.\nReturns the potentially modified state and any commands to execute.","ref":"Raxol.UI.Components.Base.Component.html#c:handle_event/3","title":"Raxol.UI.Components.Base.Component.handle_event/3","type":"callback"},{"doc":"Initializes the component with the given props.\n\nCalled when the component is created. Should merge default values with\nthe provided props to create the initial state.","ref":"Raxol.UI.Components.Base.Component.html#c:init/1","title":"Raxol.UI.Components.Base.Component.init/1","type":"callback"},{"doc":"","ref":"Raxol.UI.Components.Base.Component.html#t:message/0","title":"Raxol.UI.Components.Base.Component.message/0","type":"type"},{"doc":"Called when the component is mounted in the UI.\n\nThis is where you can set up subscriptions, execute initial commands,\nor perform other setup tasks. Returns the potentially modified state\nand any commands to execute.","ref":"Raxol.UI.Components.Base.Component.html#c:mount/1","title":"Raxol.UI.Components.Base.Component.mount/1","type":"callback"},{"doc":"","ref":"Raxol.UI.Components.Base.Component.html#t:props/0","title":"Raxol.UI.Components.Base.Component.props/0","type":"type"},{"doc":"Renders the component based on its current state.\n\nReturns an element tree that will be rendered to the screen. The context\nmap contains theme, layout constraints, etc.","ref":"Raxol.UI.Components.Base.Component.html#c:render/2","title":"Raxol.UI.Components.Base.Component.render/2","type":"callback"},{"doc":"","ref":"Raxol.UI.Components.Base.Component.html#t:state/0","title":"Raxol.UI.Components.Base.Component.state/0","type":"type"},{"doc":"Called when the component is being removed from the UI.\n\nUse this to clean up any resources or perform final actions.","ref":"Raxol.UI.Components.Base.Component.html#c:unmount/1","title":"Raxol.UI.Components.Base.Component.unmount/1","type":"callback"},{"doc":"Updates the component state in response to messages.\n\nSimilar to the application update function, this handles messages sent to\nthe component and returns the new state.","ref":"Raxol.UI.Components.Base.Component.html#c:update/2","title":"Raxol.UI.Components.Base.Component.update/2","type":"callback"},{"doc":"","ref":"Raxol.UI.Components.Base.ComponentTest.TestComponent.html","title":"Raxol.UI.Components.Base.ComponentTest.TestComponent","type":"module"},{"doc":"Provides component lifecycle hooks and management for UI components.\n\nThis module handles:\n- Component mounting and initialization\n- Update propagation to components\n- Component unmounting and cleanup\n- Lifecycle event tracking","ref":"Raxol.UI.Components.Base.Lifecycle.html","title":"Raxol.UI.Components.Base.Lifecycle","type":"module"},{"doc":"Adds a lifecycle event to the component for debugging purposes.","ref":"Raxol.UI.Components.Base.Lifecycle.html#add_lifecycle_event/2","title":"Raxol.UI.Components.Base.Lifecycle.add_lifecycle_event/2","type":"function"},{"doc":"* `component` - The component to add the event to\n* `event` - The lifecycle event to record","ref":"Raxol.UI.Components.Base.Lifecycle.html#add_lifecycle_event/2-parameters","title":"Parameters - Raxol.UI.Components.Base.Lifecycle.add_lifecycle_event/2","type":"function"},{"doc":"The component with the added lifecycle event","ref":"Raxol.UI.Components.Base.Lifecycle.html#add_lifecycle_event/2-returns","title":"Returns - Raxol.UI.Components.Base.Lifecycle.add_lifecycle_event/2","type":"function"},{"doc":"Gets the lifecycle events recorded for a component.","ref":"Raxol.UI.Components.Base.Lifecycle.html#get_lifecycle_events/1","title":"Raxol.UI.Components.Base.Lifecycle.get_lifecycle_events/1","type":"function"},{"doc":"* `component` - The component to get events for","ref":"Raxol.UI.Components.Base.Lifecycle.html#get_lifecycle_events/1-parameters","title":"Parameters - Raxol.UI.Components.Base.Lifecycle.get_lifecycle_events/1","type":"function"},{"doc":"List of lifecycle events with timestamps","ref":"Raxol.UI.Components.Base.Lifecycle.html#get_lifecycle_events/1-returns","title":"Returns - Raxol.UI.Components.Base.Lifecycle.get_lifecycle_events/1","type":"function"},{"doc":"Mounts a component, initializing its state and triggering mount-time effects.","ref":"Raxol.UI.Components.Base.Lifecycle.html#mount/3","title":"Raxol.UI.Components.Base.Lifecycle.mount/3","type":"function"},{"doc":"* `component` - The component to mount\n* `props` - Initial properties for the component\n* `context` - The rendering context","ref":"Raxol.UI.Components.Base.Lifecycle.html#mount/3-parameters","title":"Parameters - Raxol.UI.Components.Base.Lifecycle.mount/3","type":"function"},{"doc":"The mounted component","ref":"Raxol.UI.Components.Base.Lifecycle.html#mount/3-returns","title":"Returns - Raxol.UI.Components.Base.Lifecycle.mount/3","type":"function"},{"doc":"Processes an event on a component.","ref":"Raxol.UI.Components.Base.Lifecycle.html#process_event/3","title":"Raxol.UI.Components.Base.Lifecycle.process_event/3","type":"function"},{"doc":"* `component` - The component to process the event on\n* `event` - The event to process\n* `context` - The event context","ref":"Raxol.UI.Components.Base.Lifecycle.html#process_event/3-parameters","title":"Parameters - Raxol.UI.Components.Base.Lifecycle.process_event/3","type":"function"},{"doc":"`{:update, updated_component}` if the component state changed,\n`{:handled, component}` if the event was handled but state didn't change,\n`:passthrough` if the event wasn't handled by the component.","ref":"Raxol.UI.Components.Base.Lifecycle.html#process_event/3-returns","title":"Returns - Raxol.UI.Components.Base.Lifecycle.process_event/3","type":"function"},{"doc":"Renders a component, creating its view representation.\n\nThis is a wrapper around the component's render function that ensures\nconsistent handling of the rendering process.","ref":"Raxol.UI.Components.Base.Lifecycle.html#render/2","title":"Raxol.UI.Components.Base.Lifecycle.render/2","type":"function"},{"doc":"* `component` - The component to render\n* `context` - The rendering context","ref":"Raxol.UI.Components.Base.Lifecycle.html#render/2-parameters","title":"Parameters - Raxol.UI.Components.Base.Lifecycle.render/2","type":"function"},{"doc":"The rendered view representation and updated component state","ref":"Raxol.UI.Components.Base.Lifecycle.html#render/2-returns","title":"Returns - Raxol.UI.Components.Base.Lifecycle.render/2","type":"function"},{"doc":"Unmounts a component, allowing it to clean up resources.","ref":"Raxol.UI.Components.Base.Lifecycle.html#unmount/2","title":"Raxol.UI.Components.Base.Lifecycle.unmount/2","type":"function"},{"doc":"* `component` - The component to unmount\n* `context` - The rendering context","ref":"Raxol.UI.Components.Base.Lifecycle.html#unmount/2-parameters","title":"Parameters - Raxol.UI.Components.Base.Lifecycle.unmount/2","type":"function"},{"doc":"The unmounted component, typically for tracking/debugging only","ref":"Raxol.UI.Components.Base.Lifecycle.html#unmount/2-returns","title":"Returns - Raxol.UI.Components.Base.Lifecycle.unmount/2","type":"function"},{"doc":"Updates a component with new props.","ref":"Raxol.UI.Components.Base.Lifecycle.html#update/3","title":"Raxol.UI.Components.Base.Lifecycle.update/3","type":"function"},{"doc":"* `component` - The component to update\n* `props` - New properties to apply\n* `context` - The rendering context","ref":"Raxol.UI.Components.Base.Lifecycle.html#update/3-parameters","title":"Parameters - Raxol.UI.Components.Base.Lifecycle.update/3","type":"function"},{"doc":"The updated component","ref":"Raxol.UI.Components.Base.Lifecycle.html#update/3-returns","title":"Returns - Raxol.UI.Components.Base.Lifecycle.update/3","type":"function"},{"doc":"A customizable button component.\n\nThis module provides a more sophisticated button component than the basic\nbutton element, with support for various styles and behaviors.","ref":"Raxol.UI.Components.Button.html","title":"Raxol.UI.Components.Button","type":"module"},{"doc":"```elixir\nalias Raxol.UI.Components.Button\n\nButton.new(\"Save Changes\", on_click: :save_clicked, style: :primary)\n```","ref":"Raxol.UI.Components.Button.html#module-example","title":"Example - Raxol.UI.Components.Button","type":"module"},{"doc":"Creates a new button with the given label and options.","ref":"Raxol.UI.Components.Button.html#new/2","title":"Raxol.UI.Components.Button.new/2","type":"function"},{"doc":"* `:on_click` - Message to send when the button is clicked\n* `:style` - Button style (:primary, :secondary, :danger, :success, or a custom style map)\n* `:disabled` - Whether the button is disabled\n* `:icon` - Icon to display before the label\n* `:full_width` - Whether the button should take full width\n* `:size` - Button size (:small, :medium, :large)\n* `:tooltip` - Tooltip text to show on hover","ref":"Raxol.UI.Components.Button.html#new/2-options","title":"Options - Raxol.UI.Components.Button.new/2","type":"function"},{"doc":"A button component that can be used in a Raxol view.","ref":"Raxol.UI.Components.Button.html#new/2-returns","title":"Returns - Raxol.UI.Components.Button.new/2","type":"function"},{"doc":"```elixir\nButton.new(\"Delete\",\n  on_click: {:delete, item_id},\n  style: :danger,\n  icon: :trash\n)\n```","ref":"Raxol.UI.Components.Button.html#new/2-example","title":"Example - Raxol.UI.Components.Button.new/2","type":"function"},{"doc":"Renders the button as a basic element.\n\nThis is typically called by the renderer, not directly by users.","ref":"Raxol.UI.Components.Button.html#render/1","title":"Raxol.UI.Components.Button.render/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Button.html#t:t/0","title":"Raxol.UI.Components.Button.t/0","type":"type"},{"doc":"Renders a block of code with syntax highlighting.\n\nRequires the `makeup_elixir` dependency (and potentially other lexers).\nUses HTML output from Makeup.","ref":"Raxol.UI.Components.CodeBlock.html","title":"Raxol.UI.Components.CodeBlock","type":"module"},{"doc":"","ref":"Raxol.UI.Components.CodeBlock.html#broadcast/1","title":"Raxol.UI.Components.CodeBlock.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.CodeBlock.html#command/1","title":"Raxol.UI.Components.CodeBlock.command/1","type":"function"},{"doc":"Handles events for the component. No events are handled by default.","ref":"Raxol.UI.Components.CodeBlock.html#handle_event/3","title":"Raxol.UI.Components.CodeBlock.handle_event/3","type":"function"},{"doc":"Initializes the component state from props.","ref":"Raxol.UI.Components.CodeBlock.html#init/1","title":"Raxol.UI.Components.CodeBlock.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.CodeBlock.html#mount/1","title":"Raxol.UI.Components.CodeBlock.mount/1","type":"function"},{"doc":"Renders the code block.\n\nProps:\n  * `content` (required): The source code string.\n  * `language` (required): The language name (e.g., \"elixir\", \"html\").\n  * `style`: The Makeup HTML style module (e.g., `Makeup.Styles.GithubLight`). Defaults to `:github_light` style lookup.\n  * `class`: Optional CSS class for the outer `pre` tag.","ref":"Raxol.UI.Components.CodeBlock.html#render/2","title":"Raxol.UI.Components.CodeBlock.render/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.CodeBlock.html#schedule/2","title":"Raxol.UI.Components.CodeBlock.schedule/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.CodeBlock.html#unmount/1","title":"Raxol.UI.Components.CodeBlock.unmount/1","type":"function"},{"doc":"Updates the component state. No updates are handled by default.","ref":"Raxol.UI.Components.CodeBlock.html#update/2","title":"Raxol.UI.Components.CodeBlock.update/2","type":"function"},{"doc":"A component responsible for rendering a grid-based dashboard layout.\nManages widget placement, drag/drop, and resizing.","ref":"Raxol.UI.Components.Dashboard.Dashboard.html","title":"Raxol.UI.Components.Dashboard.Dashboard","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.Dashboard.html#broadcast/1","title":"Raxol.UI.Components.Dashboard.Dashboard.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.Dashboard.html#command/1","title":"Raxol.UI.Components.Dashboard.Dashboard.command/1","type":"function"},{"doc":"Initializes the Dashboard state from a saved layout.\nIf no saved layout exists, returns default widgets with the given grid configuration.\n\nThis function loads widget configurations using `LayoutPersistence.load_layout/0` and initializes\nthe dashboard model with those widgets and the provided grid_config.\n\nReturns {:ok, model} on success, or {:error, reason} on failure.","ref":"Raxol.UI.Components.Dashboard.Dashboard.html#init_from_saved_layout/2","title":"Raxol.UI.Components.Dashboard.Dashboard.init_from_saved_layout/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.Dashboard.Dashboard.html#mount/1","title":"Raxol.UI.Components.Dashboard.Dashboard.mount/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.Dashboard.html#schedule/2","title":"Raxol.UI.Components.Dashboard.Dashboard.schedule/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.Dashboard.Dashboard.html#unmount/1","title":"Raxol.UI.Components.Dashboard.Dashboard.unmount/1","type":"function"},{"doc":"Validates a list of widget configurations to ensure they can be properly rendered.\nReturns true if widgets are valid, false otherwise.","ref":"Raxol.UI.Components.Dashboard.Dashboard.html#validate_widgets/1","title":"Raxol.UI.Components.Dashboard.Dashboard.validate_widgets/1","type":"function"},{"doc":"State for the Dashboard component.","ref":"Raxol.UI.Components.Dashboard.Dashboard.Model.html","title":"Raxol.UI.Components.Dashboard.Dashboard.Model","type":"module"},{"doc":"Calculates layout bounds for widgets within a grid configuration.\nThis module provides functions to determine the position and size of widgets\nbased on a grid layout definition (columns, rows, gaps).","ref":"Raxol.UI.Components.Dashboard.GridContainer.html","title":"Raxol.UI.Components.Dashboard.GridContainer","type":"module"},{"doc":"Calculates the absolute bounds for a widget within a grid layout.\n\nParameters:\n  - `widget_config`: Map containing at least `grid_spec: %{col: integer(), row: integer(), col_span: integer(), row_span: integer()}`.\n  - `grid_config`: Map containing `parent_bounds: %{x: integer(), y: integer(), width: integer(), height: integer()}`,\n    and optionally `cols: integer()`, `rows: integer()`, `gap: integer()`.\n\nReturns:\n  - `%{x: integer(), y: integer(), width: integer(), height: integer()}` representing the absolute bounds.","ref":"Raxol.UI.Components.Dashboard.GridContainer.html#calculate_widget_bounds/2","title":"Raxol.UI.Components.Dashboard.GridContainer.calculate_widget_bounds/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.GridContainer.html#default_cols/0","title":"Raxol.UI.Components.Dashboard.GridContainer.default_cols/0","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.GridContainer.html#default_gap/0","title":"Raxol.UI.Components.Dashboard.GridContainer.default_gap/0","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.GridContainer.html#default_rows/0","title":"Raxol.UI.Components.Dashboard.GridContainer.default_rows/0","type":"function"},{"doc":"Calculates the dimensions of a single cell in the grid.\n\nParameters:\n  - `grid_config`: Map containing grid configuration including parent_bounds,\n    cols, rows, and gap.\n\nReturns:\n  - `{cell_width, cell_height}` tuple with the dimensions of a single cell.","ref":"Raxol.UI.Components.Dashboard.GridContainer.html#get_cell_dimensions/1","title":"Raxol.UI.Components.Dashboard.GridContainer.get_cell_dimensions/1","type":"function"},{"doc":"Resolves the effective grid parameters (cols, rows) based on breakpoints\ndefined in the grid configuration and the current parent width.\n\nParameters:\n  - `grid_config`: Map containing `parent_bounds: %{width: _}` and `breakpoints: %{...}`.\n                 Breakpoints map should have keys like `:small`, `:medium`, `:large`,\n                 with values like `%{max_width: _, cols: _, rows: _}` or just `%{cols: _, rows: _}`\n                 for the largest/default breakpoint.\n\nReturns:\n  - `%{cols: integer(), rows: integer()}`","ref":"Raxol.UI.Components.Dashboard.GridContainer.html#resolve_grid_params/1","title":"Raxol.UI.Components.Dashboard.GridContainer.resolve_grid_params/1","type":"function"},{"doc":"Handles saving and loading dashboard widget layouts to disk.","ref":"Raxol.UI.Components.Dashboard.LayoutPersistence.html","title":"Raxol.UI.Components.Dashboard.LayoutPersistence","type":"module"},{"doc":"Loads the widget layout from the file.\nReturns the list of widget configurations `[map()]` or `nil` if load fails or file doesn't exist.","ref":"Raxol.UI.Components.Dashboard.LayoutPersistence.html#load_layout/0","title":"Raxol.UI.Components.Dashboard.LayoutPersistence.load_layout/0","type":"function"},{"doc":"Saves the current widget layout (list of widget configs) to a file.\n\nOnly saves fields essential for reconstructing the layout and widget state:\n`:id`, `:type`, `:title`, `:grid_spec`, `:component_opts`, `:data`.","ref":"Raxol.UI.Components.Dashboard.LayoutPersistence.html#save_layout/1","title":"Raxol.UI.Components.Dashboard.LayoutPersistence.save_layout/1","type":"function"},{"doc":"A container component for dashboard widgets.\nProvides a frame, title bar (optional), and potentially drag/resize handles.\nRenders the actual widget content passed to it.","ref":"Raxol.UI.Components.Dashboard.WidgetContainer.html","title":"Raxol.UI.Components.Dashboard.WidgetContainer","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.WidgetContainer.html#broadcast/1","title":"Raxol.UI.Components.Dashboard.WidgetContainer.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.WidgetContainer.html#command/1","title":"Raxol.UI.Components.Dashboard.WidgetContainer.command/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.Dashboard.WidgetContainer.html#mount/1","title":"Raxol.UI.Components.Dashboard.WidgetContainer.mount/1","type":"function"},{"doc":"Renders the widget container frame and its content.\n\nRequires props:\n- `bounds`: %{x, y, width, height} - The absolute bounds calculated by GridContainer.\n- `widget_config`: The configuration map for the widget being rendered.\n                   Used for title, etc. (%{id: _, type: _, title: _, ...}).\n- `content`: The actual View element(s) representing the widget's content.","ref":"Raxol.UI.Components.Dashboard.WidgetContainer.html#render/2","title":"Raxol.UI.Components.Dashboard.WidgetContainer.render/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.WidgetContainer.html#schedule/2","title":"Raxol.UI.Components.Dashboard.WidgetContainer.schedule/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.Dashboard.WidgetContainer.html#unmount/1","title":"Raxol.UI.Components.Dashboard.WidgetContainer.unmount/1","type":"function"},{"doc":"A dashboard widget that displays a chart using Raxol.UI.Components.Visualization.Chart.\nThis module is responsible for holding the chart's state (data, config)\nand providing a data structure for rendering, rather than rendering directly.","ref":"Raxol.UI.Components.Dashboard.Widgets.ChartWidget.html","title":"Raxol.UI.Components.Dashboard.Widgets.ChartWidget","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.Widgets.ChartWidget.html#init/1","title":"Raxol.UI.Components.Dashboard.Widgets.ChartWidget.init/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.Widgets.ChartWidget.html#render_data_structure/1","title":"Raxol.UI.Components.Dashboard.Widgets.ChartWidget.render_data_structure/1","type":"function"},{"doc":"A dashboard widget that displays simple text information.","ref":"Raxol.UI.Components.Dashboard.Widgets.InfoWidget.html","title":"Raxol.UI.Components.Dashboard.Widgets.InfoWidget","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.Widgets.InfoWidget.html#broadcast/1","title":"Raxol.UI.Components.Dashboard.Widgets.InfoWidget.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.Widgets.InfoWidget.html#command/1","title":"Raxol.UI.Components.Dashboard.Widgets.InfoWidget.command/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.Dashboard.Widgets.InfoWidget.html#mount/1","title":"Raxol.UI.Components.Dashboard.Widgets.InfoWidget.mount/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.Widgets.InfoWidget.html#schedule/2","title":"Raxol.UI.Components.Dashboard.Widgets.InfoWidget.schedule/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.Dashboard.Widgets.InfoWidget.html#unmount/1","title":"Raxol.UI.Components.Dashboard.Widgets.InfoWidget.unmount/1","type":"function"},{"doc":"A dashboard widget containing a text input.","ref":"Raxol.UI.Components.Dashboard.Widgets.TextInputWidget.html","title":"Raxol.UI.Components.Dashboard.Widgets.TextInputWidget","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.Widgets.TextInputWidget.html#broadcast/1","title":"Raxol.UI.Components.Dashboard.Widgets.TextInputWidget.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.Widgets.TextInputWidget.html#command/1","title":"Raxol.UI.Components.Dashboard.Widgets.TextInputWidget.command/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.Dashboard.Widgets.TextInputWidget.html#mount/1","title":"Raxol.UI.Components.Dashboard.Widgets.TextInputWidget.mount/1","type":"function"},{"doc":"Renders the text input widget content.\n\nRequires props:\n- `widget_config`: The configuration map for the widget (%{id: _, type: _, title: _, ...}).\n- `app_text`: The current text value from the main application model.","ref":"Raxol.UI.Components.Dashboard.Widgets.TextInputWidget.html#render/2","title":"Raxol.UI.Components.Dashboard.Widgets.TextInputWidget.render/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.Widgets.TextInputWidget.html#schedule/2","title":"Raxol.UI.Components.Dashboard.Widgets.TextInputWidget.schedule/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.Dashboard.Widgets.TextInputWidget.html#unmount/1","title":"Raxol.UI.Components.Dashboard.Widgets.TextInputWidget.unmount/1","type":"function"},{"doc":"A dashboard widget that displays a treemap using Raxol.UI.Components.Visualization.TreeMap.\nThis module is responsible for holding the treemap's state (data, config)\nand providing a data structure for rendering, rather than rendering directly.","ref":"Raxol.UI.Components.Dashboard.Widgets.TreeMapWidget.html","title":"Raxol.UI.Components.Dashboard.Widgets.TreeMapWidget","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.Widgets.TreeMapWidget.html#init/1","title":"Raxol.UI.Components.Dashboard.Widgets.TreeMapWidget.init/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Dashboard.Widgets.TreeMapWidget.html#render_data_structure/1","title":"Raxol.UI.Components.Dashboard.Widgets.TreeMapWidget.render_data_structure/1","type":"function"},{"doc":"A progress bar component for displaying completion status.\n\nFeatures:\n* Customizable colors (harmonized style/theme prop merging)\n* Percentage display option\n* Custom width\n* Animated progress\n* Optional label\n* Accessibility/extra props (aria_label, tooltip, etc)\n* Robust lifecycle hooks (mount/unmount)","ref":"Raxol.UI.Components.Display.Progress.html","title":"Raxol.UI.Components.Display.Progress","type":"module"},{"doc":"Initializes the progress bar state from props.","ref":"Raxol.UI.Components.Display.Progress.html#init/1","title":"Raxol.UI.Components.Display.Progress.init/1","type":"function"},{"doc":"Mounts the progress bar (for future extensibility: timers, subscriptions, etc).","ref":"Raxol.UI.Components.Display.Progress.html#mount/1","title":"Raxol.UI.Components.Display.Progress.mount/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Display.Progress.html#t:props/0","title":"Raxol.UI.Components.Display.Progress.props/0","type":"type"},{"doc":"","ref":"Raxol.UI.Components.Display.Progress.html#t:state/0","title":"Raxol.UI.Components.Display.Progress.state/0","type":"type"},{"doc":"Unmounts the progress bar (cleanup for future extensibility).","ref":"Raxol.UI.Components.Display.Progress.html#unmount/1","title":"Raxol.UI.Components.Display.Progress.unmount/1","type":"function"},{"doc":"A component for displaying tabular data with sorting, filtering, and pagination.","ref":"Raxol.UI.Components.Display.Table.html","title":"Raxol.UI.Components.Display.Table","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Display.Table.html#t:cell/0","title":"Raxol.UI.Components.Display.Table.cell/0","type":"type"},{"doc":"Handles events for the Table component.","ref":"Raxol.UI.Components.Display.Table.html#handle_event/3","title":"Raxol.UI.Components.Display.Table.handle_event/3","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Display.Table.html#t:header/0","title":"Raxol.UI.Components.Display.Table.header/0","type":"type"},{"doc":"","ref":"Raxol.UI.Components.Display.Table.html#t:headers/0","title":"Raxol.UI.Components.Display.Table.headers/0","type":"type"},{"doc":"Initializes the Table component state from props.","ref":"Raxol.UI.Components.Display.Table.html#init/1","title":"Raxol.UI.Components.Display.Table.init/1","type":"function"},{"doc":"Mounts the Table component, performing any setup needed.","ref":"Raxol.UI.Components.Display.Table.html#mount/1","title":"Raxol.UI.Components.Display.Table.mount/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Display.Table.html#t:props/0","title":"Raxol.UI.Components.Display.Table.props/0","type":"type"},{"doc":"Renders the Table component.","ref":"Raxol.UI.Components.Display.Table.html#render/2","title":"Raxol.UI.Components.Display.Table.render/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Display.Table.html#t:row/0","title":"Raxol.UI.Components.Display.Table.row/0","type":"type"},{"doc":"","ref":"Raxol.UI.Components.Display.Table.html#t:rows/0","title":"Raxol.UI.Components.Display.Table.rows/0","type":"type"},{"doc":"","ref":"Raxol.UI.Components.Display.Table.html#t:state/0","title":"Raxol.UI.Components.Display.Table.state/0","type":"type"},{"doc":"Updates the Table component state in response to messages. Handles prop updates, sorting, filtering, and selection.","ref":"Raxol.UI.Components.Display.Table.html#update/2","title":"Raxol.UI.Components.Display.Table.update/2","type":"function"},{"doc":"Handles drawing the focus ring around focused components.\n\nThis component dynamically styles the focus ring based on:\n- Component state (focused, active, disabled)\n- User preferences (high contrast, reduced motion)\n- Theming settings\n- Animation effects","ref":"Raxol.UI.Components.FocusRing.html","title":"Raxol.UI.Components.FocusRing","type":"module"},{"doc":"","ref":"Raxol.UI.Components.FocusRing.html#broadcast/1","title":"Raxol.UI.Components.FocusRing.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.FocusRing.html#command/1","title":"Raxol.UI.Components.FocusRing.command/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.FocusRing.html#mount/1","title":"Raxol.UI.Components.FocusRing.mount/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.FocusRing.html#schedule/2","title":"Raxol.UI.Components.FocusRing.schedule/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.FocusRing.html#unmount/1","title":"Raxol.UI.Components.FocusRing.unmount/1","type":"function"},{"doc":"Displays contextual hints and keyboard shortcuts.","ref":"Raxol.UI.Components.HintDisplay.html","title":"Raxol.UI.Components.HintDisplay","type":"module"},{"doc":"","ref":"Raxol.UI.Components.HintDisplay.html#broadcast/1","title":"Raxol.UI.Components.HintDisplay.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.HintDisplay.html#command/1","title":"Raxol.UI.Components.HintDisplay.command/1","type":"function"},{"doc":"Handles events for the HintDisplay component. Typically does not handle direct events.","ref":"Raxol.UI.Components.HintDisplay.html#handle_event/3","title":"Raxol.UI.Components.HintDisplay.handle_event/3","type":"function"},{"doc":"Initializes the HintDisplay component state from props.","ref":"Raxol.UI.Components.HintDisplay.html#init/1","title":"Raxol.UI.Components.HintDisplay.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.HintDisplay.html#mount/1","title":"Raxol.UI.Components.HintDisplay.mount/1","type":"function"},{"doc":"Renders the HintDisplay component if visible and hints are present.","ref":"Raxol.UI.Components.HintDisplay.html#render/2","title":"Raxol.UI.Components.HintDisplay.render/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.HintDisplay.html#schedule/2","title":"Raxol.UI.Components.HintDisplay.schedule/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.HintDisplay.html#unmount/1","title":"Raxol.UI.Components.HintDisplay.unmount/1","type":"function"},{"doc":"Updates the HintDisplay component state in response to messages.","ref":"Raxol.UI.Components.HintDisplay.html#update/2","title":"Raxol.UI.Components.HintDisplay.update/2","type":"function"},{"doc":"Button component for interactive UI elements.\n\nThis component provides a clickable button with customizable appearance and behavior.","ref":"Raxol.UI.Components.Input.Button.html","title":"Raxol.UI.Components.Input.Button","type":"module"},{"doc":"Handles input events for the button component.","ref":"Raxol.UI.Components.Input.Button.html#handle_event/3","title":"Raxol.UI.Components.Input.Button.handle_event/3","type":"function"},{"doc":"* `button` - The button component\n* `event` - The input event to handle\n* `context` - The event context","ref":"Raxol.UI.Components.Input.Button.html#handle_event/3-parameters","title":"Parameters - Raxol.UI.Components.Input.Button.handle_event/3","type":"function"},{"doc":"`{:update, updated_button}` if the button state changed,\n`{:handled, button}` if the event was handled but state didn't change,\n`:passthrough` if the event wasn't handled by the button.","ref":"Raxol.UI.Components.Input.Button.html#handle_event/3-returns","title":"Returns - Raxol.UI.Components.Input.Button.handle_event/3","type":"function"},{"doc":"Initializes the Button component state from the given props.","ref":"Raxol.UI.Components.Input.Button.html#init/1","title":"Raxol.UI.Components.Input.Button.init/1","type":"function"},{"doc":"Mounts the Button component. Performs any setup needed after initialization.","ref":"Raxol.UI.Components.Input.Button.html#mount/1","title":"Raxol.UI.Components.Input.Button.mount/1","type":"function"},{"doc":"Creates a new Button state map, applying defaults.\nExpects opts to be a Map.","ref":"Raxol.UI.Components.Input.Button.html#new/1","title":"Raxol.UI.Components.Input.Button.new/1","type":"function"},{"doc":"Renders the button component based on its current state.","ref":"Raxol.UI.Components.Input.Button.html#render/2","title":"Raxol.UI.Components.Input.Button.render/2","type":"function"},{"doc":"* `button` - The button component to render\n* `context` - The rendering context","ref":"Raxol.UI.Components.Input.Button.html#render/2-parameters","title":"Parameters - Raxol.UI.Components.Input.Button.render/2","type":"function"},{"doc":"A rendered view representation of the button.","ref":"Raxol.UI.Components.Input.Button.html#render/2-returns","title":"Returns - Raxol.UI.Components.Input.Button.render/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.Button.html#t:t/0","title":"Raxol.UI.Components.Input.Button.t/0","type":"type"},{"doc":"Unmounts the Button component, performing any necessary cleanup.","ref":"Raxol.UI.Components.Input.Button.html#unmount/1","title":"Raxol.UI.Components.Input.Button.unmount/1","type":"function"},{"doc":"Updates the Button component state in response to messages or prop changes.","ref":"Raxol.UI.Components.Input.Button.html#update/2","title":"Raxol.UI.Components.Input.Button.update/2","type":"function"},{"doc":"Checkbox component for toggling boolean values.\n\nThis component provides a selectable checkbox with customizable appearance and behavior.\nFully supports style and theme props (with correct merging/precedence),\nimplements robust lifecycle hooks, and supports accessibility/extra props.","ref":"Raxol.UI.Components.Input.Checkbox.html","title":"Raxol.UI.Components.Input.Checkbox","type":"module"},{"doc":"Initializes the Checkbox component state from the given props.","ref":"Raxol.UI.Components.Input.Checkbox.html#init/1","title":"Raxol.UI.Components.Input.Checkbox.init/1","type":"function"},{"doc":"Mounts the Checkbox component. Performs any setup needed after initialization.","ref":"Raxol.UI.Components.Input.Checkbox.html#mount/1","title":"Raxol.UI.Components.Input.Checkbox.mount/1","type":"function"},{"doc":"Creates a new checkbox component with the given options.\nSee `init/1` for details.","ref":"Raxol.UI.Components.Input.Checkbox.html#new/1","title":"Raxol.UI.Components.Input.Checkbox.new/1","type":"function"},{"doc":"Renders the Checkbox component using the current state and context.","ref":"Raxol.UI.Components.Input.Checkbox.html#render/2","title":"Raxol.UI.Components.Input.Checkbox.render/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.Checkbox.html#t:t/0","title":"Raxol.UI.Components.Input.Checkbox.t/0","type":"type"},{"doc":"Unmounts the Checkbox component, performing any necessary cleanup.","ref":"Raxol.UI.Components.Input.Checkbox.html#unmount/1","title":"Raxol.UI.Components.Input.Checkbox.unmount/1","type":"function"},{"doc":"Updates the Checkbox component state in response to messages or prop changes.","ref":"Raxol.UI.Components.Input.Checkbox.html#update/2","title":"Raxol.UI.Components.Input.Checkbox.update/2","type":"function"},{"doc":"A multi-line input component for text editing, supporting line wrapping, scrolling, selection, and accessibility.\n\n**BREAKING:** All styling is now theme-driven. The `style` field and `@default_style` are removed. Use the theme system for all appearance customization.\n\nHarmonized with modern Raxol component standards (style/theme merging, lifecycle hooks, accessibility props).","ref":"Raxol.UI.Components.Input.MultiLineInput.html","title":"Raxol.UI.Components.Input.MultiLineInput","type":"module"},{"doc":"Handles events for the MultiLineInput component, such as keypresses, mouse events, and context changes.","ref":"Raxol.UI.Components.Input.MultiLineInput.html#handle_event/3","title":"Raxol.UI.Components.Input.MultiLineInput.handle_event/3","type":"function"},{"doc":"Initializes the MultiLineInput state, harmonizing style/theme/extra props and splitting lines for editing.","ref":"Raxol.UI.Components.Input.MultiLineInput.html#init/1","title":"Raxol.UI.Components.Input.MultiLineInput.init/1","type":"function"},{"doc":"Mounts the MultiLineInput component. Performs any setup needed after initialization.","ref":"Raxol.UI.Components.Input.MultiLineInput.html#mount/1","title":"Raxol.UI.Components.Input.MultiLineInput.mount/1","type":"function"},{"doc":"Renders the MultiLineInput component using the current state and context.","ref":"Raxol.UI.Components.Input.MultiLineInput.html#render/2","title":"Raxol.UI.Components.Input.MultiLineInput.render/2","type":"function"},{"doc":"State for the MultiLineInput component. See @type t for field details.","ref":"Raxol.UI.Components.Input.MultiLineInput.html#t:t/0","title":"Raxol.UI.Components.Input.MultiLineInput.t/0","type":"type"},{"doc":"Unmounts the MultiLineInput component, performing any necessary cleanup.","ref":"Raxol.UI.Components.Input.MultiLineInput.html#unmount/1","title":"Raxol.UI.Components.Input.MultiLineInput.unmount/1","type":"function"},{"doc":"UI adapter for MultiLineInput's ClipboardHelper. Delegates to the implementation in\nRaxol.UI.Components.Input.MultiLineInput.ClipboardHelper.","ref":"Raxol.UI.Components.Input.MultiLineInput.ClipboardHelper.html","title":"Raxol.UI.Components.Input.MultiLineInput.ClipboardHelper","type":"module"},{"doc":"Copies the currently selected text to the clipboard.","ref":"Raxol.UI.Components.Input.MultiLineInput.ClipboardHelper.html#copy_selection/1","title":"Raxol.UI.Components.Input.MultiLineInput.ClipboardHelper.copy_selection/1","type":"function"},{"doc":"Cuts the selected text (copies then deletes).","ref":"Raxol.UI.Components.Input.MultiLineInput.ClipboardHelper.html#cut_selection/1","title":"Raxol.UI.Components.Input.MultiLineInput.ClipboardHelper.cut_selection/1","type":"function"},{"doc":"Initiates a paste operation from clipboard.","ref":"Raxol.UI.Components.Input.MultiLineInput.ClipboardHelper.html#paste/1","title":"Raxol.UI.Components.Input.MultiLineInput.ClipboardHelper.paste/1","type":"function"},{"doc":"Handles events for the MultiLineInput component.","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_backspace/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_backspace/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_character_input/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_character_input/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_delete/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_delete/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_down_arrow_navigation/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_down_arrow_navigation/2","type":"function"},{"doc":"Handles events for the multi-line input component.","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_event/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_event/2","type":"function"},{"doc":"* `event` - The event to handle\n* `state` - The current state of the component","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_event/2-parameters","title":"Parameters - Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_event/2","type":"function"},{"doc":"A tuple of `{:ok, new_state}` or `{:error, reason}`.","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_event/2-returns","title":"Returns - Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_event/2","type":"function"},{"doc":"Handles key events for MultiLineInput, translating them into update messages for the component. Only processes events when the key state is :pressed or :repeat.","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_key_event/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_key_event/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_left_arrow_navigation/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_left_arrow_navigation/2","type":"function"},{"doc":"Handles mouse events for MultiLineInput, supporting both x/y fields and position tuple formats.\nReturns an update message to move the cursor to the clicked position.","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_mouse_event/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_mouse_event/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_new_line/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_new_line/2","type":"function"},{"doc":"Handles resize events.","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_resize_event/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_resize_event/2","type":"function"},{"doc":"- _event: The resize event\n  - state: The current state","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_resize_event/2-parameters","title":"Parameters - Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_resize_event/2","type":"function"},{"doc":"- {:ok, updated_state}","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_resize_event/2-returns","title":"Returns - Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_resize_event/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_right_arrow_navigation/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_right_arrow_navigation/2","type":"function"},{"doc":"Handles scroll events.","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_scroll_event/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_scroll_event/2","type":"function"},{"doc":"- _event: The scroll event\n  - state: The current state","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_scroll_event/2-parameters","title":"Parameters - Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_scroll_event/2","type":"function"},{"doc":"- {:ok, updated_state}","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_scroll_event/2-returns","title":"Returns - Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_scroll_event/2","type":"function"},{"doc":"Special case for testing: handles the :pagedown key event directly, returning an update message to move the cursor down by one page.","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_special_case_pagedown/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_special_case_pagedown/2","type":"function"},{"doc":"Special case for testing: handles the :pageup key event directly, returning an update message to move the cursor up by one page.","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_special_case_pageup/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_special_case_pageup/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_special_case_shift_arrow/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_special_case_shift_arrow/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_tab_completion/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_tab_completion/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_unhandled_event/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_unhandled_event/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.html#handle_up_arrow_navigation/2","title":"Raxol.UI.Components.Input.MultiLineInput.EventHandler.handle_up_arrow_navigation/2","type":"function"},{"doc":"Helper functions for cursor navigation and text selection in MultiLineInput.","ref":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.html","title":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.html#clear_selection/1","title":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.clear_selection/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.html#is_line_in_selection?/3","title":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.is_line_in_selection?/3","type":"function"},{"doc":"Moves the cursor.\n\nIt can take a `{row, col}` tuple to move to a specific position, or an atom to move directionally.","ref":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.html#move_cursor/2","title":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.move_cursor/2","type":"function"},{"doc":"- `{row, col}`: Moves to the specified position, clamped to document bounds.\n- `:left`: Moves one position to the left, or to the end of the previous line.\n- `:right`: Moves one position to the right, or to the start of the next line.\n- `:up`: Moves up by one line.\n- `:down`: Moves down by one line.\n- `:word_left`: Moves one word to the left.\n- `:word_right`: Moves one word to the right.","ref":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.html#move_cursor/2-directions","title":"Directions - Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.move_cursor/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.html#move_cursor_doc_end/1","title":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.move_cursor_doc_end/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.html#move_cursor_doc_start/1","title":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.move_cursor_doc_start/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.html#move_cursor_line_end/1","title":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.move_cursor_line_end/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.html#move_cursor_line_start/1","title":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.move_cursor_line_start/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.html#move_cursor_page/2","title":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.move_cursor_page/2","type":"function"},{"doc":"Moves the cursor one word to the left, using regex to find the previous word boundary.","ref":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.html#move_cursor_word_left/1","title":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.move_cursor_word_left/1","type":"function"},{"doc":"Moves the cursor one word to the right, using regex to find the next word boundary.","ref":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.html#move_cursor_word_right/1","title":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.move_cursor_word_right/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.html#normalize_selection/1","title":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.normalize_selection/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.html#select/2","title":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.select/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.html#select_all/1","title":"Raxol.UI.Components.Input.MultiLineInput.NavigationHelper.select_all/1","type":"function"},{"doc":"UI adapter for MultiLineInput's RenderHelper. Delegates to the implementation in\nRaxol.UI.Components.Input.MultiLineInput.RenderHelper.","ref":"Raxol.UI.Components.Input.MultiLineInput.RenderHelper.html","title":"Raxol.UI.Components.Input.MultiLineInput.RenderHelper","type":"module"},{"doc":"Renders the multi-line input component with proper styling based on the state.\nReturns a grid of cell data for the visible portion of text.\n\nDelegates to the implementation in Raxol.UI.Components.Input.MultiLineInput.RenderHelper.","ref":"Raxol.UI.Components.Input.MultiLineInput.RenderHelper.html#render/3","title":"Raxol.UI.Components.Input.MultiLineInput.RenderHelper.render/3","type":"function"},{"doc":"- state: The MultiLineInput state\n- context: The render context\n- theme: The theme containing style information","ref":"Raxol.UI.Components.Input.MultiLineInput.RenderHelper.html#render/3-parameters","title":"Parameters - Raxol.UI.Components.Input.MultiLineInput.RenderHelper.render/3","type":"function"},{"doc":"Renders a single line of the multi-line input, applying selection and cursor styles as needed.\nReturns a list of label components for the segments of the line.","ref":"Raxol.UI.Components.Input.MultiLineInput.RenderHelper.html#render_line/4","title":"Raxol.UI.Components.Input.MultiLineInput.RenderHelper.render_line/4","type":"function"},{"doc":"Helper functions for text and line manipulation in MultiLineInput.","ref":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.html","title":"Raxol.UI.Components.Input.MultiLineInput.TextHelper","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.html#calculate_new_position/3","title":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.calculate_new_position/3","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.html#clamp/3","title":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.clamp/3","type":"function"},{"doc":"Deletes the currently selected text in the state, updating lines and value.","ref":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.html#delete_selection/1","title":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.delete_selection/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.html#handle_backspace_no_selection/1","title":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.handle_backspace_no_selection/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.html#handle_delete_no_selection/1","title":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.handle_delete_no_selection/1","type":"function"},{"doc":"Inserts a character or codepoint at the current cursor position in the state, updating lines and value.","ref":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.html#insert_char/2","title":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.insert_char/2","type":"function"},{"doc":"Converts a {row, col} tuple to a flat string index based on the provided lines.","ref":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.html#pos_to_index/2","title":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.pos_to_index/2","type":"function"},{"doc":"Replaces text within a range (from start_pos_tuple to end_pos_tuple) with the given replacement string. Returns {new_full_text, replaced_text}.","ref":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.html#replace_text_range/4","title":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.replace_text_range/4","type":"function"},{"doc":"Splits the given text into lines and applies the provided wrapping function to each line.","ref":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.html#split_and_wrap/3","title":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.split_and_wrap/3","type":"function"},{"doc":"Splits the given text into lines, applying the specified wrapping mode (:none, :char, or :word).","ref":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.html#split_into_lines/3","title":"Raxol.UI.Components.Input.MultiLineInput.TextHelper.split_into_lines/3","type":"function"},{"doc":"A component that allows users to select an option from a list.\n\nFeatures:\n* Single or multiple selections\n* Robust keyboard navigation with stateful scrolling\n* Search/filtering capabilities\n* Accessibility support\n* Custom styling and theming\n* Pagination for very large lists","ref":"Raxol.UI.Components.Input.SelectList.html","title":"Raxol.UI.Components.Input.SelectList","type":"module"},{"doc":"Handles events for the SelectList component, such as keypresses, mouse events, and context changes.","ref":"Raxol.UI.Components.Input.SelectList.html#handle_event/3","title":"Raxol.UI.Components.Input.SelectList.handle_event/3","type":"function"},{"doc":"Initializes the SelectList component state from the given props.","ref":"Raxol.UI.Components.Input.SelectList.html#init/1","title":"Raxol.UI.Components.Input.SelectList.init/1","type":"function"},{"doc":"Mounts the SelectList component. Performs any setup needed after initialization.","ref":"Raxol.UI.Components.Input.SelectList.html#mount/1","title":"Raxol.UI.Components.Input.SelectList.mount/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.SelectList.html#t:option/0","title":"Raxol.UI.Components.Input.SelectList.option/0","type":"type"},{"doc":"","ref":"Raxol.UI.Components.Input.SelectList.html#t:options/0","title":"Raxol.UI.Components.Input.SelectList.options/0","type":"type"},{"doc":"","ref":"Raxol.UI.Components.Input.SelectList.html#t:props/0","title":"Raxol.UI.Components.Input.SelectList.props/0","type":"type"},{"doc":"Renders the SelectList component using the current state and context.","ref":"Raxol.UI.Components.Input.SelectList.html#render/2","title":"Raxol.UI.Components.Input.SelectList.render/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.SelectList.html#t:state/0","title":"Raxol.UI.Components.Input.SelectList.state/0","type":"type"},{"doc":"Unmounts the SelectList component, performing any necessary cleanup.","ref":"Raxol.UI.Components.Input.SelectList.html#unmount/1","title":"Raxol.UI.Components.Input.SelectList.unmount/1","type":"function"},{"doc":"Updates the SelectList component state in response to messages or prop changes.","ref":"Raxol.UI.Components.Input.SelectList.html#update/2","title":"Raxol.UI.Components.Input.SelectList.update/2","type":"function"},{"doc":"Handles keyboard navigation functionality for the SelectList component.","ref":"Raxol.UI.Components.Input.SelectList.Navigation.html","title":"Raxol.UI.Components.Input.SelectList.Navigation","type":"module"},{"doc":"Calculates the index of the option clicked based on the y position and current state.\nReturns the index, or -1 if out of bounds.","ref":"Raxol.UI.Components.Input.SelectList.Navigation.html#calculate_clicked_index/2","title":"Raxol.UI.Components.Input.SelectList.Navigation.calculate_clicked_index/2","type":"function"},{"doc":"Handles arrow down key press, moving focus down one item.","ref":"Raxol.UI.Components.Input.SelectList.Navigation.html#handle_arrow_down/1","title":"Raxol.UI.Components.Input.SelectList.Navigation.handle_arrow_down/1","type":"function"},{"doc":"Handles arrow up key press, moving focus up one item.","ref":"Raxol.UI.Components.Input.SelectList.Navigation.html#handle_arrow_up/1","title":"Raxol.UI.Components.Input.SelectList.Navigation.handle_arrow_up/1","type":"function"},{"doc":"Handles end key press, moving focus to the last item.","ref":"Raxol.UI.Components.Input.SelectList.Navigation.html#handle_end/1","title":"Raxol.UI.Components.Input.SelectList.Navigation.handle_end/1","type":"function"},{"doc":"Handles home key press, moving focus to the first item.","ref":"Raxol.UI.Components.Input.SelectList.Navigation.html#handle_home/1","title":"Raxol.UI.Components.Input.SelectList.Navigation.handle_home/1","type":"function"},{"doc":"Handles page down key press, moving focus down one page.","ref":"Raxol.UI.Components.Input.SelectList.Navigation.html#handle_page_down/1","title":"Raxol.UI.Components.Input.SelectList.Navigation.handle_page_down/1","type":"function"},{"doc":"Handles page up key press, moving focus up one page.","ref":"Raxol.UI.Components.Input.SelectList.Navigation.html#handle_page_up/1","title":"Raxol.UI.Components.Input.SelectList.Navigation.handle_page_up/1","type":"function"},{"doc":"Updates focus index and scroll position to ensure the focused item is visible.","ref":"Raxol.UI.Components.Input.SelectList.Navigation.html#update_focus_and_scroll/2","title":"Raxol.UI.Components.Input.SelectList.Navigation.update_focus_and_scroll/2","type":"function"},{"doc":"Recalculates scroll position to ensure the focused item is visible after a resize or visible_height change.\nAlways returns a valid state map.","ref":"Raxol.UI.Components.Input.SelectList.Navigation.html#update_scroll_position/1","title":"Raxol.UI.Components.Input.SelectList.Navigation.update_scroll_position/1","type":"function"},{"doc":"Handles pagination functionality for the SelectList component.","ref":"Raxol.UI.Components.Input.SelectList.Pagination.html","title":"Raxol.UI.Components.Input.SelectList.Pagination","type":"module"},{"doc":"Calculates the total number of pages based on the number of options and page size.","ref":"Raxol.UI.Components.Input.SelectList.Pagination.html#calculate_total_pages/2","title":"Raxol.UI.Components.Input.SelectList.Pagination.calculate_total_pages/2","type":"function"},{"doc":"Gets the effective options list (filtered or original) based on current state.","ref":"Raxol.UI.Components.Input.SelectList.Pagination.html#get_effective_options/1","title":"Raxol.UI.Components.Input.SelectList.Pagination.get_effective_options/1","type":"function"},{"doc":"Gets the options for a specific page.","ref":"Raxol.UI.Components.Input.SelectList.Pagination.html#get_page_options/3","title":"Raxol.UI.Components.Input.SelectList.Pagination.get_page_options/3","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.SelectList.Pagination.html#t:option/0","title":"Raxol.UI.Components.Input.SelectList.Pagination.option/0","type":"type"},{"doc":"","ref":"Raxol.UI.Components.Input.SelectList.Pagination.html#t:options/0","title":"Raxol.UI.Components.Input.SelectList.Pagination.options/0","type":"type"},{"doc":"Updates pagination state based on a new page number.","ref":"Raxol.UI.Components.Input.SelectList.Pagination.html#update_page_state/2","title":"Raxol.UI.Components.Input.SelectList.Pagination.update_page_state/2","type":"function"},{"doc":"Handles rendering functionality for the SelectList component.","ref":"Raxol.UI.Components.Input.SelectList.Renderer.html","title":"Raxol.UI.Components.Input.SelectList.Renderer","type":"module"},{"doc":"Renders the SelectList component.","ref":"Raxol.UI.Components.Input.SelectList.Renderer.html#render/2","title":"Raxol.UI.Components.Input.SelectList.Renderer.render/2","type":"function"},{"doc":"Renders the main list container with options.","ref":"Raxol.UI.Components.Input.SelectList.Renderer.html#render_list_container/2","title":"Raxol.UI.Components.Input.SelectList.Renderer.render_list_container/2","type":"function"},{"doc":"Renders a single option.","ref":"Raxol.UI.Components.Input.SelectList.Renderer.html#render_option/5","title":"Raxol.UI.Components.Input.SelectList.Renderer.render_option/5","type":"function"},{"doc":"Renders the list of options.","ref":"Raxol.UI.Components.Input.SelectList.Renderer.html#render_options/2","title":"Raxol.UI.Components.Input.SelectList.Renderer.render_options/2","type":"function"},{"doc":"Renders pagination controls.","ref":"Raxol.UI.Components.Input.SelectList.Renderer.html#render_pagination_controls/1","title":"Raxol.UI.Components.Input.SelectList.Renderer.render_pagination_controls/1","type":"function"},{"doc":"Renders the search input element.","ref":"Raxol.UI.Components.Input.SelectList.Renderer.html#render_search_input/1","title":"Raxol.UI.Components.Input.SelectList.Renderer.render_search_input/1","type":"function"},{"doc":"Handles search and filtering functionality for the SelectList component.","ref":"Raxol.UI.Components.Input.SelectList.Search.html","title":"Raxol.UI.Components.Input.SelectList.Search","type":"module"},{"doc":"Filters options based on search text and optional searchable fields.\nReturns nil if no search text is provided, otherwise returns filtered options.","ref":"Raxol.UI.Components.Input.SelectList.Search.html#filter_options/3","title":"Raxol.UI.Components.Input.SelectList.Search.filter_options/3","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.SelectList.Search.html#t:option/0","title":"Raxol.UI.Components.Input.SelectList.Search.option/0","type":"type"},{"doc":"","ref":"Raxol.UI.Components.Input.SelectList.Search.html#t:options/0","title":"Raxol.UI.Components.Input.SelectList.Search.options/0","type":"type"},{"doc":"Checks if an option matches the search text.\nIf searchable_fields is provided, only those fields are searched.\nOtherwise, the option label is searched.","ref":"Raxol.UI.Components.Input.SelectList.Search.html#search_matches?/3","title":"Raxol.UI.Components.Input.SelectList.Search.search_matches?/3","type":"function"},{"doc":"Updates search-related state based on new search text.","ref":"Raxol.UI.Components.Input.SelectList.Search.html#update_search_state/2","title":"Raxol.UI.Components.Input.SelectList.Search.update_search_state/2","type":"function"},{"doc":"Handles selection functionality for the SelectList component.","ref":"Raxol.UI.Components.Input.SelectList.Selection.html","title":"Raxol.UI.Components.Input.SelectList.Selection","type":"module"},{"doc":"Generates commands based on selection callbacks.","ref":"Raxol.UI.Components.Input.SelectList.Selection.html#generate_selection_commands/2","title":"Raxol.UI.Components.Input.SelectList.Selection.generate_selection_commands/2","type":"function"},{"doc":"Updates selection state based on a selected index.\nReturns updated state and any commands to execute.","ref":"Raxol.UI.Components.Input.SelectList.Selection.html#handle_select/1","title":"Raxol.UI.Components.Input.SelectList.Selection.handle_select/1","type":"function"},{"doc":"Updates selection state for a specific index.","ref":"Raxol.UI.Components.Input.SelectList.Selection.html#update_selection_state/2","title":"Raxol.UI.Components.Input.SelectList.Selection.update_selection_state/2","type":"function"},{"doc":"A simple single-line text input component.","ref":"Raxol.UI.Components.Input.SingleLineInput.html","title":"Raxol.UI.Components.Input.SingleLineInput","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Input.SingleLineInput.html#broadcast/1","title":"Raxol.UI.Components.Input.SingleLineInput.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.SingleLineInput.html#command/1","title":"Raxol.UI.Components.Input.SingleLineInput.command/1","type":"function"},{"doc":"Handles events for the SingleLineInput component, such as keypresses and mouse clicks.","ref":"Raxol.UI.Components.Input.SingleLineInput.html#handle_event/3","title":"Raxol.UI.Components.Input.SingleLineInput.handle_event/3","type":"function"},{"doc":"Initializes the SingleLineInput component state from the given props.","ref":"Raxol.UI.Components.Input.SingleLineInput.html#init/1","title":"Raxol.UI.Components.Input.SingleLineInput.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.Input.SingleLineInput.html#mount/1","title":"Raxol.UI.Components.Input.SingleLineInput.mount/1","type":"function"},{"doc":"Renders the SingleLineInput component using the current state and props.","ref":"Raxol.UI.Components.Input.SingleLineInput.html#render/2","title":"Raxol.UI.Components.Input.SingleLineInput.render/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.SingleLineInput.html#schedule/2","title":"Raxol.UI.Components.Input.SingleLineInput.schedule/2","type":"function"},{"doc":"State for the SingleLineInput component.\n\n- :id - unique identifier\n- :value - current text value\n- :placeholder - placeholder text\n- :style - style map\n- :focused - whether the field is focused\n- :cursor_pos - cursor position\n- :on_change - callback for value change\n- :on_submit - callback for submit action","ref":"Raxol.UI.Components.Input.SingleLineInput.html#t:t/0","title":"Raxol.UI.Components.Input.SingleLineInput.t/0","type":"type"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.Input.SingleLineInput.html#unmount/1","title":"Raxol.UI.Components.Input.SingleLineInput.unmount/1","type":"function"},{"doc":"Updates the SingleLineInput component state in response to messages or prop changes.","ref":"Raxol.UI.Components.Input.SingleLineInput.html#update/2","title":"Raxol.UI.Components.Input.SingleLineInput.update/2","type":"function"},{"doc":"A text field component for single-line text input.\n\nIt supports validation, placeholders, masks, and styling.","ref":"Raxol.UI.Components.Input.TextField.html","title":"Raxol.UI.Components.Input.TextField","type":"module"},{"doc":"Handles events for the TextField component, such as keypresses, focus, and blur.","ref":"Raxol.UI.Components.Input.TextField.html#handle_event/3","title":"Raxol.UI.Components.Input.TextField.handle_event/3","type":"function"},{"doc":"Initializes the TextField component state from the given props.","ref":"Raxol.UI.Components.Input.TextField.html#init/1","title":"Raxol.UI.Components.Input.TextField.init/1","type":"function"},{"doc":"Mounts the TextField component. Performs any setup needed after initialization.","ref":"Raxol.UI.Components.Input.TextField.html#mount/1","title":"Raxol.UI.Components.Input.TextField.mount/1","type":"function"},{"doc":"Renders the TextField component using the current state and context.","ref":"Raxol.UI.Components.Input.TextField.html#render/2","title":"Raxol.UI.Components.Input.TextField.render/2","type":"function"},{"doc":"State for the TextField component.\n\n- :id - unique identifier\n- :value - current text value\n- :placeholder - placeholder text\n- :style - style map\n- :theme - theme map\n- :disabled - whether the field is disabled\n- :secret - whether to mask input (e.g., password)\n- :focused - whether the field is focused\n- :cursor_pos - cursor position\n- :scroll_offset - horizontal scroll offset\n- :width - visible width of the field (not in defstruct, but added in init)","ref":"Raxol.UI.Components.Input.TextField.html#t:t/0","title":"Raxol.UI.Components.Input.TextField.t/0","type":"type"},{"doc":"Unmounts the TextField component, performing any necessary cleanup.","ref":"Raxol.UI.Components.Input.TextField.html#unmount/1","title":"Raxol.UI.Components.Input.TextField.unmount/1","type":"function"},{"doc":"Updates the TextField component state in response to messages or prop changes.","ref":"Raxol.UI.Components.Input.TextField.html#update/2","title":"Raxol.UI.Components.Input.TextField.update/2","type":"function"},{"doc":"A text input component for capturing user text input.\n\nFeatures:\n* Customizable placeholder text\n* Value binding\n* Focus handling\n* Character validation\n* Input masking (for password fields)\n* Event callbacks","ref":"Raxol.UI.Components.Input.TextInput.html","title":"Raxol.UI.Components.Input.TextInput","type":"module"},{"doc":"Handles events for the TextInput component, such as keypresses, focus, blur, and mouse events.","ref":"Raxol.UI.Components.Input.TextInput.html#handle_event/3","title":"Raxol.UI.Components.Input.TextInput.handle_event/3","type":"function"},{"doc":"Initializes the TextInput component state from the given props.","ref":"Raxol.UI.Components.Input.TextInput.html#init/1","title":"Raxol.UI.Components.Input.TextInput.init/1","type":"function"},{"doc":"Mounts the TextInput component. Performs any setup needed after initialization.","ref":"Raxol.UI.Components.Input.TextInput.html#mount/1","title":"Raxol.UI.Components.Input.TextInput.mount/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.TextInput.html#t:props/0","title":"Raxol.UI.Components.Input.TextInput.props/0","type":"type"},{"doc":"Renders the TextInput component using the current state and context.","ref":"Raxol.UI.Components.Input.TextInput.html#render/2","title":"Raxol.UI.Components.Input.TextInput.render/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Input.TextInput.html#t:state/0","title":"Raxol.UI.Components.Input.TextInput.state/0","type":"type"},{"doc":"Unmounts the TextInput component, performing any necessary cleanup.","ref":"Raxol.UI.Components.Input.TextInput.html#unmount/1","title":"Raxol.UI.Components.Input.TextInput.unmount/1","type":"function"},{"doc":"Updates the TextInput component state in response to messages or prop changes.","ref":"Raxol.UI.Components.Input.TextInput.html#update/2","title":"Raxol.UI.Components.Input.TextInput.update/2","type":"function"},{"doc":"Handles text manipulation operations for the TextInput component.\nThis includes inserting, deleting, and pasting text.","ref":"Raxol.UI.Components.Input.TextInput.Manipulation.html","title":"Raxol.UI.Components.Input.TextInput.Manipulation","type":"module"},{"doc":"Deletes the character before the cursor.","ref":"Raxol.UI.Components.Input.TextInput.Manipulation.html#delete_char_backward/1","title":"Raxol.UI.Components.Input.TextInput.Manipulation.delete_char_backward/1","type":"function"},{"doc":"Deletes a character forward from the current cursor position.","ref":"Raxol.UI.Components.Input.TextInput.Manipulation.html#delete_char_forward/1","title":"Raxol.UI.Components.Input.TextInput.Manipulation.delete_char_forward/1","type":"function"},{"doc":"Deletes the selected text and updates the cursor position.","ref":"Raxol.UI.Components.Input.TextInput.Manipulation.html#delete_selected_text/3","title":"Raxol.UI.Components.Input.TextInput.Manipulation.delete_selected_text/3","type":"function"},{"doc":"Inserts a character at the current cursor position.","ref":"Raxol.UI.Components.Input.TextInput.Manipulation.html#insert_char/2","title":"Raxol.UI.Components.Input.TextInput.Manipulation.insert_char/2","type":"function"},{"doc":"Pastes text at the specified position, optionally replacing selected text.","ref":"Raxol.UI.Components.Input.TextInput.Manipulation.html#paste_at_position/4","title":"Raxol.UI.Components.Input.TextInput.Manipulation.paste_at_position/4","type":"function"},{"doc":"Handles rendering logic for the TextInput component.\nThis includes display value formatting, style management, and visual feedback.","ref":"Raxol.UI.Components.Input.TextInput.Renderer.html","title":"Raxol.UI.Components.Input.TextInput.Renderer","type":"module"},{"doc":"Renders the text input component with appropriate styling and visual feedback.","ref":"Raxol.UI.Components.Input.TextInput.Renderer.html#render/1","title":"Raxol.UI.Components.Input.TextInput.Renderer.render/1","type":"function"},{"doc":"Handles cursor and text selection operations for the TextInput component.\nThis includes cursor movement, text selection, and selection clearing.","ref":"Raxol.UI.Components.Input.TextInput.Selection.html","title":"Raxol.UI.Components.Input.TextInput.Selection","type":"module"},{"doc":"Clears any existing text selection.","ref":"Raxol.UI.Components.Input.TextInput.Selection.html#clear_selection/1","title":"Raxol.UI.Components.Input.TextInput.Selection.clear_selection/1","type":"function"},{"doc":"Gets the currently selected text, if any.","ref":"Raxol.UI.Components.Input.TextInput.Selection.html#get_selected_text/1","title":"Raxol.UI.Components.Input.TextInput.Selection.get_selected_text/1","type":"function"},{"doc":"Moves the cursor by the specified offset, ensuring it stays within bounds.","ref":"Raxol.UI.Components.Input.TextInput.Selection.html#move_cursor/2","title":"Raxol.UI.Components.Input.TextInput.Selection.move_cursor/2","type":"function"},{"doc":"Moves the cursor to the end of the text.","ref":"Raxol.UI.Components.Input.TextInput.Selection.html#move_to_end/1","title":"Raxol.UI.Components.Input.TextInput.Selection.move_to_end/1","type":"function"},{"doc":"Moves the cursor to the start of the text.","ref":"Raxol.UI.Components.Input.TextInput.Selection.html#move_to_home/1","title":"Raxol.UI.Components.Input.TextInput.Selection.move_to_home/1","type":"function"},{"doc":"Extends or creates a text selection by moving the cursor.","ref":"Raxol.UI.Components.Input.TextInput.Selection.html#select_text/2","title":"Raxol.UI.Components.Input.TextInput.Selection.select_text/2","type":"function"},{"doc":"Selects text from the current cursor position to the end of the text.","ref":"Raxol.UI.Components.Input.TextInput.Selection.html#select_to_end/1","title":"Raxol.UI.Components.Input.TextInput.Selection.select_to_end/1","type":"function"},{"doc":"Selects text from the current cursor position to the start of the text.","ref":"Raxol.UI.Components.Input.TextInput.Selection.html#select_to_home/1","title":"Raxol.UI.Components.Input.TextInput.Selection.select_to_home/1","type":"function"},{"doc":"Handles input validation for the TextInput component.\nThis includes length validation, pattern matching, and error message generation.","ref":"Raxol.UI.Components.Input.TextInput.Validation.html","title":"Raxol.UI.Components.Input.TextInput.Validation","type":"module"},{"doc":"Validates the input value against the component's constraints.\nReturns a new state with any validation errors.","ref":"Raxol.UI.Components.Input.TextInput.Validation.html#validate_input/1","title":"Raxol.UI.Components.Input.TextInput.Validation.validate_input/1","type":"function"},{"doc":"Validates a value's length against a maximum.\nReturns :ok if valid, {:error, reason} if invalid.","ref":"Raxol.UI.Components.Input.TextInput.Validation.html#validate_length/2","title":"Raxol.UI.Components.Input.TextInput.Validation.validate_length/2","type":"function"},{"doc":"Validates a value against a pattern.\nReturns :ok if valid, {:error, reason} if invalid.","ref":"Raxol.UI.Components.Input.TextInput.Validation.html#validate_pattern/2","title":"Raxol.UI.Components.Input.TextInput.Validation.validate_pattern/2","type":"function"},{"doc":"Checks if adding a character would exceed the maximum length.","ref":"Raxol.UI.Components.Input.TextInput.Validation.html#would_exceed_max_length?/2","title":"Raxol.UI.Components.Input.TextInput.Validation.would_exceed_max_length?/2","type":"function"},{"doc":"Utility functions for text wrapping.","ref":"Raxol.UI.Components.Input.TextWrapping.html","title":"Raxol.UI.Components.Input.TextWrapping","type":"module"},{"doc":"Wraps a single line of text by character count using recursion.\n\nHandles multi-byte characters correctly.","ref":"Raxol.UI.Components.Input.TextWrapping.html#wrap_line_by_char/2","title":"Raxol.UI.Components.Input.TextWrapping.wrap_line_by_char/2","type":"function"},{"doc":"Wraps a single line of text by word boundaries.","ref":"Raxol.UI.Components.Input.TextWrapping.html#wrap_line_by_word/2","title":"Raxol.UI.Components.Input.TextWrapping.wrap_line_by_word/2","type":"function"},{"doc":"Renders Markdown text into Raxol elements or raw HTML.\n\nRequires the `earmark` dependency.","ref":"Raxol.UI.Components.MarkdownRenderer.html","title":"Raxol.UI.Components.MarkdownRenderer","type":"module"},{"doc":"","ref":"Raxol.UI.Components.MarkdownRenderer.html#broadcast/1","title":"Raxol.UI.Components.MarkdownRenderer.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.MarkdownRenderer.html#command/1","title":"Raxol.UI.Components.MarkdownRenderer.command/1","type":"function"},{"doc":"Handles events for the MarkdownRenderer component. No events are handled by default.","ref":"Raxol.UI.Components.MarkdownRenderer.html#handle_event/3","title":"Raxol.UI.Components.MarkdownRenderer.handle_event/3","type":"function"},{"doc":"Initializes the MarkdownRenderer component state from props.","ref":"Raxol.UI.Components.MarkdownRenderer.html#init/1","title":"Raxol.UI.Components.MarkdownRenderer.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.MarkdownRenderer.html#mount/1","title":"Raxol.UI.Components.MarkdownRenderer.mount/1","type":"function"},{"doc":"Renders the given Markdown string.","ref":"Raxol.UI.Components.MarkdownRenderer.html#render/2","title":"Raxol.UI.Components.MarkdownRenderer.render/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.MarkdownRenderer.html#schedule/2","title":"Raxol.UI.Components.MarkdownRenderer.schedule/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.MarkdownRenderer.html#unmount/1","title":"Raxol.UI.Components.MarkdownRenderer.unmount/1","type":"function"},{"doc":"Updates the MarkdownRenderer component state. No updates are handled by default.","ref":"Raxol.UI.Components.MarkdownRenderer.html#update/2","title":"Raxol.UI.Components.MarkdownRenderer.update/2","type":"function"},{"doc":"A modal component for displaying overlay dialogs like alerts, prompts, confirmations, and forms.","ref":"Raxol.UI.Components.Modal.html","title":"Raxol.UI.Components.Modal","type":"module"},{"doc":"Creates props for an alert modal.","ref":"Raxol.UI.Components.Modal.html#alert/4","title":"Raxol.UI.Components.Modal.alert/4","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Modal.html#broadcast/1","title":"Raxol.UI.Components.Modal.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Modal.html#command/1","title":"Raxol.UI.Components.Modal.command/1","type":"function"},{"doc":"Creates props for a confirmation modal.","ref":"Raxol.UI.Components.Modal.html#confirm/6","title":"Raxol.UI.Components.Modal.confirm/6","type":"function"},{"doc":"Creates props for a form modal.\n\n`fields` should be a list of maps, each defining a form field:\n`%{id: :atom, type: :text_input | :checkbox | :dropdown, label: \"string\", value: initial_value, props: keyword_list, options: list, validate: regex | function}`\n(options only for dropdown)","ref":"Raxol.UI.Components.Modal.html#form/6","title":"Raxol.UI.Components.Modal.form/6","type":"function"},{"doc":"Initializes the Modal component state from props.","ref":"Raxol.UI.Components.Modal.html#init/1","title":"Raxol.UI.Components.Modal.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.Modal.html#mount/1","title":"Raxol.UI.Components.Modal.mount/1","type":"function"},{"doc":"Creates props for a prompt modal.","ref":"Raxol.UI.Components.Modal.html#prompt/6","title":"Raxol.UI.Components.Modal.prompt/6","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Modal.html#schedule/2","title":"Raxol.UI.Components.Modal.schedule/2","type":"function"},{"doc":"State for the Modal component.\n\n- :id - unique identifier\n- :visible - whether the modal is visible\n- :title - modal title\n- :content - modal content (text or view elements)\n- :buttons - list of {label, message} tuples\n- :type - modal type (:alert, :confirm, :prompt, :form)\n- :width - modal width\n- :style - style map\n- :form_state - state for prompt/form fields","ref":"Raxol.UI.Components.Modal.html#t:t/0","title":"Raxol.UI.Components.Modal.t/0","type":"type"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.Modal.html#unmount/1","title":"Raxol.UI.Components.Modal.unmount/1","type":"function"},{"doc":"Updates the Modal component state in response to messages. Handles show/hide, button clicks, and form updates.","ref":"Raxol.UI.Components.Modal.html#update/2","title":"Raxol.UI.Components.Modal.update/2","type":"function"},{"doc":"Provides components for displaying progress, like progress bars and spinners.","ref":"Raxol.UI.Components.Progress.html","title":"Raxol.UI.Components.Progress","type":"module"},{"doc":"Renders a simple progress bar with configurable appearance.","ref":"Raxol.UI.Components.Progress.html#bar/2","title":"Raxol.UI.Components.Progress.bar/2","type":"function"},{"doc":"* `value` - Current progress value (0.0 to 1.0)\n* `opts` - Options for customizing the progress bar","ref":"Raxol.UI.Components.Progress.html#bar/2-parameters","title":"Parameters - Raxol.UI.Components.Progress.bar/2","type":"function"},{"doc":"* `:id` - Unique identifier for the progress bar (default: \"progress_bar\")\n* `:width` - Width of the progress bar in characters (default: 20)\n* `:style` - Style for the progress bar container\n* `:filled_style` - Style for the filled portion of the bar (default: %{bg: :blue})\n* `:empty_style` - Style for the empty portion of the bar (default: %{bg: :black})\n* `:chars` - Characters to use for different parts of the bar\n  * `:filled` - Character for filled sections (default: \" \")\n  * `:empty` - Character for empty sections (default: \" \")","ref":"Raxol.UI.Components.Progress.html#bar/2-options","title":"Options - Raxol.UI.Components.Progress.bar/2","type":"function"},{"doc":"A view element representing the progress bar.","ref":"Raxol.UI.Components.Progress.html#bar/2-returns","title":"Returns - Raxol.UI.Components.Progress.bar/2","type":"function"},{"doc":"```elixir\nProgress.bar(\n  0.75,\n  width: 30,\n  filled_style: %{bg: :green},\n  chars: %{filled: \"█\", empty: \"░\"}\n)\n```","ref":"Raxol.UI.Components.Progress.html#bar/2-example","title":"Example - Raxol.UI.Components.Progress.bar/2","type":"function"},{"doc":"Renders a progress bar with a label and optional percentage display.","ref":"Raxol.UI.Components.Progress.html#bar_with_label/3","title":"Raxol.UI.Components.Progress.bar_with_label/3","type":"function"},{"doc":"* `value` - Current progress value (0.0 to 1.0)\n* `label` - Text label to display\n* `opts` - Options for customizing the progress bar","ref":"Raxol.UI.Components.Progress.html#bar_with_label/3-parameters","title":"Parameters - Raxol.UI.Components.Progress.bar_with_label/3","type":"function"},{"doc":"All options from `bar/2` plus:\n* `:show_percentage` - Whether to show percentage (default: true)\n* `:percentage_style` - Style for the percentage text (default: %{})\n* `:label_style` - Style for the label text (default: %{})\n* `:position` - Position of the label/percentage (:above, :below, :right, default: :above)","ref":"Raxol.UI.Components.Progress.html#bar_with_label/3-options","title":"Options - Raxol.UI.Components.Progress.bar_with_label/3","type":"function"},{"doc":"A view element representing the progress bar with label.","ref":"Raxol.UI.Components.Progress.html#bar_with_label/3-returns","title":"Returns - Raxol.UI.Components.Progress.bar_with_label/3","type":"function"},{"doc":"```elixir\nProgress.bar_with_label(\n  0.35,\n  \"Loading assets...\",\n  show_percentage: true,\n  position: :below,\n  filled_style: %{bg: :cyan}\n)\n```","ref":"Raxol.UI.Components.Progress.html#bar_with_label/3-example","title":"Example - Raxol.UI.Components.Progress.bar_with_label/3","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Progress.html#broadcast/1","title":"Raxol.UI.Components.Progress.broadcast/1","type":"function"},{"doc":"Renders a circular progress indicator.","ref":"Raxol.UI.Components.Progress.html#circular/2","title":"Raxol.UI.Components.Progress.circular/2","type":"function"},{"doc":"* `value` - Current progress value (0.0 to 1.0)\n* `opts` - Options for customizing the progress indicator","ref":"Raxol.UI.Components.Progress.html#circular/2-parameters","title":"Parameters - Raxol.UI.Components.Progress.circular/2","type":"function"},{"doc":"* `:id` - Unique identifier for the indicator (default: \"circular_progress\")\n* `:style` - Style for the indicator\n* `:show_percentage` - Whether to show percentage inside (default: true)\n* `:percentage_style` - Style for the percentage text","ref":"Raxol.UI.Components.Progress.html#circular/2-options","title":"Options - Raxol.UI.Components.Progress.circular/2","type":"function"},{"doc":"A view element representing the circular progress indicator.","ref":"Raxol.UI.Components.Progress.html#circular/2-returns","title":"Returns - Raxol.UI.Components.Progress.circular/2","type":"function"},{"doc":"```elixir\nProgress.circular(\n  0.65,\n  style: %{fg: :green}\n)\n```","ref":"Raxol.UI.Components.Progress.html#circular/2-example","title":"Example - Raxol.UI.Components.Progress.circular/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Progress.html#command/1","title":"Raxol.UI.Components.Progress.command/1","type":"function"},{"doc":"Renders an indeterminate progress bar (animated).","ref":"Raxol.UI.Components.Progress.html#indeterminate/2","title":"Raxol.UI.Components.Progress.indeterminate/2","type":"function"},{"doc":"* `frame` - Current animation frame (integer, typically incremented on each render)\n* `opts` - Options for customizing the indeterminate progress bar","ref":"Raxol.UI.Components.Progress.html#indeterminate/2-parameters","title":"Parameters - Raxol.UI.Components.Progress.indeterminate/2","type":"function"},{"doc":"* `:id` - Unique identifier for the progress bar (default: \"indeterminate_progress\")\n* `:width` - Width of the progress bar in characters (default: 20)\n* `:style` - Style for the progress bar container\n* `:bar_style` - Style for the animated bar (default: %{bg: :blue})\n* `:background_style` - Style for the background (default: %{bg: :black})\n* `:segment_size` - Size of the animated segment (default: 5)","ref":"Raxol.UI.Components.Progress.html#indeterminate/2-options","title":"Options - Raxol.UI.Components.Progress.indeterminate/2","type":"function"},{"doc":"A view element representing the indeterminate progress bar.","ref":"Raxol.UI.Components.Progress.html#indeterminate/2-returns","title":"Returns - Raxol.UI.Components.Progress.indeterminate/2","type":"function"},{"doc":"```elixir\nProgress.indeterminate(\n  model.animation_frame,\n  width: 30,\n  bar_style: %{bg: :purple},\n  segment_size: 8\n)\n```","ref":"Raxol.UI.Components.Progress.html#indeterminate/2-example","title":"Example - Raxol.UI.Components.Progress.indeterminate/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.Progress.html#mount/1","title":"Raxol.UI.Components.Progress.mount/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Progress.html#schedule/2","title":"Raxol.UI.Components.Progress.schedule/2","type":"function"},{"doc":"Renders a spinner animation for indicating loading or processing.","ref":"Raxol.UI.Components.Progress.html#spinner/3","title":"Raxol.UI.Components.Progress.spinner/3","type":"function"},{"doc":"* `message` - Optional message to display next to the spinner\n* `frame` - Current animation frame (integer, typically incremented on each render)\n* `opts` - Options for customizing the spinner","ref":"Raxol.UI.Components.Progress.html#spinner/3-parameters","title":"Parameters - Raxol.UI.Components.Progress.spinner/3","type":"function"},{"doc":"* `:id` - Unique identifier for the spinner (default: \"spinner\")\n* `:style` - Style for the spinner container\n* `:spinner_style` - Style for the spinner character\n* `:message_style` - Style for the message text\n* `:type` - Type of spinner animation (default: :dots)","ref":"Raxol.UI.Components.Progress.html#spinner/3-options","title":"Options - Raxol.UI.Components.Progress.spinner/3","type":"function"},{"doc":"A view element representing the spinner.","ref":"Raxol.UI.Components.Progress.html#spinner/3-returns","title":"Returns - Raxol.UI.Components.Progress.spinner/3","type":"function"},{"doc":"```elixir\n# In your update function, increment the frame on each update\ndef update(model, :tick) do\n  %{model | spinner_frame: model.spinner_frame + 1}\nend\n\n# In your view function\nProgress.spinner(\n  \"Processing data...\",\n  model.spinner_frame,\n  type: :braille,\n  spinner_style: %{fg: :cyan}\n)\n```","ref":"Raxol.UI.Components.Progress.html#spinner/3-example","title":"Example - Raxol.UI.Components.Progress.spinner/3","type":"function"},{"doc":"Returns the available spinner types.","ref":"Raxol.UI.Components.Progress.html#spinner_types/0","title":"Raxol.UI.Components.Progress.spinner_types/0","type":"function"},{"doc":"A map of spinner types to their frame sequences.","ref":"Raxol.UI.Components.Progress.html#spinner_types/0-returns","title":"Returns - Raxol.UI.Components.Progress.spinner_types/0","type":"function"},{"doc":"```elixir\nspinner_types = Progress.spinner_types()\n```","ref":"Raxol.UI.Components.Progress.html#spinner_types/0-example","title":"Example - Raxol.UI.Components.Progress.spinner_types/0","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.Progress.html#unmount/1","title":"Raxol.UI.Components.Progress.unmount/1","type":"function"},{"doc":"A component to display a progress bar.","ref":"Raxol.UI.Components.Progress.ProgressBar.html","title":"Raxol.UI.Components.Progress.ProgressBar","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Progress.ProgressBar.html#broadcast/1","title":"Raxol.UI.Components.Progress.ProgressBar.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Progress.ProgressBar.html#command/1","title":"Raxol.UI.Components.Progress.ProgressBar.command/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.Progress.ProgressBar.html#mount/1","title":"Raxol.UI.Components.Progress.ProgressBar.mount/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Progress.ProgressBar.html#schedule/2","title":"Raxol.UI.Components.Progress.ProgressBar.schedule/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.Progress.ProgressBar.html#unmount/1","title":"Raxol.UI.Components.Progress.ProgressBar.unmount/1","type":"function"},{"doc":"A spinner component that provides animated loading indicators.","ref":"Raxol.UI.Components.Progress.Spinner.html","title":"Raxol.UI.Components.Progress.Spinner","type":"module"},{"doc":"* `:style` - The animation style to use (default: :dots)\n  * `:dots` - Rotating dots (⠋⠙⠹⠸⠼⠴⠦⠧⠇⠏)\n  * `:line` - Rotating line (|/-\\)\n  * `:bounce` - Bouncing ball (⠁⠂⠄⠂)\n  * `:pulse` - Pulsing circle (●○)\n  * `:custom` - Custom animation using `:frames`\n  * `:frames` - List of characters to use for custom animation\n  * `:colors` - List of colors to transition between\n  * `:speed` - Animation speed in milliseconds (default: 80)\n  * `:text` - Optional text to display next to the spinner\n  * `:text_position` - Position of text relative to spinner (:left or :right, default: :right)","ref":"Raxol.UI.Components.Progress.Spinner.html#module-props","title":"Props - Raxol.UI.Components.Progress.Spinner","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Progress.Spinner.html#broadcast/1","title":"Raxol.UI.Components.Progress.Spinner.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Progress.Spinner.html#command/1","title":"Raxol.UI.Components.Progress.Spinner.command/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Progress.Spinner.html#error/1","title":"Raxol.UI.Components.Progress.Spinner.error/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Progress.Spinner.html#loading/1","title":"Raxol.UI.Components.Progress.Spinner.loading/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.Progress.Spinner.html#mount/1","title":"Raxol.UI.Components.Progress.Spinner.mount/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Progress.Spinner.html#processing/1","title":"Raxol.UI.Components.Progress.Spinner.processing/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Progress.Spinner.html#saving/1","title":"Raxol.UI.Components.Progress.Spinner.saving/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Progress.Spinner.html#schedule/2","title":"Raxol.UI.Components.Progress.Spinner.schedule/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.Progress.Spinner.html#unmount/1","title":"Raxol.UI.Components.Progress.Spinner.unmount/1","type":"function"},{"doc":"A dropdown component that allows selecting one option from a list.","ref":"Raxol.UI.Components.Selection.Dropdown.html","title":"Raxol.UI.Components.Selection.Dropdown","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Selection.Dropdown.html#broadcast/1","title":"Raxol.UI.Components.Selection.Dropdown.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Selection.Dropdown.html#command/1","title":"Raxol.UI.Components.Selection.Dropdown.command/1","type":"function"},{"doc":"Handles key events for the Dropdown component, including toggling expansion and forwarding to the list.","ref":"Raxol.UI.Components.Selection.Dropdown.html#handle_event/3","title":"Raxol.UI.Components.Selection.Dropdown.handle_event/3","type":"function"},{"doc":"Initializes the Dropdown component state from props.","ref":"Raxol.UI.Components.Selection.Dropdown.html#init/1","title":"Raxol.UI.Components.Selection.Dropdown.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.Selection.Dropdown.html#mount/1","title":"Raxol.UI.Components.Selection.Dropdown.mount/1","type":"function"},{"doc":"Renders the Dropdown component, showing either the expanded or collapsed state.","ref":"Raxol.UI.Components.Selection.Dropdown.html#render/2","title":"Raxol.UI.Components.Selection.Dropdown.render/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Selection.Dropdown.html#schedule/2","title":"Raxol.UI.Components.Selection.Dropdown.schedule/2","type":"function"},{"doc":"State for the Selection.Dropdown component.\n\n- :id - unique identifier\n- :options - list of options\n- :selected_option - currently selected option\n- :expanded - whether dropdown is expanded\n- :width - dropdown width\n- :list_height - height of the dropdown list\n- :style - style map\n- :focused - whether the dropdown is focused\n- :on_change - callback for selection change\n- :list_state - state of the nested list","ref":"Raxol.UI.Components.Selection.Dropdown.html#t:t/0","title":"Raxol.UI.Components.Selection.Dropdown.t/0","type":"type"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.Selection.Dropdown.html#unmount/1","title":"Raxol.UI.Components.Selection.Dropdown.unmount/1","type":"function"},{"doc":"Updates the Dropdown component state in response to messages.","ref":"Raxol.UI.Components.Selection.Dropdown.html#update/2","title":"Raxol.UI.Components.Selection.Dropdown.update/2","type":"function"},{"doc":"A component for displaying a selectable list of items.","ref":"Raxol.UI.Components.Selection.List.html","title":"Raxol.UI.Components.Selection.List","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Selection.List.html#broadcast/1","title":"Raxol.UI.Components.Selection.List.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Selection.List.html#command/1","title":"Raxol.UI.Components.Selection.List.command/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Selection.List.html#fetch/2","title":"Raxol.UI.Components.Selection.List.fetch/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Selection.List.html#get_and_update/3","title":"Raxol.UI.Components.Selection.List.get_and_update/3","type":"function"},{"doc":"Handles events for the List component, such as keyboard and mouse input.","ref":"Raxol.UI.Components.Selection.List.html#handle_event/3","title":"Raxol.UI.Components.Selection.List.handle_event/3","type":"function"},{"doc":"Initializes the List component state from props.","ref":"Raxol.UI.Components.Selection.List.html#init/1","title":"Raxol.UI.Components.Selection.List.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.Selection.List.html#mount/1","title":"Raxol.UI.Components.Selection.List.mount/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Selection.List.html#pop/2","title":"Raxol.UI.Components.Selection.List.pop/2","type":"function"},{"doc":"Renders the List component, displaying visible items.","ref":"Raxol.UI.Components.Selection.List.html#render/2","title":"Raxol.UI.Components.Selection.List.render/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Selection.List.html#schedule/2","title":"Raxol.UI.Components.Selection.List.schedule/2","type":"function"},{"doc":"State for the Selection.List component.\n\n- :id - unique identifier\n- :items - list of items\n- :selected_index - index of selected item\n- :scroll_offset - scroll offset\n- :width - component width\n- :height - component height\n- :style - style map\n- :focused - whether the list is focused\n- :on_select - callback for selection\n- :item_renderer - function to render items","ref":"Raxol.UI.Components.Selection.List.html#t:t/0","title":"Raxol.UI.Components.Selection.List.t/0","type":"type"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.Selection.List.html#unmount/1","title":"Raxol.UI.Components.Selection.List.unmount/1","type":"function"},{"doc":"Updates the List component state in response to messages.","ref":"Raxol.UI.Components.Selection.List.html#update/2","title":"Raxol.UI.Components.Selection.List.update/2","type":"function"},{"doc":"A tab bar component for Raxol.\n\nA tab bar component for navigating between different sections of a UI.","ref":"Raxol.UI.Components.TabBar.html","title":"Raxol.UI.Components.TabBar","type":"module"},{"doc":"```elixir\nalias Raxol.UI.Components.TabBar\n\n# In your view function\ndef view(model) do\n  tabs = [\n    %{id: :dashboard, label: \"Dashboard\"},\n    %{id: :settings, label: \"Settings\"},\n    %{id: :help, label: \"Help\"}\n  ]\n\n  view do\n    panel do\n      TabBar.render(tabs, model.active_tab, &handle_tab_change/2)\n\n      # Content based on active tab\n      case model.active_tab do\n        :dashboard -> dashboard_view(model)\n        :settings -> settings_view(model)\n        :help -> help_view(model)\n      end\n    end\n  end\nend\n\n# Handler function\ndef handle_tab_change(model, tab_id) do\n  %{model | active_tab: tab_id}\nend\n\n@behaviour Raxol.ComponentBehaviour\n\n@doc \"\"\"\nRenders a tab bar with the given tabs, highlighting the active tab.","ref":"Raxol.UI.Components.TabBar.html#module-examples","title":"Examples - Raxol.UI.Components.TabBar","type":"module"},{"doc":"* `tabs` - A list of tab maps, each containing `:id` and `:label` keys\n* `active_tab` - The ID of the currently active tab\n* `on_change` - A function that takes the model and a tab ID and returns an updated model\n* `opts` - Options for customizing the tab bar appearance","ref":"Raxol.UI.Components.TabBar.html#module-parameters","title":"Parameters - Raxol.UI.Components.TabBar","type":"module"},{"doc":"* `:focus_key` - Key for focusing the tab bar (default: \"tab_bar\")\n* `:style` - Style for the tab bar (default: %{})\n* `:tab_style` - Style for individual tabs (default: %{})\n* `:active_tab_style` - Style for the active tab (default: %{fg: :white, bg: :blue})","ref":"Raxol.UI.Components.TabBar.html#module-options","title":"Options - Raxol.UI.Components.TabBar","type":"module"},{"doc":"A view element representing the tab bar.","ref":"Raxol.UI.Components.TabBar.html#module-returns","title":"Returns - Raxol.UI.Components.TabBar","type":"module"},{"doc":"```elixir\nTabBar.render(\n  [\n    %{id: :tab1, label: \"First Tab\"},\n    %{id: :tab2, label: \"Second Tab\"}\n  ],\n  :tab1,\n  &handle_tab_change/2,\n  active_tab_style: %{fg: :white, bg: :green}\n)\n```","ref":"Raxol.UI.Components.TabBar.html#module-example","title":"Example - Raxol.UI.Components.TabBar","type":"module"},{"doc":"","ref":"Raxol.UI.Components.TabBar.html#render/4","title":"Raxol.UI.Components.TabBar.render/4","type":"function"},{"doc":"Creates a tabbed interface with content.\n\nThis is a higher-level component that combines the tab bar with\ncontent areas for each tab.","ref":"Raxol.UI.Components.TabBar.html#tabbed_view/4","title":"Raxol.UI.Components.TabBar.tabbed_view/4","type":"function"},{"doc":"* `tabs` - A list of tab maps, each containing `:id`, `:label`, and `:content` keys\n* `active_tab` - The ID of the currently active tab\n* `on_change` - A function that takes the model and a tab ID and returns an updated model\n* `opts` - Options for customizing the tabbed interface","ref":"Raxol.UI.Components.TabBar.html#tabbed_view/4-parameters","title":"Parameters - Raxol.UI.Components.TabBar.tabbed_view/4","type":"function"},{"doc":"* `:focus_key` - Key for focusing the tabbed interface (default: \"tabbed_view\")\n* `:style` - Style for the container (default: %{})\n* `:tab_bar_style` - Style for the tab bar (default: %{})\n* `:tab_style` - Style for individual tabs (default: %{})\n* `:active_tab_style` - Style for the active tab (default: %{fg: :white, bg: :blue})\n* `:content_style` - Style for the content area (default: %{})","ref":"Raxol.UI.Components.TabBar.html#tabbed_view/4-options","title":"Options - Raxol.UI.Components.TabBar.tabbed_view/4","type":"function"},{"doc":"A view element representing the complete tabbed interface.","ref":"Raxol.UI.Components.TabBar.html#tabbed_view/4-returns","title":"Returns - Raxol.UI.Components.TabBar.tabbed_view/4","type":"function"},{"doc":"```elixir\nTabBar.tabbed_view(\n  [\n    %{id: :tab1, label: \"First Tab\", content: fn -> View.text(\"First tab content\") end},\n    %{id: :tab2, label: \"Second Tab\", content: fn -> View.text(\"Second tab content\") end}\n  ],\n  :tab1,\n  &handle_tab_change/2\n)\n```","ref":"Raxol.UI.Components.TabBar.html#tabbed_view/4-example","title":"Example - Raxol.UI.Components.TabBar.tabbed_view/4","type":"function"},{"doc":"Table component for displaying and interacting with tabular data.","ref":"Raxol.UI.Components.Table.html","title":"Raxol.UI.Components.Table","type":"module"},{"doc":"* Pagination\n* Sorting\n* Filtering\n* Custom column formatting\n* Row selection\n* **Custom theming and styling** (see below)","ref":"Raxol.UI.Components.Table.html#module-features","title":"Features - Raxol.UI.Components.Table","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Table.html#module-public-api","title":"Public API - Raxol.UI.Components.Table","type":"module"},{"doc":"- `:id` (required): Unique identifier for the table.\n- `:columns` (required): List of column definitions. Each column is a map with:\n  - `:id` (atom, required): Key for the column.\n  - `:label` (string, required): Header label.\n  - `:width` (integer or `:auto`, optional): Column width.\n  - `:align` (`:left` | `:center` | `:right`, optional): Text alignment.\n  - `:format` (function, optional): Custom formatting function for cell values.\n  - `:style` (map, optional): Style overrides for all cells in this column.\n  - `:header_style` (map, optional): Style overrides for this column's header cell.\n- `:data` (required): List of row maps (each map must have keys matching column ids).\n- `:options` (map, optional):\n  - `:paginate` (boolean): Enable pagination.\n  - `:searchable` (boolean): Enable filtering.\n  - `:sortable` (boolean): Enable sorting.\n  - `:page_size` (integer): Rows per page.\n- `:style` (map, optional): Style overrides for the table box and header (see below).\n  - `:header` (map, optional): Style overrides for all header cells.\n- `:theme` (map, optional): Theme map for the table. Keys can include:\n  - `:box` (map): Style for the outer box.\n  - `:header` (map): Style for all header cells.\n  - `:row` (map): Style for all rows.\n  - `:selected_row` (map): Style for the selected row.","ref":"Raxol.UI.Components.Table.html#module-props","title":"Props - Raxol.UI.Components.Table","type":"module"},{"doc":"- Per-column `:style` and `:header_style` override theme and table-level styles for their respective cells.\n- `:style` prop overrides theme for the box and header.\n- `:theme` provides defaults for box, header, row, and selected row.\n- Hardcoded defaults (e.g., header bold, selected row blue/white) are used if not overridden.","ref":"Raxol.UI.Components.Table.html#module-theming-and-style-precedence","title":"Theming and Style Precedence - Raxol.UI.Components.Table","type":"module"},{"doc":"```elixir\ncolumns = [\n  %{id: :id, label: \"ID\", style: %{color: :magenta}, header_style: %{bg: :cyan}},\n  %{id: :name, label: \"Name\"},\n  %{id: :age, label: \"Age\"}\n]\ndata = [%{id: 1, name: \"Alice\", age: 30}, ...]\ntheme = %{\n  box: %{border_color: :green},\n  header: %{underline: true},\n  row: %{bg: :yellow},\n  selected_row: %{bg: :red, fg: :black}\n}\nstyle = %{header: %{italic: true}}\n\nTable.init(%{\n  id: :my_table,\n  columns: columns,\n  data: data,\n  theme: theme,\n  style: style,\n  options: %{paginate: true, page_size: 5}\n})\n```","ref":"Raxol.UI.Components.Table.html#module-example-custom-theming-and-styling","title":"Example: Custom Theming and Styling - Raxol.UI.Components.Table","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Table.html#t:column/0","title":"Raxol.UI.Components.Table.column/0","type":"type"},{"doc":"Handles events for the table component.","ref":"Raxol.UI.Components.Table.html#handle_event/3","title":"Raxol.UI.Components.Table.handle_event/3","type":"function"},{"doc":"Initializes the table component with the given props.","ref":"Raxol.UI.Components.Table.html#init/1","title":"Raxol.UI.Components.Table.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.Table.html#mount/1","title":"Raxol.UI.Components.Table.mount/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Table.html#t:options/0","title":"Raxol.UI.Components.Table.options/0","type":"type"},{"doc":"Renders the table component.","ref":"Raxol.UI.Components.Table.html#render/2","title":"Raxol.UI.Components.Table.render/2","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.Table.html#unmount/1","title":"Raxol.UI.Components.Table.unmount/1","type":"function"},{"doc":"Updates the table state based on the given message.","ref":"Raxol.UI.Components.Table.html#update/2","title":"Raxol.UI.Components.Table.update/2","type":"function"},{"doc":"A terminal component that emulates a standard terminal within the UI.","ref":"Raxol.UI.Components.Terminal.html","title":"Raxol.UI.Components.Terminal","type":"module"},{"doc":"","ref":"Raxol.UI.Components.Terminal.html#broadcast/1","title":"Raxol.UI.Components.Terminal.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Terminal.html#command/1","title":"Raxol.UI.Components.Terminal.command/1","type":"function"},{"doc":"Handles key events for the Terminal component.","ref":"Raxol.UI.Components.Terminal.html#handle_event/3","title":"Raxol.UI.Components.Terminal.handle_event/3","type":"function"},{"doc":"Initializes the Terminal component state from props.","ref":"Raxol.UI.Components.Terminal.html#init/1","title":"Raxol.UI.Components.Terminal.init/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Components.Terminal.html#mount/1","title":"Raxol.UI.Components.Terminal.mount/1","type":"function"},{"doc":"Renders the Terminal component, displaying the buffer as lines.","ref":"Raxol.UI.Components.Terminal.html#render/2","title":"Raxol.UI.Components.Terminal.render/2","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Terminal.html#schedule/2","title":"Raxol.UI.Components.Terminal.schedule/2","type":"function"},{"doc":"State for the Terminal component.\n\n- :id - unique identifier\n- :width - terminal width\n- :height - terminal height\n- :buffer - list of lines\n- :style - style map","ref":"Raxol.UI.Components.Terminal.html#t:t/0","title":"Raxol.UI.Components.Terminal.t/0","type":"type"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Components.Terminal.html#unmount/1","title":"Raxol.UI.Components.Terminal.unmount/1","type":"function"},{"doc":"Updates the Terminal component state in response to messages. Handles writing, clearing, etc.","ref":"Raxol.UI.Components.Terminal.html#update/2","title":"Raxol.UI.Components.Terminal.update/2","type":"function"},{"doc":"Terminal emulator component wrapping the core emulator logic.","ref":"Raxol.UI.Components.Terminal.Emulator.html","title":"Raxol.UI.Components.Terminal.Emulator","type":"module"},{"doc":"Cleans up resources when the component is destroyed.","ref":"Raxol.UI.Components.Terminal.Emulator.html#cleanup/1","title":"Raxol.UI.Components.Terminal.Emulator.cleanup/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.Terminal.Emulator.html#t:emulator_state/0","title":"Raxol.UI.Components.Terminal.Emulator.emulator_state/0","type":"type"},{"doc":"Handles terminal resize events by delegating to State.\nThis ensures that the terminal's internal buffers and state are correctly\nadjusted while preserving existing content and history where possible.","ref":"Raxol.UI.Components.Terminal.Emulator.html#handle_resize/2","title":"Raxol.UI.Components.Terminal.Emulator.handle_resize/2","type":"function"},{"doc":"Initializes a new terminal emulator component state.\nAccepts an optional map of options, currently supporting `:width` and `:height`.","ref":"Raxol.UI.Components.Terminal.Emulator.html#init/1","title":"Raxol.UI.Components.Terminal.Emulator.init/1","type":"function"},{"doc":"Processes input and updates terminal state by delegating to UnifiedIO.\nReturns a tuple `{updated_state, output_string}`.","ref":"Raxol.UI.Components.Terminal.Emulator.html#process_input/2","title":"Raxol.UI.Components.Terminal.Emulator.process_input/2","type":"function"},{"doc":"Renders the current terminal state.","ref":"Raxol.UI.Components.Terminal.Emulator.html#render/1","title":"Raxol.UI.Components.Terminal.Emulator.render/1","type":"function"},{"doc":"A text input component with editing capabilities.\n\nThis module provides a text input field that allows users to enter\nand edit text with cursor positioning, selection, and validation.","ref":"Raxol.UI.Components.TextInput.html","title":"Raxol.UI.Components.TextInput","type":"module"},{"doc":"```elixir\nalias Raxol.UI.Components.TextInput\n\nTextInput.new(\n  value: model.name,\n  placeholder: \"Enter your name\",\n  on_change: fn value -> {:update_name, value} end\n)\n```","ref":"Raxol.UI.Components.TextInput.html#module-example","title":"Example - Raxol.UI.Components.TextInput","type":"module"},{"doc":"Updates the text input based on keyboard input.","ref":"Raxol.UI.Components.TextInput.html#handle_key_event/2","title":"Raxol.UI.Components.TextInput.handle_key_event/2","type":"function"},{"doc":"* `input` - The text input component\n* `key_event` - Keyboard event as `{meta, key}`","ref":"Raxol.UI.Components.TextInput.html#handle_key_event/2-parameters","title":"Parameters - Raxol.UI.Components.TextInput.handle_key_event/2","type":"function"},{"doc":"Updated text input component.","ref":"Raxol.UI.Components.TextInput.html#handle_key_event/2-returns","title":"Returns - Raxol.UI.Components.TextInput.handle_key_event/2","type":"function"},{"doc":"```elixir\nupdated_input = TextInput.handle_key_event(input, {:none, ?a})\n```","ref":"Raxol.UI.Components.TextInput.html#handle_key_event/2-example","title":"Example - Raxol.UI.Components.TextInput.handle_key_event/2","type":"function"},{"doc":"Creates a new text input with the given options.","ref":"Raxol.UI.Components.TextInput.html#new/1","title":"Raxol.UI.Components.TextInput.new/1","type":"function"},{"doc":"* `:value` - Current input value\n* `:placeholder` - Placeholder text when empty\n* `:on_change` - Function to call when value changes\n* `:password` - Whether to mask input as password\n* `:max_length` - Maximum input length\n* `:style` - Custom style for the input\n* `:disabled` - Whether the input is disabled\n* `:validation` - Validation function\n* `:invalid_message` - Message to show when validation fails","ref":"Raxol.UI.Components.TextInput.html#new/1-options","title":"Options - Raxol.UI.Components.TextInput.new/1","type":"function"},{"doc":"A text input component that can be used in a Raxol view.","ref":"Raxol.UI.Components.TextInput.html#new/1-returns","title":"Returns - Raxol.UI.Components.TextInput.new/1","type":"function"},{"doc":"```elixir\nTextInput.new(\n  value: model.email,\n  placeholder: \"example@example.com\",\n  validation: &String.contains?(&1, \"@\"),\n  invalid_message: \"Must be a valid email\"\n)\n```","ref":"Raxol.UI.Components.TextInput.html#new/1-example","title":"Example - Raxol.UI.Components.TextInput.new/1","type":"function"},{"doc":"Renders the text input as a basic element.\n\nThis is typically called by the renderer, not directly by users.","ref":"Raxol.UI.Components.TextInput.html#render/1","title":"Raxol.UI.Components.TextInput.render/1","type":"function"},{"doc":"","ref":"Raxol.UI.Components.TextInput.html#t:t/0","title":"Raxol.UI.Components.TextInput.t/0","type":"type"},{"doc":"Handles layout calculations for container elements like rows and columns.\n\nThis module is responsible for:\n* Row layout calculations\n* Column layout calculations\n* Flexbox-like distribution of space\n* Gap and alignment handling","ref":"Raxol.UI.Layout.Containers.html","title":"Raxol.UI.Layout.Containers","type":"module"},{"doc":"Measures the space needed by a column element.","ref":"Raxol.UI.Layout.Containers.html#measure_column/2","title":"Raxol.UI.Layout.Containers.measure_column/2","type":"function"},{"doc":"* `column` - The column element to measure\n* `available_space` - The available space for the column","ref":"Raxol.UI.Layout.Containers.html#measure_column/2-parameters","title":"Parameters - Raxol.UI.Layout.Containers.measure_column/2","type":"function"},{"doc":"The dimensions of the column: %{width: w, height: h}","ref":"Raxol.UI.Layout.Containers.html#measure_column/2-returns","title":"Returns - Raxol.UI.Layout.Containers.measure_column/2","type":"function"},{"doc":"Measures the space needed by a row element.","ref":"Raxol.UI.Layout.Containers.html#measure_row/2","title":"Raxol.UI.Layout.Containers.measure_row/2","type":"function"},{"doc":"* `row` - The row element to measure\n* `available_space` - The available space for the row","ref":"Raxol.UI.Layout.Containers.html#measure_row/2-parameters","title":"Parameters - Raxol.UI.Layout.Containers.measure_row/2","type":"function"},{"doc":"The dimensions of the row: %{width: w, height: h}","ref":"Raxol.UI.Layout.Containers.html#measure_row/2-returns","title":"Returns - Raxol.UI.Layout.Containers.measure_row/2","type":"function"},{"doc":"Processes a column element, calculating layout for it and its children.","ref":"Raxol.UI.Layout.Containers.html#process_column/3","title":"Raxol.UI.Layout.Containers.process_column/3","type":"function"},{"doc":"* `column` - The column element to process\n* `space` - The available space for the column\n* `acc` - The accumulator for rendered elements","ref":"Raxol.UI.Layout.Containers.html#process_column/3-parameters","title":"Parameters - Raxol.UI.Layout.Containers.process_column/3","type":"function"},{"doc":"A list of positioned elements with absolute coordinates.","ref":"Raxol.UI.Layout.Containers.html#process_column/3-returns","title":"Returns - Raxol.UI.Layout.Containers.process_column/3","type":"function"},{"doc":"Processes a row element, calculating layout for it and its children.","ref":"Raxol.UI.Layout.Containers.html#process_row/3","title":"Raxol.UI.Layout.Containers.process_row/3","type":"function"},{"doc":"* `row` - The row element to process\n* `space` - The available space for the row\n* `acc` - The accumulator for rendered elements","ref":"Raxol.UI.Layout.Containers.html#process_row/3-parameters","title":"Parameters - Raxol.UI.Layout.Containers.process_row/3","type":"function"},{"doc":"A list of positioned elements with absolute coordinates.","ref":"Raxol.UI.Layout.Containers.html#process_row/3-returns","title":"Returns - Raxol.UI.Layout.Containers.process_row/3","type":"function"},{"doc":"Handles measurement of basic UI elements like text, labels, boxes, and checkboxes.","ref":"Raxol.UI.Layout.Elements.html","title":"Raxol.UI.Layout.Elements","type":"module"},{"doc":"","ref":"Raxol.UI.Layout.Elements.html#measure/2","title":"Raxol.UI.Layout.Elements.measure/2","type":"function"},{"doc":"Core layout engine that translates the logical view structure into absolute positions.\n\nThis module is responsible for:\n* Calculating element positions based on available space\n* Resolving layout constraints\n* Managing the layout pipeline","ref":"Raxol.UI.Layout.Engine.html","title":"Raxol.UI.Layout.Engine","type":"module"},{"doc":"Applies layout to a view, calculating absolute positions for all elements.","ref":"Raxol.UI.Layout.Engine.html#apply_layout/2","title":"Raxol.UI.Layout.Engine.apply_layout/2","type":"function"},{"doc":"* `view` - The view to calculate layout for\n* `dimensions` - Terminal dimensions `%{width: w, height: h}`","ref":"Raxol.UI.Layout.Engine.html#apply_layout/2-parameters","title":"Parameters - Raxol.UI.Layout.Engine.apply_layout/2","type":"function"},{"doc":"A list of positioned elements with absolute coordinates.","ref":"Raxol.UI.Layout.Engine.html#apply_layout/2-returns","title":"Returns - Raxol.UI.Layout.Engine.apply_layout/2","type":"function"},{"doc":"Calculates the intrinsic dimensions (width, height) of an element.\n\nThis function determines the natural size of an element before layout constraints\nare applied. For containers, it might recursively measure children.","ref":"Raxol.UI.Layout.Engine.html#measure_element/2","title":"Raxol.UI.Layout.Engine.measure_element/2","type":"function"},{"doc":"* `element` - The element map to measure.\n* `available_space` - Map providing context (e.g., max width).\n- Defaults to an empty map.","ref":"Raxol.UI.Layout.Engine.html#measure_element/2-parameters","title":"Parameters - Raxol.UI.Layout.Engine.measure_element/2","type":"function"},{"doc":"A map representing the dimensions: `%{width: integer(), height: integer()}`.","ref":"Raxol.UI.Layout.Engine.html#measure_element/2-returns","title":"Returns - Raxol.UI.Layout.Engine.measure_element/2","type":"function"},{"doc":"","ref":"Raxol.UI.Layout.Engine.html#process_element/3","title":"Raxol.UI.Layout.Engine.process_element/3","type":"function"},{"doc":"Handles layout calculations for grid UI elements.\n\nThis module is responsible for:\n* Grid-based layout calculations\n* Cell sizing and positioning\n* Column and row spanning elements\n* Grid-specific spacing and constraints","ref":"Raxol.UI.Layout.Grid.html","title":"Raxol.UI.Layout.Grid","type":"module"},{"doc":"Creates grid cell information for a grid layout.","ref":"Raxol.UI.Layout.Grid.html#calculate_grid_cells/2","title":"Raxol.UI.Layout.Grid.calculate_grid_cells/2","type":"function"},{"doc":"* `grid_attrs` - The grid attributes\n* `space` - The available space","ref":"Raxol.UI.Layout.Grid.html#calculate_grid_cells/2-parameters","title":"Parameters - Raxol.UI.Layout.Grid.calculate_grid_cells/2","type":"function"},{"doc":"A map containing cell dimensions and grid information.","ref":"Raxol.UI.Layout.Grid.html#calculate_grid_cells/2-returns","title":"Returns - Raxol.UI.Layout.Grid.calculate_grid_cells/2","type":"function"},{"doc":"Calculates the position for a cell in the grid.","ref":"Raxol.UI.Layout.Grid.html#cell_position/4","title":"Raxol.UI.Layout.Grid.cell_position/4","type":"function"},{"doc":"* `col` - The column index (0-based)\n* `row` - The row index (0-based)\n* `grid_cells` - The grid cell information from `calculate_grid_cells/2`\n* `space` - The base space for the grid","ref":"Raxol.UI.Layout.Grid.html#cell_position/4-parameters","title":"Parameters - Raxol.UI.Layout.Grid.cell_position/4","type":"function"},{"doc":"A space map with x, y, width, and height for the cell.","ref":"Raxol.UI.Layout.Grid.html#cell_position/4-returns","title":"Returns - Raxol.UI.Layout.Grid.cell_position/4","type":"function"},{"doc":"Measures the space needed by a grid element.","ref":"Raxol.UI.Layout.Grid.html#measure_grid/2","title":"Raxol.UI.Layout.Grid.measure_grid/2","type":"function"},{"doc":"* `grid` - The grid element to measure\n* `available_space` - The available space for the grid","ref":"Raxol.UI.Layout.Grid.html#measure_grid/2-parameters","title":"Parameters - Raxol.UI.Layout.Grid.measure_grid/2","type":"function"},{"doc":"The dimensions of the grid: %{width: w, height: h}","ref":"Raxol.UI.Layout.Grid.html#measure_grid/2-returns","title":"Returns - Raxol.UI.Layout.Grid.measure_grid/2","type":"function"},{"doc":"Processes a grid element, calculating layout for it and its children.","ref":"Raxol.UI.Layout.Grid.html#process/3","title":"Raxol.UI.Layout.Grid.process/3","type":"function"},{"doc":"* `grid` - The grid element to process\n* `space` - The available space for the grid\n* `acc` - The accumulator for rendered elements","ref":"Raxol.UI.Layout.Grid.html#process/3-parameters","title":"Parameters - Raxol.UI.Layout.Grid.process/3","type":"function"},{"doc":"A list of positioned elements with absolute coordinates.","ref":"Raxol.UI.Layout.Grid.html#process/3-returns","title":"Returns - Raxol.UI.Layout.Grid.process/3","type":"function"},{"doc":"Handles measurement of input elements like buttons and text inputs.","ref":"Raxol.UI.Layout.Inputs.html","title":"Raxol.UI.Layout.Inputs","type":"module"},{"doc":"","ref":"Raxol.UI.Layout.Inputs.html#measure/3","title":"Raxol.UI.Layout.Inputs.measure/3","type":"function"},{"doc":"Handles layout calculations for panel UI elements.\n\nThis module is responsible for:\n* Panel border rendering\n* Panel content layout\n* Panel title positioning\n* Panel-specific spacing and constraints","ref":"Raxol.UI.Layout.Panels.html","title":"Raxol.UI.Layout.Panels","type":"module"},{"doc":"Measures the space required by a panel element.","ref":"Raxol.UI.Layout.Panels.html#measure_panel/2","title":"Raxol.UI.Layout.Panels.measure_panel/2","type":"function"},{"doc":"* `panel` - The panel element to measure\n* `available_space` - The available space for the panel","ref":"Raxol.UI.Layout.Panels.html#measure_panel/2-parameters","title":"Parameters - Raxol.UI.Layout.Panels.measure_panel/2","type":"function"},{"doc":"The dimensions of the panel: %{width: w, height: h}","ref":"Raxol.UI.Layout.Panels.html#measure_panel/2-returns","title":"Returns - Raxol.UI.Layout.Panels.measure_panel/2","type":"function"},{"doc":"Processes a panel element, calculating layout for it and its children.","ref":"Raxol.UI.Layout.Panels.html#process/3","title":"Raxol.UI.Layout.Panels.process/3","type":"function"},{"doc":"* `panel` - The panel element to process\n* `space` - The available space for the panel\n* `acc` - The accumulator for rendered elements","ref":"Raxol.UI.Layout.Panels.html#process/3-parameters","title":"Parameters - Raxol.UI.Layout.Panels.process/3","type":"function"},{"doc":"A list of positioned elements with absolute coordinates.","ref":"Raxol.UI.Layout.Panels.html#process/3-returns","title":"Returns - Raxol.UI.Layout.Panels.process/3","type":"function"},{"doc":"Handles measurement and positioning logic for Table elements within the LayoutEngine.","ref":"Raxol.UI.Layout.Table.html","title":"Raxol.UI.Layout.Table","type":"module"},{"doc":"","ref":"Raxol.UI.Layout.Table.html#measure/2","title":"Raxol.UI.Layout.Table.measure/2","type":"function"},{"doc":"Measures the required space for a table and returns a single positioned table element.","ref":"Raxol.UI.Layout.Table.html#measure_and_position/3","title":"Raxol.UI.Layout.Table.measure_and_position/3","type":"function"},{"doc":"Translates a positioned element tree into a flat list of renderable cells.\n\nTakes the output of the Layout Engine and converts UI primitives (text, boxes, etc.)\ninto styled characters at specific coordinates.","ref":"Raxol.UI.Renderer.html","title":"Raxol.UI.Renderer","type":"module"},{"doc":"","ref":"Raxol.UI.Renderer.html#t:cell/0","title":"Raxol.UI.Renderer.cell/0","type":"type"},{"doc":"","ref":"Raxol.UI.Renderer.html#t:positioned_element/0","title":"Raxol.UI.Renderer.positioned_element/0","type":"type"},{"doc":"Renders a tree of positioned elements into a list of cells.\n\nArgs:\n  - `elements`: A list or single map representing positioned elements from the Layout Engine.\n  - `theme`: The current theme map (expected %Theme{}).\n\nReturns:\n  - `list(cell())`","ref":"Raxol.UI.Renderer.html#render_to_cells/2","title":"Raxol.UI.Renderer.render_to_cells/2","type":"function"},{"doc":"","ref":"Raxol.UI.Renderer.html#t:theme/0","title":"Raxol.UI.Renderer.theme/0","type":"type"},{"doc":"Helper module for renderer tests providing common test utilities and fixtures.","ref":"Raxol.UI.RendererTestHelper.html","title":"Raxol.UI.RendererTestHelper","type":"module"},{"doc":"","ref":"Raxol.UI.RendererTestHelper.html#assert_cell_style/4","title":"Raxol.UI.RendererTestHelper.assert_cell_style/4","type":"function"},{"doc":"","ref":"Raxol.UI.RendererTestHelper.html#create_test_box/5","title":"Raxol.UI.RendererTestHelper.create_test_box/5","type":"function"},{"doc":"","ref":"Raxol.UI.RendererTestHelper.html#create_test_element/4","title":"Raxol.UI.RendererTestHelper.create_test_element/4","type":"function"},{"doc":"","ref":"Raxol.UI.RendererTestHelper.html#create_test_panel/6","title":"Raxol.UI.RendererTestHelper.create_test_panel/6","type":"function"},{"doc":"","ref":"Raxol.UI.RendererTestHelper.html#create_test_table/5","title":"Raxol.UI.RendererTestHelper.create_test_table/5","type":"function"},{"doc":"","ref":"Raxol.UI.RendererTestHelper.html#create_test_text/4","title":"Raxol.UI.RendererTestHelper.create_test_text/4","type":"function"},{"doc":"","ref":"Raxol.UI.RendererTestHelper.html#create_test_theme/4","title":"Raxol.UI.RendererTestHelper.create_test_theme/4","type":"function"},{"doc":"","ref":"Raxol.UI.RendererTestHelper.html#get_cell_at/3","title":"Raxol.UI.RendererTestHelper.get_cell_at/3","type":"function"},{"doc":"","ref":"Raxol.UI.RendererTestHelper.html#get_cells_with_char/2","title":"Raxol.UI.RendererTestHelper.get_cells_with_char/2","type":"function"},{"doc":"","ref":"Raxol.UI.Rendering.Composer.html","title":"Raxol.UI.Rendering.Composer","type":"module"},{"doc":"Composes a render tree or command list from the layout tree.\nCurrently a stub; in the future, this will build a render tree or command list,\npotentially processing diffs or layout-specific changes.","ref":"Raxol.UI.Rendering.Composer.html#compose_render_tree/3","title":"Raxol.UI.Rendering.Composer.compose_render_tree/3","type":"function"},{"doc":"","ref":"Raxol.UI.Rendering.Layouter.html","title":"Raxol.UI.Rendering.Layouter","type":"module"},{"doc":"","ref":"Raxol.UI.Rendering.Layouter.html#layout_tree/2","title":"Raxol.UI.Rendering.Layouter.layout_tree/2","type":"function"},{"doc":"","ref":"Raxol.UI.Rendering.Painter.html","title":"Raxol.UI.Rendering.Painter","type":"module"},{"doc":"Paints the render tree into draw commands or buffer updates.\nCurrently a stub; in the future, this will convert the render tree into draw commands,\npotentially processing diffs or composition-specific changes.","ref":"Raxol.UI.Rendering.Painter.html#paint/4","title":"Raxol.UI.Rendering.Painter.paint/4","type":"function"},{"doc":"Manages the rendering pipeline for the UI as a GenServer.","ref":"Raxol.UI.Rendering.Pipeline.html","title":"Raxol.UI.Rendering.Pipeline","type":"module"},{"doc":"1. **Diffing**: Compare the new UI tree to the previous one and compute minimal changes.\n   DELEGATED TO: `Raxol.UI.Rendering.TreeDiffer`\n2. **Layout**: Calculate positions and sizes for all UI elements.\n3. **Composition**: Build a render tree or command list from the layout.\n4. **Paint**: Convert the render tree into draw commands or buffer updates.\n5. **Commit**: Send the final output to the Renderer process for display.","ref":"Raxol.UI.Rendering.Pipeline.html#module-pipeline-stages-planned","title":"Pipeline Stages (Planned) - Raxol.UI.Rendering.Pipeline","type":"module"},{"doc":"- UI state changes or events call `update_tree/1` (or `update_tree/2`) to submit a new UI tree.\n- The pipeline stores the latest tree, may batch or debounce rapid updates, and triggers a render via the Renderer process.\n- The GenServer holds pipeline state (current tree, previous tree, pending updates, etc.).","ref":"Raxol.UI.Rendering.Pipeline.html#module-data-flow","title":"Data Flow - Raxol.UI.Rendering.Pipeline","type":"module"},{"doc":"- Custom diffing or batching strategies\n- Animation frame scheduling\n- Hooks for custom renderers or output backends","ref":"Raxol.UI.Rendering.Pipeline.html#module-extension-points","title":"Extension Points - Raxol.UI.Rendering.Pipeline","type":"module"},{"doc":"- Implement diffing and minimal update computation (DELEGATED: `TreeDiffer` handles core diffing. Layout stage has partial diff-awareness. Compose and Paint stages now reuse previous results if their respective inputs are unchanged, providing a level of minimal update.)\n- Add batching/debouncing of rapid updates (partially implemented with send_after for debouncing)\n- Integrate animation frame scheduling (request_animation_frame now uses GenServer.call with deferred reply from :animation_tick; this is more robust.)\n- Store and manage pipeline state (previous tree, pending updates, etc.) (GenServer state has current_tree, previous_tree)\n- Connect to the real rendering backend (commit stage calls a renderer module)","ref":"Raxol.UI.Rendering.Pipeline.html#module-todo","title":"TODO - Raxol.UI.Rendering.Pipeline","type":"module"},{"doc":"Applies animation settings (delegates to Renderer).","ref":"Raxol.UI.Rendering.Pipeline.html#apply_animation_settings/8","title":"Raxol.UI.Rendering.Pipeline.apply_animation_settings/8","type":"function"},{"doc":"Child spec for supervision trees.","ref":"Raxol.UI.Rendering.Pipeline.html#child_spec/1","title":"Raxol.UI.Rendering.Pipeline.child_spec/1","type":"function"},{"doc":"Commits the final output to the Renderer process for display.\nThis is where the pipeline would send the output (a list of paint operations)\nto the configured renderer.","ref":"Raxol.UI.Rendering.Pipeline.html#commit/2","title":"Raxol.UI.Rendering.Pipeline.commit/2","type":"function"},{"doc":"Computes the minimal set of changes (diff) between two UI trees.\n\nReturns:\n  * :no_change if trees are identical\n  * {:replace, new_tree} if the root node differs\n  * {:update, path, changes} for subtree updates (path is a list of indices)\n\nTODO: Support keyed children, reordering, and more granular diffs.","ref":"Raxol.UI.Rendering.Pipeline.html#diff_trees/2","title":"Raxol.UI.Rendering.Pipeline.diff_trees/2","type":"function"},{"doc":"Gets the current renderer module (default: Raxol.UI.Rendering.Renderer).","ref":"Raxol.UI.Rendering.Pipeline.html#get_renderer/0","title":"Raxol.UI.Rendering.Pipeline.get_renderer/0","type":"function"},{"doc":"Requests notification on the next animation frame. The caller will receive {:animation_frame, ref}.\nReturns a unique reference for the request.","ref":"Raxol.UI.Rendering.Pipeline.html#request_animation_frame/1","title":"Raxol.UI.Rendering.Pipeline.request_animation_frame/1","type":"function"},{"doc":"Schedules a render to occur on the next animation frame.\nOnly one render will be scheduled per frame, regardless of how many times this is called before the next frame.","ref":"Raxol.UI.Rendering.Pipeline.html#schedule_render_on_next_frame/0","title":"Raxol.UI.Rendering.Pipeline.schedule_render_on_next_frame/0","type":"function"},{"doc":"Sets the renderer module to use for output (default: Raxol.UI.Rendering.Renderer).\nThis allows for custom renderers or output backends.","ref":"Raxol.UI.Rendering.Pipeline.html#set_renderer/1","title":"Raxol.UI.Rendering.Pipeline.set_renderer/1","type":"function"},{"doc":"Starts the rendering pipeline GenServer. Registers under the module name by default.","ref":"Raxol.UI.Rendering.Pipeline.html#start_link/1","title":"Raxol.UI.Rendering.Pipeline.start_link/1","type":"function"},{"doc":"Triggers a render with the current UI tree (or provided data).","ref":"Raxol.UI.Rendering.Pipeline.html#trigger_render/1","title":"Raxol.UI.Rendering.Pipeline.trigger_render/1","type":"function"},{"doc":"Updates the UI tree in the pipeline and triggers a render.","ref":"Raxol.UI.Rendering.Pipeline.html#update_tree/1","title":"Raxol.UI.Rendering.Pipeline.update_tree/1","type":"function"},{"doc":"GenServer responsible for managing rendering state and applying animation settings.\nReceives commands from the rendering pipeline and coordinates rendering actions.","ref":"Raxol.UI.Rendering.Renderer.html","title":"Raxol.UI.Rendering.Renderer","type":"module"},{"doc":"Applies a diff to the renderer. For now, only full replacement is supported; granular diffs are logged and trigger a full render.","ref":"Raxol.UI.Rendering.Renderer.html#apply_diff/2","title":"Raxol.UI.Rendering.Renderer.apply_diff/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.UI.Rendering.Renderer.html#child_spec/1","title":"Raxol.UI.Rendering.Renderer.child_spec/1","type":"function"},{"doc":"Triggers a render with the current state.","ref":"Raxol.UI.Rendering.Renderer.html#render/1","title":"Raxol.UI.Rendering.Renderer.render/1","type":"function"},{"doc":"Sets animation settings for the renderer.","ref":"Raxol.UI.Rendering.Renderer.html#set_animation_settings/1","title":"Raxol.UI.Rendering.Renderer.set_animation_settings/1","type":"function"},{"doc":"Sets a test process PID to receive render messages (for test visibility).\nNo-op in production.","ref":"Raxol.UI.Rendering.Renderer.html#set_test_pid/1","title":"Raxol.UI.Rendering.Renderer.set_test_pid/1","type":"function"},{"doc":"Starts the rendering process.","ref":"Raxol.UI.Rendering.Renderer.html#start_link/1","title":"Raxol.UI.Rendering.Renderer.start_link/1","type":"function"},{"doc":"Provides functions to compute the difference (diff) between two UI trees.\nThis module is responsible for identifying changes, additions, removals,\nand reordering of nodes, supporting both keyed and non-keyed children.","ref":"Raxol.UI.Rendering.TreeDiffer.html","title":"Raxol.UI.Rendering.TreeDiffer","type":"module"},{"doc":"Computes the minimal set of changes (diff) between two UI trees.\n\nReturns:\n  * :no_change if trees are identical\n  * {:replace, new_tree} if the root node differs significantly\n  * {:update, path, changes} for subtree updates. `path` is a list of indices\n    to the parent node, and `changes` describes the modifications to its children\n    (either as indexed diffs or keyed operations).\n\nThe `path` in `{:update, path, changes}` always refers to the parent node whose\nchildren have changed. For keyed children, the recursive diffs for individual\nchildren (e.g., in `{:key_update, key, child_diff}`) will have their own paths\nrelative to that child (i.e., starting with `[]` if the child itself is the root\nof that sub-diff).","ref":"Raxol.UI.Rendering.TreeDiffer.html#diff_trees/2","title":"Raxol.UI.Rendering.TreeDiffer.diff_trees/2","type":"function"},{"doc":"A terminal UI rendering module for Raxol.\n\nThis module provides basic terminal rendering capabilities for Raxol applications,\nwith support for accessibility features, internationalization, and color system\nintegration.","ref":"Raxol.UI.Terminal.html","title":"Raxol.UI.Terminal","type":"module"},{"doc":"- Terminal screen management (clearing, cursor positioning)\n- Text rendering with colors and styles\n- Input handling with support for keyboard shortcuts\n- Basic UI elements (boxes, lines, progress bars)\n- RTL rendering support\n- Accessibility-friendly output formatting","ref":"Raxol.UI.Terminal.html#module-features","title":"Features - Raxol.UI.Terminal","type":"module"},{"doc":"Clear the terminal screen.","ref":"Raxol.UI.Terminal.html#clear/0","title":"Raxol.UI.Terminal.clear/0","type":"function"},{"doc":"iex> Terminal.clear()\n    :ok","ref":"Raxol.UI.Terminal.html#clear/0-examples","title":"Examples - Raxol.UI.Terminal.clear/0","type":"function"},{"doc":"Move the cursor to a specific position.","ref":"Raxol.UI.Terminal.html#move_cursor/2","title":"Raxol.UI.Terminal.move_cursor/2","type":"function"},{"doc":"* `row` - The row (1-indexed)\n* `col` - The column (1-indexed)","ref":"Raxol.UI.Terminal.html#move_cursor/2-parameters","title":"Parameters - Raxol.UI.Terminal.move_cursor/2","type":"function"},{"doc":"iex> Terminal.move_cursor(1, 1)\n    :ok","ref":"Raxol.UI.Terminal.html#move_cursor/2-examples","title":"Examples - Raxol.UI.Terminal.move_cursor/2","type":"function"},{"doc":"Print text with optional styling.","ref":"Raxol.UI.Terminal.html#print/2","title":"Raxol.UI.Terminal.print/2","type":"function"},{"doc":"* `:color` - The text color (hex string or color name)\n* `:background` - The background color (hex string or color name)\n* `:bold` - Whether to display the text in bold (default: false)\n* `:italic` - Whether to display the text in italic (default: false)\n* `:underline` - Whether to underline the text (default: false)\n* `:dim` - Whether to display the text dimmed (default: false)\n* `:blink` - Whether to make the text blink (default: false)\n* `:rtl` - Whether to render the text right-to-left (default: from I18n)","ref":"Raxol.UI.Terminal.html#print/2-options","title":"Options - Raxol.UI.Terminal.print/2","type":"function"},{"doc":"iex> Terminal.print(\"Hello\", color: \"#FF0000\", bold: true)\n    :ok","ref":"Raxol.UI.Terminal.html#print/2-examples","title":"Examples - Raxol.UI.Terminal.print/2","type":"function"},{"doc":"Print a box with content.","ref":"Raxol.UI.Terminal.html#print_box/2","title":"Raxol.UI.Terminal.print_box/2","type":"function"},{"doc":"* `content` - The text content to display inside the box\n* `opts` - Styling options","ref":"Raxol.UI.Terminal.html#print_box/2-parameters","title":"Parameters - Raxol.UI.Terminal.print_box/2","type":"function"},{"doc":"* `:width` - Box width (default: content width + 4)\n* `:height` - Box height (default: content lines + 2)\n* `:border_color` - Color for the border\n* `:title` - Optional title for the box\n* `:title_color` - Color for the title\n* `:centered` - Whether to center the box horizontally (default: false)","ref":"Raxol.UI.Terminal.html#print_box/2-options","title":"Options - Raxol.UI.Terminal.print_box/2","type":"function"},{"doc":"iex> Terminal.print_box(\"Hello\nWorld\", title: \"Greeting\", border_color: \"#0000FF\")\n    :ok","ref":"Raxol.UI.Terminal.html#print_box/2-examples","title":"Examples - Raxol.UI.Terminal.print_box/2","type":"function"},{"doc":"Print centered text.","ref":"Raxol.UI.Terminal.html#print_centered/2","title":"Raxol.UI.Terminal.print_centered/2","type":"function"},{"doc":"Takes the same options as `print/2`.","ref":"Raxol.UI.Terminal.html#print_centered/2-options","title":"Options - Raxol.UI.Terminal.print_centered/2","type":"function"},{"doc":"iex> Terminal.print_centered(\"Title\", color: \"#FF0000\", bold: true)\n    :ok","ref":"Raxol.UI.Terminal.html#print_centered/2-examples","title":"Examples - Raxol.UI.Terminal.print_centered/2","type":"function"},{"doc":"Print a horizontal line spanning the terminal width.","ref":"Raxol.UI.Terminal.html#print_horizontal_line/1","title":"Raxol.UI.Terminal.print_horizontal_line/1","type":"function"},{"doc":"* `:char` - The character to use for the line (default: \"─\")\n* Other options are passed to `print/2`","ref":"Raxol.UI.Terminal.html#print_horizontal_line/1-options","title":"Options - Raxol.UI.Terminal.print_horizontal_line/1","type":"function"},{"doc":"iex> Terminal.print_horizontal_line(char: \"-\", color: \"#CCCCCC\")\n    :ok","ref":"Raxol.UI.Terminal.html#print_horizontal_line/1-examples","title":"Examples - Raxol.UI.Terminal.print_horizontal_line/1","type":"function"},{"doc":"Print text followed by a newline.\n\nTakes the same options as `print/2`.","ref":"Raxol.UI.Terminal.html#println/2","title":"Raxol.UI.Terminal.println/2","type":"function"},{"doc":"iex> Terminal.println(\"Hello\", color: \"#FF0000\", bold: true)\n    :ok","ref":"Raxol.UI.Terminal.html#println/2-examples","title":"Examples - Raxol.UI.Terminal.println/2","type":"function"},{"doc":"Read a keypress from the user.","ref":"Raxol.UI.Terminal.html#read_key/1","title":"Raxol.UI.Terminal.read_key/1","type":"function"},{"doc":"* `:timeout` - Timeout in milliseconds (default: :infinity)","ref":"Raxol.UI.Terminal.html#read_key/1-options","title":"Options - Raxol.UI.Terminal.read_key/1","type":"function"},{"doc":"* `{:ok, key}` - Where key is the key pressed\n* `:timeout` - If no key was pressed within the timeout\n* `{:error, reason}` - If an error occurred","ref":"Raxol.UI.Terminal.html#read_key/1-returns","title":"Returns - Raxol.UI.Terminal.read_key/1","type":"function"},{"doc":"iex> Terminal.read_key()\n    {:ok, :enter}\n\n    iex> Terminal.read_key(timeout: 1000)\n    :timeout","ref":"Raxol.UI.Terminal.html#read_key/1-examples","title":"Examples - Raxol.UI.Terminal.read_key/1","type":"function"},{"doc":"Color management utilities for theme handling.\n\nThis module provides functions for working with colors in the context of UI theming,\nincluding color format conversion, manipulation, and theme-specific operations.","ref":"Raxol.UI.Theming.Colors.html","title":"Raxol.UI.Theming.Colors","type":"module"},{"doc":"- Color format conversion (hex, RGB, ANSI)\n- Color manipulation (lighten, darken, blend)\n- Theme color management\n- Accessibility checks","ref":"Raxol.UI.Theming.Colors.html#module-features","title":"Features - Raxol.UI.Theming.Colors","type":"module"},{"doc":"Checks if two colors are accessible according to WCAG contrast requirements.","ref":"Raxol.UI.Theming.Colors.html#accessible?/4","title":"Raxol.UI.Theming.Colors.accessible?/4","type":"function"},{"doc":"iex> accessible?(\"#FFFFFF\", \"#000000\", :aa, :normal)\n    true","ref":"Raxol.UI.Theming.Colors.html#accessible?/4-examples","title":"Examples - Raxol.UI.Theming.Colors.accessible?/4","type":"function"},{"doc":"Converts an ANSI color code to RGB values.","ref":"Raxol.UI.Theming.Colors.html#ansi_to_rgb/1","title":"Raxol.UI.Theming.Colors.ansi_to_rgb/1","type":"function"},{"doc":"iex> ansi_to_rgb(1)\n    {205, 0, 0}","ref":"Raxol.UI.Theming.Colors.html#ansi_to_rgb/1-examples","title":"Examples - Raxol.UI.Theming.Colors.ansi_to_rgb/1","type":"function"},{"doc":"Blends two colors with the specified alpha value.","ref":"Raxol.UI.Theming.Colors.html#blend/3","title":"Raxol.UI.Theming.Colors.blend/3","type":"function"},{"doc":"iex> blend(\"#FF0000\", \"#0000FF\", 0.5)\n    \"#800080\"\n    iex> blend(:red, :blue, 0.5)\n    \"#800080\"","ref":"Raxol.UI.Theming.Colors.html#blend/3-examples","title":"Examples - Raxol.UI.Theming.Colors.blend/3","type":"function"},{"doc":"","ref":"Raxol.UI.Theming.Colors.html#t:color_hex/0","title":"Raxol.UI.Theming.Colors.color_hex/0","type":"type"},{"doc":"","ref":"Raxol.UI.Theming.Colors.html#t:color_hsl/0","title":"Raxol.UI.Theming.Colors.color_hsl/0","type":"type"},{"doc":"","ref":"Raxol.UI.Theming.Colors.html#t:color_name/0","title":"Raxol.UI.Theming.Colors.color_name/0","type":"type"},{"doc":"","ref":"Raxol.UI.Theming.Colors.html#t:color_rgb/0","title":"Raxol.UI.Theming.Colors.color_rgb/0","type":"type"},{"doc":"","ref":"Raxol.UI.Theming.Colors.html#t:color_rgba/0","title":"Raxol.UI.Theming.Colors.color_rgba/0","type":"type"},{"doc":"Calculates the contrast ratio between two colors.","ref":"Raxol.UI.Theming.Colors.html#contrast_ratio/2","title":"Raxol.UI.Theming.Colors.contrast_ratio/2","type":"function"},{"doc":"iex> contrast_ratio(\"#FFFFFF\", \"#000000\")\n    21.0\n    iex> contrast_ratio(:white, :black)\n    21.0","ref":"Raxol.UI.Theming.Colors.html#contrast_ratio/2-examples","title":"Examples - Raxol.UI.Theming.Colors.contrast_ratio/2","type":"function"},{"doc":"","ref":"Raxol.UI.Theming.Colors.html#convert_to_basic/1","title":"Raxol.UI.Theming.Colors.convert_to_basic/1","type":"function"},{"doc":"Converts a color or theme map to use a specific palette (e.g., 256 colors).\nFinds the closest color in the palette for each color in the theme.\n*Currently only supports named palettes like :xterm256*","ref":"Raxol.UI.Theming.Colors.html#convert_to_palette/2","title":"Raxol.UI.Theming.Colors.convert_to_palette/2","type":"function"},{"doc":"Darkens a color by the specified amount.","ref":"Raxol.UI.Theming.Colors.html#darken/2","title":"Raxol.UI.Theming.Colors.darken/2","type":"function"},{"doc":"iex> darken(\"#FFFFFF\", 0.5)\n    \"#808080\"\n    iex> darken(:red, 0.5)\n    \"#800000\"","ref":"Raxol.UI.Theming.Colors.html#darken/2-examples","title":"Examples - Raxol.UI.Theming.Colors.darken/2","type":"function"},{"doc":"Finds the closest ANSI 256-color index (0-255) to the given RGB color.","ref":"Raxol.UI.Theming.Colors.html#find_closest_256_color/1","title":"Raxol.UI.Theming.Colors.find_closest_256_color/1","type":"function"},{"doc":"Finds the closest ANSI basic color index (0-15) to the given RGB color.","ref":"Raxol.UI.Theming.Colors.html#find_closest_basic_color/1","title":"Raxol.UI.Theming.Colors.find_closest_basic_color/1","type":"function"},{"doc":"Converts a hex color string to RGB values.","ref":"Raxol.UI.Theming.Colors.html#hex_to_rgb/1","title":"Raxol.UI.Theming.Colors.hex_to_rgb/1","type":"function"},{"doc":"iex> hex_to_rgb(\"#FF0000\")\n    {255, 0, 0}","ref":"Raxol.UI.Theming.Colors.html#hex_to_rgb/1-examples","title":"Examples - Raxol.UI.Theming.Colors.hex_to_rgb/1","type":"function"},{"doc":"Converts HSL values to RGB values.","ref":"Raxol.UI.Theming.Colors.html#hsl_to_rgb/3","title":"Raxol.UI.Theming.Colors.hsl_to_rgb/3","type":"function"},{"doc":"iex> hsl_to_rgb(0, 1.0, 0.5)\n    {255, 0, 0}","ref":"Raxol.UI.Theming.Colors.html#hsl_to_rgb/3-examples","title":"Examples - Raxol.UI.Theming.Colors.hsl_to_rgb/3","type":"function"},{"doc":"Lightens a color by the specified amount.","ref":"Raxol.UI.Theming.Colors.html#lighten/2","title":"Raxol.UI.Theming.Colors.lighten/2","type":"function"},{"doc":"iex> lighten(\"#000000\", 0.5)\n    \"#808080\"\n    iex> lighten(:red, 0.5)\n    \"#FF8080\"","ref":"Raxol.UI.Theming.Colors.html#lighten/2-examples","title":"Examples - Raxol.UI.Theming.Colors.lighten/2","type":"function"},{"doc":"Checks if two colors meet WCAG contrast requirements.","ref":"Raxol.UI.Theming.Colors.html#meets_contrast_requirements?/4","title":"Raxol.UI.Theming.Colors.meets_contrast_requirements?/4","type":"function"},{"doc":"iex> meets_contrast_requirements?(\"#FFFFFF\", \"#000000\", :AA, :normal)\n    true","ref":"Raxol.UI.Theming.Colors.html#meets_contrast_requirements?/4-examples","title":"Examples - Raxol.UI.Theming.Colors.meets_contrast_requirements?/4","type":"function"},{"doc":"Converts RGB values to the closest ANSI color code.","ref":"Raxol.UI.Theming.Colors.html#rgb_to_ansi/3","title":"Raxol.UI.Theming.Colors.rgb_to_ansi/3","type":"function"},{"doc":"iex> rgb_to_ansi(255, 0, 0)\n    196","ref":"Raxol.UI.Theming.Colors.html#rgb_to_ansi/3-examples","title":"Examples - Raxol.UI.Theming.Colors.rgb_to_ansi/3","type":"function"},{"doc":"Converts RGB values to a hex color string.","ref":"Raxol.UI.Theming.Colors.html#rgb_to_hex/3","title":"Raxol.UI.Theming.Colors.rgb_to_hex/3","type":"function"},{"doc":"iex> rgb_to_hex(255, 0, 0)\n    \"#FF0000\"","ref":"Raxol.UI.Theming.Colors.html#rgb_to_hex/3-examples","title":"Examples - Raxol.UI.Theming.Colors.rgb_to_hex/3","type":"function"},{"doc":"Converts RGB values to HSL values.","ref":"Raxol.UI.Theming.Colors.html#rgb_to_hsl/3","title":"Raxol.UI.Theming.Colors.rgb_to_hsl/3","type":"function"},{"doc":"iex> rgb_to_hsl(255, 0, 0)\n    {0, 1.0, 0.5}","ref":"Raxol.UI.Theming.Colors.html#rgb_to_hsl/3-examples","title":"Examples - Raxol.UI.Theming.Colors.rgb_to_hsl/3","type":"function"},{"doc":"Converts a color to its ANSI representation.","ref":"Raxol.UI.Theming.Colors.html#to_ansi/1","title":"Raxol.UI.Theming.Colors.to_ansi/1","type":"function"},{"doc":"iex> Colors.to_ansi(:red)\n    196\n\n    iex> Colors.to_ansi(\"#FF0000\")\n    196","ref":"Raxol.UI.Theming.Colors.html#to_ansi/1-examples","title":"Examples - Raxol.UI.Theming.Colors.to_ansi/1","type":"function"},{"doc":"Converts a color to its ANSI 16-color representation.","ref":"Raxol.UI.Theming.Colors.html#to_ansi_16/1","title":"Raxol.UI.Theming.Colors.to_ansi_16/1","type":"function"},{"doc":"iex> Colors.to_ansi_16(:red)\n    1\n\n    iex> Colors.to_ansi_16(\"#FF0000\")\n    1","ref":"Raxol.UI.Theming.Colors.html#to_ansi_16/1-examples","title":"Examples - Raxol.UI.Theming.Colors.to_ansi_16/1","type":"function"},{"doc":"Converts a color to its hex representation.","ref":"Raxol.UI.Theming.Colors.html#to_hex/1","title":"Raxol.UI.Theming.Colors.to_hex/1","type":"function"},{"doc":"iex> Colors.to_hex(:red)\n    \"#FF0000\"\n\n    iex> Colors.to_hex(\"#00FF00\")\n    \"#00FF00\"","ref":"Raxol.UI.Theming.Colors.html#to_hex/1-examples","title":"Examples - Raxol.UI.Theming.Colors.to_hex/1","type":"function"},{"doc":"Converts a color from one format to RGB values.","ref":"Raxol.UI.Theming.Colors.html#to_rgb/1","title":"Raxol.UI.Theming.Colors.to_rgb/1","type":"function"},{"doc":"iex> Colors.to_rgb(\"#FF0000\")\n    {255, 0, 0}\n\n    iex> Colors.to_rgb(:blue)\n    {0, 0, 255}","ref":"Raxol.UI.Theming.Colors.html#to_rgb/1-examples","title":"Examples - Raxol.UI.Theming.Colors.to_rgb/1","type":"function"},{"doc":"A component for selecting and applying themes.\n\nThis module provides:\n* A list-based theme selector UI\n* Theme preview capabilities\n* Theme application functionality\n* Theme management integration","ref":"Raxol.UI.Theming.Selector.html","title":"Raxol.UI.Theming.Selector","type":"module"},{"doc":"","ref":"Raxol.UI.Theming.Selector.html#broadcast/1","title":"Raxol.UI.Theming.Selector.broadcast/1","type":"function"},{"doc":"","ref":"Raxol.UI.Theming.Selector.html#command/1","title":"Raxol.UI.Theming.Selector.command/1","type":"function"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.mount/1 .","ref":"Raxol.UI.Theming.Selector.html#mount/1","title":"Raxol.UI.Theming.Selector.mount/1","type":"function"},{"doc":"","ref":"Raxol.UI.Theming.Selector.html#t:props/0","title":"Raxol.UI.Theming.Selector.props/0","type":"type"},{"doc":"","ref":"Raxol.UI.Theming.Selector.html#schedule/2","title":"Raxol.UI.Theming.Selector.schedule/2","type":"function"},{"doc":"","ref":"Raxol.UI.Theming.Selector.html#t:state/0","title":"Raxol.UI.Theming.Selector.state/0","type":"type"},{"doc":"","ref":"Raxol.UI.Theming.Selector.html#t:t/0","title":"Raxol.UI.Theming.Selector.t/0","type":"type"},{"doc":"Callback implementation for  Raxol.UI.Components.Base.Component.unmount/1 .","ref":"Raxol.UI.Theming.Selector.html#unmount/1","title":"Raxol.UI.Theming.Selector.unmount/1","type":"function"},{"doc":"Theme management for Raxol UI components.\n\nThis module provides functionality for:\n- Theme definition and management\n- Color palette integration\n- Component styling\n- Theme variants and accessibility","ref":"Raxol.UI.Theming.Theme.html","title":"Raxol.UI.Theming.Theme","type":"module"},{"doc":"Returns a high-contrast version of the given theme, for accessibility support.\nIf the theme is already high-contrast, returns it unchanged.","ref":"Raxol.UI.Theming.Theme.html#adjust_for_high_contrast/1","title":"Raxol.UI.Theming.Theme.adjust_for_high_contrast/1","type":"function"},{"doc":"Applies a theme by name or struct.","ref":"Raxol.UI.Theming.Theme.html#apply_theme/1","title":"Raxol.UI.Theming.Theme.apply_theme/1","type":"function"},{"doc":"","ref":"Raxol.UI.Theming.Theme.html#t:color_value/0","title":"Raxol.UI.Theming.Theme.color_value/0","type":"type"},{"doc":"","ref":"Raxol.UI.Theming.Theme.html#component_style/2","title":"Raxol.UI.Theming.Theme.component_style/2","type":"function"},{"doc":"Creates a high contrast variant of the theme.","ref":"Raxol.UI.Theming.Theme.html#create_high_contrast_variant/1","title":"Raxol.UI.Theming.Theme.create_high_contrast_variant/1","type":"function"},{"doc":"Returns the current theme.","ref":"Raxol.UI.Theming.Theme.html#current/0","title":"Raxol.UI.Theming.Theme.current/0","type":"function"},{"doc":"Returns the dark theme.","ref":"Raxol.UI.Theming.Theme.html#dark_theme/0","title":"Raxol.UI.Theming.Theme.dark_theme/0","type":"function"},{"doc":"Returns the default theme.","ref":"Raxol.UI.Theming.Theme.html#default_theme/0","title":"Raxol.UI.Theming.Theme.default_theme/0","type":"function"},{"doc":"","ref":"Raxol.UI.Theming.Theme.html#default_theme_id/0","title":"Raxol.UI.Theming.Theme.default_theme_id/0","type":"function"},{"doc":"Gets a theme by ID.","ref":"Raxol.UI.Theming.Theme.html#get/1","title":"Raxol.UI.Theming.Theme.get/1","type":"function"},{"doc":"Gets a color from the theme, respecting variants and accessibility settings.","ref":"Raxol.UI.Theming.Theme.html#get_color/3","title":"Raxol.UI.Theming.Theme.get_color/3","type":"function"},{"doc":"Gets a component style from the theme.","ref":"Raxol.UI.Theming.Theme.html#get_component_style/2","title":"Raxol.UI.Theming.Theme.get_component_style/2","type":"function"},{"doc":"Initializes the theme system and registers the default theme.\nThis should be called during application startup.","ref":"Raxol.UI.Theming.Theme.html#init/0","title":"Raxol.UI.Theming.Theme.init/0","type":"function"},{"doc":"Lists all available themes.","ref":"Raxol.UI.Theming.Theme.html#list_themes/0","title":"Raxol.UI.Theming.Theme.list_themes/0","type":"function"},{"doc":"Creates a new theme with the given attributes.","ref":"Raxol.UI.Theming.Theme.html#new/0","title":"Raxol.UI.Theming.Theme.new/0","type":"function"},{"doc":"","ref":"Raxol.UI.Theming.Theme.html#new/1","title":"Raxol.UI.Theming.Theme.new/1","type":"function"},{"doc":"Registers a theme in the application environment.","ref":"Raxol.UI.Theming.Theme.html#register/1","title":"Raxol.UI.Theming.Theme.register/1","type":"function"},{"doc":"","ref":"Raxol.UI.Theming.Theme.html#t:style_map/0","title":"Raxol.UI.Theming.Theme.style_map/0","type":"type"},{"doc":"Defines the behaviour for Theme services.","ref":"Raxol.UI.Theming.ThemeBehaviour.html","title":"Raxol.UI.Theming.ThemeBehaviour","type":"behaviour"},{"doc":"Applies a theme to an element tree.","ref":"Raxol.UI.Theming.ThemeBehaviour.html#c:apply_theme/2","title":"Raxol.UI.Theming.ThemeBehaviour.apply_theme/2","type":"callback"},{"doc":"Gets a color from a theme.","ref":"Raxol.UI.Theming.ThemeBehaviour.html#c:color/2","title":"Raxol.UI.Theming.ThemeBehaviour.color/2","type":"callback"},{"doc":"Gets a component style from a theme.","ref":"Raxol.UI.Theming.ThemeBehaviour.html#c:component_style/2","title":"Raxol.UI.Theming.ThemeBehaviour.component_style/2","type":"callback"},{"doc":"Gets the current theme system version as a string.","ref":"Raxol.UI.Theming.ThemeBehaviour.html#c:current_version/0","title":"Raxol.UI.Theming.ThemeBehaviour.current_version/0","type":"callback"},{"doc":"Gets the dark theme.","ref":"Raxol.UI.Theming.ThemeBehaviour.html#c:dark_theme/0","title":"Raxol.UI.Theming.ThemeBehaviour.dark_theme/0","type":"callback"},{"doc":"Gets the default theme.","ref":"Raxol.UI.Theming.ThemeBehaviour.html#c:default_theme/0","title":"Raxol.UI.Theming.ThemeBehaviour.default_theme/0","type":"callback"},{"doc":"Gets a theme by ID.","ref":"Raxol.UI.Theming.ThemeBehaviour.html#c:get/1","title":"Raxol.UI.Theming.ThemeBehaviour.get/1","type":"callback"},{"doc":"Gets a color value considering the theme and an optional variant.","ref":"Raxol.UI.Theming.ThemeBehaviour.html#c:get_color/3","title":"Raxol.UI.Theming.ThemeBehaviour.get_color/3","type":"callback"},{"doc":"Initializes the theme system.","ref":"Raxol.UI.Theming.ThemeBehaviour.html#c:init/0","title":"Raxol.UI.Theming.ThemeBehaviour.init/0","type":"callback"},{"doc":"Lists all registered themes.","ref":"Raxol.UI.Theming.ThemeBehaviour.html#c:list/0","title":"Raxol.UI.Theming.ThemeBehaviour.list/0","type":"callback"},{"doc":"Registers a theme.","ref":"Raxol.UI.Theming.ThemeBehaviour.html#c:register/1","title":"Raxol.UI.Theming.ThemeBehaviour.register/1","type":"callback"},{"doc":"","ref":"Raxol.UI.Theming.ThemeBehaviour.html#t:theme_t/0","title":"Raxol.UI.Theming.ThemeBehaviour.theme_t/0","type":"type"},{"doc":"Provides component functions for Raxol views.\n\nThis module contains functions for creating various UI components\nthat can be used in Raxol views.","ref":"Raxol.View.Components.html","title":"Raxol.View.Components","type":"module"},{"doc":"Creates a button component with options for label, click action, style, and disabled state.","ref":"Raxol.View.Components.html#button/2","title":"Raxol.View.Components.button/2","type":"function"},{"doc":"- `:label` - The button text\n- `:on_click` - Function to call when clicked\n- `:style` - Style options for the button\n- `:disabled` - Whether the button is disabled","ref":"Raxol.View.Components.html#button/2-options","title":"Options - Raxol.View.Components.button/2","type":"function"},{"doc":"button(\"Submit\", on_click: &handle_submit/0, style: [bg: :blue])","ref":"Raxol.View.Components.html#button/2-example","title":"Example - Raxol.View.Components.button/2","type":"function"},{"doc":"Creates a label component with options for text, width, and style.","ref":"Raxol.View.Components.html#label/2","title":"Raxol.View.Components.label/2","type":"function"},{"doc":"- `:width` - Width of the label in characters\n- `:style` - Style options for the label\n- `:align` - Text alignment (:left, :center, :right)","ref":"Raxol.View.Components.html#label/2-options","title":"Options - Raxol.View.Components.label/2","type":"function"},{"doc":"label(\"Username:\", width: 10)\n    label(\"Password:\", width: 10, align: :right)","ref":"Raxol.View.Components.html#label/2-example","title":"Example - Raxol.View.Components.label/2","type":"function"},{"doc":"Creates a space component with options for width and height.","ref":"Raxol.View.Components.html#space/1","title":"Raxol.View.Components.space/1","type":"function"},{"doc":"- `:width` - Width of the space in characters\n- `:height` - Height of the space in lines\n- `:style` - Style options for the space","ref":"Raxol.View.Components.html#space/1-options","title":"Options - Raxol.View.Components.space/1","type":"function"},{"doc":"space(width: 2)\n    space(width: 1, height: 2)","ref":"Raxol.View.Components.html#space/1-example","title":"Example - Raxol.View.Components.space/1","type":"function"},{"doc":"Creates a text component with options for content, style, foreground, and background colors.","ref":"Raxol.View.Components.html#text/2","title":"Raxol.View.Components.text/2","type":"function"},{"doc":"- `:content` - The text content to display\n- `:style` - Style options for the text (font, size, etc.)\n- `:fg` - Foreground color\n- `:bg` - Background color","ref":"Raxol.View.Components.html#text/2-options","title":"Options - Raxol.View.Components.text/2","type":"function"},{"doc":"text(\"Hello World\", style: [bold: true], fg: :blue)","ref":"Raxol.View.Components.html#text/2-example","title":"Example - Raxol.View.Components.text/2","type":"function"},{"doc":"Creates a text input component with options for value, placeholder, change action, and style.","ref":"Raxol.View.Components.html#text_input/1","title":"Raxol.View.Components.text_input/1","type":"function"},{"doc":"- `:value` - Current input value\n- `:placeholder` - Placeholder text\n- `:on_change` - Function to call when value changes\n- `:style` - Style options for the input","ref":"Raxol.View.Components.html#text_input/1-options","title":"Options - Raxol.View.Components.text_input/1","type":"function"},{"doc":"text_input(value: name, placeholder: \"Enter your name\", on_change: &handle_name_change/1)","ref":"Raxol.View.Components.html#text_input/1-example","title":"Example - Raxol.View.Components.text_input/1","type":"function"},{"doc":"Basic UI elements for Raxol views.\n\nThis module defines the core UI elements that can be used\nin Raxol views.","ref":"Raxol.View.Elements.html","title":"Raxol.View.Elements","type":"module"},{"doc":"Creates a box container, often used for bordering or grouping.","ref":"Raxol.View.Elements.html#box/2","title":"Raxol.View.Elements.box/2","type":"macro"},{"doc":"* `:style` - Map containing styling attributes (e.g., border, padding)","ref":"Raxol.View.Elements.html#box/2-options","title":"Options - Raxol.View.Elements.box/2","type":"macro"},{"doc":"```elixir\nbox style: %{border: :single, padding: 1} do\n  text content: \"Content inside the box\"\nend\n```","ref":"Raxol.View.Elements.html#box/2-example","title":"Example - Raxol.View.Elements.box/2","type":"macro"},{"doc":"Creates a button that can be clicked.","ref":"Raxol.View.Elements.html#button/1","title":"Raxol.View.Elements.button/1","type":"macro"},{"doc":"* `:label` - The button text\n* `:on_click` - The message to send when clicked","ref":"Raxol.View.Elements.html#button/1-options","title":"Options - Raxol.View.Elements.button/1","type":"macro"},{"doc":"```elixir\nbutton label: \"Click me\", on_click: :button_clicked\n```","ref":"Raxol.View.Elements.html#button/1-example","title":"Example - Raxol.View.Elements.button/1","type":"macro"},{"doc":"Creates a checkbox.","ref":"Raxol.View.Elements.html#checkbox/1","title":"Raxol.View.Elements.checkbox/1","type":"macro"},{"doc":"* `:checked` - Whether the checkbox is checked\n* `:label` - The checkbox label\n* `:on_toggle` - Function to call when toggled","ref":"Raxol.View.Elements.html#checkbox/1-options","title":"Options - Raxol.View.Elements.checkbox/1","type":"macro"},{"doc":"```elixir\ncheckbox checked: model.agreed, label: \"I agree to terms\", on_toggle: fn value -> {:update_agreed, value} end\n```","ref":"Raxol.View.Elements.html#checkbox/1-example","title":"Example - Raxol.View.Elements.checkbox/1","type":"macro"},{"doc":"Creates a column layout for vertical arrangement.","ref":"Raxol.View.Elements.html#column/2","title":"Raxol.View.Elements.column/2","type":"macro"},{"doc":"* `:size` - The column size (1-12)","ref":"Raxol.View.Elements.html#column/2-options","title":"Options - Raxol.View.Elements.column/2","type":"macro"},{"doc":"```elixir\ncolumn size: 6 do\n  label content: \"Half width\"\nend\n```","ref":"Raxol.View.Elements.html#column/2-example","title":"Example - Raxol.View.Elements.column/2","type":"macro"},{"doc":"Creates a text input field.","ref":"Raxol.View.Elements.html#input/1","title":"Raxol.View.Elements.input/1","type":"macro"},{"doc":"* `:value` - The current input value\n* `:cursor` - The cursor position\n* `:focused` - Whether the input is focused\n* `:placeholder` - Placeholder text\n* `:password` - Whether to mask the input (boolean)","ref":"Raxol.View.Elements.html#input/1-options","title":"Options - Raxol.View.Elements.input/1","type":"macro"},{"doc":"Creates a text label.","ref":"Raxol.View.Elements.html#label/1","title":"Raxol.View.Elements.label/1","type":"macro"},{"doc":"* `:content` - The label text\n* Other options are passed as attributes","ref":"Raxol.View.Elements.html#label/1-options","title":"Options - Raxol.View.Elements.label/1","type":"macro"},{"doc":"Creates a label element with the given text and options.","ref":"Raxol.View.Elements.html#label/2","title":"Raxol.View.Elements.label/2","type":"macro"},{"doc":"Creates a panel with a title and content.","ref":"Raxol.View.Elements.html#panel/2","title":"Raxol.View.Elements.panel/2","type":"macro"},{"doc":"* `:title` - The panel title\n* `:height` - The panel height (optional)\n* `:width` - The panel width (optional)","ref":"Raxol.View.Elements.html#panel/2-options","title":"Options - Raxol.View.Elements.panel/2","type":"macro"},{"doc":"```elixir\npanel title: \"Information\" do\n  label content: \"Some information\"\nend\n```","ref":"Raxol.View.Elements.html#panel/2-example","title":"Example - Raxol.View.Elements.panel/2","type":"macro"},{"doc":"Creates a row layout for horizontal arrangement.","ref":"Raxol.View.Elements.html#row/2","title":"Raxol.View.Elements.row/2","type":"macro"},{"doc":"```elixir\nrow do\n  label content: \"Left\"\n  label content: \"Right\"\nend\n```","ref":"Raxol.View.Elements.html#row/2-example","title":"Example - Raxol.View.Elements.row/2","type":"macro"},{"doc":"Creates a table for displaying tabular data.","ref":"Raxol.View.Elements.html#table/1","title":"Raxol.View.Elements.table/1","type":"macro"},{"doc":"* `:headers` - List of column headers\n* `:data` - List of rows, where each row is a list of cells","ref":"Raxol.View.Elements.html#table/1-options","title":"Options - Raxol.View.Elements.table/1","type":"macro"},{"doc":"```elixir\ntable headers: [\"Name\", \"Age\", \"City\"], data: [[\"John\", \"25\", \"New York\"], [\"Jane\", \"30\", \"San Francisco\"]]\n```","ref":"Raxol.View.Elements.html#table/1-example","title":"Example - Raxol.View.Elements.table/1","type":"macro"},{"doc":"Creates a text input field.","ref":"Raxol.View.Elements.html#text_input/1","title":"Raxol.View.Elements.text_input/1","type":"macro"},{"doc":"* `:value` - The current input value\n* `:placeholder` - Placeholder text\n* `:on_change` - Function to call when value changes","ref":"Raxol.View.Elements.html#text_input/1-options","title":"Options - Raxol.View.Elements.text_input/1","type":"macro"},{"doc":"```elixir\ntext_input value: model.name, placeholder: \"Enter your name\", on_change: fn value -> {:update_name, value} end\n```","ref":"Raxol.View.Elements.html#text_input/1-example","title":"Example - Raxol.View.Elements.text_input/1","type":"macro"},{"doc":"Provides layout functions for Raxol views.\n\nThis module previously contained functions for creating layout components\nthat can be used in Raxol views.\nThese have been superseded by macros in `Raxol.View.Elements`.","ref":"Raxol.View.Layout.html","title":"Raxol.View.Layout","type":"module"},{"doc":"Manages authentication state and operations for the Raxol application.","ref":"Raxol.Web.Auth.Manager.html","title":"Raxol.Web.Auth.Manager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Web.Auth.Manager.html#child_spec/1","title":"Raxol.Web.Auth.Manager.child_spec/1","type":"function"},{"doc":"Callback implementation for  GenServer.init/1 .","ref":"Raxol.Web.Auth.Manager.html#init/1","title":"Raxol.Web.Auth.Manager.init/1","type":"function"},{"doc":"","ref":"Raxol.Web.Auth.Manager.html#start_link/1","title":"Raxol.Web.Auth.Manager.start_link/1","type":"function"},{"doc":"Manages web sessions and terminal connections for the Raxol application.","ref":"Raxol.Web.Manager.html","title":"Raxol.Web.Manager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Web.Manager.html#child_spec/1","title":"Raxol.Web.Manager.child_spec/1","type":"function"},{"doc":"Callback implementation for  GenServer.init/1 .","ref":"Raxol.Web.Manager.html#init/1","title":"Raxol.Web.Manager.init/1","type":"function"},{"doc":"","ref":"Raxol.Web.Manager.html#start_link/1","title":"Raxol.Web.Manager.start_link/1","type":"function"},{"doc":"Handles session cleanup for Raxol applications.\n\nThis module provides functionality to clean up expired and inactive sessions,\nensuring efficient resource usage and data hygiene.","ref":"Raxol.Web.Session.Cleanup.html","title":"Raxol.Web.Session.Cleanup","type":"module"},{"doc":"Clean up expired sessions.","ref":"Raxol.Web.Session.Cleanup.html#cleanup_expired_sessions/0","title":"Raxol.Web.Session.Cleanup.cleanup_expired_sessions/0","type":"function"},{"doc":"Clean up old sessions.","ref":"Raxol.Web.Session.Cleanup.html#cleanup_old_sessions/1","title":"Raxol.Web.Session.Cleanup.cleanup_old_sessions/1","type":"function"},{"doc":"Clean up orphaned sessions.","ref":"Raxol.Web.Session.Cleanup.html#cleanup_orphaned_sessions/0","title":"Raxol.Web.Session.Cleanup.cleanup_orphaned_sessions/0","type":"function"},{"doc":"Initialize the session cleanup system.","ref":"Raxol.Web.Session.Cleanup.html#init/0","title":"Raxol.Web.Session.Cleanup.init/0","type":"function"},{"doc":"Manages web sessions for Raxol applications.\n\nThis module provides comprehensive session management capabilities:\n* Session storage and retrieval\n* Session recovery and cleanup\n* Session limits and monitoring\n* Session metadata management","ref":"Raxol.Web.Session.Manager.html","title":"Raxol.Web.Session.Manager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Web.Session.Manager.html#child_spec/1","title":"Raxol.Web.Session.Manager.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Web.Session.Manager.html#cleanup_sessions/0","title":"Raxol.Web.Session.Manager.cleanup_sessions/0","type":"function"},{"doc":"","ref":"Raxol.Web.Session.Manager.html#create_session/2","title":"Raxol.Web.Session.Manager.create_session/2","type":"function"},{"doc":"","ref":"Raxol.Web.Session.Manager.html#end_session/1","title":"Raxol.Web.Session.Manager.end_session/1","type":"function"},{"doc":"","ref":"Raxol.Web.Session.Manager.html#get_active_sessions/0","title":"Raxol.Web.Session.Manager.get_active_sessions/0","type":"function"},{"doc":"","ref":"Raxol.Web.Session.Manager.html#get_session/1","title":"Raxol.Web.Session.Manager.get_session/1","type":"function"},{"doc":"","ref":"Raxol.Web.Session.Manager.html#start_link/1","title":"Raxol.Web.Session.Manager.start_link/1","type":"function"},{"doc":"","ref":"Raxol.Web.Session.Manager.html#update_session/2","title":"Raxol.Web.Session.Manager.update_session/2","type":"function"},{"doc":"Handles session monitoring for Raxol applications.\n\nThis module provides functionality to monitor active sessions, track usage\npatterns, and detect potential issues.","ref":"Raxol.Web.Session.Monitor.html","title":"Raxol.Web.Session.Monitor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Web.Session.Monitor.html#child_spec/1","title":"Raxol.Web.Session.Monitor.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Web.Session.Monitor.html#get_active_users/0","title":"Raxol.Web.Session.Monitor.get_active_users/0","type":"function"},{"doc":"","ref":"Raxol.Web.Session.Monitor.html#get_session_stats/0","title":"Raxol.Web.Session.Monitor.get_session_stats/0","type":"function"},{"doc":"","ref":"Raxol.Web.Session.Monitor.html#start_link/1","title":"Raxol.Web.Session.Monitor.start_link/1","type":"function"},{"doc":"Handles session recovery for Raxol applications.\n\nThis module provides functionality to recover sessions after crashes or\nunexpected terminations, ensuring session continuity and data integrity.","ref":"Raxol.Web.Session.Recovery.html","title":"Raxol.Web.Session.Recovery","type":"module"},{"doc":"Initialize the session recovery system.","ref":"Raxol.Web.Session.Recovery.html#init/0","title":"Raxol.Web.Session.Recovery.init/0","type":"function"},{"doc":"Recover a specific session.","ref":"Raxol.Web.Session.Recovery.html#recover_session/1","title":"Raxol.Web.Session.Recovery.recover_session/1","type":"function"},{"doc":"Database schema for session storage.","ref":"Raxol.Web.Session.Session.html","title":"Raxol.Web.Session.Session","type":"module"},{"doc":"Creates a changeset for a session.","ref":"Raxol.Web.Session.Session.html#changeset/2","title":"Raxol.Web.Session.Session.changeset/2","type":"function"},{"doc":"Handles session storage and retrieval for Raxol applications.\n\nThis module provides persistent storage for session data using ETS tables\nand optional database storage for long-term persistence.","ref":"Raxol.Web.Session.Storage.html","title":"Raxol.Web.Session.Storage","type":"module"},{"doc":"Delete a session from storage.","ref":"Raxol.Web.Session.Storage.html#delete/1","title":"Raxol.Web.Session.Storage.delete/1","type":"function"},{"doc":"Retrieve a session from storage.","ref":"Raxol.Web.Session.Storage.html#get/1","title":"Raxol.Web.Session.Storage.get/1","type":"function"},{"doc":"Get all active sessions.","ref":"Raxol.Web.Session.Storage.html#get_active_sessions/0","title":"Raxol.Web.Session.Storage.get_active_sessions/0","type":"function"},{"doc":"Get all expired sessions.","ref":"Raxol.Web.Session.Storage.html#get_expired_sessions/1","title":"Raxol.Web.Session.Storage.get_expired_sessions/1","type":"function"},{"doc":"Initialize the session storage system.","ref":"Raxol.Web.Session.Storage.html#init/0","title":"Raxol.Web.Session.Storage.init/0","type":"function"},{"doc":"Store a session in the storage system.","ref":"Raxol.Web.Session.Storage.html#store/1","title":"Raxol.Web.Session.Storage.store/1","type":"function"},{"doc":"Supervisor for web-related processes.","ref":"Raxol.Web.Supervisor.html","title":"Raxol.Web.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Raxol.Web.Supervisor.html#child_spec/1","title":"Raxol.Web.Supervisor.child_spec/1","type":"function"},{"doc":"","ref":"Raxol.Web.Supervisor.html#start_link/1","title":"Raxol.Web.Supervisor.start_link/1","type":"function"},{"doc":"The entrypoint for defining your web interface, such\nas controllers, components, channels, and so on.\n\nThis can be used in your application as:\n\n    use RaxolWeb, :controller\n    use RaxolWeb, :live_view\n    use RaxolWeb, :live_component\n    use RaxolWeb, :channel\n\nThe definitions below will be executed for every component,\ncontroller, etc, so keep them short and clean, focused\non imports, uses and aliases.","ref":"RaxolWeb.html","title":"RaxolWeb","type":"module"},{"doc":"When used, dispatch to the appropriate controller/view/etc.","ref":"RaxolWeb.html#__using__/1","title":"RaxolWeb.__using__/1","type":"macro"},{"doc":"","ref":"RaxolWeb.html#channel/0","title":"RaxolWeb.channel/0","type":"function"},{"doc":"","ref":"RaxolWeb.html#controller/0","title":"RaxolWeb.controller/0","type":"function"},{"doc":"","ref":"RaxolWeb.html#live_component/0","title":"RaxolWeb.live_component/0","type":"function"},{"doc":"","ref":"RaxolWeb.html#live_view/0","title":"RaxolWeb.live_view/0","type":"function"},{"doc":"","ref":"RaxolWeb.html#router/0","title":"RaxolWeb.router/0","type":"function"},{"doc":"","ref":"RaxolWeb.html#static_paths/0","title":"RaxolWeb.static_paths/0","type":"function"},{"doc":"","ref":"RaxolWeb.html#verified_routes/0","title":"RaxolWeb.verified_routes/0","type":"function"},{"doc":"","ref":"RaxolWeb.html#view/0","title":"RaxolWeb.view/0","type":"function"},{"doc":"","ref":"RaxolWeb.AccessibilityComponent.html","title":"RaxolWeb.AccessibilityComponent","type":"module"},{"doc":"Callback implementation for  Phoenix.LiveComponent.handle_event/3 .","ref":"RaxolWeb.AccessibilityComponent.html#handle_event/3","title":"RaxolWeb.AccessibilityComponent.handle_event/3","type":"function"},{"doc":"Callback implementation for  Phoenix.LiveComponent.render/1 .","ref":"RaxolWeb.AccessibilityComponent.html#render/1","title":"RaxolWeb.AccessibilityComponent.render/1","type":"function"},{"doc":"","ref":"RaxolWeb.AuthPlug.html","title":"RaxolWeb.AuthPlug","type":"module"},{"doc":"","ref":"RaxolWeb.AuthPlug.html#call/2","title":"RaxolWeb.AuthPlug.call/2","type":"function"},{"doc":"","ref":"RaxolWeb.AuthPlug.html#init/1","title":"RaxolWeb.AuthPlug.init/1","type":"function"},{"doc":"Provides core UI components for the Raxol web interface.","ref":"RaxolWeb.CoreComponents.html","title":"RaxolWeb.CoreComponents","type":"module"},{"doc":"Renders a button with the given text and options.","ref":"RaxolWeb.CoreComponents.html#button/1","title":"RaxolWeb.CoreComponents.button/1","type":"function"},{"doc":"* `type` (`:string`) - Defaults to `\"button\"`.\n* `class` (`:string`) - Defaults to `nil`.\n* `disabled` (`:boolean`) - Defaults to `false`.\n* Global attributes are accepted. Supports all globals plus: `[\"form\", \"name\", \"value\"]`.","ref":"RaxolWeb.CoreComponents.html#button/1-attributes","title":"Attributes - RaxolWeb.CoreComponents.button/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"RaxolWeb.CoreComponents.html#button/1-slots","title":"Slots - RaxolWeb.CoreComponents.button/1","type":"function"},{"doc":"Renders a flash message.","ref":"RaxolWeb.CoreComponents.html#flash/1","title":"RaxolWeb.CoreComponents.flash/1","type":"function"},{"doc":"* `kind` (`:string`) (required)\n* `title` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted. Supports all globals plus: `[\"phx-click\", \"phx-value\"]`.","ref":"RaxolWeb.CoreComponents.html#flash/1-attributes","title":"Attributes - RaxolWeb.CoreComponents.flash/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"RaxolWeb.CoreComponents.html#flash/1-slots","title":"Slots - RaxolWeb.CoreComponents.flash/1","type":"function"},{"doc":"Renders a form group with a label and input.","ref":"RaxolWeb.CoreComponents.html#form_group/1","title":"RaxolWeb.CoreComponents.form_group/1","type":"function"},{"doc":"* `name` (`:string`) (required)\n* `label` (`:string`) (required)\n* `type` (`:string`) - Defaults to `\"text\"`.\n* `value` (`:any`)\n* `placeholder` (`:string`) - Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* `disabled` (`:boolean`) - Defaults to `false`.\n* Global attributes are accepted. Supports all globals plus: `[\"autocomplete\", \"form\", \"required\"]`.","ref":"RaxolWeb.CoreComponents.html#form_group/1-attributes","title":"Attributes - RaxolWeb.CoreComponents.form_group/1","type":"function"},{"doc":"Renders a form input with the given type and options.","ref":"RaxolWeb.CoreComponents.html#input/1","title":"RaxolWeb.CoreComponents.input/1","type":"function"},{"doc":"* `type` (`:string`) - Defaults to `\"text\"`.\n* `name` (`:string`) (required)\n* `value` (`:any`)\n* `placeholder` (`:string`) - Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* `disabled` (`:boolean`) - Defaults to `false`.\n* Global attributes are accepted. Supports all globals plus: `[\"autocomplete\", \"form\", \"required\"]`.","ref":"RaxolWeb.CoreComponents.html#input/1-attributes","title":"Attributes - RaxolWeb.CoreComponents.input/1","type":"function"},{"doc":"Renders a label for a form input.","ref":"RaxolWeb.CoreComponents.html#label/1","title":"RaxolWeb.CoreComponents.label/1","type":"function"},{"doc":"* `for` (`:string`) (required)\n* `class` (`:string`) - Defaults to `nil`.","ref":"RaxolWeb.CoreComponents.html#label/1-attributes","title":"Attributes - RaxolWeb.CoreComponents.label/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"RaxolWeb.CoreComponents.html#label/1-slots","title":"Slots - RaxolWeb.CoreComponents.label/1","type":"function"},{"doc":"","ref":"RaxolWeb.Endpoint.html","title":"RaxolWeb.Endpoint","type":"module"},{"doc":"Callback implementation for  Phoenix.Endpoint.broadcast/3 .","ref":"RaxolWeb.Endpoint.html#broadcast/3","title":"RaxolWeb.Endpoint.broadcast/3","type":"function"},{"doc":"Callback implementation for  Phoenix.Endpoint.broadcast!/3 .","ref":"RaxolWeb.Endpoint.html#broadcast!/3","title":"RaxolWeb.Endpoint.broadcast!/3","type":"function"},{"doc":"Callback implementation for  Phoenix.Endpoint.broadcast_from/4 .","ref":"RaxolWeb.Endpoint.html#broadcast_from/4","title":"RaxolWeb.Endpoint.broadcast_from/4","type":"function"},{"doc":"Callback implementation for  Phoenix.Endpoint.broadcast_from!/4 .","ref":"RaxolWeb.Endpoint.html#broadcast_from!/4","title":"RaxolWeb.Endpoint.broadcast_from!/4","type":"function"},{"doc":"Callback implementation for  Plug.call/2 .","ref":"RaxolWeb.Endpoint.html#call/2","title":"RaxolWeb.Endpoint.call/2","type":"function"},{"doc":"Returns the child specification to start the endpoint\nunder a supervision tree.","ref":"RaxolWeb.Endpoint.html#child_spec/1","title":"RaxolWeb.Endpoint.child_spec/1","type":"function"},{"doc":"Returns the endpoint configuration for `key`\n\nReturns `default` if the key does not exist.","ref":"RaxolWeb.Endpoint.html#config/2","title":"RaxolWeb.Endpoint.config/2","type":"function"},{"doc":"Reloads the configuration given the application environment changes.","ref":"RaxolWeb.Endpoint.html#config_change/2","title":"RaxolWeb.Endpoint.config_change/2","type":"function"},{"doc":"Returns the host for the given endpoint.","ref":"RaxolWeb.Endpoint.html#host/0","title":"RaxolWeb.Endpoint.host/0","type":"function"},{"doc":"Callback implementation for  Plug.init/1 .","ref":"RaxolWeb.Endpoint.html#init/1","title":"RaxolWeb.Endpoint.init/1","type":"function"},{"doc":"Callback implementation for  Phoenix.Endpoint.local_broadcast/3 .","ref":"RaxolWeb.Endpoint.html#local_broadcast/3","title":"RaxolWeb.Endpoint.local_broadcast/3","type":"function"},{"doc":"Callback implementation for  Phoenix.Endpoint.local_broadcast_from/4 .","ref":"RaxolWeb.Endpoint.html#local_broadcast_from/4","title":"RaxolWeb.Endpoint.local_broadcast_from/4","type":"function"},{"doc":"Generates the path information when routing to this endpoint.","ref":"RaxolWeb.Endpoint.html#path/1","title":"RaxolWeb.Endpoint.path/1","type":"function"},{"doc":"Generates the script name.","ref":"RaxolWeb.Endpoint.html#script_name/0","title":"RaxolWeb.Endpoint.script_name/0","type":"function"},{"doc":"Returns the address and port that the server is running on","ref":"RaxolWeb.Endpoint.html#server_info/1","title":"RaxolWeb.Endpoint.server_info/1","type":"function"},{"doc":"Starts the endpoint supervision tree.\n\nAll other options are merged into the endpoint configuration.","ref":"RaxolWeb.Endpoint.html#start_link/1","title":"RaxolWeb.Endpoint.start_link/1","type":"function"},{"doc":"Generates a base64-encoded cryptographic hash (sha512) to a static file\nin `priv/static`. Meant to be used for Subresource Integrity with CDNs.","ref":"RaxolWeb.Endpoint.html#static_integrity/1","title":"RaxolWeb.Endpoint.static_integrity/1","type":"function"},{"doc":"Returns a two item tuple with the first item being the `static_path`\nand the second item being the `static_integrity`.","ref":"RaxolWeb.Endpoint.html#static_lookup/1","title":"RaxolWeb.Endpoint.static_lookup/1","type":"function"},{"doc":"Generates a route to a static file in `priv/static`.","ref":"RaxolWeb.Endpoint.html#static_path/1","title":"RaxolWeb.Endpoint.static_path/1","type":"function"},{"doc":"Generates the static URL without any path information.\n\nIt uses the configuration under `:static_url` to generate\nsuch. It falls back to `:url` if `:static_url` is not set.","ref":"RaxolWeb.Endpoint.html#static_url/0","title":"RaxolWeb.Endpoint.static_url/0","type":"function"},{"doc":"Generates the endpoint base URL but as a `URI` struct.\n\nIt uses the configuration under `:url` to generate such.\nUseful for manipulating the URL data and passing it to\nURL helpers.","ref":"RaxolWeb.Endpoint.html#struct_url/0","title":"RaxolWeb.Endpoint.struct_url/0","type":"function"},{"doc":"Callback implementation for  Phoenix.Endpoint.subscribe/2 .","ref":"RaxolWeb.Endpoint.html#subscribe/2","title":"RaxolWeb.Endpoint.subscribe/2","type":"function"},{"doc":"Callback implementation for  Phoenix.Endpoint.unsubscribe/1 .","ref":"RaxolWeb.Endpoint.html#unsubscribe/1","title":"RaxolWeb.Endpoint.unsubscribe/1","type":"function"},{"doc":"Generates the endpoint base URL without any path information.\n\nIt uses the configuration under `:url` to generate such.","ref":"RaxolWeb.Endpoint.html#url/0","title":"RaxolWeb.Endpoint.url/0","type":"function"},{"doc":"","ref":"RaxolWeb.ErrorView.html","title":"RaxolWeb.ErrorView","type":"module"},{"doc":"","ref":"RaxolWeb.ErrorView.html#render/2","title":"RaxolWeb.ErrorView.render/2","type":"function"},{"doc":"","ref":"RaxolWeb.ErrorView.html#template_not_found/2","title":"RaxolWeb.ErrorView.template_not_found/2","type":"function"},{"doc":"A module providing Internationalization with a gettext-based API.","ref":"RaxolWeb.Gettext.html","title":"RaxolWeb.Gettext","type":"module"},{"doc":"Callback implementation for  Gettext.Backend.handle_missing_bindings/2 .","ref":"RaxolWeb.Gettext.html#handle_missing_bindings/2","title":"RaxolWeb.Gettext.handle_missing_bindings/2","type":"function"},{"doc":"Callback implementation for  Gettext.Backend.handle_missing_plural_translation/7 .","ref":"RaxolWeb.Gettext.html#handle_missing_plural_translation/7","title":"RaxolWeb.Gettext.handle_missing_plural_translation/7","type":"function"},{"doc":"Callback implementation for  Gettext.Backend.handle_missing_translation/5 .","ref":"RaxolWeb.Gettext.html#handle_missing_translation/5","title":"RaxolWeb.Gettext.handle_missing_translation/5","type":"function"},{"doc":"","ref":"RaxolWeb.LoginLive.html","title":"RaxolWeb.LoginLive","type":"module"},{"doc":"Callback implementation for  Phoenix.LiveView.render/1 .","ref":"RaxolWeb.LoginLive.html#render/1","title":"RaxolWeb.LoginLive.render/1","type":"function"},{"doc":"","ref":"RaxolWeb.MonitoringLive.html","title":"RaxolWeb.MonitoringLive","type":"module"},{"doc":"Callback implementation for  Phoenix.LiveView.render/1 .","ref":"RaxolWeb.MonitoringLive.html#render/1","title":"RaxolWeb.MonitoringLive.render/1","type":"function"},{"doc":"","ref":"RaxolWeb.PageController.html","title":"RaxolWeb.PageController","type":"module"},{"doc":"","ref":"RaxolWeb.PageController.html#home/2","title":"RaxolWeb.PageController.home/2","type":"function"},{"doc":"","ref":"RaxolWeb.PageLive.html","title":"RaxolWeb.PageLive","type":"module"},{"doc":"Callback implementation for  Phoenix.LiveView.handle_event/3 .","ref":"RaxolWeb.PageLive.html#handle_event/3","title":"RaxolWeb.PageLive.handle_event/3","type":"function"},{"doc":"Callback implementation for  Phoenix.LiveView.handle_params/3 .","ref":"RaxolWeb.PageLive.html#handle_params/3","title":"RaxolWeb.PageLive.handle_params/3","type":"function"},{"doc":"Callback implementation for  Phoenix.LiveView.mount/3 .","ref":"RaxolWeb.PageLive.html#mount/3","title":"RaxolWeb.PageLive.mount/3","type":"function"},{"doc":"View module for pages served by PageController.","ref":"RaxolWeb.PageView.html","title":"RaxolWeb.PageView","type":"module"},{"doc":"A LiveView for a code playground that allows users to write, edit, and run code snippets.","ref":"RaxolWeb.PlaygroundLive.html","title":"RaxolWeb.PlaygroundLive","type":"module"},{"doc":"Callback implementation for  Phoenix.LiveView.handle_event/3 .","ref":"RaxolWeb.PlaygroundLive.html#handle_event/3","title":"RaxolWeb.PlaygroundLive.handle_event/3","type":"function"},{"doc":"Callback implementation for  Phoenix.LiveView.mount/3 .","ref":"RaxolWeb.PlaygroundLive.html#mount/3","title":"RaxolWeb.PlaygroundLive.mount/3","type":"function"},{"doc":"Callback implementation for  Phoenix.LiveView.render/1 .","ref":"RaxolWeb.PlaygroundLive.html#render/1","title":"RaxolWeb.PlaygroundLive.render/1","type":"function"},{"doc":"","ref":"RaxolWeb.Presence.html","title":"RaxolWeb.Presence","type":"module"},{"doc":"","ref":"RaxolWeb.Presence.html#child_spec/1","title":"RaxolWeb.Presence.child_spec/1","type":"function"},{"doc":"Callback implementation for  Phoenix.Presence.fetch/2 .","ref":"RaxolWeb.Presence.html#fetch/2","title":"RaxolWeb.Presence.fetch/2","type":"function"},{"doc":"","ref":"RaxolWeb.Presence.html#fetchers_pids/0","title":"RaxolWeb.Presence.fetchers_pids/0","type":"function"},{"doc":"Callback implementation for  Phoenix.Presence.get_by_key/2 .","ref":"RaxolWeb.Presence.html#get_by_key/2","title":"RaxolWeb.Presence.get_by_key/2","type":"function"},{"doc":"Callback implementation for  Phoenix.Presence.list/1 .","ref":"RaxolWeb.Presence.html#list/1","title":"RaxolWeb.Presence.list/1","type":"function"},{"doc":"Callback implementation for  Phoenix.Presence.track/3 .","ref":"RaxolWeb.Presence.html#track/3","title":"RaxolWeb.Presence.track/3","type":"function"},{"doc":"Callback implementation for  Phoenix.Presence.track/4 .","ref":"RaxolWeb.Presence.html#track/4","title":"RaxolWeb.Presence.track/4","type":"function"},{"doc":"Callback implementation for  Phoenix.Presence.untrack/2 .","ref":"RaxolWeb.Presence.html#untrack/2","title":"RaxolWeb.Presence.untrack/2","type":"function"},{"doc":"Callback implementation for  Phoenix.Presence.untrack/3 .","ref":"RaxolWeb.Presence.html#untrack/3","title":"RaxolWeb.Presence.untrack/3","type":"function"},{"doc":"Callback implementation for  Phoenix.Presence.update/3 .","ref":"RaxolWeb.Presence.html#update/3","title":"RaxolWeb.Presence.update/3","type":"function"},{"doc":"Callback implementation for  Phoenix.Presence.update/4 .","ref":"RaxolWeb.Presence.html#update/4","title":"RaxolWeb.Presence.update/4","type":"function"},{"doc":"","ref":"RaxolWeb.Router.html","title":"RaxolWeb.Router","type":"module"},{"doc":"","ref":"RaxolWeb.Router.html#api/2","title":"RaxolWeb.Router.api/2","type":"function"},{"doc":"","ref":"RaxolWeb.Router.html#auth/2","title":"RaxolWeb.Router.auth/2","type":"function"},{"doc":"","ref":"RaxolWeb.Router.html#browser/2","title":"RaxolWeb.Router.browser/2","type":"function"},{"doc":"Callback invoked by Plug on every request.","ref":"RaxolWeb.Router.html#call/2","title":"RaxolWeb.Router.call/2","type":"function"},{"doc":"Callback required by Plug that initializes the router\nfor serving web requests.","ref":"RaxolWeb.Router.html#init/1","title":"RaxolWeb.Router.init/1","type":"function"},{"doc":"","ref":"RaxolWeb.SettingsLive.html","title":"RaxolWeb.SettingsLive","type":"module"},{"doc":"Callback implementation for  Phoenix.LiveView.render/1 .","ref":"RaxolWeb.SettingsLive.html#render/1","title":"RaxolWeb.SettingsLive.render/1","type":"function"},{"doc":"","ref":"RaxolWeb.Telemetry.html","title":"RaxolWeb.Telemetry","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"RaxolWeb.Telemetry.html#child_spec/1","title":"RaxolWeb.Telemetry.child_spec/1","type":"function"},{"doc":"","ref":"RaxolWeb.Telemetry.html#metrics/0","title":"RaxolWeb.Telemetry.metrics/0","type":"function"},{"doc":"","ref":"RaxolWeb.Telemetry.html#start_link/1","title":"RaxolWeb.Telemetry.start_link/1","type":"function"},{"doc":"WebSocket channel for real-time terminal communication.\n\nThis channel handles:\n- Terminal session initialization\n- Real-time input/output\n- Terminal resizing\n- Session management\n- Error handling","ref":"RaxolWeb.TerminalChannel.html","title":"RaxolWeb.TerminalChannel","type":"module"},{"doc":"","ref":"RaxolWeb.TerminalChannel.html#child_spec/1","title":"RaxolWeb.TerminalChannel.child_spec/1","type":"function"},{"doc":"","ref":"RaxolWeb.TerminalChannel.html#start_link/1","title":"RaxolWeb.TerminalChannel.start_link/1","type":"function"},{"doc":"","ref":"RaxolWeb.TerminalChannel.html#t:t/0","title":"RaxolWeb.TerminalChannel.t/0","type":"type"},{"doc":"LiveView component for the terminal interface.\n\nThis component provides:\n- Terminal rendering\n- Input handling\n- Resize management\n- Theme customization\n- Scroll management\n- Session management","ref":"RaxolWeb.TerminalLive.html","title":"RaxolWeb.TerminalLive","type":"module"},{"doc":"","ref":"RaxolWeb.ThemeToggleComponent.html","title":"RaxolWeb.ThemeToggleComponent","type":"module"},{"doc":"Callback implementation for  Phoenix.LiveComponent.handle_event/3 .","ref":"RaxolWeb.ThemeToggleComponent.html#handle_event/3","title":"RaxolWeb.ThemeToggleComponent.handle_event/3","type":"function"},{"doc":"Callback implementation for  Phoenix.LiveComponent.render/1 .","ref":"RaxolWeb.ThemeToggleComponent.html#render/1","title":"RaxolWeb.ThemeToggleComponent.render/1","type":"function"},{"doc":"A view for rendering UI components.","ref":"RaxolWeb.UIComponentView.html","title":"RaxolWeb.UIComponentView","type":"module"},{"doc":"Provides authentication plugs and helpers.","ref":"RaxolWeb.UserAuth.html","title":"RaxolWeb.UserAuth","type":"module"},{"doc":"Authenticates the user by looking into the session\nand remember me token.","ref":"RaxolWeb.UserAuth.html#fetch_current_user/2","title":"RaxolWeb.UserAuth.fetch_current_user/2","type":"function"},{"doc":"Logs the user in.\n\nIt renews the session ID and clears the whole session\nto avoid fixation attacks. See the renew_session\nfunction to customize this behaviour.\n\nIt also sets a `:live_socket_id` key in the session,\nso LiveView sessions are identified and automatically\ndisconnected on log out. The line can be safely removed\nif you are not using LiveView.","ref":"RaxolWeb.UserAuth.html#log_in_user/3","title":"RaxolWeb.UserAuth.log_in_user/3","type":"function"},{"doc":"Logs the user out.\n\nIt clears all session data for safety. See renew_session.","ref":"RaxolWeb.UserAuth.html#log_out_user/1","title":"RaxolWeb.UserAuth.log_out_user/1","type":"function"},{"doc":"Used for routes that require the user to not be authenticated.","ref":"RaxolWeb.UserAuth.html#redirect_if_user_is_authenticated/2","title":"RaxolWeb.UserAuth.redirect_if_user_is_authenticated/2","type":"function"},{"doc":"Used for routes that require the user to be authenticated.\n\nIf you want to enforce the user email is confirmed before\nthey use the application at all, here would be a good place.","ref":"RaxolWeb.UserAuth.html#require_authenticated_user/2","title":"RaxolWeb.UserAuth.require_authenticated_user/2","type":"function"},{"doc":"Handles user registration.","ref":"RaxolWeb.UserRegistrationController.html","title":"RaxolWeb.UserRegistrationController","type":"module"},{"doc":"","ref":"RaxolWeb.UserRegistrationController.html#create/2","title":"RaxolWeb.UserRegistrationController.create/2","type":"function"},{"doc":"","ref":"RaxolWeb.UserRegistrationController.html#new/2","title":"RaxolWeb.UserRegistrationController.new/2","type":"function"},{"doc":"Handles user session management (login/logout).","ref":"RaxolWeb.UserSessionController.html","title":"RaxolWeb.UserSessionController","type":"module"},{"doc":"","ref":"RaxolWeb.UserSessionController.html#create/2","title":"RaxolWeb.UserSessionController.create/2","type":"function"},{"doc":"","ref":"RaxolWeb.UserSessionController.html#delete/2","title":"RaxolWeb.UserSessionController.delete/2","type":"function"},{"doc":"","ref":"RaxolWeb.UserSessionController.html#new/2","title":"RaxolWeb.UserSessionController.new/2","type":"function"},{"doc":"","ref":"RaxolWeb.UserSocket.html","title":"RaxolWeb.UserSocket","type":"module"},{"doc":"Identifies the socket connections.","ref":"RaxolWeb.UserSocket.html#id/1","title":"RaxolWeb.UserSocket.id/1","type":"function"},{"doc":"# Raxol\n\nA modern, feature-rich toolkit for building sophisticated terminal user interfaces (TUIs) in Elixir. Raxol provides a comprehensive set of components, styling options, and event handling capabilities to create interactive terminal applications with rich text formatting and dynamic UI updates.","ref":"readme-1.html","title":"Raxol","type":"extras"},{"doc":"","ref":"readme-1.html#features","title":"Features - Raxol","type":"extras"},{"doc":"- **Component-Based Architecture**: Build UIs using reusable components with their own state management\n- **Flexible View Definition**: Choose between HEEx-like syntax or programmatic component functions\n- **Rich Text Formatting**: Support for colors, styles, and dynamic content updates\n- **Layout System**: Flexbox-inspired layout engine for responsive terminal UIs\n- **Event Handling**: Comprehensive event system for keyboard and mouse interactions\n- **Theme Support**: Customizable styling and theming capabilities\n- **Accessibility**: Built-in support for screen readers and keyboard navigation","ref":"readme-1.html#core-features","title":"Core Features - Raxol","type":"extras"},{"doc":"- **Data Visualization**: Charts, graphs, and TreeMaps for data representation\n- **Animation System**: Smooth transitions and dynamic UI updates\n- **Plugin System**: Extensible architecture for custom functionality\n- **Cloud Integration**: Monitoring, configuration, and service discovery\n- **Performance Optimization**: Advanced caching and rendering optimizations\n- **Metrics System**: Comprehensive performance monitoring and visualization\n- **Progress Indicators**: Multiple progress visualization options including bars, spinners, and circular indicators","ref":"readme-1.html#advanced-features","title":"Advanced Features - Raxol","type":"extras"},{"doc":"Add Raxol to your dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:raxol, \"~> 0.5.0\"}\n  ]\nend\n```\n\nThen fetch the dependencies:\n\n```bash\nmix deps.get\ngit submodule update --init --recursive  # Required for termbox2 dependency\n```","ref":"readme-1.html#installation","title":"Installation - Raxol","type":"extras"},{"doc":"Create a new application module:\n\n```elixir\ndefmodule MyApp.Application do\n  use Raxol.Core.Runtime.Application\n\n  @impl true\n  def render(assigns) do\n    ~H\"\"\"\n     \n       Hello from Raxol! \n       \n     \n    \"\"\"\n  end\nend\n```\n\nOr using the programmatic approach:\n\n```elixir\ndefmodule MyApp.Application do\n  use Raxol.Core.Runtime.Application\n  use Raxol.View\n  import Raxol.View.Elements\n\n  @impl true\n  def render(assigns) do\n    view do\n      box border: :single, padding: 1 do\n        text content: \"Hello from Raxol!\", color: :cyan, attributes: [:bold]\n        Progress.bar(0.75, width: 20)\n      end\n    end\n  end\nend\n```","ref":"readme-1.html#quick-start","title":"Quick Start - Raxol","type":"extras"},{"doc":"","ref":"readme-1.html#documentation","title":"Documentation - Raxol","type":"extras"},{"doc":"- [Quick Start Guide](examples/guides/01_getting_started/quick_start.md)\n- [Terminal Emulator](examples/guides/02_core_concepts/terminal_emulator.md)\n- [API Reference](examples/guides/02_core_concepts/api/README.md)","ref":"readme-1.html#core-concepts","title":"Core Concepts - Raxol","type":"extras"},{"doc":"- [Components Overview](examples/guides/03_components_and_layout/components/README.md)\n- [Visualization Components](examples/guides/03_components_and_layout/components/visualization/README.md)\n- [Database Components](examples/guides/03_components_and_layout/components/database/README.md)\n- [Progress Components](examples/guides/03_components_and_layout/components/README.md)","ref":"readme-1.html#components-layout","title":"Components & Layout - Raxol","type":"extras"},{"doc":"Raxol is built for speed and reliability. Automated tests enforce strict performance standards:\n\n- **Event processing**: < 1ms average, < 2ms (95th percentile)\n- **Screen updates**: < 2ms average, < 5ms (95th percentile)\n- **Concurrent operations**: < 5ms average, < 10ms (95th percentile)","ref":"readme-1.html#performance","title":"Performance - Raxol","type":"extras"},{"doc":"This project is licensed under the MIT License - see the [LICENSE.md](LICENSE.md) file for details.","ref":"readme-1.html#license","title":"License - Raxol","type":"extras"},{"doc":"- [Documentation](docs/README.md)\n- [Issue Tracker](https://github.com/Hydepwns/raxol/issues)\n- [Discussions](https://github.com/Hydepwns/raxol/discussions)\n\n---","ref":"readme-1.html#support","title":"Support - Raxol","type":"extras"},{"doc":"# Raxol Terminal Emulator Configuration Guide","ref":"configuration.html","title":"Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"The Raxol Terminal Emulator uses a centralized configuration system that manages all aspects of the terminal's operation.\n\n```mermaid\ngraph TB\n    subgraph Config[\"Configuration System\"]\n        File[Config File]\n        Manager[Config Manager]\n        Validator[Validator]\n        Storage[Storage]\n    end\n\n    File --> Manager\n    Manager --> Validator\n    Manager --> Storage\n\n    classDef component fill:#4a4e69,stroke:#f8f8f2,stroke-width:2px,color:#f8f8f2,font-size:14px,padding:6px;\n    class File,Manager,Validator,Storage component;\n```","ref":"configuration.html#overview","title":"Overview - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"```mermaid\ngraph TB\n    subgraph Config[\"Configuration\"]\n        Terminal[Terminal]\n        Buffer[Buffer]\n        Renderer[Renderer]\n    end\n\n    Terminal --> Settings1[Width/Height/Mode]\n    Buffer --> Settings2[Size/Scrollback]\n    Renderer --> Settings3[Mode/Buffering]\n\n    classDef section fill:#22223b,stroke:#f8f8f2,stroke-width:2px,color:#f8f8f2,font-size:14px,padding:6px;\n    classDef setting fill:#4a4e69,stroke:#f8f8f2,stroke-width:2px,color:#f8f8f2,font-size:12px,padding:4px;\n    class Terminal,Buffer,Renderer section\n    class Settings1,Settings2,Settings3 setting;\n```","ref":"configuration.html#configuration-structure","title":"Configuration Structure - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"Located at `config/raxol.exs`:\n\n```elixir\nimport Config\n\nconfig :raxol,\n  terminal: %{\n    width: 80,\n    height: 24,\n    mode: :normal\n  },\n  buffer: %{\n    max_size: 10000,\n    scrollback: 1000\n  },\n  renderer: %{\n    mode: :gpu,\n    double_buffering: true\n  }\n```","ref":"configuration.html#configuration-file","title":"Configuration File - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"","ref":"configuration.html#configuration-sections","title":"Configuration Sections - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"```elixir\nterminal: %{\n  width: 80,        # Terminal width in characters\n  height: 24,       # Terminal height in characters\n  mode: :normal     # Terminal mode (:normal or :raw)\n}\n```","ref":"configuration.html#terminal-configuration","title":"Terminal Configuration - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"```elixir\nbuffer: %{\n  max_size: 10_000,  # Maximum buffer size in characters\n  scrollback: 1000   # Number of lines to keep in scrollback\n}\n```","ref":"configuration.html#buffer-configuration","title":"Buffer Configuration - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"```elixir\nrenderer: %{\n  mode: :gpu,           # Rendering mode (:gpu or :cpu)\n  double_buffering: true # Whether to use double buffering\n}\n```","ref":"configuration.html#renderer-configuration","title":"Renderer Configuration - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"```mermaid\nsequenceDiagram\n    participant App as Application\n    participant Manager as Config Manager\n    participant Validator as Validator\n    participant Storage as Storage\n\n    App->>Manager: Get/Set Config\n    Manager->>Validator: Validate\n    Validator-->>Manager: Valid/Invalid\n    Manager->>Storage: Persist (if needed)\n    Storage-->>Manager: Success/Failure\n    Manager-->>App: Result\n```","ref":"configuration.html#runtime-configuration","title":"Runtime Configuration - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"```elixir\n# Get configuration\nwidth = Raxol.Core.Config.Manager.get(:terminal_width)\n\n# Set configuration\n:ok = Raxol.Core.Config.Manager.set(:terminal_width, 100)\n\n# Update configuration\n:ok = Raxol.Core.Config.Manager.update(:terminal_width, &(&1 + 50))\n\n# Delete configuration\n:ok = Raxol.Core.Config.Manager.delete(:custom_key)\n\n# Get all configuration\nconfig = Raxol.Core.Config.Manager.get_all()\n\n# Reload configuration\n:ok = Raxol.Core.Config.Manager.reload()\n```","ref":"configuration.html#configuration-manager-api","title":"Configuration Manager API - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"```mermaid\ngraph TB\n    subgraph Env[\"Environment Config\"]\n        Dev[Development]\n        Test[Testing]\n        Prod[Production]\n    end\n\n    Dev --> DevConfig[config/dev.exs]\n    Test --> TestConfig[config/test.exs]\n    Prod --> ProdConfig[config/prod.exs]\n\n    classDef env fill:#22223b,stroke:#f8f8f2,stroke-width:2px,color:#f8f8f2,font-size:14px,padding:6px;\n    classDef config fill:#4a4e69,stroke:#f8f8f2,stroke-width:2px,color:#f8f8f2,font-size:12px,padding:4px;\n    class Dev,Test,Prod env\n    class DevConfig,TestConfig,ProdConfig config;\n```","ref":"configuration.html#environment-specific-configuration","title":"Environment-Specific Configuration - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"```mermaid\ngraph TB\n    subgraph Rules[\"Validation Rules\"]\n        Terminal[Terminal Rules]\n        Buffer[Buffer Rules]\n        Renderer[Renderer Rules]\n    end\n\n    Terminal --> T1[Width > 0]\n    Terminal --> T2[Height > 0]\n    Terminal --> T3[Mode in [:normal, :raw]]\n\n    Buffer --> B1[Max Size > 0]\n    Buffer --> B2[Scrollback >= 0]\n\n    Renderer --> R1[Mode in [:gpu, :cpu]]\n    Renderer --> R2[Double Buffering is boolean]\n\n    classDef rule fill:#22223b,stroke:#f8f8f2,stroke-width:2px,color:#f8f8f2,font-size:14px,padding:6px;\n    classDef check fill:#4a4e69,stroke:#f8f8f2,stroke-width:2px,color:#f8f8f2,font-size:12px,padding:4px;\n    class Terminal,Buffer,Renderer rule\n    class T1,T2,T3,B1,B2,R1,R2 check;\n```","ref":"configuration.html#validation-rules","title":"Validation Rules - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"1. **Organization**\n\n   - Group related settings\n   - Use descriptive names\n   - Document options\n\n2. **Validation**\n\n   - Validate all values\n   - Provide clear errors\n   - Handle invalid configs\n\n3. **Security**\n   - No sensitive data\n   - Use env variables\n   - Validate inputs","ref":"configuration.html#best-practices","title":"Best Practices - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"","ref":"configuration.html#troubleshooting","title":"Troubleshooting - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"1. **Invalid Configuration**\n\n   - Check required fields\n   - Verify value types\n   - Check syntax\n\n2. **Loading Issues**\n\n   - Verify file path\n   - Check permissions\n   - Validate syntax\n\n3. **Persistence Issues**\n   - Check persist option\n   - Verify permissions\n   - Check write errors","ref":"configuration.html#common-issues","title":"Common Issues - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"","ref":"configuration.html#api-reference","title":"API Reference - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"| Function       | Description    |\n| -------------- | -------------- |\n| `start_link/1` | Start manager  |\n| `get/2`        | Get value      |\n| `set/3`        | Set value      |\n| `update/3`     | Update value   |\n| `delete/2`     | Delete value   |\n| `get_all/0`    | Get all values |\n| `reload/0`     | Reload config  |","ref":"configuration.html#raxol-core-config-manager","title":"Raxol.Core.Config.Manager - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"For issues and feature requests, please use the [issue tracker](https://github.com/raxol/raxol/issues).","ref":"configuration.html#support","title":"Support - Raxol Terminal Emulator Configuration Guide","type":"extras"},{"doc":"---\ntitle: Quick Start Guide\ndescription: Create your first Raxol application\ndate: 2025-04-27\nauthor: Raxol Team\nsection: guides\ntags: [quick start, guide, tutorial, application, components]\n---\n\n# Quick Start Guide: Your First Raxol App\n\nThis guide walks you through creating a simple stateful counter application using Raxol, a modern, feature-rich toolkit for building sophisticated terminal user interfaces (TUIs) in Elixir. You'll learn how to use Raxol's comprehensive set of components, styling options, and event handling to create an interactive terminal application with rich text formatting and dynamic UI updates.","ref":"quick_start.html","title":"quick_start","type":"extras"},{"doc":"Before you start, ensure you have:\n\n1. **Elixir installed:** Raxol requires Elixir 1.14 or later. You can find installation instructions on the [official Elixir website](https://elixir-lang.org/install.html).\n2. **A new Mix project (optional):** If you don't have a project, create one:\n\n   ```bash\n   mix new my_raxol_app\n   cd my_raxol_app\n   ```","ref":"quick_start.html#prerequisites","title":"Prerequisites - quick_start","type":"extras"},{"doc":"First, add `raxol` to your project's dependencies. Open your `mix.exs` file and update the `deps` function:\n\n```elixir\ndef deps do\n  [\n    {:raxol, \"~> 0.5.0\"}\n  ]\nend\n```\n\nThen, fetch the dependency:\n\n```bash\nmix deps.get\n```","ref":"quick_start.html#1-add-raxol-dependency","title":"1. Add Raxol Dependency - quick_start","type":"extras"},{"doc":"Create a new Elixir file, for example, `lib/my_raxol_app/application.ex`, and define your application module. This module will use `Raxol.Core.Runtime.Application` and implement the required callbacks to define the user interface.\n\nRaxol offers two primary ways to define your UI:","ref":"quick_start.html#2-create-your-application-module","title":"2. Create Your Application Module - quick_start","type":"extras"},{"doc":"This approach uses a syntax similar to HTML and is often convenient for static structures or when integrating with HEEx templates.\n\n```elixir\ndefmodule MyRaxolApp.Application do\n  use Raxol.Core.Runtime.Application\n\n  @impl true\n  def init(_context), do: %{count: 0}\n\n  @impl true\n  def update(:increment, state), do: %{state | count: state.count + 1}\n  def update(_, state), do: state\n\n  @impl true\n  def render(assigns) do\n    ~H\"\"\"\n     \n       Count: <%= @count %> \n       \n     \n    \"\"\"\n  end\nend\n```","ref":"quick_start.html#method-1-using-the-heex-sigil-h","title":"Method 1: Using the HEEx Sigil (~H) - quick_start","type":"extras"},{"doc":"This approach uses standard Elixir function calls for components, providing more flexibility for programmatically building complex UIs.\n\n```elixir\ndefmodule MyRaxolApp.Application do\n  use Raxol.Core.Runtime.Application\n  use Raxol.View\n  import Raxol.View.Elements\n\n  @impl true\n  def init(_context), do: %{count: 0}\n\n  @impl true\n  def update(:increment, state), do: %{state | count: state.count + 1}\n  def update(_, state), do: state\n\n  @impl true\n  def render(assigns) do\n    view do\n      box border: :single, padding: 1 do\n        text content: \"Count: #{assigns.count}\", color: :cyan, attributes: [:bold]\n        button label: \"Increment\", on_click: :increment\n      end\n    end\n  end\nend\n```","ref":"quick_start.html#method-2-using-raxol-view-and-component-functions","title":"Method 2: Using Raxol.View and Component Functions - quick_start","type":"extras"},{"doc":"Raxol applications use a set of callbacks to manage state and handle user interactions:\n\n- `init/1`: Called when the application starts, returns the initial state\n- `update/2`: Handles messages (like button clicks) and updates the state\n- `render/1`: Defines the UI based on the current state\n- `handle_event/3`: (Optional) Handles raw input events like keyboard or mouse","ref":"quick_start.html#3-understanding-the-callbacks","title":"3. Understanding the Callbacks - quick_start","type":"extras"},{"doc":"To run your application, you can start it directly in `iex`:\n\n```elixir\niex> Raxol.Core.Runtime.Lifecycle.start_application(MyRaxolApp.Application)\n{:ok, #PID<0.xxx.0>}\n```\n\nFor long-running applications, add it to your supervision tree:\n\n```elixir\ndefmodule MyRaxolApp.Application do\n  use Application\n\n  def start(_type, _args) do\n    children = [\n      {Raxol.Core.Runtime.Application, app: MyRaxolApp.Application}\n    ]\n\n    opts = [strategy: :one_for_one, name: MyRaxolApp.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\nend\n```\n\nMake sure `MyRaxolApp.Application` is listed in your `application/0` function in `mix.exs`:\n\n```elixir\ndef application do\n  [\n    extra_applications: [:logger],\n    mod: {MyRaxolApp.Application, []}\n  ]\nend\n```","ref":"quick_start.html#4-start-the-application","title":"4. Start the Application - quick_start","type":"extras"},{"doc":"Congratulations! You've built and run your first Raxol application. Here's what you can explore next:\n\n- [Examples](../) - Check out sample applications and use cases\n- [Installation Guide](install.md) - Learn about platform-specific considerations","ref":"quick_start.html#next-steps","title":"Next Steps - quick_start","type":"extras"},{"doc":"---\ntitle: Terminal Handling in Raxol\ndescription: Understanding how Raxol interacts with the terminal emulator\ndate: 2025-06-18\nauthor: DROO AMOR\nsection: internals\ntags: [terminal, emulator, ansi, rendering, internals]\n---\n\n# Terminal Handling in Raxol\n\nWhile you typically interact with Raxol through the `Raxol.Core.Runtime.Application` behaviour and components, understanding how Raxol manages the underlying terminal can be helpful. Raxol includes a sophisticated layer for terminal interaction, ensuring efficient rendering and consistent behaviour across different terminal emulators.","ref":"terminal_emulator.html","title":"terminal_emulator","type":"extras"},{"doc":"Users of the Raxol library benefit from the following terminal handling features, which operate mostly behind the scenes:\n\n1. **Efficient Rendering Pipeline:**\n\n   - **Double Buffering:** Raxol renders UI changes to an off-screen buffer first (`Raxol.UI.Renderer`). It then calculates the minimal set of changes required to update the visible terminal screen to match the new buffer.\n   - **Diffing:** Only the differing cells between the current screen state and the desired new state are redrawn. This minimizes the amount of data sent to the terminal, reducing flicker and improving performance, especially over slower connections.\n\n2. **ANSI Escape Code Management:**\n\n   - Raxol abstracts away the complexities of generating ANSI escape codes for cursor positioning, text styling (bold, italics, underline), and color application. The `Raxol.Terminal.Parser` handles incoming codes, and the `Raxol.UI.Renderer` generates outgoing codes based on the view.\n   - Components like ` `, ` `, etc., translate their properties into the correct sequences for the terminal via the rendering pipeline.\n\n3. **Color Support:**\n\n   - Raxol attempts to detect the color capabilities of the user's terminal (Truecolor, 256-color, 16-color).\n   - The `Raxol.Core.ColorSystem` intelligently maps specified colors (e.g., hex codes, names) to the closest available color in the detected mode, respecting themes and accessibility settings (like high contrast) managed via `Raxol.Core.UserPreferences`.\n\n4. **Unicode Handling:**\n\n   - Raxol is designed to work correctly with Unicode characters, including multi-width characters (like CJK characters or emojis).\n   - The layout engine (`Raxol.UI.Layout.Engine`) correctly calculates character widths to ensure proper layout and alignment within components.\n\n5. **Input Processing:**\n\n   - The `Raxol.Terminal.Driver` captures and parses raw terminal input events (keyboard presses, mouse events - if enabled/supported).\n   - These events are translated into a standardized format (`Raxol.Core.Events.Event`).\n   - Events are typically dispatched by the `Raxol.Core.Runtime.Events.Dispatcher` to the application's `update/2` function as messages, or potentially handled directly by components implementing the `handle_event/3` callback.\n\n6. **Sixel Graphics Support:**\n   - Raxol includes support for parsing and rendering Sixel graphics sequences (`Raxol.Terminal.ANSI.SixelGraphics`), allowing for bitmap image display in compatible terminals.","ref":"terminal_emulator.html#key-features","title":"Key Features - terminal_emulator","type":"extras"},{"doc":"Even though you don't directly interact with modules like `Raxol.Terminal.Parser` or `Raxol.Terminal.Emulator` in typical application code, this underlying system provides:\n\n- **Performance:** Smooth, flicker-free updates even for complex UIs.\n- **Consistency:** Your application should look and behave similarly across different terminal emulators (within the limits of the emulator's capabilities).\n- **Developer Experience:** You can focus on defining your UI structure and logic using components, without worrying about low-level terminal escape codes.\n\nFor most use cases involving `Raxol.Core.Runtime.Application`, you don't need to interact with this layer directly. The `Raxol.Core.Runtime` manages the terminal lifecycle and rendering based on the output of your `view/1` function and how messages are handled in `update/2`.","ref":"terminal_emulator.html#why-this-matters-for-library-users","title":"Why This Matters for Library Users - terminal_emulator","type":"extras"},{"doc":"- **`Raxol.Terminal.Driver`**: Handles low-level terminal interaction through the `:rrex_termbox` v2.0.1 NIF-based backend. Responsible for setting raw mode, reading input events, writing output bytes, and translating NIF events into `Raxol.Core.Events.Event` structs. This architecture provides improved performance and reliability over the previous Port-based implementation.\n- **`Raxol.Terminal.Parser`**: A state machine responsible for parsing incoming ANSI escape sequences and other control codes, interpreting their meaning, and updating the terminal state. It utilizes helper modules for specific code types.\n- **`Raxol.Terminal.Emulator`**: Manages the internal state representation of the terminal, including screen buffers, cursor position, character attributes (color, style), screen modes, character sets, and scroll regions.\n- **`Raxol.Terminal.ControlCodes`**: Handles the interpretation and execution of simple C0 control codes (like newline, carriage return, backspace) and basic ESC sequences.\n- **`Raxol.Terminal.Buffer`**: Manages the in-memory representation of the terminal screen (often using double buffering) and tracks changes for efficient updates.\n- **`Raxol.Terminal.Cursor`**: Manages the logical and physical cursor state, including visibility, shape, and position.\n- **`Raxol.Terminal.ANSI.SixelGraphics`**: Specifically handles the parsing and state management related to Sixel bitmap graphics sequences.\n- **Rendering Pipeline Integration**: The terminal components work together with the `Raxol.UI.Renderer` (generates styled cell data) and `Raxol.Terminal.Renderer` (outputs optimized diffs to the `Driver`) to display the UI defined by the application's `view/1` function.","ref":"terminal_emulator.html#key-concepts","title":"Key Concepts - terminal_emulator","type":"extras"},{"doc":"# Raxol Examples\n\nA collection of examples demonstrating Raxol's features and capabilities.","ref":"readme-2.html","title":"Raxol Examples","type":"extras"},{"doc":"```mermaid\ngraph TD\n    A[Examples] --> B[Basic]\n    A --> C[Advanced]\n    A --> D[Display]\n    A --> E[Interactive]\n    A --> F[Layout]\n    A --> G[Showcase]\n    A --> H[Without Runtime]\n\n    B --> B1[Counter]\n    B --> B2[MultipleViews]\n    B --> B3[Rendering]\n    B --> B4[Subscriptions]\n    B --> B5[TableFeatures]\n\n    C --> C1[Commands]\n    C --> C2[DocumentationBrowser]\n    C --> C3[Editor]\n    C --> C4[Snake]\n\n    D --> D1[ProgressBar]\n    D --> D2[Charts]\n    D --> D3[TreeMaps]\n\n    E --> E1[FormValidation]\n    E --> E2[EventHandling]\n    E --> E3[KeyboardShortcuts]\n\n    F --> F1[Dashboard]\n    F --> F2[AdvancedLayout]\n    F --> F3[Responsive]\n\n    G --> G1[ComponentShowcase]\n    G --> G2[ArchitectureDemo]\n    G --> G3[ProgressBarDemo]\n\n    H --> H1[HelloWorld]\n    H --> H2[Clock]\n    H --> H3[EventViewer]\n```","ref":"readme-2.html#directory-structure","title":"Directory Structure - Raxol Examples","type":"extras"},{"doc":"```bash\n# Run basic example\nmix run examples/basic/counter.exs | cat\n\n# Run showcase example\nmix run examples/showcase/component_showcase.exs | cat\n```","ref":"readme-2.html#quick-start","title":"Quick Start - Raxol Examples","type":"extras"},{"doc":"","ref":"readme-2.html#example-categories","title":"Example Categories - Raxol Examples","type":"extras"},{"doc":"- **Counter**: Simple state management\n- **MultipleViews**: View composition\n- **Rendering**: Basic rendering patterns\n- **Subscriptions**: Event subscriptions\n- **TableFeatures**: Table component usage","ref":"readme-2.html#basic-examples","title":"Basic Examples - Raxol Examples","type":"extras"},{"doc":"- **Commands**: Command pattern implementation\n- **DocumentationBrowser**: Documentation viewer\n- **Editor**: Text editor implementation\n- **Snake**: Game implementation","ref":"readme-2.html#advanced-examples","title":"Advanced Examples - Raxol Examples","type":"extras"},{"doc":"- **ProgressBar**: Progress visualization\n- **Charts**: Data visualization\n- **TreeMaps**: Hierarchical data display","ref":"readme-2.html#display-examples","title":"Display Examples - Raxol Examples","type":"extras"},{"doc":"- **FormValidation**: Form handling\n- **EventHandling**: Event system usage\n- **KeyboardShortcuts**: Shortcut implementation","ref":"readme-2.html#interactive-examples","title":"Interactive Examples - Raxol Examples","type":"extras"},{"doc":"- **Dashboard**: Dashboard layout\n- **AdvancedLayout**: Complex layouts\n- **Responsive**: Responsive design","ref":"readme-2.html#layout-examples","title":"Layout Examples - Raxol Examples","type":"extras"},{"doc":"- **ComponentShowcase**: Component library\n- **ArchitectureDemo**: Architecture patterns\n- **ProgressBarDemo**: Progress bar variations","ref":"readme-2.html#showcase-examples","title":"Showcase Examples - Raxol Examples","type":"extras"},{"doc":"- **HelloWorld**: Basic terminal output\n- **Clock**: Real-time updates\n- **EventViewer**: Event debugging","ref":"readme-2.html#without-runtime-examples","title":"Without Runtime Examples - Raxol Examples","type":"extras"},{"doc":"```elixir\ndefmodule MyApp do\n  use Raxol.Component\n  alias Raxol.View.Elements\n\n  @impl Raxol.Component\n  def mount(_params, _session, socket) do\n    {:ok, assign(socket, :message, \"Hello from Raxol!\")}\n  end\n\n  @impl Raxol.Component\n  def handle_event(\"some_event\", _payload, socket) do\n    {:noreply, assign(socket, :message, \"Event handled!\")}\n  end\n\n  @impl Raxol.Component\n  def render(assigns) do\n    ~V\"\"\"\n    <.panel title=\"My App\">\n      <.text>{assigns.message}</.text>\n      <.button rax-click=\"some_event\">Click Me</.button>\n    </.panel>\n    \"\"\"\n  end\nend\n```","ref":"readme-2.html#creating-your-own-example","title":"Creating Your Own Example - Raxol Examples","type":"extras"},{"doc":"```mermaid\nsequenceDiagram\n    participant U as User\n    participant C as Component\n    participant E as Event Handler\n    participant R as Renderer\n\n    U->>C: Interact\n    C->>E: Handle Event\n    E->>C: Update State\n    C->>R: Render\n    R->>U: Update UI\n```","ref":"readme-2.html#component-flow","title":"Component Flow - Raxol Examples","type":"extras"},{"doc":"1. **Structure**\n\n   - Follow directory organization\n   - Use appropriate category\n   - Include documentation\n\n2. **Implementation**\n\n   - Use component behaviour\n   - Handle events properly\n   - Follow naming conventions\n\n3. **Documentation**\n   - Add file header\n   - Document dependencies\n   - Include usage examples","ref":"readme-2.html#best-practices","title":"Best Practices - Raxol Examples","type":"extras"},{"doc":"For more examples, check the [examples directory](../../examples/).","ref":"readme-2.html#related-documentation","title":"Related Documentation - Raxol Examples","type":"extras"},{"doc":"# Raxol VS Code Extension\n\nA VS Code extension for the Raxol framework, providing tools for enhanced productivity, performance analysis, and intelligent assistance.","ref":"readme-3.html","title":"Raxol VS Code Extension","type":"extras"},{"doc":"","ref":"readme-3.html#features","title":"Features - Raxol VS Code Extension","type":"extras"},{"doc":"View all Raxol components in your project via the dedicated Explorer view. Quickly navigate to component files and understand the component structure of your application.","ref":"readme-3.html#component-explorer","title":"Component Explorer - Raxol VS Code Extension","type":"extras"},{"doc":"Analyze the performance of your Raxol components with detailed metrics:\n\n- Rendering time\n- Memory usage\n- Event handler efficiency\n- Update performance","ref":"readme-3.html#performance-analysis","title":"Performance Analysis - Raxol VS Code Extension","type":"extras"},{"doc":"This extension integrates with Raxol's AI features to provide:\n\n- Code completion and suggestions\n- Performance optimization recommendations\n- Refactoring assistance\n- Best practice guidelines","ref":"readme-3.html#ai-assisted-development","title":"AI-Assisted Development - Raxol VS Code Extension","type":"extras"},{"doc":"- **Raxol: Create New Component** - Generate a new Raxol component with proper structure\n- **Raxol: Analyze Performance** - Analyze the current file for performance issues\n- **Raxol: Optimize Component** - Get optimization suggestions for the current component","ref":"readme-3.html#commands","title":"Commands - Raxol VS Code Extension","type":"extras"},{"doc":"1. Install the extension from the VS Code marketplace\n2. Open a Raxol project\n3. Access Raxol tools from the activity bar","ref":"readme-3.html#getting-started","title":"Getting Started - Raxol VS Code Extension","type":"extras"},{"doc":"- VS Code 1.60.0 or higher\n- Raxol framework installed in your project","ref":"readme-3.html#requirements","title":"Requirements - Raxol VS Code Extension","type":"extras"},{"doc":"This extension contributes the following settings:\n\n- `raxol.enableIntelligentAssistance`: Enable/disable AI-powered code assistance\n- `raxol.performanceMetricsEnabled`: Enable/disable real-time performance metrics\n- `raxol.componentTemplatesPath`: Path to custom component templates","ref":"readme-3.html#extension-settings","title":"Extension Settings - Raxol VS Code Extension","type":"extras"},{"doc":"","ref":"readme-3.html#development","title":"Development - Raxol VS Code Extension","type":"extras"},{"doc":"1. Clone the repository\n2. Run `npm install`\n3. Run `npm run watch` for development or `npm run compile` for production","ref":"readme-3.html#building-the-extension","title":"Building the Extension - Raxol VS Code Extension","type":"extras"},{"doc":"Run `npm test` to execute the extension tests.","ref":"readme-3.html#testing","title":"Testing - Raxol VS Code Extension","type":"extras"},{"doc":"- Language server implementation for advanced type checking\n- Visual component editor\n- State flow visualization\n- Integration with Raxol CLI tools","ref":"readme-3.html#roadmap","title":"Roadmap - Raxol VS Code Extension","type":"extras"},{"doc":"Contributions are welcome! Please feel free to submit a Pull Request.","ref":"readme-3.html#contributing","title":"Contributing - Raxol VS Code Extension","type":"extras"},{"doc":"For licensing information, see the [License](../../LICENSE.md).","ref":"readme-3.html#license","title":"License - Raxol VS Code Extension","type":"extras"},{"doc":"---\ntitle: Raxol UI Components & Layout\ndescription: Overview of Raxol UI Components and the Layout System\ndate: 2025-05-10\nauthor: Raxol Team\nsection: guides\ntags: [components, layout, ui, guides, documentation]\n---\n\n# Raxol UI Components & Layout\n\nThis document overviews the Raxol UI component system (`Base.Component` behaviour, `View.Elements` DSL, HEEx-like syntax) and the flexbox-inspired layout engine.","ref":"readme-4.html","title":"README","type":"extras"},{"doc":"- **Components:** Reusable UI elements that manage their own state and rendering logic. They implement the `Raxol.UI.Components.Base.Component` behaviour.\n- **View Definition:** Describes the structure and appearance of the UI. Raxol primarily uses a DSL based on `Raxol.View.Elements` macros, but also supports HEEx-like syntax (`~H`) in some contexts.\n- **Layout Engine:** Calculates the size and position of elements within the terminal window based on the view structure and component styles.\n- **Renderer:** Converts the calculated layout into styled character cells for display in the terminal.","ref":"readme-4.html#core-concepts","title":"Core Concepts - README","type":"extras"},{"doc":"Custom components should typically implement this behaviour:\n\n- `init/1`: Initializes the component's state.\n- `update/2`: Handles messages sent to the component (optional).\n- `handle_event/3`: Processes user input events like keyboard or mouse clicks (optional).\n- `render/2`: Returns the component's view structure using one of the view definition methods.","ref":"readme-4.html#component-behaviour-raxol-ui-components-base-component","title":"Component Behaviour (Raxol.UI.Components.Base.Component) - README","type":"extras"},{"doc":"You define your application's UI within the `render/2` callback of your `Raxol.Core.Runtime.Application` module or a custom component.","ref":"readme-4.html#defining-views","title":"Defining Views - README","type":"extras"},{"doc":"This approach uses Elixir macros for a more programmatic feel.\n\n```elixir\ndefmodule MyApp.MyView do\n  use Raxol.Core.Runtime.Application\n  import Raxol.View.Elements # Import macros like view, box, text, etc.\n\n  @impl true\n  def render(assigns) do\n    # Use the view macro as the root\n    view do\n      panel title: \"Layout Example\", style: [padding: 1] do\n        box style: [flex_direction: :row, justify_content: :space_between] do\n          text(content: \"Left Text\")\n          button(label: \"Click Me\", on_click: :button_pressed)\n        end\n      end\n    end\n  end\n\n  @impl true\n  def handle_event({:click, :button_pressed}, state) do\n    # Handle button click\n    {:noreply, state}\n  end\n\n  # Other Application callbacks...\nend\n```","ref":"readme-4.html#1-using-raxol-view-elements-macros-primary-method","title":"1. Using Raxol.View.Elements Macros (Primary Method) - README","type":"extras"},{"doc":"Raxol also supports a syntax inspired by Surface/Phoenix LiveView's HEEx for defining views, which might feel more familiar to web developers.\n\n```elixir\ndefmodule MyApp.MyView do\n  use Raxol.Core.Runtime.Application\n  # NOTE: `use Raxol.View` might be needed depending on setup\n  # and how HEEx support is integrated. Check latest examples.\n\n  @impl true\n  def render(assigns) do\n    ~H\"\"\"\n     \n       \n         \n         \n       \n     \n    \"\"\"\n  end\n\n  @impl true\n  def handle_event({:click, :button_pressed}, state) do\n    # Handle button click\n    {:noreply, state}\n  end\n\n  # Other Application callbacks...\nend\n```\n\nComponent attributes are passed as keyword lists or maps in both syntaxes.","ref":"readme-4.html#2-using-heex-like-sigil-h","title":"2. Using HEEx-like Sigil (~H) - README","type":"extras"},{"doc":"Raxol provides several components primarily focused on structuring the UI layout.\n\n### ` ` / `box/1`\n\nA fundamental container component, often used to group other elements and apply layout properties, borders, or padding.\n\n**Attributes / Options:**\n\n- `border`: Defines the border style (e.g., `:single`, `:double`, `:none`).\n- `padding`: Adds space inside the border (e.g., `1`, `%{top: 1, bottom: 1}`).\n- `margin`: Adds space outside the border.\n- `title`: Displays a title within the top border.\n- `width`, `height`: Specifies dimensions. Can use integers (cells), percentages (`\"50%\"`), or `:auto`.\n- `flex_direction`: `:row` or `:column` (default: `:column`).\n- `justify_content`: `:flex_start`, `:flex_end`, `:center`, `:space_between`, `:space_around`.\n- `align_items`: `:flex_start`, `:flex_end`, `:center`, `:stretch` (default: `:stretch`).\n- `style`: Apply theme styles (background color, text attributes, etc. - e.g., `[bg_color: :dark_grey, padding: 1]`).\n\n**Example (`View.Elements`):**\n\n```elixir\nbox border: :single, padding: 1, title: \"My Box\", style: [bg_color: :dark_grey] do\n  text content: \"Content inside the box\"\nend\n```\n\n**Example (`~H`):**\n\n```elixir\n~H\"\"\"\n \n   \n \n\"\"\"\n```\n\n### ` ` / `panel/1`\n\nSimilar to `box`, often used as a primary container or section divider. Includes styling for a title integrated into the top border.\n\n**Attributes / Options:**\n\n- `title`: Text displayed in the panel's top border.\n- `border`: Border style (e.g., `:single`, default: `:none`).\n- `width`, `height`: Specifies dimensions.\n- `padding`: Space inside the border.\n- `style`: Apply theme styles.\n\n**Example (`View.Elements`):**\n\n```elixir\npanel title: \"Settings\", border: :single do\n  text content: \"Some setting\"\n  button label: \"Save\", on_click: :save_settings\nend\n```\n\n**Example (`~H`):**\n\n```elixir\n~H\"\"\"\n \n   \n   \n \n\"\"\"\n```\n\n### ` ` / `grid/1`\n\nArranges child components in a grid.\n\n**Attributes / Options:**\n\n- `columns` (integer, default: 1): The number of columns.\n- `rows` (integer, default: calculated): The number of rows. If omitted, it's calculated based on children and columns.\n- `gap_x` (integer, default: 1): Horizontal gap between columns.\n- `gap_y` (integer, default: 1): Vertical gap between rows.\n- `style`: Styles for the grid container itself (e.g., `[width: 40, height: 10]`).\n\n**Child Attributes (within `grid`):**\n\n- `col_span` (integer, default: 1): Columns the child occupies.\n- `row_span` (integer, default: 1): Rows the child occupies.\n\n**Behavior:** Children fill cells left-to-right, top-to-bottom. Space is divided among cells after accounting for gaps.\n\n**Example (2x2 Grid - `View.Elements`):**\n\n```elixir\ngrid columns: 2, rows: 2, gap_x: 2, gap_y: 1, style: [width: 40, height: 10] do\n  panel title: \"Top Left\", border: :single\n  panel title: \"Top Right\", border: :single\n  panel title: \"Bottom Left\", border: :single\n  panel title: \"Bottom Right\", border: :single\nend\n```\n\n**Example (Spanning Item - `~H`):**\n\n```elixir\n~H\"\"\"\n \n   \n   \n   \n   \n   \n  <!-- Note: C spans row 1 & 2 in col 0. D fills row 1, col 1. E fills row 1, col 2. -->\n \n\"\"\"\n```","ref":"readme-4.html#layout-components","title":"Layout Components - README","type":"extras"},{"doc":"### ` ` / `text/1`\n\nDisplays static or dynamic text content.\n\n**Attributes / Options:**\n\n- `content`: The string to display.\n- `style`: Apply text styles from the theme (e.g., `[color: :cyan, attributes: [:bold]]`).\n\n**Example (`View.Elements`):**\n\n```elixir\ntext content: \"Important Notice\", style: [color: :yellow, attributes: [:bold]]\n```\n\n**Example (`~H`):**\n\n```elixir\n~H\"\"\"\n \n\"\"\"\n```\n\n### ` ` / `label/1`\n\nDisplays simple text, often used alongside form inputs. Semantically similar to ` `, but might have specific styling or accessibility implications in the future.\n\n**Attributes / Options:**\n\n- `content`: The text to display.\n- `for`: (Future) May associate the label with an input element's ID for accessibility.\n\n**Example (`View.Elements`):**\n\n```elixir\nlabel content: \"Enter your name:\"\n```\n\n### ` ` / `button/1`\n\nAn interactive element that triggers a message when clicked or activated (e.g., via Enter key when focused).\n\n**Attributes / Options:**\n\n- `label`: The text displayed on the button.\n- `on_click`: The message (usually an atom or tuple) sent to the `handle_event/2` or `update/2` callback when activated.\n- `variant`: (Optional) Style variant from the theme (e.g., `:primary`, `:danger`).\n- `style`: Custom styles.\n\n**Example (`View.Elements`):**\n\n```elixir\nbutton label: \"Increment Count\", on_click: :increment\n```","ref":"readme-4.html#common-ui-components","title":"Common UI Components - README","type":"extras"},{"doc":"Raxol provides many other components located in `lib/raxol/ui/components/`.\n\n**Input Components (`lib/raxol/ui/components/input/`):**\n\n- `text_input`: Single-line text input field.\n- `multi_line_input`: Multi-line text editor.\n- `checkbox`: A toggleable checkbox.\n- `radio_group`: Select one option from a group.\n- `select_list`: Select one or more items from a scrollable list.\n- `slider`: Select a value within a range.\n- `form`: (Likely) Groups related input components.\n\n### ` ` / `multi_line_input/1`\n\nA multi-line text editor component supporting line wrapping, scrolling, selection, clipboard, and accessibility features. Now harmonized with the modern component system (style/theme merging, accessibility props, lifecycle hooks).\n\n**Attributes / Options:**\n\n- `value`: The current text value (string, default: \"\").\n- `placeholder`: Placeholder text when empty (string, default: \"\").\n- `width`, `height`: Dimensions in cells (integers, default: 40x10).\n- `wrap`: Line wrapping mode (`:none`, `:char`, `:word`, default: `:word`).\n- `style`: Custom styles (map, merged with theme and context styles).\n- `theme`: Theme overrides (map, merged with context theme).\n- `aria_label`: Accessibility label (string, optional).\n- `tooltip`: Tooltip/help text (string, optional).\n- `on_change`: Callback when text changes (function, optional).\n\n**Example (`View.Elements`):**\n\n```elixir\nmulti_line_input \\\n  value: state.notes,\n  placeholder: \"Enter notes...\",\n  width: 60,\n  height: 8,\n  wrap: :word,\n  style: [text_color: :cyan, selection_color: :magenta],\n  theme: %{cursor_color: :yellow},\n  aria_label: \"Notes field\",\n  tooltip: \"Type your notes here\",\n  on_change: fn new_text -> send(self(), {:notes_changed, new_text}) end\n```\n\n**Example (`~H`):**\n\n```elixir\n~H\"\"\"\n \n\"\"\"\n```\n\n**Display Components (`lib/raxol/ui/components/display/`):**\n\n- `table`: Displays tabular data. Takes data and column definitions directly via attributes (e.g., `:headers`, `:data`) after refactoring.\n- `spinner`: Shows an animated loading indicator.\n- `progress` / `progress_bar`: Visualizes progress.\n\n**Other (`lib/raxol/ui/components/`):**\n\n- `modal`: Displays content in a layer above the main UI.\n- `hint_display`: Shows contextual hints or shortcuts.\n- `focus_ring`: Visual indicator for the focused element.\n\n_(Note: This list is based on the current structure and previous documentation. Always check the source directory and specific component modules for the most up-to-date attributes and usage.)_\n\n**Example (`Table` - Conceptual):**\n\n```elixir\n# In your Application or Component:\nassigns = %{\n  my_headers: [%{label: \"ID\"}, %{label: \"Name\"}],\n  my_data: [%{id: 1, name: \"Alice\"}, %{id: 2, name: \"Bob\"}]\n}\n\n# In render/2 using View.Elements:\ntable headers: assigns.my_headers, data: assigns.my_data\n\n# In render/2 using ~H:\n~H\"\"\"\n \n\"\"\"\n```","ref":"readme-4.html#other-available-components","title":"Other Available Components - README","type":"extras"},{"doc":"Advanced visualizations like charts and treemaps are handled via the `Raxol.Plugins.VisualizationPlugin`. The plugin looks for specific placeholder elements (like `:chart`, `:treemap`, `:image`) in the view definition returned by your application or components and replaces them with the rendered visualization. Refer to the plugin's documentation or examples for details on required attributes for these placeholders.","ref":"readme-4.html#visualization-placeholders","title":"Visualization Placeholders - README","type":"extras"},{"doc":"The layout engine uses a flexbox-inspired approach. Control layout using style attributes (`:flex_direction`, `:justify_content`, `:align_items`, `:width`, `:height`, `:padding`, `:margin`, `:flex_grow`, etc.) within the `View.Elements` macros or component tags.\n\nRefer to specific component documentation and examples for more details.","ref":"readme-4.html#layout-system-details","title":"Layout System Details - README","type":"extras"},{"doc":"1. Create a new module, e.g., `lib/raxol/ui/components/my_custom_component.ex`.\n2. `use Raxol.UI.Components.Base.Component`.\n3. Implement the required callbacks (`init/1`, `render/2`) and optional callbacks (`handle_event/3`, `update/2`).\n4. Use `Raxol.View.Elements` macros or `~H` within your `render/2` function to define the component's structure.\n5. Integrate your component into your application's `render/2` function using its module name as a function (`MyCustomComponent.render(assigns)`) or potentially as a tag (` ` if HEEx integration supports it).","ref":"readme-4.html#creating-custom-components","title":"Creating Custom Components - README","type":"extras"}],"producer":{"name":"ex_doc","version":"0.38.2"},"proglang":"elixir"}